Deft for Emacs
==============

<!-- Automatically generated from comments in deft.el. -->

Deft is an Emacs mode for quickly browsing, filtering, and editing
directories of plain text notes, inspired by Notational Velocity.
It was designed for increased productivity when writing and taking
notes by making it fast and simple to find the right file at the
right time and by automating many of the usual tasks such as
creating new files and saving files.

Deft is open source software and may be freely distributed and
modified under the BSD license.  Version 0.7 is the latest stable
version, released on December 21, 2015.  You may download it
directly here:

  * [deft.el](http://jblevins.org/projects/deft/deft.el)

To follow or contribute to Deft development, you can browse or
clone the Git repository at [jblevins.org][] or [GitHub][]:

    git clone git://jblevins.org/git/deft.git
    git clone https://github.com/jrblevin/deft.git

[![Build Status][status]][travis]

[jblevins.org]: http://jblevins.org/git/deft.git
[GitHub]: https://github.com/jrblevin/deft
[travis]: https://travis-ci.org/jrblevin/deft
[status]: https://travis-ci.org/jrblevin/deft.svg?branch=master

![Deft Screencast](http://jblevins.org/projects/deft/deft-v0.6.gif)

The Deft buffer is simply a file browser which lists the titles of
all text files in the Deft directory followed by short summaries
and last modified times.  The title is taken to be the first line
of the file and the summary is extracted from the text that
follows.  Files are, by default, sorted in terms of the last
modified date, from newest to oldest.

All Deft files or notes are simple plain text files where the first
line contains a title.  As an example, the following directory
structure generated the screenshot above.

    % ls ~/.deft
    about.txt    browser.txt     directory.txt   operations.txt
    ack.txt      completion.txt  extensions.org
    binding.txt  creation.txt    filtering.txt

    % cat ~/.deft/about.txt
    # About

    An Emacs mode for slicing and dicing plain text files.

Deft's primary operation is searching and filtering.  The list of
files can be limited or filtered using a search string, which will
match both the title and the body text.  To initiate a filter,
simply start typing.  Filtering happens on the fly.  As you type,
the file browser is updated to include only files that match the
current string.

To open the first matching file, simply press <kbd>RET</kbd>.  If no files
match your search string, pressing <kbd>RET</kbd> will create a new file
using the string as the title.  This is a very fast way to start
writing new notes.  The filename will be generated automatically.
If you prefer to provide a specific filename, use <kbd>C-RET</kbd> instead.

To open files other than the first match, navigate up and down
using <kbd>C-p</kbd> and <kbd>C-n</kbd> and press <kbd>RET</kbd> on the file you want to open.
When opening a file, Deft searches forward and leaves the point
at the end of the first match of the filter string.

You can also press <kbd>C-o</kbd> to open a file in another window, without
switching to the other window.  Issue the same command with a prefix
argument, <kbd>C-u C-o</kbd>, to open the file in another window and switch
to that window.

To edit the filter string, press `DEL` (backspace) to remove the
last character or <kbd>M-DEL</kbd> to remove the last "word".  To yank
(paste) the most recently killed (cut or copied) text into the
filter string, press <kbd>C-y</kbd>.  Press <kbd>C-c C-c</kbd> to clear the filter
string and display all files and <kbd>C-c C-g</kbd> to refresh the file
browser using the current filter string.

For more advanced editing operations, you can also edit the filter
string in the minibuffer by pressing <kbd>C-c C-l</kbd>.  While in the
minibuffer, the history of previous edits can be cycled through by
pressing <kbd>M-p</kbd> and <kbd>M-n</kbd>.  This form of static, one-time filtering
(as opposed to incremental, on-the-fly filtering) may be preferable
in some situations, such as over slow connections or on systems
where interactive filtering performance is poor.

By default, Deft filters files in incremental string search mode,
where "search string" will match all files containing both "search"
and "string" in any order.  Alternatively, Deft supports direct
regexp filtering, where the filter string is interpreted as a
formal regular expression.  For example, `^\(foo\|bar\)` matches
foo or bar at the beginning of a line.  Pressing <kbd>C-c C-t</kbd> will
toggle between incremental and regexp search modes.  Regexp
search mode is indicated by an "R" in the mode line.

Common file operations can also be carried out from within Deft.
Files can be renamed using <kbd>C-c C-r</kbd> or deleted using <kbd>C-c C-d</kbd>.
New files can also be created using <kbd>C-c C-n</kbd> for quick creation or
<kbd>C-c C-m</kbd> for a filename prompt.  You can leave Deft at any time
with <kbd>C-c C-q</kbd>.

Unused files can be archived by pressing <kbd>C-c C-a</kbd>. Files will be
moved to `deft-archive-directory`, which is a directory named
`archive` within your `deft-directory` by default.

Files opened with deft are automatically saved after Emacs has been
idle for a customizable number of seconds.  This value is a floating
point number given by `deft-auto-save-interval` (default: 1.0).

Getting Started
---------------

To start using it, place it somewhere in your Emacs load-path and
add the line

    (require 'deft)

in your `.emacs` file.  Then run <kbd>M-x deft</kbd> to start.  It is useful
to create a global keybinding for the `deft` function (e.g., a
function key) to start it quickly (see below for details).

When you first run Deft, it will complain that it cannot find the
`~/.deft` directory.  You can either create a symbolic link to
another directory where you keep your notes or run <kbd>M-x deft-setup</kbd>
to create the `~/.deft` directory automatically.

One useful way to use Deft is to keep a directory of notes in a
Dropbox folder.  This can be used with other applications and
mobile devices, for example, [nvALT][], [Notational Velocity][], or
[Simplenote][] on OS X or [Editorial][], [Byword][], or [1Writer][]
on iOS.

[nvALT]: http://brettterpstra.com/projects/nvalt/
[Notational Velocity]: http://notational.net/
[Simplenote]: http://simplenote.com/
[Editorial]: https://geo.itunes.apple.com/us/app/editorial/id673907758?mt=8&uo=6&at=11l5Vs&ct=deft
[Byword]: https://geo.itunes.apple.com/us/app/byword/id482063361?mt=8&uo=6&at=11l5Vs&ct=deft
[1Writer]: https://geo.itunes.apple.com/us/app/1writer-note-taking-writing/id680469088?mt=8&uo=6&at=11l5Vs&ct=deft

Basic Customization
-------------------

You can customize items in the `deft` group to change the default
functionality.

By default, Deft looks for notes by searching for files with the
extensions `.txt`, `.text`, `.md`, `.markdown`, or `.org` in the
`~/.deft` directory.  You can customize both the file extension and
the Deft directory by running <kbd>M-x customize-group</kbd> and typing
`deft`.  Alternatively, you can configure them in your `.emacs`
file:

    (setq deft-extensions '("txt" "tex" "org")
    (setq deft-directory "~/Dropbox/notes"))

The first element of `deft-extensions` (or in Lisp parlance, the
car) is the default extension used to create new files.

By default, Deft only searches for files in `deft-directory` but
not in any subdirectories. All files in `deft-directory` with one
of the specified extensions will be included except for those
matching `deft-ignore-file-regexp`. Set `deft-recursive` to a
non-nil value to enable searching for files in subdirectories
(those not matching `deft-recursive-ignore-dir-regexp`):

    (setq deft-recursive t)

You can easily set up a global keyboard binding for Deft.  For
example, to bind it to F8, add the following code to your `.emacs`
file:

    (global-set-key [f8] 'deft)

Reading Files
-------------

The displayed title of each file is taken to be the first line of
the file, with certain characters removed from the beginning. Hash
characters, as used in Markdown headers, and asterisks, as in Org
Mode headers, are removed.  Additionally, Org mode `#+TITLE:` tags,
MultiMarkdown `Title:` tags, LaTeX comment markers (<kbd>%</kbd>), and
Emacs mode-line declarations (e.g., `-*-mode-*-`) are stripped from
displayed titles.  This can be customized by changing
`deft-strip-title-regexp`.

More generally, the title post-processing function itself can be
customized by setting `deft-parse-title-function`, which accepts
the first line of the file as an argument and returns the parsed
title to display in the file browser.  The default function is
`deft-strip-title`, which removes all occurrences of
`deft-strip-title-regexp` as described above.

For compatibility with other applications which use the filename as
the title of a note (rather than the first line of the file), set the
`deft-use-filename-as-title` flag to a non-`nil` value. Deft will then
use note filenames to generate the displayed titles in the Deft
file browser. To enable this, add the following to your `.emacs` file:

    (setq deft-use-filename-as-title t)

Finally, the short summary that is displayed following the file
title can be customized by changing `deft-strip-summary-regexp`. By
default, this is set to remove certain org-mode metadata statements
such as `#+OPTIONS:` and `#+AUTHOR:`.

Creating Files
--------------

Filenames for newly created files are generated by Deft automatically.
The process for doing so is determined by the variables
`deft-use-filename-as-title` and `deft-use-filter-string-for-filename`
as well as the rules in the `deft-file-naming-rules` alist.
The possible cases are as follows:

1.  **Default** (`deft-use-filename-as-title` and
    `deft-use-filter-string-for-filename` are both `nil`):

    The filename will be automatically generated with prefix `deft-`
    and a numerical suffix as in `deft-0.ext`, `deft-1.ext`, ...
    The filter string will be inserted as the first line of the file
    (which is also used as the display title).

2.  **Filenames as titles** (`deft-use-filename-as-title` is non-`nil`):

    When `deft-use-filename-as-title` is non-`nil`, the filter string
    will be used as the filename for new files (with the appropriate
    file extension appended to the end).

3.  **Readable filenames** (`deft-use-filename-as-title` is
    `nil` but `deft-use-filter-string-for-filename` is non-`nil`):

    In this case you can choose to display the title as parsed from
    the first line of the file while also generating readable
    filenames for new files based on the filter string. The
    variable `deft-use-filter-string-for-filename` controls this
    behavior and decouples the title display
    (`deft-use-filename-as-title`) from the actual filename. New
    filenames will be generated from the filter string and
    processed according to the rules defined in the
    `deft-file-naming-rules` alist. By default, slashes are removed
    and replaced by hyphens, but many other options are possible
    (camel case, replacing spaces by hyphens, and so on). See the
    documentation for `deft-file-naming-rules` for additional
    details.

Titles inserted into files from the filter string can also be
customized for two common modes, `markdown-mode` and `org-mode`, by
setting the following variables:

* `deft-markdown-mode-title-level` - When set to a positive
  integer, determines how many hash marks will be added to titles
  in new Markdown files. In other words, setting
  `deft-markdown-mode-title-level` to <kbd>2</kbd> will result in new files
  being created with level-2 headings of the form `## Title`.

* `deft-org-mode-title-prefix` - When non-nil, automatically
  generated titles in new `org-mode` files will be prefixed with
  `#+TITLE:`.

Other Customizations
--------------------

Deft, by default, lists files from newest to oldest.  You can set
`deft-current-sort-method` to 'title to sort by file titles, case
ignored.  Or, you can toggle sorting method using
`deft-toggle-sort-method`.

Incremental string search is the default method of filtering on
startup, but you can set `deft-incremental-search` to nil to make
regexp search the default.

Deft also provides a function for opening files without using the
Deft buffer directly.  Calling `deft-find-file` will prompt for a
file to open, just like `find-file`, but starting from
`deft-directory`.  If the file selected is in `deft-directory`, it
is opened with the usual deft features (automatic saving, automatic
updating of the Deft buffer, etc.).  Otherwise, the file will be
opened by `find-file` as usual.  Therefore, you can set up a global
keybinding for this function to open Deft files anywhere.  For
example, to use <kbd>C-x C-g</kbd>, a neighbor of <kbd>C-x C-f</kbd>, use the
following:

    (global-set-key (kbd "C-x C-g") 'deft-find-file)

The faces used for highlighting various parts of the screen can
also be customized.  By default, these faces inherit their
properties from the standard font-lock faces defined by your current
color theme.

Acknowledgments
---------------

Thanks to Konstantinos Efstathiou for writing simplenote.el, from
which I borrowed liberally, and to Zachary Schneirov for writing
Notational Velocity, whose functionality and spirit I wanted to
bring to Emacs.

History
-------

Version 0.7 (2015-12-21):

* Add custom regular expression `deft-strip-summary-regexp` for
  stripping extraneous text for generating the summary line. Strip
  all `org-mode` metadata by default.
* New customizable regular expressions for ignoring files and
  directories. See `deft-recursive-ignore-dir-regexp` and
  `deft-ignore-file-regexp`.
* Bug fix: Prevent lines from wrapping in console mode.
* Bug fix: Setup `deft-extensions` and `deft-default-extension` at
  load time.
* Bug fix: Try to prevent false title matches in org-mode notes
  where the string `#+TITLE:` might also appear in the body.
* Bug fix: Use `with-current-buffer` instead of `save-excursion`
  while auto-saving files since we do not want to save the point.
* Bug fix: Don't escape quotes in `deft-file-naming-rules`.

Version 0.6 (2015-06-26):

* Recursive search in subdirectories (optional). Set
  `deft-recursive` to a non-nil value to enable.
* Support for multiple extensions via the `deft-extensions` list.
  As such, `deft-extension` is now deprecated.
* New variable `deft-create-file-from-filter-string` can enable
  generation of new filenames based on the filter string. This decouples
  the title display (`deft-use-filename-as-title`) from the actual filename
  generation.
* New variable `deft-file-naming-rules` allows customizing generation
  of filenames with regard to letter case and handling of spaces.
* New variables `deft-markdown-mode-title-level` and
  `deft-org-mode-title-prefix` for automatic insertion of title markup.
* Archiving of files in `deft-archive-directory`.
* Ability to sort by either title or modification time via
  `deft-current-sort-method`.
* Update default `deft-strip-title-regexp` to remove the following:
    - org-mode `#+TITLE:` tags
    - MultiMarkdown `Title:` tags
    - LaTeX comment markers (i.e., `%`)
    - Emacs mode-line declarations (e.g., `-*-mode-*-`)
* Remove leading and trailing whitespace from titles.
* Disable visual line mode to prevent lines from wrapping.
* Enable line truncation to avoid displaying truncation characters.
* Show the old filename as the default prompt when renaming a file.
* Call `hack-local-variables` to read file-local variables when
  opening files.
* Fixed several byte-compilation warnings.
* Bug fix: more robust handling of relative and absolute filenames.
* Bug fix: use width instead of length of strings for calculations.
* Bug fix: fix `string-width` error with empty file.

Version 0.5.1 (2013-01-28):

* Bug fix: creating files with <kbd>C-c C-n</kbd> when both the filter string and
  `deft-use-filename-as-title` are non-nil resulted in an invalid path.
* Bug fix: killed buffers would persist in `deft-auto-save-buffers`.

Version 0.5 (2013-01-25):

* Implement incremental string search (default) and regexp search.
  These search modes can be toggled by pressing <kbd>C-c C-t</kbd>.
* Default search method can be changed by setting `deft-incremental-search`.
* Support custom `deft-parse-title-function` for post-processing titles.
* The default `deft-parse-title-function` simply strips occurrences of
  `deft-strip-title-regexp`, which removes Markdown and Org headings.
* Open files in another window with <kbd>C-o</kbd>.  Prefix it with <kbd>C-u</kbd> to
  switch to the other window.
* For symbolic links, use modification time of taget for sorting.
* When opening files, move point to the end of the first match of
  the filter string.
* Improved filter editing: delete (`DEL`), delete word (<kbd>M-DEL</kbd>),
  and yank (<kbd>C-y</kbd>).
* Advanced filter editing in minibuffer (<kbd>C-c C-l</kbd>).

Version 0.4 (2011-12-11):

* Improved filtering performance.
* Optionally take title from filename instead of first line of the
  contents (see `deft-use-filename-as-title`).
* Dynamically resize width to fit the entire window.
* Customizable time format (see `deft-time-format`).
* Handle `deft-directory` properly with or without a trailing slash.

Version 0.3 (2011-09-11):

* Internationalization: support filtering with multibyte characters.

Version 0.2 (2011-08-22):

* Match filenames when filtering.
* Automatically save opened files (optional).
* Address some byte-compilation warnings.

Deft was originally written by [Jason Blevins](http://jblevins.org/).
The initial version, 0.1, was released on August 6, 2011.

# Deft for Emacs [![MELPA badge][melpa-badge]][melpa-link] [![MELPA stable badge][melpa-stable-badge]][melpa-stable-link] [![Travis CI Build Status][travis-badge]][travis-link]

  [melpa-link]: https://melpa.org/#/deft
  [melpa-stable-link]: https://stable.melpa.org/#/deft
  [melpa-badge]: https://melpa.org/packages/deft-badge.svg
  [melpa-stable-badge]: https://stable.melpa.org/packages/deft-badge.svg
  [travis-link]: https://travis-ci.org/jrblevin/deft
  [travis-badge]: https://travis-ci.org/jrblevin/deft.svg?branch=master

<!-- Automatically generated from comments in deft.el. -->

Deft is an Emacs mode for quickly browsing, filtering, and editing
directories of plain text notes, inspired by Notational Velocity.
It was designed for increased productivity when writing and taking
notes by making it fast and simple to find the right file at the
right time and by automating many of the usual tasks such as
creating new files and saving files.

![Deft Screencast](https://jblevins.org/projects/deft/deft-v0.6.gif)

Obtaining Deft
--------------

Deft is open source software and may be freely distributed and
modified under the BSD license.  The latest stable release is
version 0.8, released on January 12, 2018.

**Installation via MELPA Stable**

The recommended way to install Deft is to obtain the stable version
from [MELPA Stable](https://stable.melpa.org/#/deft) using
`package.el`.  First, configure `package.el` and the MELPA Stable
repository by adding the following to your `.emacs`, `init.el`, or
equivalent startup file:

    (require 'package)
    (add-to-list 'package-archives
                 '("melpa-stable" . "https://stable.melpa.org/packages/"))
    (package-initialize)

Then, after restarting Emacs or evaluating the above statements, issue
the following command: <kbd>M-x package-install RET deft RET</kbd>.

[MELPA Stable]: http://stable.melpa.org/

**Direct Download**

Alternatively you can manually download and install Deft.
First, download the latest stable version of and save the file
where Emacs can find it---a directory in your `load-path`:

  * [deft.el](https://jblevins.org/projects/deft/deft.el)

Then, add the following line to your startup file:

    (require 'deft)

**Development Version**

To follow or contribute to Deft development, you can browse or
clone the Git repository [on GitHub](https://github.com/jrblevin/deft):

    git clone https://github.com/jrblevin/deft.git

If you prefer to install and use the development version, which may
become unstable at some times, you can either clone the Git
repository as above or install Deft from
[MELPA](https://melpa.org/#/deft).

If you clone the repository directly, then make sure that Emacs can
find it by adding the following line to your startup file:

    (add-to-list 'load-path "/path/to/deft/repository")

Overview
--------

The Deft buffer is simply a file browser which lists the titles of
all text files in the Deft directory followed by short summaries
and last modified times.  The title is taken to be the first line
of the file and the summary is extracted from the text that
follows.  Files are, by default, sorted in terms of the last
modified date, from newest to oldest.

All Deft files or notes are simple plain text files where the first
line contains a title.  As an example, the following directory
structure generated the screenshot above.

    % ls ~/.deft
    about.txt    browser.txt     directory.txt   operations.txt
    ack.txt      completion.txt  extensions.org
    binding.txt  creation.txt    filtering.txt

    % cat ~/.deft/about.txt
    # About

    An Emacs mode for slicing and dicing plain text files.

Deft's primary operation is searching and filtering.  The list of
files can be limited or filtered using a search string, which will
match both the title and the body text.  To initiate a filter,
simply start typing.  Filtering happens on the fly.  As you type,
the file browser is updated to include only files that match the
current string.

To open the first matching file, simply press <kbd>RET</kbd>.  If no files
match your search string, pressing <kbd>RET</kbd> will create a new file
using the string as the title.  This is a very fast way to start
writing new notes.  The filename will be generated automatically.
If you prefer to provide a specific filename, use <kbd>C-RET</kbd> instead.

To open files other than the first match, navigate up and down
using <kbd>C-p</kbd> and <kbd>C-n</kbd> and press <kbd>RET</kbd> on the file you want to open.
When opening a file, Deft searches forward and leaves the point
at the end of the first match of the filter string.

You can also press <kbd>C-o</kbd> to open a file in another window, without
switching to the other window.  Issue the same command with a prefix
argument, <kbd>C-u C-o</kbd>, to open the file in another window and switch
to that window.

To edit the filter string, press `DEL` (backspace) to remove the
last character or <kbd>M-DEL</kbd> to remove the last "word".  To yank
(paste) the most recently killed (cut or copied) text into the
filter string, press <kbd>C-y</kbd>.  Press <kbd>C-c C-c</kbd> to clear the filter
string and display all files and <kbd>C-c C-g</kbd> to refresh the file
browser using the current filter string.

For more advanced editing operations, you can also edit the filter
string in the minibuffer by pressing <kbd>C-c C-l</kbd>.  While in the
minibuffer, the history of previous edits can be cycled through by
pressing <kbd>M-p</kbd> and <kbd>M-n</kbd>.  This form of static, one-time filtering
(as opposed to incremental, on-the-fly filtering) may be preferable
in some situations, such as over slow connections or on systems
where interactive filtering performance is poor.

By default, Deft filters files in incremental string search mode,
where "search string" will match all files containing both "search"
and "string" in any order.  Alternatively, Deft supports direct
regexp filtering, where the filter string is interpreted as a
formal regular expression.  For example, `^\(foo\|bar\)` matches
foo or bar at the beginning of a line.  Pressing <kbd>C-c C-t</kbd> will
toggle between incremental and regexp search modes.  Regexp
search mode is indicated by an "R" in the mode line.

Common file operations can also be carried out from within Deft.
Files can be renamed using <kbd>C-c C-r</kbd> or deleted using <kbd>C-c C-d</kbd>.
New files can also be created using <kbd>C-c C-n</kbd> for quick creation or
<kbd>C-c C-m</kbd> for a filename prompt.  You can leave Deft at any time
with <kbd>C-c C-q</kbd>.

Unused files can be archived by pressing <kbd>C-c C-a</kbd>.  Files will be
moved to `deft-archive-directory`, which is a directory named
`archive` within your `deft-directory` by default.

Files opened with deft are automatically saved after Emacs has been
idle for a customizable number of seconds.  This value is a floating
point number given by `deft-auto-save-interval` (default: 1.0).

Getting Started
---------------

Once you have installed Deft following one of the above methods,
you can simply run <kbd>M-x deft</kbd> to start Deft.  It is useful
to create a global keybinding for the `deft` function (e.g., a
function key) to start it quickly (see below for details).

When you first run Deft, it will complain that it cannot find the
`~/.deft` directory.  You can either create a symbolic link to
another directory where you keep your notes or run <kbd>M-x deft-setup</kbd>
to create the `~/.deft` directory automatically.

One useful way to use Deft is to keep a directory of notes in a
Dropbox folder.  This can be used with other applications and
mobile devices, for example, [nvALT][], [Notational Velocity][], or
[Simplenote][] on OS X or [Editorial][], [Byword][], or [1Writer][]
on iOS.

[nvALT]: http://brettterpstra.com/projects/nvalt/
[Notational Velocity]: http://notational.net/
[Simplenote]: http://simplenote.com/
[Editorial]: https://geo.itunes.apple.com/us/app/editorial/id673907758?mt=8&uo=6&at=11l5Vs&ct=deft
[Byword]: https://geo.itunes.apple.com/us/app/byword/id482063361?mt=8&uo=6&at=11l5Vs&ct=deft
[1Writer]: https://geo.itunes.apple.com/us/app/1writer-note-taking-writing/id680469088?mt=8&uo=6&at=11l5Vs&ct=deft

Basic Customization
-------------------

You can customize items in the `deft` group to change the default
functionality.

By default, Deft looks for notes by searching for files with the
extensions `.txt`, `.text`, `.md`, `.markdown`, or `.org` in the
`~/.deft` directory.  You can customize both the file extension and
the Deft directory by running <kbd>M-x customize-group</kbd> and typing
`deft`.  Alternatively, you can configure them in your `.emacs`
file:

    (setq deft-extensions '("txt" "tex" "org"))
    (setq deft-directory "~/Dropbox/notes")

The first element of `deft-extensions` (or in Lisp parlance, the
car) is the default extension used to create new files.

By default, Deft only searches for files in `deft-directory` but
not in any subdirectories.  All files in `deft-directory` with one
of the specified extensions will be included except for those
matching `deft-ignore-file-regexp`.  Set `deft-recursive` to a
non-nil value to enable searching for files in subdirectories
(those not matching `deft-recursive-ignore-dir-regexp`):

    (setq deft-recursive t)

You can easily set up a global keyboard binding for Deft.  For
example, to bind it to F8, add the following code to your `.emacs`
file:

    (global-set-key [f8] 'deft)

If you manage loading packages with [use-package][], then you can
configure by adding a declaration such as this one to your init
file:

    (use-package deft
      :bind ("<f8>" . deft)
      :commands (deft)
      :config (setq deft-directory "~/Dropbox/notes"
                    deft-extensions '("md" "org")))

[use-package]: https://github.com/jwiegley/use-package

Reading Files
-------------

The displayed title of each file is taken to be the first line of
the file, with certain characters removed from the beginning.  Hash
characters, as used in Markdown headers, and asterisks, as in Org
Mode headers, are removed.  Additionally, Org mode `#+TITLE:` tags,
MultiMarkdown `Title:` tags, LaTeX comment markers, and
Emacs mode-line declarations (e.g., `-*-mode-*-`) are stripped from
displayed titles.  This can be customized by changing
`deft-strip-title-regexp`.

More generally, the title post-processing function itself can be
customized by setting `deft-parse-title-function`, which accepts
the first line of the file as an argument and returns the parsed
title to display in the file browser.  The default function is
`deft-strip-title`, which removes all occurrences of
`deft-strip-title-regexp` as described above.

For compatibility with other applications which use the filename as
the title of a note (rather than the first line of the file), set the
`deft-use-filename-as-title` flag to a non-`nil` value.  Deft will then
use note filenames to generate the displayed titles in the Deft
file browser.  To enable this, add the following to your `.emacs` file:

    (setq deft-use-filename-as-title t)

Finally, the short summary that is displayed following the file
title can be customized by changing `deft-strip-summary-regexp`.  By
default, this is set to remove certain org-mode metadata statements
such as `#+OPTIONS:` and `#+AUTHOR:`.

Creating Files
--------------

Filenames for newly created files are generated by Deft automatically.
The process for doing so is determined by the variables
`deft-use-filename-as-title` and `deft-use-filter-string-for-filename`
as well as the rules in the `deft-file-naming-rules` alist.
The possible cases are as follows:

1.  **Default** (`deft-use-filename-as-title` and
    `deft-use-filter-string-for-filename` are both `nil`):

    The filename will be automatically generated using an short,
    ISO-like timestamp as in `2016-05-12T09:00.txt`.  The format
    can be customized by setting the variable
    `deft-new-file-format`.  The filter string will be inserted as
    the first line of the file (which is also used as the display
    title).  In case of file name conflicts, an underscore and a
    numerical suffix (e.g., `_2`) will be appended before the
    extension.

2.  **Filenames as titles** (`deft-use-filename-as-title` is non-`nil`):

    When `deft-use-filename-as-title` is non-`nil`, the filter string
    will be used as the filename for new files (with the appropriate
    file extension appended to the end).  An example of new file creation
    in this case:

      * Filter string: "My New Project"
      * File name: "My New Project.txt"
      * File contents: [empty]

3.  **Readable filenames** (`deft-use-filename-as-title` is
    `nil` but `deft-use-filter-string-for-filename` is non-`nil`):

    In this case you can choose to display the title as parsed from
    the first line of the file while also generating readable
    filenames for new files based on the filter string.  The
    variable `deft-use-filter-string-for-filename` controls this
    behavior and decouples the title display
    (`deft-use-filename-as-title`) from the actual filename.  New
    filenames will be generated from the filter string and
    processed according to the rules defined in the
    `deft-file-naming-rules` alist.  By default, slashes are removed
    and replaced by hyphens, but many other options are possible
    (camel case, replacing spaces by hyphens, and so on).  See the
    documentation for `deft-file-naming-rules` for additional
    details.

    As an example, with the following value for
    `deft-file-naming-rules`, Deft will replace all slashes and
    spaces with hyphens and will convert the file name to
    lowercase:

        (setq deft-file-naming-rules
              '((noslash . "-")
                (nospace . "-")
                (case-fn . downcase)))

    Below is an example in this case, with the above file naming
    rules.  Notice that the filter string is inserted as the first
    line of the file but it is also used to generate a "readable"
    file name.

      * Filter string: "My New Project"
      * File name: "my-new-project.txt"
      * File contents: "My New Project"

Titles inserted into files from the filter string can also be
customized for two common modes, `markdown-mode` and `org-mode`, by
setting the following variables:

* `deft-markdown-mode-title-level` - When set to a positive
  integer, determines how many hash marks will be added to titles
  in new Markdown files.  In other words, setting
  `deft-markdown-mode-title-level` to <kbd>2</kbd> will result in new files
  being created with level-2 headings of the form `## Title`.

* `deft-org-mode-title-prefix` - When non-nil, automatically
  generated titles in new `org-mode` files will be prefixed with
  `#+TITLE:`.

Other Customizations
--------------------

Deft, by default, lists files from newest to oldest.  You can set
`deft-current-sort-method` to 'title to sort by file titles, case
ignored.  Or, you can toggle sorting method using
`deft-toggle-sort-method`.

Incremental string search is the default method of filtering on
startup, but you can set `deft-incremental-search` to nil to make
regexp search the default.

Deft also provides a function for opening files without using the
Deft buffer directly.  Calling `deft-find-file` will prompt for a
file to open, much like `find-file`, but limits consideration to
files in `deft-directory` that are known to Deft (i.e., those files
matching `deft-extensions`).  Unlike `find-file`, a list of all
such files is provided and the desired file name can be completed
using `completing-read` (and, as a result, `deft-find-file` will
read/complete filenames using ido, helm, etc.  when enabled).  If
the selected file is in `deft-directory`, it is opened with the
usual Deft features (automatic saving, automatic updating of the
Deft buffer, etc.).  Otherwise, the file will be opened by
`find-file` as usual.  Therefore, you can set up a global
keybinding for this function to open Deft files anywhere.  For
example, to use <kbd>C-x C-g</kbd>, a neighbor of <kbd>C-x C-f</kbd>, use the
following:

    (global-set-key (kbd "C-x C-g") 'deft-find-file)

The faces used for highlighting various parts of the screen can
also be customized.  By default, these faces inherit their
properties from the standard font-lock faces defined by your current
color theme.

Deft also provides several hooks: `deft-mode-hook`,
`deft-filter-hook`, and `deft-open-file-hook`.  See the
documentation for these variables for further details.

Acknowledgments
---------------

Thanks to Konstantinos Efstathiou for writing simplenote.el, from
which I borrowed liberally, and to Zachary Schneirov for writing
Notational Velocity, whose functionality and spirit I wanted to
bring to Emacs.

History
-------

Version 0.8 (2018-01-12):

* Limit `deft-find-file` to files known to Deft and support
  completing-read.
* Keep subdirectory portion when displaying filenames.
* New variable `deft-width-offset` for custom summary line width
  offset.
* Attempt to restore point after refreshing browser and preserve
  position while filtering.
* Add hooks: `deft-filter-hook` for filter string changes and
  `deft-open-file-hook` which runs after opening a file.
* Prevent spurious Deft browser refreshes, which fixes an issue
  with `sublimity-mode`.
* More reliable browser updates when window size changes.
* Only update width when buffer is visible.
* Lazily update the Deft buffer after saving files.
* Close open buffer when deleting a file.
* Initialize width even when started in background.
* Omit files generated from org or markdown.
* Custom format string `deft-new-file-format` for new file names.
* Reduce summary line width when there is no fringe.
* Support Org links.
* Option `deft-filter-only-filenames` to filter only on file names.

Version 0.7 (2015-12-21):

* Add custom regular expression `deft-strip-summary-regexp` for
  stripping extraneous text for generating the summary line.  Strip
  all `org-mode` metadata by default.
* New customizable regular expressions for ignoring files and
  directories.  See `deft-recursive-ignore-dir-regexp` and
  `deft-ignore-file-regexp`.
* Bug fix: Prevent lines from wrapping in console mode.
* Bug fix: Setup `deft-extensions` and `deft-default-extension` at
  load time.
* Bug fix: Try to prevent false title matches in org-mode notes
  where the string `#+TITLE:` might also appear in the body.
* Bug fix: Use `with-current-buffer` instead of `save-excursion`
  while auto-saving files since we do not want to save the point.
* Bug fix: Don't escape quotes in `deft-file-naming-rules`.

Version 0.6 (2015-06-26):

* Recursive search in subdirectories (optional).  Set
  `deft-recursive` to a non-nil value to enable.
* Support for multiple extensions via the `deft-extensions` list.
  As such, `deft-extension` is now deprecated.
* New variable `deft-create-file-from-filter-string` can enable
  generation of new filenames based on the filter string.  This decouples
  the title display (`deft-use-filename-as-title`) from the actual filename
  generation.
* New variable `deft-file-naming-rules` allows customizing generation
  of filenames with regard to letter case and handling of spaces.
* New variables `deft-markdown-mode-title-level` and
  `deft-org-mode-title-prefix` for automatic insertion of title markup.
* Archiving of files in `deft-archive-directory`.
* Ability to sort by either title or modification time via
  `deft-current-sort-method`.
* Update default `deft-strip-title-regexp` to remove the following:
    - org-mode `#+TITLE:` tags
    - MultiMarkdown `Title:` tags
    - LaTeX comment markers
    - Emacs mode-line declarations (e.g., `-*-mode-*-`)
* Remove leading and trailing whitespace from titles.
* Disable visual line mode to prevent lines from wrapping.
* Enable line truncation to avoid displaying truncation characters.
* Show the old filename as the default prompt when renaming a file.
* Call `hack-local-variables` to read file-local variables when
  opening files.
* Fixed several byte-compilation warnings.
* Bug fix: more robust handling of relative and absolute filenames.
* Bug fix: use width instead of length of strings for calculations.
* Bug fix: fix `string-width` error with empty file.

Version 0.5.1 (2013-01-28):

* Bug fix: creating files with <kbd>C-c C-n</kbd> when both the filter string and
  `deft-use-filename-as-title` are non-nil resulted in an invalid path.
* Bug fix: killed buffers would persist in `deft-auto-save-buffers`.

Version 0.5 (2013-01-25):

* Implement incremental string search (default) and regexp search.
  These search modes can be toggled by pressing <kbd>C-c C-t</kbd>.
* Default search method can be changed by setting `deft-incremental-search`.
* Support custom `deft-parse-title-function` for post-processing titles.
* The default `deft-parse-title-function` simply strips occurrences of
  `deft-strip-title-regexp`, which removes Markdown and Org headings.
* Open files in another window with <kbd>C-o</kbd>.  Prefix it with <kbd>C-u</kbd> to
  switch to the other window.
* For symbolic links, use modification time of taget for sorting.
* When opening files, move point to the end of the first match of
  the filter string.
* Improved filter editing: delete (`DEL`), delete word (<kbd>M-DEL</kbd>),
  and yank (<kbd>C-y</kbd>).
* Advanced filter editing in minibuffer (<kbd>C-c C-l</kbd>).

Version 0.4 (2011-12-11):

* Improved filtering performance.
* Optionally take title from filename instead of first line of the
  contents (see `deft-use-filename-as-title`).
* Dynamically resize width to fit the entire window.
* Customizable time format (see `deft-time-format`).
* Handle `deft-directory` properly with or without a trailing slash.

Version 0.3 (2011-09-11):

* Internationalization: support filtering with multibyte characters.

Version 0.2 (2011-08-22):

* Match filenames when filtering.
* Automatically save opened files (optional).
* Address some byte-compilation warnings.

Deft was originally written by [Jason Blevins](https://jblevins.org/).
The initial version, 0.1, was released on August 6, 2011.

IN NO EVENT WILL DeFT's DISTRIBUTORS BE LIABLE FOR ANY DAMAGES, LOST PROFIT,
LOST DATA, LOSS OF USE, INCLUDING BUT NOT LIMITED TO SPECIAL, INCIDENTAL,
CONSEQUENTIAL OR INDIRECT DAMAGES, ARISING FROM THE USE OF DeFT, HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, EVEN IF DeFT's DISTRIBUTORS HAVE BEEN
ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  DeFT's DISTRIBUTORS MAKES NO
WARRANTIES AS TO THE PERFORMANCE, CORRECTNESS, OR GENERAL FITNESS OF DeFT.
IN ADDITION, DeFT's DISTRIBUTORS SHALL NOT BE OBLIGATED TO CORRECT OR MAINTAIN
DeFT, OR NOTIFY USERS OF MODIFICATIONS OR UPDATES.

The User understands that DeFT is an experimental computer code.

This subdirectory contains several sample DeFT input files.  The DeFT shell
included in this subdirectory is discussed in the installation document found
in the parent directory.  To run the input in acetone.dft, for example, one
need only type in

       DeFT acetone

or

       DeFT acetone &

to run in the background.

Many of the input files have _a, _b, _c, _d, ... in their names.  Often, this
is done for illustrative purposes, to reinforce the fact that some types of
DeFT runs require a restart file from a previous run (for example, this is
necessary for vibrational analyses and constrained MESP fitting procedures).
Therefore, the _b file uses the restart file from the _a run, the _c file
uses the restart file from the _b run, etc. etc.  In practise, you will most
likely just retain the same filenames.  You are *not* required to use distinct
new filenames for subsequent runs using previously created restart files.
Restart files are not included in this distribution, as they are binary files.
Therefore, to run ethylene_b.dft, for example, you will need to first run
ethylene_a.dft and transfer its restart file, ethylene_a.rst, to ethylene_b.rst

Samples of straightforward geometry optimizations are given by:

   1,3-difluorobenzene.dft
   2-hydroxybicyclopentane.dft
   acetone.dft
   acetylene.dft
   allene.dft
   ammonia.dft
   benzene.dft
   benzaldehyde.dft
   bh4-.dft                    (geometry defined using internal coordinates)
   disilyl_ether.dft
   ethane.dft
   ethanol.dft
   ethylene_a.dft              (geometry defined using internal coordinates)
   furan.dft
   hcn_a.dft                   (geometry defined using internal coordinates)
   hydroxysulphane.dft
   methanol.dft                (geometry defined using internal coordinates)
   methylamine.dft
   neopentane.dft
   nh4+.dft                    (geometry defined using internal coordinates)
   o2.dft                      (geometry defined using internal coordinates)
   water.dft

Samples of constrained geometry optimizations are given by:

   peroxide_a.dft
   peroxide_b.dft
   peroxide_c.dft

Finding a transition state is illustrated in:

   peroxide_d.dft

Performing a vibrational analysis is illustrated in:

   ethylene_b.dft  (local minimum, requires restart file from ethylene_a)
   hcn_b.dft       (local minimum, requires restart file from hcn_a)
   peroxide_e.dft  (transition state, requires restart file from peroxide_d)

The particular problems associated with calculations on atoms with partially
filled subshells are illustrated in:

   c_atom.dft
   f_atom.dft

The pros and cons of

  1) using different quality grids for the SCF and the final total energy and
     energy gradients

  2) using gradient corrections

  3) using a perturbative approach to gradient-corrections

  4) not calculating grid point weight derivatives

are highlighted in the following set of input files:

   malonaldehyde_a.dft
   malonaldehyde_b.dft
   malonaldehyde_c.dft
   malonaldehyde_d.dft
   malonaldehyde_e.dft
   malonaldehyde_f.dft
   malonaldehyde_g.dft
   malonaldehyde_h.dft
   malonaldehyde_i.dft

N.B. malonaldehyde has the *worst* errors I've error seen introduced by not
     calculating grid point weight derivatives --- in most cases the errors
     introduced are negligeable

N.B. malonaldehyde is an example of a molecule where gradient-corrections are
     absolutely necessary to properly describe the geometry --- in most cases
     only the thermochemistry absolutely requires the use of
     gradient-corrections

Unconstrained and constrained MESP fits are presented in:

   acetone_a.dft
   acetone_b.dft     (requires the restart file from acetone_a)

The use of diffuse functions is presented in:

   hydroxide_a.dft
   hydroxide_b.dft
   hydroxide_c.dft

Boys localized and canonical molecular orbitals are generated in:

   formaldehyde_a.dft
   formaldehyde_b.dft
   ch2.dft

The explicit definition of basis sets is employed in:

   hcn_a.dft
   hcn_b.dft

      function getvalue(char_string,n)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      character char_string(n)

      rewind 77
      write(77,*) char_string

      rewind 77
      read(77,*) getvalue

      return
      end

      subroutine cdftps(m,n,ncds,ncdspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,g,coord,alphaaux,coeffs,coeffp,
     &                  coeffd,tvec,dmat,zeta,px,py,pz,base,pxax,pyay,
     &                  pzaz,u,zetarec,wxcx,wycy,wzcz,wxpx,wypy,wzpz,
     &                  sss0,sss1,sss2,sss3,pss,pss0,pss1,pss2,ssp1,psp,
     &                  psp0,psp1,psd,psd0,zetac1,zetac2,c,c1,c2,zzeta,
     &                  ppx,ppy,ppz,ppxax,ppyay,ppzaz,gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cdfitp(3),cdfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(m,*),
     &          iloc(*)

      dimension g(*),coord(3,*),alphaaux(*),coeffs(*),coeffp(*),
     &          coeffd(*),tvec(*),dmat(*),zeta(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),u(*),zetarec(*),wxcx(*),
     &          wycy(*),wzcz(*),wxpx(*),wypy(*),wzpz(*),sss0(*),sss1(*),
     &          sss2(*),sss3(*),pss(m,*),pss0(n,*),pss1(n,*),pss2(n,*),
     &          ssp1(n,*),psp(m,*),psp0(n,*),psp1(n,*),psd(m,*),
     &          psd0(n,*),zetac1(*),zetac2(*),c(*),c1(n,*),c2(n,*),
     &          zzeta(*),ppx(*),ppy(*),ppz(*),ppxax(*),ppyay(*),
     &          ppzaz(*),gather(n,*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data five,seven/5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(2,n,iloc,u,psp0,ppx,ppy,ppz)

      do 1004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,1)/zeta(i)/zetaux
 1004 sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,2)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
 1006 zetac1(i)=zetaux*zetarec(i)

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1008 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1009 i=1,nn
 1009 gather(i,1)=zero

      do 1010 j=1,3
      do 1010 i=1,nn
 1010 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pss0(i,j)

      do 1011 i=1,nn
 1011 gather(i,1)=gather(i,1)*cdfits

      do 1012 i=1,nn
 1012 tvec(naux)=tvec(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=coeffs(ilaux)

      cdfitp(1)=coeffp(ilaux)
      cdfitp(2)=coeffp(ilaux)
      cdfitp(3)=coeffp(ilaux)

      cdfitd(1)=coeffd(ilaux)/dnormcd
      cdfitd(2)=coeffd(ilaux)
      cdfitd(3)=coeffd(ilaux)
      cdfitd(4)=coeffd(ilaux)/dnormcd
      cdfitd(5)=coeffd(ilaux)
      cdfitd(6)=coeffd(ilaux)/dnormcd

      do 2002 i=1,n
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 2003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(4,n,iloc,u,psp0,ppx,ppy,ppz)

      do 2004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,3)/zeta(i)/zetaux
 2004 sss3(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,4)/zeta(i)/zetaux

      nn=0

      do 2005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                 endif
 2005 continue

      do 2006 i=1,nn
      zetac1(i)=zetaux*zetarec(i)
 2006 zetac2(i)=zzeta(i)*zetarec(i)

      do 2007 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 2007 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 2008 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 2008 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 2009 i=1,nn

      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
      pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

 2009 continue

      do 2010 i=1,nn
      ssp1(i,1)=wxcx(i)*sss2(i)
      ssp1(i,2)=wycy(i)*sss2(i)
 2010 ssp1(i,3)=wzcz(i)*sss2(i)

      do 2011 i=1,nn

      c(i)=half*sss1(i)*zetarec(i)

      psp0(i,1)=wxcx(i)*pss1(i,1)+c(i)
      psp0(i,2)=wycy(i)*pss1(i,1)
      psp0(i,3)=wzcz(i)*pss1(i,1)
      psp0(i,4)=wxcx(i)*pss1(i,2)
      psp0(i,5)=wycy(i)*pss1(i,2)+c(i)
      psp0(i,6)=wzcz(i)*pss1(i,2)
      psp0(i,7)=wxcx(i)*pss1(i,3)
      psp0(i,8)=wycy(i)*pss1(i,3)
      psp0(i,9)=wzcz(i)*pss1(i,3)+c(i)

      c(i)=half*sss2(i)*zetarec(i)

      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
      psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

 2011 continue

      do 2012 j=1,3
      do 2012 i=1,nn
 2012 c1(i,j)=(pss0(i,j)-zetac2(i)*pss1(i,j))/(two*zetaux)

      do 2013 j=1,3
      do 2013 i=1,nn
 2013 c2(i,j)=half*ssp1(i,j)*zetarec(i)

      do 2014 i=1,nn
      psd0(i,01)=wxcx(i)*psp1(i,1)+c1(i,1)+c2(i,1)
      psd0(i,02)=wycy(i)*psp1(i,1)
      psd0(i,03)=wzcz(i)*psp1(i,1)
      psd0(i,04)=wycy(i)*psp1(i,2)+c1(i,1)
      psd0(i,05)=wzcz(i)*psp1(i,2)
      psd0(i,06)=wzcz(i)*psp1(i,3)+c1(i,1)
      psd0(i,07)=wxcx(i)*psp1(i,4)+c1(i,2)
      psd0(i,08)=wycy(i)*psp1(i,4)        +c2(i,1)
      psd0(i,09)=wzcz(i)*psp1(i,4)
      psd0(i,10)=wycy(i)*psp1(i,5)+c1(i,2)+c2(i,2)
      psd0(i,11)=wzcz(i)*psp1(i,5)
      psd0(i,12)=wzcz(i)*psp1(i,6)+c1(i,2)
      psd0(i,13)=wxcx(i)*psp1(i,7)+c1(i,3)
      psd0(i,14)=wycy(i)*psp1(i,7)
      psd0(i,15)=wzcz(i)*psp1(i,7)        +c2(i,1)
      psd0(i,16)=wycy(i)*psp1(i,8)+c1(i,3)
      psd0(i,17)=wzcz(i)*psp1(i,8)        +c2(i,2)
 2014 psd0(i,18)=wzcz(i)*psp1(i,9)+c1(i,3)+c2(i,3)

      do 2015 j=1,10
      do 2015 i=1,nn
 2015 gather(i,j)=zero

      do 2016 j=1,3
      do 2016 i=1,nn
 2016 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pss0(i,j)

      do 2017 k=1,3
      do 2017 j=1,3
      do 2017 i=1,nn
 2017 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*psp0(i,3*(j-1)+k)

      do 2018 k=1,6
      do 2018 j=1,3
      do 2018 i=1,nn
 2018 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*psd0(i,6*(j-1)+k)

      do 2019 i=1,nn
      gather(i,01)=gather(i,01)*cdfits
      gather(i,02)=gather(i,02)*cdfitp(1)
      gather(i,03)=gather(i,03)*cdfitp(2)
      gather(i,04)=gather(i,04)*cdfitp(3)
      gather(i,05)=gather(i,05)*cdfitd(1)
      gather(i,06)=gather(i,06)*cdfitd(2)
      gather(i,07)=gather(i,07)*cdfitd(3)
      gather(i,08)=gather(i,08)*cdfitd(4)
      gather(i,09)=gather(i,09)*cdfitd(5)
 2019 gather(i,10)=gather(i,10)*cdfitd(6)

      nc=ncds+(naux-1)*10

      do 2020 i=1,nn
      do 2020 j=1,10
 2020 tvec(nc+j)=tvec(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine gridcall(nreal,nxcdim,iswitch,iteration,nfunctional,
     &                    ncenters,natoms,nbsystems,nalpha,nbeta,nconts,
     &                    ncontp,ncontd,nxcs,nxcspd,nmaxpts,natomtype,
     &                    nptsatom,nshels,nshelp,nsheld,ilfunc,icfunc,
     &                    ngauss,ixclfunc,ixccfunc,isys,ixclsave,iwkvec,
     &                    xim,cutoff,coord,alpha,coeffs,alphaxc,coefsxc,
     &                    coefpxc,coefdxc,xcfita,xcfitb,xcfite,amat,
     &                    bmat,tveca,tvecb,tvece,storexc,xcstore,
     &                    overlap,focka,fockb,focke,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),ngauss(*),ixclfunc(*),ixccfunc(*),
     &          isys(natoms,*),ixclsave(*),iwkvec(*)

      dimension coord(3,*),amat(*),bmat(*),alpha(*),coeffs(*),
     &          alphaxc(*),coefsxc(*),coefpxc(*),coefdxc(*),xcfita(*),
     &          xcfitb(*),xcfite(*),tveca(*),tvecb(*),tvece(*),
     &          storexc(*),xcstore(*),overlap(nxcdim,*),focka(*),
     &          fockb(*),focke(*),wkvec(*)

      data zero,one/0.0d0,1.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ncntrt=nconts+3*ncontp+6*ncontd
      ndim=ncntrt*(ncntrt+1)/2

      nxcfit=nxcs+10*(nxcspd-nxcs)

      if(myid.eq.0) rewind 19

casa
c     if((iteration.gt.1).and.(myid.eq.0)) then

c                              do 1001 i=1,nxcfit
c1001                          call fastrd(19,overlap(1,i),nxcfit)

c                              do 1002 i=1,nxcfit
c                              tvecb(i)=zero
c                              do 1002 j=1,nxcfit
c1002                          tvecb(i)=tvecb(i)+overlap(j,i)*tveca(j)

c                              rewind 19

c                                          endif

c     call mpi_bcast(tvecb,nxcfit,mpi_real8,0,mpi_comm_world,ierr)
casa

      nbsystems_save=nbsystems

      if(nxcfit.eq.0) nbsystems=1

      do 1003 i=1,ndim
      focka(i)=zero
      fockb(i)=zero
 1003 if(nxcfit.eq.0) focke(i)=zero

      call mpi_bcast(amat,ndim,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(bmat,ndim,mpi_real8,0,mpi_comm_world,ierr)

casa
c     do 1004 i=1,nxcfit
c     xcfita(i)=zero
c     xcfitb(i)=zero
c     storexc(2*nxcfit+i)=zero
c1004 xcstore(2*nxcfit+i)=xcfite(i)
casa

      nxcs_save=nxcs
      nxcspd_save=nxcspd-nxcs

      do 1005 i=1,nxcfit
 1005 ixclsave(i)=ixclfunc(i)

      do 1006 i=1,nbsystems

      if(iswitch.eq.0) goto 1007

      do 1008 j=1,ncenters
 1008 iwkvec(j)=0

      do 1009 j=1,ncenters
      do 1009 k=1,isys(1,i)
 1009 if(dist(coord(1,j),coord(1,isys(k+1,i))).le.cutoff) iwkvec(j)=1

      nxcs=0

      do 1010 j=1,nxcs_save
      if(iwkvec(ixccfunc(ixclsave(j))).eq.1) then

                             nxcs=nxcs+1
                             ixclfunc(nxcs)=ixclsave(j)

                                             endif
 1010 continue

      nxcspd=0

      do 1011 j=1,nxcspd_save
      if(iwkvec(ixccfunc(ixclsave(nxcs_save+j))).eq.1) then

                             nxcspd=nxcspd+1
                             ixclfunc(nxcs+nxcspd)=ixclsave(nxcs_save+j)

                                                       endif
 1011 continue

      do 1012 j=1,ncenters
 1012 iwkvec(j)=0

      do 1013 j=1,isys(1,i)
 1013 iwkvec(isys(j+1,i))=1

 1007 continue

      nxcfunc=nxcs+10*nxcspd

      nxcspd=nxcspd+nxcs

      nstart=min(512,32*numprocs)

      npoints=nstart+16

 1014 npoints=npoints-16

      if(npoints.le.0) stop 'real overflow for scf grid work'

      nfunctions=max(ncntrt,nxcfunc)
      norbitals=max(nalpha,nbeta)
      nwork=max((nfunctions*30*2+nfunctions*3),(npoints*121),
     &          (((nxcfunc*(nxcfunc+1))/2)+npoints*7))

      ka=1
      kb=ka+npoints*nfunctions
      kc=kb+npoints*norbitals
      kd=kc+npoints*norbitals
      ke=kd+npoints*3
      kf=ke+nmaxpts*2
      kg=kf+nmaxpts
      kh=kg+npoints
      ki=kh+npoints*3
      kj=ki+npoints*3
      kk=kj+npoints*3
      kl=kk+npoints*3
      km=kl+npoints*3
      kn=km+npoints*3
      ko=kn+npoints*3
      kp=ko+npoints*3
      kq=kp+npoints*3
      kr=kq+nmaxpts
      ks=kr+nmaxpts
      kt=ks+nmaxpts
      ku=kt+nmaxpts
      kv=ku+nwork
      kw=kv+npoints*nfunctions
      kx=kw+npoints*nfunctions
      ky=kx+npoints*ncntrt
      kz=ky+npoints*ncntrt
      la=kz+npoints*ncntrt
      lb=la+npoints*ncntrt
      lc=lb+npoints*ncntrt
      ld=lc+npoints*ncntrt
      le=ld+npoints*ncntrt
      lf=le+npoints*ncntrt
      lg=lf+npoints*ncntrt
      lh=lg+npoints*ncntrt
      li=lh+npoints*ncntrt
      lj=li+ncntrt
      lk=lj+ncntrt+nfunctions
      ll=lk+ncntrt+nfunctions
      lm=ll+ncenters
      ln=lm+natoms*natoms

      if((ln.gt.nreal).and.(npoints.gt.16)) goto 1014

      call gridwork(i,iswitch,iteration,nfunctional,nxcdim,npoints,
     &              nfunctions,norbitals,ncntrt,ncenters,natoms,
     &              nbsystems,nalpha,nbeta,nconts,ncontp,ncontd,nxcfunc,
     &              nxcs,nxcspd,natomtype,nptsatom,nshels,nshelp,nsheld,
     &              ilfunc,icfunc,ngauss,ixclfunc,ixccfunc,iwkvec,
     &              iwkvec(ncenters+1),coord,alpha,coeffs,alphaxc,
     &              coefsxc,coefpxc,coefdxc,tveca,tvecb,tvece,overlap,
     &              amat,bmat,wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &              wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &              wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),
     &              wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),
     &              wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),
     &              focka,fockb,focke)

      if(iswitch.eq.0) goto 1015

casa
c     ja=1
c     jb=ja+nxcfunc*nxcfunc
c     jc=jb+nxcfunc*nxcfunc
c     jd=jc+nxcfunc*nxcfunc
c     je=jd+nxcfunc*nxcfunc
c     jf=je+nxcfunc
c     jg=jf+nxcfunc
c     jh=jg+nxcfunc
c     ji=jh+nxcfunc

c     if(ji.gt.nreal) stop 'matrix inversion required for grid work'

c     if((nxcfunc.gt.1).and.(iteration.eq.1)) then

c             do 1016 j=1,nxcfunc
c             do 1016 k=1,j
c1016         overlap(j,k)=overlap(k,j)

c             jk=0

c             do 1017 k=1,nxcfunc
c             do 1017 j=1,nxcfunc
c             jk=jk+1
c1017         wkvec(jk)=overlap(j,k)

c             call mpi_bcast(wkvec,nxcfunc**2,
c    &                       mpi_real8,0,mpi_comm_world,ierr)

c             call x_annihilate(19,nxcfunc,iwkvec,iwkvec(numprocs+1),
c    &                          wkvec(ja),overlap,wkvec(jb),wkvec(jc),
c    &                          wkvec(jd),wkvec(je),wkvec(jf),wkvec(jg),
c    &                          wkvec(jh))

c             goto 1006

c                                             endif
casa

      if((myid.gt.0).or.(nxcfunc.eq.0)) goto 1006

casa
c     call gtxccf(xcfite,tvece,overlap,nxcfunc,nxcdim)

c     do 1018 j=1,nxcfunc
c1018 tvece(j)=xcfite(j)

c     do 1019 j=1,ncenters
c1019 iwkvec(j)=0

c     do 1020 j=1,ncenters
c     do 1020 k=1,isys(1,i)
c1020 if(dist(coord(1,j),coord(1,isys(k+1,i))).le.cutoff) iwkvec(j)=1

c     nxcs=0

c     do 1021 j=1,nxcs_save
c     if(iwkvec(ixccfunc(ixclsave(j))).eq.1) then
c                                                  nxcs=nxcs+1

c                                                  xcfite(j)=tvece(nxcs)
c                                            else
c                                                  xcfite(j)=zero
c                                            endif
c1021 continue

c     nxcspd=0

c     do 1022 j=1,nxcspd_save
c     if(iwkvec(ixccfunc(ixclsave(nxcs_save+j))).eq.1) then

c             nxcspd=nxcspd+1

c             xcfite(nxcs_save+10*(j-1)+01)=tvece(nxcs+10*(nxcspd-1)+01)
c             xcfite(nxcs_save+10*(j-1)+02)=tvece(nxcs+10*(nxcspd-1)+02)
c             xcfite(nxcs_save+10*(j-1)+03)=tvece(nxcs+10*(nxcspd-1)+03)
c             xcfite(nxcs_save+10*(j-1)+04)=tvece(nxcs+10*(nxcspd-1)+04)
c             xcfite(nxcs_save+10*(j-1)+05)=tvece(nxcs+10*(nxcspd-1)+05)
c             xcfite(nxcs_save+10*(j-1)+06)=tvece(nxcs+10*(nxcspd-1)+06)
c             xcfite(nxcs_save+10*(j-1)+07)=tvece(nxcs+10*(nxcspd-1)+07)
c             xcfite(nxcs_save+10*(j-1)+08)=tvece(nxcs+10*(nxcspd-1)+08)
c             xcfite(nxcs_save+10*(j-1)+09)=tvece(nxcs+10*(nxcspd-1)+09)
c             xcfite(nxcs_save+10*(j-1)+10)=tvece(nxcs+10*(nxcspd-1)+10)

c                                                      else

c             xcfite(nxcs_save+10*(j-1)+01)=zero
c             xcfite(nxcs_save+10*(j-1)+02)=zero
c             xcfite(nxcs_save+10*(j-1)+03)=zero
c             xcfite(nxcs_save+10*(j-1)+04)=zero
c             xcfite(nxcs_save+10*(j-1)+05)=zero
c             xcfite(nxcs_save+10*(j-1)+06)=zero
c             xcfite(nxcs_save+10*(j-1)+07)=zero
c             xcfite(nxcs_save+10*(j-1)+08)=zero
c             xcfite(nxcs_save+10*(j-1)+09)=zero
c             xcfite(nxcs_save+10*(j-1)+10)=zero

c                                            endif
c1022 continue

c     do 1023 j=1,nxcfit
c1023 storexc(2*nxcfit+j)=storexc(2*nxcfit+j)+xcfite(j)

 1006 continue

casa
c     do 1024 j=1,nxcfit
c1024 ixclfunc(j)=ixclsave(j)

c     nxcs=nxcs_save
c     nxcspd=nxcs_save+nxcspd_save

c     if(iteration.gt.1) then

c        do 1025 i=1,nxcfit
c1025    xcfite(i)=xim*storexc(2*nxcfit+i)+(one-xim)*xcstore(2*nxcfit+i)

c                        endif
casa

 1015 continue

      nbsystems=nbsystems_save

      return
      end

      subroutine gradovds(ndim,m,n,icontr,inddyy,icentr,density,overlap,
     &                    gradient,zeta,twozetaa,eta,eta2,base,etarr,
     &                    pxax,pyay,pzaz,twozeta,ss0,ss,ps0,ps,ds,fs,c,
     &                    c1,pscond,fscond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),icentr(m,*)

      dimension density(*),overlap(ndim,*),gradient(3,*),zeta(*),
     &          twozetaa(*),eta(*),eta2(*),base(*),etarr(*),pxax(*),
     &          pyay(*),pzaz(*),twozeta(*),ss0(*),ss(*),ps0(n,*),
     &          ps(n,*),ds(n,*),fs(n,*),c(*),c1(n,*),pscond(m,*),
     &          fscond(m,*),grad(m,*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)
      ps0(i,2)=pyay(i)*ss0(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
 1004 c(i)=ss0(i)/twozeta(i)

      do 1005 i=1,n
      ds(i,1)=pxax(i)*ps0(i,1)+c(i)
      ds(i,2)=pyay(i)*ps0(i,1)
      ds(i,3)=pzaz(i)*ps0(i,1)
      ds(i,4)=pyay(i)*ps0(i,2)+c(i)
      ds(i,5)=pzaz(i)*ps0(i,2)
 1005 ds(i,6)=pzaz(i)*ps0(i,3)+c(i)

      do 1006 j=1,3
      do 1006 i=1,n
 1006 c1(i,j)=ps0(i,j)/twozeta(i)

      do 1007 i=1,n
      fs(i,01)=pxax(i)*ds(i,1)+c1(i,1)+c1(i,1)
      fs(i,02)=pyay(i)*ds(i,1)
      fs(i,03)=pzaz(i)*ds(i,1)
      fs(i,04)=pyay(i)*ds(i,2)+c1(i,1)
      fs(i,05)=pzaz(i)*ds(i,2)
      fs(i,06)=pzaz(i)*ds(i,3)+c1(i,1)
      fs(i,07)=pyay(i)*ds(i,4)+c1(i,2)+c1(i,2)
      fs(i,08)=pzaz(i)*ds(i,4)
      fs(i,09)=pzaz(i)*ds(i,5)+c1(i,2)
 1007 fs(i,10)=pzaz(i)*ds(i,6)+c1(i,3)+c1(i,3)

      do 1008 j=1,3
      do 1008 i=1,m
 1008 pscond(i,j)=zero

      do 1009 j=1,10
      do 1009 i=1,m
 1009 fscond(i,j)=zero

      do 1010 j=1,3
      do 1010 i=1,n
 1010 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)

      do 1011 j=1,10
      do 1011 i=1,n
 1011 fscond(icontr(i),j)=fscond(icontr(i),j)+fs(i,j)*twozetaa(i)

      do 1012 i=1,m
      overlap(inddyy(i,1),1)=overlap(inddyy(i,1),1)-pscond(i,1)*two
      overlap(inddyy(i,2),1)=overlap(inddyy(i,2),1)-pscond(i,2)
      overlap(inddyy(i,3),1)=overlap(inddyy(i,3),1)-pscond(i,3)
      overlap(inddyy(i,2),2)=overlap(inddyy(i,2),2)-pscond(i,1)
      overlap(inddyy(i,4),2)=overlap(inddyy(i,4),2)-pscond(i,2)*two
      overlap(inddyy(i,5),2)=overlap(inddyy(i,5),2)-pscond(i,3)
      overlap(inddyy(i,3),3)=overlap(inddyy(i,3),3)-pscond(i,1)
      overlap(inddyy(i,5),3)=overlap(inddyy(i,5),3)-pscond(i,2)
 1012 overlap(inddyy(i,6),3)=overlap(inddyy(i,6),3)-pscond(i,3)*two

      do 1013 i=1,m
      overlap(inddyy(i,1),1)=overlap(inddyy(i,1),1)+fscond(i,01)
      overlap(inddyy(i,2),1)=overlap(inddyy(i,2),1)+fscond(i,02)
      overlap(inddyy(i,3),1)=overlap(inddyy(i,3),1)+fscond(i,03)
      overlap(inddyy(i,4),1)=overlap(inddyy(i,4),1)+fscond(i,04)
      overlap(inddyy(i,5),1)=overlap(inddyy(i,5),1)+fscond(i,05)
      overlap(inddyy(i,6),1)=overlap(inddyy(i,6),1)+fscond(i,06)
      overlap(inddyy(i,1),2)=overlap(inddyy(i,1),2)+fscond(i,02)
      overlap(inddyy(i,2),2)=overlap(inddyy(i,2),2)+fscond(i,04)
      overlap(inddyy(i,3),2)=overlap(inddyy(i,3),2)+fscond(i,05)
      overlap(inddyy(i,4),2)=overlap(inddyy(i,4),2)+fscond(i,07)
      overlap(inddyy(i,5),2)=overlap(inddyy(i,5),2)+fscond(i,08)
      overlap(inddyy(i,6),2)=overlap(inddyy(i,6),2)+fscond(i,09)
      overlap(inddyy(i,1),3)=overlap(inddyy(i,1),3)+fscond(i,03)
      overlap(inddyy(i,2),3)=overlap(inddyy(i,2),3)+fscond(i,05)
      overlap(inddyy(i,3),3)=overlap(inddyy(i,3),3)+fscond(i,06)
      overlap(inddyy(i,4),3)=overlap(inddyy(i,4),3)+fscond(i,08)
      overlap(inddyy(i,5),3)=overlap(inddyy(i,5),3)+fscond(i,09)
 1013 overlap(inddyy(i,6),3)=overlap(inddyy(i,6),3)+fscond(i,10)

      do 1014 i=1,n
 1014 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1015 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps0(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps0(i,2)
 1015 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps0(i,3)

      do 1016 i=1,n
 1016 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/twozetaa(i)

      do 1017 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds(i,2)
      ds(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds(i,3)
      ds(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds(i,4)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds(i,5)
 1017 ds(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds(i,6)+c(i)

      do 1018 j=1,3
      do 1018 i=1,n
 1018 c1(i,j)=ps(i,j)/twozeta(i)-eta2(i)*ps0(i,j)/twozetaa(i)

      do 1019 i=1,n
      fs(i,01)=pxax(i)*ds(i,1)+eta2(i)*fs(i,01)+c1(i,1)+c1(i,1)
      fs(i,02)=pyay(i)*ds(i,1)+eta2(i)*fs(i,02)
      fs(i,03)=pzaz(i)*ds(i,1)+eta2(i)*fs(i,03)
      fs(i,04)=pyay(i)*ds(i,2)+eta2(i)*fs(i,04)+c1(i,1)
      fs(i,05)=pzaz(i)*ds(i,2)+eta2(i)*fs(i,05)
      fs(i,06)=pzaz(i)*ds(i,3)+eta2(i)*fs(i,06)+c1(i,1)
      fs(i,07)=pyay(i)*ds(i,4)+eta2(i)*fs(i,07)+c1(i,2)+c1(i,2)
      fs(i,08)=pzaz(i)*ds(i,4)+eta2(i)*fs(i,08)
      fs(i,09)=pzaz(i)*ds(i,5)+eta2(i)*fs(i,09)+c1(i,2)
 1019 fs(i,10)=pzaz(i)*ds(i,6)+eta2(i)*fs(i,10)+c1(i,3)+c1(i,3)

      do 1020 j=1,3
      do 1020 i=1,m
 1020 pscond(i,j)=zero

      do 1021 j=1,10
      do 1021 i=1,m
 1021 fscond(i,j)=zero

      do 1022 j=1,3
      do 1022 i=1,n
 1022 pscond(icontr(i),j)=pscond(icontr(i),j)+ps(i,j)

      do 1023 j=1,10
      do 1023 i=1,n
 1023 fscond(icontr(i),j)=fscond(icontr(i),j)+fs(i,j)*twozetaa(i)

      do 1024 i=1,m
      grad(i,1)=pscond(i,1)*density(inddyy(i,1))*two
      grad(i,2)=pscond(i,2)*density(inddyy(i,2))
      grad(i,3)=pscond(i,3)*density(inddyy(i,3))
      grad(i,4)=pscond(i,1)*density(inddyy(i,2))
      grad(i,5)=pscond(i,2)*density(inddyy(i,4))*two
      grad(i,6)=pscond(i,3)*density(inddyy(i,5))
      grad(i,7)=pscond(i,1)*density(inddyy(i,3))
      grad(i,8)=pscond(i,2)*density(inddyy(i,5))
 1024 grad(i,9)=pscond(i,3)*density(inddyy(i,6))*two

      do 1025 k=1,3
      do 1025 j=1,3
      do 1025 i=1,m
 1025 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,3*(k-1)+j)

      do 1026 k=1,3
      do 1026 j=1,3
      do 1026 i=1,m
 1026 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,3*(k-1)+j)

      do 1027 i=1,m
      grad(i,01)=fscond(i,01)*density(inddyy(i,1))
      grad(i,02)=fscond(i,02)*density(inddyy(i,2))
      grad(i,03)=fscond(i,03)*density(inddyy(i,3))
      grad(i,04)=fscond(i,04)*density(inddyy(i,4))
      grad(i,05)=fscond(i,05)*density(inddyy(i,5))
      grad(i,06)=fscond(i,06)*density(inddyy(i,6))
      grad(i,07)=fscond(i,02)*density(inddyy(i,1))
      grad(i,08)=fscond(i,04)*density(inddyy(i,2))
      grad(i,09)=fscond(i,05)*density(inddyy(i,3))
      grad(i,10)=fscond(i,07)*density(inddyy(i,4))
      grad(i,11)=fscond(i,08)*density(inddyy(i,5))
      grad(i,12)=fscond(i,09)*density(inddyy(i,6))
      grad(i,13)=fscond(i,03)*density(inddyy(i,1))
      grad(i,14)=fscond(i,05)*density(inddyy(i,2))
      grad(i,15)=fscond(i,06)*density(inddyy(i,3))
      grad(i,16)=fscond(i,08)*density(inddyy(i,4))
      grad(i,17)=fscond(i,09)*density(inddyy(i,5))
 1027 grad(i,18)=fscond(i,10)*density(inddyy(i,6))

      do 1028 k=1,3
      do 1028 j=1,6
      do 1028 i=1,m
 1028 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,6*(k-1)+j)

      do 1029 k=1,3
      do 1029 j=1,6
      do 1029 i=1,m
 1029 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,6*(k-1)+j)

      return
      end

      subroutine baker(istep,nint,dmt,dmt1,dmt2,
     &                 f,vec1,vec2,vec3,vec4,vec5,grad,h)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension simvec(10000)

      dimension dmt(nint,*),dmt1(nint,*),dmt2(nint,*),f(*),vec1(*),
     &          vec2(*),vec3(*),vec4(*),vec5(*),grad(*),h(nint,*)

      data zero,half,four,eigmin/0.0d0,0.5d0,4.0d0,0.02d0/

      save simvec
    
      do 1001 j=1,nint
      do 1001 i=1,nint
 1001 dmt1(i,j)=h(i,j)

      call tred9(nint,nint,dmt1,vec1,vec2,vec3,dmt)
      call tql9(nint,nint,vec1,vec2,dmt,vec3,vec4,ierr)   

      inegative=0

      do 1002 i=1,nint
 1002 if(vec1(i).lt.zero) inegative=inegative+1

      do 1003 i=1,nint
      f(i)=zero
      do 1003 j=1,nint
 1003 f(i)=f(i)+dmt(j,i)*grad(j)

      imode=1

      if(istep.gt.1) then
                           dotmax=zero

                           imode=0   

                           do 1004 i=1,nint

                           dotprod=zero

                           do 1005 j=1,nint
 1005                      dotprod=dotprod+dmt(j,i)*simvec(j)

                           dotprod=abs(dotprod)

                           if(dotprod.gt.dotmax) then    
                                                       imode=i
                                                       dotmax=dotprod
                                                 endif

 1004                      continue
                     endif

      do 1006 i=1,nint
 1006 simvec(i)=dmt(i,imode)

      dunp=half*(vec1(imode)+sqrt((vec1(imode)**2)+four*(f(imode)**2)))

      do 1007 j=1,nint
      do 1007 i=1,nint
 1007 dmt1(i,j)=zero
 
      l=0

      do 1008 i=1,nint
      if(i.ne.imode) then
                           l=l+1
                           dmt1(l,l)=vec1(i)
                           dmt1(l,nint)=f(i)
                           dmt1(nint,l)=f(i)
                     endif
 1008 continue

      call tred9(nint,nint,dmt1,vec5,vec2,vec3,dmt2)
      call tql9(nint,nint,vec5,vec2,dmt2,vec3,vec4,ierr)

      dunn=vec5(1)

      if(imode.eq.1) then
                           dunnmax=vec1(2)
                     else
                           dunnmax=vec1(1)
                     endif

      if(dunn.ge.dunnmax) dunn=dunnmax-eigmin

      do 1009 i=1,nint
 1009 vec2(i)=zero  

      do 1010 i=1,nint
      if(i.eq.imode) eigval=dunp
      if(i.ne.imode) eigval=dunn
      do 1010 j=1,nint
 1010 vec2(j)=vec2(j)-(f(i)*dmt(j,i))/(vec1(i)-eigval)

      return
      end

      subroutine redundant(icycle,natoms,nmodes,nbonds,nangles,
     &                     ndihedrals,nimpropers,ifrozen,natomtype,
     &                     i_bond,i_angle,i_dihedral,i_improper,ifreeze,
     &                     dmaxstep,grms,gmax,crms,cmax,coord,q_0,q_1,
     &                     deltaq,deltax,bmatrix,gmatrix,ginvmatrix,
     &                     gcart,gint,gintp,pmatrix,amatrix,hessian,
     &                     wkmat1,wkmat2,coordsave,wkvec)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension natomtype(*),i_bond(2,*),i_angle(3,*),i_dihedral(4,*),
     &          i_improper(4,*),ifreeze(*)

      dimension coord(3,*),q_0(*),q_1(*),deltaq(*),deltax(*),
     &          bmatrix(nmodes,*),gmatrix(nmodes,*),
     &          ginvmatrix(nmodes,*),gcart(*),gint(*),gintp(*),
     &          pmatrix(nmodes,*),amatrix(3*natoms,*),hessian(nmodes,*),
     &          wkmat1(nmodes,*),wkmat2(nmodes,*),coordsave(3,*),
     &          wkvec(*)

      data zero,one,two,pi,bohr/0.0d0,1.0d0,
     &                          2.0d0,3.1415926535898d0,0.529177d0/
      data tolerance,big/0.000001d0,1000.0d0/
      data ang_cutoff,one80/170.0d0,180.0d0/

      fac=(one80/pi)

      call get_bmatrix(natoms,nmodes,nbonds,nangles,ndihedrals,
     &                 nimpropers,i_bond,i_angle,i_dihedral,i_improper,
     &                 coord,bmatrix)

      do 1001 i=1,nbonds
 1001 q_0(i)=dist(coord(1,i_bond(1,i)),coord(1,i_bond(2,i)))

      do 1002 i=1,nangles
      test=ang(coord(1,i_angle(1,i)),
     &         coord(1,i_angle(2,i)),
     &         coord(1,i_angle(3,i)))
      if(test.gt.ang_cutoff) icycle=0
      if(test.gt.ang_cutoff) return
      if(test.lt.(one80-ang_cutoff)) icycle=0
      if(test.lt.(one80-ang_cutoff)) return
 1002 q_0(nbonds+i)=dang(coord(1,i_angle(1,i)),
     &                   coord(1,i_angle(2,i)),
     &                   coord(1,i_angle(3,i)))

      do 1003 i=1,ndihedrals
      test1=ang(coord(1,i_dihedral(1,i)),
     &          coord(1,i_dihedral(2,i)),
     &          coord(1,i_dihedral(3,i)))
      test2=ang(coord(1,i_dihedral(2,i)),
     &          coord(1,i_dihedral(3,i)),
     &          coord(1,i_dihedral(4,i)))
      test=max(test1,test2)
      if(test.gt.ang_cutoff) icycle=0
      if(test.gt.ang_cutoff) return
      test=min(test1,test2)
      if(test.lt.(one80-ang_cutoff)) icycle=0
      if(test.lt.(one80-ang_cutoff)) return
 1003 q_0(nbonds+nangles+i)=ddihed(coord(1,i_dihedral(1,i)),
     &                             coord(1,i_dihedral(2,i)),
     &                             coord(1,i_dihedral(3,i)),
     &                             coord(1,i_dihedral(4,i)))

      do 1004 i=1,nimpropers
      test1=ang(coord(1,i_improper(1,i)),
     &          coord(1,i_improper(4,i)),
     &          coord(1,i_improper(2,i)))
      test2=ang(coord(1,i_improper(1,i)),
     &          coord(1,i_improper(4,i)),
     &          coord(1,i_improper(3,i)))
      test=max(test1,test2)
      if(test.gt.ang_cutoff) icycle=0
      if(test.gt.ang_cutoff) return
      test=min(test1,test2)
      if(test.lt.(one80-ang_cutoff)) icycle=0
      if(test.lt.(one80-ang_cutoff)) return
 1004 q_0(nbonds+nangles+ndihedrals+i)=dimp(coord(1,i_improper(1,i)),
     &                                      coord(1,i_improper(2,i)),
     &                                      coord(1,i_improper(3,i)),
     &                                      coord(1,i_improper(4,i)))

      do 1005 j=1,nmodes
      do 1005 i=1,nmodes
 1005 gmatrix(i,j)=zero

      do 1006 k=1,3*natoms
      do 1006 j=1,nmodes
      do 1006 i=1,nmodes
 1006 gmatrix(i,j)=gmatrix(i,j)+bmatrix(i,k)*bmatrix(j,k)

      ja=1
      jb=ja+nmodes*nmodes
      jc=jb+nmodes*nmodes
      jd=jc+nmodes

      call ginverse(nmodes,gmatrix,ginvmatrix,wkvec(ja),wkvec(jb),
     &              wkvec(jc),wkvec(jd))

      do 1007 i=1,nmodes
 1007 wkvec(i)=zero

      do 1008 j=1,3*natoms
      do 1008 i=1,nmodes
 1008 wkvec(i)=wkvec(i)+bmatrix(i,j)*gcart(j)

      do 1009 i=1,nmodes
 1009 gint(i)=zero

      do 1010 j=1,nmodes
      do 1010 i=1,nmodes
 1010 gint(i)=gint(i)+ginvmatrix(i,j)*wkvec(j)

      do 1011 j=1,nmodes
      do 1012 i=1,nmodes
 1012 pmatrix(i,j)=zero
      do 1011 k=1,nmodes
      do 1011 i=1,nmodes
 1011 pmatrix(i,j)=pmatrix(i,j)+gmatrix(i,k)*ginvmatrix(k,j)

      do 1013 i=1,nmodes
      wkvec(i)=zero
      do 1013 j=1,ifrozen
 1013 if(i.eq.ifreeze(j)) wkvec(i)=one

      do 1014 j=1,nmodes
      do 1015 i=1,nmodes
 1015 wkmat1(i,j)=zero
      do 1014 i=1,nmodes
 1014 wkmat1(i,j)=wkmat1(i,j)+wkvec(i)*pmatrix(i,j)

      do 1016 j=1,nmodes
      do 1017 i=1,nmodes
 1017 gmatrix(i,j)=zero
      do 1016 i=1,nmodes
 1016 gmatrix(i,j)=gmatrix(i,j)+pmatrix(i,j)*wkvec(j)

      do 1018 j=1,nmodes
      do 1019 i=1,nmodes
 1019 wkmat2(i,j)=zero
      do 1018 i=1,nmodes
 1018 wkmat2(i,j)=wkmat2(i,j)+wkvec(i)*gmatrix(i,j)

      ja=nmodes+1
      jb=ja+nmodes*nmodes
      jc=jb+nmodes*nmodes
      jd=jc+nmodes

      call ginverse(nmodes,wkmat2,gmatrix,wkvec(ja),wkvec(jb),
     &              wkvec(jc),wkvec(jd))

      do 1020 j=1,nmodes
      do 1021 i=1,nmodes
 1021 wkmat2(i,j)=zero
      do 1020 k=1,nmodes
      do 1020 i=1,nmodes
 1020 wkmat2(i,j)=wkmat2(i,j)+gmatrix(i,k)*wkmat1(k,j)

      do 1022 j=1,nmodes
      do 1023 i=1,nmodes
 1023 gmatrix(i,j)=zero
      do 1022 i=1,nmodes
 1022 gmatrix(i,j)=gmatrix(i,j)+wkvec(i)*wkmat2(i,j)

      do 1024 j=1,nmodes
      do 1025 i=1,nmodes
 1025 wkmat1(i,j)=zero
      do 1024 k=1,nmodes
      do 1024 i=1,nmodes
 1024 wkmat1(i,j)=wkmat1(i,j)+pmatrix(i,k)*gmatrix(k,j)

      do 1026 j=1,nmodes
      do 1026 i=1,nmodes
 1026 pmatrix(i,j)=pmatrix(i,j)-wkmat1(i,j)

      do 1027 i=1,nmodes
 1027 gintp(i)=zero

      do 1028 j=1,nmodes
      do 1028 i=1,nmodes
 1028 gintp(i)=gintp(i)+pmatrix(i,j)*gint(j)

      do 1029 j=1,nmodes
      do 1029 i=1,3*natoms
      amatrix(i,j)=zero
      do 1029 k=1,nmodes
 1029 amatrix(i,j)=amatrix(i,j)+bmatrix(k,i)*ginvmatrix(k,j)

      if(icycle.eq.1) then
                            call hguess(nmodes,nbonds,nangles,
     &                                  ndihedrals,nimpropers,natomtype,
     &                                  i_bond,i_angle,i_dihedral,
     &                                  i_improper,coord,hessian)
                      else
                            goto 1036
                      endif

      do 1030 j=1,nmodes
      do 1031 i=1,nmodes
 1031 wkmat1(i,j)=zero
      do 1030 k=1,nmodes
      do 1030 i=1,nmodes
 1030 wkmat1(i,j)=wkmat1(i,j)+hessian(i,k)*pmatrix(k,j)

      do 1032 j=1,nmodes
      do 1033 i=1,nmodes
 1033 hessian(i,j)=zero
      do 1032 k=1,nmodes
      do 1032 i=1,nmodes
 1032 hessian(i,j)=hessian(i,j)+pmatrix(i,k)*wkmat1(k,j)

      do 1034 j=1,nmodes
      do 1034 i=1,nmodes
      factor=zero
      if(i.eq.j) factor=one
 1034 hessian(i,j)=hessian(i,j)+big*(factor-pmatrix(i,j))

      ja=1
      jb=ja+nmodes*nmodes
      jc=jb+nmodes*nmodes
      jd=jc+nmodes

      call ginverse(nmodes,hessian,wkmat1,wkvec(ja),wkvec(jb),wkvec(jc),
     &              wkvec(jd))

      do 1035 j=1,nmodes
      do 1035 i=1,nmodes
 1035 hessian(i,j)=wkmat1(i,j)

 1036 continue

      ja=1
      jb=ja+nmodes
      jc=jb+nmodes
      jd=jc+nmodes
      je=jd+nmodes
      jf=je+nmodes*nmodes

      if(icycle.gt.1) then
                            call bfgs_r(icycle,nmodes,hessian,gintp,q_0,
     &                                  wkvec(ja),wkvec(jb),wkvec(jc),
     &                                  wkvec(jd),wkvec(je),wkvec(jf))
                      endif

      do 1037 i=1,nmodes
 1037 deltaq(i)=zero

      do 1038 j=1,nmodes
      do 1038 i=1,nmodes
 1038 deltaq(i)=deltaq(i)-hessian(i,j)*gintp(j)

      do 1039 i=1,nmodes
 1039 wkvec(i)=deltaq(i)

      do 1040 i=1,natoms
      do 1040 j=1,3
 1040 coordsave(j,i)=coord(j,i)

      check_save=one/tolerance

 1041 continue

      do 1042 i=1,3*natoms
 1042 deltax(i)=zero

      do 1043 j=1,nmodes
      do 1043 i=1,3*natoms
 1043 deltax(i)=deltax(i)+amatrix(i,j)*wkvec(j)

      check=zero

      do 1044 i=1,3*natoms
 1044 check=check+deltax(i)**2

      check=sqrt(check/real64(3*natoms))

      if(check.gt.check_save) write(6,1045)
 1045 format(/,' divergence in redundant internals --- resetting ',/)
      if(check.gt.check_save) goto 1054

      check_save=check

      do 1046 i=1,natoms
      do 1046 j=1,3
 1046 coord(j,i)=coord(j,i)+deltax(3*(i-1)+j)

      do 1047 i=1,nbonds
 1047 q_1(i)=dist(coord(1,i_bond(1,i)),coord(1,i_bond(2,i)))

      do 1048 i=1,nangles
 1048 q_1(nbonds+i)=dang(coord(1,i_angle(1,i)),
     &                   coord(1,i_angle(2,i)),
     &                   coord(1,i_angle(3,i)))

      do 1049 i=1,ndihedrals
 1049 q_1(nbonds+nangles+i)=ddihed(coord(1,i_dihedral(1,i)),
     &                             coord(1,i_dihedral(2,i)),
     &                             coord(1,i_dihedral(3,i)),
     &                             coord(1,i_dihedral(4,i)))

      do 1050 i=1,nimpropers
 1050 q_1(nbonds+nangles+ndihedrals+i)=dimp(coord(1,i_improper(1,i)),
     &                                      coord(1,i_improper(2,i)),
     &                                      coord(1,i_improper(3,i)),
     &                                      coord(1,i_improper(4,i)))

      do 1051 i=1,nmodes
 1051 wkvec(i)=q_1(i)-q_0(i)

      do 1052 i=1,nmodes
      if(wkvec(i).lt.(-pi)) wkvec(i)=wkvec(i)+two*pi
 1052 if(wkvec(i).gt.(+pi)) wkvec(i)=wkvec(i)-two*pi

      do 1053 i=1,nmodes
 1053 wkvec(i)=deltaq(i)-wkvec(i)

      if(check.gt.tolerance) goto 1041

 1054 continue

      cmax=zero

      do 1055 i=1,natoms
      difference=sqrt((coordsave(1,i)-coord(1,i))**2
     &               +(coordsave(2,i)-coord(2,i))**2
     &               +(coordsave(3,i)-coord(3,i))**2)
 1055 if(difference.gt.cmax) cmax=difference

      if(cmax.gt.dmaxstep) then

              do 1056 i=1,natoms
              do 1056 j=1,3
 1056         coord(j,i)=coordsave(j,i)
     &                  +(dmaxstep/cmax)*(coord(j,i)-coordsave(j,i))

                           endif

      do 1057 i=1,nmodes
 1057 wkvec(i)=q_1(i)-q_0(i)

      do 1058 i=1,nmodes
      if(wkvec(i).lt.(-pi)) wkvec(i)=wkvec(i)+two*pi
 1058 if(wkvec(i).gt.(+pi)) wkvec(i)=wkvec(i)-two*pi

      do 1059 i=1,nmodes
 1059 wkvec(i)=zero-wkvec(i)

 1060 continue

      do 1061 i=1,3*natoms
 1061 deltax(i)=zero

      do 1062 j=1,nmodes
      factor=zero
      do 1063 k=1,ifrozen
 1063 if(j.eq.ifreeze(k)) factor=one
      do 1062 i=1,3*natoms
 1062 deltax(i)=deltax(i)+amatrix(i,j)*wkvec(j)*factor

      do 1064 i=1,natoms
      do 1064 j=1,3
 1064 coord(j,i)=coord(j,i)+deltax(3*(i-1)+j)

      do 1065 i=1,nbonds
 1065 q_1(i)=dist(coord(1,i_bond(1,i)),coord(1,i_bond(2,i)))

      do 1066 i=1,nangles
 1066 q_1(nbonds+i)=dang(coord(1,i_angle(1,i)),
     &                   coord(1,i_angle(2,i)),
     &                   coord(1,i_angle(3,i)))

      do 1067 i=1,ndihedrals
 1067 q_1(nbonds+nangles+i)=ddihed(coord(1,i_dihedral(1,i)),
     &                             coord(1,i_dihedral(2,i)),
     &                             coord(1,i_dihedral(3,i)),
     &                             coord(1,i_dihedral(4,i)))

      do 1068 i=1,nimpropers
 1068 q_1(nbonds+nangles+ndihedrals+i)=dimp(coord(1,i_improper(1,i)),
     &                                      coord(1,i_improper(2,i)),
     &                                      coord(1,i_improper(3,i)),
     &                                      coord(1,i_improper(4,i)))

      do 1069 i=1,nmodes
 1069 wkvec(i)=q_1(i)-q_0(i)

      do 1070 i=1,nmodes
      if(wkvec(i).lt.(-pi)) wkvec(i)=wkvec(i)+two*pi
 1070 if(wkvec(i).gt.(+pi)) wkvec(i)=wkvec(i)-two*pi

      do 1071 i=1,nmodes
 1071 wkvec(i)=zero-wkvec(i)

      check=zero

      do 1072 i=1,3*natoms
 1072 check=check+deltax(i)**2

      check=sqrt(check/real64(3*natoms))

      if(check.gt.tolerance**2) goto 1060

      rewind 21

      call fastwr(21,hessian,nmodes*nmodes)
      call fastwr(21,gintp,nmodes)
      call fastwr(21,q_0,nmodes)

      grms=zero

      do 1073 i=1,nmodes
 1073 grms=grms+gintp(i)*gintp(i)

      grms=sqrt(grms/real64(nmodes))

      gmax=zero

      do 1074 i=1,nmodes
 1074 if(abs(gintp(i)).gt.gmax) gmax=abs(gintp(i))

      crms=zero

      do 1075 i=1,natoms
 1075 crms=crms+(coordsave(1,i)-coord(1,i))**2
     &         +(coordsave(2,i)-coord(2,i))**2
     &         +(coordsave(3,i)-coord(3,i))**2

      crms=sqrt(crms/real64(natoms))

      cmax=zero

      do 1076 i=1,natoms
      difference=sqrt((coordsave(1,i)-coord(1,i))**2
     &               +(coordsave(2,i)-coord(2,i))**2
     &               +(coordsave(3,i)-coord(3,i))**2)
 1076 if(difference.gt.cmax) cmax=difference

      write(6,1077)
 1077 format(//,' set of redundant internal coordinates:')

      write(6,1078)
 1078 format(/,'      bonds:',/)

      do 1079 i=1,nbonds
 1079 write(6,1080) i,i_bond(1,i),i_bond(2,i),q_1(i)*bohr
 1080 format('            bond #',i4,' : ',2i5,f15.5)

      write(6,1081)
 1081 format(/,'      angles:',/)
 
      do 1082 i=1,nangles
      ii=nbonds+i
 1082 write(6,1083) i,i_angle(1,i),i_angle(2,i),i_angle(3,i),q_1(ii)*fac
 1083 format('            angle #',i4,' : ',3i5,f15.3)

      write(6,1084)
 1084 format(/,'      dihedrals:',/)
 
      do 1085 i=1,ndihedrals
      ii=nbonds+nangles+i
 1085 write(6,1086) i,i_dihedral(1,i),i_dihedral(2,i),
     &                i_dihedral(3,i),i_dihedral(4,i),q_1(ii)*fac
 1086 format('            dihedral #',i4,' : ',4i5,f15.3)

      write(6,1087)
 1087 format(/,'      improper torsions:',/)
 
      do 1088 i=1,nimpropers
      ii=nbonds+nangles+ndihedrals+i
 1088 write(6,1089) i,i_improper(1,i),i_improper(2,i),
     &                i_improper(3,i),i_improper(4,i),q_1(ii)*fac
 1089 format('            improper torsion #',i4,' : ',4i5,f15.3)

      write(6,1090)
 1090 format(//)

      return
      end

      subroutine cdovxx(ncds,ncdspd,ndim,ilfunc,icfunc,alpha,coeffs,
     &                  coeffp,coeffd,cdsmat,cent)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension g(13)

      dimension ilfunc(*),icfunc(*)

      dimension alpha(*),coeffs(*),coeffp(*),coeffd(*),cdsmat(ndim,*)
      dimension cent(3,*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,forty9/4.0d0,5.0d0,49.0d0/
      data pi/3.1415926535898d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      dnorm1=sqrt(forty9/three)
      dnorm2=    (forty9/three)

      factor=(pi**(five/four)*sqrt(two))**2

      n=(ncdspd*(ncdspd+1))/2

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)
                          call mpi_bsend(isent,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(isent,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      istart=isent+1
      iend=isent+nloop

      ij=0

      do 1002 i=1,ncdspd
      do 1002 j=1,i

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1002

      ilabel=ilfunc(ncds+i)
      jlabel=ilfunc(ncds+j)

      nc1=icfunc(ilabel)
      nc2=icfunc(jlabel)

      zetaa=alpha(ilabel)
      zetab=alpha(jlabel)

      zetaab=one/(zetaa+zetab)

      wxpx=(zetaa*cent(1,nc1)+zetab*cent(1,nc2))*zetaab-cent(1,nc1)
      wypy=(zetaa*cent(2,nc1)+zetab*cent(2,nc2))*zetaab-cent(2,nc1)
      wzpz=(zetaa*cent(3,nc1)+zetab*cent(3,nc2))*zetaab-cent(3,nc1)

      wxqx=(zetaa*cent(1,nc1)+zetab*cent(1,nc2))*zetaab-cent(1,nc2)
      wyqy=(zetaa*cent(2,nc1)+zetab*cent(2,nc2))*zetaab-cent(2,nc2)
      wzqz=(zetaa*cent(3,nc1)+zetab*cent(3,nc2))*zetaab-cent(3,nc2)

      axbx=cent(1,nc1)-cent(1,nc2)
      ayby=cent(2,nc1)-cent(2,nc2)
      azbz=cent(3,nc1)-cent(3,nc2)

      u=zetaa*zetab*zetaab*(axbx*axbx+ayby*ayby+azbz*azbz)

      call augg(5,u,g)

      sasa0=g(1)*factor*sqrt(zetaab)/(zetaa*zetab)
      sasa1=g(2)*factor*sqrt(zetaab)/(zetaa*zetab)
      sasa2=g(3)*factor*sqrt(zetaab)/(zetaa*zetab)
      sasa3=g(4)*factor*sqrt(zetaab)/(zetaa*zetab)
      sasa4=g(5)*factor*sqrt(zetaab)/(zetaa*zetab)

      pasa0=wxpx*sasa1
      pbsa0=wypy*sasa1
      pcsa0=wzpz*sasa1

      pasa1=wxpx*sasa2
      pbsa1=wypy*sasa2
      pcsa1=wzpz*sasa2

      pasa2=wxpx*sasa3
      pbsa2=wypy*sasa3
      pcsa2=wzpz*sasa3

      pasa3=wxpx*sasa4
      pbsa3=wypy*sasa4
      pcsa3=wzpz*sasa4

      sapa0=wxqx*sasa1
      sapb0=wyqy*sasa1
      sapc0=wzqz*sasa1

      sapa1=wxqx*sasa2
      sapb1=wyqy*sasa2
      sapc1=wzqz*sasa2

      corr=(sasa0-zetab*zetaab*sasa1)/(two*zetaa)

      dasa0=wxpx*pasa1+corr
      dbsa0=wypy*pasa1
      dcsa0=wzpz*pasa1
      ddsa0=wypy*pbsa1+corr
      desa0=wzpz*pbsa1
      dfsa0=wzpz*pcsa1+corr

      corr=(sasa1-zetab*zetaab*sasa2)/(two*zetaa)

      dasa1=wxpx*pasa2+corr
      dbsa1=wypy*pasa2
      dcsa1=wzpz*pasa2
      ddsa1=wypy*pbsa2+corr
      desa1=wzpz*pbsa2
      dfsa1=wzpz*pcsa2+corr

      corr=(sasa2-zetab*zetaab*sasa3)/(two*zetaa)

      dasa2=wxpx*pasa3+corr
      dbsa2=wypy*pasa3
      dcsa2=wzpz*pasa3
      ddsa2=wypy*pbsa3+corr
      desa2=wzpz*pbsa3
      dfsa2=wzpz*pcsa3+corr

      corr=(sasa0-zetaa*zetaab*sasa1)/(two*zetab)

      sada0=wxqx*sapa1+corr
      sadb0=wyqy*sapa1
      sadc0=wzqz*sapa1
      sadd0=wyqy*sapb1+corr
      sade0=wzqz*sapb1
      sadf0=wzqz*sapc1+corr

      corr=zetaab*sasa1/two

      papa0=wxqx*pasa1+corr
      papb0=wyqy*pasa1
      papc0=wzqz*pasa1
      pbpa0=wxqx*pbsa1
      pbpb0=wyqy*pbsa1+corr
      pbpc0=wzqz*pbsa1
      pcpa0=wxqx*pcsa1
      pcpb0=wyqy*pcsa1
      pcpc0=wzqz*pcsa1+corr

      corr=zetaab*sasa2/two

      papa1=wxqx*pasa2+corr
      papb1=wyqy*pasa2
      papc1=wzqz*pasa2
      pbpa1=wxqx*pbsa2
      pbpb1=wyqy*pbsa2+corr
      pbpc1=wzqz*pbsa2
      pcpa1=wxqx*pcsa2
      pcpb1=wyqy*pcsa2
      pcpc1=wzqz*pcsa2+corr

      corrx=zetaab*pasa1/two
      corry=zetaab*pbsa1/two
      corrz=zetaab*pcsa1/two

      dapa0=wxqx*dasa1+corrx*two
      dapb0=wyqy*dasa1
      dapc0=wzqz*dasa1
      dbpa0=wxqx*dbsa1+corry
      dbpb0=wyqy*dbsa1+corrx
      dbpc0=wzqz*dbsa1
      dcpa0=wxqx*dcsa1+corrz
      dcpb0=wyqy*dcsa1
      dcpc0=wzqz*dcsa1+corrx
      ddpa0=wxqx*ddsa1
      ddpb0=wyqy*ddsa1+corry*two
      ddpc0=wzqz*ddsa1
      depa0=wxqx*desa1
      depb0=wyqy*desa1+corrz
      depc0=wzqz*desa1+corry
      dfpa0=wxqx*dfsa1
      dfpb0=wyqy*dfsa1
      dfpc0=wzqz*dfsa1+corrz*two

      corrx=zetaab*pasa2/two
      corry=zetaab*pbsa2/two
      corrz=zetaab*pcsa2/two

      dapa1=wxqx*dasa2+corrx*two
      dapb1=wyqy*dasa2
      dapc1=wzqz*dasa2
      dbpa1=wxqx*dbsa2+corry
      dbpb1=wyqy*dbsa2+corrx
      dbpc1=wzqz*dbsa2
      dcpa1=wxqx*dcsa2+corrz
      dcpb1=wyqy*dcsa2
      dcpc1=wzqz*dcsa2+corrx
      ddpa1=wxqx*ddsa2
      ddpb1=wyqy*ddsa2+corry*two
      ddpc1=wzqz*ddsa2
      depa1=wxqx*desa2
      depb1=wyqy*desa2+corrz
      depc1=wzqz*desa2+corry
      dfpa1=wxqx*dfsa2
      dfpb1=wyqy*dfsa2
      dfpc1=wzqz*dfsa2+corrz*two

      xcorr=(pasa0-zetaa*zetaab*pasa1)/(two*zetab)
      ycorr=(pbsa0-zetaa*zetaab*pbsa1)/(two*zetab)
      zcorr=(pcsa0-zetaa*zetaab*pcsa1)/(two*zetab)

      corrx=zetaab*sapa1/two
      corry=zetaab*sapb1/two
      corrz=zetaab*sapc1/two

      pada0=wxqx*papa1+xcorr+corrx
      padb0=wyqy*papa1
      padc0=wzqz*papa1
      padd0=wyqy*papb1+xcorr
      pade0=wzqz*papb1
      padf0=wzqz*papc1+xcorr
      pbda0=wxqx*pbpa1+ycorr
      pbdb0=wyqy*pbpa1      +corrx
      pbdc0=wzqz*pbpa1
      pbdd0=wyqy*pbpb1+ycorr+corry
      pbde0=wzqz*pbpb1
      pbdf0=wzqz*pbpc1+ycorr
      pcda0=wxqx*pcpa1+zcorr
      pcdb0=wyqy*pcpa1
      pcdc0=wzqz*pcpa1      +corrx
      pcdd0=wyqy*pcpb1+zcorr
      pcde0=wzqz*pcpb1      +corry
      pcdf0=wzqz*pcpc1+zcorr+corrz

      xxcorr=(dasa0-zetaa*zetaab*dasa1)/(two*zetab)
      xycorr=(dbsa0-zetaa*zetaab*dbsa1)/(two*zetab)
      xzcorr=(dcsa0-zetaa*zetaab*dcsa1)/(two*zetab)
      yycorr=(ddsa0-zetaa*zetaab*ddsa1)/(two*zetab)
      yzcorr=(desa0-zetaa*zetaab*desa1)/(two*zetab)
      zzcorr=(dfsa0-zetaa*zetaab*dfsa1)/(two*zetab)

      xcorrx=zetaab*papa1/two
      xcorry=zetaab*papb1/two
      xcorrz=zetaab*papc1/two
      ycorrx=zetaab*pbpa1/two
      ycorry=zetaab*pbpb1/two
      ycorrz=zetaab*pbpc1/two
      zcorrx=zetaab*pcpa1/two
      zcorry=zetaab*pcpb1/two
      zcorrz=zetaab*pcpc1/two

      dada0=wxqx*dapa1+xxcorr+xcorrx*two
      dadb0=wyqy*dapa1
      dadc0=wzqz*dapa1
      dadd0=wyqy*dapb1+xxcorr
      dade0=wzqz*dapb1
      dadf0=wzqz*dapc1+xxcorr
      dbda0=wxqx*dbpa1+xycorr+ycorrx
      dbdb0=wyqy*dbpa1       +xcorrx
      dbdc0=wzqz*dbpa1
      dbdd0=wyqy*dbpb1+xycorr+xcorry
      dbde0=wzqz*dbpb1
      dbdf0=wzqz*dbpc1+xycorr
      dcda0=wxqx*dcpa1+xzcorr+zcorrx
      dcdb0=wyqy*dcpa1
      dcdc0=wzqz*dcpa1       +xcorrx
      dcdd0=wyqy*dcpb1+xzcorr
      dcde0=wzqz*dcpb1       +xcorry
      dcdf0=wzqz*dcpc1+xzcorr+xcorrz
      ddda0=wxqx*ddpa1+yycorr
      dddb0=wyqy*ddpa1       +ycorrx*two
      dddc0=wzqz*ddpa1
      dddd0=wyqy*ddpb1+yycorr+ycorry*two
      ddde0=wzqz*ddpb1
      dddf0=wzqz*ddpc1+yycorr
      deda0=wxqx*depa1+yzcorr
      dedb0=wyqy*depa1       +zcorrx
      dedc0=wzqz*depa1       +ycorrx
      dedd0=wyqy*depb1+yzcorr+zcorry
      dede0=wzqz*depb1       +ycorry
      dedf0=wzqz*depc1+yzcorr+ycorrz
      dfda0=wxqx*dfpa1+zzcorr
      dfdb0=wyqy*dfpa1
      dfdc0=wzqz*dfpa1       +zcorrx*two
      dfdd0=wyqy*dfpb1+zzcorr
      dfde0=wzqz*dfpb1       +zcorry*two
      dfdf0=wzqz*dfpc1+zzcorr+zcorrz*two

      m=ncds+10*(i-1)
      n=ncds+10*(j-1)

      cdsmat(m+01,n+01)=coeffs(ilabel)*coeffs(jlabel)*sasa0
      cdsmat(m+01,n+02)=coeffs(ilabel)*coeffp(jlabel)*sapa0
      cdsmat(m+01,n+03)=coeffs(ilabel)*coeffp(jlabel)*sapb0
      cdsmat(m+01,n+04)=coeffs(ilabel)*coeffp(jlabel)*sapc0
      cdsmat(m+01,n+05)=coeffs(ilabel)*coeffd(jlabel)*sada0/dnorm1
      cdsmat(m+01,n+06)=coeffs(ilabel)*coeffd(jlabel)*sadb0
      cdsmat(m+01,n+07)=coeffs(ilabel)*coeffd(jlabel)*sadc0
      cdsmat(m+01,n+08)=coeffs(ilabel)*coeffd(jlabel)*sadd0/dnorm1
      cdsmat(m+01,n+09)=coeffs(ilabel)*coeffd(jlabel)*sade0
      cdsmat(m+01,n+10)=coeffs(ilabel)*coeffd(jlabel)*sadf0/dnorm1

      cdsmat(m+02,n+01)=coeffp(ilabel)*coeffs(jlabel)*pasa0
      cdsmat(m+02,n+02)=coeffp(ilabel)*coeffp(jlabel)*papa0
      cdsmat(m+02,n+03)=coeffp(ilabel)*coeffp(jlabel)*papb0
      cdsmat(m+02,n+04)=coeffp(ilabel)*coeffp(jlabel)*papc0
      cdsmat(m+02,n+05)=coeffp(ilabel)*coeffd(jlabel)*pada0/dnorm1
      cdsmat(m+02,n+06)=coeffp(ilabel)*coeffd(jlabel)*padb0
      cdsmat(m+02,n+07)=coeffp(ilabel)*coeffd(jlabel)*padc0
      cdsmat(m+02,n+08)=coeffp(ilabel)*coeffd(jlabel)*padd0/dnorm1
      cdsmat(m+02,n+09)=coeffp(ilabel)*coeffd(jlabel)*pade0
      cdsmat(m+02,n+10)=coeffp(ilabel)*coeffd(jlabel)*padf0/dnorm1

      cdsmat(m+03,n+01)=coeffp(ilabel)*coeffs(jlabel)*pbsa0
      cdsmat(m+03,n+02)=coeffp(ilabel)*coeffp(jlabel)*pbpa0
      cdsmat(m+03,n+03)=coeffp(ilabel)*coeffp(jlabel)*pbpb0
      cdsmat(m+03,n+04)=coeffp(ilabel)*coeffp(jlabel)*pbpc0
      cdsmat(m+03,n+05)=coeffp(ilabel)*coeffd(jlabel)*pbda0/dnorm1
      cdsmat(m+03,n+06)=coeffp(ilabel)*coeffd(jlabel)*pbdb0
      cdsmat(m+03,n+07)=coeffp(ilabel)*coeffd(jlabel)*pbdc0
      cdsmat(m+03,n+08)=coeffp(ilabel)*coeffd(jlabel)*pbdd0/dnorm1
      cdsmat(m+03,n+09)=coeffp(ilabel)*coeffd(jlabel)*pbde0
      cdsmat(m+03,n+10)=coeffp(ilabel)*coeffd(jlabel)*pbdf0/dnorm1

      cdsmat(m+04,n+01)=coeffp(ilabel)*coeffs(jlabel)*pcsa0
      cdsmat(m+04,n+02)=coeffp(ilabel)*coeffp(jlabel)*pcpa0
      cdsmat(m+04,n+03)=coeffp(ilabel)*coeffp(jlabel)*pcpb0
      cdsmat(m+04,n+04)=coeffp(ilabel)*coeffp(jlabel)*pcpc0
      cdsmat(m+04,n+05)=coeffp(ilabel)*coeffd(jlabel)*pcda0/dnorm1
      cdsmat(m+04,n+06)=coeffp(ilabel)*coeffd(jlabel)*pcdb0
      cdsmat(m+04,n+07)=coeffp(ilabel)*coeffd(jlabel)*pcdc0
      cdsmat(m+04,n+08)=coeffp(ilabel)*coeffd(jlabel)*pcdd0/dnorm1
      cdsmat(m+04,n+09)=coeffp(ilabel)*coeffd(jlabel)*pcde0
      cdsmat(m+04,n+10)=coeffp(ilabel)*coeffd(jlabel)*pcdf0/dnorm1

      cdsmat(m+05,n+01)=coeffd(ilabel)*coeffs(jlabel)*dasa0/dnorm1
      cdsmat(m+05,n+02)=coeffd(ilabel)*coeffp(jlabel)*dapa0/dnorm1
      cdsmat(m+05,n+03)=coeffd(ilabel)*coeffp(jlabel)*dapb0/dnorm1
      cdsmat(m+05,n+04)=coeffd(ilabel)*coeffp(jlabel)*dapc0/dnorm1
      cdsmat(m+05,n+05)=coeffd(ilabel)*coeffd(jlabel)*dada0/dnorm2
      cdsmat(m+05,n+06)=coeffd(ilabel)*coeffd(jlabel)*dadb0/dnorm1
      cdsmat(m+05,n+07)=coeffd(ilabel)*coeffd(jlabel)*dadc0/dnorm1
      cdsmat(m+05,n+08)=coeffd(ilabel)*coeffd(jlabel)*dadd0/dnorm2
      cdsmat(m+05,n+09)=coeffd(ilabel)*coeffd(jlabel)*dade0/dnorm1
      cdsmat(m+05,n+10)=coeffd(ilabel)*coeffd(jlabel)*dadf0/dnorm2

      cdsmat(m+06,n+01)=coeffd(ilabel)*coeffs(jlabel)*dbsa0
      cdsmat(m+06,n+02)=coeffd(ilabel)*coeffp(jlabel)*dbpa0
      cdsmat(m+06,n+03)=coeffd(ilabel)*coeffp(jlabel)*dbpb0
      cdsmat(m+06,n+04)=coeffd(ilabel)*coeffp(jlabel)*dbpc0
      cdsmat(m+06,n+05)=coeffd(ilabel)*coeffd(jlabel)*dbda0/dnorm1
      cdsmat(m+06,n+06)=coeffd(ilabel)*coeffd(jlabel)*dbdb0
      cdsmat(m+06,n+07)=coeffd(ilabel)*coeffd(jlabel)*dbdc0
      cdsmat(m+06,n+08)=coeffd(ilabel)*coeffd(jlabel)*dbdd0/dnorm1
      cdsmat(m+06,n+09)=coeffd(ilabel)*coeffd(jlabel)*dbde0
      cdsmat(m+06,n+10)=coeffd(ilabel)*coeffd(jlabel)*dbdf0/dnorm1

      cdsmat(m+07,n+01)=coeffd(ilabel)*coeffs(jlabel)*dcsa0
      cdsmat(m+07,n+02)=coeffd(ilabel)*coeffp(jlabel)*dcpa0
      cdsmat(m+07,n+03)=coeffd(ilabel)*coeffp(jlabel)*dcpb0
      cdsmat(m+07,n+04)=coeffd(ilabel)*coeffp(jlabel)*dcpc0
      cdsmat(m+07,n+05)=coeffd(ilabel)*coeffd(jlabel)*dcda0/dnorm1
      cdsmat(m+07,n+06)=coeffd(ilabel)*coeffd(jlabel)*dcdb0
      cdsmat(m+07,n+07)=coeffd(ilabel)*coeffd(jlabel)*dcdc0
      cdsmat(m+07,n+08)=coeffd(ilabel)*coeffd(jlabel)*dcdd0/dnorm1
      cdsmat(m+07,n+09)=coeffd(ilabel)*coeffd(jlabel)*dcde0
      cdsmat(m+07,n+10)=coeffd(ilabel)*coeffd(jlabel)*dcdf0/dnorm1

      cdsmat(m+08,n+01)=coeffd(ilabel)*coeffs(jlabel)*ddsa0/dnorm1
      cdsmat(m+08,n+02)=coeffd(ilabel)*coeffp(jlabel)*ddpa0/dnorm1
      cdsmat(m+08,n+03)=coeffd(ilabel)*coeffp(jlabel)*ddpb0/dnorm1
      cdsmat(m+08,n+04)=coeffd(ilabel)*coeffp(jlabel)*ddpc0/dnorm1
      cdsmat(m+08,n+05)=coeffd(ilabel)*coeffd(jlabel)*ddda0/dnorm2
      cdsmat(m+08,n+06)=coeffd(ilabel)*coeffd(jlabel)*dddb0/dnorm1
      cdsmat(m+08,n+07)=coeffd(ilabel)*coeffd(jlabel)*dddc0/dnorm1
      cdsmat(m+08,n+08)=coeffd(ilabel)*coeffd(jlabel)*dddd0/dnorm2
      cdsmat(m+08,n+09)=coeffd(ilabel)*coeffd(jlabel)*ddde0/dnorm1
      cdsmat(m+08,n+10)=coeffd(ilabel)*coeffd(jlabel)*dddf0/dnorm2

      cdsmat(m+09,n+01)=coeffd(ilabel)*coeffs(jlabel)*desa0
      cdsmat(m+09,n+02)=coeffd(ilabel)*coeffp(jlabel)*depa0
      cdsmat(m+09,n+03)=coeffd(ilabel)*coeffp(jlabel)*depb0
      cdsmat(m+09,n+04)=coeffd(ilabel)*coeffp(jlabel)*depc0
      cdsmat(m+09,n+05)=coeffd(ilabel)*coeffd(jlabel)*deda0/dnorm1
      cdsmat(m+09,n+06)=coeffd(ilabel)*coeffd(jlabel)*dedb0
      cdsmat(m+09,n+07)=coeffd(ilabel)*coeffd(jlabel)*dedc0
      cdsmat(m+09,n+08)=coeffd(ilabel)*coeffd(jlabel)*dedd0/dnorm1
      cdsmat(m+09,n+09)=coeffd(ilabel)*coeffd(jlabel)*dede0
      cdsmat(m+09,n+10)=coeffd(ilabel)*coeffd(jlabel)*dedf0/dnorm1

      cdsmat(m+10,n+01)=coeffd(ilabel)*coeffs(jlabel)*dfsa0/dnorm1
      cdsmat(m+10,n+02)=coeffd(ilabel)*coeffp(jlabel)*dfpa0/dnorm1
      cdsmat(m+10,n+03)=coeffd(ilabel)*coeffp(jlabel)*dfpb0/dnorm1
      cdsmat(m+10,n+04)=coeffd(ilabel)*coeffp(jlabel)*dfpc0/dnorm1
      cdsmat(m+10,n+05)=coeffd(ilabel)*coeffd(jlabel)*dfda0/dnorm2
      cdsmat(m+10,n+06)=coeffd(ilabel)*coeffd(jlabel)*dfdb0/dnorm1
      cdsmat(m+10,n+07)=coeffd(ilabel)*coeffd(jlabel)*dfdc0/dnorm1
      cdsmat(m+10,n+08)=coeffd(ilabel)*coeffd(jlabel)*dfdd0/dnorm2
      cdsmat(m+10,n+09)=coeffd(ilabel)*coeffd(jlabel)*dfde0/dnorm1
      cdsmat(m+10,n+10)=coeffd(ilabel)*coeffd(jlabel)*dfdf0/dnorm2

 1002 continue

      return
      end

      subroutine setuppss(m,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &                    icentvc,icontr,inddyy,cutoff,coord,alpha,
     &                    coeff,zeta,zetaa,zetab,aax,aay,aaz,eta,etarr,
     &                    base,px,py,pz,buffer)

c  this subroutine written by alain st-amant and sor koon goh of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension nshels(*),mtloca(*),iprimvc(*),nprimvc(*),icentvc(*),
     &          icontr(*),inddyy(*)

      dimension coord(3,*),alpha(*),coeff(*),zeta(*),zetaa(*),zetab(*),
     &          aax(*),aay(*),aaz(*),eta(*),etarr(*),base(*),px(*),
     &          py(*),pz(*),buffer(*)

      data zero,expcut/0.0d0,50.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      n=0

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=nconts-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(isent+1,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(iloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1002 i=iloop,iloop+nloop-1
      do 1002 j=1,i

      icnptr=(i*(i-1)/2)+j

      nconta=nshels(i)
      ncontb=nshels(j)

      matlca=mtloca(nconta)
      matlcb=mtloca(ncontb)

      i1=matlca
      i2=(i1*(i1-1))/2
      i3=matlcb
      i4=i2+i3

      inddyy(icnptr)=i4

      iprima=iprimvc(nconta)
      iprimb=iprimvc(ncontb)

      nprima=iprima+nprimvc(nconta)-1
      nprimb=iprimb+nprimvc(ncontb)-1

      icenta=icentvc(nconta)
      icentb=icentvc(ncontb)

      ax=coord(1,icenta)
      ay=coord(2,icenta)
      az=coord(3,icenta)

      bx=coord(1,icentb)
      by=coord(2,icentb)
      bz=coord(3,icentb)

      caxbx=ax-bx
      cayby=ay-by
      cazbz=az-bz

      rr=caxbx*caxbx+cayby*cayby+cazbz*cazbz

      if(rr.gt.(cutoff**2)) goto 1002

      do 1003 ii=iprima,nprima
      do 1003 jj=iprimb,nprimb

      test=rr*alpha(ii)*alpha(jj)/(alpha(ii)+alpha(jj))

      if(test.lt.expcut) then
                               n=n+1

                               icontr(n)=icnptr

                               zetaa(n)=alpha(ii)
                               zetab(n)=alpha(jj)

                               zeta(n)=zetaa(n)+zetab(n)

                               factor=coeff(ii)*coeff(jj)

                               aax(n)=ax
                               aay(n)=ay
                               aaz(n)=az

                               px(n)=(zetaa(n)*ax+zetab(n)*bx)/zeta(n)
                               py(n)=(zetaa(n)*ay+zetab(n)*by)/zeta(n)
                               pz(n)=(zetaa(n)*az+zetab(n)*bz)/zeta(n)

                               eta(n)=zetaa(n)*zetab(n)/zeta(n)

                               etarr(n)=eta(n)*rr

                               base(n)=factor*exp(-etarr(n))
                         endif
 1003 continue
 1002 continue

      do 1004 i=1,nconts
      do 1004 j=1,i

      i1=mtloca(nshels(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

 1004 inddyy((i*(i-1)/2)+j)=i4

      call mpi_bsend(n,1,mpi_integer,0,01,mpi_comm_world,ierr)

      call mpi_bsend(icontr,n,mpi_integer,0,02,mpi_comm_world,ierr)

      call stringcopy(n,buffer(0*n+1),zeta)
      call stringcopy(n,buffer(1*n+1),base)
      call stringcopy(n,buffer(2*n+1),eta)
      call stringcopy(n,buffer(3*n+1),etarr)
      call stringcopy(n,buffer(4*n+1),px)
      call stringcopy(n,buffer(5*n+1),py)
      call stringcopy(n,buffer(6*n+1),pz)

      call mpi_bsend(buffer,7*n,mpi_real8,0,03,mpi_comm_world,ierr)

      if(myid.eq.0) then

                    n=0

                    do 1005 i=0,numprocs-1

                    call mpi_recv(nsub,1,mpi_integer,
     &                            i,01,mpi_comm_world,istat,ierr)

                    call mpi_recv(icontr(n+1),nsub,mpi_integer,
     &                            i,02,mpi_comm_world,istat,ierr)

                    call mpi_recv(buffer,7*nsub,mpi_real8,
     &                            i,03,mpi_comm_world,istat,ierr)

                    call stringcopy(nsub,zeta(n+1),buffer(0*nsub+1))
                    call stringcopy(nsub,base(n+1),buffer(1*nsub+1))
                    call stringcopy(nsub,eta(n+1),buffer(2*nsub+1))
                    call stringcopy(nsub,etarr(n+1),buffer(3*nsub+1))
                    call stringcopy(nsub,px(n+1),buffer(4*nsub+1))
                    call stringcopy(nsub,py(n+1),buffer(5*nsub+1))
                    call stringcopy(nsub,pz(n+1),buffer(6*nsub+1))

                    n=n+nsub

 1005               continue

                    endif

      call mpi_bcast(n,1,mpi_integer,0,mpi_comm_world,ierr)

      return
      end

      subroutine gradovps(ndim,m,n,icontr,inddyy,icentr,density,overlap,
     &                    gradient,zeta,twozetaa,eta,eta2,base,etarr,
     &                    pxax,pyay,pzaz,twozeta,ss0,ss,ps,ds,c,sscond,
     &                    dscond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),icentr(m,*)

      dimension density(*),overlap(ndim,*),gradient(3,*),zeta(*),
     &          twozetaa(*),eta(*),eta2(*),base(*),etarr(*),pxax(*),
     &          pyay(*),pzaz(*),twozeta(*),ss0(*),ss(*),ps(n,*),ds(n,*),
     &          c(*),sscond(*),dscond(m,*),grad(m,*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps(i,1)=pxax(i)*ss0(i)
      ps(i,2)=pyay(i)*ss0(i)
 1003 ps(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
 1004 c(i)=ss0(i)/twozeta(i)

      do 1005 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)
      ds(i,3)=pzaz(i)*ps(i,1)
      ds(i,4)=pyay(i)*ps(i,2)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)
 1005 ds(i,6)=pzaz(i)*ps(i,3)+c(i)

      do 1006 i=1,m
 1006 sscond(i)=zero

      do 1007 j=1,6
      do 1007 i=1,m
 1007 dscond(i,j)=zero

      do 1008 i=1,n
 1008 sscond(icontr(i))=sscond(icontr(i))+ss0(i)

      do 1009 j=1,6
      do 1009 i=1,n
 1009 dscond(icontr(i),j)=dscond(icontr(i),j)+ds(i,j)*twozetaa(i)

      do 1010 j=1,3
      do 1010 i=1,m
 1010 overlap(inddyy(i,j),j)=overlap(inddyy(i,j),j)-sscond(i)

      do 1011 i=1,m
      overlap(inddyy(i,1),1)=overlap(inddyy(i,1),1)+dscond(i,1)
      overlap(inddyy(i,2),1)=overlap(inddyy(i,2),1)+dscond(i,2)
      overlap(inddyy(i,3),1)=overlap(inddyy(i,3),1)+dscond(i,3)
      overlap(inddyy(i,1),2)=overlap(inddyy(i,1),2)+dscond(i,2)
      overlap(inddyy(i,2),2)=overlap(inddyy(i,2),2)+dscond(i,4)
      overlap(inddyy(i,3),2)=overlap(inddyy(i,3),2)+dscond(i,5)
      overlap(inddyy(i,1),3)=overlap(inddyy(i,1),3)+dscond(i,3)
      overlap(inddyy(i,2),3)=overlap(inddyy(i,2),3)+dscond(i,5)
 1011 overlap(inddyy(i,3),3)=overlap(inddyy(i,3),3)+dscond(i,6)

      do 1012 i=1,n
 1012 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1013 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps(i,2)
 1013 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps(i,3)

      do 1014 i=1,n
 1014 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/twozetaa(i)

      do 1015 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds(i,2)
      ds(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds(i,3)
      ds(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds(i,4)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds(i,5)
 1015 ds(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds(i,6)+c(i)

      do 1016 i=1,m
 1016 sscond(i)=zero

      do 1017 j=1,6
      do 1017 i=1,m
 1017 dscond(i,j)=zero

      do 1018 i=1,n
 1018 sscond(icontr(i))=sscond(icontr(i))+ss(i)

      do 1019 j=1,6
      do 1019 i=1,n
 1019 dscond(icontr(i),j)=dscond(icontr(i),j)+ds(i,j)*twozetaa(i)

      do 1020 j=1,3
      do 1020 i=1,m
 1020 grad(i,j)=sscond(i)*density(inddyy(i,j))

      do 1021 j=1,3
      do 1021 i=1,m
 1021 gradient(j,icentr(i,1))=gradient(j,icentr(i,1))-grad(i,j)

      do 1022 j=1,3
      do 1022 i=1,m
 1022 gradient(j,icentr(i,2))=gradient(j,icentr(i,2))+grad(i,j)

      do 1023 i=1,m
      grad(i,1)=dscond(i,1)*density(inddyy(i,1))
      grad(i,2)=dscond(i,2)*density(inddyy(i,2))
      grad(i,3)=dscond(i,3)*density(inddyy(i,3))
      grad(i,4)=dscond(i,2)*density(inddyy(i,1))
      grad(i,5)=dscond(i,4)*density(inddyy(i,2))
      grad(i,6)=dscond(i,5)*density(inddyy(i,3))
      grad(i,7)=dscond(i,3)*density(inddyy(i,1))
      grad(i,8)=dscond(i,5)*density(inddyy(i,2))
 1023 grad(i,9)=dscond(i,6)*density(inddyy(i,3))

      do 1024 k=1,3
      do 1024 j=1,3
      do 1024 i=1,m
 1024 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,3*(k-1)+j)

      do 1025 k=1,3
      do 1025 j=1,3
      do 1025 i=1,m
 1025 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,3*(k-1)+j)

      return
      end

      subroutine setupgdp(m,n,ncontd,ncontp,nsheld,nshelp,mtloca,
     &                    iprimvc,nprimvc,icentvc,icontr,inddyy,icentr,
     &                    coord,alpha,coeff,zeta,zetaa,zetab,twozetaa,
     &                    twozetab,aax,aay,aaz,eta,eta2,etarr,base,px,
     &                    py,pz,pxax,pyay,pzaz,pxbx,pyby,pzbz,axbx,ayby,
     &                    azbz,buffer)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension nsheld(*),nshelp(*),mtloca(*),iprimvc(*),nprimvc(*),
     &          icentvc(*),icontr(*),inddyy(m,*),icentr(m,*)

      dimension coord(3,*),alpha(*),coeff(*),zeta(*),zetaa(*),zetab(*),
     &          twozetaa(*),twozetab(*),aax(*),aay(*),aaz(*),eta(*),
     &          eta2(*),etarr(*),base(*),px(*),py(*),pz(*),pxax(*),
     &          pyay(*),pzaz(*),pxbx(*),pyby(*),pzbz(*),axbx(*),ayby(*),
     &          azbz(*),buffer(*)

      data zero,two,expcut/0.0d0,2.0d0,100.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      n=0

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=ncontd-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(isent+1,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(iloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1002 i=iloop,iloop+nloop-1
      do 1002 j=1,ncontp

      icnptr=ncontp*(i-1)+j

      nconta=nsheld(i)
      ncontb=nshelp(j)

      iprima=iprimvc(nconta)
      iprimb=iprimvc(ncontb)

      nprima=iprima+nprimvc(nconta)-1
      nprimb=iprimb+nprimvc(ncontb)-1

      icenta=icentvc(nconta)
      icentb=icentvc(ncontb)

      ax=coord(1,icenta)
      ay=coord(2,icenta)
      az=coord(3,icenta)

      bx=coord(1,icentb)
      by=coord(2,icentb)
      bz=coord(3,icentb)

      caxbx=ax-bx
      cayby=ay-by
      cazbz=az-bz

      rr=caxbx*caxbx+cayby*cayby+cazbz*cazbz

      do 1003 ii=iprima,nprima
      do 1003 jj=iprimb,nprimb

      n=n+1

      icontr(n)=icnptr

      zetaa(n)=alpha(ii)
      zetab(n)=alpha(jj)

      zeta(n)=zetaa(n)+zetab(n)

      twozetaa(n)=two*zetaa(n)
      twozetab(n)=two*zetab(n)

      factor=coeff(ii)*coeff(jj)

      aax(n)=ax
      aay(n)=ay
      aaz(n)=az

      px(n)=(zetaa(n)*ax+zetab(n)*bx)/zeta(n)
      py(n)=(zetaa(n)*ay+zetab(n)*by)/zeta(n)
      pz(n)=(zetaa(n)*az+zetab(n)*bz)/zeta(n)

      pxax(n)=px(n)-ax
      pyay(n)=py(n)-ay
      pzaz(n)=pz(n)-az

      pxbx(n)=px(n)-bx
      pyby(n)=py(n)-by
      pzbz(n)=pz(n)-bz

      eta(n)=zetaa(n)*zetab(n)/zeta(n)

      eta2(n)=two*eta(n)

      etarr(n)=eta(n)*rr

      base(n)=zero

      if(etarr(n).lt.expcut) then
                                   base(n)=factor*exp(-etarr(n))
                             else
                                   n=n-1
                             endif

 1003 continue
 1002 continue

      do 1004 i=1,ncontd
      do 1004 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      inddyy(ncontp*(i-1)+j,01)=i4
      inddyy(ncontp*(i-1)+j,02)=i4+1
      inddyy(ncontp*(i-1)+j,03)=i4+2
      inddyy(ncontp*(i-1)+j,04)=i4+i1
      inddyy(ncontp*(i-1)+j,05)=i4+i1+1
      inddyy(ncontp*(i-1)+j,06)=i4+i1+2
      inddyy(ncontp*(i-1)+j,07)=i4+i1*2+1
      inddyy(ncontp*(i-1)+j,08)=i4+i1*2+2
      inddyy(ncontp*(i-1)+j,09)=i4+i1*2+3
      inddyy(ncontp*(i-1)+j,10)=i4+i1*3+3
      inddyy(ncontp*(i-1)+j,11)=i4+i1*3+4
      inddyy(ncontp*(i-1)+j,12)=i4+i1*3+5
      inddyy(ncontp*(i-1)+j,13)=i4+i1*4+6
      inddyy(ncontp*(i-1)+j,14)=i4+i1*4+7
      inddyy(ncontp*(i-1)+j,15)=i4+i1*4+8
      inddyy(ncontp*(i-1)+j,16)=i4+i1*5+10
      inddyy(ncontp*(i-1)+j,17)=i4+i1*5+11
      inddyy(ncontp*(i-1)+j,18)=i4+i1*5+12

      icenta=icentvc(nsheld(i))
      icentb=icentvc(nshelp(j))

      icnptr=ncontp*(i-1)+j

      icentr(icnptr,1)=icenta
      icentr(icnptr,2)=icentb

      axbx(icnptr)=coord(1,icenta)-coord(1,icentb)
      ayby(icnptr)=coord(2,icenta)-coord(2,icentb)
      azbz(icnptr)=coord(3,icenta)-coord(3,icentb)

 1004 continue

      call mpi_bsend(n,1,mpi_integer,0,01,mpi_comm_world,ierr)
      call mpi_bsend(icontr,n,mpi_integer,0,02,mpi_comm_world,ierr)

      call stringcopy(n,buffer(00*n+1),twozetaa)
      call stringcopy(n,buffer(01*n+1),twozetab)
      call stringcopy(n,buffer(02*n+1),etarr)
      call stringcopy(n,buffer(03*n+1),zeta)
      call stringcopy(n,buffer(04*n+1),base)
      call stringcopy(n,buffer(05*n+1),eta2)
      call stringcopy(n,buffer(06*n+1),pxax)
      call stringcopy(n,buffer(07*n+1),pyay)
      call stringcopy(n,buffer(08*n+1),pzaz)
      call stringcopy(n,buffer(09*n+1),pxbx)
      call stringcopy(n,buffer(10*n+1),pyby)
      call stringcopy(n,buffer(11*n+1),pzbz)
      call stringcopy(n,buffer(12*n+1),eta)
      call stringcopy(n,buffer(13*n+1),px)
      call stringcopy(n,buffer(14*n+1),py)
      call stringcopy(n,buffer(15*n+1),pz)

      call mpi_bsend(buffer,16*n,mpi_real8,0,03,mpi_comm_world,ierr)

      if(myid.eq.0) then

                 n=0

                 do 1005 i=0,numprocs-1

                 call mpi_recv(nsub,1,mpi_integer,
     &                         i,01,mpi_comm_world,istat,ierr)

                 call mpi_recv(icontr(n+1),nsub,mpi_integer,
     &                         i,02,mpi_comm_world,istat,ierr)

                 call mpi_recv(buffer,16*nsub,mpi_real8,
     &                         i,03,mpi_comm_world,istat,ierr)

                 call stringcopy(nsub,twozetaa(n+1),buffer(00*nsub+1))
                 call stringcopy(nsub,twozetab(n+1),buffer(01*nsub+1))
                 call stringcopy(nsub,etarr(n+1),buffer(02*nsub+1))
                 call stringcopy(nsub,zeta(n+1),buffer(03*nsub+1))
                 call stringcopy(nsub,base(n+1),buffer(04*nsub+1))
                 call stringcopy(nsub,eta2(n+1),buffer(05*nsub+1))
                 call stringcopy(nsub,pxax(n+1),buffer(06*nsub+1))
                 call stringcopy(nsub,pyay(n+1),buffer(07*nsub+1))
                 call stringcopy(nsub,pzaz(n+1),buffer(08*nsub+1))
                 call stringcopy(nsub,pxbx(n+1),buffer(09*nsub+1))
                 call stringcopy(nsub,pyby(n+1),buffer(10*nsub+1))
                 call stringcopy(nsub,pzbz(n+1),buffer(11*nsub+1))
                 call stringcopy(nsub,eta(n+1),buffer(12*nsub+1))
                 call stringcopy(nsub,px(n+1),buffer(13*nsub+1))
                 call stringcopy(nsub,py(n+1),buffer(14*nsub+1))
                 call stringcopy(nsub,pz(n+1),buffer(15*nsub+1))

                n=n+nsub

 1005           continue

                    endif

      call mpi_bcast(n,1,mpi_integer,0,mpi_comm_world,ierr)

      return
      end

      subroutine move(iswitch,istep,nreal,ninteger,nmaxpoints,ndim1,
     &                ndim2,natoms,nalpha,nbeta,ncontractions,nconts,
     &                ncontp,ncontd,ncds,ncdspd,ibfrozen,iafrozen,
     &                idfrozen,iifrozen,imode,ngridtype,iptsweight,
     &                natomtype,nptsatom,nfuncatom,izmat1,izmat2,izmat3,
     &                nshels,nshelp,nsheld,ilfunc,icfunc,ngaussians,
     &                mtloca,icdlfunc,icdcfunc,ibfreeze,iafreeze,
     &                idfreeze,iifreeze,ibmode,iamode,idmode,iimode,
     &                iwkvec,dmaxfactor,stepsize,dmaxmove,coordsave,
     &                coord,charge,dmata,dmatb,coeffa,coeffb,alpha,
     &                coeffs,cdfitc,alphacd,coefscd,coefpcd,coefdcd,
     &                grad,overlap,wkvec,lsym)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension natomtype(*),nptsatom(*),nfuncatom(*),izmat1(*),
     &          izmat2(*),izmat3(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),ngaussians(*),mtloca(*),icdlfunc(*),
     &          icdcfunc(*),ibfreeze(2,*),iafreeze(3,*),idfreeze(4,*),
     &          iifreeze(4,*),ibmode(*),iamode(*),idmode(*),iimode(*),
     &          iwkvec(*)

      dimension coordsave(3,*),coord(3,*),charge(*),dmata(*),dmatb(*),
     &          coeffa(ndim1,*),coeffb(ndim1,*),alpha(*),coeffs(*),
     &          cdfitc(*),alphacd(*),coefscd(*),coefpcd(*),coefdcd(*),
     &          grad(3,*),overlap(ndim2,*),wkvec(*)

      character*4 lsym(*)

      data zero,big/0.0d0,999999.9d0/

      save ifollow

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      igeometry=istep

      call gradmm(nreal,ninteger,ndim2,natoms,nconts,ncontp,ncontd,ncds,
     &            ncdspd,nshels,nshelp,nsheld,mtloca,ilfunc,ngaussians,
     &            icfunc,icdlfunc,icdcfunc,iwkvec,coord,charge,alpha,
     &            coeffs,cdfitc,alphacd,coefscd,coefpcd,coefdcd,grad,
     &            overlap,dmata,dmatb,wkvec(1),wkvec(ndim2+1))

      call cdgrmm(natoms,ncds,ncdspd,icdlfunc,icdcfunc,cdfitc,alphacd,
     &            coefscd,coefpcd,coefdcd,coord,grad,wkvec)

      call gradxc(nreal-6*natoms,nmaxpoints,ngridtype,iptsweight,
     &            ncontractions,natoms,nconts,ncontp,ncontd,natomtype,
     &            nptsatom,nfuncatom,ilfunc,icfunc,ngaussians,nshels,
     &            nshelp,nsheld,iwkvec,wkvec,wkvec(6*natoms+1),dmata,
     &            dmatb,coord,grad,alpha,coeffs)

      ia=1
      ib=ia+ndim2
      ic=ib+nalpha*nalpha
      id=ic+ndim2
      ie=id+ndim2

      if(ie.gt.nreal) stop 'not enough room for pulay forces'

      call pulayforce(ndim1,ndim2,natoms,nalpha,nbeta,nconts,ncontp,
     &                ncontd,icfunc,mtloca,nshels,nshelp,nsheld,grad,
     &                wkvec(ia),overlap,coeffa,coeffb,wkvec(ib),
     &                wkvec(ic),wkvec(id))

      if((iswitch.eq.1).or.(myid.gt.0)) return

 1001 continue

      if(igeometry.eq.1) then

            ia=1
            ib=ia+natoms*natoms
            ic=ib+natoms*natoms*natoms
            id=ic+natoms*natoms*natoms
            ie=id+natoms*natoms*natoms

            call find_ints(natoms,nbonds,nangles,ndihedrals,nimpropers,
     &                     natomtype,iwkvec(ia),iwkvec(ib),iwkvec(ic),
     &                     iwkvec(id),iwkvec(ie),coord)

            rewind 31

            do 1002 i=1,ibfrozen
            iwkvec(ia+2*(nbonds+i-1)+0)=ibfreeze(1,i)
 1002       iwkvec(ia+2*(nbonds+i-1)+1)=ibfreeze(2,i)

            do 1003 i=1,iafrozen
            iwkvec(ib+3*(nangles+i-1)+0)=iafreeze(1,i)
            iwkvec(ib+3*(nangles+i-1)+1)=iafreeze(2,i)
 1003       iwkvec(ib+3*(nangles+i-1)+2)=iafreeze(3,i)

            do 1004 i=1,idfrozen
            iwkvec(ic+4*(ndihedrals+i-1)+0)=idfreeze(1,i)
            iwkvec(ic+4*(ndihedrals+i-1)+1)=idfreeze(2,i)
            iwkvec(ic+4*(ndihedrals+i-1)+2)=idfreeze(3,i)
 1004       iwkvec(ic+4*(ndihedrals+i-1)+3)=idfreeze(4,i)

            do 1005 i=1,iifrozen
            iwkvec(id+4*(nimpropers+i-1)+0)=iifreeze(1,i)
            iwkvec(id+4*(nimpropers+i-1)+1)=iifreeze(2,i)
            iwkvec(id+4*(nimpropers+i-1)+2)=iifreeze(3,i)
 1005       iwkvec(id+4*(nimpropers+i-1)+3)=iifreeze(4,i)

            nbonds=nbonds+ibfrozen
            nangles=nangles+iafrozen
            ndihedrals=ndihedrals+idfrozen
            nimpropers=nimpropers+iifrozen

            if(imode.eq.1) then
                                 iwkvec(ia+2*nbonds+0)=ibmode(1)
                                 iwkvec(ia+2*nbonds+1)=ibmode(2)

                                 nbonds=nbonds+1
                           endif

            if(imode.eq.2) then
                                 iwkvec(ib+3*nangles+0)=iamode(1)
                                 iwkvec(ib+3*nangles+1)=iamode(2)
                                 iwkvec(ib+3*nangles+2)=iamode(3)

                                 nangles=nangles+1
                           endif

            if(imode.eq.3) then
                                 iwkvec(ic+4*ndihedrals+0)=idmode(1)
                                 iwkvec(ic+4*ndihedrals+1)=idmode(2)
                                 iwkvec(ic+4*ndihedrals+2)=idmode(3)
                                 iwkvec(ic+4*ndihedrals+3)=idmode(4)

                                 ndihedrals=ndihedrals+1
                           endif

            if(imode.eq.4) then
                                 iwkvec(id+4*nimpropers+0)=iimode(1)
                                 iwkvec(id+4*nimpropers+1)=iimode(2)
                                 iwkvec(id+4*nimpropers+2)=iimode(3)
                                 iwkvec(id+4*nimpropers+3)=iimode(4)

                                 nimpropers=nimpropers+1
                           endif

            if(imode.eq.1) ifollow=nbonds
            if(imode.eq.2) ifollow=nbonds+nangles
            if(imode.eq.3) ifollow=nbonds+nangles+ndihedrals
            if(imode.eq.4) ifollow=nbonds+nangles+ndihedrals+nimpropers

            write(31) nbonds,nangles,ndihedrals,nimpropers

            write(31) (iwkvec(ia+i),i=0,2*nbonds-1)
            write(31) (iwkvec(ib+i),i=0,3*nangles-1)
            write(31) (iwkvec(ic+i),i=0,4*ndihedrals-1)
            write(31) (iwkvec(id+i),i=0,4*nimpropers-1)

                         endif

      rewind 31

      read(31) nbonds,nangles,ndihedrals,nimpropers

      nmodes=nbonds+nangles+ndihedrals+nimpropers

      ia=1
      ib=ia+1+nbonds*2
      ic=ib+1+nangles*3
      id=ic+1+ndihedrals*4
      ie=id+1+nimpropers*4

      read(31) (iwkvec(ia+i),i=0,2*nbonds-1)
      read(31) (iwkvec(ib+i),i=0,3*nangles-1)
      read(31) (iwkvec(ic+i),i=0,4*ndihedrals-1)
      read(31) (iwkvec(id+i),i=0,4*nimpropers-1)

      ja=1
      jb=ja+nmodes
      jc=jb+nmodes
      jd=jc+nmodes
      je=jd+natoms*3
      jf=je+nmodes*natoms*3
      jg=jf+nmodes*nmodes
      jh=jg+nmodes*nmodes
      ji=jh+natoms*3
      jj=ji+nmodes
      jk=jj+nmodes
      jl=jk+nmodes*nmodes
      jm=jl+nmodes*natoms*3
      jn=jm+nmodes*nmodes
      jo=jn+nmodes*nmodes
      jp=jo+nmodes*nmodes
      jq=jp+natoms*3

      ifrozen=ibfrozen+iafrozen+idfrozen+iifrozen

      ii=ie-1

      kk=nbonds-ibfrozen

      do 1006 i=nbonds-ibfrozen+1,nbonds
      ii=ii+1
      kk=kk+1
 1006 iwkvec(ii)=kk

      kk=nbonds+nangles-iafrozen

      do 1007 i=nangles-iafrozen+1,nangles
      ii=ii+1
      kk=kk+1
 1007 iwkvec(ii)=kk

      kk=nbonds+nangles+ndihedrals-idfrozen

      do 1008 i=ndihedrals-idfrozen+1,ndihedrals
      ii=ii+1
      kk=kk+1
 1008 iwkvec(ii)=kk

      kk=nbonds+nangles+ndihedrals+nimpropers-iifrozen

      do 1009 i=nimpropers-iifrozen+1,nimpropers
      ii=ii+1
      kk=kk+1
 1009 iwkvec(ii)=kk

      if(imode.eq.0) then

               call redundant(igeometry,natoms,nmodes,nbonds,nangles,
     &                        ndihedrals,nimpropers,ifrozen,natomtype,
     &                        iwkvec(ia),iwkvec(ib),iwkvec(ic),
     &                        iwkvec(id),iwkvec(ie),stepsize,grms,gmax,
     &                        crms,cmax,coord,wkvec(ja),wkvec(jb),
     &                        wkvec(jc),wkvec(jd),wkvec(je),wkvec(jf),
     &                        wkvec(jg),grad,wkvec(ji),wkvec(jj),
     &                        wkvec(jk),wkvec(jl),wkvec(jm),wkvec(jn),
     &                        wkvec(jo),wkvec(jp),wkvec(jq))

                     else

               call tstate(igeometry,ifollow,natoms,nmodes,nbonds,
     &                     nangles,ndihedrals,nimpropers,ifrozen,
     &                     natomtype,iwkvec(ia),iwkvec(ib),iwkvec(ic),
     &                     iwkvec(id),iwkvec(ie),stepsize,grms,gmax,
     &                     crms,cmax,coord,wkvec(ja),wkvec(jb),
     &                     wkvec(jc),wkvec(jd),wkvec(je),wkvec(jf),
     &                     wkvec(jg),grad,wkvec(ji),wkvec(jj),wkvec(jk),
     &                     wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),
     &                     wkvec(jp),wkvec(jq))

                     endif

      if(igeometry.eq.0) then

             igeometry=1

             write(6,1010)
 1010        format(//,' redefining the redundant internal',
     &                 ' coordinates, angle approaching 180!!',//)

             goto 1001

                         endif

      write(6,1011) grms,gmax,crms,cmax
 1011 format(/,' rms component of gradient =      ',f10.6,/,
     &         ' maximum component of gradient =  ',f10.6,/,
     &         ' rms change in coordinates =      ',f10.6,/,
     &         ' maximum change in coordinates =  ',f10.6,/////)

      if((grms.lt.0.00030).and.
     &   (gmax.lt.0.00045).and.
     &   (crms.lt.0.00120).and.
     &   (cmax.lt.dmaxmove))    then
                                      dmaxfactor=zero

                                      call stringcopy(3*natoms,
     &                                                coord,wkvec(jp))
                                else
                                      dmaxfactor=big
                                endif

      return
      end

      subroutine boys_mm(nreal,ninteger,ncontractions,nconts,ncontp,
     &                   ncontd,nshels,nshelp,nsheld,mtloca,iprimvc,
     &                   nprimvc,icentvc,iwkvec,coord,alpha,coeff,
     &                   x_moment,y_moment,z_moment,wkvec)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*),iprimvc(*),
     &          nprimvc(*),icentvc(*),iwkvec(*)

      dimension coord(3,*),alpha(*),coeff(*),x_moment(ncontractions,*),
     &          y_moment(ncontractions,*),z_moment(ncontractions,*),
     &          wkvec(*)

      data zero,cutoff/0.0d0,1.0d+35/

      do 1001 j=1,ncontractions
      do 1001 i=1,ncontractions
      x_moment(i,j)=zero
      y_moment(i,j)=zero
 1001 z_moment(i,j)=zero

      ncposs=(nconts*(nconts+1))/2
      ncpopp=(ncontp*(ncontp+1))/2
      ncpodd=(ncontd*(ncontd+1))/2

      ncpops=ncontp*nconts
      ncpods=ncontd*nconts
      ncpodp=ncontd*ncontp

      npposs=0
      nppops=0
      nppopp=0
      nppods=0
      nppodp=0
      nppodd=0

      do 1002 i=1,nconts
      do 1002 j=1,i
 1002 npposs=npposs+nprimvc(nshels(i))*nprimvc(nshels(j))

      do 1003 i=1,ncontp
      do 1003 j=1,nconts
 1003 nppops=nppops+nprimvc(nshelp(i))*nprimvc(nshels(j))

      do 1004 i=1,ncontp
      do 1004 j=1,i
 1004 nppopp=nppopp+nprimvc(nshelp(i))*nprimvc(nshelp(j))

      do 1005 i=1,ncontd
      do 1005 j=1,nconts
 1005 nppods=nppods+nprimvc(nsheld(i))*nprimvc(nshels(j))

      do 1006 i=1,ncontd
      do 1006 j=1,ncontp
 1006 nppodp=nppodp+nprimvc(nsheld(i))*nprimvc(nshelp(j))

      do 1007 i=1,ncontd
      do 1007 j=1,i
 1007 nppodd=nppodd+nprimvc(nsheld(i))*nprimvc(nsheld(j))

      ja=1
      jb=ja+npposs
      jc=jb+ncposs

      if(jc.gt.ninteger) stop 'boys_mm ss integer overflow'

      je=1
      jf=je+npposs
      jg=jf+npposs
      jh=jg+npposs
      ji=jh+npposs
      jj=ji+npposs
      jk=jj+npposs
      jl=jk+npposs
      jm=jl+npposs
      jn=jm+npposs
      jo=jn+npposs
      jp=jo+npposs
      jq=jp+npposs

      if(jq.gt.nreal) stop 'boys_mm ss real overflow'

      call setupss(ncposs,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &             icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,alpha,
     &             coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp))

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n

      ka=jq+1
      kb=ka+n*3

      if(kb.gt.nreal) stop 'boys_mm ss real overflow'

      call boys_ss(n,iwkvec(ja),iwkvec(jb),wkvec(je),wkvec(jn),
     &             wkvec(jo),wkvec(jp),wkvec(jm),wkvec(ka),x_moment,
     &             y_moment,z_moment)

      if(ncontp.eq.0) goto 1008

      ja=1
      jb=ja+nppops
      jc=jb+ncpops*3

      if(jc.gt.ninteger) stop 'boys_mm ps integer overflow'

      je=1
      jf=je+nppops
      jg=jf+nppops
      jh=jg+nppops
      ji=jh+nppops
      jj=ji+nppops
      jk=jj+nppops
      jl=jk+nppops
      jm=jl+nppops
      jn=jm+nppops
      jo=jn+nppops
      jp=jo+nppops
      jq=jp+nppops
      jr=jq+nppops
      js=jr+nppops
      jt=js+nppops

      if(jt.gt.nreal) stop 'boys_mm ps real overflow'

      call setupps(ncpops,n,ncontp,nconts,nshelp,nshels,mtloca,iprimvc,
     &             nprimvc,icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,
     &             alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js))

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      ka=jt+1
      kb=ka+n*3
      kc=kb+n*9
      kd=kc+n

      if(kd.gt.nreal) stop 'boys_mm ps real overflow'

      call boys_ps(ncpops,n,iwkvec(ja),iwkvec(jb),wkvec(je),wkvec(jn),
     &             wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),
     &             wkvec(jm),wkvec(ka),wkvec(kb),wkvec(kc),x_moment,
     &             y_moment,z_moment)

      ja=1
      jb=ja+ncpopp
      jc=jb+nppopp
      jd=jc+ncpopp*9

      if(jd.gt.ninteger) stop 'boys_mm pp integer overflow'

      je=1
      jf=je+nppopp
      jg=jf+nppopp
      jh=jg+nppopp
      ji=jh+nppopp
      jj=ji+nppopp
      jk=jj+nppopp
      jl=jk+nppopp
      jm=jl+nppopp
      jn=jm+nppopp
      jo=jn+nppopp
      jp=jo+nppopp
      jq=jp+nppopp
      jr=jq+nppopp
      js=jr+nppopp
      jt=js+nppopp
      ju=jt+nppopp
      jv=ju+nppopp
      jw=jv+nppopp
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      if(jz.gt.nreal) stop 'boys_mm pp real overflow'

      call setuppp(ncpopp,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &             icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &             coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &             wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &             wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &             wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &             wkvec(jw),wkvec(jx),wkvec(jy))

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))
      call stringcopy(n,wkvec(15*n+1),wkvec(jt))
      call stringcopy(n,wkvec(16*n+1),wkvec(ju))
      call stringcopy(n,wkvec(17*n+1),wkvec(jv))
      call stringcopy(ncpopp,wkvec(18*n+0*ncpopp+1),wkvec(jw))
      call stringcopy(ncpopp,wkvec(18*n+1*ncpopp+1),wkvec(jx))
      call stringcopy(ncpopp,wkvec(18*n+2*ncpopp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      ka=jz+1
      kb=ka+n*3
      kc=kb+n*9
      kd=kc+n*27
      ke=kd+n*3
      kf=ke+n
      kg=kf+n*3
      kh=kg+n*3

      if(kh.gt.nreal) stop 'boys_mm pp real overflow'

      call boys_pp(ncpopp,n,iwkvec(ja),iwkvec(jb),iwkvec(jc),wkvec(je),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jm),
     &             wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &             wkvec(kf),wkvec(kg),x_moment,y_moment,z_moment)

      if(ncontd.eq.0) goto 1008

      ja=1
      jb=ja+nppods
      jc=jb+ncpods*6

      if(jc.gt.ninteger) stop 'boys_mm ds integer overflow'

      je=1
      jf=je+nppods
      jg=jf+nppods
      jh=jg+nppods
      ji=jh+nppods
      jj=ji+nppods
      jk=jj+nppods
      jl=jk+nppods
      jm=jl+nppods
      jn=jm+nppods
      jo=jn+nppods
      jp=jo+nppods
      jq=jp+nppods
      jr=jq+nppods
      js=jr+nppods
      jt=js+nppods

      if(jt.gt.nreal) stop 'boys_mm ds real overflow'

      call setupds(ncpods,n,ncontd,nconts,nsheld,nshels,mtloca,iprimvc,
     &             nprimvc,icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,
     &             alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js))

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      ka=jt+1
      kb=ka+n*3
      kc=kb+n*9
      kd=kc+n*18
      ke=kd+n*3
      kf=ke+n
      kg=kf+n*3
      kh=kg+n*3

      if(kh.gt.nreal) stop 'boys_mm ds real overflow'

      call boys_ds(ncpods,n,iwkvec(ja),iwkvec(jb),wkvec(je),wkvec(jn),
     &             wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),
     &             wkvec(jm),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &             wkvec(ke),wkvec(kf),wkvec(kg),x_moment,y_moment,
     &             z_moment)

      ja=1
      jb=ja+nppodp
      jc=jb+ncpodp*18

      if(jc.gt.ninteger) stop 'boys_mm dp integer overflow'

      je=1
      jf=je+nppodp
      jg=jf+nppodp
      jh=jg+nppodp
      ji=jh+nppodp
      jj=ji+nppodp
      jk=jj+nppodp
      jl=jk+nppodp
      jm=jl+nppodp
      jn=jm+nppodp
      jo=jn+nppodp
      jp=jo+nppodp
      jq=jp+nppodp
      jr=jq+nppodp
      js=jr+nppodp
      jt=js+nppodp
      ju=jt+nppodp
      jv=ju+nppodp
      jw=jv+nppodp
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      if(jz.gt.nreal) stop 'boys_mm dp real overflow'

      call setupdp(ncpodp,n,ncontd,ncontp,nsheld,nshelp,mtloca,iprimvc,
     &             nprimvc,icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,
     &             alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &             wkvec(jx),wkvec(jy))

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))
      call stringcopy(n,wkvec(15*n+1),wkvec(jt))
      call stringcopy(n,wkvec(16*n+1),wkvec(ju))
      call stringcopy(n,wkvec(17*n+1),wkvec(jv))
      call stringcopy(ncpodp,wkvec(18*n+0*ncpodp+1),wkvec(jw))
      call stringcopy(ncpodp,wkvec(18*n+1*ncpodp+1),wkvec(jx))
      call stringcopy(ncpodp,wkvec(18*n+2*ncpodp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      ka=jz+1
      kb=ka+n*3
      kc=kb+n*9
      kd=kc+n*18
      ke=kd+n*54
      kf=ke+n*3
      kg=kf+n*6
      kh=kg+n
      ki=kh+n*6
      kj=ki+n*9

      if(kj.gt.nreal) stop 'boys_mm dp real overflow'

      call boys_dp(ncpodp,n,iwkvec(ja),iwkvec(jb),wkvec(je),wkvec(jn),
     &             wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),
     &             wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jm),wkvec(ka),
     &             wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &             wkvec(kg),wkvec(kh),wkvec(ki),x_moment,y_moment,
     &             z_moment)

      ja=1
      jb=ja+ncpodd
      jc=jb+nppodd
      jd=jc+ncpodd*36

      if(jd.gt.ninteger) stop 'boys_mm dd integer overflow'

      je=1
      jf=je+nppodd
      jg=jf+nppodd
      jh=jg+nppodd
      ji=jh+nppodd
      jj=ji+nppodd
      jk=jj+nppodd
      jl=jk+nppodd
      jm=jl+nppodd
      jn=jm+nppodd
      jo=jn+nppodd
      jp=jo+nppodd
      jq=jp+nppodd
      jr=jq+nppodd
      js=jr+nppodd
      jt=js+nppodd
      ju=jt+nppodd
      jv=ju+nppodd
      jw=jv+nppodd
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      if(jz.gt.nreal) stop 'boys_mm dd real overflow'

      call setupdd(ncpodd,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &             icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &             coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &             wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &             wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &             wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &             wkvec(jw),wkvec(jx),wkvec(jy))

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))
      call stringcopy(n,wkvec(15*n+1),wkvec(jt))
      call stringcopy(n,wkvec(16*n+1),wkvec(ju))
      call stringcopy(n,wkvec(17*n+1),wkvec(jv))
      call stringcopy(ncpodd,wkvec(18*n+0*ncpodd+1),wkvec(jw))
      call stringcopy(ncpodd,wkvec(18*n+1*ncpodd+1),wkvec(jx))
      call stringcopy(ncpodd,wkvec(18*n+2*ncpodd+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      ka=jz+1
      kb=ka+n*3
      kc=kb+n*9
      kd=kc+n*18
      ke=kd+n*27
      kf=ke+n*54
      kg=kf+n*108
      kh=kg+n*3
      ki=kh+n*6
      kj=ki+n*18
      kk=kj+n
      kl=kk+n*18
      km=kl+n*18
      kn=km+n*27

      if(kn.gt.nreal) stop 'boys_mm dd real overflow'

      call boys_dd(ncpodd,n,iwkvec(ja),iwkvec(jb),iwkvec(jc),wkvec(je),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jm),
     &             wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &             wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &             wkvec(kk),wkvec(kl),wkvec(km),x_moment,y_moment,
     &             z_moment)

 1008 continue

      ndim=(ncontractions*(ncontractions+1))/2

      call stringcopy(ndim,wkvec,x_moment)

      ij=0
      do 1009 i=1,ncontractions
      do 1009 j=1,i
      ij=ij+1
      x_moment(i,j)=wkvec(ij)
 1009 x_moment(j,i)=wkvec(ij)

      call stringcopy(ndim,wkvec,y_moment)

      ij=0
      do 1010 i=1,ncontractions
      do 1010 j=1,i
      ij=ij+1
      y_moment(i,j)=wkvec(ij)
 1010 y_moment(j,i)=wkvec(ij)

      call stringcopy(ndim,wkvec,z_moment)

      ij=0
      do 1011 i=1,ncontractions
      do 1011 j=1,i
      ij=ij+1
      z_moment(i,j)=wkvec(ij)
 1011 z_moment(j,i)=wkvec(ij)

      return
      end

      subroutine gradnapp(m,n,ncentr,iminj,icontr,inddyy,icentr,g,coord,
     &                    charge,density,gradient,zeta,twozetaa,
     &                    twozetab,px,py,pz,base,pxax,pyay,pzaz,axbx,
     &                    ayby,azbz,pxcx,pycy,pzcz,twozeta,u,ss0,ss1,
     &                    ss2,ss3,ps0,ps1,ps2,ds0,ds1,fs0,c,c1,sscond,
     &                    pscond,spcond,dscond,ppcond,fscond,dpcond,
     &                    pdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*),icentr(m,*)

      dimension g(*),coord(3,*),charge(*),density(*),gradient(3,*),
     &          zeta(*),twozetaa(*),twozetab(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          pxcx(*),pycy(*),pzcz(*),twozeta(*),u(*),ss0(*),ss1(*),
     &          ss2(*),ss3(*),ps0(n,*),ps1(n,*),ps2(n,*),ds0(n,*),
     &          ds1(n,*),fs0(n,*),c(*),c1(n,*),sscond(*),pscond(m,*),
     &          spcond(m,*),dscond(m,*),ppcond(m,*),fscond(m,*),
     &          dpcond(m,*),pdcond(m,*),grad(m,*)

      data zero,two,three,four,pi/0.0d0,2.0d0,
     &                            3.0d0,4.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 1003 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1003 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1004 i=1,n
      call augg(4,u(i),g)
      ss0(i)=base(i)*g(1)*twopichrg/zeta(i)
      ss1(i)=base(i)*g(2)*twopichrg/zeta(i)
      ss2(i)=base(i)*g(3)*twopichrg/zeta(i)
 1004 ss3(i)=base(i)*g(4)*twopichrg/zeta(i)

      do 1005 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 1005 ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      do 1006 i=1,n
      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
 1006 ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      do 1007 i=1,n
      ps2(i,1)=pxax(i)*ss2(i)-pxcx(i)*ss3(i)
      ps2(i,2)=pyay(i)*ss2(i)-pycy(i)*ss3(i)
 1007 ps2(i,3)=pzaz(i)*ss2(i)-pzcz(i)*ss3(i)

      do 1008 i=1,n
 1008 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1009 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1009 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1010 i=1,n
 1010 c(i)=(ss1(i)-ss2(i))/twozeta(i)

      do 1011 i=1,n
      ds1(i,1)=pxax(i)*ps1(i,1)-pxcx(i)*ps2(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps1(i,1)-pycy(i)*ps2(i,1)
      ds1(i,3)=pzaz(i)*ps1(i,1)-pzcz(i)*ps2(i,1)
      ds1(i,4)=pyay(i)*ps1(i,2)-pycy(i)*ps2(i,2)+c(i)
      ds1(i,5)=pzaz(i)*ps1(i,2)-pzcz(i)*ps2(i,2)
 1011 ds1(i,6)=pzaz(i)*ps1(i,3)-pzcz(i)*ps2(i,3)+c(i)

      do 1012 j=1,3
      do 1012 i=1,n
 1012 c1(i,j)=(ps0(i,j)-ps1(i,j))/twozeta(i)

      do 1013 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)-pxcx(i)*ds1(i,1)+c1(i,1)*two
      fs0(i,02)=pyay(i)*ds0(i,1)-pycy(i)*ds1(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)-pzcz(i)*ds1(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)-pycy(i)*ds1(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)-pzcz(i)*ds1(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)-pzcz(i)*ds1(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)-pycy(i)*ds1(i,4)+c1(i,2)*two
      fs0(i,08)=pzaz(i)*ds0(i,4)-pzcz(i)*ds1(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)-pzcz(i)*ds1(i,5)+c1(i,2)
 1013 fs0(i,10)=pzaz(i)*ds0(i,6)-pzcz(i)*ds1(i,6)+c1(i,3)*two

      do 1014 i=1,m
 1014 sscond(i)=zero

      do 1015 j=1,3
      do 1015 i=1,m
 1015 pscond(i,j)=zero

      do 1016 i=1,n
 1016 sscond(icontr(i))=sscond(icontr(i))-ss0(i)

      do 1017 j=1,3
      do 1017 i=1,n
 1017 pscond(icontr(i),j)=pscond(icontr(i),j)-ps0(i,j)

      do 1018 i=1,m
      spcond(i,1)=axbx(i)*sscond(i)+pscond(i,1)
      spcond(i,2)=ayby(i)*sscond(i)+pscond(i,2)
 1018 spcond(i,3)=azbz(i)*sscond(i)+pscond(i,3)

      do 1019 i=1,m
      grad(i,1)=spcond(i,1)*density(inddyy(i,1))
      grad(i,2)=spcond(i,2)*density(inddyy(i,2))
      grad(i,3)=spcond(i,3)*density(inddyy(i,3))
      grad(i,4)=spcond(i,1)*density(inddyy(i,4))
      grad(i,5)=spcond(i,2)*density(inddyy(i,5))
      grad(i,6)=spcond(i,3)*density(inddyy(i,6))
      grad(i,7)=spcond(i,1)*density(inddyy(i,7))
      grad(i,8)=spcond(i,2)*density(inddyy(i,8))
 1019 grad(i,9)=spcond(i,3)*density(inddyy(i,9))

      do 1020 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,2)=zero
                              grad(i,3)=zero
                              grad(i,6)=zero
                        endif
 1020 continue

      do 1021 k=1,3
      do 1021 j=1,3
      do 1021 i=1,m
 1021 gradient(k,nn)=gradient(k,nn)+grad(i,3*(k-1)+j)

      do 1022 k=1,3
      do 1022 j=1,3
      do 1022 i=1,m
 1022 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,3*(k-1)+j)

      do 1023 i=1,m
      grad(i,1)=pscond(i,1)*density(inddyy(i,1))
      grad(i,2)=pscond(i,2)*density(inddyy(i,4))
      grad(i,3)=pscond(i,3)*density(inddyy(i,7))
      grad(i,4)=pscond(i,1)*density(inddyy(i,2))
      grad(i,5)=pscond(i,2)*density(inddyy(i,5))
      grad(i,6)=pscond(i,3)*density(inddyy(i,8))
      grad(i,7)=pscond(i,1)*density(inddyy(i,3))
      grad(i,8)=pscond(i,2)*density(inddyy(i,6))
 1023 grad(i,9)=pscond(i,3)*density(inddyy(i,9))

      do 1024 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,4)=zero
                              grad(i,7)=zero
                              grad(i,8)=zero
                        endif
 1024 continue

      do 1025 k=1,3
      do 1025 j=1,3
      do 1025 i=1,m
 1025 gradient(k,nn)=gradient(k,nn)+grad(i,3*(k-1)+j)

      do 1026 k=1,3
      do 1026 j=1,3
      do 1026 i=1,m
 1026 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,3*(k-1)+j)

      do 1027 j=1,6
      do 1027 i=1,m
 1027 dscond(i,j)=zero

      do 1028 j=1,10
      do 1028 i=1,m
 1028 fscond(i,j)=zero

      do 1029 j=1,6
      do 1029 i=1,n
 1029 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)*twozetaa(i)

      do 1030 j=1,10
      do 1030 i=1,n
 1030 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)*twozetaa(i)

      do 1031 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1031 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1032 i=1,m
      grad(i,01)=dpcond(i,01)*density(inddyy(i,1))
      grad(i,02)=dpcond(i,02)*density(inddyy(i,2))
      grad(i,03)=dpcond(i,03)*density(inddyy(i,3))
      grad(i,04)=dpcond(i,04)*density(inddyy(i,4))
      grad(i,05)=dpcond(i,05)*density(inddyy(i,5))
      grad(i,06)=dpcond(i,06)*density(inddyy(i,6))
      grad(i,07)=dpcond(i,07)*density(inddyy(i,7))
      grad(i,08)=dpcond(i,08)*density(inddyy(i,8))
      grad(i,09)=dpcond(i,09)*density(inddyy(i,9))
      grad(i,10)=dpcond(i,04)*density(inddyy(i,1))
      grad(i,11)=dpcond(i,05)*density(inddyy(i,2))
      grad(i,12)=dpcond(i,06)*density(inddyy(i,3))
      grad(i,13)=dpcond(i,10)*density(inddyy(i,4))
      grad(i,14)=dpcond(i,11)*density(inddyy(i,5))
      grad(i,15)=dpcond(i,12)*density(inddyy(i,6))
      grad(i,16)=dpcond(i,13)*density(inddyy(i,7))
      grad(i,17)=dpcond(i,14)*density(inddyy(i,8))
      grad(i,18)=dpcond(i,15)*density(inddyy(i,9))
      grad(i,19)=dpcond(i,07)*density(inddyy(i,1))
      grad(i,20)=dpcond(i,08)*density(inddyy(i,2))
      grad(i,21)=dpcond(i,09)*density(inddyy(i,3))
      grad(i,22)=dpcond(i,13)*density(inddyy(i,4))
      grad(i,23)=dpcond(i,14)*density(inddyy(i,5))
      grad(i,24)=dpcond(i,15)*density(inddyy(i,6))
      grad(i,25)=dpcond(i,16)*density(inddyy(i,7))
      grad(i,26)=dpcond(i,17)*density(inddyy(i,8))
 1032 grad(i,27)=dpcond(i,18)*density(inddyy(i,9))

      do 1033 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,15)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,24)=zero
                        endif
 1033 continue

      do 1034 k=1,3
      do 1034 j=1,9
      do 1034 i=1,m
 1034 gradient(k,nn)=gradient(k,nn)+grad(i,9*(k-1)+j)

      do 1035 k=1,3
      do 1035 j=1,9
      do 1035 i=1,m
 1035 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,9*(k-1)+j)

      do 1036 j=1,3
      do 1036 i=1,m
 1036 pscond(i,j)=zero

      do 1037 j=1,6
      do 1037 i=1,m
 1037 dscond(i,j)=zero

      do 1038 j=1,10
      do 1038 i=1,m
 1038 fscond(i,j)=zero

      do 1039 j=1,3
      do 1039 i=1,n
 1039 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)*twozetab(i)

      do 1040 j=1,6
      do 1040 i=1,n
 1040 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)*twozetab(i)

      do 1041 j=1,10
      do 1041 i=1,n
 1041 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)*twozetab(i)

      do 1042 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1042 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1043 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1043 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1044 i=1,m
      pdcond(i,01)=axbx(i)*ppcond(i,1)+dpcond(i,01)
      pdcond(i,02)=ayby(i)*ppcond(i,1)+dpcond(i,04)
      pdcond(i,03)=azbz(i)*ppcond(i,1)+dpcond(i,07)
      pdcond(i,04)=ayby(i)*ppcond(i,2)+dpcond(i,05)
      pdcond(i,05)=azbz(i)*ppcond(i,2)+dpcond(i,08)
      pdcond(i,06)=azbz(i)*ppcond(i,3)+dpcond(i,09)
      pdcond(i,07)=axbx(i)*ppcond(i,4)+dpcond(i,04)
      pdcond(i,08)=ayby(i)*ppcond(i,4)+dpcond(i,10)
      pdcond(i,09)=azbz(i)*ppcond(i,4)+dpcond(i,13)
      pdcond(i,10)=ayby(i)*ppcond(i,5)+dpcond(i,11)
      pdcond(i,11)=azbz(i)*ppcond(i,5)+dpcond(i,14)
      pdcond(i,12)=azbz(i)*ppcond(i,6)+dpcond(i,15)
      pdcond(i,13)=axbx(i)*ppcond(i,7)+dpcond(i,07)
      pdcond(i,14)=ayby(i)*ppcond(i,7)+dpcond(i,13)
      pdcond(i,15)=azbz(i)*ppcond(i,7)+dpcond(i,16)
      pdcond(i,16)=ayby(i)*ppcond(i,8)+dpcond(i,14)
      pdcond(i,17)=azbz(i)*ppcond(i,8)+dpcond(i,17)
 1044 pdcond(i,18)=azbz(i)*ppcond(i,9)+dpcond(i,18)

      do 1045 i=1,m
      grad(i,01)=pdcond(i,01)*density(inddyy(i,1))
      grad(i,02)=pdcond(i,02)*density(inddyy(i,2))
      grad(i,03)=pdcond(i,03)*density(inddyy(i,3))
      grad(i,04)=pdcond(i,07)*density(inddyy(i,4))
      grad(i,05)=pdcond(i,08)*density(inddyy(i,5))
      grad(i,06)=pdcond(i,09)*density(inddyy(i,6))
      grad(i,07)=pdcond(i,13)*density(inddyy(i,7))
      grad(i,08)=pdcond(i,14)*density(inddyy(i,8))
      grad(i,09)=pdcond(i,15)*density(inddyy(i,9))
      grad(i,10)=pdcond(i,02)*density(inddyy(i,1))
      grad(i,11)=pdcond(i,04)*density(inddyy(i,2))
      grad(i,12)=pdcond(i,05)*density(inddyy(i,3))
      grad(i,13)=pdcond(i,08)*density(inddyy(i,4))
      grad(i,14)=pdcond(i,10)*density(inddyy(i,5))
      grad(i,15)=pdcond(i,11)*density(inddyy(i,6))
      grad(i,16)=pdcond(i,14)*density(inddyy(i,7))
      grad(i,17)=pdcond(i,16)*density(inddyy(i,8))
      grad(i,18)=pdcond(i,17)*density(inddyy(i,9))
      grad(i,19)=pdcond(i,03)*density(inddyy(i,1))
      grad(i,20)=pdcond(i,05)*density(inddyy(i,2))
      grad(i,21)=pdcond(i,06)*density(inddyy(i,3))
      grad(i,22)=pdcond(i,09)*density(inddyy(i,4))
      grad(i,23)=pdcond(i,11)*density(inddyy(i,5))
      grad(i,24)=pdcond(i,12)*density(inddyy(i,6))
      grad(i,25)=pdcond(i,15)*density(inddyy(i,7))
      grad(i,26)=pdcond(i,17)*density(inddyy(i,8))
 1045 grad(i,27)=pdcond(i,18)*density(inddyy(i,9))

      do 1046 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,15)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,24)=zero
                        endif
 1046 continue

      do 1047 k=1,3
      do 1047 j=1,9
      do 1047 i=1,m
 1047 gradient(k,nn)=gradient(k,nn)+grad(i,9*(k-1)+j)

      do 1048 k=1,3
      do 1048 j=1,9
      do 1048 i=1,m
 1048 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,9*(k-1)+j)

 1002 continue

      return
      end

      subroutine hguess(nmodes,nbonds,nangles,ndihedrals,nimpropers,
     &                  natomtype,i_bond,i_angle,i_dihedral,i_improper,
     &                  coord,hessian)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension radii(0:54),radius(0:54)

      dimension natomtype(*),i_bond(2,*),i_angle(3,*),i_dihedral(4,*),
     &          i_improper(4,*)

      dimension coord(3,*),hessian(nmodes,*)

      data zero,bohr/0.0d0,0.529177d0/

      data radii/1.00d0,0.32d0,0.60d0,1.20d0,1.05d0,0.81d0,0.77d0,
     &                  0.74d0,0.74d0,0.72d0,0.72d0,1.50d0,1.40d0,
     &                  1.30d0,1.17d0,1.10d0,1.04d0,0.99d0,0.99d0,
     &                  1.80d0,1.60d0,1.40d0,1.40d0,1.40d0,1.40d0,
     &                  1.40d0,1.40d0,1.40d0,1.40d0,1.40d0,1.40d0,
     &                  1.40d0,1.30d0,1.20d0,1.20d0,1.10d0,1.10d0,
     &                  1.80d0,1.60d0,1.40d0,1.40d0,1.40d0,1.40d0,
     &                  1.40d0,1.40d0,1.40d0,1.40d0,1.40d0,1.40d0,
     &                  1.40d0,1.30d0,1.20d0,1.20d0,1.10d0,1.10d0/

      data a_b,b_b/0.3601d0,1.944d0/
      data a_a,b_a,c_a,d_a/0.089d0,0.11d0,0.44d0,-0.42d0/
      data a_d,b_d,c_d,d_d,e_d/0.0015d0,14.0d0,2.85d0,0.57d0,4.00d0/
      data a_i,b_i,c_i,d_i,e_i/0.0025d0,0.0061d0,3.00d0,4.00d0,0.80d0/

      do 1001 i=0,54
 1001 radius(i)=radii(i)/bohr

      do 1002 j=1,nmodes
      do 1002 i=1,nmodes
 1002 hessian(i,j)=zero

      do 1003 i=1,nbonds
      r_ab=dist(coord(1,i_bond(1,i)),coord(1,i_bond(2,i)))
      r_ab_cov=radius(natomtype(i_bond(1,i)))
     &        +radius(natomtype(i_bond(2,i)))
 1003 hessian(i,i)=a_b*exp(-b_b*(r_ab-r_ab_cov))

      do 1004 i=1,nangles
      r_ab=dist(coord(1,i_angle(2,i)),coord(1,i_angle(1,i)))
      r_ac=dist(coord(1,i_angle(2,i)),coord(1,i_angle(3,i)))
      r_ab_cov=radius(natomtype(i_angle(2,i)))
     &        +radius(natomtype(i_angle(1,i)))
      r_ac_cov=radius(natomtype(i_angle(2,i)))
     &        +radius(natomtype(i_angle(3,i)))
      factor1=c_a*(r_ab+r_ac-r_ab_cov-r_ac_cov)
      factor2=(r_ab_cov*r_ac_cov)**(d_a)
 1004 hessian(nbonds+i,nbonds+i)=a_a+(b_a/factor2)*exp(-factor1)

      do 1005 i=1,ndihedrals

      l=0

      do 1006 j=1,nbonds
      if(i_bond(1,j).eq.i_dihedral(2,i)) l=l+1
      if(i_bond(1,j).eq.i_dihedral(3,i)) l=l+1
      if(i_bond(2,j).eq.i_dihedral(2,i)) l=l+1
      if(i_bond(2,j).eq.i_dihedral(3,i)) l=l+1
 1006 continue

      r_ab=dist(coord(1,i_dihedral(2,i)),coord(1,i_dihedral(3,i)))
      r_ab_cov=radius(natomtype(i_dihedral(2,i)))
     &        +radius(natomtype(i_dihedral(3,i)))

      factor1=exp(-c_d*(r_ab-r_ab_cov))
      factor2=(b_d*(real64(l)**d_d))/((r_ab*r_ab_cov)**e_d)

 1005 hessian(nbonds+nangles+i,nbonds+nangles+i)=a_d+factor1*factor2

      do 1007 i=1,nimpropers

      theta=dimp(coord(1,i_improper(1,i)),coord(1,i_improper(2,i)),
     &           coord(1,i_improper(3,i)),coord(1,i_improper(4,i)))

      r_ax=dist(coord(1,i_improper(4,i)),coord(1,i_improper(1,i)))

      r_ab_cov=radius(natomtype(i_improper(4,i)))
     &        +radius(natomtype(i_improper(2,i)))
      r_ac_cov=radius(natomtype(i_improper(4,i)))
     &        +radius(natomtype(i_improper(3,i)))
      r_ax_cov=radius(natomtype(i_improper(4,i)))
     &        +radius(natomtype(i_improper(1,i)))

      factor1=exp(-c_i*(r_ax-r_ax_cov))
      factor2=b_i*((r_ab_cov*r_ac_cov)**e_i)*((cos(theta))**d_i)

      ii=nbonds+nangles+ndihedrals+i

 1007 hessian(ii,ii)=a_i+factor1*factor2

      return
      end

      subroutine corepp(m,n,ncentr,iminj,icontr,inddyy,iloc,coord,
     &                  charge,overlap,core,zeta,axbx,ayby,azbz,px,py,
     &                  pz,pxax,pyay,pzaz,pxbx,pyby,pzbz,eta,base,
     &                  etarr,ss,ss0,ss1,ss2,ps,ps0,ps1,ds0,pp,ppcond,
     &                  c,pxcx,pycy,pzcz,u,twozeta,eta2)


c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*),iloc(*)

      dimension coord(3,*),charge(*),overlap(*),core(*),zeta(*),
     &          axbx(*),ayby(*),azbz(*),px(*),py(*),pz(*),pxax(*),
     &          pyay(*),pzaz(*),pxbx(*),pyby(*),pzbz(*),eta(*),base(*),
     &          etarr(*),ss(*),ss0(*),ss1(*),ss2(*),ps(n,*),ps0(n,*),
     &          ps1(n,*),ds0(n,*),pp(n,*),ppcond(n,*),c(*),pxcx(*),
     &          pycy(*),pzcz(*),u(*),twozeta(*),eta2(*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
      eta2(i)=two*eta(i)
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)
      ps0(i,2)=pyay(i)*ss0(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
 1004 c(i)=ss0(i)/twozeta(i)

      do 1005 i=1,n
      pp(i,1)=pxbx(i)*ps0(i,1)+c(i)
      pp(i,2)=pyby(i)*ps0(i,1)
      pp(i,3)=pzbz(i)*ps0(i,1)
      pp(i,4)=pxbx(i)*ps0(i,2)
      pp(i,5)=pyby(i)*ps0(i,2)+c(i)
      pp(i,6)=pzbz(i)*ps0(i,2)
      pp(i,7)=pxbx(i)*ps0(i,3)
      pp(i,8)=pyby(i)*ps0(i,3)
 1005 pp(i,9)=pzbz(i)*ps0(i,3)+c(i)

      do 1006 i=1,n
      overlap(inddyy(icontr(i),1))=overlap(inddyy(icontr(i),1))+pp(i,1)
      overlap(inddyy(icontr(i),4))=overlap(inddyy(icontr(i),4))+pp(i,4)
      overlap(inddyy(icontr(i),5))=overlap(inddyy(icontr(i),5))+pp(i,5)
      overlap(inddyy(icontr(i),7))=overlap(inddyy(icontr(i),7))+pp(i,7)
      overlap(inddyy(icontr(i),8))=overlap(inddyy(icontr(i),8))+pp(i,8)
 1006 overlap(inddyy(icontr(i),9))=overlap(inddyy(icontr(i),9))+pp(i,9)


      do 1007 i=1,n
      if(iminj(icontr(i)).ne.0) then

              overlap(inddyy(icontr(i),2))=overlap(inddyy(icontr(i),2))
     &                                    +pp(i,2)
              overlap(inddyy(icontr(i),3))=overlap(inddyy(icontr(i),3))
     &                                    +pp(i,3)
              overlap(inddyy(icontr(i),6))=overlap(inddyy(icontr(i),6))
     &                                    +pp(i,6)

                        endif
 1007 continue

      do 1008 i=1,n
 1008 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1009 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps0(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps0(i,2)
 1009 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps0(i,3)

      do 1010 i=1,n
 1010 c(i)=ss(i)/twozeta(i)

      do 1011 i=1,n
      pp(i,1)=pxbx(i)*ps(i,1)+eta2(i)*pp(i,1)+c(i)
      pp(i,2)=pyby(i)*ps(i,1)+eta2(i)*pp(i,2)
      pp(i,3)=pzbz(i)*ps(i,1)+eta2(i)*pp(i,3)
      pp(i,4)=pxbx(i)*ps(i,2)+eta2(i)*pp(i,4)
      pp(i,5)=pyby(i)*ps(i,2)+eta2(i)*pp(i,5)+c(i)
      pp(i,6)=pzbz(i)*ps(i,2)+eta2(i)*pp(i,6)
      pp(i,7)=pxbx(i)*ps(i,3)+eta2(i)*pp(i,7)
      pp(i,8)=pyby(i)*ps(i,3)+eta2(i)*pp(i,8)
 1011 pp(i,9)=pzbz(i)*ps(i,3)+eta2(i)*pp(i,9)+c(i)

      do 1012 i=1,n
      core(inddyy(icontr(i),1))=core(inddyy(icontr(i),1))+pp(i,1)
      core(inddyy(icontr(i),4))=core(inddyy(icontr(i),4))+pp(i,4)
      core(inddyy(icontr(i),5))=core(inddyy(icontr(i),5))+pp(i,5)
      core(inddyy(icontr(i),7))=core(inddyy(icontr(i),7))+pp(i,7)
      core(inddyy(icontr(i),8))=core(inddyy(icontr(i),8))+pp(i,8)
 1012 core(inddyy(icontr(i),9))=core(inddyy(icontr(i),9))+pp(i,9)

      do 1013 i=1,n
      if(iminj(icontr(i)).ne.0) then

               core(inddyy(icontr(i),2))=core(inddyy(icontr(i),2))
     &                                  +pp(i,2)
               core(inddyy(icontr(i),3))=core(inddyy(icontr(i),3))
     &                                  +pp(i,3)
               core(inddyy(icontr(i),6))=core(inddyy(icontr(i),6))
     &                                  +pp(i,6)

                        endif
 1013 continue

      do 1014 j=1,9
      do 1014 i=1,n
 1014 ppcond(i,j)=zero

      do 2001 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 2002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 2002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      call auggv(3,n,iloc,u,ps0,ss0,eta2,c)

      do 2003 i=1,n
      ss0(i)=base(i)*ps0(i,1)*twopichrg/zeta(i)
      ss1(i)=base(i)*ps0(i,2)*twopichrg/zeta(i)
 2003 ss2(i)=base(i)*ps0(i,3)*twopichrg/zeta(i)

      do 2004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

 2004 continue

      do 2005 i=1,n
 2005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 2006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 2006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 2011 i=1,n
      ppcond(i,1)=ppcond(i,1)+axbx(icontr(i))*ps0(i,1)+ds0(i,1)
      ppcond(i,2)=ppcond(i,2)+ayby(icontr(i))*ps0(i,1)+ds0(i,2)
      ppcond(i,3)=ppcond(i,3)+azbz(icontr(i))*ps0(i,1)+ds0(i,3)
      ppcond(i,4)=ppcond(i,4)+axbx(icontr(i))*ps0(i,2)+ds0(i,2)
      ppcond(i,5)=ppcond(i,5)+ayby(icontr(i))*ps0(i,2)+ds0(i,4)
      ppcond(i,6)=ppcond(i,6)+azbz(icontr(i))*ps0(i,2)+ds0(i,5)
      ppcond(i,7)=ppcond(i,7)+axbx(icontr(i))*ps0(i,3)+ds0(i,3)
      ppcond(i,8)=ppcond(i,8)+ayby(icontr(i))*ps0(i,3)+ds0(i,5)
 2011 ppcond(i,9)=ppcond(i,9)+azbz(icontr(i))*ps0(i,3)+ds0(i,6)

 2001 continue

      do 2012 i=1,n
      core(inddyy(icontr(i),1))=core(inddyy(icontr(i),1))-ppcond(i,1)
      core(inddyy(icontr(i),4))=core(inddyy(icontr(i),4))-ppcond(i,4)
      core(inddyy(icontr(i),5))=core(inddyy(icontr(i),5))-ppcond(i,5)
      core(inddyy(icontr(i),7))=core(inddyy(icontr(i),7))-ppcond(i,7)
      core(inddyy(icontr(i),8))=core(inddyy(icontr(i),8))-ppcond(i,8)
 2012 core(inddyy(icontr(i),9))=core(inddyy(icontr(i),9))-ppcond(i,9)

      do 2013 i=1,n
      if(iminj(icontr(i)).ne.0) then

               core(inddyy(icontr(i),2))=core(inddyy(icontr(i),2))
     &                                  -ppcond(i,2)
               core(inddyy(icontr(i),3))=core(inddyy(icontr(i),3))
     &                                  -ppcond(i,3)
               core(inddyy(icontr(i),6))=core(inddyy(icontr(i),6))
     &                                  -ppcond(i,6)

                        endif
 2013 continue

      return
      end

      subroutine chrgds(m,n,ncds,ncdspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,g,coord,cdfitc,alphaaux,coeffs,
     &                  coeffp,coeffd,fock,zeta,px,py,pz,base,pxax,pyay,
     &                  pzaz,u,zetarec,wxcx,wycy,wzcz,wxpx,wypy,wzpz,
     &                  sss0,sss1,sss2,sss3,sss4,pss0,pss1,pss2,pss3,
     &                  dss,dss0,dss1,dss2,psp1,dsp,dsp0,dsp1,dsd,dsd0,
     &                  zetac1,zetac2,c,c1,c2,c3,zzeta,ppx,ppy,ppz,
     &                  ppxax,ppyay,ppzaz,gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cdfitp(3),cdfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(m,*),
     &          iloc(*)

      dimension g(*),coord(3,*),cdfitc(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),fock(*),zeta(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),u(*),zetarec(*),wxcx(*),
     &          wycy(*),wzcz(*),wxpx(*),wypy(*),wzpz(*),sss0(*),sss1(*),
     &          sss2(*),sss3(*),sss4(*),pss0(n,*),pss1(n,*),pss2(n,*),
     &          pss3(n,*),dss(m,*),dss0(n,*),dss1(n,*),dss2(n,*),
     &          psp1(n,*),dsp(m,*),dsp0(n,*),dsp1(n,*),dsd(m,*),
     &          dsd0(n,*),zetac1(*),zetac2(*),c(*),c1(n,*),c2(n,*),
     &          c3(n,*),zzeta(*),ppx(*),ppy(*),ppz(*),ppxax(*),ppyay(*),
     &          ppzaz(*),gather(n,*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,seven/4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 j=1,6
      do 1001 i=1,n
 1001 gather(i,j)=zero

      do 1002 naux=1,ncds

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1003 i=1,n
 1003 zetarec(i)=one/(zeta(i)+zetaux)

      do 1004 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1004 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(3,n,iloc,u,psp1,ppx,ppy,ppz)

      do 1005 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,2)/zeta(i)/zetaux
 1005 sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,3)/zeta(i)/zetaux

      nn=0

      do 1006 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iloc(nn)=i

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                 endif
 1006 continue

      do 1007 i=1,nn
 1007 zetac1(i)=zetaux*zetarec(i)

      do 1008 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1008 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1009 i=1,nn

      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

 1009 continue

      do 1010 i=1,nn

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

 1010 continue

      do 1011 j=1,6
cfpp$ nodepchk
      do 1011 i=1,nn
 1011 gather(iloc(i),j)=gather(iloc(i),j)+dss0(i,j)*cdfits

 1002 continue

      do 2001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(ncds+(naux-1)*10+1)*coeffs(ilaux)

      cdfitp(1)=cdfitc(ncds+(naux-1)*10+2)*coeffp(ilaux)
      cdfitp(2)=cdfitc(ncds+(naux-1)*10+3)*coeffp(ilaux)
      cdfitp(3)=cdfitc(ncds+(naux-1)*10+4)*coeffp(ilaux)

      cdfitd(1)=cdfitc(ncds+(naux-1)*10+05)*coeffd(ilaux)/dnormcd
      cdfitd(2)=cdfitc(ncds+(naux-1)*10+06)*coeffd(ilaux)
      cdfitd(3)=cdfitc(ncds+(naux-1)*10+07)*coeffd(ilaux)
      cdfitd(4)=cdfitc(ncds+(naux-1)*10+08)*coeffd(ilaux)/dnormcd
      cdfitd(5)=cdfitc(ncds+(naux-1)*10+09)*coeffd(ilaux)
      cdfitd(6)=cdfitc(ncds+(naux-1)*10+10)*coeffd(ilaux)/dnormcd

      do 2002 i=1,n
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 2003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(5,n,iloc,u,psp1,ppx,ppy,ppz)

      do 2004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,4)/zeta(i)/zetaux
 2004 sss4(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp1(i,5)/zeta(i)/zetaux

      nn=0

      do 2005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iloc(nn)=i

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                       sss4(nn)=sss4(i)
                                 endif
 2005 continue

      do 2006 i=1,nn
      zetac1(i)=zetaux*zetarec(i)
 2006 zetac2(i)=zzeta(i)*zetarec(i)

      do 2007 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 2007 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 2008 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 2008 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 2009 i=1,nn

      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
      pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      pss3(i,1)=ppxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=ppyay(i)*sss3(i)+wypy(i)*sss4(i)
      pss3(i,3)=ppzaz(i)*sss3(i)+wzpz(i)*sss4(i)

 2009 continue

      do 2010 i=1,nn

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
      dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zzeta(i))

      dss2(i,1)=ppxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=ppyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=ppzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=ppyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=ppzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
      dss2(i,6)=ppzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

 2010 continue

      do 2011 i=1,nn

      c(i)=half*sss2(i)*zetarec(i)

      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
      psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

 2011 continue

      do 2012 j=1,3
      do 2012 i=1,nn
 2012 c1(i,j)=half*pss1(i,j)*zetarec(i)

      do 2013 i=1,nn
      dsp0(i,01)=wxcx(i)*dss1(i,1)+c1(i,1)*two
      dsp0(i,02)=wycy(i)*dss1(i,1)
      dsp0(i,03)=wzcz(i)*dss1(i,1)
      dsp0(i,04)=wxcx(i)*dss1(i,2)+c1(i,2)
      dsp0(i,05)=wycy(i)*dss1(i,2)+c1(i,1)
      dsp0(i,06)=wzcz(i)*dss1(i,2)
      dsp0(i,07)=wxcx(i)*dss1(i,3)+c1(i,3)
      dsp0(i,08)=wycy(i)*dss1(i,3)
      dsp0(i,09)=wzcz(i)*dss1(i,3)+c1(i,1)
      dsp0(i,10)=wxcx(i)*dss1(i,4)
      dsp0(i,11)=wycy(i)*dss1(i,4)+c1(i,2)*two
      dsp0(i,12)=wzcz(i)*dss1(i,4)
      dsp0(i,13)=wxcx(i)*dss1(i,5)
      dsp0(i,14)=wycy(i)*dss1(i,5)+c1(i,3)
      dsp0(i,15)=wzcz(i)*dss1(i,5)+c1(i,2)
      dsp0(i,16)=wxcx(i)*dss1(i,6)
      dsp0(i,17)=wycy(i)*dss1(i,6)
 2013 dsp0(i,18)=wzcz(i)*dss1(i,6)+c1(i,3)*two

      do 2014 j=1,3
      do 2014 i=1,nn
 2014 c1(i,j)=half*pss2(i,j)*zetarec(i)

      do 2015 i=1,nn
      dsp1(i,01)=wxcx(i)*dss2(i,1)+c1(i,1)*two
      dsp1(i,02)=wycy(i)*dss2(i,1)
      dsp1(i,03)=wzcz(i)*dss2(i,1)
      dsp1(i,04)=wxcx(i)*dss2(i,2)+c1(i,2)
      dsp1(i,05)=wycy(i)*dss2(i,2)+c1(i,1)
      dsp1(i,06)=wzcz(i)*dss2(i,2)
      dsp1(i,07)=wxcx(i)*dss2(i,3)+c1(i,3)
      dsp1(i,08)=wycy(i)*dss2(i,3)
      dsp1(i,09)=wzcz(i)*dss2(i,3)+c1(i,1)
      dsp1(i,10)=wxcx(i)*dss2(i,4)
      dsp1(i,11)=wycy(i)*dss2(i,4)+c1(i,2)*two
      dsp1(i,12)=wzcz(i)*dss2(i,4)
      dsp1(i,13)=wxcx(i)*dss2(i,5)
      dsp1(i,14)=wycy(i)*dss2(i,5)+c1(i,3)
      dsp1(i,15)=wzcz(i)*dss2(i,5)+c1(i,2)
      dsp1(i,16)=wxcx(i)*dss2(i,6)
      dsp1(i,17)=wycy(i)*dss2(i,6)
 2015 dsp1(i,18)=wzcz(i)*dss2(i,6)+c1(i,3)*two

      do 2016 j=1,6
      do 2016 i=1,nn
 2016 c2(i,j)=(dss0(i,j)-zetac2(i)*dss1(i,j))/(two*zetaux)

      do 2017 j=1,9
      do 2017 i=1,nn
 2017 c3(i,j)=half*psp1(i,j)*zetarec(i)

      do 2018 i=1,nn
      dsd0(i,01)=wxcx(i)*dsp1(i,01)+c2(i,1)+c3(i,1)*two
      dsd0(i,02)=wycy(i)*dsp1(i,01)
      dsd0(i,03)=wzcz(i)*dsp1(i,01)
      dsd0(i,04)=wycy(i)*dsp1(i,02)+c2(i,1)
      dsd0(i,05)=wzcz(i)*dsp1(i,02)
      dsd0(i,06)=wzcz(i)*dsp1(i,03)+c2(i,1)
      dsd0(i,07)=wxcx(i)*dsp1(i,04)+c2(i,2)+c3(i,4)
      dsd0(i,08)=wycy(i)*dsp1(i,04)        +c3(i,1)
      dsd0(i,09)=wzcz(i)*dsp1(i,04)
      dsd0(i,10)=wycy(i)*dsp1(i,05)+c2(i,2)+c3(i,2)
      dsd0(i,11)=wzcz(i)*dsp1(i,05)
      dsd0(i,12)=wzcz(i)*dsp1(i,06)+c2(i,2)
      dsd0(i,13)=wxcx(i)*dsp1(i,07)+c2(i,3)+c3(i,7)
      dsd0(i,14)=wycy(i)*dsp1(i,07)
      dsd0(i,15)=wzcz(i)*dsp1(i,07)        +c3(i,1)
      dsd0(i,16)=wycy(i)*dsp1(i,08)+c2(i,3)
      dsd0(i,17)=wzcz(i)*dsp1(i,08)        +c3(i,2)
      dsd0(i,18)=wzcz(i)*dsp1(i,09)+c2(i,3)+c3(i,3)
      dsd0(i,19)=wxcx(i)*dsp1(i,10)+c2(i,4)
      dsd0(i,20)=wycy(i)*dsp1(i,10)        +c3(i,4)*two
      dsd0(i,21)=wzcz(i)*dsp1(i,10)
      dsd0(i,22)=wycy(i)*dsp1(i,11)+c2(i,4)+c3(i,5)*two
      dsd0(i,23)=wzcz(i)*dsp1(i,11)
      dsd0(i,24)=wzcz(i)*dsp1(i,12)+c2(i,4)
      dsd0(i,25)=wxcx(i)*dsp1(i,13)+c2(i,5)
      dsd0(i,26)=wycy(i)*dsp1(i,13)        +c3(i,7)
      dsd0(i,27)=wzcz(i)*dsp1(i,13)        +c3(i,4)
      dsd0(i,28)=wycy(i)*dsp1(i,14)+c2(i,5)+c3(i,8)
      dsd0(i,29)=wzcz(i)*dsp1(i,14)        +c3(i,5)
      dsd0(i,30)=wzcz(i)*dsp1(i,15)+c2(i,5)+c3(i,6)
      dsd0(i,31)=wxcx(i)*dsp1(i,16)+c2(i,6)
      dsd0(i,32)=wycy(i)*dsp1(i,16)
      dsd0(i,33)=wzcz(i)*dsp1(i,16)        +c3(i,7)*two
      dsd0(i,34)=wycy(i)*dsp1(i,17)+c2(i,6)
      dsd0(i,35)=wzcz(i)*dsp1(i,17)        +c3(i,8)*two
 2018 dsd0(i,36)=wzcz(i)*dsp1(i,18)+c2(i,6)+c3(i,9)*two

      do 2019 j=1,6
cfpp$ nodepchk
      do 2019 i=1,nn
 2019 gather(iloc(i),j)=gather(iloc(i),j)
     &                 +dss0(i,j)*cdfits
     &                 +dsp0(i,3*(j-1)+1)*cdfitp(1)
     &                 +dsp0(i,3*(j-1)+2)*cdfitp(2)
     &                 +dsp0(i,3*(j-1)+3)*cdfitp(3)
     &                 +dsd0(i,6*(j-1)+1)*cdfitd(1)
     &                 +dsd0(i,6*(j-1)+2)*cdfitd(2)
     &                 +dsd0(i,6*(j-1)+3)*cdfitd(3)
     &                 +dsd0(i,6*(j-1)+4)*cdfitd(4)
     &                 +dsd0(i,6*(j-1)+5)*cdfitd(5)
     &                 +dsd0(i,6*(j-1)+6)*cdfitd(6)

 2001 continue

      do 1012 i=1,n
cfpp$ nodepchk
      do 1012 j=1,6
 1012 fock(inddyy(icontr(i),j))=fock(inddyy(icontr(i),j))+gather(i,j)

      do 3001 i=1,n
 3001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      return
      end

      subroutine boys_loc(n,ndim,nocc,coeff,x_moment,y_moment,z_moment,
     &                    veci,vecj,wkmat,centroid)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension coeff(ndim,*),x_moment(n,*),y_moment(n,*),z_moment(n,*),
     &          veci(*),vecj(*),wkmat(n,*),centroid(3,*)

      data nmaxloop/200/
      data zero,quarter,one/0.0d0,0.25d0,1.0d0/
      data pi,tol/3.1415926535898d0,0.00000001d0/

      dvalue=pi

      do 1001 j=1,n
      do 1001 i=1,n
      wkmat(i,j)=zero
      do 1001 k=1,n
 1001 wkmat(i,j)=wkmat(i,j)+coeff(k,j)*x_moment(k,i)

      do 1002 j=1,n
      do 1002 i=1,n
 1002 x_moment(i,j)=wkmat(i,j)

      do 1003 j=1,n
      do 1003 i=1,n
      wkmat(i,j)=zero
      do 1003 k=1,n
 1003 wkmat(i,j)=wkmat(i,j)+coeff(k,j)*y_moment(k,i)

      do 1004 j=1,n
      do 1004 i=1,n
 1004 y_moment(i,j)=wkmat(i,j)

      do 1005 j=1,n
      do 1005 i=1,n
      wkmat(i,j)=zero
      do 1005 k=1,n
 1005 wkmat(i,j)=wkmat(i,j)+coeff(k,j)*z_moment(k,i)

      do 1006 j=1,n
      do 1006 i=1,n
 1006 z_moment(i,j)=wkmat(i,j)

      do 1007 iloop=1,nmaxloop

      dvalue_save=dvalue

      dvalue=zero

      do 1008 i=1,nocc

      x_rii=zero
      y_rii=zero
      z_rii=zero

      do 1009 jj=1,n
      x_rii=x_rii+coeff(jj,i)*x_moment(jj,i)
      y_rii=y_rii+coeff(jj,i)*y_moment(jj,i)
 1009 z_rii=z_rii+coeff(jj,i)*z_moment(jj,i)

 1008 dvalue=dvalue+(x_rii*x_rii+y_rii*y_rii+z_rii*z_rii)

      if(abs(dvalue-dvalue_save).lt.tol) goto 1030

      do 1010 i=1,nocc
      do 1010 j=1,i

      if(i.eq.j) goto 1010

      x_rii=zero
      y_rii=zero
      z_rii=zero

      do 1011 jj=1,n
      x_rii=x_rii+coeff(jj,i)*x_moment(jj,i)
      y_rii=y_rii+coeff(jj,i)*y_moment(jj,i)
 1011 z_rii=z_rii+coeff(jj,i)*z_moment(jj,i)

      x_rjj=zero
      y_rjj=zero
      z_rjj=zero

      do 1012 jj=1,n
      x_rjj=x_rjj+coeff(jj,j)*x_moment(jj,j)
      y_rjj=y_rjj+coeff(jj,j)*y_moment(jj,j)
 1012 z_rjj=z_rjj+coeff(jj,j)*z_moment(jj,j)

      x_rij=zero
      y_rij=zero
      z_rij=zero

      do 1013 jj=1,n
      x_rij=x_rij+coeff(jj,j)*x_moment(jj,i)
      y_rij=y_rij+coeff(jj,j)*y_moment(jj,i)
 1013 z_rij=z_rij+coeff(jj,j)*z_moment(jj,i)

      aij=x_rij*x_rij
     &   +y_rij*y_rij
     &   +z_rij*z_rij
     &   -quarter*((x_rii-x_rjj)*(x_rii-x_rjj))
     &   -quarter*((y_rii-y_rjj)*(y_rii-y_rjj))
     &   -quarter*((z_rii-z_rjj)*(z_rii-z_rjj))

      bij=(x_rii-x_rjj)*x_rij
     &   +(y_rii-y_rjj)*y_rij
     &   +(z_rii-z_rjj)*z_rij

      factor=aij/(sqrt(aij**2+bij**2))

      if(abs(factor).gt.one) factor=one*factor/abs(factor)

      gamma=quarter*acos(-factor)

      if(bij.lt.zero) gamma=-gamma

      if(abs(gamma).gt.abs(quarter*pi)) stop 'boys localization'

      a=cos(gamma)
      b=sin(gamma)

      do 1014 ii=1,n
 1014 veci(ii)=coeff(ii,i)

      do 1015 ii=1,n
 1015 vecj(ii)=coeff(ii,j)

      do 1016 ii=1,n
 1016 coeff(ii,i)=a*veci(ii)+b*vecj(ii)

      do 1017 ii=1,n
 1017 coeff(ii,j)=a*vecj(ii)-b*veci(ii)

      do 1018 ii=1,n
 1018 veci(ii)=x_moment(ii,i)

      do 1019 ii=1,n
 1019 vecj(ii)=x_moment(ii,j)

      do 1020 ii=1,n
 1020 x_moment(ii,i)=a*veci(ii)+b*vecj(ii)

      do 1021 ii=1,n
 1021 x_moment(ii,j)=a*vecj(ii)-b*veci(ii)

      do 1022 ii=1,n
 1022 veci(ii)=y_moment(ii,i)

      do 1023 ii=1,n
 1023 vecj(ii)=y_moment(ii,j)

      do 1024 ii=1,n
 1024 y_moment(ii,i)=a*veci(ii)+b*vecj(ii)

      do 1025 ii=1,n
 1025 y_moment(ii,j)=a*vecj(ii)-b*veci(ii)

      do 1026 ii=1,n
 1026 veci(ii)=z_moment(ii,i)

      do 1027 ii=1,n
 1027 vecj(ii)=z_moment(ii,j)

      do 1028 ii=1,n
 1028 z_moment(ii,i)=a*veci(ii)+b*vecj(ii)

      do 1029 ii=1,n
 1029 z_moment(ii,j)=a*vecj(ii)-b*veci(ii)

 1010 continue

 1007 if(iloop.eq.nmaxloop) stop 'problem localizing orbitals'

 1030 continue

      write(6,1031)
 1031 format(//)

      do 1032 i=1,nocc

      x_rii=zero
      y_rii=zero
      z_rii=zero

      do 1033 jj=1,n
      x_rii=x_rii+coeff(jj,i)*x_moment(jj,i)
      y_rii=y_rii+coeff(jj,i)*y_moment(jj,i)
 1033 z_rii=z_rii+coeff(jj,i)*z_moment(jj,i)

      centroid(1,i)=x_rii
      centroid(2,i)=y_rii
      centroid(3,i)=z_rii

 1032 continue

      return
      end

      subroutine docdfit(ndim,ncds,ncdspd,ilfunc,dnorm,alpha,coeffs,
     &                   coeffd,cdfit,tvector,sinverse,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*)

      dimension alpha(*),coeffs(*),coeffd(*)
      dimension cdfit(*),tvector(*),sinverse(ndim,*),wkvec(*)

      data zero,one,two,three,fortynine/0.0d0,1.0d0,2.0d0,3.0d0,49.0d0/
      data pi/3.1415926535898d0/

      ncoeffs=ncds+10*ncdspd

      do 1001 i=1,ncds
 1001 wkvec(i)=((pi/alpha(ilfunc(i)))**(three/two))*coeffs(ilfunc(i))

      do 1002 i=1,ncdspd

      val1=((pi/alpha(ilfunc(ncds+i)))**(three/two))
     &    *coeffs(ilfunc(ncds+i))

      val2=((pi/alpha(ilfunc(ncds+i)))**(three/two))
     &    *coeffd(ilfunc(ncds+i))/(two*alpha(ilfunc(ncds+i)))

      wkvec(ncds+10*(i-1)+01)=val1
      wkvec(ncds+10*(i-1)+02)=zero
      wkvec(ncds+10*(i-1)+03)=zero
      wkvec(ncds+10*(i-1)+04)=zero
      wkvec(ncds+10*(i-1)+05)=val2/sqrt(fortynine/three)
      wkvec(ncds+10*(i-1)+06)=zero
      wkvec(ncds+10*(i-1)+07)=zero
      wkvec(ncds+10*(i-1)+08)=val2/sqrt(fortynine/three)
      wkvec(ncds+10*(i-1)+09)=zero
      wkvec(ncds+10*(i-1)+10)=val2/sqrt(fortynine/three)

 1002 continue

      do 1003 i=1,ncoeffs
 1003 call fastrd(18,sinverse(1,i),ncoeffs)

      val1=dnorm
      val2=zero

      do 1004 i=1,ncoeffs
 1004 val1=val1-wkvec(i)*dot(ncoeffs,sinverse(1,i),tvector)

      do 1005 i=1,ncoeffs
 1005 val2=val2+wkvec(i)*dot(ncoeffs,sinverse(1,i),wkvec)

      do 1006 i=1,ncoeffs
 1006 tvector(i)=tvector(i)+val1*wkvec(i)/val2

      do 1007 i=1,ncoeffs
 1007 cdfit(i)=dot(ncoeffs,sinverse(1,i),tvector)

      return
      end

      subroutine mulliken(n,natoms,nconts,ncontp,ncontd,nshels,nshelp,
     &                    nsheld,icfunc,nfuncatom,natomtype,overlap,
     &                    dmta,dmtb,pmat,smat,pstmat,pssmat,pop)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),nfuncatom(*),icfunc(*),
     &          natomtype(*)

      dimension overlap(*),dmta(*),dmtb(*)

      dimension pmat(n,*),smat(n,*),pstmat(n,*),pssmat(n,*),pop(*)

      data zero,half,one/0.0d0,0.5d0,1.0d0/

      ij=0

      do 1001 i=1,n
      do 1001 j=1,i
      ij=ij+1
      factor=half
      if(i.eq.j) factor=one
      pmat(i,j)=(dmta(ij)+dmtb(ij))*factor
 1001 pmat(j,i)=(dmta(ij)+dmtb(ij))*factor

      ij=0

      do 1002 i=1,n
      do 1002 j=1,i
      ij=ij+1
      smat(i,j)=overlap(ij)
 1002 smat(j,i)=overlap(ij)

      do 1003 j=1,n
      do 1004 i=1,n
 1004 pstmat(i,j)=zero
      do 1003 k=1,n
      do 1003 i=1,n
 1003 pstmat(i,j)=pstmat(i,j)+pmat(i,k)*smat(k,j)

      do 1005 i=1,n
      do 1005 j=1,i
      ij=ij+1
      factor=half
      if(i.eq.j) factor=one
      pmat(i,j)=(dmta(ij)-dmtb(ij))*factor
 1005 pmat(j,i)=(dmta(ij)-dmtb(ij))*factor

      do 1006 j=1,n
      do 1007 i=1,n
 1007 pssmat(i,j)=zero
      do 1006 k=1,n
      do 1006 i=1,n
 1006 pssmat(i,j)=pssmat(i,j)+pmat(i,k)*smat(k,j)

      ii=0

      do 1008 i=1,nconts
      nfuncatom(ii+1)=icfunc(nshels(i))
 1008 ii=ii+1

      do 1009 i=1,ncontp
      do 1010 k=1,3
 1010 nfuncatom(ii+k)=icfunc(nshelp(i))
 1009 ii=ii+3

      do 1011 i=1,ncontd
      do 1012 k=1,6
 1012 nfuncatom(ii+k)=icfunc(nsheld(i))
 1011 ii=ii+6

      write(6,1013)
 1013 format(//,' mulliken population analysis :',/)

      do 1014 i=1,natoms

      pop(i)=zero

      do 1015 j=1,n
 1015 if(nfuncatom(j).eq.i) pop(i)=pop(i)+pstmat(j,j)

      write(6,1016) i,real64(natomtype(i))-pop(i)
 1016 format(5x,' atom # ',i4,'       charge = ',f8.4)

 1014 continue

      write(6,1017)
 1017 format(//,' mayer bond order analysis :',/)

      do 1018 i=1,natoms
      do 1018 j=i,natoms

      if(i.eq.j) goto 1018

      bond=zero

      do 1019 k=1,n
      do 1019 l=1,n
 1019 if((nfuncatom(k).eq.i).and.
     &   (nfuncatom(l).eq.j)) bond=bond+pstmat(k,l)*pstmat(l,k)
     &                                 -pssmat(k,l)*pssmat(l,k)

      write(6,1020) i,j,bond
 1020 format(5x,' atoms # ',i4,' and ',i4,'       bond order = ',f8.4)

 1018 continue

      write(6,1021)
 1021 format(//,' mayer valence indices :',/)

      do 1022 i=1,natoms

      valence=pop(i)+pop(i)

      do 1023 j=1,n
      do 1023 k=1,n
 1023 if((nfuncatom(j).eq.i).and.
     &   (nfuncatom(k).eq.i)) valence=valence-pstmat(j,k)*pstmat(k,j)

      write(6,1024) i,valence
 1024 format(5x,' atom # ',i4,'       valence = ',f8.4)

 1022 continue

      return
      end

      subroutine pulayforce(ndim1,ndim2,natoms,nalpha,nbeta,nconts,
     &                      ncontp,ncontd,icfunc,matloc,nptrs,nptrp,
     &                      nptrd,gradient,density,dsbydx,coeffa,coeffb,
     &                      orbnrgy,wkvec,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension indexx(36)

      dimension subgrad(3)

      dimension icfunc(*),matloc(*),nptrs(*),nptrp(*),nptrd(*)

      dimension gradient(3,*),density(*),dsbydx(ndim2,*)
      dimension coeffa(ndim1,*),coeffb(ndim1,*),orbnrgy(nalpha,*)
      dimension wkvec(*),grad(3,*)

      data zero,two/0.0d0,2.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ncontractions=nconts+3*ncontp+6*ncontd

      do 1001 i=1,natoms
      do 1001 j=1,3
 1001 grad(j,i)=zero

      do 1002 i=1,ndim2
 1002 density(i)=zero

      if(myid.eq.0) then
                          rewind 51

                          do 1003 i=1,nalpha
 1003                     call fastrd(51,orbnrgy(1,i),nalpha)
                    endif

      call mpi_bcast(orbnrgy,nalpha*nalpha,
     &               mpi_real8,0,mpi_comm_world,ierr)

      nloop=ncontractions/numprocs

      if((nloop*numprocs).lt.ncontractions) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      do 1004 i=istart,iend
      do 1004 j=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
      do 1004 k=1,nalpha
      do 1004 l=1,nalpha
 1004 density(ij)=density(ij)+orbnrgy(l,k)*coeffa(i,k)*coeffa(j,l)

      if(nalpha.eq.nbeta) then

            do 1005 i=1,ncontractions*(ncontractions+1)/2
 1005       density(i)=two*density(i)

                          else

                  if(myid.eq.0) then
                                      do 1006 i=1,nbeta
 1006                                 call fastrd(51,orbnrgy(1,i),nbeta)
                                endif

            call mpi_bcast(orbnrgy,nalpha*nalpha,
     &                     mpi_real8,0,mpi_comm_world,ierr)

            do 1007 i=istart,iend
            do 1007 j=1,ncontractions
            ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
            do 1007 k=1,nbeta
            do 1007 l=1,nbeta
 1007       density(ij)=density(ij)+orbnrgy(l,k)*coeffb(i,k)*coeffb(j,l)

                          endif

      call mpi_reduce(density,wkvec,ndim2,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      call mpi_bcast(wkvec,ndim2,mpi_real8,0,mpi_comm_world,ierr)

      ncombos=(nconts*(nconts+1))/2

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1008 iii=1,nconts
      do 1008 jjj=1,iii

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1008

      ii=nptrs(iii)
      jj=nptrs(jjj)

      if(icfunc(ii).eq.icfunc(jj)) goto 1008

      i1=matloc(ii)
      i2=(i1*(i1-1))/2
      i3=matloc(jj)
      i4=i2+i3

      do 1009 i=1,3
 1009 subgrad(i)=zero

      do 1010 i=1,3
 1010 subgrad(i)=subgrad(i)+dsbydx(i4,i)*wkvec(i4)

      do 1011 i=1,3
      grad(i,icfunc(ii))=grad(i,icfunc(ii))-subgrad(i)
 1011 grad(i,icfunc(jj))=grad(i,icfunc(jj))+subgrad(i)

 1008 continue

      ncombos=nconts*ncontp

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1012 iii=1,ncontp
      do 1012 jjj=1,nconts

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1012

      ii=nptrp(iii)
      jj=nptrs(jjj)

      if(icfunc(ii).eq.icfunc(jj)) goto 1012

      i1=matloc(ii)
      i2=(i1*(i1-1))/2
      i3=matloc(jj)
      i4=i2+i3

      indexx(1)=i4
      indexx(2)=i4+i1
      indexx(3)=i4+i1*2+1

      do 1013 i=1,3
 1013 subgrad(i)=zero

      do 1014 i=1,3
      do 1014 j=1,3
 1014 subgrad(i)=subgrad(i)+dsbydx(indexx(j),i)*wkvec(indexx(j))

      do 1015 i=1,3
      grad(i,icfunc(ii))=grad(i,icfunc(ii))-subgrad(i)
 1015 grad(i,icfunc(jj))=grad(i,icfunc(jj))+subgrad(i)

 1012 continue

      ncombos=(ncontp*(ncontp+1))/2

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1016 iii=1,ncontp
      do 1016 jjj=1,iii

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1016

      ii=nptrp(iii)
      jj=nptrp(jjj)

      if(icfunc(ii).eq.icfunc(jj)) goto 1016

      i1=matloc(ii)
      i2=(i1*(i1-1))/2
      i3=matloc(jj)
      i4=i2+i3

      indexx(1)=i4
      indexx(2)=i4+1
      indexx(3)=i4+2
      indexx(4)=i4+i1
      indexx(5)=i4+i1+1
      indexx(6)=i4+i1+2
      indexx(7)=i4+i1*2+1
      indexx(8)=i4+i1*2+2
      indexx(9)=i4+i1*2+3

      do 1017 i=1,3
 1017 subgrad(i)=zero

      do 1018 i=1,3
      do 1018 j=1,9
 1018 subgrad(i)=subgrad(i)+dsbydx(indexx(j),i)*wkvec(indexx(j))

      do 1019 i=1,3
      grad(i,icfunc(ii))=grad(i,icfunc(ii))-subgrad(i)
 1019 grad(i,icfunc(jj))=grad(i,icfunc(jj))+subgrad(i)

 1016 continue

      ncombos=nconts*ncontd

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1020 iii=1,ncontd
      do 1020 jjj=1,nconts

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1020

      ii=nptrd(iii)
      jj=nptrs(jjj)

      if(icfunc(ii).eq.icfunc(jj)) goto 1020

      i1=matloc(ii)
      i2=(i1*(i1-1))/2
      i3=matloc(jj)
      i4=i2+i3

      indexx(1)=i4
      indexx(2)=i4+i1
      indexx(3)=i4+i1*2+1
      indexx(4)=i4+i1*3+3
      indexx(5)=i4+i1*4+6
      indexx(6)=i4+i1*5+10

      do 1021 i=1,3
 1021 subgrad(i)=zero

      do 1022 i=1,3
      do 1022 j=1,6
 1022 subgrad(i)=subgrad(i)+dsbydx(indexx(j),i)*wkvec(indexx(j))

      do 1023 i=1,3
      grad(i,icfunc(ii))=grad(i,icfunc(ii))-subgrad(i)
 1023 grad(i,icfunc(jj))=grad(i,icfunc(jj))+subgrad(i)

 1020 continue

      ncombos=ncontp*ncontd

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1024 iii=1,ncontd
      do 1024 jjj=1,ncontp

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1024

      ii=nptrd(iii)
      jj=nptrp(jjj)

      if(icfunc(ii).eq.icfunc(jj)) goto 1024

      i1=matloc(ii)
      i2=(i1*(i1-1))/2
      i3=matloc(jj)
      i4=i2+i3

      indexx(01)=i4
      indexx(02)=i4+1
      indexx(03)=i4+2
      indexx(04)=i4+i1
      indexx(05)=i4+i1+1
      indexx(06)=i4+i1+2
      indexx(07)=i4+i1*2+1
      indexx(08)=i4+i1*2+2
      indexx(09)=i4+i1*2+3
      indexx(10)=i4+i1*3+3
      indexx(11)=i4+i1*3+4
      indexx(12)=i4+i1*3+5
      indexx(13)=i4+i1*4+6
      indexx(14)=i4+i1*4+7
      indexx(15)=i4+i1*4+8
      indexx(16)=i4+i1*5+10
      indexx(17)=i4+i1*5+11
      indexx(18)=i4+i1*5+12

      do 1025 i=1,3
 1025 subgrad(i)=zero

      do 1026 i=1,3
      do 1026 j=1,18
 1026 subgrad(i)=subgrad(i)+dsbydx(indexx(j),i)*wkvec(indexx(j))

      do 1027 i=1,3
      grad(i,icfunc(ii))=grad(i,icfunc(ii))-subgrad(i)
 1027 grad(i,icfunc(jj))=grad(i,icfunc(jj))+subgrad(i)

 1024 continue

      ncombos=(ncontd*(ncontd+1))/2

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1028 iii=1,ncontd
      do 1028 jjj=1,iii

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1028

      ii=nptrd(iii)
      jj=nptrd(jjj)

      if(icfunc(ii).eq.icfunc(jj)) goto 1028

      i1=matloc(ii)
      i2=(i1*(i1-1))/2
      i3=matloc(jj)
      i4=i2+i3

      indexx(01)=i4
      indexx(02)=i4+1
      indexx(03)=i4+2
      indexx(04)=i4+3
      indexx(05)=i4+4
      indexx(06)=i4+5
      indexx(07)=i4+i1
      indexx(08)=i4+i1+1
      indexx(09)=i4+i1+2
      indexx(10)=i4+i1+3
      indexx(11)=i4+i1+4
      indexx(12)=i4+i1+5
      indexx(13)=i4+i1*2+1
      indexx(14)=i4+i1*2+2
      indexx(15)=i4+i1*2+3
      indexx(16)=i4+i1*2+4
      indexx(17)=i4+i1*2+5
      indexx(18)=i4+i1*2+6
      indexx(19)=i4+i1*3+3
      indexx(20)=i4+i1*3+4
      indexx(21)=i4+i1*3+5
      indexx(22)=i4+i1*3+6
      indexx(23)=i4+i1*3+7
      indexx(24)=i4+i1*3+8
      indexx(25)=i4+i1*4+6
      indexx(26)=i4+i1*4+7
      indexx(27)=i4+i1*4+8
      indexx(28)=i4+i1*4+9
      indexx(29)=i4+i1*4+10
      indexx(30)=i4+i1*4+11
      indexx(31)=i4+i1*5+10
      indexx(32)=i4+i1*5+11
      indexx(33)=i4+i1*5+12
      indexx(34)=i4+i1*5+13
      indexx(35)=i4+i1*5+14
      indexx(36)=i4+i1*5+15

      do 1029 i=1,3
 1029 subgrad(i)=zero

      do 1030 i=1,3
      do 1030 j=1,36
 1030 subgrad(i)=subgrad(i)+dsbydx(indexx(j),i)*wkvec(indexx(j))

      do 1031 i=1,3
      grad(i,icfunc(ii))=grad(i,icfunc(ii))-subgrad(i)
 1031 grad(i,icfunc(jj))=grad(i,icfunc(jj))+subgrad(i)

 1028 continue

      call mpi_reduce(grad,wkvec,3*natoms,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1032 i=1,natoms
                          do 1032 j=1,3
 1032                     gradient(j,i)=gradient(j,i)+wkvec(3*(i-1)+j)
                    endif

      return
      end

      subroutine efidp(m,n,icontr,inddyy,esp,efix,efiy,efiz,ccx,ccy,ccz,
     &                 g,density,zeta,axbx,ayby,azbz,px,py,pz,pxax,pyay,
     &                 pzaz,base,ss0,ss1,ss2,ss3,ps0,ps1,ps2,dscond,ds0,
     &                 ds1,fscond,fs0,dpcond,c,c1,pxcx,pycy,pzcz,u,
     &                 twozeta,ss4,cx,cy,cz,cx1,cy1,cz1,saxs0,says0,
     &                 sazs0,saxs1,says1,sazs1,saxs2,says2,sazs2,saxs3,
     &                 says3,sazs3,paxs0,pays0,pazs0,paxs1,pays1,pazs1,
     &                 paxs2,pays2,pazs2,daxs0,days0,dazs0,daxs1,days1,
     &                 dazs1,faxs0,fays0,fazs0,daxscond,dayscond,
     &                 dazscond,daxpcond,daypcond,dazpcond,faxscond,
     &                 fayscond,fazscond)

c  this subroutine written by roger gallant and alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension g(*),density(*),zeta(*),axbx(*),ayby(*),azbz(*),px(*),
     &          py(*),pz(*),pxax(*),pyay(*),pzaz(*),base(*),ss0(*),
     &          ss1(*),ss2(*),ss3(*),ss4(*),ps0(n,*),ps1(n,*),ps2(n,*),
     &          dscond(m,*),ds0(n,*),ds1(n,*),fscond(m,*),fs0(n,*),
     &          dpcond(m,*),c(*),c1(n,*),pxcx(*),pycy(*),pzcz(*),u(*),
     &          twozeta(*),cx(*),cy(*),cz(*),cx1(n,*),cy1(n,*),cz1(n,*),
     &          saxs0(*),says0(*),sazs0(*),saxs1(*),says1(*),sazs1(*),
     &          saxs2(*),says2(*),sazs2(*),saxs3(*),says3(*),sazs3(*),
     &          paxs0(n,*),pays0(n,*),pazs0(n,*),paxs1(n,*),pays1(n,*),
     &          pazs1(n,*),paxs2(n,*),pays2(n,*),pazs2(n,*),daxs0(n,*),
     &          days0(n,*),dazs0(n,*),daxs1(n,*),days1(n,*),dazs1(n,*),
     &          faxs0(n,*),fays0(n,*),fazs0(n,*),daxscond(m,*),
     &          dayscond(m,*),dazscond(m,*),faxscond(m,*),fayscond(m,*),
     &          fazscond(m,*),daxpcond(m,*),daypcond(m,*),dazpcond(m,*)

      data zero,two,three,pi/0.0d0,2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      twopi=two*pi

      do 1002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1003 i=1,n
      call augg(5,u(i),g)
      ss0(i)=base(i)*g(1)*twopi/zeta(i)
      ss1(i)=base(i)*g(2)*twopi/zeta(i)
      ss2(i)=base(i)*g(3)*twopi/zeta(i)
      ss3(i)=base(i)*g(4)*twopi/zeta(i)
 1003 ss4(i)=base(i)*g(5)*twopi/zeta(i)

      do 1004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      ps2(i,1)=pxax(i)*ss2(i)-pxcx(i)*ss3(i)
      ps2(i,2)=pyay(i)*ss2(i)-pycy(i)*ss3(i)
      ps2(i,3)=pzaz(i)*ss2(i)-pzcz(i)*ss3(i)

 1004 continue

      do 1005 i=1,n
 1005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1007 i=1,n
 1007 c(i)=(ss1(i)-ss2(i))/twozeta(i)

      do 1008 i=1,n
      ds1(i,1)=pxax(i)*ps1(i,1)-pxcx(i)*ps2(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps1(i,1)-pycy(i)*ps2(i,1)
      ds1(i,3)=pzaz(i)*ps1(i,1)-pzcz(i)*ps2(i,1)
      ds1(i,4)=pyay(i)*ps1(i,2)-pycy(i)*ps2(i,2)+c(i)
      ds1(i,5)=pzaz(i)*ps1(i,2)-pzcz(i)*ps2(i,2)
 1008 ds1(i,6)=pzaz(i)*ps1(i,3)-pzcz(i)*ps2(i,3)+c(i)

      do 1009 j=1,3
      do 1009 i=1,n
 1009 c1(i,j)=(ps0(i,j)-ps1(i,j))/twozeta(i)

      do 1010 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)-pxcx(i)*ds1(i,1)+c1(i,1)*two
      fs0(i,02)=pyay(i)*ds0(i,1)-pycy(i)*ds1(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)-pzcz(i)*ds1(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)-pycy(i)*ds1(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)-pzcz(i)*ds1(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)-pzcz(i)*ds1(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)-pycy(i)*ds1(i,4)+c1(i,2)*two
      fs0(i,08)=pzaz(i)*ds0(i,4)-pzcz(i)*ds1(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)-pzcz(i)*ds1(i,5)+c1(i,2)
 1010 fs0(i,10)=pzaz(i)*ds0(i,6)-pzcz(i)*ds1(i,6)+c1(i,3)*two

      do 1011 i=1,n

      saxs0(i)=twozeta(i)*pxcx(i)*ss1(i)
      says0(i)=twozeta(i)*pycy(i)*ss1(i)
      sazs0(i)=twozeta(i)*pzcz(i)*ss1(i)

      saxs1(i)=twozeta(i)*pxcx(i)*ss2(i)
      says1(i)=twozeta(i)*pycy(i)*ss2(i)
      sazs1(i)=twozeta(i)*pzcz(i)*ss2(i)

      saxs2(i)=twozeta(i)*pxcx(i)*ss3(i)
      says2(i)=twozeta(i)*pycy(i)*ss3(i)
      sazs2(i)=twozeta(i)*pzcz(i)*ss3(i)

      saxs3(i)=twozeta(i)*pxcx(i)*ss4(i)
      says3(i)=twozeta(i)*pycy(i)*ss4(i)
      sazs3(i)=twozeta(i)*pzcz(i)*ss4(i)

 1011 continue

      do 1012 i=1,n

      paxs0(i,1)=pxax(i)*saxs0(i)-pxcx(i)*saxs1(i)+ss1(i)
      paxs0(i,2)=pyay(i)*saxs0(i)-pycy(i)*saxs1(i)
      paxs0(i,3)=pzaz(i)*saxs0(i)-pzcz(i)*saxs1(i)
      pays0(i,1)=pxax(i)*says0(i)-pxcx(i)*says1(i)
      pays0(i,2)=pyay(i)*says0(i)-pycy(i)*says1(i)+ss1(i)
      pays0(i,3)=pzaz(i)*says0(i)-pzcz(i)*says1(i)
      pazs0(i,1)=pxax(i)*sazs0(i)-pxcx(i)*sazs1(i)
      pazs0(i,2)=pyay(i)*sazs0(i)-pycy(i)*sazs1(i)
      pazs0(i,3)=pzaz(i)*sazs0(i)-pzcz(i)*sazs1(i)+ss1(i)

      paxs1(i,1)=pxax(i)*saxs1(i)-pxcx(i)*saxs2(i)+ss2(i)
      paxs1(i,2)=pyay(i)*saxs1(i)-pycy(i)*saxs2(i)
      paxs1(i,3)=pzaz(i)*saxs1(i)-pzcz(i)*saxs2(i)
      pays1(i,1)=pxax(i)*says1(i)-pxcx(i)*says2(i)
      pays1(i,2)=pyay(i)*says1(i)-pycy(i)*says2(i)+ss2(i)
      pays1(i,3)=pzaz(i)*says1(i)-pzcz(i)*says2(i)
      pazs1(i,1)=pxax(i)*sazs1(i)-pxcx(i)*sazs2(i)
      pazs1(i,2)=pyay(i)*sazs1(i)-pycy(i)*sazs2(i)
      pazs1(i,3)=pzaz(i)*sazs1(i)-pzcz(i)*sazs2(i)+ss2(i)

      paxs2(i,1)=pxax(i)*saxs2(i)-pxcx(i)*saxs3(i)+ss3(i)
      paxs2(i,2)=pyay(i)*saxs2(i)-pycy(i)*saxs3(i)
      paxs2(i,3)=pzaz(i)*saxs2(i)-pzcz(i)*saxs3(i)
      pays2(i,1)=pxax(i)*says2(i)-pxcx(i)*says3(i)
      pays2(i,2)=pyay(i)*says2(i)-pycy(i)*says3(i)+ss3(i)
      pays2(i,3)=pzaz(i)*says2(i)-pzcz(i)*says3(i)
      pazs2(i,1)=pxax(i)*sazs2(i)-pxcx(i)*sazs3(i)
      pazs2(i,2)=pyay(i)*sazs2(i)-pycy(i)*sazs3(i)
      pazs2(i,3)=pzaz(i)*sazs2(i)-pzcz(i)*sazs3(i)+ss3(i)

 1012 continue

      do 1013 i=1,n
      cx(i)=(saxs0(i)-saxs1(i))/twozeta(i)
      cy(i)=(says0(i)-says1(i))/twozeta(i)
 1013 cz(i)=(sazs0(i)-sazs1(i))/twozeta(i)

      do 1014 i=1,n
      daxs0(i,1)=pxax(i)*paxs0(i,1)-pxcx(i)*paxs1(i,1)+cx(i)+ps1(i,1)
      daxs0(i,2)=pyay(i)*paxs0(i,1)-pycy(i)*paxs1(i,1)
      daxs0(i,3)=pzaz(i)*paxs0(i,1)-pzcz(i)*paxs1(i,1)
      daxs0(i,4)=pyay(i)*paxs0(i,2)-pycy(i)*paxs1(i,2)+cx(i)
      daxs0(i,5)=pzaz(i)*paxs0(i,2)-pzcz(i)*paxs1(i,2)
      daxs0(i,6)=pzaz(i)*paxs0(i,3)-pzcz(i)*paxs1(i,3)+cx(i)
      days0(i,1)=pxax(i)*pays0(i,1)-pxcx(i)*pays1(i,1)+cy(i)
      days0(i,2)=pyay(i)*pays0(i,1)-pycy(i)*pays1(i,1)      +ps1(i,1)
      days0(i,3)=pzaz(i)*pays0(i,1)-pzcz(i)*pays1(i,1)
      days0(i,4)=pyay(i)*pays0(i,2)-pycy(i)*pays1(i,2)+cy(i)+ps1(i,2)
      days0(i,5)=pzaz(i)*pays0(i,2)-pzcz(i)*pays1(i,2)
      days0(i,6)=pzaz(i)*pays0(i,3)-pzcz(i)*pays1(i,3)+cy(i)
      dazs0(i,1)=pxax(i)*pazs0(i,1)-pxcx(i)*pazs1(i,1)+cz(i)
      dazs0(i,2)=pyay(i)*pazs0(i,1)-pycy(i)*pazs1(i,1)
      dazs0(i,3)=pzaz(i)*pazs0(i,1)-pzcz(i)*pazs1(i,1)      +ps1(i,1)
      dazs0(i,4)=pyay(i)*pazs0(i,2)-pycy(i)*pazs1(i,2)+cz(i)
      dazs0(i,5)=pzaz(i)*pazs0(i,2)-pzcz(i)*pazs1(i,2)      +ps1(i,2)
 1014 dazs0(i,6)=pzaz(i)*pazs0(i,3)-pzcz(i)*pazs1(i,3)+cz(i)+ps1(i,3)

      do 1015 i=1,n
      cx(i)=(saxs1(i)-saxs2(i))/twozeta(i)
      cy(i)=(says1(i)-says2(i))/twozeta(i)
 1015 cz(i)=(sazs1(i)-sazs2(i))/twozeta(i)

      do 1016 i=1,n
      daxs1(i,1)=pxax(i)*paxs1(i,1)-pxcx(i)*paxs2(i,1)+cx(i)+ps2(i,1)
      daxs1(i,2)=pyay(i)*paxs1(i,1)-pycy(i)*paxs2(i,1)
      daxs1(i,3)=pzaz(i)*paxs1(i,1)-pzcz(i)*paxs2(i,1)
      daxs1(i,4)=pyay(i)*paxs1(i,2)-pycy(i)*paxs2(i,2)+cx(i)
      daxs1(i,5)=pzaz(i)*paxs1(i,2)-pzcz(i)*paxs2(i,2)
      daxs1(i,6)=pzaz(i)*paxs1(i,3)-pzcz(i)*paxs2(i,3)+cx(i)
      days1(i,1)=pxax(i)*pays1(i,1)-pxcx(i)*pays2(i,1)+cy(i)
      days1(i,2)=pyay(i)*pays1(i,1)-pycy(i)*pays2(i,1)      +ps2(i,1)
      days1(i,3)=pzaz(i)*pays1(i,1)-pzcz(i)*pays2(i,1)
      days1(i,4)=pyay(i)*pays1(i,2)-pycy(i)*pays2(i,2)+cy(i)+ps2(i,2)
      days1(i,5)=pzaz(i)*pays1(i,2)-pzcz(i)*pays2(i,2)
      days1(i,6)=pzaz(i)*pays1(i,3)-pzcz(i)*pays2(i,3)+cy(i)
      dazs1(i,1)=pxax(i)*pazs1(i,1)-pxcx(i)*pazs2(i,1)+cz(i)
      dazs1(i,2)=pyay(i)*pazs1(i,1)-pycy(i)*pazs2(i,1)
      dazs1(i,3)=pzaz(i)*pazs1(i,1)-pzcz(i)*pazs2(i,1)      +ps2(i,1)
      dazs1(i,4)=pyay(i)*pazs1(i,2)-pycy(i)*pazs2(i,2)+cz(i)
      dazs1(i,5)=pzaz(i)*pazs1(i,2)-pzcz(i)*pazs2(i,2)      +ps2(i,2)
 1016 dazs1(i,6)=pzaz(i)*pazs1(i,3)-pzcz(i)*pazs2(i,3)+cz(i)+ps2(i,3)
   
      do 1017 j=1,3
      do 1017 i=1,n
      cx1(i,j)=(paxs0(i,j)-paxs1(i,j))/twozeta(i)
      cy1(i,j)=(pays0(i,j)-pays1(i,j))/twozeta(i)
 1017 cz1(i,j)=(pazs0(i,j)-pazs1(i,j))/twozeta(i)

      do 1018 i=1,n
      faxs0(i,01)=pxax(i)*daxs0(i,1)-pxcx(i)*daxs1(i,1)+cx1(i,1)*two
     &                                                 +ds1(i,1)
      faxs0(i,02)=pyay(i)*daxs0(i,1)-pycy(i)*daxs1(i,1)
      faxs0(i,03)=pzaz(i)*daxs0(i,1)-pzcz(i)*daxs1(i,1)
      faxs0(i,04)=pyay(i)*daxs0(i,2)-pycy(i)*daxs1(i,2)+cx1(i,1)
      faxs0(i,05)=pzaz(i)*daxs0(i,2)-pzcz(i)*daxs1(i,2)
      faxs0(i,06)=pzaz(i)*daxs0(i,3)-pzcz(i)*daxs1(i,3)+cx1(i,1)
      faxs0(i,07)=pyay(i)*daxs0(i,4)-pycy(i)*daxs1(i,4)+cx1(i,2)*two
      faxs0(i,08)=pzaz(i)*daxs0(i,4)-pzcz(i)*daxs1(i,4)
      faxs0(i,09)=pzaz(i)*daxs0(i,5)-pzcz(i)*daxs1(i,5)+cx1(i,2)
      faxs0(i,10)=pzaz(i)*daxs0(i,6)-pzcz(i)*daxs1(i,6)+cx1(i,3)*two
      fays0(i,01)=pxax(i)*days0(i,1)-pxcx(i)*days1(i,1)+cy1(i,1)*two
      fays0(i,02)=pyay(i)*days0(i,1)-pycy(i)*days1(i,1)
     &                                                 +ds1(i,1)
      fays0(i,03)=pzaz(i)*days0(i,1)-pzcz(i)*days1(i,1)
      fays0(i,04)=pyay(i)*days0(i,2)-pycy(i)*days1(i,2)+cy1(i,1)
     &                                                 +ds1(i,2)
      fays0(i,05)=pzaz(i)*days0(i,2)-pzcz(i)*days1(i,2)
      fays0(i,06)=pzaz(i)*days0(i,3)-pzcz(i)*days1(i,3)+cy1(i,1)
      fays0(i,07)=pyay(i)*days0(i,4)-pycy(i)*days1(i,4)+cy1(i,2)*two
     &                                                 +ds1(i,4)
      fays0(i,08)=pzaz(i)*days0(i,4)-pzcz(i)*days1(i,4)
      fays0(i,09)=pzaz(i)*days0(i,5)-pzcz(i)*days1(i,5)+cy1(i,2)
      fays0(i,10)=pzaz(i)*days0(i,6)-pzcz(i)*days1(i,6)+cy1(i,3)*two
      fazs0(i,01)=pxax(i)*dazs0(i,1)-pxcx(i)*dazs1(i,1)+cz1(i,1)*two
      fazs0(i,02)=pyay(i)*dazs0(i,1)-pycy(i)*dazs1(i,1)
      fazs0(i,03)=pzaz(i)*dazs0(i,1)-pzcz(i)*dazs1(i,1)
     &                                                 +ds1(i,1)
      fazs0(i,04)=pyay(i)*dazs0(i,2)-pycy(i)*dazs1(i,2)+cz1(i,1)
      fazs0(i,05)=pzaz(i)*dazs0(i,2)-pzcz(i)*dazs1(i,2)
     &                                                 +ds1(i,2)
      fazs0(i,06)=pzaz(i)*dazs0(i,3)-pzcz(i)*dazs1(i,3)+cz1(i,1)    
     &                                                 +ds1(i,3)
      fazs0(i,07)=pyay(i)*dazs0(i,4)-pycy(i)*dazs1(i,4)+cz1(i,2)*two
      fazs0(i,08)=pzaz(i)*dazs0(i,4)-pzcz(i)*dazs1(i,4)
     &                                                 +ds1(i,4)
      fazs0(i,09)=pzaz(i)*dazs0(i,5)-pzcz(i)*dazs1(i,5)+cz1(i,2)
     &                                                 +ds1(i,5)
 1018 fazs0(i,10)=pzaz(i)*dazs0(i,6)-pzcz(i)*dazs1(i,6)+cz1(i,3)*two
     &                                                 +ds1(i,6)

      do 1019 j=1,6
      do 1019 i=1,m
 1019 dscond(i,j)=zero

      do 1020 j=1,10
      do 1020 i=1,m
 1020 fscond(i,j)=zero

      do 1021 j=1,6
      do 1021 i=1,n
 1021 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)

      do 1022 j=1,10
      do 1022 i=1,n
 1022 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)

      do 1023 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1023 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1024 j=1,6
      do 1024 i=1,m
      daxscond(i,j)=zero
      dayscond(i,j)=zero
 1024 dazscond(i,j)=zero

      do 1025 j=1,10
      do 1025 i=1,m
      faxscond(i,j)=zero
      fayscond(i,j)=zero
 1025 fazscond(i,j)=zero

      do 1026 j=1,6
      do 1026 i=1,n
      daxscond(icontr(i),j)=daxscond(icontr(i),j)+daxs0(i,j)
      dayscond(icontr(i),j)=dayscond(icontr(i),j)+days0(i,j)
 1026 dazscond(icontr(i),j)=dazscond(icontr(i),j)+dazs0(i,j)

      do 1027 j=1,10
      do 1027 i=1,n
      faxscond(icontr(i),j)=faxscond(icontr(i),j)+faxs0(i,j)
      fayscond(icontr(i),j)=fayscond(icontr(i),j)+fays0(i,j)
 1027 fazscond(icontr(i),j)=fazscond(icontr(i),j)+fazs0(i,j)

      do 1028 i=1,m
      daxpcond(i,01)=axbx(i)*daxscond(i,1)+faxscond(i,01)
      daxpcond(i,02)=ayby(i)*daxscond(i,1)+faxscond(i,02)
      daxpcond(i,03)=azbz(i)*daxscond(i,1)+faxscond(i,03)
      daxpcond(i,04)=axbx(i)*daxscond(i,2)+faxscond(i,02)
      daxpcond(i,05)=ayby(i)*daxscond(i,2)+faxscond(i,04)
      daxpcond(i,06)=azbz(i)*daxscond(i,2)+faxscond(i,05)
      daxpcond(i,07)=axbx(i)*daxscond(i,3)+faxscond(i,03)
      daxpcond(i,08)=ayby(i)*daxscond(i,3)+faxscond(i,05)
      daxpcond(i,09)=azbz(i)*daxscond(i,3)+faxscond(i,06)
      daxpcond(i,10)=axbx(i)*daxscond(i,4)+faxscond(i,04)
      daxpcond(i,11)=ayby(i)*daxscond(i,4)+faxscond(i,07)
      daxpcond(i,12)=azbz(i)*daxscond(i,4)+faxscond(i,08)
      daxpcond(i,13)=axbx(i)*daxscond(i,5)+faxscond(i,05)
      daxpcond(i,14)=ayby(i)*daxscond(i,5)+faxscond(i,08)
      daxpcond(i,15)=azbz(i)*daxscond(i,5)+faxscond(i,09)
      daxpcond(i,16)=axbx(i)*daxscond(i,6)+faxscond(i,06)
      daxpcond(i,17)=ayby(i)*daxscond(i,6)+faxscond(i,09)
      daxpcond(i,18)=azbz(i)*daxscond(i,6)+faxscond(i,10)
      daypcond(i,01)=axbx(i)*dayscond(i,1)+fayscond(i,01)
      daypcond(i,02)=ayby(i)*dayscond(i,1)+fayscond(i,02)
      daypcond(i,03)=azbz(i)*dayscond(i,1)+fayscond(i,03)
      daypcond(i,04)=axbx(i)*dayscond(i,2)+fayscond(i,02)
      daypcond(i,05)=ayby(i)*dayscond(i,2)+fayscond(i,04)
      daypcond(i,06)=azbz(i)*dayscond(i,2)+fayscond(i,05)
      daypcond(i,07)=axbx(i)*dayscond(i,3)+fayscond(i,03)
      daypcond(i,08)=ayby(i)*dayscond(i,3)+fayscond(i,05)
      daypcond(i,09)=azbz(i)*dayscond(i,3)+fayscond(i,06)
      daypcond(i,10)=axbx(i)*dayscond(i,4)+fayscond(i,04)
      daypcond(i,11)=ayby(i)*dayscond(i,4)+fayscond(i,07)
      daypcond(i,12)=azbz(i)*dayscond(i,4)+fayscond(i,08)
      daypcond(i,13)=axbx(i)*dayscond(i,5)+fayscond(i,05)
      daypcond(i,14)=ayby(i)*dayscond(i,5)+fayscond(i,08)
      daypcond(i,15)=azbz(i)*dayscond(i,5)+fayscond(i,09)
      daypcond(i,16)=axbx(i)*dayscond(i,6)+fayscond(i,06)
      daypcond(i,17)=ayby(i)*dayscond(i,6)+fayscond(i,09)
      daypcond(i,18)=azbz(i)*dayscond(i,6)+fayscond(i,10)
      dazpcond(i,01)=axbx(i)*dazscond(i,1)+fazscond(i,01)
      dazpcond(i,02)=ayby(i)*dazscond(i,1)+fazscond(i,02)
      dazpcond(i,03)=azbz(i)*dazscond(i,1)+fazscond(i,03)
      dazpcond(i,04)=axbx(i)*dazscond(i,2)+fazscond(i,02)
      dazpcond(i,05)=ayby(i)*dazscond(i,2)+fazscond(i,04)
      dazpcond(i,06)=azbz(i)*dazscond(i,2)+fazscond(i,05)
      dazpcond(i,07)=axbx(i)*dazscond(i,3)+fazscond(i,03)
      dazpcond(i,08)=ayby(i)*dazscond(i,3)+fazscond(i,05)
      dazpcond(i,09)=azbz(i)*dazscond(i,3)+fazscond(i,06)
      dazpcond(i,10)=axbx(i)*dazscond(i,4)+fazscond(i,04)
      dazpcond(i,11)=ayby(i)*dazscond(i,4)+fazscond(i,07)
      dazpcond(i,12)=azbz(i)*dazscond(i,4)+fazscond(i,08)
      dazpcond(i,13)=axbx(i)*dazscond(i,5)+fazscond(i,05)
      dazpcond(i,14)=ayby(i)*dazscond(i,5)+fazscond(i,08)
      dazpcond(i,15)=azbz(i)*dazscond(i,5)+fazscond(i,09)
      dazpcond(i,16)=axbx(i)*dazscond(i,6)+fazscond(i,06)
      dazpcond(i,17)=ayby(i)*dazscond(i,6)+fazscond(i,09)
 1028 dazpcond(i,18)=azbz(i)*dazscond(i,6)+fazscond(i,10)

      do 1029 j=1,18
      do 1029 i=1,m
 1029 esp=esp-density(inddyy(i,j))*dpcond(i,j)

      do 1030 j=1,18
      do 1030 i=1,m
      efix=efix-density(inddyy(i,j))*daxpcond(i,j)
      efiy=efiy-density(inddyy(i,j))*daypcond(i,j)
 1030 efiz=efiz-density(inddyy(i,j))*dazpcond(i,j)

      return 
      end 

      subroutine zmatrix(nnn,c,izmat1,izmat2,izmat3,label)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
 
      implicit real*8(a-h,o-z)
 
      dimension c(3,*)
      dimension izmat1(*),izmat2(*),izmat3(*)
      character label(*)*4
 
      data bohr,pi/0.529177d0,3.1415926535898d0/
 
      write(6,1001)
 1001 format(' z-matrix :',/)
 
      write(6,1002) label(1)
 1002 format(5x,a4,50x,'   0   0   0')
 
      if(nnn.eq.1) goto 1007 
 
      coord1=dist(c(1,1),c(1,2))*bohr
 
      write(6,1003) label(2),coord1
 1003 format(5x,a4,5x,f10.7,35x,'   1   0   0')
 
      if(nnn.eq.2) goto 1007
 
      iii1=izmat1(3)
      iii2=izmat2(3)
 
      coord1=dist(c(1,3),c(1,iii1))*bohr
      coord2=ang(c(1,3),c(1,iii1),c(1,iii2))
 
      write(6,1004) label(3),coord1,coord2,iii1,iii2
 1004 format(5x,a4,5x,f10.7,5x,f10.4,20x,2i4,'   0')
 
      if(nnn.eq.3) goto 1007
 
      do 1005 i=4,nnn
 
      iii=i
      iii1=izmat1(i)
      iii2=izmat2(i)
      iii3=izmat3(i)
 
      coord1=dist(c(1,iii),c(1,iii1))*bohr
      coord2=ang(c(1,iii),c(1,iii1),c(1,iii2))
      coord3=dihed(c(1,iii),c(1,iii1),c(1,iii2),c(1,iii3))
 
      write(6,1006) label(i),coord1,coord2,coord3,iii1,iii2,iii3
 1006 format(5x,a4,5x,f10.7,5x,f10.4,5x,f10.4,5x,3i4)
 
 1005 continue
 
 1007 write(6,1008)
 1008 format()
 
      return
      end

      subroutine igftable

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
c
c  based on brett dunlap's incomplete gamma function subroutines

      implicit real*8(a-h,o-z)

      common/igfdata/table(17,161),smallu(17),bigu(13)

      data small,tenth,one,two,t1,t2/0.0000000001d0,0.1d0,1.0d0,
     &                               2.0d0,16.5d0,33.0d0/

      bigu(1)=one

      do 1001 i=2,13
 1001 bigu(i)=real64(2*i-3)*bigu(i-1)

      do 1002 i=1,17
 1002 smallu(i)=one/real64(2*i-1)

      do 1003 i=1,17
 1003 table(i,1)=smallu(i)

      do 1004 i=2,161

      factor=tenth*real64(i-1)

      scale=smallu(17)

      sum=scale

      do 1005 j=1,99
      scale=scale*factor/(t1+real64(j))
      if(scale.le.small) goto 1006
 1005 sum=sum+scale

 1006 expfac=exp(-factor)

      table(17,i)=expfac*sum

      do 1007 j=1,16
 1007 table(17-j,i)=(table(18-j,i)*two*factor+expfac)/(t2-real64(2*j))

 1004 continue

      return
      end

      subroutine mespmm(nreal,ninteger,iptsflag,nauxiliary,nunique,
     &                  npoints,ncentr,ndim,nbsystems,nconts,ncontp,
     &                  ncontd,ncds,ncdspd,nshels,nshelp,nsheld,mtloca,
     &                  iprimvc,nprimvc,icentvc,icdcfunc,icdlfunc,
     &                  nptsvec,isys,iwkvec,coord,charge,alpha,coeff,
     &                  alphacd,coeffscd,coeffpcd,coeffdcd,cdfitc,
     &                  density,tdensity,qqa,qqb,qqd,esppt,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension g(6)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*),iprimvc(*),
     &          nprimvc(*),icentvc(*),icdcfunc(*),icdlfunc(*),
     &          nptsvec(*),isys(ndim,*),iwkvec(*)

      dimension coord(3,*),charge(*),alpha(*),coeff(*),alphacd(*),
     &          coeffscd(*),coeffpcd(*),coeffdcd(*),cdfitc(*),
     &          density(*),tdensity(*),qqa(2*ndim,*),qqb(*),
     &          qqd(npoints,*),esppt(npoints,*),wkvec(*)

      data zero,half,one,two,three/0.0d0,0.5d0,1.0d0,2.0d0,3.0d0/

      data bohr,cutoff/0.529177d0,1.0d+35/

      sqrt3=sqrt(three)

      rewind 66

      n=0

      loop=4
      if(iptsflag.eq.0) loop=1

      do 1001 i=1,loop

      read(66) nsubpoints

      call fastrd(66,esppt(n+1,1),nsubpoints)
      call fastrd(66,esppt(n+1,2),nsubpoints)
      call fastrd(66,esppt(n+1,3),nsubpoints)

 1001 n=n+nsubpoints

      do 1002 j=1,ncentr
      do 1002 i=1,npoints
 1002 qqd(i,j)=one/sqrt((esppt(i,1)-coord(1,j))**2
     &                 +(esppt(i,2)-coord(2,j))**2
     &                 +(esppt(i,3)-coord(3,j))**2)

      do 1003 i=1,ncontd
      do 1003 j=1,nconts

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3

 1003 continue

      do 1004 i=1,ncontd
      do 1004 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+1)=density(i4+1)/sqrt3
      density(i4+2)=density(i4+2)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3

 1004 continue

      do 1005 i=1,ncontd
      do 1005 j=1,i

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      density(i4)=density(i4)/three
      if(i.ne.j) density(i4+1)=density(i4+1)/sqrt3
      if(i.ne.j) density(i4+2)=density(i4+2)/sqrt3
      if(i.ne.j) density(i4+3)=density(i4+3)/three
      if(i.ne.j) density(i4+4)=density(i4+4)/sqrt3
      if(i.ne.j) density(i4+5)=density(i4+5)/three

      density(i4+i1)=density(i4+i1)/sqrt3
      if(i.ne.j) density(i4+i1+3)=density(i4+i1+3)/sqrt3
      if(i.ne.j) density(i4+i1+5)=density(i4+i1+5)/sqrt3

      density(i4+i1*2+1)=density(i4+i1*2+1)/sqrt3
      if(i.ne.j) density(i4+i1*2+4)=density(i4+i1*2+4)/sqrt3
      if(i.ne.j) density(i4+i1*2+6)=density(i4+i1*2+6)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/three
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3
      density(i4+i1*3+6)=density(i4+i1*3+6)/three
      if(i.ne.j) density(i4+i1*3+7)=density(i4+i1*3+7)/sqrt3
      if(i.ne.j) density(i4+i1*3+8)=density(i4+i1*3+8)/three

      density(i4+i1*4+6)=density(i4+i1*4+6)/sqrt3
      density(i4+i1*4+9)=density(i4+i1*4+9)/sqrt3
      if(i.ne.j) density(i4+i1*4+11)=density(i4+i1*4+11)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/three
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3
      density(i4+i1*5+13)=density(i4+i1*5+13)/three
      density(i4+i1*5+14)=density(i4+i1*5+14)/sqrt3
      density(i4+i1*5+15)=density(i4+i1*5+15)/three

 1005 continue

      ncposs=nconts*(nconts+1)/2
      ncpopp=ncontp*(ncontp+1)/2
      ncpodd=ncontd*(ncontd+1)/2

      ncpops=ncontp*nconts
      ncpods=ncontd*nconts
      ncpodp=ncontd*ncontp

      npposs=0
      nppops=0
      nppopp=0
      nppods=0
      nppodp=0
      nppodd=0

      do 1006 i=1,nconts
      do 1006 j=1,i
 1006 npposs=npposs+nprimvc(nshels(i))*nprimvc(nshels(j))

      do 1007 i=1,ncontp
      do 1007 j=1,nconts
 1007 nppops=nppops+nprimvc(nshelp(i))*nprimvc(nshels(j))

      do 1008 i=1,ncontp
      do 1008 j=1,i
 1008 nppopp=nppopp+nprimvc(nshelp(i))*nprimvc(nshelp(j))

      do 1009 i=1,ncontd
      do 1009 j=1,nconts
 1009 nppods=nppods+nprimvc(nsheld(i))*nprimvc(nshels(j))

      do 1010 i=1,ncontd
      do 1010 j=1,ncontp
 1010 nppodp=nppodp+nprimvc(nsheld(i))*nprimvc(nshelp(j))

      do 1011 i=1,ncontd
      do 1011 j=1,i
 1011 nppodd=nppodd+nprimvc(nsheld(i))*nprimvc(nsheld(j))

      do 1012 i=1,npoints
      esppt(i,4)=zero
      do 1012 j=1,ncentr
 1012 esppt(i,4)=esppt(i,4)+charge(j)*qqd(i,j)

      do 1013 k=1,3
      do 1013 i=1,npoints
      esppt(i,k+4)=zero
      do 1013 j=1,ncentr
 1013 esppt(i,k+4)=esppt(i,k+4)
     &            -charge(j)*(esppt(i,k)-coord(k,j))*(qqd(i,j)**3)

      do 1014 i=1,npoints

      ja=1
      jb=ja+npposs
      jc=jb+ncposs

      if(jc.gt.ninteger) stop 'mespmm ss integer overflow'

      je=1
      jf=je+npposs
      jg=jf+npposs
      jh=jg+npposs
      ji=jh+npposs
      jj=ji+npposs
      jk=jj+npposs
      jl=jk+npposs
      jm=jl+npposs
      jn=jm+npposs
      jo=jn+npposs
      jp=jo+npposs
      jq=jp+npposs

      if(jq.gt.nreal) stop 'mespmm ss real overflow'

      call setupdcss(ncposs,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &               icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,alpha,
     &               coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &               wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &               wkvec(jn),wkvec(jo),wkvec(jp),density)

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n

      ka=jq+1
      kb=ka+n
      kc=kb+ncposs
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+ncposs
      km=kl+ncposs
      kn=km+ncposs

      if(kn.gt.nreal) stop 'mespmm ss real overflow'

      call efiss(ncposs,n,iwkvec(ja),iwkvec(jb),esppt(i,4),esppt(i,5),
     &           esppt(i,6),esppt(i,7),esppt(i,1),esppt(i,2),esppt(i,3),
     &           g,density,wkvec(je),wkvec(jn),wkvec(jo),wkvec(jp),
     &           wkvec(jm),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &           wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &           wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km))

 1014 continue

      do 1015 i=1,npoints

      ja=1
      jb=ja+nppops
      jc=jb+ncpops*3

      if(jc.gt.ninteger) stop 'mespmm ps integer overflow'

      je=1
      jf=je+nppops
      jg=jf+nppops
      jh=jg+nppops
      ji=jh+nppops
      jj=ji+nppops
      jk=jj+nppops
      jl=jk+nppops
      jm=jl+nppops
      jn=jm+nppops
      jo=jn+nppops
      jp=jo+nppops
      jq=jp+nppops
      jr=jq+nppops
      js=jr+nppops
      jt=js+nppops

      if(jt.gt.nreal) stop 'mespmm ps real overflow'

      call setupdcps(ncpops,n,ncontp,nconts,nshelp,nshels,mtloca,
     &               iprimvc,nprimvc,icentvc,iwkvec(ja),iwkvec(jb),
     &               cutoff,coord,alpha,coeff,wkvec(je),wkvec(jf),
     &               wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &               wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &               wkvec(jq),wkvec(jr),wkvec(js),density)

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      ka=jt+1
      kb=ka+n
      kc=kb+n
      kd=kc+n*3
      ke=kd+ncpops*3
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+n
      kp=ko+n
      kq=kp+n*3
      kr=kq+n*3
      ks=kr+n*3
      kt=ks+ncpops*3
      ku=kt+ncpops*3
      kv=ku+ncpops*3

      if(kv.gt.nreal) stop 'mespmm ps real overflow'

      call efips(ncpops,n,iwkvec(ja),iwkvec(jb),esppt(i,4),esppt(i,5),
     &           esppt(i,6),esppt(i,7),esppt(i,1),esppt(i,2),esppt(i,3),
     &           g,density,wkvec(je),wkvec(jn),wkvec(jo),wkvec(jp),
     &           wkvec(jq),wkvec(jr),wkvec(js),wkvec(jm),wkvec(ka),
     &           wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &           wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &           wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &           wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku))

 1015 continue

      do 1016 i=1,npoints

      ja=1
      jb=ja+ncpopp
      jc=jb+nppopp
      jd=jc+ncpopp*9

      if(jd.gt.ninteger) stop 'mespmm pp integer overflow'

      je=1
      jf=je+nppopp
      jg=jf+nppopp
      jh=jg+nppopp
      ji=jh+nppopp
      jj=ji+nppopp
      jk=jj+nppopp
      jl=jk+nppopp
      jm=jl+nppopp
      jn=jm+nppopp
      jo=jn+nppopp
      jp=jo+nppopp
      jq=jp+nppopp
      jr=jq+nppopp
      js=jr+nppopp
      jt=js+nppopp
      ju=jt+nppopp
      jv=ju+nppopp
      jw=jv+nppopp
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      if(jz.gt.nreal) stop 'mespmm pp real overflow'

      call setupdcpp(ncpopp,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &               icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &               coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &               wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &               wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &               wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &               wkvec(jw),wkvec(jx),wkvec(jy),density)

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))
      call stringcopy(n,wkvec(15*n+1),wkvec(jt))
      call stringcopy(n,wkvec(16*n+1),wkvec(ju))
      call stringcopy(n,wkvec(17*n+1),wkvec(jv))
      call stringcopy(ncpopp,wkvec(18*n+0*ncpopp+1),wkvec(jw))
      call stringcopy(ncpopp,wkvec(18*n+1*ncpopp+1),wkvec(jx))
      call stringcopy(ncpopp,wkvec(18*n+2*ncpopp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      ka=jz+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n*3
      kf=ke+n*3
      kg=kf+n*3
      kh=kg+n*6
      ki=kh+n*6
      kj=ki+n*9
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+n
      kp=ko+n
      kq=kp+n
      kr=kq+n
      ks=kr+n
      kt=ks+n
      ku=kt+n
      kv=ku+n
      kw=kv+n
      kx=kw+n
      ky=kx+n
      kz=ky+n
      la=kz+n*3
      lb=la+n*3
      lc=lb+n*3
      ld=lc+n*3
      le=ld+n*3
      lf=le+n*3
      lg=lf+n*6
      lh=lg+n*6
      li=lh+n*6
      lj=li+n
      lk=lj+n
      ll=lk+n
      lm=ll+n*3
      ln=lm+n*3
      lo=ln+n*3
      lp=lo+n*9
      lq=lp+n*9
      lr=lq+n*9
      ls=lr+n*6
      lt=ls+n*6
      lu=lt+n*6

      if(lu.gt.nreal) stop 'mespmm pp real overflow'

      call efipp(ncpopp,n,iwkvec(ja),iwkvec(jb),iwkvec(jc),esppt(i,4),
     &           esppt(i,5),esppt(i,6),esppt(i,7),esppt(i,1),
     &           esppt(i,2),esppt(i,3),g,density,wkvec(je),
     &           wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),wkvec(jo),
     &           wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jm),
     &           wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &           wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &           wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &           wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),
     &           wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),
     &           wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),
     &           wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),
     &           wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),
     &           wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls),
     &           wkvec(lt))

 1016 continue

      do 1017 i=1,npoints

      ja=1
      jb=ja+nppods
      jc=jb+ncpods*6

      if(jc.gt.ninteger) stop 'mespmm ds integer overflow'

      je=1
      jf=je+nppods
      jg=jf+nppods
      jh=jg+nppods
      ji=jh+nppods
      jj=ji+nppods
      jk=jj+nppods
      jl=jk+nppods
      jm=jl+nppods
      jn=jm+nppods
      jo=jn+nppods
      jp=jo+nppods
      jq=jp+nppods
      jr=jq+nppods
      js=jr+nppods
      jt=js+nppods

      if(jt.gt.nreal) stop 'mespmm ds real overflow'

      call setupdcds(ncpods,n,ncontd,nconts,nsheld,nshels,mtloca,
     &               iprimvc,nprimvc,icentvc,iwkvec(ja),iwkvec(jb),
     &               cutoff,coord,alpha,coeff,wkvec(je),wkvec(jf),
     &               wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &               wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &               wkvec(jq),wkvec(jr),wkvec(js),density)

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      ka=jt+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n*3
      kf=ke+n*3
      kg=kf+n*6
      kh=kg+ncpods*6
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+n
      kp=ko+n
      kq=kp+n
      kr=kq+n
      ks=kr+n
      kt=ks+n
      ku=kt+n
      kv=ku+n
      kw=kv+n
      kx=kw+n
      ky=kx+n
      kz=ky+n
      la=kz+n
      lb=la+n*3
      lc=lb+n*3
      ld=lc+n*3
      le=ld+n*3
      lf=le+n*3
      lg=lf+n*3
      lh=lg+n*6
      li=lh+n*6
      lj=li+n*6
      lk=lj+ncpods*6
      ll=lk+ncpods*6
      lm=ll+ncpods*6

      if(lm.gt.nreal) stop 'mespmm ds real overflow'

      call efids(ncpods,n,iwkvec(ja),iwkvec(jb),esppt(i,4),esppt(i,5),
     &           esppt(i,6),esppt(i,7),esppt(i,1),esppt(i,2),esppt(i,3),
     &           g,density,wkvec(je),wkvec(jn),wkvec(jo),wkvec(jp),
     &           wkvec(jq),wkvec(jr),wkvec(js),wkvec(jm),wkvec(ka),
     &           wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf), 
     &           wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &           wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &           wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &           wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),
     &           wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),
     &           wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &           wkvec(lk),wkvec(ll))

 1017 continue

      do 1018 i=1,npoints

      ja=1
      jb=ja+nppodp
      jc=jb+ncpodp*18

      if(jc.gt.ninteger) stop 'mespmm dp integer overflow'

      je=1
      jf=je+nppodp
      jg=jf+nppodp
      jh=jg+nppodp
      ji=jh+nppodp
      jj=ji+nppodp
      jk=jj+nppodp
      jl=jk+nppodp
      jm=jl+nppodp
      jn=jm+nppodp
      jo=jn+nppodp
      jp=jo+nppodp
      jq=jp+nppodp
      jr=jq+nppodp
      js=jr+nppodp
      jt=js+nppodp
      ju=jt+nppodp
      jv=ju+nppodp
      jw=jv+nppodp
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      if(jz.gt.nreal) stop 'mespmm dp real overflow'

      call setupdcdp(ncpodp,n,ncontd,ncontp,nsheld,nshelp,mtloca,
     &               iprimvc,nprimvc,icentvc,iwkvec(ja),iwkvec(jb),
     &               cutoff,coord,alpha,coeff,wkvec(je),wkvec(jf),
     &               wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &               wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &               wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),
     &               wkvec(jv),wkvec(jw),wkvec(jx),wkvec(jy),density)

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))
      call stringcopy(n,wkvec(15*n+1),wkvec(jt))
      call stringcopy(n,wkvec(16*n+1),wkvec(ju))
      call stringcopy(n,wkvec(17*n+1),wkvec(jv))
      call stringcopy(ncpodp,wkvec(18*n+0*ncpodp+1),wkvec(jw))
      call stringcopy(ncpodp,wkvec(18*n+1*ncpodp+1),wkvec(jx))
      call stringcopy(ncpodp,wkvec(18*n+2*ncpodp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      ka=jz+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n*3
      kg=kf+n*3
      kh=kg+n*3
      ki=kh+n*6
      kj=ki+n*6
      kk=kj+n*6
      kl=kk+n*10
      km=kl+n*10
      kn=km+n*18
      ko=kn+n
      kp=ko+n*3
      kq=kp+n
      kr=kq+n
      ks=kr+n
      kt=ks+n
      ku=kt+n
      kv=ku+n
      kw=kv+n
      kx=kw+n
      ky=kx+n
      kz=ky+n*3
      la=kz+n*3
      lb=la+n*3
      lc=lb+n
      ld=lc+n
      le=ld+n
      lf=le+n
      lg=lf+n
      lh=lg+n
      li=lh+n
      lj=li+n
      lk=lj+n
      ll=lk+n
      lm=ll+n
      ln=lm+n
      lo=ln+n*3
      lp=lo+n*3
      lq=lp+n*3
      lr=lq+n*3
      ls=lr+n*3
      lt=ls+n*3
      lu=lt+n*3
      lv=lu+n*3
      lw=lv+n*3
      lx=lw+n*6
      ly=lx+n*6
      lz=ly+n*6
      ma=lz+n*6
      mb=ma+n*6
      mc=mb+n*6
      md=mc+n*10
      me=md+n*10
      mf=me+n*10
      mg=mf+n*6
      mh=mg+n*6
      mi=mh+n*6
      mj=mi+n*18
      mk=mj+n*18
      ml=mk+n*18
      mm=ml+n*10
      mn=mm+n*10
      mo=mn+n*10

      if(mo.gt.nreal) stop 'mespmm dp real overflow'

      call efidp(ncpodp,n,iwkvec(ja),iwkvec(jb),esppt(i,4),esppt(i,5),
     &           esppt(i,6),esppt(i,7),esppt(i,1),esppt(i,2),esppt(i,3),
     &           g,density,wkvec(je),wkvec(jw),wkvec(jx),wkvec(jy),
     &           wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &           wkvec(js),wkvec(jm),wkvec(ka),wkvec(kb),wkvec(kc),
     &           wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &           wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &           wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &           wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),
     &           wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),
     &           wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),
     &           wkvec(lh),wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),
     &           wkvec(lm),wkvec(ln),wkvec(lo),wkvec(lp),wkvec(lq),
     &           wkvec(lr),wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),
     &           wkvec(lw),wkvec(lx),wkvec(ly),wkvec(lz),wkvec(ma),
     &           wkvec(mb),wkvec(mc),wkvec(md),wkvec(me),wkvec(mf),
     &           wkvec(mg),wkvec(mh),wkvec(mi),wkvec(mj),wkvec(mk),
     &           wkvec(ml),wkvec(mm),wkvec(mn))

 1018 continue

      do 1019 i=1,npoints

      ja=1
      jb=ja+ncpodd
      jc=jb+nppodd
      jd=jc+ncpodd*36

      if(jd.gt.ninteger) stop 'mespmm dd integer overflow'

      je=1
      jf=je+nppodd
      jg=jf+nppodd
      jh=jg+nppodd
      ji=jh+nppodd
      jj=ji+nppodd
      jk=jj+nppodd
      jl=jk+nppodd
      jm=jl+nppodd
      jn=jm+nppodd
      jo=jn+nppodd
      jp=jo+nppodd
      jq=jp+nppodd
      jr=jq+nppodd
      js=jr+nppodd
      jt=js+nppodd
      ju=jt+nppodd
      jv=ju+nppodd
      jw=jv+nppodd
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      if(jz.gt.nreal) stop 'mespmm dd real overflow'

      call setupdcdd(ncpodd,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &               icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &               coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &               wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &               wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &               wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &               wkvec(jw),wkvec(jx),wkvec(jy),density)

      call stringcopy(n,wkvec(00*n+1),wkvec(je))
      call stringcopy(n,wkvec(01*n+1),wkvec(jf))
      call stringcopy(n,wkvec(02*n+1),wkvec(jg))
      call stringcopy(n,wkvec(03*n+1),wkvec(jh))
      call stringcopy(n,wkvec(04*n+1),wkvec(ji))
      call stringcopy(n,wkvec(05*n+1),wkvec(jj))
      call stringcopy(n,wkvec(06*n+1),wkvec(jk))
      call stringcopy(n,wkvec(07*n+1),wkvec(jl))
      call stringcopy(n,wkvec(08*n+1),wkvec(jm))
      call stringcopy(n,wkvec(09*n+1),wkvec(jn))
      call stringcopy(n,wkvec(10*n+1),wkvec(jo))
      call stringcopy(n,wkvec(11*n+1),wkvec(jp))
      call stringcopy(n,wkvec(12*n+1),wkvec(jq))
      call stringcopy(n,wkvec(13*n+1),wkvec(jr))
      call stringcopy(n,wkvec(14*n+1),wkvec(js))
      call stringcopy(n,wkvec(15*n+1),wkvec(jt))
      call stringcopy(n,wkvec(16*n+1),wkvec(ju))
      call stringcopy(n,wkvec(17*n+1),wkvec(jv))
      call stringcopy(ncpodd,wkvec(18*n+0*ncpodd+1),wkvec(jw))
      call stringcopy(ncpodd,wkvec(18*n+1*ncpodd+1),wkvec(jx))
      call stringcopy(ncpodd,wkvec(18*n+2*ncpodd+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      ka=jz+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n*3
      kh=kg+n*3
      ki=kh+n*3
      kj=ki+n*3
      kk=kj+n*6
      kl=kk+n*6
      km=kl+n*6
      kn=km+n*6
      ko=kn+n*10
      kp=ko+n*10
      kq=kp+n*10
      kr=kq+n*15
      ks=kr+n*15
      kt=ks+n*18
      ku=kt+n*30
      kv=ku+n*36
      kw=kv+n
      kx=kw+n*3
      ky=kx+n*6
      kz=ky+n
      la=kz+n
      lb=la+n
      lc=lb+n
      ld=lc+n
      le=ld+n
      lf=le+n
      lg=lf+n
      lh=lg+n*3
      li=lh+n*3
      lj=li+n*3
      lk=lj+n*6
      ll=lk+n*6
      lm=ll+n*6
      ln=lm+n
      lo=ln+n
      lp=lo+n
      lq=lp+n
      lr=lq+n
      ls=lr+n
      lt=ls+n
      lu=lt+n
      lv=lu+n
      lw=lv+n
      lx=lw+n
      ly=lx+n
      lz=ly+n
      ma=lz+n
      mb=ma+n
      mc=mb+n
      md=mc+n*3
      me=md+n*3
      mf=me+n*3
      mg=mf+n*3
      mh=mg+n*3
      mi=mh+n*3
      mj=mi+n*3
      mk=mj+n*3
      ml=mk+n*3
      mm=ml+n*3
      mn=mm+n*3
      mo=mn+n*3
      mp=mo+n*6
      mq=mp+n*6
      mr=mq+n*6
      ms=mr+n*6
      mt=ms+n*6
      mu=mt+n*6
      mv=mu+n*6
      mw=mv+n*6
      mx=mw+n*6
      my=mx+n*10
      mz=my+n*10
      na=mz+n*10
      nb=na+n*10
      nc=nb+n*10
      nd=nc+n*10
      ne=nd+n*15
      nf=ne+n*15
      ng=nf+n*15
      nh=ng+n*6
      ni=nh+n*6
      nj=ni+n*6
      nk=nj+n*10
      nl=nk+n*10
      nm=nl+n*10
      nn=nm+n*15
      no=nn+n*15
      np=no+n*15
      nq=np+n*18
      nr=nq+n*18
      ns=nr+n*18
      nt=ns+n*30
      nu=nt+n*30
      nv=nu+n*30
      nw=nv+n*36
      nx=nw+n*36
      ny=nx+n*36

      if(ny.gt.nreal) stop 'mespmm dd real overflow'

      call efidd(ncpodd,n,iwkvec(ja),iwkvec(jb),iwkvec(jc),esppt(i,4),
     &           esppt(i,5),esppt(i,6),esppt(i,7),esppt(i,1),esppt(i,2),
     &           esppt(i,3),g,density,wkvec(je),wkvec(jw),wkvec(jx),
     &           wkvec(jy),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &           wkvec(jr),wkvec(js),wkvec(jm),wkvec(ka),wkvec(kb),
     &           wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &           wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &           wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),
     &           wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),
     &           wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),
     &           wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),
     &           wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),wkvec(lk),
     &           wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),wkvec(lp),
     &           wkvec(lq),wkvec(lr),wkvec(ls),wkvec(lt),wkvec(lu),
     &           wkvec(lv),wkvec(lw),wkvec(lx),wkvec(ly),wkvec(lz),
     &           wkvec(ma),wkvec(mb),wkvec(mc),wkvec(md),wkvec(me),
     &           wkvec(mf),wkvec(mg),wkvec(mh),wkvec(mi),wkvec(mj),
     &           wkvec(mk),wkvec(ml),wkvec(mm),wkvec(mn),wkvec(mo),
     &           wkvec(mp),wkvec(mq),wkvec(mr),wkvec(ms),wkvec(mt),
     &           wkvec(mu),wkvec(mv),wkvec(mw),wkvec(mx),wkvec(my),
     &           wkvec(mz),wkvec(na),wkvec(nb),wkvec(nc),wkvec(nd),
     &           wkvec(ne),wkvec(nf),wkvec(ng),wkvec(nh),wkvec(ni),
     &           wkvec(nj),wkvec(nk),wkvec(nl),wkvec(nm),wkvec(nn),
     &           wkvec(no),wkvec(np),wkvec(nq),wkvec(nr),wkvec(ns),
     &           wkvec(nt),wkvec(nu),wkvec(nv),wkvec(nw),wkvec(nx))

 1019 continue

      nstore=0
 
      do 1020 j=1,nunique
      do 1020 k=1,nunique
      qqa(j,k)=zero
      do 1020 i=1,npoints
 1020 qqa(j,k)=qqa(j,k)+qqd(i,k)*qqd(i,j)

      do 1021 i=1,nunique
 1021 qqb(i)=zero

      do 1022 j=1,nunique
      do 1022 i=1,npoints
 1022 qqb(j)=qqb(j)+esppt(i,4)*qqd(i,j)

      rewind 91

      do 1023 i=1,npoints
 1023 write(91,1024) esppt(i,1)*bohr,esppt(i,2)*bohr,esppt(i,3)*bohr,
     &               esppt(i,4),
     &               esppt(i,5),esppt(i,6),esppt(i,7)
 1024 format(4f20.12,/,3f20.12)

      return
      end

      subroutine normo(ndim,nconts,ncontp,ncontd,nshels,nshelp,nsheld,
     &                 mtloca,overlap)

      implicit real*8 (a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*)

      dimension overlap(ndim,*)

      data three/3.0d0/

      sqrt3=sqrt(three)

      do 1001 i=1,ncontd
      do 1001 j=1,nconts

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      overlap(i4,1)=overlap(i4,1)/sqrt3
      overlap(i4,2)=overlap(i4,2)/sqrt3
      overlap(i4,3)=overlap(i4,3)/sqrt3

      overlap(i4+i1*3+3,1)=overlap(i4+i1*3+3,1)/sqrt3
      overlap(i4+i1*3+3,2)=overlap(i4+i1*3+3,2)/sqrt3
      overlap(i4+i1*3+3,3)=overlap(i4+i1*3+3,3)/sqrt3

      overlap(i4+i1*5+10,1)=overlap(i4+i1*5+10,1)/sqrt3
      overlap(i4+i1*5+10,2)=overlap(i4+i1*5+10,2)/sqrt3
      overlap(i4+i1*5+10,3)=overlap(i4+i1*5+10,3)/sqrt3

 1001 continue

      do 1002 i=1,ncontd
      do 1002 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      overlap(i4,1)=overlap(i4,1)/sqrt3
      overlap(i4,2)=overlap(i4,2)/sqrt3
      overlap(i4,3)=overlap(i4,3)/sqrt3

      overlap(i4+1,1)=overlap(i4+1,1)/sqrt3
      overlap(i4+1,2)=overlap(i4+1,2)/sqrt3
      overlap(i4+1,3)=overlap(i4+1,3)/sqrt3

      overlap(i4+2,1)=overlap(i4+2,1)/sqrt3
      overlap(i4+2,2)=overlap(i4+2,2)/sqrt3
      overlap(i4+2,3)=overlap(i4+2,3)/sqrt3

      overlap(i4+i1*3+3,1)=overlap(i4+i1*3+3,1)/sqrt3
      overlap(i4+i1*3+3,2)=overlap(i4+i1*3+3,2)/sqrt3
      overlap(i4+i1*3+3,3)=overlap(i4+i1*3+3,3)/sqrt3

      overlap(i4+i1*3+4,1)=overlap(i4+i1*3+4,1)/sqrt3
      overlap(i4+i1*3+4,2)=overlap(i4+i1*3+4,2)/sqrt3
      overlap(i4+i1*3+4,3)=overlap(i4+i1*3+4,3)/sqrt3

      overlap(i4+i1*3+5,1)=overlap(i4+i1*3+5,1)/sqrt3
      overlap(i4+i1*3+5,2)=overlap(i4+i1*3+5,2)/sqrt3
      overlap(i4+i1*3+5,3)=overlap(i4+i1*3+5,3)/sqrt3

      overlap(i4+i1*5+10,1)=overlap(i4+i1*5+10,1)/sqrt3
      overlap(i4+i1*5+10,2)=overlap(i4+i1*5+10,2)/sqrt3
      overlap(i4+i1*5+10,3)=overlap(i4+i1*5+10,3)/sqrt3

      overlap(i4+i1*5+11,1)=overlap(i4+i1*5+11,1)/sqrt3
      overlap(i4+i1*5+11,2)=overlap(i4+i1*5+11,2)/sqrt3
      overlap(i4+i1*5+11,3)=overlap(i4+i1*5+11,3)/sqrt3

      overlap(i4+i1*5+12,1)=overlap(i4+i1*5+12,1)/sqrt3
      overlap(i4+i1*5+12,2)=overlap(i4+i1*5+12,2)/sqrt3
      overlap(i4+i1*5+12,3)=overlap(i4+i1*5+12,3)/sqrt3

 1002 continue

      do 1003 i=1,ncontd
      do 1003 j=1,i

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      overlap(i4,1)=overlap(i4,1)/three
      overlap(i4,2)=overlap(i4,2)/three
      overlap(i4,3)=overlap(i4,3)/three

      if(i.ne.j) overlap(i4+1,1)=overlap(i4+1,1)/sqrt3
      if(i.ne.j) overlap(i4+1,2)=overlap(i4+1,2)/sqrt3
      if(i.ne.j) overlap(i4+1,3)=overlap(i4+1,3)/sqrt3

      if(i.ne.j) overlap(i4+2,1)=overlap(i4+2,1)/sqrt3
      if(i.ne.j) overlap(i4+2,2)=overlap(i4+2,2)/sqrt3
      if(i.ne.j) overlap(i4+2,3)=overlap(i4+2,3)/sqrt3

      if(i.ne.j) overlap(i4+3,1)=overlap(i4+3,1)/three
      if(i.ne.j) overlap(i4+3,2)=overlap(i4+3,2)/three
      if(i.ne.j) overlap(i4+3,3)=overlap(i4+3,3)/three

      if(i.ne.j) overlap(i4+4,1)=overlap(i4+4,1)/sqrt3
      if(i.ne.j) overlap(i4+4,2)=overlap(i4+4,2)/sqrt3
      if(i.ne.j) overlap(i4+4,3)=overlap(i4+4,3)/sqrt3

      if(i.ne.j) overlap(i4+5,1)=overlap(i4+5,1)/three
      if(i.ne.j) overlap(i4+5,2)=overlap(i4+5,2)/three
      if(i.ne.j) overlap(i4+5,3)=overlap(i4+5,3)/three

      overlap(i4+i1,1)=overlap(i4+i1,1)/sqrt3
      overlap(i4+i1,2)=overlap(i4+i1,2)/sqrt3
      overlap(i4+i1,3)=overlap(i4+i1,3)/sqrt3

      if(i.ne.j) overlap(i4+i1+3,1)=overlap(i4+i1+3,1)/sqrt3
      if(i.ne.j) overlap(i4+i1+3,2)=overlap(i4+i1+3,2)/sqrt3
      if(i.ne.j) overlap(i4+i1+3,3)=overlap(i4+i1+3,3)/sqrt3

      if(i.ne.j) overlap(i4+i1+5,1)=overlap(i4+i1+5,1)/sqrt3
      if(i.ne.j) overlap(i4+i1+5,2)=overlap(i4+i1+5,2)/sqrt3
      if(i.ne.j) overlap(i4+i1+5,3)=overlap(i4+i1+5,3)/sqrt3

      overlap(i4+i1*2+1,1)=overlap(i4+i1*2+1,1)/sqrt3
      overlap(i4+i1*2+1,2)=overlap(i4+i1*2+1,2)/sqrt3
      overlap(i4+i1*2+1,3)=overlap(i4+i1*2+1,3)/sqrt3

      if(i.ne.j) overlap(i4+i1*2+4,1)=overlap(i4+i1*2+4,1)/sqrt3
      if(i.ne.j) overlap(i4+i1*2+4,2)=overlap(i4+i1*2+4,2)/sqrt3
      if(i.ne.j) overlap(i4+i1*2+4,3)=overlap(i4+i1*2+4,3)/sqrt3

      if(i.ne.j) overlap(i4+i1*2+6,1)=overlap(i4+i1*2+6,1)/sqrt3
      if(i.ne.j) overlap(i4+i1*2+6,2)=overlap(i4+i1*2+6,2)/sqrt3
      if(i.ne.j) overlap(i4+i1*2+6,3)=overlap(i4+i1*2+6,3)/sqrt3

      overlap(i4+i1*3+3,1)=overlap(i4+i1*3+3,1)/three
      overlap(i4+i1*3+3,2)=overlap(i4+i1*3+3,2)/three
      overlap(i4+i1*3+3,3)=overlap(i4+i1*3+3,3)/three

      overlap(i4+i1*3+4,1)=overlap(i4+i1*3+4,1)/sqrt3
      overlap(i4+i1*3+4,2)=overlap(i4+i1*3+4,2)/sqrt3
      overlap(i4+i1*3+4,3)=overlap(i4+i1*3+4,3)/sqrt3

      overlap(i4+i1*3+5,1)=overlap(i4+i1*3+5,1)/sqrt3
      overlap(i4+i1*3+5,2)=overlap(i4+i1*3+5,2)/sqrt3
      overlap(i4+i1*3+5,3)=overlap(i4+i1*3+5,3)/sqrt3

      overlap(i4+i1*3+6,1)=overlap(i4+i1*3+6,1)/three
      overlap(i4+i1*3+6,2)=overlap(i4+i1*3+6,2)/three
      overlap(i4+i1*3+6,3)=overlap(i4+i1*3+6,3)/three

      if(i.ne.j) overlap(i4+i1*3+7,1)=overlap(i4+i1*3+7,1)/sqrt3
      if(i.ne.j) overlap(i4+i1*3+7,2)=overlap(i4+i1*3+7,2)/sqrt3
      if(i.ne.j) overlap(i4+i1*3+7,3)=overlap(i4+i1*3+7,3)/sqrt3

      if(i.ne.j) overlap(i4+i1*3+8,1)=overlap(i4+i1*3+8,1)/three
      if(i.ne.j) overlap(i4+i1*3+8,2)=overlap(i4+i1*3+8,2)/three
      if(i.ne.j) overlap(i4+i1*3+8,3)=overlap(i4+i1*3+8,3)/three

      overlap(i4+i1*4+6,1)=overlap(i4+i1*4+6,1)/sqrt3
      overlap(i4+i1*4+6,2)=overlap(i4+i1*4+6,2)/sqrt3
      overlap(i4+i1*4+6,3)=overlap(i4+i1*4+6,3)/sqrt3

      overlap(i4+i1*4+9,1)=overlap(i4+i1*4+9,1)/sqrt3
      overlap(i4+i1*4+9,2)=overlap(i4+i1*4+9,2)/sqrt3
      overlap(i4+i1*4+9,3)=overlap(i4+i1*4+9,3)/sqrt3

      if(i.ne.j) overlap(i4+i1*4+11,1)=overlap(i4+i1*4+11,1)/sqrt3
      if(i.ne.j) overlap(i4+i1*4+11,2)=overlap(i4+i1*4+11,2)/sqrt3
      if(i.ne.j) overlap(i4+i1*4+11,3)=overlap(i4+i1*4+11,3)/sqrt3

      overlap(i4+i1*5+10,1)=overlap(i4+i1*5+10,1)/three
      overlap(i4+i1*5+10,2)=overlap(i4+i1*5+10,2)/three
      overlap(i4+i1*5+10,3)=overlap(i4+i1*5+10,3)/three

      overlap(i4+i1*5+11,1)=overlap(i4+i1*5+11,1)/sqrt3
      overlap(i4+i1*5+11,2)=overlap(i4+i1*5+11,2)/sqrt3
      overlap(i4+i1*5+11,3)=overlap(i4+i1*5+11,3)/sqrt3

      overlap(i4+i1*5+12,1)=overlap(i4+i1*5+12,1)/sqrt3
      overlap(i4+i1*5+12,2)=overlap(i4+i1*5+12,2)/sqrt3
      overlap(i4+i1*5+12,3)=overlap(i4+i1*5+12,3)/sqrt3

      overlap(i4+i1*5+13,1)=overlap(i4+i1*5+13,1)/three
      overlap(i4+i1*5+13,2)=overlap(i4+i1*5+13,2)/three
      overlap(i4+i1*5+13,3)=overlap(i4+i1*5+13,3)/three

      overlap(i4+i1*5+14,1)=overlap(i4+i1*5+14,1)/sqrt3
      overlap(i4+i1*5+14,2)=overlap(i4+i1*5+14,2)/sqrt3
      overlap(i4+i1*5+14,3)=overlap(i4+i1*5+14,3)/sqrt3

      overlap(i4+i1*5+15,1)=overlap(i4+i1*5+15,1)/three
      overlap(i4+i1*5+15,2)=overlap(i4+i1*5+15,2)/three
      overlap(i4+i1*5+15,3)=overlap(i4+i1*5+15,3)/three

 1003 continue

      return
      end

      subroutine drho(gx,gy,gz,hxx,hxy,hxz,hyy,hyz,hzz,gradmod,
     &                dlaplacian,xcpotterm)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      data zero,two,tolerance/0.0d0,2.0d0,1.0d-15/

      gradmod=sqrt(gx*gx+gy*gy+gz*gz)

      dlaplacian=hxx+hyy+hzz

      if(gradmod.gt.tolerance) then
                                     xcpotterm=(gx*gx*hxx
     &                                         +gx*gy*hxy*two
     &                                         +gx*gz*hxz*two
     &                                         +gy*gy*hyy
     &                                         +gy*gz*hyz*two
     &                                         +gz*gz*hzz)/gradmod
                               else
                                     xcpotterm=zero
                               endif

      return
      end

      subroutine element(natom,string,natomtype)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      character atomic_symbol(0:105)*2,symbol*2

      character string(*)

      dimension natomtype(*)

      data atomic_symbol/ 'xx', 'h ', 'he', 'li', 'be', 'b ', 'c ',
     &                    'n ', 'o ', 'f ', 'ne', 'na', 'mg', 'al',
     &                    'si', 'p ', 's ', 'cl', 'ar', 'k ', 'ca',
     &                    'sc', 'ti', 'v ', 'cr', 'mn', 'fe', 'co',
     &                    'ni', 'cu', 'zn', 'ga', 'ge', 'as', 'se',
     &                    'br', 'kr', 'rb', 'sr', 'y ', 'zr', 'nb',
     &                    'mo', 'tc', 'ru', 'rh', 'pd', 'ag', 'cd',
     &                    'in', 'sn', 'sb', 'te', 'i ', 'xe', 'cs',
     &                    'ba', 'la', 'ce', 'pr', 'nd', 'pm', 'sm',
     &                    'eu', 'gd', 'tb', 'dy', 'ho', 'er', 'tm',
     &                    'yb', 'lu', 'hf', 'ta', 'w ', 're', 'os',
     &                    'ir', 'pt', 'au', 'hg', 'tl', 'pb', 'bi',
     &                    'po', 'at', 'rn', 'fr', 'ra', 'ac', 'th',
     &                    'pa', 'u ', 'np', 'pu', 'am', 'cm', 'bk',
     &                    'cf', 'es', 'fm', 'md', 'no', 'lw', 'ku',
     &                    'ha'/

      symbol(1:1)=string(1)

      if(((ichar(string(2)).ge.ichar('0')).and.
     &    (ichar(string(2)).le.ichar('9'))).or.
     &    (ichar(string(2)).eq.ichar(' '))) then
                                                  symbol(2:2)=' '
                                            else
                                                  symbol(2:2)=string(2)
                                            endif

      call makelowercase(symbol,2)

      natomtype(natom)=666

      do 1001 i=0,105
 1001 if(symbol.eq.atomic_symbol(i)) natomtype(natom)=i

      if(natomtype(natom).eq.666) stop 'bad atomic symbol'

      return
      end

      subroutine cdgrss(ncds,ilfunc,icfunc,cdfitc,alpha,coeffs,coord,
     &                  gradient)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension g(2)
 
      dimension ilfunc(*),icfunc(*)

      dimension cdfitc(*),alpha(*),coeffs(*),coord(3,*),gradient(3,*) 

      data one,two,pi/1.0d0,2.0d0,3.1415926535898d0/
      data four,five/4.0d0,5.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      factor=(pi**(five/four)*sqrt(two))**2

      ncombos=(ncds*(ncds+1))/2

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1001 i=1,ncds
      do 1001 j=1,i

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1001

      ilabel=ilfunc(i)
      jlabel=ilfunc(j)

      nc1=icfunc(ilabel)
      nc2=icfunc(jlabel)

      zetaa=alpha(ilabel)
      zetab=alpha(jlabel)

      axbx=coord(1,nc1)-coord(1,nc2)
      ayby=coord(2,nc1)-coord(2,nc2)
      azbz=coord(3,nc1)-coord(3,nc2)

      const=factor/(zetaa*zetab)

      zetaab=one/(zetaa+zetab)

      wxpx=(zetaa*coord(1,nc1)+zetab*coord(1,nc2))*zetaab-coord(1,nc1)
      wypy=(zetaa*coord(2,nc1)+zetab*coord(2,nc2))*zetaab-coord(2,nc1)
      wzpz=(zetaa*coord(3,nc1)+zetab*coord(3,nc2))*zetaab-coord(3,nc1)

      u=zetaa*zetab*zetaab*(axbx*axbx+ayby*ayby+azbz*azbz)

      call augg(2,u,g)

      s1=g(2)*const*sqrt(zetaab)

      px0=wxpx*s1
      py0=wypy*s1
      pz0=wzpz*s1

      cfact=zetaa*cdfitc(i)*cdfitc(j)*coeffs(ilabel)*coeffs(jlabel)

      if(i.ne.j) cfact=cfact+cfact

      gradient(1,nc1)=gradient(1,nc1)-cfact*px0
      gradient(2,nc1)=gradient(2,nc1)-cfact*py0
      gradient(3,nc1)=gradient(3,nc1)-cfact*pz0

      gradient(1,nc2)=gradient(1,nc2)+cfact*px0
      gradient(2,nc2)=gradient(2,nc2)+cfact*py0
      gradient(3,nc2)=gradient(3,nc2)+cfact*pz0

 1001 continue

      return
      end

      subroutine cdcalls(nreal,ncds,ncdspd,ndim,nmaxatoms,natoms,
     &                   nbsystems,isys,icdlsave,ilfunc,icfunc,iwkvec,
     &                   cutoff,alpha,coeffs,coeffp,coeffd,cdsmat,cent,
     &                   wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension isys(nmaxatoms,*),icdlsave(*),ilfunc(*),icfunc(*),
     &          iwkvec(*)

      dimension alpha(*),coeffs(*),coeffp(*),coeffd(*),cdsmat(ndim,*)
      dimension cent(3,*),wkvec(*)

      data zero/0.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ntotal=ncds+10*ncdspd

      do 1001 i=1,ndim
      do 1001 j=1,i
 1001 cdsmat(i,j)=zero

      call cdovss(ncds,ntotal,ilfunc,icfunc,alpha,coeffs,cdsmat,cent)

      call cdovxs(ncds,ncdspd,ntotal,ilfunc,icfunc,alpha,coeffs,coeffp,
     &            coeffd,cdsmat,cent)

      call cdovxx(ncds,ncdspd,ntotal,ilfunc,icfunc,alpha,coeffs,coeffp,
     &            coeffd,cdsmat,cent)

      call mpi_reduce(cdsmat,wkvec,ntotal*ntotal,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1002 i=1,ntotal
                          do 1002 j=1,i
                          ij=(j-1)*ntotal+i
                          cdsmat(i,j)=wkvec(ij)
 1002                     cdsmat(j,i)=wkvec(ij)

                          rewind 17

                          do 1003 i=1,ntotal
 1003                     call fastwr(17,cdsmat(1,i),ntotal)
                    endif

      ncds_save=ncds
      ncdspd_save=ncdspd

      do 1004 i=1,ndim
 1004 icdlsave(i)=ilfunc(i)

      rewind 18

      do 1005 i=1,nbsystems

      do 1006 j=1,natoms
 1006 iwkvec(j)=0

      do 1007 j=1,isys(1,i)
 1007 iwkvec(isys(j+1,i))=1

      do 1008 j=1,natoms
      do 1008 k=1,isys(1,i)
 1008 if(dist(cent(1,j),cent(1,isys(k+1,i))).le.cutoff) iwkvec(j)=1

      ncds=0

      do 1009 j=1,ncds_save
      if(iwkvec(icfunc(icdlsave(j))).eq.1) then

                               ncds=ncds+1
                               ilfunc(ncds)=icdlsave(j)

                                           endif
 1009 continue

      ncdspd=0

      do 1010 j=1,ncdspd_save
      if(iwkvec(icfunc(icdlsave(ncds_save+j))).eq.1) then

                               ncdspd=ncdspd+1
                               ilfunc(ncds+ncdspd)=icdlsave(ncds_save+j)

                                                     endif
 1010 continue

      ntotal=ncds+10*ncdspd

      do 1011 j=1,ndim
      do 1011 k=1,j
 1011 cdsmat(j,k)=zero

      call cdovss(ncds,ntotal,ilfunc,icfunc,alpha,coeffs,cdsmat,cent)

      call cdovxs(ncds,ncdspd,ntotal,ilfunc,icfunc,alpha,coeffs,coeffp,
     &            coeffd,cdsmat,cent)

      call cdovxx(ncds,ncdspd,ntotal,ilfunc,icfunc,alpha,coeffs,coeffp,
     &            coeffd,cdsmat,cent)

      call mpi_reduce(cdsmat,wkvec,ntotal*ntotal,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1012 j=1,ntotal
                          do 1012 k=1,j
                          jk=(k-1)*ntotal+j
                          cdsmat(j,k)=wkvec(jk)
 1012                     cdsmat(k,j)=wkvec(jk)

                          do 1013 k=1,ntotal
                          do 1013 j=1,ntotal
 1013                     wkvec(ntotal*(k-1)+j)=cdsmat(j,k)
                    endif

      call mpi_bcast(wkvec,ntotal**2,mpi_real8,0,mpi_comm_world,ierr)

      ja=1
      jb=ja+ntotal*ntotal
      jc=jb+ntotal*ntotal
      jd=jc+ntotal*ntotal
      je=jd+ntotal*ntotal
      jf=je+ntotal
      jg=jf+ntotal
      jh=jg+ntotal
      ji=jh+ntotal

      if(ji.gt.nreal) stop 'real overflow in cdcalls'

      call x_annihilate(18,ntotal,iwkvec,iwkvec(numprocs+1),wkvec(ja),
     &                  cdsmat,wkvec(jb),wkvec(jc),wkvec(jd),wkvec(je),
     &                  wkvec(jf),wkvec(jg),wkvec(jh))

      ncds=ncds_save
      ncdspd=ncdspd_save

      do 1014 j=1,ndim
 1014 ilfunc(j)=icdlsave(j)

 1005 continue

      return
      end

      subroutine gradcdds(m,n,ncds,ilfunc,icfunc,icontr,inddyy,icentr,
     &                    iicontr,g,coord,density,gradient,cdfitc,
     &                    alphaaux,coeffs,zeta,twozetaa,twozetab,px,py,
     &                    pz,base,pxax,pyay,pzaz,axbx,ayby,azbz,zzeta,
     &                    ttwozetaa,ttwozetab,zetarec,ppx,ppy,ppz,ppxax,
     &                    ppyay,ppzaz,wxpx,wypy,wzpz,zetac1,u,sss0,sss1,
     &                    sss2,sss3,pss0,pss1,pss2,dss0,dss1,fss0,c,c1,
     &                    pscond,dscond,fscond,dpcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),icontr(*),inddyy(m,*),icentr(m,*),
     &          iicontr(*)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),zeta(*),twozetaa(*),twozetab(*),
     &          px(*),py(*),pz(*),base(*),pxax(*),pyay(*),pzaz(*),
     &          axbx(*),ayby(*),azbz(*),zzeta(*),ttwozetaa(*),
     &          ttwozetab(*),zetarec(*),ppx(*),ppy(*),ppz(*),ppxax(*),
     &          ppyay(*),ppzaz(*),wxpx(*),wypy(*),wzpz(*),zetac1(*),
     &          u(*),sss0(*),sss1(*),sss2(*),sss3(*),pss0(n,*),
     &          pss1(n,*),pss2(n,*),dss0(n,*),dss1(n,*),fss0(n,*),c(*),
     &          c1(n,*),pscond(m,*),dscond(m,*),fscond(m,*),dpcond(m,*),
     &          grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(4,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(3)/zeta(i)/zetaux
 1004 sss3(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(4)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
 1006 zetac1(i)=zetaux*zetarec(i)

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1008 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1009 i=1,nn
      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
 1009 pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      do 1010 i=1,nn
      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
 1010 pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      do 1011 i=1,nn
 1011 c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      do 1012 i=1,nn
      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
 1012 dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      do 1013 i=1,nn
 1013 c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      do 1014 i=1,nn
      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
 1014 dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      do 1015 j=1,3
      do 1015 i=1,nn
 1015 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zzeta(i))

      do 1016 i=1,nn
      fss0(i,01)=ppxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=ppyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=ppzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=ppyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=ppzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=ppzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=ppyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=ppzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=ppzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 1016 fss0(i,10)=ppzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 1017 j=1,3
      do 1017 i=1,m
 1017 pscond(i,j)=zero

      do 1018 j=1,3
      do 1018 i=1,nn
 1018 pscond(iicontr(i),j)=pscond(iicontr(i),j)-pss0(i,j)

      do 1019 i=1,m
      grad(i,1)=pscond(i,1)*density(inddyy(i,1))*cdfits*two
      grad(i,2)=pscond(i,2)*density(inddyy(i,2))*cdfits
      grad(i,3)=pscond(i,3)*density(inddyy(i,3))*cdfits
      grad(i,4)=pscond(i,1)*density(inddyy(i,2))*cdfits
      grad(i,5)=pscond(i,2)*density(inddyy(i,4))*cdfits*two
      grad(i,6)=pscond(i,3)*density(inddyy(i,5))*cdfits
      grad(i,7)=pscond(i,1)*density(inddyy(i,3))*cdfits
      grad(i,8)=pscond(i,2)*density(inddyy(i,5))*cdfits
 1019 grad(i,9)=pscond(i,3)*density(inddyy(i,6))*cdfits*two

      do 1020 k=1,3
      do 1020 j=1,3
      do 1020 i=1,m
 1020 gradient(k,nc)=gradient(k,nc)-grad(i,3*(k-1)+j)

      do 1021 k=1,3
      do 1021 j=1,3
      do 1021 i=1,m
 1021 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,3*(k-1)+j)

      do 1022 j=1,10
      do 1022 i=1,m
 1022 fscond(i,j)=zero

      do 1023 j=1,10
      do 1023 i=1,nn
 1023 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetaa(i)

      do 1024 i=1,m
      grad(i,01)=fscond(i,01)*density(inddyy(i,1))*cdfits
      grad(i,02)=fscond(i,02)*density(inddyy(i,2))*cdfits
      grad(i,03)=fscond(i,03)*density(inddyy(i,3))*cdfits
      grad(i,04)=fscond(i,04)*density(inddyy(i,4))*cdfits
      grad(i,05)=fscond(i,05)*density(inddyy(i,5))*cdfits
      grad(i,06)=fscond(i,06)*density(inddyy(i,6))*cdfits
      grad(i,07)=fscond(i,02)*density(inddyy(i,1))*cdfits
      grad(i,08)=fscond(i,04)*density(inddyy(i,2))*cdfits
      grad(i,09)=fscond(i,05)*density(inddyy(i,3))*cdfits
      grad(i,10)=fscond(i,07)*density(inddyy(i,4))*cdfits
      grad(i,11)=fscond(i,08)*density(inddyy(i,5))*cdfits
      grad(i,12)=fscond(i,09)*density(inddyy(i,6))*cdfits
      grad(i,13)=fscond(i,03)*density(inddyy(i,1))*cdfits
      grad(i,14)=fscond(i,05)*density(inddyy(i,2))*cdfits
      grad(i,15)=fscond(i,06)*density(inddyy(i,3))*cdfits
      grad(i,16)=fscond(i,08)*density(inddyy(i,4))*cdfits
      grad(i,17)=fscond(i,09)*density(inddyy(i,5))*cdfits
 1024 grad(i,18)=fscond(i,10)*density(inddyy(i,6))*cdfits

      do 1025 k=1,3
      do 1025 j=1,6
      do 1025 i=1,m
 1025 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1026 k=1,3
      do 1026 j=1,6
      do 1026 i=1,m
 1026 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,6*(k-1)+j)

      do 1027 j=1,6
      do 1027 i=1,m
 1027 dscond(i,j)=zero

      do 1028 j=1,10
      do 1028 i=1,m
 1028 fscond(i,j)=zero

      do 1029 j=1,6
      do 1029 i=1,nn
 1029 dscond(iicontr(i),j)=dscond(iicontr(i),j)+dss0(i,j)*ttwozetab(i)

      do 1030 j=1,10
      do 1030 i=1,nn
 1030 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetab(i)

      do 1031 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1031 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1032 i=1,m
      grad(i,01)=dpcond(i,01)*density(inddyy(i,1))*cdfits
      grad(i,02)=dpcond(i,04)*density(inddyy(i,2))*cdfits
      grad(i,03)=dpcond(i,07)*density(inddyy(i,3))*cdfits
      grad(i,04)=dpcond(i,10)*density(inddyy(i,4))*cdfits
      grad(i,05)=dpcond(i,13)*density(inddyy(i,5))*cdfits
      grad(i,06)=dpcond(i,16)*density(inddyy(i,6))*cdfits
      grad(i,07)=dpcond(i,02)*density(inddyy(i,1))*cdfits
      grad(i,08)=dpcond(i,05)*density(inddyy(i,2))*cdfits
      grad(i,09)=dpcond(i,08)*density(inddyy(i,3))*cdfits
      grad(i,10)=dpcond(i,11)*density(inddyy(i,4))*cdfits
      grad(i,11)=dpcond(i,14)*density(inddyy(i,5))*cdfits
      grad(i,12)=dpcond(i,17)*density(inddyy(i,6))*cdfits
      grad(i,13)=dpcond(i,03)*density(inddyy(i,1))*cdfits
      grad(i,14)=dpcond(i,06)*density(inddyy(i,2))*cdfits
      grad(i,15)=dpcond(i,09)*density(inddyy(i,3))*cdfits
      grad(i,16)=dpcond(i,12)*density(inddyy(i,4))*cdfits
      grad(i,17)=dpcond(i,15)*density(inddyy(i,5))*cdfits
 1032 grad(i,18)=dpcond(i,18)*density(inddyy(i,6))*cdfits

      do 1033 k=1,3
      do 1033 j=1,6
      do 1033 i=1,m
 1033 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1034 k=1,3
      do 1034 j=1,6
      do 1034 i=1,m
 1034 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

 1001 continue

      return
      end

      subroutine fastwr(nunit,a,n)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      real*8 a(n)

      write(nunit) a

      return
      end

      logical function collid(cprobe,rprobe,c,r,n)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
c
c  this is based on a subroutine taken out of connolly's ms program.

      implicit real*8(a-h,o-z)

      dimension cprobe(*),c(3,*),r(*)

      if(n.gt.0) then

                       do 1001 i=1,n

                       s=rprobe+r(i)

                       ss=s*s

                       xx=cprobe(1)-c(1,i)
                       yy=cprobe(2)-c(2,i)
                       zz=cprobe(3)-c(3,i)

                       dd=xx*xx+yy*yy+zz*zz

                       if(dd.lt.ss) goto 1002

 1001                  continue

                 endif

      collid=.false.
      return

 1002 collid=.true.
      return

      end

      subroutine gradcddp(m,n,ncds,ilfunc,icfunc,icontr,inddyy,icentr,
     &                    iicontr,g,coord,density,gradient,cdfitc,
     &                    alphaaux,coeffs,zeta,twozetaa,twozetab,px,py,
     &                    pz,base,pxax,pyay,pzaz,axbx,ayby,azbz,zzeta,
     &                    ttwozetaa,ttwozetab,zetarec,ppx,ppy,ppz,ppxax,
     &                    ppyay,ppzaz,wxpx,wypy,wzpz,zetac1,u,sss0,sss1,
     &                    sss2,sss3,sss4,pss0,pss1,pss2,pss3,dss0,dss1,
     &                    dss2,fss0,fss1,gss0,c,c1,pscond,dscond,ppcond,
     &                    fscond,dpcond,gscond,fpcond,ddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),icontr(*),inddyy(m,*),icentr(m,*),
     &          iicontr(*)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),zeta(*),twozetaa(*),twozetab(*),
     &          px(*),py(*),pz(*),base(*),pxax(*),pyay(*),pzaz(*),
     &          axbx(*),ayby(*),azbz(*),zzeta(*),ttwozetaa(*),
     &          ttwozetab(*),zetarec(*),ppx(*),ppy(*),ppz(*),ppxax(*),
     &          ppyay(*),ppzaz(*),wxpx(*),wypy(*),wzpz(*),zetac1(*),
     &          u(*),sss0(*),sss1(*),sss2(*),sss3(*),sss4(*),pss0(n,*),
     &          pss1(n,*),pss2(n,*),pss3(n,*),dss0(n,*),dss1(n,*),
     &          dss2(n,*),fss0(n,*),fss1(n,*),gss0(n,*),c(*),c1(n,*),
     &          pscond(m,*),dscond(m,*),ppcond(m,*),fscond(m,*),
     &          dpcond(m,*),gscond(m,*),fpcond(m,*),ddcond(m,*),
     &          grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(5,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(4)/zeta(i)/zetaux
 1004 sss4(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(5)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                       sss4(nn)=sss4(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
 1006 zetac1(i)=zetaux*zetarec(i)

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1008 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1009 i=1,nn
      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
 1009 pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      do 1010 i=1,nn
      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
 1010 pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      do 1011 i=1,nn
      pss3(i,1)=ppxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=ppyay(i)*sss3(i)+wypy(i)*sss4(i)
 1011 pss3(i,3)=ppzaz(i)*sss3(i)+wzpz(i)*sss4(i)

      do 1012 i=1,nn
 1012 c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      do 1013 i=1,nn
      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
 1013 dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      do 1014 i=1,nn
 1014 c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      do 1015 i=1,nn
      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
 1015 dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      do 1016 i=1,nn
 1016 c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zzeta(i))

      do 1017 i=1,nn
      dss2(i,1)=ppxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=ppyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=ppzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=ppyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=ppzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
 1017 dss2(i,6)=ppzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

      do 1018 j=1,3
      do 1018 i=1,nn
 1018 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zzeta(i))

      do 1019 i=1,nn
      fss0(i,01)=ppxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=ppyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=ppzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=ppyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=ppzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=ppzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=ppyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=ppzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=ppzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 1019 fss0(i,10)=ppzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 1020 j=1,3
      do 1020 i=1,nn
 1020 c1(i,j)=(pss1(i,j)-zetac1(i)*pss2(i,j))/(two*zzeta(i))

      do 1021 i=1,nn
      fss1(i,01)=ppxax(i)*dss1(i,1)+wxpx(i)*dss2(i,1)+c1(i,1)+c1(i,1)
      fss1(i,02)=ppyay(i)*dss1(i,1)+wypy(i)*dss2(i,1)
      fss1(i,03)=ppzaz(i)*dss1(i,1)+wzpz(i)*dss2(i,1)
      fss1(i,04)=ppyay(i)*dss1(i,2)+wypy(i)*dss2(i,2)+c1(i,1)
      fss1(i,05)=ppzaz(i)*dss1(i,2)+wzpz(i)*dss2(i,2)
      fss1(i,06)=ppzaz(i)*dss1(i,3)+wzpz(i)*dss2(i,3)+c1(i,1)
      fss1(i,07)=ppyay(i)*dss1(i,4)+wypy(i)*dss2(i,4)+c1(i,2)+c1(i,2)
      fss1(i,08)=ppzaz(i)*dss1(i,4)+wzpz(i)*dss2(i,4)
      fss1(i,09)=ppzaz(i)*dss1(i,5)+wzpz(i)*dss2(i,5)+c1(i,2)
 1021 fss1(i,10)=ppzaz(i)*dss1(i,6)+wzpz(i)*dss2(i,6)+c1(i,3)+c1(i,3)

      do 1022 j=1,6
      do 1022 i=1,nn
 1022 c1(i,j)=(dss0(i,j)-zetac1(i)*dss1(i,j))/(two*zzeta(i))

      do 1023 i=1,nn
      gss0(i,01)=ppxax(i)*fss0(i,01)+wxpx(i)*fss1(i,01)+c1(i,1)*three
      gss0(i,02)=ppyay(i)*fss0(i,01)+wypy(i)*fss1(i,01)
      gss0(i,03)=ppzaz(i)*fss0(i,01)+wzpz(i)*fss1(i,01)
      gss0(i,04)=ppyay(i)*fss0(i,02)+wypy(i)*fss1(i,02)+c1(i,1)
      gss0(i,05)=ppzaz(i)*fss0(i,02)+wzpz(i)*fss1(i,02)
      gss0(i,06)=ppzaz(i)*fss0(i,03)+wzpz(i)*fss1(i,03)+c1(i,1)
      gss0(i,07)=ppyay(i)*fss0(i,04)+wypy(i)*fss1(i,04)+c1(i,2)*two
      gss0(i,08)=ppzaz(i)*fss0(i,04)+wzpz(i)*fss1(i,04)
      gss0(i,09)=ppzaz(i)*fss0(i,05)+wzpz(i)*fss1(i,05)+c1(i,2)
      gss0(i,10)=ppzaz(i)*fss0(i,06)+wzpz(i)*fss1(i,06)+c1(i,3)*two
      gss0(i,11)=ppyay(i)*fss0(i,07)+wypy(i)*fss1(i,07)+c1(i,4)*three
      gss0(i,12)=ppzaz(i)*fss0(i,07)+wzpz(i)*fss1(i,07)
      gss0(i,13)=ppzaz(i)*fss0(i,08)+wzpz(i)*fss1(i,08)+c1(i,4)
      gss0(i,14)=ppzaz(i)*fss0(i,09)+wzpz(i)*fss1(i,09)+c1(i,5)*two
 1023 gss0(i,15)=ppzaz(i)*fss0(i,10)+wzpz(i)*fss1(i,10)+c1(i,6)*three

      do 1024 j=1,3
      do 1024 i=1,m
 1024 pscond(i,j)=zero

      do 1025 j=1,6
      do 1025 i=1,m
 1025 dscond(i,j)=zero

      do 1026 j=1,3
      do 1026 i=1,nn
 1026 pscond(iicontr(i),j)=pscond(iicontr(i),j)-pss0(i,j)

      do 1027 j=1,6
      do 1027 i=1,nn
 1027 dscond(iicontr(i),j)=dscond(iicontr(i),j)-dss0(i,j)

      do 1028 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1028 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1029 i=1,m
      grad(i,01)=ppcond(i,1)*density(inddyy(i,01))*cdfits*two
      grad(i,02)=ppcond(i,2)*density(inddyy(i,02))*cdfits*two
      grad(i,03)=ppcond(i,3)*density(inddyy(i,03))*cdfits*two
      grad(i,04)=ppcond(i,4)*density(inddyy(i,04))*cdfits
      grad(i,05)=ppcond(i,5)*density(inddyy(i,05))*cdfits
      grad(i,06)=ppcond(i,6)*density(inddyy(i,06))*cdfits
      grad(i,07)=ppcond(i,7)*density(inddyy(i,07))*cdfits
      grad(i,08)=ppcond(i,8)*density(inddyy(i,08))*cdfits
      grad(i,09)=ppcond(i,9)*density(inddyy(i,09))*cdfits
      grad(i,10)=ppcond(i,1)*density(inddyy(i,04))*cdfits
      grad(i,11)=ppcond(i,2)*density(inddyy(i,05))*cdfits
      grad(i,12)=ppcond(i,3)*density(inddyy(i,06))*cdfits
      grad(i,13)=ppcond(i,4)*density(inddyy(i,10))*cdfits*two
      grad(i,14)=ppcond(i,5)*density(inddyy(i,11))*cdfits*two
      grad(i,15)=ppcond(i,6)*density(inddyy(i,12))*cdfits*two
      grad(i,16)=ppcond(i,7)*density(inddyy(i,13))*cdfits
      grad(i,17)=ppcond(i,8)*density(inddyy(i,14))*cdfits
      grad(i,18)=ppcond(i,9)*density(inddyy(i,15))*cdfits
      grad(i,19)=ppcond(i,1)*density(inddyy(i,07))*cdfits
      grad(i,20)=ppcond(i,2)*density(inddyy(i,08))*cdfits
      grad(i,21)=ppcond(i,3)*density(inddyy(i,09))*cdfits
      grad(i,22)=ppcond(i,4)*density(inddyy(i,13))*cdfits
      grad(i,23)=ppcond(i,5)*density(inddyy(i,14))*cdfits
      grad(i,24)=ppcond(i,6)*density(inddyy(i,15))*cdfits
      grad(i,25)=ppcond(i,7)*density(inddyy(i,16))*cdfits*two
      grad(i,26)=ppcond(i,8)*density(inddyy(i,17))*cdfits*two
 1029 grad(i,27)=ppcond(i,9)*density(inddyy(i,18))*cdfits*two

      do 1030 k=1,3
      do 1030 j=1,9
      do 1030 i=1,m
 1030 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1031 k=1,3
      do 1031 j=1,9
      do 1031 i=1,m
 1031 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

      do 1032 i=1,m
      grad(i,01)=dscond(i,1)*density(inddyy(i,01))*cdfits
      grad(i,02)=dscond(i,2)*density(inddyy(i,04))*cdfits
      grad(i,03)=dscond(i,3)*density(inddyy(i,07))*cdfits
      grad(i,04)=dscond(i,4)*density(inddyy(i,10))*cdfits
      grad(i,05)=dscond(i,5)*density(inddyy(i,13))*cdfits
      grad(i,06)=dscond(i,6)*density(inddyy(i,16))*cdfits
      grad(i,07)=dscond(i,1)*density(inddyy(i,02))*cdfits
      grad(i,08)=dscond(i,2)*density(inddyy(i,05))*cdfits
      grad(i,09)=dscond(i,3)*density(inddyy(i,08))*cdfits
      grad(i,10)=dscond(i,4)*density(inddyy(i,11))*cdfits
      grad(i,11)=dscond(i,5)*density(inddyy(i,14))*cdfits
      grad(i,12)=dscond(i,6)*density(inddyy(i,17))*cdfits
      grad(i,13)=dscond(i,1)*density(inddyy(i,03))*cdfits
      grad(i,14)=dscond(i,2)*density(inddyy(i,06))*cdfits
      grad(i,15)=dscond(i,3)*density(inddyy(i,09))*cdfits
      grad(i,16)=dscond(i,4)*density(inddyy(i,12))*cdfits
      grad(i,17)=dscond(i,5)*density(inddyy(i,15))*cdfits
 1032 grad(i,18)=dscond(i,6)*density(inddyy(i,18))*cdfits

      do 1033 k=1,3
      do 1033 j=1,6
      do 1033 i=1,m
 1033 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1034 k=1,3
      do 1034 j=1,6
      do 1034 i=1,m
 1034 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

      do 1035 j=1,10
      do 1035 i=1,m
 1035 fscond(i,j)=zero

      do 1036 j=1,15
      do 1036 i=1,m
 1036 gscond(i,j)=zero

      do 1037 j=1,10
      do 1037 i=1,nn
 1037 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetaa(i)

      do 1038 j=1,15
      do 1038 i=1,nn
 1038 gscond(iicontr(i),j)=gscond(iicontr(i),j)+gss0(i,j)*ttwozetaa(i)

      do 1039 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1039 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1040 i=1,m
      grad(i,01)=fpcond(i,01)*density(inddyy(i,01))*cdfits
      grad(i,02)=fpcond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,03)=fpcond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,04)=fpcond(i,04)*density(inddyy(i,04))*cdfits
      grad(i,05)=fpcond(i,05)*density(inddyy(i,05))*cdfits
      grad(i,06)=fpcond(i,06)*density(inddyy(i,06))*cdfits
      grad(i,07)=fpcond(i,07)*density(inddyy(i,07))*cdfits
      grad(i,08)=fpcond(i,08)*density(inddyy(i,08))*cdfits
      grad(i,09)=fpcond(i,09)*density(inddyy(i,09))*cdfits
      grad(i,10)=fpcond(i,10)*density(inddyy(i,10))*cdfits
      grad(i,11)=fpcond(i,11)*density(inddyy(i,11))*cdfits
      grad(i,12)=fpcond(i,12)*density(inddyy(i,12))*cdfits
      grad(i,13)=fpcond(i,13)*density(inddyy(i,13))*cdfits
      grad(i,14)=fpcond(i,14)*density(inddyy(i,14))*cdfits
      grad(i,15)=fpcond(i,15)*density(inddyy(i,15))*cdfits
      grad(i,16)=fpcond(i,16)*density(inddyy(i,16))*cdfits
      grad(i,17)=fpcond(i,17)*density(inddyy(i,17))*cdfits
      grad(i,18)=fpcond(i,18)*density(inddyy(i,18))*cdfits
      grad(i,19)=fpcond(i,04)*density(inddyy(i,01))*cdfits
      grad(i,20)=fpcond(i,05)*density(inddyy(i,02))*cdfits
      grad(i,21)=fpcond(i,06)*density(inddyy(i,03))*cdfits
      grad(i,22)=fpcond(i,10)*density(inddyy(i,04))*cdfits
      grad(i,23)=fpcond(i,11)*density(inddyy(i,05))*cdfits
      grad(i,24)=fpcond(i,12)*density(inddyy(i,06))*cdfits
      grad(i,25)=fpcond(i,13)*density(inddyy(i,07))*cdfits
      grad(i,26)=fpcond(i,14)*density(inddyy(i,08))*cdfits
      grad(i,27)=fpcond(i,15)*density(inddyy(i,09))*cdfits
      grad(i,28)=fpcond(i,19)*density(inddyy(i,10))*cdfits
      grad(i,29)=fpcond(i,20)*density(inddyy(i,11))*cdfits
      grad(i,30)=fpcond(i,21)*density(inddyy(i,12))*cdfits
      grad(i,31)=fpcond(i,22)*density(inddyy(i,13))*cdfits
      grad(i,32)=fpcond(i,23)*density(inddyy(i,14))*cdfits
      grad(i,33)=fpcond(i,24)*density(inddyy(i,15))*cdfits
      grad(i,34)=fpcond(i,25)*density(inddyy(i,16))*cdfits
      grad(i,35)=fpcond(i,26)*density(inddyy(i,17))*cdfits
      grad(i,36)=fpcond(i,27)*density(inddyy(i,18))*cdfits
      grad(i,37)=fpcond(i,07)*density(inddyy(i,01))*cdfits
      grad(i,38)=fpcond(i,08)*density(inddyy(i,02))*cdfits
      grad(i,39)=fpcond(i,09)*density(inddyy(i,03))*cdfits
      grad(i,40)=fpcond(i,13)*density(inddyy(i,04))*cdfits
      grad(i,41)=fpcond(i,14)*density(inddyy(i,05))*cdfits
      grad(i,42)=fpcond(i,15)*density(inddyy(i,06))*cdfits
      grad(i,43)=fpcond(i,16)*density(inddyy(i,07))*cdfits
      grad(i,44)=fpcond(i,17)*density(inddyy(i,08))*cdfits
      grad(i,45)=fpcond(i,18)*density(inddyy(i,09))*cdfits
      grad(i,46)=fpcond(i,22)*density(inddyy(i,10))*cdfits
      grad(i,47)=fpcond(i,23)*density(inddyy(i,11))*cdfits
      grad(i,48)=fpcond(i,24)*density(inddyy(i,12))*cdfits
      grad(i,49)=fpcond(i,25)*density(inddyy(i,13))*cdfits
      grad(i,50)=fpcond(i,26)*density(inddyy(i,14))*cdfits
      grad(i,51)=fpcond(i,27)*density(inddyy(i,15))*cdfits
      grad(i,52)=fpcond(i,28)*density(inddyy(i,16))*cdfits
      grad(i,53)=fpcond(i,29)*density(inddyy(i,17))*cdfits
 1040 grad(i,54)=fpcond(i,30)*density(inddyy(i,18))*cdfits

      do 1041 k=1,3
      do 1041 j=1,18
      do 1041 i=1,m
 1041 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1042 k=1,3
      do 1042 j=1,18
      do 1042 i=1,m
 1042 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

      do 1043 j=1,6
      do 1043 i=1,m
 1043 dscond(i,j)=zero

      do 1044 j=1,10
      do 1044 i=1,m
 1044 fscond(i,j)=zero

      do 1045 j=1,15
      do 1045 i=1,m
 1045 gscond(i,j)=zero

      do 1046 j=1,6
      do 1046 i=1,nn
 1046 dscond(iicontr(i),j)=dscond(iicontr(i),j)+dss0(i,j)*ttwozetab(i)

      do 1047 j=1,10
      do 1047 i=1,nn
 1047 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetab(i)

      do 1048 j=1,15
      do 1048 i=1,nn
 1048 gscond(iicontr(i),j)=gscond(iicontr(i),j)+gss0(i,j)*ttwozetab(i)

      do 1049 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1049 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1050 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1050 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1051 i=1,m
      ddcond(i,01)=axbx(i)*dpcond(i,01)+fpcond(i,01)
      ddcond(i,02)=ayby(i)*dpcond(i,01)+fpcond(i,04)
      ddcond(i,03)=azbz(i)*dpcond(i,01)+fpcond(i,07)
      ddcond(i,04)=ayby(i)*dpcond(i,02)+fpcond(i,05)
      ddcond(i,05)=azbz(i)*dpcond(i,02)+fpcond(i,08)
      ddcond(i,06)=azbz(i)*dpcond(i,03)+fpcond(i,09)
      ddcond(i,07)=axbx(i)*dpcond(i,04)+fpcond(i,04)
      ddcond(i,08)=ayby(i)*dpcond(i,04)+fpcond(i,10)
      ddcond(i,09)=azbz(i)*dpcond(i,04)+fpcond(i,13)
      ddcond(i,10)=ayby(i)*dpcond(i,05)+fpcond(i,11)
      ddcond(i,11)=azbz(i)*dpcond(i,05)+fpcond(i,14)
      ddcond(i,12)=azbz(i)*dpcond(i,06)+fpcond(i,15)
      ddcond(i,13)=axbx(i)*dpcond(i,07)+fpcond(i,07)
      ddcond(i,14)=ayby(i)*dpcond(i,07)+fpcond(i,13)
      ddcond(i,15)=azbz(i)*dpcond(i,07)+fpcond(i,16)
      ddcond(i,16)=ayby(i)*dpcond(i,08)+fpcond(i,14)
      ddcond(i,17)=azbz(i)*dpcond(i,08)+fpcond(i,17)
      ddcond(i,18)=azbz(i)*dpcond(i,09)+fpcond(i,18)
      ddcond(i,19)=axbx(i)*dpcond(i,10)+fpcond(i,10)
      ddcond(i,20)=ayby(i)*dpcond(i,10)+fpcond(i,19)
      ddcond(i,21)=azbz(i)*dpcond(i,10)+fpcond(i,22)
      ddcond(i,22)=ayby(i)*dpcond(i,11)+fpcond(i,20)
      ddcond(i,23)=azbz(i)*dpcond(i,11)+fpcond(i,23)
      ddcond(i,24)=azbz(i)*dpcond(i,12)+fpcond(i,24)
      ddcond(i,25)=axbx(i)*dpcond(i,13)+fpcond(i,13)
      ddcond(i,26)=ayby(i)*dpcond(i,13)+fpcond(i,22)
      ddcond(i,27)=azbz(i)*dpcond(i,13)+fpcond(i,25)
      ddcond(i,28)=ayby(i)*dpcond(i,14)+fpcond(i,23)
      ddcond(i,29)=azbz(i)*dpcond(i,14)+fpcond(i,26)
      ddcond(i,30)=azbz(i)*dpcond(i,15)+fpcond(i,27)
      ddcond(i,31)=axbx(i)*dpcond(i,16)+fpcond(i,16)
      ddcond(i,32)=ayby(i)*dpcond(i,16)+fpcond(i,25)
      ddcond(i,33)=azbz(i)*dpcond(i,16)+fpcond(i,28)
      ddcond(i,34)=ayby(i)*dpcond(i,17)+fpcond(i,26)
      ddcond(i,35)=azbz(i)*dpcond(i,17)+fpcond(i,29)
 1051 ddcond(i,36)=azbz(i)*dpcond(i,18)+fpcond(i,30)

      do 1052 i=1,m
      grad(i,01)=ddcond(i,01)*density(inddyy(i,01))*cdfits
      grad(i,02)=ddcond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,03)=ddcond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,04)=ddcond(i,07)*density(inddyy(i,04))*cdfits
      grad(i,05)=ddcond(i,08)*density(inddyy(i,05))*cdfits
      grad(i,06)=ddcond(i,09)*density(inddyy(i,06))*cdfits
      grad(i,07)=ddcond(i,13)*density(inddyy(i,07))*cdfits
      grad(i,08)=ddcond(i,14)*density(inddyy(i,08))*cdfits
      grad(i,09)=ddcond(i,15)*density(inddyy(i,09))*cdfits
      grad(i,10)=ddcond(i,19)*density(inddyy(i,10))*cdfits
      grad(i,11)=ddcond(i,20)*density(inddyy(i,11))*cdfits
      grad(i,12)=ddcond(i,21)*density(inddyy(i,12))*cdfits
      grad(i,13)=ddcond(i,25)*density(inddyy(i,13))*cdfits
      grad(i,14)=ddcond(i,26)*density(inddyy(i,14))*cdfits
      grad(i,15)=ddcond(i,27)*density(inddyy(i,15))*cdfits
      grad(i,16)=ddcond(i,31)*density(inddyy(i,16))*cdfits
      grad(i,17)=ddcond(i,32)*density(inddyy(i,17))*cdfits
      grad(i,18)=ddcond(i,33)*density(inddyy(i,18))*cdfits
      grad(i,19)=ddcond(i,02)*density(inddyy(i,01))*cdfits
      grad(i,20)=ddcond(i,04)*density(inddyy(i,02))*cdfits
      grad(i,21)=ddcond(i,05)*density(inddyy(i,03))*cdfits
      grad(i,22)=ddcond(i,08)*density(inddyy(i,04))*cdfits
      grad(i,23)=ddcond(i,10)*density(inddyy(i,05))*cdfits
      grad(i,24)=ddcond(i,11)*density(inddyy(i,06))*cdfits
      grad(i,25)=ddcond(i,14)*density(inddyy(i,07))*cdfits
      grad(i,26)=ddcond(i,16)*density(inddyy(i,08))*cdfits
      grad(i,27)=ddcond(i,17)*density(inddyy(i,09))*cdfits
      grad(i,28)=ddcond(i,20)*density(inddyy(i,10))*cdfits
      grad(i,29)=ddcond(i,22)*density(inddyy(i,11))*cdfits
      grad(i,30)=ddcond(i,23)*density(inddyy(i,12))*cdfits
      grad(i,31)=ddcond(i,26)*density(inddyy(i,13))*cdfits
      grad(i,32)=ddcond(i,28)*density(inddyy(i,14))*cdfits
      grad(i,33)=ddcond(i,29)*density(inddyy(i,15))*cdfits
      grad(i,34)=ddcond(i,32)*density(inddyy(i,16))*cdfits
      grad(i,35)=ddcond(i,34)*density(inddyy(i,17))*cdfits
      grad(i,36)=ddcond(i,35)*density(inddyy(i,18))*cdfits
      grad(i,37)=ddcond(i,03)*density(inddyy(i,01))*cdfits
      grad(i,38)=ddcond(i,05)*density(inddyy(i,02))*cdfits
      grad(i,39)=ddcond(i,06)*density(inddyy(i,03))*cdfits
      grad(i,40)=ddcond(i,09)*density(inddyy(i,04))*cdfits
      grad(i,41)=ddcond(i,11)*density(inddyy(i,05))*cdfits
      grad(i,42)=ddcond(i,12)*density(inddyy(i,06))*cdfits
      grad(i,43)=ddcond(i,15)*density(inddyy(i,07))*cdfits
      grad(i,44)=ddcond(i,17)*density(inddyy(i,08))*cdfits
      grad(i,45)=ddcond(i,18)*density(inddyy(i,09))*cdfits
      grad(i,46)=ddcond(i,21)*density(inddyy(i,10))*cdfits
      grad(i,47)=ddcond(i,23)*density(inddyy(i,11))*cdfits
      grad(i,48)=ddcond(i,24)*density(inddyy(i,12))*cdfits
      grad(i,49)=ddcond(i,27)*density(inddyy(i,13))*cdfits
      grad(i,50)=ddcond(i,29)*density(inddyy(i,14))*cdfits
      grad(i,51)=ddcond(i,30)*density(inddyy(i,15))*cdfits
      grad(i,52)=ddcond(i,33)*density(inddyy(i,16))*cdfits
      grad(i,53)=ddcond(i,35)*density(inddyy(i,17))*cdfits
 1052 grad(i,54)=ddcond(i,36)*density(inddyy(i,18))*cdfits

      do 1053 k=1,3
      do 1053 j=1,18
      do 1053 i=1,m
 1053 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1054 k=1,3
      do 1054 j=1,18
      do 1054 i=1,m
 1054 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

 1001 continue

      return
      end

      subroutine startscf(nreal,ninteger,nmaxatoms,nmaxorbs,nmaxaux,
     &                    nmaxpoints,natoms,nptcharges,nconts,ncontp,
     &                    ncontd,ncds,ncdspd,nxcs,nxcspd,level,
     &                    igridtype,nbsystems,isys,icdlsave,iwkvec,
     &                    nshels,nshelp,nsheld,ilfunc,icfunc,ngaussians,
     &                    matloca,icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &                    natomtype,nptsatom,energy,rhochange,diiserror,
     &                    cutoff,wkvec,core,focka,fockb,focke,overlap,
     &                    coeffa,coeffb,coord,coordptcharges,charge,
     &                    ptcharge,alpha,coeff,alphacd,coefscd,coefpcd,
     &                    coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,
     &                    cdcoef,xcoefa,xcoefb,xcoefe,dmta,dmtb,tveca,
     &                    tvecb,tvece)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension isys(nmaxatoms,*),icdlsave(*),iwkvec(*),nshels(*),
     &          nshelp(*),nsheld(*),ilfunc(*),icfunc(*),ngaussians(*),
     &          matloca(*),icdlfunc(*),icdcfunc(*),ixclfunc(*),
     &          ixccfunc(*),natomtype(*),nptsatom(*)

      dimension cutoff(*),wkvec(*),core(*),focka(*),fockb(*),focke(*),
     &          overlap(nmaxorbs,*),coeffa(nmaxorbs,*),
     &          coeffb(nmaxorbs,*),coord(3,*),coordptcharges(3,*),
     &          charge(*),ptcharge(*),alpha(*),coeff(*),alphacd(*),
     &          coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),coefsxc(*),
     &          coefpxc(*),coefdxc(*),cdcoef(*),xcoefa(*),xcoefb(*),
     &          xcoefe(*),dmta(*),dmtb(*),tveca(*),tvecb(*),tvece(*)

      data zero,one,bignumber/0.0d0,1.0d0,1.0d+35/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      if(myid.eq.0) then
                          rewind 43
                          rewind 45
                          rewind 66
                    endif

      ncontractions=nconts+3*ncontp+6*ncontd

      ndim=ncontractions*(ncontractions+1)/2

      energy=zero
      rhochange=zero
      diiserror=zero

      call gengrid(nreal,nmaxpoints,igridtype,1,natoms,nconts,ncontp,
     &             ncontd,ilfunc,icfunc,ngaussians,nshels,nshelp,nsheld,
     &             natomtype,nptsatom,iwkvec,coord,alpha,coeff,wkvec)

      ja=1
      jb=ja+(natoms+nptcharges)*3
      jc=jb+(natoms+nptcharges)
      jd=jc+ndim

      call coremm(nreal-jd-ndim,ninteger,natoms,nptcharges,nconts,
     &            ncontp,ncontd,nshels,nshelp,nsheld,matloca,ilfunc,
     &            ngaussians,icfunc,iwkvec,cutoff(3),wkvec(ja),coord,
     &            coordptcharges,wkvec(jb),charge,ptcharge,alpha,coeff,
     &            wkvec(jc),core,wkvec(jd+1))

      if(myid.eq.0) call fastwr(43,wkvec(jc),ndim)

      do 1001 j=1,ncontractions
      do 1001 k=1,ncontractions
      jk=((max(j,k)*(max(j,k)-1))/2)+min(j,k)-1
 1001 overlap(j,k)=wkvec(jc+jk)

      if(myid.eq.0) then
                          do 1002 i=1,ncontractions
 1002                     call fastwr(45,overlap(1,i),ncontractions)
                    endif

      ka=1
      kb=ka+ncontractions*ncontractions
      kc=kb+ncontractions*ncontractions
      kd=kc+ncontractions*ncontractions
      ke=kd+ncontractions
      kf=ke+ncontractions
      kg=kf+ncontractions

      call s_annihilate(nmaxorbs,ncontractions,iwkvec,
     &                  iwkvec(numprocs+1),overlap,coeffa,coeffb,
     &                  wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &                  wkvec(ke),wkvec(kf),wkvec(kg))

      nsize=ncds+10*ncdspd

      call cdcalls(nreal-nsize*nsize,ncds,ncdspd,nsize,nmaxatoms,natoms,
     &             nbsystems,isys,icdlsave,icdlfunc,icdcfunc,iwkvec,
     &             cutoff(1),alphacd,coefscd,coefpcd,coefdcd,wkvec,
     &             coord,wkvec(nsize*nsize+1))

      return
      end

      subroutine gradovdd(ndim,m,n,iminj,icontr,inddyy,icentr,density,
     &                    overlap,gradient,zeta,twozetaa,twozetab,eta,
     &                    eta2,base,etarr,pxax,pyay,pzaz,pxbx,pyby,pzbz,
     &                    twozeta,ss0,ss,ps0,ps,sp,ds0,ds,sd,fs0,fs,dp,
     &                    pd,fp,fd,c,c1,c2,pdcond,fdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*),icentr(m,*)

      dimension density(*),overlap(ndim,*),gradient(3,*),zeta(*),
     &          twozetaa(*),twozetab(*),eta(*),eta2(*),base(*),etarr(*),
     &          pxax(*),pyay(*),pzaz(*),pxbx(*),pyby(*),pzbz(*),
     &          twozeta(*),ss0(*),ss(*),ps0(n,*),ps(n,*),sp(n,*),
     &          ds0(n,*),ds(n,*),sd(n,*),fs0(n,*),fs(n,*),dp(n,*),
     &          pd(n,*),fp(n,*),fd(n,*),c(*),c1(n,*),c2(n,*),
     &          pdcond(m,*),fdcond(m,*),grad(m,*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)
      ps0(i,2)=pyay(i)*ss0(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
      sp(i,1)=pxbx(i)*ss0(i)
      sp(i,2)=pyby(i)*ss0(i)
 1004 sp(i,3)=pzbz(i)*ss0(i)

      do 1005 i=1,n
 1005 c(i)=ss0(i)/twozeta(i)

      do 1006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)
 1006 ds0(i,6)=pzaz(i)*ps0(i,3)+c(i)

      do 1007 i=1,n
      sd(i,1)=pxbx(i)*sp(i,1)+c(i)
      sd(i,2)=pyby(i)*sp(i,1)
      sd(i,3)=pzbz(i)*sp(i,1)
      sd(i,4)=pyby(i)*sp(i,2)+c(i)
      sd(i,5)=pzbz(i)*sp(i,2)
 1007 sd(i,6)=pzbz(i)*sp(i,3)+c(i)

      do 1008 j=1,3
      do 1008 i=1,n
 1008 c1(i,j)=ps0(i,j)/twozeta(i)

      do 1009 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)+c1(i,1)+c1(i,1)
      fs0(i,02)=pyay(i)*ds0(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)+c1(i,2)+c1(i,2)
      fs0(i,08)=pzaz(i)*ds0(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)+c1(i,2)
 1009 fs0(i,10)=pzaz(i)*ds0(i,6)+c1(i,3)+c1(i,3)

      do 1010 i=1,n
      dp(i,01)=pxbx(i)*ds0(i,1)+c1(i,1)*two
      dp(i,02)=pyby(i)*ds0(i,1)
      dp(i,03)=pzbz(i)*ds0(i,1)
      dp(i,04)=pxbx(i)*ds0(i,2)+c1(i,2)
      dp(i,05)=pyby(i)*ds0(i,2)+c1(i,1)
      dp(i,06)=pzbz(i)*ds0(i,2)
      dp(i,07)=pxbx(i)*ds0(i,3)+c1(i,3)
      dp(i,08)=pyby(i)*ds0(i,3)
      dp(i,09)=pzbz(i)*ds0(i,3)+c1(i,1)
      dp(i,10)=pxbx(i)*ds0(i,4)
      dp(i,11)=pyby(i)*ds0(i,4)+c1(i,2)*two
      dp(i,12)=pzbz(i)*ds0(i,4)
      dp(i,13)=pxbx(i)*ds0(i,5)
      dp(i,14)=pyby(i)*ds0(i,5)+c1(i,3)
      dp(i,15)=pzbz(i)*ds0(i,5)+c1(i,2)
      dp(i,16)=pxbx(i)*ds0(i,6)
      dp(i,17)=pyby(i)*ds0(i,6)
 1010 dp(i,18)=pzbz(i)*ds0(i,6)+c1(i,3)*two

      do 1011 j=1,3
      do 1011 i=1,n
 1011 c1(i,j)=sp(i,j)/twozeta(i)

      do 1012 i=1,n
      pd(i,01)=pxax(i)*sd(i,1)+c1(i,1)+c1(i,1)
      pd(i,02)=pxax(i)*sd(i,2)+c1(i,2)
      pd(i,03)=pxax(i)*sd(i,3)+c1(i,3)
      pd(i,04)=pxax(i)*sd(i,4)
      pd(i,05)=pxax(i)*sd(i,5)
      pd(i,06)=pxax(i)*sd(i,6)
      pd(i,07)=pyay(i)*sd(i,1)
      pd(i,08)=pyay(i)*sd(i,2)+c1(i,1)
      pd(i,09)=pyay(i)*sd(i,3)
      pd(i,10)=pyay(i)*sd(i,4)+c1(i,2)+c1(i,2)
      pd(i,11)=pyay(i)*sd(i,5)+c1(i,3)
      pd(i,12)=pyay(i)*sd(i,6)
      pd(i,13)=pzaz(i)*sd(i,1)
      pd(i,14)=pzaz(i)*sd(i,2)
      pd(i,15)=pzaz(i)*sd(i,3)+c1(i,1)
      pd(i,16)=pzaz(i)*sd(i,4)
      pd(i,17)=pzaz(i)*sd(i,5)+c1(i,2)
 1012 pd(i,18)=pzaz(i)*sd(i,6)+c1(i,3)+c1(i,3)

      do 1013 j=1,6
      do 1013 i=1,n
 1013 c1(i,j)=ds0(i,j)/twozeta(i)

      do 1014 i=1,n
      fp(i,01)=pxbx(i)*fs0(i,01)+c1(i,1)*three
      fp(i,02)=pyby(i)*fs0(i,01)
      fp(i,03)=pzbz(i)*fs0(i,01)
      fp(i,04)=pxbx(i)*fs0(i,02)+c1(i,2)*two
      fp(i,05)=pyby(i)*fs0(i,02)+c1(i,1)
      fp(i,06)=pzbz(i)*fs0(i,02)
      fp(i,07)=pxbx(i)*fs0(i,03)+c1(i,3)*two
      fp(i,08)=pyby(i)*fs0(i,03)
      fp(i,09)=pzbz(i)*fs0(i,03)+c1(i,1)
      fp(i,10)=pxbx(i)*fs0(i,04)+c1(i,4)
      fp(i,11)=pyby(i)*fs0(i,04)+c1(i,2)*two
      fp(i,12)=pzbz(i)*fs0(i,04)
      fp(i,13)=pxbx(i)*fs0(i,05)+c1(i,5)
      fp(i,14)=pyby(i)*fs0(i,05)+c1(i,3)
      fp(i,15)=pzbz(i)*fs0(i,05)+c1(i,2)
      fp(i,16)=pxbx(i)*fs0(i,06)+c1(i,6)
      fp(i,17)=pyby(i)*fs0(i,06)
      fp(i,18)=pzbz(i)*fs0(i,06)+c1(i,3)*two
      fp(i,19)=pxbx(i)*fs0(i,07)
      fp(i,20)=pyby(i)*fs0(i,07)+c1(i,4)*three
      fp(i,21)=pzbz(i)*fs0(i,07)
      fp(i,22)=pxbx(i)*fs0(i,08)
      fp(i,23)=pyby(i)*fs0(i,08)+c1(i,5)*two
      fp(i,24)=pzbz(i)*fs0(i,08)+c1(i,4)
      fp(i,25)=pxbx(i)*fs0(i,09)
      fp(i,26)=pyby(i)*fs0(i,09)+c1(i,6)
      fp(i,27)=pzbz(i)*fs0(i,09)+c1(i,5)*two
      fp(i,28)=pxbx(i)*fs0(i,10)
      fp(i,29)=pyby(i)*fs0(i,10)
 1014 fp(i,30)=pzbz(i)*fs0(i,10)+c1(i,6)*three

      do 1015 j=1,10
      do 1015 i=1,n
 1015 c1(i,j)=fs0(i,j)/twozeta(i)

      do 1016 j=1,18
      do 1016 i=1,n
 1016 c2(i,j)=dp(i,j)/twozeta(i)

      do 1017 i=1,n
      fd(i,01)=pxbx(i)*fp(i,01)+c1(i,01)+c2(i,01)*three
      fd(i,02)=pyby(i)*fp(i,01)
      fd(i,03)=pzbz(i)*fp(i,01)
      fd(i,04)=pyby(i)*fp(i,02)+c1(i,01)
      fd(i,05)=pzbz(i)*fp(i,02)
      fd(i,06)=pzbz(i)*fp(i,03)+c1(i,01)
      fd(i,07)=pxbx(i)*fp(i,04)+c1(i,02)+c2(i,04)*two
      fd(i,08)=pyby(i)*fp(i,04)         +c2(i,01)
      fd(i,09)=pzbz(i)*fp(i,04)
      fd(i,10)=pyby(i)*fp(i,05)+c1(i,02)+c2(i,02)
      fd(i,11)=pzbz(i)*fp(i,05)
      fd(i,12)=pzbz(i)*fp(i,06)+c1(i,02)
      fd(i,13)=pxbx(i)*fp(i,07)+c1(i,03)+c2(i,07)*two
      fd(i,14)=pyby(i)*fp(i,07)
      fd(i,15)=pzbz(i)*fp(i,07)         +c2(i,01)
      fd(i,16)=pyby(i)*fp(i,08)+c1(i,03)
      fd(i,17)=pzbz(i)*fp(i,08)         +c2(i,02)
      fd(i,18)=pzbz(i)*fp(i,09)+c1(i,03)+c2(i,03)
      fd(i,19)=pxbx(i)*fp(i,10)+c1(i,04)+c2(i,10)
      fd(i,20)=pyby(i)*fp(i,10)         +c2(i,04)*two
      fd(i,21)=pzbz(i)*fp(i,10)
      fd(i,22)=pyby(i)*fp(i,11)+c1(i,04)+c2(i,05)*two
      fd(i,23)=pzbz(i)*fp(i,11)
      fd(i,24)=pzbz(i)*fp(i,12)+c1(i,04)
      fd(i,25)=pxbx(i)*fp(i,13)+c1(i,05)+c2(i,13)
      fd(i,26)=pyby(i)*fp(i,13)         +c2(i,07)
      fd(i,27)=pzbz(i)*fp(i,13)         +c2(i,04)
      fd(i,28)=pyby(i)*fp(i,14)+c1(i,05)+c2(i,08)
      fd(i,29)=pzbz(i)*fp(i,14)         +c2(i,05)
      fd(i,30)=pzbz(i)*fp(i,15)+c1(i,05)+c2(i,06)
      fd(i,31)=pxbx(i)*fp(i,16)+c1(i,06)+c2(i,16)
      fd(i,32)=pyby(i)*fp(i,16)
      fd(i,33)=pzbz(i)*fp(i,16)         +c2(i,07)*two
      fd(i,34)=pyby(i)*fp(i,17)+c1(i,06)
      fd(i,35)=pzbz(i)*fp(i,17)         +c2(i,08)*two
      fd(i,36)=pzbz(i)*fp(i,18)+c1(i,06)+c2(i,09)*two
      fd(i,37)=pxbx(i)*fp(i,19)+c1(i,07)
      fd(i,38)=pyby(i)*fp(i,19)         +c2(i,10)*three
      fd(i,39)=pzbz(i)*fp(i,19)
      fd(i,40)=pyby(i)*fp(i,20)+c1(i,07)+c2(i,11)*three
      fd(i,41)=pzbz(i)*fp(i,20)
      fd(i,42)=pzbz(i)*fp(i,21)+c1(i,07)
      fd(i,43)=pxbx(i)*fp(i,22)+c1(i,08)
      fd(i,44)=pyby(i)*fp(i,22)         +c2(i,13)*two
      fd(i,45)=pzbz(i)*fp(i,22)         +c2(i,10)
      fd(i,46)=pyby(i)*fp(i,23)+c1(i,08)+c2(i,14)*two
      fd(i,47)=pzbz(i)*fp(i,23)         +c2(i,11)
      fd(i,48)=pzbz(i)*fp(i,24)+c1(i,08)+c2(i,12)
      fd(i,49)=pxbx(i)*fp(i,25)+c1(i,09)
      fd(i,50)=pyby(i)*fp(i,25)         +c2(i,16)
      fd(i,51)=pzbz(i)*fp(i,25)         +c2(i,13)*two
      fd(i,52)=pyby(i)*fp(i,26)+c1(i,09)+c2(i,17)
      fd(i,53)=pzbz(i)*fp(i,26)         +c2(i,14)*two
      fd(i,54)=pzbz(i)*fp(i,27)+c1(i,09)+c2(i,15)*two
      fd(i,55)=pxbx(i)*fp(i,28)+c1(i,10)
      fd(i,56)=pyby(i)*fp(i,28)
      fd(i,57)=pzbz(i)*fp(i,28)         +c2(i,16)*three
      fd(i,58)=pyby(i)*fp(i,29)+c1(i,10)
      fd(i,59)=pzbz(i)*fp(i,29)         +c2(i,17)*three
 1017 fd(i,60)=pzbz(i)*fp(i,30)+c1(i,10)+c2(i,18)*three

      do 1018 j=1,18
      do 1018 i=1,m
 1018 pdcond(i,j)=zero

      do 1019 j=1,60
      do 1019 i=1,m
 1019 fdcond(i,j)=zero

      do 1020 j=1,18
      do 1020 i=1,n
 1020 pdcond(icontr(i),j)=pdcond(icontr(i),j)+pd(i,j)

      do 1021 j=1,60
      do 1021 i=1,n
 1021 fdcond(icontr(i),j)=fdcond(icontr(i),j)+fd(i,j)*twozetaa(i)

      do 1022 i=1,m
      overlap(inddyy(i,01),1)=overlap(inddyy(i,01),1)-pdcond(i,01)*two
      overlap(inddyy(i,07),1)=overlap(inddyy(i,07),1)-pdcond(i,07)
      overlap(inddyy(i,08),1)=overlap(inddyy(i,08),1)-pdcond(i,08)
      overlap(inddyy(i,13),1)=overlap(inddyy(i,13),1)-pdcond(i,13)
      overlap(inddyy(i,14),1)=overlap(inddyy(i,14),1)-pdcond(i,14)
      overlap(inddyy(i,15),1)=overlap(inddyy(i,15),1)-pdcond(i,15)
      overlap(inddyy(i,07),2)=overlap(inddyy(i,07),2)-pdcond(i,01)
      overlap(inddyy(i,08),2)=overlap(inddyy(i,08),2)-pdcond(i,02)
      overlap(inddyy(i,19),2)=overlap(inddyy(i,19),2)-pdcond(i,07)*two
      overlap(inddyy(i,20),2)=overlap(inddyy(i,20),2)-pdcond(i,08)*two
      overlap(inddyy(i,21),2)=overlap(inddyy(i,21),2)-pdcond(i,09)*two
      overlap(inddyy(i,22),2)=overlap(inddyy(i,22),2)-pdcond(i,10)*two
      overlap(inddyy(i,25),2)=overlap(inddyy(i,25),2)-pdcond(i,13)
      overlap(inddyy(i,26),2)=overlap(inddyy(i,26),2)-pdcond(i,14)
      overlap(inddyy(i,27),2)=overlap(inddyy(i,27),2)-pdcond(i,15)
      overlap(inddyy(i,28),2)=overlap(inddyy(i,28),2)-pdcond(i,16)
      overlap(inddyy(i,29),2)=overlap(inddyy(i,29),2)-pdcond(i,17)
      overlap(inddyy(i,13),3)=overlap(inddyy(i,13),3)-pdcond(i,01)
      overlap(inddyy(i,14),3)=overlap(inddyy(i,14),3)-pdcond(i,02)
      overlap(inddyy(i,15),3)=overlap(inddyy(i,15),3)-pdcond(i,03)
      overlap(inddyy(i,25),3)=overlap(inddyy(i,25),3)-pdcond(i,07)
      overlap(inddyy(i,26),3)=overlap(inddyy(i,26),3)-pdcond(i,08)
      overlap(inddyy(i,27),3)=overlap(inddyy(i,27),3)-pdcond(i,09)
      overlap(inddyy(i,28),3)=overlap(inddyy(i,28),3)-pdcond(i,10)
      overlap(inddyy(i,29),3)=overlap(inddyy(i,29),3)-pdcond(i,11)
      overlap(inddyy(i,31),3)=overlap(inddyy(i,31),3)-pdcond(i,13)*two
      overlap(inddyy(i,32),3)=overlap(inddyy(i,32),3)-pdcond(i,14)*two
      overlap(inddyy(i,33),3)=overlap(inddyy(i,33),3)-pdcond(i,15)*two
      overlap(inddyy(i,34),3)=overlap(inddyy(i,34),3)-pdcond(i,16)*two
      overlap(inddyy(i,35),3)=overlap(inddyy(i,35),3)-pdcond(i,17)*two
 1022 overlap(inddyy(i,36),3)=overlap(inddyy(i,36),3)-pdcond(i,18)*two

      do 1023 i=1,m
      if(iminj(i).ne.0) then

        overlap(inddyy(i,02),1)=overlap(inddyy(i,02),1)-pdcond(i,02)*two
        overlap(inddyy(i,03),1)=overlap(inddyy(i,03),1)-pdcond(i,03)*two
        overlap(inddyy(i,04),1)=overlap(inddyy(i,04),1)-pdcond(i,04)*two
        overlap(inddyy(i,05),1)=overlap(inddyy(i,05),1)-pdcond(i,05)*two
        overlap(inddyy(i,06),1)=overlap(inddyy(i,06),1)-pdcond(i,06)*two
        overlap(inddyy(i,09),1)=overlap(inddyy(i,09),1)-pdcond(i,09)
        overlap(inddyy(i,10),1)=overlap(inddyy(i,10),1)-pdcond(i,10)
        overlap(inddyy(i,11),1)=overlap(inddyy(i,11),1)-pdcond(i,11)
        overlap(inddyy(i,12),1)=overlap(inddyy(i,12),1)-pdcond(i,12)
        overlap(inddyy(i,16),1)=overlap(inddyy(i,16),1)-pdcond(i,16)
        overlap(inddyy(i,17),1)=overlap(inddyy(i,17),1)-pdcond(i,17)
        overlap(inddyy(i,18),1)=overlap(inddyy(i,18),1)-pdcond(i,18)
        overlap(inddyy(i,09),2)=overlap(inddyy(i,09),2)-pdcond(i,03)
        overlap(inddyy(i,10),2)=overlap(inddyy(i,10),2)-pdcond(i,04)
        overlap(inddyy(i,11),2)=overlap(inddyy(i,11),2)-pdcond(i,05)
        overlap(inddyy(i,12),2)=overlap(inddyy(i,12),2)-pdcond(i,06)
        overlap(inddyy(i,23),2)=overlap(inddyy(i,23),2)-pdcond(i,11)*two
        overlap(inddyy(i,24),2)=overlap(inddyy(i,24),2)-pdcond(i,12)*two
        overlap(inddyy(i,30),2)=overlap(inddyy(i,30),2)-pdcond(i,18)
        overlap(inddyy(i,16),3)=overlap(inddyy(i,16),3)-pdcond(i,04)
        overlap(inddyy(i,17),3)=overlap(inddyy(i,17),3)-pdcond(i,05)
        overlap(inddyy(i,18),3)=overlap(inddyy(i,18),3)-pdcond(i,06)
        overlap(inddyy(i,30),3)=overlap(inddyy(i,30),3)-pdcond(i,12)

                        endif
 1023 continue

      do 1024 i=1,m
      overlap(inddyy(i,01),1)=overlap(inddyy(i,01),1)+fdcond(i,01)
      overlap(inddyy(i,07),1)=overlap(inddyy(i,07),1)+fdcond(i,07)
      overlap(inddyy(i,08),1)=overlap(inddyy(i,08),1)+fdcond(i,08)
      overlap(inddyy(i,13),1)=overlap(inddyy(i,13),1)+fdcond(i,13)
      overlap(inddyy(i,14),1)=overlap(inddyy(i,14),1)+fdcond(i,14)
      overlap(inddyy(i,15),1)=overlap(inddyy(i,15),1)+fdcond(i,15)
      overlap(inddyy(i,19),1)=overlap(inddyy(i,19),1)+fdcond(i,19)
      overlap(inddyy(i,20),1)=overlap(inddyy(i,20),1)+fdcond(i,20)
      overlap(inddyy(i,21),1)=overlap(inddyy(i,21),1)+fdcond(i,21)
      overlap(inddyy(i,22),1)=overlap(inddyy(i,22),1)+fdcond(i,22)
      overlap(inddyy(i,25),1)=overlap(inddyy(i,25),1)+fdcond(i,25)
      overlap(inddyy(i,26),1)=overlap(inddyy(i,26),1)+fdcond(i,26)
      overlap(inddyy(i,27),1)=overlap(inddyy(i,27),1)+fdcond(i,27)
      overlap(inddyy(i,28),1)=overlap(inddyy(i,28),1)+fdcond(i,28)
      overlap(inddyy(i,29),1)=overlap(inddyy(i,29),1)+fdcond(i,29)
      overlap(inddyy(i,31),1)=overlap(inddyy(i,31),1)+fdcond(i,31)
      overlap(inddyy(i,32),1)=overlap(inddyy(i,32),1)+fdcond(i,32)
      overlap(inddyy(i,33),1)=overlap(inddyy(i,33),1)+fdcond(i,33)
      overlap(inddyy(i,34),1)=overlap(inddyy(i,34),1)+fdcond(i,34)
      overlap(inddyy(i,35),1)=overlap(inddyy(i,35),1)+fdcond(i,35)
      overlap(inddyy(i,36),1)=overlap(inddyy(i,36),1)+fdcond(i,36)
      overlap(inddyy(i,01),2)=overlap(inddyy(i,01),2)+fdcond(i,07)
      overlap(inddyy(i,07),2)=overlap(inddyy(i,07),2)+fdcond(i,19)
      overlap(inddyy(i,08),2)=overlap(inddyy(i,08),2)+fdcond(i,20)
      overlap(inddyy(i,13),2)=overlap(inddyy(i,13),2)+fdcond(i,25)
      overlap(inddyy(i,14),2)=overlap(inddyy(i,14),2)+fdcond(i,26)
      overlap(inddyy(i,15),2)=overlap(inddyy(i,15),2)+fdcond(i,27)
      overlap(inddyy(i,19),2)=overlap(inddyy(i,19),2)+fdcond(i,37)
      overlap(inddyy(i,20),2)=overlap(inddyy(i,20),2)+fdcond(i,38)
      overlap(inddyy(i,21),2)=overlap(inddyy(i,21),2)+fdcond(i,39)
      overlap(inddyy(i,22),2)=overlap(inddyy(i,22),2)+fdcond(i,40)
      overlap(inddyy(i,25),2)=overlap(inddyy(i,25),2)+fdcond(i,43)
      overlap(inddyy(i,26),2)=overlap(inddyy(i,26),2)+fdcond(i,44)
      overlap(inddyy(i,27),2)=overlap(inddyy(i,27),2)+fdcond(i,45)
      overlap(inddyy(i,28),2)=overlap(inddyy(i,28),2)+fdcond(i,46)
      overlap(inddyy(i,29),2)=overlap(inddyy(i,29),2)+fdcond(i,47)
      overlap(inddyy(i,31),2)=overlap(inddyy(i,31),2)+fdcond(i,49)
      overlap(inddyy(i,32),2)=overlap(inddyy(i,32),2)+fdcond(i,50)
      overlap(inddyy(i,33),2)=overlap(inddyy(i,33),2)+fdcond(i,51)
      overlap(inddyy(i,34),2)=overlap(inddyy(i,34),2)+fdcond(i,52)
      overlap(inddyy(i,35),2)=overlap(inddyy(i,35),2)+fdcond(i,53)
      overlap(inddyy(i,36),2)=overlap(inddyy(i,36),2)+fdcond(i,54)
      overlap(inddyy(i,01),3)=overlap(inddyy(i,01),3)+fdcond(i,13)
      overlap(inddyy(i,07),3)=overlap(inddyy(i,07),3)+fdcond(i,25)
      overlap(inddyy(i,08),3)=overlap(inddyy(i,08),3)+fdcond(i,26)
      overlap(inddyy(i,13),3)=overlap(inddyy(i,13),3)+fdcond(i,31)
      overlap(inddyy(i,14),3)=overlap(inddyy(i,14),3)+fdcond(i,32)
      overlap(inddyy(i,15),3)=overlap(inddyy(i,15),3)+fdcond(i,33)
      overlap(inddyy(i,19),3)=overlap(inddyy(i,19),3)+fdcond(i,43)
      overlap(inddyy(i,20),3)=overlap(inddyy(i,20),3)+fdcond(i,44)
      overlap(inddyy(i,21),3)=overlap(inddyy(i,21),3)+fdcond(i,45)
      overlap(inddyy(i,22),3)=overlap(inddyy(i,22),3)+fdcond(i,46)
      overlap(inddyy(i,25),3)=overlap(inddyy(i,25),3)+fdcond(i,49)
      overlap(inddyy(i,26),3)=overlap(inddyy(i,26),3)+fdcond(i,50)
      overlap(inddyy(i,27),3)=overlap(inddyy(i,27),3)+fdcond(i,51)
      overlap(inddyy(i,28),3)=overlap(inddyy(i,28),3)+fdcond(i,52)
      overlap(inddyy(i,29),3)=overlap(inddyy(i,29),3)+fdcond(i,53)
      overlap(inddyy(i,31),3)=overlap(inddyy(i,31),3)+fdcond(i,55)
      overlap(inddyy(i,32),3)=overlap(inddyy(i,32),3)+fdcond(i,56)
      overlap(inddyy(i,33),3)=overlap(inddyy(i,33),3)+fdcond(i,57)
      overlap(inddyy(i,34),3)=overlap(inddyy(i,34),3)+fdcond(i,58)
      overlap(inddyy(i,35),3)=overlap(inddyy(i,35),3)+fdcond(i,59)
 1024 overlap(inddyy(i,36),3)=overlap(inddyy(i,36),3)+fdcond(i,60)


      do 1025 i=1,m
      if(iminj(i).ne.0) then

            overlap(inddyy(i,02),1)=overlap(inddyy(i,02),1)+fdcond(i,02)
            overlap(inddyy(i,03),1)=overlap(inddyy(i,03),1)+fdcond(i,03)
            overlap(inddyy(i,04),1)=overlap(inddyy(i,04),1)+fdcond(i,04)
            overlap(inddyy(i,05),1)=overlap(inddyy(i,05),1)+fdcond(i,05)
            overlap(inddyy(i,06),1)=overlap(inddyy(i,06),1)+fdcond(i,06)
            overlap(inddyy(i,09),1)=overlap(inddyy(i,09),1)+fdcond(i,09)
            overlap(inddyy(i,10),1)=overlap(inddyy(i,10),1)+fdcond(i,10)
            overlap(inddyy(i,11),1)=overlap(inddyy(i,11),1)+fdcond(i,11)
            overlap(inddyy(i,12),1)=overlap(inddyy(i,12),1)+fdcond(i,12)
            overlap(inddyy(i,16),1)=overlap(inddyy(i,16),1)+fdcond(i,16)
            overlap(inddyy(i,17),1)=overlap(inddyy(i,17),1)+fdcond(i,17)
            overlap(inddyy(i,18),1)=overlap(inddyy(i,18),1)+fdcond(i,18)
            overlap(inddyy(i,23),1)=overlap(inddyy(i,23),1)+fdcond(i,23)
            overlap(inddyy(i,24),1)=overlap(inddyy(i,24),1)+fdcond(i,24)
            overlap(inddyy(i,30),1)=overlap(inddyy(i,30),1)+fdcond(i,30)
            overlap(inddyy(i,02),2)=overlap(inddyy(i,02),2)+fdcond(i,08)
            overlap(inddyy(i,03),2)=overlap(inddyy(i,03),2)+fdcond(i,09)
            overlap(inddyy(i,04),2)=overlap(inddyy(i,04),2)+fdcond(i,10)
            overlap(inddyy(i,05),2)=overlap(inddyy(i,05),2)+fdcond(i,11)
            overlap(inddyy(i,06),2)=overlap(inddyy(i,06),2)+fdcond(i,12)
            overlap(inddyy(i,09),2)=overlap(inddyy(i,09),2)+fdcond(i,21)
            overlap(inddyy(i,10),2)=overlap(inddyy(i,10),2)+fdcond(i,22)
            overlap(inddyy(i,11),2)=overlap(inddyy(i,11),2)+fdcond(i,23)
            overlap(inddyy(i,12),2)=overlap(inddyy(i,12),2)+fdcond(i,24)
            overlap(inddyy(i,16),2)=overlap(inddyy(i,16),2)+fdcond(i,28)
            overlap(inddyy(i,17),2)=overlap(inddyy(i,17),2)+fdcond(i,29)
            overlap(inddyy(i,18),2)=overlap(inddyy(i,18),2)+fdcond(i,30)
            overlap(inddyy(i,23),2)=overlap(inddyy(i,23),2)+fdcond(i,41)
            overlap(inddyy(i,24),2)=overlap(inddyy(i,24),2)+fdcond(i,42)
            overlap(inddyy(i,30),2)=overlap(inddyy(i,30),2)+fdcond(i,48)
            overlap(inddyy(i,02),3)=overlap(inddyy(i,02),3)+fdcond(i,14)
            overlap(inddyy(i,03),3)=overlap(inddyy(i,03),3)+fdcond(i,15)
            overlap(inddyy(i,04),3)=overlap(inddyy(i,04),3)+fdcond(i,16)
            overlap(inddyy(i,05),3)=overlap(inddyy(i,05),3)+fdcond(i,17)
            overlap(inddyy(i,06),3)=overlap(inddyy(i,06),3)+fdcond(i,18)
            overlap(inddyy(i,09),3)=overlap(inddyy(i,09),3)+fdcond(i,27)
            overlap(inddyy(i,10),3)=overlap(inddyy(i,10),3)+fdcond(i,28)
            overlap(inddyy(i,11),3)=overlap(inddyy(i,11),3)+fdcond(i,29)
            overlap(inddyy(i,12),3)=overlap(inddyy(i,12),3)+fdcond(i,30)
            overlap(inddyy(i,16),3)=overlap(inddyy(i,16),3)+fdcond(i,34)
            overlap(inddyy(i,17),3)=overlap(inddyy(i,17),3)+fdcond(i,35)
            overlap(inddyy(i,18),3)=overlap(inddyy(i,18),3)+fdcond(i,36)
            overlap(inddyy(i,23),3)=overlap(inddyy(i,23),3)+fdcond(i,47)
            overlap(inddyy(i,24),3)=overlap(inddyy(i,24),3)+fdcond(i,48)
            overlap(inddyy(i,30),3)=overlap(inddyy(i,30),3)+fdcond(i,54)

                        endif
 1025 continue

      do 1026 i=1,n
 1026 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1027 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps0(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps0(i,2)
 1027 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps0(i,3)

      do 1028 i=1,n
      sp(i,1)=pxbx(i)*ss(i)+eta2(i)*sp(i,1)
      sp(i,2)=pyby(i)*ss(i)+eta2(i)*sp(i,2)
 1028 sp(i,3)=pzbz(i)*ss(i)+eta2(i)*sp(i,3)

      do 1029 i=1,n
 1029 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/twozetaa(i)

      do 1030 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds0(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds0(i,2)
      ds(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds0(i,3)
      ds(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds0(i,4)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds0(i,5)
 1030 ds(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds0(i,6)+c(i)

      do 1031 i=1,n
 1031 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/twozetab(i)

      do 1032 i=1,n
      sd(i,1)=pxbx(i)*sp(i,1)+eta2(i)*sd(i,1)+c(i)
      sd(i,2)=pyby(i)*sp(i,1)+eta2(i)*sd(i,2)
      sd(i,3)=pzbz(i)*sp(i,1)+eta2(i)*sd(i,3)
      sd(i,4)=pyby(i)*sp(i,2)+eta2(i)*sd(i,4)+c(i)
      sd(i,5)=pzbz(i)*sp(i,2)+eta2(i)*sd(i,5)
 1032 sd(i,6)=pzbz(i)*sp(i,3)+eta2(i)*sd(i,6)+c(i)

      do 1033 j=1,3
      do 1033 i=1,n
 1033 c1(i,j)=ps(i,j)/twozeta(i)-eta2(i)*ps0(i,j)/twozetaa(i)

      do 1034 i=1,n
      fs(i,01)=pxax(i)*ds(i,1)+eta2(i)*fs0(i,01)+c1(i,1)+c1(i,1)
      fs(i,02)=pyay(i)*ds(i,1)+eta2(i)*fs0(i,02)
      fs(i,03)=pzaz(i)*ds(i,1)+eta2(i)*fs0(i,03)
      fs(i,04)=pyay(i)*ds(i,2)+eta2(i)*fs0(i,04)+c1(i,1)
      fs(i,05)=pzaz(i)*ds(i,2)+eta2(i)*fs0(i,05)
      fs(i,06)=pzaz(i)*ds(i,3)+eta2(i)*fs0(i,06)+c1(i,1)
      fs(i,07)=pyay(i)*ds(i,4)+eta2(i)*fs0(i,07)+c1(i,2)+c1(i,2)
      fs(i,08)=pzaz(i)*ds(i,4)+eta2(i)*fs0(i,08)
      fs(i,09)=pzaz(i)*ds(i,5)+eta2(i)*fs0(i,09)+c1(i,2)
 1034 fs(i,10)=pzaz(i)*ds(i,6)+eta2(i)*fs0(i,10)+c1(i,3)+c1(i,3)

      do 1035 j=1,3
      do 1035 i=1,n
 1035 c1(i,j)=ps(i,j)/twozeta(i)

      do 1036 i=1,n
      dp(i,01)=pxbx(i)*ds(i,1)+eta2(i)*dp(i,01)+c1(i,1)*two
      dp(i,02)=pyby(i)*ds(i,1)+eta2(i)*dp(i,02)
      dp(i,03)=pzbz(i)*ds(i,1)+eta2(i)*dp(i,03)
      dp(i,04)=pxbx(i)*ds(i,2)+eta2(i)*dp(i,04)+c1(i,2)
      dp(i,05)=pyby(i)*ds(i,2)+eta2(i)*dp(i,05)+c1(i,1)
      dp(i,06)=pzbz(i)*ds(i,2)+eta2(i)*dp(i,06)
      dp(i,07)=pxbx(i)*ds(i,3)+eta2(i)*dp(i,07)+c1(i,3)
      dp(i,08)=pyby(i)*ds(i,3)+eta2(i)*dp(i,08)
      dp(i,09)=pzbz(i)*ds(i,3)+eta2(i)*dp(i,09)+c1(i,1)
      dp(i,10)=pxbx(i)*ds(i,4)+eta2(i)*dp(i,10)
      dp(i,11)=pyby(i)*ds(i,4)+eta2(i)*dp(i,11)+c1(i,2)*two
      dp(i,12)=pzbz(i)*ds(i,4)+eta2(i)*dp(i,12)
      dp(i,13)=pxbx(i)*ds(i,5)+eta2(i)*dp(i,13)
      dp(i,14)=pyby(i)*ds(i,5)+eta2(i)*dp(i,14)+c1(i,3)
      dp(i,15)=pzbz(i)*ds(i,5)+eta2(i)*dp(i,15)+c1(i,2)
      dp(i,16)=pxbx(i)*ds(i,6)+eta2(i)*dp(i,16)
      dp(i,17)=pyby(i)*ds(i,6)+eta2(i)*dp(i,17)
 1036 dp(i,18)=pzbz(i)*ds(i,6)+eta2(i)*dp(i,18)+c1(i,3)*two

      do 1037 j=1,3
      do 1037 i=1,n
 1037 c1(i,j)=sp(i,j)/twozeta(i)

      do 1038 i=1,n
      pd(i,01)=pxax(i)*sd(i,1)+eta2(i)*pd(i,01)+c1(i,1)+c1(i,1)
      pd(i,02)=pxax(i)*sd(i,2)+eta2(i)*pd(i,02)+c1(i,2)
      pd(i,03)=pxax(i)*sd(i,3)+eta2(i)*pd(i,03)+c1(i,3)
      pd(i,04)=pxax(i)*sd(i,4)+eta2(i)*pd(i,04)
      pd(i,05)=pxax(i)*sd(i,5)+eta2(i)*pd(i,05)
      pd(i,06)=pxax(i)*sd(i,6)+eta2(i)*pd(i,06)
      pd(i,07)=pyay(i)*sd(i,1)+eta2(i)*pd(i,07)
      pd(i,08)=pyay(i)*sd(i,2)+eta2(i)*pd(i,08)+c1(i,1)
      pd(i,09)=pyay(i)*sd(i,3)+eta2(i)*pd(i,09)
      pd(i,10)=pyay(i)*sd(i,4)+eta2(i)*pd(i,10)+c1(i,2)+c1(i,2)
      pd(i,11)=pyay(i)*sd(i,5)+eta2(i)*pd(i,11)+c1(i,3)
      pd(i,12)=pyay(i)*sd(i,6)+eta2(i)*pd(i,12)
      pd(i,13)=pzaz(i)*sd(i,1)+eta2(i)*pd(i,13)
      pd(i,14)=pzaz(i)*sd(i,2)+eta2(i)*pd(i,14)
      pd(i,15)=pzaz(i)*sd(i,3)+eta2(i)*pd(i,15)+c1(i,1)
      pd(i,16)=pzaz(i)*sd(i,4)+eta2(i)*pd(i,16)
      pd(i,17)=pzaz(i)*sd(i,5)+eta2(i)*pd(i,17)+c1(i,2)
 1038 pd(i,18)=pzaz(i)*sd(i,6)+eta2(i)*pd(i,18)+c1(i,3)+c1(i,3)

      do 1039 j=1,6
      do 1039 i=1,n
 1039 c1(i,j)=ds(i,j)/twozeta(i)

      do 1040 i=1,n
      fp(i,01)=pxbx(i)*fs(i,01)+eta2(i)*fp(i,01)+c1(i,1)*three
      fp(i,02)=pyby(i)*fs(i,01)+eta2(i)*fp(i,02)
      fp(i,03)=pzbz(i)*fs(i,01)+eta2(i)*fp(i,03)
      fp(i,04)=pxbx(i)*fs(i,02)+eta2(i)*fp(i,04)+c1(i,2)*two
      fp(i,05)=pyby(i)*fs(i,02)+eta2(i)*fp(i,05)+c1(i,1)
      fp(i,06)=pzbz(i)*fs(i,02)+eta2(i)*fp(i,06)
      fp(i,07)=pxbx(i)*fs(i,03)+eta2(i)*fp(i,07)+c1(i,3)*two
      fp(i,08)=pyby(i)*fs(i,03)+eta2(i)*fp(i,08)
      fp(i,09)=pzbz(i)*fs(i,03)+eta2(i)*fp(i,09)+c1(i,1)
      fp(i,10)=pxbx(i)*fs(i,04)+eta2(i)*fp(i,10)+c1(i,4)
      fp(i,11)=pyby(i)*fs(i,04)+eta2(i)*fp(i,11)+c1(i,2)*two
      fp(i,12)=pzbz(i)*fs(i,04)+eta2(i)*fp(i,12)
      fp(i,13)=pxbx(i)*fs(i,05)+eta2(i)*fp(i,13)+c1(i,5)
      fp(i,14)=pyby(i)*fs(i,05)+eta2(i)*fp(i,14)+c1(i,3)
      fp(i,15)=pzbz(i)*fs(i,05)+eta2(i)*fp(i,15)+c1(i,2)
      fp(i,16)=pxbx(i)*fs(i,06)+eta2(i)*fp(i,16)+c1(i,6)
      fp(i,17)=pyby(i)*fs(i,06)+eta2(i)*fp(i,17)
      fp(i,18)=pzbz(i)*fs(i,06)+eta2(i)*fp(i,18)+c1(i,3)*two
      fp(i,19)=pxbx(i)*fs(i,07)+eta2(i)*fp(i,19)
      fp(i,20)=pyby(i)*fs(i,07)+eta2(i)*fp(i,20)+c1(i,4)*three
      fp(i,21)=pzbz(i)*fs(i,07)+eta2(i)*fp(i,21)
      fp(i,22)=pxbx(i)*fs(i,08)+eta2(i)*fp(i,22)
      fp(i,23)=pyby(i)*fs(i,08)+eta2(i)*fp(i,23)+c1(i,5)*two
      fp(i,24)=pzbz(i)*fs(i,08)+eta2(i)*fp(i,24)+c1(i,4)
      fp(i,25)=pxbx(i)*fs(i,09)+eta2(i)*fp(i,25)
      fp(i,26)=pyby(i)*fs(i,09)+eta2(i)*fp(i,26)+c1(i,6)
      fp(i,27)=pzbz(i)*fs(i,09)+eta2(i)*fp(i,27)+c1(i,5)*two
      fp(i,28)=pxbx(i)*fs(i,10)+eta2(i)*fp(i,28)
      fp(i,29)=pyby(i)*fs(i,10)+eta2(i)*fp(i,29)
 1040 fp(i,30)=pzbz(i)*fs(i,10)+eta2(i)*fp(i,30)+c1(i,6)*three

      do 1041 j=1,10
      do 1041 i=1,n
 1041 c1(i,j)=fs(i,j)/twozeta(i)-eta2(i)*fs0(i,j)/twozetab(i)

      do 1042 j=1,18
      do 1042 i=1,n
 1042 c2(i,j)=dp(i,j)/twozeta(i)

      do 1043 i=1,n
      fd(i,01)=pxbx(i)*fp(i,01)+eta2(i)*fd(i,01)+c1(i,01)+c2(i,01)*three
      fd(i,02)=pyby(i)*fp(i,01)+eta2(i)*fd(i,02)
      fd(i,03)=pzbz(i)*fp(i,01)+eta2(i)*fd(i,03)
      fd(i,04)=pyby(i)*fp(i,02)+eta2(i)*fd(i,04)+c1(i,01)
      fd(i,05)=pzbz(i)*fp(i,02)+eta2(i)*fd(i,05)
      fd(i,06)=pzbz(i)*fp(i,03)+eta2(i)*fd(i,06)+c1(i,01)
      fd(i,07)=pxbx(i)*fp(i,04)+eta2(i)*fd(i,07)+c1(i,02)+c2(i,04)*two
      fd(i,08)=pyby(i)*fp(i,04)+eta2(i)*fd(i,08)         +c2(i,01)
      fd(i,09)=pzbz(i)*fp(i,04)+eta2(i)*fd(i,09)
      fd(i,10)=pyby(i)*fp(i,05)+eta2(i)*fd(i,10)+c1(i,02)+c2(i,02)
      fd(i,11)=pzbz(i)*fp(i,05)+eta2(i)*fd(i,11)
      fd(i,12)=pzbz(i)*fp(i,06)+eta2(i)*fd(i,12)+c1(i,02)
      fd(i,13)=pxbx(i)*fp(i,07)+eta2(i)*fd(i,13)+c1(i,03)+c2(i,07)*two
      fd(i,14)=pyby(i)*fp(i,07)+eta2(i)*fd(i,14)
      fd(i,15)=pzbz(i)*fp(i,07)+eta2(i)*fd(i,15)         +c2(i,01)
      fd(i,16)=pyby(i)*fp(i,08)+eta2(i)*fd(i,16)+c1(i,03)
      fd(i,17)=pzbz(i)*fp(i,08)+eta2(i)*fd(i,17)         +c2(i,02)
      fd(i,18)=pzbz(i)*fp(i,09)+eta2(i)*fd(i,18)+c1(i,03)+c2(i,03)
      fd(i,19)=pxbx(i)*fp(i,10)+eta2(i)*fd(i,19)+c1(i,04)+c2(i,10)
      fd(i,20)=pyby(i)*fp(i,10)+eta2(i)*fd(i,20)         +c2(i,04)*two
      fd(i,21)=pzbz(i)*fp(i,10)+eta2(i)*fd(i,21)
      fd(i,22)=pyby(i)*fp(i,11)+eta2(i)*fd(i,22)+c1(i,04)+c2(i,05)*two
      fd(i,23)=pzbz(i)*fp(i,11)+eta2(i)*fd(i,23)
      fd(i,24)=pzbz(i)*fp(i,12)+eta2(i)*fd(i,24)+c1(i,04)
      fd(i,25)=pxbx(i)*fp(i,13)+eta2(i)*fd(i,25)+c1(i,05)+c2(i,13)
      fd(i,26)=pyby(i)*fp(i,13)+eta2(i)*fd(i,26)         +c2(i,07)
      fd(i,27)=pzbz(i)*fp(i,13)+eta2(i)*fd(i,27)         +c2(i,04)
      fd(i,28)=pyby(i)*fp(i,14)+eta2(i)*fd(i,28)+c1(i,05)+c2(i,08)
      fd(i,29)=pzbz(i)*fp(i,14)+eta2(i)*fd(i,29)         +c2(i,05)
      fd(i,30)=pzbz(i)*fp(i,15)+eta2(i)*fd(i,30)+c1(i,05)+c2(i,06)
      fd(i,31)=pxbx(i)*fp(i,16)+eta2(i)*fd(i,31)+c1(i,06)+c2(i,16)
      fd(i,32)=pyby(i)*fp(i,16)+eta2(i)*fd(i,32)
      fd(i,33)=pzbz(i)*fp(i,16)+eta2(i)*fd(i,33)         +c2(i,07)*two
      fd(i,34)=pyby(i)*fp(i,17)+eta2(i)*fd(i,34)+c1(i,06)
      fd(i,35)=pzbz(i)*fp(i,17)+eta2(i)*fd(i,35)         +c2(i,08)*two
      fd(i,36)=pzbz(i)*fp(i,18)+eta2(i)*fd(i,36)+c1(i,06)+c2(i,09)*two
      fd(i,37)=pxbx(i)*fp(i,19)+eta2(i)*fd(i,37)+c1(i,07)
      fd(i,38)=pyby(i)*fp(i,19)+eta2(i)*fd(i,38)         +c2(i,10)*three
      fd(i,39)=pzbz(i)*fp(i,19)+eta2(i)*fd(i,39)
      fd(i,40)=pyby(i)*fp(i,20)+eta2(i)*fd(i,40)+c1(i,07)+c2(i,11)*three
      fd(i,41)=pzbz(i)*fp(i,20)+eta2(i)*fd(i,41)
      fd(i,42)=pzbz(i)*fp(i,21)+eta2(i)*fd(i,42)+c1(i,07)
      fd(i,43)=pxbx(i)*fp(i,22)+eta2(i)*fd(i,43)+c1(i,08)
      fd(i,44)=pyby(i)*fp(i,22)+eta2(i)*fd(i,44)         +c2(i,13)*two
      fd(i,45)=pzbz(i)*fp(i,22)+eta2(i)*fd(i,45)         +c2(i,10)
      fd(i,46)=pyby(i)*fp(i,23)+eta2(i)*fd(i,46)+c1(i,08)+c2(i,14)*two
      fd(i,47)=pzbz(i)*fp(i,23)+eta2(i)*fd(i,47)         +c2(i,11)
      fd(i,48)=pzbz(i)*fp(i,24)+eta2(i)*fd(i,48)+c1(i,08)+c2(i,12)
      fd(i,49)=pxbx(i)*fp(i,25)+eta2(i)*fd(i,49)+c1(i,09)
      fd(i,50)=pyby(i)*fp(i,25)+eta2(i)*fd(i,50)         +c2(i,16)
      fd(i,51)=pzbz(i)*fp(i,25)+eta2(i)*fd(i,51)         +c2(i,13)*two
      fd(i,52)=pyby(i)*fp(i,26)+eta2(i)*fd(i,52)+c1(i,09)+c2(i,17)
      fd(i,53)=pzbz(i)*fp(i,26)+eta2(i)*fd(i,53)         +c2(i,14)*two
      fd(i,54)=pzbz(i)*fp(i,27)+eta2(i)*fd(i,54)+c1(i,09)+c2(i,15)*two
      fd(i,55)=pxbx(i)*fp(i,28)+eta2(i)*fd(i,55)+c1(i,10)
      fd(i,56)=pyby(i)*fp(i,28)+eta2(i)*fd(i,56)
      fd(i,57)=pzbz(i)*fp(i,28)+eta2(i)*fd(i,57)         +c2(i,16)*three
      fd(i,58)=pyby(i)*fp(i,29)+eta2(i)*fd(i,58)+c1(i,10)
      fd(i,59)=pzbz(i)*fp(i,29)+eta2(i)*fd(i,59)         +c2(i,17)*three
 1043 fd(i,60)=pzbz(i)*fp(i,30)+eta2(i)*fd(i,60)+c1(i,10)+c2(i,18)*three

      do 1044 j=1,18
      do 1044 i=1,m
 1044 pdcond(i,j)=zero

      do 1045 j=1,60
      do 1045 i=1,m
 1045 fdcond(i,j)=zero

      do 1046 j=1,18
      do 1046 i=1,n
 1046 pdcond(icontr(i),j)=pdcond(icontr(i),j)+pd(i,j)

      do 1047 j=1,60
      do 1047 i=1,n
 1047 fdcond(icontr(i),j)=fdcond(icontr(i),j)+fd(i,j)*twozetaa(i)

      do 1048 i=1,m
      grad(i,01)=pdcond(i,01)*density(inddyy(i,01))*two
      grad(i,02)=pdcond(i,02)*density(inddyy(i,02))*two
      grad(i,03)=pdcond(i,03)*density(inddyy(i,03))*two
      grad(i,04)=pdcond(i,04)*density(inddyy(i,04))*two
      grad(i,05)=pdcond(i,05)*density(inddyy(i,05))*two
      grad(i,06)=pdcond(i,06)*density(inddyy(i,06))*two
      grad(i,07)=pdcond(i,07)*density(inddyy(i,07))
      grad(i,08)=pdcond(i,08)*density(inddyy(i,08))
      grad(i,09)=pdcond(i,09)*density(inddyy(i,09))
      grad(i,10)=pdcond(i,10)*density(inddyy(i,10))
      grad(i,11)=pdcond(i,11)*density(inddyy(i,11))
      grad(i,12)=pdcond(i,12)*density(inddyy(i,12))
      grad(i,13)=pdcond(i,13)*density(inddyy(i,13))
      grad(i,14)=pdcond(i,14)*density(inddyy(i,14))
      grad(i,15)=pdcond(i,15)*density(inddyy(i,15))
      grad(i,16)=pdcond(i,16)*density(inddyy(i,16))
      grad(i,17)=pdcond(i,17)*density(inddyy(i,17))
      grad(i,18)=pdcond(i,18)*density(inddyy(i,18))
      grad(i,19)=pdcond(i,01)*density(inddyy(i,07))
      grad(i,20)=pdcond(i,02)*density(inddyy(i,08))
      grad(i,21)=pdcond(i,03)*density(inddyy(i,09))
      grad(i,22)=pdcond(i,04)*density(inddyy(i,10))
      grad(i,23)=pdcond(i,05)*density(inddyy(i,11))
      grad(i,24)=pdcond(i,06)*density(inddyy(i,12))
      grad(i,25)=pdcond(i,07)*density(inddyy(i,19))*two
      grad(i,26)=pdcond(i,08)*density(inddyy(i,20))*two
      grad(i,27)=pdcond(i,09)*density(inddyy(i,21))*two
      grad(i,28)=pdcond(i,10)*density(inddyy(i,22))*two
      grad(i,29)=pdcond(i,11)*density(inddyy(i,23))*two
      grad(i,30)=pdcond(i,12)*density(inddyy(i,24))*two
      grad(i,31)=pdcond(i,13)*density(inddyy(i,25))
      grad(i,32)=pdcond(i,14)*density(inddyy(i,26))
      grad(i,33)=pdcond(i,15)*density(inddyy(i,27))
      grad(i,34)=pdcond(i,16)*density(inddyy(i,28))
      grad(i,35)=pdcond(i,17)*density(inddyy(i,29))
      grad(i,36)=pdcond(i,18)*density(inddyy(i,30))
      grad(i,37)=pdcond(i,01)*density(inddyy(i,13))
      grad(i,38)=pdcond(i,02)*density(inddyy(i,14))
      grad(i,39)=pdcond(i,03)*density(inddyy(i,15))
      grad(i,40)=pdcond(i,04)*density(inddyy(i,16))
      grad(i,41)=pdcond(i,05)*density(inddyy(i,17))
      grad(i,42)=pdcond(i,06)*density(inddyy(i,18))
      grad(i,43)=pdcond(i,07)*density(inddyy(i,25))
      grad(i,44)=pdcond(i,08)*density(inddyy(i,26))
      grad(i,45)=pdcond(i,09)*density(inddyy(i,27))
      grad(i,46)=pdcond(i,10)*density(inddyy(i,28))
      grad(i,47)=pdcond(i,11)*density(inddyy(i,29))
      grad(i,48)=pdcond(i,12)*density(inddyy(i,30))
      grad(i,49)=pdcond(i,13)*density(inddyy(i,31))*two
      grad(i,50)=pdcond(i,14)*density(inddyy(i,32))*two
      grad(i,51)=pdcond(i,15)*density(inddyy(i,33))*two
      grad(i,52)=pdcond(i,16)*density(inddyy(i,34))*two
      grad(i,53)=pdcond(i,17)*density(inddyy(i,35))*two
 1048 grad(i,54)=pdcond(i,18)*density(inddyy(i,36))*two

      do 1049 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,04)=zero
                              grad(i,05)=zero
                              grad(i,06)=zero
                              grad(i,09)=zero
                              grad(i,10)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,16)=zero
                              grad(i,17)=zero
                              grad(i,18)=zero
                              grad(i,21)=zero
                              grad(i,22)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,29)=zero
                              grad(i,30)=zero
                              grad(i,36)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,48)=zero
                        endif
 1049 continue

      do 1050 k=1,3
      do 1050 j=1,18
      do 1050 i=1,m
 1050 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,18*(k-1)+j)

      do 1051 k=1,3
      do 1051 j=1,18
      do 1051 i=1,m
 1051 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

      do 1052 i=1,m
      grad(i,001)=fdcond(i,01)*density(inddyy(i,01))
      grad(i,002)=fdcond(i,02)*density(inddyy(i,02))
      grad(i,003)=fdcond(i,03)*density(inddyy(i,03))
      grad(i,004)=fdcond(i,04)*density(inddyy(i,04))
      grad(i,005)=fdcond(i,05)*density(inddyy(i,05))
      grad(i,006)=fdcond(i,06)*density(inddyy(i,06))
      grad(i,007)=fdcond(i,07)*density(inddyy(i,07))
      grad(i,008)=fdcond(i,08)*density(inddyy(i,08))
      grad(i,009)=fdcond(i,09)*density(inddyy(i,09))
      grad(i,010)=fdcond(i,10)*density(inddyy(i,10))
      grad(i,011)=fdcond(i,11)*density(inddyy(i,11))
      grad(i,012)=fdcond(i,12)*density(inddyy(i,12))
      grad(i,013)=fdcond(i,13)*density(inddyy(i,13))
      grad(i,014)=fdcond(i,14)*density(inddyy(i,14))
      grad(i,015)=fdcond(i,15)*density(inddyy(i,15))
      grad(i,016)=fdcond(i,16)*density(inddyy(i,16))
      grad(i,017)=fdcond(i,17)*density(inddyy(i,17))
      grad(i,018)=fdcond(i,18)*density(inddyy(i,18))
      grad(i,019)=fdcond(i,19)*density(inddyy(i,19))
      grad(i,020)=fdcond(i,20)*density(inddyy(i,20))
      grad(i,021)=fdcond(i,21)*density(inddyy(i,21))
      grad(i,022)=fdcond(i,22)*density(inddyy(i,22))
      grad(i,023)=fdcond(i,23)*density(inddyy(i,23))
      grad(i,024)=fdcond(i,24)*density(inddyy(i,24))
      grad(i,025)=fdcond(i,25)*density(inddyy(i,25))
      grad(i,026)=fdcond(i,26)*density(inddyy(i,26))
      grad(i,027)=fdcond(i,27)*density(inddyy(i,27))
      grad(i,028)=fdcond(i,28)*density(inddyy(i,28))
      grad(i,029)=fdcond(i,29)*density(inddyy(i,29))
      grad(i,030)=fdcond(i,30)*density(inddyy(i,30))
      grad(i,031)=fdcond(i,31)*density(inddyy(i,31))
      grad(i,032)=fdcond(i,32)*density(inddyy(i,32))
      grad(i,033)=fdcond(i,33)*density(inddyy(i,33))
      grad(i,034)=fdcond(i,34)*density(inddyy(i,34))
      grad(i,035)=fdcond(i,35)*density(inddyy(i,35))
      grad(i,036)=fdcond(i,36)*density(inddyy(i,36))
      grad(i,037)=fdcond(i,07)*density(inddyy(i,01))
      grad(i,038)=fdcond(i,08)*density(inddyy(i,02))
      grad(i,039)=fdcond(i,09)*density(inddyy(i,03))
      grad(i,040)=fdcond(i,10)*density(inddyy(i,04))
      grad(i,041)=fdcond(i,11)*density(inddyy(i,05))
      grad(i,042)=fdcond(i,12)*density(inddyy(i,06))
      grad(i,043)=fdcond(i,19)*density(inddyy(i,07))
      grad(i,044)=fdcond(i,20)*density(inddyy(i,08))
      grad(i,045)=fdcond(i,21)*density(inddyy(i,09))
      grad(i,046)=fdcond(i,22)*density(inddyy(i,10))
      grad(i,047)=fdcond(i,23)*density(inddyy(i,11))
      grad(i,048)=fdcond(i,24)*density(inddyy(i,12))
      grad(i,049)=fdcond(i,25)*density(inddyy(i,13))
      grad(i,050)=fdcond(i,26)*density(inddyy(i,14))
      grad(i,051)=fdcond(i,27)*density(inddyy(i,15))
      grad(i,052)=fdcond(i,28)*density(inddyy(i,16))
      grad(i,053)=fdcond(i,29)*density(inddyy(i,17))
      grad(i,054)=fdcond(i,30)*density(inddyy(i,18))
      grad(i,055)=fdcond(i,37)*density(inddyy(i,19))
      grad(i,056)=fdcond(i,38)*density(inddyy(i,20))
      grad(i,057)=fdcond(i,39)*density(inddyy(i,21))
      grad(i,058)=fdcond(i,40)*density(inddyy(i,22))
      grad(i,059)=fdcond(i,41)*density(inddyy(i,23))
      grad(i,060)=fdcond(i,42)*density(inddyy(i,24))
      grad(i,061)=fdcond(i,43)*density(inddyy(i,25))
      grad(i,062)=fdcond(i,44)*density(inddyy(i,26))
      grad(i,063)=fdcond(i,45)*density(inddyy(i,27))
      grad(i,064)=fdcond(i,46)*density(inddyy(i,28))
      grad(i,065)=fdcond(i,47)*density(inddyy(i,29))
      grad(i,066)=fdcond(i,48)*density(inddyy(i,30))
      grad(i,067)=fdcond(i,49)*density(inddyy(i,31))
      grad(i,068)=fdcond(i,50)*density(inddyy(i,32))
      grad(i,069)=fdcond(i,51)*density(inddyy(i,33))
      grad(i,070)=fdcond(i,52)*density(inddyy(i,34))
      grad(i,071)=fdcond(i,53)*density(inddyy(i,35))
      grad(i,072)=fdcond(i,54)*density(inddyy(i,36))
      grad(i,073)=fdcond(i,13)*density(inddyy(i,01))
      grad(i,074)=fdcond(i,14)*density(inddyy(i,02))
      grad(i,075)=fdcond(i,15)*density(inddyy(i,03))
      grad(i,076)=fdcond(i,16)*density(inddyy(i,04))
      grad(i,077)=fdcond(i,17)*density(inddyy(i,05))
      grad(i,078)=fdcond(i,18)*density(inddyy(i,06))
      grad(i,079)=fdcond(i,25)*density(inddyy(i,07))
      grad(i,080)=fdcond(i,26)*density(inddyy(i,08))
      grad(i,081)=fdcond(i,27)*density(inddyy(i,09))
      grad(i,082)=fdcond(i,28)*density(inddyy(i,10))
      grad(i,083)=fdcond(i,29)*density(inddyy(i,11))
      grad(i,084)=fdcond(i,30)*density(inddyy(i,12))
      grad(i,085)=fdcond(i,31)*density(inddyy(i,13))
      grad(i,086)=fdcond(i,32)*density(inddyy(i,14))
      grad(i,087)=fdcond(i,33)*density(inddyy(i,15))
      grad(i,088)=fdcond(i,34)*density(inddyy(i,16))
      grad(i,089)=fdcond(i,35)*density(inddyy(i,17))
      grad(i,090)=fdcond(i,36)*density(inddyy(i,18))
      grad(i,091)=fdcond(i,43)*density(inddyy(i,19))
      grad(i,092)=fdcond(i,44)*density(inddyy(i,20))
      grad(i,093)=fdcond(i,45)*density(inddyy(i,21))
      grad(i,094)=fdcond(i,46)*density(inddyy(i,22))
      grad(i,095)=fdcond(i,47)*density(inddyy(i,23))
      grad(i,096)=fdcond(i,48)*density(inddyy(i,24))
      grad(i,097)=fdcond(i,49)*density(inddyy(i,25))
      grad(i,098)=fdcond(i,50)*density(inddyy(i,26))
      grad(i,099)=fdcond(i,51)*density(inddyy(i,27))
      grad(i,100)=fdcond(i,52)*density(inddyy(i,28))
      grad(i,101)=fdcond(i,53)*density(inddyy(i,29))
      grad(i,102)=fdcond(i,54)*density(inddyy(i,30))
      grad(i,103)=fdcond(i,55)*density(inddyy(i,31))
      grad(i,104)=fdcond(i,56)*density(inddyy(i,32))
      grad(i,105)=fdcond(i,57)*density(inddyy(i,33))
      grad(i,106)=fdcond(i,58)*density(inddyy(i,34))
      grad(i,107)=fdcond(i,59)*density(inddyy(i,35))
 1052 grad(i,108)=fdcond(i,60)*density(inddyy(i,36))

      do 1053 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1053 continue

      do 1054 k=1,3
      do 1054 j=1,36
      do 1054 i=1,m
 1054 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,36*(k-1)+j)

      do 1055 k=1,3
      do 1055 j=1,36
      do 1055 i=1,m
 1055 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,36*(k-1)+j)

      return
      end

      subroutine cdftdd2(m,n,nn,ncds,naux,iminj,iicontr,inddyy,iloc,
     &                   cdfits,cdfitp,cdfitd,tvec,dmat,dds,ddp,ddd,
     &                   gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension index(15)

      dimension iminj(*),iicontr(*),inddyy(m,*),iloc(*)

      dimension cdfitp(*),cdfitd(*),tvec(*),dmat(*),dds(n,*),ddp(n,*),
     &          ddd(n,*),gather(n,*)

      data zero/0.0d0/

      do 1001 j=1,10
      do 1001 i=1,nn
 1001 gather(i,j)=zero

      do 1002 j=1,36
      do 1002 i=1,nn
 1002 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dds(i,j)

      do 1003 k=1,3
      do 1003 j=1,36
      do 1003 i=1,nn
 1003 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*ddp(i,3*(j-1)+k)

      do 1004 k=1,6
      do 1004 j=1,36
      do 1004 i=1,nn
 1004 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*ddd(i,6*(j-1)+k)

      nnn=0

      do 1005 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 1005 continue

      index(01)=02
      index(02)=03
      index(03)=04
      index(04)=05
      index(05)=06
      index(06)=09
      index(07)=10
      index(08)=11
      index(09)=12
      index(10)=16
      index(11)=17
      index(12)=18
      index(13)=23
      index(14)=24
      index(15)=30

      do 1006 j=1,15
cfpp$ nodepchk
      do 1006 i=1,nnn
 1006 gather(iloc(i),1)=gather(iloc(i),1)
     &                 -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                 *dds(iloc(i),index(j))

      do 1007 k=1,3
      do 1007 j=1,15
cfpp$ nodepchk
      do 1007 i=1,nnn
 1007 gather(iloc(i),k+1)=gather(iloc(i),k+1)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ddp(iloc(i),3*(index(j)-1)+k)

      do 1008 k=1,6
      do 1008 j=1,15
cfpp$ nodepchk
      do 1008 i=1,nnn
 1008 gather(iloc(i),k+4)=gather(iloc(i),k+4)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ddd(iloc(i),6*(index(j)-1)+k)

      do 1009 i=1,nn
      gather(i,01)=gather(i,01)*cdfits
      gather(i,02)=gather(i,02)*cdfitp(1)
      gather(i,03)=gather(i,03)*cdfitp(2)
      gather(i,04)=gather(i,04)*cdfitp(3)
      gather(i,05)=gather(i,05)*cdfitd(1)
      gather(i,06)=gather(i,06)*cdfitd(2)
      gather(i,07)=gather(i,07)*cdfitd(3)
      gather(i,08)=gather(i,08)*cdfitd(4)
      gather(i,09)=gather(i,09)*cdfitd(5)
 1009 gather(i,10)=gather(i,10)*cdfitd(6)

      nc=ncds+(naux-1)*10

      do 1010 i=1,nn
      do 1010 j=1,10
 1010 tvec(nc+j)=tvec(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine gradcdss(m,n,ncds,ilfunc,icfunc,icontr,inddyy,icentr,
     &                    iicontr,g,coord,density,gradient,cdfitc,
     &                    alphaaux,coeffs,zeta,twozetaa,twozetab,px,py,
     &                    pz,base,pxax,pyay,pzaz,axbx,ayby,azbz,zzeta,
     &                    ttwozetaa,ttwozetab,zetarec,ppx,ppy,ppz,ppxax,
     &                    ppyay,ppzaz,wxpx,wypy,wzpz,u,sss0,sss1,pss0,
     &                    sscond,pscond,spcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),icontr(*),inddyy(*),icentr(m,*),
     &          iicontr(*)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),zeta(*),twozetaa(*),twozetab(*),
     &          px(*),py(*),pz(*),base(*),pxax(*),pyay(*),pzaz(*),
     &          axbx(*),ayby(*),azbz(*),zzeta(*),ttwozetaa(*),
     &          ttwozetab(*),zetarec(*),ppx(*),ppy(*),ppz(*),ppxax(*),
     &          ppyay(*),ppzaz(*),wxpx(*),wypy(*),wzpz(*),u(*),sss0(*),
     &          sss1(*),pss0(n,*),sscond(*),pscond(m,*),spcond(m,*),
     &          grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(2,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
 1004 sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1006 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1007 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1007 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1008 j=1,3
      do 1008 i=1,m
 1008 pscond(i,j)=zero

      do 1009 j=1,3
      do 1009 i=1,nn
 1009 pscond(iicontr(i),j)=pscond(iicontr(i),j)+pss0(i,j)*ttwozetaa(i)

      do 1010 j=1,3
      do 1010 i=1,m
 1010 grad(i,j)=pscond(i,j)*density(inddyy(i))*cdfits

      do 1011 j=1,3
      do 1011 i=1,m
 1011 gradient(j,nc)=gradient(j,nc)-grad(i,j)

      do 1012 j=1,3
      do 1012 i=1,m
 1012 gradient(j,icentr(i,1))=gradient(j,icentr(i,1))+grad(i,j)

      do 1013 i=1,m
 1013 sscond(i)=zero

      do 1014 j=1,3
      do 1014 i=1,m
 1014 pscond(i,j)=zero

      do 1015 i=1,nn
 1015 sscond(iicontr(i))=sscond(iicontr(i))+sss0(i)*ttwozetab(i)

      do 1016 j=1,3
      do 1016 i=1,nn
 1016 pscond(iicontr(i),j)=pscond(iicontr(i),j)+pss0(i,j)*ttwozetab(i)

      do 1017 i=1,m
      spcond(i,1)=axbx(i)*sscond(i)+pscond(i,1)
      spcond(i,2)=ayby(i)*sscond(i)+pscond(i,2)
 1017 spcond(i,3)=azbz(i)*sscond(i)+pscond(i,3)

      do 1018 j=1,3
      do 1018 i=1,m
 1018 grad(i,j)=spcond(i,j)*density(inddyy(i))*cdfits

      do 1019 j=1,3
      do 1019 i=1,m
 1019 gradient(j,nc)=gradient(j,nc)-grad(i,j)

      do 1020 j=1,3
      do 1020 i=1,m
 1020 gradient(j,icentr(i,2))=gradient(j,icentr(i,2))+grad(i,j)

 1001 continue

      return
      end

      subroutine boys_pp(m,n,iminj,icontr,inddyy,zeta,px,py,pz,pxax,
     &                   pyay,pzaz,pxbx,pyby,pzbz,base,ss,ps,pp,pso,c,
     &                   c1,c2,x_moment,y_moment,z_moment)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*)

      dimension zeta(*),px(*),py(*),pz(*),pxax(*),pyay(*),pzaz(*),
     &          pxbx(*),pyby(*),pzbz(*),base(*),ss(n,*),ps(n,*),pp(n,*),
     &          pso(n,*),c(*),c1(n,*),c2(n,*),x_moment(*),y_moment(*),
     &          z_moment(*)

      data zero,thrhlf,two,pi/0.0d0,1.5d0,2.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      pso(i,1)=pxax(i)*base(i)
      pso(i,2)=pyay(i)*base(i)
 1002 pso(i,3)=pzaz(i)*base(i)

      do 1003 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1003 ss(i,3)=pz(i)*base(i)

      do 1004 i=1,n
 1004 c(i)=base(i)/(two*zeta(i))

      do 1005 i=1,n
      ps(i,1)=pxax(i)*ss(i,1)+c(i)
      ps(i,2)=pxax(i)*ss(i,2)
      ps(i,3)=pxax(i)*ss(i,3)
      ps(i,4)=pyay(i)*ss(i,1)
      ps(i,5)=pyay(i)*ss(i,2)+c(i)
      ps(i,6)=pyay(i)*ss(i,3)
      ps(i,7)=pzaz(i)*ss(i,1)
      ps(i,8)=pzaz(i)*ss(i,2)
 1005 ps(i,9)=pzaz(i)*ss(i,3)+c(i)

      do 1006 j=1,3
      do 1006 i=1,n
 1006 c1(i,j)=ss(i,j)/(two*zeta(i))

      do 1007 j=1,3
      do 1007 i=1,n
 1007 c2(i,j)=pso(i,j)/(two*zeta(i))

      do 1008 i=1,n
      pp(i,01)=pxbx(i)*ps(i,1)+c1(i,1)+c2(i,1)
      pp(i,02)=pxbx(i)*ps(i,2)+c1(i,2)
      pp(i,03)=pxbx(i)*ps(i,3)+c1(i,3)
      pp(i,04)=pyby(i)*ps(i,1)
      pp(i,05)=pyby(i)*ps(i,2)        +c2(i,1)
      pp(i,06)=pyby(i)*ps(i,3)
      pp(i,07)=pzbz(i)*ps(i,1)
      pp(i,08)=pzbz(i)*ps(i,2)
      pp(i,09)=pzbz(i)*ps(i,3)        +c2(i,1)
      pp(i,10)=pxbx(i)*ps(i,4)        +c2(i,2)
      pp(i,11)=pxbx(i)*ps(i,5)
      pp(i,12)=pxbx(i)*ps(i,6)
      pp(i,13)=pyby(i)*ps(i,4)+c1(i,1)
      pp(i,14)=pyby(i)*ps(i,5)+c1(i,2)+c2(i,2)
      pp(i,15)=pyby(i)*ps(i,6)+c1(i,3)
      pp(i,16)=pzbz(i)*ps(i,4)
      pp(i,17)=pzbz(i)*ps(i,5)
      pp(i,18)=pzbz(i)*ps(i,6)        +c2(i,2)
      pp(i,19)=pxbx(i)*ps(i,7)        +c2(i,3)
      pp(i,20)=pxbx(i)*ps(i,8)
      pp(i,21)=pxbx(i)*ps(i,9)
      pp(i,22)=pyby(i)*ps(i,7)
      pp(i,23)=pyby(i)*ps(i,8)        +c2(i,3)
      pp(i,24)=pyby(i)*ps(i,9)
      pp(i,25)=pzbz(i)*ps(i,7)+c1(i,1)
      pp(i,26)=pzbz(i)*ps(i,8)+c1(i,2)
 1008 pp(i,27)=pzbz(i)*ps(i,9)+c1(i,3)+c2(i,3)

      do 1009 i=1,n
      ii=icontr(i)
      x_moment(inddyy(ii,1))=x_moment(inddyy(ii,1))+pp(i,01)
      x_moment(inddyy(ii,4))=x_moment(inddyy(ii,4))+pp(i,10)
      x_moment(inddyy(ii,5))=x_moment(inddyy(ii,5))+pp(i,13)
      x_moment(inddyy(ii,7))=x_moment(inddyy(ii,7))+pp(i,19)
      x_moment(inddyy(ii,8))=x_moment(inddyy(ii,8))+pp(i,22)
      x_moment(inddyy(ii,9))=x_moment(inddyy(ii,9))+pp(i,25)
      y_moment(inddyy(ii,1))=y_moment(inddyy(ii,1))+pp(i,02)
      y_moment(inddyy(ii,4))=y_moment(inddyy(ii,4))+pp(i,11)
      y_moment(inddyy(ii,5))=y_moment(inddyy(ii,5))+pp(i,14)
      y_moment(inddyy(ii,7))=y_moment(inddyy(ii,7))+pp(i,20)
      y_moment(inddyy(ii,8))=y_moment(inddyy(ii,8))+pp(i,23)
      y_moment(inddyy(ii,9))=y_moment(inddyy(ii,9))+pp(i,26)
      z_moment(inddyy(ii,1))=z_moment(inddyy(ii,1))+pp(i,03)
      z_moment(inddyy(ii,4))=z_moment(inddyy(ii,4))+pp(i,12)
      z_moment(inddyy(ii,5))=z_moment(inddyy(ii,5))+pp(i,15)
      z_moment(inddyy(ii,7))=z_moment(inddyy(ii,7))+pp(i,21)
      z_moment(inddyy(ii,8))=z_moment(inddyy(ii,8))+pp(i,24)
 1009 z_moment(inddyy(ii,9))=z_moment(inddyy(ii,9))+pp(i,27)

      do 1010 i=1,n
      ii=icontr(i)
      if(iminj(ii).ne.0) then

               x_moment(inddyy(ii,2))=x_moment(inddyy(ii,2))+pp(i,04)
               x_moment(inddyy(ii,3))=x_moment(inddyy(ii,3))+pp(i,07)
               x_moment(inddyy(ii,6))=x_moment(inddyy(ii,6))+pp(i,16)
               y_moment(inddyy(ii,2))=y_moment(inddyy(ii,2))+pp(i,05)
               y_moment(inddyy(ii,3))=y_moment(inddyy(ii,3))+pp(i,08)
               y_moment(inddyy(ii,6))=y_moment(inddyy(ii,6))+pp(i,17)
               z_moment(inddyy(ii,2))=z_moment(inddyy(ii,2))+pp(i,06)
               z_moment(inddyy(ii,3))=z_moment(inddyy(ii,3))+pp(i,09)
               z_moment(inddyy(ii,6))=z_moment(inddyy(ii,6))+pp(i,18)

                         endif
 1010 continue

      return
      end

      subroutine ang12(x,y,z,weight)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xunit(12),yunit(12),zunit(12)

      dimension x(*),y(*),z(*),weight(*)

      data xunit/  0.0d0,  0.0d0,  0.0d0,  0.0d0,  1.0d0, -1.0d0,
     &             1.0d0, -1.0d0,  1.0d0, -1.0d0,  1.0d0, -1.0d0/

      data yunit/  1.0d0, -1.0d0,  1.0d0, -1.0d0,  0.0d0,  0.0d0,
     &             0.0d0,  0.0d0,  1.0d0,  1.0d0, -1.0d0, -1.0d0/

      data zunit/  1.0d0,  1.0d0, -1.0d0, -1.0d0,  1.0d0,  1.0d0,
     &            -1.0d0, -1.0d0,  0.0d0,  0.0d0,  0.0d0,  0.0d0/

      data wght1/0.08333333333333d0/

      data one,two/1.0d0,2.0d0/

      rsqrt2=one/sqrt(two)

      do 1001 i=1,12
 1001 weight(i)=wght1

      do 1002 i=1,12
      x(i)=rsqrt2*xunit(i)
      y(i)=rsqrt2*yunit(i)
 1002 z(i)=rsqrt2*zunit(i)

      return
      end

      program main

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      include "params.h"

      character input(natoms,2)*30,atomsymbol(natoms)*4

      common/ci/iwkvec(ninteger),nptsatom(natoms),natomtype(natoms),
     &          izmat1(natoms),izmat2(natoms),izmat3(natoms),
     &          neutral(natoms,natoms),isys(natoms,natoms),
     &          nequivvec(natoms,2),nfuncatom(ncontractions),
     &          ilfunc(ncontractions),icfunc(ncontractions),
     &          mtloca(ncontractions),ngaussians(ncontractions),
     &          nshels(ncontractions),nshelp(ncontractions),
     &          nsheld(ncontractions),icdlfunc(nauxiliary),
     &          icdcfunc(nauxiliary),ixclfunc(nauxiliary),
     &          ixccfunc(nauxiliary),ibfreeze(2,natoms),
     &          iafreeze(3,natoms),idfreeze(4,natoms),iifreeze(4,natoms)

      common/cr/wkvec(nreal),coord(3,natoms),coordsave(3,natoms),
     &          charge(natoms),coordptcharge(3,nptcharges),
     &          ptcharge(nptcharges),grad(3,natoms),cutoff(3),
     &          coeffa(ncontractions,ncontractions),
     &          coeffb(ncontractions,ncontractions),
     &          overlap(ncontractions,ncontractions),dmata(nfockdim),
     &          dmatb(nfockdim),core(nfockdim),focka(nfockdim),
     &          fockb(nfockdim),focke(nfockdim),alpha(nprimitives),
     &          coeff(nprimitives),alphacd(nauxiliary),
     &          coefscd(nauxiliary),coefpcd(nauxiliary),
     &          coefdcd(nauxiliary),alphaxc(nauxiliary),
     &          coefsxc(nauxiliary),coefpxc(nauxiliary),
     &          coefdxc(nauxiliary),cdfitc(nauxiliary),
     &          xcfita(nauxiliary),xcfitb(nauxiliary),
     &          xcfite(nauxiliary),xcfitsave(nauxiliary),
     &          tvector(nauxiliary),tveca(nauxiliary),tvecb(nauxiliary),
     &          tvece(nauxiliary)

      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)

      call mpi_init(ierr)

      call deft(nreal,ninteger,nrbuffer,natoms,ncontractions,nfockdim,
     &          nauxiliary,nmaxpts,nesppts,ncontacts,iwkvec,nptsatom,
     &          natomtype,izmat1,izmat2,izmat3,neutral,isys,nequivvec,
     &          nfuncatom,ilfunc,icfunc,mtloca,ngaussians,nshels,nshelp,
     &          nsheld,icdlfunc,icdcfunc,ixclfunc,ixccfunc,ibfreeze,
     &          iafreeze,idfreeze,iifreeze,wkvec,coord,coordsave,charge,
     &          coordptcharge,ptcharge,grad,coeffa,coeffb,overlap,dmata,
     &          dmatb,core,focka,fockb,focke,alpha,coeff,alphacd,
     &          coefscd,coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,
     &          cdfitc,xcfita,xcfitb,xcfite,xcfitsave,tvector,tveca,
     &          tvecb,tvece,cutoff,buffer,input,atomsymbol)

      call mpi_finalize(ierr)

      stop 'normal'
      end

      subroutine setuppp(m,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &                   icentvc,iminj,icontr,inddyy,cutoff,coord,alpha,
     &                   coeff,zeta,zetaa,zetab,aax,aay,aaz,eta,etarr,
     &                   base,px,py,pz,pxax,pyay,pzaz,pxbx,pyby,pzbz,
     &                   axbx,ayby,azbz)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshelp(*),mtloca(*),iprimvc(*),nprimvc(*),icentvc(*),
     &          iminj(*),icontr(*),inddyy(m,*)

      dimension coord(3,*),alpha(*),coeff(*),zeta(*),zetaa(*),zetab(*),
     &          aax(*),aay(*),aaz(*),eta(*),etarr(*),base(*),px(*),
     &          py(*),pz(*),pxax(*),pyay(*),pzaz(*),pxbx(*),pyby(*),
     &          pzbz(*),axbx(*),ayby(*),azbz(*)

      data zero,expcut/0.0d0,50.0d0/

      icnptr=0

      n=0

      do 1001 i=1,ncontp
      do 1001 j=1,i

      icnptr=icnptr+1

      iminj(icnptr)=i-j

      nconta=nshelp(i)
      ncontb=nshelp(j)

      matlca=mtloca(nconta)
      matlcb=mtloca(ncontb)

      i1=matlca
      i2=(i1*(i1-1))/2
      i3=matlcb
      i4=i2+i3

      inddyy(icnptr,1)=i4
      inddyy(icnptr,2)=i4+1
      inddyy(icnptr,3)=i4+2
      inddyy(icnptr,4)=i4+i1
      inddyy(icnptr,5)=i4+i1+1
      inddyy(icnptr,6)=i4+i1+2
      inddyy(icnptr,7)=i4+i1+i1+1
      inddyy(icnptr,8)=i4+i1+i1+2
      inddyy(icnptr,9)=i4+i1+i1+3

      iprima=iprimvc(nconta)
      iprimb=iprimvc(ncontb)

      nprima=iprima+nprimvc(nconta)-1
      nprimb=iprimb+nprimvc(ncontb)-1

      icenta=icentvc(nconta)
      icentb=icentvc(ncontb)

      ax=coord(1,icenta)
      ay=coord(2,icenta)
      az=coord(3,icenta)

      bx=coord(1,icentb)
      by=coord(2,icentb)
      bz=coord(3,icentb)

      caxbx=ax-bx
      cayby=ay-by
      cazbz=az-bz

      axbx(icnptr)=caxbx
      ayby(icnptr)=cayby
      azbz(icnptr)=cazbz

      rr=caxbx*caxbx+cayby*cayby+cazbz*cazbz

      if(rr.gt.(cutoff**2)) goto 1001

      do 1002 ii=iprima,nprima
      do 1002 jj=iprimb,nprimb

      test=alpha(ii)*alpha(jj)*rr/(alpha(ii)+alpha(jj))

      if(test.lt.expcut) then
                               n=n+1

                               icontr(n)=icnptr

                               zetaa(n)=alpha(ii)
                               zetab(n)=alpha(jj)

                               zeta(n)=zetaa(n)+zetab(n)

                               factor=coeff(ii)*coeff(jj)

                               aax(n)=ax
                               aay(n)=ay
                               aaz(n)=az

                               px(n)=(zetaa(n)*ax+zetab(n)*bx)/zeta(n)
                               py(n)=(zetaa(n)*ay+zetab(n)*by)/zeta(n)
                               pz(n)=(zetaa(n)*az+zetab(n)*bz)/zeta(n)

                               pxax(n)=px(n)-ax
                               pyay(n)=py(n)-ay
                               pzaz(n)=pz(n)-az

                               pxbx(n)=px(n)-bx
                               pyby(n)=py(n)-by
                               pzbz(n)=pz(n)-bz

                               eta(n)=zetaa(n)*zetab(n)/zeta(n)

                               etarr(n)=eta(n)*rr

                               base(n)=factor*exp(-etarr(n))
                         endif
 1002 continue
 1001 continue

      return
      end

      subroutine deft(nreal,ninteger,nbuffer,nmaxatoms,nmaxcontractions,
     &                ndim,nauxfunctions,nmaxpoints,nesppts,ncontacts,
     &                iwkvec,nptsatom,natomtype,izmat1,izmat2,izmat3,
     &                neutral,isys,nequivvec,nfuncatom,ilfunc,icfunc,
     &                mtloca,ngaussians,nshels,nshelp,nsheld,icdlfunc,
     &                icdcfunc,ixclfunc,ixccfunc,ibfreeze,iafreeze,
     &                idfreeze,iifreeze,wkvec,coord,coordsave,charge,
     &                coordptcharge,ptcharge,grad,coeffa,coeffb,overlap,
     &                dmta,dmtb,core,focka,fockb,focke,alpha,coeff,
     &                alphacd,coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &                coefpxc,coefdxc,cdfitc,xcfita,xcfitb,xcfite,
     &                xcfitsave,tvector,tveca,tvecb,tvece,cutoff,buffer,
     &                inputstring,atomsymbol)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      character inputstring(nmaxatoms,*)*30,atomsymbol(*)*4

      dimension ibmode(2),iamode(3),idmode(4),iimode(4)

      dimension iwkvec(*),nptsatom(*),natomtype(*),izmat1(*),izmat2(*),
     &          izmat3(*),neutral(nmaxatoms,*),isys(nmaxatoms,*),
     &          nequivvec(nmaxatoms,*),nfuncatom(*),ilfunc(*),icfunc(*),
     &          mtloca(*),ngaussians(*),nshels(*),nshelp(*),nsheld(*),
     &          icdlfunc(*),icdcfunc(*),ixclfunc(*),ixccfunc(*),
     &          ibfreeze(2,*),iafreeze(3,*),idfreeze(4,*),iifreeze(4,*)

      dimension wkvec(*),coord(3,*),coordsave(3,*),charge(*),
     &          coordptcharge(3,*),ptcharge(*),grad(3,*),
     &          coeffa(nmaxcontractions,*),coeffb(nmaxcontractions,*),
     &          overlap(nmaxcontractions,*),dmta(*),dmtb(*),core(*),
     &          focka(*),fockb(*),focke(*),alpha(*),coeff(*),alphacd(*),
     &          coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),coefsxc(*),
     &          coefpxc(*),coefdxc(*),cdfitc(*),xcfita(*),xcfitb(*),
     &          xcfite(*),xcfitsave(*),tvector(*),tveca(*),tvecb(*),
     &          tvece(*),cutoff(*),buffer(*)

      data zero,one,two,three,four,five,seven/0.0d0,1.0d0,2.0d0,3.0d0,
     &                                        4.0d0,5.0d0,7.0d0/
      data smallnumber,bignumber/0.000001d0,1.0d+25/
      data bohr,evolt/0.529177d0,27.2116d0/

      call startup

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      call mpi_buffer_attach(buffer,nbuffer*8,ierror)

      if(myid.gt.0) goto 1014

      imode=0
      imesp=0
      irestart=0
      ioptimize=0
      ncenters=0
      nptcharges=0
      iptsflag=1
      icharge=0
      imultiplicity=1
      ngridtype=5454
      nfunctional=0
      idiis=1
      idiffuse=0
      ixcfit=0
      iptsweight=1
      nmaxiterations=50
      nmaxgeometries=30
      ivibrations=0
      ilocalize=0
      nfdpbt=0
      nequivalences=0
      nbneutrals=0
      nbsystems=1
      level=1
      ibfrozen=0
      iafrozen=0
      idfrozen=0
      iifrozen=0

      do 1001 j=1,nmaxatoms
      do 1001 i=1,nmaxatoms
      isys(i+1,1)=i
      nequivvec(i,1)=0
      nequivvec(i,2)=0
 1001 neutral(i,j)=0

      dmixing=0.100
      dmaxstep=0.300
      econvergence=0.00000001
      gconvergence=0.00180
      elevelshift=zero
      epsilon=one
      cutoff(1)=five
      cutoff(2)=seven
      cutoff(3)=bignumber

      call input(nmaxatoms,ncenters,nptcharges,ilocalize,ibfrozen,
     &           iafrozen,idfrozen,iifrozen,nfunctional,ngridtype,
     &           nmaxiterations,nmaxgeometries,iptsflag,icharge,
     &           imultiplicity,idiis,nfdpbt,irestart,imesp,ioptimize,
     &           ivibrations,intcoordflag,imode,nequivalences,
     &           nbneutrals,nbsystems,idiffuse,ixcfit,iptsweight,izmat1,
     &           izmat2,izmat3,natomtype,nequivvec,neutral,isys,
     &           ibfreeze,iafreeze,idfreeze,iifreeze,ibmode,iamode,
     &           idmode,iimode,econvergence,gconvergence,dmixing,
     &           dmaxstep,elevelshift,epsilon,cutoff,coord,charge,
     &           coordptcharge,ptcharge,atomsymbol)

      if(nbsystems.gt.1) nbsystems=nbsystems-1

      if(nbsystems.eq.1) isys(1,1)=ncenters

      write(6,1002)
 1002 format(//)

      dnuclearcharge=zero

      do 1003 i=1,ncenters
 1003 dnuclearcharge=dnuclearcharge+charge(i)

      nelectrons=nint(dnuclearcharge)-icharge

      if((mod(imultiplicity,2)).eq.1) then

                  nalpha=(nelectrons/2)+((imultiplicity-1)/2)
                  nbeta=(nelectrons/2)-((imultiplicity-1)/2)

                                      else

                  nalpha=((nelectrons+1)/2)+((imultiplicity-2)/2)
                  nbeta=((nelectrons-1)/2)-((imultiplicity-2)/2)

                                      endif

      if((nalpha+nbeta).ne.nelectrons) then

             write(6,1004)
 1004        format(' the charge and multiplicity do not make sense')
             stop

                                       endif

      savedmixing=dmixing

      call inputbases(nmaxatoms,ncenters,nconts,ncontp,ncontd,
     &                ncontractions,ncds,ncdsets,ncdfunctions,nxcs,
     &                nxcsets,nxcfunctions,idiffuse,ixcfit,wkvec,
     &                wkvec(1*nauxfunctions+1),wkvec(2*nauxfunctions+1),
     &                wkvec(3*nauxfunctions+1),icfunc,ilfunc,ngaussians,
     &                mtloca,nshels,nshelp,nsheld,icdcfunc,icdlfunc,
     &                ixccfunc,ixclfunc,natomtype,alpha,coeff,alphacd,
     &                coefscd,coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,
     &                coefdxc,inputstring)

      do 1005 i=1,ncdfunctions
 1005 cdfitc(i)=zero

      icds=0
      icdspd=ncds

      do 1006 i=1,ncenters
 1006 if(natomtype(i).ne.0) call start(natomtype(i),icds,icdspd,cdfitc)

      do 1007 i=1,nxcfunctions
      xcfita(i)=-(one/three)*cdfitc(i)
      xcfitb(i)=-(one/three)*cdfitc(i)
 1007 xcfite(i)=-(one/three)*(three/four)*cdfitc(i)

      ja=1
      jb=ja+9*ncenters**2
      jc=jb+9*ncenters**2
      jd=jc+3*ncenters
      je=jd+3*ncenters
      jf=je+3*ncenters

      if(ioptimize.ne.0) then
                               do 1008 j=1,ncenters
                               do 1008 i=1,3
 1008                          coordsave(i,j)=coord(i,j)
                         endif

      if(irestart.ne.0) call readt(ncenters,ncdfunctions,nxcfunctions,
     &                             nmaxcontractions,ncontractions,coord,
     &                             cdfitc,xcfita,xcfitb,xcfite,coeffa,
     &                             coeffb)

      if(intcoordflag.eq.1) call zmatrix(ncenters,coord,izmat1,izmat2,
     &                                   izmat3,atomsymbol)

      write(6,1009)
 1009 format(' cartesian coordinates (with basis sets):',/)

      if(idiffuse.eq.1) write(6,1010)
 1010 format('   N.B. on heavy atoms, diffuse functions added to',
     &         ' the following bases ',/)
      if(idiffuse.eq.2) write(6,1011)
 1011 format('   N.B. on all atoms, diffuse functions added to',
     &         ' the following bases ',/)

      do 1012 i=1,ncenters
 1012 write(6,1013) atomsymbol(i),coord(1,i)*bohr,coord(2,i)*bohr,
     &              coord(3,i)*bohr,inputstring(i,1),inputstring(i,2)
 1013 format(1x,a4,2x,3f12.7,6x,a30,/,49x,a30,/)

      if(irestart.eq.3) goto 1028

      call rijmat(ncenters,atomsymbol,coord)

 1014 continue

      call mpi_bcast(ioptimize,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ivibrations,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(imesp,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(irestart,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(intcoordflag,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(iptsflag,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ixcfit,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(iptsweight,1,mpi_integer,0,mpi_comm_world,ierr)

      if(ivibrations.eq.1) then

          if(myid.eq.0) call savet(ncenters,ncdfunctions,nxcfunctions,
     &                             nmaxcontractions,ncontractions,coord,
     &                             cdfitc,xcfita,xcfitb,xcfite,coeffa,
     &                             coeffb)

          call vibrations(nreal,ninteger,nmaxatoms,nmaxcontractions,
     &                    nauxfunctions,nmaxpoints,ncenters,
     &                    nptcharges,nbsystems,level,nalpha,nbeta,
     &                    nconts,ncontp,ncontd,ncds,ncdsets-ncds,nxcs,
     &                    nxcsets-nxcs,idiis,nmaxiterations,nfunctional,
     &                    ngridtype,ibfrozen,iafrozen,idfrozen,iifrozen,
     &                    ixcfit,iptsweight,imode,iwkvec,izmat1,izmat2,
     &                    izmat3,natomtype,nfuncatom,nptsatom,icfunc,
     &                    ilfunc,ngaussians,mtloca,nshels,nshelp,nsheld,
     &                    icdcfunc,icdlfunc,ixccfunc,ixclfunc,isys,
     &                    ibfreeze,iafreeze,idfreeze,iifreeze,ibmode,
     &                    iamode,idmode,iimode,econvergence,dmixing,
     &                    elevelshift,cutoff,wkvec,coord,coordsave,
     &                    charge,grad,coordptcharge,ptcharge,overlap,
     &                    core,focka,fockb,focke,dmta,dmtb,coeffa,
     &                    coeffb,alpha,coeff,alphacd,coefscd,coefpcd,
     &                    coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,
     &                    cdfitc,xcfita,xcfitb,xcfite,xcfitsave,tvector,
     &                    tveca,tvecb,tvece,atomsymbol)

            return

                      endif

      if(ioptimize.eq.0) then

          call scfcontrol(nfdpbt,nreal,ninteger,nmaxatoms,
     &                    nmaxcontractions,nauxfunctions,nmaxpoints,
     &                    ncontacts,nesppts,nmaxiterations,nfunctional,
     &                    idiis,ngridtype,iptsflag,ncenters,nptcharges,
     &                    nbsystems,level,nalpha,nbeta,nconts,ncontp,
     &                    ncontd,ncds,ncdsets-ncds,nxcs,nxcsets-nxcs,
     &                    ixcfit,natomtype,nptsatom,nshels,nshelp,
     &                    nsheld,ilfunc,icfunc,ngaussians,mtloca,
     &                    nfuncatom,icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &                    isys,iwkvec,epsilon,econvergence,dmixing,
     &                    elevelshift,cutoff,coord,charge,coordptcharge,
     &                    ptcharge,core,focka,fockb,focke,dmta,dmtb,
     &                    coeffa,coeffb,overlap,alpha,coeff,alphacd,
     &                    coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &                    coefpxc,coefdxc,cdfitc,xcfita,xcfitb,xcfite,
     &                    xcfitsave,tvector,tveca,tvecb,tvece,wkvec)

          goto 1028

                         endif

      gradfactor=bignumber

      call mpi_bcast(nmaxgeometries,1,mpi_integer,0,mpi_comm_world,ierr)

      do 1015 igeom=1,nmaxgeometries

      call mpi_bcast(gradfactor,1,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(gconvergence,1,mpi_real8,0,mpi_comm_world,ierr)

      if(gradfactor.lt.gconvergence) goto 1015

      if(myid.eq.0) then
                          write(6,1016) igeom
 1016                     format(////,' geometry # ',i4,/)

                          if(intcoordflag.eq.1) call zmatrix(ncenters,
     &                                                       coord,
     &                                                       izmat1,
     &                                                       izmat2,
     &                                                       izmat3,
     &                                                       atomsymbol)

                          write(6,1017)
 1017                     format(' cartesian coordinates :',/)

                          do 1018 i=1,ncenters
 1018                     write(6,1019) atomsymbol(i),coord(1,i)*bohr,
     &                                                coord(2,i)*bohr,
     &                                                coord(3,i)*bohr
 1019                     format(5x,a4,2x,3f15.7)

                          write(6,1020)
 1020                     format()
                    endif

      call scfcontrol(nfdpbt,nreal,ninteger,nmaxatoms,nmaxcontractions,
     &                nauxfunctions,nmaxpoints,ncontacts,nesppts,
     &                nmaxiterations,nfunctional,idiis,ngridtype,
     &                iptsflag,ncenters,nptcharges,nbsystems,level,
     &                nalpha,nbeta,nconts,ncontp,ncontd,ncds,
     &                ncdsets-ncds,nxcs,nxcsets-nxcs,ixcfit,natomtype,
     &                nptsatom,nshels,nshelp,nsheld,ilfunc,icfunc,
     &                ngaussians,mtloca,nfuncatom,icdlfunc,icdcfunc,
     &                ixclfunc,ixccfunc,isys,iwkvec,epsilon,
     &                econvergence,dmixing,elevelshift,cutoff,coord,
     &                charge,coordptcharge,ptcharge,core,focka,fockb,
     &                focke,dmta,dmtb,coeffa,coeffb,overlap,alpha,coeff,
     &                alphacd,coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &                coefpxc,coefdxc,cdfitc,xcfita,xcfitb,xcfite,
     &                xcfitsave,tvector,tveca,tvecb,tvece,wkvec)

      if(ixcfit.eq.0) then
                            nxcs=0
                            nxcsets=0
                      endif

      call mpi_bcast(ncontractions,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(savedmixing,1,mpi_real8,0,mpi_comm_world,ierr)

      dmixing=savedmixing

      nsqdim=ncontractions*(ncontractions+1)/2
      ja=3*nsqdim

      call mpi_bcast(ncdsets,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nfuncatom,ncontractions,
     &               mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(izmat1,ncenters,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(izmat2,ncenters,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(izmat3,ncenters,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(dmaxstep,1,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coordsave,3*ncenters,
     &               mpi_real8,0,mpi_comm_world,ierr)

      call move(0,igeom,nreal-ja,ninteger,nmaxpoints,nmaxcontractions,
     &          nsqdim,ncenters,nalpha,nbeta,ncontractions,nconts,
     &          ncontp,ncontd,ncds,ncdsets-ncds,ibfrozen,iafrozen,
     &          idfrozen,iifrozen,imode,ngridtype,iptsweight,natomtype,
     &          nptsatom,nfuncatom,izmat1,izmat2,izmat3,nshels,nshelp,
     &          nsheld,ilfunc,icfunc,ngaussians,mtloca,icdlfunc,
     &          icdcfunc,ibfreeze,iafreeze,idfreeze,iifreeze,ibmode,
     &          iamode,idmode,iimode,iwkvec,gradfactor,dmaxstep,
     &          gconvergence,coordsave,coord,charge,dmta,dmtb,coeffa,
     &          coeffb,alpha,coeff,cdfitc,alphacd,coefscd,coefpcd,
     &          coefdcd,grad,wkvec(1),wkvec(ja+1),atomsymbol)

 1015 continue

      if(gradfactor.lt.gconvergence) then
                                           if(myid.eq.0) write(6,1021)
                                     else
                                           if(myid.eq.0) write(6,1022)
                                     endif

 1021 format(/,' geometry optimized!!! :-) :-) :-) ',//)
 1022 format(/,' geometry not optimized??? :-( :-( :-( ',//)

      if(myid.eq.0) write(6,1023)
 1023 format(/,' final geometry:',/)

      if((intcoordflag.eq.1).and.(myid.eq.0)) call zmatrix(ncenters,
     &                                                     coord,
     &                                                     izmat1,
     &                                                     izmat2,
     &                                                     izmat3,
     &                                                     atomsymbol)

      if(myid.eq.0) write(6,1024)
 1024 format(' cartesian coordinates :',/)

      do 1025 i=1,ncenters
 1025 if(myid.eq.0) write(6,1026) atomsymbol(i),coord(1,i)*bohr,
     &                            coord(2,i)*bohr,coord(3,i)*bohr
 1026 format(5x,a4,2x,3f15.7)

      if(myid.eq.0) write(6,1027)
 1027 format()

 1028 continue

      if(myid.eq.0) call rijmat(ncenters,atomsymbol,coord)

      if(myid.eq.0) call writet(ncenters,ncdfunctions,nxcfunctions,
     &                          nmaxcontractions,ncontractions,coord,
     &                          cdfitc,xcfita,xcfitb,xcfite,coeffa,
     &                          coeffb)

      if(myid.ne.0) return

      ncontractions=nconts+3*ncontp+6*ncontd

      ja=1
      jb=ja+3*nesppts
      jc=jb+4*nmaxatoms*nmaxatoms
      jd=jc+2*nmaxatoms
      je=jd+nmaxatoms
      jf=je+3*nmaxatoms
      jg=jf+3*nmaxatoms
      jh=jg+3*ncontacts

      if(imesp.eq.1) then

               do 2001 i=1,ncontractions
               do 2001 j=1,i
               imax=max(i,j)
               imin=min(i,j)
               ij=((imax*(imax-1))/2)+imin
               temp_value=zero
               do 2002 k=1,nalpha
 2002          temp_value=temp_value+coeffa(i,k)*coeffa(j,k)
               if(i.ne.j) temp_value=two*temp_value
 2001          dmta(ij)=temp_value

               do 3001 i=1,ncontractions
               do 3001 j=1,i
               imax=max(i,j)
               imin=min(i,j)
               ij=((imax*(imax-1))/2)+imin
               temp_value=zero
               do 3002 k=1,nalpha
 3002          temp_value=temp_value+coeffb(i,k)*coeffb(j,k)
               if(i.ne.j) temp_value=two*temp_value
 3001          dmtb(ij)=temp_value

               call mespgen(nreal-jh,ninteger-2*nesppts,iptsflag,
     &                      nmaxatoms,nesppts,ncontacts,nauxfunctions,
     &                      level,ncenters,nbsystems,nequivalences,
     &                      nbneutrals,nalpha,nbeta,nconts,ncontp,
     &                      ncontd,ncds,ncdsets-ncds,nshels,nshelp,
     &                      nsheld,ilfunc,ngaussians,icfunc,mtloca,
     &                      icdlfunc,icdcfunc,natomtype,nequivvec,
     &                      neutral,isys,iwkvec,iwkvec(nesppts+1),
     &                      iwkvec(2*nesppts+1),coord,charge,dmta,dmtb,
     &                      alpha,coeff,alphacd,coefscd,coefpcd,coefdcd,
     &                      cdfitc,wkvec(ja),wkvec(jb),wkvec(jc),
     &                      wkvec(jd),wkvec(je),wkvec(jf),wkvec(jg),
     &                      wkvec(jh))

                     endif

      if(irestart.eq.3) return

      ncontractions=nconts+3*ncontp+6*ncontd

      if(myid.eq.0) then
                          ncntsq=(ncontractions*(ncontractions+1))/2

                          rewind 43

                          call fastrd(43,overlap,ncntsq)
                    endif

      if(5*(ncontractions**2)+1.gt.nreal) stop 'mulliken'

      call mulliken(ncontractions,ncenters,nconts,ncontp,ncontd,nshels,
     &              nshelp,nsheld,icfunc,nfuncatom,natomtype,overlap,
     &              dmta,dmtb,wkvec(0*(ncontractions**2)+1),
     &              wkvec(1*(ncontractions**2)+1),
     &              wkvec(2*(ncontractions**2)+1),
     &              wkvec(3*(ncontractions**2)+1),
     &              wkvec(4*(ncontractions**2)+1))

      ja=1
      jb=ja+ncontractions*ncontractions
      jc=jb+ncontractions*ncontractions
      jd=jc+ncontractions*ncontractions
      je=jd+ncontractions*ncontractions
      jf=je+ncontractions
      jg=jf+ncontractions

      if(ilocalize.ge.2) then

                   call boys_mm(nreal-jf,ninteger,ncontractions,nconts,
     &                          ncontp,ncontd,nshels,nshelp,nsheld,
     &                          mtloca,ilfunc,ngaussians,icfunc,iwkvec,
     &                          coord,alpha,coeff,wkvec(ja),wkvec(jb),
     &                          wkvec(jc),wkvec(jd))

                   call boys_loc(ncontractions,nmaxcontractions,nalpha,
     &                           coeffa,wkvec(ja),wkvec(jb),wkvec(jc),
     &                           wkvec(jd),wkvec(je),wkvec(jf),
     &                           wkvec(jg))

                   call orbitals(ncontractions,nmaxcontractions,nalpha,
     &                           nconts,ncontp,ncontd,ilfunc,icfunc,
     &                           ngaussians,nshels,nshelp,nsheld,
     &                           nfuncatom,coord,alpha,coeff,overlap,
     &                           coeffa,wkvec(ja),wkvec(jg),wkvec(jb),
     &                           wkvec(jc))

                   write(6,1029)
 1029              format(///,' boys localized orbitals generated ',
     &                        '(spin alpha)',/)

                   do 1030 iii=1,nalpha

                   write(6,1031) iii
 1031              format('   orbital # ',i5)

                   call boys_print(ncontractions,ncenters,nconts,ncontp,
     &                             ncontd,nshels,nshelp,nsheld,icfunc,
     &                             nfuncatom,natomtype,overlap,
     &                             coeffa(1,iii),
     &                             wkvec(0*(ncontractions**2)+1),
     &                             wkvec(1*(ncontractions**2)+1),
     &                             wkvec(2*(ncontractions**2)+1))

 1030              continue

                   if(nbeta.eq.nalpha) goto 1035

                   call boys_mm(nreal-jf,ninteger,ncontractions,nconts,
     &                          ncontp,ncontd,nshels,nshelp,nsheld,
     &                          mtloca,ilfunc,ngaussians,icfunc,iwkvec,
     &                          coord,alpha,coeff,wkvec(ja),wkvec(jb),
     &                          wkvec(jc),wkvec(jd))

                   call boys_loc(ncontractions,nmaxcontractions,nbeta,
     &                           coeffb,wkvec(ja),wkvec(jb),wkvec(jc),
     &                           wkvec(jd),wkvec(je),wkvec(jf),
     &                           wkvec(jg))

                   call orbitals(ncontractions,nmaxcontractions,nbeta,
     &                           nconts,ncontp,ncontd,ilfunc,icfunc,
     &                           ngaussians,nshels,nshelp,nsheld,
     &                           nfuncatom,coord,alpha,coeff,overlap,
     &                           coeffb,wkvec(ja),wkvec(jg),wkvec(jb),
     &                           wkvec(jc))

                   write(6,1032)
 1032              format(///,' boys localized orbitals generated ',
     &                        '(spin beta)',/)

                   do 1033 iii=1,nbeta

                   write(6,1034) iii
 1034              format('   orbital # ',i5)

                   call boys_print(ncontractions,ncenters,nconts,ncontp,
     &                             ncontd,nshels,nshelp,nsheld,icfunc,
     &                             nfuncatom,natomtype,overlap,
     &                             coeffb(1,iii),
     &                             wkvec(0*(ncontractions**2)+1),
     &                             wkvec(1*(ncontractions**2)+1),
     &                             wkvec(2*(ncontractions**2)+1))

 1033              continue

 1035              continue

                         endif

      if((ilocalize.gt.0).and.(ilocalize.le.2)) then

                   write(6,1036)
 1036              format(///,' canonical orbitals generated ',
     &                        '(spin alpha)')

                   ka=1
                   kb=ka+ncontractions
                   kc=kb+ncontractions*ncontractions
                   kd=kc+ncontractions*ncontractions
                   ke=kd+ncontractions*ncontractions
                   kf=ke+ncontractions

                   call canonical(nmaxcontractions,ncontractions,nalpha,
     &                            nconts,ncontp,ncontd,nfuncatom,iwkvec,
     &                            focka,coeffa,wkvec(ka),wkvec(kb),
     &                            wkvec(kc),wkvec(kd),wkvec(ke),
     &                            wkvec(kf))

                   if(nbeta.eq.nalpha) goto 1038

                   write(6,1037)
 1037              format(///,' canonical orbitals generated ',
     &                        '(spin beta)')

                   ka=1
                   kb=ka+ncontractions
                   kc=kb+ncontractions*ncontractions
                   kd=kc+ncontractions*ncontractions
                   ke=kd+ncontractions*ncontractions
                   kf=ke+ncontractions

                   call canonical(nmaxcontractions,ncontractions,nbeta,
     &                            nconts,ncontp,ncontd,nfuncatom,iwkvec,
     &                            fockb,coeffb,wkvec(ka),wkvec(kb),
     &                            wkvec(kc),wkvec(kd),wkvec(ke),
     &                            wkvec(kf))

 1038              continue

                                                endif

      na=ncontractions*(ncontractions+1)/2

      call dipolemm(nreal-na-5,ninteger,ncenters,nconts,ncontp,ncontd,
     &              nshels,nshelp,nsheld,mtloca,ilfunc,ngaussians,
     &              icfunc,iwkvec,wkvec,coord,charge,alpha,coeff,dmta,
     &              dmtb,wkvec(5),wkvec(na+5))

      call mpi_buffer_detach(buffer,nbuffer*8,ierror)

      return
      end

      subroutine abmat(itest,ncycle,mvalue,nvalue,nmaxcontractions,
     &                 nalpha,ncontractions,coeffa,dint,a,b)

c  this subroutine written by sor koon goh of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)
 
      dimension coeffa(nmaxcontractions,*),a(nalpha,*),b(nalpha,*)

      dimension dint(ncontractions*(ncontractions+1)/2,*)

      data zero,quarter,pi/0.0d0,0.25d0,3.1415926535898d0/

      do 1001 n=1,nalpha
      do 1001 m=1,n
      if(itest.eq.0) then
                           if((ncycle.gt.1).and.
     &                        ((m.ne.mvalue).and.(m.ne.nvalue)).and.
     &                        ((n.ne.mvalue).and.(n.ne.nvalue)))
     &                        goto 1001
                     else
                           if((m.ne.mvalue).or.(n.ne.nvalue)) goto 1001
                     endif
      a(m,n)=zero
      b(m,n)=zero
      if(m.eq.n) goto 1001
      do 1002 l=1,ncontractions
      cm=coeffa(l,m)
      cn=coeffa(l,n)
      do 1002 k=1,ncontractions
      cmm=coeffa(k,m)*cm
      cmn=coeffa(k,m)*cn
      cnn=coeffa(k,n)*cn
      do 1002 j=1,ncontractions
      cmmm=coeffa(j,m)*cmm*quarter
      cmmn=coeffa(j,m)*cmn
      cmnn=coeffa(j,m)*cnn*quarter
      cnmm=coeffa(j,n)*cmm*quarter
      cnmn=coeffa(j,n)*cmn
      cnnn=coeffa(j,n)*cnn*quarter
      fac1=cnmn+cmnn-cmmm
      fac2=cnmm-cnnn
      do 1002 i=1,ncontractions
      ijmin=min(i,j)
      ijmax=max(i,j)
      klmin=min(k,l)
      klmax=max(k,l)
      ij=(ijmax*(ijmax-1)/2)+ijmin
      kl=(klmax*(klmax-1)/2)+klmin
      a(m,n)=a(m,n)+coeffa(i,m)*fac1*dint(ij,kl)
     &             +coeffa(i,n)*fac2*dint(ij,kl)
      b(m,n)=b(m,n)+coeffa(i,m)*cmmn*dint(ij,kl)
     &             -coeffa(i,n)*cnmn*dint(ij,kl)
 1002 continue
 1001 continue

      return
      end

      function sumsum(n,x)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension x(*)

      data zero/0.0d0/

      sumsum=zero
 
      do 1001 i=1,n
 1001 sumsum=sumsum+abs(x(i))

      return
      end

      real*8 function dmaxvec(a,n)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension a(*)

      data zero/0.0d0/

      dmaxvec=zero

      do 1001 i=1,n
 1001 if(abs(a(i)).gt.dmaxvec) dmaxvec=abs(a(i))

      return
      end

      subroutine cdpops(level,n,natoms,nmaxatoms,nconts,ncontp,ncontd,
     &                  nbsystems,nshels,nshelp,nsheld,icfunc,
     &                  nfuncatom,isys,overlap,dmta,dmtb,cdnorm,
     &                  pmat,smat,psmat,population)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),nfuncatom(*),icfunc(*),
     &          isys(nmaxatoms,*)

      dimension overlap(*),dmta(*),dmtb(*)

      dimension cdnorm(*),pmat(n,*),smat(n,*),psmat(n,*),population(*)

      data zero,half,one/0.0d0,0.5d0,1.0d0/

      ij=0

      do 1001 i=1,n
      do 1001 j=1,i
      ij=ij+1
      factor=half
      if(i.eq.j) factor=one
      pmat(i,j)=(dmta(ij)+dmtb(ij))*factor
 1001 pmat(j,i)=(dmta(ij)+dmtb(ij))*factor

      ij=0

      do 1002 i=1,n
      do 1002 j=1,i
      ij=ij+1
      smat(i,j)=overlap(ij)
 1002 smat(j,i)=overlap(ij)

      do 1003 j=1,n
      do 1004 i=1,n
 1004 psmat(i,j)=zero
      do 1003 k=1,n
      do 1003 i=1,n
 1003 psmat(i,j)=psmat(i,j)+pmat(i,k)*smat(k,j)

      ii=0

      do 1005 i=1,nconts
      nfuncatom(ii+1)=icfunc(nshels(i))
 1005 ii=ii+1

      do 1006 i=1,ncontp
      do 1007 k=1,3
 1007 nfuncatom(ii+k)=icfunc(nshelp(i))
 1006 ii=ii+3

      do 1008 i=1,ncontd
      do 1009 k=1,6
 1009 nfuncatom(ii+k)=icfunc(nsheld(i))
 1008 ii=ii+6

      do 1010 i=1,natoms
      population(i)=zero
      do 1010 j=1,n
 1010 if(nfuncatom(j).eq.i) population(i)=population(i)+psmat(j,j)

      do 1011 i=1,nbsystems
 1011 cdnorm(i)=zero

      do 1012 i=1,nbsystems
      do 1012 j=1,isys(1,i)
      do 1012 k=1,level
 1012 cdnorm(i)=cdnorm(i)+population((k-1)*(natoms/level)+isys(j+1,i))

      return
      end

      subroutine gradcddd(m,n,ncds,ilfunc,icfunc,iminj,icontr,inddyy,
     &                    icentr,iicontr,g,coord,density,gradient,
     &                    cdfitc,alphaaux,coeffs,zeta,twozetaa,twozetab,
     &                    px,py,pz,base,pxax,pyay,pzaz,axbx,ayby,azbz,
     &                    zzeta,ttwozetaa,ttwozetab,zetarec,ppx,ppy,ppz,
     &                    ppxax,ppyay,ppzaz,wxpx,wypy,wzpz,zetac1,u,
     &                    sss0,sss1,sss2,sss3,sss4,sss5,pss0,pss1,pss2,
     &                    pss3,pss4,dss0,dss1,dss2,dss3,fss0,fss1,fss2,
     &                    gss0,gss1,hss0,c,c1,pscond,dscond,ppcond,
     &                    fscond,dpcond,pdcond,gscond,fpcond,ddcond,
     &                    hscond,gpcond,fdcond,dfcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),inddyy(m,*),
     &          icentr(m,*),iicontr(*)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),zeta(*),twozetaa(*),twozetab(*),
     &          px(*),py(*),pz(*),base(*),pxax(*),pyay(*),pzaz(*),
     &          axbx(*),ayby(*),azbz(*),zzeta(*),ttwozetaa(*),
     &          ttwozetab(*),zetarec(*),ppx(*),ppy(*),ppz(*),ppxax(*),
     &          ppyay(*),ppzaz(*),wxpx(*),wypy(*),wzpz(*),zetac1(*),
     &          u(*),sss0(*),sss1(*),sss2(*),sss3(*),sss4(*),sss5(*),
     &          pss0(n,*),pss1(n,*),pss2(n,*),pss3(n,*),pss4(n,*),
     &          dss0(n,*),dss1(n,*),dss2(n,*),dss3(n,*),fss0(n,*),
     &          fss1(n,*),fss2(n,*),gss0(n,*),gss1(n,*),hss0(n,*),c(*),
     &          c1(n,*),pscond(m,*),dscond(m,*),ppcond(m,*),fscond(m,*),
     &          dpcond(m,*),pdcond(m,*),gscond(m,*),fpcond(m,*),
     &          ddcond(m,*),hscond(m,*),gpcond(m,*),fdcond(m,*),
     &          dfcond(m,*),grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(6,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(4)/zeta(i)/zetaux
      sss4(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(5)/zeta(i)/zetaux
 1004 sss5(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(6)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                       sss4(nn)=sss4(i)
                                       sss5(nn)=sss5(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
 1006 zetac1(i)=zetaux*zetarec(i)

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1008 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1009 i=1,nn
      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
 1009 pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      do 1010 i=1,nn
      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
 1010 pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      do 1011 i=1,nn
      pss3(i,1)=ppxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=ppyay(i)*sss3(i)+wypy(i)*sss4(i)
 1011 pss3(i,3)=ppzaz(i)*sss3(i)+wzpz(i)*sss4(i)

      do 1012 i=1,nn
      pss4(i,1)=ppxax(i)*sss4(i)+wxpx(i)*sss5(i)
      pss4(i,2)=ppyay(i)*sss4(i)+wypy(i)*sss5(i)
 1012 pss4(i,3)=ppzaz(i)*sss4(i)+wzpz(i)*sss5(i)

      do 1013 i=1,nn
 1013 c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      do 1014 i=1,nn
      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
 1014 dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      do 1015 i=1,nn
 1015 c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      do 1016 i=1,nn
      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
 1016 dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      do 1017 i=1,nn
 1017 c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zzeta(i))

      do 1018 i=1,nn
      dss2(i,1)=ppxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=ppyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=ppzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=ppyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=ppzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
 1018 dss2(i,6)=ppzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

      do 1019 i=1,nn
 1019 c(i)=(sss3(i)-zetac1(i)*sss4(i))/(two*zzeta(i))

      do 1020 i=1,nn
      dss3(i,1)=ppxax(i)*pss3(i,1)+wxpx(i)*pss4(i,1)+c(i)
      dss3(i,2)=ppyay(i)*pss3(i,1)+wypy(i)*pss4(i,1)
      dss3(i,3)=ppzaz(i)*pss3(i,1)+wzpz(i)*pss4(i,1)
      dss3(i,4)=ppyay(i)*pss3(i,2)+wypy(i)*pss4(i,2)+c(i)
      dss3(i,5)=ppzaz(i)*pss3(i,2)+wzpz(i)*pss4(i,2)
 1020 dss3(i,6)=ppzaz(i)*pss3(i,3)+wzpz(i)*pss4(i,3)+c(i)

      do 1021 j=1,3
      do 1021 i=1,nn
 1021 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zzeta(i))

      do 1022 i=1,nn
      fss0(i,01)=ppxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=ppyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=ppzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=ppyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=ppzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=ppzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=ppyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=ppzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=ppzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 1022 fss0(i,10)=ppzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 1023 j=1,3
      do 1023 i=1,nn
 1023 c1(i,j)=(pss1(i,j)-zetac1(i)*pss2(i,j))/(two*zzeta(i))

      do 1024 i=1,nn
      fss1(i,01)=ppxax(i)*dss1(i,1)+wxpx(i)*dss2(i,1)+c1(i,1)+c1(i,1)
      fss1(i,02)=ppyay(i)*dss1(i,1)+wypy(i)*dss2(i,1)
      fss1(i,03)=ppzaz(i)*dss1(i,1)+wzpz(i)*dss2(i,1)
      fss1(i,04)=ppyay(i)*dss1(i,2)+wypy(i)*dss2(i,2)+c1(i,1)
      fss1(i,05)=ppzaz(i)*dss1(i,2)+wzpz(i)*dss2(i,2)
      fss1(i,06)=ppzaz(i)*dss1(i,3)+wzpz(i)*dss2(i,3)+c1(i,1)
      fss1(i,07)=ppyay(i)*dss1(i,4)+wypy(i)*dss2(i,4)+c1(i,2)+c1(i,2)
      fss1(i,08)=ppzaz(i)*dss1(i,4)+wzpz(i)*dss2(i,4)
      fss1(i,09)=ppzaz(i)*dss1(i,5)+wzpz(i)*dss2(i,5)+c1(i,2)
 1024 fss1(i,10)=ppzaz(i)*dss1(i,6)+wzpz(i)*dss2(i,6)+c1(i,3)+c1(i,3)

      do 1025 j=1,3
      do 1025 i=1,nn
 1025 c1(i,j)=(pss2(i,j)-zetac1(i)*pss3(i,j))/(two*zzeta(i))

      do 1026 i=1,nn
      fss2(i,01)=ppxax(i)*dss2(i,1)+wxpx(i)*dss3(i,1)+c1(i,1)+c1(i,1)
      fss2(i,02)=ppyay(i)*dss2(i,1)+wypy(i)*dss3(i,1)
      fss2(i,03)=ppzaz(i)*dss2(i,1)+wzpz(i)*dss3(i,1)
      fss2(i,04)=ppyay(i)*dss2(i,2)+wypy(i)*dss3(i,2)+c1(i,1)
      fss2(i,05)=ppzaz(i)*dss2(i,2)+wzpz(i)*dss3(i,2)
      fss2(i,06)=ppzaz(i)*dss2(i,3)+wzpz(i)*dss3(i,3)+c1(i,1)
      fss2(i,07)=ppyay(i)*dss2(i,4)+wypy(i)*dss3(i,4)+c1(i,2)+c1(i,2)
      fss2(i,08)=ppzaz(i)*dss2(i,4)+wzpz(i)*dss3(i,4)
      fss2(i,09)=ppzaz(i)*dss2(i,5)+wzpz(i)*dss3(i,5)+c1(i,2)
 1026 fss2(i,10)=ppzaz(i)*dss2(i,6)+wzpz(i)*dss3(i,6)+c1(i,3)+c1(i,3)

      do 1027 j=1,6
      do 1027 i=1,nn
 1027 c1(i,j)=(dss0(i,j)-zetac1(i)*dss1(i,j))/(two*zzeta(i))

      do 1028 i=1,nn
      gss0(i,01)=ppxax(i)*fss0(i,01)+wxpx(i)*fss1(i,01)+c1(i,1)*three
      gss0(i,02)=ppyay(i)*fss0(i,01)+wypy(i)*fss1(i,01)
      gss0(i,03)=ppzaz(i)*fss0(i,01)+wzpz(i)*fss1(i,01)
      gss0(i,04)=ppyay(i)*fss0(i,02)+wypy(i)*fss1(i,02)+c1(i,1)
      gss0(i,05)=ppzaz(i)*fss0(i,02)+wzpz(i)*fss1(i,02)
      gss0(i,06)=ppzaz(i)*fss0(i,03)+wzpz(i)*fss1(i,03)+c1(i,1)
      gss0(i,07)=ppyay(i)*fss0(i,04)+wypy(i)*fss1(i,04)+c1(i,2)*two
      gss0(i,08)=ppzaz(i)*fss0(i,04)+wzpz(i)*fss1(i,04)
      gss0(i,09)=ppzaz(i)*fss0(i,05)+wzpz(i)*fss1(i,05)+c1(i,2)
      gss0(i,10)=ppzaz(i)*fss0(i,06)+wzpz(i)*fss1(i,06)+c1(i,3)*two
      gss0(i,11)=ppyay(i)*fss0(i,07)+wypy(i)*fss1(i,07)+c1(i,4)*three
      gss0(i,12)=ppzaz(i)*fss0(i,07)+wzpz(i)*fss1(i,07)
      gss0(i,13)=ppzaz(i)*fss0(i,08)+wzpz(i)*fss1(i,08)+c1(i,4)
      gss0(i,14)=ppzaz(i)*fss0(i,09)+wzpz(i)*fss1(i,09)+c1(i,5)*two
 1028 gss0(i,15)=ppzaz(i)*fss0(i,10)+wzpz(i)*fss1(i,10)+c1(i,6)*three

      do 1029 j=1,6
      do 1029 i=1,nn
 1029 c1(i,j)=(dss1(i,j)-zetac1(i)*dss2(i,j))/(two*zzeta(i))

      do 1030 i=1,nn
      gss1(i,01)=ppxax(i)*fss1(i,01)+wxpx(i)*fss2(i,01)+c1(i,1)*three
      gss1(i,02)=ppyay(i)*fss1(i,01)+wypy(i)*fss2(i,01)
      gss1(i,03)=ppzaz(i)*fss1(i,01)+wzpz(i)*fss2(i,01)
      gss1(i,04)=ppyay(i)*fss1(i,02)+wypy(i)*fss2(i,02)+c1(i,1)
      gss1(i,05)=ppzaz(i)*fss1(i,02)+wzpz(i)*fss2(i,02)
      gss1(i,06)=ppzaz(i)*fss1(i,03)+wzpz(i)*fss2(i,03)+c1(i,1)
      gss1(i,07)=ppyay(i)*fss1(i,04)+wypy(i)*fss2(i,04)+c1(i,2)*two
      gss1(i,08)=ppzaz(i)*fss1(i,04)+wzpz(i)*fss2(i,04)
      gss1(i,09)=ppzaz(i)*fss1(i,05)+wzpz(i)*fss2(i,05)+c1(i,2)
      gss1(i,10)=ppzaz(i)*fss1(i,06)+wzpz(i)*fss2(i,06)+c1(i,3)*two
      gss1(i,11)=ppyay(i)*fss1(i,07)+wypy(i)*fss2(i,07)+c1(i,4)*three
      gss1(i,12)=ppzaz(i)*fss1(i,07)+wzpz(i)*fss2(i,07)
      gss1(i,13)=ppzaz(i)*fss1(i,08)+wzpz(i)*fss2(i,08)+c1(i,4)
      gss1(i,14)=ppzaz(i)*fss1(i,09)+wzpz(i)*fss2(i,09)+c1(i,5)*two
 1030 gss1(i,15)=ppzaz(i)*fss1(i,10)+wzpz(i)*fss2(i,10)+c1(i,6)*three

      do 1031 j=1,10
      do 1031 i=1,nn
 1031 c1(i,j)=(fss0(i,j)-zetac1(i)*fss1(i,j))/(two*zzeta(i))

      do 1032 i=1,nn
      hss0(i,01)=ppxax(i)*gss0(i,01)+wxpx(i)*gss1(i,01)+c1(i,01)*four
      hss0(i,02)=ppyay(i)*gss0(i,01)+wypy(i)*gss1(i,01)
      hss0(i,03)=ppzaz(i)*gss0(i,01)+wzpz(i)*gss1(i,01)
      hss0(i,04)=ppyay(i)*gss0(i,02)+wypy(i)*gss1(i,02)+c1(i,01)
      hss0(i,05)=ppzaz(i)*gss0(i,02)+wzpz(i)*gss1(i,02)
      hss0(i,06)=ppzaz(i)*gss0(i,03)+wzpz(i)*gss1(i,03)+c1(i,01)
      hss0(i,07)=ppyay(i)*gss0(i,04)+wypy(i)*gss1(i,04)+c1(i,02)*two
      hss0(i,08)=ppzaz(i)*gss0(i,04)+wzpz(i)*gss1(i,04)
      hss0(i,09)=ppzaz(i)*gss0(i,05)+wzpz(i)*gss1(i,05)+c1(i,02)
      hss0(i,10)=ppzaz(i)*gss0(i,06)+wzpz(i)*gss1(i,06)+c1(i,03)*two
      hss0(i,11)=ppyay(i)*gss0(i,07)+wypy(i)*gss1(i,07)+c1(i,04)*three
      hss0(i,12)=ppzaz(i)*gss0(i,07)+wzpz(i)*gss1(i,07)
      hss0(i,13)=ppzaz(i)*gss0(i,08)+wzpz(i)*gss1(i,08)+c1(i,04)
      hss0(i,14)=ppzaz(i)*gss0(i,09)+wzpz(i)*gss1(i,09)+c1(i,05)*two
      hss0(i,15)=ppzaz(i)*gss0(i,10)+wzpz(i)*gss1(i,10)+c1(i,06)*three
      hss0(i,16)=ppyay(i)*gss0(i,11)+wypy(i)*gss1(i,11)+c1(i,07)*four
      hss0(i,17)=ppzaz(i)*gss0(i,11)+wzpz(i)*gss1(i,11)
      hss0(i,18)=ppzaz(i)*gss0(i,12)+wzpz(i)*gss1(i,12)+c1(i,07)
      hss0(i,19)=ppzaz(i)*gss0(i,13)+wzpz(i)*gss1(i,13)+c1(i,08)*two
      hss0(i,20)=ppzaz(i)*gss0(i,14)+wzpz(i)*gss1(i,14)+c1(i,09)*three
 1032 hss0(i,21)=ppzaz(i)*gss0(i,15)+wzpz(i)*gss1(i,15)+c1(i,10)*four

      do 1033 j=1,3
      do 1033 i=1,m
 1033 pscond(i,j)=zero

      do 1034 j=1,6
      do 1034 i=1,m
 1034 dscond(i,j)=zero

      do 1035 j=1,10
      do 1035 i=1,m
 1035 fscond(i,j)=zero

      do 1036 j=1,3
      do 1036 i=1,nn
 1036 pscond(iicontr(i),j)=pscond(iicontr(i),j)-pss0(i,j)

      do 1037 j=1,6
      do 1037 i=1,nn
 1037 dscond(iicontr(i),j)=dscond(iicontr(i),j)-dss0(i,j)

      do 1038 j=1,10
      do 1038 i=1,nn
 1038 fscond(iicontr(i),j)=fscond(iicontr(i),j)-fss0(i,j)

      do 1039 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1039 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1040 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1040 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1041 i=1,m
      pdcond(i,01)=axbx(i)*ppcond(i,1)+dpcond(i,01)
      pdcond(i,02)=ayby(i)*ppcond(i,1)+dpcond(i,04)
      pdcond(i,03)=azbz(i)*ppcond(i,1)+dpcond(i,07)
      pdcond(i,04)=ayby(i)*ppcond(i,2)+dpcond(i,05)
      pdcond(i,05)=azbz(i)*ppcond(i,2)+dpcond(i,08)
      pdcond(i,06)=azbz(i)*ppcond(i,3)+dpcond(i,09)
      pdcond(i,07)=axbx(i)*ppcond(i,4)+dpcond(i,04)
      pdcond(i,08)=ayby(i)*ppcond(i,4)+dpcond(i,10)
      pdcond(i,09)=azbz(i)*ppcond(i,4)+dpcond(i,13)
      pdcond(i,10)=ayby(i)*ppcond(i,5)+dpcond(i,11)
      pdcond(i,11)=azbz(i)*ppcond(i,5)+dpcond(i,14)
      pdcond(i,12)=azbz(i)*ppcond(i,6)+dpcond(i,15)
      pdcond(i,13)=axbx(i)*ppcond(i,7)+dpcond(i,07)
      pdcond(i,14)=ayby(i)*ppcond(i,7)+dpcond(i,13)
      pdcond(i,15)=azbz(i)*ppcond(i,7)+dpcond(i,16)
      pdcond(i,16)=ayby(i)*ppcond(i,8)+dpcond(i,14)
      pdcond(i,17)=azbz(i)*ppcond(i,8)+dpcond(i,17)
 1041 pdcond(i,18)=azbz(i)*ppcond(i,9)+dpcond(i,18)

      do 1042 i=1,m
      grad(i,01)=pdcond(i,01)*density(inddyy(i,01))*cdfits*two
      grad(i,02)=pdcond(i,02)*density(inddyy(i,02))*cdfits*two
      grad(i,03)=pdcond(i,03)*density(inddyy(i,03))*cdfits*two
      grad(i,04)=pdcond(i,04)*density(inddyy(i,04))*cdfits*two
      grad(i,05)=pdcond(i,05)*density(inddyy(i,05))*cdfits*two
      grad(i,06)=pdcond(i,06)*density(inddyy(i,06))*cdfits*two
      grad(i,07)=pdcond(i,07)*density(inddyy(i,07))*cdfits
      grad(i,08)=pdcond(i,08)*density(inddyy(i,08))*cdfits
      grad(i,09)=pdcond(i,09)*density(inddyy(i,09))*cdfits
      grad(i,10)=pdcond(i,10)*density(inddyy(i,10))*cdfits
      grad(i,11)=pdcond(i,11)*density(inddyy(i,11))*cdfits
      grad(i,12)=pdcond(i,12)*density(inddyy(i,12))*cdfits
      grad(i,13)=pdcond(i,13)*density(inddyy(i,13))*cdfits
      grad(i,14)=pdcond(i,14)*density(inddyy(i,14))*cdfits
      grad(i,15)=pdcond(i,15)*density(inddyy(i,15))*cdfits
      grad(i,16)=pdcond(i,16)*density(inddyy(i,16))*cdfits
      grad(i,17)=pdcond(i,17)*density(inddyy(i,17))*cdfits
      grad(i,18)=pdcond(i,18)*density(inddyy(i,18))*cdfits
      grad(i,19)=pdcond(i,01)*density(inddyy(i,07))*cdfits
      grad(i,20)=pdcond(i,02)*density(inddyy(i,08))*cdfits
      grad(i,21)=pdcond(i,03)*density(inddyy(i,09))*cdfits
      grad(i,22)=pdcond(i,04)*density(inddyy(i,10))*cdfits
      grad(i,23)=pdcond(i,05)*density(inddyy(i,11))*cdfits
      grad(i,24)=pdcond(i,06)*density(inddyy(i,12))*cdfits
      grad(i,25)=pdcond(i,07)*density(inddyy(i,19))*cdfits*two
      grad(i,26)=pdcond(i,08)*density(inddyy(i,20))*cdfits*two
      grad(i,27)=pdcond(i,09)*density(inddyy(i,21))*cdfits*two
      grad(i,28)=pdcond(i,10)*density(inddyy(i,22))*cdfits*two
      grad(i,29)=pdcond(i,11)*density(inddyy(i,23))*cdfits*two
      grad(i,30)=pdcond(i,12)*density(inddyy(i,24))*cdfits*two
      grad(i,31)=pdcond(i,13)*density(inddyy(i,25))*cdfits
      grad(i,32)=pdcond(i,14)*density(inddyy(i,26))*cdfits
      grad(i,33)=pdcond(i,15)*density(inddyy(i,27))*cdfits
      grad(i,34)=pdcond(i,16)*density(inddyy(i,28))*cdfits
      grad(i,35)=pdcond(i,17)*density(inddyy(i,29))*cdfits
      grad(i,36)=pdcond(i,18)*density(inddyy(i,30))*cdfits
      grad(i,37)=pdcond(i,01)*density(inddyy(i,13))*cdfits
      grad(i,38)=pdcond(i,02)*density(inddyy(i,14))*cdfits
      grad(i,39)=pdcond(i,03)*density(inddyy(i,15))*cdfits
      grad(i,40)=pdcond(i,04)*density(inddyy(i,16))*cdfits
      grad(i,41)=pdcond(i,05)*density(inddyy(i,17))*cdfits
      grad(i,42)=pdcond(i,06)*density(inddyy(i,18))*cdfits
      grad(i,43)=pdcond(i,07)*density(inddyy(i,25))*cdfits
      grad(i,44)=pdcond(i,08)*density(inddyy(i,26))*cdfits
      grad(i,45)=pdcond(i,09)*density(inddyy(i,27))*cdfits
      grad(i,46)=pdcond(i,10)*density(inddyy(i,28))*cdfits
      grad(i,47)=pdcond(i,11)*density(inddyy(i,29))*cdfits
      grad(i,48)=pdcond(i,12)*density(inddyy(i,30))*cdfits
      grad(i,49)=pdcond(i,13)*density(inddyy(i,31))*cdfits*two
      grad(i,50)=pdcond(i,14)*density(inddyy(i,32))*cdfits*two
      grad(i,51)=pdcond(i,15)*density(inddyy(i,33))*cdfits*two
      grad(i,52)=pdcond(i,16)*density(inddyy(i,34))*cdfits*two
      grad(i,53)=pdcond(i,17)*density(inddyy(i,35))*cdfits*two
 1042 grad(i,54)=pdcond(i,18)*density(inddyy(i,36))*cdfits*two

      do 1043 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,04)=zero
                              grad(i,05)=zero
                              grad(i,06)=zero
                              grad(i,09)=zero
                              grad(i,10)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,16)=zero
                              grad(i,17)=zero
                              grad(i,18)=zero
                              grad(i,21)=zero
                              grad(i,22)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,29)=zero
                              grad(i,30)=zero
                              grad(i,36)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,48)=zero
                        endif
 1043 continue

      do 1044 k=1,3
      do 1044 j=1,18
      do 1044 i=1,m
 1044 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1045 k=1,3
      do 1045 j=1,18
      do 1045 i=1,m
 1045 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

      do 1046 i=1,m
      grad(i,01)=dpcond(i,01)*density(inddyy(i,01))*cdfits*two
      grad(i,02)=dpcond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,03)=dpcond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,04)=dpcond(i,04)*density(inddyy(i,07))*cdfits*two
      grad(i,05)=dpcond(i,05)*density(inddyy(i,08))*cdfits
      grad(i,06)=dpcond(i,06)*density(inddyy(i,09))*cdfits
      grad(i,07)=dpcond(i,07)*density(inddyy(i,13))*cdfits*two
      grad(i,08)=dpcond(i,08)*density(inddyy(i,14))*cdfits
      grad(i,09)=dpcond(i,09)*density(inddyy(i,15))*cdfits
      grad(i,10)=dpcond(i,10)*density(inddyy(i,19))*cdfits*two
      grad(i,11)=dpcond(i,11)*density(inddyy(i,20))*cdfits
      grad(i,12)=dpcond(i,12)*density(inddyy(i,21))*cdfits
      grad(i,13)=dpcond(i,13)*density(inddyy(i,25))*cdfits*two
      grad(i,14)=dpcond(i,14)*density(inddyy(i,26))*cdfits
      grad(i,15)=dpcond(i,15)*density(inddyy(i,27))*cdfits
      grad(i,16)=dpcond(i,16)*density(inddyy(i,31))*cdfits*two
      grad(i,17)=dpcond(i,17)*density(inddyy(i,32))*cdfits
      grad(i,18)=dpcond(i,18)*density(inddyy(i,33))*cdfits
      grad(i,19)=dpcond(i,01)*density(inddyy(i,02))*cdfits
      grad(i,20)=dpcond(i,02)*density(inddyy(i,04))*cdfits*two
      grad(i,21)=dpcond(i,03)*density(inddyy(i,05))*cdfits
      grad(i,22)=dpcond(i,04)*density(inddyy(i,08))*cdfits
      grad(i,23)=dpcond(i,05)*density(inddyy(i,10))*cdfits*two
      grad(i,24)=dpcond(i,06)*density(inddyy(i,11))*cdfits
      grad(i,25)=dpcond(i,07)*density(inddyy(i,14))*cdfits
      grad(i,26)=dpcond(i,08)*density(inddyy(i,16))*cdfits*two
      grad(i,27)=dpcond(i,09)*density(inddyy(i,17))*cdfits
      grad(i,28)=dpcond(i,10)*density(inddyy(i,20))*cdfits
      grad(i,29)=dpcond(i,11)*density(inddyy(i,22))*cdfits*two
      grad(i,30)=dpcond(i,12)*density(inddyy(i,23))*cdfits
      grad(i,31)=dpcond(i,13)*density(inddyy(i,26))*cdfits
      grad(i,32)=dpcond(i,14)*density(inddyy(i,28))*cdfits*two
      grad(i,33)=dpcond(i,15)*density(inddyy(i,29))*cdfits
      grad(i,34)=dpcond(i,16)*density(inddyy(i,32))*cdfits
      grad(i,35)=dpcond(i,17)*density(inddyy(i,34))*cdfits*two
      grad(i,36)=dpcond(i,18)*density(inddyy(i,35))*cdfits
      grad(i,37)=dpcond(i,01)*density(inddyy(i,03))*cdfits
      grad(i,38)=dpcond(i,02)*density(inddyy(i,05))*cdfits
      grad(i,39)=dpcond(i,03)*density(inddyy(i,06))*cdfits*two
      grad(i,40)=dpcond(i,04)*density(inddyy(i,09))*cdfits
      grad(i,41)=dpcond(i,05)*density(inddyy(i,11))*cdfits
      grad(i,42)=dpcond(i,06)*density(inddyy(i,12))*cdfits*two
      grad(i,43)=dpcond(i,07)*density(inddyy(i,15))*cdfits
      grad(i,44)=dpcond(i,08)*density(inddyy(i,17))*cdfits
      grad(i,45)=dpcond(i,09)*density(inddyy(i,18))*cdfits*two
      grad(i,46)=dpcond(i,10)*density(inddyy(i,21))*cdfits
      grad(i,47)=dpcond(i,11)*density(inddyy(i,23))*cdfits
      grad(i,48)=dpcond(i,12)*density(inddyy(i,24))*cdfits*two
      grad(i,49)=dpcond(i,13)*density(inddyy(i,27))*cdfits
      grad(i,50)=dpcond(i,14)*density(inddyy(i,29))*cdfits
      grad(i,51)=dpcond(i,15)*density(inddyy(i,30))*cdfits*two
      grad(i,52)=dpcond(i,16)*density(inddyy(i,33))*cdfits
      grad(i,53)=dpcond(i,17)*density(inddyy(i,35))*cdfits
 1046 grad(i,54)=dpcond(i,18)*density(inddyy(i,36))*cdfits*two

      do 1047 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,19)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,26)=zero
                              grad(i,27)=zero
                              grad(i,30)=zero
                              grad(i,37)=zero
                              grad(i,38)=zero
                              grad(i,39)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,44)=zero
                              grad(i,45)=zero
                              grad(i,47)=zero
                              grad(i,48)=zero
                              grad(i,51)=zero
                        endif
 1047 continue

      do 1048 k=1,3
      do 1048 j=1,18
      do 1048 i=1,m
 1048 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1049 k=1,3
      do 1049 j=1,18
      do 1049 i=1,m
 1049 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

      do 1050 j=1,10
      do 1050 i=1,m
 1050 fscond(i,j)=zero

      do 1051 j=1,15
      do 1051 i=1,m
 1051 gscond(i,j)=zero

      do 1052 j=1,21
      do 1052 i=1,m
 1052 hscond(i,j)=zero

      do 1053 j=1,10
      do 1053 i=1,nn
 1053 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetaa(i)

      do 1054 j=1,15
      do 1054 i=1,nn
 1054 gscond(iicontr(i),j)=gscond(iicontr(i),j)+gss0(i,j)*ttwozetaa(i)

      do 1055 j=1,21
      do 1055 i=1,nn
 1055 hscond(iicontr(i),j)=hscond(iicontr(i),j)+hss0(i,j)*ttwozetaa(i)

      do 1056 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1056 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1057 i=1,m
      gpcond(i,01)=axbx(i)*gscond(i,01)+hscond(i,01)
      gpcond(i,02)=ayby(i)*gscond(i,01)+hscond(i,02)
      gpcond(i,03)=azbz(i)*gscond(i,01)+hscond(i,03)
      gpcond(i,04)=axbx(i)*gscond(i,02)+hscond(i,02)
      gpcond(i,05)=ayby(i)*gscond(i,02)+hscond(i,04)
      gpcond(i,06)=azbz(i)*gscond(i,02)+hscond(i,05)
      gpcond(i,07)=axbx(i)*gscond(i,03)+hscond(i,03)
      gpcond(i,08)=ayby(i)*gscond(i,03)+hscond(i,05)
      gpcond(i,09)=azbz(i)*gscond(i,03)+hscond(i,06)
      gpcond(i,10)=axbx(i)*gscond(i,04)+hscond(i,04)
      gpcond(i,11)=ayby(i)*gscond(i,04)+hscond(i,07)
      gpcond(i,12)=azbz(i)*gscond(i,04)+hscond(i,08)
      gpcond(i,13)=axbx(i)*gscond(i,05)+hscond(i,05)
      gpcond(i,14)=ayby(i)*gscond(i,05)+hscond(i,08)
      gpcond(i,15)=azbz(i)*gscond(i,05)+hscond(i,09)
      gpcond(i,16)=axbx(i)*gscond(i,06)+hscond(i,06)
      gpcond(i,17)=ayby(i)*gscond(i,06)+hscond(i,09)
      gpcond(i,18)=azbz(i)*gscond(i,06)+hscond(i,10)
      gpcond(i,19)=axbx(i)*gscond(i,07)+hscond(i,07)
      gpcond(i,20)=ayby(i)*gscond(i,07)+hscond(i,11)
      gpcond(i,21)=azbz(i)*gscond(i,07)+hscond(i,12)
      gpcond(i,22)=axbx(i)*gscond(i,08)+hscond(i,08)
      gpcond(i,23)=ayby(i)*gscond(i,08)+hscond(i,12)
      gpcond(i,24)=azbz(i)*gscond(i,08)+hscond(i,13)
      gpcond(i,25)=axbx(i)*gscond(i,09)+hscond(i,09)
      gpcond(i,26)=ayby(i)*gscond(i,09)+hscond(i,13)
      gpcond(i,27)=azbz(i)*gscond(i,09)+hscond(i,14)
      gpcond(i,28)=axbx(i)*gscond(i,10)+hscond(i,10)
      gpcond(i,29)=ayby(i)*gscond(i,10)+hscond(i,14)
      gpcond(i,30)=azbz(i)*gscond(i,10)+hscond(i,15)
      gpcond(i,31)=axbx(i)*gscond(i,11)+hscond(i,11)
      gpcond(i,32)=ayby(i)*gscond(i,11)+hscond(i,16)
      gpcond(i,33)=azbz(i)*gscond(i,11)+hscond(i,17)
      gpcond(i,34)=axbx(i)*gscond(i,12)+hscond(i,12)
      gpcond(i,35)=ayby(i)*gscond(i,12)+hscond(i,17)
      gpcond(i,36)=azbz(i)*gscond(i,12)+hscond(i,18)
      gpcond(i,37)=axbx(i)*gscond(i,13)+hscond(i,13)
      gpcond(i,38)=ayby(i)*gscond(i,13)+hscond(i,18)
      gpcond(i,39)=azbz(i)*gscond(i,13)+hscond(i,19)
      gpcond(i,40)=axbx(i)*gscond(i,14)+hscond(i,14)
      gpcond(i,41)=ayby(i)*gscond(i,14)+hscond(i,19)
      gpcond(i,42)=azbz(i)*gscond(i,14)+hscond(i,20)
      gpcond(i,43)=axbx(i)*gscond(i,15)+hscond(i,15)
      gpcond(i,44)=ayby(i)*gscond(i,15)+hscond(i,20)
 1057 gpcond(i,45)=azbz(i)*gscond(i,15)+hscond(i,21)

      do 1058 i=1,m
      fdcond(i,01)=axbx(i)*fpcond(i,01)+gpcond(i,01)
      fdcond(i,02)=ayby(i)*fpcond(i,01)+gpcond(i,04)
      fdcond(i,03)=azbz(i)*fpcond(i,01)+gpcond(i,07)
      fdcond(i,04)=ayby(i)*fpcond(i,02)+gpcond(i,05)
      fdcond(i,05)=azbz(i)*fpcond(i,02)+gpcond(i,08)
      fdcond(i,06)=azbz(i)*fpcond(i,03)+gpcond(i,09)
      fdcond(i,07)=axbx(i)*fpcond(i,04)+gpcond(i,04)
      fdcond(i,08)=ayby(i)*fpcond(i,04)+gpcond(i,10)
      fdcond(i,09)=azbz(i)*fpcond(i,04)+gpcond(i,13)
      fdcond(i,10)=ayby(i)*fpcond(i,05)+gpcond(i,11)
      fdcond(i,11)=azbz(i)*fpcond(i,05)+gpcond(i,14)
      fdcond(i,12)=azbz(i)*fpcond(i,06)+gpcond(i,15)
      fdcond(i,13)=axbx(i)*fpcond(i,07)+gpcond(i,07)
      fdcond(i,14)=ayby(i)*fpcond(i,07)+gpcond(i,13)
      fdcond(i,15)=azbz(i)*fpcond(i,07)+gpcond(i,16)
      fdcond(i,16)=ayby(i)*fpcond(i,08)+gpcond(i,14)
      fdcond(i,17)=azbz(i)*fpcond(i,08)+gpcond(i,17)
      fdcond(i,18)=azbz(i)*fpcond(i,09)+gpcond(i,18)
      fdcond(i,19)=axbx(i)*fpcond(i,10)+gpcond(i,10)
      fdcond(i,20)=ayby(i)*fpcond(i,10)+gpcond(i,19)
      fdcond(i,21)=azbz(i)*fpcond(i,10)+gpcond(i,22)
      fdcond(i,22)=ayby(i)*fpcond(i,11)+gpcond(i,20)
      fdcond(i,23)=azbz(i)*fpcond(i,11)+gpcond(i,23)
      fdcond(i,24)=azbz(i)*fpcond(i,12)+gpcond(i,24)
      fdcond(i,25)=axbx(i)*fpcond(i,13)+gpcond(i,13)
      fdcond(i,26)=ayby(i)*fpcond(i,13)+gpcond(i,22)
      fdcond(i,27)=azbz(i)*fpcond(i,13)+gpcond(i,25)
      fdcond(i,28)=ayby(i)*fpcond(i,14)+gpcond(i,23)
      fdcond(i,29)=azbz(i)*fpcond(i,14)+gpcond(i,26)
      fdcond(i,30)=azbz(i)*fpcond(i,15)+gpcond(i,27)
      fdcond(i,31)=axbx(i)*fpcond(i,16)+gpcond(i,16)
      fdcond(i,32)=ayby(i)*fpcond(i,16)+gpcond(i,25)
      fdcond(i,33)=azbz(i)*fpcond(i,16)+gpcond(i,28)
      fdcond(i,34)=ayby(i)*fpcond(i,17)+gpcond(i,26)
      fdcond(i,35)=azbz(i)*fpcond(i,17)+gpcond(i,29)
      fdcond(i,36)=azbz(i)*fpcond(i,18)+gpcond(i,30)
      fdcond(i,37)=axbx(i)*fpcond(i,19)+gpcond(i,19)
      fdcond(i,38)=ayby(i)*fpcond(i,19)+gpcond(i,31)
      fdcond(i,39)=azbz(i)*fpcond(i,19)+gpcond(i,34)
      fdcond(i,40)=ayby(i)*fpcond(i,20)+gpcond(i,32)
      fdcond(i,41)=azbz(i)*fpcond(i,20)+gpcond(i,35)
      fdcond(i,42)=azbz(i)*fpcond(i,21)+gpcond(i,36)
      fdcond(i,43)=axbx(i)*fpcond(i,22)+gpcond(i,22)
      fdcond(i,44)=ayby(i)*fpcond(i,22)+gpcond(i,34)
      fdcond(i,45)=azbz(i)*fpcond(i,22)+gpcond(i,37)
      fdcond(i,46)=ayby(i)*fpcond(i,23)+gpcond(i,35)
      fdcond(i,47)=azbz(i)*fpcond(i,23)+gpcond(i,38)
      fdcond(i,48)=azbz(i)*fpcond(i,24)+gpcond(i,39)
      fdcond(i,49)=axbx(i)*fpcond(i,25)+gpcond(i,25)
      fdcond(i,50)=ayby(i)*fpcond(i,25)+gpcond(i,37)
      fdcond(i,51)=azbz(i)*fpcond(i,25)+gpcond(i,40)
      fdcond(i,52)=ayby(i)*fpcond(i,26)+gpcond(i,38)
      fdcond(i,53)=azbz(i)*fpcond(i,26)+gpcond(i,41)
      fdcond(i,54)=azbz(i)*fpcond(i,27)+gpcond(i,42)
      fdcond(i,55)=axbx(i)*fpcond(i,28)+gpcond(i,28)
      fdcond(i,56)=ayby(i)*fpcond(i,28)+gpcond(i,40)
      fdcond(i,57)=azbz(i)*fpcond(i,28)+gpcond(i,43)
      fdcond(i,58)=ayby(i)*fpcond(i,29)+gpcond(i,41)
      fdcond(i,59)=azbz(i)*fpcond(i,29)+gpcond(i,44)
 1058 fdcond(i,60)=azbz(i)*fpcond(i,30)+gpcond(i,45)

      do 1059 i=1,m
      grad(i,001)=fdcond(i,01)*density(inddyy(i,01))*cdfits
      grad(i,002)=fdcond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,003)=fdcond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,004)=fdcond(i,04)*density(inddyy(i,04))*cdfits
      grad(i,005)=fdcond(i,05)*density(inddyy(i,05))*cdfits
      grad(i,006)=fdcond(i,06)*density(inddyy(i,06))*cdfits
      grad(i,007)=fdcond(i,07)*density(inddyy(i,07))*cdfits
      grad(i,008)=fdcond(i,08)*density(inddyy(i,08))*cdfits
      grad(i,009)=fdcond(i,09)*density(inddyy(i,09))*cdfits
      grad(i,010)=fdcond(i,10)*density(inddyy(i,10))*cdfits
      grad(i,011)=fdcond(i,11)*density(inddyy(i,11))*cdfits
      grad(i,012)=fdcond(i,12)*density(inddyy(i,12))*cdfits
      grad(i,013)=fdcond(i,13)*density(inddyy(i,13))*cdfits
      grad(i,014)=fdcond(i,14)*density(inddyy(i,14))*cdfits
      grad(i,015)=fdcond(i,15)*density(inddyy(i,15))*cdfits
      grad(i,016)=fdcond(i,16)*density(inddyy(i,16))*cdfits
      grad(i,017)=fdcond(i,17)*density(inddyy(i,17))*cdfits
      grad(i,018)=fdcond(i,18)*density(inddyy(i,18))*cdfits
      grad(i,019)=fdcond(i,19)*density(inddyy(i,19))*cdfits
      grad(i,020)=fdcond(i,20)*density(inddyy(i,20))*cdfits
      grad(i,021)=fdcond(i,21)*density(inddyy(i,21))*cdfits
      grad(i,022)=fdcond(i,22)*density(inddyy(i,22))*cdfits
      grad(i,023)=fdcond(i,23)*density(inddyy(i,23))*cdfits
      grad(i,024)=fdcond(i,24)*density(inddyy(i,24))*cdfits
      grad(i,025)=fdcond(i,25)*density(inddyy(i,25))*cdfits
      grad(i,026)=fdcond(i,26)*density(inddyy(i,26))*cdfits
      grad(i,027)=fdcond(i,27)*density(inddyy(i,27))*cdfits
      grad(i,028)=fdcond(i,28)*density(inddyy(i,28))*cdfits
      grad(i,029)=fdcond(i,29)*density(inddyy(i,29))*cdfits
      grad(i,030)=fdcond(i,30)*density(inddyy(i,30))*cdfits
      grad(i,031)=fdcond(i,31)*density(inddyy(i,31))*cdfits
      grad(i,032)=fdcond(i,32)*density(inddyy(i,32))*cdfits
      grad(i,033)=fdcond(i,33)*density(inddyy(i,33))*cdfits
      grad(i,034)=fdcond(i,34)*density(inddyy(i,34))*cdfits
      grad(i,035)=fdcond(i,35)*density(inddyy(i,35))*cdfits
      grad(i,036)=fdcond(i,36)*density(inddyy(i,36))*cdfits
      grad(i,037)=fdcond(i,07)*density(inddyy(i,01))*cdfits
      grad(i,038)=fdcond(i,08)*density(inddyy(i,02))*cdfits
      grad(i,039)=fdcond(i,09)*density(inddyy(i,03))*cdfits
      grad(i,040)=fdcond(i,10)*density(inddyy(i,04))*cdfits
      grad(i,041)=fdcond(i,11)*density(inddyy(i,05))*cdfits
      grad(i,042)=fdcond(i,12)*density(inddyy(i,06))*cdfits
      grad(i,043)=fdcond(i,19)*density(inddyy(i,07))*cdfits
      grad(i,044)=fdcond(i,20)*density(inddyy(i,08))*cdfits
      grad(i,045)=fdcond(i,21)*density(inddyy(i,09))*cdfits
      grad(i,046)=fdcond(i,22)*density(inddyy(i,10))*cdfits
      grad(i,047)=fdcond(i,23)*density(inddyy(i,11))*cdfits
      grad(i,048)=fdcond(i,24)*density(inddyy(i,12))*cdfits
      grad(i,049)=fdcond(i,25)*density(inddyy(i,13))*cdfits
      grad(i,050)=fdcond(i,26)*density(inddyy(i,14))*cdfits
      grad(i,051)=fdcond(i,27)*density(inddyy(i,15))*cdfits
      grad(i,052)=fdcond(i,28)*density(inddyy(i,16))*cdfits
      grad(i,053)=fdcond(i,29)*density(inddyy(i,17))*cdfits
      grad(i,054)=fdcond(i,30)*density(inddyy(i,18))*cdfits
      grad(i,055)=fdcond(i,37)*density(inddyy(i,19))*cdfits
      grad(i,056)=fdcond(i,38)*density(inddyy(i,20))*cdfits
      grad(i,057)=fdcond(i,39)*density(inddyy(i,21))*cdfits
      grad(i,058)=fdcond(i,40)*density(inddyy(i,22))*cdfits
      grad(i,059)=fdcond(i,41)*density(inddyy(i,23))*cdfits
      grad(i,060)=fdcond(i,42)*density(inddyy(i,24))*cdfits
      grad(i,061)=fdcond(i,43)*density(inddyy(i,25))*cdfits
      grad(i,062)=fdcond(i,44)*density(inddyy(i,26))*cdfits
      grad(i,063)=fdcond(i,45)*density(inddyy(i,27))*cdfits
      grad(i,064)=fdcond(i,46)*density(inddyy(i,28))*cdfits
      grad(i,065)=fdcond(i,47)*density(inddyy(i,29))*cdfits
      grad(i,066)=fdcond(i,48)*density(inddyy(i,30))*cdfits
      grad(i,067)=fdcond(i,49)*density(inddyy(i,31))*cdfits
      grad(i,068)=fdcond(i,50)*density(inddyy(i,32))*cdfits
      grad(i,069)=fdcond(i,51)*density(inddyy(i,33))*cdfits
      grad(i,070)=fdcond(i,52)*density(inddyy(i,34))*cdfits
      grad(i,071)=fdcond(i,53)*density(inddyy(i,35))*cdfits
      grad(i,072)=fdcond(i,54)*density(inddyy(i,36))*cdfits
      grad(i,073)=fdcond(i,13)*density(inddyy(i,01))*cdfits
      grad(i,074)=fdcond(i,14)*density(inddyy(i,02))*cdfits
      grad(i,075)=fdcond(i,15)*density(inddyy(i,03))*cdfits
      grad(i,076)=fdcond(i,16)*density(inddyy(i,04))*cdfits
      grad(i,077)=fdcond(i,17)*density(inddyy(i,05))*cdfits
      grad(i,078)=fdcond(i,18)*density(inddyy(i,06))*cdfits
      grad(i,079)=fdcond(i,25)*density(inddyy(i,07))*cdfits
      grad(i,080)=fdcond(i,26)*density(inddyy(i,08))*cdfits
      grad(i,081)=fdcond(i,27)*density(inddyy(i,09))*cdfits
      grad(i,082)=fdcond(i,28)*density(inddyy(i,10))*cdfits
      grad(i,083)=fdcond(i,29)*density(inddyy(i,11))*cdfits
      grad(i,084)=fdcond(i,30)*density(inddyy(i,12))*cdfits
      grad(i,085)=fdcond(i,31)*density(inddyy(i,13))*cdfits
      grad(i,086)=fdcond(i,32)*density(inddyy(i,14))*cdfits
      grad(i,087)=fdcond(i,33)*density(inddyy(i,15))*cdfits
      grad(i,088)=fdcond(i,34)*density(inddyy(i,16))*cdfits
      grad(i,089)=fdcond(i,35)*density(inddyy(i,17))*cdfits
      grad(i,090)=fdcond(i,36)*density(inddyy(i,18))*cdfits
      grad(i,091)=fdcond(i,43)*density(inddyy(i,19))*cdfits
      grad(i,092)=fdcond(i,44)*density(inddyy(i,20))*cdfits
      grad(i,093)=fdcond(i,45)*density(inddyy(i,21))*cdfits
      grad(i,094)=fdcond(i,46)*density(inddyy(i,22))*cdfits
      grad(i,095)=fdcond(i,47)*density(inddyy(i,23))*cdfits
      grad(i,096)=fdcond(i,48)*density(inddyy(i,24))*cdfits
      grad(i,097)=fdcond(i,49)*density(inddyy(i,25))*cdfits
      grad(i,098)=fdcond(i,50)*density(inddyy(i,26))*cdfits
      grad(i,099)=fdcond(i,51)*density(inddyy(i,27))*cdfits
      grad(i,100)=fdcond(i,52)*density(inddyy(i,28))*cdfits
      grad(i,101)=fdcond(i,53)*density(inddyy(i,29))*cdfits
      grad(i,102)=fdcond(i,54)*density(inddyy(i,30))*cdfits
      grad(i,103)=fdcond(i,55)*density(inddyy(i,31))*cdfits
      grad(i,104)=fdcond(i,56)*density(inddyy(i,32))*cdfits
      grad(i,105)=fdcond(i,57)*density(inddyy(i,33))*cdfits
      grad(i,106)=fdcond(i,58)*density(inddyy(i,34))*cdfits
      grad(i,107)=fdcond(i,59)*density(inddyy(i,35))*cdfits
 1059 grad(i,108)=fdcond(i,60)*density(inddyy(i,36))*cdfits

      do 1060 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1060 continue

      do 1061 k=1,3
      do 1061 j=1,36
      do 1061 i=1,m
 1061 gradient(k,nc)=gradient(k,nc)-grad(i,36*(k-1)+j)

      do 1062 k=1,3
      do 1062 j=1,36
      do 1062 i=1,m
 1062 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,36*(k-1)+j)

      do 1063 j=1,6
      do 1063 i=1,m
 1063 dscond(i,j)=zero

      do 1064 j=1,10
      do 1064 i=1,m
 1064 fscond(i,j)=zero

      do 1065 j=1,15
      do 1065 i=1,m
 1065 gscond(i,j)=zero

      do 1066 j=1,21
      do 1066 i=1,m
 1066 hscond(i,j)=zero

      do 1067 j=1,6
      do 1067 i=1,nn
 1067 dscond(iicontr(i),j)=dscond(iicontr(i),j)+dss0(i,j)*ttwozetab(i)

      do 1068 j=1,10
      do 1068 i=1,nn
 1068 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetab(i)

      do 1069 j=1,15
      do 1069 i=1,nn
 1069 gscond(iicontr(i),j)=gscond(iicontr(i),j)+gss0(i,j)*ttwozetab(i)

      do 1070 j=1,21
      do 1070 i=1,nn
 1070 hscond(iicontr(i),j)=hscond(iicontr(i),j)+hss0(i,j)*ttwozetab(i)

      do 1071 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1071 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1072 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1072 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1073 i=1,m
      gpcond(i,01)=axbx(i)*gscond(i,01)+hscond(i,01)
      gpcond(i,02)=ayby(i)*gscond(i,01)+hscond(i,02)
      gpcond(i,03)=azbz(i)*gscond(i,01)+hscond(i,03)
      gpcond(i,04)=axbx(i)*gscond(i,02)+hscond(i,02)
      gpcond(i,05)=ayby(i)*gscond(i,02)+hscond(i,04)
      gpcond(i,06)=azbz(i)*gscond(i,02)+hscond(i,05)
      gpcond(i,07)=axbx(i)*gscond(i,03)+hscond(i,03)
      gpcond(i,08)=ayby(i)*gscond(i,03)+hscond(i,05)
      gpcond(i,09)=azbz(i)*gscond(i,03)+hscond(i,06)
      gpcond(i,10)=axbx(i)*gscond(i,04)+hscond(i,04)
      gpcond(i,11)=ayby(i)*gscond(i,04)+hscond(i,07)
      gpcond(i,12)=azbz(i)*gscond(i,04)+hscond(i,08)
      gpcond(i,13)=axbx(i)*gscond(i,05)+hscond(i,05)
      gpcond(i,14)=ayby(i)*gscond(i,05)+hscond(i,08)
      gpcond(i,15)=azbz(i)*gscond(i,05)+hscond(i,09)
      gpcond(i,16)=axbx(i)*gscond(i,06)+hscond(i,06)
      gpcond(i,17)=ayby(i)*gscond(i,06)+hscond(i,09)
      gpcond(i,18)=azbz(i)*gscond(i,06)+hscond(i,10)
      gpcond(i,19)=axbx(i)*gscond(i,07)+hscond(i,07)
      gpcond(i,20)=ayby(i)*gscond(i,07)+hscond(i,11)
      gpcond(i,21)=azbz(i)*gscond(i,07)+hscond(i,12)
      gpcond(i,22)=axbx(i)*gscond(i,08)+hscond(i,08)
      gpcond(i,23)=ayby(i)*gscond(i,08)+hscond(i,12)
      gpcond(i,24)=azbz(i)*gscond(i,08)+hscond(i,13)
      gpcond(i,25)=axbx(i)*gscond(i,09)+hscond(i,09)
      gpcond(i,26)=ayby(i)*gscond(i,09)+hscond(i,13)
      gpcond(i,27)=azbz(i)*gscond(i,09)+hscond(i,14)
      gpcond(i,28)=axbx(i)*gscond(i,10)+hscond(i,10)
      gpcond(i,29)=ayby(i)*gscond(i,10)+hscond(i,14)
      gpcond(i,30)=azbz(i)*gscond(i,10)+hscond(i,15)
      gpcond(i,31)=axbx(i)*gscond(i,11)+hscond(i,11)
      gpcond(i,32)=ayby(i)*gscond(i,11)+hscond(i,16)
      gpcond(i,33)=azbz(i)*gscond(i,11)+hscond(i,17)
      gpcond(i,34)=axbx(i)*gscond(i,12)+hscond(i,12)
      gpcond(i,35)=ayby(i)*gscond(i,12)+hscond(i,17)
      gpcond(i,36)=azbz(i)*gscond(i,12)+hscond(i,18)
      gpcond(i,37)=axbx(i)*gscond(i,13)+hscond(i,13)
      gpcond(i,38)=ayby(i)*gscond(i,13)+hscond(i,18)
      gpcond(i,39)=azbz(i)*gscond(i,13)+hscond(i,19)
      gpcond(i,40)=axbx(i)*gscond(i,14)+hscond(i,14)
      gpcond(i,41)=ayby(i)*gscond(i,14)+hscond(i,19)
      gpcond(i,42)=azbz(i)*gscond(i,14)+hscond(i,20)
      gpcond(i,43)=axbx(i)*gscond(i,15)+hscond(i,15)
      gpcond(i,44)=ayby(i)*gscond(i,15)+hscond(i,20)
 1073 gpcond(i,45)=azbz(i)*gscond(i,15)+hscond(i,21)

      do 1074 i=1,m
      ddcond(i,01)=axbx(i)*dpcond(i,01)+fpcond(i,01)
      ddcond(i,02)=ayby(i)*dpcond(i,01)+fpcond(i,04)
      ddcond(i,03)=azbz(i)*dpcond(i,01)+fpcond(i,07)
      ddcond(i,04)=ayby(i)*dpcond(i,02)+fpcond(i,05)
      ddcond(i,05)=azbz(i)*dpcond(i,02)+fpcond(i,08)
      ddcond(i,06)=azbz(i)*dpcond(i,03)+fpcond(i,09)
      ddcond(i,07)=axbx(i)*dpcond(i,04)+fpcond(i,04)
      ddcond(i,08)=ayby(i)*dpcond(i,04)+fpcond(i,10)
      ddcond(i,09)=azbz(i)*dpcond(i,04)+fpcond(i,13)
      ddcond(i,10)=ayby(i)*dpcond(i,05)+fpcond(i,11)
      ddcond(i,11)=azbz(i)*dpcond(i,05)+fpcond(i,14)
      ddcond(i,12)=azbz(i)*dpcond(i,06)+fpcond(i,15)
      ddcond(i,13)=axbx(i)*dpcond(i,07)+fpcond(i,07)
      ddcond(i,14)=ayby(i)*dpcond(i,07)+fpcond(i,13)
      ddcond(i,15)=azbz(i)*dpcond(i,07)+fpcond(i,16)
      ddcond(i,16)=ayby(i)*dpcond(i,08)+fpcond(i,14)
      ddcond(i,17)=azbz(i)*dpcond(i,08)+fpcond(i,17)
      ddcond(i,18)=azbz(i)*dpcond(i,09)+fpcond(i,18)
      ddcond(i,19)=axbx(i)*dpcond(i,10)+fpcond(i,10)
      ddcond(i,20)=ayby(i)*dpcond(i,10)+fpcond(i,19)
      ddcond(i,21)=azbz(i)*dpcond(i,10)+fpcond(i,22)
      ddcond(i,22)=ayby(i)*dpcond(i,11)+fpcond(i,20)
      ddcond(i,23)=azbz(i)*dpcond(i,11)+fpcond(i,23)
      ddcond(i,24)=azbz(i)*dpcond(i,12)+fpcond(i,24)
      ddcond(i,25)=axbx(i)*dpcond(i,13)+fpcond(i,13)
      ddcond(i,26)=ayby(i)*dpcond(i,13)+fpcond(i,22)
      ddcond(i,27)=azbz(i)*dpcond(i,13)+fpcond(i,25)
      ddcond(i,28)=ayby(i)*dpcond(i,14)+fpcond(i,23)
      ddcond(i,29)=azbz(i)*dpcond(i,14)+fpcond(i,26)
      ddcond(i,30)=azbz(i)*dpcond(i,15)+fpcond(i,27)
      ddcond(i,31)=axbx(i)*dpcond(i,16)+fpcond(i,16)
      ddcond(i,32)=ayby(i)*dpcond(i,16)+fpcond(i,25)
      ddcond(i,33)=azbz(i)*dpcond(i,16)+fpcond(i,28)
      ddcond(i,34)=ayby(i)*dpcond(i,17)+fpcond(i,26)
      ddcond(i,35)=azbz(i)*dpcond(i,17)+fpcond(i,29)
 1074 ddcond(i,36)=azbz(i)*dpcond(i,18)+fpcond(i,30)

      do 1075 i=1,m
      fdcond(i,01)=axbx(i)*fpcond(i,01)+gpcond(i,01)
      fdcond(i,02)=ayby(i)*fpcond(i,01)+gpcond(i,04)
      fdcond(i,03)=azbz(i)*fpcond(i,01)+gpcond(i,07)
      fdcond(i,04)=ayby(i)*fpcond(i,02)+gpcond(i,05)
      fdcond(i,05)=azbz(i)*fpcond(i,02)+gpcond(i,08)
      fdcond(i,06)=azbz(i)*fpcond(i,03)+gpcond(i,09)
      fdcond(i,07)=axbx(i)*fpcond(i,04)+gpcond(i,04)
      fdcond(i,08)=ayby(i)*fpcond(i,04)+gpcond(i,10)
      fdcond(i,09)=azbz(i)*fpcond(i,04)+gpcond(i,13)
      fdcond(i,10)=ayby(i)*fpcond(i,05)+gpcond(i,11)
      fdcond(i,11)=azbz(i)*fpcond(i,05)+gpcond(i,14)
      fdcond(i,12)=azbz(i)*fpcond(i,06)+gpcond(i,15)
      fdcond(i,13)=axbx(i)*fpcond(i,07)+gpcond(i,07)
      fdcond(i,14)=ayby(i)*fpcond(i,07)+gpcond(i,13)
      fdcond(i,15)=azbz(i)*fpcond(i,07)+gpcond(i,16)
      fdcond(i,16)=ayby(i)*fpcond(i,08)+gpcond(i,14)
      fdcond(i,17)=azbz(i)*fpcond(i,08)+gpcond(i,17)
      fdcond(i,18)=azbz(i)*fpcond(i,09)+gpcond(i,18)
      fdcond(i,19)=axbx(i)*fpcond(i,10)+gpcond(i,10)
      fdcond(i,20)=ayby(i)*fpcond(i,10)+gpcond(i,19)
      fdcond(i,21)=azbz(i)*fpcond(i,10)+gpcond(i,22)
      fdcond(i,22)=ayby(i)*fpcond(i,11)+gpcond(i,20)
      fdcond(i,23)=azbz(i)*fpcond(i,11)+gpcond(i,23)
      fdcond(i,24)=azbz(i)*fpcond(i,12)+gpcond(i,24)
      fdcond(i,25)=axbx(i)*fpcond(i,13)+gpcond(i,13)
      fdcond(i,26)=ayby(i)*fpcond(i,13)+gpcond(i,22)
      fdcond(i,27)=azbz(i)*fpcond(i,13)+gpcond(i,25)
      fdcond(i,28)=ayby(i)*fpcond(i,14)+gpcond(i,23)
      fdcond(i,29)=azbz(i)*fpcond(i,14)+gpcond(i,26)
      fdcond(i,30)=azbz(i)*fpcond(i,15)+gpcond(i,27)
      fdcond(i,31)=axbx(i)*fpcond(i,16)+gpcond(i,16)
      fdcond(i,32)=ayby(i)*fpcond(i,16)+gpcond(i,25)
      fdcond(i,33)=azbz(i)*fpcond(i,16)+gpcond(i,28)
      fdcond(i,34)=ayby(i)*fpcond(i,17)+gpcond(i,26)
      fdcond(i,35)=azbz(i)*fpcond(i,17)+gpcond(i,29)
      fdcond(i,36)=azbz(i)*fpcond(i,18)+gpcond(i,30)
      fdcond(i,37)=axbx(i)*fpcond(i,19)+gpcond(i,19)
      fdcond(i,38)=ayby(i)*fpcond(i,19)+gpcond(i,31)
      fdcond(i,39)=azbz(i)*fpcond(i,19)+gpcond(i,34)
      fdcond(i,40)=ayby(i)*fpcond(i,20)+gpcond(i,32)
      fdcond(i,41)=azbz(i)*fpcond(i,20)+gpcond(i,35)
      fdcond(i,42)=azbz(i)*fpcond(i,21)+gpcond(i,36)
      fdcond(i,43)=axbx(i)*fpcond(i,22)+gpcond(i,22)
      fdcond(i,44)=ayby(i)*fpcond(i,22)+gpcond(i,34)
      fdcond(i,45)=azbz(i)*fpcond(i,22)+gpcond(i,37)
      fdcond(i,46)=ayby(i)*fpcond(i,23)+gpcond(i,35)
      fdcond(i,47)=azbz(i)*fpcond(i,23)+gpcond(i,38)
      fdcond(i,48)=azbz(i)*fpcond(i,24)+gpcond(i,39)
      fdcond(i,49)=axbx(i)*fpcond(i,25)+gpcond(i,25)
      fdcond(i,50)=ayby(i)*fpcond(i,25)+gpcond(i,37)
      fdcond(i,51)=azbz(i)*fpcond(i,25)+gpcond(i,40)
      fdcond(i,52)=ayby(i)*fpcond(i,26)+gpcond(i,38)
      fdcond(i,53)=azbz(i)*fpcond(i,26)+gpcond(i,41)
      fdcond(i,54)=azbz(i)*fpcond(i,27)+gpcond(i,42)
      fdcond(i,55)=axbx(i)*fpcond(i,28)+gpcond(i,28)
      fdcond(i,56)=ayby(i)*fpcond(i,28)+gpcond(i,40)
      fdcond(i,57)=azbz(i)*fpcond(i,28)+gpcond(i,43)
      fdcond(i,58)=ayby(i)*fpcond(i,29)+gpcond(i,41)
      fdcond(i,59)=azbz(i)*fpcond(i,29)+gpcond(i,44)
 1075 fdcond(i,60)=azbz(i)*fpcond(i,30)+gpcond(i,45)

      do 1076 i=1,m
      dfcond(i,01)=axbx(i)*ddcond(i,01)+fdcond(i,01)
      dfcond(i,02)=ayby(i)*ddcond(i,01)+fdcond(i,07)
      dfcond(i,03)=azbz(i)*ddcond(i,01)+fdcond(i,13)
      dfcond(i,04)=ayby(i)*ddcond(i,02)+fdcond(i,08)
      dfcond(i,05)=azbz(i)*ddcond(i,02)+fdcond(i,14)
      dfcond(i,06)=azbz(i)*ddcond(i,03)+fdcond(i,15)
      dfcond(i,07)=ayby(i)*ddcond(i,04)+fdcond(i,10)
      dfcond(i,08)=azbz(i)*ddcond(i,04)+fdcond(i,16)
      dfcond(i,09)=azbz(i)*ddcond(i,05)+fdcond(i,17)
      dfcond(i,10)=azbz(i)*ddcond(i,06)+fdcond(i,18)
      dfcond(i,11)=axbx(i)*ddcond(i,07)+fdcond(i,07)
      dfcond(i,12)=ayby(i)*ddcond(i,07)+fdcond(i,19)
      dfcond(i,13)=azbz(i)*ddcond(i,07)+fdcond(i,25)
      dfcond(i,14)=ayby(i)*ddcond(i,08)+fdcond(i,20)
      dfcond(i,15)=azbz(i)*ddcond(i,08)+fdcond(i,26)
      dfcond(i,16)=azbz(i)*ddcond(i,09)+fdcond(i,27)
      dfcond(i,17)=ayby(i)*ddcond(i,10)+fdcond(i,22)
      dfcond(i,18)=azbz(i)*ddcond(i,10)+fdcond(i,28)
      dfcond(i,19)=azbz(i)*ddcond(i,11)+fdcond(i,29)
      dfcond(i,20)=azbz(i)*ddcond(i,12)+fdcond(i,30)
      dfcond(i,21)=axbx(i)*ddcond(i,13)+fdcond(i,13)
      dfcond(i,22)=ayby(i)*ddcond(i,13)+fdcond(i,25)
      dfcond(i,23)=azbz(i)*ddcond(i,13)+fdcond(i,31)
      dfcond(i,24)=ayby(i)*ddcond(i,14)+fdcond(i,26)
      dfcond(i,25)=azbz(i)*ddcond(i,14)+fdcond(i,32)
      dfcond(i,26)=azbz(i)*ddcond(i,15)+fdcond(i,33)
      dfcond(i,27)=ayby(i)*ddcond(i,16)+fdcond(i,28)
      dfcond(i,28)=azbz(i)*ddcond(i,16)+fdcond(i,34)
      dfcond(i,29)=azbz(i)*ddcond(i,17)+fdcond(i,35)
      dfcond(i,30)=azbz(i)*ddcond(i,18)+fdcond(i,36)
      dfcond(i,31)=axbx(i)*ddcond(i,19)+fdcond(i,19)
      dfcond(i,32)=ayby(i)*ddcond(i,19)+fdcond(i,37)
      dfcond(i,33)=azbz(i)*ddcond(i,19)+fdcond(i,43)
      dfcond(i,34)=ayby(i)*ddcond(i,20)+fdcond(i,38)
      dfcond(i,35)=azbz(i)*ddcond(i,20)+fdcond(i,44)
      dfcond(i,36)=azbz(i)*ddcond(i,21)+fdcond(i,45)
      dfcond(i,37)=ayby(i)*ddcond(i,22)+fdcond(i,40)
      dfcond(i,38)=azbz(i)*ddcond(i,22)+fdcond(i,46)
      dfcond(i,39)=azbz(i)*ddcond(i,23)+fdcond(i,47)
      dfcond(i,40)=azbz(i)*ddcond(i,24)+fdcond(i,48)
      dfcond(i,41)=axbx(i)*ddcond(i,25)+fdcond(i,25)
      dfcond(i,42)=ayby(i)*ddcond(i,25)+fdcond(i,43)
      dfcond(i,43)=azbz(i)*ddcond(i,25)+fdcond(i,49)
      dfcond(i,44)=ayby(i)*ddcond(i,26)+fdcond(i,44)
      dfcond(i,45)=azbz(i)*ddcond(i,26)+fdcond(i,50)
      dfcond(i,46)=azbz(i)*ddcond(i,27)+fdcond(i,51)
      dfcond(i,47)=ayby(i)*ddcond(i,28)+fdcond(i,46)
      dfcond(i,48)=azbz(i)*ddcond(i,28)+fdcond(i,52)
      dfcond(i,49)=azbz(i)*ddcond(i,29)+fdcond(i,53)
      dfcond(i,50)=azbz(i)*ddcond(i,30)+fdcond(i,54)
      dfcond(i,51)=axbx(i)*ddcond(i,31)+fdcond(i,31)
      dfcond(i,52)=ayby(i)*ddcond(i,31)+fdcond(i,49)
      dfcond(i,53)=azbz(i)*ddcond(i,31)+fdcond(i,55)
      dfcond(i,54)=ayby(i)*ddcond(i,32)+fdcond(i,50)
      dfcond(i,55)=azbz(i)*ddcond(i,32)+fdcond(i,56)
      dfcond(i,56)=azbz(i)*ddcond(i,33)+fdcond(i,57)
      dfcond(i,57)=ayby(i)*ddcond(i,34)+fdcond(i,52)
      dfcond(i,58)=azbz(i)*ddcond(i,34)+fdcond(i,58)
      dfcond(i,59)=azbz(i)*ddcond(i,35)+fdcond(i,59)
 1076 dfcond(i,60)=azbz(i)*ddcond(i,36)+fdcond(i,60)

      do 1077 i=1,m
      grad(i,001)=dfcond(i,01)*density(inddyy(i,01))*cdfits
      grad(i,002)=dfcond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,003)=dfcond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,004)=dfcond(i,04)*density(inddyy(i,04))*cdfits
      grad(i,005)=dfcond(i,05)*density(inddyy(i,05))*cdfits
      grad(i,006)=dfcond(i,06)*density(inddyy(i,06))*cdfits
      grad(i,007)=dfcond(i,11)*density(inddyy(i,07))*cdfits
      grad(i,008)=dfcond(i,12)*density(inddyy(i,08))*cdfits
      grad(i,009)=dfcond(i,13)*density(inddyy(i,09))*cdfits
      grad(i,010)=dfcond(i,14)*density(inddyy(i,10))*cdfits
      grad(i,011)=dfcond(i,15)*density(inddyy(i,11))*cdfits
      grad(i,012)=dfcond(i,16)*density(inddyy(i,12))*cdfits
      grad(i,013)=dfcond(i,21)*density(inddyy(i,13))*cdfits
      grad(i,014)=dfcond(i,22)*density(inddyy(i,14))*cdfits
      grad(i,015)=dfcond(i,23)*density(inddyy(i,15))*cdfits
      grad(i,016)=dfcond(i,24)*density(inddyy(i,16))*cdfits
      grad(i,017)=dfcond(i,25)*density(inddyy(i,17))*cdfits
      grad(i,018)=dfcond(i,26)*density(inddyy(i,18))*cdfits
      grad(i,019)=dfcond(i,31)*density(inddyy(i,19))*cdfits
      grad(i,020)=dfcond(i,32)*density(inddyy(i,20))*cdfits
      grad(i,021)=dfcond(i,33)*density(inddyy(i,21))*cdfits
      grad(i,022)=dfcond(i,34)*density(inddyy(i,22))*cdfits
      grad(i,023)=dfcond(i,35)*density(inddyy(i,23))*cdfits
      grad(i,024)=dfcond(i,36)*density(inddyy(i,24))*cdfits
      grad(i,025)=dfcond(i,41)*density(inddyy(i,25))*cdfits
      grad(i,026)=dfcond(i,42)*density(inddyy(i,26))*cdfits
      grad(i,027)=dfcond(i,43)*density(inddyy(i,27))*cdfits
      grad(i,028)=dfcond(i,44)*density(inddyy(i,28))*cdfits
      grad(i,029)=dfcond(i,45)*density(inddyy(i,29))*cdfits
      grad(i,030)=dfcond(i,46)*density(inddyy(i,30))*cdfits
      grad(i,031)=dfcond(i,51)*density(inddyy(i,31))*cdfits
      grad(i,032)=dfcond(i,52)*density(inddyy(i,32))*cdfits
      grad(i,033)=dfcond(i,53)*density(inddyy(i,33))*cdfits
      grad(i,034)=dfcond(i,54)*density(inddyy(i,34))*cdfits
      grad(i,035)=dfcond(i,55)*density(inddyy(i,35))*cdfits
      grad(i,036)=dfcond(i,56)*density(inddyy(i,36))*cdfits
      grad(i,037)=dfcond(i,02)*density(inddyy(i,01))*cdfits
      grad(i,038)=dfcond(i,04)*density(inddyy(i,02))*cdfits
      grad(i,039)=dfcond(i,05)*density(inddyy(i,03))*cdfits
      grad(i,040)=dfcond(i,07)*density(inddyy(i,04))*cdfits
      grad(i,041)=dfcond(i,08)*density(inddyy(i,05))*cdfits
      grad(i,042)=dfcond(i,09)*density(inddyy(i,06))*cdfits
      grad(i,043)=dfcond(i,12)*density(inddyy(i,07))*cdfits
      grad(i,044)=dfcond(i,14)*density(inddyy(i,08))*cdfits
      grad(i,045)=dfcond(i,15)*density(inddyy(i,09))*cdfits
      grad(i,046)=dfcond(i,17)*density(inddyy(i,10))*cdfits
      grad(i,047)=dfcond(i,18)*density(inddyy(i,11))*cdfits
      grad(i,048)=dfcond(i,19)*density(inddyy(i,12))*cdfits
      grad(i,049)=dfcond(i,22)*density(inddyy(i,13))*cdfits
      grad(i,050)=dfcond(i,24)*density(inddyy(i,14))*cdfits
      grad(i,051)=dfcond(i,25)*density(inddyy(i,15))*cdfits
      grad(i,052)=dfcond(i,27)*density(inddyy(i,16))*cdfits
      grad(i,053)=dfcond(i,28)*density(inddyy(i,17))*cdfits
      grad(i,054)=dfcond(i,29)*density(inddyy(i,18))*cdfits
      grad(i,055)=dfcond(i,32)*density(inddyy(i,19))*cdfits
      grad(i,056)=dfcond(i,34)*density(inddyy(i,20))*cdfits
      grad(i,057)=dfcond(i,35)*density(inddyy(i,21))*cdfits
      grad(i,058)=dfcond(i,37)*density(inddyy(i,22))*cdfits
      grad(i,059)=dfcond(i,38)*density(inddyy(i,23))*cdfits
      grad(i,060)=dfcond(i,39)*density(inddyy(i,24))*cdfits
      grad(i,061)=dfcond(i,42)*density(inddyy(i,25))*cdfits
      grad(i,062)=dfcond(i,44)*density(inddyy(i,26))*cdfits
      grad(i,063)=dfcond(i,45)*density(inddyy(i,27))*cdfits
      grad(i,064)=dfcond(i,47)*density(inddyy(i,28))*cdfits
      grad(i,065)=dfcond(i,48)*density(inddyy(i,29))*cdfits
      grad(i,066)=dfcond(i,49)*density(inddyy(i,30))*cdfits
      grad(i,067)=dfcond(i,52)*density(inddyy(i,31))*cdfits
      grad(i,068)=dfcond(i,54)*density(inddyy(i,32))*cdfits
      grad(i,069)=dfcond(i,55)*density(inddyy(i,33))*cdfits
      grad(i,070)=dfcond(i,57)*density(inddyy(i,34))*cdfits
      grad(i,071)=dfcond(i,58)*density(inddyy(i,35))*cdfits
      grad(i,072)=dfcond(i,59)*density(inddyy(i,36))*cdfits
      grad(i,073)=dfcond(i,03)*density(inddyy(i,01))*cdfits
      grad(i,074)=dfcond(i,05)*density(inddyy(i,02))*cdfits
      grad(i,075)=dfcond(i,06)*density(inddyy(i,03))*cdfits
      grad(i,076)=dfcond(i,08)*density(inddyy(i,04))*cdfits
      grad(i,077)=dfcond(i,09)*density(inddyy(i,05))*cdfits
      grad(i,078)=dfcond(i,10)*density(inddyy(i,06))*cdfits
      grad(i,079)=dfcond(i,13)*density(inddyy(i,07))*cdfits
      grad(i,080)=dfcond(i,15)*density(inddyy(i,08))*cdfits
      grad(i,081)=dfcond(i,16)*density(inddyy(i,09))*cdfits
      grad(i,082)=dfcond(i,18)*density(inddyy(i,10))*cdfits
      grad(i,083)=dfcond(i,19)*density(inddyy(i,11))*cdfits
      grad(i,084)=dfcond(i,20)*density(inddyy(i,12))*cdfits
      grad(i,085)=dfcond(i,23)*density(inddyy(i,13))*cdfits
      grad(i,086)=dfcond(i,25)*density(inddyy(i,14))*cdfits
      grad(i,087)=dfcond(i,26)*density(inddyy(i,15))*cdfits
      grad(i,088)=dfcond(i,28)*density(inddyy(i,16))*cdfits
      grad(i,089)=dfcond(i,29)*density(inddyy(i,17))*cdfits
      grad(i,090)=dfcond(i,30)*density(inddyy(i,18))*cdfits
      grad(i,091)=dfcond(i,33)*density(inddyy(i,19))*cdfits
      grad(i,092)=dfcond(i,35)*density(inddyy(i,20))*cdfits
      grad(i,093)=dfcond(i,36)*density(inddyy(i,21))*cdfits
      grad(i,094)=dfcond(i,38)*density(inddyy(i,22))*cdfits
      grad(i,095)=dfcond(i,39)*density(inddyy(i,23))*cdfits
      grad(i,096)=dfcond(i,40)*density(inddyy(i,24))*cdfits
      grad(i,097)=dfcond(i,43)*density(inddyy(i,25))*cdfits
      grad(i,098)=dfcond(i,45)*density(inddyy(i,26))*cdfits
      grad(i,099)=dfcond(i,46)*density(inddyy(i,27))*cdfits
      grad(i,100)=dfcond(i,48)*density(inddyy(i,28))*cdfits
      grad(i,101)=dfcond(i,49)*density(inddyy(i,29))*cdfits
      grad(i,102)=dfcond(i,50)*density(inddyy(i,30))*cdfits
      grad(i,103)=dfcond(i,53)*density(inddyy(i,31))*cdfits
      grad(i,104)=dfcond(i,55)*density(inddyy(i,32))*cdfits
      grad(i,105)=dfcond(i,56)*density(inddyy(i,33))*cdfits
      grad(i,106)=dfcond(i,58)*density(inddyy(i,34))*cdfits
      grad(i,107)=dfcond(i,59)*density(inddyy(i,35))*cdfits
 1077 grad(i,108)=dfcond(i,60)*density(inddyy(i,36))*cdfits

      do 1078 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1078 continue

      do 1079 k=1,3
      do 1079 j=1,36
      do 1079 i=1,m
 1079 gradient(k,nc)=gradient(k,nc)-grad(i,36*(k-1)+j)

      do 1080 k=1,3
      do 1080 j=1,36
      do 1080 i=1,m
 1080 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,36*(k-1)+j)

 1001 continue

      return
      end

      subroutine gradnadp(m,n,ncentr,icontr,inddyy,icentr,g,coord,
     &                    charge,density,gradient,zeta,twozetaa,
     &                    twozetab,px,py,pz,base,pxax,pyay,pzaz,axbx,
     &                    ayby,azbz,pxcx,pycy,pzcz,twozeta,u,ss0,ss1,
     &                    ss2,ss3,ss4,ps0,ps1,ps2,ps3,ds0,ds1,ds2,fs0,
     &                    fs1,gs0,c,c1,pscond,dscond,ppcond,fscond,
     &                    dpcond,gscond,fpcond,ddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),icentr(m,*)

      dimension g(*),coord(3,*),charge(*),density(*),gradient(3,*),
     &          zeta(*),twozetaa(*),twozetab(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          pxcx(*),pycy(*),pzcz(*),twozeta(*),u(*),ss0(*),ss1(*),
     &          ss2(*),ss3(*),ss4(*),ps0(n,*),ps1(n,*),ps2(n,*),
     &          ps3(n,*),ds0(n,*),ds1(n,*),ds2(n,*),fs0(n,*),fs1(n,*),
     &          gs0(n,*),c(*),c1(n,*),pscond(m,*),dscond(m,*),
     &          ppcond(m,*),fscond(m,*),dpcond(m,*),gscond(m,*),
     &          fpcond(m,*),ddcond(m,*),grad(m,*)

      data zero,two,three,four,pi/0.0d0,2.0d0,
     &                            3.0d0,4.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 1003 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1003 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1004 i=1,n
      call augg(5,u(i),g)
      ss0(i)=base(i)*g(1)*twopichrg/zeta(i)
      ss1(i)=base(i)*g(2)*twopichrg/zeta(i)
      ss2(i)=base(i)*g(3)*twopichrg/zeta(i)
      ss3(i)=base(i)*g(4)*twopichrg/zeta(i)
 1004 ss4(i)=base(i)*g(5)*twopichrg/zeta(i)

      do 1005 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 1005 ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      do 1006 i=1,n
      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
 1006 ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      do 1007 i=1,n
      ps2(i,1)=pxax(i)*ss2(i)-pxcx(i)*ss3(i)
      ps2(i,2)=pyay(i)*ss2(i)-pycy(i)*ss3(i)
 1007 ps2(i,3)=pzaz(i)*ss2(i)-pzcz(i)*ss3(i)

      do 1008 i=1,n
      ps3(i,1)=pxax(i)*ss3(i)-pxcx(i)*ss4(i)
      ps3(i,2)=pyay(i)*ss3(i)-pycy(i)*ss4(i)
 1008 ps3(i,3)=pzaz(i)*ss3(i)-pzcz(i)*ss4(i)

      do 1009 i=1,n
 1009 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1010 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1010 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1011 i=1,n
 1011 c(i)=(ss1(i)-ss2(i))/twozeta(i)

      do 1012 i=1,n
      ds1(i,1)=pxax(i)*ps1(i,1)-pxcx(i)*ps2(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps1(i,1)-pycy(i)*ps2(i,1)
      ds1(i,3)=pzaz(i)*ps1(i,1)-pzcz(i)*ps2(i,1)
      ds1(i,4)=pyay(i)*ps1(i,2)-pycy(i)*ps2(i,2)+c(i)
      ds1(i,5)=pzaz(i)*ps1(i,2)-pzcz(i)*ps2(i,2)
 1012 ds1(i,6)=pzaz(i)*ps1(i,3)-pzcz(i)*ps2(i,3)+c(i)

      do 1013 i=1,n
 1013 c(i)=(ss2(i)-ss3(i))/twozeta(i)

      do 1014 i=1,n
      ds2(i,1)=pxax(i)*ps2(i,1)-pxcx(i)*ps3(i,1)+c(i)
      ds2(i,2)=pyay(i)*ps2(i,1)-pycy(i)*ps3(i,1)
      ds2(i,3)=pzaz(i)*ps2(i,1)-pzcz(i)*ps3(i,1)
      ds2(i,4)=pyay(i)*ps2(i,2)-pycy(i)*ps3(i,2)+c(i)
      ds2(i,5)=pzaz(i)*ps2(i,2)-pzcz(i)*ps3(i,2)
 1014 ds2(i,6)=pzaz(i)*ps2(i,3)-pzcz(i)*ps3(i,3)+c(i)

      do 1015 j=1,3
      do 1015 i=1,n
 1015 c1(i,j)=(ps0(i,j)-ps1(i,j))/twozeta(i)

      do 1016 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)-pxcx(i)*ds1(i,1)+c1(i,1)*two
      fs0(i,02)=pyay(i)*ds0(i,1)-pycy(i)*ds1(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)-pzcz(i)*ds1(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)-pycy(i)*ds1(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)-pzcz(i)*ds1(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)-pzcz(i)*ds1(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)-pycy(i)*ds1(i,4)+c1(i,2)*two
      fs0(i,08)=pzaz(i)*ds0(i,4)-pzcz(i)*ds1(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)-pzcz(i)*ds1(i,5)+c1(i,2)
 1016 fs0(i,10)=pzaz(i)*ds0(i,6)-pzcz(i)*ds1(i,6)+c1(i,3)*two

      do 1017 j=1,3
      do 1017 i=1,n
 1017 c1(i,j)=(ps1(i,j)-ps2(i,j))/twozeta(i)

      do 1018 i=1,n
      fs1(i,01)=pxax(i)*ds1(i,1)-pxcx(i)*ds2(i,1)+c1(i,1)*two
      fs1(i,02)=pyay(i)*ds1(i,1)-pycy(i)*ds2(i,1)
      fs1(i,03)=pzaz(i)*ds1(i,1)-pzcz(i)*ds2(i,1)
      fs1(i,04)=pyay(i)*ds1(i,2)-pycy(i)*ds2(i,2)+c1(i,1)
      fs1(i,05)=pzaz(i)*ds1(i,2)-pzcz(i)*ds2(i,2)
      fs1(i,06)=pzaz(i)*ds1(i,3)-pzcz(i)*ds2(i,3)+c1(i,1)
      fs1(i,07)=pyay(i)*ds1(i,4)-pycy(i)*ds2(i,4)+c1(i,2)*two
      fs1(i,08)=pzaz(i)*ds1(i,4)-pzcz(i)*ds2(i,4)
      fs1(i,09)=pzaz(i)*ds1(i,5)-pzcz(i)*ds2(i,5)+c1(i,2)
 1018 fs1(i,10)=pzaz(i)*ds1(i,6)-pzcz(i)*ds2(i,6)+c1(i,3)*two

      do 1019 j=1,6
      do 1019 i=1,n
 1019 c1(i,j)=(ds0(i,j)-ds1(i,j))/twozeta(i)

      do 1020 i=1,n
      gs0(i,01)=pxax(i)*fs0(i,01)-pxcx(i)*fs1(i,01)+c1(i,1)*three
      gs0(i,02)=pyay(i)*fs0(i,01)-pycy(i)*fs1(i,01)
      gs0(i,03)=pzaz(i)*fs0(i,01)-pzcz(i)*fs1(i,01)
      gs0(i,04)=pyay(i)*fs0(i,02)-pycy(i)*fs1(i,02)+c1(i,1)
      gs0(i,05)=pzaz(i)*fs0(i,02)-pzcz(i)*fs1(i,02)
      gs0(i,06)=pzaz(i)*fs0(i,03)-pzcz(i)*fs1(i,03)+c1(i,1)
      gs0(i,07)=pyay(i)*fs0(i,04)-pycy(i)*fs1(i,04)+c1(i,2)*two
      gs0(i,08)=pzaz(i)*fs0(i,04)-pzcz(i)*fs1(i,04)
      gs0(i,09)=pzaz(i)*fs0(i,05)-pzcz(i)*fs1(i,05)+c1(i,2)
      gs0(i,10)=pzaz(i)*fs0(i,06)-pzcz(i)*fs1(i,06)+c1(i,3)*two
      gs0(i,11)=pyay(i)*fs0(i,07)-pycy(i)*fs1(i,07)+c1(i,4)*three
      gs0(i,12)=pzaz(i)*fs0(i,07)-pzcz(i)*fs1(i,07)
      gs0(i,13)=pzaz(i)*fs0(i,08)-pzcz(i)*fs1(i,08)+c1(i,4)
      gs0(i,14)=pzaz(i)*fs0(i,09)-pzcz(i)*fs1(i,09)+c1(i,5)*two
 1020 gs0(i,15)=pzaz(i)*fs0(i,10)-pzcz(i)*fs1(i,10)+c1(i,6)*three

      do 1021 j=1,3
      do 1021 i=1,m
 1021 pscond(i,j)=zero

      do 1022 j=1,6
      do 1022 i=1,m
 1022 dscond(i,j)=zero

      do 1023 j=1,3
      do 1023 i=1,n
 1023 pscond(icontr(i),j)=pscond(icontr(i),j)-ps0(i,j)

      do 1024 j=1,6
      do 1024 i=1,n
 1024 dscond(icontr(i),j)=dscond(icontr(i),j)-ds0(i,j)

      do 1025 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1025 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1026 i=1,m
      grad(i,01)=ppcond(i,1)*density(inddyy(i,01))*two
      grad(i,02)=ppcond(i,2)*density(inddyy(i,02))*two
      grad(i,03)=ppcond(i,3)*density(inddyy(i,03))*two
      grad(i,04)=ppcond(i,4)*density(inddyy(i,04))
      grad(i,05)=ppcond(i,5)*density(inddyy(i,05))
      grad(i,06)=ppcond(i,6)*density(inddyy(i,06))
      grad(i,07)=ppcond(i,7)*density(inddyy(i,07))
      grad(i,08)=ppcond(i,8)*density(inddyy(i,08))
      grad(i,09)=ppcond(i,9)*density(inddyy(i,09))
      grad(i,10)=ppcond(i,1)*density(inddyy(i,04))
      grad(i,11)=ppcond(i,2)*density(inddyy(i,05))
      grad(i,12)=ppcond(i,3)*density(inddyy(i,06))
      grad(i,13)=ppcond(i,4)*density(inddyy(i,10))*two
      grad(i,14)=ppcond(i,5)*density(inddyy(i,11))*two
      grad(i,15)=ppcond(i,6)*density(inddyy(i,12))*two
      grad(i,16)=ppcond(i,7)*density(inddyy(i,13))
      grad(i,17)=ppcond(i,8)*density(inddyy(i,14))
      grad(i,18)=ppcond(i,9)*density(inddyy(i,15))
      grad(i,19)=ppcond(i,1)*density(inddyy(i,07))
      grad(i,20)=ppcond(i,2)*density(inddyy(i,08))
      grad(i,21)=ppcond(i,3)*density(inddyy(i,09))
      grad(i,22)=ppcond(i,4)*density(inddyy(i,13))
      grad(i,23)=ppcond(i,5)*density(inddyy(i,14))
      grad(i,24)=ppcond(i,6)*density(inddyy(i,15))
      grad(i,25)=ppcond(i,7)*density(inddyy(i,16))*two
      grad(i,26)=ppcond(i,8)*density(inddyy(i,17))*two
 1026 grad(i,27)=ppcond(i,9)*density(inddyy(i,18))*two

      do 1027 k=1,3
      do 1027 j=1,9
      do 1027 i=1,m
 1027 gradient(k,nn)=gradient(k,nn)+grad(i,9*(k-1)+j)

      do 1028 k=1,3
      do 1028 j=1,9
      do 1028 i=1,m
 1028 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,9*(k-1)+j)

      do 1029 i=1,m
      grad(i,01)=dscond(i,1)*density(inddyy(i,01))
      grad(i,02)=dscond(i,2)*density(inddyy(i,04))
      grad(i,03)=dscond(i,3)*density(inddyy(i,07))
      grad(i,04)=dscond(i,4)*density(inddyy(i,10))
      grad(i,05)=dscond(i,5)*density(inddyy(i,13))
      grad(i,06)=dscond(i,6)*density(inddyy(i,16))
      grad(i,07)=dscond(i,1)*density(inddyy(i,02))
      grad(i,08)=dscond(i,2)*density(inddyy(i,05))
      grad(i,09)=dscond(i,3)*density(inddyy(i,08))
      grad(i,10)=dscond(i,4)*density(inddyy(i,11))
      grad(i,11)=dscond(i,5)*density(inddyy(i,14))
      grad(i,12)=dscond(i,6)*density(inddyy(i,17))
      grad(i,13)=dscond(i,1)*density(inddyy(i,03))
      grad(i,14)=dscond(i,2)*density(inddyy(i,06))
      grad(i,15)=dscond(i,3)*density(inddyy(i,09))
      grad(i,16)=dscond(i,4)*density(inddyy(i,12))
      grad(i,17)=dscond(i,5)*density(inddyy(i,15))
 1029 grad(i,18)=dscond(i,6)*density(inddyy(i,18))

      do 1030 k=1,3
      do 1030 j=1,6
      do 1030 i=1,m
 1030 gradient(k,nn)=gradient(k,nn)+grad(i,6*(k-1)+j)

      do 1031 k=1,3
      do 1031 j=1,6
      do 1031 i=1,m
 1031 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,6*(k-1)+j)

      do 1032 j=1,10
      do 1032 i=1,m
 1032 fscond(i,j)=zero

      do 1033 j=1,15
      do 1033 i=1,m
 1033 gscond(i,j)=zero

      do 1034 j=1,10
      do 1034 i=1,n
 1034 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)*twozetaa(i)

      do 1035 j=1,15
      do 1035 i=1,n
 1035 gscond(icontr(i),j)=gscond(icontr(i),j)+gs0(i,j)*twozetaa(i)

      do 1036 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1036 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1037 i=1,m
      grad(i,01)=fpcond(i,01)*density(inddyy(i,01))
      grad(i,02)=fpcond(i,02)*density(inddyy(i,02))
      grad(i,03)=fpcond(i,03)*density(inddyy(i,03))
      grad(i,04)=fpcond(i,04)*density(inddyy(i,04))
      grad(i,05)=fpcond(i,05)*density(inddyy(i,05))
      grad(i,06)=fpcond(i,06)*density(inddyy(i,06))
      grad(i,07)=fpcond(i,07)*density(inddyy(i,07))
      grad(i,08)=fpcond(i,08)*density(inddyy(i,08))
      grad(i,09)=fpcond(i,09)*density(inddyy(i,09))
      grad(i,10)=fpcond(i,10)*density(inddyy(i,10))
      grad(i,11)=fpcond(i,11)*density(inddyy(i,11))
      grad(i,12)=fpcond(i,12)*density(inddyy(i,12))
      grad(i,13)=fpcond(i,13)*density(inddyy(i,13))
      grad(i,14)=fpcond(i,14)*density(inddyy(i,14))
      grad(i,15)=fpcond(i,15)*density(inddyy(i,15))
      grad(i,16)=fpcond(i,16)*density(inddyy(i,16))
      grad(i,17)=fpcond(i,17)*density(inddyy(i,17))
      grad(i,18)=fpcond(i,18)*density(inddyy(i,18))
      grad(i,19)=fpcond(i,04)*density(inddyy(i,01))
      grad(i,20)=fpcond(i,05)*density(inddyy(i,02))
      grad(i,21)=fpcond(i,06)*density(inddyy(i,03))
      grad(i,22)=fpcond(i,10)*density(inddyy(i,04))
      grad(i,23)=fpcond(i,11)*density(inddyy(i,05))
      grad(i,24)=fpcond(i,12)*density(inddyy(i,06))
      grad(i,25)=fpcond(i,13)*density(inddyy(i,07))
      grad(i,26)=fpcond(i,14)*density(inddyy(i,08))
      grad(i,27)=fpcond(i,15)*density(inddyy(i,09))
      grad(i,28)=fpcond(i,19)*density(inddyy(i,10))
      grad(i,29)=fpcond(i,20)*density(inddyy(i,11))
      grad(i,30)=fpcond(i,21)*density(inddyy(i,12))
      grad(i,31)=fpcond(i,22)*density(inddyy(i,13))
      grad(i,32)=fpcond(i,23)*density(inddyy(i,14))
      grad(i,33)=fpcond(i,24)*density(inddyy(i,15))
      grad(i,34)=fpcond(i,25)*density(inddyy(i,16))
      grad(i,35)=fpcond(i,26)*density(inddyy(i,17))
      grad(i,36)=fpcond(i,27)*density(inddyy(i,18))
      grad(i,37)=fpcond(i,07)*density(inddyy(i,01))
      grad(i,38)=fpcond(i,08)*density(inddyy(i,02))
      grad(i,39)=fpcond(i,09)*density(inddyy(i,03))
      grad(i,40)=fpcond(i,13)*density(inddyy(i,04))
      grad(i,41)=fpcond(i,14)*density(inddyy(i,05))
      grad(i,42)=fpcond(i,15)*density(inddyy(i,06))
      grad(i,43)=fpcond(i,16)*density(inddyy(i,07))
      grad(i,44)=fpcond(i,17)*density(inddyy(i,08))
      grad(i,45)=fpcond(i,18)*density(inddyy(i,09))
      grad(i,46)=fpcond(i,22)*density(inddyy(i,10))
      grad(i,47)=fpcond(i,23)*density(inddyy(i,11))
      grad(i,48)=fpcond(i,24)*density(inddyy(i,12))
      grad(i,49)=fpcond(i,25)*density(inddyy(i,13))
      grad(i,50)=fpcond(i,26)*density(inddyy(i,14))
      grad(i,51)=fpcond(i,27)*density(inddyy(i,15))
      grad(i,52)=fpcond(i,28)*density(inddyy(i,16))
      grad(i,53)=fpcond(i,29)*density(inddyy(i,17))
 1037 grad(i,54)=fpcond(i,30)*density(inddyy(i,18))

      do 1038 k=1,3
      do 1038 j=1,18
      do 1038 i=1,m
 1038 gradient(k,nn)=gradient(k,nn)+grad(i,18*(k-1)+j)

      do 1039 k=1,3
      do 1039 j=1,18
      do 1039 i=1,m
 1039 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,18*(k-1)+j)

      do 1040 j=1,6
      do 1040 i=1,m
 1040 dscond(i,j)=zero

      do 1041 j=1,10
      do 1041 i=1,m
 1041 fscond(i,j)=zero

      do 1042 j=1,15
      do 1042 i=1,m
 1042 gscond(i,j)=zero

      do 1043 j=1,6
      do 1043 i=1,n
 1043 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)*twozetab(i)

      do 1044 j=1,10
      do 1044 i=1,n
 1044 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)*twozetab(i)

      do 1045 j=1,15
      do 1045 i=1,n
 1045 gscond(icontr(i),j)=gscond(icontr(i),j)+gs0(i,j)*twozetab(i)

      do 1046 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1046 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1047 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1047 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1048 i=1,m
      ddcond(i,01)=axbx(i)*dpcond(i,01)+fpcond(i,01)
      ddcond(i,02)=ayby(i)*dpcond(i,01)+fpcond(i,04)
      ddcond(i,03)=azbz(i)*dpcond(i,01)+fpcond(i,07)
      ddcond(i,04)=ayby(i)*dpcond(i,02)+fpcond(i,05)
      ddcond(i,05)=azbz(i)*dpcond(i,02)+fpcond(i,08)
      ddcond(i,06)=azbz(i)*dpcond(i,03)+fpcond(i,09)
      ddcond(i,07)=axbx(i)*dpcond(i,04)+fpcond(i,04)
      ddcond(i,08)=ayby(i)*dpcond(i,04)+fpcond(i,10)
      ddcond(i,09)=azbz(i)*dpcond(i,04)+fpcond(i,13)
      ddcond(i,10)=ayby(i)*dpcond(i,05)+fpcond(i,11)
      ddcond(i,11)=azbz(i)*dpcond(i,05)+fpcond(i,14)
      ddcond(i,12)=azbz(i)*dpcond(i,06)+fpcond(i,15)
      ddcond(i,13)=axbx(i)*dpcond(i,07)+fpcond(i,07)
      ddcond(i,14)=ayby(i)*dpcond(i,07)+fpcond(i,13)
      ddcond(i,15)=azbz(i)*dpcond(i,07)+fpcond(i,16)
      ddcond(i,16)=ayby(i)*dpcond(i,08)+fpcond(i,14)
      ddcond(i,17)=azbz(i)*dpcond(i,08)+fpcond(i,17)
      ddcond(i,18)=azbz(i)*dpcond(i,09)+fpcond(i,18)
      ddcond(i,19)=axbx(i)*dpcond(i,10)+fpcond(i,10)
      ddcond(i,20)=ayby(i)*dpcond(i,10)+fpcond(i,19)
      ddcond(i,21)=azbz(i)*dpcond(i,10)+fpcond(i,22)
      ddcond(i,22)=ayby(i)*dpcond(i,11)+fpcond(i,20)
      ddcond(i,23)=azbz(i)*dpcond(i,11)+fpcond(i,23)
      ddcond(i,24)=azbz(i)*dpcond(i,12)+fpcond(i,24)
      ddcond(i,25)=axbx(i)*dpcond(i,13)+fpcond(i,13)
      ddcond(i,26)=ayby(i)*dpcond(i,13)+fpcond(i,22)
      ddcond(i,27)=azbz(i)*dpcond(i,13)+fpcond(i,25)
      ddcond(i,28)=ayby(i)*dpcond(i,14)+fpcond(i,23)
      ddcond(i,29)=azbz(i)*dpcond(i,14)+fpcond(i,26)
      ddcond(i,30)=azbz(i)*dpcond(i,15)+fpcond(i,27)
      ddcond(i,31)=axbx(i)*dpcond(i,16)+fpcond(i,16)
      ddcond(i,32)=ayby(i)*dpcond(i,16)+fpcond(i,25)
      ddcond(i,33)=azbz(i)*dpcond(i,16)+fpcond(i,28)
      ddcond(i,34)=ayby(i)*dpcond(i,17)+fpcond(i,26)
      ddcond(i,35)=azbz(i)*dpcond(i,17)+fpcond(i,29)
 1048 ddcond(i,36)=azbz(i)*dpcond(i,18)+fpcond(i,30)

      do 1049 i=1,m
      grad(i,01)=ddcond(i,01)*density(inddyy(i,01))
      grad(i,02)=ddcond(i,02)*density(inddyy(i,02))
      grad(i,03)=ddcond(i,03)*density(inddyy(i,03))
      grad(i,04)=ddcond(i,07)*density(inddyy(i,04))
      grad(i,05)=ddcond(i,08)*density(inddyy(i,05))
      grad(i,06)=ddcond(i,09)*density(inddyy(i,06))
      grad(i,07)=ddcond(i,13)*density(inddyy(i,07))
      grad(i,08)=ddcond(i,14)*density(inddyy(i,08))
      grad(i,09)=ddcond(i,15)*density(inddyy(i,09))
      grad(i,10)=ddcond(i,19)*density(inddyy(i,10))
      grad(i,11)=ddcond(i,20)*density(inddyy(i,11))
      grad(i,12)=ddcond(i,21)*density(inddyy(i,12))
      grad(i,13)=ddcond(i,25)*density(inddyy(i,13))
      grad(i,14)=ddcond(i,26)*density(inddyy(i,14))
      grad(i,15)=ddcond(i,27)*density(inddyy(i,15))
      grad(i,16)=ddcond(i,31)*density(inddyy(i,16))
      grad(i,17)=ddcond(i,32)*density(inddyy(i,17))
      grad(i,18)=ddcond(i,33)*density(inddyy(i,18))
      grad(i,19)=ddcond(i,02)*density(inddyy(i,01))
      grad(i,20)=ddcond(i,04)*density(inddyy(i,02))
      grad(i,21)=ddcond(i,05)*density(inddyy(i,03))
      grad(i,22)=ddcond(i,08)*density(inddyy(i,04))
      grad(i,23)=ddcond(i,10)*density(inddyy(i,05))
      grad(i,24)=ddcond(i,11)*density(inddyy(i,06))
      grad(i,25)=ddcond(i,14)*density(inddyy(i,07))
      grad(i,26)=ddcond(i,16)*density(inddyy(i,08))
      grad(i,27)=ddcond(i,17)*density(inddyy(i,09))
      grad(i,28)=ddcond(i,20)*density(inddyy(i,10))
      grad(i,29)=ddcond(i,22)*density(inddyy(i,11))
      grad(i,30)=ddcond(i,23)*density(inddyy(i,12))
      grad(i,31)=ddcond(i,26)*density(inddyy(i,13))
      grad(i,32)=ddcond(i,28)*density(inddyy(i,14))
      grad(i,33)=ddcond(i,29)*density(inddyy(i,15))
      grad(i,34)=ddcond(i,32)*density(inddyy(i,16))
      grad(i,35)=ddcond(i,34)*density(inddyy(i,17))
      grad(i,36)=ddcond(i,35)*density(inddyy(i,18))
      grad(i,37)=ddcond(i,03)*density(inddyy(i,01))
      grad(i,38)=ddcond(i,05)*density(inddyy(i,02))
      grad(i,39)=ddcond(i,06)*density(inddyy(i,03))
      grad(i,40)=ddcond(i,09)*density(inddyy(i,04))
      grad(i,41)=ddcond(i,11)*density(inddyy(i,05))
      grad(i,42)=ddcond(i,12)*density(inddyy(i,06))
      grad(i,43)=ddcond(i,15)*density(inddyy(i,07))
      grad(i,44)=ddcond(i,17)*density(inddyy(i,08))
      grad(i,45)=ddcond(i,18)*density(inddyy(i,09))
      grad(i,46)=ddcond(i,21)*density(inddyy(i,10))
      grad(i,47)=ddcond(i,23)*density(inddyy(i,11))
      grad(i,48)=ddcond(i,24)*density(inddyy(i,12))
      grad(i,49)=ddcond(i,27)*density(inddyy(i,13))
      grad(i,50)=ddcond(i,29)*density(inddyy(i,14))
      grad(i,51)=ddcond(i,30)*density(inddyy(i,15))
      grad(i,52)=ddcond(i,33)*density(inddyy(i,16))
      grad(i,53)=ddcond(i,35)*density(inddyy(i,17))
 1049 grad(i,54)=ddcond(i,36)*density(inddyy(i,18))

      do 1050 k=1,3
      do 1050 j=1,18
      do 1050 i=1,m
 1050 gradient(k,nn)=gradient(k,nn)+grad(i,18*(k-1)+j)

      do 1051 k=1,3
      do 1051 j=1,18
      do 1051 i=1,m
 1051 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,18*(k-1)+j)

 1002 continue

      return
      end

      function dist(x,y)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension x(3),y(3)

      xx=x(1)-y(1)
      yy=x(2)-y(2)
      zz=x(3)-y(3)

      dist=sqrt(xx*xx+yy*yy+zz*zz)

      return
      end

      subroutine openfl

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      open(01,file='old_restart',access='sequential',form='unformatted',
     &        status='old')

      open(02,file='new_restart',access='sequential',form='unformatted',
     &        status='new')

      open(03,file='bases',access='sequential',form='formatted',
     &        status='old')

      open(90,file='esppts',access='sequential',form='formatted',
     &        status='unknown')

      open(91,file='espf',access='sequential',form='formatted',
     &        status='new')

c  scratch files

      open(11,file='fort.11',access='sequential',form='unformatted',
     &        status='new')

      open(12,file='fort.12',access='sequential',form='unformatted',
     &        status='new')

      open(17,file='fort.17',access='sequential',form='unformatted',
     &        status='new')

      open(18,file='fort.18',access='sequential',form='unformatted',
     &        status='new')

      open(19,file='fort.19',access='sequential',form='unformatted',
     &        status='new')

      open(21,file='fort.21',access='sequential',form='unformatted',
     &        status='new')

      open(31,file='fort.31',access='sequential',form='unformatted',
     &        status='new')

      open(43,file='fort.43',access='sequential',form='unformatted',
     &        status='new')

      open(44,file='fort.44',access='sequential',form='unformatted',
     &        status='new')

      open(45,file='fort.45',access='sequential',form='unformatted',
     &        status='new')

      open(49,file='fort.49',access='sequential',form='unformatted',
     &        status='new')

      open(50,file='fort.50',access='sequential',form='unformatted',
     &        status='new')

      open(51,file='fort.51',access='sequential',form='unformatted',
     &        status='new')

      open(66,file='fort.66',access='sequential',form='unformatted',
     &        status='new')

      open(73,file='fort.73',access='sequential',form='unformatted',
     &        status='new')

      open(74,file='fort.74',access='sequential',form='unformatted',
     &        status='new')

      open(77,file='fort.77',access='sequential',form='formatted',
     &        status='new')

      open(81,file='fort.81',access='sequential',form='unformatted',
     &        status='new')

      open(82,file='fort.82',access='sequential',form='unformatted',
     &        status='new')

      open(83,file='fort.83',access='sequential',form='unformatted',
     &        status='new')

      open(84,file='fort.84',access='sequential',form='unformatted',
     &        status='new')

      open(85,file='fort.85',access='sequential',form='unformatted',
     &        status='new')

      open(86,file='fort.86',access='sequential',form='unformatted',
     &        status='new')

      return
      end

      subroutine coress(m,n,ncentr,icontr,inddyy,iloc,coord,charge,
     &                  overlap,core,zeta,px,py,pz,eta,base,etarr,ss,
     &                  sscond,pxcx,pycy,pzcz,u)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(*),iloc(*)

      dimension coord(3,*),charge(*),overlap(*),core(*),zeta(*),
     &          px(*),py(*),pz(*),eta(*),base(*),etarr(*),ss(*),
     &          sscond(*),pxcx(*),pycy(*),pzcz(*),u(*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 ss(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1002 i=1,n
 1002 overlap(inddyy(icontr(i)))=overlap(inddyy(icontr(i)))+ss(i)

      do 1003 i=1,n
 1003 ss(i)=eta(i)*(three-two*etarr(i))*ss(i)

      do 1004 i=1,n
 1004 core(inddyy(icontr(i)))=core(inddyy(icontr(i)))+ss(i)

      do 1005 i=1,n
 1005 sscond(i)=zero

      do 2001 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 2002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 2002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      call auggv(1,n,iloc,u,ss,pxcx,pycy,pzcz)

      do 2003 i=1,n
 2003 ss(i)=base(i)*ss(i)*twopichrg/zeta(i)

      do 2004 i=1,n
 2004 sscond(i)=sscond(i)+ss(i)

 2001 continue

      do 2005 i=1,n
 2005 core(inddyy(icontr(i)))=core(inddyy(icontr(i)))-sscond(i)

      return
      end

      subroutine gradcdpp(m,n,ncds,ilfunc,icfunc,iminj,icontr,inddyy,
     &                    icentr,iicontr,g,coord,density,gradient,
     &                    cdfitc,alphaaux,coeffs,zeta,twozetaa,twozetab,
     &                    px,py,pz,base,pxax,pyay,pzaz,axbx,ayby,azbz,
     &                    zzeta,ttwozetaa,ttwozetab,zetarec,ppx,ppy,ppz,
     &                    ppxax,ppyay,ppzaz,wxpx,wypy,wzpz,zetac1,u,
     &                    sss0,sss1,sss2,sss3,pss0,pss1,pss2,dss0,dss1,
     &                    fss0,c,c1,sscond,pscond,spcond,dscond,ppcond,
     &                    fscond,dpcond,pdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),inddyy(m,*),
     &          icentr(m,*),iicontr(*)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),zeta(*),twozetaa(*),twozetab(*),
     &          px(*),py(*),pz(*),base(*),pxax(*),pyay(*),pzaz(*),
     &          axbx(*),ayby(*),azbz(*),zzeta(*),ttwozetaa(*),
     &          ttwozetab(*),zetarec(*),ppx(*),ppy(*),ppz(*),ppxax(*),
     &          ppyay(*),ppzaz(*),wxpx(*),wypy(*),wzpz(*),zetac1(*),
     &          u(*),sss0(*),sss1(*),sss2(*),sss3(*),pss0(n,*),
     &          pss1(n,*),pss2(n,*),dss0(n,*),dss1(n,*),fss0(n,*),c(*),
     &          c1(n,*),sscond(*),pscond(m,*),spcond(m,*),dscond(m,*),
     &          ppcond(m,*),fscond(m,*),dpcond(m,*),pdcond(m,*),
     &          grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(4,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(3)/zeta(i)/zetaux
 1004 sss3(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(4)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
 1006 zetac1(i)=zetaux*zetarec(i)

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1008 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1009 i=1,nn
      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
 1009 pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      do 1010 i=1,nn
      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
 1010 pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      do 1011 i=1,nn
 1011 c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      do 1012 i=1,nn
      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
 1012 dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      do 1013 i=1,nn
 1013 c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      do 1014 i=1,nn
      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
 1014 dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      do 1015 j=1,3
      do 1015 i=1,nn
 1015 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zzeta(i))

      do 1016 i=1,nn
      fss0(i,01)=ppxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=ppyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=ppzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=ppyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=ppzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=ppzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=ppyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=ppzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=ppzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 1016 fss0(i,10)=ppzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 1017 i=1,m
 1017 sscond(i)=zero

      do 1018 j=1,3
      do 1018 i=1,m
 1018 pscond(i,j)=zero

      do 1019 i=1,nn
 1019 sscond(iicontr(i))=sscond(iicontr(i))-sss0(i)

      do 1020 j=1,3
      do 1020 i=1,nn
 1020 pscond(iicontr(i),j)=pscond(iicontr(i),j)-pss0(i,j)

      do 1021 i=1,m
      spcond(i,1)=axbx(i)*sscond(i)+pscond(i,1)
      spcond(i,2)=ayby(i)*sscond(i)+pscond(i,2)
 1021 spcond(i,3)=azbz(i)*sscond(i)+pscond(i,3)

      do 1022 i=1,m
      grad(i,1)=spcond(i,1)*density(inddyy(i,1))*cdfits
      grad(i,2)=spcond(i,2)*density(inddyy(i,2))*cdfits
      grad(i,3)=spcond(i,3)*density(inddyy(i,3))*cdfits
      grad(i,4)=spcond(i,1)*density(inddyy(i,4))*cdfits
      grad(i,5)=spcond(i,2)*density(inddyy(i,5))*cdfits
      grad(i,6)=spcond(i,3)*density(inddyy(i,6))*cdfits
      grad(i,7)=spcond(i,1)*density(inddyy(i,7))*cdfits
      grad(i,8)=spcond(i,2)*density(inddyy(i,8))*cdfits
 1022 grad(i,9)=spcond(i,3)*density(inddyy(i,9))*cdfits

      do 1023 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,2)=zero
                              grad(i,3)=zero
                              grad(i,6)=zero
                        endif
 1023 continue

      do 1024 k=1,3
      do 1024 j=1,3
      do 1024 i=1,m
 1024 gradient(k,nc)=gradient(k,nc)-grad(i,3*(k-1)+j)

      do 1025 k=1,3
      do 1025 j=1,3
      do 1025 i=1,m
 1025 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,3*(k-1)+j)

      do 1026 i=1,m
      grad(i,1)=pscond(i,1)*density(inddyy(i,1))*cdfits
      grad(i,2)=pscond(i,2)*density(inddyy(i,4))*cdfits
      grad(i,3)=pscond(i,3)*density(inddyy(i,7))*cdfits
      grad(i,4)=pscond(i,1)*density(inddyy(i,2))*cdfits
      grad(i,5)=pscond(i,2)*density(inddyy(i,5))*cdfits
      grad(i,6)=pscond(i,3)*density(inddyy(i,8))*cdfits
      grad(i,7)=pscond(i,1)*density(inddyy(i,3))*cdfits
      grad(i,8)=pscond(i,2)*density(inddyy(i,6))*cdfits
 1026 grad(i,9)=pscond(i,3)*density(inddyy(i,9))*cdfits

      do 1027 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,4)=zero
                              grad(i,7)=zero
                              grad(i,8)=zero
                        endif
 1027 continue

      do 1028 k=1,3
      do 1028 j=1,3
      do 1028 i=1,m
 1028 gradient(k,nc)=gradient(k,nc)-grad(i,3*(k-1)+j)

      do 1029 k=1,3
      do 1029 j=1,3
      do 1029 i=1,m
 1029 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,3*(k-1)+j)

      do 1030 j=1,6
      do 1030 i=1,m
 1030 dscond(i,j)=zero

      do 1031 j=1,10
      do 1031 i=1,m
 1031 fscond(i,j)=zero

      do 1032 j=1,6
      do 1032 i=1,nn
 1032 dscond(iicontr(i),j)=dscond(iicontr(i),j)+dss0(i,j)*ttwozetaa(i)

      do 1033 j=1,10
      do 1033 i=1,nn
 1033 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetaa(i)

      do 1034 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1034 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1035 i=1,m
      grad(i,01)=dpcond(i,01)*density(inddyy(i,1))*cdfits
      grad(i,02)=dpcond(i,02)*density(inddyy(i,2))*cdfits
      grad(i,03)=dpcond(i,03)*density(inddyy(i,3))*cdfits
      grad(i,04)=dpcond(i,04)*density(inddyy(i,4))*cdfits
      grad(i,05)=dpcond(i,05)*density(inddyy(i,5))*cdfits
      grad(i,06)=dpcond(i,06)*density(inddyy(i,6))*cdfits
      grad(i,07)=dpcond(i,07)*density(inddyy(i,7))*cdfits
      grad(i,08)=dpcond(i,08)*density(inddyy(i,8))*cdfits
      grad(i,09)=dpcond(i,09)*density(inddyy(i,9))*cdfits
      grad(i,10)=dpcond(i,04)*density(inddyy(i,1))*cdfits
      grad(i,11)=dpcond(i,05)*density(inddyy(i,2))*cdfits
      grad(i,12)=dpcond(i,06)*density(inddyy(i,3))*cdfits
      grad(i,13)=dpcond(i,10)*density(inddyy(i,4))*cdfits
      grad(i,14)=dpcond(i,11)*density(inddyy(i,5))*cdfits
      grad(i,15)=dpcond(i,12)*density(inddyy(i,6))*cdfits
      grad(i,16)=dpcond(i,13)*density(inddyy(i,7))*cdfits
      grad(i,17)=dpcond(i,14)*density(inddyy(i,8))*cdfits
      grad(i,18)=dpcond(i,15)*density(inddyy(i,9))*cdfits
      grad(i,19)=dpcond(i,07)*density(inddyy(i,1))*cdfits
      grad(i,20)=dpcond(i,08)*density(inddyy(i,2))*cdfits
      grad(i,21)=dpcond(i,09)*density(inddyy(i,3))*cdfits
      grad(i,22)=dpcond(i,13)*density(inddyy(i,4))*cdfits
      grad(i,23)=dpcond(i,14)*density(inddyy(i,5))*cdfits
      grad(i,24)=dpcond(i,15)*density(inddyy(i,6))*cdfits
      grad(i,25)=dpcond(i,16)*density(inddyy(i,7))*cdfits
      grad(i,26)=dpcond(i,17)*density(inddyy(i,8))*cdfits
 1035 grad(i,27)=dpcond(i,18)*density(inddyy(i,9))*cdfits

      do 1036 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,15)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,24)=zero
                        endif
 1036 continue

      do 1037 k=1,3
      do 1037 j=1,9
      do 1037 i=1,m
 1037 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1038 k=1,3
      do 1038 j=1,9
      do 1038 i=1,m
 1038 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

      do 1039 j=1,3
      do 1039 i=1,m
 1039 pscond(i,j)=zero

      do 1040 j=1,6
      do 1040 i=1,m
 1040 dscond(i,j)=zero

      do 1041 j=1,10
      do 1041 i=1,m
 1041 fscond(i,j)=zero

      do 1042 j=1,3
      do 1042 i=1,nn
 1042 pscond(iicontr(i),j)=pscond(iicontr(i),j)+pss0(i,j)*ttwozetab(i)

      do 1043 j=1,6
      do 1043 i=1,nn
 1043 dscond(iicontr(i),j)=dscond(iicontr(i),j)+dss0(i,j)*ttwozetab(i)

      do 1044 j=1,10
      do 1044 i=1,nn
 1044 fscond(iicontr(i),j)=fscond(iicontr(i),j)+fss0(i,j)*ttwozetab(i)

      do 1045 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1045 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1046 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1046 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1047 i=1,m
      pdcond(i,01)=axbx(i)*ppcond(i,1)+dpcond(i,01)
      pdcond(i,02)=ayby(i)*ppcond(i,1)+dpcond(i,04)
      pdcond(i,03)=azbz(i)*ppcond(i,1)+dpcond(i,07)
      pdcond(i,04)=ayby(i)*ppcond(i,2)+dpcond(i,05)
      pdcond(i,05)=azbz(i)*ppcond(i,2)+dpcond(i,08)
      pdcond(i,06)=azbz(i)*ppcond(i,3)+dpcond(i,09)
      pdcond(i,07)=axbx(i)*ppcond(i,4)+dpcond(i,04)
      pdcond(i,08)=ayby(i)*ppcond(i,4)+dpcond(i,10)
      pdcond(i,09)=azbz(i)*ppcond(i,4)+dpcond(i,13)
      pdcond(i,10)=ayby(i)*ppcond(i,5)+dpcond(i,11)
      pdcond(i,11)=azbz(i)*ppcond(i,5)+dpcond(i,14)
      pdcond(i,12)=azbz(i)*ppcond(i,6)+dpcond(i,15)
      pdcond(i,13)=axbx(i)*ppcond(i,7)+dpcond(i,07)
      pdcond(i,14)=ayby(i)*ppcond(i,7)+dpcond(i,13)
      pdcond(i,15)=azbz(i)*ppcond(i,7)+dpcond(i,16)
      pdcond(i,16)=ayby(i)*ppcond(i,8)+dpcond(i,14)
      pdcond(i,17)=azbz(i)*ppcond(i,8)+dpcond(i,17)
 1047 pdcond(i,18)=azbz(i)*ppcond(i,9)+dpcond(i,18)

      do 1048 i=1,m
      grad(i,01)=pdcond(i,01)*density(inddyy(i,1))*cdfits
      grad(i,02)=pdcond(i,02)*density(inddyy(i,2))*cdfits
      grad(i,03)=pdcond(i,03)*density(inddyy(i,3))*cdfits
      grad(i,04)=pdcond(i,07)*density(inddyy(i,4))*cdfits
      grad(i,05)=pdcond(i,08)*density(inddyy(i,5))*cdfits
      grad(i,06)=pdcond(i,09)*density(inddyy(i,6))*cdfits
      grad(i,07)=pdcond(i,13)*density(inddyy(i,7))*cdfits
      grad(i,08)=pdcond(i,14)*density(inddyy(i,8))*cdfits
      grad(i,09)=pdcond(i,15)*density(inddyy(i,9))*cdfits
      grad(i,10)=pdcond(i,02)*density(inddyy(i,1))*cdfits
      grad(i,11)=pdcond(i,04)*density(inddyy(i,2))*cdfits
      grad(i,12)=pdcond(i,05)*density(inddyy(i,3))*cdfits
      grad(i,13)=pdcond(i,08)*density(inddyy(i,4))*cdfits
      grad(i,14)=pdcond(i,10)*density(inddyy(i,5))*cdfits
      grad(i,15)=pdcond(i,11)*density(inddyy(i,6))*cdfits
      grad(i,16)=pdcond(i,14)*density(inddyy(i,7))*cdfits
      grad(i,17)=pdcond(i,16)*density(inddyy(i,8))*cdfits
      grad(i,18)=pdcond(i,17)*density(inddyy(i,9))*cdfits
      grad(i,19)=pdcond(i,03)*density(inddyy(i,1))*cdfits
      grad(i,20)=pdcond(i,05)*density(inddyy(i,2))*cdfits
      grad(i,21)=pdcond(i,06)*density(inddyy(i,3))*cdfits
      grad(i,22)=pdcond(i,09)*density(inddyy(i,4))*cdfits
      grad(i,23)=pdcond(i,11)*density(inddyy(i,5))*cdfits
      grad(i,24)=pdcond(i,12)*density(inddyy(i,6))*cdfits
      grad(i,25)=pdcond(i,15)*density(inddyy(i,7))*cdfits
      grad(i,26)=pdcond(i,17)*density(inddyy(i,8))*cdfits
 1048 grad(i,27)=pdcond(i,18)*density(inddyy(i,9))*cdfits

      do 1049 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,15)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,24)=zero
                        endif
 1049 continue

      do 1050 k=1,3
      do 1050 j=1,9
      do 1050 i=1,m
 1050 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1051 k=1,3
      do 1051 j=1,9
      do 1051 i=1,m
 1051 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,9*(k-1)+j)

 1001 continue

      return
      end

      subroutine genxyz(n,i,j,k,bondl,bangle,dangle,c)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension c(3,*)

      data zero,pi,one80/0.0d0,3.1415926535898d0,180.0d0/

      pi180=pi/one80

      if(n.eq.1) then
                       c(1,n)=zero
                       c(2,n)=zero
                       c(3,n)=zero
                       return
                 endif

      if(n.eq.2) then
                       c(1,n)=bondl
                       c(2,n)=zero
                       c(3,n)=zero
                       return
                 endif

      xo=c(1,i)
      yo=c(2,i)
      zo=c(3,i)

      if(n.eq.3) then
                       if(i.eq.1) c(1,n)=xo+bondl*cos(bangle*pi180)
                       if(i.eq.2) c(1,n)=xo-bondl*cos(bangle*pi180)
                                  c(2,n)=yo+bondl*sin(bangle*pi180)
                                  c(3,n)=zero
                                  return
                 endif

      xa=c(1,j)-c(1,i)
      ya=c(2,j)-c(2,i)
      za=c(3,j)-c(3,i)

      r=sqrt(xa*xa+ya*ya+za*za)

      xa=xa/r
      ya=ya/r
      za=za/r

      xb=c(1,j)-c(1,k)
      yb=c(2,j)-c(2,k)
      zb=c(3,j)-c(3,k)

      xc=ya*zb-za*yb
      yc=za*xb-xa*zb
      zc=xa*yb-ya*xb

      r=sqrt(xc*xc+yc*yc+zc*zc)

      xc=xc/r
      yc=yc/r
      zc=zc/r

      xb=ya*zc-za*yc
      yb=za*xc-xa*zc
      zb=xa*yc-ya*xc

      z=bondl*cos(bangle*pi180)
      x=bondl*sin(bangle*pi180)*cos(dangle*pi180)
      y=bondl*sin(bangle*pi180)*sin(dangle*pi180)

      c(1,n)=xo+xa*z+xb*x+xc*y
      c(2,n)=yo+ya*z+yb*x+yc*y
      c(3,n)=zo+za*z+zb*x+zc*y

      return
      end

      subroutine vibrations(nreal,ninteger,nmaxatoms,nmaxorbs,nmaxaux,
     &                      nmaxpoints,ncenters,nptcharges,nbsystems,
     &                      level,nalpha,nbeta,nconts,ncontp,ncontd,
     &                      ncds,ncdspd,nxcs,nxcspd,idiis,
     &                      nmaxiterations,nfunctional,ngridtype,
     &                      ibfrozen,iafrozen,idfrozen,iifrozen,ixcfit,
     &                      iptsweight,imode,iwkvec,izmat1,izmat2,
     &                      izmat3,natomtype,nfuncatom,nptsatom,icfunc,
     &                      ilfunc,ngaussians,mtloca,nshels,nshelp,
     &                      nsheld,icdcfunc,icdlfunc,ixccfunc,ixclfunc,
     &                      isys,ibfreeze,iafreeze,idfreeze,iifreeze,
     &                      ibmode,iamode,idmode,iimode,econvergence,
     &                      dmixing,elevelshift,cutoff,wkvec,coord,
     &                      coordfix,charge,grad,coordpc,ptcharge,
     &                      overlap,core,focka,fockb,focke,dmta,dmtb,
     &                      coeffa,coeffb,alpha,coeff,alphacd,coefscd,
     &                      coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,
     &                      coefdxc,cdfitc,xcfita,xcfitb,xcfite,
     &                      xcfitsave,tvec,tveca,tvecb,tvece,labelatoms)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      character labelatoms(*)*4

      dimension iwkvec(*),izmat1(*),izmat2(*),izmat3(*),natomtype(*),
     &          nfuncatom(*),nptsatom(*),icfunc(*),ilfunc(*),
     &          ngaussians(*),mtloca(*),nshels(*),nshelp(*),nsheld(*),
     &          icdcfunc(*),icdlfunc(*),ixccfunc(*),ixclfunc(*),
     &          isys(nmaxatoms,*),ibfreeze(2,*),iafreeze(3,*),
     &          idfreeze(4,*),iifreeze(4,*),ibmode(*),iamode(*),
     &          idmode(*),iimode(*)

      dimension cutoff(*),wkvec(*),coord(3,*),coordfix(3,*),charge(*),
     &          grad(3,*),coordpc(3,*),ptcharge(*),overlap(nmaxorbs,*),
     &          core(*),focka(*),fockb(*),focke(*),dmta(*),dmtb(*),
     &          coeffa(nmaxorbs,*),coeffb(nmaxorbs,*),alpha(*),coeff(*),
     &          alphacd(*),coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),
     &          coefsxc(*),coefpxc(*),coefdxc(*),cdfitc(*),xcfita(*),
     &          xcfitb(*),xcfite(*),xcfitsave(*),tvec(*),tveca(*),
     &          tvecb(*),tvece(*)

      data small,step,bohr/0.00001d0,0.0025d0,0.529177d0/

      rewind 73
      rewind 74

      ncontractions=nconts+3*ncontp+6*ncontd

      displacement=step/bohr

      nstep=0

      do 1001 i=1,ncenters
      do 1001 j=1,3
 1001 coordfix(j,i)=coord(j,i)

      do 1002 i=1,2
      do 1002 j=1,ncenters
      do 1002 k=1,3

      if(i.eq.1) coord(k,j)=coord(k,j)+displacement
      if(i.eq.2) coord(k,j)=coord(k,j)-displacement

      nstep=nstep+1

      write(6,1003) nstep
 1003 format(///////////,' geometry number',i4,
     &                   ' of the vibrational analysis',/)

      do 1004 l=1,ncenters
 1004 write(6,1005) l,coord(1,l)*bohr,coord(2,l)*bohr,coord(3,l)*bohr
 1005 format(' atom # ',i3,5x,3f12.7)

      write(6,1006)
 1006 format(/)

      call scfrun(nreal,ninteger,nmaxatoms,nmaxorbs,nmaxaux,nmaxpoints,
     &            nfunctional,nmaxiterations,idiis,ngridtype,ncenters,
     &            nptcharges,nbsystems,level,nalpha,nbeta,nconts,ncontp,
     &            ncontd,ncds,ncdspd,nxcs,nxcspd,ixcfit,natomtype,
     &            nptsatom,nshels,nshelp,nsheld,ilfunc,icfunc,mtloca,
     &            ngaussians,nfuncatom,icdlfunc,icdcfunc,ixclfunc,
     &            ixccfunc,isys,iwkvec,econvergence,dmixing,elevelshift,
     &            diiserror,cutoff,coord,charge,coordpc,ptcharge,core,
     &            focka,fockb,focke,dmta,dmtb,coeffa,coeffb,alpha,coeff,
     &            alphacd,coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &            coefpxc,coefdxc,cdfitc,xcfita,xcfitb,xcfite,xcfitsave,
     &            tvec,tveca,tvecb,tvece,overlap,wkvec)

      n=ncontractions*(ncontractions+1)/2

      call dipolemm(nreal-n-5,ninteger,ncenters,nconts,ncontp,ncontd,
     &              nshels,nshelp,nsheld,mtloca,ilfunc,ngaussians,
     &              icfunc,iwkvec,wkvec(1),coord,charge,alpha,coeff,
     &              dmta,dmtb,wkvec(5),wkvec(n+5))

      call fastwr(73,wkvec,3)

      ndim=(ncontractions*(ncontractions+1))/2

      ja=3*ndim

      call move(1,nstep,nreal-ja,ninteger,nmaxpoints,nmaxorbs,ndim,
     &          ncenters,nalpha,nbeta,ncontractions,nconts,ncontp,
     &          ncontd,ncds,ncdspd,ibfrozen,iafrozen,idfrozen,iifrozen,
     &          imode,ngridtype,iptsweight,natomtype,nptsatom,nfuncatom,
     &          izmat1,izmat2,izmat3,nshels,nshelp,nsheld,ilfunc,icfunc,
     &          ngaussians,mtloca,icdlfunc,icdcfunc,ibfreeze,iafreeze,
     &          idfreeze,iifreeze,ibmode,iamode,idmode,iimode,iwkvec,
     &          dmaxfactor,step,small,coordfix,coord,charge,dmta,dmtb,
     &          coeffa,coeffb,alpha,coeff,cdfitc,alphacd,coefscd,
     &          coefpcd,coefdcd,grad,wkvec(1),wkvec(ja+1),labelatoms)

      write(6,1007)
 1007 format(/,' gradient :',/)

      do 1008 l=1,ncenters
 1008 write(6,1009) l,grad(1,l),grad(2,l),grad(3,l)
 1009 format(' atom # ',i3,5x,3f17.12)

      do 1010 l=1,ncenters
 1010 write(74) grad(1,l),grad(2,l),grad(3,l)

      do 1011 l=1,ncenters
      do 1011 m=1,3
 1011 coord(m,l)=coordfix(m,l)

 1002 continue

      ja=1
      jb=ja+ncenters*ncenters*9
      jc=jb+ncenters*ncenters*9
      jd=jc+ncenters*9
      je=jd+ncenters*9
      jf=je+ncenters*3
      jg=jf+ncenters*9
      jh=jg+ncenters*3
      ji=jh+ncenters*3

      call irspectrum(ncenters,natomtype,displacement,coord,wkvec(ja),
     &                wkvec(jb),wkvec(jc),wkvec(jd),wkvec(je),wkvec(jf),
     &                wkvec(jg),wkvec(jh),wkvec(ji))

      return
      end

      subroutine bofill(icycle,n,hessian,grad_1,coord_1,grad_0,
     &                  coord_0,delta_g,delta_x,wkmat1,wkmat2)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)  

      dimension hessian(n,*),grad_1(*),coord_1(*),grad_0(*),coord_0(*),
     &          delta_g(*),delta_x(*),wkmat1(n,*),wkmat2(n,*)

      data zero,one,two,pi/0.0d0,1.0d0,2.0d0,3.1415926535898d0/

      rewind 21

      call fastrd(21,hessian,n*n)
      call fastrd(21,grad_0,n)
      call fastrd(21,coord_0,n)

      do 1001 i=1,n
 1001 delta_x(i)=coord_1(i)-coord_0(i)

      do 1002 i=1,n
 1002 delta_g(i)=grad_1(i)-grad_0(i)

      do 1003 i=1,n
      if(delta_x(i).lt.(-pi)) delta_x(i)=delta_x(i)+two*pi
 1003 if(delta_x(i).gt.(+pi)) delta_x(i)=delta_x(i)-two*pi

      do 1004 j=1,n
      do 1004 i=1,n
 1004 delta_g(i)=delta_g(i)-hessian(i,j)*delta_x(j)

      fac1=zero
      fac2=zero
      fac3=zero

      do 1005 i=1,n
 1005 fac1=fac1+delta_x(i)*delta_x(i)

      do 1006 i=1,n
 1006 fac2=fac2+delta_g(i)*delta_g(i)

      do 1007 i=1,n
 1007 fac3=fac3+delta_g(i)*delta_x(i)

      factor=fac3/fac1

      do 1008 j=1,n
      do 1008 i=1,n
 1008 wkmat1(i,j)=zero

      do 1009 j=1,n
      do 1009 i=1,n
 1009 wkmat1(i,j)=wkmat1(i,j)+delta_g(i)*delta_x(j)
     &                       +delta_x(i)*delta_g(j)
     &                       -delta_x(i)*delta_x(j)*factor

      do 1010 j=1,n
      do 1010 i=1,n
 1010 wkmat1(i,j)=wkmat1(i,j)/fac1

      do 1011 j=1,n
      do 1011 i=1,n
 1011 wkmat2(i,j)=zero

      do 1012 j=1,n
      do 1012 i=1,n
 1012 wkmat2(i,j)=wkmat2(i,j)+delta_g(i)*delta_g(j)

      do 1013 j=1,n
      do 1013 i=1,n
 1013 wkmat2(i,j)=wkmat2(i,j)/fac3

      phi=one-((fac3*fac3)/(fac1*fac2))

      do 1014 j=1,n
      do 1014 i=1,n
 1014 hessian(i,j)=hessian(i,j)+phi*wkmat1(i,j)+(one-phi)*wkmat2(i,j)

      return
      end

c  these subroutines are required for the DeFT program.  they were
c  previously public domain.  they also include domain routines that
c  replace existing functions on cray machines
c
      subroutine flush(iunit)

      return
      end
c***********************************************************************
      SUBROUTINE MATINV(A,B,N,L,IDIM)

      IMPLICIT REAL*8(A-H,O-Z)

      PARAMETER (NDMATI=1000)

      DIMENSION A(IDIM,IDIM),B(IDIM),IP(NDMATI),IN(NDMATI,2)

      DATA ZERO,ONE,SMALL/0.0D0,1.0D0,1.0D-30/

      IF(N.GT.NDMATI) stop 'increase size of tables in matinv'

      D=ONE
      DO 1002 I=1,N
 1002 IP(I)=0

      DO 1003 I=1,N

      AMAX=ZERO

      DO 1004 J=1,N

      IF(IP(J).GT.0) GOTO 1004
      IF(IP(J).LT.0) GOTO 1005

      DO 1006 K=1,N

      IF(IP(K).EQ.1) GOTO 1006
      IF(IP(K).GT.1) GOTO 1005

      IF(ABS(A(J,K)).LE.AMAX) GOTO 1006
      IR=J
      IC=K
      AMAX=ABS(A(J,K))

 1006 CONTINUE

 1004 CONTINUE

      IP(IC)=IP(IC)+1

      IF(AMAX.GT.SMALL) GOTO 1007

 1005 STOP 'MATINV'

 1007 IF(IR.EQ.IC) GOTO 1008

      D=-D

      DO 1009 K=1,N
      AMAX=A(IR,K)
      A(IR,K)=A(IC,K)
 1009 A(IC,K)=AMAX

      IF(L.EQ.0) GOTO 1008

      AMAX=B(IR)
      B(IR)=B(IC)
      B(IC)=AMAX

 1008 IN(I,1)=IR

      IN(I,2)=IC
      AMAX=A(IC,IC)
      D=D*AMAX
      A(IC,IC)=ONE

      DO 1010 K=1,N
 1010 A(IC,K)=A(IC,K)/AMAX

      IF(L.EQ.0) GOTO 1011

      B(IC)=B(IC)/AMAX

 1011 DO 1003 J=1,N

      IF(J.EQ.IC) GOTO 1003

      AMAX=A(J,IC)
      A(J,IC)=ZERO

      DO 1012 K=1,N
 1012 A(J,K)=A(J,K)-A(IC,K)*AMAX

      IF(L.EQ.0) GOTO 1003
      B(J)=B(J)-B(IC)*AMAX

 1003 CONTINUE

      IF(L.EQ.1) GOTO 1013

      DO 1014 I=1,N

      J=N+1-I

      IF(IN(J,1).EQ.IN(J,2)) GOTO 1014
      IR=IN(J,1)
      IC=IN(J,2)

      DO 1015 K=1,N
      AMAX=A(K,IR)
      A(K,IR)=A(K,IC)
 1015 A(K,IC)=AMAX

 1014 CONTINUE
 1013 CONTINUE

      return
      end
C***********************************************************************
      SUBROUTINE TQL9(NM,N,D,E,Z,AUX,AUX1,IERR)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION D(N),E(N),Z(NM,N),AUX(N),AUX1(N)
C
      DATA PRECSN,ZERO,ONE,TWO/1.0D-24,0.0D0,1.0D0,2.0D0/
C
      IERR=0
      IF(N.EQ.1) GOTO 1600
      DO 100 I=2,N
  100 E(I-1)=E(I)
      F=ZERO
      B=ZERO
      E(N)=ZERO
      DO 1100 L=1,N
      J=0
      H=PRECSN*(ABS(D(L))+ABS(E(L)))
      IF(B.LT.H) B=H
      DO 200 M=L,N
      IF(ABS(E(M)).LE.B) GOTO 300
  200 CONTINUE
  300 IF(M.EQ.L) GOTO 1000
  400 IF(J.EQ.30) GOTO 1500
      J=J+1
      L1=L+1
      G=D(L)
      P=(D(L1)-G)/(TWO*E(L))
      R=SQRT(P*P+ONE)
      D(L)=E(L)/(P+SIGN(R,P))
      H=G-D(L)
      DO 500 I=L1,N
  500 D(I)=D(I)-H
      F=F+H
      P=D(M)
      C=ONE
      S=ZERO
      MML=M-L
      DO 900 II=1,MML
      I=M-II
      G=C*E(I)
      H=C*P
      IF(ABS(P).LT.ABS(E(I))) GOTO 600
      C=E(I)/P
      R=SQRT(C*C+ONE)
      E(I+1)=S*P*R
      S=C/R
      C=ONE/R
      GOTO 700
  600 C=P/E(I)
      R=SQRT(C*C+ONE)
      E(I+1)=S*E(I)*R
      S=ONE/R
      C=C*S
  700 P=C*D(I)-S*G
      D(I+1)=H+S*(C*G+S*D(I))
      DO 800 K=1,N
      AUX(K)=C*Z(K,I+1)
      AUX1(K)=S*Z(K,I+1)
      Z(K,I+1)=S*Z(K,I)
  800 Z(K,I)=C*Z(K,I)
      DO 850 K=1,N
      Z(K,I+1)=Z(K,I+1)+AUX(K)
  850 Z(K,I)=Z(K,I)-AUX1(K)
  900 CONTINUE
      E(L)=S*P
      D(L)=C*P
      IF(ABS(E(L)).GT.B) GOTO 400
 1000 D(L)=D(L)+F
 1100 CONTINUE
      DO 1400 II=2,N
      I=II-1
      K=I
      P=D(I)
      DO 1200 J=II,N
      IF(D(J).GE.P) GOTO 1200
      K=J
      P=D(J)
 1200 CONTINUE
      IF(K.EQ.I) GOTO 1400
      D(K)=D(I)
      D(I)=P
      DO 1250 J=1,N
      AUX(J)=Z(J,I)
 1250 Z(J,I)=Z(J,K)
      DO 1300 J=1,N
 1300 Z(J,K)=AUX(J)
 1400 CONTINUE
      GOTO 1600
 1500 IERR=L
 1600 RETURN
      END
C***********************************************************************
      SUBROUTINE TRED9(NM,N,A,D,E,AUX,Z)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION A(NM,N),D(N),E(N),Z(NM,N),AUX(N)
C
      DATA ZERO,ONE/0.0D0,1.0D0/
C
      DO 100 I=1,N
      DO 100 J=1,I
      Z(I,J)=A(I,J)
  100 CONTINUE
      IF(N.EQ.1) GOTO 1300
      DO 1200 II=2,N
      I=N+2-II
      L=I-1
      H=ZERO
      SCALE=ZERO
      IF(L.LT.2) GOTO 300
      DO 200 K=1,L
      AUX(K)=ABS(Z(I,K))
  200 SCALE=SCALE+AUX(K)
      IF(SCALE.NE.ZERO) GOTO 400
  300 E(I)=Z(I,L)
      GOTO 1100
  400 DO 500 K=1,L
      Z(I,K)=Z(I,K)/SCALE
      H=H+Z(I,K)*Z(I,K)
  500 CONTINUE
      F=Z(I,L)
      G=-SIGN(SQRT(H),F)
      E(I)=SCALE*G
      H=H-F*G
      Z(I,L)=F-G
      F=ZERO
      DO 900 J=1,L
      Z(J,I)=Z(I,J)/H
      G=ZERO
      DO 600 K=1,J
  600 G=G+Z(J,K)*Z(I,K)
      JP1=J+1
      IF(L.LT.JP1) GOTO 800
      DO 700 K=JP1,L
  700 G=G+Z(K,J)*Z(I,K)
  800 E(J)=G/H
      F=F+E(J)*Z(I,J)
  900 CONTINUE
      HH=F/(H+H)
      DO 1000 J=1,L
      F=Z(I,J)
      AUX(J)=E(J)-HH*F
      E(J)=AUX(J)
      DO 950 K=1,J
      AUX(K)=F*E(K)
  950 Z(J,K)=Z(J,K)-AUX(K)
      DO 1000 K=1,J
      AUX(K)=E(J)*Z(I,K)
 1000 Z(J,K)=Z(J,K)-AUX(K)
 1100 D(I)=H
 1200 CONTINUE
 1300 D(1)=ZERO
      E(1)=ZERO
      DO 1800 I=1,N
      L=I-1
      IF(D(I).EQ.ZERO) GOTO 1600
      DO 1500 J=1,L
      G=ZERO
      DO 1400 K=1,L
 1400 G=G+Z(I,K)*Z(K,J)
      DO 1450 K=1,L
 1450 AUX(K)=G*Z(K,I)
      DO 1500 K=1,L
 1500 Z(K,J)=Z(K,J)-AUX(K)
 1600 D(I)=Z(I,I)
      Z(I,I)=ONE
      IF(L.LT.1) GOTO 1800
      DO 1650 J=1,L
 1650 Z(I,J)=ZERO
      DO 1700 J=1,L
      Z(J,I)=ZERO
 1700 CONTINUE
 1800 CONTINUE
      RETURN
      END

      subroutine augg(n,tvalue,gv)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
c
c  based on brett dunlap's incomplete gamma function subroutines

      implicit real*8(a-h,o-z)

      dimension gv(13)

      common/igfdata/table(17,161),smallu(17),bigu(13)

      data small,eterm/0.00000001d0,0.018315638888734d0/

      data a1,a2,a3/0.2507213d0,0.0292732d0,0.0038278d0/

      data b1,b2,b3,b4,b5/1.333333333333d0,0.53333333333333d0,
     &                    0.152380952000d0,3.28125000000000d0,
     &                    0.937500000000d0/

      data c1,c2,c3,c4/1.772453850905500d0,0.88622692545276d0,
     &                 0.041666666666667d0,0.16666666666667d0/

      data zero,tenth,quarter,three8ths,half,
     &     one,two,ten,sixteen,plus16,thirty6/0.000d0, 0.100d0, 0.250d0,
     &                                        0.375d0, 0.500d0, 1.000d0,
     &                                        2.000d0,10.000d0,16.000d0,
     &                                       16.050d0,36.000d0/

      twotvalue=two*tvalue

      if(n.eq.1) then
                       if(tvalue.le.small) then
                                                 gv(1)=one
                                                 return
                                           endif

                        if(tvalue.ge.plus16) then
                                                   gv(1)=c2/sqrt(tvalue)
                                                   return
                                             endif

                        i=ten*tvalue

                        x=tvalue-tenth*real64(i)

                        gv(1)=(((c3*table(5,i+1)*x-c4*table(4,i+1))*x
     &                          +half*table(3,i+1))*x-table(2,i+1))*x
     &                          +table(1,i+1)

                        return
                  endif

      if(tvalue.le.small) then
                                do 1001 i=1,n
 1001                           gv(i)=smallu(i)

                                return
                          endif

      if(tvalue.lt.plus16) goto 1002

      if(n.gt.5) goto 1003

      x=tvalue-sixteen

      factor1=(eterm/(((a3*x+a2)*x+a1)*x+one))**4
      factor2=one/tvalue
      factor3=factor2+two
      factor4=sqrt(tvalue)
      factor5=c1/factor4

      goto(1004,1005,1006,1007,1008) n

 1008 gv(5)=b4*factor2*(factor5/(tvalue**3)
     &     -factor1*(((factor3*factor2+b1)*factor2+b2)*factor2+b3))

 1007 gv(4)=b5*factor2*(factor5/(tvalue**2)
     &     -factor1*((factor3*factor2+b1)*factor2+b2))

 1006 gv(3)=three8ths*factor2*(factor5/tvalue
     &     -factor1*(factor3*factor2+b1))

 1005 gv(2)=quarter*factor2*(factor5-factor1*factor3)

 1004 gv(1)=half*factor2*(c1*factor4-factor1)

      return

 1003 gv(n)=c2*bigu(n)/sqrt(tvalue)

      do 1009 i=1,n-1
 1009 gv(n)=gv(n)*half/tvalue

      x1=2*n-1
      x2=2*n-1

      term=one
      sum=one

      do 1010 i=1,n
      x1=x1-two
      term=term*x1/twotvalue
 1010 sum=sum+term

      expfac=zero
      if(tvalue.lt.thirty6) expfac=exp(-tvalue)

      gv(n)=gv(n)-sum*expfac/twotvalue

      do 1011 i=1,n-1
      x2=x2-two
 1011 gv(n-i)=(gv(n-i+1)*twotvalue+expfac)/x2

      return

 1002 i=ten*tvalue

      x1=tvalue-tenth*real64(i)
      x2=2*n-1

      gv(n)=(((c3*table(n+4,i+1)*x1-c4*table(n+3,i+1))*x1
     &        +half*table(n+2,i+1))*x1-table(n+1,i+1))*x1+table(n,i+1)

      expfac=exp(-tvalue)

      do 1012 i=1,n-1
      x2=x2-two
 1012 gv(n-i)=(gv(n-i+1)*twotvalue+expfac)/x2

      return
      end

      subroutine delphi(iswitch,iteration,ncenters,nptcharges,ngrid,
     &                  ngridby2,natomtype,nboundary,epsilon,coord,
     &                  charges,coordptcharge,ptcharges,phinew,phiold,
     &                  gridcharge,dielectric,avgdielectric,
     &                  coordneighbour,radneighbour)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      logical connol

      dimension vanderwaal(18),cubepts(3,6)

      dimension natomtype(*),nboundary(ngrid,ngrid,*)

      dimension coord(3,*),charges(*),coordptcharge(3,*),ptcharges(*),
     &          phinew(ngrid,ngrid,*),phiold(ngrid,ngrid,*),
     &          gridcharge(ngrid,ngrid,*),dielectric(6,ngrid,ngrid,*),
     &          avgdielectric(ngrid,ngrid,*),coordneighbour(3,*),
     &          radneighbour(*)

      data zero,half,one/0.0d0,0.5d0,1.0d0/
      data pi,six/3.1415926535898d0,6.0d0/
      data bohr,efactor1,efactor2/0.529177d0,27.212d0,23.062d0/
      data hstep,tolerance,probe/0.50d0,0.0001d0,1.40d0/

      data vanderwaal/
     &     1.40d0,                                               1.62d0,
     &     2.02d0,0.00d0,     0.00d0,1.92d0,1.77d0,1.62d0,1.57d0,1.76d0,
     &     2.52d0,1.92d0,     0.00d0,2.32d0,2.07d0,2.07d0,2.02d0,2.14d0/

      rewind 49
      rewind 50

      fourpi=pi/half/half

      proberadius=probe/bohr

      do 1001 k=1,ngrid
      do 1001 j=1,ngrid
      do 1001 i=1,ngrid
      nboundary(i,j,k)=0
      gridcharge(i,j,k)=zero
 1001 phiold(i,j,k)=zero

      do 1002 i=1,ncenters

      if(natomtype(i).eq.0) goto 1002

      ix=int((coord(1,i)+real64(ngridby2)*hstep)/hstep)
      iy=int((coord(2,i)+real64(ngridby2)*hstep)/hstep)
      iz=int((coord(3,i)+real64(ngridby2)*hstep)/hstep)

      ix1=ix
      iy1=iy
      iz1=iz

      ix2=ix
      iy2=iy
      iz2=iz+1

      ix3=ix
      iy3=iy+1
      iz3=iz

      ix4=ix
      iy4=iy+1
      iz4=iz+1

      ix5=ix+1
      iy5=iy
      iz5=iz

      ix6=ix+1
      iy6=iy
      iz6=iz+1

      ix7=ix+1
      iy7=iy+1
      iz7=iz

      ix8=ix+1
      iy8=iy+1
      iz8=iz+1

      x1=real64(ix1-ngridby2)*hstep
      y1=real64(iy1-ngridby2)*hstep
      z1=real64(iz1-ngridby2)*hstep

      x2=real64(ix2-ngridby2)*hstep
      y2=real64(iy2-ngridby2)*hstep
      z2=real64(iz2-ngridby2)*hstep

      x3=real64(ix3-ngridby2)*hstep
      y3=real64(iy3-ngridby2)*hstep
      z3=real64(iz3-ngridby2)*hstep

      x4=real64(ix4-ngridby2)*hstep
      y4=real64(iy4-ngridby2)*hstep
      z4=real64(iz4-ngridby2)*hstep

      x5=real64(ix5-ngridby2)*hstep
      y5=real64(iy5-ngridby2)*hstep
      z5=real64(iz5-ngridby2)*hstep

      x6=real64(ix6-ngridby2)*hstep
      y6=real64(iy6-ngridby2)*hstep
      z6=real64(iz6-ngridby2)*hstep

      x7=real64(ix7-ngridby2)*hstep
      y7=real64(iy7-ngridby2)*hstep
      z7=real64(iz7-ngridby2)*hstep

      x8=real64(ix8-ngridby2)*hstep
      y8=real64(iy8-ngridby2)*hstep
      z8=real64(iz8-ngridby2)*hstep

      x1=abs(x1-coord(1,i))/hstep
      y1=abs(y1-coord(2,i))/hstep
      z1=abs(z1-coord(3,i))/hstep

      x2=abs(x2-coord(1,i))/hstep
      y2=abs(y2-coord(2,i))/hstep
      z2=abs(z2-coord(3,i))/hstep

      x3=abs(x3-coord(1,i))/hstep
      y3=abs(y3-coord(2,i))/hstep
      z3=abs(z3-coord(3,i))/hstep

      x4=abs(x4-coord(1,i))/hstep
      y4=abs(y4-coord(2,i))/hstep
      z4=abs(z4-coord(3,i))/hstep

      x5=abs(x5-coord(1,i))/hstep
      y5=abs(y5-coord(2,i))/hstep
      z5=abs(z5-coord(3,i))/hstep

      x6=abs(x6-coord(1,i))/hstep
      y6=abs(y6-coord(2,i))/hstep
      z6=abs(z6-coord(3,i))/hstep

      x7=abs(x7-coord(1,i))/hstep
      y7=abs(y7-coord(2,i))/hstep
      z7=abs(z7-coord(3,i))/hstep

      x8=abs(x8-coord(1,i))/hstep
      y8=abs(y8-coord(2,i))/hstep
      z8=abs(z8-coord(3,i))/hstep

      gridcharge(ix1,iy1,iz1)=gridcharge(ix1,iy1,iz1)
     &                       +(one-x1)*(one-y1)*(one-z1)*charges(i)

      gridcharge(ix2,iy2,iz2)=gridcharge(ix2,iy2,iz2)
     &                       +(one-x2)*(one-y2)*(one-z2)*charges(i)

      gridcharge(ix3,iy3,iz3)=gridcharge(ix3,iy3,iz3)
     &                       +(one-x3)*(one-y3)*(one-z3)*charges(i)

      gridcharge(ix4,iy4,iz4)=gridcharge(ix4,iy4,iz4)
     &                       +(one-x4)*(one-y4)*(one-z4)*charges(i)

      gridcharge(ix5,iy5,iz5)=gridcharge(ix5,iy5,iz5)
     &                       +(one-x5)*(one-y5)*(one-z5)*charges(i)

      gridcharge(ix6,iy6,iz6)=gridcharge(ix6,iy6,iz6)
     &                       +(one-x6)*(one-y6)*(one-z6)*charges(i)

      gridcharge(ix7,iy7,iz7)=gridcharge(ix7,iy7,iz7)
     &                       +(one-x7)*(one-y7)*(one-z7)*charges(i)

      gridcharge(ix8,iy8,iz8)=gridcharge(ix8,iy8,iz8)
     &                       +(one-x8)*(one-y8)*(one-z8)*charges(i)

 1002 continue

      if(iteration.gt.1) call fastrd(50,phiold,ngrid*ngrid*ngrid)

      da=real64(1-ngridby2)*hstep
      db=real64(ngrid-ngridby2)*hstep

      do 1003 j=1,ngrid
      do 1003 i=1,ngrid

      phiold(i,j,1)=zero
      phiold(i,1,j)=zero
      phiold(1,i,j)=zero

      phiold(i,j,ngrid)=zero
      phiold(i,ngrid,j)=zero
      phiold(ngrid,i,j)=zero

 1003 continue

      do 1004 k=1,ncenters

      if(natomtype(k).ne.0) then

               xx=coord(1,k)
               yy=coord(2,k)
               zz=coord(3,k)

               do 1005 j=2,ngrid-1

               dj=real64(j-ngridby2)*hstep

               do 1005 i=2,ngrid-1

               di=real64(i-ngridby2)*hstep

               phiold(i,j,1)=phiold(i,j,1)+charges(k)/epsilon/
     &                       sqrt((di-xx)**2+(dj-yy)**2+(da-zz)**2)

               phiold(i,1,j)=phiold(i,1,j)+charges(k)/epsilon/
     &                       sqrt((di-xx)**2+(da-yy)**2+(dj-zz)**2)

               phiold(1,i,j)=phiold(1,i,j)+charges(k)/epsilon/
     &                       sqrt((da-xx)**2+(di-yy)**2+(dj-zz)**2)

               phiold(i,j,ngrid)=phiold(i,j,ngrid)+charges(k)/epsilon/
     &                           sqrt((di-xx)**2+(dj-yy)**2+(db-zz)**2)

               phiold(i,ngrid,j)=phiold(i,ngrid,j)+charges(k)/epsilon/
     &                           sqrt((di-xx)**2+(db-yy)**2+(dj-zz)**2)

               phiold(ngrid,i,j)=phiold(ngrid,i,j)+charges(k)/epsilon/
     &                           sqrt((db-xx)**2+(di-yy)**2+(dj-zz)**2)

 1005          continue

                            endif
 1004 continue

      do 1006 j=1,ngrid
      do 1006 i=1,ngrid
      phinew(i,j,1)=phiold(i,j,1)
      phinew(i,1,j)=phiold(i,1,j)
      phinew(1,i,j)=phiold(1,i,j)
      phinew(i,j,ngrid)=phiold(i,j,ngrid)
      phinew(i,ngrid,j)=phiold(i,ngrid,j)
 1006 phinew(ngrid,i,j)=phiold(ngrid,i,j)

      if(iteration.gt.1) then

                call fastrd(49,dielectric,6*ngrid*ngrid*ngrid)

                         else

                do 1007 k=1,ngrid
                do 1007 j=1,ngrid
                do 1007 i=1,ngrid
                dielectric(1,i,j,k)=epsilon
                dielectric(2,i,j,k)=epsilon
                dielectric(3,i,j,k)=epsilon
                dielectric(4,i,j,k)=epsilon
                dielectric(5,i,j,k)=epsilon
 1007           dielectric(6,i,j,k)=epsilon

                do 1008 l=1,ncenters

                if(natomtype(l).eq.0) goto 1008 

                if(natomtype(l).eq.04) stop 'cannot do delphi'
                if(natomtype(l).eq.05) stop 'cannot do delphi'
                if(natomtype(l).eq.13) stop 'cannot do delphi'
                if(natomtype(l).gt.18) stop 'cannot do delphi'

                radius=vanderwaal(natomtype(l))/bohr

                neighbour=0

                do 1009 i=1,ncenters
                if((i.ne.l).and.(natomtype(i).ne.0)) then

                   neighbour=neighbour+1

                   coordneighbour(1,neighbour)=coord(1,i)
                   coordneighbour(2,neighbour)=coord(2,i)
                   coordneighbour(3,neighbour)=coord(3,i)

                   radneighbour(neighbour)=vanderwaal(natomtype(i))/bohr

                                                     endif
 1009           continue

                do 1010 k=2,ngrid-1
                z=real64(k-ngridby2)*hstep

                do 1010 j=2,ngrid-1
                y=real64(j-ngridby2)*hstep

                do 1010 i=2,ngrid-1
                x=real64(i-ngridby2)*hstep

                cubepts(1,1)=x+hstep*half
                cubepts(2,1)=y
                cubepts(3,1)=z

                cubepts(1,2)=x-hstep*half
                cubepts(2,2)=y
                cubepts(3,2)=z

                cubepts(1,3)=x
                cubepts(2,3)=y+hstep*half
                cubepts(3,3)=z

                cubepts(1,4)=x
                cubepts(2,4)=y-hstep*half
                cubepts(3,4)=z

                cubepts(1,5)=x
                cubepts(2,5)=y
                cubepts(3,5)=z+hstep*half

                cubepts(1,6)=x
                cubepts(2,6)=y
                cubepts(3,6)=z-hstep*half

       do 1011 m=1,6

       if(dist(cubepts(1,m),coord(1,l)).le.radius)
     &                                  dielectric(m,i,j,k)=one

       if((dist(cubepts(1,m),coord(1,l)).gt.radius).and.
     &    (dist(cubepts(1,m),coord(1,l)).le.(radius+proberadius))) then

       if(connol(cubepts(1,m),proberadius,coordneighbour,radneighbour,
     &    coord(1,l),radius,neighbour)) dielectric(m,i,j,k)=one

                                                                   endif

 1011  continue

 1010           continue

 1008           continue

                rewind 49

                call fastwr(49,dielectric,6*ngrid*ngrid*ngrid)

                         endif

      do 1012 k=2,ngrid-1
      do 1012 j=2,ngrid-1
      do 1012 i=2,ngrid-1
 1012 avgdielectric(i,j,k)=dielectric(1,i,j,k)+dielectric(2,i,j,k)
     &                    +dielectric(3,i,j,k)+dielectric(4,i,j,k)
     &                    +dielectric(5,i,j,k)+dielectric(6,i,j,k)

      do 1013 k=2,ngrid-1
      do 1013 j=2,ngrid-1
      do 1013 i=2,ngrid-1
      a1=abs(six-avgdielectric(i,j,k))
      a2=abs(six-avgdielectric(i,j,k)/epsilon)
 1013 if(min(a1,a2).gt.tolerance) nboundary(i,j,k)=1

      do 1014 n=1,150

      do 1015 k=2,ngrid-1
      do 1015 j=2,ngrid-1
      do 1015 i=2,ngrid-1

      phinew(i,j,k)=phiold(i+1,j,k)*dielectric(1,i,j,k)
     &             +phiold(i-1,j,k)*dielectric(2,i,j,k)
     &             +phiold(i,j+1,k)*dielectric(3,i,j,k)
     &             +phiold(i,j-1,k)*dielectric(4,i,j,k)
     &             +phiold(i,j,k+1)*dielectric(5,i,j,k)
     &             +phiold(i,j,k-1)*dielectric(6,i,j,k)
     &             +fourpi*gridcharge(i,j,k)/hstep

 1015 phinew(i,j,k)=phinew(i,j,k)/avgdielectric(i,j,k)

      do 1016 k=2,ngrid-1
      do 1016 j=2,ngrid-1
      do 1016 i=2,ngrid-1
 1016 phiold(i,j,k)=phinew(i,j,k)

 1014 continue

      rewind 50

      call fastwr(50,phiold,ngrid*ngrid*ngrid)

      do 1017 k=2,ngrid-1
      do 1017 j=2,ngrid-1
      do 1017 i=2,ngrid-1
 1017 phiold(i,j,k)=(hstep/fourpi)*(six*phinew(i,j,k)
     &                             -phinew(i+1,j,k)-phinew(i-1,j,k)
     &                             -phinew(i,j+1,k)-phinew(i,j-1,k)
     &                             -phinew(i,j,k+1)-phinew(i,j,k-1))
     &                             -gridcharge(i,j,k)

      nptcharges=0

      if(iswitch.eq.1) write(6,1018)
 1018 format(/,' surface induced charges',
     &         ' (can be displayed with MIDAS): ',/)

      do 1019 k=2,ngrid-1
      do 1019 j=2,ngrid-1
      do 1019 i=2,ngrid-1

      if(nboundary(i,j,k).eq.0) goto 1019

      nptcharges=nptcharges+1

      x=real64(i-ngridby2)*hstep
      y=real64(j-ngridby2)*hstep
      z=real64(k-ngridby2)*hstep

      coordptcharge(1,nptcharges)=x
      coordptcharge(2,nptcharges)=y
      coordptcharge(3,nptcharges)=z

      ptcharges(nptcharges)=phiold(i,j,k)

      if(iswitch.eq.1) then

         if(phiold(i,j,k).lt.zero) then

             write(6,1020) nptcharges,nptcharges+1,x,y,z,phiold(i,j,k)
 1020        format('ATOM',3x,i4,'  CL- CIO ',i5,4x,3f8.3,f12.9)

                                   else

             write(6,1021) nptcharges,nptcharges+1,x,y,z,phiold(i,j,k)
 1021        format('ATOM',3x,i4,'  NA+ CIO ',i5,4x,3f8.3,f12.9)

                                   endif

                       endif
 1019 continue

      deltag=zero

      do 1022 j=1,ncenters
      do 1022 i=1,nptcharges
 1022 deltag=deltag+half*ptcharges(i)*charges(j)/
     &                               dist(coordptcharge(1,i),coord(1,j))

      write(6,1023) nptcharges
 1023 format(/,' there are ',i5,' surface induced charges',/)

      write(6,1024) deltag*efactor1*efactor2
 1024 format(' electrostatic contribution to free energy of solvation',
     &       ' = ',f9.4,' kcal/mole',////)

      return
      end

      subroutine xcfunctional(nfunctional,ixcfit,igrad,
     &                        dnstya,dnstyb,dnstyt,
     &                        gradxa,gradya,gradza,
     &                        gradxb,gradyb,gradzb,
     &                        gradxt,gradyt,gradzt,
     &                        hssxxa,hssxya,hssxza,hssyya,hssyza,hsszza,
     &                        hssxxb,hssxyb,hssxzb,hssyyb,hssyzb,hsszzb,
     &                        hssxxt,hssxyt,hssxzt,hssyyt,hssyzt,hsszzt,
     &                        xcnrgy,xcpota,xcpotb)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      data small,expcut/1.0d-15,80.0d0/

      data zero,one,two,three,four,five,six,seven,dnine,eleven/
     &    0.0d0,1.0d0,2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,9.0d0,11.0d0/

      data third,threequarters,fourthirds,fivethirds/
     &    0.33333333333333d0,0.75d0,1.3333333333333d0,1.6666666666667d0/

      data pi,dnom,zetadnom,pialpha/
     &    3.1415926535898d0,5.1297633d0,0.519842099d0,1.636963801d0/

      data fperdew,cp1,cp2,cp3,cp4/
     &    0.11d0,0.023266d0,7.389d-06,8.723d0,0.472d0/

      data tenthousand,thirtythousand,cpa,cpb,cpc,cpd/
     &    10000.0d0,30000.0d0,0.001667d0,0.002568d0,1.745d0,0.004235d0/

      ex=zero
      ec=zero

      vxa=zero
      vxb=zero

      vca=zero
      vcb=zero

      if(nfunctional.gt.0) call drho(gradxa,gradya,gradza,
     &                               hssxxa,hssxya,hssxza,
     &                               hssyya,hssyza,hsszza,
     &                               gmoda,dlapa,xcvta)

      if(nfunctional.gt.0) call drho(gradxb,gradyb,gradzb,
     &                               hssxxb,hssxyb,hssxzb,
     &                               hssyyb,hssyzb,hsszzb,
     &                               gmodb,dlapb,xcvtb)

      if(nfunctional.gt.0) call drho(gradxt,gradyt,gradzt,
     &                               hssxxt,hssxyt,hssxzt,
     &                               hssyyt,hssyzt,hsszzt,
     &                               gmodt,dlapt,xcvtt)

      if(dnstyt.gt.small) then
                                rs=one/(pi*fourthirds*dnstyt)**third

                                zeta=(dnstya-dnstyb)/dnstyt

                                if(zeta.gt.+one) zeta=+one
                                if(zeta.lt.-one) zeta=-one
                          else
                                xcnrgy=zero

                                xcpota=zero
                                xcpotb=zero

                                return
                          endif

      ex=-(threequarters/(pialpha*rs))*((one+zeta)**fourthirds
     &                                 +(one-zeta)**fourthirds)/two

      factor=-threequarters*(three/pi)**third

      vxa=factor*((two*dnstya)**third)*fourthirds
      vxb=factor*((two*dnstyb)**third)*fourthirds

      if(nfunctional.gt.0) then

            if((ixcfit.eq.1).or.(igrad.eq.1)) then

                       call beckex(dnstya,dnstyb,dnstyt,gmoda,gmodb,
     &                             dlapa,dlapb,xcvta,xcvtb,ex,vxa,vxb)

                                              else

                       ex=zero

                       vxa=zero
                       vxb=zero

                                              endif

                           endif

      sqrtrs=sqrt(rs)

      aa=vwnf1(1,sqrtrs)/two
      bb=vwnf2(1,sqrtrs)/two

      ec=aa

      vca=aa-bb*sqrtrs/six
      vcb=aa-bb*sqrtrs/six

      cc=(vwnf1(2,sqrtrs)/two)-aa
      dd=(vwnf2(2,sqrtrs)/two)-bb
      ee=(vwnf1(3,sqrtrs)/two)*three/dnom

      sf1=((one+zeta)**third-(one-zeta)**third)*dnom/two
      sf2=(((one+zeta)**fourthirds+(one-zeta)**fourthirds)-two)/zetadnom

      ff=sf2*(cc*zeta**4+ee*(one-zeta**4)-(sqrtrs/six)
     &  *(dd*zeta**4+(one-zeta**4)*vwnf2(3,sqrtrs)*three/two/dnom))

      gg=sf1*(cc*zeta**4+ee*(one-zeta**4))+four*sf2*((cc-ee)*zeta**3)

      ec=ec+sf2*(cc*(zeta**4)+ee*(one-zeta**4))

      vca=vca+ff+(one-zeta)*gg
      vcb=vcb+ff-(one+zeta)*gg

      if(nfunctional.eq.0) goto 1001
      if((ixcfit.eq.0).and.(igrad.eq.0)) goto 1001

      d2minus1=one/((two**third)*sqrt(((one+zeta)/two)**fivethirds
     &                               +((one-zeta)/two)**fivethirds))

      cnperdew=cpa+(cpb+cp1*rs+cp2*rs*rs)
     &            /(one+cp3*rs+cp4*rs*rs+tenthousand*cp2*rs*rs*rs)

      phi=zero

      if(dnstyt.gt.small) phi=cpc*fperdew*(cpd/cnperdew)*gmodt
     &                       /dnstyt**(seven/six)

      expfac=zero

      if(phi.lt.expcut) expfac=exp(-phi)

      if(dnstyt.gt.small) ec=ec+d2minus1*expfac*cnperdew*gmodt*gmodt
     &                         /(dnstyt**(seven/three))

      term=one+cp3*rs+cp4*rs*rs+tenthousand*cp2*rs*rs*rs

      term1=((cp1+two*cp2*rs)/term)-((cpb+cp1*rs+cp2*rs*rs)
     &      *(cp3+two*cp4*rs+thirtythousand*cp2*rs*rs)/term**2)

      term2=zero

      if(dnstyt.gt.small) term2=-(four*pi/dnine)
     &                         *((four*pi*dnstyt/three)**(-fourthirds))

      term=term1*term2

      perdewc=zero

      aa=zero
      bb=zero
      cc=zero

      if(dnstyt.gt.small) then
                                perdewc=d2minus1*expfac*gmodt*gmodt
     &                                 *(phi*phi-phi-one)*term
     &                                 /(dnstyt**fourthirds)

                                aa=d2minus1*expfac*cnperdew
     &                                            /(dnstyt**third)

                                bb=(two-phi)*dlapt/dnstyt

                                cc=(fourthirds-(eleven*phi/three)
     &                            +((seven/six)*phi*phi))*gmodt*gmodt
     &                            /(dnstyt*dnstyt)
                          endif

      rhograd=dnstyt*gmodt

      if(rhograd.gt.small) then
                                 rhograd=phi*(phi-three)*xcvtt/rhograd
                           else
                                 rhograd=zero
                           endif

      rhot13=dnstyt**third

      rhoa23=dnstya**(two/three)
      rhob23=dnstyb**(two/three)

      dd=six*(dnstyt**4)/(d2minus1*d2minus1)

      dda=zero
      ddb=zero

      if(dd.gt.(small**4)) then
                                 dda=five*rhot13*(rhoa23-rhob23)/dd
                                 ddb=five*rhot13*(rhob23-rhoa23)/dd
                           endif

      ee=(two**(two/three))*(two-phi)*dnstyt

      eea=ee*(gradxb*gradxt+gradyb*gradyt+gradzb*gradzt)
      eeb=ee*(gradxa*gradxt+gradya*gradyt+gradza*gradzt)

      factor=(two**(two/three))*(one-phi)*gmodt*gmodt

      vca=vca+perdewc-aa*(bb-cc+rhograd-dda*(factor*dnstyb-eea))
      vcb=vcb+perdewc-aa*(bb-cc+rhograd-ddb*(factor*dnstya-eeb))

 1001 continue

      xcnrgy=ex+ec

      xcpota=vxa+vca
      xcpotb=vxb+vcb

      return
      end

      subroutine ksorbs(maxorbitals,nalpha,nbeta,eigalpha,eigbeta)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension eigalpha(*),eigbeta(*)

      data zero,one,ev/0.0d0,1.0d0,27.212d0/

      write(6,1001)
 1001 format(//,' kohn-sham orbitals : ',/)

      do 1002 i=1,min(nalpha+5,maxorbitals)
      if(i.le.nalpha) write(6,1003) i,eigalpha(i)*ev,one
 1002 if(i.gt.nalpha) write(6,1003) i,eigalpha(i)*ev,zero

 1003 format(' spin alpha orbital # ',i4,',  eigenvalue = ',f12.5,
     &       ' eV,  occupancy = ',f6.4)

      write(6,1004)
 1004 format()

      do 1005 i=1,min(nbeta+5,maxorbitals)
      if(i.le.nbeta) write(6,1006) i,eigbeta(i)*ev,one
 1005 if(i.gt.nbeta) write(6,1006) i,eigbeta(i)*ev,zero

 1006 format(' spin beta orbital #  ',i4,',  eigenvalue = ',f12.5,
     &       ' eV,  occupancy = ',f6.4)

      write(6,1007)
 1007 format(//)

      return
      end

      subroutine scfcycle(iteration,nreal,ninteger,nmaxatoms,nmaxorbs,
     &                    maxaux,nmaxpoints,idiis,nfunctional,ngridtype,
     &                    natoms,nptcharges,nbsystems,level,nalpha,
     &                    nbeta,ncontractions,nconts,ncontp,ncontd,ncds,
     &                    ncdspd,nxcs,nxcspd,ixcfit,natomtype,nptsatom,
     &                    nshels,nshelp,nsheld,mtloca,ilfunc,icfunc,
     &                    ngaussians,nfuncatom,icdlfunc,icdcfunc,
     &                    ixclfunc,ixccfunc,isys,icdlsave,iwkvec,energy,
     &                    eshift,dmixing,diiserror,dmaxpc,cutoff,coord,
     &                    coordpc,charge,ptcharge,core,focka,fockb,
     &                    focke,dmta,dmtb,coeffa,coeffb,overlap,alpha,
     &                    coeffs,alphacd,coefscd,coefpcd,coefdcd,
     &                    alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,xcfita,
     &                    xcfitb,xcfite,tvector,tveca,tvecb,tvece,
     &                    storecd,cdstore,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          mtloca(*),ilfunc(*),icfunc(*),ngaussians(*),
     &          nfuncatom(*),icdlfunc(*),icdcfunc(*),ixclfunc(*),
     &          ixccfunc(*),isys(nmaxatoms,*),icdlsave(*),iwkvec(*)

      dimension cutoff(*),coord(3,*),coordpc(3,*),charge(*),ptcharge(*),
     &          core(*),focka(*),fockb(*),focke(*),dmta(*),dmtb(*),
     &          coeffa(nmaxorbs,*),coeffb(nmaxorbs,*),
     &          overlap(nmaxorbs,*),alpha(*),coeffs(*),alphacd(*),
     &          coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),coefsxc(*),
     &          coefpxc(*),coefdxc(*),cdfitc(*),xcfita(*),xcfitb(*),
     &          xcfite(*),tvector(*),tveca(*),tvecb(*),tvece(*),
     &          storecd(*),cdstore(*),wkvec(*)

      data zero,one/0.0d0,1.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ndim=ncontractions*(ncontractions+1)/2

      ncdfunc=ncds+10*ncdspd
      nxcfunc=nxcs+10*nxcspd

      if(iteration.eq.1) then

               call startscf(nreal,ninteger,nmaxatoms,nmaxorbs,ncdfunc,
     &               nmaxpoints,natoms,nptcharges,nconts,ncontp,ncontd,
     &               ncds,ncdspd,nxcs,nxcspd,level,ngridtype,nbsystems,
     &               isys,icdlsave,iwkvec,nshels,nshelp,nsheld,ilfunc,
     &               icfunc,ngaussians,mtloca,icdlfunc,icdcfunc,
     &               ixclfunc,ixccfunc,natomtype,nptsatom,energy,dmaxpc,
     &               diiserror,cutoff,wkvec,core,focka,fockb,focke,
     &               overlap,coeffa,coeffb,coord,coordpc,charge,
     &               ptcharge,alpha,coeffs,alphacd,coefscd,coefpcd,
     &               coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,
     &               xcfita,xcfitb,xcfite,dmta,dmtb,tveca,tvecb,tvece)

               call mpi_bcast(nptsatom,natoms,
     &                        mpi_integer,0,mpi_comm_world,ierr)

               if(nxcs.eq.0) nxcspd=0
               if(nxcs.eq.0) nxcfunc=0

               nnn=max(nxcfunc,ncontractions)

               ja=1
               jb=ja+3*nnn
               jc=jb+3*nnn
               jd=jc+nnn*nnn

               call gridcall(nreal-jd,nnn,1,iteration,nfunctional,
     &                       natoms,nmaxatoms,nbsystems,nalpha,nbeta,
     &                       nconts,ncontp,ncontd,nxcs,nxcs+nxcspd,
     &                       nmaxpoints,natomtype,nptsatom,nshels,
     &                       nshelp,nsheld,ilfunc,icfunc,ngaussians,
     &                       ixclfunc,ixccfunc,isys,iwkvec,
     &                       iwkvec(nnn+1),dmixing,cutoff(2),coord,
     &                       alpha,coeffs,alphaxc,coefsxc,coefpxc,
     &                       coefdxc,xcfita,xcfitb,xcfite,dmta,dmtb,
     &                       tveca,tvecb,tvece,wkvec(ja),wkvec(jb),
     &                       wkvec(jc),focka,fockb,focke,wkvec(jd))

                         endif

      call twoemm(nreal-3*ndim,ninteger,nconts,ncontp,ncontd,ncds,
     &            ncdspd,nxcs,nxcspd,nshels,nshelp,nsheld,mtloca,ilfunc,
     &            ngaussians,icfunc,icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &            iwkvec,cutoff(3),coord,alpha,coeffs,alphacd,coefscd,
     &            coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,
     &            cdfitc,xcfita,xcfitb,xcfite,wkvec(1),focka,fockb,
     &            focke,wkvec(ndim+1),wkvec(2*ndim+1))

      if(ixcfit.eq.0) then
                            nxcs=0
                            nxcspd=0
                            nxcfunc=0
                      endif

      do 1001 j=1,ndim
      focka(j)=focka(j)+core(j)
      fockb(j)=fockb(j)+core(j)
 1001 focke(j)=focke(j)+core(j)

      ja=1
      jb=ja+ncontractions*ncontractions

      if((eshift.ne.zero).
     &    and.(myid.eq.0)) call carbo(nmaxorbs,ncontractions,
     &                                ncontractions,nalpha,nbeta,eshift,
     &                                focka,fockb,coeffa,coeffb,overlap,
     &                                wkvec(ja),wkvec(jb))

      ka=1
      kb=ka+ncontractions*ncontractions
      kc=kb+ncontractions*ncontractions
      kd=kc+ncontractions*ncontractions
      ke=kd+ncontractions*ncontractions
      kf=ke+ncontractions*ncontractions
      kg=kf+ncontractions*ncontractions
      kh=kg+ncontractions

      if(idiis.eq.1) then
                           if(kh.gt.nreal) stop 'calling diis'

                           call ddiis(81,iteration,ncontractions,
     &                                dmixing,diiserror,focka,fockb,
     &                                dmta,dmtb,wkvec(ka),wkvec(kb),
     &                                wkvec(kc),wkvec(kd),wkvec(ke),
     &                                wkvec(kf),wkvec(kg))
                     endif

      if(iteration.eq.1) tol=one
      if(iteration.gt.1) tol=dmaxpc**2

      dmaxpc=zero

      ka=1
      kb=ka+ncontractions**2
      kc=kb+ncontractions
      kd=kc+ncontractions
      ke=kd+ncontractions**2
      kf=ke+ncontractions**2
      kg=kf+ncontractions**2
      kh=kf+ncontractions
      ki=kf+ncontractions

      if(ki.gt.nreal) stop 'not enough memory for annihilation routine'

      rewind 51

      if(nalpha.eq.nbeta) then
                                call annihilate(nmaxorbs,ncontractions,
     &                                          nalpha,iwkvec,
     &                                          iwkvec(3*numprocs+1),
     &                                          dmaxpc,tol,dmta,focka,
     &                                          coeffa,wkvec(ka),
     &                                          wkvec(kb),wkvec(kc),
     &                                          wkvec(kd),wkvec(ke),
     &                                          wkvec(kf),wkvec(kg),
     &                                          wkvec(kh))

                                do 1002 i=1,ndim
 1002                           dmtb(i)=dmta(i)
                          else
                                call annihilate(nmaxorbs,ncontractions,
     &                                          nalpha,iwkvec,
     &                                          iwkvec(3*numprocs+1),
     &                                          dmaxpc,tol,dmta,focka,
     &                                          coeffa,wkvec(ka),
     &                                          wkvec(kb),wkvec(kc),
     &                                          wkvec(kd),wkvec(ke),
     &                                          wkvec(kf),wkvec(kg),
     &                                          wkvec(kh))

                                call annihilate(nmaxorbs,ncontractions,
     &                                          nbeta,iwkvec,
     &                                          iwkvec(3*numprocs+1),
     &                                          dmaxpc,tol,dmtb,fockb,
     &                                          coeffb,wkvec(ka),
     &                                          wkvec(kb),wkvec(kc),
     &                                          wkvec(kd),wkvec(ke),
     &                                          wkvec(kf),wkvec(kg),
     &                                          wkvec(kh))
                          endif

      ja=1
      jb=ja+ncontractions*ncontractions
      jc=jb+ncontractions*ncontractions
      jd=jc+ncontractions

      call totale(0,ncontractions,ncdfunc,iteration,nptcharges,natoms,
     &            nalpha,nbeta,ncdfunc,energy,diiserror,dmta,dmtb,focke,
     &            coord,charge,coordpc,ptcharge,wkvec,cdfitc,dmaxpc)

      if(nxcfunc.gt.0) then

            do 1003 i=1,ndim
 1003       wkvec(i)=dmta(i)+dmtb(i)

            call xvecmm(nreal-ndim,ninteger,nconts,ncontp,ncontd,nxcs,
     &                  nxcspd,nshels,nshelp,nsheld,mtloca,ilfunc,
     &                  ngaussians,icfunc,ixclfunc,ixccfunc,iwkvec,
     &                  cutoff(3),coord,alpha,coeffs,alphaxc,coefsxc,
     &                  coefpxc,coefdxc,wkvec(1),tveca,wkvec(ndim+1))

                       endif

      nnn=max(nxcfunc,ncontractions)

      ja=1
      jb=ja+3*nnn
      jc=jb+3*nnn
      jd=jc+nnn*nnn

      call gridcall(nreal-jd,nnn,1,iteration+1,nfunctional,natoms,
     &              nmaxatoms,nbsystems,nalpha,nbeta,nconts,ncontp,
     &              ncontd,nxcs,nxcs+nxcspd,nmaxpoints,natomtype,
     &              nptsatom,nshels,nshelp,nsheld,ilfunc,icfunc,
     &              ngaussians,ixclfunc,ixccfunc,isys,iwkvec,
     &              iwkvec(nnn+1),dmixing,cutoff(2),coord,alpha,coeffs,
     &              alphaxc,coefsxc,coefpxc,coefdxc,xcfita,xcfitb,
     &              xcfite,dmta,dmtb,tveca,tvecb,tvece,wkvec(ja),
     &              wkvec(jb),wkvec(jc),focka,fockb,focke,wkvec(jd))

      if(myid.eq.0) then
                          rewind 43
                          call fastrd(43,overlap,ndim)
                    endif

      call mpi_bcast(overlap,ndim,mpi_real8,0,mpi_comm_world,ierr)

      if(myid.eq.0) call cdpops(level,ncontractions,natoms,nmaxatoms,
     &                          nconts,ncontp,ncontd,nbsystems,nshels,
     &                          nshelp,nsheld,icfunc,nfuncatom,isys,
     &                          overlap,dmta,dmtb,wkvec(1),
     &                          wkvec(nbsystems+0*(ncontractions**2)+1),
     &                          wkvec(nbsystems+1*(ncontractions**2)+1),
     &                          wkvec(nbsystems+2*(ncontractions**2)+1),
     &                          wkvec(nbsystems+3*(ncontractions**2)+1))

      do 1004 i=1,ncdfunc
      storecd(i)=zero
 1004 cdstore(i)=cdfitc(i)

      ncds_save=ncds
      ncdspd_save=ncdspd

      do 1005 i=1,ncdfunc
 1005 icdlsave(i)=icdlfunc(i)

      if(myid.eq.0) rewind 18

      do 1006 i=1,nbsystems

      do 1007 j=1,ndim
 1007 wkvec(nbsystems+j)=dmta(j)+dmtb(j)

      do 1008 j=1,natoms
 1008 iwkvec(j)=0

      do 1009 j=1,natoms
      do 1009 k=1,isys(1,i)
 1009 if(dist(coord(1,j),coord(1,isys(k+1,i))).le.cutoff(1)) iwkvec(j)=1

      ncds=0

      do 1010 j=1,ncds_save
      if(iwkvec(icdcfunc(icdlsave(j))).eq.1) then

                             ncds=ncds+1
                             icdlfunc(ncds)=icdlsave(j)

                                             endif
 1010 continue

      ncdspd=0

      do 1011 j=1,ncdspd_save
      if(iwkvec(icdcfunc(icdlsave(ncds_save+j))).eq.1) then

                             ncdspd=ncdspd+1
                             icdlfunc(ncds+ncdspd)=icdlsave(ncds_save+j)

                                                       endif
 1011 continue

      do 1012 j=1,natoms
 1012 iwkvec(j)=0

      do 1013 k=1,level
      do 1013 j=1,isys(1,i)
 1013 if(myid.eq.0) iwkvec((k-1)*(natoms/level)+isys(j+1,i))=1

      call mpi_bcast(iwkvec,natoms,mpi_integer,0,mpi_comm_world,ierr)

      call cdftmm(nreal-nbsystems-ndim,ninteger,nconts,ncontp,ncontd,
     &            ncds,ncdspd,nshels,nshelp,nsheld,mtloca,ilfunc,
     &            ngaussians,icfunc,icdlfunc,icdcfunc,iwkvec,
     &            iwkvec(nmaxatoms+1),coord,alpha,coeffs,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,wkvec(nbsystems+1),
     &            wkvec(nbsystems+ndim+1))

      nsize=ncds+10*ncdspd

      if(myid.eq.0) call docdfit(nsize,ncds,ncdspd,icdlfunc,wkvec(i),
     &                           alphacd,coefscd,coefdcd,cdfitc,tvector,
     &                           wkvec(nbsystems+1),
     &                           wkvec(nbsystems+nsize*nsize+1))

      do 1014 j=1,ncdfunc
 1014 tvector(j)=cdfitc(j)

      do 1015 j=1,natoms
 1015 iwkvec(j)=0

      do 1016 j=1,natoms
      do 1016 k=1,isys(1,i)
 1016 if(dist(coord(1,j),coord(1,isys(k+1,i))).le.cutoff(1)) iwkvec(j)=1

      ncds=0

      do 1017 j=1,ncds_save
      if(iwkvec(icdcfunc(icdlsave(j))).eq.1) then

                                             ncds=ncds+1
                                             cdfitc(j)=tvector(ncds)

                                             else

                                             cdfitc(j)=zero

                                             endif
 1017 continue

      ncdspd=0

      do 1018 j=1,ncdspd_save
      if(iwkvec(icdcfunc(icdlsave(ncds_save+j))).eq.1) then

            ncdspd=ncdspd+1
            cdfitc(ncds_save+10*(j-1)+01)=tvector(ncds+10*(ncdspd-1)+01)
            cdfitc(ncds_save+10*(j-1)+02)=tvector(ncds+10*(ncdspd-1)+02)
            cdfitc(ncds_save+10*(j-1)+03)=tvector(ncds+10*(ncdspd-1)+03)
            cdfitc(ncds_save+10*(j-1)+04)=tvector(ncds+10*(ncdspd-1)+04)
            cdfitc(ncds_save+10*(j-1)+05)=tvector(ncds+10*(ncdspd-1)+05)
            cdfitc(ncds_save+10*(j-1)+06)=tvector(ncds+10*(ncdspd-1)+06)
            cdfitc(ncds_save+10*(j-1)+07)=tvector(ncds+10*(ncdspd-1)+07)
            cdfitc(ncds_save+10*(j-1)+08)=tvector(ncds+10*(ncdspd-1)+08)
            cdfitc(ncds_save+10*(j-1)+09)=tvector(ncds+10*(ncdspd-1)+09)
            cdfitc(ncds_save+10*(j-1)+10)=tvector(ncds+10*(ncdspd-1)+10)

                                                       else

            cdfitc(ncds_save+10*(j-1)+01)=zero
            cdfitc(ncds_save+10*(j-1)+02)=zero
            cdfitc(ncds_save+10*(j-1)+03)=zero
            cdfitc(ncds_save+10*(j-1)+04)=zero
            cdfitc(ncds_save+10*(j-1)+05)=zero
            cdfitc(ncds_save+10*(j-1)+06)=zero
            cdfitc(ncds_save+10*(j-1)+07)=zero
            cdfitc(ncds_save+10*(j-1)+08)=zero
            cdfitc(ncds_save+10*(j-1)+09)=zero
            cdfitc(ncds_save+10*(j-1)+10)=zero

                                             endif
 1018 continue

      do 1019 j=1,ncdfunc
 1019 storecd(j)=storecd(j)+cdfitc(j)

      ncds=ncds_save
      ncdspd=ncdspd_save

      do 1020 j=1,ncdfunc
 1020 icdlfunc(j)=icdlsave(j)

 1006 continue

      do 1021 i=1,ncdfunc
 1021 cdfitc(i)=dmixing*storecd(i)+(one-dmixing)*cdstore(i)

      return
      end

      subroutine orbitals(n,ndim,nmos,nconts,ncontp,ncontd,ilfunc,
     &                    icfunc,ngauss,nptrs,nptrp,nptrd,nfuncatom,
     &                    coord,alpha,coeff,overlap,coeffmo,smat,
     &                    centroid,extent,exvec)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),
     &          nptrs(*),nptrp(*),nptrd(*),nfuncatom(*)

      dimension coord(3,*),alpha(*),coeff(*),overlap(*),coeffmo(ndim,*),
     &          smat(n,*),centroid(3,*),extent(*),exvec(*)

      data zero,one,bohr/0.0d0,1.0d0,0.529177d0/
      data cutoff,tolerance/9999.0d0,0.0000000000000001d0/

      call diffuse2(nconts,ncontp,ncontd,ilfunc,icfunc,ngauss,nptrs,
     &              nptrp,nptrd,tolerance,alpha,coeff,coord,extent)

      do 1001 i=1,nconts
 1001 exvec(i)=extent(i)

      do 1002 i=1,ncontp
      exvec(nconts+3*(i-1)+1)=extent(nconts+i)
      exvec(nconts+3*(i-1)+2)=extent(nconts+i)
 1002 exvec(nconts+3*(i-1)+3)=extent(nconts+i)

      do 1003 i=1,ncontd
      exvec(nconts+3*ncontp+6*(i-1)+1)=extent(nconts+ncontp+i)
      exvec(nconts+3*ncontp+6*(i-1)+2)=extent(nconts+ncontp+i)
      exvec(nconts+3*ncontp+6*(i-1)+3)=extent(nconts+ncontp+i)
      exvec(nconts+3*ncontp+6*(i-1)+4)=extent(nconts+ncontp+i)
      exvec(nconts+3*ncontp+6*(i-1)+5)=extent(nconts+ncontp+i)
 1003 exvec(nconts+3*ncontp+6*(i-1)+6)=extent(nconts+ncontp+i)

      ij=0

      do 1004 i=1,n
      do 1004 j=1,i
      ij=ij+1
      smat(i,j)=overlap(ij)
 1004 smat(j,i)=overlap(ij)

      do 1005 j=1,nmos
      do 1005 i=1,n
      distance=dist(coord(1,nfuncatom(i)),centroid(1,j))
 1005 if((distance.gt.exvec(i)).and.
     &   (distance.gt.(cutoff/bohr))) coeffmo(i,j)=zero

      do 1006 k=1,nmos

      svalue=zero

      do 1007 j=1,n
      do 1007 i=1,n
 1007 svalue=svalue+coeffmo(i,k)*coeffmo(j,k)*smat(i,j)

      factor=one/sqrt(svalue)

      do 1008 i=1,n
 1008 coeffmo(i,k)=coeffmo(i,k)*factor

 1006 continue

      return
      end

      subroutine unitvec(a,b,c)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension a(*),b(*),c(*)

      r=dist(b,c)

      do 1001 i=1,3
 1001 a(i)=(c(i)-b(i))/r

      return
      end

      subroutine totale(nflag,ncntrt,ncd,iter,nbpc,ncentr,nalpha,nbeta,
     &                  ndim,energy,diisv,dmta,dmtb,fock,coord,charge,
     &                  coordpc,pcharge,overcd,cdcoef,dmaxdm)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension dmta(*),dmtb(*),fock(*)
      dimension coord(3,*),charge(*),coordpc(3,*),pcharge(*)
      dimension overcd(ndim,*),cdcoef(*)

      data zero,half,one,two/0.0d0,0.5d0,1.0d0,2.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      esave=energy

      energy=zero

      do 1001 i=1,ncntrt*(ncntrt+1)/2
 1001 energy=energy+(dmta(i)+dmtb(i))*fock(i)

      rewind 17

      do 1002 i=1,ncd
 1002 if(myid.eq.0) call fastrd(17,overcd(1,i),ncd)

      do 1003 i=1,ncd
      do 1003 j=1,ncd
 1003 energy=energy-half*cdcoef(i)*cdcoef(j)*overcd(j,i)

      do 1004 i=1,ncentr
      do 1004 j=1,i

      rrij=dist(coord(1,i),coord(1,j))

      if(rrij.eq.zero) goto 1004

      energy=energy+charge(i)*charge(j)/rrij

 1004 continue

      if(nbpc.ne.0) then
                          do 1005 i=1,nbpc

                          do 1006 j=1,ncentr
                          if(charge(j).eq.zero) goto 1006
                          rrij=dist(coord(1,j),coordpc(1,i))
                          energy=energy+charge(j)*pcharge(i)/rrij
 1006                     continue

                          do 1005 j=1,i

                          if(i.eq.j) goto 1005

                          rrij=dist(coordpc(1,j),coordpc(1,i))
                          energy=energy+pcharge(j)*pcharge(i)/rrij

 1005                     continue
                    endif

      if(nflag.eq.1) then
                           if(myid.eq.0) write(6,1007) energy 
                           return
                     endif 

 1007 format(/,' - xc terms numerically integrated',/,
     &         ' - gradient corrections perturbatively added',
     &         ' (if requested)',//,
     &         '           gives :         total energy =',f21.9,//)

      if(myid.eq.0) write(6,1008) iter,energy,
     &                            abs(energy-esave),dmaxdm
 1008 format(/,' cycle #',i4,', energy = ',f20.9,4x,
     &         ' |delta E|      = ',e14.7,/,47x,
     &         ' max |delta P|  = ',e14.7)

      if(myid.eq.0) call flush(6)

      return
      end

      subroutine gradxxdp3(m,n,nn,nc,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,ttwozetab,
     &                     dss0,dsp0,dsd0,fss0,fsp0,fsd0,gss0,gsp0,gsd0,
     &                     axbx,ayby,azbz,dsscond,dspcond,dsdcond,
     &                     fsscond,fspcond,fsdcond,gsscond,gspcond,
     &                     gsdcond,dpscond,dppcond,dpdcond,fpscond,
     &                     fppcond,fpdcond,ddscond,ddpcond,dddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),
     &          ttwozetab(*),dss0(n,*),dsp0(n,*),dsd0(n,*),fss0(n,*),
     &          fsp0(n,*),fsd0(n,*),gss0(n,*),gsp0(n,*),gsd0(n,*),
     &          axbx(*),ayby(*),azbz(*),dsscond(m,*),dspcond(m,*),
     &          dsdcond(m,*),fsscond(m,*),fspcond(m,*),fsdcond(m,*),
     &          gsscond(m,*),gspcond(m,*),gsdcond(m,*),dpscond(m,*),
     &          dppcond(m,*),dpdcond(m,*),fpscond(m,*),fppcond(m,*),
     &          fpdcond(m,*),ddscond(m,*),ddpcond(m,*),dddcond(m,*),
     &          grad(m,*)

      data zero/0.0d0/

      do 1001 j=1,6
      do 1001 i=1,m
 1001 dsscond(i,j)=zero

      do 1002 j=1,10
      do 1002 i=1,m
 1002 fsscond(i,j)=zero

      do 1003 j=1,15
      do 1003 i=1,m
 1003 gsscond(i,j)=zero

      do 1004 j=1,6
      do 1004 i=1,nn
 1004 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dss0(i,j)*ttwozetab(i)*cdfits

      do 1005 k=1,3
      do 1005 j=1,6
      do 1005 i=1,nn
 1005 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1006 k=1,6
      do 1006 j=1,6
      do 1006 i=1,nn
 1006 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1007 j=1,10
      do 1007 i=1,nn
 1007 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fss0(i,j)*ttwozetab(i)*cdfits

      do 1008 k=1,3
      do 1008 j=1,10
      do 1008 i=1,nn
 1008 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1009 k=1,6
      do 1009 j=1,10
      do 1009 i=1,nn
 1009 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1010 j=1,15
      do 1010 i=1,nn
 1010 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gss0(i,j)*ttwozetab(i)*cdfits

      do 1011 k=1,3
      do 1011 j=1,15
      do 1011 i=1,nn
 1011 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1012 k=1,6
      do 1012 j=1,15
      do 1012 i=1,nn
 1012 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1013 i=1,m
      dpscond(i,01)=axbx(i)*dsscond(i,1)+fsscond(i,01)
      dpscond(i,02)=ayby(i)*dsscond(i,1)+fsscond(i,02)
      dpscond(i,03)=azbz(i)*dsscond(i,1)+fsscond(i,03)
      dpscond(i,04)=axbx(i)*dsscond(i,2)+fsscond(i,02)
      dpscond(i,05)=ayby(i)*dsscond(i,2)+fsscond(i,04)
      dpscond(i,06)=azbz(i)*dsscond(i,2)+fsscond(i,05)
      dpscond(i,07)=axbx(i)*dsscond(i,3)+fsscond(i,03)
      dpscond(i,08)=ayby(i)*dsscond(i,3)+fsscond(i,05)
      dpscond(i,09)=azbz(i)*dsscond(i,3)+fsscond(i,06)
      dpscond(i,10)=axbx(i)*dsscond(i,4)+fsscond(i,04)
      dpscond(i,11)=ayby(i)*dsscond(i,4)+fsscond(i,07)
      dpscond(i,12)=azbz(i)*dsscond(i,4)+fsscond(i,08)
      dpscond(i,13)=axbx(i)*dsscond(i,5)+fsscond(i,05)
      dpscond(i,14)=ayby(i)*dsscond(i,5)+fsscond(i,08)
      dpscond(i,15)=azbz(i)*dsscond(i,5)+fsscond(i,09)
      dpscond(i,16)=axbx(i)*dsscond(i,6)+fsscond(i,06)
      dpscond(i,17)=ayby(i)*dsscond(i,6)+fsscond(i,09)
 1013 dpscond(i,18)=azbz(i)*dsscond(i,6)+fsscond(i,10)

      do 1014 i=1,m
      fpscond(i,01)=axbx(i)*fsscond(i,01)+gsscond(i,01)
      fpscond(i,02)=ayby(i)*fsscond(i,01)+gsscond(i,02)
      fpscond(i,03)=azbz(i)*fsscond(i,01)+gsscond(i,03)
      fpscond(i,04)=axbx(i)*fsscond(i,02)+gsscond(i,02)
      fpscond(i,05)=ayby(i)*fsscond(i,02)+gsscond(i,04)
      fpscond(i,06)=azbz(i)*fsscond(i,02)+gsscond(i,05)
      fpscond(i,07)=axbx(i)*fsscond(i,03)+gsscond(i,03)
      fpscond(i,08)=ayby(i)*fsscond(i,03)+gsscond(i,05)
      fpscond(i,09)=azbz(i)*fsscond(i,03)+gsscond(i,06)
      fpscond(i,10)=axbx(i)*fsscond(i,04)+gsscond(i,04)
      fpscond(i,11)=ayby(i)*fsscond(i,04)+gsscond(i,07)
      fpscond(i,12)=azbz(i)*fsscond(i,04)+gsscond(i,08)
      fpscond(i,13)=axbx(i)*fsscond(i,05)+gsscond(i,05)
      fpscond(i,14)=ayby(i)*fsscond(i,05)+gsscond(i,08)
      fpscond(i,15)=azbz(i)*fsscond(i,05)+gsscond(i,09)
      fpscond(i,16)=axbx(i)*fsscond(i,06)+gsscond(i,06)
      fpscond(i,17)=ayby(i)*fsscond(i,06)+gsscond(i,09)
      fpscond(i,18)=azbz(i)*fsscond(i,06)+gsscond(i,10)
      fpscond(i,19)=axbx(i)*fsscond(i,07)+gsscond(i,07)
      fpscond(i,20)=ayby(i)*fsscond(i,07)+gsscond(i,11)
      fpscond(i,21)=azbz(i)*fsscond(i,07)+gsscond(i,12)
      fpscond(i,22)=axbx(i)*fsscond(i,08)+gsscond(i,08)
      fpscond(i,23)=ayby(i)*fsscond(i,08)+gsscond(i,12)
      fpscond(i,24)=azbz(i)*fsscond(i,08)+gsscond(i,13)
      fpscond(i,25)=axbx(i)*fsscond(i,09)+gsscond(i,09)
      fpscond(i,26)=ayby(i)*fsscond(i,09)+gsscond(i,13)
      fpscond(i,27)=azbz(i)*fsscond(i,09)+gsscond(i,14)
      fpscond(i,28)=axbx(i)*fsscond(i,10)+gsscond(i,10)
      fpscond(i,29)=ayby(i)*fsscond(i,10)+gsscond(i,14)
 1014 fpscond(i,30)=azbz(i)*fsscond(i,10)+gsscond(i,15)

      do 1015 i=1,m
      ddscond(i,01)=axbx(i)*dpscond(i,01)+fpscond(i,01)
      ddscond(i,02)=ayby(i)*dpscond(i,01)+fpscond(i,04)
      ddscond(i,03)=azbz(i)*dpscond(i,01)+fpscond(i,07)
      ddscond(i,04)=ayby(i)*dpscond(i,02)+fpscond(i,05)
      ddscond(i,05)=azbz(i)*dpscond(i,02)+fpscond(i,08)
      ddscond(i,06)=azbz(i)*dpscond(i,03)+fpscond(i,09)
      ddscond(i,07)=axbx(i)*dpscond(i,04)+fpscond(i,04)
      ddscond(i,08)=ayby(i)*dpscond(i,04)+fpscond(i,10)
      ddscond(i,09)=azbz(i)*dpscond(i,04)+fpscond(i,13)
      ddscond(i,10)=ayby(i)*dpscond(i,05)+fpscond(i,11)
      ddscond(i,11)=azbz(i)*dpscond(i,05)+fpscond(i,14)
      ddscond(i,12)=azbz(i)*dpscond(i,06)+fpscond(i,15)
      ddscond(i,13)=axbx(i)*dpscond(i,07)+fpscond(i,07)
      ddscond(i,14)=ayby(i)*dpscond(i,07)+fpscond(i,13)
      ddscond(i,15)=azbz(i)*dpscond(i,07)+fpscond(i,16)
      ddscond(i,16)=ayby(i)*dpscond(i,08)+fpscond(i,14)
      ddscond(i,17)=azbz(i)*dpscond(i,08)+fpscond(i,17)
      ddscond(i,18)=azbz(i)*dpscond(i,09)+fpscond(i,18)
      ddscond(i,19)=axbx(i)*dpscond(i,10)+fpscond(i,10)
      ddscond(i,20)=ayby(i)*dpscond(i,10)+fpscond(i,19)
      ddscond(i,21)=azbz(i)*dpscond(i,10)+fpscond(i,22)
      ddscond(i,22)=ayby(i)*dpscond(i,11)+fpscond(i,20)
      ddscond(i,23)=azbz(i)*dpscond(i,11)+fpscond(i,23)
      ddscond(i,24)=azbz(i)*dpscond(i,12)+fpscond(i,24)
      ddscond(i,25)=axbx(i)*dpscond(i,13)+fpscond(i,13)
      ddscond(i,26)=ayby(i)*dpscond(i,13)+fpscond(i,22)
      ddscond(i,27)=azbz(i)*dpscond(i,13)+fpscond(i,25)
      ddscond(i,28)=ayby(i)*dpscond(i,14)+fpscond(i,23)
      ddscond(i,29)=azbz(i)*dpscond(i,14)+fpscond(i,26)
      ddscond(i,30)=azbz(i)*dpscond(i,15)+fpscond(i,27)
      ddscond(i,31)=axbx(i)*dpscond(i,16)+fpscond(i,16)
      ddscond(i,32)=ayby(i)*dpscond(i,16)+fpscond(i,25)
      ddscond(i,33)=azbz(i)*dpscond(i,16)+fpscond(i,28)
      ddscond(i,34)=ayby(i)*dpscond(i,17)+fpscond(i,26)
      ddscond(i,35)=azbz(i)*dpscond(i,17)+fpscond(i,29)
 1015 ddscond(i,36)=azbz(i)*dpscond(i,18)+fpscond(i,30)

      do 1016 i=1,m
      grad(i,01)=ddscond(i,01)*density(inddyy(i,01))
      grad(i,02)=ddscond(i,02)*density(inddyy(i,02))
      grad(i,03)=ddscond(i,03)*density(inddyy(i,03))
      grad(i,04)=ddscond(i,07)*density(inddyy(i,04))
      grad(i,05)=ddscond(i,08)*density(inddyy(i,05))
      grad(i,06)=ddscond(i,09)*density(inddyy(i,06))
      grad(i,07)=ddscond(i,13)*density(inddyy(i,07))
      grad(i,08)=ddscond(i,14)*density(inddyy(i,08))
      grad(i,09)=ddscond(i,15)*density(inddyy(i,09))
      grad(i,10)=ddscond(i,19)*density(inddyy(i,10))
      grad(i,11)=ddscond(i,20)*density(inddyy(i,11))
      grad(i,12)=ddscond(i,21)*density(inddyy(i,12))
      grad(i,13)=ddscond(i,25)*density(inddyy(i,13))
      grad(i,14)=ddscond(i,26)*density(inddyy(i,14))
      grad(i,15)=ddscond(i,27)*density(inddyy(i,15))
      grad(i,16)=ddscond(i,31)*density(inddyy(i,16))
      grad(i,17)=ddscond(i,32)*density(inddyy(i,17))
      grad(i,18)=ddscond(i,33)*density(inddyy(i,18))
      grad(i,19)=ddscond(i,02)*density(inddyy(i,01))
      grad(i,20)=ddscond(i,04)*density(inddyy(i,02))
      grad(i,21)=ddscond(i,05)*density(inddyy(i,03))
      grad(i,22)=ddscond(i,08)*density(inddyy(i,04))
      grad(i,23)=ddscond(i,10)*density(inddyy(i,05))
      grad(i,24)=ddscond(i,11)*density(inddyy(i,06))
      grad(i,25)=ddscond(i,14)*density(inddyy(i,07))
      grad(i,26)=ddscond(i,16)*density(inddyy(i,08))
      grad(i,27)=ddscond(i,17)*density(inddyy(i,09))
      grad(i,28)=ddscond(i,20)*density(inddyy(i,10))
      grad(i,29)=ddscond(i,22)*density(inddyy(i,11))
      grad(i,30)=ddscond(i,23)*density(inddyy(i,12))
      grad(i,31)=ddscond(i,26)*density(inddyy(i,13))
      grad(i,32)=ddscond(i,28)*density(inddyy(i,14))
      grad(i,33)=ddscond(i,29)*density(inddyy(i,15))
      grad(i,34)=ddscond(i,32)*density(inddyy(i,16))
      grad(i,35)=ddscond(i,34)*density(inddyy(i,17))
      grad(i,36)=ddscond(i,35)*density(inddyy(i,18))
      grad(i,37)=ddscond(i,03)*density(inddyy(i,01))
      grad(i,38)=ddscond(i,05)*density(inddyy(i,02))
      grad(i,39)=ddscond(i,06)*density(inddyy(i,03))
      grad(i,40)=ddscond(i,09)*density(inddyy(i,04))
      grad(i,41)=ddscond(i,11)*density(inddyy(i,05))
      grad(i,42)=ddscond(i,12)*density(inddyy(i,06))
      grad(i,43)=ddscond(i,15)*density(inddyy(i,07))
      grad(i,44)=ddscond(i,17)*density(inddyy(i,08))
      grad(i,45)=ddscond(i,18)*density(inddyy(i,09))
      grad(i,46)=ddscond(i,21)*density(inddyy(i,10))
      grad(i,47)=ddscond(i,23)*density(inddyy(i,11))
      grad(i,48)=ddscond(i,24)*density(inddyy(i,12))
      grad(i,49)=ddscond(i,27)*density(inddyy(i,13))
      grad(i,50)=ddscond(i,29)*density(inddyy(i,14))
      grad(i,51)=ddscond(i,30)*density(inddyy(i,15))
      grad(i,52)=ddscond(i,33)*density(inddyy(i,16))
      grad(i,53)=ddscond(i,35)*density(inddyy(i,17))
 1016 grad(i,54)=ddscond(i,36)*density(inddyy(i,18))

      do 1017 k=1,3
      do 1017 j=1,18
      do 1017 i=1,m
 1017 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1018 k=1,3
      do 1018 j=1,18
      do 1018 i=1,m
 1018 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

      return
      end

      subroutine compg2(iatom,ncntrt,npts,nd,natoms,nconts,ncontp,
     &                  ncontd,ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,
     &                  radius,cent,alpha,coeff,x,y,z,qf,qx,qy,qz,q1,q2,
     &                  q3,q4,q5,q6,extent1,extent3,dcc,xx,yy,zz,rr,
     &                  rralpha,s,px,py,pz,dxx,dxy,dxz,dyy,dyz,dzz,fxxx,
     &                  fxxy,fxxz,fxyy,fxyz,fxzz,fyyy,fyyz,fyzz,fzzz,
     &                  gxxxx,gxxxy,gxxxz,gxxyy,gxxyz,gxxzz,gxyyy,gxyyz,
     &                  gxyzz,gxzzz,gyyyy,gyyyz,gyyzz,gyzzz,gzzzz)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)

      dimension cent(3,*),alpha(*),coeff(*)

      dimension x(*),y(*),z(*),qf(nd,*),qx(nd,*),qy(nd,*),qz(nd,*)
      dimension q1(nd,*),q2(nd,*),q3(nd,*),q4(nd,*),q5(nd,*),q6(nd,*)

      dimension extent1(*),extent3(*),dcc(natoms,*)
      dimension xx(*),yy(*),zz(*),rr(*),rralpha(*)
      dimension s(*),px(*),py(*),pz(*)
      dimension dxx(*),dxy(*),dxz(*),dyy(*),dyz(*),dzz(*)
      dimension fxxx(*),fxxy(*),fxxz(*),fxyy(*),fxyz(*),
     &          fxzz(*),fyyy(*),fyyz(*),fyzz(*),fzzz(*)
      dimension gxxxx(*),gxxxy(*),gxxxz(*),gxxyy(*),gxxyz(*),
     &          gxxzz(*),gxyyy(*),gxyyz(*),gxyzz(*),gxzzz(*),
     &          gyyyy(*),gyyyz(*),gyyzz(*),gyzzz(*),gzzzz(*)

      data zero,one,two,three,five,expcut/0.0d0,1.0d0,2.0d0,
     &                                    3.0d0,5.0d0,50.0d0/

      rsqrt3=one/sqrt(three)

      do 1001 i=1,ncntrt
 1001 extent3(i)=zero

      k=0

      if(nconts.eq.0) return

      do 1002 i=1,nconts

      ilabel=nptrs(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(i)) goto 1002

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1003 j=1,npts
      qf(j,k+1)=zero
      qx(j,k+1)=zero
      qy(j,k+1)=zero
      qz(j,k+1)=zero
      q1(j,k+1)=zero
      q2(j,k+1)=zero
      q3(j,k+1)=zero
      q4(j,k+1)=zero
      q5(j,k+1)=zero
 1003 q6(j,k+1)=zero

      do 1004 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1004 zz(j)=z(j)-cent(3,nc)

      do 1005 j=1,npts
 1005 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1006 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1007 j=1,npts
 1007 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1008 j=1,npts
      if(rralpha(j).lt.expcut) then

                       s(j)=coeff(nprimitive)*exp(-rralpha(j))

                       qf(j,k+1)=qf(j,k+1)+s(j)

                       s(j)=s(j)*twozeta

                       px(j)=xx(j)*s(j)
                       py(j)=yy(j)*s(j)
                       pz(j)=zz(j)*s(j)

                       qx(j,k+1)=qx(j,k+1)-px(j)
                       qy(j,k+1)=qy(j,k+1)-py(j)
                       qz(j,k+1)=qz(j,k+1)-pz(j)

                       px(j)=px(j)*twozeta
                       py(j)=py(j)*twozeta
                       pz(j)=pz(j)*twozeta

                       q1(j,k+1)=q1(j,k+1)+xx(j)*px(j)-s(j)
                       q2(j,k+1)=q2(j,k+1)+xx(j)*py(j)
                       q3(j,k+1)=q3(j,k+1)+xx(j)*pz(j)
                       q4(j,k+1)=q4(j,k+1)+yy(j)*py(j)-s(j)
                       q5(j,k+1)=q5(j,k+1)+yy(j)*pz(j)
                       q6(j,k+1)=q6(j,k+1)+zz(j)*pz(j)-s(j)

                               endif
 1008 continue

 1006 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)

 1002 k=k+1

      if(ncontp.eq.0) return

      do 1009 i=1,ncontp

      ilabel=nptrp(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(nconts+i)) goto 1009

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1010 j=1,npts
      qf(j,k+1)=zero
      qx(j,k+1)=zero
      qy(j,k+1)=zero
      qz(j,k+1)=zero
      q1(j,k+1)=zero
      q2(j,k+1)=zero
      q3(j,k+1)=zero
      q4(j,k+1)=zero
      q5(j,k+1)=zero
      q6(j,k+1)=zero
      qf(j,k+2)=zero
      qx(j,k+2)=zero
      qy(j,k+2)=zero
      qz(j,k+2)=zero
      q1(j,k+2)=zero
      q2(j,k+2)=zero
      q3(j,k+2)=zero
      q4(j,k+2)=zero
      q5(j,k+2)=zero
      q6(j,k+2)=zero
      qf(j,k+3)=zero
      qx(j,k+3)=zero
      qy(j,k+3)=zero
      qz(j,k+3)=zero
      q1(j,k+3)=zero
      q2(j,k+3)=zero
      q3(j,k+3)=zero
      q4(j,k+3)=zero
      q5(j,k+3)=zero
 1010 q6(j,k+3)=zero

      do 1011 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1011 zz(j)=z(j)-cent(3,nc)

      do 1012 j=1,npts
 1012 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1013 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1014 j=1,npts
 1014 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1015 j=1,npts
      if(rralpha(j).lt.expcut) then

                       s(j)=coeff(nprimitive)*exp(-rralpha(j))

                       px(j)=xx(j)*s(j)
                       py(j)=yy(j)*s(j)
                       pz(j)=zz(j)*s(j)

                       qf(j,k+1)=qf(j,k+1)+px(j)
                       qf(j,k+2)=qf(j,k+2)+py(j)
                       qf(j,k+3)=qf(j,k+3)+pz(j)

                       px(j)=px(j)*twozeta
                       py(j)=py(j)*twozeta
                       pz(j)=pz(j)*twozeta

                       dxx(j)=xx(j)*px(j)
                       dxy(j)=xx(j)*py(j)
                       dxz(j)=xx(j)*pz(j)
                       dyy(j)=yy(j)*py(j)
                       dyz(j)=yy(j)*pz(j)
                       dzz(j)=zz(j)*pz(j)

                       qx(j,k+1)=qx(j,k+1)-dxx(j)+s(j)
                       qy(j,k+1)=qy(j,k+1)-dxy(j)
                       qz(j,k+1)=qz(j,k+1)-dxz(j)

                       qx(j,k+2)=qx(j,k+2)-dxy(j)
                       qy(j,k+2)=qy(j,k+2)-dyy(j)+s(j)
                       qz(j,k+2)=qz(j,k+2)-dyz(j)

                       qx(j,k+3)=qx(j,k+3)-dxz(j)
                       qy(j,k+3)=qy(j,k+3)-dyz(j)
                       qz(j,k+3)=qz(j,k+3)-dzz(j)+s(j)

                       dxx(j)=dxx(j)*twozeta
                       dxy(j)=dxy(j)*twozeta
                       dxz(j)=dxz(j)*twozeta
                       dyy(j)=dyy(j)*twozeta
                       dyz(j)=dyz(j)*twozeta
                       dzz(j)=dzz(j)*twozeta

                       fxxx(j)=xx(j)*dxx(j)
                       fxxy(j)=xx(j)*dxy(j)
                       fxxz(j)=xx(j)*dxz(j)
                       fxyy(j)=xx(j)*dyy(j)
                       fxyz(j)=xx(j)*dyz(j)
                       fxzz(j)=xx(j)*dzz(j)
                       fyyy(j)=yy(j)*dyy(j)
                       fyyz(j)=yy(j)*dyz(j)
                       fyzz(j)=yy(j)*dzz(j)
                       fzzz(j)=zz(j)*dzz(j)

                       q1(j,k+1)=q1(j,k+1)+fxxx(j)-px(j)-px(j)-px(j)
                       q2(j,k+1)=q2(j,k+1)+fxxy(j)-py(j)
                       q3(j,k+1)=q3(j,k+1)+fxxz(j)-pz(j)
                       q4(j,k+1)=q4(j,k+1)+fxyy(j)-px(j)
                       q5(j,k+1)=q5(j,k+1)+fxyz(j)
                       q6(j,k+1)=q6(j,k+1)+fxzz(j)-px(j)

                       q1(j,k+2)=q1(j,k+2)+fxxy(j)-py(j)
                       q2(j,k+2)=q2(j,k+2)+fxyy(j)-px(j)
                       q3(j,k+2)=q3(j,k+2)+fxyz(j)
                       q4(j,k+2)=q4(j,k+2)+fyyy(j)-py(j)-py(j)-py(j)
                       q5(j,k+2)=q5(j,k+2)+fyyz(j)-pz(j)
                       q6(j,k+2)=q6(j,k+2)+fyzz(j)-py(j)

                       q1(j,k+3)=q1(j,k+3)+fxxz(j)-pz(j)
                       q2(j,k+3)=q2(j,k+3)+fxyz(j)
                       q3(j,k+3)=q3(j,k+3)+fxzz(j)-px(j)
                       q4(j,k+3)=q4(j,k+3)+fyyz(j)-pz(j)
                       q5(j,k+3)=q5(j,k+3)+fyzz(j)-py(j)
                       q6(j,k+3)=q6(j,k+3)+fzzz(j)-pz(j)-pz(j)-pz(j)

                               endif
 1015 continue

 1013 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,qf(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,qf(1,k+3))/real64(npts)

 1009 k=k+3

      if(ncontd.eq.0) return

      do 1016 i=1,ncontd

      ilabel=nptrd(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(nconts+ncontp+i)) goto 1016

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1017 j=1,npts
      qf(j,k+1)=zero
      qx(j,k+1)=zero
      qy(j,k+1)=zero
      qz(j,k+1)=zero
      q1(j,k+1)=zero
      q2(j,k+1)=zero
      q3(j,k+1)=zero
      q4(j,k+1)=zero
      q5(j,k+1)=zero
      q6(j,k+1)=zero
      qf(j,k+2)=zero
      qx(j,k+2)=zero
      qy(j,k+2)=zero
      qz(j,k+2)=zero
      q1(j,k+2)=zero
      q2(j,k+2)=zero
      q3(j,k+2)=zero
      q4(j,k+2)=zero
      q5(j,k+2)=zero
      q6(j,k+2)=zero
      qf(j,k+3)=zero
      qx(j,k+3)=zero
      qy(j,k+3)=zero
      qz(j,k+3)=zero
      q1(j,k+3)=zero
      q2(j,k+3)=zero
      q3(j,k+3)=zero
      q4(j,k+3)=zero
      q5(j,k+3)=zero
      q6(j,k+3)=zero
      qf(j,k+4)=zero
      qx(j,k+4)=zero
      qy(j,k+4)=zero
      qz(j,k+4)=zero
      q1(j,k+4)=zero
      q2(j,k+4)=zero
      q3(j,k+4)=zero
      q4(j,k+4)=zero
      q5(j,k+4)=zero
      q6(j,k+4)=zero
      qf(j,k+5)=zero
      qx(j,k+5)=zero
      qy(j,k+5)=zero
      qz(j,k+5)=zero
      q1(j,k+5)=zero
      q2(j,k+5)=zero
      q3(j,k+5)=zero
      q4(j,k+5)=zero
      q5(j,k+5)=zero
      q6(j,k+5)=zero
      qf(j,k+6)=zero
      qx(j,k+6)=zero
      qy(j,k+6)=zero
      qz(j,k+6)=zero
      q1(j,k+6)=zero
      q2(j,k+6)=zero
      q3(j,k+6)=zero
      q4(j,k+6)=zero
      q5(j,k+6)=zero
 1017 q6(j,k+6)=zero

      do 1018 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1018 zz(j)=z(j)-cent(3,nc)

      do 1019 j=1,npts
 1019 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1020 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1021 j=1,npts
 1021 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1022 j=1,npts
      if(rralpha(j).lt.expcut) then

            s(j)=coeff(nprimitive)*exp(-rralpha(j))

            px(j)=xx(j)*s(j)
            py(j)=yy(j)*s(j)
            pz(j)=zz(j)*s(j)

            dxx(j)=xx(j)*px(j)
            dxy(j)=xx(j)*py(j)
            dxz(j)=xx(j)*pz(j)
            dyy(j)=yy(j)*py(j)
            dyz(j)=yy(j)*pz(j)
            dzz(j)=zz(j)*pz(j)

            qf(j,k+1)=qf(j,k+1)+dxx(j)
            qf(j,k+2)=qf(j,k+2)+dxy(j)
            qf(j,k+3)=qf(j,k+3)+dxz(j)
            qf(j,k+4)=qf(j,k+4)+dyy(j)
            qf(j,k+5)=qf(j,k+5)+dyz(j)
            qf(j,k+6)=qf(j,k+6)+dzz(j)

            dxx(j)=dxx(j)*twozeta
            dxy(j)=dxy(j)*twozeta
            dxz(j)=dxz(j)*twozeta
            dyy(j)=dyy(j)*twozeta
            dyz(j)=dyz(j)*twozeta
            dzz(j)=dzz(j)*twozeta

            fxxx(j)=xx(j)*dxx(j)
            fxxy(j)=xx(j)*dxy(j)
            fxxz(j)=xx(j)*dxz(j)
            fxyy(j)=xx(j)*dyy(j)
            fxyz(j)=xx(j)*dyz(j)
            fxzz(j)=xx(j)*dzz(j)
            fyyy(j)=yy(j)*dyy(j)
            fyyz(j)=yy(j)*dyz(j)
            fyzz(j)=yy(j)*dzz(j)
            fzzz(j)=zz(j)*dzz(j)

            qx(j,k+1)=qx(j,k+1)-fxxx(j)+px(j)+px(j)
            qy(j,k+1)=qy(j,k+1)-fxxy(j)
            qz(j,k+1)=qz(j,k+1)-fxxz(j)

            qx(j,k+2)=qx(j,k+2)-fxxy(j)+py(j)
            qy(j,k+2)=qy(j,k+2)-fxyy(j)+px(j)
            qz(j,k+2)=qz(j,k+2)-fxyz(j)

            qx(j,k+3)=qx(j,k+3)-fxxz(j)+pz(j)
            qy(j,k+3)=qy(j,k+3)-fxyz(j)
            qz(j,k+3)=qz(j,k+3)-fxzz(j)+px(j)

            qx(j,k+4)=qx(j,k+4)-fxyy(j)
            qy(j,k+4)=qy(j,k+4)-fyyy(j)+py(j)+py(j)
            qz(j,k+4)=qz(j,k+4)-fyyz(j)

            qx(j,k+5)=qx(j,k+5)-fxyz(j)
            qy(j,k+5)=qy(j,k+5)-fyyz(j)+pz(j)
            qz(j,k+5)=qz(j,k+5)-fyzz(j)+py(j)

            qx(j,k+6)=qx(j,k+6)-fxzz(j)
            qy(j,k+6)=qy(j,k+6)-fyzz(j)
            qz(j,k+6)=qz(j,k+6)-fzzz(j)+pz(j)+pz(j)

            fxxx(j)=fxxx(j)*twozeta
            fxxy(j)=fxxy(j)*twozeta
            fxxz(j)=fxxz(j)*twozeta
            fxyy(j)=fxyy(j)*twozeta
            fxyz(j)=fxyz(j)*twozeta
            fxzz(j)=fxzz(j)*twozeta
            fyyy(j)=fyyy(j)*twozeta
            fyyz(j)=fyyz(j)*twozeta
            fyzz(j)=fyzz(j)*twozeta
            fzzz(j)=fzzz(j)*twozeta

            gxxxx(j)=xx(j)*fxxx(j)
            gxxxy(j)=xx(j)*fxxy(j)
            gxxxz(j)=xx(j)*fxxz(j)
            gxxyy(j)=xx(j)*fxyy(j)
            gxxyz(j)=xx(j)*fxyz(j)
            gxxzz(j)=xx(j)*fxzz(j)
            gxyyy(j)=xx(j)*fyyy(j)
            gxyyz(j)=xx(j)*fyyz(j)
            gxyzz(j)=xx(j)*fyzz(j)
            gxzzz(j)=xx(j)*fzzz(j)
            gyyyy(j)=yy(j)*fyyy(j)
            gyyyz(j)=yy(j)*fyyz(j)
            gyyzz(j)=yy(j)*fyzz(j)
            gyzzz(j)=yy(j)*fzzz(j)
            gzzzz(j)=zz(j)*fzzz(j)

            q1(j,k+1)=q1(j,k+1)+gxxxx(j)+s(j)+s(j)-dxx(j)*five
            q2(j,k+1)=q2(j,k+1)+gxxxy(j)          -dxy(j)-dxy(j)
            q3(j,k+1)=q3(j,k+1)+gxxxz(j)          -dxz(j)-dxz(j)
            q4(j,k+1)=q4(j,k+1)+gxxyy(j)          -dxx(j)
            q5(j,k+1)=q5(j,k+1)+gxxyz(j)
            q6(j,k+1)=q6(j,k+1)+gxxzz(j)          -dxx(j)

            q1(j,k+2)=q1(j,k+2)+gxxxy(j)          -dxy(j)-dxy(j)-dxy(j)
            q2(j,k+2)=q2(j,k+2)+gxxyy(j)+s(j)     -dyy(j)-dxx(j)
            q3(j,k+2)=q3(j,k+2)+gxxyz(j)          -dyz(j)
            q4(j,k+2)=q4(j,k+2)+gxyyy(j)          -dxy(j)-dxy(j)-dxy(j)
            q5(j,k+2)=q5(j,k+2)+gxyyz(j)          -dxz(j)
            q6(j,k+2)=q6(j,k+2)+gxyzz(j)          -dxy(j)

            q1(j,k+3)=q1(j,k+3)+gxxxz(j)          -dxz(j)-dxz(j)-dxz(j)
            q2(j,k+3)=q2(j,k+3)+gxxyz(j)          -dyz(j)
            q3(j,k+3)=q3(j,k+3)+gxxzz(j)+s(j)     -dzz(j)-dxx(j)
            q4(j,k+3)=q4(j,k+3)+gxyyz(j)          -dxz(j)
            q5(j,k+3)=q5(j,k+3)+gxyzz(j)          -dxy(j)
            q6(j,k+3)=q6(j,k+3)+gxzzz(j)          -dxz(j)-dxz(j)-dxz(j)

            q1(j,k+4)=q1(j,k+4)+gxxyy(j)          -dyy(j)
            q2(j,k+4)=q2(j,k+4)+gxyyy(j)          -dxy(j)-dxy(j)
            q3(j,k+4)=q3(j,k+4)+gxyyz(j)
            q4(j,k+4)=q4(j,k+4)+gyyyy(j)+s(j)+s(j)-dyy(j)*five
            q5(j,k+4)=q5(j,k+4)+gyyyz(j)          -dyz(j)-dyz(j)
            q6(j,k+4)=q6(j,k+4)+gyyzz(j)          -dyy(j)

            q1(j,k+5)=q1(j,k+5)+gxxyz(j)          -dyz(j)
            q2(j,k+5)=q2(j,k+5)+gxyyz(j)          -dxz(j)
            q3(j,k+5)=q3(j,k+5)+gxyzz(j)          -dxy(j)
            q4(j,k+5)=q4(j,k+5)+gyyyz(j)          -dyz(j)-dyz(j)-dyz(j)
            q5(j,k+5)=q5(j,k+5)+gyyzz(j)+s(j)     -dzz(j)-dyy(j)
            q6(j,k+5)=q6(j,k+5)+gyzzz(j)          -dyz(j)-dyz(j)-dyz(j)

            q1(j,k+6)=q1(j,k+6)+gxxzz(j)          -dzz(j)
            q2(j,k+6)=q2(j,k+6)+gxyzz(j)
            q3(j,k+6)=q3(j,k+6)+gxzzz(j)          -dxz(j)-dxz(j)
            q4(j,k+6)=q4(j,k+6)+gyyzz(j)          -dzz(j)
            q5(j,k+6)=q5(j,k+6)+gyzzz(j)          -dyz(j)-dyz(j)
            q6(j,k+6)=q6(j,k+6)+gzzzz(j)+s(j)+s(j)-dzz(j)*five

                               endif
 1022 continue

 1020 continue

      do 1023 j=1,npts

      qf(j,k+1)=qf(j,k+1)*rsqrt3
      qf(j,k+4)=qf(j,k+4)*rsqrt3
      qf(j,k+6)=qf(j,k+6)*rsqrt3

      qx(j,k+1)=qx(j,k+1)*rsqrt3
      qy(j,k+1)=qy(j,k+1)*rsqrt3
      qz(j,k+1)=qz(j,k+1)*rsqrt3

      qx(j,k+4)=qx(j,k+4)*rsqrt3
      qy(j,k+4)=qy(j,k+4)*rsqrt3
      qz(j,k+4)=qz(j,k+4)*rsqrt3

      qx(j,k+6)=qx(j,k+6)*rsqrt3
      qy(j,k+6)=qy(j,k+6)*rsqrt3
      qz(j,k+6)=qz(j,k+6)*rsqrt3

      q1(j,k+1)=q1(j,k+1)*rsqrt3
      q2(j,k+1)=q2(j,k+1)*rsqrt3
      q3(j,k+1)=q3(j,k+1)*rsqrt3
      q4(j,k+1)=q4(j,k+1)*rsqrt3
      q5(j,k+1)=q5(j,k+1)*rsqrt3
      q6(j,k+1)=q6(j,k+1)*rsqrt3

      q1(j,k+4)=q1(j,k+4)*rsqrt3
      q2(j,k+4)=q2(j,k+4)*rsqrt3
      q3(j,k+4)=q3(j,k+4)*rsqrt3
      q4(j,k+4)=q4(j,k+4)*rsqrt3
      q5(j,k+4)=q5(j,k+4)*rsqrt3
      q6(j,k+4)=q6(j,k+4)*rsqrt3

      q1(j,k+6)=q1(j,k+6)*rsqrt3
      q2(j,k+6)=q2(j,k+6)*rsqrt3
      q3(j,k+6)=q3(j,k+6)*rsqrt3
      q4(j,k+6)=q4(j,k+6)*rsqrt3
      q5(j,k+6)=q5(j,k+6)*rsqrt3
      q6(j,k+6)=q6(j,k+6)*rsqrt3

 1023 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,qf(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,qf(1,k+3))/real64(npts)
      extent3(k+4)=sumsum(npts,qf(1,k+4))/real64(npts)
      extent3(k+5)=sumsum(npts,qf(1,k+5))/real64(npts)
      extent3(k+6)=sumsum(npts,qf(1,k+6))/real64(npts)

 1016 k=k+6

      return
      end

      subroutine s_annihilate(nmax,n,istart,iend,overlap,coeffa,coeffb,
     &                        smat,wkmat1,wkmat2,veci,vecj,s,tau)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension istart(*),iend(*)

      dimension overlap(nmax,*),coeffa(nmax,*),coeffb(nmax,*),
     &          smat(n,*),wkmat1(n,*),wkmat2(n,*),veci(*),vecj(*),s(*),
     &          tau(*)

      data loopmax/100/

      data big,tol/10000.0d0,0.0000000001d0/
      data zero,half,one,two,hundred/0.0d0,0.5d0,1.0d0,2.0d0,100.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      isent=0
      do 1001 islave=0,numprocs-1
      ia=n-isent
      ib=numprocs-islave
      nloop=ia/ib
      if(mod(ia,ib).ne.0) nloop=nloop+1
      istart(islave+1)=isent+1
      iend(islave+1)=isent+nloop
 1001 isent=isent+nloop

      do 1002 j=1,n
      do 1003 i=istart(myid+1),iend(myid+1)
 1003 coeffa(i,j)=zero
 1002 coeffa(j,j)=one

      do 1004 j=1,n
      do 1004 i=istart(myid+1),iend(myid+1)
 1004 smat(i,j)=overlap(i,j)

      do 1005 j=1,n
      do 1005 i=1,n
      wkmat1(i,j)=zero
      do 1005 k=istart(myid+1),iend(myid+1)
 1005 wkmat1(i,j)=wkmat1(i,j)+coeffa(k,j)*smat(k,i)

      call mpi_reduce(wkmat1,wkmat2,
     &                n*n,mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(wkmat2,n*n,mpi_real8,0,mpi_comm_world,ierr)

      prev_s_ij_max=two

      do 1006 loop=1,loopmax

      s_ij_max=zero

      do 1007 j=1,n

      do 1008 i=1,n
      wkmat1(i,j)=zero
      do 1008 k=istart(myid+1),iend(myid+1)
 1008 wkmat1(i,j)=wkmat1(i,j)+coeffa(k,j)*smat(k,i)

      call mpi_reduce(wkmat1(1,j),wkmat2(1,j),
     &                n,mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(wkmat2(1,j),n,mpi_real8,0,mpi_comm_world,ierr)

      do 1009 i=istart(myid+1),iend(myid+1)

      if(i.eq.j) then
                       s(i)=zero
                       tau(i)=zero

                       goto 1009
                 endif

      s_ij=wkmat2(i,j)

      if(abs(s_ij).gt.s_ij_max) s_ij_max=abs(s_ij)

      t01=tol/hundred

      if(abs(s_ij).gt.t01) then
                                 s_ii=wkmat2(i,i)
                                 s_jj=wkmat2(j,j)

                                 theta=(s_jj-s_ii)/(two*s_ij)
                           else
                                 s(i)=zero
                                 tau(i)=zero

                                 goto 1009
                           endif

      if(theta.lt.zero) then
                              tan_phi=theta+sqrt(theta*theta+one)
                        else
                              tan_phi=theta-sqrt(theta*theta+one)
                        endif

      if(abs(theta).gt.big) tan_phi=-(half/theta)

      phi=atan(tan_phi)

      if(prev_s_ij_max.gt.(one/hundred)) then
                                               c=cos(half*phi)
                                               s(i)=sin(half*phi)
                                         else
                                               c=cos(phi)
                                               s(i)=sin(phi)
                                         endif

      tau(i)=s(i)/(one+c)

 1009 continue

      do 1010 l=1,numprocs
      m=iend(l)-istart(l)+1
      call mpi_bcast(s(istart(l)),m,mpi_real8,l-1,mpi_comm_world,ierr)
 1010 call mpi_bcast(tau(istart(l)),m,mpi_real8,l-1,mpi_comm_world,ierr)

      cutoff=prev_s_ij_max/big

      do 1007 i=1,n

      if(abs(s(i)).lt.cutoff) goto 1007

      do 1011 k=istart(myid+1),iend(myid+1)
 1011 veci(k)=coeffa(k,i)

      do 1012 k=istart(myid+1),iend(myid+1)
 1012 vecj(k)=coeffa(k,j)

      do 1013 k=istart(myid+1),iend(myid+1)
 1013 coeffa(k,i)=coeffa(k,i)+s(i)*(vecj(k)-tau(i)*veci(k))

      do 1014 k=istart(myid+1),iend(myid+1)
 1014 coeffa(k,j)=coeffa(k,j)-s(i)*(veci(k)+tau(i)*vecj(k))

      do 1015 k=istart(myid+1),iend(myid+1)
 1015 veci(k)=smat(k,i)

      do 1016 k=istart(myid+1),iend(myid+1)
 1016 vecj(k)=smat(k,j)

      do 1017 k=istart(myid+1),iend(myid+1)
 1017 smat(k,i)=smat(k,i)+s(i)*(vecj(k)-tau(i)*veci(k))

      do 1018 k=istart(myid+1),iend(myid+1)
 1018 smat(k,j)=smat(k,j)-s(i)*(veci(k)+tau(i)*vecj(k))

 1007 continue

      call mpi_bsend(s_ij_max,1,mpi_real8,0,0,mpi_comm_world,ierr)

      if(myid.eq.0) then

              s_ij_max_all=zero

              do 1019 i=0,numprocs-1
              call mpi_recv(s_ij_max,1,mpi_real8,i,
     &                      mpi_any_tag,mpi_comm_world,istat,ierror)
 1019         if(s_ij_max.gt.s_ij_max_all) s_ij_max_all=s_ij_max

                    endif

      call mpi_bcast(s_ij_max_all,1,mpi_real8,0,mpi_comm_world,ierr)

      if(s_ij_max_all.lt.tol) goto 1020

      if((loop.eq.loopmax).and.(myid.eq.0)) write(6,1021)
 1021 format(/,' s_annihilation routine did not fully converge')

      if(loop.eq.loopmax) stop

 1006 prev_s_ij_max=s_ij_max_all

 1020 continue

      do 1022 j=1,n
      do 1022 i=1,n
      wkmat1(i,j)=zero
      do 1022 k=istart(myid+1),iend(myid+1)
 1022 wkmat1(i,j)=wkmat1(i,j)+coeffa(k,j)*smat(k,i)

      call mpi_reduce(wkmat1,wkmat2,
     &                n*n,mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(wkmat2,n*n,mpi_real8,0,mpi_comm_world,ierr)

      do 1023 i=1,n

      factor=sqrt(one/wkmat2(i,i))

      do 1024 j=istart(myid+1),iend(myid+1)
 1024 coeffa(j,i)=coeffa(j,i)*factor

      do 1025 j=istart(myid+1),iend(myid+1)
 1025 coeffb(j,i)=coeffa(j,i)

 1023 continue

      do 1026 k=1,numprocs
      do 1026 j=1,n
      nloop=iend(k)-istart(k)+1
      call mpi_bcast(coeffa(istart(k),j),iend(k)-istart(k)+1,
     &               mpi_real8,k-1,mpi_comm_world,ierr)
 1026 call mpi_bcast(coeffb(istart(k),j),iend(k)-istart(k)+1,
     &               mpi_real8,k-1,mpi_comm_world,ierr)

      rewind 44

      do 1027 i=1,n
 1027 if(myid.eq.0) call fastwr(44,coeffa(1,i),n)

      return
      end

      subroutine rijmat(n,label,cent)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ival(6)

      dimension rval(6)

      character label(*)*4

      dimension cent(3,*)

      data small,six,bohr/0.01d0,6.0d0,0.529177d0/

      write(6,1001)
 1001 format(/,' distance matrix in angstroms : ',/)

      nblocks=int((real64(n)-small)/six)+1

      do 1002 i=1,nblocks
      do 1002 j=1,nblocks

      ii=max(1,(6*i-5))
      if=min(n,(6*i-0))

      ji=max(1,(6*j-5))
      jf=min(n,(6*j-0))

      nentries=min(6,(jf-ji+1))

      ival(1)=ji+0
      ival(2)=ji+1
      ival(3)=ji+2
      ival(4)=ji+3
      ival(5)=ji+4
      ival(6)=ji+5

      write(6,1003) (ival(l),label(ival(l)),l=1,nentries)
 1003 format(11x,6(2x,i4,1x,a4))

      write(6,1004)

      do 1005 k=0,5

      if((ii+k).gt.if) goto 1005

      rval(1)=dist(cent(1,ii+k),cent(1,ji+0))*bohr
      rval(2)=dist(cent(1,ii+k),cent(1,ji+1))*bohr
      rval(3)=dist(cent(1,ii+k),cent(1,ji+2))*bohr
      rval(4)=dist(cent(1,ii+k),cent(1,ji+3))*bohr
      rval(5)=dist(cent(1,ii+k),cent(1,ji+4))*bohr
      rval(6)=dist(cent(1,ii+k),cent(1,ji+5))*bohr

      write(6,1006) ii+k,label(ii+k),(rval(l),l=1,nentries)
 1006 format(2x,i4,1x,a4,6f11.6)

 1005 continue

      write(6,1004)
      write(6,1004)

 1002 continue

 1004 format()

      return
      end

      subroutine canonical(nmax,ncontractions,nocc,nconts,ncontp,ncontd,
     &                     nfuncatom,isave,fock,coeff,eigenvalue,
     &                     fockmat,wkmat1,wkmat2,veci,vecj)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension nfuncatom(*),isave(*)

      dimension fock(*),coeff(nmax,*),eigenvalue(*),
     &          fockmat(ncontractions,*),wkmat1(ncontractions,*),
     &          wkmat2(ncontractions,*),veci(*),vecj(*)

      data loopmax/100/

      data zero,half,one,two/0.0d0,0.5d0,1.0d0,2.0d0/
      data tolerance,big,ev/0.000000000001d0,10000.0d0,27.212d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      if(myid.eq.0) rewind 44

      do 1001 i=1,ncontractions
 1001 if(myid.eq.0) call fastrd(44,wkmat2(1,i),ncontractions)

      call mpi_bcast(wkmat2,ncontractions**2,
     &               mpi_real8,0,mpi_comm_world,ierr)

      do 1002 j=1,ncontractions
      do 1002 i=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
 1002 fockmat(i,j)=fock(ij)

      do 1003 j=1,ncontractions
      do 1004 i=1,ncontractions
 1004 wkmat1(i,j)=zero
      do 1003 k=1,ncontractions
      do 1003 i=1,ncontractions
 1003 wkmat1(i,j)=wkmat1(i,j)+fockmat(i,k)*wkmat2(k,j)

      do 1005 j=1,ncontractions
      do 1006 i=1,ncontractions
 1006 fockmat(i,j)=zero
      do 1005 i=1,ncontractions
      do 1005 k=1,ncontractions
 1005 fockmat(i,j)=fockmat(i,j)+wkmat2(k,i)*wkmat1(k,j)

      do 1007 j=1,ncontractions
      do 1008 i=1,ncontractions
 1008 wkmat1(i,j)=zero
 1007 wkmat1(j,j)=one

      do 1009 loop=1,loopmax

      f_ij_max=zero

      do 1010 i=1,ncontractions
      do 1010 j=1,i

      if(i.eq.j) goto 1010

      if(abs(fockmat(i,j)).gt.f_ij_max) f_ij_max=abs(fockmat(i,j))

      if(abs(fockmat(i,j)).gt.tolerance) then

                    theta=(fockmat(j,j)-fockmat(i,i))/(two*fockmat(i,j))

                                         else

                    goto 1010

                                         endif

      if(theta.lt.zero) then
                              tan_phi=theta+sqrt(theta*theta+1)
                        else
                              tan_phi=theta-sqrt(theta*theta+1)
                        endif

      if(abs(theta).gt.big) tan_phi=-(half/theta)

      phi=atan(tan_phi)

      c=cos(phi)
      s=sin(phi)
      tau=tan(phi*half)

      f_ii_save=fockmat(i,i)
      f_jj_save=fockmat(j,j)
      f_ij_save=fockmat(i,j)

      do 1011 ii=1,ncontractions
 1011 veci(ii)=fockmat(ii,i)

      do 1012 jj=1,ncontractions
 1012 vecj(jj)=fockmat(jj,j)

      do 1013 ii=1,ncontractions
 1013 fockmat(ii,i)=c*veci(ii)+s*vecj(ii)

      do 1014 jj=1,ncontractions
 1014 fockmat(jj,j)=c*vecj(jj)-s*veci(jj)

      do 1015 ii=1,ncontractions
 1015 fockmat(i,ii)=fockmat(ii,i)

      do 1016 jj=1,ncontractions
 1016 fockmat(j,jj)=fockmat(jj,j)

      fockmat(i,i)=c*c*f_ii_save+two*c*s*f_ij_save+s*s*f_jj_save
      fockmat(j,j)=c*c*f_jj_save-two*c*s*f_ij_save+s*s*f_ii_save

      fockmat(i,j)=zero
      fockmat(j,i)=zero

      do 1017 ii=1,ncontractions
 1017 veci(ii)=wkmat1(ii,i)

      do 1018 jj=1,ncontractions
 1018 vecj(jj)=wkmat1(jj,j)

      do 1019 ii=1,ncontractions
 1019 wkmat1(ii,i)=c*veci(ii)+s*vecj(ii)

      do 1020 jj=1,ncontractions
 1020 wkmat1(jj,j)=c*vecj(jj)-s*veci(jj)

 1010 continue

      if(f_ij_max.lt.tolerance) goto 1021

      if((myid.eq.0).and.(loop.eq.loopmax)) write(6,1022) f_ij_max
 1022 format(/,' orthogonalization routine did not fully converge,',/,
     &         ' maximum value = ', f21.16,/)

      if(loop.eq.loopmax) stop

 1009 continue

 1021 continue

      do 1023 i=1,ncontractions
 1023 isave(i)=i

 1024 iswitch=0

      do 1025 i=2,ncontractions
      j=isave(i)
      k=isave(i-1)
      if(fockmat(j,j).lt.fockmat(k,k)) then
                                             iswitch=1
                                             isave(i)=k
                                             isave(i-1)=j
                                       endif
 1025 continue

      if(iswitch.eq.1) goto 1024

      do 1026 i=1,ncontractions
 1026 eigenvalue(i)=fockmat(isave(i),isave(i))

      do 1027 j=1,ncontractions
      do 1028 i=1,ncontractions
 1028 coeff(i,j)=zero
      do 1027 k=1,ncontractions
      do 1027 i=1,ncontractions
 1027 coeff(i,j)=coeff(i,j)+wkmat2(i,k)*wkmat1(k,isave(j))

      do 1029 i=1,ncontractions

      if((myid.eq.0).and.(i.le.nocc)) write(6,1030) i,ev*eigenvalue(i)
 1030 format(/,'     orbital # ',i5,
     &         ',     energy = ',f15.6,' eV    (occupied)',/)

      if((myid.eq.0).and.(i.gt.nocc)) write(6,1031) i,ev*eigenvalue(i)
 1031 format(/,'     orbital # ',i5,
     &         ',     energy = ',f15.6,' eV    (virtual)',/)

      ii=0

      do 1032 j=1,nconts
      if(myid.eq.0) write(6,1033) ii+1,nfuncatom(ii+1),coeff(ii+1,i)
 1033 format('         a.o. #',i5,',     center',i4,',    s  ',f15.8)
 1032 ii=ii+1

      do 1034 j=1,ncontp
      if(myid.eq.0) write(6,1035) ii+1,nfuncatom(ii+1),coeff(ii+1,i)
 1035 format('         a.o. #',i5,',     center',i4,',    px ',f15.8)
      if(myid.eq.0) write(6,1036) ii+2,nfuncatom(ii+2),coeff(ii+2,i)
 1036 format('         a.o. #',i5,',     center',i4,',    py ',f15.8)
      if(myid.eq.0) write(6,1037) ii+3,nfuncatom(ii+3),coeff(ii+3,i)
 1037 format('         a.o. #',i5,',     center',i4,',    pz ',f15.8)
 1034 ii=ii+3

      do 1038 j=1,ncontd
      if(myid.eq.0) write(6,1039) ii+1,nfuncatom(ii+1),coeff(ii+1,i)
 1039 format('         a.o. #',i5,',     center',i4,',    dxx',f15.8)
      if(myid.eq.0) write(6,1040) ii+2,nfuncatom(ii+2),coeff(ii+2,i)
 1040 format('         a.o. #',i5,',     center',i4,',    dxy',f15.8)
      if(myid.eq.0) write(6,1041) ii+3,nfuncatom(ii+3),coeff(ii+3,i)
 1041 format('         a.o. #',i5,',     center',i4,',    dxz',f15.8)
      if(myid.eq.0) write(6,1042) ii+4,nfuncatom(ii+4),coeff(ii+4,i)
 1042 format('         a.o. #',i5,',     center',i4,',    dyy',f15.8)
      if(myid.eq.0) write(6,1043) ii+5,nfuncatom(ii+5),coeff(ii+5,i)
 1043 format('         a.o. #',i5,',     center',i4,',    dyz',f15.8)
      if(myid.eq.0) write(6,1044) ii+6,nfuncatom(ii+6),coeff(ii+6,i)
 1044 format('         a.o. #',i5,',     center',i4,',    dzz',f15.8)
 1038 ii=ii+6

 1029 continue

      return
      end

      subroutine beckex(dnstya,dnstyb,dnstyt,gmoda,gmodb,dlapa,dlapb,
     &                  xcvta,xcvtb,ex,vxa,vxb)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      data tolerance,beta/1.0d-15,0.0042d0/

      data zero,one,two/0.0d0,1.0d0,2.0d0/
      data three,four,six/3.0d0,4.0d0,6.0d0/

      data third,fourthirds/0.33333333333333d0,1.33333333333333d0/

      if(dnstya.gt.tolerance) then
                                    dka=gmoda/dnstya**fourthirds
                              else
                                    dka=zero
                              endif

      if(dnstyb.gt.tolerance) then
                                    dkb=gmodb/dnstyb**fourthirds
                              else
                                    dkb=zero
                              endif

      sinha=log(dka+sqrt(one+dka*dka))
      sinhb=log(dkb+sqrt(one+dkb*dkb))

      denoma=one+six*beta*dka*sinha
      denomb=one+six*beta*dkb*sinhb

      dsinha=one/sqrt(one+dka*dka)
      dsinhb=one/sqrt(one+dkb*dkb)

      eterma=fourthirds*dka*dka*denoma*dnstya**third
      etermb=fourthirds*dkb*dkb*denomb*dnstyb**third

      vterma=one+three*beta*dka*(sinha-dka*dsinha)
      vtermb=one+three*beta*dkb*(sinhb-dkb*dsinhb)

      if(dnstya.gt.tolerance) then
                                    vterma=two*vterma*dlapa
     &                                    /dnstya**fourthirds

                                    pterma=six*beta*(dnstya**third)
     &                                     *((xcvta/dnstya**3)
     &                                       -fourthirds*dka**3)

                                    ex=ex-beta*(dnstya**fourthirds)
     &                                        *dka*dka/denoma/dnstyt
                              else
                                    vterma=zero
                                    pterma=zero
                              endif

      if(dnstyb.gt.tolerance) then
                                    vtermb=two*vtermb*dlapb
     &                                    /dnstyb**fourthirds

                                    ptermb=six*beta*(dnstyb**third)
     &                                     *((xcvtb/dnstyb**3)
     &                                       -fourthirds*dkb**3)

                                    ex=ex-beta*(dnstyb**fourthirds)
     &                                        *dkb*dkb/denomb/dnstyt
                              else
                                    vtermb=zero
                                    ptermb=zero
                              endif

      factora=(three*sinha*(one+two*beta*dka*sinha)
     &        +four*dka*dsinha*(one-three*beta*dka*dka*dsinha))/denoma
     &        +dka*(dsinha**3)
      factorb=(three*sinhb*(one+two*beta*dkb*sinhb)
     &        +four*dkb*dsinhb*(one-three*beta*dkb*dkb*dsinhb))/denomb
     &        +dkb*(dsinhb**3)

      factora=eterma-vterma+pterma*factora
      factorb=etermb-vtermb+ptermb*factorb

      vxa=vxa-beta*factora/(denoma*denoma)
      vxb=vxb-beta*factorb/(denomb*denomb)

      return
      end

      subroutine gengrid(nreal,maxpoints,ngridtype,nscf,ncenters,nconts,
     &                   ncontp,ncontd,ilfunc,icfunc,ngauss,nptrs,nptrp,
     &                   nptrd,natomtype,nptsatom,iwkvec,cent,alpha,
     &                   coeff,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension natomtype(*),nptsatom(*),iwkvec(*)

      dimension cent(3,*),alpha(*),coeff(*),wkvec(*)

      ja=1
      jb=ja+maxpoints
      jc=jb+maxpoints
      jd=jc+maxpoints
      je=jd+maxpoints
      jf=je+ncenters*maxpoints
      jg=jf+ncenters*ncenters
      jh=jg+ncenters

      ji=jh+ncenters

      if(ji.gt.nreal) stop 'real overflow in gengrid'

      call gridgen(ngridtype,nscf,ncenters,nconts,ncontp,ncontd,ilfunc,
     &             icfunc,ngauss,nptrs,nptrp,nptrd,natomtype,nptsatom,
     &             iwkvec,cent,alpha,coeff,wkvec(ja),wkvec(jb),
     &             wkvec(jc),wkvec(jd),wkvec(je),wkvec(jf),wkvec(jg),
     &             wkvec(jh))

      return
      end

      subroutine diffuse3(nxcs,nxcspd,ilaux,icaux,tolerance,alpha,
     &                    coeffs,coeffp,coeffd,cent,extent)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilaux(*),icaux(*)

      dimension alpha(*),coeffs(*),coeffp(*),coeffd(*)
      dimension cent(3,*),extent(*)

      data nextent/50/
      data zero,one,expcut/0.0d0,1.0d0,50.0d0/

      do 1001 i=1,nxcspd
 1001 extent(i)=zero

      do 1002 iloop=1,nextent

      xx=real64(iloop)
      rr=xx*xx

c  now for lone-s exponent xc fitting functions

      do 1003 i=1,nxcs

      ilabel=ilaux(i)

      rralpha=rr*alpha(ilabel)

      s=zero

      if(rralpha.le.expcut) s=exp(-rralpha)*coeffs(ilabel)

      if(abs(s).gt.tolerance) then
                                    if(xx.gt.extent(i)) extent(i)=xx
                              endif

 1003 continue

c  now for shared exponent xc fitting functions

      do 1006 i=nxcs+1,nxcspd

      ilabel=ilaux(i)

      rralpha=rr*alpha(ilabel)

      dxx=zero

      if(rralpha.le.expcut) dxx=xx*xx*exp(-rralpha)*coeffd(ilabel)

      if(abs(dxx).gt.tolerance) then
                                      if(xx.gt.extent(i)) extent(i)=xx
                                endif

 1006 continue

 1002 continue

      do 1007 i=1,nxcspd
 1007 if(extent(i).ge.real64(nextent-1)) stop 'extent may be a problem'

      do 1008 i=1,nxcspd
 1008 extent(i)=extent(i)+one

      return
      end

      subroutine gradnass(m,n,ncentr,icontr,inddyy,icentr,g,coord,
     &                    charge,density,gradient,zeta,twozetaa,
     &                    twozetab,px,py,pz,base,pxax,pyay,pzaz,axbx,
     &                    ayby,azbz,pxcx,pycy,pzcz,u,ss0,ss1,ps0,sscond,
     &                    pscond,spcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(*),icentr(m,*)

      dimension g(*),coord(3,*),charge(*),density(*),gradient(3,*),
     &          zeta(*),twozetaa(*),twozetab(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          pxcx(*),pycy(*),pzcz(*),u(*),ss0(*),ss1(*),ps0(n,*),
     &          sscond(*),pscond(m,*),spcond(m,*),grad(m,*)

      data zero,two,three,four,pi/0.0d0,2.0d0,
     &                            3.0d0,4.0d0,3.1415926535898d0/

      do 1001 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 1002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1003 i=1,n
      call augg(2,u(i),g)
      ss0(i)=base(i)*g(1)*twopichrg/zeta(i)
 1003 ss1(i)=base(i)*g(2)*twopichrg/zeta(i)

      do 1004 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 1004 ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      do 1005 j=1,3
      do 1005 i=1,m
 1005 pscond(i,j)=zero

      do 1006 j=1,3
      do 1006 i=1,n
 1006 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)*twozetaa(i)

      do 1007 j=1,3
      do 1007 i=1,m
 1007 grad(i,j)=pscond(i,j)*density(inddyy(i))

      do 1008 j=1,3
      do 1008 i=1,m
 1008 gradient(j,nn)=gradient(j,nn)+grad(i,j)

      do 1009 j=1,3
      do 1009 i=1,m
 1009 gradient(j,icentr(i,1))=gradient(j,icentr(i,1))-grad(i,j)

      do 1010 i=1,m
 1010 sscond(i)=zero

      do 1011 j=1,3
      do 1011 i=1,m
 1011 pscond(i,j)=zero

      do 1012 i=1,n
 1012 sscond(icontr(i))=sscond(icontr(i))+ss0(i)*twozetab(i)

      do 1013 j=1,3
      do 1013 i=1,n
 1013 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)*twozetab(i)

      do 1014 i=1,m
      spcond(i,1)=axbx(i)*sscond(i)+pscond(i,1)
      spcond(i,2)=ayby(i)*sscond(i)+pscond(i,2)
 1014 spcond(i,3)=azbz(i)*sscond(i)+pscond(i,3)

      do 1015 j=1,3
      do 1015 i=1,m
 1015 grad(i,j)=spcond(i,j)*density(inddyy(i))

      do 1016 j=1,3
      do 1016 i=1,m
 1016 gradient(j,nn)=gradient(j,nn)+grad(i,j)

      do 1017 j=1,3
      do 1017 i=1,m
 1017 gradient(j,icentr(i,2))=gradient(j,icentr(i,2))-grad(i,j)

 1001 continue

      return
      end

      subroutine gradmm(nreal,ninteger,nfockdim,ncenters,nconts,ncontp,
     &                  ncontd,ncds,ncdspd,nshels,nshelp,nsheld,mtloca,
     &                  iprimvc,nprimvc,icentvc,icdlfunc,icdcfunc,
     &                  iwkvec,coord,charge,alpha,coeff,cdfitc,alphacd,
     &                  coefscd,coefpcd,coefdcd,gradient,overlap,dmata,
     &                  dmatb,density,wkvec)


c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension jsend(30)

      dimension istat(mpi_status_size)

      dimension g(8)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*),iprimvc(*),
     &          nprimvc(*),icentvc(*),icdlfunc(*),icdcfunc(*),iwkvec(*)

      dimension coord(3,*),charge(*),alpha(*),coeff(*),cdfitc(*),
     &          alphacd(*),coefscd(*),coefpcd(*),coefdcd(*),
     &          gradient(3,*),overlap(nfockdim,*),dmata(*),dmatb(*),
     &          density(*),wkvec(*)

      data zero,half,one,three/0.0d0,0.5d0,1.0d0,3.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      call igftable

      call mpi_bcast(ncdspd,1,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(charge,ncenters,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(dmata,nfockdim,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(dmatb,nfockdim,mpi_real8,0,mpi_comm_world,ierr)

      sqrt3=sqrt(three)

      do 1001 i=1,nfockdim
 1001 density(i)=dmata(i)+dmatb(i)

      do 1002 i=1,ncontd
      do 1002 j=1,nconts

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3

 1002 continue

      do 1003 i=1,ncontd
      do 1003 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+1)=density(i4+1)/sqrt3
      density(i4+2)=density(i4+2)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3

 1003 continue

      do 1004 i=1,ncontd
      do 1004 j=1,i

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      density(i4)=density(i4)/three
      if(i.ne.j) density(i4+1)=density(i4+1)/sqrt3
      if(i.ne.j) density(i4+2)=density(i4+2)/sqrt3
      if(i.ne.j) density(i4+3)=density(i4+3)/three
      if(i.ne.j) density(i4+4)=density(i4+4)/sqrt3
      if(i.ne.j) density(i4+5)=density(i4+5)/three

      density(i4+i1)=density(i4+i1)/sqrt3
      if(i.ne.j) density(i4+i1+3)=density(i4+i1+3)/sqrt3
      if(i.ne.j) density(i4+i1+5)=density(i4+i1+5)/sqrt3

      density(i4+i1*2+1)=density(i4+i1*2+1)/sqrt3
      if(i.ne.j) density(i4+i1*2+4)=density(i4+i1*2+4)/sqrt3
      if(i.ne.j) density(i4+i1*2+6)=density(i4+i1*2+6)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/three
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3
      density(i4+i1*3+6)=density(i4+i1*3+6)/three
      if(i.ne.j) density(i4+i1*3+7)=density(i4+i1*3+7)/sqrt3
      if(i.ne.j) density(i4+i1*3+8)=density(i4+i1*3+8)/three

      density(i4+i1*4+6)=density(i4+i1*4+6)/sqrt3
      density(i4+i1*4+9)=density(i4+i1*4+9)/sqrt3
      if(i.ne.j) density(i4+i1*4+11)=density(i4+i1*4+11)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/three
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3
      density(i4+i1*5+13)=density(i4+i1*5+13)/three
      density(i4+i1*5+14)=density(i4+i1*5+14)/sqrt3
      density(i4+i1*5+15)=density(i4+i1*5+15)/three

 1004 continue

      do 1005 i=1,ncenters
      do 1005 j=1,3
 1005 gradient(j,i)=zero

      do 1006 j=1,3
      do 1006 i=1,nfockdim
 1006 overlap(i,j)=zero

      if(myid.eq.0) then

              do 1007 i=1,ncenters
              do 1007 j=1,i

              if(i.eq.j) goto 1007

              factor=charge(i)*charge(j)/
     &               ((((coord(1,i)-coord(1,j))**2)+
     &                 ((coord(2,i)-coord(2,j))**2)+
     &                 ((coord(3,i)-coord(3,j))**2))**(one+half))

              gradient(1,i)=gradient(1,i)+factor*(coord(1,j)-coord(1,i))
              gradient(2,i)=gradient(2,i)+factor*(coord(2,j)-coord(2,i))
              gradient(3,i)=gradient(3,i)+factor*(coord(3,j)-coord(3,i))

              gradient(1,j)=gradient(1,j)+factor*(coord(1,i)-coord(1,j))
              gradient(2,j)=gradient(2,j)+factor*(coord(2,i)-coord(2,j))
              gradient(3,j)=gradient(3,j)+factor*(coord(3,i)-coord(3,j))

 1007         continue

                      endif

      ncposs=nconts*(nconts+1)/2
      ncpopp=ncontp*(ncontp+1)/2
      ncpodd=ncontd*(ncontd+1)/2

      ncpops=ncontp*nconts
      ncpods=ncontd*nconts
      ncpodp=ncontd*ncontp

      npposs=0
      nppops=0
      nppopp=0
      nppods=0
      nppodp=0
      nppodd=0

      do 1008 i=1,nconts
      do 1008 j=1,i
 1008 npposs=npposs+nprimvc(nshels(i))*nprimvc(nshels(j))

      do 1009 i=1,ncontp
      do 1009 j=1,nconts
 1009 nppops=nppops+nprimvc(nshelp(i))*nprimvc(nshels(j))

      do 1010 i=1,ncontp
      do 1010 j=1,i
 1010 nppopp=nppopp+nprimvc(nshelp(i))*nprimvc(nshelp(j))

      do 1011 i=1,ncontd
      do 1011 j=1,nconts
 1011 nppods=nppods+nprimvc(nsheld(i))*nprimvc(nshels(j))

      do 1012 i=1,ncontd
      do 1012 j=1,ncontp
 1012 nppodp=nppodp+nprimvc(nsheld(i))*nprimvc(nshelp(j))

      do 1013 i=1,ncontd
      do 1013 j=1,i
 1013 nppodd=nppodd+nprimvc(nsheld(i))*nprimvc(nsheld(j))

      ja=1
      jb=ja+npposs
      jc=jb+ncposs

      ia=jc+ncposs*2
      ib=ia+npposs

      if(ib.gt.ninteger) stop 'gradmm ss integer overflow'

      je=1
      jf=je+npposs
      jg=jf+npposs
      jh=jg+npposs
      ji=jh+npposs
      jj=ji+npposs
      jk=jj+npposs
      jl=jk+npposs
      jm=jl+npposs
      jn=jm+npposs
      jo=jn+npposs
      jp=jo+npposs
      jq=jp+npposs
      jr=jq+npposs
      js=jr+npposs
      jt=js+npposs
      ju=jt+npposs
      jv=ju+npposs
      jw=jv+npposs
      jx=jw+ncposs
      jy=jx+ncposs
      jz=jy+ncposs
      j0=jz+npposs*13

      if(j0.gt.nreal) stop 'gradmm ss real overflow'

      call setupgss(ncposs,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &              icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),coord,
     &              alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &              wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &              wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &              wkvec(jx),wkvec(jy),wkvec(jz))

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncposs,wkvec(18*n+0*ncposs+1),wkvec(jw))
      call stringcopy(ncposs,wkvec(18*n+1*ncposs+1),wkvec(jx))
      call stringcopy(ncposs,wkvec(18*n+2*ncposs+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncposs
      jy=jx+ncposs
      jz=jy+ncposs

      if(myid.eq.0) then
                          isent=0

                          do 1014 islave=0,numprocs-1

                          i1=n-isent
                          i2=numprocs-islave

                          nloop=i1/i2
                          if(mod(i1,i2).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jh),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ji),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop
 
                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop
 
 1014                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jh),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ji),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop*3
      kd=kc+ncposs*3
      ke=kd+ncposs*3

      if(ke.gt.nreal) stop 'gradmm ss real overflow'

      call gradovss(nfockdim,ncposs,nloop,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),density,overlap,gradient,wkvec(je),
     &              wkvec(jh),wkvec(jm),wkvec(jn),wkvec(jp),wkvec(jo),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop*3
      ki=kh+ncposs
      kj=ki+ncposs*3
      kk=kj+ncposs*3
      kl=kk+ncposs*3

      if(kl.gt.nreal) stop 'gradmm ss real overflow'

      call gradnass(ncposs,nloop,ncenters,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),g,coord,charge,density,gradient,
     &              wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop*3
      ks=kr+ncposs
      kt=ks+ncposs*3
      ku=kt+ncposs*3
      kv=ku+ncposs*3

      if(kv.gt.nreal) stop 'gradmm ss real overflow'

      call gradcdss(ncposs,nloop,ncds,icdlfunc,icdcfunc,iwkvec(ja),
     &              iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,density,
     &              gradient,cdfitc,alphacd,coefscd,wkvec(je),
     &              wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),
     &              wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &              wkvec(jx),wkvec(jy),wkvec(ka),wkvec(kb),wkvec(kc),
     &              wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &              wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &              wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &              wkvec(ks),wkvec(kt),wkvec(ku))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop
      kx=kw+nloop
      ky=kx+nloop*3
      kz=ky+nloop*3
      la=kz+nloop*3
      lb=la+nloop*3
      lc=lb+nloop*3
      ld=lc+nloop*6
      le=ld+nloop*9
      lf=le+nloop*9
      lg=lf+nloop*18
      lh=lg+nloop
      li=lh+nloop*3
      lj=li+nloop*3
      lk=lj+ncposs
      ll=lk+ncposs*3
      lm=ll+ncposs*6
      ln=lm+ncposs*3
      lo=ln+ncposs*9
      lp=lo+ncposs*18
      lq=lp+ncposs*3
      lr=lq+ncposs*9
      ls=lr+ncposs*18
      lt=ls+ncposs*3

      if(lt.gt.nreal) stop 'gradmm ss real overflow'

      call gradxxss(ncposs,nloop,ncds,ncdspd,icdlfunc,icdcfunc,
     &              iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,
     &              density,gradient,cdfitc,alphacd,coefscd,coefpcd,
     &              coefdcd,wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),
     &              wkvec(jv),wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),
     &              wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &              wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &              wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &              wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &              wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),
     &              wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),
     &              wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &              wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),
     &              wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls))

      if(ncontp.eq.0) goto 2001

      ja=1
      jb=ja+nppops
      jc=jb+ncpops*3

      ia=jc+ncpops*2
      ib=ia+nppops

      if(ib.gt.ninteger) stop 'gradmm ps integer overflow'

      je=1
      jf=je+nppops
      jg=jf+nppops
      jh=jg+nppops
      ji=jh+nppops
      jj=ji+nppops
      jk=jj+nppops
      jl=jk+nppops
      jm=jl+nppops
      jn=jm+nppops
      jo=jn+nppops
      jp=jo+nppops
      jq=jp+nppops
      jr=jq+nppops
      js=jr+nppops
      jt=js+nppops
      ju=jt+nppops
      jv=ju+nppops
      jw=jv+nppops
      jx=jw+ncpops
      jy=jx+ncpops
      jz=jy+ncpops
      j0=jz+nppops*13

      if(j0.gt.nreal) stop 'gradmm ps real overflow'

      call setupgps(ncpops,n,ncontp,nconts,nshelp,nshels,mtloca,iprimvc,
     &              nprimvc,icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz))

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpops,wkvec(18*n+0*ncpops+1),wkvec(jw))
      call stringcopy(ncpops,wkvec(18*n+1*ncpops+1),wkvec(jx))
      call stringcopy(ncpops,wkvec(18*n+2*ncpops+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpops
      jy=jx+ncpops
      jz=jy+ncpops

      if(myid.eq.0) then
                          isent=0

                          do 1015 islave=0,numprocs-1

                          i1=n-isent
                          i2=numprocs-islave

                          nloop=i1/i2
                          if(mod(i1,i2).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jh),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ji),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

1015                      isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jh),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ji),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop*3
      kf=ke+nloop*6
      kg=kf+nloop
      kh=kg+ncpops
      ki=kh+ncpops*6
      kj=ki+ncpops*9

      if(kj.gt.nreal) stop 'gradmm ps real overflow'

      call gradovps(nfockdim,ncpops,nloop,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),density,overlap,gradient,wkvec(je),
     &              wkvec(jh),wkvec(jm),wkvec(jn),wkvec(jp),wkvec(jo),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop*3
      kk=kj+nloop*3
      kl=kk+nloop*6
      km=kl+nloop
      kn=km+ncpops
      ko=kn+ncpops*3
      kp=ko+ncpops*6
      kq=kp+ncpops*9
      kr=kq+ncpops*9

      if(kr.gt.nreal) stop 'gradmm ps real overflow'

      call gradnaps(ncpops,nloop,ncenters,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),g,coord,charge,density,gradient,
     &              wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &              wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop*3
      ku=kt+nloop*3
      kv=ku+nloop*6
      kw=kv+nloop
      kx=kw+ncpops
      ky=kx+ncpops*3
      kz=ky+ncpops*6
      k0=kz+ncpops*9
      k1=k0+ncpops*9

      if(k1.gt.nreal) stop 'gradmm ps real overflow'

      call gradcdps(ncpops,nloop,ncds,icdlfunc,icdcfunc,iwkvec(ja),
     &              iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,density,
     &              gradient,cdfitc,alphacd,coefscd,wkvec(je),wkvec(jh),
     &              wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jp),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),wkvec(jx),
     &              wkvec(jy),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &              wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &              wkvec(ky),wkvec(kz),wkvec(k0))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop
      kx=kw+nloop
      ky=kx+nloop
      kz=ky+nloop*3
      la=kz+nloop*3
      lb=la+nloop*3
      lc=lb+nloop*3
      ld=lc+nloop*6
      le=ld+nloop*6
      lf=le+nloop*6
      lg=lf+nloop*3
      lh=lg+nloop*3
      li=lh+nloop*6
      lj=li+nloop*9
      lk=lj+nloop*9
      ll=lk+nloop*18
      lm=ll+nloop*18
      ln=lm+nloop*18
      lo=ln+nloop*36
      lp=lo+nloop
      lq=lp+nloop*6
      lr=lq+nloop*9
      ls=lr+ncpops
      lt=ls+ncpops*3
      lu=lt+ncpops*6
      lv=lu+ncpops*3
      lw=lv+ncpops*9
      lx=lw+ncpops*18
      ly=lx+ncpops*6
      lz=ly+ncpops*18
      ma=lz+ncpops*36
      mb=ma+ncpops*9
      mc=mb+ncpops*27
      md=mc+ncpops*54
      me=md+ncpops*9

      if(me.gt.nreal) stop 'gradmm ps real overflow'

      call gradxxps(ncpops,nloop,ncds,ncdspd,icdlfunc,icdcfunc,
     &              iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,
     &              density,gradient,cdfitc,alphacd,coefscd,coefpcd,
     &              coefdcd,wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),
     &              wkvec(jv),wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),
     &              wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &              wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &              wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &              wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &              wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),
     &              wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),
     &              wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &              wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),
     &              wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls),wkvec(lt),
     &              wkvec(lu),wkvec(lv),wkvec(lw),wkvec(lx),wkvec(ly),
     &              wkvec(lz),wkvec(ma),wkvec(mb),wkvec(mc),wkvec(md))

      ja=1
      jb=ja+ncpopp
      jc=jb+nppopp
      jd=jc+ncpopp*9

      ia=jd+ncpopp*2
      ib=ia+nppopp

      if(ib.gt.ninteger) stop 'gradmm pp integer overflow'

      je=1
      jf=je+nppopp
      jg=jf+nppopp
      jh=jg+nppopp
      ji=jh+nppopp
      jj=ji+nppopp
      jk=jj+nppopp
      jl=jk+nppopp
      jm=jl+nppopp
      jn=jm+nppopp
      jo=jn+nppopp
      jp=jo+nppopp
      jq=jp+nppopp
      jr=jq+nppopp
      js=jr+nppopp
      jt=js+nppopp
      ju=jt+nppopp
      jv=ju+nppopp
      jw=jv+nppopp
      jx=jw+nppopp
      jy=jx+nppopp
      jz=jy+nppopp
      j0=jz+ncpopp
      j1=j0+ncpopp
      j2=j1+ncpopp
      j3=j2+nppopp*16

      if(j3.gt.nreal) stop 'gradmm pp real overflow'

      call setupgpp(ncpopp,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &              icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(jd),
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz),wkvec(j0),
     &              wkvec(j1),wkvec(j2))


      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                          call stringcopy(n,wkvec(18*n+1),wkvec(jw))
                          call stringcopy(n,wkvec(19*n+1),wkvec(jx))
                          call stringcopy(n,wkvec(20*n+1),wkvec(jy))
                    endif

      call stringcopy(ncpopp,wkvec(21*n+0*ncpopp+1),wkvec(jz))
      call stringcopy(ncpopp,wkvec(21*n+1*ncpopp+1),wkvec(j0))
      call stringcopy(ncpopp,wkvec(21*n+2*ncpopp+1),wkvec(j1))
 
      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+n
      jy=jx+n
      jz=jy+n
      j0=jz+ncpopp
      j1=j0+ncpopp
      j2=j1+ncpopp

      if(myid.eq.0) then
                          isent=0

                          do 1016 islave=0,numprocs-1

                          i1=n-isent
                          i2=numprocs-islave

                          nloop=i1/i2
                          if(mod(i1,i2).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=jb
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv
                          jsend(20)=jw
                          jsend(21)=jx
                          jsend(22)=jy

                          call mpi_bsend(jsend,22,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(jb),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jh),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ji),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jw),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jx),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jy),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          jb=jb+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop
                          jw=jw+nloop
                          jx=jx+nloop
                          jy=jy+nloop

1016                      isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,22,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      jb=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)
      jw=jsend(20)
      jx=jsend(21)
      jy=jsend(22)

      call mpi_recv(iwkvec(jb),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jh),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ji),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jw),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jx),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jy),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop*3
      kf=ke+nloop*3
      kg=kf+nloop*6
      kh=kg+nloop*18
      ki=kh+nloop
      kj=ki+nloop*3
      kk=kj+ncpopp*3
      kl=kk+ncpopp*18
      km=kl+ncpopp*27

      if(km.gt.nreal) stop 'gradmm pp real overflow'

      call gradovpp(nfockdim,ncpopp,nloop,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),iwkvec(jd),density,overlap,gradient,
     &              wkvec(je),wkvec(jh),wkvec(jm),wkvec(jn),wkvec(jp),
     &              wkvec(jo),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &              wkvec(jx),wkvec(jy),wkvec(ka),wkvec(kb),wkvec(kc),
     &              wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &              wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop*3
      kl=kk+nloop*3
      km=kl+nloop*3
      kn=km+nloop*6
      ko=kn+nloop*6
      kp=ko+nloop*10
      kq=kp+nloop
      kr=kq+nloop*3
      ks=kr+ncpopp
      kt=ks+ncpopp*3
      ku=kt+ncpopp*3
      kv=ku+ncpopp*6
      kw=kv+ncpopp*9
      kx=kw+ncpopp*10
      ky=kx+ncpopp*18
      kz=ky+ncpopp*18
      k0=kz+ncpopp*27

      if(k0.gt.nreal) stop 'gradmm pp real overflow'

      call gradnapp(ncpopp,nloop,ncenters,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),iwkvec(jd),g,coord,charge,density,
     &              gradient,wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),
     &              wkvec(jv),wkvec(jz),wkvec(j0),wkvec(j1),wkvec(ka),
     &              wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &              wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &              wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &              wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &              wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop 
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop*3
      kv=ku+nloop*3
      kw=kv+nloop*3
      kx=kw+nloop*6
      ky=kx+nloop*6
      kz=ky+nloop*10
      la=kz+nloop
      lb=la+nloop*3
      lc=lb+ncpopp
      ld=lc+ncpopp*3
      le=ld+ncpopp*3
      lf=le+ncpopp*6
      lg=lf+ncpopp*9
      lh=lg+ncpopp*10
      li=lh+ncpopp*18
      lj=li+ncpopp*18
      lk=lj+ncpopp*27

      if(lk.gt.nreal) stop 'gradmm pp real overflow'

      call gradcdpp(ncpopp,nloop,ncds,icdlfunc,icdcfunc,iwkvec(ja),
     &              iwkvec(jb),iwkvec(jc),iwkvec(jd),iwkvec(ia),g,coord,
     &              density,gradient,cdfitc,alphacd,coefscd,wkvec(je),
     &              wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),
     &              wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jz),
     &              wkvec(j0),wkvec(j1),wkvec(ka),wkvec(kb),wkvec(kc),
     &              wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &              wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &              wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &              wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),
     &              wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),
     &              wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),
     &              wkvec(lh),wkvec(li),wkvec(lj))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop
      kx=kw+nloop
      ky=kx+nloop
      kz=ky+nloop
      la=kz+nloop*3
      lb=la+nloop*3
      lc=lb+nloop*3
      ld=lc+nloop*3
      le=ld+nloop*3
      lf=le+nloop*6
      lg=lf+nloop*6
      lh=lg+nloop*6
      li=lh+nloop*6
      lj=li+nloop*10
      lk=lj+nloop*10
      ll=lk+nloop*10
      lm=ll+nloop*3
      ln=lm+nloop*3
      lo=ln+nloop*6
      lp=lo+nloop*9
      lq=lp+nloop*9
      lr=lq+nloop*18
      ls=lr+nloop*18
      lt=ls+nloop*18
      lu=lt+nloop*36
      lv=lu+nloop*30
      lw=lv+nloop*30
      lx=lw+nloop*60
      ly=lx+nloop
      lz=ly+nloop*10
      ma=lz+nloop*18
      mb=ma+ncpopp
      mc=mb+ncpopp*3
      md=mc+ncpopp*6
      me=md+ncpopp*3
      mf=me+ncpopp*9
      mg=mf+ncpopp*18
      mh=mg+ncpopp*3
      mi=mh+ncpopp*9
      mj=mi+ncpopp*18
      mk=mj+ncpopp*6
      ml=mk+ncpopp*18
      mm=ml+ncpopp*36
      mn=mm+ncpopp*9
      mo=mn+ncpopp*27
      mp=mo+ncpopp*54
      mq=mp+ncpopp*10
      mr=mq+ncpopp*30
      ms=mr+ncpopp*60
      mt=ms+ncpopp*18
      mu=mt+ncpopp*54
      mv=mu+ncpopp*108
      mw=mv+ncpopp*18
      mx=mw+ncpopp*54
      my=mx+ncpopp*108
      mz=my+ncpopp*27

      if(mz.gt.nreal) stop 'gradmm pp real overflow'

      call gradxxpp(ncpopp,nloop,ncds,ncdspd,icdlfunc,icdcfunc,
     &              iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(jd),
     &              iwkvec(ia),g,coord,density,gradient,cdfitc,alphacd,
     &              coefscd,coefpcd,coefdcd,wkvec(je),wkvec(jh),
     &              wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jp),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jz),wkvec(j0),
     &              wkvec(j1),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &              wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &              wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),
     &              wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),
     &              wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),
     &              wkvec(ln),wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),
     &              wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),wkvec(lw),
     &              wkvec(lx),wkvec(ly),wkvec(lz),wkvec(ma),wkvec(mb),
     &              wkvec(mc),wkvec(md),wkvec(me),wkvec(mf),wkvec(mg),
     &              wkvec(mh),wkvec(mi),wkvec(mj),wkvec(mk),wkvec(ml),
     &              wkvec(mm),wkvec(mn),wkvec(mo),wkvec(mp),wkvec(mq),
     &              wkvec(mr),wkvec(ms),wkvec(mt),wkvec(mu),wkvec(mv),
     &              wkvec(mw),wkvec(mx),wkvec(my))

      if(ncontd.eq.0) goto 2001

      ja=1
      jb=ja+nppods
      jc=jb+ncpods*6

      ia=jc+ncpods*2
      ib=ia+nppods

      if(ib.gt.ninteger) stop 'gradmm ds integer overflow'

      je=1
      jf=je+nppods
      jg=jf+nppods
      jh=jg+nppods
      ji=jh+nppods
      jj=ji+nppods
      jk=jj+nppods
      jl=jk+nppods
      jm=jl+nppods
      jn=jm+nppods
      jo=jn+nppods
      jp=jo+nppods
      jq=jp+nppods
      jr=jq+nppods
      js=jr+nppods
      jt=js+nppods
      ju=jt+nppods
      jv=ju+nppods
      jw=jv+nppods
      jx=jw+ncpods
      jy=jx+ncpods
      jz=jy+ncpods
      j1=jz+nppods*13

      if(j1.gt.nreal) stop 'gradmm ds real overflow'

      call setupgds(ncpods,n,ncontd,nconts,nsheld,nshels,mtloca,iprimvc,
     &              nprimvc,icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz))

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif
 
      call stringcopy(ncpods,wkvec(18*n+0*ncpods+1),wkvec(jw))
      call stringcopy(ncpods,wkvec(18*n+1*ncpods+1),wkvec(jx))
      call stringcopy(ncpods,wkvec(18*n+2*ncpods+1),wkvec(jy))
 
      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpods
      jy=jx+ncpods
      jz=jy+ncpods

      if(myid.eq.0) then
                          isent=0

                          do 1017 islave=0,numprocs-1

                          i1=n-isent
                          i2=numprocs-islave
                       
                          nloop=i1/i2
                          if(mod(i1,i2).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jh),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ji),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1017                     isent=isent+nloop   
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jh),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ji),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop*3
      kf=ke+nloop*3
      kg=kf+nloop*6
      kh=kg+nloop*10
      ki=kh+nloop
      kj=ki+nloop*3
      kk=kj+ncpods*3
      kl=kk+ncpods*10
      km=kl+ncpods*18

      if(km.gt.nreal) stop 'gradmm ds real overflow'

      call gradovds(nfockdim,ncpods,nloop,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),density,overlap,gradient,wkvec(je),
     &              wkvec(jh),wkvec(jm),wkvec(jn),wkvec(jp),wkvec(jo),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop*3
      kl=kk+nloop*3
      km=kl+nloop*3
      kn=km+nloop*6
      ko=kn+nloop*6
      kp=ko+nloop*10
      kq=kp+nloop
      kr=kq+nloop*3
      ks=kr+ncpods*3
      kt=ks+ncpods*6
      ku=kt+ncpods*10
      kv=ku+ncpods*18
      kw=kv+ncpods*18

      if(kw.gt.nreal) stop 'gradmm ds real overflow'

      call gradnads(ncpods,nloop,ncenters,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),g,coord,charge,density,gradient,
     &              wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &              wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),
     &              wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop*3
      kv=ku+nloop*3
      kw=kv+nloop*3
      kx=kw+nloop*6
      ky=kx+nloop*6
      kz=ky+nloop*10
      k0=kz+nloop
      k1=k0+nloop*3
      k2=k1+ncpods*3
      k3=k2+ncpods*6
      k4=k3+ncpods*10
      k5=k4+ncpods*18
      k6=k5+ncpods*18

      if(k6.gt.nreal) stop 'gradmm ds real overflow'

      call gradcdds(ncpods,nloop,ncds,icdlfunc,icdcfunc,iwkvec(ja),
     &              iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,density,
     &              gradient,cdfitc,alphacd,coefscd,wkvec(je),wkvec(jh),
     &              wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jp),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),wkvec(jx),
     &              wkvec(jy),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &              wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &              wkvec(ky),wkvec(kz),wkvec(k0),wkvec(k1),wkvec(k2),
     &              wkvec(k3),wkvec(k4),wkvec(k5))

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop
      kx=kw+nloop
      ky=kx+nloop
      kz=ky+nloop
      la=kz+nloop*3
      lb=la+nloop*3
      lc=lb+nloop*3
      ld=lc+nloop*3
      le=ld+nloop*3
      lf=le+nloop*6
      lg=lf+nloop*6
      lh=lg+nloop*6
      li=lh+nloop*6
      lj=li+nloop*10
      lk=lj+nloop*10
      ll=lk+nloop*10
      lm=ll+nloop*3
      ln=lm+nloop*9
      lo=ln+nloop*9
      lp=lo+nloop*18
      lq=lp+nloop*18
      lr=lq+nloop*18
      ls=lr+nloop*36
      lt=ls+nloop*30
      lu=lt+nloop*30
      lv=lu+nloop*60
      lw=lv+nloop
      lx=lw+nloop*10
      ly=lx+nloop*18
      lz=ly+ncpods*3
      ma=lz+ncpods*9
      mb=ma+ncpods*18
      mc=mb+ncpods*6
      md=mc+ncpods*18
      me=md+ncpods*36
      mf=me+ncpods*10
      mg=mf+ncpods*30
      mh=mg+ncpods*60
      mi=mh+ncpods*18
      mj=mi+ncpods*54
      mk=mj+ncpods*108
      ml=mk+ncpods*18

      if(ml.gt.nreal) stop 'gradmm ds real overflow'

      call gradxxds(ncpods,nloop,ncds,ncdspd,icdlfunc,icdcfunc,
     &              iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,
     &              density,gradient,cdfitc,alphacd,coefscd,coefpcd,
     &              coefdcd,wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),
     &              wkvec(jv),wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),
     &              wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &              wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &              wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &              wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &              wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),
     &              wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),
     &              wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &              wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),
     &              wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls),wkvec(lt),
     &              wkvec(lu),wkvec(lv),wkvec(lw),wkvec(lx),wkvec(ly),
     &              wkvec(lz),wkvec(ma),wkvec(mb),wkvec(mc),wkvec(md),
     &              wkvec(me),wkvec(mf),wkvec(mg),wkvec(mh),wkvec(mi),
     &              wkvec(mj),wkvec(mk))

      ja=1
      jb=ja+nppodp
      jc=jb+ncpodp*18

      ia=jc+ncpodp*2
      ib=ia+nppodp

      if(ib.gt.ninteger) stop 'gradmm dp integer overflow'

      je=1
      jf=je+nppodp
      jg=jf+nppodp
      jh=jg+nppodp
      ji=jh+nppodp
      jj=ji+nppodp
      jk=jj+nppodp
      jl=jk+nppodp
      jm=jl+nppodp
      jn=jm+nppodp
      jo=jn+nppodp
      jp=jo+nppodp
      jq=jp+nppodp
      jr=jq+nppodp
      js=jr+nppodp
      jt=js+nppodp
      ju=jt+nppodp
      jv=ju+nppodp
      jw=jv+nppodp
      jx=jw+nppodp
      jy=jx+nppodp
      jz=jy+nppodp
      j0=jz+ncpodp
      j1=j0+ncpodp
      j2=j1+ncpodp
      j3=j2+nppodp*16

      if(j2.gt.nreal) stop 'gradmm dp real overflow'

      call setupgdp(ncpodp,n,ncontd,ncontp,nsheld,nshelp,mtloca,iprimvc,
     &              nprimvc,icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz),wkvec(j0),
     &              wkvec(j1),wkvec(j2))

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                          call stringcopy(n,wkvec(18*n+1),wkvec(jw))
                          call stringcopy(n,wkvec(19*n+1),wkvec(jx))
                          call stringcopy(n,wkvec(20*n+1),wkvec(jy))
                    endif

      call stringcopy(ncpodp,wkvec(21*n+0*ncpodp+1),wkvec(jz))
      call stringcopy(ncpodp,wkvec(21*n+1*ncpodp+1),wkvec(j0))
      call stringcopy(ncpodp,wkvec(21*n+2*ncpodp+1),wkvec(j1))
 
      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+n
      jy=jx+n
      jz=jy+n
      j0=jz+ncpodp
      j1=j0+ncpodp
      j2=j1+ncpodp

      if(myid.eq.0) then
                          isent=0

                          do 1018 islave=0,numprocs-1

                          i1=n-isent
                          i2=numprocs-islave

                          nloop=i1/i2
                          if(mod(i1,i2).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv
                          jsend(20)=jw
                          jsend(21)=jx
                          jsend(22)=jy


                          call mpi_bsend(jsend,22,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jh),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ji),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jw),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jx),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jy),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop
                          jw=jw+nloop
                          jx=jx+nloop
                          jy=jy+nloop

1018                      isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,22,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)
      jw=jsend(20)
      jx=jsend(21)
      jy=jsend(22)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jh),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ji),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jw),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jx),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jy),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop*3
      kf=ke+nloop*3
      kg=kf+nloop*6
      kh=kg+nloop*9
      ki=kh+nloop*10
      kj=ki+nloop*30
      kk=kj+nloop
      kl=kk+nloop*3
      km=kl+nloop*6
      kn=km+ncpodp*9
      ko=kn+ncpodp*30
      kp=ko+ncpodp*54

      if(kp.gt.nreal) stop 'gradmm dp real overflow'

      call gradovdp(nfockdim,ncpodp,nloop,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),density,overlap,gradient,wkvec(je),
     &              wkvec(jh),wkvec(jm),wkvec(jn),wkvec(jp),wkvec(jo),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),wkvec(jx),
     &              wkvec(jy),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop*3
      km=kl+nloop*3
      kn=km+nloop*3
      ko=kn+nloop*3
      kp=ko+nloop*6
      kq=kp+nloop*6
      kr=kq+nloop*6
      ks=kr+nloop*10
      kt=ks+nloop*10
      ku=kt+nloop*15
      kv=ku+nloop
      kw=kv+nloop*6
      kx=kw+ncpodp*3
      ky=kx+ncpodp*6
      kz=ky+ncpodp*9
      k0=kz+ncpodp*10
      k1=k0+ncpodp*18
      k2=k1+ncpodp*15
      k3=k2+ncpodp*30
      k4=k3+ncpodp*36
      k5=k4+ncpodp*54

      if(k5.gt.nreal) stop 'gradmm dp real overflow'

      call gradnadp(ncpodp,nloop,ncenters,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),g,coord,charge,density,gradient,
     &              wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jz),wkvec(j0),wkvec(j1),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &              wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),
     &              wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),
     &              wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),wkvec(k0),
     &              wkvec(k1),wkvec(k2),wkvec(k3),wkvec(k4))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop*3
      kw=kv+nloop*3
      kx=kw+nloop*3
      ky=kx+nloop*3
      kz=ky+nloop*6
      la=kz+nloop*6
      lb=la+nloop*6
      lc=lb+nloop*10
      ld=lc+nloop*10
      le=ld+nloop*15
      lf=le+nloop
      lg=lf+nloop*6
      lh=lg+ncpodp*3
      li=lh+ncpodp*6
      lj=li+ncpodp*9
      lk=lj+ncpodp*10
      ll=lk+ncpodp*18
      lm=ll+ncpodp*15
      ln=lm+ncpodp*30
      lo=ln+ncpodp*36
      lp=lo+ncpodp*54

      if(lp.gt.nreal) stop 'gradmm dp real overflow'

      call gradcddp(ncpodp,nloop,ncds,icdlfunc,icdcfunc,iwkvec(ja),
     &              iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,density,
     &              gradient,cdfitc,alphacd,coefscd,wkvec(je),wkvec(jh),
     &              wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jp),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jz),wkvec(j0),
     &              wkvec(j1),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &              wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &              wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),
     &              wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),
     &              wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),
     &              wkvec(ln),wkvec(lo))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop
      kx=kw+nloop
      ky=kx+nloop
      kz=ky+nloop
      la=kz+nloop
      lb=la+nloop*3
      lc=lb+nloop*3
      ld=lc+nloop*3
      le=ld+nloop*3
      lf=le+nloop*3
      lg=lf+nloop*3
      lh=lg+nloop*6
      li=lh+nloop*6
      lj=li+nloop*6
      lk=lj+nloop*6
      ll=lk+nloop*6
      lm=ll+nloop*10
      ln=lm+nloop*10
      lo=ln+nloop*10
      lp=lo+nloop*10
      lq=lp+nloop*15
      lr=lq+nloop*15
      ls=lr+nloop*15
      lt=ls+nloop*3
      lu=lt+nloop*9
      lv=lu+nloop*9
      lw=lv+nloop*18
      lx=lw+nloop*18
      ly=lx+nloop*18
      lz=ly+nloop*36
      ma=lz+nloop*30
      mb=ma+nloop*30
      mc=mb+nloop*60
      md=mc+nloop*45
      me=md+nloop*45
      mf=me+nloop*90
      mg=mf+nloop
      mh=mg+nloop*15
      mi=mh+nloop*30
      mj=mi+ncpodp*3
      mk=mj+ncpodp*9
      ml=mk+ncpodp*18
      mm=ml+ncpodp*6
      mn=mm+ncpodp*18
      mo=mn+ncpodp*36
      mp=mo+ncpodp*9
      mq=mp+ncpodp*27
      mr=mq+ncpodp*54
      ms=mr+ncpodp*10
      mt=ms+ncpodp*30
      mu=mt+ncpodp*60
      mv=mu+ncpodp*18
      mw=mv+ncpodp*54
      mx=mw+ncpodp*108
      my=mx+ncpodp*15
      mz=my+ncpodp*45
      na=mz+ncpodp*90
      nb=na+ncpodp*30
      nc=nb+ncpodp*90
      nd=nc+ncpodp*180
      ne=nd+ncpodp*36
      nf=ne+ncpodp*108
      ng=nf+ncpodp*216
      nh=ng+ncpodp*54

      if(nh.gt.nreal) stop 'gradmm dp real overflow'

      call gradxxdp(ncpodp,nloop,ncds,ncdspd,icdlfunc,icdcfunc,
     &              iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(ia),g,coord,
     &              density,gradient,cdfitc,alphacd,coefscd,coefpcd,
     &              coefdcd,wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),
     &              wkvec(jv),wkvec(jz),wkvec(j0),wkvec(j1),wkvec(ka),
     &              wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &              wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &              wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &              wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &              wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),
     &              wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),
     &              wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &              wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),
     &              wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls),wkvec(lt),
     &              wkvec(lu),wkvec(lv),wkvec(lw),wkvec(lx),wkvec(ly),
     &              wkvec(lz),wkvec(ma),wkvec(mb),wkvec(mc),wkvec(md),
     &              wkvec(me),wkvec(mf),wkvec(mg),wkvec(mh),wkvec(mi),
     &              wkvec(mj),wkvec(mk),wkvec(ml),wkvec(mm),wkvec(mn),
     &              wkvec(mo),wkvec(mp),wkvec(mq),wkvec(mr),wkvec(ms),
     &              wkvec(mt),wkvec(mu),wkvec(mv),wkvec(mw),wkvec(mx),
     &              wkvec(my),wkvec(mz),wkvec(na),wkvec(nb),wkvec(nc),
     &              wkvec(nd),wkvec(ne),wkvec(nf),wkvec(ng))

      ja=1
      jb=ja+ncpodd
      jc=jb+nppodd
      jd=jc+ncpodd*36

      ia=jd+ncpodd*2
      ib=ia+nppodd

      if(ib.gt.ninteger) stop 'gradmm dd integer overflow'

      je=1
      jf=je+nppodd
      jg=jf+nppodd
      jh=jg+nppodd
      ji=jh+nppodd
      jj=ji+nppodd
      jk=jj+nppodd
      jl=jk+nppodd
      jm=jl+nppodd
      jn=jm+nppodd
      jo=jn+nppodd
      jp=jo+nppodd
      jq=jp+nppodd
      jr=jq+nppodd
      js=jr+nppodd
      jt=js+nppodd
      ju=jt+nppodd
      jv=ju+nppodd
      jw=jv+nppodd
      jx=jw+nppodd
      jy=jx+nppodd
      jz=jy+nppodd
      j0=jz+ncpodd
      j1=j0+ncpodd
      j2=j1+ncpodd
      j3=j2+nppodd*16

      if(j3.gt.nreal) stop 'gradmm dd real overflow'

      call setupgdd(ncpodd,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &              icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(jd),
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz),wkvec(j0),
     &              wkvec(j1),wkvec(j2))

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                          call stringcopy(n,wkvec(18*n+1),wkvec(jw))
                          call stringcopy(n,wkvec(19*n+1),wkvec(jx))
                          call stringcopy(n,wkvec(20*n+1),wkvec(jy))
                    endif

      call stringcopy(ncpodd,wkvec(21*n+0*ncpodd+1),wkvec(jz))
      call stringcopy(ncpodd,wkvec(21*n+1*ncpodd+1),wkvec(j0))
      call stringcopy(ncpodd,wkvec(21*n+2*ncpodd+1),wkvec(j1))
 
      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+n
      jy=jx+n
      jz=jy+n
      j0=jz+ncpodd
      j1=j0+ncpodd
      j2=j1+ncpodd

      if(myid.eq.0) then
                          isent=0

                          do 1019 islave=0,numprocs-1

                          i1=n-isent
                          i2=numprocs-islave

                          nloop=i1/i2
                          if(mod(i1,i2).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=jb
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv
                          jsend(20)=jw
                          jsend(21)=jx
                          jsend(22)=jy


                          call mpi_bsend(jsend,22,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(jb),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jh),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ji),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jw),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jx),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jy),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          jb=jb+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop
                          jw=jw+nloop
                          jx=jx+nloop
                          jy=jy+nloop

1019                      isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      call mpi_recv(jsend,22,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      jb=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)
      jw=jsend(20)
      jx=jsend(21)
      jy=jsend(22)

      call mpi_recv(iwkvec(jb),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jh),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ji),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jw),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jx),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jy),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop*3
      kf=ke+nloop*3
      kg=kf+nloop*3
      kh=kg+nloop*6
      ki=kh+nloop*6
      kj=ki+nloop*6
      kk=kj+nloop*10
      kl=kk+nloop*10
      km=kl+nloop*18
      kn=km+nloop*18
      ko=kn+nloop*30
      kp=ko+nloop*60
      kq=kp+nloop
      kr=kq+nloop*10
      ks=kr+nloop*18
      kt=ks+ncpodd*18
      ku=kt+ncpodd*60
      kv=ku+ncpodd*108

      if(kv.gt.nreal) stop 'gradmm dd real overflow'

      call gradovdd(nfockdim,ncpodd,nloop,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),iwkvec(jd),density,overlap,gradient,
     &              wkvec(je),wkvec(jh),wkvec(ji),wkvec(jm),wkvec(jn),
     &              wkvec(jp),wkvec(jo),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(ka),wkvec(kb),
     &              wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &              wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &              wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),
     &              wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop*3
      kn=km+nloop*3
      ko=kn+nloop*3
      kp=ko+nloop*3
      kq=kp+nloop*3
      kr=kq+nloop*6
      ks=kr+nloop*6
      kt=ks+nloop*6
      ku=kt+nloop*6
      kv=ku+nloop*10
      kw=kv+nloop*10
      kx=kw+nloop*10
      ky=kx+nloop*15
      kz=ky+nloop*15
      la=kz+nloop*21
      lb=la+nloop
      lc=lb+nloop*10
      ld=lc+ncpodd*3
      le=ld+ncpodd*6
      lf=le+ncpodd*9
      lg=lf+ncpodd*10
      lh=lg+ncpodd*18
      li=lh+ncpodd*18
      lj=li+ncpodd*15
      lk=lj+ncpodd*30
      ll=lk+ncpodd*36
      lm=ll+ncpodd*21
      ln=lm+ncpodd*45
      lo=ln+ncpodd*60
      lp=lo+ncpodd*60
      lq=lp+ncpodd*108

      if(lq.gt.nreal) stop 'gradmm dd real overflow'

      call gradnadd(ncpodd,nloop,ncenters,iwkvec(ja),iwkvec(jb),
     &              iwkvec(jc),iwkvec(jd),g,coord,charge,density,
     &              gradient,wkvec(je),wkvec(jh),wkvec(ji),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jp),wkvec(jt),wkvec(ju),
     &              wkvec(jv),wkvec(jz),wkvec(j0),wkvec(j1),wkvec(ka),
     &              wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &              wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &              wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &              wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),
     &              wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),
     &              wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),
     &              wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &              wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),
     &              wkvec(lp))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop*3
      kx=kw+nloop*3
      ky=kx+nloop*3
      kz=ky+nloop*3
      la=kz+nloop*3
      lb=la+nloop*6
      lc=lb+nloop*6
      ld=lc+nloop*6
      le=ld+nloop*6
      lf=le+nloop*10
      lg=lf+nloop*10
      lh=lg+nloop*10
      li=lh+nloop*15
      lj=li+nloop*15
      lk=lj+nloop*21
      ll=lk+nloop
      lm=ll+nloop*10
      ln=lm+ncpodd*3
      lo=ln+ncpodd*6
      lp=lo+ncpodd*9
      lq=lp+ncpodd*10
      lr=lq+ncpodd*18
      ls=lr+ncpodd*18
      lt=ls+ncpodd*15
      lu=lt+ncpodd*30
      lv=lu+ncpodd*36
      lw=lv+ncpodd*21
      lx=lw+ncpodd*45
      ly=lx+ncpodd*60
      lz=ly+ncpodd*60
      l0=lz+ncpodd*108

      if(l0.gt.nreal) stop 'gradmm dd real overflow'

      call gradcddd(ncpodd,nloop,ncds,icdlfunc,icdcfunc,iwkvec(ja),
     &              iwkvec(jb),iwkvec(jc),iwkvec(jd),iwkvec(ia),g,coord,
     &              density,gradient,cdfitc,alphacd,coefscd,wkvec(je),
     &              wkvec(jh),wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),
     &              wkvec(jp),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jz),
     &              wkvec(j0),wkvec(j1),wkvec(ka),wkvec(kb),wkvec(kc),
     &              wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &              wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &              wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &              wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),
     &              wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),
     &              wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),
     &              wkvec(lh),wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),
     &              wkvec(lm),wkvec(ln),wkvec(lo),wkvec(lp),wkvec(lq),
     &              wkvec(lr),wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),
     &              wkvec(lw),wkvec(lx),wkvec(ly),wkvec(lz))

      ka=j2+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop
      kx=kw+nloop
      ky=kx+nloop
      kz=ky+nloop
      la=kz+nloop
      lb=la+nloop
      lc=lb+nloop*3
      ld=lc+nloop*3
      le=ld+nloop*3
      lf=le+nloop*3
      lg=lf+nloop*3
      lh=lg+nloop*3
      li=lh+nloop*3
      lj=li+nloop*6
      lk=lj+nloop*6
      ll=lk+nloop*6
      lm=ll+nloop*6
      ln=lm+nloop*6
      lo=ln+nloop*6
      lp=lo+nloop*10
      lq=lp+nloop*10
      lr=lq+nloop*10
      ls=lr+nloop*10
      lt=ls+nloop*10
      lu=lt+nloop*15
      lv=lu+nloop*15
      lw=lv+nloop*15
      lx=lw+nloop*15
      ly=lx+nloop*21
      lz=ly+nloop*21
      ma=lz+nloop*21
      mb=ma+nloop*3
      mc=mb+nloop*9
      md=mc+nloop*9
      me=md+nloop*18
      mf=me+nloop*18
      mg=mf+nloop*18
      mh=mg+nloop*36
      mi=mh+nloop*30
      mj=mi+nloop*30
      mk=mj+nloop*60
      ml=mk+nloop*45
      mm=ml+nloop*45
      mn=mm+nloop*90
      mo=mn+nloop*63
      mp=mo+nloop*63
      mq=mp+nloop*126
      mr=mq+nloop
      ms=mr+nloop*21
      mt=ms+nloop*45
      mu=mt+ncpodd*3
      mv=mu+ncpodd*9
      mw=mv+ncpodd*18
      mx=mw+ncpodd*6
      my=mx+ncpodd*18
      mz=my+ncpodd*36
      na=mz+ncpodd*9
      nb=na+ncpodd*27
      nc=nb+ncpodd*54
      nd=nc+ncpodd*10
      ne=nd+ncpodd*30
      nf=ne+ncpodd*60
      ng=nf+ncpodd*18
      nh=ng+ncpodd*54
      ni=nh+ncpodd*108
      nj=ni+ncpodd*18
      nk=nj+ncpodd*54
      nl=nk+ncpodd*108
      nm=nl+ncpodd*15
      nn=nm+ncpodd*45
      no=nn+ncpodd*90
      np=no+ncpodd*30
      nq=np+ncpodd*90
      nr=nq+ncpodd*180
      ns=nr+ncpodd*36
      nt=ns+ncpodd*108
      nu=nt+ncpodd*216
      nv=nu+ncpodd*21
      nw=nv+ncpodd*63
      nx=nw+ncpodd*126
      ny=nx+ncpodd*45
      nz=ny+ncpodd*135
      n0=nz+ncpodd*270
      n1=n0+ncpodd*60
      n2=n1+ncpodd*180
      n3=n2+ncpodd*360
      n4=n3+ncpodd*60
      n5=n4+ncpodd*180
      n6=n5+ncpodd*360
      n7=n6+ncpodd*108

      if(n7.gt.nreal) stop 'gradmm dd real overflow'

      call gradxxdd(ncpodd,nloop,ncds,ncdspd,icdlfunc,icdcfunc,
     &              iwkvec(ja),iwkvec(jb),iwkvec(jc),iwkvec(jd),
     &              iwkvec(ia),g,coord,density,gradient,cdfitc,alphacd,
     &              coefscd,coefpcd,coefdcd,wkvec(je),wkvec(jh),
     &              wkvec(ji),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jp),
     &              wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jz),wkvec(j0),
     &              wkvec(j1),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &              wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &              wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &              wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &              wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &              wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),
     &              wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),
     &              wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),
     &              wkvec(ln),wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),
     &              wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),wkvec(lw),
     &              wkvec(lx),wkvec(ly),wkvec(lz),wkvec(ma),wkvec(mb),
     &              wkvec(mc),wkvec(md),wkvec(me),wkvec(mf),wkvec(mg),
     &              wkvec(mh),wkvec(mi),wkvec(mj),wkvec(mk),wkvec(ml),
     &              wkvec(mm),wkvec(mn),wkvec(mo),wkvec(mp),wkvec(mq),
     &              wkvec(mr),wkvec(ms),wkvec(mt),wkvec(mu),wkvec(mv),
     &              wkvec(mw),wkvec(mx),wkvec(my),wkvec(mz),wkvec(na),
     &              wkvec(nb),wkvec(nc),wkvec(nd),wkvec(ne),wkvec(nf),
     &              wkvec(ng),wkvec(nh),wkvec(ni),wkvec(nj),wkvec(nk),
     &              wkvec(nl),wkvec(nm),wkvec(nn),wkvec(no),wkvec(np),
     &              wkvec(nq),wkvec(nr),wkvec(ns),wkvec(nt),wkvec(nu),
     &              wkvec(nv),wkvec(nw),wkvec(nx),wkvec(ny),wkvec(nz),
     &              wkvec(n0),wkvec(n1),wkvec(n2),wkvec(n3),wkvec(n4),
     &              wkvec(n5),wkvec(n6))

 2001 continue

      call normo(nfockdim,nconts,ncontp,ncontd,
     &           nshels,nshelp,nsheld,mtloca,overlap)

      call mpi_reduce(overlap(1,1),wkvec,nfockdim,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierror)

      if(myid.eq.0) call stringcopy(nfockdim,overlap(1,1),wkvec)

      call mpi_reduce(overlap(1,2),wkvec,nfockdim,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierror)

      if(myid.eq.0) call stringcopy(nfockdim,overlap(1,2),wkvec)

      call mpi_reduce(overlap(1,3),wkvec,nfockdim,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierror)

      if(myid.eq.0) call stringcopy(nfockdim,overlap(1,3),wkvec)

      call mpi_reduce(gradient,wkvec,3*ncenters,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) call stringcopy(3*ncenters,gradient,wkvec)

      call mpi_bcast(overlap,3*nfockdim,mpi_real8,0,mpi_comm_world,ierr)

      return
      end

      subroutine efiss(m,n,icontr,inddyy,esp,efix,efiy,efiz,ccx,ccy,ccz,
     &                 g,density,zeta,px,py,pz,base,ss0,sscond,pxcx,
     &                 pycy,pzcz,u,ss1,saxs0,says0,sazs0,saxscond,
     &                 sayscond,sazscond)

c  this subroutine written by roger gallant and alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(*)

      dimension g(*),density(*),zeta(*),px(*),py(*),pz(*),base(*),
     &          ss0(*),sscond(*),pxcx(*),pycy(*),pzcz(*),u(*),ss1(*),
     &          saxs0(*),says0(*),sazs0(*),saxscond(*),sayscond(*),
     &          sazscond(*)

      data zero,two,three,pi/0.0d0,2.0d0,3.0d0,3.1415926535898d0/

      twopi=two*pi

      do 1001 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1001 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1002 i=1,n
      call augg(2,u(i),g)
      ss0(i)=base(i)*g(1)*twopi/zeta(i)
 1002 ss1(i)=base(i)*g(2)*twopi/zeta(i)

      do 1003 i=1,n
      saxs0(i)=two*zeta(i)*pxcx(i)*ss1(i)
      says0(i)=two*zeta(i)*pycy(i)*ss1(i)
 1003 sazs0(i)=two*zeta(i)*pzcz(i)*ss1(i)

      do 1004 i=1,m
 1004 sscond(i)=zero

      do 1005 i=1,n
 1005 sscond(icontr(i))=sscond(icontr(i))+ss0(i)

      do 1006 i=1,m
      saxscond(i)=zero
      sayscond(i)=zero
 1006 sazscond(i)=zero

      do 1007 i=1,n
      saxscond(icontr(i))=saxscond(icontr(i))+saxs0(i)
      sayscond(icontr(i))=sayscond(icontr(i))+says0(i)
 1007 sazscond(icontr(i))=sazscond(icontr(i))+sazs0(i)

      do 1008 i=1,m
 1008 esp=esp-density(inddyy(i))*sscond(i)

      do 1009 i=1,m
      efix=efix-density(inddyy(i))*saxscond(i)
      efiy=efiy-density(inddyy(i))*sayscond(i)
 1009 efiz=efiz-density(inddyy(i))*sazscond(i)

      return
      end

      subroutine scfrun(nreal,ninteger,nmaxatoms,nmaxorbs,nmaxaux,
     &                  nmaxpoints,nfunctional,maxiterations,idiis,
     &                  ngridtype,natoms,nptcharges,nbsystems,level,
     &                  nalpha,nbeta,nconts,ncontp,ncontd,ncds,ncdspd,
     &                  nxcs,nxcspd,ixcfit,natomtype,nptsatom,nshels,
     &                  nshelp,nsheld,ilfunc,icfunc,mtloca,ngaussian,
     &                  nfuncatom,icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &                  isys,iwkvec,converged,dmixing,eshift,diiserror,
     &                  cutoff,coord,charge,coordpc,ptcharge,core,focka,
     &                  fockb,focke,dmta,dmtb,coeffa,coeffb,alpha,
     &                  coeffs,alphacd,coefscd,coefpcd,coefdcd,alphaxc,
     &                  coefsxc,coefpxc,coefdxc,cdfitc,xcfita,xcfitb,
     &                  xcfite,xcfite_save,tvector,tveca,tvecb,tvece,
     &                  overlapinv,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),mtloca(*),ngaussian(*),nfuncatom(*),
     &          icdlfunc(*),icdcfunc(*),ixclfunc(*),ixccfunc(*),
     &          isys(nmaxatoms,*),iwkvec(*)

      dimension cutoff(*),coord(3,*),charge(*),coordpc(3,*),ptcharge(*),
     &          core(*),focka(*),fockb(*),focke(*),dmta(*),dmtb(*),
     &          coeffa(nmaxorbs,*),coeffb(nmaxorbs,*),alpha(*),
     &          coeffs(*),alphacd(*),coefscd(*),coefpcd(*),coefdcd(*),
     &          alphaxc(*),coefsxc(*),coefpxc(*),coefdxc(*),cdfitc(*),
     &          xcfita(*),xcfitb(*),xcfite(*),xcfite_save(*),tvector(*),
     &          tveca(*),tvecb(*),tvece(*),overlapinv(nmaxorbs,*),
     &          wkvec(*)

      data zero,one,dlarge/0.0d0,1.0d0,1.0d+25/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      call mpi_bcast(natoms,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nptcharges,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nbsystems,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(level,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nalpha,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nbeta,1,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(nconts,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ncontp,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ncontd,1,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(ncds,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ncdspd,1,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(nxcs,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nxcspd,1,mpi_integer,0,mpi_comm_world,ierr)

      ncontractions=nconts+3*ncontp+6*ncontd

      ndim=ncontractions*(ncontractions+1)/2

      ncdfunc=ncds+10*ncdspd
      nxcfunc=nxcs+10*nxcspd

      call mpi_bcast(idiis,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ngridtype,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nfunctional,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(maxiterations,1,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ixcfit,1,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(natomtype,natoms,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(nshels,nconts,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nshelp,ncontp,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(nsheld,ncontd,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(mtloca,ncontractions,
     &               mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ilfunc,ncontractions,
     &               mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(icfunc,ncontractions,
     &               mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ngaussian,ncontractions,
     &               mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(icdlfunc,ncdfunc,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(icdcfunc,ncdfunc,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(ixclfunc,nxcfunc,mpi_integer,0,mpi_comm_world,ierr)
      call mpi_bcast(ixccfunc,nxcfunc,mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(isys,nmaxatoms*nmaxatoms,
     &               mpi_integer,0,mpi_comm_world,ierr)

      call mpi_bcast(converged,1,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(dmixing,1,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(cutoff(1),3,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(coord,3*natoms,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(charge,natoms,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(coordpc,3*nptcharges,
     &               mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(ptcharge,nptcharges,
     &               mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(alpha,10000,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coeffs,10000,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(cdfitc,ncdfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(xcoefa,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(xcoefb,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(xcoefe,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(alphacd,ncdfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coefscd,ncdfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coefpcd,ncdfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coefdcd,ncdfunc,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_bcast(alphaxc,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coefsxc,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coefpxc,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(coefdxc,nxcfunc,mpi_real8,0,mpi_comm_world,ierr)

      e1=zero
      e2=zero

      dmixing_save=dmixing
      eshift_save=eshift
      idiis_save=idiis

      deltanrg=dlarge
      dmaxpc=dlarge

      ihit=0

      do 1001 i=1,maxiterations

      if(deltanrg.le.converged) then
                                      ihit=ihit+1
                                else
                                      ihit=0
                                endif

      if((ihit.ge.2).and.(dmaxpc.le.converged)) goto 1001

      ja=1
      jb=ja+nmaxaux*3
      jc=jb+nmaxaux*3

      call scfcycle(i,nreal-jc,ninteger-nmaxaux,nmaxatoms,nmaxorbs,
     &              nmaxaux,nmaxpoints,idiis,nfunctional,ngridtype,
     &              natoms,nptcharges,nbsystems,level,nalpha,nbeta,
     &              ncontractions,nconts,ncontp,ncontd,ncds,ncdspd,nxcs,
     &              nxcspd,ixcfit,natomtype,nptsatom,nshels,nshelp,
     &              nsheld,mtloca,ilfunc,icfunc,ngaussian,nfuncatom,
     &              icdlfunc,icdcfunc,ixclfunc,ixccfunc,isys,iwkvec(1),
     &              iwkvec(nmaxaux+1),energy,eshift,dmixing,diiserror,
     &              dmaxpc,cutoff,coord,coordpc,charge,ptcharge,core,
     &              focka,fockb,focke,dmta,dmtb,coeffa,coeffb,
     &              overlapinv,alpha,coeffs,alphacd,coefscd,coefpcd,
     &              coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,
     &              xcfita,xcfitb,xcfite,tvector,tveca,tvecb,tvece,
     &              wkvec(ja),wkvec(jb),wkvec(jc))

      e2=e1
      e1=energy

      deltanrg=abs(e2-e1)

      if(dmaxpc.le.converged) then
                                    dmixing=zero
                                    idiis=0
                              endif

      call mpi_bcast(deltanrg,1,mpi_real8,0,mpi_comm_world,ierr)

 1001 continue

      dmixing=dmixing_save
      idiis=idiis_save

      if(deltanrg.le.converged) then
                                      if(myid.eq.0) write(6,1002) 
                                else
                                      if(myid.eq.0) write(6,1003)
                                endif

 1002 format(/,' scf converged!!! :-) :-) :-) ')
 1003 format(/,' scf terminated unsuccessfully??? :-( :-( :-( ')

      if(nalpha.eq.nbeta) then
                                do 1004 j=1,nbeta
                                do 1004 i=1,ncontractions
 1004                           coeffb(i,j)=coeffa(i,j)
                          endif

      call gengrid(nreal,nmaxpoints,ngridtype,0,natoms,nconts,ncontp,
     &             ncontd,ilfunc,icfunc,ngaussian,nshels,nshelp,nsheld,
     &             natomtype,nptsatom,iwkvec,coord,alpha,coeffs,wkvec)

      call mpi_bcast(nptsatom,natoms,mpi_integer,0,mpi_comm_world,ierr)

      ja=1
      jb=ja+3*nxcfunc
      jc=jb+3*nxcfunc
      jd=jc+nxcfunc*nxcfunc

      call gridcall(nreal-jd,nxcfunc,0,-1,nfunctional,natoms,nmaxatoms,
     &              nbsystems,nalpha,nbeta,nconts,ncontp,ncontd,nxcs,
     &              nxcs+nxcspd,nmaxpoints,natomtype,nptsatom,nshels,
     &              nshelp,nsheld,ilfunc,icfunc,ngaussian,ixclfunc,
     &              ixccfunc,isys,iwkvec,iwkvec(nxcfunc+1),dmixing,
     &              cutoff(2),coord,alpha,coeffs,alphaxc,coefsxc,
     &              coefpxc,coefdxc,xcfita,xcfitb,xcfite,dmta,dmtb,
     &              tveca,tvecb,tvece,wkvec(ja),wkvec(jb),wkvec(jc),
     &              focka,fockb,focke,wkvec(jd))

      do 1005 i=1,nxcfunc
 1005 xcfite_save(i)=xcfite(i)

      do 1006 i=1,nxcfunc
 1006 xcfite(i)=zero

      call numxcc(nreal,ninteger,nmaxatoms,nmaxpoints,natoms,nconts,
     &            ncontp,ncontd,ncds,ncdspd,nxcs,nxcspd,nbsystems,level,
     &            iwkvec,mtloca,ilfunc,ngaussian,icfunc,nshels,nshelp,
     &            nsheld,natomtype,nptsatom,icdlfunc,icdcfunc,ixclfunc,
     &            ixccfunc,isys,cutoff(3),wkvec,coord,core,focka,fockb,
     &            focke,alpha,coeffs,alphacd,coefscd,coefpcd,coefdcd,
     &            alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,xcfita,xcfitb,
     &            xcfite)

      do 1007 i=1,nxcfunc
 1007 xcfite(i)=xcfite_save(i)

      call totale(1,ncontractions,ncdfunc,0,nptcharges,natoms,nalpha,
     &            nbeta,nmaxaux,energy,diiserror,dmta,dmtb,focke,coord,
     &            charge,coordpc,ptcharge,wkvec,cdfitc,dmaxpc)

      return
      end

      subroutine dipoless(m,n,icontr,inddyy,density,zeta,px,py,pz,base,
     &                    ss,sscond,dipole)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(*)

      dimension density(*),zeta(*),px(*),py(*),pz(*),base(*),ss(n,*),
     &          sscond(m,*),dipole(*)

      data zero,thrhlf,two,pi/0.0d0,1.5d0,2.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1002 ss(i,3)=pz(i)*base(i)

      do 1003 j=1,3
      do 1003 i=1,m
 1003 sscond(i,j)=zero

      do 1004 j=1,3
      do 1004 i=1,n
 1004 sscond(icontr(i),j)=sscond(icontr(i),j)+ss(i,j)

      do 1005 j=1,3
      do 1005 i=1,m
 1005 dipole(j)=dipole(j)-density(inddyy(i))*sscond(i,j)

      return
      end

      subroutine ddiis(iunit,niteration,ncontractions,dmix,emax,focka,
     &                 fockb,amat,bmat,wkmat1,wkmat2,wkmat3,wkmat4,
     &                 overlap,ematrix,wkvec)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      parameter(maxdiis=200)

      dimension istat(mpi_status_size)

      dimension bmatrix(maxdiis,maxdiis),bbmatrix(maxdiis,maxdiis)

      dimension focka(*),fockb(*),amat(*),bmat(*)

      dimension wkmat1(ncontractions,*),wkmat2(ncontractions,*),
     &          wkmat3(ncontractions,*),wkmat4(ncontractions,*),
     &          overlap(ncontractions,*),ematrix(ncontractions,*),
     &          wkvec(*)

      data zero,half,one,two,startdiis/0.0d0,0.5d0,1.0d0,2.0d0,0.2d0/

      save ndiiss,ndiisw,bmatrix

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      if(niteration.gt.1) goto 1001

      ndiiss=0

      do 1002 i=1,maxdiis
      bmatrix(i,1)=-one
 1002 bmatrix(1,i)=-one

      bmatrix(1,1)=zero

      return

 1001 continue

      if(ndiiss.eq.0) then

                rewind 45

                do 1003 i=1,ncontractions
 1003           if(myid.eq.0) call fastrd(45,overlap(1,i),ncontractions)

                call mpi_bcast(overlap,ncontractions**2,
     &                         mpi_real8,0,mpi_comm_world,ierr)

                ij=0
                do 1004 i=1,ncontractions
                do 1004 j=1,i
                ij=ij+1
                wkmat1(i,j)=focka(ij)
 1004           wkmat1(j,i)=focka(ij)

                ij=0
                do 1005 i=1,ncontractions
                do 1005 j=1,i
                ij=ij+1
                wkmat2(i,j)=half*amat(ij)
 1005           wkmat2(j,i)=half*amat(ij)

                do 1006 i=1,ncontractions
 1006           wkmat2(i,i)=wkmat2(i,i)*two

                call mxmy_mpi(ncontractions,wkmat2,wkmat1,wkmat3)
                call mxmy_mpi(ncontractions,overlap,wkmat3,ematrix)
                call mxmy_mpi(ncontractions,wkmat2,overlap,wkmat3)
                call mxmy_mpi(ncontractions,wkmat1,wkmat3,wkmat4)

                do 1007 j=1,ncontractions
                do 1007 i=1,ncontractions
 1007           ematrix(i,j)=wkmat4(i,j)-ematrix(i,j)

                rewind iunit

                if(myid.eq.0) call fastwr(iunit,
     &                                    wkmat1,ncontractions**2)

                ij=0
                do 1008 i=1,ncontractions
                do 1008 j=1,i
                ij=ij+1
                wkmat1(i,j)=fockb(ij)
 1008           wkmat1(j,i)=fockb(ij)

                ij=0
                do 1009 i=1,ncontractions
                do 1009 j=1,i
                ij=ij+1
                wkmat2(i,j)=half*bmat(ij)
 1009           wkmat2(j,i)=half*bmat(ij)

                do 1010 i=1,ncontractions
 1010           wkmat2(i,i)=wkmat2(i,i)*two

                call mxmy_mpi(ncontractions,wkmat2,wkmat1,wkmat3)
                call mxmy_mpi(ncontractions,overlap,wkmat3,wkmat4)

                do 1011 j=1,ncontractions
                do 1011 i=1,ncontractions
 1011           ematrix(i,j)=ematrix(i,j)-wkmat4(i,j)

                call mxmy_mpi(ncontractions,wkmat2,overlap,wkmat3)
                call mxmy_mpi(ncontractions,wkmat1,wkmat3,wkmat4)

                do 1012 j=1,ncontractions
                do 1012 i=1,ncontractions
 1012           ematrix(i,j)=ematrix(i,j)+wkmat4(i,j)

                rewind iunit+2

                if(myid.eq.0) call fastwr(iunit+2,
     &                                    wkmat1,ncontractions**2)

                rewind iunit+1

                if(myid.eq.0) call fastwr(iunit+1,
     &                                    ematrix,ncontractions**2)

                emax=zero

                do 1013 i=1,ncontractions
                do 1013 j=1,ncontractions
 1013           if(abs(ematrix(i,j)).gt.emax) emax=abs(ematrix(i,j))

                if(emax.gt.startdiis) return

                dmix=one

                ndiiss=1

                ndiisw=niteration

                bmatrix(2,2)=zero

                do 1014 j=1,ncontractions
                do 1014 i=1,ncontractions
 1014           bmatrix(2,2)=bmatrix(2,2)+ematrix(i,j)**2

                return

                      endif

      rewind 45

      do 1015 i=1,ncontractions
 1015 if(myid.eq.0) call fastrd(45,overlap(1,i),ncontractions)

      call mpi_bcast(overlap,ncontractions**2,
     &               mpi_real8,0,mpi_comm_world,ierr)

      ij=0
      do 1016 i=1,ncontractions
      do 1016 j=1,i
      ij=ij+1
      wkmat1(i,j)=focka(ij)
 1016 wkmat1(j,i)=focka(ij)

      ij=0
      do 1017 i=1,ncontractions
      do 1017 j=1,i
      ij=ij+1
      wkmat2(i,j)=half*amat(ij)
 1017 wkmat2(j,i)=half*amat(ij)

      do 1018 i=1,ncontractions
 1018 wkmat2(i,i)=wkmat2(i,i)*two

      call mxmy_mpi(ncontractions,wkmat2,wkmat1,wkmat3)
      call mxmy_mpi(ncontractions,overlap,wkmat3,ematrix)
      call mxmy_mpi(ncontractions,wkmat2,overlap,wkmat3)
      call mxmy_mpi(ncontractions,wkmat1,wkmat3,wkmat4)

      do 1019 j=1,ncontractions
      do 1019 i=1,ncontractions
 1019 ematrix(i,j)=wkmat4(i,j)-ematrix(i,j)

      if(myid.eq.0) endfile iunit
      if(myid.eq.0) backspace iunit

      if(myid.eq.0) call fastwr(iunit,wkmat1,ncontractions**2)

      ij=0
      do 1020 i=1,ncontractions
      do 1020 j=1,i
      ij=ij+1
      wkmat1(i,j)=fockb(ij)
 1020 wkmat1(j,i)=fockb(ij)

      ij=0
      do 1021 i=1,ncontractions
      do 1021 j=1,i
      ij=ij+1
      wkmat2(i,j)=half*bmat(ij)
 1021 wkmat2(j,i)=half*bmat(ij)

      do 1022 i=1,ncontractions
 1022 wkmat2(i,i)=wkmat2(i,i)*two

      call mxmy_mpi(ncontractions,wkmat2,wkmat1,wkmat3)
      call mxmy_mpi(ncontractions,overlap,wkmat3,wkmat4)

      do 1023 j=1,ncontractions
      do 1023 i=1,ncontractions
 1023 ematrix(i,j)=ematrix(i,j)-wkmat4(i,j)

      call mxmy_mpi(ncontractions,wkmat2,overlap,wkmat3)
      call mxmy_mpi(ncontractions,wkmat1,wkmat3,wkmat4)

      do 1024 j=1,ncontractions
      do 1024 i=1,ncontractions
 1024 ematrix(i,j)=ematrix(i,j)+wkmat4(i,j)

      nn_start=ndiisw
      nn_end=niteration

      if(myid.eq.0) then
                          endfile iunit+2
                          backspace iunit+2

                          call fastwr(iunit+2,wkmat1,ncontractions**2)

                          endfile iunit+1
                          backspace iunit+1

                          call fastwr(iunit+1,ematrix,ncontractions**2)

                          rewind iunit+1
                    endif

      do 1025 k=nn_start,nn_end

      if(myid.eq.0) call fastrd(iunit+1,wkmat1,ncontractions**2)

      call mpi_bcast(wkmat1,ncontractions**2,
     &               mpi_real8,0,mpi_comm_world,ierr)

      factor=zero

      do 1026 i=1,ncontractions
      do 1026 j=1,ncontractions
 1026 factor=factor+wkmat1(j,i)*ematrix(j,i)

      bmatrix(k-nn_start+2,niteration-nn_start+2)=factor
      bmatrix(niteration-nn_start+2,k-nn_start+2)=factor

 1025 continue

      nn_stop=niteration-ndiisw+2

      do 1027 i=1,nn_stop
      do 1027 j=1,nn_stop
 1027 bbmatrix(j,i)=bmatrix(j,i)

      do 1028 i=1,nn_stop
 1028 wkvec(i)=zero

      wkvec(1)=-one

      emax=zero

      do 1029 i=1,ncontractions
      do 1029 j=1,ncontractions
 1029 if(abs(ematrix(j,i)).gt.emax) emax=abs(ematrix(j,i))

      ndiisd=nn_stop

      if(nn_stop.gt.02) ndiisd=2
      if(nn_stop.gt.04) ndiisd=3
      if(nn_stop.gt.06) ndiisd=4
      if(nn_stop.gt.08) ndiisd=min(10,nn_stop-4)

      if(nn_stop.gt.ndiisd) then
                                  nnn=nn_stop-ndiisd

                                  do 1030 i=2,ndiisd
                                  do 1030 j=2,ndiisd
 1030                             bbmatrix(i,j)=bmatrix(i+nnn,j+nnn)
                            endif

      ndim=min(ndiisd,nn_stop)

      call matinv(bbmatrix,wkvec,ndim,2,maxdiis)

      if(myid.eq.0) rewind iunit
      if(myid.eq.0) rewind iunit+2

      if(nn_stop.gt.ndiisd) then

                    nnn=nn_stop-ndiisd

                    do 1031 k=1,nnn
 1031               if(myid.eq.0) call fastrd(iunit,wkmat1,1)

                    do 1032 k=1,nnn
 1032               if(myid.eq.0) call fastrd(iunit+2,wkmat1(1,i),1)

                            endif

      do 1033 i=1,ncontractions
      do 1033 j=1,ncontractions
 1033 wkmat1(j,i)=zero

      do 1034 i=1,ncontractions
      do 1034 j=1,ncontractions
 1034 wkmat2(j,i)=zero

      do 1035 k=2,ndim

      if(myid.eq.0) call fastrd(iunit,wkmat3,ncontractions**2)

      call mpi_bcast(wkmat3,ncontractions**2,
     &               mpi_real8,0,mpi_comm_world,ierr)

      if(myid.eq.0) call fastrd(iunit+2,wkmat4,ncontractions**2)

      call mpi_bcast(wkmat4,ncontractions**2,
     &               mpi_real8,0,mpi_comm_world,ierr)

      do 1036 i=1,ncontractions
      do 1036 j=1,ncontractions
 1036 wkmat1(j,i)=wkmat1(j,i)+wkvec(k)*wkmat3(j,i)

      do 1037 i=1,ncontractions
      do 1037 j=1,ncontractions
 1037 wkmat2(j,i)=wkmat2(j,i)+wkvec(k)*wkmat4(j,i)

 1035 continue

      ij=0

      do 1038 i=1,ncontractions
      do 1038 j=1,i
      ij=ij+1
 1038 focka(ij)=wkmat1(j,i)

      ij=0

      do 1039 i=1,ncontractions
      do 1039 j=1,i
      ij=ij+1
 1039 fockb(ij)=wkmat2(j,i)

      return
      end

      subroutine gridgen(ngridtype,nscf,ncenters,nconts,ncontp,ncontd,
     &                   ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,
     &                   natomtype,nptsatom,iwkvec,cent,alpha,coeff,
     &                   xcoord,ycoord,zcoord,weight,dcp,dcc,wtbecke,
     &                   extent)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension slater(105),gcroot(96),gcwght(96)

      dimension coordshell(3,194),wghtshell(194)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension natomtype(*),nptsatom(*),iwkvec(*)

      dimension cent(3,*),alpha(*),coeff(*)

      dimension xcoord(*),ycoord(*),zcoord(*),weight(*)
      dimension dcp(ncenters,*),dcc(ncenters,*),wtbecke(*),extent(*)

      data slater/ 0.35d0, 2.00d0, 1.45d0, 1.05d0, 0.85d0, 0.70d0,
     &             0.65d0, 0.60d0, 0.50d0, 2.25d0, 1.80d0, 1.50d0,
     &             1.25d0, 1.10d0, 1.00d0, 1.00d0, 1.00d0, 2.50d0,
     &             2.20d0, 1.80d0, 1.60d0, 1.40d0, 1.35d0, 1.40d0,
     &             1.40d0, 1.40d0, 1.35d0, 1.35d0, 1.35d0, 1.35d0,
     &             1.30d0, 1.25d0, 1.15d0, 1.15d0, 1.15d0, 2.75d0,
     &             2.35d0, 2.00d0, 1.80d0, 1.55d0, 1.45d0, 1.45d0,
     &             1.35d0, 1.30d0, 1.35d0, 1.40d0, 1.60d0, 1.55d0,
     &             1.55d0, 1.45d0, 1.45d0, 1.40d0, 1.40d0, 3.00d0,
     &             2.60d0, 2.15d0, 1.95d0, 1.85d0, 1.85d0, 1.85d0,
     &             1.85d0, 1.85d0, 1.85d0, 1.80d0, 1.75d0, 1.75d0,
     &             1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.55d0,
     &             1.45d0, 1.35d0, 1.35d0, 1.30d0, 1.35d0, 1.35d0,
     &             1.35d0, 1.50d0, 1.90d0, 1.80d0, 1.60d0, 1.90d0,
     &             1.65d0, 3.25d0, 2.80d0, 2.15d0, 1.95d0, 1.80d0,
     &             1.80d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,
     &             1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0, 1.75d0,
     &             1.75d0, 1.55d0, 1.55d0/

      data zero,half,one,two,four,five/0.0d0,0.5d0,1.0d0,
     &                                 2.0d0,4.0d0,5.0d0/
      data sixteen,twentyone,thirtyfive,one_o_5/16.0d0,21.0d0,
     &                                          35.0d0,105.0d0/
      data tolerance,bohr/0.0000000001d0,0.529177d0/
      data afactor,pi/0.64d0,3.1415926535898d0/
      data alpha1,alpha2,alpha3/0.40d0,1.20d0,2.00d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      nptstotal=0

      if(myid.eq.0) rewind 11

      if(nscf.eq.1) then
                          ncheck=mod(ngridtype,100)
                          if(ncheck.ge.10) nradpts=24
                          if(ncheck.ge.20) nradpts=32
                          if(ncheck.ge.30) nradpts=40
                          if(ncheck.ge.40) nradpts=48
                          if(ncheck.ge.50) nradpts=64
                          if(ncheck.ge.60) nradpts=80
                          if(ncheck.ge.70) nradpts=96
                          ncheck=mod(ngridtype,10)
                          if(ncheck.ge.1) nnangpts=026
                          if(ncheck.ge.2) nnangpts=050
                          if(ncheck.ge.3) nnangpts=110
                          if(ncheck.ge.4) nnangpts=194
                    else
                          ncheck=ngridtype
                          if(ncheck.ge.1000) nradpts=24
                          if(ncheck.ge.2000) nradpts=32
                          if(ncheck.ge.3000) nradpts=40
                          if(ncheck.ge.4000) nradpts=48
                          if(ncheck.ge.5000) nradpts=64
                          if(ncheck.ge.6000) nradpts=80
                          if(ncheck.ge.7000) nradpts=96
                          ncheck=mod(ngridtype,1000)
                          if(ncheck.ge.100) nnangpts=026
                          if(ncheck.ge.200) nnangpts=050
                          if(ncheck.ge.300) nnangpts=110
                          if(ncheck.ge.400) nnangpts=194
                    endif

      call diffuse1(ncenters,nconts,ncontp,ncontd,ilfunc,icfunc,ngauss,
     &              nptrs,nptrp,nptrd,tolerance,alpha,coeff,cent,extent)

      do 1001 jatom=1,ncenters
      do 1001 iatom=1,ncenters
 1001 dcc(iatom,jatom)=dist(cent(1,iatom),cent(1,jatom))

      if(myid.eq.0) then
                          isent=0

                          do 1002 islave=0,numprocs-1

                          ia=ncenters-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(isent,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1002                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      call mpi_recv(isent,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1003 iatom=isent+1,isent+nloop

      if(natomtype(iatom).eq.0) goto 1003

      smallest=one/tolerance

      do 1004 jatom=1,ncenters
      if((jatom.ne.iatom).and.(natomtype(jatom).ne.0)) then

              if(dcc(iatom,jatom).le.smallest) smallest=dcc(iatom,jatom)

                                                       endif
 1004 continue

      smallest=smallest*(one-afactor)*half

      npoints=0

      do 1005 nshell=1,nradpts

      gcroot(nshell)=-cos(real64(nshell)*pi/real64(nradpts+1))

      gcwght(nshell)=(pi/real64(nradpts+1))
      gcwght(nshell)=gcwght(nshell)
     &              *(sin(real64(nshell)*pi/real64(nradpts+1)))**2
      gcwght(nshell)=gcwght(nshell)/sqrt(one-gcroot(nshell)**2)

      halfslater=half*slater(natomtype(iatom))/bohr

      rfactor=(one+gcroot(nshell))/(one-gcroot(nshell))

      radius=halfslater*rfactor

      thickness=two*halfslater/((one-gcroot(nshell))**2)

      volume=four*pi*radius*radius*thickness*gcwght(nshell)

      nangpts=nnangpts

      if(rfactor.le.alpha3) then
                                  if(nnangpts.eq.194) nangpts=110
                                  if(nnangpts.eq.110) nangpts=050
                                  if(nnangpts.eq.050) nangpts=026
                                  if(nnangpts.eq.026) nangpts=012
                            endif

      if(rfactor.le.alpha2) then
                                  if(nnangpts.eq.194) nangpts=050
                                  if(nnangpts.eq.110) nangpts=026
                                  if(nnangpts.eq.050) nangpts=012
                                  if(nnangpts.eq.026) nangpts=012
                            endif

      if(rfactor.le.alpha1) then
                                  if(nnangpts.eq.194) nangpts=26
                                  if(nnangpts.eq.110) nangpts=12
                                  if(nnangpts.eq.050) nangpts=12
                                  if(nnangpts.eq.026) nangpts=12
                            endif

      call points(nangpts,radius,volume,cent(1,iatom),coordshell,
     &            wghtshell)

      do 1006 ipoint=1,nangpts
 1006 dcp(iatom,ipoint)=radius

      do 1005 ipoint=1,nangpts

      do 1007 icenter=1,ncenters
 1007 wtbecke(icenter)=zero

      if(radius.lt.smallest) then
                                   ihits=1
                                   iwkvec(1)=iatom
                                   wtbecke(iatom)=one
                                   goto 1008
                             endif

      ihits=0

      do 1009 icenter=1,ncenters
      rr=(cent(1,icenter)-coordshell(1,ipoint))**2
     &  +(cent(2,icenter)-coordshell(2,ipoint))**2
     &  +(cent(3,icenter)-coordshell(3,ipoint))**2
      if(rr.le.extent(icenter)) then
                                      ihits=ihits+1
                                      iwkvec(ihits)=icenter
                                endif
 1009 continue

      if(ihits.eq.0) goto 1005

      do 1010 icenter=1,ihits
      jcenter=iwkvec(icenter)
 1010 if(jcenter.ne.iatom) dcp(jcenter,ipoint)=dist(cent(1,jcenter),
     &                                         coordshell(1,ipoint))

      do 1011 icenter=1,ihits

      jcenter=iwkvec(icenter)

      if(natomtype(jcenter).eq.0) goto 1011 

      partition=one

      do 1012 kcenter=1,ihits

      lcenter=iwkvec(kcenter)

      if((lcenter.eq.jcenter).or.(natomtype(lcenter).eq.0)) goto 1012

      u=(dcp(jcenter,ipoint)-dcp(lcenter,ipoint))/dcc(jcenter,lcenter)

      if(u.le.(-afactor)) z=-one

      if(abs(u).lt.afactor) z=(thirtyfive*(u/afactor)
     &                        -thirtyfive*(u/afactor)**3
     &                        +twentyone*(u/afactor)**5
     &                        -five*(u/afactor)**7)/sixteen

      if(u.ge.(+afactor)) z=+one

      s=half*(one-z)

      partition=partition*s

 1012 continue

      wtbecke(jcenter)=partition

 1011 continue

 1008 continue

      totalwtbecke=zero

      do 1013 kcenter=1,ihits
      lcenter=iwkvec(kcenter)
 1013 totalwtbecke=totalwtbecke+wtbecke(lcenter)

      wghtshell(ipoint)=wghtshell(ipoint)*wtbecke(iatom)/totalwtbecke

      npoints=npoints+1

      xcoord(npoints)=coordshell(1,ipoint)
      ycoord(npoints)=coordshell(2,ipoint)
      zcoord(npoints)=coordshell(3,ipoint)

      weight(npoints)=wghtshell(ipoint)

 1005 continue

      if(numprocs.eq.1) then

                        nptsatom(iatom)=npoints

                        call fastwr(11,xcoord,nptsatom(iatom))
                        call fastwr(11,ycoord,nptsatom(iatom))
                        call fastwr(11,zcoord,nptsatom(iatom))
                        call fastwr(11,weight,nptsatom(iatom))

                        nptstotal=nptstotal+npoints

                        else

                        call mpi_bsend(npoints,1,mpi_integer,0,
     &                                 5*iatom+1,mpi_comm_world,ierr)

                        call mpi_bsend(xcoord,npoints,mpi_real8,0,
     &                                 5*iatom+2,mpi_comm_world,ierr)
                        call mpi_bsend(ycoord,npoints,mpi_real8,0,
     &                                 5*iatom+3,mpi_comm_world,ierr)
                        call mpi_bsend(zcoord,npoints,mpi_real8,0,
     &                                 5*iatom+4,mpi_comm_world,ierr)
                        call mpi_bsend(weight,npoints,mpi_real8,0,
     &                                 5*iatom+5,mpi_comm_world,ierr)

                        endif

 1003 continue

      if((myid.eq.0).and.(numprocs.gt.1)) then

               do 1014 iatom=1,ncenters

               call mpi_recv(npoints,1,mpi_integer,mpi_any_source,
     &                       5*iatom+1,mpi_comm_world,istat,ierr)

               call mpi_recv(xcoord,npoints,mpi_real8,mpi_any_source,
     &                       5*iatom+2,mpi_comm_world,istat,ierr)
               call mpi_recv(ycoord,npoints,mpi_real8,mpi_any_source,
     &                       5*iatom+3,mpi_comm_world,istat,ierr)
               call mpi_recv(zcoord,npoints,mpi_real8,mpi_any_source,
     &                       5*iatom+4,mpi_comm_world,istat,ierr)
               call mpi_recv(weight,npoints,mpi_real8,mpi_any_source,
     &                       5*iatom+5,mpi_comm_world,istat,ierr)

               nptsatom(iatom)=npoints

               call fastwr(11,xcoord,nptsatom(iatom))
               call fastwr(11,ycoord,nptsatom(iatom))
               call fastwr(11,zcoord,nptsatom(iatom))
               call fastwr(11,weight,nptsatom(iatom))

 1014          nptstotal=nptstotal+npoints

                                          endif

      if(myid.eq.0) write(6,1015) nptstotal
 1015 format(/,' total number of grid points = ',2i9,/)

      return
      end

      subroutine gradxxdp1(m,n,nn,nc,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,pss0,psp0,
     &                     psd0,dss0,dsp0,dsd0,axbx,ayby,azbz,psscond,
     &                     pspcond,psdcond,dsscond,dspcond,dsdcond,
     &                     ppscond,pppcond,ppdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),pss0(n,*),
     &          psp0(n,*),psd0(n,*),dss0(n,*),dsp0(n,*),dsd0(n,*),
     &          axbx(*),ayby(*),azbz(*),psscond(m,*),pspcond(m,*),
     &          psdcond(m,*),dsscond(m,*),dspcond(m,*),dsdcond(m,*),
     &          ppscond(m,*),pppcond(m,*),ppdcond(m,*),grad(m,*)

      data zero,two/0.0d0,2.0d0/

      do 1001 j=1,3
      do 1001 i=1,m
 1001 psscond(i,j)=zero

      do 1002 j=1,6
      do 1002 i=1,m
 1002 dsscond(i,j)=zero

      do 1003 j=1,3
      do 1003 i=1,nn
 1003 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -pss0(i,j)*cdfits

      do 1004 k=1,3
      do 1004 j=1,3
      do 1004 i=1,nn
 1004 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -psp0(i,3*(j-1)+k)*cdfitp(k)

      do 1005 k=1,6
      do 1005 j=1,3
      do 1005 i=1,nn
 1005 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -psd0(i,6*(j-1)+k)*cdfitd(k)

      do 1006 j=1,6
      do 1006 i=1,nn
 1006 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     -dss0(i,j)*cdfits

      do 1007 k=1,3
      do 1007 j=1,6
      do 1007 i=1,nn
 1007 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     -dsp0(i,3*(j-1)+k)*cdfitp(k)

      do 1008 k=1,6
      do 1008 j=1,6
      do 1008 i=1,nn
 1008 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     -dsd0(i,6*(j-1)+k)*cdfitd(k)

      do 1009 i=1,m
      ppscond(i,1)=axbx(i)*psscond(i,1)+dsscond(i,1)
      ppscond(i,2)=ayby(i)*psscond(i,1)+dsscond(i,2)
      ppscond(i,3)=azbz(i)*psscond(i,1)+dsscond(i,3)
      ppscond(i,4)=axbx(i)*psscond(i,2)+dsscond(i,2)
      ppscond(i,5)=ayby(i)*psscond(i,2)+dsscond(i,4)
      ppscond(i,6)=azbz(i)*psscond(i,2)+dsscond(i,5)
      ppscond(i,7)=axbx(i)*psscond(i,3)+dsscond(i,3)
      ppscond(i,8)=ayby(i)*psscond(i,3)+dsscond(i,5)
 1009 ppscond(i,9)=azbz(i)*psscond(i,3)+dsscond(i,6)

      do 1010 i=1,m
      grad(i,01)=ppscond(i,1)*density(inddyy(i,01))*two
      grad(i,02)=ppscond(i,2)*density(inddyy(i,02))*two
      grad(i,03)=ppscond(i,3)*density(inddyy(i,03))*two
      grad(i,04)=ppscond(i,4)*density(inddyy(i,04))
      grad(i,05)=ppscond(i,5)*density(inddyy(i,05))
      grad(i,06)=ppscond(i,6)*density(inddyy(i,06))
      grad(i,07)=ppscond(i,7)*density(inddyy(i,07))
      grad(i,08)=ppscond(i,8)*density(inddyy(i,08))
      grad(i,09)=ppscond(i,9)*density(inddyy(i,09))
      grad(i,10)=ppscond(i,1)*density(inddyy(i,04))
      grad(i,11)=ppscond(i,2)*density(inddyy(i,05))
      grad(i,12)=ppscond(i,3)*density(inddyy(i,06))
      grad(i,13)=ppscond(i,4)*density(inddyy(i,10))*two
      grad(i,14)=ppscond(i,5)*density(inddyy(i,11))*two
      grad(i,15)=ppscond(i,6)*density(inddyy(i,12))*two
      grad(i,16)=ppscond(i,7)*density(inddyy(i,13))
      grad(i,17)=ppscond(i,8)*density(inddyy(i,14))
      grad(i,18)=ppscond(i,9)*density(inddyy(i,15))
      grad(i,19)=ppscond(i,1)*density(inddyy(i,07))
      grad(i,20)=ppscond(i,2)*density(inddyy(i,08))
      grad(i,21)=ppscond(i,3)*density(inddyy(i,09))
      grad(i,22)=ppscond(i,4)*density(inddyy(i,13))
      grad(i,23)=ppscond(i,5)*density(inddyy(i,14))
      grad(i,24)=ppscond(i,6)*density(inddyy(i,15))
      grad(i,25)=ppscond(i,7)*density(inddyy(i,16))*two
      grad(i,26)=ppscond(i,8)*density(inddyy(i,17))*two
 1010 grad(i,27)=ppscond(i,9)*density(inddyy(i,18))*two

      do 1011 k=1,3
      do 1011 j=1,9
      do 1011 i=1,m
 1011 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1012 k=1,3
      do 1012 j=1,9
      do 1012 i=1,m
 1012 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

      do 1013 i=1,m
      grad(i,01)=dsscond(i,1)*density(inddyy(i,01))
      grad(i,02)=dsscond(i,2)*density(inddyy(i,04))
      grad(i,03)=dsscond(i,3)*density(inddyy(i,07))
      grad(i,04)=dsscond(i,4)*density(inddyy(i,10))
      grad(i,05)=dsscond(i,5)*density(inddyy(i,13))
      grad(i,06)=dsscond(i,6)*density(inddyy(i,16))
      grad(i,07)=dsscond(i,1)*density(inddyy(i,02))
      grad(i,08)=dsscond(i,2)*density(inddyy(i,05))
      grad(i,09)=dsscond(i,3)*density(inddyy(i,08))
      grad(i,10)=dsscond(i,4)*density(inddyy(i,11))
      grad(i,11)=dsscond(i,5)*density(inddyy(i,14))
      grad(i,12)=dsscond(i,6)*density(inddyy(i,17))
      grad(i,13)=dsscond(i,1)*density(inddyy(i,03))
      grad(i,14)=dsscond(i,2)*density(inddyy(i,06))
      grad(i,15)=dsscond(i,3)*density(inddyy(i,09))
      grad(i,16)=dsscond(i,4)*density(inddyy(i,12))
      grad(i,17)=dsscond(i,5)*density(inddyy(i,15))
 1013 grad(i,18)=dsscond(i,6)*density(inddyy(i,18))

      do 1014 k=1,3
      do 1014 j=1,6
      do 1014 i=1,m
 1014 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1015 k=1,3
      do 1015 j=1,6
      do 1015 i=1,m
 1015 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

      return
      end

      subroutine surfac(density,scale,c,rad,cn,rn,cpts,potc,natomtype,
     &                  nptsvec,iatomtype,nconlimit,ncentr,maxpts,npts,
     &                  nespts)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

c  origins of this routine:
c
c  this subroutine was lifted from michael connolly's surface program
c  for ucsf graphics systems by u. chandra singh and peter a. kollman
c  and modified for use in quest
c
c  k. m. merz adapted and modified this program for use in ampac and
c  mopac
c
c  ian r. gould further modified this code for use in gaussian 90

      dimension vandwl(100),ciatom(3),centre(3)

      dimension c(3,*),rad(*),cn(3,*),rn(*),cpts(3,*),potc(maxpts,*)

      dimension natomtype(*),iatomtype(*),nptsvec(*)

      logical collid

      data vandwl/1.20d0,1.20d0,1.37d0,1.45d0,1.45d0,1.50d0,
     &            1.50d0,1.40d0,1.35d0,1.30d0,1.57d0,1.36d0,
     &            1.24d0,1.17d0,1.80d0,1.75d0,1.70d0,
     &            17*2.5d0,2.5d0,65*2.5d0/ 

      data zero,bohr,pi,four/0.0d0,0.529177d0,3.1415926535898d0,4.0d0/

      npts=0

      do 1001 iatom=1,ncentr

      iatomtype(iatom)=0

      if(natomtype(iatom).eq.0) goto 1001

      rad(iatom)=scale*vandwl(natomtype(iatom))/bohr

      if(rad(iatom).eq.zero) then

          write(6,1002) iatom
 1002     format(' van der waals radius for atom',i5,' is set to 2.5',/,
     &           ' you may want to supply another value in the',
     &           ' subroutine surfac',/)

                             endif

      iatomtype(iatom)=1

 1001 continue

      do 1003 iatom=1,ncentr

      if(iatomtype(iatom).eq.0) goto 1003

      riatom=rad(iatom)

      ciatom(1)=c(1,iatom)
      ciatom(2)=c(2,iatom)
      ciatom(3)=c(3,iatom)

      nnbr=0

      do 1004 jatom=1,ncentr

      if((iatom.eq.jatom).or.(iatomtype(jatom).eq.0)) goto 1004

      if(dist(ciatom,c(1,jatom)).ge.(riatom+rad(jatom))) goto 1004

      nnbr=nnbr+1

      rn(nnbr)=rad(jatom)

      cn(1,nnbr)=c(1,jatom)
      cn(2,nnbr)=c(2,jatom)
      cn(3,nnbr)=c(3,jatom)

 1004 continue

      ncon=(four*pi*(riatom**2))*density
      if(ncon.gt.nconlimit) ncon=nconlimit

      call genun(cpts,ncon,number)

      do 1005 i=1,number

      centre(1)=ciatom(1)+riatom*cpts(1,i)
      centre(2)=ciatom(2)+riatom*cpts(2,i)
      centre(3)=ciatom(3)+riatom*cpts(3,i)

      if(collid(centre,zero,cn,rn,nnbr)) goto 1005

      npts=npts+1

      if(npts.gt.maxpts) then
                               stop 'too many points in surfac'
                         else
                               potc(npts,1)=ciatom(1)+riatom*cpts(1,i)
                               potc(npts,2)=ciatom(2)+riatom*cpts(2,i)
                               potc(npts,3)=ciatom(3)+riatom*cpts(3,i)
                         endif

      nptsvec(nespts+npts)=iatom

 1005 continue

 1003 continue

      write(66) npts

      call fastwr(66,potc(1,1),npts)
      call fastwr(66,potc(1,2),npts)
      call fastwr(66,potc(1,3),npts)

      return
      end

      subroutine gradxxss(m,n,ncds,ncdspd,ilfunc,icfunc,icontr,inddyy,
     &                    icentr,iicontr,g,coord,density,gradient,
     &                    cdfitc,alphaaux,coeffs,coeffp,coeffd,zeta,
     &                    twozetaa,twozetab,px,py,pz,base,pxax,pyay,
     &                    pzaz,axbx,ayby,azbz,zzeta,ttwozetaa,ttwozetab,
     &                    zetarec,ppx,ppy,ppz,ppxax,ppyay,ppzaz,wxpx,
     &                    wypy,wzpz,wxcx,wycy,wzcz,zetac1,zetac2,u,sss0,
     &                    sss1,sss2,sss3,pss0,pss1,pss2,ssp0,ssp1,ssd0,
     &                    psp0,psp1,psd0,c,c1,c2,ssscond,sspcond,
     &                    ssdcond,psscond,pspcond,psdcond,spscond,
     &                    sppcond,spdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),icontr(*),inddyy(*),icentr(m,*),
     &          iicontr(*)

      dimension cdfitp(3),cdfitd(6)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),coeffp(*),coeffd(*),zeta(*),
     &          twozetaa(*),twozetab(*),px(*),py(*),pz(*),base(*),
     &          pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          zzeta(*),ttwozetaa(*),ttwozetab(*),zetarec(*),ppx(*),
     &          ppy(*),ppz(*),ppxax(*),ppyay(*),ppzaz(*),wxpx(*),
     &          wypy(*),wzpz(*),wxcx(*),wycy(*),wzcz(*),zetac1(*),
     &          zetac2(*),u(*),sss0(*),sss1(*),sss2(*),sss3(*),
     &          pss0(n,*),pss1(n,*),pss2(n,*),ssp0(n,*),ssp1(n,*),
     &          ssd0(n,*),psp0(n,*),psp1(n,*),psd0(n,*),c(*),c1(n,*),
     &          c2(n,*),ssscond(*),sspcond(m,*),ssdcond(m,*),
     &          psscond(m,*),pspcond(m,*),psdcond(m,*),spscond(m,*),
     &          sppcond(m,*),spdcond(m,*),grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      dnormcd=seven/sqrt(three)

      do 1001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(ncds+(naux-1)*10+1)*coeffs(ilaux)

      cdfitp(1)=cdfitc(ncds+(naux-1)*10+2)*coeffp(ilaux)
      cdfitp(2)=cdfitc(ncds+(naux-1)*10+3)*coeffp(ilaux)
      cdfitp(3)=cdfitc(ncds+(naux-1)*10+4)*coeffp(ilaux)

      cdfitd(1)=cdfitc(ncds+(naux-1)*10+05)*coeffd(ilaux)/dnormcd
      cdfitd(2)=cdfitc(ncds+(naux-1)*10+06)*coeffd(ilaux)
      cdfitd(3)=cdfitc(ncds+(naux-1)*10+07)*coeffd(ilaux)
      cdfitd(4)=cdfitc(ncds+(naux-1)*10+08)*coeffd(ilaux)/dnormcd
      cdfitd(5)=cdfitc(ncds+(naux-1)*10+09)*coeffd(ilaux)
      cdfitd(6)=cdfitc(ncds+(naux-1)*10+10)*coeffd(ilaux)/dnormcd

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(4,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(3)/zeta(i)/zetaux
 1004 sss3(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(4)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
      zetac1(i)=zetaux*zetarec(i)
 1006 zetac2(i)=zzeta(i)*zetarec(i)

      do 1007 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 1007 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 1008 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1008 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1009 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1009 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1010 i=1,nn
      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
 1010 pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      do 1011 i=1,nn
      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
 1011 pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      do 1012 i=1,nn
      ssp0(i,1)=wxcx(i)*sss1(i)
      ssp0(i,2)=wycy(i)*sss1(i)
 1012 ssp0(i,3)=wzcz(i)*sss1(i)

      do 1013 i=1,nn
      ssp1(i,1)=wxcx(i)*sss2(i)
      ssp1(i,2)=wycy(i)*sss2(i)
 1013 ssp1(i,3)=wzcz(i)*sss2(i)

      do 1014 i=1,nn
 1014 c(i)=(sss0(i)-zetac2(i)*sss1(i))/(two*zetaux)

      do 1015 i=1,nn
      ssd0(i,1)=wxcx(i)*ssp1(i,1)+c(i)
      ssd0(i,2)=wycy(i)*ssp1(i,1)
      ssd0(i,3)=wzcz(i)*ssp1(i,1)
      ssd0(i,4)=wycy(i)*ssp1(i,2)+c(i)
      ssd0(i,5)=wzcz(i)*ssp1(i,2)
 1015 ssd0(i,6)=wzcz(i)*ssp1(i,3)+c(i)

      do 1016 i=1,nn
 1016 c(i)=half*sss1(i)*zetarec(i)

      do 1017 i=1,nn
      psp0(i,1)=wxcx(i)*pss1(i,1)+c(i)
      psp0(i,2)=wycy(i)*pss1(i,1)
      psp0(i,3)=wzcz(i)*pss1(i,1)
      psp0(i,4)=wxcx(i)*pss1(i,2)
      psp0(i,5)=wycy(i)*pss1(i,2)+c(i)
      psp0(i,6)=wzcz(i)*pss1(i,2)
      psp0(i,7)=wxcx(i)*pss1(i,3)
      psp0(i,8)=wycy(i)*pss1(i,3)
 1017 psp0(i,9)=wzcz(i)*pss1(i,3)+c(i)

      do 1018 i=1,nn
 1018 c(i)=half*sss2(i)*zetarec(i)

      do 1019 i=1,nn
      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
 1019 psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

      do 1020 j=1,3
      do 1020 i=1,nn
 1020 c1(i,j)=(pss0(i,j)-zetac2(i)*pss1(i,j))/(two*zetaux)

      do 1021 j=1,3
      do 1021 i=1,nn
 1021 c2(i,j)=half*ssp1(i,j)*zetarec(i)

      do 1022 i=1,nn
      psd0(i,01)=wxcx(i)*psp1(i,1)+c1(i,1)+c2(i,1)
      psd0(i,02)=wycy(i)*psp1(i,1)
      psd0(i,03)=wzcz(i)*psp1(i,1)
      psd0(i,04)=wycy(i)*psp1(i,2)+c1(i,1)
      psd0(i,05)=wzcz(i)*psp1(i,2)
      psd0(i,06)=wzcz(i)*psp1(i,3)+c1(i,1)
      psd0(i,07)=wxcx(i)*psp1(i,4)+c1(i,2)
      psd0(i,08)=wycy(i)*psp1(i,4)        +c2(i,1)
      psd0(i,09)=wzcz(i)*psp1(i,4)
      psd0(i,10)=wycy(i)*psp1(i,5)+c1(i,2)+c2(i,2)
      psd0(i,11)=wzcz(i)*psp1(i,5)
      psd0(i,12)=wzcz(i)*psp1(i,6)+c1(i,2)
      psd0(i,13)=wxcx(i)*psp1(i,7)+c1(i,3)
      psd0(i,14)=wycy(i)*psp1(i,7)
      psd0(i,15)=wzcz(i)*psp1(i,7)        +c2(i,1)
      psd0(i,16)=wycy(i)*psp1(i,8)+c1(i,3)
      psd0(i,17)=wzcz(i)*psp1(i,8)        +c2(i,2)
 1022 psd0(i,18)=wzcz(i)*psp1(i,9)+c1(i,3)+c2(i,3)

      do 1023 j=1,3
      do 1023 i=1,m
 1023 psscond(i,j)=zero

      do 1024 j=1,3
      do 1024 i=1,nn
 1024 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     +pss0(i,j)*ttwozetaa(i)*cdfits

      do 1025 k=1,3
      do 1025 j=1,3
      do 1025 i=1,nn
 1025 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     +psp0(i,3*(j-1)+k)*ttwozetaa(i)*cdfitp(k)

      do 1026 k=1,6
      do 1026 j=1,3
      do 1026 i=1,nn
 1026 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     +psd0(i,6*(j-1)+k)*ttwozetaa(i)*cdfitd(k)

      do 1027 i=1,m
      grad(i,1)=psscond(i,1)*density(inddyy(i))
      grad(i,2)=psscond(i,2)*density(inddyy(i))
 1027 grad(i,3)=psscond(i,3)*density(inddyy(i))

      do 1028 j=1,3
      do 1028 i=1,m
 1028 gradient(j,nc)=gradient(j,nc)-grad(i,j)

      do 1029 j=1,3
      do 1029 i=1,m
 1029 gradient(j,icentr(i,1))=gradient(j,icentr(i,1))+grad(i,j)

      do 1030 i=1,m
 1030 ssscond(i)=zero

      do 1031 j=1,3
      do 1031 i=1,m
 1031 psscond(i,j)=zero

      do 1032 i=1,nn
 1032 ssscond(iicontr(i))=ssscond(iicontr(i))
     &                   +sss0(i)*ttwozetab(i)*cdfits

      do 1033 j=1,3
      do 1033 i=1,nn
 1033 ssscond(iicontr(i))=ssscond(iicontr(i))
     &                   +ssp0(i,j)*ttwozetab(i)*cdfitp(j)

      do 1034 j=1,6
      do 1034 i=1,nn
 1034 ssscond(iicontr(i))=ssscond(iicontr(i))
     &                   +ssd0(i,j)*ttwozetab(i)*cdfitd(j)

      do 1035 j=1,3
      do 1035 i=1,nn
 1035 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     +pss0(i,j)*ttwozetab(i)*cdfits

      do 1036 k=1,3
      do 1036 j=1,3
      do 1036 i=1,nn
 1036 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     +psp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1037 k=1,6
      do 1037 j=1,3
      do 1037 i=1,nn
 1037 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     +psd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1038 i=1,m
      spscond(i,1)=axbx(i)*ssscond(i)+psscond(i,1)
      spscond(i,2)=ayby(i)*ssscond(i)+psscond(i,2)
 1038 spscond(i,3)=azbz(i)*ssscond(i)+psscond(i,3)

      do 1039 i=1,m
      grad(i,1)=spscond(i,1)*density(inddyy(i))
      grad(i,2)=spscond(i,2)*density(inddyy(i))
 1039 grad(i,3)=spscond(i,3)*density(inddyy(i))

      do 1040 j=1,3
      do 1040 i=1,m
 1040 gradient(j,nc)=gradient(j,nc)-grad(i,j)

      do 1041 j=1,3
      do 1041 i=1,m
 1041 gradient(j,icentr(i,2))=gradient(j,icentr(i,2))+grad(i,j)

 1001 continue

      return
      end

      subroutine perdew_partial(dnstya,dnstyb,dnstyt,gmodt,bval,
     &                          dbdrhoa,dbdrhob,dbdgama,dbdgamb,dbdgamc)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      data perdew1,perdew2/0.001667d0,0.002568d0/
      data perdew3,perdew4,perdew5/10000.0d0,0.11d0,1.745d0/
      data alpha,beta,gamma,delta/0.023266d0,7.389d-6,8.723d0,0.472d0/
      data zero,one,two,three,four/0.0d0,1.0d0,2.0d0,3.0d0,4.0d0/
      data five,six,seven,dnine,thirteen/5.0d0,6.0d0,7.0d0,9.0d0,13.0d0/
      data third,twothirds/0.33333333333333d0,0.66666666666667d0/
      data fourthirds,fivethirds/1.33333333333333d0,1.66666666666667d0/
      data seventhirds/2.33333333333333d0/
      data cutoff/80.0d0/
      data pi/3.1415926535898d0/

      zeta=(dnstya-dnstyb)/dnstyt

      if(zeta.gt.+one) zeta=+one
      if(zeta.lt.-one) zeta=-one

      factor1=sqrt(((one+zeta)/two)**fivethirds
     &            +((one-zeta)/two)**fivethirds)

      factor2=(((one+zeta)/two)**twothirds)
     &       -(((one-zeta)/two)**twothirds)

      d=(two**third)*factor1

      d_1=(one/d)

      dd_1dzeta=-(five/six)*factor2/((two**fourthirds)*(factor1**3))

      dd_1drhoa=+dd_1dzeta*two*dnstyb/(dnstyt**2)
      dd_1drhob=-dd_1dzeta*two*dnstya/(dnstyt**2)

      r=(three/(four*pi*dnstyt))**third

      factor1=perdew2+alpha*r+beta*r*r
      factor2=one+gamma*r+delta*r*r+perdew3*beta*r*r*r
      factor3=alpha+two*beta*r
      factor4=gamma+two*delta*r+three*perdew3*beta*r*r

      cn=perdew1+(factor1/factor2)

      dcndr=(factor3/factor2)-((factor1*factor4)/(factor2**2))

      drdrho=((-four*pi)/dnine)*(three/(four*pi*dnstyt))**fourthirds

      dcdrho=dcndr*drdrho

      rho_43=(one/(dnstyt**fourthirds))

      drho_43drho=(-four/three)*rho_43/dnstyt

      grad2=gmodt**2

      dgrad2dgamaa=one
      dgrad2dgambb=one
      dgrad2dgamab=two

      cinfinity=perdew1+perdew2

      factor1=(one/dnstyt**(seven/six))

      phi=perdew5*perdew4*(cinfinity/cn)*gmodt*factor1

      e_phi=zero
      if(e_phi.lt.cutoff) e_phi=exp(-phi)

      dcn_1drho=(-one/(cn**2))*dcdrho

      drho_76drho=(-seven/six)/(dnstyt**(thirteen/six))

      factor2=-e_phi*perdew5*perdew4*cinfinity*gmodt

      factor3=factor2*factor1*dcn_1drho
      factor4=factor2*(one/cn)*drho_76drho

      dephidrho=factor3+factor4

      factor2=-e_phi*perdew5*perdew4*(cinfinity/cn)*factor1

      dgmodtdgamaa=one/(two*gmodt)
      dgmodtdgambb=one/(two*gmodt)
      dgmodtdgamab=one/gmodt

      dephidgamaa=factor2*dgmodtdgamaa
      dephidgambb=factor2*dgmodtdgambb
      dephidgamab=factor2*dgmodtdgamab

      bval=bval+d_1*e_phi*cn*grad2/(dnstyt**seventhirds)

      factor1a=dd_1drhoa*e_phi*cn*grad2*rho_43
      factor1b=dd_1drhob*e_phi*cn*grad2*rho_43

      factor2=d_1*dephidrho*cn*grad2*rho_43

      factor3=d_1*e_phi*dcdrho*grad2*rho_43

      factor4=d_1*e_phi*cn*grad2*drho_43drho

      dbdrhoa=dbdrhoa+factor1a+factor2+factor3+factor4
      dbdrhob=dbdrhob+factor1b+factor2+factor3+factor4

      factor1aa=d_1*cn*rho_43*e_phi*dgrad2dgamaa
      factor1bb=d_1*cn*rho_43*e_phi*dgrad2dgambb
      factor1ab=d_1*cn*rho_43*e_phi*dgrad2dgamab

      factor2aa=d_1*cn*rho_43*grad2*dephidgamaa
      factor2bb=d_1*cn*rho_43*grad2*dephidgambb
      factor2ab=d_1*cn*rho_43*grad2*dephidgamab

      dbdgama=dbdgama+factor1aa+factor2aa
      dbdgamb=dbdgamb+factor1bb+factor2bb
      dbdgamc=dbdgamc+factor1ab+factor2ab

      return
      end

      subroutine gradnaps(m,n,ncentr,icontr,inddyy,icentr,g,coord,
     &                    charge,density,gradient,zeta,twozetaa,
     &                    twozetab,px,py,pz,base,pxax,pyay,pzaz,axbx,
     &                    ayby,azbz,pxcx,pycy,pzcz,twozeta,u,ss0,ss1,
     &                    ss2,ps0,ps1,ds0,c,sscond,pscond,dscond,ppcond,
     &                    grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),icentr(m,*)

      dimension g(*),coord(3,*),charge(*),density(*),gradient(3,*),
     &          zeta(*),twozetaa(*),twozetab(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          pxcx(*),pycy(*),pzcz(*),twozeta(*),u(*),ss0(*),ss1(*),
     &          ss2(*),ps0(n,*),ps1(n,*),ds0(n,*),c(*),sscond(*),
     &          pscond(m,*),dscond(m,*),ppcond(m,*),grad(m,*)

      data zero,two,three,four,pi/0.0d0,2.0d0,
     &                            3.0d0,4.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 1003 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1003 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1004 i=1,n
      call augg(3,u(i),g)
      ss0(i)=base(i)*g(1)*twopichrg/zeta(i)
      ss1(i)=base(i)*g(2)*twopichrg/zeta(i)
 1004 ss2(i)=base(i)*g(3)*twopichrg/zeta(i)

      do 1005 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 1005 ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      do 1006 i=1,n
      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
 1006 ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      do 1007 i=1,n
 1007 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1008 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1008 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1009 i=1,m
 1009 sscond(i)=zero

      do 1010 i=1,n
 1010 sscond(icontr(i))=sscond(icontr(i))-ss0(i)

      do 1011 j=1,3
      do 1011 i=1,m
 1011 grad(i,j)=sscond(i)*density(inddyy(i,j))

      do 1012 j=1,3
      do 1012 i=1,m
 1012 gradient(j,nn)=gradient(j,nn)+grad(i,j)

      do 1013 j=1,3
      do 1013 i=1,m
 1013 gradient(j,icentr(i,1))=gradient(j,icentr(i,1))-grad(i,j)

      do 1014 j=1,6
      do 1014 i=1,m
 1014 dscond(i,j)=zero

      do 1015 j=1,6
      do 1015 i=1,n
 1015 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)*twozetaa(i)

      do 1016 i=1,m
      grad(i,1)=dscond(i,1)*density(inddyy(i,1))
      grad(i,2)=dscond(i,2)*density(inddyy(i,2))
      grad(i,3)=dscond(i,3)*density(inddyy(i,3))
      grad(i,4)=dscond(i,2)*density(inddyy(i,1))
      grad(i,5)=dscond(i,4)*density(inddyy(i,2))
      grad(i,6)=dscond(i,5)*density(inddyy(i,3))
      grad(i,7)=dscond(i,3)*density(inddyy(i,1))
      grad(i,8)=dscond(i,5)*density(inddyy(i,2))
 1016 grad(i,9)=dscond(i,6)*density(inddyy(i,3))

      do 1017 k=1,3
      do 1017 j=1,3
      do 1017 i=1,m
 1017 gradient(k,nn)=gradient(k,nn)+grad(i,3*(k-1)+j)

      do 1018 k=1,3
      do 1018 j=1,3
      do 1018 i=1,m
 1018 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,3*(k-1)+j)

      do 1019 j=1,3
      do 1019 i=1,m
 1019 pscond(i,j)=zero

      do 1020 j=1,6
      do 1020 i=1,m
 1020 dscond(i,j)=zero

      do 1021 j=1,3
      do 1021 i=1,n
 1021 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)*twozetab(i)

      do 1022 j=1,6
      do 1022 i=1,n
 1022 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)*twozetab(i)

      do 1023 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1023 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1024 i=1,m
      grad(i,1)=ppcond(i,1)*density(inddyy(i,1))
      grad(i,2)=ppcond(i,4)*density(inddyy(i,2))
      grad(i,3)=ppcond(i,7)*density(inddyy(i,3))
      grad(i,4)=ppcond(i,2)*density(inddyy(i,1))
      grad(i,5)=ppcond(i,5)*density(inddyy(i,2))
      grad(i,6)=ppcond(i,8)*density(inddyy(i,3))
      grad(i,7)=ppcond(i,3)*density(inddyy(i,1))
      grad(i,8)=ppcond(i,6)*density(inddyy(i,2))
 1024 grad(i,9)=ppcond(i,9)*density(inddyy(i,3))

      do 1025 k=1,3
      do 1025 j=1,3
      do 1025 i=1,m
 1025 gradient(k,nn)=gradient(k,nn)+grad(i,3*(k-1)+j)

      do 1026 k=1,3
      do 1026 j=1,3
      do 1026 i=1,m
 1026 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,3*(k-1)+j)

 1002 continue

      return
      end

      subroutine numxcc(nreal,ninteger,nmaxatoms,nmaxpoints,natoms,
     &                  nconts,ncontp,ncontd,ncds,ncdspd,nxcs,nxcspd,
     &                  nbsystems,level,iwkvec,mtloca,ilfunc,ngauss,
     &                  icfunc,nptrs,nptrp,nptrd,natomtype,nptsatom,
     &                  icdlfunc,icdcfunc,ixclfunc,ixccfunc,isys,cutoff,
     &                  wkvec,coord,core,fock1,fock2,fock3,alpha,coeff,
     &                  alphacd,coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &                  coefpxc,coefdxc,cdfitc,xcfit1,xcfit2,xcfit3)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension iwkvec(*),mtloca(*),ilfunc(*),ngauss(*),icfunc(*),
     &          nptrs(*),nptrp(*),nptrd(*),natomtype(*),nptsatom(*),
     &          icdlfunc(*),icdcfunc(*),ixclfunc(*),ixccfunc(*),
     &          isys(nmaxatoms,*)

      dimension wkvec(*),core(*),fock1(*),fock2(*),fock3(*),coord(3,*),
     &          alpha(*),coeff(*),alphacd(*),coefscd(*),coefpcd(*),
     &          coefdcd(*),alphaxc(*),coefsxc(*),coefpxc(*),coefdxc(*),
     &          cdfitc(*),xcfit1(*),xcfit2(*),xcfit3(*)

      data zero,one/0.0d0,1.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ncntrt=nconts+3*ncontp+6*ncontd

      ncntsq=ncntrt*(ncntrt+1)/2

      do 1001 i=1,ncntsq
      fock1(i)=zero
      fock2(i)=zero
 1001 fock3(i)=zero

      ncdfunc=ncds+10*ncdspd
      nxcfunc=nxcs+10*nxcspd

      call twoemm(nreal-3*ncntsq,ninteger,nconts,ncontp,ncontd,ncds,
     &            ncdspd,nxcs,nxcspd,nptrs,nptrp,nptrd,mtloca,ilfunc,
     &            ngauss,icfunc,icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &            iwkvec,cutoff,coord,alpha,coeff,alphacd,coefscd,
     &            coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,
     &            cdfitc,xcfit1,xcfit2,xcfit3,wkvec(1),fock1,fock2,
     &            fock3,wkvec(2*ncntsq+1),wkvec(3*ncntsq+1))

      do 1002 i=1,ncntsq
      fock1(i)=fock1(i)+core(i)
      fock2(i)=fock2(i)+core(i)
 1002 fock3(i)=fock3(i)+core(i)

      nstart=min(512,32*numprocs)

      npoints=nstart+16

 1003 npoints=npoints-16

      if(npoints.le.0) stop 'numxcc real overflow'

      ja=1
      jb=ja+nmaxpoints
      jc=jb+nmaxpoints
      jd=jc+nmaxpoints
      je=jd+nmaxpoints
      jf=je+nmaxpoints
      jg=jf+nmaxpoints
      jh=jg+nmaxpoints
      ji=jh+npoints
      jj=ji+npoints
      jk=jj+npoints
      jl=jk+ncntrt*npoints
      jm=jl+ncntrt*npoints
      jn=jm+nconts+ncontp+ncontd
      jo=jn+natoms
      jp=jo+ncntrt
      jq=jp+natoms*natoms
      jr=jq+(ncntrt*(ncntrt+1))/2
      js=jr+(ncntrt*(ncntrt+1))/2
      jt=js+(ncntrt*(ncntrt+1))/2

      if((jt+12*npoints).gt.nreal) goto 1003

      call numxc(npoints,natoms,ncntrt,nconts,ncontp,ncontd,ilfunc,
     &           icfunc,ngauss,nptrs,nptrp,nptrd,natomtype,nptsatom,
     &           iwkvec,coord,alpha,coeff,fock1,fock2,fock3,wkvec(ja),
     &           wkvec(jb),wkvec(jc),wkvec(jd),wkvec(je),wkvec(jf),
     &           wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &           wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &           wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt))

      return
      end

      subroutine get_bmatrix(natoms,nmodes,nbonds,nangles,ndihedrals,
     &                       nimpropers,i_bond,i_angle,i_dihedral,
     &                       i_improper,coord,bmatrix)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)  

      dimension i_bond(2,*),i_angle(3,*),i_dihedral(4,*),i_improper(4,*)

      dimension coord(3,*),bmatrix(nmodes,*)

      dimension vec12(3),vec31(3),vec32(3),vec23(3),vec34(3),vec43(3),
     &          vec21(3),vec41(3),vec42(3),veca(3),vecb(3),vecc(3)

      data zero,one/0.0d0,1.0d0/

      do 1001 i=1,3*natoms
      do 1001 j=1,nmodes
 1001 bmatrix(j,i)=zero

      do 1002 i=1,nbonds

      natom1=i_bond(1,i)
      natom2=i_bond(2,i)

      iloc1=3*(natom1-1)
      iloc2=3*(natom2-1)

      call unitvec(vec12,coord(1,natom1),coord(1,natom2))

      do 1003 k=1,3
      bmatrix(i,iloc1+k)=-vec12(k)
 1003 bmatrix(i,iloc2+k)=+vec12(k)

 1002 continue

      do 1004 i=1,nangles

      natom1=i_angle(1,i)
      natom2=i_angle(2,i)
      natom3=i_angle(3,i)

      iloc1=3*(natom1-1)
      iloc2=3*(natom2-1)
      iloc3=3*(natom3-1)

      call unitvec(vec31,coord(1,natom2),coord(1,natom1))
      call unitvec(vec32,coord(1,natom2),coord(1,natom3))

      dist31=dist(coord(1,natom2),coord(1,natom1))
      dist32=dist(coord(1,natom2),coord(1,natom3))

      cos_phi=dot(3,vec31,vec32)
      sin_phi=sqrt(one-cos_phi*cos_phi)

      do 1005 k=1,3
      bmatrix(nbonds+i,iloc1+k)=+(cos_phi*vec31(k)-vec32(k))
     &                          /(dist31*sin_phi)
      bmatrix(nbonds+i,iloc2+k)=+((dist31-dist32*cos_phi)*vec31(k)
     &                           +(dist32-dist31*cos_phi)*vec32(k))
     &                          /(dist31*dist32*sin_phi)
 1005 bmatrix(nbonds+i,iloc3+k)=+(cos_phi*vec32(k)-vec31(k))
     &                          /(dist32*sin_phi)

 1004 continue

      do 1006 i=1,ndihedrals

      natom1=i_dihedral(1,i)
      natom2=i_dihedral(2,i)
      natom3=i_dihedral(3,i)
      natom4=i_dihedral(4,i)

      iloc1=3*(natom1-1)
      iloc2=3*(natom2-1)
      iloc3=3*(natom3-1)
      iloc4=3*(natom4-1)

      call unitvec(vec12,coord(1,natom1),coord(1,natom2))
      call unitvec(vec23,coord(1,natom2),coord(1,natom3))
      call unitvec(vec34,coord(1,natom3),coord(1,natom4))

      call unitvec(vec43,coord(1,natom4),coord(1,natom3))
      call unitvec(vec32,coord(1,natom3),coord(1,natom2))
      call unitvec(vec21,coord(1,natom2),coord(1,natom1))

      cos_phi2=dot(3,vec21,vec23)
      cos_phi3=dot(3,vec32,vec34)

      sin_phi2=sqrt(one-cos_phi2*cos_phi2)
      sin_phi3=sqrt(one-cos_phi3*cos_phi3)

      call crossprod(veca,vec12,vec23)
      call crossprod(vecb,vec43,vec32)

      dist12=dist(coord(1,natom1),coord(1,natom2))
      dist23=dist(coord(1,natom2),coord(1,natom3))
      dist34=dist(coord(1,natom3),coord(1,natom4))

      factor1=(dist23-dist12*cos_phi2)/(dist23*dist12*sin_phi2*sin_phi2)
      factor2=cos_phi3/(dist23*sin_phi3*sin_phi3)
      factor3=(dist23-dist34*cos_phi3)/(dist23*dist34*sin_phi3*sin_phi3)
      factor4=cos_phi2/(dist23*sin_phi2*sin_phi2)

      do 1007 k=1,3
      bmatrix(nbonds+nangles+i,iloc1+k)=-veca(k)
     &                                  /(dist12*sin_phi2*sin_phi2)
      bmatrix(nbonds+nangles+i,iloc2+k)=factor1*veca(k)+factor2*vecb(k)
      bmatrix(nbonds+nangles+i,iloc3+k)=factor3*vecb(k)+factor4*veca(k)
 1007 bmatrix(nbonds+nangles+i,iloc4+k)=-vecb(k)
     &                                  /(dist34*sin_phi3*sin_phi3)

 1006 continue

      do 1008 i=1,nimpropers

      natom1=i_improper(1,i)
      natom2=i_improper(2,i)
      natom3=i_improper(3,i)
      natom4=i_improper(4,i)

      iloc1=3*(natom1-1)
      iloc2=3*(natom2-1)
      iloc3=3*(natom3-1)
      iloc4=3*(natom4-1)

      phi_1=dang(coord(1,natom2),coord(1,natom4),coord(1,natom3))

      theta=dimp(coord(1,natom1),coord(1,natom2),
     &           coord(1,natom3),coord(1,natom4))

      den=cos(theta)*sin(phi_1)

      fact1=tan(theta)
      fact2=tan(theta)/(sin(phi_1)**2)
      fact3=cos(phi_1)

      d41=one/dist(coord(1,natom4),coord(1,natom1))
      d42=one/dist(coord(1,natom4),coord(1,natom2))
      d43=one/dist(coord(1,natom4),coord(1,natom3))

      call unitvec(vec41,coord(1,natom4),coord(1,natom1))
      call unitvec(vec42,coord(1,natom4),coord(1,natom2))
      call unitvec(vec43,coord(1,natom4),coord(1,natom3))

      call crossprod(veca,vec42,vec43)
      call crossprod(vecb,vec43,vec41)
      call crossprod(vecc,vec41,vec42)

      ii=nbonds+nangles+ndihedrals+i

      do 1009 k=1,3
      bmatrix(ii,iloc1+k)=+d41*((veca(k)/den)-fact1*vec41(k))
      bmatrix(ii,iloc2+k)=+d42*((vecb(k)/den)
     &                    -fact2*(vec42(k)-fact3*vec43(k)))
      bmatrix(ii,iloc3+k)=+d43*((vecc(k)/den)
     &                    -fact2*(vec43(k)-fact3*vec42(k)))
 1009 bmatrix(ii,iloc4+k)=-d41*((veca(k)/den)-fact1*vec41(k))
     &                    -d42*((vecb(k)/den)
     &                    -fact2*(vec42(k)-fact3*vec43(k)))
     &                    -d43*((vecc(k)/den)
     &                    -fact2*(vec43(k)-fact3*vec42(k)))

 1008 continue

      return
      end

      subroutine bound(n,x,y,z,x1,x2,y1,y2,z1,z2)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension x(*),y(*),z(*)

      data hugepos,hugeneg/+1.0d+35,-1.0d+35/

      x1=hugepos
      x2=hugeneg
      y1=hugepos
      y2=hugeneg
      z1=hugepos
      z2=hugeneg

      do 1001 i=1,n
      if(x(i).lt.x1) x1=x(i)
      if(x(i).gt.x2) x2=x(i)
      if(y(i).lt.y1) y1=y(i)
      if(y(i).gt.y2) y2=y(i)
      if(z(i).lt.z1) z1=z(i)
 1001 if(z(i).gt.z2) z2=z(i)

      return
      end

      subroutine gradnads(m,n,ncentr,icontr,inddyy,icentr,g,coord,
     &                    charge,density,gradient,zeta,twozetaa,
     &                    twozetab,px,py,pz,base,pxax,pyay,pzaz,axbx,
     &                    ayby,azbz,pxcx,pycy,pzcz,twozeta,u,ss0,ss1,
     &                    ss2,ss3,ps0,ps1,ps2,ds0,ds1,fs0,c,c1,pscond,
     &                    dscond,fscond,dpcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),icentr(m,*)

      dimension g(*),coord(3,*),charge(*),density(*),gradient(3,*),
     &          zeta(*),twozetaa(*),twozetab(*),px(*),py(*),pz(*),
     &          base(*),pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          pxcx(*),pycy(*),pzcz(*),twozeta(*),u(*),ss0(*),ss1(*),
     &          ss2(*),ss3(*),ps0(n,*),ps1(n,*),ps2(n,*),ds0(n,*),
     &          ds1(n,*),fs0(n,*),c(*),c1(n,*),pscond(m,*),dscond(m,*),
     &          fscond(m,*),dpcond(m,*),grad(m,*)

      data zero,two,three,four,pi/0.0d0,2.0d0,
     &                            3.0d0,4.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 1003 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1003 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1004 i=1,n
      call augg(4,u(i),g)
      ss0(i)=base(i)*g(1)*twopichrg/zeta(i)
      ss1(i)=base(i)*g(2)*twopichrg/zeta(i)
      ss2(i)=base(i)*g(3)*twopichrg/zeta(i)
 1004 ss3(i)=base(i)*g(4)*twopichrg/zeta(i)

      do 1005 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 1005 ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      do 1006 i=1,n
      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
 1006 ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      do 1007 i=1,n
      ps2(i,1)=pxax(i)*ss2(i)-pxcx(i)*ss3(i)
      ps2(i,2)=pyay(i)*ss2(i)-pycy(i)*ss3(i)
 1007 ps2(i,3)=pzaz(i)*ss2(i)-pzcz(i)*ss3(i)

      do 1008 i=1,n
 1008 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1009 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1009 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1010 i=1,n
 1010 c(i)=(ss1(i)-ss2(i))/twozeta(i)

      do 1011 i=1,n
      ds1(i,1)=pxax(i)*ps1(i,1)-pxcx(i)*ps2(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps1(i,1)-pycy(i)*ps2(i,1)
      ds1(i,3)=pzaz(i)*ps1(i,1)-pzcz(i)*ps2(i,1)
      ds1(i,4)=pyay(i)*ps1(i,2)-pycy(i)*ps2(i,2)+c(i)
      ds1(i,5)=pzaz(i)*ps1(i,2)-pzcz(i)*ps2(i,2)
 1011 ds1(i,6)=pzaz(i)*ps1(i,3)-pzcz(i)*ps2(i,3)+c(i)

      do 1012 j=1,3
      do 1012 i=1,n
 1012 c1(i,j)=(ps0(i,j)-ps1(i,j))/twozeta(i)

      do 1013 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)-pxcx(i)*ds1(i,1)+c1(i,1)*two
      fs0(i,02)=pyay(i)*ds0(i,1)-pycy(i)*ds1(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)-pzcz(i)*ds1(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)-pycy(i)*ds1(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)-pzcz(i)*ds1(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)-pzcz(i)*ds1(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)-pycy(i)*ds1(i,4)+c1(i,2)*two
      fs0(i,08)=pzaz(i)*ds0(i,4)-pzcz(i)*ds1(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)-pzcz(i)*ds1(i,5)+c1(i,2)
 1013 fs0(i,10)=pzaz(i)*ds0(i,6)-pzcz(i)*ds1(i,6)+c1(i,3)*two

      do 1014 j=1,3
      do 1014 i=1,m
 1014 pscond(i,j)=zero

      do 1015 j=1,3
      do 1015 i=1,n
 1015 pscond(icontr(i),j)=pscond(icontr(i),j)-ps0(i,j)

      do 1016 i=1,m
      grad(i,1)=pscond(i,1)*density(inddyy(i,1))*two
      grad(i,2)=pscond(i,2)*density(inddyy(i,2))
      grad(i,3)=pscond(i,3)*density(inddyy(i,3))
      grad(i,4)=pscond(i,1)*density(inddyy(i,2))
      grad(i,5)=pscond(i,2)*density(inddyy(i,4))*two
      grad(i,6)=pscond(i,3)*density(inddyy(i,5))
      grad(i,7)=pscond(i,1)*density(inddyy(i,3))
      grad(i,8)=pscond(i,2)*density(inddyy(i,5))
 1016 grad(i,9)=pscond(i,3)*density(inddyy(i,6))*two

      do 1017 k=1,3
      do 1017 j=1,3
      do 1017 i=1,m
 1017 gradient(k,nn)=gradient(k,nn)+grad(i,3*(k-1)+j)

      do 1018 k=1,3
      do 1018 j=1,3
      do 1018 i=1,m
 1018 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,3*(k-1)+j)

      do 1019 j=1,10
      do 1019 i=1,m
 1019 fscond(i,j)=zero

      do 1020 j=1,10
      do 1020 i=1,n
 1020 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)*twozetaa(i)

      do 1021 i=1,m
      grad(i,01)=fscond(i,01)*density(inddyy(i,1))
      grad(i,02)=fscond(i,02)*density(inddyy(i,2))
      grad(i,03)=fscond(i,03)*density(inddyy(i,3))
      grad(i,04)=fscond(i,04)*density(inddyy(i,4))
      grad(i,05)=fscond(i,05)*density(inddyy(i,5))
      grad(i,06)=fscond(i,06)*density(inddyy(i,6))
      grad(i,07)=fscond(i,02)*density(inddyy(i,1))
      grad(i,08)=fscond(i,04)*density(inddyy(i,2))
      grad(i,09)=fscond(i,05)*density(inddyy(i,3))
      grad(i,10)=fscond(i,07)*density(inddyy(i,4))
      grad(i,11)=fscond(i,08)*density(inddyy(i,5))
      grad(i,12)=fscond(i,09)*density(inddyy(i,6))
      grad(i,13)=fscond(i,03)*density(inddyy(i,1))
      grad(i,14)=fscond(i,05)*density(inddyy(i,2))
      grad(i,15)=fscond(i,06)*density(inddyy(i,3))
      grad(i,16)=fscond(i,08)*density(inddyy(i,4))
      grad(i,17)=fscond(i,09)*density(inddyy(i,5))
 1021 grad(i,18)=fscond(i,10)*density(inddyy(i,6))

      do 1022 k=1,3
      do 1022 j=1,6
      do 1022 i=1,m
 1022 gradient(k,nn)=gradient(k,nn)+grad(i,6*(k-1)+j)

      do 1023 k=1,3
      do 1023 j=1,6
      do 1023 i=1,m
 1023 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,6*(k-1)+j)

      do 1024 j=1,6
      do 1024 i=1,m
 1024 dscond(i,j)=zero

      do 1025 j=1,10
      do 1025 i=1,m
 1025 fscond(i,j)=zero

      do 1026 j=1,6
      do 1026 i=1,n
 1026 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)*twozetab(i)

      do 1027 j=1,10
      do 1027 i=1,n
 1027 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)*twozetab(i)

      do 1028 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1028 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1029 i=1,m
      grad(i,01)=dpcond(i,01)*density(inddyy(i,1))
      grad(i,02)=dpcond(i,04)*density(inddyy(i,2))
      grad(i,03)=dpcond(i,07)*density(inddyy(i,3))
      grad(i,04)=dpcond(i,10)*density(inddyy(i,4))
      grad(i,05)=dpcond(i,13)*density(inddyy(i,5))
      grad(i,06)=dpcond(i,16)*density(inddyy(i,6))
      grad(i,07)=dpcond(i,02)*density(inddyy(i,1))
      grad(i,08)=dpcond(i,05)*density(inddyy(i,2))
      grad(i,09)=dpcond(i,08)*density(inddyy(i,3))
      grad(i,10)=dpcond(i,11)*density(inddyy(i,4))
      grad(i,11)=dpcond(i,14)*density(inddyy(i,5))
      grad(i,12)=dpcond(i,17)*density(inddyy(i,6))
      grad(i,13)=dpcond(i,03)*density(inddyy(i,1))
      grad(i,14)=dpcond(i,06)*density(inddyy(i,2))
      grad(i,15)=dpcond(i,09)*density(inddyy(i,3))
      grad(i,16)=dpcond(i,12)*density(inddyy(i,4))
      grad(i,17)=dpcond(i,15)*density(inddyy(i,5))
 1029 grad(i,18)=dpcond(i,18)*density(inddyy(i,6))

      do 1030 k=1,3
      do 1030 j=1,6
      do 1030 i=1,m
 1030 gradient(k,nn)=gradient(k,nn)+grad(i,6*(k-1)+j)

      do 1031 k=1,3
      do 1031 j=1,6
      do 1031 i=1,m
 1031 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,6*(k-1)+j)

 1002 continue

      return
      end

      subroutine find_ints(natoms,nbonds,nangles,ndihedrals,nimpropers,
     &                     natomtype,i_bond,i_angle,i_dihedral,
     &                     i_improper,iwkmat,coord)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension radii(0:54),radius(0:54)

      dimension natomtype(*),i_bond(2,*),i_angle(3,*),i_dihedral(4,*),
     &          i_improper(4,*),iwkmat(natoms,*)

      dimension coord(3,*)

      data zero,bohr,ang_cutoff,one80,fact/0.0d0,0.529177d0,
     &                                     170.0d0,180.0d0,1.3d0/
      data perturb/0.99999d0/

      data radii/1.00d0,0.32d0,0.60d0,1.20d0,1.05d0,0.81d0,0.77d0,
     &                  0.74d0,0.74d0,0.72d0,0.72d0,1.50d0,1.40d0,
     &                  1.30d0,1.17d0,1.10d0,1.04d0,0.99d0,0.99d0,
     &                  1.80d0,1.60d0,1.40d0,1.40d0,1.40d0,1.40d0,
     &                  1.40d0,1.40d0,1.40d0,1.40d0,1.40d0,1.40d0,
     &                  1.40d0,1.30d0,1.20d0,1.20d0,1.10d0,1.10d0,
     &                  2.20d0,2.00d0,1.60d0,1.60d0,1.60d0,1.60d0,
     &                  1.60d0,1.60d0,1.60d0,1.60d0,1.60d0,1.60d0,
     &                  1.55d0,1.45d0,1.45d0,1.40d0,1.40d0,1.40d0/

      do 1001 i=0,54
 1001 radius(i)=radii(i)/bohr

      nbonds=0
      nangles=0
      ndihedrals=0
      nimpropers=0

      do 1002 i=1,natoms
      do 1002 j=1,i

      if(i.eq.j) goto 1002

      r_ab=fact*(radius(natomtype(i))+radius(natomtype(j)))

      if(dist(coord(1,i),coord(1,j)).le.r_ab) then
                                                    nbonds=nbonds+1

                                                    i_bond(1,nbonds)=i
                                                    i_bond(2,nbonds)=j
                                              endif

 1002 continue

      do 1003 j=1,natoms
      do 1004 i=1,natoms
 1004 iwkmat(i,j)=0
 1003 iwkmat(j,j)=1

 1005 continue

      do 1006 i=1,nbonds

      ii=i_bond(1,i)
      jj=i_bond(2,i)

      iwkmat(ii,jj)=1
      iwkmat(jj,ii)=1

      do 1007 j=1,natoms
 1007 iwkmat(j,ii)=iwkmat(j,ii)+iwkmat(j,jj)

      do 1008 j=1,natoms
 1008 iwkmat(j,jj)=iwkmat(j,ii)

      do 1009 j=1,natoms
 1009 iwkmat(ii,j)=iwkmat(ii,j)+iwkmat(jj,j)

      do 1010 j=1,natoms
 1010 iwkmat(jj,j)=iwkmat(ii,j)

 1006 continue

      icheck=0

      do 1011 j=1,natoms
      do 1011 i=1,natoms
 1011 if(iwkmat(i,j).eq.0) icheck=1

      if(icheck.eq.0) goto 1012

      do 1013 i=1,natoms

      jcheck=0

      do 1014 j=1,natoms
 1014 if(iwkmat(j,i).eq.0) jcheck=j

      if(jcheck.eq.0) goto 1013

      dist_min=one80**10

      do 1015 j=1,natoms
      do 1015 k=1,natoms
      if((iwkmat(j,i).ne.0).and.
     &   (iwkmat(k,jcheck).ne.0).and.
     &   (iwkmat(k,i).eq.0).and.
     &   (iwkmat(j,jcheck).eq.0)) then

                           distance=dist(coord(1,j),coord(1,k))
                           if(distance.le.dist_min) dist_min=distance

                                  endif
 1015 continue

      dist_min=perturb*dist_min

      do 1016 j=1,natoms
      do 1016 k=1,j
      distance=dist(coord(1,j),coord(1,k))
      if((distance.ge.dist_min).and.(distance.le.fact*dist_min)) then

                     nbonds=nbonds+1

                     i_bond(1,nbonds)=j
                     i_bond(2,nbonds)=k

                     iwkmat(j,k)=1
                     iwkmat(k,j)=1

                     do 1017 l=1,natoms
 1017                iwkmat(l,j)=iwkmat(l,j)+iwkmat(l,k)

                     do 1018 l=1,natoms
 1018                iwkmat(l,k)=iwkmat(l,j)

                     do 1019 l=1,natoms
 1019                iwkmat(j,l)=iwkmat(j,l)+iwkmat(k,l)

                     do 1020 l=1,natoms
 1020                iwkmat(k,l)=iwkmat(j,l)

                                                                 endif
 1016 continue

      goto 1005

 1013 continue

 1012 continue

      nbonds_tmp=nbonds

      do 1021 i=1,nbonds
      do 1021 j=1,i

      if(i.eq.j) goto 1021

      ind_1i=i_bond(1,i)
      ind_2i=i_bond(2,i)
      ind_1j=i_bond(1,j)
      ind_2j=i_bond(2,j)

      if(ind_1i.eq.ind_1j) then
                                 a1=ang(coord(1,ind_2i),
     &                                  coord(1,ind_1i),
     &                                  coord(1,ind_2j))

                                 if(a1.gt.ang_cutoff) then

                                              nbonds=nbonds+1

                                              i_bond(1,nbonds)=ind_2i
                                              i_bond(2,nbonds)=ind_2j

                                              goto 1021

                                                      endif

                                 nangles=nangles+1

                                 i_angle(1,nangles)=ind_2i
                                 i_angle(2,nangles)=ind_1i
                                 i_angle(3,nangles)=ind_2j

                                 goto 1021
                           endif

      if(ind_1i.eq.ind_2j) then
                                 a1=ang(coord(1,ind_2i),
     &                                  coord(1,ind_1i),
     &                                  coord(1,ind_1j))

                                 if(a1.gt.ang_cutoff) then

                                              nbonds=nbonds+1

                                              i_bond(1,nbonds)=ind_2i
                                              i_bond(2,nbonds)=ind_1j

                                              goto 1021

                                                      endif

                                 nangles=nangles+1

                                 i_angle(1,nangles)=ind_2i
                                 i_angle(2,nangles)=ind_1i
                                 i_angle(3,nangles)=ind_1j

                                 goto 1021
                           endif

      if(ind_2i.eq.ind_1j) then
                                 a1=ang(coord(1,ind_1i),
     &                                  coord(1,ind_2i),
     &                                  coord(1,ind_2j))

                                 if(a1.gt.ang_cutoff) then

                                              nbonds=nbonds+1

                                              i_bond(1,nbonds)=ind_1i
                                              i_bond(2,nbonds)=ind_2j

                                              goto 1021

                                                      endif

                                 nangles=nangles+1

                                 i_angle(1,nangles)=ind_1i
                                 i_angle(2,nangles)=ind_2i
                                 i_angle(3,nangles)=ind_2j

                                 goto 1021
                           endif

      if(ind_2i.eq.ind_2j) then
                                 a1=ang(coord(1,ind_1i),
     &                                  coord(1,ind_2i),
     &                                  coord(1,ind_1j))

                                 if(a1.gt.ang_cutoff) then

                                              nbonds=nbonds+1

                                              i_bond(1,nbonds)=ind_1i
                                              i_bond(2,nbonds)=ind_1j

                                              goto 1021

                                                      endif

                                 nangles=nangles+1

                                 i_angle(1,nangles)=ind_1i
                                 i_angle(2,nangles)=ind_2i
                                 i_angle(3,nangles)=ind_1j

                                 goto 1021
                           endif

 1021 continue

      do 1022 i=1,nbonds
      do 1022 j=1,natoms
      do 1022 k=1,j

      if(k.eq.j) goto 1022

      ind_1i=i_bond(1,i)
      ind_2i=i_bond(2,i)

      if(ind_1i.eq.j) goto 1022
      if(ind_1i.eq.k) goto 1022
      if(ind_2i.eq.j) goto 1022
      if(ind_2i.eq.k) goto 1022

      dist_ab=dist(coord(1,ind_1i),coord(1,j))
      dist_cd=dist(coord(1,ind_2i),coord(1,k))

      r_ab=fact*(radius(natomtype(ind_1i))+radius(natomtype(j)))
      r_cd=fact*(radius(natomtype(ind_2i))+radius(natomtype(k)))

      if((dist_ab.le.r_ab).and.(dist_cd.le.r_cd)) then

                  if(i.gt.nbonds_tmp) then
                                            nbonds=nbonds+1

                                            i_bond(1,nbonds)=j
                                            i_bond(2,nbonds)=k

                                            goto 1022
                                      endif

                  ang1=ang(coord(1,j),coord(1,ind_1i),coord(1,ind_2i))
                  ang2=ang(coord(1,k),coord(1,ind_2i),coord(1,ind_1i))

                  angmax=max(ang1,ang2)
                  if(angmax.gt.ang_cutoff) goto 1022

                  angmin=min(ang1,ang2)
                  if(angmin.lt.(one80-ang_cutoff)) goto 1022

                  ndihedrals=ndihedrals+1

                  i_dihedral(1,ndihedrals)=j
                  i_dihedral(2,ndihedrals)=ind_1i
                  i_dihedral(3,ndihedrals)=ind_2i
                  i_dihedral(4,ndihedrals)=k

                  goto 1022

                                                  endif

      dist_ab=dist(coord(1,ind_1i),coord(1,k))
      dist_cd=dist(coord(1,ind_2i),coord(1,j))

      r_ab=fact*(radius(natomtype(ind_1i))+radius(natomtype(k)))
      r_cd=fact*(radius(natomtype(ind_2i))+radius(natomtype(j)))

      if((dist_ab.le.r_ab).and.(dist_cd.le.r_cd)) then

                  if(i.gt.nbonds_tmp) then
                                            nbonds=nbonds+1

                                            i_bond(1,nbonds)=j
                                            i_bond(2,nbonds)=k

                                            goto 1022
                                      endif

                  ang1=ang(coord(1,k),coord(1,ind_1i),coord(1,ind_2i))
                  ang2=ang(coord(1,j),coord(1,ind_2i),coord(1,ind_1i))

                  angmax=max(ang1,ang2)
                  if(angmax.gt.ang_cutoff) goto 1022

                  angmin=min(ang1,ang2)
                  if(angmin.lt.(one80-ang_cutoff)) goto 1022

                  ndihedrals=ndihedrals+1

                  i_dihedral(1,ndihedrals)=k
                  i_dihedral(2,ndihedrals)=ind_1i
                  i_dihedral(3,ndihedrals)=ind_2i
                  i_dihedral(4,ndihedrals)=j

                  goto 1022

                                                  endif

      if(i.gt.nbonds_tmp) goto 1022

      ang_max=max(ang(coord(1,ind_1i),coord(1,ind_2i),coord(1,j)),
     &            ang(coord(1,ind_1i),coord(1,ind_2i),coord(1,k)),
     &            ang(coord(1,ind_2i),coord(1,ind_1i),coord(1,j)),
     &            ang(coord(1,ind_2i),coord(1,ind_1i),coord(1,k)))

      if(ang_max.gt.ang_cutoff) goto 1022

      ang_min=min(ang(coord(1,ind_1i),coord(1,ind_2i),coord(1,j)),
     &            ang(coord(1,ind_1i),coord(1,ind_2i),coord(1,k)),
     &            ang(coord(1,ind_2i),coord(1,ind_1i),coord(1,j)),
     &            ang(coord(1,ind_2i),coord(1,ind_1i),coord(1,k)))

      if(ang_min.lt.(one80-ang_cutoff)) goto 1022

      dist_ab=dist(coord(1,ind_1i),coord(1,j))
      dist_ac=dist(coord(1,ind_1i),coord(1,k))

      r_ab=fact*(radius(natomtype(ind_1i))+radius(natomtype(j)))
      r_ac=fact*(radius(natomtype(ind_1i))+radius(natomtype(k)))

      if((ind_1i.lt.k).and.
     &   (dist_ab.le.r_ab).and.
     &   (dist_ac.le.r_ac)) then
                                  nimpropers=nimpropers+1

                                  i_improper(1,nimpropers)=ind_2i
                                  i_improper(2,nimpropers)=j
                                  i_improper(3,nimpropers)=k
                                  i_improper(4,nimpropers)=ind_1i

                                  goto 1022
                            endif

      dist_ab=dist(coord(1,ind_2i),coord(1,j))
      dist_ac=dist(coord(1,ind_2i),coord(1,k))

      r_ab=fact*(radius(natomtype(ind_2i))+radius(natomtype(j)))
      r_ac=fact*(radius(natomtype(ind_2i))+radius(natomtype(k)))

      if((ind_1i.lt.k).and.
     &   (dist_ab.le.r_ab).and.
     &   (dist_ac.le.r_ac)) then
                                  nimpropers=nimpropers+1

                                  i_improper(1,nimpropers)=ind_1i
                                  i_improper(2,nimpropers)=j
                                  i_improper(3,nimpropers)=k
                                  i_improper(4,nimpropers)=ind_2i

                                  goto 1022
                            endif

 1022 continue

      return
      end

      subroutine sxcbld(ilast,n,nmaxpoints,nxcfunctions,npoints,iwkvec,
     &                  dlarge,cutoff,saux,extent,g,gw,weight,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iwkvec(*)

      dimension saux(n,*),extent(*),g(nmaxpoints,*),gw(*),weight(*),
     &          wkvec(*)

      ihits=0

      do 1001 i=1,nxcfunctions
      if(extent(i).gt.cutoff) then

                   ihits=ihits+1
                   iwkvec(ihits)=i
                   factor=extent(i)*dlarge

                   do 1002 k=1,npoints
 1002              gw(k)=g(k,i)*weight(k)

                   do 1003 j=1,ihits
                   jj=iwkvec(j)
                   if(factor*extent(jj).gt.cutoff) then

                                    do 1004 k=1,npoints
 1004                               saux(jj,i)=saux(jj,i)+g(k,jj)*gw(k)

                                                   endif
 1003              continue

                              endif
 1001 continue

      if(ilast.eq.1) then
                           nloop=0

                           do 1005 i=1,nxcfunctions
                           do 1005 j=1,i
                           nloop=nloop+1
 1005                      wkvec(nloop)=saux(j,i)
                     endif
      
      return
      end

      subroutine chrgss(m,n,ncds,ncdspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,g,coord,cdfitc,alphaaux,coeffs,
     &                  coeffp,coeffd,fock,zeta,px,py,pz,base,u,zetarec,
     &                  wxcx,wycy,wzcz,sss,sss0,sss1,sss2,ssp,ssp0,ssp1,
     &                  ssd,ssd0,zetac,c,zzeta,ppx,ppy,ppz,gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cdfitp(3),cdfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(*),
     &          iloc(*)

      dimension g(*),coord(3,*),cdfitc(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),fock(*),zeta(*),px(*),py(*),pz(*),
     &          base(*),u(*),zetarec(*),wxcx(*),wycy(*),wzcz(*),sss(*),
     &          sss0(*),sss1(*),sss2(*),ssp(m,*),ssp0(n,*),ssp1(n,*),
     &          ssd(m,*),ssd0(n,*),zetac(*),c(*),zzeta(*),ppx(*),ppy(*),
     &          ppz(*),gather(*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,seven/4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 i=1,n
 1001 gather(i)=zero

      do 1002 naux=1,ncds

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(naux)*coeffs(ilaux)

      do 1003 i=1,n
 1003 zetarec(i)=one/(zeta(i)+zetaux)

      do 1004 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1004 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(1,n,iloc,u,sss0,ppx,ppy,ppz)

      do 1005 i=1,n
 1005 sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*sss0(i)/zeta(i)/zetaux

      do 1006 i=1,n
 1006 gather(i)=gather(i)+sss0(i)*cdfits

 1002 continue

      do 2001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(ncds+(naux-1)*10+1)*coeffs(ilaux)

      cdfitp(1)=cdfitc(ncds+(naux-1)*10+2)*coeffp(ilaux)
      cdfitp(2)=cdfitc(ncds+(naux-1)*10+3)*coeffp(ilaux)
      cdfitp(3)=cdfitc(ncds+(naux-1)*10+4)*coeffp(ilaux)

      cdfitd(1)=cdfitc(ncds+(naux-1)*10+05)*coeffd(ilaux)/dnormcd
      cdfitd(2)=cdfitc(ncds+(naux-1)*10+06)*coeffd(ilaux)
      cdfitd(3)=cdfitc(ncds+(naux-1)*10+07)*coeffd(ilaux)
      cdfitd(4)=cdfitc(ncds+(naux-1)*10+08)*coeffd(ilaux)/dnormcd
      cdfitd(5)=cdfitc(ncds+(naux-1)*10+09)*coeffd(ilaux)
      cdfitd(6)=cdfitc(ncds+(naux-1)*10+10)*coeffd(ilaux)/dnormcd

      do 2002 i=1,n
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 2003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(3,n,iloc,u,ssp0,ppx,ppy,ppz)

      do 2004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*ssp0(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*ssp0(i,2)/zeta(i)/zetaux
 2004 sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*ssp0(i,3)/zeta(i)/zetaux

      nn=0

      do 2005 i=1,n

      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iloc(nn)=i

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                 endif

 2005 continue

      do 2006 i=1,nn
 2006 zetac(i)=zzeta(i)*zetarec(i)

      do 2007 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 2007 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 2008 i=1,nn

      ssp0(i,1)=wxcx(i)*sss1(i)
      ssp0(i,2)=wycy(i)*sss1(i)
      ssp0(i,3)=wzcz(i)*sss1(i)

      ssp1(i,1)=wxcx(i)*sss2(i)
      ssp1(i,2)=wycy(i)*sss2(i)
      ssp1(i,3)=wzcz(i)*sss2(i)

 2008 continue

      do 2009 i=1,nn

      c(i)=(sss0(i)-zetac(i)*sss1(i))/(two*zetaux)

      ssd0(i,1)=wxcx(i)*ssp1(i,1)+c(i)
      ssd0(i,2)=wycy(i)*ssp1(i,1)
      ssd0(i,3)=wzcz(i)*ssp1(i,1)
      ssd0(i,4)=wycy(i)*ssp1(i,2)+c(i)
      ssd0(i,5)=wzcz(i)*ssp1(i,2)
      ssd0(i,6)=wzcz(i)*ssp1(i,3)+c(i)

 2009 continue

cfpp$ nodepchk
      do 2010 i=1,nn
 2010 gather(iloc(i))=gather(iloc(i))
     &               +sss0(i)*cdfits
     &               +ssp0(i,1)*cdfitp(1)
     &               +ssp0(i,2)*cdfitp(2)
     &               +ssp0(i,3)*cdfitp(3)
     &               +ssd0(i,1)*cdfitd(1)
     &               +ssd0(i,2)*cdfitd(2)
     &               +ssd0(i,3)*cdfitd(3)
     &               +ssd0(i,4)*cdfitd(4)
     &               +ssd0(i,5)*cdfitd(5)
     &               +ssd0(i,6)*cdfitd(6)

 2001 continue

      do 1007 i=1,n
 1007 fock(inddyy(icontr(i)))=fock(inddyy(icontr(i)))+gather(i)

      do 3001 i=1,n
 3001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      return
      end

      subroutine gridxc(iatom,natoms,npts,ndim,n,n1,n2,ilaux,icaux,
     &                  radius,cent,alpha,coeffs,coeffp,coeffd,x,y,z,q,
     &                  extent2,extent3,dcc,xx,yy,zz,rr,sfac)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilaux(*),icaux(*)

      dimension cent(3,*),alpha(*),coeffs(*),coeffp(*),coeffd(*)
      dimension x(*),y(*),z(*),q(ndim,*),xx(*),yy(*),zz(*),rr(*),sfac(*)
      dimension extent2(*),extent3(*),dcc(natoms,*)

      data zero,one,three,expcut/0.0d0,1.0d0,3.0d0,50.0d0/

      sqrt3=sqrt(three)

      do 1001 i=1,n
 1001 extent3(i)=zero

c  now for lone-s exponent xc fitting functions

      k=1

      do 1002 i=1,n1

      ilabel=ilaux(i)

      nc=icaux(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent2(i)) goto 1002

      do 1003 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1003 zz(j)=z(j)-cent(3,nc)

      do 1004 j=1,npts
 1004 rr(j)=(xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j))*alpha(ilabel)

      do 1005 j=1,npts
      if(rr(j).lt.expcut) then
                                q(j,k)=exp(-rr(j))*coeffs(ilabel)
                          else
                                q(j,k)=zero
                          endif
 1005 continue

      extent3(k)=sumsum(npts,q(1,k))/real64(npts)

 1002 k=k+1

      if(n2.eq.n1) return

c  now for shared exponent xc fitting functions

      do 1006 i=n1+1,n2

      ilabel=ilaux(i)

      nc=icaux(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent2(i)) goto 1006

      do 1007 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1007 zz(j)=z(j)-cent(3,nc)

      do 1008 j=1,npts
 1008 rr(j)=(xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j))*alpha(ilabel)

      do 1009 j=1,npts
      if(rr(j).lt.expcut) then

                   sfac(j)=exp(-rr(j))

                   q(j,k+0)=sfac(j)*coeffs(ilabel)

                   q(j,k+1)=xx(j)*sfac(j)*coeffp(ilabel)
                   q(j,k+2)=yy(j)*sfac(j)*coeffp(ilabel)
                   q(j,k+3)=zz(j)*sfac(j)*coeffp(ilabel)

                   q(j,k+4)=xx(j)*xx(j)*sfac(j)*coeffd(ilabel)/sqrt3
                   q(j,k+5)=xx(j)*yy(j)*sfac(j)*coeffd(ilabel)
                   q(j,k+6)=xx(j)*zz(j)*sfac(j)*coeffd(ilabel)
                   q(j,k+7)=yy(j)*yy(j)*sfac(j)*coeffd(ilabel)/sqrt3
                   q(j,k+8)=yy(j)*zz(j)*sfac(j)*coeffd(ilabel)
                   q(j,k+9)=zz(j)*zz(j)*sfac(j)*coeffd(ilabel)/sqrt3

                          else

                   q(j,k+0)=zero

                   q(j,k+1)=zero
                   q(j,k+2)=zero
                   q(j,k+3)=zero

                   q(j,k+4)=zero
                   q(j,k+5)=zero
                   q(j,k+6)=zero
                   q(j,k+7)=zero
                   q(j,k+8)=zero
                   q(j,k+9)=zero

                          endif
 1009 continue

      extent3(k+0)=sumsum(npts,q(1,k+0))/real64(npts)
      extent3(k+1)=sumsum(npts,q(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,q(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,q(1,k+3))/real64(npts)
      extent3(k+4)=sumsum(npts,q(1,k+4))/real64(npts)
      extent3(k+5)=sumsum(npts,q(1,k+5))/real64(npts)
      extent3(k+6)=sumsum(npts,q(1,k+6))/real64(npts)
      extent3(k+7)=sumsum(npts,q(1,k+7))/real64(npts)
      extent3(k+8)=sumsum(npts,q(1,k+8))/real64(npts)
      extent3(k+9)=sumsum(npts,q(1,k+9))/real64(npts)

 1006 k=k+10

      return
      end

      subroutine carbo(ncontmax,ncont,nindpndnt,nalpha,nbeta,
     &                 elevelshift,fockalpha,fockbeta,coeffalpha,
     &                 coeffbeta,overlap,wkmat1,wkmat2)

      implicit real*8(a-h,o-z)

      dimension fockalpha(*),fockbeta(*),
     &          coeffalpha(ncontmax,*),coeffbeta(ncontmax,*),
     &          overlap(ncontmax,*)

      dimension wkmat1(ncont,*),wkmat2(ncont,*)

      data zero/0.0d0/

      rewind 45

      do 1001 i=1,ncont
 1001 call fastrd(45,overlap(1,i),ncont)

      do 1002 i=1,ncont
      do 1002 j=1,ncont
      if(j.le.nalpha) wkmat2(j,i)=-coeffalpha(i,j)*elevelshift
      if(j.gt.nalpha) wkmat2(j,i)=+coeffalpha(i,j)*elevelshift
 1002 if(j.gt.nindpndnt) wkmat2(j,i)=zero

      do 1003 j=1,ncont
      do 1004 i=1,ncont
 1004 wkmat1(i,j)=zero
      do 1003 k=1,nindpndnt
      do 1003 i=1,ncont
 1003 wkmat1(i,j)=wkmat1(i,j)+coeffalpha(i,k)*wkmat2(k,j)

      do 1005 j=1,ncont
      do 1006 i=1,ncont
 1006 wkmat2(i,j)=zero
      do 1005 k=1,ncont
      do 1005 i=1,ncont
 1005 wkmat2(i,j)=wkmat2(i,j)+wkmat1(i,k)*overlap(k,j)

      do 1007 j=1,ncont
      istart=j*(j-1)/2
      do 1007 k=1,ncont
      do 1007 i=1,j
 1007 fockalpha(istart+i)=fockalpha(istart+i)+overlap(i,k)*wkmat2(k,j)

      do 1008 i=1,ncont
      do 1008 j=1,ncont
      if(j.le.nbeta) wkmat2(j,i)=-coeffbeta(i,j)*elevelshift
      if(j.gt.nbeta) wkmat2(j,i)=+coeffbeta(i,j)*elevelshift
 1008 if(j.gt.nindpndnt) wkmat2(j,i)=zero

      do 1009 j=1,ncont
      do 1010 i=1,ncont
 1010 wkmat1(i,j)=zero
      do 1009 k=1,nindpndnt
      do 1009 i=1,ncont
 1009 wkmat1(i,j)=wkmat1(i,j)+coeffbeta(i,k)*wkmat2(k,j)

      do 1011 j=1,ncont
      do 1012 i=1,ncont
 1012 wkmat2(i,j)=zero
      do 1011 k=1,ncont
      do 1011 i=1,ncont
 1011 wkmat2(i,j)=wkmat2(i,j)+wkmat1(i,k)*overlap(k,j)

      do 1013 j=1,ncont
      istart=j*(j-1)/2
      do 1013 k=1,ncont
      do 1013 i=1,j
 1013 fockbeta(istart+i)=fockbeta(istart+i)+overlap(i,k)*wkmat2(k,j)

      return
      end

      subroutine dipoleps(m,n,icontr,inddyy,density,zeta,px,py,pz,pxax,
     &                    pyay,pzaz,base,ss,ps,c,pscond,dipole)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension density(*),zeta(*),px(*),py(*),pz(*),pxax(*),pyay(*),
     &          pzaz(*),base(*),ss(n,*),ps(n,*),c(*),pscond(m,*),
     &          dipole(*)

      data zero,thrhlf,two,pi/0.0d0,1.5d0,2.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1002 ss(i,3)=pz(i)*base(i)

      do 1003 i=1,n
 1003 c(i)=base(i)/(two*zeta(i))

      do 1004 i=1,n
      ps(i,1)=pxax(i)*ss(i,1)+c(i)
      ps(i,2)=pxax(i)*ss(i,2)
      ps(i,3)=pxax(i)*ss(i,3)
      ps(i,4)=pyay(i)*ss(i,1)
      ps(i,5)=pyay(i)*ss(i,2)+c(i)
      ps(i,6)=pyay(i)*ss(i,3)
      ps(i,7)=pzaz(i)*ss(i,1)
      ps(i,8)=pzaz(i)*ss(i,2)
 1004 ps(i,9)=pzaz(i)*ss(i,3)+c(i)

      do 1005 j=1,9
      do 1005 i=1,m
 1005 pscond(i,j)=zero

      do 1006 j=1,9
      do 1006 i=1,n
 1006 pscond(icontr(i),j)=pscond(icontr(i),j)+ps(i,j)

      do 1007 k=1,3
      do 1007 j=1,3
      do 1007 i=1,m
 1007 dipole(j)=dipole(j)-density(inddyy(i,k))*pscond(i,3*(k-1)+j)

      return
      end

      logical function connol(cprobe,rprobe,cother,rother,
     &                                        cthis,rthis,nother)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cprobe(*),cother(3,*),rother(*),cthis(*)
      dimension x(194),y(194),z(194),w(194),point(3,194)

      call ang194(x,y,z,w)

      do 1001 i=1,194
      point(1,i)=cprobe(1)+x(i)*rprobe
      point(2,i)=cprobe(2)+y(i)*rprobe
      point(3,i)=cprobe(3)+z(i)*rprobe
 1001 continue

      do 1002 i=1,nother

      s1=(rprobe+rother(i))**2
      s2=(rprobe+rthis)**2

      s3=(rprobe+rprobe+rother(i))**2

      xx=cprobe(1)-cother(1,i)
      yy=cprobe(2)-cother(2,i)
      zz=cprobe(3)-cother(3,i)

      dd=xx*xx+yy*yy+zz*zz

      if(dd.gt.s3) goto 1002

      do 1003 j=1,194
                      xx=cother(1,i)-point(1,j)
                      yy=cother(2,i)-point(2,j)
                      zz=cother(3,i)-point(3,j)

                      r1=xx*xx+yy*yy+zz*zz

                      xx=cthis(1)-point(1,j)
                      yy=cthis(2)-point(2,j)
                      zz=cthis(3)-point(3,j)

                      r2=xx*xx+yy*yy+zz*zz

                      if((r1.gt.s1).and.(r2.gt.s2)) goto 1002
 1003        continue

      connol=.true.
      return

 1002 continue

      connol=.false.

      return
      end

      subroutine xvecpp(m,n,nxcs,nxcspd,ilfunc,icfunc,iminj,icontr,
     &                  iicontr,inddyy,iloc,coord,dmat,vvector,
     &                  alphaaux,coeffs,coeffp,coeffd,zeta,ax,ay,az,
     &                  axbx,ayby,azbz,px,py,pz,base,zetarec,zetafac,
     &                  efac,gxax,gyay,gzaz,sss,pss,psscond,dss,dsscond,
     &                  fss,fsscond,gss,gsscond,pps,dps,fps,ppp,dpp,ppd,
     &                  c,c1,c2,zzeta,aax,aay,aaz,ppx,ppy,ppz,axcx,aycy,
     &                  azcz,gather)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension index(9)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),iicontr(*),
     &          inddyy(m,*),iloc(*)

      dimension coord(3,*),dmat(*),vvector(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),zeta(*),ax(*),ay(*),az(*),axbx(*),
     &          ayby(*),azbz(*),px(*),py(*),pz(*),base(*),zetarec(*),
     &          zetafac(*),efac(*),gxax(*),gyay(*),gzaz(*),sss(*),
     &          pss(n,*),psscond(n,*),dss(n,*),dsscond(n,*),fss(n,*),
     &          fsscond(n,*),gss(n,*),gsscond(n,*),pps(n,*),dps(n,*),
     &          fps(n,*),ppp(n,*),dpp(n,*),ppd(n,*),c(*),c1(n,*),
     &          c2(n,*),zzeta(*),aax(*),aay(*),aaz(*),ppx(*),ppy(*),
     &          ppz(*),axcx(*),aycy(*),azcz(*),gather(n,*)

      data zero,one,two,three/0.0d0,1.0d0,2.0d0,3.0d0/
      data expcut,calcut,pi/45.0d0,1.0d-16,3.1415926535898d0/

      thrhlf=three/two

      sqrt3=sqrt(three)

      do 1000 i=1,n
 1000 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1001 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      do 1002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      sss(i)=zero
 1004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 1005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 1005 continue

      do 1006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 1006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 1007 i=1,nn
 1007 zetarec(i)=zetarec(i)/two

      do 1008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 1008 pss(i,3)=gzaz(i)*sss(i)

      do 1009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 1009 continue

      do 1010 i=1,nn
      pps(i,1)=axbx(iicontr(i))*pss(i,1)+dss(i,1)
      pps(i,2)=ayby(iicontr(i))*pss(i,1)+dss(i,2)
      pps(i,3)=azbz(iicontr(i))*pss(i,1)+dss(i,3)
      pps(i,4)=axbx(iicontr(i))*pss(i,2)+dss(i,2)
      pps(i,5)=ayby(iicontr(i))*pss(i,2)+dss(i,4)
      pps(i,6)=azbz(iicontr(i))*pss(i,2)+dss(i,5)
      pps(i,7)=axbx(iicontr(i))*pss(i,3)+dss(i,3)
      pps(i,8)=ayby(iicontr(i))*pss(i,3)+dss(i,5)
 1010 pps(i,9)=azbz(iicontr(i))*pss(i,3)+dss(i,6)

      do 1011 i=1,nn
 1011 gather(i,1)=zero

      do 1012 j=1,9
      do 1012 i=1,nn
 1012 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pps(i,j)

      nnn=0

      do 1013 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 1013 continue

      index(1)=2
      index(2)=3
      index(3)=6

      do 1014 j=1,3
cfpp$ nodepchk
      do 1014 i=1,nnn
 1014 gather(iloc(i),1)=gather(iloc(i),1)
     &   -dmat(inddyy(iicontr(iloc(i)),index(j)))*pps(iloc(i),index(j))

      do 1015 i=1,nn
 1015 gather(i,1)=gather(i,1)*xcfits

      do 1016 i=1,nn
 1016 vvector(naux)=vvector(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      xcfitp(1)=coeffp(ilaux)
      xcfitp(2)=coeffp(ilaux)
      xcfitp(3)=coeffp(ilaux)

      xcfitd(1)=coeffd(ilaux)/sqrt3
      xcfitd(2)=coeffd(ilaux)
      xcfitd(3)=coeffd(ilaux)
      xcfitd(4)=coeffd(ilaux)/sqrt3
      xcfitd(5)=coeffd(ilaux)
      xcfitd(6)=coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,nn
 2010 c1(i,j)=zetarec(i)*pss(i,j)

      do 2011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)*two
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)*two
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 2011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)*two

      do 2012 j=1,6
      do 2012 i=1,nn
 2012 c2(i,j)=zetarec(i)*dss(i,j)

      do 2013 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 2013 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 2014 i=1,nn
      pps(i,1)=axbx(iicontr(i))*pss(i,1)+dss(i,1)
      pps(i,2)=ayby(iicontr(i))*pss(i,1)+dss(i,2)
      pps(i,3)=azbz(iicontr(i))*pss(i,1)+dss(i,3)
      pps(i,4)=axbx(iicontr(i))*pss(i,2)+dss(i,2)
      pps(i,5)=ayby(iicontr(i))*pss(i,2)+dss(i,4)
      pps(i,6)=azbz(iicontr(i))*pss(i,2)+dss(i,5)
      pps(i,7)=axbx(iicontr(i))*pss(i,3)+dss(i,3)
      pps(i,8)=ayby(iicontr(i))*pss(i,3)+dss(i,5)
 2014 pps(i,9)=azbz(iicontr(i))*pss(i,3)+dss(i,6)

      do 2015 i=1,nn
      dps(i,01)=axbx(iicontr(i))*dss(i,1)+fss(i,01)
      dps(i,02)=ayby(iicontr(i))*dss(i,1)+fss(i,02)
      dps(i,03)=azbz(iicontr(i))*dss(i,1)+fss(i,03)
      dps(i,04)=axbx(iicontr(i))*dss(i,2)+fss(i,02)
      dps(i,05)=ayby(iicontr(i))*dss(i,2)+fss(i,04)
      dps(i,06)=azbz(iicontr(i))*dss(i,2)+fss(i,05)
      dps(i,07)=axbx(iicontr(i))*dss(i,3)+fss(i,03)
      dps(i,08)=ayby(iicontr(i))*dss(i,3)+fss(i,05)
      dps(i,09)=azbz(iicontr(i))*dss(i,3)+fss(i,06)
      dps(i,10)=axbx(iicontr(i))*dss(i,4)+fss(i,04)
      dps(i,11)=ayby(iicontr(i))*dss(i,4)+fss(i,07)
      dps(i,12)=azbz(iicontr(i))*dss(i,4)+fss(i,08)
      dps(i,13)=axbx(iicontr(i))*dss(i,5)+fss(i,05)
      dps(i,14)=ayby(iicontr(i))*dss(i,5)+fss(i,08)
      dps(i,15)=azbz(iicontr(i))*dss(i,5)+fss(i,09)
      dps(i,16)=axbx(iicontr(i))*dss(i,6)+fss(i,06)
      dps(i,17)=ayby(iicontr(i))*dss(i,6)+fss(i,09)
 2015 dps(i,18)=azbz(iicontr(i))*dss(i,6)+fss(i,10)

      do 2016 i=1,nn
      ppp(i,01)=axcx(i)*pps(i,1)+dps(i,01)
      ppp(i,02)=aycy(i)*pps(i,1)+dps(i,04)
      ppp(i,03)=azcz(i)*pps(i,1)+dps(i,07)
      ppp(i,04)=axcx(i)*pps(i,2)+dps(i,02)
      ppp(i,05)=aycy(i)*pps(i,2)+dps(i,05)
      ppp(i,06)=azcz(i)*pps(i,2)+dps(i,08)
      ppp(i,07)=axcx(i)*pps(i,3)+dps(i,03)
      ppp(i,08)=aycy(i)*pps(i,3)+dps(i,06)
      ppp(i,09)=azcz(i)*pps(i,3)+dps(i,09)
      ppp(i,10)=axcx(i)*pps(i,4)+dps(i,04)
      ppp(i,11)=aycy(i)*pps(i,4)+dps(i,10)
      ppp(i,12)=azcz(i)*pps(i,4)+dps(i,13)
      ppp(i,13)=axcx(i)*pps(i,5)+dps(i,05)
      ppp(i,14)=aycy(i)*pps(i,5)+dps(i,11)
      ppp(i,15)=azcz(i)*pps(i,5)+dps(i,14)
      ppp(i,16)=axcx(i)*pps(i,6)+dps(i,06)
      ppp(i,17)=aycy(i)*pps(i,6)+dps(i,12)
      ppp(i,18)=azcz(i)*pps(i,6)+dps(i,15)
      ppp(i,19)=axcx(i)*pps(i,7)+dps(i,07)
      ppp(i,20)=aycy(i)*pps(i,7)+dps(i,13)
      ppp(i,21)=azcz(i)*pps(i,7)+dps(i,16)
      ppp(i,22)=axcx(i)*pps(i,8)+dps(i,08)
      ppp(i,23)=aycy(i)*pps(i,8)+dps(i,14)
      ppp(i,24)=azcz(i)*pps(i,8)+dps(i,17)
      ppp(i,25)=axcx(i)*pps(i,9)+dps(i,09)
      ppp(i,26)=aycy(i)*pps(i,9)+dps(i,15)
 2016 ppp(i,27)=azcz(i)*pps(i,9)+dps(i,18)

      do 2017 i=1,nn
      fps(i,01)=axbx(iicontr(i))*fss(i,01)+gss(i,01)
      fps(i,02)=ayby(iicontr(i))*fss(i,01)+gss(i,02)
      fps(i,03)=azbz(iicontr(i))*fss(i,01)+gss(i,03)
      fps(i,04)=axbx(iicontr(i))*fss(i,02)+gss(i,02)
      fps(i,05)=ayby(iicontr(i))*fss(i,02)+gss(i,04)
      fps(i,06)=azbz(iicontr(i))*fss(i,02)+gss(i,05)
      fps(i,07)=axbx(iicontr(i))*fss(i,03)+gss(i,03)
      fps(i,08)=ayby(iicontr(i))*fss(i,03)+gss(i,05)
      fps(i,09)=azbz(iicontr(i))*fss(i,03)+gss(i,06)
      fps(i,10)=axbx(iicontr(i))*fss(i,04)+gss(i,04)
      fps(i,11)=ayby(iicontr(i))*fss(i,04)+gss(i,07)
      fps(i,12)=azbz(iicontr(i))*fss(i,04)+gss(i,08)
      fps(i,13)=axbx(iicontr(i))*fss(i,05)+gss(i,05)
      fps(i,14)=ayby(iicontr(i))*fss(i,05)+gss(i,08)
      fps(i,15)=azbz(iicontr(i))*fss(i,05)+gss(i,09)
      fps(i,16)=axbx(iicontr(i))*fss(i,06)+gss(i,06)
      fps(i,17)=ayby(iicontr(i))*fss(i,06)+gss(i,09)
      fps(i,18)=azbz(iicontr(i))*fss(i,06)+gss(i,10)
      fps(i,19)=axbx(iicontr(i))*fss(i,07)+gss(i,07)
      fps(i,20)=ayby(iicontr(i))*fss(i,07)+gss(i,11)
      fps(i,21)=azbz(iicontr(i))*fss(i,07)+gss(i,12)
      fps(i,22)=axbx(iicontr(i))*fss(i,08)+gss(i,08)
      fps(i,23)=ayby(iicontr(i))*fss(i,08)+gss(i,12)
      fps(i,24)=azbz(iicontr(i))*fss(i,08)+gss(i,13)
      fps(i,25)=axbx(iicontr(i))*fss(i,09)+gss(i,09)
      fps(i,26)=ayby(iicontr(i))*fss(i,09)+gss(i,13)
      fps(i,27)=azbz(iicontr(i))*fss(i,09)+gss(i,14)
      fps(i,28)=axbx(iicontr(i))*fss(i,10)+gss(i,10)
      fps(i,29)=ayby(iicontr(i))*fss(i,10)+gss(i,14)
 2017 fps(i,30)=azbz(iicontr(i))*fss(i,10)+gss(i,15)

      do 2018 i=1,nn
      dpp(i,01)=axcx(i)*dps(i,01)+fps(i,01)
      dpp(i,02)=aycy(i)*dps(i,01)+fps(i,04)
      dpp(i,03)=azcz(i)*dps(i,01)+fps(i,07)
      dpp(i,04)=axcx(i)*dps(i,02)+fps(i,02)
      dpp(i,05)=aycy(i)*dps(i,02)+fps(i,05)
      dpp(i,06)=azcz(i)*dps(i,02)+fps(i,08)
      dpp(i,07)=axcx(i)*dps(i,03)+fps(i,03)
      dpp(i,08)=aycy(i)*dps(i,03)+fps(i,06)
      dpp(i,09)=azcz(i)*dps(i,03)+fps(i,09)
      dpp(i,10)=axcx(i)*dps(i,04)+fps(i,04)
      dpp(i,11)=aycy(i)*dps(i,04)+fps(i,10)
      dpp(i,12)=azcz(i)*dps(i,04)+fps(i,13)
      dpp(i,13)=axcx(i)*dps(i,05)+fps(i,05)
      dpp(i,14)=aycy(i)*dps(i,05)+fps(i,11)
      dpp(i,15)=azcz(i)*dps(i,05)+fps(i,14)
      dpp(i,16)=axcx(i)*dps(i,06)+fps(i,06)
      dpp(i,17)=aycy(i)*dps(i,06)+fps(i,12)
      dpp(i,18)=azcz(i)*dps(i,06)+fps(i,15)
      dpp(i,19)=axcx(i)*dps(i,07)+fps(i,07)
      dpp(i,20)=aycy(i)*dps(i,07)+fps(i,13)
      dpp(i,21)=azcz(i)*dps(i,07)+fps(i,16)
      dpp(i,22)=axcx(i)*dps(i,08)+fps(i,08)
      dpp(i,23)=aycy(i)*dps(i,08)+fps(i,14)
      dpp(i,24)=azcz(i)*dps(i,08)+fps(i,17)
      dpp(i,25)=axcx(i)*dps(i,09)+fps(i,09)
      dpp(i,26)=aycy(i)*dps(i,09)+fps(i,15)
      dpp(i,27)=azcz(i)*dps(i,09)+fps(i,18)
      dpp(i,28)=axcx(i)*dps(i,10)+fps(i,10)
      dpp(i,29)=aycy(i)*dps(i,10)+fps(i,19)
      dpp(i,30)=azcz(i)*dps(i,10)+fps(i,22)
      dpp(i,31)=axcx(i)*dps(i,11)+fps(i,11)
      dpp(i,32)=aycy(i)*dps(i,11)+fps(i,20)
      dpp(i,33)=azcz(i)*dps(i,11)+fps(i,23)
      dpp(i,34)=axcx(i)*dps(i,12)+fps(i,12)
      dpp(i,35)=aycy(i)*dps(i,12)+fps(i,21)
      dpp(i,36)=azcz(i)*dps(i,12)+fps(i,24)
      dpp(i,37)=axcx(i)*dps(i,13)+fps(i,13)
      dpp(i,38)=aycy(i)*dps(i,13)+fps(i,22)
      dpp(i,39)=azcz(i)*dps(i,13)+fps(i,25)
      dpp(i,40)=axcx(i)*dps(i,14)+fps(i,14)
      dpp(i,41)=aycy(i)*dps(i,14)+fps(i,23)
      dpp(i,42)=azcz(i)*dps(i,14)+fps(i,26)
      dpp(i,43)=axcx(i)*dps(i,15)+fps(i,15)
      dpp(i,44)=aycy(i)*dps(i,15)+fps(i,24)
      dpp(i,45)=azcz(i)*dps(i,15)+fps(i,27)
      dpp(i,46)=axcx(i)*dps(i,16)+fps(i,16)
      dpp(i,47)=aycy(i)*dps(i,16)+fps(i,25)
      dpp(i,48)=azcz(i)*dps(i,16)+fps(i,28)
      dpp(i,49)=axcx(i)*dps(i,17)+fps(i,17)
      dpp(i,50)=aycy(i)*dps(i,17)+fps(i,26)
      dpp(i,51)=azcz(i)*dps(i,17)+fps(i,29)
      dpp(i,52)=axcx(i)*dps(i,18)+fps(i,18)
      dpp(i,53)=aycy(i)*dps(i,18)+fps(i,27)
 2018 dpp(i,54)=azcz(i)*dps(i,18)+fps(i,30)

      do 2019 i=1,nn
      ppd(i,01)=axcx(i)*ppp(i,01)+dpp(i,01)
      ppd(i,02)=aycy(i)*ppp(i,01)+dpp(i,10)
      ppd(i,03)=azcz(i)*ppp(i,01)+dpp(i,19)
      ppd(i,04)=aycy(i)*ppp(i,02)+dpp(i,11)
      ppd(i,05)=azcz(i)*ppp(i,02)+dpp(i,20)
      ppd(i,06)=azcz(i)*ppp(i,03)+dpp(i,21)
      ppd(i,07)=axcx(i)*ppp(i,04)+dpp(i,04)
      ppd(i,08)=aycy(i)*ppp(i,04)+dpp(i,13)
      ppd(i,09)=azcz(i)*ppp(i,04)+dpp(i,22)
      ppd(i,10)=aycy(i)*ppp(i,05)+dpp(i,14)
      ppd(i,11)=azcz(i)*ppp(i,05)+dpp(i,23)
      ppd(i,12)=azcz(i)*ppp(i,06)+dpp(i,24)
      ppd(i,13)=axcx(i)*ppp(i,07)+dpp(i,07)
      ppd(i,14)=aycy(i)*ppp(i,07)+dpp(i,16)
      ppd(i,15)=azcz(i)*ppp(i,07)+dpp(i,25)
      ppd(i,16)=aycy(i)*ppp(i,08)+dpp(i,17)
      ppd(i,17)=azcz(i)*ppp(i,08)+dpp(i,26)
      ppd(i,18)=azcz(i)*ppp(i,09)+dpp(i,27)
      ppd(i,19)=axcx(i)*ppp(i,10)+dpp(i,10)
      ppd(i,20)=aycy(i)*ppp(i,10)+dpp(i,28)
      ppd(i,21)=azcz(i)*ppp(i,10)+dpp(i,37)
      ppd(i,22)=aycy(i)*ppp(i,11)+dpp(i,29)
      ppd(i,23)=azcz(i)*ppp(i,11)+dpp(i,38)
      ppd(i,24)=azcz(i)*ppp(i,12)+dpp(i,39)
      ppd(i,25)=axcx(i)*ppp(i,13)+dpp(i,13)
      ppd(i,26)=aycy(i)*ppp(i,13)+dpp(i,31)
      ppd(i,27)=azcz(i)*ppp(i,13)+dpp(i,40)
      ppd(i,28)=aycy(i)*ppp(i,14)+dpp(i,32)
      ppd(i,29)=azcz(i)*ppp(i,14)+dpp(i,41)
      ppd(i,30)=azcz(i)*ppp(i,15)+dpp(i,42)
      ppd(i,31)=axcx(i)*ppp(i,16)+dpp(i,16)
      ppd(i,32)=aycy(i)*ppp(i,16)+dpp(i,34)
      ppd(i,33)=azcz(i)*ppp(i,16)+dpp(i,43)
      ppd(i,34)=aycy(i)*ppp(i,17)+dpp(i,35)
      ppd(i,35)=azcz(i)*ppp(i,17)+dpp(i,44)
      ppd(i,36)=azcz(i)*ppp(i,18)+dpp(i,45)
      ppd(i,37)=axcx(i)*ppp(i,19)+dpp(i,19)
      ppd(i,38)=aycy(i)*ppp(i,19)+dpp(i,37)
      ppd(i,39)=azcz(i)*ppp(i,19)+dpp(i,46)
      ppd(i,40)=aycy(i)*ppp(i,20)+dpp(i,38)
      ppd(i,41)=azcz(i)*ppp(i,20)+dpp(i,47)
      ppd(i,42)=azcz(i)*ppp(i,21)+dpp(i,48)
      ppd(i,43)=axcx(i)*ppp(i,22)+dpp(i,22)
      ppd(i,44)=aycy(i)*ppp(i,22)+dpp(i,40)
      ppd(i,45)=azcz(i)*ppp(i,22)+dpp(i,49)
      ppd(i,46)=aycy(i)*ppp(i,23)+dpp(i,41)
      ppd(i,47)=azcz(i)*ppp(i,23)+dpp(i,50)
      ppd(i,48)=azcz(i)*ppp(i,24)+dpp(i,51)
      ppd(i,49)=axcx(i)*ppp(i,25)+dpp(i,25)
      ppd(i,50)=aycy(i)*ppp(i,25)+dpp(i,43)
      ppd(i,51)=azcz(i)*ppp(i,25)+dpp(i,52)
      ppd(i,52)=aycy(i)*ppp(i,26)+dpp(i,44)
      ppd(i,53)=azcz(i)*ppp(i,26)+dpp(i,53)
 2019 ppd(i,54)=azcz(i)*ppp(i,27)+dpp(i,54)

      do 2020 j=1,10
      do 2020 i=1,nn
 2020 gather(i,j)=zero

      do 2021 j=1,9
      do 2021 i=1,nn
 2021 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pps(i,j)

      do 2022 k=1,3
      do 2022 j=1,9
      do 2022 i=1,nn
 2022 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*ppp(i,3*(j-1)+k)

      do 2023 k=1,6
      do 2023 j=1,9
      do 2023 i=1,nn
 2023 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*ppd(i,6*(j-1)+k)

      nnn=0

      do 2024 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 2024 continue

      index(1)=2
      index(2)=3
      index(3)=6

      do 2025 j=1,3
cfpp$ nodepchk
      do 2025 i=1,nnn
 2025 gather(iloc(i),1)=gather(iloc(i),1)
     &                 -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                 *pps(iloc(i),index(j))

      do 2026 k=1,3
      do 2026 j=1,3
cfpp$ nodepchk
      do 2026 i=1,nnn
 2026 gather(iloc(i),k+1)=gather(iloc(i),k+1)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ppp(iloc(i),3*(index(j)-1)+k)

      do 2027 k=1,6
      do 2027 j=1,3
cfpp$ nodepchk
      do 2027 i=1,nnn
 2027 gather(iloc(i),k+4)=gather(iloc(i),k+4)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ppd(iloc(i),6*(index(j)-1)+k)

      do 2028 i=1,nn
      gather(i,01)=gather(i,01)*xcfits
      gather(i,02)=gather(i,02)*xcfitp(1)
      gather(i,03)=gather(i,03)*xcfitp(2)
      gather(i,04)=gather(i,04)*xcfitp(3)
      gather(i,05)=gather(i,05)*xcfitd(1)
      gather(i,06)=gather(i,06)*xcfitd(2)
      gather(i,07)=gather(i,07)*xcfitd(3)
      gather(i,08)=gather(i,08)*xcfitd(4)
      gather(i,09)=gather(i,09)*xcfitd(5)
 2028 gather(i,10)=gather(i,10)*xcfitd(6)

      nc=nxcs+(naux-1)*10

      do 2029 i=1,nn
      do 2029 j=1,10
 2029 vvector(nc+j)=vvector(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine cdovxs(ncds,ncdspd,ndim,ilfunc,icfunc,alpha,coeffs,
     &                  coeffp,coeffd,cdsmat,cent,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension g(13)

      dimension ilfunc(*),icfunc(*)

      dimension alpha(*),coeffs(*),coeffp(*),coeffd(*),cdsmat(ndim,*)
      dimension cent(3,*),wkvec(*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,forty9/4.0d0,5.0d0,49.0d0/
      data pi/3.1415926535898d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      sqrt493=sqrt(forty9/three)

      factor=(pi**(five/four)*sqrt(two))**2

      n=ncds*ncdspd

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)
                          call mpi_bsend(isent,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(isent,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      istart=isent+1
      iend=isent+nloop

      ij=0

      do 1002 i=1,ncdspd
      do 1002 j=1,ncds

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1002

      ilabel=ilfunc(ncds+i)
      jlabel=ilfunc(j)

      nc1=icfunc(ilabel)
      nc2=icfunc(jlabel)

      zetaa=alpha(ilabel)
      zetab=alpha(jlabel)

      zetaab=one/(zetaa+zetab)

      wxpx=(zetaa*cent(1,nc1)+zetab*cent(1,nc2))*zetaab-cent(1,nc1)
      wypy=(zetaa*cent(2,nc1)+zetab*cent(2,nc2))*zetaab-cent(2,nc1)
      wzpz=(zetaa*cent(3,nc1)+zetab*cent(3,nc2))*zetaab-cent(3,nc1)

      axbx=cent(1,nc1)-cent(1,nc2)
      ayby=cent(2,nc1)-cent(2,nc2)
      azbz=cent(3,nc1)-cent(3,nc2)

      u=zetaa*zetab*zetaab*(axbx*axbx+ayby*ayby+azbz*azbz)

      call augg(3,u,g)

      sasa0=g(1)*factor*sqrt(zetaab)/(zetaa*zetab)
      sasa1=g(2)*factor*sqrt(zetaab)/(zetaa*zetab)
      sasa2=g(3)*factor*sqrt(zetaab)/(zetaa*zetab)

      pasa0=wxpx*sasa1
      pbsa0=wypy*sasa1
      pcsa0=wzpz*sasa1

      pasa1=wxpx*sasa2
      pbsa1=wypy*sasa2
      pcsa1=wzpz*sasa2

      corr=(sasa0-zetab*zetaab*sasa1)/(two*zetaa)

      dasa0=wxpx*pasa1+corr
      dbsa0=wypy*pasa1
      dcsa0=wzpz*pasa1
      ddsa0=wypy*pbsa1+corr
      desa0=wzpz*pbsa1
      dfsa0=wzpz*pcsa1+corr

      n=ncds+10*(i-1)

      cdsmat(n+01,j)=coeffs(ilabel)*coeffs(jlabel)*sasa0
      cdsmat(n+02,j)=coeffp(ilabel)*coeffs(jlabel)*pasa0
      cdsmat(n+03,j)=coeffp(ilabel)*coeffs(jlabel)*pbsa0
      cdsmat(n+04,j)=coeffp(ilabel)*coeffs(jlabel)*pcsa0
      cdsmat(n+05,j)=coeffd(ilabel)*coeffs(jlabel)*dasa0/sqrt493
      cdsmat(n+06,j)=coeffd(ilabel)*coeffs(jlabel)*dbsa0
      cdsmat(n+07,j)=coeffd(ilabel)*coeffs(jlabel)*dcsa0
      cdsmat(n+08,j)=coeffd(ilabel)*coeffs(jlabel)*ddsa0/sqrt493
      cdsmat(n+09,j)=coeffd(ilabel)*coeffs(jlabel)*desa0
      cdsmat(n+10,j)=coeffd(ilabel)*coeffs(jlabel)*dfsa0/sqrt493

 1002 continue

      return
      end

      subroutine inputbases(natoms,ncenters,nconts,ncontp,ncontd,
     &                      ncontractions,ncds,ncdspd,ncdfuncs,nxcs,
     &                      nxcspd,nxcfuncs,idiffuse,ixcfit,iwkvec1,
     &                      iwkvec2,iwkvec3,iwkvec4,icfunc,ilfunc,
     &                      ngaussians,mtloca,nshels,nshelp,nsheld,
     &                      icdcfunc,icdlfunc,ixccfunc,ixclfunc,nt,
     &                      alpha,coeff,alphacd,coefscd,coefpcd,coefdcd,
     &                      alphaxc,coefsxc,coefpxc,coefdxc,bstring)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      character input_string*30,test_string*30,bstring(natoms,2)*30

      dimension iwkvec1(*),iwkvec2(*),iwkvec3(*),iwkvec4(*),icfunc(*),
     &          ilfunc(*),ngaussians(*),mtloca(*),nshels(*),nshelp(*),
     &          nsheld(*),icdcfunc(*),icdlfunc(*),ixccfunc(*),
     &          ixclfunc(*),nt(*)

      dimension alpha(*),coeff(*),alphacd(*),coefscd(*),coefpcd(*),
     &          coefdcd(*),alphaxc(*),coefsxc(*),coefpxc(*),coefdxc(*)

      data pi/3.1415926535898d0/
      data zero,quarter,thrhlf,fivhlf/0.0d0,0.25d0,1.5d0,2.5d0/
      data one,two,three,eight,twelve,twenty/1.0d0,2.0d0,3.0d0,
     &                                       8.0d0,12.0d0,20.0d0/
      data onehund28,twothou48/128.0d0,2048.0d0/

      ncds=0
      nxcs=0

      ncdspd=0
      nxcspd=0

      n1=0
      n2=0

      read(5,2001) test_string

      do 1001 i=1,ncenters

      if(test_string(1:2).eq.'a-') then

        if(i.eq.1) bstring(1,1)=test_string
        if(i.gt.1) read(5,2001) bstring(i,1)

                                   else

        if(test_string(1:5).eq.'aux1a') then

          if(nt(i).eq.00) bstring(i,1)='a-dummy'
          if(nt(i).eq.01) bstring(i,1)='a-hydrogen (3,1;3,1)'
          if(nt(i).eq.02) bstring(i,1)='a-helium (3,1;3,1)'
          if(nt(i).eq.03) bstring(i,1)='a-lithium (4,3;4,3)'
          if(nt(i).eq.04) bstring(i,1)='a-beryllium (4,3;4,3)'
          if(nt(i).eq.05) bstring(i,1)='a-boron (4,4;4,4)'
          if(nt(i).eq.06) bstring(i,1)='a-carbon (4,4;4,4)'
          if(nt(i).eq.07) bstring(i,1)='a-nitrogen (4,4;4,4)'
          if(nt(i).eq.08) bstring(i,1)='a-oxygen (4,4;4,4)'
          if(nt(i).eq.09) bstring(i,1)='a-fluorine (4,4;4,4)'
          if(nt(i).eq.10) bstring(i,1)='a-neon (4,4;4,4)'
          if(nt(i).eq.11) bstring(i,1)='a-sodium (5,4;5,4)'
          if(nt(i).eq.12) bstring(i,1)='a-magnesium (5,4;5,4)'
          if(nt(i).eq.13) bstring(i,1)='a-aluminum (5,4;5,4)'
          if(nt(i).eq.14) bstring(i,1)='a-silicon (5,4;5,4)'
          if(nt(i).eq.15) bstring(i,1)='a-phosphorus (5,4;5,4)'
          if(nt(i).eq.16) bstring(i,1)='a-sulfur (5,4;5,4)'
          if(nt(i).eq.17) bstring(i,1)='a-chlorine (5,4;5,4)'
          if(nt(i).eq.18) bstring(i,1)='a-argon (5,4;5,4)'
          if(nt(i).eq.19) bstring(i,1)='a-potassium (5,5;5,5)'
          if(nt(i).eq.20) bstring(i,1)='a-calcium (5,5;5,5)'
          if(nt(i).eq.21) bstring(i,1)='a-scandium (5,5;5,5)'
          if(nt(i).eq.22) bstring(i,1)='a-titanium (5,5;5,5)'
          if(nt(i).eq.23) bstring(i,1)='a-vanadium (5,5;5,5)'
          if(nt(i).eq.24) bstring(i,1)='a-chromium (5,5;5,5)'
          if(nt(i).eq.25) bstring(i,1)='a-manganese (5,5;5,5)'
          if(nt(i).eq.26) bstring(i,1)='a-iron (5,5;5,5)'
          if(nt(i).eq.27) bstring(i,1)='a-cobalt (5,5;5,5)'
          if(nt(i).eq.28) bstring(i,1)='a-nickel (5,5;5,5)'
          if(nt(i).eq.29) bstring(i,1)='a-copper (5,5;5,5)'
          if(nt(i).eq.30) bstring(i,1)='a-zinc (5,5;5,5)'
          if(nt(i).eq.31) bstring(i,1)='a-gallium (5,5;5,5)'
          if(nt(i).eq.32) bstring(i,1)='a-germanium (5,5;5,5)'
          if(nt(i).eq.33) bstring(i,1)='a-arsenic (5,5;5,5)'
          if(nt(i).eq.34) bstring(i,1)='a-selenium (5,5;5,5)'
          if(nt(i).eq.35) bstring(i,1)='a-bromine (5,5;5,5)'
          if(nt(i).eq.36) bstring(i,1)='a-krypton (5,5;5,5)'
          if(nt(i).eq.37) bstring(i,1)='a-rubidium (5,5;5,5)'
          if(nt(i).eq.38) bstring(i,1)='a-strontium (5,5;5,5)'
          if(nt(i).eq.39) bstring(i,1)='a-yttrium (5,5;5,5)'
          if(nt(i).eq.40) bstring(i,1)='a-zirconium (5,5;5,5)'
          if(nt(i).eq.41) bstring(i,1)='a-niobium (5,5;5,5)'
          if(nt(i).eq.42) bstring(i,1)='a-molybdenum (5,5;5,5)'
          if(nt(i).eq.43) bstring(i,1)='a-technetium (5,5;5,5)'
          if(nt(i).eq.44) bstring(i,1)='a-ruthenium (5,5;5,5)'
          if(nt(i).eq.45) bstring(i,1)='a-rhodium (5,5;5,5)'
          if(nt(i).eq.46) bstring(i,1)='a-palladium (5,5;5,5)'
          if(nt(i).eq.47) bstring(i,1)='a-silver (5,5;5,5)'
          if(nt(i).eq.48) bstring(i,1)='a-cadmium (5,5;5,5)'
          if(nt(i).eq.49) bstring(i,1)='a-indium (5,5;5,5)'
          if(nt(i).eq.50) bstring(i,1)='a-tin (5,5;5,5)'
          if(nt(i).eq.51) bstring(i,1)='a-antimony (5,5;5,5)'
          if(nt(i).eq.52) bstring(i,1)='a-tellurium (5,5;5,5)'
          if(nt(i).eq.53) bstring(i,1)='a-iodine (5,5;5,5)'
          if(nt(i).eq.54) bstring(i,1)='a-xenon (5,5;5,5)'

                                        endif

                                   endif

      rewind(3)

 1002 read(3,2001) input_string
      if(input_string.ne.bstring(i,1)) goto 1002

      read(3,*) n

      if(n.ne.0) then
                       do 1003 j=1,n
                       read(3,*) alphacd(n1+j)
                       icdcfunc(n1+j)=i
                       iwkvec1(ncds+j)=n1+j
 1003                  coefscd(n1+j)=one/sqrt(sqrt(two)*
     &                                  ((pi/alphacd(n1+j))**fivhlf))
                 endif

      ncds=ncds+n
      n1=n1+n

      read(3,*) n

      if(n.ne.0) then
                       do 1004 j=1,n
                       read(3,*) alphacd(n1+j)
                       icdcfunc(n1+j)=i
                       iwkvec2(ncdspd+j)=n1+j
                       factor=sqrt(two)*((pi/alphacd(n1+j))**fivhlf)
                       coefscd(n1+j)=one/sqrt(factor)
                       factor=factor/(twelve*alphacd(n1+j))
                       coefpcd(n1+j)=one/sqrt(factor)
                       factor=factor*three/(twenty*alphacd(n1+j))
 1004                  coefdcd(n1+j)=one/sqrt(factor)
                 endif

      ncdspd=ncdspd+n
      n1=n1+n

      read(3,*) n

      if(n.ne.0) then
                       do 1005 j=1,n
                       read(3,*) alphaxc(n2+j)
                       ixccfunc(n2+j)=i
                       iwkvec3(nxcs+j)=n2+j
 1005                  coefsxc(n2+j)=(eight*alphaxc(n2+j)**3/pi**3)**
     &                                                          quarter
                 endif

      nxcs=nxcs+n
      n2=n2+n

      read(3,*) n

      if(n.ne.0) then
                       do 1006 j=1,n
                       read(3,*) alphaxc(n2+j)
                       ixccfunc(n2+j)=i
                       iwkvec4(nxcspd+j)=n2+j
                       coefsxc(n2+j)=(eight*alphaxc(n2+j)**3/pi**3)
     &                                                       **quarter
                       coefpxc(n2+j)=(onehund28*alphaxc(n2+j)**5/pi**3)
     &                                                       **quarter
 1006                  coefdxc(n2+j)=(twothou48*alphaxc(n2+j)**7/pi**3)
     &                                                       **quarter
                 endif

      nxcspd=nxcspd+n
      n2=n2+n

 1001 continue

      if(ncds.ne.0) then
                          do 1007 i=1,ncds
 1007                     icdlfunc(i)=iwkvec1(i)
                    endif

      if(nxcs.ne.0) then
                          do 1008 i=1,nxcs
 1008                     ixclfunc(i)=iwkvec3(i)
                    endif

      if(ncdspd.ne.0) then
                            do 1009 i=1,ncdspd
 1009                       icdlfunc(ncds+i)=iwkvec2(i)
                      endif

      if(nxcspd.ne.0) then
                            do 1010 i=1,nxcspd
 1010                       ixclfunc(nxcs+i)=iwkvec4(i)
                      endif

      ncdfuncs=ncds+10*ncdspd
      nxcfuncs=nxcs+10*nxcspd

      ncdspd=ncds+ncdspd
      nxcspd=nxcs+nxcspd

      nconts=0
      ncontp=0
      ncontd=0

      m=0
      n=0

      read(5,2001) test_string

      do 1011 i=1,ncenters

      if(test_string(1:2).eq.'o-') then

                          if(i.eq.1) bstring(1,2)=test_string
                          if(i.gt.1) read(5,2001) bstring(i,2)

                                   else

      if(test_string(1:7).eq.'tzp/dzp') then

       if(nt(i).eq.00) bstring(i,2)='o-dummy'
       if(nt(i).eq.01) bstring(i,2)='o-hydrogen (41/1)'
       if(nt(i).eq.02) bstring(i,2)='o-helium (51/1)'
       if(nt(i).eq.03) bstring(i,2)='o-lithium (7111/1/1)'
       if(nt(i).eq.04) bstring(i,2)='o-beryllium (7111/1/1)'
       if(nt(i).eq.05) bstring(i,2)='o-boron (7111/411/1)'
       if(nt(i).eq.06) bstring(i,2)='o-carbon (7111/411/1)'
       if(nt(i).eq.07) bstring(i,2)='o-nitrogen (7111/411/1)'
       if(nt(i).eq.08) bstring(i,2)='o-oxygen (7111/411/1)'
       if(nt(i).eq.09) bstring(i,2)='o-fluorine (7111/411/1)'
       if(nt(i).eq.10) bstring(i,2)='o-neon (7111/411/1)'
       if(nt(i).eq.11) bstring(i,2)='o-sodium (63111/411/1)'
       if(nt(i).eq.12) bstring(i,2)='o-magnesium (63111/411/1)'
       if(nt(i).eq.13) bstring(i,2)='o-aluminum (73111/6111/1)'
       if(nt(i).eq.14) bstring(i,2)='o-silicon (73111/6111/1)'
       if(nt(i).eq.15) bstring(i,2)='o-phosphorus (73111/6111/1)'
       if(nt(i).eq.16) bstring(i,2)='o-sulfur (73111/6111/1)'
       if(nt(i).eq.17) bstring(i,2)='o-chlorine (73111/6111/1)'
       if(nt(i).eq.18) bstring(i,2)='o-argon (73111/6111/1)'
       if(nt(i).eq.19) bstring(i,2)='o-potassium (633111/5211/1)'
       if(nt(i).eq.20) bstring(i,2)='o-calcium (633111/5211/1)'
       if(nt(i).eq.21) bstring(i,2)='o-scandium (633111/5211/311)'
       if(nt(i).eq.22) bstring(i,2)='o-titanium (633111/5211/311)'
       if(nt(i).eq.23) bstring(i,2)='o-vanadium (633111/5211/311)'
       if(nt(i).eq.24) bstring(i,2)='o-chromium (633111/5211/311)'
       if(nt(i).eq.25) bstring(i,2)='o-manganese (633111/5211/311)'
       if(nt(i).eq.26) bstring(i,2)='o-iron (633111/5211/311)'
       if(nt(i).eq.27) bstring(i,2)='o-cobalt (633111/5211/311)'
       if(nt(i).eq.28) bstring(i,2)='o-nickel (633111/5211/311)'
       if(nt(i).eq.29) bstring(i,2)='o-copper (633111/5211/311)'
       if(nt(i).eq.30) bstring(i,2)='o-zinc (633111/5211/311)'
       if(nt(i).eq.31) bstring(i,2)='o-gallium (633111/53111/41)'
       if(nt(i).eq.32) bstring(i,2)='o-germanium (633111/53111/41)'
       if(nt(i).eq.33) bstring(i,2)='o-arsenic (633111/53111/41)'
       if(nt(i).eq.34) bstring(i,2)='o-selenium (633111/53111/41)'
       if(nt(i).eq.35) bstring(i,2)='o-bromine (633111/53111/41)'
       if(nt(i).eq.36) bstring(i,2)='o-krypton (633111/53111/41)'
       if(nt(i).eq.37) bstring(i,2)='o-rubidium (6333111/53211/51)'
       if(nt(i).eq.38) bstring(i,2)='o-strontium (6333111/53211/51)'
       if(nt(i).eq.39) bstring(i,2)='o-yttrium (6333111/53211/5211)'
       if(nt(i).eq.40) bstring(i,2)='o-zirconium (6333111/53211/5211)'
       if(nt(i).eq.41) bstring(i,2)='o-niobium (6333111/53211/5211)'
       if(nt(i).eq.42) bstring(i,2)='o-molybdenum (6333111/53211/5211)'
       if(nt(i).eq.43) bstring(i,2)='o-technetium (6333111/53211/5211)'
       if(nt(i).eq.44) bstring(i,2)='o-ruthenium (6333111/53211/5211)'
       if(nt(i).eq.45) bstring(i,2)='o-rhodium (6333111/53211/5211)'
       if(nt(i).eq.46) bstring(i,2)='o-palladium (6333111/53211/5211)'
       if(nt(i).eq.47) bstring(i,2)='o-silver (6333111/53211/5211)'
       if(nt(i).eq.48) bstring(i,2)='o-cadmium (6333111/53211/5211)'
       if(nt(i).eq.49) bstring(i,2)='o-indium (6333111/533111/531)'
       if(nt(i).eq.50) bstring(i,2)='o-tin (6333111/533111/531)'
       if(nt(i).eq.51) bstring(i,2)='o-antimony (6333111/533111/531)'
       if(nt(i).eq.52) bstring(i,2)='o-tellurium (6333111/533111/531)'
       if(nt(i).eq.53) bstring(i,2)='o-iodine (6333111/533111/531)'
       if(nt(i).eq.54) bstring(i,2)='o-xenon (6333111/533111/531)'

                                        endif

                                 endif

      rewind(3)

 1012 read(3,2001) input_string
      if(input_string.ne.bstring(i,2)) goto 1012

      read(3,*) nfuncs,nfuncp,nfuncd

      do 1013 j=1,nfuncs

      read(3,*) nprimitives
      nshels(nconts+j)=m+j
      ngaussians(m+j)=nprimitives
      icfunc(m+j)=i
      ilfunc(m+j)=n+1

      do 1014 k=1,nprimitives
      read(3,*) alpha(n+k),coeff(n+k)
 1014 coeff(n+k)=coeff(n+k)*(eight*alpha(n+k)**3/pi**3)**quarter

      dn=zero

      do 1015 k=1,nprimitives
      do 1015 l=1,nprimitives
 1015 dn=dn+coeff(n+k)*coeff(n+l)*(pi/(alpha(n+k)+alpha(n+l)))**thrhlf

      do 1016 k=1,nprimitives
 1016 coeff(n+k)=coeff(n+k)/sqrt(dn)

 1013 n=n+nprimitives

      i_add=0
      if((idiffuse.eq.1).and.(nt(i).gt.2)) i_add=1
      if(idiffuse.eq.2) i_add=1

      if(i_add.eq.1) then
                           nshels(nconts+nfuncs+1)=m+nfuncs+1
                           ngaussians(m+nfuncs+1)=1
                           icfunc(m+nfuncs+1)=i
                           ilfunc(m+nfuncs+1)=n+1

                           alpha(n+1)=alpha(n)/three
                           coeff(n+1)=coeff(n)
                           coeff(n+1)=coeff(n+1)
     &                               *(eight*alpha(n+1)**3/pi**3)
     &                               **quarter

                           dn=zero

                           dn=dn+coeff(n+1)*coeff(n+1)
     &                          *(pi/(alpha(n+1)+alpha(n+1)))**thrhlf

                           coeff(n+1)=coeff(n+1)/sqrt(dn)

                           nfuncs=nfuncs+1

                           n=n+1
                     endif

      m=m+nfuncs

      do 1018 j=1,nfuncp

      read(3,*) nprimitives
      nshelp(ncontp+j)=m+j
      ngaussians(m+j)=nprimitives
      icfunc(m+j)=i
      ilfunc(m+j)=n+1

      do 1019 k=1,nprimitives
      read(3,*) alpha(n+k),coeff(n+k)
 1019 coeff(n+k)=coeff(n+k)*(onehund28*alpha(n+k)**5/pi**3)**quarter

      dn=zero

      do 1020 k=1,nprimitives
      do 1020 l=1,nprimitives
      factor=coeff(n+k)*coeff(n+l)*(pi/(alpha(n+k)+alpha(n+l)))**thrhlf
 1020 dn=dn+factor/(two*(alpha(n+k)+alpha(n+l)))

      do 1021 k=1,nprimitives
 1021 coeff(n+k)=coeff(n+k)/sqrt(dn)

 1018 n=n+nprimitives

      i_add=0
      if((idiffuse.eq.1).and.(nt(i).gt.2)) i_add=1
      if(idiffuse.eq.2) i_add=1

      if(i_add.eq.1) then
                           nshelp(ncontp+nfuncp+1)=m+nfuncp+1
                           ngaussians(m+nfuncp+1)=1
                           icfunc(m+nfuncp+1)=i
                           ilfunc(m+nfuncp+1)=n+1

                           alpha(n+1)=alpha(n)/three
                           coeff(n+1)=coeff(n)
                           coeff(n+1)=coeff(n+1)
     &                               *(onehund28*alpha(n+1)**5/pi**3)
     &                               **quarter

                           dn=zero

                           factor=coeff(n+1)*coeff(n+1)
     &                           *(pi/(alpha(n+1)+alpha(n+1)))**thrhlf
                           dn=dn+factor/(two*(alpha(n+1)+alpha(n+1)))

                           coeff(n+1)=coeff(n+1)/sqrt(dn)

                           nfuncp=nfuncp+1

                           n=n+1
                     endif

      m=m+nfuncp

      do 1022 j=1,nfuncd

      read(3,*) nprimitives
      nsheld(ncontd+j)=m+j
      ngaussians(m+j)=nprimitives
      icfunc(m+j)=i
      ilfunc(m+j)=n+1

      do 1023 k=1,nprimitives
      read(3,*) alpha(n+k),coeff(n+k)
 1023 coeff(n+k)=coeff(n+k)*(twothou48*alpha(n+k)**7/pi**3)**quarter

      dn=zero

      do 1024 k=1,nprimitives
      do 1024 l=1,nprimitives
      factor=coeff(n+k)*coeff(n+l)*(pi/(alpha(n+k)+alpha(n+l)))**thrhlf
 1024 dn=dn+factor/((two*(alpha(n+k)+alpha(n+l)))**2)

      do 1025 k=1,nprimitives
 1025 coeff(n+k)=coeff(n+k)/sqrt(dn)

 1022 n=n+nprimitives

      i_add=0
      if((idiffuse.ne.0).and.(nt(i).gt.18)) i_add=1

      if(i_add.eq.1) then
                           nsheld(ncontd+nfuncd+1)=m+nfuncd+1
                           ngaussians(m+nfuncd+1)=1
                           icfunc(m+nfuncd+1)=i
                           ilfunc(m+nfuncd+1)=n+1

                           alpha(n+1)=alpha(n)/three
                           coeff(n+1)=coeff(n)
                           coeff(n+1)=coeff(n+1)
     &                               *(twothou48*alpha(n+1)**7/pi**3)
     &                               **quarter

                           dn=zero

                           factor=coeff(n+1)*coeff(n+1)
     &                           *(pi/(alpha(n+1)+alpha(n+1)))**thrhlf
                           dn=dn+factor
     &                          /((two*(alpha(n+1)+alpha(n+1)))**2)

                           coeff(n+1)=coeff(n+1)/sqrt(dn)

                           nfuncd=nfuncd+1

                           n=n+1
                     endif

      m=m+nfuncd

      nconts=nconts+nfuncs
      ncontp=ncontp+nfuncp
      ncontd=ncontd+nfuncd

 1011 continue

      ncontractions=nconts+3*ncontp+6*ncontd

      ntemp=nxcfuncs
      if(ixcfit.eq.0) ntemp=0

      write(6,2002) ncontractions,ncdfuncs

      do 1026 i=1,nconts
 1026 mtloca(nshels(i))=i

      if(ncontp.ne.0) then
                            do 1027 i=1,ncontp
 1027                       mtloca(nshelp(i))=nconts+3*(i-1)+1
                      endif

      if(ncontd.ne.0) then
                            do 1028 i=1,ncontd
 1028                       mtloca(nsheld(i))=nconts+3*ncontp+6*(i-1)+1
                      endif

 2001 format(a30)
 2002 format(' number of orbital basis functions                =',i5,/,
     &       ' number of charge density fitting functions       =',i5,/)

      return
      end

      subroutine savet(ncenters,ncdfunctions,nxcfunctions,
     &                 nmaxcontractions,ncontractions,coord,cdfitc,
     &                 xcfita,xcfitb,xcfite,coeffa,coeffb)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension coord(3,*),cdfitc(*),xcfita(*),xcfitb(*),xcfite(*)
      dimension coeffa(nmaxcontractions,*),coeffb(nmaxcontractions,*)

      rewind 1
      rewind 2

      call fastrd(1,coord,3*ncenters)
      call fastwr(2,coord,3*ncenters)

      call fastrd(1,cdfitc,ncdfunctions)
      call fastwr(2,cdfitc,ncdfunctions)

      call fastrd(1,xcfita,nxcfunctions)
      call fastrd(1,xcfitb,nxcfunctions)
      call fastrd(1,xcfite,nxcfunctions)
      call fastwr(2,xcfita,nxcfunctions)
      call fastwr(2,xcfitb,nxcfunctions)
      call fastwr(2,xcfite,nxcfunctions)

      do 1001 i=1,ncontractions
      call fastrd(1,coeffa(1,i),ncontractions)
 1001 call fastwr(2,coeffa(1,i),ncontractions)

      do 1002 i=1,ncontractions
      call fastrd(1,coeffb(1,i),ncontractions)
 1002 call fastwr(2,coeffb(1,i),ncontractions)

      return
      end

      subroutine xcordd(m,n,nxcs,nxcspd,ilfunc,icfunc,iminj,icontr,
     &                  iicontr,inddyy,iloc,coord,xcfit1,xcfit2,xcfit3,
     &                  alphaaux,coeffs,coeffp,coeffd,fock1,fock2,fock3,
     &                  zeta,ax,ay,az,axbx,ayby,azbz,px,py,pz,base,
     &                  zetarec,zetafac,efac,gxax,gyay,gzaz,sss,pss,dss,
     &                  dsscond,fss,fsscond,gss,gsscond,hss,hsscond,qss,
     &                  qsscond,dps,dds,ddp,ddd,fps,fds,fdp,gps,gds,hps,
     &                  c,c1,c2,c3,c4,zzeta,aax,aay,aaz,ppx,ppy,ppz,
     &                  axcx,aycy,azcz,gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension index(36)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),iicontr(*),
     &          inddyy(m,*),iloc(*)

      dimension coord(3,*),xcfit1(*),xcfit2(*),xcfit3(*),alphaaux(*),
     &          coeffs(*),coeffp(*),coeffd(*),fock1(*),fock2(*),
     &          fock3(*),zeta(*),ax(*),ay(*),az(*),axbx(*),ayby(*),
     &          azbz(*),px(*),py(*),pz(*),base(*),zetarec(*),zetafac(*),
     &          efac(*),gxax(*),gyay(*),gzaz(*),sss(*),pss(n,*),
     &          dss(n,*),dsscond(n,*),fss(n,*),fsscond(n,*),gss(n,*),
     &          gsscond(n,*),hss(n,*),hsscond(n,*),qss(n,*),
     &          qsscond(n,*),dps(n,*),dds(n,*),ddp(n,*),ddd(n,*),
     &          fps(n,*),fds(n,*),fdp(n,*),gps(n,*),gds(n,*),hps(n,*),
     &          c(*),c1(n,*),c2(n,*),c3(n,*),c4(n,*),zzeta(*),aax(*),
     &          aay(*),aaz(*),ppx(*),ppy(*),ppz(*),axcx(*),aycy(*),
     &          azcz(*),gather(n,*)

      data zero,one,two,three,four,five/0.0d0,1.0d0,2.0d0,
     &                                  3.0d0,4.0d0,5.0d0/
      data expcut,calcut/45.0d0,1.0d-16/

      sqrt3=sqrt(three)

      do 1001 j=1,36
      do 1001 i=1,n
 1001 gather(i,j)=zero

      do 1002 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=xcfit3(naux)*coeffs(ilaux)

      do 1003 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1003 zetarec(i)=one/(zeta(i)+zetaux)

      do 1004 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1004 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1005 i=1,n
      sss(i)=zero
 1005 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 1006 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 1006 continue

      do 1007 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 1007 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 1008 i=1,nn
 1008 zetarec(i)=zetarec(i)/two

      do 1009 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 1009 pss(i,3)=gzaz(i)*sss(i)

      do 1010 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 1010 continue

      do 1011 j=1,3
      do 1011 i=1,nn
 1011 c1(i,j)=zetarec(i)*pss(i,j)

      do 1012 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 1012 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 1013 j=1,6
      do 1013 i=1,nn
 1013 c2(i,j)=zetarec(i)*dss(i,j)

      do 1014 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 1014 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 1015 i=1,nn
      dps(i,01)=axbx(iicontr(i))*dss(i,1)+fss(i,01)
      dps(i,02)=ayby(iicontr(i))*dss(i,1)+fss(i,02)
      dps(i,03)=azbz(iicontr(i))*dss(i,1)+fss(i,03)
      dps(i,04)=axbx(iicontr(i))*dss(i,2)+fss(i,02)
      dps(i,05)=ayby(iicontr(i))*dss(i,2)+fss(i,04)
      dps(i,06)=azbz(iicontr(i))*dss(i,2)+fss(i,05)
      dps(i,07)=axbx(iicontr(i))*dss(i,3)+fss(i,03)
      dps(i,08)=ayby(iicontr(i))*dss(i,3)+fss(i,05)
      dps(i,09)=azbz(iicontr(i))*dss(i,3)+fss(i,06)
      dps(i,10)=axbx(iicontr(i))*dss(i,4)+fss(i,04)
      dps(i,11)=ayby(iicontr(i))*dss(i,4)+fss(i,07)
      dps(i,12)=azbz(iicontr(i))*dss(i,4)+fss(i,08)
      dps(i,13)=axbx(iicontr(i))*dss(i,5)+fss(i,05)
      dps(i,14)=ayby(iicontr(i))*dss(i,5)+fss(i,08)
      dps(i,15)=azbz(iicontr(i))*dss(i,5)+fss(i,09)
      dps(i,16)=axbx(iicontr(i))*dss(i,6)+fss(i,06)
      dps(i,17)=ayby(iicontr(i))*dss(i,6)+fss(i,09)
 1015 dps(i,18)=azbz(iicontr(i))*dss(i,6)+fss(i,10)

      do 1016 i=1,nn
      fps(i,01)=axbx(iicontr(i))*fss(i,01)+gss(i,01)
      fps(i,02)=ayby(iicontr(i))*fss(i,01)+gss(i,02)
      fps(i,03)=azbz(iicontr(i))*fss(i,01)+gss(i,03)
      fps(i,04)=axbx(iicontr(i))*fss(i,02)+gss(i,02)
      fps(i,05)=ayby(iicontr(i))*fss(i,02)+gss(i,04)
      fps(i,06)=azbz(iicontr(i))*fss(i,02)+gss(i,05)
      fps(i,07)=axbx(iicontr(i))*fss(i,03)+gss(i,03)
      fps(i,08)=ayby(iicontr(i))*fss(i,03)+gss(i,05)
      fps(i,09)=azbz(iicontr(i))*fss(i,03)+gss(i,06)
      fps(i,10)=axbx(iicontr(i))*fss(i,04)+gss(i,04)
      fps(i,11)=ayby(iicontr(i))*fss(i,04)+gss(i,07)
      fps(i,12)=azbz(iicontr(i))*fss(i,04)+gss(i,08)
      fps(i,13)=axbx(iicontr(i))*fss(i,05)+gss(i,05)
      fps(i,14)=ayby(iicontr(i))*fss(i,05)+gss(i,08)
      fps(i,15)=azbz(iicontr(i))*fss(i,05)+gss(i,09)
      fps(i,16)=axbx(iicontr(i))*fss(i,06)+gss(i,06)
      fps(i,17)=ayby(iicontr(i))*fss(i,06)+gss(i,09)
      fps(i,18)=azbz(iicontr(i))*fss(i,06)+gss(i,10)
      fps(i,19)=axbx(iicontr(i))*fss(i,07)+gss(i,07)
      fps(i,20)=ayby(iicontr(i))*fss(i,07)+gss(i,11)
      fps(i,21)=azbz(iicontr(i))*fss(i,07)+gss(i,12)
      fps(i,22)=axbx(iicontr(i))*fss(i,08)+gss(i,08)
      fps(i,23)=ayby(iicontr(i))*fss(i,08)+gss(i,12)
      fps(i,24)=azbz(iicontr(i))*fss(i,08)+gss(i,13)
      fps(i,25)=axbx(iicontr(i))*fss(i,09)+gss(i,09)
      fps(i,26)=ayby(iicontr(i))*fss(i,09)+gss(i,13)
      fps(i,27)=azbz(iicontr(i))*fss(i,09)+gss(i,14)
      fps(i,28)=axbx(iicontr(i))*fss(i,10)+gss(i,10)
      fps(i,29)=ayby(iicontr(i))*fss(i,10)+gss(i,14)
 1016 fps(i,30)=azbz(iicontr(i))*fss(i,10)+gss(i,15)

      do 1017 i=1,nn
      dds(i,01)=axbx(iicontr(i))*dps(i,01)+fps(i,01)
      dds(i,02)=ayby(iicontr(i))*dps(i,01)+fps(i,04)
      dds(i,03)=azbz(iicontr(i))*dps(i,01)+fps(i,07)
      dds(i,04)=ayby(iicontr(i))*dps(i,02)+fps(i,05)
      dds(i,05)=azbz(iicontr(i))*dps(i,02)+fps(i,08)
      dds(i,06)=azbz(iicontr(i))*dps(i,03)+fps(i,09)
      dds(i,07)=axbx(iicontr(i))*dps(i,04)+fps(i,04)
      dds(i,08)=ayby(iicontr(i))*dps(i,04)+fps(i,10)
      dds(i,09)=azbz(iicontr(i))*dps(i,04)+fps(i,13)
      dds(i,10)=ayby(iicontr(i))*dps(i,05)+fps(i,11)
      dds(i,11)=azbz(iicontr(i))*dps(i,05)+fps(i,14)
      dds(i,12)=azbz(iicontr(i))*dps(i,06)+fps(i,15)
      dds(i,13)=axbx(iicontr(i))*dps(i,07)+fps(i,07)
      dds(i,14)=ayby(iicontr(i))*dps(i,07)+fps(i,13)
      dds(i,15)=azbz(iicontr(i))*dps(i,07)+fps(i,16)
      dds(i,16)=ayby(iicontr(i))*dps(i,08)+fps(i,14)
      dds(i,17)=azbz(iicontr(i))*dps(i,08)+fps(i,17)
      dds(i,18)=azbz(iicontr(i))*dps(i,09)+fps(i,18)
      dds(i,19)=axbx(iicontr(i))*dps(i,10)+fps(i,10)
      dds(i,20)=ayby(iicontr(i))*dps(i,10)+fps(i,19)
      dds(i,21)=azbz(iicontr(i))*dps(i,10)+fps(i,22)
      dds(i,22)=ayby(iicontr(i))*dps(i,11)+fps(i,20)
      dds(i,23)=azbz(iicontr(i))*dps(i,11)+fps(i,23)
      dds(i,24)=azbz(iicontr(i))*dps(i,12)+fps(i,24)
      dds(i,25)=axbx(iicontr(i))*dps(i,13)+fps(i,13)
      dds(i,26)=ayby(iicontr(i))*dps(i,13)+fps(i,22)
      dds(i,27)=azbz(iicontr(i))*dps(i,13)+fps(i,25)
      dds(i,28)=ayby(iicontr(i))*dps(i,14)+fps(i,23)
      dds(i,29)=azbz(iicontr(i))*dps(i,14)+fps(i,26)
      dds(i,30)=azbz(iicontr(i))*dps(i,15)+fps(i,27)
      dds(i,31)=axbx(iicontr(i))*dps(i,16)+fps(i,16)
      dds(i,32)=ayby(iicontr(i))*dps(i,16)+fps(i,25)
      dds(i,33)=azbz(iicontr(i))*dps(i,16)+fps(i,28)
      dds(i,34)=ayby(iicontr(i))*dps(i,17)+fps(i,26)
      dds(i,35)=azbz(iicontr(i))*dps(i,17)+fps(i,29)
 1017 dds(i,36)=azbz(iicontr(i))*dps(i,18)+fps(i,30)

      do 1018 j=1,36
cfpp$ nodepchk
      do 1018 i=1,nn
 1018 gather(iloc(i),j)=gather(iloc(i),j)+dds(i,j)*xcfits

 1002 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=xcfit3(nxcs+(naux-1)*10+1)*coeffs(ilaux)

      xcfitp(1)=xcfit3(nxcs+(naux-1)*10+2)*coeffp(ilaux)
      xcfitp(2)=xcfit3(nxcs+(naux-1)*10+3)*coeffp(ilaux)
      xcfitp(3)=xcfit3(nxcs+(naux-1)*10+4)*coeffp(ilaux)

      xcfitd(1)=xcfit3(nxcs+(naux-1)*10+05)*coeffd(ilaux)/sqrt3
      xcfitd(2)=xcfit3(nxcs+(naux-1)*10+06)*coeffd(ilaux)
      xcfitd(3)=xcfit3(nxcs+(naux-1)*10+07)*coeffd(ilaux)
      xcfitd(4)=xcfit3(nxcs+(naux-1)*10+08)*coeffd(ilaux)/sqrt3
      xcfitd(5)=xcfit3(nxcs+(naux-1)*10+09)*coeffd(ilaux)
      xcfitd(6)=xcfit3(nxcs+(naux-1)*10+10)*coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,nn
 2010 c1(i,j)=zetarec(i)*pss(i,j)

      do 2011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 2011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 2012 j=1,6
      do 2012 i=1,nn
 2012 c2(i,j)=zetarec(i)*dss(i,j)

      do 2013 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 2013 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 2014 j=1,10
      do 2014 i=1,nn
 2014 c3(i,j)=zetarec(i)*fss(i,j)

      do 2015 i=1,nn
      hss(i,01)=gxax(i)*gss(i,01)+c3(i,01)*four
      hss(i,02)=gyay(i)*gss(i,01)
      hss(i,03)=gzaz(i)*gss(i,01)
      hss(i,04)=gyay(i)*gss(i,02)+c3(i,01)
      hss(i,05)=gzaz(i)*gss(i,02)
      hss(i,06)=gzaz(i)*gss(i,03)+c3(i,01)
      hss(i,07)=gyay(i)*gss(i,04)+c3(i,02)*two
      hss(i,08)=gzaz(i)*gss(i,04)
      hss(i,09)=gzaz(i)*gss(i,05)+c3(i,02)
      hss(i,10)=gzaz(i)*gss(i,06)+c3(i,03)*two
      hss(i,11)=gyay(i)*gss(i,07)+c3(i,04)*three
      hss(i,12)=gzaz(i)*gss(i,07)
      hss(i,13)=gzaz(i)*gss(i,08)+c3(i,04)
      hss(i,14)=gzaz(i)*gss(i,09)+c3(i,05)*two
      hss(i,15)=gzaz(i)*gss(i,10)+c3(i,06)*three
      hss(i,16)=gyay(i)*gss(i,11)+c3(i,07)*four
      hss(i,17)=gzaz(i)*gss(i,11)
      hss(i,18)=gzaz(i)*gss(i,12)+c3(i,07)
      hss(i,19)=gzaz(i)*gss(i,13)+c3(i,08)*two
      hss(i,20)=gzaz(i)*gss(i,14)+c3(i,09)*three
 2015 hss(i,21)=gzaz(i)*gss(i,15)+c3(i,10)*four

      do 2016 j=1,15
      do 2016 i=1,nn
 2016 c4(i,j)=zetarec(i)*gss(i,j)

      do 2017 i=1,nn
      qss(i,01)=gxax(i)*hss(i,01)+c4(i,01)*five
      qss(i,02)=gyay(i)*hss(i,01)
      qss(i,03)=gzaz(i)*hss(i,01)
      qss(i,04)=gyay(i)*hss(i,02)+c4(i,01)
      qss(i,05)=gzaz(i)*hss(i,02)
      qss(i,06)=gzaz(i)*hss(i,03)+c4(i,01)
      qss(i,07)=gyay(i)*hss(i,04)+c4(i,02)*two
      qss(i,08)=gzaz(i)*hss(i,04)
      qss(i,09)=gzaz(i)*hss(i,05)+c4(i,02)
      qss(i,10)=gzaz(i)*hss(i,06)+c4(i,03)*two
      qss(i,11)=gyay(i)*hss(i,07)+c4(i,04)*three
      qss(i,12)=gzaz(i)*hss(i,07)
      qss(i,13)=gzaz(i)*hss(i,08)+c4(i,04)
      qss(i,14)=gzaz(i)*hss(i,09)+c4(i,05)*two
      qss(i,15)=gzaz(i)*hss(i,10)+c4(i,06)*three
      qss(i,16)=gyay(i)*hss(i,11)+c4(i,07)*four
      qss(i,17)=gzaz(i)*hss(i,11)
      qss(i,18)=gzaz(i)*hss(i,12)+c4(i,07)
      qss(i,19)=gzaz(i)*hss(i,13)+c4(i,08)*two
      qss(i,20)=gzaz(i)*hss(i,14)+c4(i,09)*three
      qss(i,21)=gzaz(i)*hss(i,15)+c4(i,10)*four
      qss(i,22)=gyay(i)*hss(i,16)+c4(i,11)*five
      qss(i,23)=gzaz(i)*hss(i,16)
      qss(i,24)=gzaz(i)*hss(i,17)+c4(i,11)
      qss(i,25)=gzaz(i)*hss(i,18)+c4(i,12)*two
      qss(i,26)=gzaz(i)*hss(i,19)+c4(i,13)*three
      qss(i,27)=gzaz(i)*hss(i,20)+c4(i,14)*four
 2017 qss(i,28)=gzaz(i)*hss(i,21)+c4(i,15)*five

      call xcordd1(m,n,nn,iicontr,axbx,ayby,azbz,axcx,aycy,azcz,dss,
     &             fss,gss,hss,qss,dps,dds,ddp,ddd,fps,fds,fdp,gps,gds,
     &             hps)

      do 2018 j=1,36
cfpp$ nodepchk
      do 2018 i=1,nn
 2018 gather(iloc(i),j)=gather(iloc(i),j)
     &                 +dds(i,j)*xcfits
     &                 +ddp(i,3*(j-1)+1)*xcfitp(1)
     &                 +ddp(i,3*(j-1)+2)*xcfitp(2)
     &                 +ddp(i,3*(j-1)+3)*xcfitp(3)
     &                 +ddd(i,6*(j-1)+1)*xcfitd(1)
     &                 +ddd(i,6*(j-1)+2)*xcfitd(2)
     &                 +ddd(i,6*(j-1)+3)*xcfitd(3)
     &                 +ddd(i,6*(j-1)+4)*xcfitd(4)
     &                 +ddd(i,6*(j-1)+5)*xcfitd(5)
     &                 +ddd(i,6*(j-1)+6)*xcfitd(6)

 2001 continue

      index(01)=01
      index(02)=07
      index(03)=08
      index(04)=13
      index(05)=14
      index(06)=15
      index(07)=19
      index(08)=20
      index(09)=21
      index(10)=22
      index(11)=25
      index(12)=26
      index(13)=27
      index(14)=28
      index(15)=29
      index(16)=31
      index(17)=32
      index(18)=33
      index(19)=34
      index(20)=35
      index(21)=36

      do 1019 i=1,n
cfpp$ nodepchk
      do 1019 j=1,21
      jj=index(j)
 1019 fock3(inddyy(icontr(i),jj))=fock3(inddyy(icontr(i),jj))
     &                           +gather(i,jj)

      index(01)=02
      index(02)=03
      index(03)=04
      index(04)=05
      index(05)=06
      index(06)=09
      index(07)=10
      index(08)=11
      index(09)=12
      index(10)=16
      index(11)=17
      index(12)=18
      index(13)=23
      index(14)=24
      index(15)=30

      do 1020 i=1,n
      if(iminj(icontr(i)).ne.0) then

cfpp$ nodepchk
      do 1021 j=1,15
      jj=index(j)
 1021 fock3(inddyy(icontr(i),jj))=fock3(inddyy(icontr(i),jj))
     &                           +gather(i,jj)

                                endif
 1020 continue

      return
      end

      subroutine xcgrad(nptsbatch,nmaxpts,ngridtype,iptsweight,ncntrt,
     &                  nconts,ncontp,ncontd,ncentr,ilfunc,icfunc,
     &                  ngauss,nptrs,nptrp,nptrd,nptsatom,natnumber,
     &                  nfuncatom,istore,iwkvec,alpha,coeff,dmta,dmtb,
     &                  cent,grad,x,y,z,weight,xcalph,xcbeta,xcenrg,qf,
     &                  qx,qy,qz,dcc,extent1,extent3,drvtv,wv)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension nptsatom(*),natnumber(*),nfuncatom(*)
      dimension istore(*),iwkvec(*)

      dimension alpha(*),coeff(*),dmta(*),dmtb(*),cent(3,*),grad(3,*)

      dimension x(*),y(*),z(*),weight(*),xcalph(*),xcbeta(*),xcenrg(*)
      dimension qf(nptsbatch,*)
      dimension qx(nptsbatch,*),qy(nptsbatch,*),qz(nptsbatch,*)
      dimension dcc(ncentr,*),extent1(*),extent3(*),drvtv(nptsbatch,*)
      dimension wv(*)

      data cutoff,tolerance,two/1.0d-16,1.0d-18,2.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      if(myid.eq.0) then
                          rewind 11
                          rewind 12
                    endif

      do 1001 i=1,ncentr
      do 1001 j=1,ncentr
 1001 dcc(j,i)=dist(cent(1,j),cent(1,i))

      call diffuse2(nconts,ncontp,ncontd,ilfunc,icfunc,ngauss,nptrs,
     &              nptrp,nptrd,cutoff,alpha,coeff,cent,extent1)

      do 1002 iatom=1,ncentr

      if(natnumber(iatom).eq.0) goto 1002

      if(myid.eq.0) then
                          call fastrd(11,x,nptsatom(iatom))
                          call fastrd(11,y,nptsatom(iatom))
                          call fastrd(11,z,nptsatom(iatom))
                          call fastrd(11,weight,nptsatom(iatom))
                          call fastrd(12,xcalph,nptsatom(iatom))
                          call fastrd(12,xcbeta,nptsatom(iatom))
                          call fastrd(12,xcenrg,nptsatom(iatom))
                    endif

      do 1003 ia=1,nptsatom(iatom),nptsbatch

      radius=sqrt((cent(1,iatom)-x(ia+nptsbatch-1))**2
     &           +(cent(2,iatom)-y(ia+nptsbatch-1))**2
     &           +(cent(3,iatom)-z(ia+nptsbatch-1))**2)

      call mpi_bcast(radius,1,mpi_real8,0,mpi_comm_world,ierr)

      ib=min(ia+nptsbatch-1,nptsatom(iatom))

      npts=ib-ia+1

      nmaxloop=(npts/numprocs)+1
      if((nmaxloop*numprocs).lt.npts) nmaxloop=nmaxloop+1

      if(myid.eq.0) then

              ja=ia

              islave=0

              do 1004 i=1,npts,nmaxloop

              nloop=min(nmaxloop,npts-i+1)

              call mpi_bsend(nloop,1,mpi_integer,islave,
     &                       islave,mpi_comm_world,ierr)
              call mpi_bsend(ja,1,mpi_integer,islave,
     &                       islave,mpi_comm_world,ierr)

              call mpi_bsend(x(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(y(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(z(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(weight(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(xcalph(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(xcbeta(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(xcenrg(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)

              ja=ja+nloop

              last_slave=islave
                           
 1004         islave=islave+1

              do 1005 i=islave,numprocs-1
              ii=0
 1005         call mpi_bsend(ii,1,mpi_integer,i,i,mpi_comm_world,ierr)

                    endif

      call mpi_recv(npts,1,
     &              mpi_integer,0,mpi_any_tag,mpi_comm_world,istat,ierr)

      if(npts.eq.0) goto 1003

      call mpi_recv(ja,1,
     &              mpi_integer,0,mpi_any_tag,mpi_comm_world,istat,ierr)

      call mpi_recv(x(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(y(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(z(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(weight(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(xcalph(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(xcbeta(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(xcenrg(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)

      ka=1
      kb=ka+ncentr
      kc=kb+ncentr
      kd=kc+ncentr
      ke=kd+ncentr*ncentr

      if(iptsweight.eq.1) then

                   call gridgrad(iatom,npts,nptsbatch,ncentr,nconts,
     &                           ncontp,ncontd,ilfunc,icfunc,ngauss,
     &                           nptrs,nptrp,nptrd,natnumber,istore,
     &                           iwkvec,cent,alpha,coeff,wv(ka),wv(kb),
     &                           wv(kc),wv(kd),wv(ke),drvtv,x(ja),y(ja),
     &                           z(ja),weight(ja))

                          endif

      do 1006 i=ja,ja+npts-1
      xcalph(i)=xcalph(i)*weight(i)
 1006 xcbeta(i)=xcbeta(i)*weight(i)

      call compg1(iatom,ncntrt,npts,nptsbatch,ncentr,nconts,ncontp,
     &            ncontd,ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,radius,
     &            cent,alpha,coeff,x(ja),y(ja),z(ja),qf,qx,qy,qz,
     &            extent1,extent3,dcc,wv(00*npts+1),wv(01*npts+1),
     &            wv(02*npts+1),wv(03*npts+1),wv(04*npts+1),
     &            wv(05*npts+1),wv(06*npts+1),wv(07*npts+1),
     &            wv(08*npts+1),wv(09*npts+1),wv(10*npts+1),
     &            wv(11*npts+1),wv(12*npts+1),wv(13*npts+1),
     &            wv(14*npts+1),wv(15*npts+1),wv(16*npts+1),
     &            wv(17*npts+1),wv(18*npts+1),wv(19*npts+1),
     &            wv(20*npts+1),wv(21*npts+1),wv(22*npts+1),
     &            wv(23*npts+1),wv(24*npts+1))

      xcmax=dmaxvec(xcenrg(ja),npts)

      ihits=0

      do 1007 i=1,ncntrt
      if(extent3(i).gt.tolerance) then
                                        ihits=ihits+1
                                        iwkvec(ncentr+ihits)=i
                                  endif
 1007 continue

      do 1008 i=1,ihits
      ii=iwkvec(ncentr+i)

      icenter=nfuncatom(ii)

      do 1008 j=1,ihits
      jj=iwkvec(ncentr+j)

      ijmax=max(ii,jj)
      ijmin=min(ii,jj)
      ij=(ijmax*(ijmax-1)/2)+ijmin

      if(ii.eq.jj) then
                         dnstya=dmta(ij)*two
                         dnstyb=dmtb(ij)*two
                   else
                         dnstya=dmta(ij)
                         dnstyb=dmtb(ij)
                   endif

      do 1009 k=1,npts
 1009 wv(k)=(dnstya*xcalph(ja+k-1)+dnstyb*xcbeta(ja+k-1))*qf(k,jj)

      do 1010 k=1,npts
      grad(1,icenter)=grad(1,icenter)-qx(k,ii)*wv(k)
      grad(2,icenter)=grad(2,icenter)-qy(k,ii)*wv(k)
 1010 grad(3,icenter)=grad(3,icenter)-qz(k,ii)*wv(k)

      if((jj.gt.ii).or.(iptsweight.eq.0)) goto 1008

      dnstya=dmta(ij)
      dnstyb=dmtb(ij)

      check=(dnstya+dnstyb)*extent3(ii)*extent3(jj)*xcmax

      if(abs(check).lt.tolerance) goto 1008

      if(iwkvec(iatom).eq.1) then
                                   do 1011 k=1,npts
 1011                              wv(k)=(dnstya+dnstyb)*xcenrg(ja+k-1)
     &                                  *(qf(k,ii)*qf(k,jj))
                             endif

      do 1012 l=1,ncentr
      if(iwkvec(l).eq.1) then
                               do 1013 m=1,3
                               n=3*(l-1)+m
                               do 1013 k=1,npts
 1013                          grad(m,l)=grad(m,l)+wv(k)*drvtv(k,n)
                         endif
 1012 continue

 1008 continue
 1003 continue
 1002 continue

      return
      end

      subroutine cdftpp(m,n,ncds,ncdspd,ilfunc,icfunc,iminj,icontr,
     &                  iicontr,inddyy,iloc,g,coord,alphaaux,coeffs,
     &                  coeffp,coeffd,tvec,dmat,zeta,axbx,ayby,azbz,px,
     &                  py,pz,base,pxax,pyay,pzaz,u,zetarec,wxcx,wycy,
     &                  wzcz,wxpx,wypy,wzpz,sss0,sss1,sss2,sss3,sss4,
     &                  pss,pss0,pss1,pss2,pss3,dss,dss0,dss1,dss2,ssp1,
     &                  psp,psp0,psp1,dsp,dsp0,dsp1,psd,psd0,dsd,dsd0,
     &                  pps0,ppp0,ppd0,zetac1,zetac2,c,c1,c2,c3,zzeta,
     &                  ppx,ppy,ppz,ppxax,ppyay,ppzaz,aaxbx,aayby,aazbz,
     &                  gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension index(9)

      dimension cdfitp(3),cdfitd(6)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),iicontr(*),
     &          inddyy(m,*),iloc(*)

      dimension g(*),coord(3,*),alphaaux(*),coeffs(*),coeffp(*),
     &          coeffd(*),tvec(*),dmat(*),zeta(*),axbx(*),ayby(*),
     &          azbz(*),px(*),py(*),pz(*),base(*),pxax(*),pyay(*),
     &          pzaz(*),u(*),zetarec(*),wxcx(*),wycy(*),wzcz(*),wxpx(*),
     &          wypy(*),wzpz(*),sss0(*),sss1(*),sss2(*),sss3(*),sss4(*),
     &          pss(n,*),pss0(n,*),pss1(n,*),pss2(n,*),pss3(n,*),
     &          dss(n,*),dss0(n,*),dss1(n,*),dss2(n,*),ssp1(n,*),
     &          psp(n,*),psp0(n,*),psp1(n,*),dsp(n,*),dsp0(n,*),
     &          dsp1(n,*),psd(n,*),psd0(n,*),dsd(n,*),dsd0(n,*),
     &          pps0(n,*),ppp0(n,*),ppd0(n,*),zetac1(*),zetac2(*),c(*),
     &          c1(n,*),c2(n,*),c3(n,*),zzeta(*),ppx(*),ppy(*),ppz(*),
     &          ppxax(*),ppyay(*),ppzaz(*),aaxbx(*),aayby(*),aazbz(*),
     &          gather(n,*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data five,seven/5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(3,n,iloc,u,psp0,ppx,ppy,ppz)

      do 1004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,2)/zeta(i)/zetaux
 1004 sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,3)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       aaxbx(nn)=axbx(icontr(i))
                                       aayby(nn)=ayby(icontr(i))
                                       aazbz(nn)=azbz(icontr(i))

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
 1006 zetac1(i)=zetaux*zetarec(i)

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn

      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

 1008 continue

      do 1009 i=1,nn

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

 1009 continue

      do 1010 i=1,nn
      pps0(i,1)=aaxbx(i)*pss0(i,1)+dss0(i,1)
      pps0(i,2)=aayby(i)*pss0(i,1)+dss0(i,2)
      pps0(i,3)=aazbz(i)*pss0(i,1)+dss0(i,3)
      pps0(i,4)=aaxbx(i)*pss0(i,2)+dss0(i,2)
      pps0(i,5)=aayby(i)*pss0(i,2)+dss0(i,4)
      pps0(i,6)=aazbz(i)*pss0(i,2)+dss0(i,5)
      pps0(i,7)=aaxbx(i)*pss0(i,3)+dss0(i,3)
      pps0(i,8)=aayby(i)*pss0(i,3)+dss0(i,5)
 1010 pps0(i,9)=aazbz(i)*pss0(i,3)+dss0(i,6)

      do 1011 i=1,nn
 1011 gather(i,1)=zero

      do 1012 j=1,9
      do 1012 i=1,nn
 1012 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pps0(i,j)

      nnn=0

      do 1013 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 1013 continue

      index(1)=2
      index(2)=3
      index(3)=6

      do 1014 j=1,3
cfpp$ nodepchk
      do 1014 i=1,nnn
 1014 gather(iloc(i),1)=gather(iloc(i),1)
     &   -dmat(inddyy(iicontr(iloc(i)),index(j)))*pps0(iloc(i),index(j))

      do 1015 i=1,nn
 1015 gather(i,1)=gather(i,1)*cdfits

      do 1016 i=1,nn
 1016 tvec(naux)=tvec(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=coeffs(ilaux)

      cdfitp(1)=coeffp(ilaux)
      cdfitp(2)=coeffp(ilaux)
      cdfitp(3)=coeffp(ilaux)

      cdfitd(1)=coeffd(ilaux)/dnormcd
      cdfitd(2)=coeffd(ilaux)
      cdfitd(3)=coeffd(ilaux)
      cdfitd(4)=coeffd(ilaux)/dnormcd
      cdfitd(5)=coeffd(ilaux)
      cdfitd(6)=coeffd(ilaux)/dnormcd

      do 2002 i=1,n
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 2003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(5,n,iloc,u,psp0,ppx,ppy,ppz)

      do 2004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,4)/zeta(i)/zetaux
 2004 sss4(i)=base(i)*twoecnst*sqrt(zetarec(i))*psp0(i,5)/zeta(i)/zetaux

      nn=0

      do 2005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       aaxbx(nn)=axbx(icontr(i))
                                       aayby(nn)=ayby(icontr(i))
                                       aazbz(nn)=azbz(icontr(i))

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                       sss4(nn)=sss4(i)
                                 endif
 2005 continue

      do 2006 i=1,nn
      zetac1(i)=zetaux*zetarec(i)
 2006 zetac2(i)=zzeta(i)*zetarec(i)

      do 2007 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 2007 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 2008 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 2008 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 2009 i=1,nn

      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
      pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      pss3(i,1)=ppxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=ppyay(i)*sss3(i)+wypy(i)*sss4(i)
      pss3(i,3)=ppzaz(i)*sss3(i)+wzpz(i)*sss4(i)

 2009 continue

      do 2010 i=1,nn

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
      dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zzeta(i))

      dss2(i,1)=ppxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=ppyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=ppzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=ppyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=ppzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
      dss2(i,6)=ppzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

 2010 continue

      do 2011 i=1,nn
      ssp1(i,1)=wxcx(i)*sss2(i)
      ssp1(i,2)=wycy(i)*sss2(i)
 2011 ssp1(i,3)=wzcz(i)*sss2(i)

      do 2012 i=1,nn

      c(i)=half*sss1(i)*zetarec(i)

      psp0(i,1)=wxcx(i)*pss1(i,1)+c(i)
      psp0(i,2)=wycy(i)*pss1(i,1)
      psp0(i,3)=wzcz(i)*pss1(i,1)
      psp0(i,4)=wxcx(i)*pss1(i,2)
      psp0(i,5)=wycy(i)*pss1(i,2)+c(i)
      psp0(i,6)=wzcz(i)*pss1(i,2)
      psp0(i,7)=wxcx(i)*pss1(i,3)
      psp0(i,8)=wycy(i)*pss1(i,3)
      psp0(i,9)=wzcz(i)*pss1(i,3)+c(i)

      c(i)=half*sss2(i)*zetarec(i)

      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
      psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

 2012 continue

      do 2013 j=1,3
      do 2013 i=1,nn
 2013 c1(i,j)=half*pss1(i,j)*zetarec(i)

      do 2014 i=1,nn
      dsp0(i,01)=wxcx(i)*dss1(i,1)+c1(i,1)*two
      dsp0(i,02)=wycy(i)*dss1(i,1)
      dsp0(i,03)=wzcz(i)*dss1(i,1)
      dsp0(i,04)=wxcx(i)*dss1(i,2)+c1(i,2)
      dsp0(i,05)=wycy(i)*dss1(i,2)+c1(i,1)
      dsp0(i,06)=wzcz(i)*dss1(i,2)
      dsp0(i,07)=wxcx(i)*dss1(i,3)+c1(i,3)
      dsp0(i,08)=wycy(i)*dss1(i,3)
      dsp0(i,09)=wzcz(i)*dss1(i,3)+c1(i,1)
      dsp0(i,10)=wxcx(i)*dss1(i,4)
      dsp0(i,11)=wycy(i)*dss1(i,4)+c1(i,2)*two
      dsp0(i,12)=wzcz(i)*dss1(i,4)
      dsp0(i,13)=wxcx(i)*dss1(i,5)
      dsp0(i,14)=wycy(i)*dss1(i,5)+c1(i,3)
      dsp0(i,15)=wzcz(i)*dss1(i,5)+c1(i,2)
      dsp0(i,16)=wxcx(i)*dss1(i,6)
      dsp0(i,17)=wycy(i)*dss1(i,6)
 2014 dsp0(i,18)=wzcz(i)*dss1(i,6)+c1(i,3)*two

      do 2015 j=1,3
      do 2015 i=1,nn
 2015 c1(i,j)=half*pss2(i,j)*zetarec(i)

      do 2016 i=1,nn
      dsp1(i,01)=wxcx(i)*dss2(i,1)+c1(i,1)*two
      dsp1(i,02)=wycy(i)*dss2(i,1)
      dsp1(i,03)=wzcz(i)*dss2(i,1)
      dsp1(i,04)=wxcx(i)*dss2(i,2)+c1(i,2)
      dsp1(i,05)=wycy(i)*dss2(i,2)+c1(i,1)
      dsp1(i,06)=wzcz(i)*dss2(i,2)
      dsp1(i,07)=wxcx(i)*dss2(i,3)+c1(i,3)
      dsp1(i,08)=wycy(i)*dss2(i,3)
      dsp1(i,09)=wzcz(i)*dss2(i,3)+c1(i,1)
      dsp1(i,10)=wxcx(i)*dss2(i,4)
      dsp1(i,11)=wycy(i)*dss2(i,4)+c1(i,2)*two
      dsp1(i,12)=wzcz(i)*dss2(i,4)
      dsp1(i,13)=wxcx(i)*dss2(i,5)
      dsp1(i,14)=wycy(i)*dss2(i,5)+c1(i,3)
      dsp1(i,15)=wzcz(i)*dss2(i,5)+c1(i,2)
      dsp1(i,16)=wxcx(i)*dss2(i,6)
      dsp1(i,17)=wycy(i)*dss2(i,6)
 2016 dsp1(i,18)=wzcz(i)*dss2(i,6)+c1(i,3)*two

      do 2017 j=1,3
      do 2017 i=1,nn
 2017 c1(i,j)=(pss0(i,j)-zetac2(i)*pss1(i,j))/(two*zetaux)

      do 2018 j=1,3
      do 2018 i=1,nn
 2018 c2(i,j)=half*ssp1(i,j)*zetarec(i)

      do 2019 i=1,nn
      psd0(i,01)=wxcx(i)*psp1(i,1)+c1(i,1)+c2(i,1)
      psd0(i,02)=wycy(i)*psp1(i,1)
      psd0(i,03)=wzcz(i)*psp1(i,1)
      psd0(i,04)=wycy(i)*psp1(i,2)+c1(i,1)
      psd0(i,05)=wzcz(i)*psp1(i,2)
      psd0(i,06)=wzcz(i)*psp1(i,3)+c1(i,1)
      psd0(i,07)=wxcx(i)*psp1(i,4)+c1(i,2)
      psd0(i,08)=wycy(i)*psp1(i,4)        +c2(i,1)
      psd0(i,09)=wzcz(i)*psp1(i,4)
      psd0(i,10)=wycy(i)*psp1(i,5)+c1(i,2)+c2(i,2)
      psd0(i,11)=wzcz(i)*psp1(i,5)
      psd0(i,12)=wzcz(i)*psp1(i,6)+c1(i,2)
      psd0(i,13)=wxcx(i)*psp1(i,7)+c1(i,3)
      psd0(i,14)=wycy(i)*psp1(i,7)
      psd0(i,15)=wzcz(i)*psp1(i,7)        +c2(i,1)
      psd0(i,16)=wycy(i)*psp1(i,8)+c1(i,3)
      psd0(i,17)=wzcz(i)*psp1(i,8)        +c2(i,2)
 2019 psd0(i,18)=wzcz(i)*psp1(i,9)+c1(i,3)+c2(i,3)

      do 2020 j=1,6
      do 2020 i=1,nn
 2020 c2(i,j)=(dss0(i,j)-zetac2(i)*dss1(i,j))/(two*zetaux)

      do 2021 j=1,9
      do 2021 i=1,nn
 2021 c3(i,j)=half*psp1(i,j)*zetarec(i)

      do 2022 i=1,nn
      dsd0(i,01)=wxcx(i)*dsp1(i,01)+c2(i,1)+c3(i,1)*two
      dsd0(i,02)=wycy(i)*dsp1(i,01)
      dsd0(i,03)=wzcz(i)*dsp1(i,01)
      dsd0(i,04)=wycy(i)*dsp1(i,02)+c2(i,1)
      dsd0(i,05)=wzcz(i)*dsp1(i,02)
      dsd0(i,06)=wzcz(i)*dsp1(i,03)+c2(i,1)
      dsd0(i,07)=wxcx(i)*dsp1(i,04)+c2(i,2)+c3(i,4)
      dsd0(i,08)=wycy(i)*dsp1(i,04)        +c3(i,1)
      dsd0(i,09)=wzcz(i)*dsp1(i,04)
      dsd0(i,10)=wycy(i)*dsp1(i,05)+c2(i,2)+c3(i,2)
      dsd0(i,11)=wzcz(i)*dsp1(i,05)
      dsd0(i,12)=wzcz(i)*dsp1(i,06)+c2(i,2)
      dsd0(i,13)=wxcx(i)*dsp1(i,07)+c2(i,3)+c3(i,7)
      dsd0(i,14)=wycy(i)*dsp1(i,07)
      dsd0(i,15)=wzcz(i)*dsp1(i,07)        +c3(i,1)
      dsd0(i,16)=wycy(i)*dsp1(i,08)+c2(i,3)
      dsd0(i,17)=wzcz(i)*dsp1(i,08)        +c3(i,2)
      dsd0(i,18)=wzcz(i)*dsp1(i,09)+c2(i,3)+c3(i,3)
      dsd0(i,19)=wxcx(i)*dsp1(i,10)+c2(i,4)
      dsd0(i,20)=wycy(i)*dsp1(i,10)        +c3(i,4)*two
      dsd0(i,21)=wzcz(i)*dsp1(i,10)
      dsd0(i,22)=wycy(i)*dsp1(i,11)+c2(i,4)+c3(i,5)*two
      dsd0(i,23)=wzcz(i)*dsp1(i,11)
      dsd0(i,24)=wzcz(i)*dsp1(i,12)+c2(i,4)
      dsd0(i,25)=wxcx(i)*dsp1(i,13)+c2(i,5)
      dsd0(i,26)=wycy(i)*dsp1(i,13)        +c3(i,7)
      dsd0(i,27)=wzcz(i)*dsp1(i,13)        +c3(i,4)
      dsd0(i,28)=wycy(i)*dsp1(i,14)+c2(i,5)+c3(i,8)
      dsd0(i,29)=wzcz(i)*dsp1(i,14)        +c3(i,5)
      dsd0(i,30)=wzcz(i)*dsp1(i,15)+c2(i,5)+c3(i,6)
      dsd0(i,31)=wxcx(i)*dsp1(i,16)+c2(i,6)
      dsd0(i,32)=wycy(i)*dsp1(i,16)
      dsd0(i,33)=wzcz(i)*dsp1(i,16)        +c3(i,7)*two
      dsd0(i,34)=wycy(i)*dsp1(i,17)+c2(i,6)
      dsd0(i,35)=wzcz(i)*dsp1(i,17)        +c3(i,8)*two
 2022 dsd0(i,36)=wzcz(i)*dsp1(i,18)+c2(i,6)+c3(i,9)*two

      do 2023 i=1,nn
      pps0(i,1)=aaxbx(i)*pss0(i,1)+dss0(i,1)
      pps0(i,2)=aayby(i)*pss0(i,1)+dss0(i,2)
      pps0(i,3)=aazbz(i)*pss0(i,1)+dss0(i,3)
      pps0(i,4)=aaxbx(i)*pss0(i,2)+dss0(i,2)
      pps0(i,5)=aayby(i)*pss0(i,2)+dss0(i,4)
      pps0(i,6)=aazbz(i)*pss0(i,2)+dss0(i,5)
      pps0(i,7)=aaxbx(i)*pss0(i,3)+dss0(i,3)
      pps0(i,8)=aayby(i)*pss0(i,3)+dss0(i,5)
 2023 pps0(i,9)=aazbz(i)*pss0(i,3)+dss0(i,6)

      do 2024 i=1,nn
      ppp0(i,01)=aaxbx(i)*psp0(i,1)+dsp0(i,01)
      ppp0(i,02)=aaxbx(i)*psp0(i,2)+dsp0(i,02)
      ppp0(i,03)=aaxbx(i)*psp0(i,3)+dsp0(i,03)
      ppp0(i,04)=aayby(i)*psp0(i,1)+dsp0(i,04)
      ppp0(i,05)=aayby(i)*psp0(i,2)+dsp0(i,05)
      ppp0(i,06)=aayby(i)*psp0(i,3)+dsp0(i,06)
      ppp0(i,07)=aazbz(i)*psp0(i,1)+dsp0(i,07)
      ppp0(i,08)=aazbz(i)*psp0(i,2)+dsp0(i,08)
      ppp0(i,09)=aazbz(i)*psp0(i,3)+dsp0(i,09)
      ppp0(i,10)=aaxbx(i)*psp0(i,4)+dsp0(i,04)
      ppp0(i,11)=aaxbx(i)*psp0(i,5)+dsp0(i,05)
      ppp0(i,12)=aaxbx(i)*psp0(i,6)+dsp0(i,06)
      ppp0(i,13)=aayby(i)*psp0(i,4)+dsp0(i,10)
      ppp0(i,14)=aayby(i)*psp0(i,5)+dsp0(i,11)
      ppp0(i,15)=aayby(i)*psp0(i,6)+dsp0(i,12)
      ppp0(i,16)=aazbz(i)*psp0(i,4)+dsp0(i,13)
      ppp0(i,17)=aazbz(i)*psp0(i,5)+dsp0(i,14)
      ppp0(i,18)=aazbz(i)*psp0(i,6)+dsp0(i,15)
      ppp0(i,19)=aaxbx(i)*psp0(i,7)+dsp0(i,07)
      ppp0(i,20)=aaxbx(i)*psp0(i,8)+dsp0(i,08)
      ppp0(i,21)=aaxbx(i)*psp0(i,9)+dsp0(i,09)
      ppp0(i,22)=aayby(i)*psp0(i,7)+dsp0(i,13)
      ppp0(i,23)=aayby(i)*psp0(i,8)+dsp0(i,14)
      ppp0(i,24)=aayby(i)*psp0(i,9)+dsp0(i,15)
      ppp0(i,25)=aazbz(i)*psp0(i,7)+dsp0(i,16)
      ppp0(i,26)=aazbz(i)*psp0(i,8)+dsp0(i,17)
 2024 ppp0(i,27)=aazbz(i)*psp0(i,9)+dsp0(i,18)

      do 2025 i=1,nn
      ppd0(i,01)=aaxbx(i)*psd0(i,01)+dsd0(i,01)
      ppd0(i,02)=aaxbx(i)*psd0(i,02)+dsd0(i,02)
      ppd0(i,03)=aaxbx(i)*psd0(i,03)+dsd0(i,03)
      ppd0(i,04)=aaxbx(i)*psd0(i,04)+dsd0(i,04)
      ppd0(i,05)=aaxbx(i)*psd0(i,05)+dsd0(i,05)
      ppd0(i,06)=aaxbx(i)*psd0(i,06)+dsd0(i,06)
      ppd0(i,07)=aayby(i)*psd0(i,01)+dsd0(i,07)
      ppd0(i,08)=aayby(i)*psd0(i,02)+dsd0(i,08)
      ppd0(i,09)=aayby(i)*psd0(i,03)+dsd0(i,09)
      ppd0(i,10)=aayby(i)*psd0(i,04)+dsd0(i,10)
      ppd0(i,11)=aayby(i)*psd0(i,05)+dsd0(i,11)
      ppd0(i,12)=aayby(i)*psd0(i,06)+dsd0(i,12)
      ppd0(i,13)=aazbz(i)*psd0(i,01)+dsd0(i,13)
      ppd0(i,14)=aazbz(i)*psd0(i,02)+dsd0(i,14)
      ppd0(i,15)=aazbz(i)*psd0(i,03)+dsd0(i,15)
      ppd0(i,16)=aazbz(i)*psd0(i,04)+dsd0(i,16)
      ppd0(i,17)=aazbz(i)*psd0(i,05)+dsd0(i,17)
      ppd0(i,18)=aazbz(i)*psd0(i,06)+dsd0(i,18)
      ppd0(i,19)=aaxbx(i)*psd0(i,07)+dsd0(i,07)
      ppd0(i,20)=aaxbx(i)*psd0(i,08)+dsd0(i,08)
      ppd0(i,21)=aaxbx(i)*psd0(i,09)+dsd0(i,09)
      ppd0(i,22)=aaxbx(i)*psd0(i,10)+dsd0(i,10)
      ppd0(i,23)=aaxbx(i)*psd0(i,11)+dsd0(i,11)
      ppd0(i,24)=aaxbx(i)*psd0(i,12)+dsd0(i,12)
      ppd0(i,25)=aayby(i)*psd0(i,07)+dsd0(i,19)
      ppd0(i,26)=aayby(i)*psd0(i,08)+dsd0(i,20)
      ppd0(i,27)=aayby(i)*psd0(i,09)+dsd0(i,21)
      ppd0(i,28)=aayby(i)*psd0(i,10)+dsd0(i,22)
      ppd0(i,29)=aayby(i)*psd0(i,11)+dsd0(i,23)
      ppd0(i,30)=aayby(i)*psd0(i,12)+dsd0(i,24)
      ppd0(i,31)=aazbz(i)*psd0(i,07)+dsd0(i,25)
      ppd0(i,32)=aazbz(i)*psd0(i,08)+dsd0(i,26)
      ppd0(i,33)=aazbz(i)*psd0(i,09)+dsd0(i,27)
      ppd0(i,34)=aazbz(i)*psd0(i,10)+dsd0(i,28)
      ppd0(i,35)=aazbz(i)*psd0(i,11)+dsd0(i,29)
      ppd0(i,36)=aazbz(i)*psd0(i,12)+dsd0(i,30)
      ppd0(i,37)=aaxbx(i)*psd0(i,13)+dsd0(i,13)
      ppd0(i,38)=aaxbx(i)*psd0(i,14)+dsd0(i,14)
      ppd0(i,39)=aaxbx(i)*psd0(i,15)+dsd0(i,15)
      ppd0(i,40)=aaxbx(i)*psd0(i,16)+dsd0(i,16)
      ppd0(i,41)=aaxbx(i)*psd0(i,17)+dsd0(i,17)
      ppd0(i,42)=aaxbx(i)*psd0(i,18)+dsd0(i,18)
      ppd0(i,43)=aayby(i)*psd0(i,13)+dsd0(i,25)
      ppd0(i,44)=aayby(i)*psd0(i,14)+dsd0(i,26)
      ppd0(i,45)=aayby(i)*psd0(i,15)+dsd0(i,27)
      ppd0(i,46)=aayby(i)*psd0(i,16)+dsd0(i,28)
      ppd0(i,47)=aayby(i)*psd0(i,17)+dsd0(i,29)
      ppd0(i,48)=aayby(i)*psd0(i,18)+dsd0(i,30)
      ppd0(i,49)=aazbz(i)*psd0(i,13)+dsd0(i,31)
      ppd0(i,50)=aazbz(i)*psd0(i,14)+dsd0(i,32)
      ppd0(i,51)=aazbz(i)*psd0(i,15)+dsd0(i,33)
      ppd0(i,52)=aazbz(i)*psd0(i,16)+dsd0(i,34)
      ppd0(i,53)=aazbz(i)*psd0(i,17)+dsd0(i,35)
 2025 ppd0(i,54)=aazbz(i)*psd0(i,18)+dsd0(i,36)

      do 2026 j=1,10
      do 2026 i=1,nn
 2026 gather(i,j)=zero

      do 2027 j=1,9
      do 2027 i=1,nn
 2027 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pps0(i,j)

      do 2028 k=1,3
      do 2028 j=1,9
      do 2028 i=1,nn
 2028 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*ppp0(i,3*(j-1)+k)

      do 2029 k=1,6
      do 2029 j=1,9
      do 2029 i=1,nn
 2029 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*ppd0(i,6*(j-1)+k)

      nnn=0

      do 2030 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 2030 continue

      index(1)=2
      index(2)=3
      index(3)=6

      do 2031 j=1,3
cfpp$ nodepchk
      do 2031 i=1,nnn
 2031 gather(iloc(i),1)=gather(iloc(i),1)
     &                 -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                 *pps0(iloc(i),index(j))

      do 2032 k=1,3
      do 2032 j=1,3
cfpp$ nodepchk
      do 2032 i=1,nnn
 2032 gather(iloc(i),k+1)=gather(iloc(i),k+1)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ppp0(iloc(i),3*(index(j)-1)+k)

      do 2033 k=1,6
      do 2033 j=1,3
cfpp$ nodepchk
      do 2033 i=1,nnn
 2033 gather(iloc(i),k+4)=gather(iloc(i),k+4)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ppd0(iloc(i),6*(index(j)-1)+k)

      do 2034 i=1,nn
      gather(i,01)=gather(i,01)*cdfits
      gather(i,02)=gather(i,02)*cdfitp(1)
      gather(i,03)=gather(i,03)*cdfitp(2)
      gather(i,04)=gather(i,04)*cdfitp(3)
      gather(i,05)=gather(i,05)*cdfitd(1)
      gather(i,06)=gather(i,06)*cdfitd(2)
      gather(i,07)=gather(i,07)*cdfitd(3)
      gather(i,08)=gather(i,08)*cdfitd(4)
      gather(i,09)=gather(i,09)*cdfitd(5)
 2034 gather(i,10)=gather(i,10)*cdfitd(6)

      nc=ncds+(naux-1)*10

      do 2035 i=1,nn
      do 2035 j=1,10
 2035 tvec(nc+j)=tvec(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine diffuse1(ncenters,nconts,ncontp,ncontd,ilfunc,icfunc,
     &                    ngauss,nptrs,nptrp,nptrd,tolerance,alpha,
     &                    coeff,cent,extent)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)

      dimension alpha(*),coeff(*),cent(3,*),extent(*)

      data nextent/50/
      data zero,one,expcut/0.0d0,1.0d0,50.0d0/

      do 1001 i=1,ncenters
 1001 extent(i)=zero

      do 1002 iloop=1,nextent

      xx=real64(iloop)
      rr=xx*xx

c  loop over s functions

      do 1003 i=1,nconts

      s=zero

      ilabel=nptrs(i)

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      nc=icfunc(ilabel)

      do 1004 j=iptr1,iptr2
      rralpha=rr*alpha(j)
      if(rralpha.gt.expcut) goto 1004
      s=s+coeff(j)*exp(-rralpha)
 1004 continue

      if(abs(s).gt.tolerance) then
                                    if(xx.gt.extent(nc)) extent(nc)=xx
                              endif

 1003 continue

c  loop over p functions

      do 1005 i=1,ncontp

      px=zero

      ilabel=nptrp(i)

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      nc=icfunc(ilabel)

      do 1006 j=iptr1,iptr2
      rralpha=rr*alpha(j)
      if(rralpha.gt.expcut) goto 1006
      s=coeff(j)*exp(-rralpha)
      px=px+xx*s
 1006 continue

      if(abs(px).gt.tolerance) then
                                     if(xx.gt.extent(nc)) extent(nc)=xx
                               endif

 1005 continue

c  loop over d functions

      do 1007 i=1,ncontd

      dxx=zero

      ilabel=nptrd(i)

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      nc=icfunc(ilabel)

      do 1008 j=iptr1,iptr2
      rralpha=rr*alpha(j)
      if(rralpha.gt.expcut) goto 1008
      s=coeff(j)*exp(-rralpha)
      dxx=dxx+xx*xx*s
 1008 continue

      if(abs(dxx).gt.tolerance) then
                                      if(xx.gt.extent(nc)) extent(nc)=xx
                                endif

 1007 continue

 1002 continue

      do 1009 i=1,ncenters
 1009 if(extent(i).ge.real64(nextent-1)) stop 'extent may be a problem'

      do 1010 i=1,ncenters
 1010 extent(i)=(extent(i)+one)**2

      return
      end

      subroutine basize(natoms,nmos,naos,nconts,ncontp,ncontd,nshels,
     &                  nshelp,nsheld,icfunc,nfuncatom,iatom_center,
     &                  istart,ibasis_size,ibasis,iatom_last,cutoff,
     &                  coord)

      implicit real*8(a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),icfunc(*),nfuncatom(*)
      dimension iatom_center(*),istart(*),ibasis_size(*),ibasis(naos,*),
     &          iatom_last(*)

      dimension coord(3,*)

      data zero/0.0d0/

      ii=0

      do 1001 i=1,nconts
      nfuncatom(ii+1)=icfunc(nshels(i))
 1001 ii=ii+1

      do 1002 i=1,ncontp
      do 1003 k=1,3
 1003 nfuncatom(ii+k)=icfunc(nshelp(i))
 1002 ii=ii+3

      do 1004 i=1,ncontd
      do 1005 k=1,6
 1005 nfuncatom(ii+k)=icfunc(nsheld(i))
 1004 ii=ii+6

      if(iatom_center(1).eq.0) then
                                     do 1006 i=1,nmos
 1006                                iatom_center(i)=nfuncatom(i)
                               endif

      do 1007 j=1,nmos

      nkeep=0

      do 1008 i=1,naos
      distance=dist(coord(1,nfuncatom(i)),coord(1,iatom_center(j)))
      if(distance.le.cutoff) then
                                   nkeep=nkeep+1
                                   ibasis(nkeep,j)=i
                             endif
 1008 continue

 1007 ibasis_size(j)=nkeep

      do 1009 i=1,natoms
 1009 iatom_last(i)=0

      do 1010 j=1,nmos

      ihits=0

      icenter=iatom_center(j)

      do 1011 i=1,ibasis_size(j)

      if(nfuncatom(ibasis(i,j)).eq.icenter) ihits=ihits+1

      if(ihits.eq.(iatom_last(icenter)+1)) then
                                                 istart(j)=i
                                                 goto 1012
                                           endif
 1011 continue

 1012 iatom_last(iatom_center(j))=ihits

 1010 continue

      return
      end

      subroutine gradxxdd2(m,n,nn,nc,iminj,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,pss0,psp0,
     &                     psd0,dss0,dsp0,dsd0,fss0,fsp0,fsd0,axbx,ayby,
     &                     azbz,psscond,pspcond,psdcond,dsscond,dspcond,
     &                     dsdcond,fsscond,fspcond,fsdcond,ppscond,
     &                     pppcond,ppdcond,dpscond,dppcond,dpdcond,
     &                     pdscond,pdpcond,pddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),pss0(n,*),
     &          psp0(n,*),psd0(n,*),dss0(n,*),dsp0(n,*),dsd0(n,*),
     &          fss0(n,*),fsp0(n,*),fsd0(n,*),axbx(*),ayby(*),azbz(*),
     &          psscond(m,*),pspcond(m,*),psdcond(m,*),dsscond(m,*),
     &          dspcond(m,*),dsdcond(m,*),fsscond(m,*),fspcond(m,*),
     &          fsdcond(m,*),ppscond(m,*),pppcond(m,*),ppdcond(m,*),
     &          dpscond(m,*),dppcond(m,*),dpdcond(m,*),pdscond(m,*),
     &          pdpcond(m,*),pddcond(m,*),grad(m,*)

      data zero,two/0.0d0,2.0d0/

      do 1001 j=1,3
      do 1001 i=1,m
 1001 psscond(i,j)=zero

      do 1002 j=1,6
      do 1002 i=1,m
 1002 dsscond(i,j)=zero

      do 1003 j=1,10
      do 1003 i=1,m
 1003 fsscond(i,j)=zero

      do 1004 j=1,3
      do 1004 i=1,nn
 1004 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -pss0(i,j)*cdfits

      do 1005 k=1,3
      do 1005 j=1,3
      do 1005 i=1,nn
 1005 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -psp0(i,3*(j-1)+k)*cdfitp(k)

      do 1006 k=1,6
      do 1006 j=1,3
      do 1006 i=1,nn
 1006 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -psd0(i,6*(j-1)+k)*cdfitd(k)

      do 1007 j=1,6
      do 1007 i=1,nn
 1007 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     -dss0(i,j)*cdfits

      do 1008 k=1,3
      do 1008 j=1,6
      do 1008 i=1,nn
 1008 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     -dsp0(i,3*(j-1)+k)*cdfitp(k)

      do 1009 k=1,6
      do 1009 j=1,6
      do 1009 i=1,nn
 1009 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     -dsd0(i,6*(j-1)+k)*cdfitd(k)

      do 1010 j=1,10
      do 1010 i=1,nn
 1010 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     -fss0(i,j)*cdfits

      do 1011 k=1,3
      do 1011 j=1,10
      do 1011 i=1,nn
 1011 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     -fsp0(i,3*(j-1)+k)*cdfitp(k)

      do 1012 k=1,6
      do 1012 j=1,10
      do 1012 i=1,nn
 1012 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     -fsd0(i,6*(j-1)+k)*cdfitd(k)

      do 1013 i=1,m
      ppscond(i,1)=axbx(i)*psscond(i,1)+dsscond(i,1)
      ppscond(i,2)=ayby(i)*psscond(i,1)+dsscond(i,2)
      ppscond(i,3)=azbz(i)*psscond(i,1)+dsscond(i,3)
      ppscond(i,4)=axbx(i)*psscond(i,2)+dsscond(i,2)
      ppscond(i,5)=ayby(i)*psscond(i,2)+dsscond(i,4)
      ppscond(i,6)=azbz(i)*psscond(i,2)+dsscond(i,5)
      ppscond(i,7)=axbx(i)*psscond(i,3)+dsscond(i,3)
      ppscond(i,8)=ayby(i)*psscond(i,3)+dsscond(i,5)
 1013 ppscond(i,9)=azbz(i)*psscond(i,3)+dsscond(i,6)

      do 1014 i=1,m
      dpscond(i,01)=axbx(i)*dsscond(i,1)+fsscond(i,01)
      dpscond(i,02)=ayby(i)*dsscond(i,1)+fsscond(i,02)
      dpscond(i,03)=azbz(i)*dsscond(i,1)+fsscond(i,03)
      dpscond(i,04)=axbx(i)*dsscond(i,2)+fsscond(i,02)
      dpscond(i,05)=ayby(i)*dsscond(i,2)+fsscond(i,04)
      dpscond(i,06)=azbz(i)*dsscond(i,2)+fsscond(i,05)
      dpscond(i,07)=axbx(i)*dsscond(i,3)+fsscond(i,03)
      dpscond(i,08)=ayby(i)*dsscond(i,3)+fsscond(i,05)
      dpscond(i,09)=azbz(i)*dsscond(i,3)+fsscond(i,06)
      dpscond(i,10)=axbx(i)*dsscond(i,4)+fsscond(i,04)
      dpscond(i,11)=ayby(i)*dsscond(i,4)+fsscond(i,07)
      dpscond(i,12)=azbz(i)*dsscond(i,4)+fsscond(i,08)
      dpscond(i,13)=axbx(i)*dsscond(i,5)+fsscond(i,05)
      dpscond(i,14)=ayby(i)*dsscond(i,5)+fsscond(i,08)
      dpscond(i,15)=azbz(i)*dsscond(i,5)+fsscond(i,09)
      dpscond(i,16)=axbx(i)*dsscond(i,6)+fsscond(i,06)
      dpscond(i,17)=ayby(i)*dsscond(i,6)+fsscond(i,09)
 1014 dpscond(i,18)=azbz(i)*dsscond(i,6)+fsscond(i,10)

      do 1015 i=1,m
      pdscond(i,01)=axbx(i)*ppscond(i,1)+dpscond(i,01)
      pdscond(i,02)=ayby(i)*ppscond(i,1)+dpscond(i,04)
      pdscond(i,03)=azbz(i)*ppscond(i,1)+dpscond(i,07)
      pdscond(i,04)=ayby(i)*ppscond(i,2)+dpscond(i,05)
      pdscond(i,05)=azbz(i)*ppscond(i,2)+dpscond(i,08)
      pdscond(i,06)=azbz(i)*ppscond(i,3)+dpscond(i,09)
      pdscond(i,07)=axbx(i)*ppscond(i,4)+dpscond(i,04)
      pdscond(i,08)=ayby(i)*ppscond(i,4)+dpscond(i,10)
      pdscond(i,09)=azbz(i)*ppscond(i,4)+dpscond(i,13)
      pdscond(i,10)=ayby(i)*ppscond(i,5)+dpscond(i,11)
      pdscond(i,11)=azbz(i)*ppscond(i,5)+dpscond(i,14)
      pdscond(i,12)=azbz(i)*ppscond(i,6)+dpscond(i,15)
      pdscond(i,13)=axbx(i)*ppscond(i,7)+dpscond(i,07)
      pdscond(i,14)=ayby(i)*ppscond(i,7)+dpscond(i,13)
      pdscond(i,15)=azbz(i)*ppscond(i,7)+dpscond(i,16)
      pdscond(i,16)=ayby(i)*ppscond(i,8)+dpscond(i,14)
      pdscond(i,17)=azbz(i)*ppscond(i,8)+dpscond(i,17)
 1015 pdscond(i,18)=azbz(i)*ppscond(i,9)+dpscond(i,18)

      do 1016 i=1,m
      grad(i,01)=pdscond(i,01)*density(inddyy(i,01))*two
      grad(i,02)=pdscond(i,02)*density(inddyy(i,02))*two
      grad(i,03)=pdscond(i,03)*density(inddyy(i,03))*two
      grad(i,04)=pdscond(i,04)*density(inddyy(i,04))*two
      grad(i,05)=pdscond(i,05)*density(inddyy(i,05))*two
      grad(i,06)=pdscond(i,06)*density(inddyy(i,06))*two
      grad(i,07)=pdscond(i,07)*density(inddyy(i,07))
      grad(i,08)=pdscond(i,08)*density(inddyy(i,08))
      grad(i,09)=pdscond(i,09)*density(inddyy(i,09))
      grad(i,10)=pdscond(i,10)*density(inddyy(i,10))
      grad(i,11)=pdscond(i,11)*density(inddyy(i,11))
      grad(i,12)=pdscond(i,12)*density(inddyy(i,12))
      grad(i,13)=pdscond(i,13)*density(inddyy(i,13))
      grad(i,14)=pdscond(i,14)*density(inddyy(i,14))
      grad(i,15)=pdscond(i,15)*density(inddyy(i,15))
      grad(i,16)=pdscond(i,16)*density(inddyy(i,16))
      grad(i,17)=pdscond(i,17)*density(inddyy(i,17))
      grad(i,18)=pdscond(i,18)*density(inddyy(i,18))
      grad(i,19)=pdscond(i,01)*density(inddyy(i,07))
      grad(i,20)=pdscond(i,02)*density(inddyy(i,08))
      grad(i,21)=pdscond(i,03)*density(inddyy(i,09))
      grad(i,22)=pdscond(i,04)*density(inddyy(i,10))
      grad(i,23)=pdscond(i,05)*density(inddyy(i,11))
      grad(i,24)=pdscond(i,06)*density(inddyy(i,12))
      grad(i,25)=pdscond(i,07)*density(inddyy(i,19))*two
      grad(i,26)=pdscond(i,08)*density(inddyy(i,20))*two
      grad(i,27)=pdscond(i,09)*density(inddyy(i,21))*two
      grad(i,28)=pdscond(i,10)*density(inddyy(i,22))*two
      grad(i,29)=pdscond(i,11)*density(inddyy(i,23))*two
      grad(i,30)=pdscond(i,12)*density(inddyy(i,24))*two
      grad(i,31)=pdscond(i,13)*density(inddyy(i,25))
      grad(i,32)=pdscond(i,14)*density(inddyy(i,26))
      grad(i,33)=pdscond(i,15)*density(inddyy(i,27))
      grad(i,34)=pdscond(i,16)*density(inddyy(i,28))
      grad(i,35)=pdscond(i,17)*density(inddyy(i,29))
      grad(i,36)=pdscond(i,18)*density(inddyy(i,30))
      grad(i,37)=pdscond(i,01)*density(inddyy(i,13))
      grad(i,38)=pdscond(i,02)*density(inddyy(i,14))
      grad(i,39)=pdscond(i,03)*density(inddyy(i,15))
      grad(i,40)=pdscond(i,04)*density(inddyy(i,16))
      grad(i,41)=pdscond(i,05)*density(inddyy(i,17))
      grad(i,42)=pdscond(i,06)*density(inddyy(i,18))
      grad(i,43)=pdscond(i,07)*density(inddyy(i,25))
      grad(i,44)=pdscond(i,08)*density(inddyy(i,26))
      grad(i,45)=pdscond(i,09)*density(inddyy(i,27))
      grad(i,46)=pdscond(i,10)*density(inddyy(i,28))
      grad(i,47)=pdscond(i,11)*density(inddyy(i,29))
      grad(i,48)=pdscond(i,12)*density(inddyy(i,30))
      grad(i,49)=pdscond(i,13)*density(inddyy(i,31))*two
      grad(i,50)=pdscond(i,14)*density(inddyy(i,32))*two
      grad(i,51)=pdscond(i,15)*density(inddyy(i,33))*two
      grad(i,52)=pdscond(i,16)*density(inddyy(i,34))*two
      grad(i,53)=pdscond(i,17)*density(inddyy(i,35))*two
 1016 grad(i,54)=pdscond(i,18)*density(inddyy(i,36))*two

      do 1017 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,04)=zero
                              grad(i,05)=zero
                              grad(i,06)=zero
                              grad(i,09)=zero
                              grad(i,10)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,16)=zero
                              grad(i,17)=zero
                              grad(i,18)=zero
                              grad(i,21)=zero
                              grad(i,22)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,29)=zero
                              grad(i,30)=zero
                              grad(i,36)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,48)=zero
                        endif
 1017 continue

      do 1018 k=1,3
      do 1018 j=1,18
      do 1018 i=1,m
 1018 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1019 k=1,3
      do 1019 j=1,18
      do 1019 i=1,m
 1019 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

      do 1020 i=1,m
      grad(i,01)=dpscond(i,01)*density(inddyy(i,01))*two
      grad(i,02)=dpscond(i,02)*density(inddyy(i,02))
      grad(i,03)=dpscond(i,03)*density(inddyy(i,03))
      grad(i,04)=dpscond(i,04)*density(inddyy(i,07))*two
      grad(i,05)=dpscond(i,05)*density(inddyy(i,08))
      grad(i,06)=dpscond(i,06)*density(inddyy(i,09))
      grad(i,07)=dpscond(i,07)*density(inddyy(i,13))*two
      grad(i,08)=dpscond(i,08)*density(inddyy(i,14))
      grad(i,09)=dpscond(i,09)*density(inddyy(i,15))
      grad(i,10)=dpscond(i,10)*density(inddyy(i,19))*two
      grad(i,11)=dpscond(i,11)*density(inddyy(i,20))
      grad(i,12)=dpscond(i,12)*density(inddyy(i,21))
      grad(i,13)=dpscond(i,13)*density(inddyy(i,25))*two
      grad(i,14)=dpscond(i,14)*density(inddyy(i,26))
      grad(i,15)=dpscond(i,15)*density(inddyy(i,27))
      grad(i,16)=dpscond(i,16)*density(inddyy(i,31))*two
      grad(i,17)=dpscond(i,17)*density(inddyy(i,32))
      grad(i,18)=dpscond(i,18)*density(inddyy(i,33))
      grad(i,19)=dpscond(i,01)*density(inddyy(i,02))
      grad(i,20)=dpscond(i,02)*density(inddyy(i,04))*two
      grad(i,21)=dpscond(i,03)*density(inddyy(i,05))
      grad(i,22)=dpscond(i,04)*density(inddyy(i,08))
      grad(i,23)=dpscond(i,05)*density(inddyy(i,10))*two
      grad(i,24)=dpscond(i,06)*density(inddyy(i,11))
      grad(i,25)=dpscond(i,07)*density(inddyy(i,14))
      grad(i,26)=dpscond(i,08)*density(inddyy(i,16))*two
      grad(i,27)=dpscond(i,09)*density(inddyy(i,17))
      grad(i,28)=dpscond(i,10)*density(inddyy(i,20))
      grad(i,29)=dpscond(i,11)*density(inddyy(i,22))*two
      grad(i,30)=dpscond(i,12)*density(inddyy(i,23))
      grad(i,31)=dpscond(i,13)*density(inddyy(i,26))
      grad(i,32)=dpscond(i,14)*density(inddyy(i,28))*two
      grad(i,33)=dpscond(i,15)*density(inddyy(i,29))
      grad(i,34)=dpscond(i,16)*density(inddyy(i,32))
      grad(i,35)=dpscond(i,17)*density(inddyy(i,34))*two
      grad(i,36)=dpscond(i,18)*density(inddyy(i,35))
      grad(i,37)=dpscond(i,01)*density(inddyy(i,03))
      grad(i,38)=dpscond(i,02)*density(inddyy(i,05))
      grad(i,39)=dpscond(i,03)*density(inddyy(i,06))*two
      grad(i,40)=dpscond(i,04)*density(inddyy(i,09))
      grad(i,41)=dpscond(i,05)*density(inddyy(i,11))
      grad(i,42)=dpscond(i,06)*density(inddyy(i,12))*two
      grad(i,43)=dpscond(i,07)*density(inddyy(i,15))
      grad(i,44)=dpscond(i,08)*density(inddyy(i,17))
      grad(i,45)=dpscond(i,09)*density(inddyy(i,18))*two
      grad(i,46)=dpscond(i,10)*density(inddyy(i,21))
      grad(i,47)=dpscond(i,11)*density(inddyy(i,23))
      grad(i,48)=dpscond(i,12)*density(inddyy(i,24))*two
      grad(i,49)=dpscond(i,13)*density(inddyy(i,27))
      grad(i,50)=dpscond(i,14)*density(inddyy(i,29))
      grad(i,51)=dpscond(i,15)*density(inddyy(i,30))*two
      grad(i,52)=dpscond(i,16)*density(inddyy(i,33))
      grad(i,53)=dpscond(i,17)*density(inddyy(i,35))
 1020 grad(i,54)=dpscond(i,18)*density(inddyy(i,36))*two

      do 1021 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,19)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,26)=zero
                              grad(i,27)=zero
                              grad(i,30)=zero
                              grad(i,37)=zero
                              grad(i,38)=zero
                              grad(i,39)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,44)=zero
                              grad(i,45)=zero
                              grad(i,47)=zero
                              grad(i,48)=zero
                              grad(i,51)=zero
                        endif
 1021 continue

      do 1022 k=1,3
      do 1022 j=1,18
      do 1022 i=1,m
 1022 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1023 k=1,3
      do 1023 j=1,18
      do 1023 i=1,m
 1023 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

      return
      end

      subroutine overlpcopy(n1,n2,a,s)

      implicit real*8(a-h,o-z)

      dimension a(*),s(n1,*)

      data zero/0.0d0/

      nn=0

      do 1001 i=1,n2
      do 1001 j=1,i
      nn=nn+1
 1001 s(j,i)=a(nn)

      return 
      end

      subroutine input(natoms,ncenters,nptcharges,ilocalize,ibfrozen,
     &                 iafrozen,idfrozen,iifrozen,nfunctional,ngridtype,
     &                 maxiterations,maxgeometries,iptsflag,icharge,
     &                 imultiplicity,idiis,nfdpbt,irestart,imesp,
     &                 ioptimization,ivibrations,intcoordflag,imode,
     &                 nequivalences,nbneutrals,nbsystems,idiffuse,
     &                 ixcfit,iptsweight,izmat1,izmat2,izmat3,natomtype,
     &                 nequivvec,neutral,isys,ibfreeze,iafreeze,
     &                 idfreeze,iifreeze,ibmode,iamode,idmode,iimode,
     &                 econvergence,gconvergence,dmixing,dmaxstep,
     &                 elevelshift,epsilon,cutoff,coord,charge,
     &                 coordptcharge,ptcharge,atomsymbol)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
c
c  based on steve chin and fiona sim's decode subroutine

      implicit real*8(a-h,o-z)

      parameter(noptions=31,maxitems=40)

      character char_string*79,parsed(maxitems)*32,options(noptions)*4

      dimension nchars(maxitems)

      dimension value(3)

      dimension izmat1(*),izmat2(*),izmat3(*),natomtype(*),
     &          nequivvec(natoms,*),neutral(natoms,*),isys(natoms,*),
     &          ibfreeze(2,*),iafreeze(3,*),idfreeze(4,*),iifreeze(4,*),
     &          ibmode(*),iamode(*),idmode(*),iimode(*)

      dimension cutoff(*),coord(3,*),charge(*),coordptcharge(3,*),
     &          ptcharge(*)

      character atomsymbol(*)*4

      data zero,bohr,one,evolt/0.0d0,0.529177d0,1.0d0,27.2116d0/





      data options/ 'CART', 'ZMAT', 'RUNT', 'POTE', 'MULT',
     &              'CHAR', 'MAXI', 'DCON', 'GCON', 'MAXS',
     &              'MIXI', 'DIIS', 'LEVE', 'MAXG', 'EQUI',
     &              'POIN', 'FDPB', 'MODE', 'ORBI', 'NEUT',
     &              'CUTO', 'SUBS', 'MESP', 'QUAL', 'BFRE',
     &              'AFRE', 'DFRE', 'IFRE', 'DIFF', 'XCFI',
     &              'WEIG'/





 1001 call parser(numwords,nchars,parsed,char_string)





      do 1002 i=1,noptions

      if(parsed(1)(1:1).eq.'#') then
                                      write(6,1003) char_string
 1003                                 format(a79)
                                      goto 1001
                                endif

      if(parsed(1)(1:4).eq.options(i)) goto 1004
      if(parsed(1)(1:3).eq.'END')  goto 1005

 1002 continue

      stop 'keyword error:  please check your input file'





 1004 continue

      goto( 2010, 2020, 2030, 2040, 2050, 2060, 2070, 2080, 2090, 2100,
     &      2110, 2120, 2130, 2140, 2150, 2160, 2170, 2180, 2190, 2200,
     &      2210, 2220, 2230, 2240, 2250, 2260, 2270, 2280, 2290, 2300,
     &      2310) i





 2010 if(parsed(2)(1:3).eq.'ANG') then

           iangstroms=1

           write(6,2011)
 2011      format(/,' input in cartesian coordinates and angstroms')

                                  else

           iangstroms=0

           write(6,2012)
 2012      format(/,' input in cartesian coordinates and bohr radii')

                                  endif

      intcoordflag=0

 2013 call parser(numwords,nchars,parsed,char_string)

      if(parsed(1)(1:3).eq.'END') goto 1001

      ncenters=ncenters+1

      atomsymbol(ncenters)=parsed(1)(1:4)

      call element(ncenters,atomsymbol(ncenters),natomtype)

      if(iangstroms.eq.1) then

           coord(1,ncenters)=getvalue(parsed(2),nchars(2))/bohr
           coord(2,ncenters)=getvalue(parsed(3),nchars(3))/bohr
           coord(3,ncenters)=getvalue(parsed(4),nchars(4))/bohr

                          else

           coord(1,ncenters)=getvalue(parsed(2),nchars(2))
           coord(2,ncenters)=getvalue(parsed(3),nchars(3))
           coord(3,ncenters)=getvalue(parsed(4),nchars(4))

                          endif

      goto 2013





 2020 if(parsed(2)(1:3).eq.'ANG') then

           iangstroms=1

           write(6,2021)
 2021      format(/,' input in zmatrix form and angstroms')

                                  else

           iangstroms=0

           write(6,2022)
 2022      format(/,' input in zmatrix form and bohr radii')

                                  endif

      intcoordflag=1

 2023 call parser(numwords,nchars,parsed,char_string)

      if(parsed(1)(1:3).eq.'END') goto 1001

      ncenters=ncenters+1

      atomsymbol(ncenters)=parsed(1)(1:4)

      call element(ncenters,atomsymbol(ncenters),natomtype)

      if(ncenters.eq.1) call genxyz(1,0,0,0,zero,zero,zero,coord)

      if(ncenters.eq.2) then

           izmat1(ncenters)=int(getvalue(parsed(2),nchars(2)))

           if(iangstroms.eq.1) then

                           value(1)=getvalue(parsed(3),nchars(3))/bohr

                               else

                           value(1)=getvalue(parsed(3),nchars(3))

                               endif

           call genxyz(2,izmat1(2),0,0,value(1),zero,zero,coord)

                        endif

      if(ncenters.eq.3) then

           izmat1(ncenters)=int(getvalue(parsed(2),nchars(2)))
           izmat2(ncenters)=int(getvalue(parsed(4),nchars(4)))

           if(iangstroms.eq.1) then

                           value(1)=getvalue(parsed(3),nchars(3))/bohr

                               else

                           value(1)=getvalue(parsed(3),nchars(3))

                               endif

           value(2)=getvalue(parsed(5),nchars(5))

           call genxyz(3,izmat1(3),izmat2(3),0,value(1),value(2),
     &                 zero,coord)

                        endif

      if(ncenters.gt.3) then

           izmat1(ncenters)=int(getvalue(parsed(2),nchars(2)))
           izmat2(ncenters)=int(getvalue(parsed(4),nchars(4)))
           izmat3(ncenters)=int(getvalue(parsed(6),nchars(6)))

           if(iangstroms.eq.1) then

                           value(1)=getvalue(parsed(3),nchars(3))/bohr

                               else

                           value(1)=getvalue(parsed(3),nchars(3))

                               endif

           value(2)=getvalue(parsed(5),nchars(5))
           value(3)=getvalue(parsed(7),nchars(7))

           call genxyz(ncenters,izmat1(ncenters),izmat2(ncenters),
     &                 izmat3(ncenters),value(1),value(2),value(3),
     &                 coord)

                      endif

      goto 2023




 2030 continue

      do 2031 iword=2,3

      if(parsed(iword)(1:4).eq.'STAR') then

                    irestart=0

                    write(6,2032)
 2032               format(/,' starting up an scf calculation ')

                                       endif

      if(parsed(iword)(1:4).eq.'REST') then

                    irestart=1

                    write(6,2033)
 2033               format(/,' restarting an scf calculation ')

                                       endif

      if(parsed(iword)(1:3).eq.'OPT')  then

                    ioptimization=1

                    write(6,2034)
 2034               format(/,' starting a geometry optimization ')

                                       endif

      if(parsed(iword)(1:4).eq.'CONT') then

                    ioptimization=1

                    irestart=2

                    write(6,2035)
 2035               format(/,' restarting a geometry optimization ')

                                       endif

      if(parsed(iword)(1:4).eq.'VIBR') then

                    ivibrations=1

                    irestart=2

                    write(6,2036)
 2036               format(/,' performing a vibrational analysis ')

                                       endif

      if(parsed(iword)(1:4).eq.'MESP') then

                    imesp=1

                    irestart=3

                    write(6,2037)
 2037               format(/,' going straight to an',
     &                       ' evaluation of the MESP ')

                                       endif

 2031 continue

      goto 1001





 2040 if(parsed(2)(1:4).eq.'BECK') then

        nfunctional=1

        write(6,2041)
 2041   format(/,' using becke exchange/perdew correlation functional ')

        goto 1001

                                   endif

      if(parsed(2)(1:4).eq.'MIXB') then

        nfunctional=2

        write(6,2042)
 2042   format(/,' using becke exchange/perdew correlation energy',
     &           ' with the vwn potential ')

        goto 1001

                                   endif

      nfunctional=0

      write(6,2043)
 2043 format(/,' using the vwn (lsda) functional ')

      goto 1001





 2050 imultiplicity=getvalue(parsed(2),nchars(2))

      write(6,2051) imultiplicity
 2051 format(/,' the multiplicity of the system is ',i3)

      goto 1001





 2060 icharge=int(getvalue(parsed(2),nchars(2)))

      write(6,2061) icharge
 2061 format(/,' the charge on the system is ',i4)

      goto 1001





 2070 maxiterations=int(getvalue(parsed(2),nchars(2)))

      write(6,2071) maxiterations
 2071 format(/,' the maximum number of iterations per geometry is ',i4)

      goto 1001





 2080 econvergence=getvalue(parsed(2),nchars(2))

      write(6,2081) econvergence
 2081 format(/,' the scf convergence criterion is set at ',e14.7)

      goto 1001





 2090 gconvergence=getvalue(parsed(2),nchars(2))

      write(6,2091) gconvergence
 2091 format(/,' the geometry optimization criterion is set at ',e14.7)

      goto 1001





 2100 dmaxstep=getvalue(parsed(2),nchars(2))

      write(6,2101) dmaxstep
 2101 format(/,' maximum stepsize in geometry optimization set at ',
     &       f10.6,' bohr ')

      goto 1001





 2110 dmixing=getvalue(parsed(2),nchars(2))

      write(6,2111) dmixing
 2111 format(/,' using an scf mixing parameter of ',f6.3)

      goto 1001





 2120 if(parsed(2)(1:3).eq.'OFF') then

               idiis=0

               write(6,2121)
 2121          format(/,' the diis scheme has been turned off ')

                                  else

               idiis=1

               write(6,2122)
 2122          format(/,' the diis scheme has been turned on ')

                                  endif

      goto 1001





 2130 elevelshift=getvalue(parsed(2),nchars(2))

      write(6,2131) elevelshift
 2131 format(/,' the levelshift parameter is set to ',f10.3,
     &         ' electron volts ')

      elevelshift=elevelshift/evolt

      goto 1001





 2140 maxgeometries=int(getvalue(parsed(2),nchars(2)))

      write(6,2141) maxgeometries
 2141 format(/,' the maximum number of geometries is ',i4)

      goto 1001





 2150 continue

      do 2151 i=3,numwords

      nequivalences=nequivalences+1

      nequivvec(nequivalences,1)=int(getvalue(parsed(2),nchars(2)))
      nequivvec(nequivalences,2)=int(getvalue(parsed(i),nchars(i)))

      write(6,2152) nequivvec(nequivalences,1),
     &              nequivvec(nequivalences,2)

 2152 format(/,' atoms # ',i4,' and ',i4,' are constrained to have',
     &         ' the same esp fitted charge ')

 2151 continue

      goto 1001





 2160 if(parsed(2)(1:3).eq.'ANG') then

            iangstroms=1

            write(6,2161)
 2161       format(/,' the positions of the point charges are given',
     &               ' in angstroms ')

                                  else

            iangstroms=0

            write(6,2162)
 2162       format(/,' the positions of the point charges are given',
     &               ' in bohr ')

                                  endif

 2163 call parser(numwords,nchars,parsed,char_string)

      if(parsed(1)(1:3).eq.'END') goto 1001

      nptcharges=nptcharges+1

      if(iangstroms.eq.1) then

          coordptcharge(1,nptcharges)=getvalue(parsed(1),nchars(1))/bohr
          coordptcharge(2,nptcharges)=getvalue(parsed(2),nchars(2))/bohr
          coordptcharge(3,nptcharges)=getvalue(parsed(3),nchars(3))/bohr

                          else

          coordptcharge(1,nptcharges)=getvalue(parsed(1),nchars(1))
          coordptcharge(2,nptcharges)=getvalue(parsed(2),nchars(2))
          coordptcharge(3,nptcharges)=getvalue(parsed(3),nchars(3))

                          endif

      ptcharge(nptcharges)=getvalue(parsed(4),nchars(4))

      goto 2163





 2170 if(parsed(2)(1:3).eq.'ON') then

           nfdpbt=1

           epsilon=getvalue(parsed(3),nchars(3))

           write(6,2171) epsilon
 2171      format(/,' a dft-fdpb calculation will be performed,',
     &              ' with a dielectric of ',f8.3)

                                 else

           nfdpbt=0

           epsilon=one

           write(6,2172)
 2172      format(/,' a dft-fdpb calculation will not be performed ')

                                 endif

      goto 1001





 2180 continue

      if(parsed(2)(1:1).eq.'B') then

                imode=1

                ibmode(1)=getvalue(parsed(3),nchars(3))
                ibmode(2)=getvalue(parsed(4),nchars(4))

                write(6,2181) ibmode(1),ibmode(2)
 2181           format(/,' will try to find transition state',
     &                   ' along bond ',2i5)

                                endif

      if(parsed(2)(1:1).eq.'A') then

                imode=2

                iamode(1)=getvalue(parsed(3),nchars(3))
                iamode(2)=getvalue(parsed(4),nchars(4))
                iamode(3)=getvalue(parsed(5),nchars(5))

                write(6,2182) iamode(1),iamode(2),iamode(3)
 2182           format(/,' will try to find transition state',
     &                   ' along bond angle ',3i5)

                                endif

      if(parsed(2)(1:1).eq.'D') then

                imode=3

                idmode(1)=getvalue(parsed(3),nchars(3))
                idmode(2)=getvalue(parsed(4),nchars(4))
                idmode(3)=getvalue(parsed(5),nchars(5))
                idmode(4)=getvalue(parsed(6),nchars(6))

                write(6,2183) idmode(1),idmode(2),idmode(3),idmode(4)
 2183           format(/,' will try to find transition state',
     &                   ' along dihedral angle ',4i5)

                                endif

      if(parsed(2)(1:1).eq.'I') then

                imode=4

                iimode(1)=getvalue(parsed(3),nchars(3))
                iimode(2)=getvalue(parsed(4),nchars(4))
                iimode(3)=getvalue(parsed(5),nchars(5))
                iimode(4)=getvalue(parsed(6),nchars(6))

                write(6,2184) iimode(1),iimode(2),iimode(3),iimode(4)
 2184           format(/,' will try to find transition state',
     &                   ' along improper torsion ',4i5)

                                endif
         
      goto 1001





 2190 continue

      if(parsed(2)(1:3).eq.'CAN') then

               ilocalize=1

               write(6,2191)
 2191          format(/,' canonical molecular orbitals will be',
     &                  ' generated')
 

                                  endif

      if(parsed(2)(1:3).eq.'BOY') then

               ilocalize=3

               write(6,2192)
 2192          format(/,' boys localized molecular orbitals will be',
     &                  ' generated')

                                  endif

      if(parsed(2)(1:3).eq.'BOT') then

               ilocalize=2

               write(6,2193)
 2193          format(/,' canonical molecular orbitals will be',
     &                  ' generated',/,
     &                  ' boys localized molecular orbitals will be',
     &                  ' generated')

                                  endif

      goto 1001





 2200 write (6,2201)
 2201 format(/,' constrained atomic charges (sum is zero)')
 
      nbneutrals=nbneutrals+1

      write(6,2202) nbneutrals
 2202 format(/,'       group # ',i3)

      neutral(nbneutrals,1)=numwords-1
  
      do 2204 i=2,numwords
      neutral(nbneutrals,i)=getvalue(parsed(i),nchars(i))
      write(6,2205) neutral(nbneutrals,i)
 2205 format('             atom #',i4)
 2204 continue

      write(6,2206)
 2206 format(//)

      goto 1001





 2210 continue

      cutoff(1)=getvalue(parsed(2),nchars(2))
      cutoff(2)=getvalue(parsed(3),nchars(3))
      cutoff(3)=getvalue(parsed(4),nchars(4))

      write(6,2211) cutoff(1),cutoff(2),cutoff(3)
 2211 format(/,' buffer atom space (CD fitting) cutoff set at ',
     &       f8.2,' Angstroms',/,
     &         ' buffer atom space (XC fitting) cutoff set at ',
     &       f8.2,' Angstroms',/,
     &         ' overlap/fock matrix element cutoff set at    ',
     &       f8.2,' Angstroms')

      cutoff(1)=cutoff(1)/bohr
      cutoff(2)=cutoff(2)/bohr
      cutoff(3)=cutoff(3)/bohr

      goto 1001





 2220 continue

      write(6,2222) nbsystems
 2222 format(/,' subsystem # ',i3)

      nbsystems=nbsystems+1

      isys(1,nbsystems-1)=numwords-1

      do 2223 i=2,numwords
      index=int(getvalue(parsed(i),nchars(i)))
      isys(i,nbsystems-1)=index
 2223 write(6,2224) index
 2224 format('           atom #',i4)

      write(6,2225)
 2225 format(//)

      goto 1001





 2230 if(parsed(2)(1:4).eq.'READ') then

               imesp=1
               iptsflag=0

               write(6,2231)
 2231          format(/,' the points used to fit the mesp will',
     &                  ' be read in from a user-supplied file ')

                                   else

               imesp=1
               iptsflag=1

               write(6,2232)
 2232          format(/,' the default set of points',
     &                  ' will be used to fit the mesp ')

                                   endif

      goto 1001





 2240 ngridtype=int(getvalue(parsed(2),nchars(2)))

      write(6,2241) ngridtype
 2241 format(/,' the following grid quality has been chosen: ',i4)

      goto 1001





 2250 ibfrozen=ibfrozen+1

      ibfreeze(1,ibfrozen)=int(getvalue(parsed(2),nchars(2)))
      ibfreeze(2,ibfrozen)=int(getvalue(parsed(3),nchars(3)))

      write(6,2251) ibfreeze(1,ibfrozen),ibfreeze(2,ibfrozen)
 2251 format(/,' the following bond will be frozen: ',2i5)

      goto 1001





 2260 iafrozen=iafrozen+1

      iafreeze(1,iafrozen)=int(getvalue(parsed(2),nchars(2)))
      iafreeze(2,iafrozen)=int(getvalue(parsed(3),nchars(3)))
      iafreeze(3,iafrozen)=int(getvalue(parsed(4),nchars(4)))

      write(6,2261) iafreeze(1,iafrozen),iafreeze(2,iafrozen),
     &              iafreeze(3,iafrozen)
 2261 format(/,' the following angle will be frozen: ',3i5)

      goto 1001





 2270 idfrozen=idfrozen+1

      idfreeze(1,idfrozen)=int(getvalue(parsed(2),nchars(2)))
      idfreeze(2,idfrozen)=int(getvalue(parsed(3),nchars(3)))
      idfreeze(3,idfrozen)=int(getvalue(parsed(4),nchars(4)))
      idfreeze(4,idfrozen)=int(getvalue(parsed(5),nchars(5)))

      write(6,2271) idfreeze(1,idfrozen),idfreeze(2,idfrozen),
     &              idfreeze(3,idfrozen),idfreeze(4,idfrozen)
 2271 format(/,' the following dihedral will be frozen: ',4i5)

      goto 1001





 2280 iifrozen=iifrozen+1

      iifreeze(1,iifrozen)=int(getvalue(parsed(2),nchars(2)))
      iifreeze(2,iifrozen)=int(getvalue(parsed(3),nchars(3)))
      iifreeze(3,iifrozen)=int(getvalue(parsed(4),nchars(4)))
      iifreeze(4,iifrozen)=int(getvalue(parsed(5),nchars(5)))

      write(6,2281) iifreeze(1,iifrozen),iifreeze(2,iifrozen),
     &              iifreeze(3,iifrozen),iifreeze(4,idfrozen)
 2281 format(/,' the following improper torsion will be frozen: ',4i5)

      goto 1001





 2290 idiffuse=int(getvalue(parsed(2),nchars(2)))

      if(idiffuse.eq.0) then

           write(6,2291)
 2291      format(/,' diffuse functions will not be added ')

                        endif

      if(idiffuse.eq.1) then

           write(6,2292)
 2292      format(/,' diffuse functions will be added to heavy atoms ')
 
                        endif

      if(idiffuse.eq.2) then

           write(6,2293)
 2293      format(/,' diffuse functions will be added to all atoms ')
 
                        endif

      goto 1001





 2300 if(parsed(2)(1:3).eq.'OFF') then

               ixcfit=0

               write(6,2301)
 2301          format(/,' no xc fitting functions will be used ')

                                  else

               ixcfit=1

               write(6,2302)
 2302          format(/,' xc fitting functions will be used ')

                                  endif

      goto 1001





 2310 if(parsed(2)(1:3).eq.'OFF') then

               iptsweight=0

               write(6,2311)
 2311          format(/,' grid point weight derivatives not',
     &                  ' included in gradient calculation ')

                                  else

               iptsweight=1

               write(6,2312)
 2312          format(/,' grid point weight derivatives',
     &                  ' included in gradient calculation ')

                                  endif

      goto 1001





 1005 continue

      do 1006 i=1,ncenters
 1006 call makelowercase(atomsymbol(i),4)

      do 1007 i=1,ncenters
 1007 charge(i)=real64(natomtype(i))

      return
      end

      subroutine init(ishake,nmomax,nmos,nocc,naos,istart,ibasis_size,
     &                ibasis,coeff,fock,wkmat,theta,omega,gamma,ccoeff,
     &                overlap)

      implicit real*8(a-h,o-z)

      dimension istart(*),ibasis_size(*),ibasis(naos,*)

      dimension coeff(nmomax,*),fock(*),wkmat(naos,*),theta(naos,*),
     &          omega(naos,*),gamma(nmos,*),ccoeff(naos,*),
     &          overlap(naos,*)

      data zero,hundredth,tenth,one,two,ten/0.0d0,0.01d0,0.1d0,
     &                                      1.0d0,2.0d0,10.0d0/
      data tolerance/0.000000000001d0/

      save cutoff

      if(ishake.le.10) imaxloop=1
      if(ishake.gt.10) imaxloop=20

      if(ishake.eq.1) then
                            cutoff=tenth

                            rewind 45

                            do 1001 i=1,naos
 1001                       call fastrd(45,overlap(1,i),naos)
                      endif

      do 1002 j=1,nmos
      do 1003 i=1,naos
 1003 omega(i,j)=zero
      do 1002 k=1,ibasis_size(j)
      do 1002 i=1,naos
 1002 omega(i,j)=omega(i,j)+overlap(i,ibasis(k,j))*coeff(k,j)

      do 1004 jmo=1,nmos
      do 1005 j=1,ibasis_size(jmo)
 1005 theta(j,jmo)=zero
      do 1004 i=1,naos
      do 1004 j=1,ibasis_size(jmo)
 1004 theta(j,jmo)=theta(j,jmo)+overlap(ibasis(j,jmo),i)*omega(i,jmo)

      do 1006 jmo=1,nocc
      do 1007 i=1,naos
 1007 wkmat(i,jmo)=zero
      do 1006 k=1,ibasis_size(jmo)
      do 1006 i=1,naos
 1006 wkmat(i,jmo)=wkmat(i,jmo)+overlap(i,ibasis(k,jmo))*coeff(k,jmo)

      do 1008 iloop=1,imaxloop

      sum_right_max=zero

      do 1009 imo=1,nocc
      do 1009 jmo=1,imo

      if(jmo.eq.imo) then
                           sum_right=one
                     else
                           sum_right=zero
                     endif

      do 1010 i=1,ibasis_size(imo)
 1010 sum_right=sum_right-coeff(i,imo)*wkmat(ibasis(i,imo),jmo)

      if(abs(sum_right).gt.sum_right_max) then

                                          i_save=imo
                                          j_save=jmo
                                          sum_right_max=abs(sum_right)

                                          endif

      if(abs(sum_right).le.cutoff) goto 1009

      sum_left=zero

      do 1011 i=1,ibasis_size(imo)
 1011 sum_left=sum_left+coeff(i,imo)*theta(i,imo)

      do 1012 j=1,ibasis_size(jmo)
 1012 sum_left=sum_left+coeff(j,jmo)*theta(j,jmo)

      sum_left=sum_left

      if(imo.eq.jmo) sum_left=two*sum_left

      gshake=-(sum_right/sum_left)

      if(abs(gshake).gt.tenth) gshake=tenth*abs(gshake)/gshake

      do 1013 i=1,ibasis_size(imo)
 1013 coeff(i,imo)=coeff(i,imo)-gshake*omega(ibasis(i,imo),jmo)

      do 1014 i=1,ibasis_size(jmo)
 1014 coeff(i,jmo)=coeff(i,jmo)-gshake*omega(ibasis(i,jmo),imo)

      do 1015 i=1,naos
 1015 wkmat(i,imo)=zero

      do 1016 k=1,ibasis_size(imo)
      do 1016 i=1,naos
 1016 wkmat(i,imo)=wkmat(i,imo)+overlap(i,ibasis(k,imo))*coeff(k,imo)

      do 1017 i=1,naos
 1017 wkmat(i,jmo)=zero

      do 1018 k=1,ibasis_size(jmo)
      do 1018 i=1,naos
 1018 wkmat(i,jmo)=wkmat(i,jmo)+overlap(i,ibasis(k,jmo))*coeff(k,jmo)

      sum_right=zero

      do 1019 i=1,ibasis_size(imo)
 1019 sum_right=sum_right+coeff(i,imo)*wkmat(ibasis(i,imo),imo)

      factor=sqrt(one/sum_right)

      do 1020 i=1,ibasis_size(imo)
 1020 coeff(i,imo)=coeff(i,imo)*factor

      do 1021 i=1,naos
 1021 wkmat(i,imo)=wkmat(i,imo)*factor

      sum_right=zero

      do 1022 i=1,ibasis_size(jmo)
 1022 sum_right=sum_right+coeff(i,jmo)*wkmat(ibasis(i,jmo),jmo)

      factor=sqrt(one/sum_right)

      do 1023 i=1,ibasis_size(jmo)
 1023 coeff(i,jmo)=coeff(i,jmo)*factor

      do 1024 i=1,naos
 1024 wkmat(i,jmo)=wkmat(i,jmo)*factor

 1009 continue

      write(6,2223) ishake,iloop,sum_right_max,i_save,j_save
 2223 format(' checking ',2i7,f20.12,2i5)

      if(sum_right_max.lt.tolerance) then

            if(ishake.ne.50) then
                                   return
                             else
                                   do 1025 j=1,nocc
                                   do 1025 i=1,ibasis_size(j)
 1025                              wkmat(i,j)=coeff(i,j)

                                   do 1026 j=1,nocc
                                   do 1026 i=1,naos
 1026                              coeff(i,j)=zero

                                   do 1027 j=1,nocc
                                   do 1027 i=1,ibasis_size(j)
 1027                              coeff(ibasis(i,j),j)=wkmat(i,j)

                                   return
                             endif

                                     endif

 1008 cutoff=sum_right_max/ten

      if(ishake.eq.50) stop ' failed to create initial set of MOs'

      return
      end

      subroutine xvecdp(m,n,nxcs,nxcspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,coord,dmat,vvector,alphaaux,
     &                  coeffs,coeffp,coeffd,zeta,ax,ay,az,axbx,ayby,
     &                  azbz,px,py,pz,base,zetarec,zetafac,efac,gxax,
     &                  gyay,gzaz,sss,pss,dss,dsscond,fss,fsscond,gss,
     &                  gsscond,hss,hsscond,dps,fps,gps,dpp,fpp,dpd,c,
     &                  c1,c2,c3,zzeta,aax,aay,aaz,ppx,ppy,ppz,axcx,
     &                  aycy,azcz,gather)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(m,*),
     &          iloc(*)

      dimension coord(3,*),dmat(*),vvector(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),zeta(*),ax(*),ay(*),az(*),axbx(*),
     &          ayby(*),azbz(*),px(*),py(*),pz(*),base(*),zetarec(*),
     &          zetafac(*),efac(*),gxax(*),gyay(*),gzaz(*),sss(*),
     &          pss(n,*),dss(n,*),dsscond(n,*),fss(n,*),fsscond(n,*),
     &          gss(n,*),gsscond(n,*),hss(n,*),hsscond(n,*),dps(n,*),
     &          fps(n,*),gps(n,*),dpp(n,*),fpp(n,*),dpd(n,*),c(*),
     &          c1(n,*),c2(n,*),c3(n,*),zzeta(*),aax(*),aay(*),aaz(*),
     &          ppx(*),ppy(*),ppz(*),axcx(*),aycy(*),azcz(*),gather(n,*)

      data zero,one,two,three,four,five/0.0d0,1.0d0,2.0d0,
     &                                  3.0d0,4.0d0,5.0d0/
      data expcut,calcut,pi/45.0d0,1.0d-16,3.1415926535898d0/

      thrhlf=three/two

      sqrt3=sqrt(three)

      do 1000 i=1,n
 1000 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1001 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      do 1002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      sss(i)=zero
 1004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 1005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 1005 continue

      do 1006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 1006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 1007 i=1,nn
 1007 zetarec(i)=zetarec(i)/two

      do 1008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 1008 pss(i,3)=gzaz(i)*sss(i)

      do 1009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 1009 continue

      do 1010 j=1,3
      do 1010 i=1,nn
 1010 c1(i,j)=zetarec(i)*pss(i,j)

      do 1011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 1011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 1012 i=1,nn
      dps(i,01)=axbx(iicontr(i))*dss(i,1)+fss(i,01)
      dps(i,02)=ayby(iicontr(i))*dss(i,1)+fss(i,02)
      dps(i,03)=azbz(iicontr(i))*dss(i,1)+fss(i,03)
      dps(i,04)=axbx(iicontr(i))*dss(i,2)+fss(i,02)
      dps(i,05)=ayby(iicontr(i))*dss(i,2)+fss(i,04)
      dps(i,06)=azbz(iicontr(i))*dss(i,2)+fss(i,05)
      dps(i,07)=axbx(iicontr(i))*dss(i,3)+fss(i,03)
      dps(i,08)=ayby(iicontr(i))*dss(i,3)+fss(i,05)
      dps(i,09)=azbz(iicontr(i))*dss(i,3)+fss(i,06)
      dps(i,10)=axbx(iicontr(i))*dss(i,4)+fss(i,04)
      dps(i,11)=ayby(iicontr(i))*dss(i,4)+fss(i,07)
      dps(i,12)=azbz(iicontr(i))*dss(i,4)+fss(i,08)
      dps(i,13)=axbx(iicontr(i))*dss(i,5)+fss(i,05)
      dps(i,14)=ayby(iicontr(i))*dss(i,5)+fss(i,08)
      dps(i,15)=azbz(iicontr(i))*dss(i,5)+fss(i,09)
      dps(i,16)=axbx(iicontr(i))*dss(i,6)+fss(i,06)
      dps(i,17)=ayby(iicontr(i))*dss(i,6)+fss(i,09)
 1012 dps(i,18)=azbz(iicontr(i))*dss(i,6)+fss(i,10)

      do 1013 i=1,nn
 1013 gather(i,1)=zero

      do 1014 j=1,18
      do 1014 i=1,nn
 1014 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dps(i,j)

      do 1015 i=1,nn
 1015 gather(i,1)=gather(i,1)*xcfits

      do 1016 i=1,nn
 1016 vvector(naux)=vvector(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      xcfitp(1)=coeffp(ilaux)
      xcfitp(2)=coeffp(ilaux)
      xcfitp(3)=coeffp(ilaux)

      xcfitd(1)=coeffd(ilaux)/sqrt3
      xcfitd(2)=coeffd(ilaux)
      xcfitd(3)=coeffd(ilaux)
      xcfitd(4)=coeffd(ilaux)/sqrt3
      xcfitd(5)=coeffd(ilaux)
      xcfitd(6)=coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,nn
 2010 c1(i,j)=zetarec(i)*pss(i,j)

      do 2011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 2011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 2012 j=1,6
      do 2012 i=1,nn
 2012 c2(i,j)=zetarec(i)*dss(i,j)

      do 2013 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 2013 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 2014 j=1,10
      do 2014 i=1,nn
 2014 c3(i,j)=zetarec(i)*fss(i,j)

      do 2015 i=1,nn
      hss(i,01)=gxax(i)*gss(i,01)+c3(i,01)*four
      hss(i,02)=gyay(i)*gss(i,01)
      hss(i,03)=gzaz(i)*gss(i,01)
      hss(i,04)=gyay(i)*gss(i,02)+c3(i,01)
      hss(i,05)=gzaz(i)*gss(i,02)
      hss(i,06)=gzaz(i)*gss(i,03)+c3(i,01)
      hss(i,07)=gyay(i)*gss(i,04)+c3(i,02)*two
      hss(i,08)=gzaz(i)*gss(i,04)
      hss(i,09)=gzaz(i)*gss(i,05)+c3(i,02)
      hss(i,10)=gzaz(i)*gss(i,06)+c3(i,03)*two
      hss(i,11)=gyay(i)*gss(i,07)+c3(i,04)*three
      hss(i,12)=gzaz(i)*gss(i,07)
      hss(i,13)=gzaz(i)*gss(i,08)+c3(i,04)
      hss(i,14)=gzaz(i)*gss(i,09)+c3(i,05)*two
      hss(i,15)=gzaz(i)*gss(i,10)+c3(i,06)*three
      hss(i,16)=gyay(i)*gss(i,11)+c3(i,07)*four
      hss(i,17)=gzaz(i)*gss(i,11)
      hss(i,18)=gzaz(i)*gss(i,12)+c3(i,07)
      hss(i,19)=gzaz(i)*gss(i,13)+c3(i,08)*two
      hss(i,20)=gzaz(i)*gss(i,14)+c3(i,09)*three
 2015 hss(i,21)=gzaz(i)*gss(i,15)+c3(i,10)*four

      do 2016 i=1,nn
      dps(i,01)=axbx(iicontr(i))*dss(i,1)+fss(i,01)
      dps(i,02)=ayby(iicontr(i))*dss(i,1)+fss(i,02)
      dps(i,03)=azbz(iicontr(i))*dss(i,1)+fss(i,03)
      dps(i,04)=axbx(iicontr(i))*dss(i,2)+fss(i,02)
      dps(i,05)=ayby(iicontr(i))*dss(i,2)+fss(i,04)
      dps(i,06)=azbz(iicontr(i))*dss(i,2)+fss(i,05)
      dps(i,07)=axbx(iicontr(i))*dss(i,3)+fss(i,03)
      dps(i,08)=ayby(iicontr(i))*dss(i,3)+fss(i,05)
      dps(i,09)=azbz(iicontr(i))*dss(i,3)+fss(i,06)
      dps(i,10)=axbx(iicontr(i))*dss(i,4)+fss(i,04)
      dps(i,11)=ayby(iicontr(i))*dss(i,4)+fss(i,07)
      dps(i,12)=azbz(iicontr(i))*dss(i,4)+fss(i,08)
      dps(i,13)=axbx(iicontr(i))*dss(i,5)+fss(i,05)
      dps(i,14)=ayby(iicontr(i))*dss(i,5)+fss(i,08)
      dps(i,15)=azbz(iicontr(i))*dss(i,5)+fss(i,09)
      dps(i,16)=axbx(iicontr(i))*dss(i,6)+fss(i,06)
      dps(i,17)=ayby(iicontr(i))*dss(i,6)+fss(i,09)
 2016 dps(i,18)=azbz(iicontr(i))*dss(i,6)+fss(i,10)

      do 2017 i=1,nn
      fps(i,01)=axbx(iicontr(i))*fss(i,01)+gss(i,01)
      fps(i,02)=ayby(iicontr(i))*fss(i,01)+gss(i,02)
      fps(i,03)=azbz(iicontr(i))*fss(i,01)+gss(i,03)
      fps(i,04)=axbx(iicontr(i))*fss(i,02)+gss(i,02)
      fps(i,05)=ayby(iicontr(i))*fss(i,02)+gss(i,04)
      fps(i,06)=azbz(iicontr(i))*fss(i,02)+gss(i,05)
      fps(i,07)=axbx(iicontr(i))*fss(i,03)+gss(i,03)
      fps(i,08)=ayby(iicontr(i))*fss(i,03)+gss(i,05)
      fps(i,09)=azbz(iicontr(i))*fss(i,03)+gss(i,06)
      fps(i,10)=axbx(iicontr(i))*fss(i,04)+gss(i,04)
      fps(i,11)=ayby(iicontr(i))*fss(i,04)+gss(i,07)
      fps(i,12)=azbz(iicontr(i))*fss(i,04)+gss(i,08)
      fps(i,13)=axbx(iicontr(i))*fss(i,05)+gss(i,05)
      fps(i,14)=ayby(iicontr(i))*fss(i,05)+gss(i,08)
      fps(i,15)=azbz(iicontr(i))*fss(i,05)+gss(i,09)
      fps(i,16)=axbx(iicontr(i))*fss(i,06)+gss(i,06)
      fps(i,17)=ayby(iicontr(i))*fss(i,06)+gss(i,09)
      fps(i,18)=azbz(iicontr(i))*fss(i,06)+gss(i,10)
      fps(i,19)=axbx(iicontr(i))*fss(i,07)+gss(i,07)
      fps(i,20)=ayby(iicontr(i))*fss(i,07)+gss(i,11)
      fps(i,21)=azbz(iicontr(i))*fss(i,07)+gss(i,12)
      fps(i,22)=axbx(iicontr(i))*fss(i,08)+gss(i,08)
      fps(i,23)=ayby(iicontr(i))*fss(i,08)+gss(i,12)
      fps(i,24)=azbz(iicontr(i))*fss(i,08)+gss(i,13)
      fps(i,25)=axbx(iicontr(i))*fss(i,09)+gss(i,09)
      fps(i,26)=ayby(iicontr(i))*fss(i,09)+gss(i,13)
      fps(i,27)=azbz(iicontr(i))*fss(i,09)+gss(i,14)
      fps(i,28)=axbx(iicontr(i))*fss(i,10)+gss(i,10)
      fps(i,29)=ayby(iicontr(i))*fss(i,10)+gss(i,14)
 2017 fps(i,30)=azbz(iicontr(i))*fss(i,10)+gss(i,15)

      do 2018 i=1,nn
      dpp(i,01)=axcx(i)*dps(i,01)+fps(i,01)
      dpp(i,02)=aycy(i)*dps(i,01)+fps(i,04)
      dpp(i,03)=azcz(i)*dps(i,01)+fps(i,07)
      dpp(i,04)=axcx(i)*dps(i,02)+fps(i,02)
      dpp(i,05)=aycy(i)*dps(i,02)+fps(i,05)
      dpp(i,06)=azcz(i)*dps(i,02)+fps(i,08)
      dpp(i,07)=axcx(i)*dps(i,03)+fps(i,03)
      dpp(i,08)=aycy(i)*dps(i,03)+fps(i,06)
      dpp(i,09)=azcz(i)*dps(i,03)+fps(i,09)
      dpp(i,10)=axcx(i)*dps(i,04)+fps(i,04)
      dpp(i,11)=aycy(i)*dps(i,04)+fps(i,10)
      dpp(i,12)=azcz(i)*dps(i,04)+fps(i,13)
      dpp(i,13)=axcx(i)*dps(i,05)+fps(i,05)
      dpp(i,14)=aycy(i)*dps(i,05)+fps(i,11)
      dpp(i,15)=azcz(i)*dps(i,05)+fps(i,14)
      dpp(i,16)=axcx(i)*dps(i,06)+fps(i,06)
      dpp(i,17)=aycy(i)*dps(i,06)+fps(i,12)
      dpp(i,18)=azcz(i)*dps(i,06)+fps(i,15)
      dpp(i,19)=axcx(i)*dps(i,07)+fps(i,07)
      dpp(i,20)=aycy(i)*dps(i,07)+fps(i,13)
      dpp(i,21)=azcz(i)*dps(i,07)+fps(i,16)
      dpp(i,22)=axcx(i)*dps(i,08)+fps(i,08)
      dpp(i,23)=aycy(i)*dps(i,08)+fps(i,14)
      dpp(i,24)=azcz(i)*dps(i,08)+fps(i,17)
      dpp(i,25)=axcx(i)*dps(i,09)+fps(i,09)
      dpp(i,26)=aycy(i)*dps(i,09)+fps(i,15)
      dpp(i,27)=azcz(i)*dps(i,09)+fps(i,18)
      dpp(i,28)=axcx(i)*dps(i,10)+fps(i,10)
      dpp(i,29)=aycy(i)*dps(i,10)+fps(i,19)
      dpp(i,30)=azcz(i)*dps(i,10)+fps(i,22)
      dpp(i,31)=axcx(i)*dps(i,11)+fps(i,11)
      dpp(i,32)=aycy(i)*dps(i,11)+fps(i,20)
      dpp(i,33)=azcz(i)*dps(i,11)+fps(i,23)
      dpp(i,34)=axcx(i)*dps(i,12)+fps(i,12)
      dpp(i,35)=aycy(i)*dps(i,12)+fps(i,21)
      dpp(i,36)=azcz(i)*dps(i,12)+fps(i,24)
      dpp(i,37)=axcx(i)*dps(i,13)+fps(i,13)
      dpp(i,38)=aycy(i)*dps(i,13)+fps(i,22)
      dpp(i,39)=azcz(i)*dps(i,13)+fps(i,25)
      dpp(i,40)=axcx(i)*dps(i,14)+fps(i,14)
      dpp(i,41)=aycy(i)*dps(i,14)+fps(i,23)
      dpp(i,42)=azcz(i)*dps(i,14)+fps(i,26)
      dpp(i,43)=axcx(i)*dps(i,15)+fps(i,15)
      dpp(i,44)=aycy(i)*dps(i,15)+fps(i,24)
      dpp(i,45)=azcz(i)*dps(i,15)+fps(i,27)
      dpp(i,46)=axcx(i)*dps(i,16)+fps(i,16)
      dpp(i,47)=aycy(i)*dps(i,16)+fps(i,25)
      dpp(i,48)=azcz(i)*dps(i,16)+fps(i,28)
      dpp(i,49)=axcx(i)*dps(i,17)+fps(i,17)
      dpp(i,50)=aycy(i)*dps(i,17)+fps(i,26)
      dpp(i,51)=azcz(i)*dps(i,17)+fps(i,29)
      dpp(i,52)=axcx(i)*dps(i,18)+fps(i,18)
      dpp(i,53)=aycy(i)*dps(i,18)+fps(i,27)
 2018 dpp(i,54)=azcz(i)*dps(i,18)+fps(i,30)

      do 2019 i=1,nn
      gps(i,01)=axbx(iicontr(i))*gss(i,01)+hss(i,01)
      gps(i,02)=ayby(iicontr(i))*gss(i,01)+hss(i,02)
      gps(i,03)=azbz(iicontr(i))*gss(i,01)+hss(i,03)
      gps(i,04)=axbx(iicontr(i))*gss(i,02)+hss(i,02)
      gps(i,05)=ayby(iicontr(i))*gss(i,02)+hss(i,04)
      gps(i,06)=azbz(iicontr(i))*gss(i,02)+hss(i,05)
      gps(i,07)=axbx(iicontr(i))*gss(i,03)+hss(i,03)
      gps(i,08)=ayby(iicontr(i))*gss(i,03)+hss(i,05)
      gps(i,09)=azbz(iicontr(i))*gss(i,03)+hss(i,06)
      gps(i,10)=axbx(iicontr(i))*gss(i,04)+hss(i,04)
      gps(i,11)=ayby(iicontr(i))*gss(i,04)+hss(i,07)
      gps(i,12)=azbz(iicontr(i))*gss(i,04)+hss(i,08)
      gps(i,13)=axbx(iicontr(i))*gss(i,05)+hss(i,05)
      gps(i,14)=ayby(iicontr(i))*gss(i,05)+hss(i,08)
      gps(i,15)=azbz(iicontr(i))*gss(i,05)+hss(i,09)
      gps(i,16)=axbx(iicontr(i))*gss(i,06)+hss(i,06)
      gps(i,17)=ayby(iicontr(i))*gss(i,06)+hss(i,09)
      gps(i,18)=azbz(iicontr(i))*gss(i,06)+hss(i,10)
      gps(i,19)=axbx(iicontr(i))*gss(i,07)+hss(i,07)
      gps(i,20)=ayby(iicontr(i))*gss(i,07)+hss(i,11)
      gps(i,21)=azbz(iicontr(i))*gss(i,07)+hss(i,12)
      gps(i,22)=axbx(iicontr(i))*gss(i,08)+hss(i,08)
      gps(i,23)=ayby(iicontr(i))*gss(i,08)+hss(i,12)
      gps(i,24)=azbz(iicontr(i))*gss(i,08)+hss(i,13)
      gps(i,25)=axbx(iicontr(i))*gss(i,09)+hss(i,09)
      gps(i,26)=ayby(iicontr(i))*gss(i,09)+hss(i,13)
      gps(i,27)=azbz(iicontr(i))*gss(i,09)+hss(i,14)
      gps(i,28)=axbx(iicontr(i))*gss(i,10)+hss(i,10)
      gps(i,29)=ayby(iicontr(i))*gss(i,10)+hss(i,14)
      gps(i,30)=azbz(iicontr(i))*gss(i,10)+hss(i,15)
      gps(i,31)=axbx(iicontr(i))*gss(i,11)+hss(i,11)
      gps(i,32)=ayby(iicontr(i))*gss(i,11)+hss(i,16)
      gps(i,33)=azbz(iicontr(i))*gss(i,11)+hss(i,17)
      gps(i,34)=axbx(iicontr(i))*gss(i,12)+hss(i,12)
      gps(i,35)=ayby(iicontr(i))*gss(i,12)+hss(i,17)
      gps(i,36)=azbz(iicontr(i))*gss(i,12)+hss(i,18)
      gps(i,37)=axbx(iicontr(i))*gss(i,13)+hss(i,13)
      gps(i,38)=ayby(iicontr(i))*gss(i,13)+hss(i,18)
      gps(i,39)=azbz(iicontr(i))*gss(i,13)+hss(i,19)
      gps(i,40)=axbx(iicontr(i))*gss(i,14)+hss(i,14)
      gps(i,41)=ayby(iicontr(i))*gss(i,14)+hss(i,19)
      gps(i,42)=azbz(iicontr(i))*gss(i,14)+hss(i,20)
      gps(i,43)=axbx(iicontr(i))*gss(i,15)+hss(i,15)
      gps(i,44)=ayby(iicontr(i))*gss(i,15)+hss(i,20)
 2019 gps(i,45)=azbz(iicontr(i))*gss(i,15)+hss(i,21)

      do 2020 i=1,nn
      fpp(i,01)=axcx(i)*fps(i,01)+gps(i,01)
      fpp(i,02)=aycy(i)*fps(i,01)+gps(i,04)
      fpp(i,03)=azcz(i)*fps(i,01)+gps(i,07)
      fpp(i,04)=axcx(i)*fps(i,02)+gps(i,02)
      fpp(i,05)=aycy(i)*fps(i,02)+gps(i,05)
      fpp(i,06)=azcz(i)*fps(i,02)+gps(i,08)
      fpp(i,07)=axcx(i)*fps(i,03)+gps(i,03)
      fpp(i,08)=aycy(i)*fps(i,03)+gps(i,06)
      fpp(i,09)=azcz(i)*fps(i,03)+gps(i,09)
      fpp(i,10)=axcx(i)*fps(i,04)+gps(i,04)
      fpp(i,11)=aycy(i)*fps(i,04)+gps(i,10)
      fpp(i,12)=azcz(i)*fps(i,04)+gps(i,13)
      fpp(i,13)=axcx(i)*fps(i,05)+gps(i,05)
      fpp(i,14)=aycy(i)*fps(i,05)+gps(i,11)
      fpp(i,15)=azcz(i)*fps(i,05)+gps(i,14)
      fpp(i,16)=axcx(i)*fps(i,06)+gps(i,06)
      fpp(i,17)=aycy(i)*fps(i,06)+gps(i,12)
      fpp(i,18)=azcz(i)*fps(i,06)+gps(i,15)
      fpp(i,19)=axcx(i)*fps(i,07)+gps(i,07)
      fpp(i,20)=aycy(i)*fps(i,07)+gps(i,13)
      fpp(i,21)=azcz(i)*fps(i,07)+gps(i,16)
      fpp(i,22)=axcx(i)*fps(i,08)+gps(i,08)
      fpp(i,23)=aycy(i)*fps(i,08)+gps(i,14)
      fpp(i,24)=azcz(i)*fps(i,08)+gps(i,17)
      fpp(i,25)=axcx(i)*fps(i,09)+gps(i,09)
      fpp(i,26)=aycy(i)*fps(i,09)+gps(i,15)
      fpp(i,27)=azcz(i)*fps(i,09)+gps(i,18)
      fpp(i,28)=axcx(i)*fps(i,10)+gps(i,10)
      fpp(i,29)=aycy(i)*fps(i,10)+gps(i,19)
      fpp(i,30)=azcz(i)*fps(i,10)+gps(i,22)
      fpp(i,31)=axcx(i)*fps(i,11)+gps(i,11)
      fpp(i,32)=aycy(i)*fps(i,11)+gps(i,20)
      fpp(i,33)=azcz(i)*fps(i,11)+gps(i,23)
      fpp(i,34)=axcx(i)*fps(i,12)+gps(i,12)
      fpp(i,35)=aycy(i)*fps(i,12)+gps(i,21)
      fpp(i,36)=azcz(i)*fps(i,12)+gps(i,24)
      fpp(i,37)=axcx(i)*fps(i,13)+gps(i,13)
      fpp(i,38)=aycy(i)*fps(i,13)+gps(i,22)
      fpp(i,39)=azcz(i)*fps(i,13)+gps(i,25)
      fpp(i,40)=axcx(i)*fps(i,14)+gps(i,14)
      fpp(i,41)=aycy(i)*fps(i,14)+gps(i,23)
      fpp(i,42)=azcz(i)*fps(i,14)+gps(i,26)
      fpp(i,43)=axcx(i)*fps(i,15)+gps(i,15)
      fpp(i,44)=aycy(i)*fps(i,15)+gps(i,24)
      fpp(i,45)=azcz(i)*fps(i,15)+gps(i,27)
      fpp(i,46)=axcx(i)*fps(i,16)+gps(i,16)
      fpp(i,47)=aycy(i)*fps(i,16)+gps(i,25)
      fpp(i,48)=azcz(i)*fps(i,16)+gps(i,28)
      fpp(i,49)=axcx(i)*fps(i,17)+gps(i,17)
      fpp(i,50)=aycy(i)*fps(i,17)+gps(i,26)
      fpp(i,51)=azcz(i)*fps(i,17)+gps(i,29)
      fpp(i,52)=axcx(i)*fps(i,18)+gps(i,18)
      fpp(i,53)=aycy(i)*fps(i,18)+gps(i,27)
      fpp(i,54)=azcz(i)*fps(i,18)+gps(i,30)
      fpp(i,55)=axcx(i)*fps(i,19)+gps(i,19)
      fpp(i,56)=aycy(i)*fps(i,19)+gps(i,31)
      fpp(i,57)=azcz(i)*fps(i,19)+gps(i,34)
      fpp(i,58)=axcx(i)*fps(i,20)+gps(i,20)
      fpp(i,59)=aycy(i)*fps(i,20)+gps(i,32)
      fpp(i,60)=azcz(i)*fps(i,20)+gps(i,35)
      fpp(i,61)=axcx(i)*fps(i,21)+gps(i,21)
      fpp(i,62)=aycy(i)*fps(i,21)+gps(i,33)
      fpp(i,63)=azcz(i)*fps(i,21)+gps(i,36)
      fpp(i,64)=axcx(i)*fps(i,22)+gps(i,22)
      fpp(i,65)=aycy(i)*fps(i,22)+gps(i,34)
      fpp(i,66)=azcz(i)*fps(i,22)+gps(i,37)
      fpp(i,67)=axcx(i)*fps(i,23)+gps(i,23)
      fpp(i,68)=aycy(i)*fps(i,23)+gps(i,35)
      fpp(i,69)=azcz(i)*fps(i,23)+gps(i,38)
      fpp(i,70)=axcx(i)*fps(i,24)+gps(i,24)
      fpp(i,71)=aycy(i)*fps(i,24)+gps(i,36)
      fpp(i,72)=azcz(i)*fps(i,24)+gps(i,39)
      fpp(i,73)=axcx(i)*fps(i,25)+gps(i,25)
      fpp(i,74)=aycy(i)*fps(i,25)+gps(i,37)
      fpp(i,75)=azcz(i)*fps(i,25)+gps(i,40)
      fpp(i,76)=axcx(i)*fps(i,26)+gps(i,26)
      fpp(i,77)=aycy(i)*fps(i,26)+gps(i,38)
      fpp(i,78)=azcz(i)*fps(i,26)+gps(i,41)
      fpp(i,79)=axcx(i)*fps(i,27)+gps(i,27)
      fpp(i,80)=aycy(i)*fps(i,27)+gps(i,39)
      fpp(i,81)=azcz(i)*fps(i,27)+gps(i,42)
      fpp(i,82)=axcx(i)*fps(i,28)+gps(i,28)
      fpp(i,83)=aycy(i)*fps(i,28)+gps(i,40)
      fpp(i,84)=azcz(i)*fps(i,28)+gps(i,43)
      fpp(i,85)=axcx(i)*fps(i,29)+gps(i,29)
      fpp(i,86)=aycy(i)*fps(i,29)+gps(i,41)
      fpp(i,87)=azcz(i)*fps(i,29)+gps(i,44)
      fpp(i,88)=axcx(i)*fps(i,30)+gps(i,30)
      fpp(i,89)=aycy(i)*fps(i,30)+gps(i,42)
 2020 fpp(i,90)=azcz(i)*fps(i,30)+gps(i,45)

      do 2021 i=1,nn
      dpd(i,001)=axcx(i)*dpp(i,01)+fpp(i,01)
      dpd(i,002)=aycy(i)*dpp(i,01)+fpp(i,10)
      dpd(i,003)=azcz(i)*dpp(i,01)+fpp(i,19)
      dpd(i,004)=aycy(i)*dpp(i,02)+fpp(i,11)
      dpd(i,005)=azcz(i)*dpp(i,02)+fpp(i,20)
      dpd(i,006)=azcz(i)*dpp(i,03)+fpp(i,21)
      dpd(i,007)=axcx(i)*dpp(i,04)+fpp(i,04)
      dpd(i,008)=aycy(i)*dpp(i,04)+fpp(i,13)
      dpd(i,009)=azcz(i)*dpp(i,04)+fpp(i,22)
      dpd(i,010)=aycy(i)*dpp(i,05)+fpp(i,14)
      dpd(i,011)=azcz(i)*dpp(i,05)+fpp(i,23)
      dpd(i,012)=azcz(i)*dpp(i,06)+fpp(i,24)
      dpd(i,013)=axcx(i)*dpp(i,07)+fpp(i,07)
      dpd(i,014)=aycy(i)*dpp(i,07)+fpp(i,16)
      dpd(i,015)=azcz(i)*dpp(i,07)+fpp(i,25)
      dpd(i,016)=aycy(i)*dpp(i,08)+fpp(i,17)
      dpd(i,017)=azcz(i)*dpp(i,08)+fpp(i,26)
      dpd(i,018)=azcz(i)*dpp(i,09)+fpp(i,27)
      dpd(i,019)=axcx(i)*dpp(i,10)+fpp(i,10)
      dpd(i,020)=aycy(i)*dpp(i,10)+fpp(i,28)
      dpd(i,021)=azcz(i)*dpp(i,10)+fpp(i,37)
      dpd(i,022)=aycy(i)*dpp(i,11)+fpp(i,29)
      dpd(i,023)=azcz(i)*dpp(i,11)+fpp(i,38)
      dpd(i,024)=azcz(i)*dpp(i,12)+fpp(i,39)
      dpd(i,025)=axcx(i)*dpp(i,13)+fpp(i,13)
      dpd(i,026)=aycy(i)*dpp(i,13)+fpp(i,31)
      dpd(i,027)=azcz(i)*dpp(i,13)+fpp(i,40)
      dpd(i,028)=aycy(i)*dpp(i,14)+fpp(i,32)
      dpd(i,029)=azcz(i)*dpp(i,14)+fpp(i,41)
      dpd(i,030)=azcz(i)*dpp(i,15)+fpp(i,42)
      dpd(i,031)=axcx(i)*dpp(i,16)+fpp(i,16)
      dpd(i,032)=aycy(i)*dpp(i,16)+fpp(i,34)
      dpd(i,033)=azcz(i)*dpp(i,16)+fpp(i,43)
      dpd(i,034)=aycy(i)*dpp(i,17)+fpp(i,35)
      dpd(i,035)=azcz(i)*dpp(i,17)+fpp(i,44)
      dpd(i,036)=azcz(i)*dpp(i,18)+fpp(i,45)
      dpd(i,037)=axcx(i)*dpp(i,19)+fpp(i,19)
      dpd(i,038)=aycy(i)*dpp(i,19)+fpp(i,37)
      dpd(i,039)=azcz(i)*dpp(i,19)+fpp(i,46)
      dpd(i,040)=aycy(i)*dpp(i,20)+fpp(i,38)
      dpd(i,041)=azcz(i)*dpp(i,20)+fpp(i,47)
      dpd(i,042)=azcz(i)*dpp(i,21)+fpp(i,48)
      dpd(i,043)=axcx(i)*dpp(i,22)+fpp(i,22)
      dpd(i,044)=aycy(i)*dpp(i,22)+fpp(i,40)
      dpd(i,045)=azcz(i)*dpp(i,22)+fpp(i,49)
      dpd(i,046)=aycy(i)*dpp(i,23)+fpp(i,41)
      dpd(i,047)=azcz(i)*dpp(i,23)+fpp(i,50)
      dpd(i,048)=azcz(i)*dpp(i,24)+fpp(i,51)
      dpd(i,049)=axcx(i)*dpp(i,25)+fpp(i,25)
      dpd(i,050)=aycy(i)*dpp(i,25)+fpp(i,43)
      dpd(i,051)=azcz(i)*dpp(i,25)+fpp(i,52)
      dpd(i,052)=aycy(i)*dpp(i,26)+fpp(i,44)
      dpd(i,053)=azcz(i)*dpp(i,26)+fpp(i,53)
      dpd(i,054)=azcz(i)*dpp(i,27)+fpp(i,54)
      dpd(i,055)=axcx(i)*dpp(i,28)+fpp(i,28)
      dpd(i,056)=aycy(i)*dpp(i,28)+fpp(i,55)
      dpd(i,057)=azcz(i)*dpp(i,28)+fpp(i,64)
      dpd(i,058)=aycy(i)*dpp(i,29)+fpp(i,56)
      dpd(i,059)=azcz(i)*dpp(i,29)+fpp(i,65)
      dpd(i,060)=azcz(i)*dpp(i,30)+fpp(i,66)
      dpd(i,061)=axcx(i)*dpp(i,31)+fpp(i,31)
      dpd(i,062)=aycy(i)*dpp(i,31)+fpp(i,58)
      dpd(i,063)=azcz(i)*dpp(i,31)+fpp(i,67)
      dpd(i,064)=aycy(i)*dpp(i,32)+fpp(i,59)
      dpd(i,065)=azcz(i)*dpp(i,32)+fpp(i,68)
      dpd(i,066)=azcz(i)*dpp(i,33)+fpp(i,69)
      dpd(i,067)=axcx(i)*dpp(i,34)+fpp(i,34)
      dpd(i,068)=aycy(i)*dpp(i,34)+fpp(i,61)
      dpd(i,069)=azcz(i)*dpp(i,34)+fpp(i,70)
      dpd(i,070)=aycy(i)*dpp(i,35)+fpp(i,62)
      dpd(i,071)=azcz(i)*dpp(i,35)+fpp(i,71)
      dpd(i,072)=azcz(i)*dpp(i,36)+fpp(i,72)
      dpd(i,073)=axcx(i)*dpp(i,37)+fpp(i,37)
      dpd(i,074)=aycy(i)*dpp(i,37)+fpp(i,64)
      dpd(i,075)=azcz(i)*dpp(i,37)+fpp(i,73)
      dpd(i,076)=aycy(i)*dpp(i,38)+fpp(i,65)
      dpd(i,077)=azcz(i)*dpp(i,38)+fpp(i,74)
      dpd(i,078)=azcz(i)*dpp(i,39)+fpp(i,75)
      dpd(i,079)=axcx(i)*dpp(i,40)+fpp(i,40)
      dpd(i,080)=aycy(i)*dpp(i,40)+fpp(i,67)
      dpd(i,081)=azcz(i)*dpp(i,40)+fpp(i,76)
      dpd(i,082)=aycy(i)*dpp(i,41)+fpp(i,68)
      dpd(i,083)=azcz(i)*dpp(i,41)+fpp(i,77)
      dpd(i,084)=azcz(i)*dpp(i,42)+fpp(i,78)
      dpd(i,085)=axcx(i)*dpp(i,43)+fpp(i,43)
      dpd(i,086)=aycy(i)*dpp(i,43)+fpp(i,70)
      dpd(i,087)=azcz(i)*dpp(i,43)+fpp(i,79)
      dpd(i,088)=aycy(i)*dpp(i,44)+fpp(i,71)
      dpd(i,089)=azcz(i)*dpp(i,44)+fpp(i,80)
      dpd(i,090)=azcz(i)*dpp(i,45)+fpp(i,81)
      dpd(i,091)=axcx(i)*dpp(i,46)+fpp(i,46)
      dpd(i,092)=aycy(i)*dpp(i,46)+fpp(i,73)
      dpd(i,093)=azcz(i)*dpp(i,46)+fpp(i,82)
      dpd(i,094)=aycy(i)*dpp(i,47)+fpp(i,74)
      dpd(i,095)=azcz(i)*dpp(i,47)+fpp(i,83)
      dpd(i,096)=azcz(i)*dpp(i,48)+fpp(i,84)
      dpd(i,097)=axcx(i)*dpp(i,49)+fpp(i,49)
      dpd(i,098)=aycy(i)*dpp(i,49)+fpp(i,76)
      dpd(i,099)=azcz(i)*dpp(i,49)+fpp(i,85)
      dpd(i,100)=aycy(i)*dpp(i,50)+fpp(i,77)
      dpd(i,101)=azcz(i)*dpp(i,50)+fpp(i,86)
      dpd(i,102)=azcz(i)*dpp(i,51)+fpp(i,87)
      dpd(i,103)=axcx(i)*dpp(i,52)+fpp(i,52)
      dpd(i,104)=aycy(i)*dpp(i,52)+fpp(i,79)
      dpd(i,105)=azcz(i)*dpp(i,52)+fpp(i,88)
      dpd(i,106)=aycy(i)*dpp(i,53)+fpp(i,80)
      dpd(i,107)=azcz(i)*dpp(i,53)+fpp(i,89)
 2021 dpd(i,108)=azcz(i)*dpp(i,54)+fpp(i,90)

      do 2022 j=1,10
      do 2022 i=1,nn
 2022 gather(i,j)=zero

      do 2023 j=1,18
      do 2023 i=1,nn
 2023 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dps(i,j)

      do 2024 k=1,3
      do 2024 j=1,18
      do 2024 i=1,nn
 2024 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*dpp(i,3*(j-1)+k)

      do 2025 k=1,6
      do 2025 j=1,18
      do 2025 i=1,nn
 2025 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*dpd(i,6*(j-1)+k)

      do 2026 i=1,nn
      gather(i,01)=gather(i,01)*xcfits
      gather(i,02)=gather(i,02)*xcfitp(1)
      gather(i,03)=gather(i,03)*xcfitp(2)
      gather(i,04)=gather(i,04)*xcfitp(3)
      gather(i,05)=gather(i,05)*xcfitd(1)
      gather(i,06)=gather(i,06)*xcfitd(2)
      gather(i,07)=gather(i,07)*xcfitd(3)
      gather(i,08)=gather(i,08)*xcfitd(4)
      gather(i,09)=gather(i,09)*xcfitd(5)
 2026 gather(i,10)=gather(i,10)*xcfitd(6)

      nc=nxcs+(naux-1)*10

      do 2027 i=1,nn
      do 2027 j=1,10
 2027 vvector(nc+j)=vvector(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine ginverse(n,gmat,ginvmat,wkmat,coeff,veci,vecj)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension gmat(n,*),ginvmat(n,*),wkmat(n,*),coeff(n,*)
      dimension veci(*),vecj(*)

      data loopmax/500/

      data big,tol,eigen/10000.0d0,0.00000001d0,0.001d0/
      data zero,half,one,two,hundred/0.0d0,0.5d0,1.0d0,2.0d0,100.0d0/

      do 1001 j=1,n
      do 1002 i=1,n
 1002 coeff(i,j)=zero
 1001 coeff(j,j)=one

      do 1003 j=1,n
      do 1003 i=1,n
      wkmat(i,j)=zero
      do 1003 k=1,n
 1003 wkmat(i,j)=wkmat(i,j)+coeff(k,j)*gmat(k,i)

      do 1004 loop=1,loopmax

      g_ij_max=zero

      do 1005 i=1,n
      do 1005 j=1,i

      if(i.eq.j) goto 1005

      g_ij=zero

      do 1006 k=1,n
 1006 g_ij=g_ij+coeff(k,j)*wkmat(k,i)

      if(abs(g_ij).gt.g_ij_max) g_ij_max=abs(g_ij)

      t01=tol/hundred/hundred/hundred

      if(abs(g_ij).gt.t01) then
                                 g_ii=zero

                                 do 1007 k=1,n
 1007                            g_ii=g_ii+coeff(k,i)*wkmat(k,i)

                                 g_jj=zero

                                 do 1008 k=1,n
 1008                            g_jj=g_jj+coeff(k,j)*wkmat(k,j)

                                 theta=(g_jj-g_ii)/(two*g_ij)
                           else
                                 goto 1005
                           endif

      if(theta.lt.zero) then
                              tan_phi=theta+sqrt(theta*theta+one)
                        else
                              tan_phi=theta-sqrt(theta*theta+one)
                        endif

      if(abs(theta).gt.big) tan_phi=-(half/theta)

      phi=atan(tan_phi)

      c=cos(phi)
      s=sin(phi)

      tau=s/(one+c)

      do 1009 k=1,n
 1009 veci(k)=coeff(k,i)

      do 1010 k=1,n
 1010 vecj(k)=coeff(k,j)

      do 1011 k=1,n
 1011 coeff(k,i)=coeff(k,i)+s*(vecj(k)-tau*veci(k))

      do 1012 k=1,n
 1012 coeff(k,j)=coeff(k,j)-s*(veci(k)+tau*vecj(k))

      do 1013 k=1,n
 1013 veci(k)=wkmat(k,i)

      do 1014 k=1,n
 1014 vecj(k)=wkmat(k,j)

      do 1015 k=1,n
 1015 wkmat(k,i)=wkmat(k,i)+s*(vecj(k)-tau*veci(k))

      do 1016 k=1,n
 1016 wkmat(k,j)=wkmat(k,j)-s*(veci(k)+tau*vecj(k))

 1005 continue

      if(g_ij_max.lt.tol) goto 1017

      if(loop.eq.loopmax) write(6,1018)
 1018 format(/,' ginverse routine did not fully converge')

      if(loop.eq.loopmax) stop

 1004 continue

 1017 continue

      do 1019 j=1,n
      do 1019 i=1,n
 1019 ginvmat(i,j)=zero

      iswitch=0

      do 1020 k=1,n

      g_value=zero

      do 1021 j=1,n
 1021 g_value=g_value+coeff(j,k)*wkmat(j,k)

      if(g_value.lt.eigen) goto 1020

      factor=sqrt(one/g_value)

      do 1022 j=1,n
 1022 coeff(j,k)=coeff(j,k)*factor

      do 1023 j=1,n
      do 1023 i=1,n
 1023 ginvmat(i,j)=ginvmat(i,j)+coeff(i,k)*coeff(j,k)

 1020 continue

      return
      end

      subroutine cdovss(ncds,ndim,ilfunc,icfunc,alpha,coeff,cdsmat,cent)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension g(13)

      dimension ilfunc(*),icfunc(*)

      dimension alpha(*),coeff(*),cdsmat(ndim,*),cent(3,*)

      data one,two,pi/1.0d0,2.0d0,3.1415926535898d0/
      data four,five/4.0d0,5.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      factor=(pi**(five/four)*sqrt(two))**2

      n=(ncds*(ncds+1))/2

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)
                          call mpi_bsend(isent,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(isent,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      istart=isent+1
      iend=isent+nloop

      ij=0

      do 1002 i=1,ncds
      do 1002 j=1,i

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1002

      ilabel=ilfunc(i)
      jlabel=ilfunc(j)

      zetaa=alpha(ilabel)
      zetab=alpha(jlabel)

      zetaab=one/(zetaa+zetab)

      axbx=cent(1,icfunc(ilabel))-cent(1,icfunc(jlabel))
      ayby=cent(2,icfunc(ilabel))-cent(2,icfunc(jlabel))
      azbz=cent(3,icfunc(ilabel))-cent(3,icfunc(jlabel))

      u=zetaa*zetab*zetaab*(axbx*axbx+ayby*ayby+azbz*azbz)

      call augg(1,u,g)

      cdsmat(i,j)=coeff(ilabel)*coeff(jlabel)*g(1)*factor*sqrt(zetaab)
     &           /(zetaa*zetab)

 1002 continue

      return
      end

      subroutine gradxxdp2(m,n,nn,nc,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,ttwozetaa,
     &                     fss0,fsp0,fsd0,gss0,gsp0,gsd0,axbx,ayby,azbz,
     &                     fsscond,fspcond,fsdcond,gsscond,gspcond,
     &                     gsdcond,fpscond,fppcond,fpdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),
     &          ttwozetaa(*),fss0(n,*),fsp0(n,*),fsd0(n,*),gss0(n,*),
     &          gsp0(n,*),gsd0(n,*),axbx(*),ayby(*),azbz(*),
     &          fsscond(m,*),fspcond(m,*),fsdcond(m,*),gsscond(m,*),
     &          gspcond(m,*),gsdcond(m,*),fpscond(m,*),fppcond(m,*),
     &          fpdcond(m,*),grad(m,*)

      data zero/0.0d0/

      do 1001 j=1,10
      do 1001 i=1,m
 1001 fsscond(i,j)=zero

      do 1002 j=1,15
      do 1002 i=1,m
 1002 gsscond(i,j)=zero

      do 1003 j=1,10
      do 1003 i=1,nn
 1003 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fss0(i,j)*ttwozetaa(i)*cdfits

      do 1004 k=1,3
      do 1004 j=1,10
      do 1004 i=1,nn
 1004 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsp0(i,3*(j-1)+k)*ttwozetaa(i)*cdfitp(k)

      do 1005 k=1,6
      do 1005 j=1,10
      do 1005 i=1,nn
 1005 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsd0(i,6*(j-1)+k)*ttwozetaa(i)*cdfitd(k)

      do 1006 j=1,15
      do 1006 i=1,nn
 1006 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gss0(i,j)*ttwozetaa(i)*cdfits

      do 1007 k=1,3
      do 1007 j=1,15
      do 1007 i=1,nn
 1007 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gsp0(i,3*(j-1)+k)*ttwozetaa(i)*cdfitp(k)

      do 1008 k=1,6
      do 1008 j=1,15
      do 1008 i=1,nn
 1008 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gsd0(i,6*(j-1)+k)*ttwozetaa(i)*cdfitd(k)

      do 1009 i=1,m
      fpscond(i,01)=axbx(i)*fsscond(i,01)+gsscond(i,01)
      fpscond(i,02)=ayby(i)*fsscond(i,01)+gsscond(i,02)
      fpscond(i,03)=azbz(i)*fsscond(i,01)+gsscond(i,03)
      fpscond(i,04)=axbx(i)*fsscond(i,02)+gsscond(i,02)
      fpscond(i,05)=ayby(i)*fsscond(i,02)+gsscond(i,04)
      fpscond(i,06)=azbz(i)*fsscond(i,02)+gsscond(i,05)
      fpscond(i,07)=axbx(i)*fsscond(i,03)+gsscond(i,03)
      fpscond(i,08)=ayby(i)*fsscond(i,03)+gsscond(i,05)
      fpscond(i,09)=azbz(i)*fsscond(i,03)+gsscond(i,06)
      fpscond(i,10)=axbx(i)*fsscond(i,04)+gsscond(i,04)
      fpscond(i,11)=ayby(i)*fsscond(i,04)+gsscond(i,07)
      fpscond(i,12)=azbz(i)*fsscond(i,04)+gsscond(i,08)
      fpscond(i,13)=axbx(i)*fsscond(i,05)+gsscond(i,05)
      fpscond(i,14)=ayby(i)*fsscond(i,05)+gsscond(i,08)
      fpscond(i,15)=azbz(i)*fsscond(i,05)+gsscond(i,09)
      fpscond(i,16)=axbx(i)*fsscond(i,06)+gsscond(i,06)
      fpscond(i,17)=ayby(i)*fsscond(i,06)+gsscond(i,09)
      fpscond(i,18)=azbz(i)*fsscond(i,06)+gsscond(i,10)
      fpscond(i,19)=axbx(i)*fsscond(i,07)+gsscond(i,07)
      fpscond(i,20)=ayby(i)*fsscond(i,07)+gsscond(i,11)
      fpscond(i,21)=azbz(i)*fsscond(i,07)+gsscond(i,12)
      fpscond(i,22)=axbx(i)*fsscond(i,08)+gsscond(i,08)
      fpscond(i,23)=ayby(i)*fsscond(i,08)+gsscond(i,12)
      fpscond(i,24)=azbz(i)*fsscond(i,08)+gsscond(i,13)
      fpscond(i,25)=axbx(i)*fsscond(i,09)+gsscond(i,09)
      fpscond(i,26)=ayby(i)*fsscond(i,09)+gsscond(i,13)
      fpscond(i,27)=azbz(i)*fsscond(i,09)+gsscond(i,14)
      fpscond(i,28)=axbx(i)*fsscond(i,10)+gsscond(i,10)
      fpscond(i,29)=ayby(i)*fsscond(i,10)+gsscond(i,14)
 1009 fpscond(i,30)=azbz(i)*fsscond(i,10)+gsscond(i,15)

      do 1010 i=1,m
      grad(i,01)=fpscond(i,01)*density(inddyy(i,01))
      grad(i,02)=fpscond(i,02)*density(inddyy(i,02))
      grad(i,03)=fpscond(i,03)*density(inddyy(i,03))
      grad(i,04)=fpscond(i,04)*density(inddyy(i,04))
      grad(i,05)=fpscond(i,05)*density(inddyy(i,05))
      grad(i,06)=fpscond(i,06)*density(inddyy(i,06))
      grad(i,07)=fpscond(i,07)*density(inddyy(i,07))
      grad(i,08)=fpscond(i,08)*density(inddyy(i,08))
      grad(i,09)=fpscond(i,09)*density(inddyy(i,09))
      grad(i,10)=fpscond(i,10)*density(inddyy(i,10))
      grad(i,11)=fpscond(i,11)*density(inddyy(i,11))
      grad(i,12)=fpscond(i,12)*density(inddyy(i,12))
      grad(i,13)=fpscond(i,13)*density(inddyy(i,13))
      grad(i,14)=fpscond(i,14)*density(inddyy(i,14))
      grad(i,15)=fpscond(i,15)*density(inddyy(i,15))
      grad(i,16)=fpscond(i,16)*density(inddyy(i,16))
      grad(i,17)=fpscond(i,17)*density(inddyy(i,17))
      grad(i,18)=fpscond(i,18)*density(inddyy(i,18))
      grad(i,19)=fpscond(i,04)*density(inddyy(i,01))
      grad(i,20)=fpscond(i,05)*density(inddyy(i,02))
      grad(i,21)=fpscond(i,06)*density(inddyy(i,03))
      grad(i,22)=fpscond(i,10)*density(inddyy(i,04))
      grad(i,23)=fpscond(i,11)*density(inddyy(i,05))
      grad(i,24)=fpscond(i,12)*density(inddyy(i,06))
      grad(i,25)=fpscond(i,13)*density(inddyy(i,07))
      grad(i,26)=fpscond(i,14)*density(inddyy(i,08))
      grad(i,27)=fpscond(i,15)*density(inddyy(i,09))
      grad(i,28)=fpscond(i,19)*density(inddyy(i,10))
      grad(i,29)=fpscond(i,20)*density(inddyy(i,11))
      grad(i,30)=fpscond(i,21)*density(inddyy(i,12))
      grad(i,31)=fpscond(i,22)*density(inddyy(i,13))
      grad(i,32)=fpscond(i,23)*density(inddyy(i,14))
      grad(i,33)=fpscond(i,24)*density(inddyy(i,15))
      grad(i,34)=fpscond(i,25)*density(inddyy(i,16))
      grad(i,35)=fpscond(i,26)*density(inddyy(i,17))
      grad(i,36)=fpscond(i,27)*density(inddyy(i,18))
      grad(i,37)=fpscond(i,07)*density(inddyy(i,01))
      grad(i,38)=fpscond(i,08)*density(inddyy(i,02))
      grad(i,39)=fpscond(i,09)*density(inddyy(i,03))
      grad(i,40)=fpscond(i,13)*density(inddyy(i,04))
      grad(i,41)=fpscond(i,14)*density(inddyy(i,05))
      grad(i,42)=fpscond(i,15)*density(inddyy(i,06))
      grad(i,43)=fpscond(i,16)*density(inddyy(i,07))
      grad(i,44)=fpscond(i,17)*density(inddyy(i,08))
      grad(i,45)=fpscond(i,18)*density(inddyy(i,09))
      grad(i,46)=fpscond(i,22)*density(inddyy(i,10))
      grad(i,47)=fpscond(i,23)*density(inddyy(i,11))
      grad(i,48)=fpscond(i,24)*density(inddyy(i,12))
      grad(i,49)=fpscond(i,25)*density(inddyy(i,13))
      grad(i,50)=fpscond(i,26)*density(inddyy(i,14))
      grad(i,51)=fpscond(i,27)*density(inddyy(i,15))
      grad(i,52)=fpscond(i,28)*density(inddyy(i,16))
      grad(i,53)=fpscond(i,29)*density(inddyy(i,17))
 1010 grad(i,54)=fpscond(i,30)*density(inddyy(i,18))

      do 1011 k=1,3
      do 1011 j=1,18
      do 1011 i=1,m
 1011 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1012 k=1,3
      do 1012 j=1,18
      do 1012 i=1,m
 1012 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

      return
      end

      subroutine annihilate(nmax,ncontractions,nocc,istart,iend,dmaxpc,
     &                      tol,dmat,fock,coeff,fockmat,veci,vecj,
     &                      wkmat1,wkmat2,wkvec,s,tau)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension istart(3,*),iend(3,*)

      dimension dmat(*),fock(*),coeff(nmax,*),fockmat(ncontractions,*),
     &          veci(*),vecj(*),wkmat1(ncontractions,*),
     &          wkmat2(ncontractions,*),wkvec(*),s(*),tau(*)

      data loopmax/500/

      data small,tol_min,tol_max/0.0001d0,0.0001d0,0.0000000001d0/
      data zero,half,one,two,four/0.0d0,0.5d0,1.0d0,2.0d0,4.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      tolerance=tol
      if(tolerance.gt.tol_min) tolerance=tol_min
      if(tolerance.lt.tol_max) tolerance=tol_max

      isent=0
      do 1001 islave=0,numprocs-1
      ia=ncontractions-isent
      ib=numprocs-islave
      nloop=ia/ib
      if(mod(ia,ib).ne.0) nloop=nloop+1
      istart(1,islave+1)=isent+1
      iend(1,islave+1)=isent+nloop
 1001 isent=isent+nloop

      isent=0
      do 1002 islave=0,numprocs-1
      ia=nocc-isent
      ib=numprocs-islave
      nloop=ia/ib
      if(mod(ia,ib).ne.0) nloop=nloop+1
      istart(2,islave+1)=isent+1
      iend(2,islave+1)=isent+nloop
 1002 isent=isent+nloop

      isent=nocc
      do 1003 islave=0,numprocs-1
      ia=ncontractions-isent
      ib=numprocs-islave
      nloop=ia/ib
      if(mod(ia,ib).ne.0) nloop=nloop+1
      istart(3,islave+1)=isent+1
      iend(3,islave+1)=isent+nloop
 1003 isent=isent+nloop

      do 1004 j=1,ncontractions
      do 1004 i=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
 1004 fockmat(i,j)=fock(ij)

      do 1005 j=1,ncontractions
      do 1005 i=istart(1,myid+1),iend(1,myid+1)
      wkmat1(i,j)=zero
      do 1005 k=1,ncontractions
 1005 wkmat1(i,j)=wkmat1(i,j)+coeff(k,j)*fockmat(k,i)

      do 1006 j=1,ncontractions
      do 1006 i=1,ncontractions
      wkmat2(i,j)=zero
      do 1006 k=istart(1,myid+1),iend(1,myid+1)
 1006 wkmat2(i,j)=wkmat2(i,j)+coeff(k,i)*wkmat1(k,j)

      call mpi_reduce(wkmat2,fockmat,ncontractions**2,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(fockmat,ncontractions**2,
     &               mpi_real8,0,mpi_comm_world,ierr)

      do 1007 loop=1,loopmax

      f_ij_max=zero

      do 1008 i=1,nocc

      do 1009 j=nocc+1,ncontractions
      wkvec(j)=zero
      do 1009 k=istart(1,myid+1),iend(1,myid+1)
 1009 wkvec(j)=wkvec(j)+coeff(k,i)*wkmat1(k,j)

      call mpi_reduce(wkvec(nocc+1),wkmat2(nocc+1,1),ncontractions-nocc,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(wkmat2(nocc+1,1),ncontractions-nocc,
     &               mpi_real8,0,mpi_comm_world,ierr)

      do 1010 j=nocc+1,ncontractions
 1010 fockmat(i,j)=wkmat2(j,1)

      do 1011 j=nocc+1,ncontractions
      wkvec(j)=zero
      do 1011 k=istart(1,myid+1),iend(1,myid+1)
 1011 wkvec(j)=wkvec(j)+coeff(k,j)*wkmat1(k,j)

      call mpi_reduce(wkvec(nocc+1),wkmat2(nocc+1,1),ncontractions-nocc,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(wkmat2(nocc+1,1),ncontractions-nocc,
     &               mpi_real8,0,mpi_comm_world,ierr)

      do 1012 j=nocc+1,ncontractions
 1012 fockmat(j,j)=wkmat2(j,1)

      f_ii=zero
      do 1013 k=istart(1,myid+1),iend(1,myid+1)
 1013 f_ii=f_ii+coeff(k,i)*wkmat1(k,i)

      call mpi_reduce(f_ii,fockmat(i,i),1,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
      call mpi_bcast(fockmat(i,i),1,mpi_real8,0,mpi_comm_world,ierr)

      do 1014 j=istart(3,myid+1),iend(3,myid+1)

      f_ij=fockmat(i,j)
      f_ii=fockmat(i,i)
      f_jj=fockmat(j,j)

      if(abs(f_ij).gt.f_ij_max) f_ij_max=abs(f_ij)

      d=f_jj-f_ii

      if(abs(d).le.tol_min) then
                                  s(j)=zero
                                  tau(j)=zero

                                  goto 1014
                            endif

      c=sqrt(four*f_ij*f_ij+d*d)

      diff=abs(c-d)

      if(diff.gt.small) then
                              s(j)=sqrt(half*diff/c)
                        else
                              s(j)=sqrt((f_ij*f_ij)/(d*c))
                        endif

      if(f_ij.ge.zero) s(j)=-s(j)

      c=sqrt(max(zero,one-s(j)*s(j)))

      tau(j)=s(j)/(one+c)

 1014 continue

      do 1015 n=1,numprocs
      nloop=iend(3,n)-istart(3,n)+1
      call mpi_bcast(s(istart(3,n)),
     &               nloop,mpi_real8,n-1,mpi_comm_world,ierr)
      call mpi_bcast(tau(istart(3,n)),
     &               nloop,mpi_real8,n-1,mpi_comm_world,ierr)
 1015 continue

      do 1008 j=nocc+1,ncontractions

      do 1016 k=istart(1,myid+1),iend(1,myid+1)
 1016 veci(k)=coeff(k,i)

      do 1017 k=istart(1,myid+1),iend(1,myid+1)
 1017 vecj(k)=coeff(k,j)

      do 1018 k=istart(1,myid+1),iend(1,myid+1)
 1018 coeff(k,i)=coeff(k,i)+s(j)*(vecj(k)-tau(j)*veci(k))

      do 1019 k=istart(1,myid+1),iend(1,myid+1)
 1019 coeff(k,j)=coeff(k,j)-s(j)*(veci(k)+tau(j)*vecj(k))

      do 1020 k=istart(1,myid+1),iend(1,myid+1)
 1020 veci(k)=wkmat1(k,i)

      do 1021 k=istart(1,myid+1),iend(1,myid+1)
 1021 vecj(k)=wkmat1(k,j)

      do 1022 k=istart(1,myid+1),iend(1,myid+1)
 1022 wkmat1(k,i)=wkmat1(k,i)+s(j)*(vecj(k)-tau(j)*veci(k))

      do 1023 k=istart(1,myid+1),iend(1,myid+1)
 1023 wkmat1(k,j)=wkmat1(k,j)-s(j)*(veci(k)+tau(j)*vecj(k))

 1008 continue

      call mpi_bsend(f_ij_max,1,mpi_real8,0,0,mpi_comm_world,ierr)

      if(myid.eq.0) then

              f_ij_max_all=zero

              do 1024 i=0,numprocs-1
              call mpi_recv(f_ij_max,1,mpi_real8,i,
     &                      mpi_any_tag,mpi_comm_world,istat,ierror)
 1024         if(f_ij_max.gt.f_ij_max_all) f_ij_max_all=f_ij_max

                    endif

      call mpi_bcast(f_ij_max_all,1,mpi_real8,0,mpi_comm_world,ierr)

      if(f_ij_max_all.lt.tolerance) goto 1025

      if((loop.eq.loopmax).and.(myid.eq.0)) write(6,1026) f_ij_max
 1026 format(/,' annihilation routine did not fully converge,',/,
     &         ' maximum value = ', f17.13,/,
     &         ' (do not worry unless this is the final iteration)')

 1007 continue

 1025 continue

      do 1027 n=1,numprocs
      do 1027 j=1,ncontractions
      nloop=iend(1,n)-istart(1,n)+1
 1027 call mpi_bcast(coeff(istart(1,n),j),nloop,
     &               mpi_real8,n-1,mpi_comm_world,ierr)

      do 1028 j=1,ncontractions
      do 1028 i=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
 1028 fockmat(i,j)=fock(ij)

      do 1029 j=1,nocc
      do 1029 i=istart(1,myid+1),iend(1,myid+1)
      wkmat1(i,j)=zero
      do 1029 k=1,ncontractions
 1029 wkmat1(i,j)=wkmat1(i,j)+coeff(k,j)*fockmat(k,i)

      do 1030 j=1,nocc
      do 1030 i=1,nocc
      fockmat(i,j)=zero
      do 1030 k=istart(1,myid+1),iend(1,myid+1)
 1030 fockmat(i,j)=fockmat(i,j)+coeff(k,i)*wkmat1(k,j)

      do 1031 i=1,nocc
      call mpi_reduce(fockmat(1,i),wkmat2(1,i),
     &                nocc,mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
 1031 call mpi_bcast(wkmat2(1,i),nocc,mpi_real8,0,mpi_comm_world,ierr)

      do 1032 i=1,nocc
 1032 if(myid.eq.0) call fastwr(51,wkmat2(1,i),nocc)

      ncntsq=(ncontractions*(ncontractions+1))/2

      do 1033 i=1,ncntsq
 1033 wkvec(i)=zero

      do 1034 i=1,ncontractions
      do 1034 j=1,i
      imax=max(i,j)
      imin=min(i,j)
      ij=((imax*(imax-1))/2)+imin
      temp_value=zero
      do 1035 k=istart(2,myid+1),iend(2,myid+1)
 1035 temp_value=temp_value+coeff(i,k)*coeff(j,k)
      if(i.ne.j) temp_value=two*temp_value
 1034 wkvec(ij)=temp_value

      call mpi_reduce(wkvec,fockmat,ncntsq,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then

              call stringcopy(ncntsq,wkvec,fockmat)

              do 1036 i=1,ncntsq
              difference=abs(wkvec(i)-dmat(i))
              if(difference.gt.dmaxpc) dmaxpc=difference
 1036         dmat(i)=wkvec(i)

                    endif

      call mpi_bcast(dmat,ncntsq,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(dmaxpc,1,mpi_real8,0,mpi_comm_world,ierr)

      return
      end

      subroutine makeuppercase(str,n)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      character str(*)

      character la,lz,ua

      data la,lz,ua/'a','z','A'/

      do 1001 i=1,n
 1001 if((ichar(str(i)).ge.ichar(la)).and.
     &   (ichar(str(i)).le.ichar(lz)))      str(i)=char(ichar(str(i))
     &                                                 +ichar(ua)
     &                                                 -ichar(la))

      return
      end

      function vwnf2(n,x)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension a(3),b(3),c(3),d(3)

      data one,two/1.0d0,2.0d0/

      data a(1),b(1),c(1),d(1)/ 0.0621814d0,3.72744d0,
     &                         12.9352d0,-0.1049800d0/
      data a(2),b(2),c(2),d(2)/ 0.0310907d0,7.06042d0,
     &                         18.0578d0,-0.3250000d0/
      data a(3),b(3),c(3),d(3)/-0.0337737d0,1.13107d0,
     &                         13.0045d0,-0.0047584d0/

      vwnf2=two*a(n)*(one/x-(one+b(n)/(x-d(n)))*x/(x*x+x*b(n)+c(n)))

      return
      end

      subroutine efids(m,n,icontr,inddyy,esp,efix,efiy,efiz,ccx,ccy,
     &                 ccz,g,density,zeta,px,py,pz,pxax,pyay,pzaz,
     &                 base,ss0,ss1,ss2,ps0,ps1,ds0,dscond,c,pxcx,
     &                 pycy,pzcz,u,twozeta,cx,cy,cz,ss3,saxs0,says0,
     &                 sazs0,saxs1,says1,sazs1,saxs2,says2,sazs2,paxs0,
     &                 pays0,pazs0,paxs1,pays1,pazs1,daxs0,days0,dazs0,
     &                 daxscond,dayscond,dazscond)

c  this subroutine written by roger gallant and alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension g(*),density(*),zeta(*),px(*),py(*),pz(*),pxax(*),
     &          pyay(*),pzaz(*),base(*),ss0(*),ss1(*),ss2(*),ps0(n,*),
     &          ps1(n,*),ds0(n,*),dscond(m,*),c(*),pxcx(*),pycy(*),
     &          pzcz(*),u(*),twozeta(*),ss3(*),saxs0(*),says0(*),
     &          sazs0(*),saxs1(*),says1(*),sazs1(*),saxs2(*),says2(*),
     &          sazs2(*),paxs0(n,*),pays0(n,*),pazs0(n,*),paxs1(n,*),
     &          pays1(n,*),pazs1(n,*),cx(*),cy(*),cz(*),daxs0(n,*),
     &          days0(n,*),dazs0(n,*),daxscond(m,*),dayscond(m,*),
     &          dazscond(m,*)

      data zero,half,one,two,pi/0.0d0,0.5d0,
     &                          1.0d0,2.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      twopi=two*pi

      do 1002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1003 i=1,n
      call augg(4,u(i),g)
      ss0(i)=base(i)*g(1)*twopi/zeta(i)
      ss1(i)=base(i)*g(2)*twopi/zeta(i)
      ss2(i)=base(i)*g(3)*twopi/zeta(i)
 1003 ss3(i)=base(i)*g(4)*twopi/zeta(i)

      do 1004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

 1004 continue

      do 1005 i=1,n
 1005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1007 i=1,n

      saxs0(i)=twozeta(i)*pxcx(i)*ss1(i)
      says0(i)=twozeta(i)*pycy(i)*ss1(i)
      sazs0(i)=twozeta(i)*pzcz(i)*ss1(i)

      saxs1(i)=twozeta(i)*pxcx(i)*ss2(i)
      says1(i)=twozeta(i)*pycy(i)*ss2(i)
      sazs1(i)=twozeta(i)*pzcz(i)*ss2(i)

      saxs2(i)=twozeta(i)*pxcx(i)*ss3(i)
      says2(i)=twozeta(i)*pycy(i)*ss3(i)
      sazs2(i)=twozeta(i)*pzcz(i)*ss3(i)

 1007 continue

      do 1008 i=1,n

      paxs0(i,1)=pxax(i)*saxs0(i)-pxcx(i)*saxs1(i)+ss1(i)
      paxs0(i,2)=pyay(i)*saxs0(i)-pycy(i)*saxs1(i)
      paxs0(i,3)=pzaz(i)*saxs0(i)-pzcz(i)*saxs1(i)
      pays0(i,1)=pxax(i)*says0(i)-pxcx(i)*says1(i)
      pays0(i,2)=pyay(i)*says0(i)-pycy(i)*says1(i)+ss1(i)
      pays0(i,3)=pzaz(i)*says0(i)-pzcz(i)*says1(i)
      pazs0(i,1)=pxax(i)*sazs0(i)-pxcx(i)*sazs1(i)
      pazs0(i,2)=pyay(i)*sazs0(i)-pycy(i)*sazs1(i)
      pazs0(i,3)=pzaz(i)*sazs0(i)-pzcz(i)*sazs1(i)+ss1(i)

      paxs1(i,1)=pxax(i)*saxs1(i)-pxcx(i)*saxs2(i)+ss2(i)
      paxs1(i,2)=pyay(i)*saxs1(i)-pycy(i)*saxs2(i)
      paxs1(i,3)=pzaz(i)*saxs1(i)-pzcz(i)*saxs2(i)
      pays1(i,1)=pxax(i)*says1(i)-pxcx(i)*says2(i)
      pays1(i,2)=pyay(i)*says1(i)-pycy(i)*says2(i)+ss2(i)
      pays1(i,3)=pzaz(i)*says1(i)-pzcz(i)*says2(i)
      pazs1(i,1)=pxax(i)*sazs1(i)-pxcx(i)*sazs2(i)
      pazs1(i,2)=pyay(i)*sazs1(i)-pycy(i)*sazs2(i)
      pazs1(i,3)=pzaz(i)*sazs1(i)-pzcz(i)*sazs2(i)+ss2(i)

 1008 continue

      do 1009 i=1,n
      cx(i)=(saxs0(i)-saxs1(i))/twozeta(i)
      cy(i)=(says0(i)-says1(i))/twozeta(i)
 1009 cz(i)=(sazs0(i)-sazs1(i))/twozeta(i)

      do 1010 i=1,n
      daxs0(i,1)=pxax(i)*paxs0(i,1)-pxcx(i)*paxs1(i,1)+cx(i)+ps1(i,1)
      daxs0(i,2)=pyay(i)*paxs0(i,1)-pycy(i)*paxs1(i,1)
      daxs0(i,3)=pzaz(i)*paxs0(i,1)-pzcz(i)*paxs1(i,1)
      daxs0(i,4)=pyay(i)*paxs0(i,2)-pycy(i)*paxs1(i,2)+cx(i)
      daxs0(i,5)=pzaz(i)*paxs0(i,2)-pzcz(i)*paxs1(i,2)
      daxs0(i,6)=pzaz(i)*paxs0(i,3)-pzcz(i)*paxs1(i,3)+cx(i)
      days0(i,1)=pxax(i)*pays0(i,1)-pxcx(i)*pays1(i,1)+cy(i)
      days0(i,2)=pyay(i)*pays0(i,1)-pycy(i)*pays1(i,1)      +ps1(i,1)
      days0(i,3)=pzaz(i)*pays0(i,1)-pzcz(i)*pays1(i,1)
      days0(i,4)=pyay(i)*pays0(i,2)-pycy(i)*pays1(i,2)+cy(i)+ps1(i,2)
      days0(i,5)=pzaz(i)*pays0(i,2)-pzcz(i)*pays1(i,2)
      days0(i,6)=pzaz(i)*pays0(i,3)-pzcz(i)*pays1(i,3)+cy(i)
      dazs0(i,1)=pxax(i)*pazs0(i,1)-pxcx(i)*pazs1(i,1)+cz(i)
      dazs0(i,2)=pyay(i)*pazs0(i,1)-pycy(i)*pazs1(i,1)
      dazs0(i,3)=pzaz(i)*pazs0(i,1)-pzcz(i)*pazs1(i,1)      +ps1(i,1)
      dazs0(i,4)=pyay(i)*pazs0(i,2)-pycy(i)*pazs1(i,2)+cz(i)
      dazs0(i,5)=pzaz(i)*pazs0(i,2)-pzcz(i)*pazs1(i,2)      +ps1(i,2)
 1010 dazs0(i,6)=pzaz(i)*pazs0(i,3)-pzcz(i)*pazs1(i,3)+cz(i)+ps1(i,3)

      do 1011 j=1,6
      do 1011 i=1,m
 1011 dscond(i,j)=zero

      do 1012 j=1,6
      do 1012 i=1,n
 1012 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)

      do 1013 j=1,6
      do 1013 i=1,m
      daxscond(i,j)=zero
      dayscond(i,j)=zero
 1013 dazscond(i,j)=zero

      do 1014 j=1,6
      do 1014 i=1,n
      daxscond(icontr(i),j)=daxscond(icontr(i),j)+daxs0(i,j)
      dayscond(icontr(i),j)=dayscond(icontr(i),j)+days0(i,j)
 1014 dazscond(icontr(i),j)=dazscond(icontr(i),j)+dazs0(i,j)

      do 1015 j=1,6
      do 1015 i=1,m
 1015 esp=esp-density(inddyy(i,j))*dscond(i,j)

      do 1016 j=1,6
      do 1016 i=1,m
      efix=efix-density(inddyy(i,j))*daxscond(i,j)
      efiy=efiy-density(inddyy(i,j))*dayscond(i,j)
 1016 efiz=efiz-density(inddyy(i,j))*dazscond(i,j)

      return
      end

      subroutine parser(nwords,ncharacters,parsed_word,char_string)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      character char_string*79

      character*32 parsed_word(*)

      dimension ncharacters(*)

      nwords=0

      n=1

      read(5,1001) char_string
 1001 format(a78)

      char_string(79:79)=' '

      do 1002 i=1,40
      do 1002 j=1,32
 1002 parsed_word(i)(j:j)=' '

 1003 if(char_string(n:n).eq.' ') then
                                        n=n+1
                                        goto 1003
                                  endif

      if(n.gt.78) return

      nwords=nwords+1

      nn=n

 1004 if(char_string(n:n).ne.' ') then

          n=n+1
          goto 1004

                                  else

          ncharacters(nwords)=n-nn
          parsed_word(nwords)(1:ncharacters(nwords))=char_string(nn:n-1)
          call makeuppercase(parsed_word(nwords),ncharacters(nwords))

                                  endif

      if(n.gt.78) return

      goto 1003

      end

      subroutine gradovss(ndim,m,n,icontr,inddyy,icentr,density,overlap,
     &                    gradient,zeta,twozetaa,eta,eta2,base,etarr,
     &                    pxax,pyay,pzaz,ss,ps,pscond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(*),icentr(m,*)

      dimension density(*),overlap(ndim,*),gradient(3,*),zeta(*),
     &          twozetaa(*),eta(*),eta2(*),base(*),etarr(*),pxax(*),
     &          pyay(*),pzaz(*),ss(*),ps(n,*),pscond(m,*),grad(m,*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 ss(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1002 i=1,n
      ps(i,1)=pxax(i)*ss(i)
      ps(i,2)=pyay(i)*ss(i)
 1002 ps(i,3)=pzaz(i)*ss(i)

      do 1003 j=1,3
      do 1003 i=1,m
 1003 pscond(i,j)=zero

      do 1004 j=1,3
      do 1004 i=1,n
 1004 pscond(icontr(i),j)=pscond(icontr(i),j)+ps(i,j)*twozetaa(i)

      do 1005 j=1,3
      do 1005 i=1,m
 1005 overlap(inddyy(i),j)=overlap(inddyy(i),j)+pscond(i,j)

      do 1006 i=1,n
 1006 ss(i)=eta(i)*(three-two*etarr(i))*ss(i)

      do 1007 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps(i,2)
 1007 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps(i,3)

      do 1008 j=1,3
      do 1008 i=1,m
 1008 pscond(i,j)=zero

      do 1009 j=1,3
      do 1009 i=1,n
 1009 pscond(icontr(i),j)=pscond(icontr(i),j)+ps(i,j)*twozetaa(i)

      do 1010 j=1,3
      do 1010 i=1,m
 1010 grad(i,j)=pscond(i,j)*density(inddyy(i))

      do 1011 j=1,3
      do 1011 i=1,m
 1011 gradient(j,icentr(i,1))=gradient(j,icentr(i,1))+grad(i,j)

      do 1012 j=1,3
      do 1012 i=1,m
 1012 gradient(j,icentr(i,2))=gradient(j,icentr(i,2))-grad(i,j)

      return
      end

      subroutine points(npts,radius,rweight,center,gridpoint,weight)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xcoord(194),ycoord(194),zcoord(194)

      dimension center(*),gridpoint(3,*),weight(*)

      if(npts.eq.12) call ang12(xcoord,ycoord,zcoord,weight)
      if(npts.eq.26) call ang26(xcoord,ycoord,zcoord,weight)
      if(npts.eq.50) call ang50(xcoord,ycoord,zcoord,weight)
      if(npts.eq.110) call ang110(xcoord,ycoord,zcoord,weight)
      if(npts.eq.194) call ang194(xcoord,ycoord,zcoord,weight)

      do 1001 i=1,npts
      gridpoint(1,i)=xcoord(i)*radius
      gridpoint(2,i)=ycoord(i)*radius
 1001 gridpoint(3,i)=zcoord(i)*radius

      do 1002 i=1,npts
 1002 weight(i)=weight(i)*rweight

      do 1003 i=1,npts
      do 1003 j=1,3
 1003 gridpoint(j,i)=gridpoint(j,i)+center(j)

      return
      end

      function dang(x,y,z)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension x(*),y(*),z(*)

      data dmtwo,dneg,dpos/-2.0d0,-1.0d0,1.0d0/

      d12=dist(x,y)
      d13=dist(x,z)
      d23=dist(y,z)

      bangle=(d13*d13-d12*d12-d23*d23)/dmtwo/d12/d23

      if(bangle.gt.dpos) bangle=dpos
      if(bangle.lt.dneg) bangle=dneg

      dang=acos(bangle)

      return
      end

      subroutine xvecps(m,n,nxcs,nxcspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,coord,dmat,vvector,alphaaux,
     &                  coeffs,coeffp,coeffd,zeta,ax,ay,az,px,py,pz,
     &                  base,zetarec,zetafac,efac,gxax,gyay,gzaz,sss,
     &                  pss,psscond,dss,dsscond,fss,fsscond,psp,dsp,psd,
     &                  c,c1,zzeta,aax,aay,aaz,ppx,ppy,ppz,axcx,aycy,
     &                  azcz,gather)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(m,*),
     &          iloc(*)

      dimension coord(3,*),dmat(*),vvector(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),zeta(*),ax(*),ay(*),az(*),px(*),
     &          py(*),pz(*),base(*),zetarec(*),zetafac(*),efac(*),
     &          gxax(*),gyay(*),gzaz(*),sss(*),pss(n,*),psscond(n,*),
     &          dss(n,*),dsscond(n,*),fss(n,*),fsscond(n,*),psp(n,*),
     &          dsp(n,*),psd(n,*),c(*),c1(n,*),zzeta(*),aax(*),aay(*),
     &          aaz(*),ppx(*),ppy(*),ppz(*),axcx(*),aycy(*),azcz(*),
     &          gather(n,*)

      data zero,one,two,three/0.0d0,1.0d0,2.0d0,3.0d0/
      data expcut,calcut,pi/45.0d0,1.0d-16,3.1415926535898d0/

      thrhlf=three/two

      sqrt3=sqrt(three)

      do 1000 i=1,n
 1000 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1001 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      do 1002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      sss(i)=zero
 1004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 1005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 1005 continue

      do 1006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 1006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 1007 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 1007 pss(i,3)=gzaz(i)*sss(i)

      do 1008 i=1,nn
 1008 gather(i,1)=zero

      do 1009 j=1,3
      do 1009 i=1,nn
 1009 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pss(i,j)

      do 1010 i=1,nn
 1010 gather(i,1)=gather(i,1)*xcfits

      do 1011 i=1,nn
 1011 vvector(naux)=vvector(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      xcfitp(1)=coeffp(ilaux)
      xcfitp(2)=coeffp(ilaux)
      xcfitp(3)=coeffp(ilaux)

      xcfitd(1)=coeffd(ilaux)/sqrt3
      xcfitd(2)=coeffd(ilaux)
      xcfitd(3)=coeffd(ilaux)
      xcfitd(4)=coeffd(ilaux)/sqrt3
      xcfitd(5)=coeffd(ilaux)
      xcfitd(6)=coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,nn
 2010 c1(i,j)=zetarec(i)*pss(i,j)

      do 2011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 2011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 2012 i=1,nn
      psp(i,1)=axcx(i)*pss(i,1)+dss(i,1)
      psp(i,2)=aycy(i)*pss(i,1)+dss(i,2)
      psp(i,3)=azcz(i)*pss(i,1)+dss(i,3)
      psp(i,4)=axcx(i)*pss(i,2)+dss(i,2)
      psp(i,5)=aycy(i)*pss(i,2)+dss(i,4)
      psp(i,6)=azcz(i)*pss(i,2)+dss(i,5)
      psp(i,7)=axcx(i)*pss(i,3)+dss(i,3)
      psp(i,8)=aycy(i)*pss(i,3)+dss(i,5)
 2012 psp(i,9)=azcz(i)*pss(i,3)+dss(i,6)

      do 2013 i=1,nn
      dsp(i,01)=axcx(i)*dss(i,1)+fss(i,01)
      dsp(i,02)=aycy(i)*dss(i,1)+fss(i,02)
      dsp(i,03)=azcz(i)*dss(i,1)+fss(i,03)
      dsp(i,04)=axcx(i)*dss(i,2)+fss(i,02)
      dsp(i,05)=aycy(i)*dss(i,2)+fss(i,04)
      dsp(i,06)=azcz(i)*dss(i,2)+fss(i,05)
      dsp(i,07)=axcx(i)*dss(i,3)+fss(i,03)
      dsp(i,08)=aycy(i)*dss(i,3)+fss(i,05)
      dsp(i,09)=azcz(i)*dss(i,3)+fss(i,06)
      dsp(i,10)=axcx(i)*dss(i,4)+fss(i,04)
      dsp(i,11)=aycy(i)*dss(i,4)+fss(i,07)
      dsp(i,12)=azcz(i)*dss(i,4)+fss(i,08)
      dsp(i,13)=axcx(i)*dss(i,5)+fss(i,05)
      dsp(i,14)=aycy(i)*dss(i,5)+fss(i,08)
      dsp(i,15)=azcz(i)*dss(i,5)+fss(i,09)
      dsp(i,16)=axcx(i)*dss(i,6)+fss(i,06)
      dsp(i,17)=aycy(i)*dss(i,6)+fss(i,09)
 2013 dsp(i,18)=azcz(i)*dss(i,6)+fss(i,10)

      do 2014 i=1,nn
      psd(i,01)=axcx(i)*psp(i,1)+dsp(i,01)
      psd(i,02)=aycy(i)*psp(i,1)+dsp(i,04)
      psd(i,03)=azcz(i)*psp(i,1)+dsp(i,07)
      psd(i,04)=aycy(i)*psp(i,2)+dsp(i,05)
      psd(i,05)=azcz(i)*psp(i,2)+dsp(i,08)
      psd(i,06)=azcz(i)*psp(i,3)+dsp(i,09)
      psd(i,07)=axcx(i)*psp(i,4)+dsp(i,04)
      psd(i,08)=aycy(i)*psp(i,4)+dsp(i,10)
      psd(i,09)=azcz(i)*psp(i,4)+dsp(i,13)
      psd(i,10)=aycy(i)*psp(i,5)+dsp(i,11)
      psd(i,11)=azcz(i)*psp(i,5)+dsp(i,14)
      psd(i,12)=azcz(i)*psp(i,6)+dsp(i,15)
      psd(i,13)=axcx(i)*psp(i,7)+dsp(i,07)
      psd(i,14)=aycy(i)*psp(i,7)+dsp(i,13)
      psd(i,15)=azcz(i)*psp(i,7)+dsp(i,16)
      psd(i,16)=aycy(i)*psp(i,8)+dsp(i,14)
      psd(i,17)=azcz(i)*psp(i,8)+dsp(i,17)
 2014 psd(i,18)=azcz(i)*psp(i,9)+dsp(i,18)

      do 2015 j=1,10
      do 2015 i=1,nn
 2015 gather(i,j)=zero

      do 2016 j=1,3
      do 2016 i=1,nn
 2016 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*pss(i,j)

      do 2017 k=1,3
      do 2017 j=1,3
      do 2017 i=1,nn
 2017 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*psp(i,3*(j-1)+k)

      do 2018 k=1,6
      do 2018 j=1,3
      do 2018 i=1,nn
 2018 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*psd(i,6*(j-1)+k)

      do 2019 i=1,nn
      gather(i,01)=gather(i,01)*xcfits
      gather(i,02)=gather(i,02)*xcfitp(1)
      gather(i,03)=gather(i,03)*xcfitp(2)
      gather(i,04)=gather(i,04)*xcfitp(3)
      gather(i,05)=gather(i,05)*xcfitd(1)
      gather(i,06)=gather(i,06)*xcfitd(2)
      gather(i,07)=gather(i,07)*xcfitd(3)
      gather(i,08)=gather(i,08)*xcfitd(4)
      gather(i,09)=gather(i,09)*xcfitd(5)
 2019 gather(i,10)=gather(i,10)*xcfitd(6)

      nc=nxcs+(naux-1)*10

      do 2020 i=1,nn
      do 2020 j=1,10
 2020 vvector(nc+j)=vvector(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine setupcddd(m,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &                     icentvc,iminj,icontr,inddyy,cutoff,coord,
     &                     alpha,coeff,zeta,zetaa,zetab,aax,aay,aaz,eta,
     &                     etarr,base,px,py,pz,pxax,pyay,pzaz,pxbx,pyby,
     &                     pzbz,axbx,ayby,azbz,buffer,density)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension nsheld(*),mtloca(*),iprimvc(*),nprimvc(*),icentvc(*),
     &          iminj(*),icontr(*),inddyy(m,*)

      dimension coord(3,*),alpha(*),coeff(*),zeta(*),zetaa(*),zetab(*),
     &          aax(*),aay(*),aaz(*),eta(*),etarr(*),base(*),px(*),
     &          py(*),pz(*),pxax(*),pyay(*),pzaz(*),pxbx(*),pyby(*),
     &          pzbz(*),axbx(*),ayby(*),azbz(*),buffer(*),density(*)

      data zero,expcut,tolerance/0.0d0,60.0d0,0.00000000000000000001d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      n=0

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=ncontd-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(isent+1,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(iloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1002 i=iloop,iloop+nloop-1
      do 1002 j=1,i

      icnptr=(i*(i-1)/2)+j

      iminj(icnptr)=i-j

      nconta=nsheld(i)
      ncontb=nsheld(j)

      matlca=mtloca(nconta)
      matlcb=mtloca(ncontb)

      i1=matlca
      i2=(i1*(i1-1))/2
      i3=matlcb
      i4=i2+i3

      inddyy(icnptr,01)=i4
      inddyy(icnptr,02)=i4+1
      inddyy(icnptr,03)=i4+2
      inddyy(icnptr,04)=i4+3
      inddyy(icnptr,05)=i4+4
      inddyy(icnptr,06)=i4+5
      inddyy(icnptr,07)=i4+i1
      inddyy(icnptr,08)=i4+i1+1
      inddyy(icnptr,09)=i4+i1+2
      inddyy(icnptr,10)=i4+i1+3
      inddyy(icnptr,11)=i4+i1+4
      inddyy(icnptr,12)=i4+i1+5
      inddyy(icnptr,13)=i4+i1*2+1
      inddyy(icnptr,14)=i4+i1*2+2
      inddyy(icnptr,15)=i4+i1*2+3
      inddyy(icnptr,16)=i4+i1*2+4
      inddyy(icnptr,17)=i4+i1*2+5
      inddyy(icnptr,18)=i4+i1*2+6
      inddyy(icnptr,19)=i4+i1*3+3
      inddyy(icnptr,20)=i4+i1*3+4
      inddyy(icnptr,21)=i4+i1*3+5
      inddyy(icnptr,22)=i4+i1*3+6
      inddyy(icnptr,23)=i4+i1*3+7
      inddyy(icnptr,24)=i4+i1*3+8
      inddyy(icnptr,25)=i4+i1*4+6
      inddyy(icnptr,26)=i4+i1*4+7
      inddyy(icnptr,27)=i4+i1*4+8
      inddyy(icnptr,28)=i4+i1*4+9
      inddyy(icnptr,29)=i4+i1*4+10
      inddyy(icnptr,30)=i4+i1*4+11
      inddyy(icnptr,31)=i4+i1*5+10
      inddyy(icnptr,32)=i4+i1*5+11
      inddyy(icnptr,33)=i4+i1*5+12
      inddyy(icnptr,34)=i4+i1*5+13
      inddyy(icnptr,35)=i4+i1*5+14
      inddyy(icnptr,36)=i4+i1*5+15

      if(i.eq.j) then
                       dmax=max(abs(density(inddyy(icnptr,01))),
     &                          abs(density(inddyy(icnptr,07))),
     &                          abs(density(inddyy(icnptr,08))),
     &                          abs(density(inddyy(icnptr,13))),
     &                          abs(density(inddyy(icnptr,14))),
     &                          abs(density(inddyy(icnptr,15))),
     &                          abs(density(inddyy(icnptr,19))),
     &                          abs(density(inddyy(icnptr,20))),
     &                          abs(density(inddyy(icnptr,21))),
     &                          abs(density(inddyy(icnptr,22))),
     &                          abs(density(inddyy(icnptr,25))),
     &                          abs(density(inddyy(icnptr,26))),
     &                          abs(density(inddyy(icnptr,27))),
     &                          abs(density(inddyy(icnptr,28))),
     &                          abs(density(inddyy(icnptr,29))),
     &                          abs(density(inddyy(icnptr,31))),
     &                          abs(density(inddyy(icnptr,32))),
     &                          abs(density(inddyy(icnptr,33))),
     &                          abs(density(inddyy(icnptr,34))),
     &                          abs(density(inddyy(icnptr,35))),
     &                          abs(density(inddyy(icnptr,36))))

                       if(dmax.lt.tolerance) goto 1002
                 else
                       dmax=max(abs(density(inddyy(icnptr,01))),
     &                          abs(density(inddyy(icnptr,02))),
     &                          abs(density(inddyy(icnptr,03))),
     &                          abs(density(inddyy(icnptr,04))),
     &                          abs(density(inddyy(icnptr,05))),
     &                          abs(density(inddyy(icnptr,06))),
     &                          abs(density(inddyy(icnptr,07))),
     &                          abs(density(inddyy(icnptr,08))),
     &                          abs(density(inddyy(icnptr,09))),
     &                          abs(density(inddyy(icnptr,10))),
     &                          abs(density(inddyy(icnptr,11))),
     &                          abs(density(inddyy(icnptr,12))),
     &                          abs(density(inddyy(icnptr,13))),
     &                          abs(density(inddyy(icnptr,14))),
     &                          abs(density(inddyy(icnptr,15))),
     &                          abs(density(inddyy(icnptr,16))),
     &                          abs(density(inddyy(icnptr,17))),
     &                          abs(density(inddyy(icnptr,18))),
     &                          abs(density(inddyy(icnptr,19))),
     &                          abs(density(inddyy(icnptr,20))),
     &                          abs(density(inddyy(icnptr,21))),
     &                          abs(density(inddyy(icnptr,22))),
     &                          abs(density(inddyy(icnptr,23))),
     &                          abs(density(inddyy(icnptr,24))),
     &                          abs(density(inddyy(icnptr,25))),
     &                          abs(density(inddyy(icnptr,26))),
     &                          abs(density(inddyy(icnptr,27))),
     &                          abs(density(inddyy(icnptr,28))),
     &                          abs(density(inddyy(icnptr,29))),
     &                          abs(density(inddyy(icnptr,30))),
     &                          abs(density(inddyy(icnptr,31))),
     &                          abs(density(inddyy(icnptr,32))),
     &                          abs(density(inddyy(icnptr,33))),
     &                          abs(density(inddyy(icnptr,34))),
     &                          abs(density(inddyy(icnptr,35))),
     &                          abs(density(inddyy(icnptr,36))))

                       if(dmax.lt.tolerance) goto 1002
                 endif

      iprima=iprimvc(nconta)
      iprimb=iprimvc(ncontb)

      nprima=iprima+nprimvc(nconta)-1
      nprimb=iprimb+nprimvc(ncontb)-1

      icenta=icentvc(nconta)
      icentb=icentvc(ncontb)

      ax=coord(1,icenta)
      ay=coord(2,icenta)
      az=coord(3,icenta)

      bx=coord(1,icentb)
      by=coord(2,icentb)
      bz=coord(3,icentb)

      caxbx=ax-bx
      cayby=ay-by
      cazbz=az-bz

      axbx(icnptr)=caxbx
      ayby(icnptr)=cayby
      azbz(icnptr)=cazbz

      rr=caxbx*caxbx+cayby*cayby+cazbz*cazbz

      if(rr.gt.(cutoff**2)) goto 1002

      do 1003 ii=iprima,nprima
      do 1003 jj=iprimb,nprimb

      test=rr*alpha(ii)*alpha(jj)/(alpha(ii)+alpha(jj))

      if(test.lt.expcut) then
                               n=n+1

                               icontr(n)=icnptr

                               zetaa(n)=alpha(ii)
                               zetab(n)=alpha(jj)

                               zeta(n)=zetaa(n)+zetab(n)

                               factor=coeff(ii)*coeff(jj)

                               aax(n)=ax
                               aay(n)=ay
                               aaz(n)=az

                               px(n)=(zetaa(n)*ax+zetab(n)*bx)/zeta(n)
                               py(n)=(zetaa(n)*ay+zetab(n)*by)/zeta(n)
                               pz(n)=(zetaa(n)*az+zetab(n)*bz)/zeta(n)

                               pxax(n)=px(n)-ax
                               pyay(n)=py(n)-ay
                               pzaz(n)=pz(n)-az

                               pxbx(n)=px(n)-bx
                               pyby(n)=py(n)-by
                               pzbz(n)=pz(n)-bz

                               eta(n)=zetaa(n)*zetab(n)/zeta(n)

                               etarr(n)=eta(n)*rr

                               base(n)=factor*exp(-etarr(n))
                         endif
 1003 continue
 1002 continue

      do 1004 i=1,ncontd
      do 1004 j=1,i

      iminj((i*(i-1)/2)+j)=i-j

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      inddyy((i*(i-1)/2)+j,01)=i4
      inddyy((i*(i-1)/2)+j,02)=i4+1
      inddyy((i*(i-1)/2)+j,03)=i4+2
      inddyy((i*(i-1)/2)+j,04)=i4+3
      inddyy((i*(i-1)/2)+j,05)=i4+4
      inddyy((i*(i-1)/2)+j,06)=i4+5
      inddyy((i*(i-1)/2)+j,07)=i4+i1
      inddyy((i*(i-1)/2)+j,08)=i4+i1+1
      inddyy((i*(i-1)/2)+j,09)=i4+i1+2
      inddyy((i*(i-1)/2)+j,10)=i4+i1+3
      inddyy((i*(i-1)/2)+j,11)=i4+i1+4
      inddyy((i*(i-1)/2)+j,12)=i4+i1+5
      inddyy((i*(i-1)/2)+j,13)=i4+i1*2+1
      inddyy((i*(i-1)/2)+j,14)=i4+i1*2+2
      inddyy((i*(i-1)/2)+j,15)=i4+i1*2+3
      inddyy((i*(i-1)/2)+j,16)=i4+i1*2+4
      inddyy((i*(i-1)/2)+j,17)=i4+i1*2+5
      inddyy((i*(i-1)/2)+j,18)=i4+i1*2+6
      inddyy((i*(i-1)/2)+j,19)=i4+i1*3+3
      inddyy((i*(i-1)/2)+j,20)=i4+i1*3+4
      inddyy((i*(i-1)/2)+j,21)=i4+i1*3+5
      inddyy((i*(i-1)/2)+j,22)=i4+i1*3+6
      inddyy((i*(i-1)/2)+j,23)=i4+i1*3+7
      inddyy((i*(i-1)/2)+j,24)=i4+i1*3+8
      inddyy((i*(i-1)/2)+j,25)=i4+i1*4+6
      inddyy((i*(i-1)/2)+j,26)=i4+i1*4+7
      inddyy((i*(i-1)/2)+j,27)=i4+i1*4+8
      inddyy((i*(i-1)/2)+j,28)=i4+i1*4+9
      inddyy((i*(i-1)/2)+j,29)=i4+i1*4+10
      inddyy((i*(i-1)/2)+j,30)=i4+i1*4+11
      inddyy((i*(i-1)/2)+j,31)=i4+i1*5+10
      inddyy((i*(i-1)/2)+j,32)=i4+i1*5+11
      inddyy((i*(i-1)/2)+j,33)=i4+i1*5+12
      inddyy((i*(i-1)/2)+j,34)=i4+i1*5+13
      inddyy((i*(i-1)/2)+j,35)=i4+i1*5+14
      inddyy((i*(i-1)/2)+j,36)=i4+i1*5+15

      icenta=icentvc(nsheld(i))
      icentb=icentvc(nsheld(j))

      icnptr=(i*(i-1)/2)+j

      axbx(icnptr)=coord(1,icenta)-coord(1,icentb)
      ayby(icnptr)=coord(2,icenta)-coord(2,icentb)
 1004 azbz(icnptr)=coord(3,icenta)-coord(3,icentb)

      call mpi_bsend(n,1,mpi_integer,0,01,mpi_comm_world,ierr)

      call mpi_bsend(icontr,n,mpi_integer,0,02,mpi_comm_world,ierr)

      call stringcopy(n,buffer(00*n+1),zeta)
      call stringcopy(n,buffer(01*n+1),base)
      call stringcopy(n,buffer(02*n+1),aax)
      call stringcopy(n,buffer(03*n+1),aay)
      call stringcopy(n,buffer(04*n+1),aaz)
      call stringcopy(n,buffer(05*n+1),px)
      call stringcopy(n,buffer(06*n+1),py)
      call stringcopy(n,buffer(07*n+1),pz)
      call stringcopy(n,buffer(08*n+1),pxax)
      call stringcopy(n,buffer(09*n+1),pyay)
      call stringcopy(n,buffer(10*n+1),pzaz)

      call mpi_bsend(buffer,11*n,mpi_real8,0,03,mpi_comm_world,ierr)

      if(myid.eq.0) then

                    n=0

                    do 1005 i=0,numprocs-1

                    call mpi_recv(nsub,1,mpi_integer,
     &                            i,01,mpi_comm_world,istat,ierr)

                    call mpi_recv(icontr(n+1),nsub,mpi_integer,
     &                            i,02,mpi_comm_world,istat,ierr)

                    call mpi_recv(buffer,11*nsub,mpi_real8,
     &                            i,03,mpi_comm_world,istat,ierr)

                    call stringcopy(nsub,zeta(n+1),buffer(0*nsub+1))
                    call stringcopy(nsub,base(n+1),buffer(1*nsub+1))
                    call stringcopy(nsub,aax(n+1),buffer(2*nsub+1))
                    call stringcopy(nsub,aay(n+1),buffer(3*nsub+1))
                    call stringcopy(nsub,aaz(n+1),buffer(4*nsub+1))
                    call stringcopy(nsub,px(n+1),buffer(5*nsub+1))
                    call stringcopy(nsub,py(n+1),buffer(6*nsub+1))
                    call stringcopy(nsub,pz(n+1),buffer(7*nsub+1))
                    call stringcopy(nsub,pxax(n+1),buffer(08*nsub+1))
                    call stringcopy(nsub,pyay(n+1),buffer(09*nsub+1))
                    call stringcopy(nsub,pzaz(n+1),buffer(10*nsub+1))

                    n=n+nsub

 1005               continue

                    endif

      call mpi_bcast(n,1,mpi_integer,0,mpi_comm_world,ierr)

      return
      end

      subroutine dipoleds(m,n,icontr,inddyy,density,zeta,px,py,pz,pxax,
     &                    pyay,pzaz,base,ss,ps,ds,pso,c,c1,c2,dscond,
     &                    dipole)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension density(*),zeta(*),px(*),py(*),pz(*),pxax(*),pyay(*),
     &          pzaz(*),base(*),ss(n,*),ps(n,*),ds(n,*),pso(n,*),c(*),
     &          c1(n,*),c2(n,*),dscond(m,*),dipole(*)

      data zero,thrhlf,two,pi/0.0d0,1.5d0,2.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      pso(i,1)=pxax(i)*base(i)
      pso(i,2)=pyay(i)*base(i)
 1002 pso(i,3)=pzaz(i)*base(i)

      do 1003 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1003 ss(i,3)=pz(i)*base(i)

      do 1004 i=1,n
 1004 c(i)=base(i)/(two*zeta(i))

      do 1005 i=1,n
      ps(i,1)=pxax(i)*ss(i,1)+c(i)
      ps(i,2)=pxax(i)*ss(i,2)
      ps(i,3)=pxax(i)*ss(i,3)
      ps(i,4)=pyay(i)*ss(i,1)
      ps(i,5)=pyay(i)*ss(i,2)+c(i)
      ps(i,6)=pyay(i)*ss(i,3)
      ps(i,7)=pzaz(i)*ss(i,1)
      ps(i,8)=pzaz(i)*ss(i,2)
 1005 ps(i,9)=pzaz(i)*ss(i,3)+c(i)

      do 1006 j=1,3
      do 1006 i=1,n
 1006 c1(i,j)=ss(i,j)/(two*zeta(i))

      do 1007 j=1,3
      do 1007 i=1,n
 1007 c2(i,j)=pso(i,j)/(two*zeta(i))

      do 1008 i=1,n
      ds(i,01)=pxax(i)*ps(i,1)+c1(i,1)+c2(i,1)
      ds(i,02)=pxax(i)*ps(i,2)+c1(i,2)
      ds(i,03)=pxax(i)*ps(i,3)+c1(i,3)
      ds(i,04)=pyay(i)*ps(i,1)
      ds(i,05)=pyay(i)*ps(i,2)        +c2(i,1)
      ds(i,06)=pyay(i)*ps(i,3)
      ds(i,07)=pzaz(i)*ps(i,1)
      ds(i,08)=pzaz(i)*ps(i,2)
      ds(i,09)=pzaz(i)*ps(i,3)        +c2(i,1)
      ds(i,10)=pyay(i)*ps(i,4)+c1(i,1)
      ds(i,11)=pyay(i)*ps(i,5)+c1(i,2)+c2(i,2)
      ds(i,12)=pyay(i)*ps(i,6)+c1(i,3)
      ds(i,13)=pzaz(i)*ps(i,4)
      ds(i,14)=pzaz(i)*ps(i,5)
      ds(i,15)=pzaz(i)*ps(i,6)        +c2(i,2)
      ds(i,16)=pzaz(i)*ps(i,7)+c1(i,1)
      ds(i,17)=pzaz(i)*ps(i,8)+c1(i,2)
 1008 ds(i,18)=pzaz(i)*ps(i,9)+c1(i,3)+c2(i,3)

      do 1009 j=1,18
      do 1009 i=1,m
 1009 dscond(i,j)=zero

      do 1010 j=1,18
      do 1010 i=1,n
 1010 dscond(icontr(i),j)=dscond(icontr(i),j)+ds(i,j)

      do 1011 k=1,6
      do 1011 j=1,3
      do 1011 i=1,m
 1011 dipole(j)=dipole(j)-density(inddyy(i,k))*dscond(i,3*(k-1)+j)

      return
      end

      subroutine stringcopy(n,a,b)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension a(*),b(*)

      do 1001 i=1,n
 1001 a(i)=b(i)

      return
      end

      subroutine compg1(iatom,ncntrt,npts,nd,natoms,nconts,ncontp,
     &                  ncontd,ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,
     &                  radius,cent,alpha,coeff,x,y,z,qf,qx,qy,qz,
     &                  extent1,extent3,dcc,xx,yy,zz,rr,rralpha,s,px,py,
     &                  pz,dxx,dxy,dxz,dyy,dyz,dzz,fxxx,fxxy,fxxz,fxyy,
     &                  fxyz,fxzz,fyyy,fyyz,fyzz,fzzz)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)

      dimension cent(3,*),alpha(*),coeff(*)

      dimension x(*),y(*),z(*),qf(nd,*),qx(nd,*),qy(nd,*),qz(nd,*)

      dimension extent1(*),extent3(*),dcc(natoms,*)
      dimension xx(*),yy(*),zz(*),rr(*),rralpha(*)
      dimension s(*),px(*),py(*),pz(*)
      dimension dxx(*),dxy(*),dxz(*),dyy(*),dyz(*),dzz(*)
      dimension fxxx(*),fxxy(*),fxxz(*),fxyy(*),fxyz(*),
     &          fxzz(*),fyyy(*),fyyz(*),fyzz(*),fzzz(*)

      data zero,one,two,three,five,expcut/0.0d0,1.0d0,2.0d0,
     &                                    3.0d0,5.0d0,50.0d0/

      rsqrt3=one/sqrt(three)

      do 1001 i=1,ncntrt
 1001 extent3(i)=zero

      k=0

      if(nconts.eq.0) return

      do 1002 i=1,nconts

      ilabel=nptrs(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(i)) goto 1002

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1003 j=1,npts
      qf(j,k+1)=zero
      qx(j,k+1)=zero
      qy(j,k+1)=zero
 1003 qz(j,k+1)=zero

      do 1004 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1004 zz(j)=z(j)-cent(3,nc)

      do 1005 j=1,npts
 1005 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1006 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1007 j=1,npts
 1007 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1008 j=1,npts
      if(rralpha(j).lt.expcut) then

                               s(j)=coeff(nprimitive)*exp(-rralpha(j))

                               qf(j,k+1)=qf(j,k+1)+s(j)

                               s(j)=s(j)*twozeta

                               px(j)=xx(j)*s(j)
                               py(j)=yy(j)*s(j)
                               pz(j)=zz(j)*s(j)

                               qx(j,k+1)=qx(j,k+1)-px(j)
                               qy(j,k+1)=qy(j,k+1)-py(j)
                               qz(j,k+1)=qz(j,k+1)-pz(j)

                               endif
 1008 continue

 1006 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)

 1002 k=k+1

      if(ncontp.eq.0) return

      do 1009 i=1,ncontp

      ilabel=nptrp(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(nconts+i)) goto 1009

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1010 j=1,npts
      qf(j,k+1)=zero
      qx(j,k+1)=zero
      qy(j,k+1)=zero
      qz(j,k+1)=zero
      qf(j,k+2)=zero
      qx(j,k+2)=zero
      qy(j,k+2)=zero
      qz(j,k+2)=zero
      qf(j,k+3)=zero
      qx(j,k+3)=zero
      qy(j,k+3)=zero
 1010 qz(j,k+3)=zero

      do 1011 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1011 zz(j)=z(j)-cent(3,nc)

      do 1012 j=1,npts
 1012 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1013 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1014 j=1,npts
 1014 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1015 j=1,npts
      if(rralpha(j).lt.expcut) then

                               s(j)=coeff(nprimitive)*exp(-rralpha(j))

                               px(j)=xx(j)*s(j)
                               py(j)=yy(j)*s(j)
                               pz(j)=zz(j)*s(j)

                               qf(j,k+1)=qf(j,k+1)+px(j)
                               qf(j,k+2)=qf(j,k+2)+py(j)
                               qf(j,k+3)=qf(j,k+3)+pz(j)

                               px(j)=px(j)*twozeta
                               py(j)=py(j)*twozeta
                               pz(j)=pz(j)*twozeta

                               dxx(j)=xx(j)*px(j)
                               dxy(j)=xx(j)*py(j)
                               dxz(j)=xx(j)*pz(j)
                               dyy(j)=yy(j)*py(j)
                               dyz(j)=yy(j)*pz(j)
                               dzz(j)=zz(j)*pz(j)

                               qx(j,k+1)=qx(j,k+1)-dxx(j)+s(j)
                               qy(j,k+1)=qy(j,k+1)-dxy(j)
                               qz(j,k+1)=qz(j,k+1)-dxz(j)

                               qx(j,k+2)=qx(j,k+2)-dxy(j)
                               qy(j,k+2)=qy(j,k+2)-dyy(j)+s(j)
                               qz(j,k+2)=qz(j,k+2)-dyz(j)

                               qx(j,k+3)=qx(j,k+3)-dxz(j)
                               qy(j,k+3)=qy(j,k+3)-dyz(j)
                               qz(j,k+3)=qz(j,k+3)-dzz(j)+s(j)

                               endif
 1015 continue

 1013 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,qf(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,qf(1,k+3))/real64(npts)

 1009 k=k+3

      if(ncontd.eq.0) return

      do 1016 i=1,ncontd

      ilabel=nptrd(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(nconts+ncontp+i)) goto 1016

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1017 j=1,npts
      qf(j,k+1)=zero
      qx(j,k+1)=zero
      qy(j,k+1)=zero
      qz(j,k+1)=zero
      qf(j,k+2)=zero
      qx(j,k+2)=zero
      qy(j,k+2)=zero
      qz(j,k+2)=zero
      qf(j,k+3)=zero
      qx(j,k+3)=zero
      qy(j,k+3)=zero
      qz(j,k+3)=zero
      qf(j,k+4)=zero
      qx(j,k+4)=zero
      qy(j,k+4)=zero
      qz(j,k+4)=zero
      qf(j,k+5)=zero
      qx(j,k+5)=zero
      qy(j,k+5)=zero
      qz(j,k+5)=zero
      qf(j,k+6)=zero
      qx(j,k+6)=zero
      qy(j,k+6)=zero
 1017 qz(j,k+6)=zero

      do 1018 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1018 zz(j)=z(j)-cent(3,nc)

      do 1019 j=1,npts
 1019 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1020 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1021 j=1,npts
 1021 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1022 j=1,npts
      if(rralpha(j).lt.expcut) then

                               s(j)=coeff(nprimitive)*exp(-rralpha(j))

                               px(j)=xx(j)*s(j)
                               py(j)=yy(j)*s(j)
                               pz(j)=zz(j)*s(j)

                               dxx(j)=xx(j)*px(j)
                               dxy(j)=xx(j)*py(j)
                               dxz(j)=xx(j)*pz(j)
                               dyy(j)=yy(j)*py(j)
                               dyz(j)=yy(j)*pz(j)
                               dzz(j)=zz(j)*pz(j)

                               qf(j,k+1)=qf(j,k+1)+dxx(j)
                               qf(j,k+2)=qf(j,k+2)+dxy(j)
                               qf(j,k+3)=qf(j,k+3)+dxz(j)
                               qf(j,k+4)=qf(j,k+4)+dyy(j)
                               qf(j,k+5)=qf(j,k+5)+dyz(j)
                               qf(j,k+6)=qf(j,k+6)+dzz(j)

                               dxx(j)=dxx(j)*twozeta
                               dxy(j)=dxy(j)*twozeta
                               dxz(j)=dxz(j)*twozeta
                               dyy(j)=dyy(j)*twozeta
                               dyz(j)=dyz(j)*twozeta
                               dzz(j)=dzz(j)*twozeta

                               fxxx(j)=xx(j)*dxx(j)
                               fxxy(j)=xx(j)*dxy(j)
                               fxxz(j)=xx(j)*dxz(j)
                               fxyy(j)=xx(j)*dyy(j)
                               fxyz(j)=xx(j)*dyz(j)
                               fxzz(j)=xx(j)*dzz(j)
                               fyyy(j)=yy(j)*dyy(j)
                               fyyz(j)=yy(j)*dyz(j)
                               fyzz(j)=yy(j)*dzz(j)
                               fzzz(j)=zz(j)*dzz(j)

                               qx(j,k+1)=qx(j,k+1)-fxxx(j)+px(j)+px(j)
                               qy(j,k+1)=qy(j,k+1)-fxxy(j)
                               qz(j,k+1)=qz(j,k+1)-fxxz(j)

                               qx(j,k+2)=qx(j,k+2)-fxxy(j)+py(j)
                               qy(j,k+2)=qy(j,k+2)-fxyy(j)+px(j)
                               qz(j,k+2)=qz(j,k+2)-fxyz(j)

                               qx(j,k+3)=qx(j,k+3)-fxxz(j)+pz(j)
                               qy(j,k+3)=qy(j,k+3)-fxyz(j)
                               qz(j,k+3)=qz(j,k+3)-fxzz(j)+px(j)

                               qx(j,k+4)=qx(j,k+4)-fxyy(j)
                               qy(j,k+4)=qy(j,k+4)-fyyy(j)+py(j)+py(j)
                               qz(j,k+4)=qz(j,k+4)-fyyz(j)

                               qx(j,k+5)=qx(j,k+5)-fxyz(j)
                               qy(j,k+5)=qy(j,k+5)-fyyz(j)+pz(j)
                               qz(j,k+5)=qz(j,k+5)-fyzz(j)+py(j)

                               qx(j,k+6)=qx(j,k+6)-fxzz(j)
                               qy(j,k+6)=qy(j,k+6)-fyzz(j)
                               qz(j,k+6)=qz(j,k+6)-fzzz(j)+pz(j)+pz(j)

                               endif
 1022 continue

 1020 continue

      do 1023 j=1,npts

      qf(j,k+1)=qf(j,k+1)*rsqrt3
      qf(j,k+4)=qf(j,k+4)*rsqrt3
      qf(j,k+6)=qf(j,k+6)*rsqrt3

      qx(j,k+1)=qx(j,k+1)*rsqrt3
      qy(j,k+1)=qy(j,k+1)*rsqrt3
      qz(j,k+1)=qz(j,k+1)*rsqrt3

      qx(j,k+4)=qx(j,k+4)*rsqrt3
      qy(j,k+4)=qy(j,k+4)*rsqrt3
      qz(j,k+4)=qz(j,k+4)*rsqrt3

      qx(j,k+6)=qx(j,k+6)*rsqrt3
      qy(j,k+6)=qy(j,k+6)*rsqrt3
      qz(j,k+6)=qz(j,k+6)*rsqrt3

 1023 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,qf(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,qf(1,k+3))/real64(npts)
      extent3(k+4)=sumsum(npts,qf(1,k+4))/real64(npts)
      extent3(k+5)=sumsum(npts,qf(1,k+5))/real64(npts)
      extent3(k+6)=sumsum(npts,qf(1,k+6))/real64(npts)

 1016 k=k+6

      return
      end

      subroutine mespgen(nreal,ninteger,iptsflag,natoms,nesppts,
     &                   ncontacts,nauxiliary,level,ncenters,nbsystems,
     &                   nequivnb,nbneutrals,nalpha,nbeta,nconts,ncontp,
     &                   ncontd,ncds,ncdspd,nshels,nshelp,nsheld,
     &                   iprimvec,nprimvec,icfunc,mtloca,icdlfunc,
     &                   icdcfunc,natomtype,nequivvec,neutral,isys,
     &                   iswitch,nptsvec,iwkvec,coord,charge,dmata,
     &                   dmatb,alpha,coeff,alphacd,coeffscd,coeffpcd,
     &                   coeffdcd,cdfitc,potpt,qqa,qqb,radius,
     &                   cneighbour,rneighbour,contacts,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension scale(4)

      dimension iprimvec(*),nprimvec(*),icfunc(*),mtloca(*),nshels(*),
     &          nshelp(*),nsheld(*),icdlfunc(*),icdcfunc(*),
     &          natomtype(*),iswitch(*),nptsvec(*),nequivvec(natoms,*),
     &          neutral(natoms,*),isys(natoms,*),iwkvec(*)

      dimension coord(3,*),charge(*),dmata(*),dmatb(*),alpha(*),
     &          coeff(*),alphacd(*),coeffscd(*),coeffpcd(*),coeffdcd(*),
     &          cdfitc(*),potpt(nesppts,*),qqa(2*natoms,*),qqb(*),
     &          radius(*),cneighbour(3,*),rneighbour(*),contacts(3,*),
     &          wkvec(*)

      data zero,bohr,one,debye,density/0.0d0,0.529177d0,
     &                                 1.0d0,2.54176568d0,1.0d0/
      data scale/1.40d0,1.60d0,1.80d0,2.00d0/

      rewind 66

      ncntrt=nconts+3*ncontp+6*ncontd
      ndim=ncntrt*(ncntrt+1)/2

      ncdfunc=ncds+10*ncdspd

      npoints=ncenters/level

      nespts=0

      dnetcharge=zero

      do 1001 i=1,ncenters
 1001 dnetcharge=dnetcharge+charge(i)

      dnetcharge=dnetcharge-real64(nalpha+nbeta)

      if(iptsflag.eq.0) then

                  nespts=0

                  rewind 90

 1002             nespts=nespts+1

                  read(90,1003,end=1004) wkvec(0*250000+nespts),
     &                                   wkvec(1*250000+nespts),
     &                                   wkvec(2*250000+nespts)
 1003             format(3f20.12)

                  wkvec(0*250000+nespts)=wkvec(0*250000+nespts)/bohr
                  wkvec(1*250000+nespts)=wkvec(1*250000+nespts)/bohr
                  wkvec(2*250000+nespts)=wkvec(2*250000+nespts)/bohr

                  goto 1002

 1004             continue

                  nespts=nespts-1

                  write(66) nespts

                  call fastwr(66,wkvec(000001),nespts)
                  call fastwr(66,wkvec(250001),nespts)
                  call fastwr(66,wkvec(500001),nespts)

                        else

                  call surfac(density,scale(1),coord,radius,cneighbour,
     &                        rneighbour,contacts,potpt,natomtype,
     &                        nptsvec,iswitch,ncontacts,ncenters,
     &                        nesppts,nesp1,nespts)

                  nespts=nespts+nesp1

                  call surfac(density,scale(2),coord,radius,cneighbour,
     &                        rneighbour,contacts,potpt,natomtype,
     &                        nptsvec,iswitch,ncontacts,ncenters,
     &                        nesppts,nesp2,nespts)

                  nespts=nespts+nesp2

                  call surfac(density,scale(3),coord,radius,cneighbour,
     &                        rneighbour,contacts,potpt,natomtype,
     &                        nptsvec,iswitch,ncontacts,ncenters,
     &                        nesppts,nesp3,nespts)

                  nespts=nespts+nesp3

                  call surfac(density,scale(4),coord,radius,cneighbour,
     &                        rneighbour,contacts,potpt,natomtype,
     &                        nptsvec,iswitch,ncontacts,ncenters,
     &                        nesppts,nesp4,nespts)

                  nespts=nespts+nesp4

                        endif

      rewind 66

      do 1005 i=1,ndim
 1005 wkvec(i)=dmata(i)+dmatb(i)

      do 1006 i=1,npoints
      qqa(i,npoints+1)=one
 1006 qqa(npoints+1,i)=one

      qqa(npoints+1,npoints+1)=zero

      if(nequivnb.gt.0) then
                              do 1007 i=1,nequivnb
                              qqa(nequivvec(i,1),npoints+1+i)=+one
                              qqa(nequivvec(i,2),npoints+1+i)=-one
                              qqa(npoints+1+i,nequivvec(i,1))=+one
 1007                         qqa(npoints+1+i,nequivvec(i,2))=-one
                        endif

      if(nbneutrals.gt.0) then

                     do 1008 i=1,nbneutrals
                     do 1008 j=1,neutral(i,1)
                     qqa(neutral(i,j+1),npoints+1+nequivnb+i)=+one
 1008                qqa(npoints+1+nequivnb+i,neutral(i,j+1))=+one

                          endif

      qqb(npoints+1)=dnetcharge

      iesp1=1
      iesp2=iesp1+ndim
      iesp3=iesp2+ndim
      iesp4=iesp3+nespts*ncenters
      iesp5=iesp4+nespts*7
      iesp6=iesp5+ncdfunc

      if(iesp6.gt.nreal) stop 'mesp evaluation'

      call mespmm(nreal-iesp4,ninteger,iptsflag,nauxiliary,npoints,
     &            nespts,ncenters,natoms,nbsystems,nconts,ncontp,ncontd,
     &            ncds,ncdspd,nshels,nshelp,nsheld,mtloca,iprimvec,
     &            nprimvec,icfunc,icdcfunc,icdlfunc,nptsvec,isys,iwkvec,
     &            coord,charge,alpha,coeff,alphacd,coeffscd,coeffpcd,
     &            coeffdcd,wkvec(iesp5),wkvec(iesp1),wkvec(iesp2),qqa,
     &            qqb,wkvec(iesp3),wkvec(iesp4),wkvec(iesp6))

      call matinv(qqa,qqb,npoints+1+nequivnb+nbneutrals,1,2*natoms)

      write(6,1009) nespts
 1009 format(//,' number of points used to fit esp = ',i6,/)

      write(6,1010)
 1010 format(' esp-fitted charges using the true density :',/)

      do 1011 i=1,npoints
 1011 write(6,1012) i,coord(1,i)*bohr,coord(2,i)*bohr,
     &                                coord(3,i)*bohr,qqb(i)
 1012 format(8x,'atom # ',i3,' at ',3f10.5,8x,' charge = ',f8.5)

      write(6,1013)
 1013 format()

      xcomp=zero
      ycomp=zero
      zcomp=zero

      do 1014 i=1,npoints
      xcomp=xcomp+coord(1,i)*qqb(i)
      ycomp=ycomp+coord(2,i)*qqb(i)
 1014 zcomp=zcomp+coord(3,i)*qqb(i)

      dipole=sqrt(xcomp*xcomp+ycomp*ycomp+zcomp*zcomp)*debye

      write(6,1015) dipole
 1015 format(8x,'dipole moment from point charges = ',f9.4,' debyes',//)

      return
      end

      subroutine mpi_init(ierror)
      implicit real*8(a-h,o-z)
      integer ierror
      ierror=0
      return
      end





      subroutine mpi_finalize(ierror)
      implicit real*8(a-h,o-z)
      integer ierror
      ierror=0
      return
      end





      subroutine mpi_comm_rank(mpi_comm_world,myid,ierror)
      implicit real*8(a-h,o-z)
      integer mpi_comm_world,myid,ierror
      mpi_comm_world=0
      myid=0
      ierror=0
      return
      end





      subroutine mpi_comm_size(mpi_comm_world,numprocs,ierror)
      implicit real*8(a-h,o-z)
      integer mpi_comm_world,numprocs,ierror
      numprocs=1
      ierror=0
      return
      end





      subroutine mpi_buffer_attach(a,icount,ierror)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer icount,ierror
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      iis=0
      iir=0
      irs=0
      irr=0
      ierror=0
      return
      end





      subroutine mpi_buffer_detach(a,icount,ierror)
      implicit real*8(a-h,o-z)
      integer icount,ierror
      ierror=0
      return
      end





      subroutine mpi_reduce(a,a_sum,n,ntype,mpi_sum,node,mpi_comm_world,
     &                      ierror)
      implicit real*8(a-h,o-z)
      integer n,ntype,mpi_sum,node,mpi_comm_world,ierror
      if(ntype.eq.1) then
                           call rcopy(a_sum,a,n)
                     else
                           call icopy(a_sum,a,n)
                     endif
      ierror=0
      return
      end
      subroutine rcopy(a_sum,a,n)
      implicit real*8(a-h,o-z)
      integer n
      dimension a(*),a_sum(*)
      do 1001 i=1,n
 1001 a_sum(i)=a(i)
      return
      end
      subroutine icopy(ia_sum,ia,n)
      implicit real*8(a-h,o-z)
      integer n,ia(*),ia_sum(*)
      do 1001 i=1,n
 1001 ia_sum(i)=ia(i)
      return
      end





      subroutine mpi_bcast(a,n,ntype,node,mpi_comm_world,ierror)
      implicit real*8(a-h,o-z)
      integer n,ntype,node,mpi_comm_world,ierror
      ierror=0
      return
      end





      subroutine mpi_bsend(a,n,ntype,islave,itag,mpi_comm_world,ierror)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer n,ntype,islave,itag,mpi_comm_world,ierror
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      if(ntype.eq.1) then
                           call send_buffer_real(a,n)
                     else
                           call send_buffer_integer(a,n)
                     endif
      ierror=0
      return
      end
      subroutine send_buffer_real(a,n)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer n
      dimension a(*)
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      do 1001 i=1,n
 1001 buffer(irs+i)=a(i)
      irs=irs+n
      if(irs.gt.nrbuffer) stop 'out of space in mpi buffer (reals)'
      return
      end
      subroutine send_buffer_integer(ia,n)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer n,ia(*)
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      do 1001 i=1,n
 1001 ibuffer(iis+i)=ia(i)
      iis=iis+n
      if(iis.gt.nibuffer) stop 'out of space in mpi buffer (integers)'
      return
      end





      subroutine mpi_recv(a,n,ntype,isource,itag,mpi_comm_world,istat,
     &                    ierror)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer n,ntype,isource,itag,mpi_comm_world,istat(*),ierror
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      if(ntype.eq.1) then
                           call receive_buffer_real(a,n)
                     else
                           call receive_buffer_integer(a,n)
                     endif
      ierror=0
      return
      end
      subroutine receive_buffer_real(a,n)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer n
      dimension a(*)
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      do 1001 i=1,n
 1001 a(i)=buffer(irr+i)
      irr=irr+n
      if(irr.eq.irs) then
                           irs=0
                           irr=0
                     endif
      return
      end
      subroutine receive_buffer_integer(ia,n)
      implicit real*8(a-h,o-z)
      include "params.h"
      integer n,ia(*)
      common/mpii/ibuffer(nibuffer),iis,iir,irs,irr
      common/mpir/buffer(nrbuffer)
      do 1001 i=1,n
 1001 ia(i)=ibuffer(iir+i)
      iir=iir+n
      if(iir.eq.iis) then
                           iis=0
                           iir=0
                     endif
      return
      end

      subroutine coredd(m,n,ncentr,iminj,icontr,inddyy,iloc,coord,
     &                  charge,overlap,core,zeta,zetaa,zetab,axbx,ayby,
     &                  azbz,px,py,pz,pxax,pyay,pzaz,pxbx,pyby,pzbz,eta,
     &                  base,etarr,ss,ss0,ss1,ss2,ss3,ss4,ps,ps0,ps1,
     &                  ps2,ps3,ds0,ds1,ds2,fs0,fs1,gs0,pp0,dpcnd,dp0,
     &                  fpcnd,ddcond,dd0,c,c1,c2,c3,pxcx,pycy,pzcz,u,
     &                  twozeta,eta2)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*),iloc(*)

      dimension coord(3,*),charge(*),overlap(*),core(*),zeta(*),
     &          zetaa(*),zetab(*),axbx(*),ayby(*),azbz(*),px(*),py(*),
     &          pz(*),pxax(*),pyay(*),pzaz(*),pxbx(*),pyby(*),pzbz(*),
     &          eta(*),base(*),etarr(*),ss(*),ss0(*),ss1(*),ss2(*),
     &          ss3(*),ss4(*),ps(n,*),ps0(n,*),ps1(n,*),ps2(n,*),
     &          ps3(n,*),ds0(n,*),ds1(n,*),ds2(n,*),fs0(n,*),fs1(n,*),
     &          gs0(n,*),pp0(n,*),dpcnd(n,*),dp0(n,*),fpcnd(n,*),
     &          ddcond(n,*),dd0(n,*),c(*),c1(n,*),c2(n,*),c3(n,*),
     &          pxcx(*),pycy(*),pzcz(*),u(*),twozeta(*),eta2(*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      sqrt3=sqrt(three)

      do 1001 i=1,n
      eta2(i)=two*eta(i)
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)
      ps0(i,2)=pyay(i)*ss0(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
 1004 c(i)=ss0(i)/twozeta(i)

      do 1005 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)
 1005 ds0(i,6)=pzaz(i)*ps0(i,3)+c(i)

      do 1006 i=1,n
      pp0(i,1)=pxbx(i)*ps0(i,1)+c(i)
      pp0(i,2)=pyby(i)*ps0(i,1)
      pp0(i,3)=pzbz(i)*ps0(i,1)
      pp0(i,4)=pxbx(i)*ps0(i,2)
      pp0(i,5)=pyby(i)*ps0(i,2)+c(i)
      pp0(i,6)=pzbz(i)*ps0(i,2)
      pp0(i,7)=pxbx(i)*ps0(i,3)
      pp0(i,8)=pyby(i)*ps0(i,3)
 1006 pp0(i,9)=pzbz(i)*ps0(i,3)+c(i)

      do 1007 j=1,3
      do 1007 i=1,n
 1007 c1(i,j)=ps0(i,j)/twozeta(i)

      do 1008 i=1,n
      dp0(i,01)=pxbx(i)*ds0(i,1)+c1(i,1)*two
      dp0(i,02)=pyby(i)*ds0(i,1)
      dp0(i,03)=pzbz(i)*ds0(i,1)
      dp0(i,04)=pxbx(i)*ds0(i,2)+c1(i,2)
      dp0(i,05)=pyby(i)*ds0(i,2)+c1(i,1)
      dp0(i,06)=pzbz(i)*ds0(i,2)
      dp0(i,07)=pxbx(i)*ds0(i,3)+c1(i,3)
      dp0(i,08)=pyby(i)*ds0(i,3)
      dp0(i,09)=pzbz(i)*ds0(i,3)+c1(i,1)
      dp0(i,10)=pxbx(i)*ds0(i,4)
      dp0(i,11)=pyby(i)*ds0(i,4)+c1(i,2)*two
      dp0(i,12)=pzbz(i)*ds0(i,4)
      dp0(i,13)=pxbx(i)*ds0(i,5)
      dp0(i,14)=pyby(i)*ds0(i,5)+c1(i,3)
      dp0(i,15)=pzbz(i)*ds0(i,5)+c1(i,2)
      dp0(i,16)=pxbx(i)*ds0(i,6)
      dp0(i,17)=pyby(i)*ds0(i,6)
 1008 dp0(i,18)=pzbz(i)*ds0(i,6)+c1(i,3)*two

      do 1009 j=1,6
      do 1009 i=1,n
 1009 c2(i,j)=ds0(i,j)/twozeta(i)

      do 1010 j=1,9
      do 1010 i=1,n
 1010 c3(i,j)=pp0(i,j)/twozeta(i)

      do 1011 i=1,n
      dd0(i,01)=pxbx(i)*dp0(i,01)+c2(i,1)+c3(i,1)*two
      dd0(i,02)=pyby(i)*dp0(i,01)
      dd0(i,03)=pzbz(i)*dp0(i,01)
      dd0(i,04)=pyby(i)*dp0(i,02)+c2(i,1)
      dd0(i,05)=pzbz(i)*dp0(i,02)
      dd0(i,06)=pzbz(i)*dp0(i,03)+c2(i,1)
      dd0(i,07)=pxbx(i)*dp0(i,04)+c2(i,2)+c3(i,4)
      dd0(i,08)=pyby(i)*dp0(i,04)        +c3(i,1)
      dd0(i,09)=pzbz(i)*dp0(i,04)
      dd0(i,10)=pyby(i)*dp0(i,05)+c2(i,2)+c3(i,2)
      dd0(i,11)=pzbz(i)*dp0(i,05)
      dd0(i,12)=pzbz(i)*dp0(i,06)+c2(i,2)
      dd0(i,13)=pxbx(i)*dp0(i,07)+c2(i,3)+c3(i,7)
      dd0(i,14)=pyby(i)*dp0(i,07)
      dd0(i,15)=pzbz(i)*dp0(i,07)        +c3(i,1)
      dd0(i,16)=pyby(i)*dp0(i,08)+c2(i,3)
      dd0(i,17)=pzbz(i)*dp0(i,08)        +c3(i,2)
      dd0(i,18)=pzbz(i)*dp0(i,09)+c2(i,3)+c3(i,3)
      dd0(i,19)=pxbx(i)*dp0(i,10)+c2(i,4)
      dd0(i,20)=pyby(i)*dp0(i,10)        +c3(i,4)*two
      dd0(i,21)=pzbz(i)*dp0(i,10)
      dd0(i,22)=pyby(i)*dp0(i,11)+c2(i,4)+c3(i,5)*two
      dd0(i,23)=pzbz(i)*dp0(i,11)
      dd0(i,24)=pzbz(i)*dp0(i,12)+c2(i,4)
      dd0(i,25)=pxbx(i)*dp0(i,13)+c2(i,5)
      dd0(i,26)=pyby(i)*dp0(i,13)        +c3(i,7)
      dd0(i,27)=pzbz(i)*dp0(i,13)        +c3(i,4)
      dd0(i,28)=pyby(i)*dp0(i,14)+c2(i,5)+c3(i,8)
      dd0(i,29)=pzbz(i)*dp0(i,14)        +c3(i,5)
      dd0(i,30)=pzbz(i)*dp0(i,15)+c2(i,5)+c3(i,6)
      dd0(i,31)=pxbx(i)*dp0(i,16)+c2(i,6)
      dd0(i,32)=pyby(i)*dp0(i,16)
      dd0(i,33)=pzbz(i)*dp0(i,16)        +c3(i,7)*two
      dd0(i,34)=pyby(i)*dp0(i,17)+c2(i,6)
      dd0(i,35)=pzbz(i)*dp0(i,17)        +c3(i,8)*two
 1011 dd0(i,36)=pzbz(i)*dp0(i,18)+c2(i,6)+c3(i,9)*two

      do 1012 i=1,n
      overlap(inddyy(icontr(i),01))=overlap(inddyy(icontr(i),01))
     &                             +dd0(i,01)
      overlap(inddyy(icontr(i),07))=overlap(inddyy(icontr(i),07))
     &                             +dd0(i,07)
      overlap(inddyy(icontr(i),08))=overlap(inddyy(icontr(i),08))
     &                             +dd0(i,08)
      overlap(inddyy(icontr(i),13))=overlap(inddyy(icontr(i),13))
     &                             +dd0(i,13)
      overlap(inddyy(icontr(i),14))=overlap(inddyy(icontr(i),14))
     &                             +dd0(i,14)
      overlap(inddyy(icontr(i),15))=overlap(inddyy(icontr(i),15))
     &                             +dd0(i,15)
      overlap(inddyy(icontr(i),19))=overlap(inddyy(icontr(i),19))
     &                             +dd0(i,19)
      overlap(inddyy(icontr(i),20))=overlap(inddyy(icontr(i),20))
     &                             +dd0(i,20)
      overlap(inddyy(icontr(i),21))=overlap(inddyy(icontr(i),21))
     &                             +dd0(i,21)
      overlap(inddyy(icontr(i),22))=overlap(inddyy(icontr(i),22))
     &                             +dd0(i,22)
      overlap(inddyy(icontr(i),25))=overlap(inddyy(icontr(i),25))
     &                             +dd0(i,25)
      overlap(inddyy(icontr(i),26))=overlap(inddyy(icontr(i),26))
     &                             +dd0(i,26)
      overlap(inddyy(icontr(i),27))=overlap(inddyy(icontr(i),27))
     &                             +dd0(i,27)
      overlap(inddyy(icontr(i),28))=overlap(inddyy(icontr(i),28))
     &                             +dd0(i,28)
      overlap(inddyy(icontr(i),29))=overlap(inddyy(icontr(i),29))
     &                             +dd0(i,29)
      overlap(inddyy(icontr(i),31))=overlap(inddyy(icontr(i),31))
     &                             +dd0(i,31)
      overlap(inddyy(icontr(i),32))=overlap(inddyy(icontr(i),32))
     &                             +dd0(i,32)
      overlap(inddyy(icontr(i),33))=overlap(inddyy(icontr(i),33))
     &                             +dd0(i,33)
      overlap(inddyy(icontr(i),34))=overlap(inddyy(icontr(i),34))
     &                             +dd0(i,34)
      overlap(inddyy(icontr(i),35))=overlap(inddyy(icontr(i),35))
     &                             +dd0(i,35)
 1012 overlap(inddyy(icontr(i),36))=overlap(inddyy(icontr(i),36))
     &                             +dd0(i,36)

      do 1013 i=1,n
      if(iminj(icontr(i)).ne.0) then

             overlap(inddyy(icontr(i),02))=overlap(inddyy(icontr(i),02))
     &                                    +dd0(i,02)
             overlap(inddyy(icontr(i),03))=overlap(inddyy(icontr(i),03))
     &                                    +dd0(i,03)
             overlap(inddyy(icontr(i),04))=overlap(inddyy(icontr(i),04))
     &                                    +dd0(i,04)
             overlap(inddyy(icontr(i),05))=overlap(inddyy(icontr(i),05))
     &                                    +dd0(i,05)
             overlap(inddyy(icontr(i),06))=overlap(inddyy(icontr(i),06))
     &                                    +dd0(i,06)
             overlap(inddyy(icontr(i),09))=overlap(inddyy(icontr(i),09))
     &                                    +dd0(i,09)
             overlap(inddyy(icontr(i),10))=overlap(inddyy(icontr(i),10))
     &                                    +dd0(i,10)
             overlap(inddyy(icontr(i),11))=overlap(inddyy(icontr(i),11))
     &                                    +dd0(i,11)
             overlap(inddyy(icontr(i),12))=overlap(inddyy(icontr(i),12))
     &                                    +dd0(i,12)
             overlap(inddyy(icontr(i),16))=overlap(inddyy(icontr(i),16))
     &                                    +dd0(i,16)
             overlap(inddyy(icontr(i),17))=overlap(inddyy(icontr(i),17))
     &                                    +dd0(i,17)
             overlap(inddyy(icontr(i),18))=overlap(inddyy(icontr(i),18))
     &                                    +dd0(i,18)
             overlap(inddyy(icontr(i),23))=overlap(inddyy(icontr(i),23))
     &                                    +dd0(i,23)
             overlap(inddyy(icontr(i),24))=overlap(inddyy(icontr(i),24))
     &                                    +dd0(i,24)
             overlap(inddyy(icontr(i),30))=overlap(inddyy(icontr(i),30))
     &                                    +dd0(i,30)

                        endif
 1013 continue

      do 1014 i=1,n
 1014 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1015 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps0(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps0(i,2)
 1015 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps0(i,3)

      do 1016 i=1,n
 1016 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/(two*zetaa(i))

      do 1017 i=1,n
      ds1(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds0(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds0(i,2)
      ds1(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds0(i,3)
      ds1(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds0(i,4)+c(i)
      ds1(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds0(i,5)
 1017 ds1(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds0(i,6)+c(i)

      do 1018 i=1,n
 1018 c(i)=ss(i)/twozeta(i)

      do 1019 i=1,n
      pp0(i,1)=pxbx(i)*ps(i,1)+eta2(i)*pp0(i,1)+c(i)
      pp0(i,2)=pyby(i)*ps(i,1)+eta2(i)*pp0(i,2)
      pp0(i,3)=pzbz(i)*ps(i,1)+eta2(i)*pp0(i,3)
      pp0(i,4)=pxbx(i)*ps(i,2)+eta2(i)*pp0(i,4)
      pp0(i,5)=pyby(i)*ps(i,2)+eta2(i)*pp0(i,5)+c(i)
      pp0(i,6)=pzbz(i)*ps(i,2)+eta2(i)*pp0(i,6)
      pp0(i,7)=pxbx(i)*ps(i,3)+eta2(i)*pp0(i,7)
      pp0(i,8)=pyby(i)*ps(i,3)+eta2(i)*pp0(i,8)
 1019 pp0(i,9)=pzbz(i)*ps(i,3)+eta2(i)*pp0(i,9)+c(i)

      do 1020 j=1,3
      do 1020 i=1,n
 1020 c1(i,j)=ps(i,j)/twozeta(i)

      do 1021 i=1,n
      dp0(i,01)=pxbx(i)*ds1(i,1)+eta2(i)*dp0(i,01)+c1(i,1)*two
      dp0(i,02)=pyby(i)*ds1(i,1)+eta2(i)*dp0(i,02)
      dp0(i,03)=pzbz(i)*ds1(i,1)+eta2(i)*dp0(i,03)
      dp0(i,04)=pxbx(i)*ds1(i,2)+eta2(i)*dp0(i,04)+c1(i,2)
      dp0(i,05)=pyby(i)*ds1(i,2)+eta2(i)*dp0(i,05)+c1(i,1)
      dp0(i,06)=pzbz(i)*ds1(i,2)+eta2(i)*dp0(i,06)
      dp0(i,07)=pxbx(i)*ds1(i,3)+eta2(i)*dp0(i,07)+c1(i,3)
      dp0(i,08)=pyby(i)*ds1(i,3)+eta2(i)*dp0(i,08)
      dp0(i,09)=pzbz(i)*ds1(i,3)+eta2(i)*dp0(i,09)+c1(i,1)
      dp0(i,10)=pxbx(i)*ds1(i,4)+eta2(i)*dp0(i,10)
      dp0(i,11)=pyby(i)*ds1(i,4)+eta2(i)*dp0(i,11)+c1(i,2)*two
      dp0(i,12)=pzbz(i)*ds1(i,4)+eta2(i)*dp0(i,12)
      dp0(i,13)=pxbx(i)*ds1(i,5)+eta2(i)*dp0(i,13)
      dp0(i,14)=pyby(i)*ds1(i,5)+eta2(i)*dp0(i,14)+c1(i,3)
      dp0(i,15)=pzbz(i)*ds1(i,5)+eta2(i)*dp0(i,15)+c1(i,2)
      dp0(i,16)=pxbx(i)*ds1(i,6)+eta2(i)*dp0(i,16)
      dp0(i,17)=pyby(i)*ds1(i,6)+eta2(i)*dp0(i,17)
 1021 dp0(i,18)=pzbz(i)*ds1(i,6)+eta2(i)*dp0(i,18)+c1(i,3)*two

      do 1022 j=1,6
      do 1022 i=1,n
 1022 c2(i,j)=ds1(i,j)/twozeta(i)-eta2(i)*ds0(i,j)/(two*zetab(i))

      do 1023 j=1,9
      do 1023 i=1,n
 1023 c3(i,j)=pp0(i,j)/twozeta(i)

      do 1024 i=1,n
      dd0(i,01)=pxbx(i)*dp0(i,01)+eta2(i)*dd0(i,01)+c2(i,1)+c3(i,1)*two
      dd0(i,02)=pyby(i)*dp0(i,01)+eta2(i)*dd0(i,02)
      dd0(i,03)=pzbz(i)*dp0(i,01)+eta2(i)*dd0(i,03)
      dd0(i,04)=pyby(i)*dp0(i,02)+eta2(i)*dd0(i,04)+c2(i,1)
      dd0(i,05)=pzbz(i)*dp0(i,02)+eta2(i)*dd0(i,05)
      dd0(i,06)=pzbz(i)*dp0(i,03)+eta2(i)*dd0(i,06)+c2(i,1)
      dd0(i,07)=pxbx(i)*dp0(i,04)+eta2(i)*dd0(i,07)+c2(i,2)+c3(i,4)
      dd0(i,08)=pyby(i)*dp0(i,04)+eta2(i)*dd0(i,08)        +c3(i,1)
      dd0(i,09)=pzbz(i)*dp0(i,04)+eta2(i)*dd0(i,09)
      dd0(i,10)=pyby(i)*dp0(i,05)+eta2(i)*dd0(i,10)+c2(i,2)+c3(i,2)
      dd0(i,11)=pzbz(i)*dp0(i,05)+eta2(i)*dd0(i,11)
      dd0(i,12)=pzbz(i)*dp0(i,06)+eta2(i)*dd0(i,12)+c2(i,2)
      dd0(i,13)=pxbx(i)*dp0(i,07)+eta2(i)*dd0(i,13)+c2(i,3)+c3(i,7)
      dd0(i,14)=pyby(i)*dp0(i,07)+eta2(i)*dd0(i,14)
      dd0(i,15)=pzbz(i)*dp0(i,07)+eta2(i)*dd0(i,15)        +c3(i,1)
      dd0(i,16)=pyby(i)*dp0(i,08)+eta2(i)*dd0(i,16)+c2(i,3)
      dd0(i,17)=pzbz(i)*dp0(i,08)+eta2(i)*dd0(i,17)        +c3(i,2)
      dd0(i,18)=pzbz(i)*dp0(i,09)+eta2(i)*dd0(i,18)+c2(i,3)+c3(i,3)
      dd0(i,19)=pxbx(i)*dp0(i,10)+eta2(i)*dd0(i,19)+c2(i,4)
      dd0(i,20)=pyby(i)*dp0(i,10)+eta2(i)*dd0(i,20)        +c3(i,4)*two
      dd0(i,21)=pzbz(i)*dp0(i,10)+eta2(i)*dd0(i,21)
      dd0(i,22)=pyby(i)*dp0(i,11)+eta2(i)*dd0(i,22)+c2(i,4)+c3(i,5)*two
      dd0(i,23)=pzbz(i)*dp0(i,11)+eta2(i)*dd0(i,23)
      dd0(i,24)=pzbz(i)*dp0(i,12)+eta2(i)*dd0(i,24)+c2(i,4)
      dd0(i,25)=pxbx(i)*dp0(i,13)+eta2(i)*dd0(i,25)+c2(i,5)
      dd0(i,26)=pyby(i)*dp0(i,13)+eta2(i)*dd0(i,26)        +c3(i,7)
      dd0(i,27)=pzbz(i)*dp0(i,13)+eta2(i)*dd0(i,27)        +c3(i,4)
      dd0(i,28)=pyby(i)*dp0(i,14)+eta2(i)*dd0(i,28)+c2(i,5)+c3(i,8)
      dd0(i,29)=pzbz(i)*dp0(i,14)+eta2(i)*dd0(i,29)        +c3(i,5)
      dd0(i,30)=pzbz(i)*dp0(i,15)+eta2(i)*dd0(i,30)+c2(i,5)+c3(i,6)
      dd0(i,31)=pxbx(i)*dp0(i,16)+eta2(i)*dd0(i,31)+c2(i,6)
      dd0(i,32)=pyby(i)*dp0(i,16)+eta2(i)*dd0(i,32)
      dd0(i,33)=pzbz(i)*dp0(i,16)+eta2(i)*dd0(i,33)        +c3(i,7)*two
      dd0(i,34)=pyby(i)*dp0(i,17)+eta2(i)*dd0(i,34)+c2(i,6)
      dd0(i,35)=pzbz(i)*dp0(i,17)+eta2(i)*dd0(i,35)        +c3(i,8)*two
 1024 dd0(i,36)=pzbz(i)*dp0(i,18)+eta2(i)*dd0(i,36)+c2(i,6)+c3(i,9)*two

      do 1025 i=1,n
      core(inddyy(icontr(i),01))=core(inddyy(icontr(i),01))+dd0(i,01)
      core(inddyy(icontr(i),07))=core(inddyy(icontr(i),07))+dd0(i,07)
      core(inddyy(icontr(i),08))=core(inddyy(icontr(i),08))+dd0(i,08)
      core(inddyy(icontr(i),13))=core(inddyy(icontr(i),13))+dd0(i,13)
      core(inddyy(icontr(i),14))=core(inddyy(icontr(i),14))+dd0(i,14)
      core(inddyy(icontr(i),15))=core(inddyy(icontr(i),15))+dd0(i,15)
      core(inddyy(icontr(i),19))=core(inddyy(icontr(i),19))+dd0(i,19)
      core(inddyy(icontr(i),20))=core(inddyy(icontr(i),20))+dd0(i,20)
      core(inddyy(icontr(i),21))=core(inddyy(icontr(i),21))+dd0(i,21)
      core(inddyy(icontr(i),22))=core(inddyy(icontr(i),22))+dd0(i,22)
      core(inddyy(icontr(i),25))=core(inddyy(icontr(i),25))+dd0(i,25)
      core(inddyy(icontr(i),26))=core(inddyy(icontr(i),26))+dd0(i,26)
      core(inddyy(icontr(i),27))=core(inddyy(icontr(i),27))+dd0(i,27)
      core(inddyy(icontr(i),28))=core(inddyy(icontr(i),28))+dd0(i,28)
      core(inddyy(icontr(i),29))=core(inddyy(icontr(i),29))+dd0(i,29)
      core(inddyy(icontr(i),31))=core(inddyy(icontr(i),31))+dd0(i,31)
      core(inddyy(icontr(i),32))=core(inddyy(icontr(i),32))+dd0(i,32)
      core(inddyy(icontr(i),33))=core(inddyy(icontr(i),33))+dd0(i,33)
      core(inddyy(icontr(i),34))=core(inddyy(icontr(i),34))+dd0(i,34)
      core(inddyy(icontr(i),35))=core(inddyy(icontr(i),35))+dd0(i,35)
 1025 core(inddyy(icontr(i),36))=core(inddyy(icontr(i),36))+dd0(i,36)

      do 1026 i=1,n
      if(iminj(icontr(i)).ne.0) then

             core(inddyy(icontr(i),02))=core(inddyy(icontr(i),02))
     &                                 +dd0(i,02)
             core(inddyy(icontr(i),03))=core(inddyy(icontr(i),03))
     &                                 +dd0(i,03)
             core(inddyy(icontr(i),04))=core(inddyy(icontr(i),04))
     &                                 +dd0(i,04)
             core(inddyy(icontr(i),05))=core(inddyy(icontr(i),05))
     &                                 +dd0(i,05)
             core(inddyy(icontr(i),06))=core(inddyy(icontr(i),06))
     &                                 +dd0(i,06)
             core(inddyy(icontr(i),09))=core(inddyy(icontr(i),09))
     &                                 +dd0(i,09)
             core(inddyy(icontr(i),10))=core(inddyy(icontr(i),10))
     &                                 +dd0(i,10)
             core(inddyy(icontr(i),11))=core(inddyy(icontr(i),11))
     &                                 +dd0(i,11)
             core(inddyy(icontr(i),12))=core(inddyy(icontr(i),12))
     &                                 +dd0(i,12)
             core(inddyy(icontr(i),16))=core(inddyy(icontr(i),16))
     &                                 +dd0(i,16)
             core(inddyy(icontr(i),17))=core(inddyy(icontr(i),17))
     &                                 +dd0(i,17)
             core(inddyy(icontr(i),18))=core(inddyy(icontr(i),18))
     &                                 +dd0(i,18)
             core(inddyy(icontr(i),23))=core(inddyy(icontr(i),23))
     &                                 +dd0(i,23)
             core(inddyy(icontr(i),24))=core(inddyy(icontr(i),24))
     &                                 +dd0(i,24)
             core(inddyy(icontr(i),30))=core(inddyy(icontr(i),30))
     &                                 +dd0(i,30)

                        endif
 1026 continue

      do 1027 j=1,36
      do 1027 i=1,n
 1027 ddcond(i,j)=zero

      do 2001 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 2002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 2002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      call auggv(5,n,iloc,u,ds0,ss0,ss1,ss2)

      do 2003 i=1,n
      ss0(i)=base(i)*ds0(i,1)*twopichrg/zeta(i)
      ss1(i)=base(i)*ds0(i,2)*twopichrg/zeta(i)
      ss2(i)=base(i)*ds0(i,3)*twopichrg/zeta(i)
      ss3(i)=base(i)*ds0(i,4)*twopichrg/zeta(i)
 2003 ss4(i)=base(i)*ds0(i,5)*twopichrg/zeta(i)

      do 2004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      ps2(i,1)=pxax(i)*ss2(i)-pxcx(i)*ss3(i)
      ps2(i,2)=pyay(i)*ss2(i)-pycy(i)*ss3(i)
      ps2(i,3)=pzaz(i)*ss2(i)-pzcz(i)*ss3(i)

      ps3(i,1)=pxax(i)*ss3(i)-pxcx(i)*ss4(i)
      ps3(i,2)=pyay(i)*ss3(i)-pycy(i)*ss4(i)
      ps3(i,3)=pzaz(i)*ss3(i)-pzcz(i)*ss4(i)

 2004 continue

      do 2005 i=1,n
 2005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 2006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 2006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 2007 i=1,n
 2007 c(i)=(ss1(i)-ss2(i))/twozeta(i)

      do 2008 i=1,n
      ds1(i,1)=pxax(i)*ps1(i,1)-pxcx(i)*ps2(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps1(i,1)-pycy(i)*ps2(i,1)
      ds1(i,3)=pzaz(i)*ps1(i,1)-pzcz(i)*ps2(i,1)
      ds1(i,4)=pyay(i)*ps1(i,2)-pycy(i)*ps2(i,2)+c(i)
      ds1(i,5)=pzaz(i)*ps1(i,2)-pzcz(i)*ps2(i,2)
 2008 ds1(i,6)=pzaz(i)*ps1(i,3)-pzcz(i)*ps2(i,3)+c(i)

      do 2009 i=1,n
 2009 c(i)=(ss2(i)-ss3(i))/twozeta(i)

      do 2010 i=1,n
      ds2(i,1)=pxax(i)*ps2(i,1)-pxcx(i)*ps3(i,1)+c(i)
      ds2(i,2)=pyay(i)*ps2(i,1)-pycy(i)*ps3(i,1)
      ds2(i,3)=pzaz(i)*ps2(i,1)-pzcz(i)*ps3(i,1)
      ds2(i,4)=pyay(i)*ps2(i,2)-pycy(i)*ps3(i,2)+c(i)
      ds2(i,5)=pzaz(i)*ps2(i,2)-pzcz(i)*ps3(i,2)
 2010 ds2(i,6)=pzaz(i)*ps2(i,3)-pzcz(i)*ps3(i,3)+c(i)

      do 2011 j=1,3
      do 2011 i=1,n
 2011 c1(i,j)=(ps0(i,j)-ps1(i,j))/twozeta(i)

      do 2012 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)-pxcx(i)*ds1(i,1)+c1(i,1)*two
      fs0(i,02)=pyay(i)*ds0(i,1)-pycy(i)*ds1(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)-pzcz(i)*ds1(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)-pycy(i)*ds1(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)-pzcz(i)*ds1(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)-pzcz(i)*ds1(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)-pycy(i)*ds1(i,4)+c1(i,2)*two
      fs0(i,08)=pzaz(i)*ds0(i,4)-pzcz(i)*ds1(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)-pzcz(i)*ds1(i,5)+c1(i,2)
 2012 fs0(i,10)=pzaz(i)*ds0(i,6)-pzcz(i)*ds1(i,6)+c1(i,3)*two

      do 2013 j=1,3
      do 2013 i=1,n
 2013 c1(i,j)=(ps1(i,j)-ps2(i,j))/twozeta(i)

      do 2014 i=1,n
      fs1(i,01)=pxax(i)*ds1(i,1)-pxcx(i)*ds2(i,1)+c1(i,1)*two
      fs1(i,02)=pyay(i)*ds1(i,1)-pycy(i)*ds2(i,1)
      fs1(i,03)=pzaz(i)*ds1(i,1)-pzcz(i)*ds2(i,1)
      fs1(i,04)=pyay(i)*ds1(i,2)-pycy(i)*ds2(i,2)+c1(i,1)
      fs1(i,05)=pzaz(i)*ds1(i,2)-pzcz(i)*ds2(i,2)
      fs1(i,06)=pzaz(i)*ds1(i,3)-pzcz(i)*ds2(i,3)+c1(i,1)
      fs1(i,07)=pyay(i)*ds1(i,4)-pycy(i)*ds2(i,4)+c1(i,2)*two
      fs1(i,08)=pzaz(i)*ds1(i,4)-pzcz(i)*ds2(i,4)
      fs1(i,09)=pzaz(i)*ds1(i,5)-pzcz(i)*ds2(i,5)+c1(i,2)
 2014 fs1(i,10)=pzaz(i)*ds1(i,6)-pzcz(i)*ds2(i,6)+c1(i,3)*two

      do 2015 j=1,6
      do 2015 i=1,n
 2015 c2(i,j)=(ds0(i,j)-ds1(i,j))/twozeta(i)

      do 2016 i=1,n
      gs0(i,01)=pxax(i)*fs0(i,01)-pxcx(i)*fs1(i,01)+c2(i,1)*three
      gs0(i,02)=pyay(i)*fs0(i,01)-pycy(i)*fs1(i,01)
      gs0(i,03)=pzaz(i)*fs0(i,01)-pzcz(i)*fs1(i,01)
      gs0(i,04)=pyay(i)*fs0(i,02)-pycy(i)*fs1(i,02)+c2(i,1)
      gs0(i,05)=pzaz(i)*fs0(i,02)-pzcz(i)*fs1(i,02)
      gs0(i,06)=pzaz(i)*fs0(i,03)-pzcz(i)*fs1(i,03)+c2(i,1)
      gs0(i,07)=pyay(i)*fs0(i,04)-pycy(i)*fs1(i,04)+c2(i,2)*two
      gs0(i,08)=pzaz(i)*fs0(i,04)-pzcz(i)*fs1(i,04)
      gs0(i,09)=pzaz(i)*fs0(i,05)-pzcz(i)*fs1(i,05)+c2(i,2)
      gs0(i,10)=pzaz(i)*fs0(i,06)-pzcz(i)*fs1(i,06)+c2(i,3)*two
      gs0(i,11)=pyay(i)*fs0(i,07)-pycy(i)*fs1(i,07)+c2(i,4)*three
      gs0(i,12)=pzaz(i)*fs0(i,07)-pzcz(i)*fs1(i,07)
      gs0(i,13)=pzaz(i)*fs0(i,08)-pzcz(i)*fs1(i,08)+c2(i,4)
      gs0(i,14)=pzaz(i)*fs0(i,09)-pzcz(i)*fs1(i,09)+c2(i,5)*two
 2016 gs0(i,15)=pzaz(i)*fs0(i,10)-pzcz(i)*fs1(i,10)+c2(i,6)*three

      do 2017 i=1,n
      dpcnd(i,01)=axbx(icontr(i))*ds0(i,1)+fs0(i,01)
      dpcnd(i,02)=ayby(icontr(i))*ds0(i,1)+fs0(i,02)
      dpcnd(i,03)=azbz(icontr(i))*ds0(i,1)+fs0(i,03)
      dpcnd(i,04)=axbx(icontr(i))*ds0(i,2)+fs0(i,02)
      dpcnd(i,05)=ayby(icontr(i))*ds0(i,2)+fs0(i,04)
      dpcnd(i,06)=azbz(icontr(i))*ds0(i,2)+fs0(i,05)
      dpcnd(i,07)=axbx(icontr(i))*ds0(i,3)+fs0(i,03)
      dpcnd(i,08)=ayby(icontr(i))*ds0(i,3)+fs0(i,05)
      dpcnd(i,09)=azbz(icontr(i))*ds0(i,3)+fs0(i,06)
      dpcnd(i,10)=axbx(icontr(i))*ds0(i,4)+fs0(i,04)
      dpcnd(i,11)=ayby(icontr(i))*ds0(i,4)+fs0(i,07)
      dpcnd(i,12)=azbz(icontr(i))*ds0(i,4)+fs0(i,08)
      dpcnd(i,13)=axbx(icontr(i))*ds0(i,5)+fs0(i,05)
      dpcnd(i,14)=ayby(icontr(i))*ds0(i,5)+fs0(i,08)
      dpcnd(i,15)=azbz(icontr(i))*ds0(i,5)+fs0(i,09)
      dpcnd(i,16)=axbx(icontr(i))*ds0(i,6)+fs0(i,06)
      dpcnd(i,17)=ayby(icontr(i))*ds0(i,6)+fs0(i,09)
 2017 dpcnd(i,18)=azbz(icontr(i))*ds0(i,6)+fs0(i,10)

      do 2018 i=1,n
      fpcnd(i,01)=axbx(icontr(i))*fs0(i,01)+gs0(i,01)
      fpcnd(i,02)=ayby(icontr(i))*fs0(i,01)+gs0(i,02)
      fpcnd(i,03)=azbz(icontr(i))*fs0(i,01)+gs0(i,03)
      fpcnd(i,04)=axbx(icontr(i))*fs0(i,02)+gs0(i,02)
      fpcnd(i,05)=ayby(icontr(i))*fs0(i,02)+gs0(i,04)
      fpcnd(i,06)=azbz(icontr(i))*fs0(i,02)+gs0(i,05)
      fpcnd(i,07)=axbx(icontr(i))*fs0(i,03)+gs0(i,03)
      fpcnd(i,08)=ayby(icontr(i))*fs0(i,03)+gs0(i,05)
      fpcnd(i,09)=azbz(icontr(i))*fs0(i,03)+gs0(i,06)
      fpcnd(i,10)=axbx(icontr(i))*fs0(i,04)+gs0(i,04)
      fpcnd(i,11)=ayby(icontr(i))*fs0(i,04)+gs0(i,07)
      fpcnd(i,12)=azbz(icontr(i))*fs0(i,04)+gs0(i,08)
      fpcnd(i,13)=axbx(icontr(i))*fs0(i,05)+gs0(i,05)
      fpcnd(i,14)=ayby(icontr(i))*fs0(i,05)+gs0(i,08)
      fpcnd(i,15)=azbz(icontr(i))*fs0(i,05)+gs0(i,09)
      fpcnd(i,16)=axbx(icontr(i))*fs0(i,06)+gs0(i,06)
      fpcnd(i,17)=ayby(icontr(i))*fs0(i,06)+gs0(i,09)
      fpcnd(i,18)=azbz(icontr(i))*fs0(i,06)+gs0(i,10)
      fpcnd(i,19)=axbx(icontr(i))*fs0(i,07)+gs0(i,07)
      fpcnd(i,20)=ayby(icontr(i))*fs0(i,07)+gs0(i,11)
      fpcnd(i,21)=azbz(icontr(i))*fs0(i,07)+gs0(i,12)
      fpcnd(i,22)=axbx(icontr(i))*fs0(i,08)+gs0(i,08)
      fpcnd(i,23)=ayby(icontr(i))*fs0(i,08)+gs0(i,12)
      fpcnd(i,24)=azbz(icontr(i))*fs0(i,08)+gs0(i,13)
      fpcnd(i,25)=axbx(icontr(i))*fs0(i,09)+gs0(i,09)
      fpcnd(i,26)=ayby(icontr(i))*fs0(i,09)+gs0(i,13)
      fpcnd(i,27)=azbz(icontr(i))*fs0(i,09)+gs0(i,14)
      fpcnd(i,28)=axbx(icontr(i))*fs0(i,10)+gs0(i,10)
      fpcnd(i,29)=ayby(icontr(i))*fs0(i,10)+gs0(i,14)
 2018 fpcnd(i,30)=azbz(icontr(i))*fs0(i,10)+gs0(i,15)

      do 2019 i=1,n
      ddcond(i,01)=ddcond(i,01)+axbx(icontr(i))*dpcnd(i,01)+fpcnd(i,01)
      ddcond(i,02)=ddcond(i,02)+ayby(icontr(i))*dpcnd(i,01)+fpcnd(i,04)
      ddcond(i,03)=ddcond(i,03)+azbz(icontr(i))*dpcnd(i,01)+fpcnd(i,07)
      ddcond(i,04)=ddcond(i,04)+ayby(icontr(i))*dpcnd(i,02)+fpcnd(i,05)
      ddcond(i,05)=ddcond(i,05)+azbz(icontr(i))*dpcnd(i,02)+fpcnd(i,08)
      ddcond(i,06)=ddcond(i,06)+azbz(icontr(i))*dpcnd(i,03)+fpcnd(i,09)
      ddcond(i,07)=ddcond(i,07)+axbx(icontr(i))*dpcnd(i,04)+fpcnd(i,04)
      ddcond(i,08)=ddcond(i,08)+ayby(icontr(i))*dpcnd(i,04)+fpcnd(i,10)
      ddcond(i,09)=ddcond(i,09)+azbz(icontr(i))*dpcnd(i,04)+fpcnd(i,13)
      ddcond(i,10)=ddcond(i,10)+ayby(icontr(i))*dpcnd(i,05)+fpcnd(i,11)
      ddcond(i,11)=ddcond(i,11)+azbz(icontr(i))*dpcnd(i,05)+fpcnd(i,14)
      ddcond(i,12)=ddcond(i,12)+azbz(icontr(i))*dpcnd(i,06)+fpcnd(i,15)
      ddcond(i,13)=ddcond(i,13)+axbx(icontr(i))*dpcnd(i,07)+fpcnd(i,07)
      ddcond(i,14)=ddcond(i,14)+ayby(icontr(i))*dpcnd(i,07)+fpcnd(i,13)
      ddcond(i,15)=ddcond(i,15)+azbz(icontr(i))*dpcnd(i,07)+fpcnd(i,16)
      ddcond(i,16)=ddcond(i,16)+ayby(icontr(i))*dpcnd(i,08)+fpcnd(i,14)
      ddcond(i,17)=ddcond(i,17)+azbz(icontr(i))*dpcnd(i,08)+fpcnd(i,17)
      ddcond(i,18)=ddcond(i,18)+azbz(icontr(i))*dpcnd(i,09)+fpcnd(i,18)
      ddcond(i,19)=ddcond(i,19)+axbx(icontr(i))*dpcnd(i,10)+fpcnd(i,10)
      ddcond(i,20)=ddcond(i,20)+ayby(icontr(i))*dpcnd(i,10)+fpcnd(i,19)
      ddcond(i,21)=ddcond(i,21)+azbz(icontr(i))*dpcnd(i,10)+fpcnd(i,22)
      ddcond(i,22)=ddcond(i,22)+ayby(icontr(i))*dpcnd(i,11)+fpcnd(i,20)
      ddcond(i,23)=ddcond(i,23)+azbz(icontr(i))*dpcnd(i,11)+fpcnd(i,23)
      ddcond(i,24)=ddcond(i,24)+azbz(icontr(i))*dpcnd(i,12)+fpcnd(i,24)
      ddcond(i,25)=ddcond(i,25)+axbx(icontr(i))*dpcnd(i,13)+fpcnd(i,13)
      ddcond(i,26)=ddcond(i,26)+ayby(icontr(i))*dpcnd(i,13)+fpcnd(i,22)
      ddcond(i,27)=ddcond(i,27)+azbz(icontr(i))*dpcnd(i,13)+fpcnd(i,25)
      ddcond(i,28)=ddcond(i,28)+ayby(icontr(i))*dpcnd(i,14)+fpcnd(i,23)
      ddcond(i,29)=ddcond(i,29)+azbz(icontr(i))*dpcnd(i,14)+fpcnd(i,26)
      ddcond(i,30)=ddcond(i,30)+azbz(icontr(i))*dpcnd(i,15)+fpcnd(i,27)
      ddcond(i,31)=ddcond(i,31)+axbx(icontr(i))*dpcnd(i,16)+fpcnd(i,16)
      ddcond(i,32)=ddcond(i,32)+ayby(icontr(i))*dpcnd(i,16)+fpcnd(i,25)
      ddcond(i,33)=ddcond(i,33)+azbz(icontr(i))*dpcnd(i,16)+fpcnd(i,28)
      ddcond(i,34)=ddcond(i,34)+ayby(icontr(i))*dpcnd(i,17)+fpcnd(i,26)
      ddcond(i,35)=ddcond(i,35)+azbz(icontr(i))*dpcnd(i,17)+fpcnd(i,29)
 2019 ddcond(i,36)=ddcond(i,36)+azbz(icontr(i))*dpcnd(i,18)+fpcnd(i,30)

 2001 continue

      do 2020 i=1,n
      core(inddyy(icontr(i),01))=core(inddyy(icontr(i),01))-ddcond(i,01)
      core(inddyy(icontr(i),07))=core(inddyy(icontr(i),07))-ddcond(i,07)
      core(inddyy(icontr(i),08))=core(inddyy(icontr(i),08))-ddcond(i,08)
      core(inddyy(icontr(i),13))=core(inddyy(icontr(i),13))-ddcond(i,13)
      core(inddyy(icontr(i),14))=core(inddyy(icontr(i),14))-ddcond(i,14)
      core(inddyy(icontr(i),15))=core(inddyy(icontr(i),15))-ddcond(i,15)
      core(inddyy(icontr(i),19))=core(inddyy(icontr(i),19))-ddcond(i,19)
      core(inddyy(icontr(i),20))=core(inddyy(icontr(i),20))-ddcond(i,20)
      core(inddyy(icontr(i),21))=core(inddyy(icontr(i),21))-ddcond(i,21)
      core(inddyy(icontr(i),22))=core(inddyy(icontr(i),22))-ddcond(i,22)
      core(inddyy(icontr(i),25))=core(inddyy(icontr(i),25))-ddcond(i,25)
      core(inddyy(icontr(i),26))=core(inddyy(icontr(i),26))-ddcond(i,26)
      core(inddyy(icontr(i),27))=core(inddyy(icontr(i),27))-ddcond(i,27)
      core(inddyy(icontr(i),28))=core(inddyy(icontr(i),28))-ddcond(i,28)
      core(inddyy(icontr(i),29))=core(inddyy(icontr(i),29))-ddcond(i,29)
      core(inddyy(icontr(i),31))=core(inddyy(icontr(i),31))-ddcond(i,31)
      core(inddyy(icontr(i),32))=core(inddyy(icontr(i),32))-ddcond(i,32)
      core(inddyy(icontr(i),33))=core(inddyy(icontr(i),33))-ddcond(i,33)
      core(inddyy(icontr(i),34))=core(inddyy(icontr(i),34))-ddcond(i,34)
      core(inddyy(icontr(i),35))=core(inddyy(icontr(i),35))-ddcond(i,35)
 2020 core(inddyy(icontr(i),36))=core(inddyy(icontr(i),36))-ddcond(i,36)

      do 2021 i=1,n
      if(iminj(icontr(i)).ne.0) then

              core(inddyy(icontr(i),02))=core(inddyy(icontr(i),02))
     &                                  -ddcond(i,02)
              core(inddyy(icontr(i),03))=core(inddyy(icontr(i),03))
     &                                  -ddcond(i,03)
              core(inddyy(icontr(i),04))=core(inddyy(icontr(i),04))
     &                                  -ddcond(i,04)
              core(inddyy(icontr(i),05))=core(inddyy(icontr(i),05))
     &                                  -ddcond(i,05)
              core(inddyy(icontr(i),06))=core(inddyy(icontr(i),06))
     &                                  -ddcond(i,06)
              core(inddyy(icontr(i),09))=core(inddyy(icontr(i),09))
     &                                  -ddcond(i,09)
              core(inddyy(icontr(i),10))=core(inddyy(icontr(i),10))
     &                                  -ddcond(i,10)
              core(inddyy(icontr(i),11))=core(inddyy(icontr(i),11))
     &                                  -ddcond(i,11)
              core(inddyy(icontr(i),12))=core(inddyy(icontr(i),12))
     &                                  -ddcond(i,12)
              core(inddyy(icontr(i),16))=core(inddyy(icontr(i),16))
     &                                  -ddcond(i,16)
              core(inddyy(icontr(i),17))=core(inddyy(icontr(i),17))
     &                                  -ddcond(i,17)
              core(inddyy(icontr(i),18))=core(inddyy(icontr(i),18))
     &                                  -ddcond(i,18)
              core(inddyy(icontr(i),23))=core(inddyy(icontr(i),23))
     &                                  -ddcond(i,23)
              core(inddyy(icontr(i),24))=core(inddyy(icontr(i),24))
     &                                  -ddcond(i,24)
              core(inddyy(icontr(i),30))=core(inddyy(icontr(i),30))
     &                                  -ddcond(i,30)

                        endif
 2021 continue

      return
      end

      subroutine cdgrxx(ncds,ncdspd,ilfunc,icfunc,cdfitc,alpha,coeffs,
     &                  coeffp,coeffd,coord,gradient)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension g(6)
 
      dimension ilfunc(*),icfunc(*)

      dimension cdfitc(*),alpha(*),coeffs(*),coeffp(*),coeffd(*)
      dimension coord(3,*),gradient(3,*) 

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,forty9/4.0d0,5.0d0,49.0d0/
      data zero,half,pi/0.0d0,0.5d0,3.1415926535898d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      sqrt493=sqrt(forty9/three)
      factor=(pi**(five/four)*sqrt(two))**2

      ncombos=(ncdspd*(ncdspd+1))/2

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1001 i=1,ncdspd
      do 1001 j=1,i

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1001

      ilabel=ilfunc(ncds+i)
      jlabel=ilfunc(ncds+j)

      nc1=icfunc(ilabel)
      nc2=icfunc(jlabel)

      zetaa=alpha(ilabel)
      zetab=alpha(jlabel)

      axbx=coord(1,nc1)-coord(1,nc2)
      ayby=coord(2,nc1)-coord(2,nc2)
      azbz=coord(3,nc1)-coord(3,nc2)

      const=factor/(zetaa*zetab)

      zetaab=one/(zetaa+zetab)

      wxpx=(zetaa*coord(1,nc1)+zetab*coord(1,nc2))*zetaab-coord(1,nc1)
      wypy=(zetaa*coord(2,nc1)+zetab*coord(2,nc2))*zetaab-coord(2,nc1)
      wzpz=(zetaa*coord(3,nc1)+zetab*coord(3,nc2))*zetaab-coord(3,nc1)

      wxqx=(zetaa*coord(1,nc1)+zetab*coord(1,nc2))*zetaab-coord(1,nc2)
      wyqy=(zetaa*coord(2,nc1)+zetab*coord(2,nc2))*zetaab-coord(2,nc2)
      wzqz=(zetaa*coord(3,nc1)+zetab*coord(3,nc2))*zetaab-coord(3,nc2)

      u=zetaa*zetab*zetaab*(axbx*axbx+ayby*ayby+azbz*azbz)

      call augg(6,u,g)

      ss0=g(1)*const*sqrt(zetaab)
      ss1=g(2)*const*sqrt(zetaab)
      ss2=g(3)*const*sqrt(zetaab)
      ss3=g(4)*const*sqrt(zetaab)
      ss4=g(5)*const*sqrt(zetaab)
      ss5=g(6)*const*sqrt(zetaab)

      spx0=wxqx*ss1
      spy0=wyqy*ss1
      spz0=wzqz*ss1

      spx1=wxqx*ss2
      spy1=wyqy*ss2
      spz1=wzqz*ss2

      cfact=(ss0-zetaa*zetaab*ss1)/(two*zetab)

      sdxx0=wxqx*spx1+cfact
      sdxy0=wyqy*spx1
      sdxz0=wzqz*spx1
      sdyy0=wyqy*spy1+cfact
      sdyz0=wzqz*spy1
      sdzz0=wzqz*spz1+cfact

      pxs0=wxpx*ss1
      pys0=wypy*ss1
      pzs0=wzpz*ss1

      pxs1=wxpx*ss2
      pys1=wypy*ss2
      pzs1=wzpz*ss2

      pxs2=wxpx*ss3
      pys2=wypy*ss3
      pzs2=wzpz*ss3

      pxs3=wxpx*ss4
      pys3=wypy*ss4
      pzs3=wzpz*ss4

      pxs4=wxpx*ss5
      pys4=wypy*ss5
      pzs4=wzpz*ss5

      cfact=ss1*zetaab/two

      pxpx0=wxqx*pxs1+cfact
      pxpy0=wyqy*pxs1
      pxpz0=wzqz*pxs1
      pypx0=wxqx*pys1
      pypy0=wyqy*pys1+cfact
      pypz0=wzqz*pys1
      pzpx0=wxqx*pzs1
      pzpy0=wyqy*pzs1
      pzpz0=wzqz*pzs1+cfact

      cfact=ss2*zetaab/two

      pxpx1=wxqx*pxs2+cfact
      pxpy1=wyqy*pxs2
      pxpz1=wzqz*pxs2
      pypx1=wxqx*pys2
      pypy1=wyqy*pys2+cfact
      pypz1=wzqz*pys2
      pzpx1=wxqx*pzs2
      pzpy1=wyqy*pzs2
      pzpz1=wzqz*pzs2+cfact

      cfactx=(pxs0-zetaa*zetaab*pxs1)/(two*zetab)
      cfacty=(pys0-zetaa*zetaab*pys1)/(two*zetab)
      cfactz=(pzs0-zetaa*zetaab*pzs1)/(two*zetab)

      cfactpx=spx1*zetaab/two
      cfactpy=spy1*zetaab/two
      cfactpz=spz1*zetaab/two

      pxdxx0=wxqx*pxpx1+cfactx+cfactpx
      pxdxy0=wyqy*pxpx1
      pxdxz0=wzqz*pxpx1
      pxdyy0=wyqy*pxpy1+cfactx
      pxdyz0=wzqz*pxpy1
      pxdzz0=wzqz*pxpz1+cfactx
      pydxx0=wxqx*pypx1+cfacty
      pydxy0=wyqy*pypx1       +cfactpx
      pydxz0=wzqz*pypx1
      pydyy0=wyqy*pypy1+cfacty+cfactpy
      pydyz0=wzqz*pypy1
      pydzz0=wzqz*pypz1+cfacty
      pzdxx0=wxqx*pzpx1+cfactz
      pzdxy0=wyqy*pzpx1
      pzdxz0=wzqz*pzpx1       +cfactpx
      pzdyy0=wyqy*pzpy1+cfactz
      pzdyz0=wzqz*pzpy1       +cfactpy
      pzdzz0=wzqz*pzpz1+cfactz+cfactpz

      cfact=(ss0-zetab*zetaab*ss1)/(two*zetaa)

      dxxs0=wxpx*pxs1+cfact
      dxys0=wypy*pxs1
      dxzs0=wzpz*pxs1
      dyys0=wypy*pys1+cfact
      dyzs0=wzpz*pys1
      dzzs0=wzpz*pzs1+cfact

      cfact=(ss1-zetab*zetaab*ss2)/(two*zetaa)

      dxxs1=wxpx*pxs2+cfact
      dxys1=wypy*pxs2
      dxzs1=wzpz*pxs2
      dyys1=wypy*pys2+cfact
      dyzs1=wzpz*pys2
      dzzs1=wzpz*pzs2+cfact

      cfact=(ss2-zetab*zetaab*ss3)/(two*zetaa)

      dxxs2=wxpx*pxs3+cfact
      dxys2=wypy*pxs3
      dxzs2=wzpz*pxs3
      dyys2=wypy*pys3+cfact
      dyzs2=wzpz*pys3
      dzzs2=wzpz*pzs3+cfact

      cfact=(ss3-zetab*zetaab*ss4)/(two*zetaa)

      dxxs3=wxpx*pxs4+cfact
      dxys3=wypy*pxs4
      dxzs3=wzpz*pxs4
      dyys3=wypy*pys4+cfact
      dyzs3=wzpz*pys4
      dzzs3=wzpz*pzs4+cfact

      cfactx=pxs1*zetaab/two
      cfacty=pys1*zetaab/two
      cfactz=pzs1*zetaab/two

      dxxpx0=wxqx*dxxs1+cfactx+cfactx
      dxxpy0=wyqy*dxxs1
      dxxpz0=wzqz*dxxs1
      dxypx0=wxqx*dxys1+cfacty
      dxypy0=wyqy*dxys1+cfactx
      dxypz0=wzqz*dxys1
      dxzpx0=wxqx*dxzs1+cfactz
      dxzpy0=wyqy*dxzs1
      dxzpz0=wzqz*dxzs1+cfactx
      dyypx0=wxqx*dyys1
      dyypy0=wyqy*dyys1+cfacty+cfacty
      dyypz0=wzqz*dyys1
      dyzpx0=wxqx*dyzs1
      dyzpy0=wyqy*dyzs1+cfactz
      dyzpz0=wzqz*dyzs1+cfacty
      dzzpx0=wxqx*dzzs1
      dzzpy0=wyqy*dzzs1
      dzzpz0=wzqz*dzzs1+cfactz+cfactz

      cfactx=pxs2*zetaab/two
      cfacty=pys2*zetaab/two
      cfactz=pzs2*zetaab/two

      dxxpx1=wxqx*dxxs2+cfactx+cfactx
      dxxpy1=wyqy*dxxs2
      dxxpz1=wzqz*dxxs2
      dxypx1=wxqx*dxys2+cfacty
      dxypy1=wyqy*dxys2+cfactx
      dxypz1=wzqz*dxys2
      dxzpx1=wxqx*dxzs2+cfactz
      dxzpy1=wyqy*dxzs2
      dxzpz1=wzqz*dxzs2+cfactx
      dyypx1=wxqx*dyys2
      dyypy1=wyqy*dyys2+cfacty+cfacty
      dyypz1=wzqz*dyys2
      dyzpx1=wxqx*dyzs2
      dyzpy1=wyqy*dyzs2+cfactz
      dyzpz1=wzqz*dyzs2+cfacty
      dzzpx1=wxqx*dzzs2
      dzzpy1=wyqy*dzzs2
      dzzpz1=wzqz*dzzs2+cfactz+cfactz

      cfactxx=(dxxs0-zetaa*zetaab*dxxs1)/(two*zetab)
      cfactxy=(dxys0-zetaa*zetaab*dxys1)/(two*zetab)
      cfactxz=(dxzs0-zetaa*zetaab*dxzs1)/(two*zetab)
      cfactyy=(dyys0-zetaa*zetaab*dyys1)/(two*zetab)
      cfactyz=(dyzs0-zetaa*zetaab*dyzs1)/(two*zetab)
      cfactzz=(dzzs0-zetaa*zetaab*dzzs1)/(two*zetab)

      cfactxpx=pxpx1*zetaab/two
      cfactxpy=pxpy1*zetaab/two
      cfactxpz=pxpz1*zetaab/two
      cfactypx=pypx1*zetaab/two
      cfactypy=pypy1*zetaab/two
      cfactypz=pypz1*zetaab/two
      cfactzpx=pzpx1*zetaab/two
      cfactzpy=pzpy1*zetaab/two
      cfactzpz=pzpz1*zetaab/two

      dxxdxx0=wxqx*dxxpx1+cfactxx+cfactxpx+cfactxpx
      dxxdxy0=wyqy*dxxpx1
      dxxdxz0=wzqz*dxxpx1
      dxxdyy0=wyqy*dxxpy1+cfactxx
      dxxdyz0=wzqz*dxxpy1
      dxxdzz0=wzqz*dxxpz1+cfactxx
      dxydxx0=wxqx*dxypx1+cfactxy+cfactypx
      dxydxy0=wyqy*dxypx1        +cfactxpx
      dxydxz0=wzqz*dxypx1
      dxydyy0=wyqy*dxypy1+cfactxy+cfactxpy
      dxydyz0=wzqz*dxypy1
      dxydzz0=wzqz*dxypz1+cfactxy
      dxzdxx0=wxqx*dxzpx1+cfactxz+cfactzpx
      dxzdxy0=wyqy*dxzpx1
      dxzdxz0=wzqz*dxzpx1        +cfactxpx
      dxzdyy0=wyqy*dxzpy1+cfactxz
      dxzdyz0=wzqz*dxzpy1        +cfactxpy
      dxzdzz0=wzqz*dxzpz1+cfactxz+cfactxpz
      dyydxx0=wxqx*dyypx1+cfactyy
      dyydxy0=wyqy*dyypx1        +cfactypx+cfactypx
      dyydxz0=wzqz*dyypx1
      dyydyy0=wyqy*dyypy1+cfactyy+cfactypy+cfactypy
      dyydyz0=wzqz*dyypy1
      dyydzz0=wzqz*dyypz1+cfactyy
      dyzdxx0=wxqx*dyzpx1+cfactyz
      dyzdxy0=wyqy*dyzpx1        +cfactzpx
      dyzdxz0=wzqz*dyzpx1        +cfactypx
      dyzdyy0=wyqy*dyzpy1+cfactyz+cfactzpy
      dyzdyz0=wzqz*dyzpy1        +cfactypy
      dyzdzz0=wzqz*dyzpz1+cfactyz+cfactypz
      dzzdxx0=wxqx*dzzpx1+cfactzz
      dzzdxy0=wyqy*dzzpx1
      dzzdxz0=wzqz*dzzpx1        +cfactzpx+cfactzpx
      dzzdyy0=wyqy*dzzpy1+cfactzz
      dzzdyz0=wzqz*dzzpy1        +cfactzpy+cfactzpy
      dzzdzz0=wzqz*dzzpz1+cfactzz+cfactzpz+cfactzpz

      cfactx=(pxs0-zetab*zetaab*pxs1)/(two*zetaa)
      cfacty=(pys0-zetab*zetaab*pys1)/(two*zetaa)
      cfactz=(pzs0-zetab*zetaab*pzs1)/(two*zetaa)

      fxxxs0=wxpx*dxxs1+cfactx+cfactx
      fxxys0=wypy*dxxs1
      fxxzs0=wzpz*dxxs1
      fxyys0=wypy*dxys1+cfactx
      fxyzs0=wzpz*dxys1
      fxzzs0=wzpz*dxzs1+cfactx
      fyyys0=wypy*dyys1+cfacty+cfacty
      fyyzs0=wzpz*dyys1
      fyzzs0=wzpz*dyzs1+cfacty
      fzzzs0=wzpz*dzzs1+cfactz+cfactz

      cfactx=(pxs1-zetab*zetaab*pxs2)/(two*zetaa)
      cfacty=(pys1-zetab*zetaab*pys2)/(two*zetaa)
      cfactz=(pzs1-zetab*zetaab*pzs2)/(two*zetaa)

      fxxxs1=wxpx*dxxs2+cfactx+cfactx
      fxxys1=wypy*dxxs2
      fxxzs1=wzpz*dxxs2
      fxyys1=wypy*dxys2+cfactx
      fxyzs1=wzpz*dxys2
      fxzzs1=wzpz*dxzs2+cfactx
      fyyys1=wypy*dyys2+cfacty+cfacty
      fyyzs1=wzpz*dyys2
      fyzzs1=wzpz*dyzs2+cfacty
      fzzzs1=wzpz*dzzs2+cfactz+cfactz

      cfactx=(pxs2-zetab*zetaab*pxs3)/(two*zetaa)
      cfacty=(pys2-zetab*zetaab*pys3)/(two*zetaa)
      cfactz=(pzs2-zetab*zetaab*pzs3)/(two*zetaa)

      fxxxs2=wxpx*dxxs3+cfactx+cfactx
      fxxys2=wypy*dxxs3
      fxxzs2=wzpz*dxxs3
      fxyys2=wypy*dxys3+cfactx
      fxyzs2=wzpz*dxys3
      fxzzs2=wzpz*dxzs3+cfactx
      fyyys2=wypy*dyys3+cfacty+cfacty
      fyyzs2=wzpz*dyys3
      fyzzs2=wzpz*dyzs3+cfacty
      fzzzs2=wzpz*dzzs3+cfactz+cfactz

      cfactxx=dxxs1*zetaab/two
      cfactxy=dxys1*zetaab/two
      cfactxz=dxzs1*zetaab/two
      cfactyy=dyys1*zetaab/two
      cfactyz=dyzs1*zetaab/two
      cfactzz=dzzs1*zetaab/two

      fxxxpx0=wxqx*fxxxs1+cfactxx+cfactxx+cfactxx
      fxxxpy0=wyqy*fxxxs1
      fxxxpz0=wzqz*fxxxs1
      fxxypx0=wxqx*fxxys1+cfactxy+cfactxy
      fxxypy0=wyqy*fxxys1+cfactxx
      fxxypz0=wzqz*fxxys1
      fxxzpx0=wxqx*fxxzs1+cfactxz+cfactxz
      fxxzpy0=wyqy*fxxzs1
      fxxzpz0=wzqz*fxxzs1+cfactxx
      fxyypx0=wxqx*fxyys1+cfactyy
      fxyypy0=wyqy*fxyys1+cfactxy+cfactxy
      fxyypz0=wzqz*fxyys1
      fxyzpx0=wxqx*fxyzs1+cfactyz
      fxyzpy0=wyqy*fxyzs1+cfactxz
      fxyzpz0=wzqz*fxyzs1+cfactxy
      fxzzpx0=wxqx*fxzzs1+cfactzz
      fxzzpy0=wyqy*fxzzs1
      fxzzpz0=wzqz*fxzzs1+cfactxz+cfactxz
      fyyypx0=wxqx*fyyys1
      fyyypy0=wyqy*fyyys1+cfactyy+cfactyy+cfactyy
      fyyypz0=wzqz*fyyys1
      fyyzpx0=wxqx*fyyzs1
      fyyzpy0=wyqy*fyyzs1+cfactyz+cfactyz
      fyyzpz0=wzqz*fyyzs1+cfactyy
      fyzzpx0=wxqx*fyzzs1
      fyzzpy0=wyqy*fyzzs1+cfactzz
      fyzzpz0=wzqz*fyzzs1+cfactyz+cfactyz
      fzzzpx0=wxqx*fzzzs1
      fzzzpy0=wyqy*fzzzs1
      fzzzpz0=wzqz*fzzzs1+cfactzz+cfactzz+cfactzz

      cfactxx=dxxs2*zetaab/two
      cfactxy=dxys2*zetaab/two
      cfactxz=dxzs2*zetaab/two
      cfactyy=dyys2*zetaab/two
      cfactyz=dyzs2*zetaab/two
      cfactzz=dzzs2*zetaab/two

      fxxxpx1=wxqx*fxxxs2+cfactxx+cfactxx+cfactxx
      fxxxpy1=wyqy*fxxxs2
      fxxxpz1=wzqz*fxxxs2
      fxxypx1=wxqx*fxxys2+cfactxy+cfactxy
      fxxypy1=wyqy*fxxys2+cfactxx
      fxxypz1=wzqz*fxxys2
      fxxzpx1=wxqx*fxxzs2+cfactxz+cfactxz
      fxxzpy1=wyqy*fxxzs2
      fxxzpz1=wzqz*fxxzs2+cfactxx
      fxyypx1=wxqx*fxyys2+cfactyy
      fxyypy1=wyqy*fxyys2+cfactxy+cfactxy
      fxyypz1=wzqz*fxyys2
      fxyzpx1=wxqx*fxyzs2+cfactyz
      fxyzpy1=wyqy*fxyzs2+cfactxz
      fxyzpz1=wzqz*fxyzs2+cfactxy
      fxzzpx1=wxqx*fxzzs2+cfactzz
      fxzzpy1=wyqy*fxzzs2
      fxzzpz1=wzqz*fxzzs2+cfactxz+cfactxz
      fyyypx1=wxqx*fyyys2
      fyyypy1=wyqy*fyyys2+cfactyy+cfactyy+cfactyy
      fyyypz1=wzqz*fyyys2
      fyyzpx1=wxqx*fyyzs2
      fyyzpy1=wyqy*fyyzs2+cfactyz+cfactyz
      fyyzpz1=wzqz*fyyzs2+cfactyy
      fyzzpx1=wxqx*fyzzs2
      fyzzpy1=wyqy*fyzzs2+cfactzz
      fyzzpz1=wzqz*fyzzs2+cfactyz+cfactyz
      fzzzpx1=wxqx*fzzzs2
      fzzzpy1=wyqy*fzzzs2
      fzzzpz1=wzqz*fzzzs2+cfactzz+cfactzz+cfactzz

      cfactxxx=(fxxxs0-zetaa*zetaab*fxxxs1)/(two*zetab)
      cfactxxy=(fxxys0-zetaa*zetaab*fxxys1)/(two*zetab)
      cfactxxz=(fxxzs0-zetaa*zetaab*fxxzs1)/(two*zetab)
      cfactxyy=(fxyys0-zetaa*zetaab*fxyys1)/(two*zetab)
      cfactxyz=(fxyzs0-zetaa*zetaab*fxyzs1)/(two*zetab)
      cfactxzz=(fxzzs0-zetaa*zetaab*fxzzs1)/(two*zetab)
      cfactyyy=(fyyys0-zetaa*zetaab*fyyys1)/(two*zetab)
      cfactyyz=(fyyzs0-zetaa*zetaab*fyyzs1)/(two*zetab)
      cfactyzz=(fyzzs0-zetaa*zetaab*fyzzs1)/(two*zetab)
      cfactzzz=(fzzzs0-zetaa*zetaab*fzzzs1)/(two*zetab)

      cfactxxpx=dxxpx1*zetaab/two
      cfactxxpy=dxxpy1*zetaab/two
      cfactxxpz=dxxpz1*zetaab/two
      cfactxypx=dxypx1*zetaab/two
      cfactxypy=dxypy1*zetaab/two
      cfactxypz=dxypz1*zetaab/two
      cfactxzpx=dxzpx1*zetaab/two
      cfactxzpy=dxzpy1*zetaab/two
      cfactxzpz=dxzpz1*zetaab/two
      cfactyypx=dyypx1*zetaab/two
      cfactyypy=dyypy1*zetaab/two
      cfactyypz=dyypz1*zetaab/two
      cfactyzpx=dyzpx1*zetaab/two
      cfactyzpy=dyzpy1*zetaab/two
      cfactyzpz=dyzpz1*zetaab/two
      cfactzzpx=dzzpx1*zetaab/two
      cfactzzpy=dzzpy1*zetaab/two
      cfactzzpz=dzzpz1*zetaab/two

      fxxxdxx0=wxqx*fxxxpx1+cfactxxx+cfactxxpx+cfactxxpx+cfactxxpx
      fxxxdxy0=wyqy*fxxxpx1
      fxxxdxz0=wzqz*fxxxpx1
      fxxxdyy0=wyqy*fxxxpy1+cfactxxx
      fxxxdyz0=wzqz*fxxxpy1
      fxxxdzz0=wzqz*fxxxpz1+cfactxxx
      fxxydxx0=wxqx*fxxypx1+cfactxxy+cfactxypx+cfactxypx
      fxxydxy0=wyqy*fxxypx1         +cfactxxpx
      fxxydxz0=wzqz*fxxypx1
      fxxydyy0=wyqy*fxxypy1+cfactxxy+cfactxxpy
      fxxydyz0=wzqz*fxxypy1
      fxxydzz0=wzqz*fxxypz1+cfactxxy
      fxxzdxx0=wxqx*fxxzpx1+cfactxxz+cfactxzpx+cfactxzpx
      fxxzdxy0=wyqy*fxxzpx1
      fxxzdxz0=wzqz*fxxzpx1         +cfactxxpx
      fxxzdyy0=wyqy*fxxzpy1+cfactxxz
      fxxzdyz0=wzqz*fxxzpy1         +cfactxxpy
      fxxzdzz0=wzqz*fxxzpz1+cfactxxz+cfactxxpz
      fxyydxx0=wxqx*fxyypx1+cfactxyy+cfactyypx
      fxyydxy0=wyqy*fxyypx1         +cfactxypx+cfactxypx
      fxyydxz0=wzqz*fxyypx1
      fxyydyy0=wyqy*fxyypy1+cfactxyy+cfactxypy+cfactxypy
      fxyydyz0=wzqz*fxyypy1
      fxyydzz0=wzqz*fxyypz1+cfactxyy
      fxyzdxx0=wxqx*fxyzpx1+cfactxyz+cfactyzpx
      fxyzdxy0=wyqy*fxyzpx1         +cfactxzpx
      fxyzdxz0=wzqz*fxyzpx1         +cfactxypx
      fxyzdyy0=wyqy*fxyzpy1+cfactxyz+cfactxzpy
      fxyzdyz0=wzqz*fxyzpy1         +cfactxypy
      fxyzdzz0=wzqz*fxyzpz1+cfactxyz+cfactxypz
      fxzzdxx0=wxqx*fxzzpx1+cfactxzz+cfactzzpx
      fxzzdxy0=wyqy*fxzzpx1
      fxzzdxz0=wzqz*fxzzpx1         +cfactxzpx+cfactxzpx
      fxzzdyy0=wyqy*fxzzpy1+cfactxzz
      fxzzdyz0=wzqz*fxzzpy1         +cfactxzpy+cfactxzpy
      fxzzdzz0=wzqz*fxzzpz1+cfactxzz+cfactxzpz+cfactxzpz
      fyyydxx0=wxqx*fyyypx1+cfactyyy
      fyyydxy0=wyqy*fyyypx1         +cfactyypx+cfactyypx+cfactyypx
      fyyydxz0=wzqz*fyyypx1
      fyyydyy0=wyqy*fyyypy1+cfactyyy+cfactyypy+cfactyypy+cfactyypy
      fyyydyz0=wzqz*fyyypy1
      fyyydzz0=wzqz*fyyypz1+cfactyyy
      fyyzdxx0=wxqx*fyyzpx1+cfactyyz
      fyyzdxy0=wyqy*fyyzpx1         +cfactyzpx+cfactyzpx
      fyyzdxz0=wzqz*fyyzpx1         +cfactyypx
      fyyzdyy0=wyqy*fyyzpy1+cfactyyz+cfactyzpy+cfactyzpy
      fyyzdyz0=wzqz*fyyzpy1         +cfactyypy
      fyyzdzz0=wzqz*fyyzpz1+cfactyyz+cfactyypz
      fyzzdxx0=wxqx*fyzzpx1+cfactyzz
      fyzzdxy0=wyqy*fyzzpx1         +cfactzzpx
      fyzzdxz0=wzqz*fyzzpx1         +cfactyzpx+cfactyzpx
      fyzzdyy0=wyqy*fyzzpy1+cfactyzz+cfactzzpy
      fyzzdyz0=wzqz*fyzzpy1         +cfactyzpy+cfactyzpy
      fyzzdzz0=wzqz*fyzzpz1+cfactyzz+cfactyzpz+cfactyzpz
      fzzzdxx0=wxqx*fzzzpx1+cfactzzz
      fzzzdxy0=wyqy*fzzzpx1
      fzzzdxz0=wzqz*fzzzpx1         +cfactzzpx+cfactzzpx+cfactzzpx
      fzzzdyy0=wyqy*fzzzpy1+cfactzzz
      fzzzdyz0=wzqz*fzzzpy1         +cfactzzpy+cfactzzpy+cfactzzpy
      fzzzdzz0=wzqz*fzzzpz1+cfactzzz+cfactzzpz+cfactzzpz+cfactzzpz

      if(i.ne.j) then
                       scale=one
                 else
                       scale=half
                 endif

      n=ncds+(i-1)*10

      cfa01=cdfitc(n+01)*scale
      cfa02=cdfitc(n+02)*scale
      cfa03=cdfitc(n+03)*scale
      cfa04=cdfitc(n+04)*scale
      cfa05=cdfitc(n+05)*scale/sqrt493
      cfa06=cdfitc(n+06)*scale
      cfa07=cdfitc(n+07)*scale
      cfa08=cdfitc(n+08)*scale/sqrt493
      cfa09=cdfitc(n+09)*scale
      cfa10=cdfitc(n+10)*scale/sqrt493

      n=ncds+(j-1)*10

      cfb01=cdfitc(n+01)
      cfb02=cdfitc(n+02)
      cfb03=cdfitc(n+03)
      cfb04=cdfitc(n+04)
      cfb05=cdfitc(n+05)/sqrt493
      cfb06=cdfitc(n+06)
      cfb07=cdfitc(n+07)
      cfb08=cdfitc(n+08)/sqrt493
      cfb09=cdfitc(n+09)
      cfb10=cdfitc(n+10)/sqrt493

      css=cfa01*cfb01*coeffs(ilabel)*coeffs(jlabel)

      cpxs=cfa02*cfb01*coeffp(ilabel)*coeffs(jlabel)
      cpys=cfa03*cfb01*coeffp(ilabel)*coeffs(jlabel)
      cpzs=cfa04*cfb01*coeffp(ilabel)*coeffs(jlabel)

      cdxxs=cfa05*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cdxys=cfa06*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cdxzs=cfa07*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cdyys=cfa08*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cdyzs=cfa09*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cdzzs=cfa10*cfb01*coeffd(ilabel)*coeffs(jlabel)

      cspx=cfa01*cfb02*coeffs(ilabel)*coeffp(jlabel)
      cspy=cfa01*cfb03*coeffs(ilabel)*coeffp(jlabel)
      cspz=cfa01*cfb04*coeffs(ilabel)*coeffp(jlabel)

      cpxpx=cfa02*cfb02*coeffp(ilabel)*coeffp(jlabel)
      cpxpy=cfa02*cfb03*coeffp(ilabel)*coeffp(jlabel)
      cpxpz=cfa02*cfb04*coeffp(ilabel)*coeffp(jlabel)
      cpypx=cfa03*cfb02*coeffp(ilabel)*coeffp(jlabel)
      cpypy=cfa03*cfb03*coeffp(ilabel)*coeffp(jlabel)
      cpypz=cfa03*cfb04*coeffp(ilabel)*coeffp(jlabel)
      cpzpx=cfa04*cfb02*coeffp(ilabel)*coeffp(jlabel)
      cpzpy=cfa04*cfb03*coeffp(ilabel)*coeffp(jlabel)
      cpzpz=cfa04*cfb04*coeffp(ilabel)*coeffp(jlabel)

      cdxxpx=cfa05*cfb02*coeffd(ilabel)*coeffp(jlabel)
      cdxxpy=cfa05*cfb03*coeffd(ilabel)*coeffp(jlabel)
      cdxxpz=cfa05*cfb04*coeffd(ilabel)*coeffp(jlabel)
      cdxypx=cfa06*cfb02*coeffd(ilabel)*coeffp(jlabel)
      cdxypy=cfa06*cfb03*coeffd(ilabel)*coeffp(jlabel)
      cdxypz=cfa06*cfb04*coeffd(ilabel)*coeffp(jlabel)
      cdxzpx=cfa07*cfb02*coeffd(ilabel)*coeffp(jlabel)
      cdxzpy=cfa07*cfb03*coeffd(ilabel)*coeffp(jlabel)
      cdxzpz=cfa07*cfb04*coeffd(ilabel)*coeffp(jlabel)
      cdyypx=cfa08*cfb02*coeffd(ilabel)*coeffp(jlabel)
      cdyypy=cfa08*cfb03*coeffd(ilabel)*coeffp(jlabel)
      cdyypz=cfa08*cfb04*coeffd(ilabel)*coeffp(jlabel)
      cdyzpx=cfa09*cfb02*coeffd(ilabel)*coeffp(jlabel)
      cdyzpy=cfa09*cfb03*coeffd(ilabel)*coeffp(jlabel)
      cdyzpz=cfa09*cfb04*coeffd(ilabel)*coeffp(jlabel)
      cdzzpx=cfa10*cfb02*coeffd(ilabel)*coeffp(jlabel)
      cdzzpy=cfa10*cfb03*coeffd(ilabel)*coeffp(jlabel)
      cdzzpz=cfa10*cfb04*coeffd(ilabel)*coeffp(jlabel)

      csdxx=cfa01*cfb05*coeffs(ilabel)*coeffd(jlabel)
      csdxy=cfa01*cfb06*coeffs(ilabel)*coeffd(jlabel)
      csdxz=cfa01*cfb07*coeffs(ilabel)*coeffd(jlabel)
      csdyy=cfa01*cfb08*coeffs(ilabel)*coeffd(jlabel)
      csdyz=cfa01*cfb09*coeffs(ilabel)*coeffd(jlabel)
      csdzz=cfa01*cfb10*coeffs(ilabel)*coeffd(jlabel)

      cpxdxx=cfa02*cfb05*coeffp(ilabel)*coeffd(jlabel)
      cpxdxy=cfa02*cfb06*coeffp(ilabel)*coeffd(jlabel)
      cpxdxz=cfa02*cfb07*coeffp(ilabel)*coeffd(jlabel)
      cpxdyy=cfa02*cfb08*coeffp(ilabel)*coeffd(jlabel)
      cpxdyz=cfa02*cfb09*coeffp(ilabel)*coeffd(jlabel)
      cpxdzz=cfa02*cfb10*coeffp(ilabel)*coeffd(jlabel)
      cpydxx=cfa03*cfb05*coeffp(ilabel)*coeffd(jlabel)
      cpydxy=cfa03*cfb06*coeffp(ilabel)*coeffd(jlabel)
      cpydxz=cfa03*cfb07*coeffp(ilabel)*coeffd(jlabel)
      cpydyy=cfa03*cfb08*coeffp(ilabel)*coeffd(jlabel)
      cpydyz=cfa03*cfb09*coeffp(ilabel)*coeffd(jlabel)
      cpydzz=cfa03*cfb10*coeffp(ilabel)*coeffd(jlabel)
      cpzdxx=cfa04*cfb05*coeffp(ilabel)*coeffd(jlabel)
      cpzdxy=cfa04*cfb06*coeffp(ilabel)*coeffd(jlabel)
      cpzdxz=cfa04*cfb07*coeffp(ilabel)*coeffd(jlabel)
      cpzdyy=cfa04*cfb08*coeffp(ilabel)*coeffd(jlabel)
      cpzdyz=cfa04*cfb09*coeffp(ilabel)*coeffd(jlabel)
      cpzdzz=cfa04*cfb10*coeffp(ilabel)*coeffd(jlabel)

      cdxxdxx=cfa05*cfb05*coeffd(ilabel)*coeffd(jlabel)
      cdxxdxy=cfa05*cfb06*coeffd(ilabel)*coeffd(jlabel)
      cdxxdxz=cfa05*cfb07*coeffd(ilabel)*coeffd(jlabel)
      cdxxdyy=cfa05*cfb08*coeffd(ilabel)*coeffd(jlabel)
      cdxxdyz=cfa05*cfb09*coeffd(ilabel)*coeffd(jlabel)
      cdxxdzz=cfa05*cfb10*coeffd(ilabel)*coeffd(jlabel)
      cdxydxx=cfa06*cfb05*coeffd(ilabel)*coeffd(jlabel)
      cdxydxy=cfa06*cfb06*coeffd(ilabel)*coeffd(jlabel)
      cdxydxz=cfa06*cfb07*coeffd(ilabel)*coeffd(jlabel)
      cdxydyy=cfa06*cfb08*coeffd(ilabel)*coeffd(jlabel)
      cdxydyz=cfa06*cfb09*coeffd(ilabel)*coeffd(jlabel)
      cdxydzz=cfa06*cfb10*coeffd(ilabel)*coeffd(jlabel)
      cdxzdxx=cfa07*cfb05*coeffd(ilabel)*coeffd(jlabel)
      cdxzdxy=cfa07*cfb06*coeffd(ilabel)*coeffd(jlabel)
      cdxzdxz=cfa07*cfb07*coeffd(ilabel)*coeffd(jlabel)
      cdxzdyy=cfa07*cfb08*coeffd(ilabel)*coeffd(jlabel)
      cdxzdyz=cfa07*cfb09*coeffd(ilabel)*coeffd(jlabel)
      cdxzdzz=cfa07*cfb10*coeffd(ilabel)*coeffd(jlabel)
      cdyydxx=cfa08*cfb05*coeffd(ilabel)*coeffd(jlabel)
      cdyydxy=cfa08*cfb06*coeffd(ilabel)*coeffd(jlabel)
      cdyydxz=cfa08*cfb07*coeffd(ilabel)*coeffd(jlabel)
      cdyydyy=cfa08*cfb08*coeffd(ilabel)*coeffd(jlabel)
      cdyydyz=cfa08*cfb09*coeffd(ilabel)*coeffd(jlabel)
      cdyydzz=cfa08*cfb10*coeffd(ilabel)*coeffd(jlabel)
      cdyzdxx=cfa09*cfb05*coeffd(ilabel)*coeffd(jlabel)
      cdyzdxy=cfa09*cfb06*coeffd(ilabel)*coeffd(jlabel)
      cdyzdxz=cfa09*cfb07*coeffd(ilabel)*coeffd(jlabel)
      cdyzdyy=cfa09*cfb08*coeffd(ilabel)*coeffd(jlabel)
      cdyzdyz=cfa09*cfb09*coeffd(ilabel)*coeffd(jlabel)
      cdyzdzz=cfa09*cfb10*coeffd(ilabel)*coeffd(jlabel)
      cdzzdxx=cfa10*cfb05*coeffd(ilabel)*coeffd(jlabel)
      cdzzdxy=cfa10*cfb06*coeffd(ilabel)*coeffd(jlabel)
      cdzzdxz=cfa10*cfb07*coeffd(ilabel)*coeffd(jlabel)
      cdzzdyy=cfa10*cfb08*coeffd(ilabel)*coeffd(jlabel)
      cdzzdyz=cfa10*cfb09*coeffd(ilabel)*coeffd(jlabel)
      cdzzdzz=cfa10*cfb10*coeffd(ilabel)*coeffd(jlabel)

      factorx=zero
      factory=zero
      factorz=zero

      zz=two*zetaa

      factorx=factorx-zz*css*pxs0
      factory=factory-zz*css*pys0
      factorz=factorz-zz*css*pzs0

      factorx=factorx-zz*(cspx*pxpx0+cspy*pxpy0+cspz*pxpz0)
      factory=factory-zz*(cspx*pypx0+cspy*pypy0+cspz*pypz0)
      factorz=factorz-zz*(cspx*pzpx0+cspy*pzpy0+cspz*pzpz0)

      factorx=factorx-zz*(csdxx*pxdxx0+csdxy*pxdxy0+csdxz*pxdxz0
     &                   +csdyy*pxdyy0+csdyz*pxdyz0+csdzz*pxdzz0)
      factory=factory-zz*(csdxx*pydxx0+csdxy*pydxy0+csdxz*pydxz0
     &                   +csdyy*pydyy0+csdyz*pydyz0+csdzz*pydzz0)
      factorz=factorz-zz*(csdxx*pzdxx0+csdxy*pzdxy0+csdxz*pzdxz0
     &                   +csdyy*pzdyy0+csdyz*pzdyz0+csdzz*pzdzz0)

      factorx=factorx+cpxs*ss0
      factory=factory+cpys*ss0
      factorz=factorz+cpzs*ss0

      factorx=factorx-zz*(cpxs*dxxs0+cpys*dxys0+cpzs*dxzs0)
      factory=factory-zz*(cpxs*dxys0+cpys*dyys0+cpzs*dyzs0)
      factorz=factorz-zz*(cpxs*dxzs0+cpys*dyzs0+cpzs*dzzs0)

      factorx=factorx+cdxxs*pxs0+cdxys*pys0+cdxzs*pzs0+cdxxs*pxs0
      factory=factory+cdxys*pxs0+cdyys*pys0+cdyzs*pzs0+cdyys*pys0
      factorz=factorz+cdxzs*pxs0+cdyzs*pys0+cdzzs*pzs0+cdzzs*pzs0

      factorx=factorx-zz*(cdxxs*fxxxs0+cdxys*fxxys0+cdxzs*fxxzs0
     &                   +cdyys*fxyys0+cdyzs*fxyzs0+cdzzs*fxzzs0)
      factory=factory-zz*(cdxxs*fxxys0+cdxys*fxyys0+cdxzs*fxyzs0
     &                   +cdyys*fyyys0+cdyzs*fyyzs0+cdzzs*fyzzs0)
      factorz=factorz-zz*(cdxxs*fxxzs0+cdxys*fxyzs0+cdxzs*fxzzs0
     &                   +cdyys*fyyzs0+cdyzs*fyzzs0+cdzzs*fzzzs0)

      factorx=factorx+cpxpx*spx0+cpxpy*spy0+cpxpz*spz0
      factory=factory+cpypx*spx0+cpypy*spy0+cpypz*spz0
      factorz=factorz+cpzpx*spx0+cpzpy*spy0+cpzpz*spz0

      factorx=factorx-zz*(cpxpx*dxxpx0+cpxpy*dxxpy0+cpxpz*dxxpz0
     &                   +cpypx*dxypx0+cpypy*dxypy0+cpypz*dxypz0
     &                   +cpzpx*dxzpx0+cpzpy*dxzpy0+cpzpz*dxzpz0)
      factory=factory-zz*(cpxpx*dxypx0+cpxpy*dxypy0+cpxpz*dxypz0
     &                   +cpypx*dyypx0+cpypy*dyypy0+cpypz*dyypz0
     &                   +cpzpx*dyzpx0+cpzpy*dyzpy0+cpzpz*dyzpz0)
      factorz=factorz-zz*(cpxpx*dxzpx0+cpxpy*dxzpy0+cpxpz*dxzpz0
     &                   +cpypx*dyzpx0+cpypy*dyzpy0+cpypz*dyzpz0
     &                   +cpzpx*dzzpx0+cpzpy*dzzpy0+cpzpz*dzzpz0)

      factorx=factorx+cdxxpx*pxpx0+cdxypx*pypx0+cdxzpx*pzpx0
     &               +cdxxpy*pxpy0+cdxypy*pypy0+cdxzpy*pzpy0
     &               +cdxxpz*pxpz0+cdxypz*pypz0+cdxzpz*pzpz0
     &               +cdxxpx*pxpx0+cdxxpy*pxpy0+cdxxpz*pxpz0
      factory=factory+cdxypx*pxpx0+cdyypx*pypx0+cdyzpx*pzpx0
     &               +cdxypy*pxpy0+cdyypy*pypy0+cdyzpy*pzpy0
     &               +cdxypz*pxpz0+cdyypz*pypz0+cdyzpz*pzpz0
     &               +cdyypx*pypx0+cdyypy*pypy0+cdyypz*pypz0
      factorz=factorz+cdxzpx*pxpx0+cdyzpx*pypx0+cdzzpx*pzpx0
     &               +cdxzpy*pxpy0+cdyzpy*pypy0+cdzzpy*pzpy0
     &               +cdxzpz*pxpz0+cdyzpz*pypz0+cdzzpz*pzpz0
     &               +cdzzpx*pzpx0+cdzzpy*pzpy0+cdzzpz*pzpz0

      factorx=factorx-zz*(cdxxpx*fxxxpx0+cdxxpy*fxxxpy0+cdxxpz*fxxxpz0
     &                   +cdxypx*fxxypx0+cdxypy*fxxypy0+cdxypz*fxxypz0
     &                   +cdxzpx*fxxzpx0+cdxzpy*fxxzpy0+cdxzpz*fxxzpz0
     &                   +cdyypx*fxyypx0+cdyypy*fxyypy0+cdyypz*fxyypz0
     &                   +cdyzpx*fxyzpx0+cdyzpy*fxyzpy0+cdyzpz*fxyzpz0
     &                   +cdzzpx*fxzzpx0+cdzzpy*fxzzpy0+cdzzpz*fxzzpz0)
      factory=factory-zz*(cdxxpx*fxxypx0+cdxxpy*fxxypy0+cdxxpz*fxxypz0
     &                   +cdxypx*fxyypx0+cdxypy*fxyypy0+cdxypz*fxyypz0
     &                   +cdxzpx*fxyzpx0+cdxzpy*fxyzpy0+cdxzpz*fxyzpz0
     &                   +cdyypx*fyyypx0+cdyypy*fyyypy0+cdyypz*fyyypz0
     &                   +cdyzpx*fyyzpx0+cdyzpy*fyyzpy0+cdyzpz*fyyzpz0
     &                   +cdzzpx*fyzzpx0+cdzzpy*fyzzpy0+cdzzpz*fyzzpz0)
      factorz=factorz-zz*(cdxxpx*fxxzpx0+cdxxpy*fxxzpy0+cdxxpz*fxxzpz0
     &                   +cdxypx*fxyzpx0+cdxypy*fxyzpy0+cdxypz*fxyzpz0
     &                   +cdxzpx*fxzzpx0+cdxzpy*fxzzpy0+cdxzpz*fxzzpz0
     &                   +cdyypx*fyyzpx0+cdyypy*fyyzpy0+cdyypz*fyyzpz0
     &                   +cdyzpx*fyzzpx0+cdyzpy*fyzzpy0+cdyzpz*fyzzpz0
     &                   +cdzzpx*fzzzpx0+cdzzpy*fzzzpy0+cdzzpz*fzzzpz0)

      factorx=factorx+cpxdxx*sdxx0+cpxdxy*sdxy0+cpxdxz*sdxz0
     &               +cpxdyy*sdyy0+cpxdyz*sdyz0+cpxdzz*sdzz0
      factory=factory+cpydxx*sdxx0+cpydxy*sdxy0+cpydxz*sdxz0
     &               +cpydyy*sdyy0+cpydyz*sdyz0+cpydzz*sdzz0
      factorz=factorz+cpzdxx*sdxx0+cpzdxy*sdxy0+cpzdxz*sdxz0
     &               +cpzdyy*sdyy0+cpzdyz*sdyz0+cpzdzz*sdzz0

      factorx=factorx-zz*(cpxdxx*dxxdxx0+cpxdxy*dxxdxy0+cpxdxz*dxxdxz0
     &                   +cpxdyy*dxxdyy0+cpxdyz*dxxdyz0+cpxdzz*dxxdzz0
     &                   +cpydxx*dxydxx0+cpydxy*dxydxy0+cpydxz*dxydxz0
     &                   +cpydyy*dxydyy0+cpydyz*dxydyz0+cpydzz*dxydzz0
     &                   +cpzdxx*dxzdxx0+cpzdxy*dxzdxy0+cpzdxz*dxzdxz0
     &                   +cpzdyy*dxzdyy0+cpzdyz*dxzdyz0+cpzdzz*dxzdzz0)
      factory=factory-zz*(cpxdxx*dxydxx0+cpxdxy*dxydxy0+cpxdxz*dxydxz0
     &                   +cpxdyy*dxydyy0+cpxdyz*dxydyz0+cpxdzz*dxydzz0
     &                   +cpydxx*dyydxx0+cpydxy*dyydxy0+cpydxz*dyydxz0
     &                   +cpydyy*dyydyy0+cpydyz*dyydyz0+cpydzz*dyydzz0
     &                   +cpzdxx*dyzdxx0+cpzdxy*dyzdxy0+cpzdxz*dyzdxz0
     &                   +cpzdyy*dyzdyy0+cpzdyz*dyzdyz0+cpzdzz*dyzdzz0)
      factorz=factorz-zz*(cpxdxx*dxzdxx0+cpxdxy*dxzdxy0+cpxdxz*dxzdxz0
     &                   +cpxdyy*dxzdyy0+cpxdyz*dxzdyz0+cpxdzz*dxzdzz0
     &                   +cpydxx*dyzdxx0+cpydxy*dyzdxy0+cpydxz*dyzdxz0
     &                   +cpydyy*dyzdyy0+cpydyz*dyzdyz0+cpydzz*dyzdzz0
     &                   +cpzdxx*dzzdxx0+cpzdxy*dzzdxy0+cpzdxz*dzzdxz0
     &                   +cpzdyy*dzzdyy0+cpzdyz*dzzdyz0+cpzdzz*dzzdzz0)

      factorx=factorx+cdxxdxx*pxdxx0+cdxxdxy*pxdxy0+cdxxdxz*pxdxz0
     &               +cdxxdyy*pxdyy0+cdxxdyz*pxdyz0+cdxxdzz*pxdzz0
     &               +cdxydxx*pydxx0+cdxydxy*pydxy0+cdxydxz*pydxz0
     &               +cdxydyy*pydyy0+cdxydyz*pydyz0+cdxydzz*pydzz0
     &               +cdxzdxx*pzdxx0+cdxzdxy*pzdxy0+cdxzdxz*pzdxz0
     &               +cdxzdyy*pzdyy0+cdxzdyz*pzdyz0+cdxzdzz*pzdzz0
     &               +cdxxdxx*pxdxx0+cdxxdxy*pxdxy0+cdxxdxz*pxdxz0
     &               +cdxxdyy*pxdyy0+cdxxdyz*pxdyz0+cdxxdzz*pxdzz0
      factory=factory+cdxydxx*pxdxx0+cdxydxy*pxdxy0+cdxydxz*pxdxz0
     &               +cdxydyy*pxdyy0+cdxydyz*pxdyz0+cdxydzz*pxdzz0
     &               +cdyydxx*pydxx0+cdyydxy*pydxy0+cdyydxz*pydxz0
     &               +cdyydyy*pydyy0+cdyydyz*pydyz0+cdyydzz*pydzz0
     &               +cdyzdxx*pzdxx0+cdyzdxy*pzdxy0+cdyzdxz*pzdxz0
     &               +cdyzdyy*pzdyy0+cdyzdyz*pzdyz0+cdyzdzz*pzdzz0
     &               +cdyydxx*pydxx0+cdyydxy*pydxy0+cdyydxz*pydxz0
     &               +cdyydyy*pydyy0+cdyydyz*pydyz0+cdyydzz*pydzz0
      factorz=factorz+cdxzdxx*pxdxx0+cdxzdxy*pxdxy0+cdxzdxz*pxdxz0
     &               +cdxzdyy*pxdyy0+cdxzdyz*pxdyz0+cdxzdzz*pxdzz0
     &               +cdyzdxx*pydxx0+cdyzdxy*pydxy0+cdyzdxz*pydxz0
     &               +cdyzdyy*pydyy0+cdyzdyz*pydyz0+cdyzdzz*pydzz0
     &               +cdzzdxx*pzdxx0+cdzzdxy*pzdxy0+cdzzdxz*pzdxz0
     &               +cdzzdyy*pzdyy0+cdzzdyz*pzdyz0+cdzzdzz*pzdzz0
     &               +cdzzdxx*pzdxx0+cdzzdxy*pzdxy0+cdzzdxz*pzdxz0
     &               +cdzzdyy*pzdyy0+cdzzdyz*pzdyz0+cdzzdzz*pzdzz0

      factorx=factorx-zz*(cdxxdxx*fxxxdxx0+cdxxdxy*fxxxdxy0
     &                   +cdxxdxz*fxxxdxz0+cdxxdyy*fxxxdyy0
     &                   +cdxxdyz*fxxxdyz0+cdxxdzz*fxxxdzz0
     &                   +cdxydxx*fxxydxx0+cdxydxy*fxxydxy0
     &                   +cdxydxz*fxxydxz0+cdxydyy*fxxydyy0
     &                   +cdxydyz*fxxydyz0+cdxydzz*fxxydzz0
     &                   +cdxzdxx*fxxzdxx0+cdxzdxy*fxxzdxy0
     &                   +cdxzdxz*fxxzdxz0+cdxzdyy*fxxzdyy0
     &                   +cdxzdyz*fxxzdyz0+cdxzdzz*fxxzdzz0
     &                   +cdyydxx*fxyydxx0+cdyydxy*fxyydxy0
     &                   +cdyydxz*fxyydxz0+cdyydyy*fxyydyy0
     &                   +cdyydyz*fxyydyz0+cdyydzz*fxyydzz0
     &                   +cdyzdxx*fxyzdxx0+cdyzdxy*fxyzdxy0
     &                   +cdyzdxz*fxyzdxz0+cdyzdyy*fxyzdyy0
     &                   +cdyzdyz*fxyzdyz0+cdyzdzz*fxyzdzz0
     &                   +cdzzdxx*fxzzdxx0+cdzzdxy*fxzzdxy0
     &                   +cdzzdxz*fxzzdxz0+cdzzdyy*fxzzdyy0
     &                   +cdzzdyz*fxzzdyz0+cdzzdzz*fxzzdzz0)
      factory=factory-zz*(cdxxdxx*fxxydxx0+cdxxdxy*fxxydxy0
     &                   +cdxxdxz*fxxydxz0+cdxxdyy*fxxydyy0
     &                   +cdxxdyz*fxxydyz0+cdxxdzz*fxxydzz0
     &                   +cdxydxx*fxyydxx0+cdxydxy*fxyydxy0
     &                   +cdxydxz*fxyydxz0+cdxydyy*fxyydyy0
     &                   +cdxydyz*fxyydyz0+cdxydzz*fxyydzz0
     &                   +cdxzdxx*fxyzdxx0+cdxzdxy*fxyzdxy0
     &                   +cdxzdxz*fxyzdxz0+cdxzdyy*fxyzdyy0
     &                   +cdxzdyz*fxyzdyz0+cdxzdzz*fxyzdzz0
     &                   +cdyydxx*fyyydxx0+cdyydxy*fyyydxy0
     &                   +cdyydxz*fyyydxz0+cdyydyy*fyyydyy0
     &                   +cdyydyz*fyyydyz0+cdyydzz*fyyydzz0
     &                   +cdyzdxx*fyyzdxx0+cdyzdxy*fyyzdxy0
     &                   +cdyzdxz*fyyzdxz0+cdyzdyy*fyyzdyy0
     &                   +cdyzdyz*fyyzdyz0+cdyzdzz*fyyzdzz0
     &                   +cdzzdxx*fyzzdxx0+cdzzdxy*fyzzdxy0
     &                   +cdzzdxz*fyzzdxz0+cdzzdyy*fyzzdyy0
     &                   +cdzzdyz*fyzzdyz0+cdzzdzz*fyzzdzz0)
      factorz=factorz-zz*(cdxxdxx*fxxzdxx0+cdxxdxy*fxxzdxy0
     &                   +cdxxdxz*fxxzdxz0+cdxxdyy*fxxzdyy0
     &                   +cdxxdyz*fxxzdyz0+cdxxdzz*fxxzdzz0
     &                   +cdxydxx*fxyzdxx0+cdxydxy*fxyzdxy0
     &                   +cdxydxz*fxyzdxz0+cdxydyy*fxyzdyy0
     &                   +cdxydyz*fxyzdyz0+cdxydzz*fxyzdzz0
     &                   +cdxzdxx*fxzzdxx0+cdxzdxy*fxzzdxy0
     &                   +cdxzdxz*fxzzdxz0+cdxzdyy*fxzzdyy0
     &                   +cdxzdyz*fxzzdyz0+cdxzdzz*fxzzdzz0
     &                   +cdyydxx*fyyzdxx0+cdyydxy*fyyzdxy0
     &                   +cdyydxz*fyyzdxz0+cdyydyy*fyyzdyy0
     &                   +cdyydyz*fyyzdyz0+cdyydzz*fyyzdzz0
     &                   +cdyzdxx*fyzzdxx0+cdyzdxy*fyzzdxy0
     &                   +cdyzdxz*fyzzdxz0+cdyzdyy*fyzzdyy0
     &                   +cdyzdyz*fyzzdyz0+cdyzdzz*fyzzdzz0
     &                   +cdzzdxx*fzzzdxx0+cdzzdxy*fzzzdxy0
     &                   +cdzzdxz*fzzzdxz0+cdzzdyy*fzzzdyy0
     &                   +cdzzdyz*fzzzdyz0+cdzzdzz*fzzzdzz0)

      gradient(1,nc1)=gradient(1,nc1)+factorx
      gradient(2,nc1)=gradient(2,nc1)+factory
      gradient(3,nc1)=gradient(3,nc1)+factorz

      gradient(1,nc2)=gradient(1,nc2)-factorx
      gradient(2,nc2)=gradient(2,nc2)-factory
      gradient(3,nc2)=gradient(3,nc2)-factorz

 1001 continue

      return
      end

      subroutine gradxxds(m,n,ncds,ncdspd,ilfunc,icfunc,icontr,inddyy,
     &                    icentr,iicontr,g,coord,density,gradient,
     &                    cdfitc,alphaaux,coeffs,coeffp,coeffd,zeta,
     &                    twozetaa,twozetab,px,py,pz,base,pxax,pyay,
     &                    pzaz,axbx,ayby,azbz,zzeta,ttwozetaa,ttwozetab,
     &                    zetarec,ppx,ppy,ppz,ppxax,ppyay,ppzaz,wxpx,
     &                    wypy,wzpz,wxcx,wycy,wzcz,zetac1,zetac2,u,sss0,
     &                    sss1,sss2,sss3,sss4,sss5,pss0,pss1,pss2,pss3,
     &                    pss4,dss0,dss1,dss2,dss3,fss0,fss1,fss2,ssp1,
     &                    psp0,psp1,psd0,dsp0,dsp1,dsd0,fsp0,fsp1,fsd0,
     &                    c,c1,c2,psscond,pspcond,psdcond,dsscond,
     &                    dspcond,dsdcond,fsscond,fspcond,fsdcond,
     &                    dpscond,dppcond,dpdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),icontr(*),inddyy(m,*),icentr(m,*),
     &          iicontr(*)

      dimension cdfitp(3),cdfitd(6)

      dimension g(*),coord(3,*),density(*),gradient(3,*),cdfitc(*),
     &          alphaaux(*),coeffs(*),coeffp(*),coeffd(*),zeta(*),
     &          twozetaa(*),twozetab(*),px(*),py(*),pz(*),base(*),
     &          pxax(*),pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*),
     &          zzeta(*),ttwozetaa(*),ttwozetab(*),zetarec(*),ppx(*),
     &          ppy(*),ppz(*),ppxax(*),ppyay(*),ppzaz(*),wxpx(*),
     &          wypy(*),wzpz(*),wxcx(*),wycy(*),wzcz(*),zetac1(*),
     &          zetac2(*),u(*),sss0(*),sss1(*),sss2(*),sss3(*),sss4(*),
     &          sss5(*),pss0(n,*),pss1(n,*),pss2(n,*),pss3(n,*),
     &          pss4(n,*),dss0(n,*),dss1(n,*),dss2(n,*),dss3(n,*),
     &          fss0(n,*),fss1(n,*),fss2(n,*),ssp1(n,*),psp0(n,*),
     &          psp1(n,*),psd0(n,*),dsp0(n,*),dsp1(n,*),dsd0(n,*),
     &          fsp0(n,*),fsp1(n,*),fsd0(n,*),c(*),c1(n,*),c2(n,*),
     &          psscond(m,*),pspcond(m,*),psdcond(m,*),dsscond(m,*),
     &          dspcond(m,*),dsdcond(m,*),fsscond(m,*),fspcond(m,*),
     &          fsdcond(m,*),dpscond(m,*),dppcond(m,*),dpdcond(m,*),
     &          grad(m,*)

      data one,two,three,four,five,seven/1.0d0,2.0d0,3.0d0,
     &                                   4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/

      twoeconst=two*pi**(five/two)

      dnormcd=seven/sqrt(three)

      do 1001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      nc=icfunc(ilaux)

      ccx=coord(1,nc)
      ccy=coord(2,nc)
      ccz=coord(3,nc)

      zetaux=alphaaux(ilaux)

      cdfits=cdfitc(ncds+(naux-1)*10+1)*coeffs(ilaux)

      cdfitp(1)=cdfitc(ncds+(naux-1)*10+2)*coeffp(ilaux)
      cdfitp(2)=cdfitc(ncds+(naux-1)*10+3)*coeffp(ilaux)
      cdfitp(3)=cdfitc(ncds+(naux-1)*10+4)*coeffp(ilaux)

      cdfitd(1)=cdfitc(ncds+(naux-1)*10+05)*coeffd(ilaux)/dnormcd
      cdfitd(2)=cdfitc(ncds+(naux-1)*10+06)*coeffd(ilaux)
      cdfitd(3)=cdfitc(ncds+(naux-1)*10+07)*coeffd(ilaux)
      cdfitd(4)=cdfitc(ncds+(naux-1)*10+08)*coeffd(ilaux)/dnormcd
      cdfitd(5)=cdfitc(ncds+(naux-1)*10+09)*coeffd(ilaux)
      cdfitd(6)=cdfitc(ncds+(naux-1)*10+10)*coeffd(ilaux)/dnormcd

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      call augg(6,u(i),g)
      sss0(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(4)/zeta(i)/zetaux
      sss4(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(5)/zeta(i)/zetaux
 1004 sss5(i)=base(i)*twoeconst*sqrt(zetarec(i))*g(6)/zeta(i)/zetaux

      nn=0

      do 1005 i=1,n
      if(abs(sss0(i)).gt.calcut) then
                                       nn=nn+1

                                       iicontr(nn)=icontr(i)

                                       zzeta(nn)=zeta(i)

                                       ttwozetaa(nn)=twozetaa(i)
                                       ttwozetab(nn)=twozetab(i)

                                       ppx(nn)=px(i)
                                       ppy(nn)=py(i)
                                       ppz(nn)=pz(i)

                                       ppxax(nn)=pxax(i)
                                       ppyay(nn)=pyay(i)
                                       ppzaz(nn)=pzaz(i)

                                       zetarec(nn)=zetarec(i)

                                       sss0(nn)=sss0(i)
                                       sss1(nn)=sss1(i)
                                       sss2(nn)=sss2(i)
                                       sss3(nn)=sss3(i)
                                       sss4(nn)=sss4(i)
                                       sss5(nn)=sss5(i)
                                 endif
 1005 continue

      do 1006 i=1,nn
      zetac1(i)=zetaux*zetarec(i)
 1006 zetac2(i)=zzeta(i)*zetarec(i)

      do 1007 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 1007 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 1008 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1008 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1009 i=1,nn
      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
 1009 pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      do 1010 i=1,nn
      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
 1010 pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      do 1011 i=1,nn
      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
 1011 pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      do 1012 i=1,nn
      pss3(i,1)=ppxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=ppyay(i)*sss3(i)+wypy(i)*sss4(i)
 1012 pss3(i,3)=ppzaz(i)*sss3(i)+wzpz(i)*sss4(i)

      do 1013 i=1,nn
      pss4(i,1)=ppxax(i)*sss4(i)+wxpx(i)*sss5(i)
      pss4(i,2)=ppyay(i)*sss4(i)+wypy(i)*sss5(i)
 1013 pss4(i,3)=ppzaz(i)*sss4(i)+wzpz(i)*sss5(i)

      do 1014 i=1,nn
 1014 c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      do 1015 i=1,nn
      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
 1015 dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      do 1016 i=1,nn
 1016 c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      do 1017 i=1,nn
      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
 1017 dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      do 1018 i=1,nn
 1018 c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zzeta(i))

      do 1019 i=1,nn
      dss2(i,1)=ppxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=ppyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=ppzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=ppyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=ppzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
 1019 dss2(i,6)=ppzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

      do 1020 i=1,nn
 1020 c(i)=(sss3(i)-zetac1(i)*sss4(i))/(two*zzeta(i))

      do 1021 i=1,nn
      dss3(i,1)=ppxax(i)*pss3(i,1)+wxpx(i)*pss4(i,1)+c(i)
      dss3(i,2)=ppyay(i)*pss3(i,1)+wypy(i)*pss4(i,1)
      dss3(i,3)=ppzaz(i)*pss3(i,1)+wzpz(i)*pss4(i,1)
      dss3(i,4)=ppyay(i)*pss3(i,2)+wypy(i)*pss4(i,2)+c(i)
      dss3(i,5)=ppzaz(i)*pss3(i,2)+wzpz(i)*pss4(i,2)
 1021 dss3(i,6)=ppzaz(i)*pss3(i,3)+wzpz(i)*pss4(i,3)+c(i)

      do 1022 j=1,3
      do 1022 i=1,nn
 1022 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zzeta(i))

      do 1023 i=1,nn
      fss0(i,01)=ppxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=ppyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=ppzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=ppyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=ppzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=ppzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=ppyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=ppzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=ppzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 1023 fss0(i,10)=ppzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 1024 j=1,3
      do 1024 i=1,nn
 1024 c1(i,j)=(pss1(i,j)-zetac1(i)*pss2(i,j))/(two*zzeta(i))

      do 1025 i=1,nn
      fss1(i,01)=ppxax(i)*dss1(i,1)+wxpx(i)*dss2(i,1)+c1(i,1)+c1(i,1)
      fss1(i,02)=ppyay(i)*dss1(i,1)+wypy(i)*dss2(i,1)
      fss1(i,03)=ppzaz(i)*dss1(i,1)+wzpz(i)*dss2(i,1)
      fss1(i,04)=ppyay(i)*dss1(i,2)+wypy(i)*dss2(i,2)+c1(i,1)
      fss1(i,05)=ppzaz(i)*dss1(i,2)+wzpz(i)*dss2(i,2)
      fss1(i,06)=ppzaz(i)*dss1(i,3)+wzpz(i)*dss2(i,3)+c1(i,1)
      fss1(i,07)=ppyay(i)*dss1(i,4)+wypy(i)*dss2(i,4)+c1(i,2)+c1(i,2)
      fss1(i,08)=ppzaz(i)*dss1(i,4)+wzpz(i)*dss2(i,4)
      fss1(i,09)=ppzaz(i)*dss1(i,5)+wzpz(i)*dss2(i,5)+c1(i,2)
 1025 fss1(i,10)=ppzaz(i)*dss1(i,6)+wzpz(i)*dss2(i,6)+c1(i,3)+c1(i,3)

      do 1026 j=1,3
      do 1026 i=1,nn
 1026 c1(i,j)=(pss2(i,j)-zetac1(i)*pss3(i,j))/(two*zzeta(i))

      do 1027 i=1,nn
      fss2(i,01)=ppxax(i)*dss2(i,1)+wxpx(i)*dss3(i,1)+c1(i,1)+c1(i,1)
      fss2(i,02)=ppyay(i)*dss2(i,1)+wypy(i)*dss3(i,1)
      fss2(i,03)=ppzaz(i)*dss2(i,1)+wzpz(i)*dss3(i,1)
      fss2(i,04)=ppyay(i)*dss2(i,2)+wypy(i)*dss3(i,2)+c1(i,1)
      fss2(i,05)=ppzaz(i)*dss2(i,2)+wzpz(i)*dss3(i,2)
      fss2(i,06)=ppzaz(i)*dss2(i,3)+wzpz(i)*dss3(i,3)+c1(i,1)
      fss2(i,07)=ppyay(i)*dss2(i,4)+wypy(i)*dss3(i,4)+c1(i,2)+c1(i,2)
      fss2(i,08)=ppzaz(i)*dss2(i,4)+wzpz(i)*dss3(i,4)
      fss2(i,09)=ppzaz(i)*dss2(i,5)+wzpz(i)*dss3(i,5)+c1(i,2)
 1027 fss2(i,10)=ppzaz(i)*dss2(i,6)+wzpz(i)*dss3(i,6)+c1(i,3)+c1(i,3)

      do 1028 i=1,nn
      ssp1(i,1)=wxcx(i)*sss2(i)
      ssp1(i,2)=wycy(i)*sss2(i)
 1028 ssp1(i,3)=wzcz(i)*sss2(i)

      do 1029 i=1,nn
 1029 c(i)=half*sss1(i)*zetarec(i)

      do 1030 i=1,nn
      psp0(i,1)=wxcx(i)*pss1(i,1)+c(i)
      psp0(i,2)=wycy(i)*pss1(i,1)
      psp0(i,3)=wzcz(i)*pss1(i,1)
      psp0(i,4)=wxcx(i)*pss1(i,2)
      psp0(i,5)=wycy(i)*pss1(i,2)+c(i)
      psp0(i,6)=wzcz(i)*pss1(i,2)
      psp0(i,7)=wxcx(i)*pss1(i,3)
      psp0(i,8)=wycy(i)*pss1(i,3)
 1030 psp0(i,9)=wzcz(i)*pss1(i,3)+c(i)

      do 1031 i=1,nn
 1031 c(i)=half*sss2(i)*zetarec(i)

      do 1032 i=1,nn
      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
 1032 psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

      do 1033 j=1,3
      do 1033 i=1,nn
 1033 c1(i,j)=(pss0(i,j)-zetac2(i)*pss1(i,j))/(two*zetaux)

      do 1034 j=1,3
      do 1034 i=1,nn
 1034 c2(i,j)=half*ssp1(i,j)*zetarec(i)

      do 1035 i=1,nn
      psd0(i,01)=wxcx(i)*psp1(i,1)+c1(i,1)+c2(i,1)
      psd0(i,02)=wycy(i)*psp1(i,1)
      psd0(i,03)=wzcz(i)*psp1(i,1)
      psd0(i,04)=wycy(i)*psp1(i,2)+c1(i,1)
      psd0(i,05)=wzcz(i)*psp1(i,2)
      psd0(i,06)=wzcz(i)*psp1(i,3)+c1(i,1)
      psd0(i,07)=wxcx(i)*psp1(i,4)+c1(i,2)
      psd0(i,08)=wycy(i)*psp1(i,4)        +c2(i,1)
      psd0(i,09)=wzcz(i)*psp1(i,4)
      psd0(i,10)=wycy(i)*psp1(i,5)+c1(i,2)+c2(i,2)
      psd0(i,11)=wzcz(i)*psp1(i,5)
      psd0(i,12)=wzcz(i)*psp1(i,6)+c1(i,2)
      psd0(i,13)=wxcx(i)*psp1(i,7)+c1(i,3)
      psd0(i,14)=wycy(i)*psp1(i,7)
      psd0(i,15)=wzcz(i)*psp1(i,7)        +c2(i,1)
      psd0(i,16)=wycy(i)*psp1(i,8)+c1(i,3)
      psd0(i,17)=wzcz(i)*psp1(i,8)        +c2(i,2)
 1035 psd0(i,18)=wzcz(i)*psp1(i,9)+c1(i,3)+c2(i,3)

      do 1036 j=1,3
      do 1036 i=1,nn
 1036 c1(i,j)=half*pss1(i,j)*zetarec(i)

      do 1037 i=1,nn
      dsp0(i,01)=wxcx(i)*dss1(i,1)+c1(i,1)*two
      dsp0(i,02)=wycy(i)*dss1(i,1)
      dsp0(i,03)=wzcz(i)*dss1(i,1)
      dsp0(i,04)=wxcx(i)*dss1(i,2)+c1(i,2)
      dsp0(i,05)=wycy(i)*dss1(i,2)+c1(i,1)
      dsp0(i,06)=wzcz(i)*dss1(i,2)
      dsp0(i,07)=wxcx(i)*dss1(i,3)+c1(i,3)
      dsp0(i,08)=wycy(i)*dss1(i,3)
      dsp0(i,09)=wzcz(i)*dss1(i,3)+c1(i,1)
      dsp0(i,10)=wxcx(i)*dss1(i,4)
      dsp0(i,11)=wycy(i)*dss1(i,4)+c1(i,2)*two
      dsp0(i,12)=wzcz(i)*dss1(i,4)
      dsp0(i,13)=wxcx(i)*dss1(i,5)
      dsp0(i,14)=wycy(i)*dss1(i,5)+c1(i,3)
      dsp0(i,15)=wzcz(i)*dss1(i,5)+c1(i,2)
      dsp0(i,16)=wxcx(i)*dss1(i,6)
      dsp0(i,17)=wycy(i)*dss1(i,6)
 1037 dsp0(i,18)=wzcz(i)*dss1(i,6)+c1(i,3)*two

      do 1038 j=1,3
      do 1038 i=1,nn
 1038 c1(i,j)=half*pss2(i,j)*zetarec(i)

      do 1039 i=1,nn
      dsp1(i,01)=wxcx(i)*dss2(i,1)+c1(i,1)*two
      dsp1(i,02)=wycy(i)*dss2(i,1)
      dsp1(i,03)=wzcz(i)*dss2(i,1)
      dsp1(i,04)=wxcx(i)*dss2(i,2)+c1(i,2)
      dsp1(i,05)=wycy(i)*dss2(i,2)+c1(i,1)
      dsp1(i,06)=wzcz(i)*dss2(i,2)
      dsp1(i,07)=wxcx(i)*dss2(i,3)+c1(i,3)
      dsp1(i,08)=wycy(i)*dss2(i,3)
      dsp1(i,09)=wzcz(i)*dss2(i,3)+c1(i,1)
      dsp1(i,10)=wxcx(i)*dss2(i,4)
      dsp1(i,11)=wycy(i)*dss2(i,4)+c1(i,2)*two
      dsp1(i,12)=wzcz(i)*dss2(i,4)
      dsp1(i,13)=wxcx(i)*dss2(i,5)
      dsp1(i,14)=wycy(i)*dss2(i,5)+c1(i,3)
      dsp1(i,15)=wzcz(i)*dss2(i,5)+c1(i,2)
      dsp1(i,16)=wxcx(i)*dss2(i,6)
      dsp1(i,17)=wycy(i)*dss2(i,6)
 1039 dsp1(i,18)=wzcz(i)*dss2(i,6)+c1(i,3)*two

      do 1040 j=1,6
      do 1040 i=1,nn
 1040 c1(i,j)=(dss0(i,j)-zetac2(i)*dss1(i,j))/(two*zetaux)

      do 1041 j=1,9
      do 1041 i=1,nn
 1041 c2(i,j)=half*psp1(i,j)*zetarec(i)

      do 1042 i=1,nn
      dsd0(i,01)=wxcx(i)*dsp1(i,01)+c1(i,1)+c2(i,1)*two
      dsd0(i,02)=wycy(i)*dsp1(i,01)
      dsd0(i,03)=wzcz(i)*dsp1(i,01)
      dsd0(i,04)=wycy(i)*dsp1(i,02)+c1(i,1)
      dsd0(i,05)=wzcz(i)*dsp1(i,02)
      dsd0(i,06)=wzcz(i)*dsp1(i,03)+c1(i,1)
      dsd0(i,07)=wxcx(i)*dsp1(i,04)+c1(i,2)+c2(i,4)
      dsd0(i,08)=wycy(i)*dsp1(i,04)        +c2(i,1)
      dsd0(i,09)=wzcz(i)*dsp1(i,04)
      dsd0(i,10)=wycy(i)*dsp1(i,05)+c1(i,2)+c2(i,2)
      dsd0(i,11)=wzcz(i)*dsp1(i,05)
      dsd0(i,12)=wzcz(i)*dsp1(i,06)+c1(i,2)
      dsd0(i,13)=wxcx(i)*dsp1(i,07)+c1(i,3)+c2(i,7)
      dsd0(i,14)=wycy(i)*dsp1(i,07)
      dsd0(i,15)=wzcz(i)*dsp1(i,07)        +c2(i,1)
      dsd0(i,16)=wycy(i)*dsp1(i,08)+c1(i,3)
      dsd0(i,17)=wzcz(i)*dsp1(i,08)        +c2(i,2)
      dsd0(i,18)=wzcz(i)*dsp1(i,09)+c1(i,3)+c2(i,3)
      dsd0(i,19)=wxcx(i)*dsp1(i,10)+c1(i,4)
      dsd0(i,20)=wycy(i)*dsp1(i,10)        +c2(i,4)*two
      dsd0(i,21)=wzcz(i)*dsp1(i,10)
      dsd0(i,22)=wycy(i)*dsp1(i,11)+c1(i,4)+c2(i,5)*two
      dsd0(i,23)=wzcz(i)*dsp1(i,11)
      dsd0(i,24)=wzcz(i)*dsp1(i,12)+c1(i,4)
      dsd0(i,25)=wxcx(i)*dsp1(i,13)+c1(i,5)
      dsd0(i,26)=wycy(i)*dsp1(i,13)        +c2(i,7)
      dsd0(i,27)=wzcz(i)*dsp1(i,13)        +c2(i,4)
      dsd0(i,28)=wycy(i)*dsp1(i,14)+c1(i,5)+c2(i,8)
      dsd0(i,29)=wzcz(i)*dsp1(i,14)        +c2(i,5)
      dsd0(i,30)=wzcz(i)*dsp1(i,15)+c1(i,5)+c2(i,6)
      dsd0(i,31)=wxcx(i)*dsp1(i,16)+c1(i,6)
      dsd0(i,32)=wycy(i)*dsp1(i,16)
      dsd0(i,33)=wzcz(i)*dsp1(i,16)        +c2(i,7)*two
      dsd0(i,34)=wycy(i)*dsp1(i,17)+c1(i,6)
      dsd0(i,35)=wzcz(i)*dsp1(i,17)        +c2(i,8)*two
 1042 dsd0(i,36)=wzcz(i)*dsp1(i,18)+c1(i,6)+c2(i,9)*two

      do 1043 j=1,6
      do 1043 i=1,nn
 1043 c1(i,j)=half*dss1(i,j)*zetarec(i)

      do 1044 i=1,nn
      fsp0(i,01)=wxcx(i)*fss1(i,01)+c1(i,1)*three
      fsp0(i,02)=wycy(i)*fss1(i,01)
      fsp0(i,03)=wzcz(i)*fss1(i,01)
      fsp0(i,04)=wxcx(i)*fss1(i,02)+c1(i,2)*two
      fsp0(i,05)=wycy(i)*fss1(i,02)+c1(i,1)
      fsp0(i,06)=wzcz(i)*fss1(i,02)
      fsp0(i,07)=wxcx(i)*fss1(i,03)+c1(i,3)*two
      fsp0(i,08)=wycy(i)*fss1(i,03)
      fsp0(i,09)=wzcz(i)*fss1(i,03)+c1(i,1)
      fsp0(i,10)=wxcx(i)*fss1(i,04)+c1(i,4)
      fsp0(i,11)=wycy(i)*fss1(i,04)+c1(i,2)*two
      fsp0(i,12)=wzcz(i)*fss1(i,04)
      fsp0(i,13)=wxcx(i)*fss1(i,05)+c1(i,5)
      fsp0(i,14)=wycy(i)*fss1(i,05)+c1(i,3)
      fsp0(i,15)=wzcz(i)*fss1(i,05)+c1(i,2)
      fsp0(i,16)=wxcx(i)*fss1(i,06)+c1(i,6)
      fsp0(i,17)=wycy(i)*fss1(i,06)
      fsp0(i,18)=wzcz(i)*fss1(i,06)+c1(i,3)*two
      fsp0(i,19)=wxcx(i)*fss1(i,07)
      fsp0(i,20)=wycy(i)*fss1(i,07)+c1(i,4)*three
      fsp0(i,21)=wzcz(i)*fss1(i,07)
      fsp0(i,22)=wxcx(i)*fss1(i,08)
      fsp0(i,23)=wycy(i)*fss1(i,08)+c1(i,5)*two
      fsp0(i,24)=wzcz(i)*fss1(i,08)+c1(i,4)
      fsp0(i,25)=wxcx(i)*fss1(i,09)
      fsp0(i,26)=wycy(i)*fss1(i,09)+c1(i,6)
      fsp0(i,27)=wzcz(i)*fss1(i,09)+c1(i,5)*two
      fsp0(i,28)=wxcx(i)*fss1(i,10)
      fsp0(i,29)=wycy(i)*fss1(i,10)
 1044 fsp0(i,30)=wzcz(i)*fss1(i,10)+c1(i,6)*three

      do 1045 j=1,6
      do 1045 i=1,nn
 1045 c1(i,j)=half*dss2(i,j)*zetarec(i)

      do 1046 i=1,nn
      fsp1(i,01)=wxcx(i)*fss2(i,01)+c1(i,1)*three
      fsp1(i,02)=wycy(i)*fss2(i,01)
      fsp1(i,03)=wzcz(i)*fss2(i,01)
      fsp1(i,04)=wxcx(i)*fss2(i,02)+c1(i,2)*two
      fsp1(i,05)=wycy(i)*fss2(i,02)+c1(i,1)
      fsp1(i,06)=wzcz(i)*fss2(i,02)
      fsp1(i,07)=wxcx(i)*fss2(i,03)+c1(i,3)*two
      fsp1(i,08)=wycy(i)*fss2(i,03)
      fsp1(i,09)=wzcz(i)*fss2(i,03)+c1(i,1)
      fsp1(i,10)=wxcx(i)*fss2(i,04)+c1(i,4)
      fsp1(i,11)=wycy(i)*fss2(i,04)+c1(i,2)*two
      fsp1(i,12)=wzcz(i)*fss2(i,04)
      fsp1(i,13)=wxcx(i)*fss2(i,05)+c1(i,5)
      fsp1(i,14)=wycy(i)*fss2(i,05)+c1(i,3)
      fsp1(i,15)=wzcz(i)*fss2(i,05)+c1(i,2)
      fsp1(i,16)=wxcx(i)*fss2(i,06)+c1(i,6)
      fsp1(i,17)=wycy(i)*fss2(i,06)
      fsp1(i,18)=wzcz(i)*fss2(i,06)+c1(i,3)*two
      fsp1(i,19)=wxcx(i)*fss2(i,07)
      fsp1(i,20)=wycy(i)*fss2(i,07)+c1(i,4)*three
      fsp1(i,21)=wzcz(i)*fss2(i,07)
      fsp1(i,22)=wxcx(i)*fss2(i,08)
      fsp1(i,23)=wycy(i)*fss2(i,08)+c1(i,5)*two
      fsp1(i,24)=wzcz(i)*fss2(i,08)+c1(i,4)
      fsp1(i,25)=wxcx(i)*fss2(i,09)
      fsp1(i,26)=wycy(i)*fss2(i,09)+c1(i,6)
      fsp1(i,27)=wzcz(i)*fss2(i,09)+c1(i,5)*two
      fsp1(i,28)=wxcx(i)*fss2(i,10)
      fsp1(i,29)=wycy(i)*fss2(i,10)
 1046 fsp1(i,30)=wzcz(i)*fss2(i,10)+c1(i,6)*three

      do 1047 j=1,10
      do 1047 i=1,nn
 1047 c1(i,j)=(fss0(i,j)-zetac2(i)*fss1(i,j))/(two*zetaux)

      do 1048 j=1,18
      do 1048 i=1,nn
 1048 c2(i,j)=half*dsp1(i,j)*zetarec(i)

      do 1049 i=1,nn
      fsd0(i,01)=wxcx(i)*fsp1(i,01)+c1(i,01)+c2(i,01)*three
      fsd0(i,02)=wycy(i)*fsp1(i,01)
      fsd0(i,03)=wzcz(i)*fsp1(i,01)
      fsd0(i,04)=wycy(i)*fsp1(i,02)+c1(i,01)
      fsd0(i,05)=wzcz(i)*fsp1(i,02)
      fsd0(i,06)=wzcz(i)*fsp1(i,03)+c1(i,01)
      fsd0(i,07)=wxcx(i)*fsp1(i,04)+c1(i,02)+c2(i,04)*two
      fsd0(i,08)=wycy(i)*fsp1(i,04)         +c2(i,01)
      fsd0(i,09)=wzcz(i)*fsp1(i,04)
      fsd0(i,10)=wycy(i)*fsp1(i,05)+c1(i,02)+c2(i,02)
      fsd0(i,11)=wzcz(i)*fsp1(i,05)
      fsd0(i,12)=wzcz(i)*fsp1(i,06)+c1(i,02)
      fsd0(i,13)=wxcx(i)*fsp1(i,07)+c1(i,03)+c2(i,07)*two
      fsd0(i,14)=wycy(i)*fsp1(i,07)
      fsd0(i,15)=wzcz(i)*fsp1(i,07)         +c2(i,01)
      fsd0(i,16)=wycy(i)*fsp1(i,08)+c1(i,03)
      fsd0(i,17)=wzcz(i)*fsp1(i,08)         +c2(i,02)
      fsd0(i,18)=wzcz(i)*fsp1(i,09)+c1(i,03)+c2(i,03)
      fsd0(i,19)=wxcx(i)*fsp1(i,10)+c1(i,04)+c2(i,10)
      fsd0(i,20)=wycy(i)*fsp1(i,10)         +c2(i,04)*two
      fsd0(i,21)=wzcz(i)*fsp1(i,10)
      fsd0(i,22)=wycy(i)*fsp1(i,11)+c1(i,04)+c2(i,05)*two
      fsd0(i,23)=wzcz(i)*fsp1(i,11)
      fsd0(i,24)=wzcz(i)*fsp1(i,12)+c1(i,04)
      fsd0(i,25)=wxcx(i)*fsp1(i,13)+c1(i,05)+c2(i,13)
      fsd0(i,26)=wycy(i)*fsp1(i,13)         +c2(i,07)
      fsd0(i,27)=wzcz(i)*fsp1(i,13)         +c2(i,04)
      fsd0(i,28)=wycy(i)*fsp1(i,14)+c1(i,05)+c2(i,08)
      fsd0(i,29)=wzcz(i)*fsp1(i,14)         +c2(i,05)
      fsd0(i,30)=wzcz(i)*fsp1(i,15)+c1(i,05)+c2(i,06)
      fsd0(i,31)=wxcx(i)*fsp1(i,16)+c1(i,06)+c2(i,16)
      fsd0(i,32)=wycy(i)*fsp1(i,16)
      fsd0(i,33)=wzcz(i)*fsp1(i,16)         +c2(i,07)*two
      fsd0(i,34)=wycy(i)*fsp1(i,17)+c1(i,06)
      fsd0(i,35)=wzcz(i)*fsp1(i,17)         +c2(i,08)*two
      fsd0(i,36)=wzcz(i)*fsp1(i,18)+c1(i,06)+c2(i,09)*two
      fsd0(i,37)=wxcx(i)*fsp1(i,19)+c1(i,07)
      fsd0(i,38)=wycy(i)*fsp1(i,19)         +c2(i,10)*three
      fsd0(i,39)=wzcz(i)*fsp1(i,19)
      fsd0(i,40)=wycy(i)*fsp1(i,20)+c1(i,07)+c2(i,11)*three
      fsd0(i,41)=wzcz(i)*fsp1(i,20)
      fsd0(i,42)=wzcz(i)*fsp1(i,21)+c1(i,07)
      fsd0(i,43)=wxcx(i)*fsp1(i,22)+c1(i,08)
      fsd0(i,44)=wycy(i)*fsp1(i,22)         +c2(i,13)*two
      fsd0(i,45)=wzcz(i)*fsp1(i,22)         +c2(i,10)
      fsd0(i,46)=wycy(i)*fsp1(i,23)+c1(i,08)+c2(i,14)*two
      fsd0(i,47)=wzcz(i)*fsp1(i,23)         +c2(i,11)
      fsd0(i,48)=wzcz(i)*fsp1(i,24)+c1(i,08)+c2(i,12)
      fsd0(i,49)=wxcx(i)*fsp1(i,25)+c1(i,09)
      fsd0(i,50)=wycy(i)*fsp1(i,25)         +c2(i,16)
      fsd0(i,51)=wzcz(i)*fsp1(i,25)         +c2(i,13)*two
      fsd0(i,52)=wycy(i)*fsp1(i,26)+c1(i,09)+c2(i,17)
      fsd0(i,53)=wzcz(i)*fsp1(i,26)         +c2(i,14)*two
      fsd0(i,54)=wzcz(i)*fsp1(i,27)+c1(i,09)+c2(i,15)*two
      fsd0(i,55)=wxcx(i)*fsp1(i,28)+c1(i,10)
      fsd0(i,56)=wycy(i)*fsp1(i,28)
      fsd0(i,57)=wzcz(i)*fsp1(i,28)         +c2(i,16)*three
      fsd0(i,58)=wycy(i)*fsp1(i,29)+c1(i,10)
      fsd0(i,59)=wzcz(i)*fsp1(i,29)         +c2(i,17)*three
 1049 fsd0(i,60)=wzcz(i)*fsp1(i,30)+c1(i,10)+c2(i,18)*three

      do 1050 j=1,3
      do 1050 i=1,m
 1050 psscond(i,j)=zero

      do 1051 j=1,3
      do 1051 i=1,nn
 1051 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -pss0(i,j)*cdfits

      do 1052 k=1,3
      do 1052 j=1,3
      do 1052 i=1,nn
 1052 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -psp0(i,3*(j-1)+k)*cdfitp(k)

      do 1053 k=1,6
      do 1053 j=1,3
      do 1053 i=1,nn
 1053 psscond(iicontr(i),j)=psscond(iicontr(i),j)
     &                     -psd0(i,6*(j-1)+k)*cdfitd(k)

      do 1054 i=1,m
      grad(i,1)=psscond(i,1)*density(inddyy(i,1))*two
      grad(i,2)=psscond(i,2)*density(inddyy(i,2))
      grad(i,3)=psscond(i,3)*density(inddyy(i,3))
      grad(i,4)=psscond(i,1)*density(inddyy(i,2))
      grad(i,5)=psscond(i,2)*density(inddyy(i,4))*two
      grad(i,6)=psscond(i,3)*density(inddyy(i,5))
      grad(i,7)=psscond(i,1)*density(inddyy(i,3))
      grad(i,8)=psscond(i,2)*density(inddyy(i,5))
 1054 grad(i,9)=psscond(i,3)*density(inddyy(i,6))*two

      do 1055 k=1,3
      do 1055 j=1,3
      do 1055 i=1,m
 1055 gradient(k,nc)=gradient(k,nc)-grad(i,3*(k-1)+j)

      do 1056 k=1,3
      do 1056 j=1,3
      do 1056 i=1,m
 1056 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,3*(k-1)+j)

      do 1057 j=1,10
      do 1057 i=1,m
 1057 fsscond(i,j)=zero

      do 1058 j=1,10
      do 1058 i=1,nn
 1058 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fss0(i,j)*ttwozetaa(i)*cdfits

      do 1059 k=1,3
      do 1059 j=1,10
      do 1059 i=1,nn
 1059 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsp0(i,3*(j-1)+k)*ttwozetaa(i)*cdfitp(k)

      do 1060 k=1,6
      do 1060 j=1,10
      do 1060 i=1,nn
 1060 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsd0(i,6*(j-1)+k)*ttwozetaa(i)*cdfitd(k)

      do 1061 i=1,m
      grad(i,01)=fsscond(i,01)*density(inddyy(i,1))
      grad(i,02)=fsscond(i,02)*density(inddyy(i,2))
      grad(i,03)=fsscond(i,03)*density(inddyy(i,3))
      grad(i,04)=fsscond(i,04)*density(inddyy(i,4))
      grad(i,05)=fsscond(i,05)*density(inddyy(i,5))
      grad(i,06)=fsscond(i,06)*density(inddyy(i,6))
      grad(i,07)=fsscond(i,02)*density(inddyy(i,1))
      grad(i,08)=fsscond(i,04)*density(inddyy(i,2))
      grad(i,09)=fsscond(i,05)*density(inddyy(i,3))
      grad(i,10)=fsscond(i,07)*density(inddyy(i,4))
      grad(i,11)=fsscond(i,08)*density(inddyy(i,5))
      grad(i,12)=fsscond(i,09)*density(inddyy(i,6))
      grad(i,13)=fsscond(i,03)*density(inddyy(i,1))
      grad(i,14)=fsscond(i,05)*density(inddyy(i,2))
      grad(i,15)=fsscond(i,06)*density(inddyy(i,3))
      grad(i,16)=fsscond(i,08)*density(inddyy(i,4))
      grad(i,17)=fsscond(i,09)*density(inddyy(i,5))
 1061 grad(i,18)=fsscond(i,10)*density(inddyy(i,6))

      do 1062 k=1,3
      do 1062 j=1,6
      do 1062 i=1,m
 1062 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1063 k=1,3
      do 1063 j=1,6
      do 1063 i=1,m
 1063 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,6*(k-1)+j)

      do 1064 j=1,6
      do 1064 i=1,m
 1064 dsscond(i,j)=zero

      do 1065 j=1,10
      do 1065 i=1,m
 1065 fsscond(i,j)=zero

      do 1066 j=1,6
      do 1066 i=1,nn
 1066 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dss0(i,j)*ttwozetab(i)*cdfits

      do 1067 k=1,3
      do 1067 j=1,6
      do 1067 i=1,nn
 1067 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1068 k=1,6
      do 1068 j=1,6
      do 1068 i=1,nn
 1068 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1069 j=1,10
      do 1069 i=1,nn
 1069 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fss0(i,j)*ttwozetab(i)*cdfits

      do 1070 k=1,3
      do 1070 j=1,10
      do 1070 i=1,nn
 1070 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1071 k=1,6
      do 1071 j=1,10
      do 1071 i=1,nn
 1071 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1072 i=1,m
      dpscond(i,01)=axbx(i)*dsscond(i,1)+fsscond(i,01)
      dpscond(i,02)=ayby(i)*dsscond(i,1)+fsscond(i,02)
      dpscond(i,03)=azbz(i)*dsscond(i,1)+fsscond(i,03)
      dpscond(i,04)=axbx(i)*dsscond(i,2)+fsscond(i,02)
      dpscond(i,05)=ayby(i)*dsscond(i,2)+fsscond(i,04)
      dpscond(i,06)=azbz(i)*dsscond(i,2)+fsscond(i,05)
      dpscond(i,07)=axbx(i)*dsscond(i,3)+fsscond(i,03)
      dpscond(i,08)=ayby(i)*dsscond(i,3)+fsscond(i,05)
      dpscond(i,09)=azbz(i)*dsscond(i,3)+fsscond(i,06)
      dpscond(i,10)=axbx(i)*dsscond(i,4)+fsscond(i,04)
      dpscond(i,11)=ayby(i)*dsscond(i,4)+fsscond(i,07)
      dpscond(i,12)=azbz(i)*dsscond(i,4)+fsscond(i,08)
      dpscond(i,13)=axbx(i)*dsscond(i,5)+fsscond(i,05)
      dpscond(i,14)=ayby(i)*dsscond(i,5)+fsscond(i,08)
      dpscond(i,15)=azbz(i)*dsscond(i,5)+fsscond(i,09)
      dpscond(i,16)=axbx(i)*dsscond(i,6)+fsscond(i,06)
      dpscond(i,17)=ayby(i)*dsscond(i,6)+fsscond(i,09)
 1072 dpscond(i,18)=azbz(i)*dsscond(i,6)+fsscond(i,10)

      do 1073 i=1,m
      grad(i,01)=dpscond(i,01)*density(inddyy(i,1))
      grad(i,02)=dpscond(i,04)*density(inddyy(i,2))
      grad(i,03)=dpscond(i,07)*density(inddyy(i,3))
      grad(i,04)=dpscond(i,10)*density(inddyy(i,4))
      grad(i,05)=dpscond(i,13)*density(inddyy(i,5))
      grad(i,06)=dpscond(i,16)*density(inddyy(i,6))
      grad(i,07)=dpscond(i,02)*density(inddyy(i,1))
      grad(i,08)=dpscond(i,05)*density(inddyy(i,2))
      grad(i,09)=dpscond(i,08)*density(inddyy(i,3))
      grad(i,10)=dpscond(i,11)*density(inddyy(i,4))
      grad(i,11)=dpscond(i,14)*density(inddyy(i,5))
      grad(i,12)=dpscond(i,17)*density(inddyy(i,6))
      grad(i,13)=dpscond(i,03)*density(inddyy(i,1))
      grad(i,14)=dpscond(i,06)*density(inddyy(i,2))
      grad(i,15)=dpscond(i,09)*density(inddyy(i,3))
      grad(i,16)=dpscond(i,12)*density(inddyy(i,4))
      grad(i,17)=dpscond(i,15)*density(inddyy(i,5))
 1073 grad(i,18)=dpscond(i,18)*density(inddyy(i,6))

      do 1074 k=1,3
      do 1074 j=1,6
      do 1074 i=1,m
 1074 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1075 k=1,3
      do 1075 j=1,6
      do 1075 i=1,m
 1075 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

 1001 continue

      return
      end

      subroutine numxc(npoints,natoms,ncntrt,nconts,ncontp,ncontd,
     &                 ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,natomtype,
     &                 nptsatom,iwkvec,cent,alpha,coeff,fock1,fock2,
     &                 fock3,xpoints,ypoints,zpoints,weights,xcpota,
     &                 xcpotb,xcnrgy,xcpot1,xcpot2,xcenergy,qf,qftrans,
     &                 extent1,extent2,extent3,dcc,dump1,dump2,dump3,
     &                 wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension natomtype(*),nptsatom(*),iwkvec(*)

      dimension cent(3,*),alpha(*),coeff(*),fock1(*),fock2(*),fock3(*)

      dimension xpoints(*),ypoints(*),zpoints(*),weights(*)
      dimension xcpota(*),xcpotb(*),xcnrgy(*)
      dimension xcpot1(*),xcpot2(*),xcenergy(*)
      dimension qf(npoints,*),qftrans(ncntrt,*)
      dimension extent1(*),extent2(*),extent3(*),dcc(natoms,*)
      dimension dump1(*),dump2(*),dump3(*),wkvec(*)

      data zero,cutoff,tolerance/0.0d0,1.0d-18,1.0d-16/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      if(myid.eq.0) then
                          rewind 11
                          rewind 12
                    endif

      ncntsq=(ncntrt*(ncntrt+1))/2

      do 1001 i=1,ncntsq
      dump1(i)=zero
      dump2(i)=zero
 1001 dump3(i)=zero

      do 1002 i=1,natoms
      do 1002 j=1,natoms
 1002 dcc(j,i)=dist(cent(1,j),cent(1,i))

      call diffuse2(nconts,ncontp,ncontd,ilfunc,icfunc,ngauss,nptrs,
     &              nptrp,nptrd,cutoff,alpha,coeff,cent,extent1)

      do 1003 iatom=1,natoms

      if(natomtype(iatom).eq.0) goto 1003

      if(myid.eq.0) then
                          call fastrd(11,xpoints,nptsatom(iatom))
                          call fastrd(11,ypoints,nptsatom(iatom))
                          call fastrd(11,zpoints,nptsatom(iatom))

                          call fastrd(11,weights,nptsatom(iatom))

                          call fastrd(12,xcpota,nptsatom(iatom))
                          call fastrd(12,xcpotb,nptsatom(iatom))

                          call fastrd(12,xcnrgy,nptsatom(iatom))
                    endif

      do 1004 istart=1,nptsatom(iatom),npoints

      iend=min(istart+npoints-1,nptsatom(iatom))

      radius=sqrt((cent(1,iatom)-xpoints(iend))**2
     &           +(cent(2,iatom)-ypoints(iend))**2
     &           +(cent(3,iatom)-zpoints(iend))**2)

      call mpi_bcast(radius,1,mpi_real8,0,mpi_comm_world,ierr)

      npts=iend-istart+1

      nmaxloop=(npts/numprocs)+1
      if((nmaxloop*numprocs).lt.npts) nmaxloop=nmaxloop+1

      if(myid.eq.0) then

              ja=istart

              islave=0

              do 1005 i=1,npts,nmaxloop

              nloop=min(nmaxloop,npts-i+1)

              call mpi_bsend(nloop,1,mpi_integer,islave,
     &                       islave,mpi_comm_world,ierr)
              call mpi_bsend(ja,1,mpi_integer,islave,
     &                       islave,mpi_comm_world,ierr)

              call mpi_bsend(xpoints(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(ypoints(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(zpoints(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(weights(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(xcpota(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(xcpotb(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)
              call mpi_bsend(xcnrgy(ja),nloop,mpi_real8,
     &                       islave,islave,mpi_comm_world,ierr)

              ja=ja+nloop

              last_slave=islave

 1005         islave=islave+1

              do 1006 i=islave,numprocs-1
              ii=0
 1006         call mpi_bsend(ii,1,mpi_integer,i,i,mpi_comm_world,ierr)

                    endif

      call mpi_recv(npts,1,
     &              mpi_integer,0,mpi_any_tag,mpi_comm_world,istat,ierr)

      if(npts.eq.0) goto 1004

      call mpi_recv(ja,1,
     &              mpi_integer,0,mpi_any_tag,mpi_comm_world,istat,ierr)

      jb=ja+npts-1

      call mpi_recv(xpoints(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(ypoints(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(zpoints(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(weights(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(xcpota(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(xcpotb(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(xcnrgy(ja),npts,
     &              mpi_real8,0,mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1007 i=ja,jb
      xcpot1(i-ja+1)=xcpota(i)*weights(i)
      xcpot2(i-ja+1)=xcpotb(i)*weights(i)
 1007 xcenergy(i-ja+1)=xcnrgy(i)*weights(i)

      call compg0(iatom,ncntrt,npts,npoints,natoms,nconts,ncontp,ncontd,
     &            ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,radius,cent,
     &            alpha,coeff,xpoints(ja),ypoints(ja),zpoints(ja),qf,
     &            extent1,extent3,dcc,wkvec(00*npoints+1),
     &            wkvec(01*npoints+1),wkvec(02*npoints+1),
     &            wkvec(03*npoints+1),wkvec(04*npoints+1),
     &            wkvec(05*npoints+1),wkvec(06*npoints+1),
     &            wkvec(07*npoints+1),wkvec(08*npoints+1),
     &            wkvec(09*npoints+1),wkvec(10*npoints+1),
     &            wkvec(11*npoints+1))

      ihits=0

      do 1008 i=1,ncntrt
      if(extent3(i).gt.tolerance) then

                       ihits=ihits+1
                       iwkvec(ihits)=i

                       ii=i*(i-1)/2

                       ka=0*npts
                       kb=1*npts
                       kc=2*npts

                       do 1009 k=1,npts
                       wkvec(ka+k)=qf(k,i)*xcpot1(k)
                       wkvec(kb+k)=qf(k,i)*xcpot2(k)
 1009                  wkvec(kc+k)=qf(k,i)*xcenergy(k)

                       do 1010 j=1,ihits
                       jj=iwkvec(j)
                       if(extent3(i)*extent3(jj).lt.tolerance) goto 1010
                       ij=ii+jj
                       do 1011 k=1,npts
 1011                  dump1(ij)=dump1(ij)+qf(k,jj)*wkvec(ka+k)
                       do 1012 k=1,npts
 1012                  dump2(ij)=dump2(ij)+qf(k,jj)*wkvec(kb+k)
                       do 1013 k=1,npts
 1013                  dump3(ij)=dump3(ij)+qf(k,jj)*wkvec(kc+k)
 1010                  continue

                                  endif
 1008 continue

 1004 continue
 1003 continue

      call mpi_reduce(dump1,wkvec,ncntsq,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1014 i=1,ncntsq
 1014                     fock1(i)=fock1(i)+wkvec(i)
                    endif

      call mpi_bcast(fock1,ncntsq,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_reduce(dump2,wkvec,ncntsq,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1015 i=1,ncntsq
 1015                     fock2(i)=fock2(i)+wkvec(i)
                    endif

      call mpi_bcast(fock2,ncntsq,mpi_real8,0,mpi_comm_world,ierr)

      call mpi_reduce(dump3,wkvec,ncntsq,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1016 i=1,ncntsq
 1016                     fock3(i)=fock3(i)+wkvec(i)
                    endif

      call mpi_bcast(fock3,ncntsq,mpi_real8,0,mpi_comm_world,ierr)

      return
      end

      subroutine cdgrxs(ncds,ncdspd,ilfunc,icfunc,cdfitc,alpha,coeffs,
     &                  coeffp,coeffd,coord,gradient)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension g(4)
 
      dimension ilfunc(*),icfunc(*)

      dimension cdfitc(*),alpha(*),coeffs(*),coeffp(*),coeffd(*)
      dimension coord(3,*),gradient(3,*) 

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,forty9/4.0d0,5.0d0,49.0d0/
      data zero,pi/0.0d0,3.1415926535898d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      sqrt493=sqrt(forty9/three)
      factor=(pi**(five/four)*sqrt(two))**2

      ncombos=ncds*ncdspd

      nloop=ncombos/numprocs
      if((nloop*numprocs).lt.ncombos) nloop=nloop+1

      istart=myid*nloop+1
      iend=(myid+1)*nloop

      ij=0

      do 1001 i=1,ncdspd
      do 1001 j=1,ncds

      ij=ij+1

      if((ij.lt.istart).or.(ij.gt.iend)) goto 1001

      ilabel=ilfunc(ncds+i)
      jlabel=ilfunc(j)

      nc1=icfunc(ilabel)
      nc2=icfunc(jlabel)

      zetaa=alpha(ilabel)
      zetab=alpha(jlabel)

      axbx=coord(1,nc1)-coord(1,nc2)
      ayby=coord(2,nc1)-coord(2,nc2)
      azbz=coord(3,nc1)-coord(3,nc2)

      const=factor/(zetaa*zetab)

      zetaab=one/(zetaa+zetab)

      wxpx=(zetaa*coord(1,nc1)+zetab*coord(1,nc2))*zetaab-coord(1,nc1)
      wypy=(zetaa*coord(2,nc1)+zetab*coord(2,nc2))*zetaab-coord(2,nc1)
      wzpz=(zetaa*coord(3,nc1)+zetab*coord(3,nc2))*zetaab-coord(3,nc1)

      u=zetaa*zetab*zetaab*(axbx*axbx+ayby*ayby+azbz*azbz)

      call augg(4,u,g)

      s0=g(1)*const*sqrt(zetaab)
      s1=g(2)*const*sqrt(zetaab)
      s2=g(3)*const*sqrt(zetaab)
      s3=g(4)*const*sqrt(zetaab)

      px0=wxpx*s1
      py0=wypy*s1
      pz0=wzpz*s1

      px1=wxpx*s2
      py1=wypy*s2
      pz1=wzpz*s2

      px2=wxpx*s3
      py2=wypy*s3
      pz2=wzpz*s3

      cfact=(s0-zetab*zetaab*s1)/(two*zetaa)

      dxx0=wxpx*px1+cfact
      dxy0=wypy*px1
      dxz0=wzpz*px1
      dyy0=wypy*py1+cfact
      dyz0=wzpz*py1
      dzz0=wzpz*pz1+cfact

      cfact=(s1-zetab*zetaab*s2)/(two*zetaa)

      dxx1=wxpx*px2+cfact
      dxy1=wypy*px2
      dxz1=wzpz*px2
      dyy1=wypy*py2+cfact
      dyz1=wzpz*py2
      dzz1=wzpz*pz2+cfact

      cfactx=(px0-zetab*zetaab*px1)/(two*zetaa)
      cfacty=(py0-zetab*zetaab*py1)/(two*zetaa)
      cfactz=(pz0-zetab*zetaab*pz1)/(two*zetaa)

      fxxx0=wxpx*dxx1+cfactx+cfactx
      fxxy0=wypy*dxx1
      fxxz0=wzpz*dxx1
      fxyy0=wypy*dxy1+cfactx
      fxyz0=wzpz*dxy1
      fxzz0=wzpz*dxz1+cfactx
      fyyy0=wypy*dyy1+cfacty+cfacty
      fyyz0=wzpz*dyy1
      fyzz0=wzpz*dyz1+cfacty
      fzzz0=wzpz*dzz1+cfactz+cfactz

      n=ncds+(i-1)*10

      cfa01=cdfitc(n+01)
      cfa02=cdfitc(n+02)
      cfa03=cdfitc(n+03)
      cfa04=cdfitc(n+04)
      cfa05=cdfitc(n+05)/sqrt493
      cfa06=cdfitc(n+06)
      cfa07=cdfitc(n+07)
      cfa08=cdfitc(n+08)/sqrt493
      cfa09=cdfitc(n+09)
      cfa10=cdfitc(n+10)/sqrt493

      cfb01=cdfitc(j)

      css=cfa01*cfb01*coeffs(ilabel)*coeffs(jlabel)
      cpx=cfa02*cfb01*coeffp(ilabel)*coeffs(jlabel)
      cpy=cfa03*cfb01*coeffp(ilabel)*coeffs(jlabel)
      cpz=cfa04*cfb01*coeffp(ilabel)*coeffs(jlabel)
      cxx=cfa05*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cxy=cfa06*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cxz=cfa07*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cyy=cfa08*cfb01*coeffd(ilabel)*coeffs(jlabel)
      cyz=cfa09*cfb01*coeffd(ilabel)*coeffs(jlabel)
      czz=cfa10*cfb01*coeffd(ilabel)*coeffs(jlabel)

      factorx=zero
      factory=zero
      factorz=zero

      factorx=factorx-two*zetaa*(css*px0
     &                          +cpx*dxx0  +cpy*dxy0  +cpz*dxz0
     &                          +cxx*fxxx0 +cxy*fxxy0 +cxz*fxxz0
     &                          +cyy*fxyy0 +cyz*fxyz0 +czz*fxzz0)

      factory=factory-two*zetaa*(css*py0
     &                          +cpx*dxy0  +cpy*dyy0  +cpz*dyz0
     &                          +cxx*fxxy0 +cxy*fxyy0 +cxz*fxyz0
     &                          +cyy*fyyy0 +cyz*fyyz0 +czz*fyzz0)

      factorz=factorz-two*zetaa*(css*pz0
     &                          +cpx*dxz0  +cpy*dyz0  +cpz*dzz0
     &                          +cxx*fxxz0 +cxy*fxyz0 +cxz*fxzz0
     &                          +cyy*fyyz0 +cyz*fyzz0 +czz*fzzz0)

      factorx=factorx+cpx*s0+cxx*px0+cxy*py0+cxz*pz0+cxx*px0
      factory=factory+cpy*s0+cxy*px0+cyy*py0+cyz*pz0+cyy*py0
      factorz=factorz+cpz*s0+cxz*px0+cyz*py0+czz*pz0+czz*pz0

      gradient(1,nc1)=gradient(1,nc1)+factorx
      gradient(2,nc1)=gradient(2,nc1)+factory
      gradient(3,nc1)=gradient(3,nc1)+factorz

      gradient(1,nc2)=gradient(1,nc2)-factorx
      gradient(2,nc2)=gradient(2,nc2)-factory
      gradient(3,nc2)=gradient(3,nc2)-factorz

 1001 continue

      return
      end

      subroutine coreps(m,n,ncentr,icontr,inddyy,iloc,coord,charge,
     &                  overlap,core,zeta,px,py,pz,pxax,pyay,pzaz,eta,
     &                  base,etarr,ss,ss0,ss1,ps,pscond,pxcx,pycy,pzcz,
     &                  u,eta2)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),iloc(*)

      dimension coord(3,*),charge(*),overlap(*),core(*),zeta(*),
     &          px(*),py(*),pz(*),pxax(*),pyay(*),pzaz(*),eta(*),
     &          base(*),etarr(*),ss(*),ss0(*),ss1(*),ps(n,*),
     &          pscond(n,*),pxcx(*),pycy(*),pzcz(*),u(*),eta2(*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 eta2(i)=two*eta(i)

      do 1002 i=1,n
 1002 ss(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps(i,1)=pxax(i)*ss(i)
      ps(i,2)=pyay(i)*ss(i)
 1003 ps(i,3)=pzaz(i)*ss(i)

      do 1004 j=1,3
      do 1004 i=1,n
 1004 overlap(inddyy(icontr(i),j))=overlap(inddyy(icontr(i),j))+ps(i,j)

      do 1005 i=1,n
 1005 ss(i)=eta(i)*(three-two*etarr(i))*ss(i)

      do 1006 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps(i,2)
 1006 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps(i,3)

      do 1007 j=1,3
      do 1007 i=1,n
 1007 core(inddyy(icontr(i),j))=core(inddyy(icontr(i),j))+ps(i,j)

      do 1008 j=1,3
      do 1008 i=1,n
 1008 pscond(i,j)=zero

      do 2001 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 2002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 2002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      call auggv(2,n,iloc,u,ps,ss,ss0,ss1)

      do 2003 i=1,n
      ss0(i)=base(i)*ps(i,1)*twopichrg/zeta(i)
 2003 ss1(i)=base(i)*ps(i,2)*twopichrg/zeta(i)

      do 2004 i=1,n
      ps(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 2004 ps(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      do 2005 j=1,3
      do 2005 i=1,n
 2005 pscond(i,j)=pscond(i,j)+ps(i,j)

 2001 continue

      do 2006 j=1,3
      do 2006 i=1,n
 2006 core(inddyy(icontr(i),j))=core(inddyy(icontr(i),j))-pscond(i,j)

      return
      end

      subroutine efidd(m,n,iminj,icontr,inddyy,esp,efix,efiy,efiz,ccx,
     &                 ccy,ccz,g,density,zeta,axbx,ayby,azbz,px,py,pz,
     &                 pxax,pyay,pzaz,base,ss0,ss1,ss2,ss3,ss4,ps0,ps1,
     &                 ps2,ps3,dscond,ds0,ds1,ds2,fscond,fs0,fs1,gscond,
     &                 gs0,dpcond,fpcond,ddcond,c,c1,c2,pxcx,pycy,
     &                 pzcz,u,twozeta,cx,cy,cz,cx1,cy1,cz1,cx2,cy2,cz2,
     &                 ss5,saxs0,says0,sazs0,saxs1,says1,sazs1,saxs2,
     &                 says2,sazs2,saxs3,says3,sazs3,saxs4,says4,sazs4,
     &                 paxs0,pays0,pazs0,paxs1,pays1,pazs1,paxs2,pays2,
     &                 pazs2,paxs3,pays3,pazs3,daxs0,days0,dazs0,daxs1,
     &                 days1,dazs1,daxs2,days2,dazs2,faxs0,fays0,fazs0,
     &                 faxs1,fays1,fazs1,gaxs0,gays0,gazs0,daxscond,
     &                 dayscond,dazscond,faxscond,fayscond,fazscond, 
     &                 gaxscond,gayscond,gazscond,daxpcond,daypcond,
     &                 dazpcond,faxpcond,faypcond,fazpcond,daxdcond,
     &                 daydcond,dazdcond)

c  this subroutine written by roger gallant and alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*)

      dimension g(*),density(*),zeta(*),axbx(*),ayby(*),azbz(*),px(*),
     &          py(*),pz(*),pxax(*),pyay(*),pzaz(*),base(*),ss0(*),
     &          ss1(*),ss2(*),ss3(*),ss4(*),ps0(n,*),ps1(n,*),ps2(n,*),
     &          ps3(n,*),dscond(m,*),ds0(n,*),ds1(n,*),ds2(n,*),
     &          fscond(m,*),fs0(n,*),fs1(n,*),gscond(m,*),gs0(n,*),
     &          dpcond(m,*),fpcond(m,*),ddcond(m,*),c(*),c1(n,*),
     &          c2(n,*),pxcx(*),pycy(*),pzcz(*),u(*),twozeta(*),
     &          cx(*),cy(*),cz(*),cx1(n,*),cy1(n,*),cz1(n,*),cx2(n,*),
     &          cy2(n,*),cz2(n,*),ss5(*),saxs0(*),says0(*),sazs0(*),
     &          saxs1(*),says1(*),sazs1(*),saxs2(*),says2(*),sazs2(*),
     &          saxs3(*),says3(*),sazs3(*),saxs4(*),says4(*),sazs4(*),
     &          paxs0(n,*),pays0(n,*),pazs0(n,*),paxs1(n,*),pays1(n,*),
     &          pazs1(n,*),paxs2(n,*),pays2(n,*),pazs2(n,*),paxs3(n,*),
     &          pays3(n,*),pazs3(n,*),daxs0(n,*),days0(n,*),dazs0(n,*),
     &          daxs1(n,*),days1(n,*),dazs1(n,*),daxs2(n,*),days2(n,*),
     &          dazs2(n,*),faxs0(n,*),fays0(n,*),fazs0(n,*),faxs1(n,*),
     &          fays1(n,*),fazs1(n,*),gaxs0(n,*),gays0(n,*),gazs0(n,*),
     &          daxscond(m,*),dayscond(m,*),dazscond(m,*),faxscond(m,*),
     &          fayscond(m,*),fazscond(m,*),gaxscond(m,*),gayscond(m,*),
     &          gazscond(m,*),daxpcond(m,*),daypcond(m,*),dazpcond(m,*),
     &          faxpcond(m,*),faypcond(m,*),fazpcond(m,*),daxdcond(m,*),
     &          daydcond(m,*),dazdcond(m,*)

      data zero,two,three,pi/0.0d0,2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      twopi=two*pi

      do 1002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1003 i=1,n
      call augg(6,u(i),g)
      ss0(i)=base(i)*g(1)*twopi/zeta(i)
      ss1(i)=base(i)*g(2)*twopi/zeta(i)
      ss2(i)=base(i)*g(3)*twopi/zeta(i)
      ss3(i)=base(i)*g(4)*twopi/zeta(i)
      ss4(i)=base(i)*g(5)*twopi/zeta(i)
 1003 ss5(i)=base(i)*g(6)*twopi/zeta(i)

      do 1004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

      ps2(i,1)=pxax(i)*ss2(i)-pxcx(i)*ss3(i)
      ps2(i,2)=pyay(i)*ss2(i)-pycy(i)*ss3(i)
      ps2(i,3)=pzaz(i)*ss2(i)-pzcz(i)*ss3(i)

      ps3(i,1)=pxax(i)*ss3(i)-pxcx(i)*ss4(i)
      ps3(i,2)=pyay(i)*ss3(i)-pycy(i)*ss4(i)
      ps3(i,3)=pzaz(i)*ss3(i)-pzcz(i)*ss4(i)

 1004 continue

      do 1005 i=1,n
 1005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1007 i=1,n
 1007 c(i)=(ss1(i)-ss2(i))/twozeta(i)

      do 1008 i=1,n
      ds1(i,1)=pxax(i)*ps1(i,1)-pxcx(i)*ps2(i,1)+c(i)
      ds1(i,2)=pyay(i)*ps1(i,1)-pycy(i)*ps2(i,1)
      ds1(i,3)=pzaz(i)*ps1(i,1)-pzcz(i)*ps2(i,1)
      ds1(i,4)=pyay(i)*ps1(i,2)-pycy(i)*ps2(i,2)+c(i)
      ds1(i,5)=pzaz(i)*ps1(i,2)-pzcz(i)*ps2(i,2)
 1008 ds1(i,6)=pzaz(i)*ps1(i,3)-pzcz(i)*ps2(i,3)+c(i)

      do 1009 i=1,n
 1009 c(i)=(ss2(i)-ss3(i))/twozeta(i)

      do 1010 i=1,n
      ds2(i,1)=pxax(i)*ps2(i,1)-pxcx(i)*ps3(i,1)+c(i)
      ds2(i,2)=pyay(i)*ps2(i,1)-pycy(i)*ps3(i,1)
      ds2(i,3)=pzaz(i)*ps2(i,1)-pzcz(i)*ps3(i,1)
      ds2(i,4)=pyay(i)*ps2(i,2)-pycy(i)*ps3(i,2)+c(i)
      ds2(i,5)=pzaz(i)*ps2(i,2)-pzcz(i)*ps3(i,2)
 1010 ds2(i,6)=pzaz(i)*ps2(i,3)-pzcz(i)*ps3(i,3)+c(i)

      do 1011 j=1,3
      do 1011 i=1,n
 1011 c1(i,j)=(ps0(i,j)-ps1(i,j))/twozeta(i)

      do 1012 i=1,n
      fs0(i,01)=pxax(i)*ds0(i,1)-pxcx(i)*ds1(i,1)+c1(i,1)*two
      fs0(i,02)=pyay(i)*ds0(i,1)-pycy(i)*ds1(i,1)
      fs0(i,03)=pzaz(i)*ds0(i,1)-pzcz(i)*ds1(i,1)
      fs0(i,04)=pyay(i)*ds0(i,2)-pycy(i)*ds1(i,2)+c1(i,1)
      fs0(i,05)=pzaz(i)*ds0(i,2)-pzcz(i)*ds1(i,2)
      fs0(i,06)=pzaz(i)*ds0(i,3)-pzcz(i)*ds1(i,3)+c1(i,1)
      fs0(i,07)=pyay(i)*ds0(i,4)-pycy(i)*ds1(i,4)+c1(i,2)*two
      fs0(i,08)=pzaz(i)*ds0(i,4)-pzcz(i)*ds1(i,4)
      fs0(i,09)=pzaz(i)*ds0(i,5)-pzcz(i)*ds1(i,5)+c1(i,2)
 1012 fs0(i,10)=pzaz(i)*ds0(i,6)-pzcz(i)*ds1(i,6)+c1(i,3)*two

      do 1013 j=1,3
      do 1013 i=1,n
 1013 c1(i,j)=(ps1(i,j)-ps2(i,j))/twozeta(i)

      do 1014 i=1,n
      fs1(i,01)=pxax(i)*ds1(i,1)-pxcx(i)*ds2(i,1)+c1(i,1)*two
      fs1(i,02)=pyay(i)*ds1(i,1)-pycy(i)*ds2(i,1)
      fs1(i,03)=pzaz(i)*ds1(i,1)-pzcz(i)*ds2(i,1)
      fs1(i,04)=pyay(i)*ds1(i,2)-pycy(i)*ds2(i,2)+c1(i,1)
      fs1(i,05)=pzaz(i)*ds1(i,2)-pzcz(i)*ds2(i,2)
      fs1(i,06)=pzaz(i)*ds1(i,3)-pzcz(i)*ds2(i,3)+c1(i,1)
      fs1(i,07)=pyay(i)*ds1(i,4)-pycy(i)*ds2(i,4)+c1(i,2)*two
      fs1(i,08)=pzaz(i)*ds1(i,4)-pzcz(i)*ds2(i,4)
      fs1(i,09)=pzaz(i)*ds1(i,5)-pzcz(i)*ds2(i,5)+c1(i,2)
 1014 fs1(i,10)=pzaz(i)*ds1(i,6)-pzcz(i)*ds2(i,6)+c1(i,3)*two

      do 1015 j=1,6
      do 1015 i=1,n
 1015 c2(i,j)=(ds0(i,j)-ds1(i,j))/twozeta(i)

      do 1016 i=1,n
      gs0(i,01)=pxax(i)*fs0(i,01)-pxcx(i)*fs1(i,01)+c2(i,1)*three
      gs0(i,02)=pyay(i)*fs0(i,01)-pycy(i)*fs1(i,01)
      gs0(i,03)=pzaz(i)*fs0(i,01)-pzcz(i)*fs1(i,01)
      gs0(i,04)=pyay(i)*fs0(i,02)-pycy(i)*fs1(i,02)+c2(i,1)
      gs0(i,05)=pzaz(i)*fs0(i,02)-pzcz(i)*fs1(i,02)
      gs0(i,06)=pzaz(i)*fs0(i,03)-pzcz(i)*fs1(i,03)+c2(i,1)
      gs0(i,07)=pyay(i)*fs0(i,04)-pycy(i)*fs1(i,04)+c2(i,2)*two
      gs0(i,08)=pzaz(i)*fs0(i,04)-pzcz(i)*fs1(i,04)
      gs0(i,09)=pzaz(i)*fs0(i,05)-pzcz(i)*fs1(i,05)+c2(i,2)
      gs0(i,10)=pzaz(i)*fs0(i,06)-pzcz(i)*fs1(i,06)+c2(i,3)*two
      gs0(i,11)=pyay(i)*fs0(i,07)-pycy(i)*fs1(i,07)+c2(i,4)*three
      gs0(i,12)=pzaz(i)*fs0(i,07)-pzcz(i)*fs1(i,07)
      gs0(i,13)=pzaz(i)*fs0(i,08)-pzcz(i)*fs1(i,08)+c2(i,4)
      gs0(i,14)=pzaz(i)*fs0(i,09)-pzcz(i)*fs1(i,09)+c2(i,5)*two
 1016 gs0(i,15)=pzaz(i)*fs0(i,10)-pzcz(i)*fs1(i,10)+c2(i,6)*three

      do 1017 i=1,n

      saxs0(i)=twozeta(i)*pxcx(i)*ss1(i)
      says0(i)=twozeta(i)*pycy(i)*ss1(i)
      sazs0(i)=twozeta(i)*pzcz(i)*ss1(i)

      saxs1(i)=twozeta(i)*pxcx(i)*ss2(i)
      says1(i)=twozeta(i)*pycy(i)*ss2(i)
      sazs1(i)=twozeta(i)*pzcz(i)*ss2(i)

      saxs2(i)=twozeta(i)*pxcx(i)*ss3(i)
      says2(i)=twozeta(i)*pycy(i)*ss3(i)
      sazs2(i)=twozeta(i)*pzcz(i)*ss3(i)

      saxs3(i)=twozeta(i)*pxcx(i)*ss4(i)
      says3(i)=twozeta(i)*pycy(i)*ss4(i)
      sazs3(i)=twozeta(i)*pzcz(i)*ss4(i)

      saxs4(i)=twozeta(i)*pxcx(i)*ss5(i)
      says4(i)=twozeta(i)*pycy(i)*ss5(i)
      sazs4(i)=twozeta(i)*pzcz(i)*ss5(i)

 1017 continue

      do 1018 i=1,n

      paxs0(i,1)=pxax(i)*saxs0(i)-pxcx(i)*saxs1(i)+ss1(i)
      paxs0(i,2)=pyay(i)*saxs0(i)-pycy(i)*saxs1(i)
      paxs0(i,3)=pzaz(i)*saxs0(i)-pzcz(i)*saxs1(i)
      pays0(i,1)=pxax(i)*says0(i)-pxcx(i)*says1(i)
      pays0(i,2)=pyay(i)*says0(i)-pycy(i)*says1(i)+ss1(i)
      pays0(i,3)=pzaz(i)*says0(i)-pzcz(i)*says1(i)
      pazs0(i,1)=pxax(i)*sazs0(i)-pxcx(i)*sazs1(i)
      pazs0(i,2)=pyay(i)*sazs0(i)-pycy(i)*sazs1(i)
      pazs0(i,3)=pzaz(i)*sazs0(i)-pzcz(i)*sazs1(i)+ss1(i)

      paxs1(i,1)=pxax(i)*saxs1(i)-pxcx(i)*saxs2(i)+ss2(i)
      paxs1(i,2)=pyay(i)*saxs1(i)-pycy(i)*saxs2(i)
      paxs1(i,3)=pzaz(i)*saxs1(i)-pzcz(i)*saxs2(i)
      pays1(i,1)=pxax(i)*says1(i)-pxcx(i)*says2(i)
      pays1(i,2)=pyay(i)*says1(i)-pycy(i)*says2(i)+ss2(i)
      pays1(i,3)=pzaz(i)*says1(i)-pzcz(i)*says2(i)
      pazs1(i,1)=pxax(i)*sazs1(i)-pxcx(i)*sazs2(i)
      pazs1(i,2)=pyay(i)*sazs1(i)-pycy(i)*sazs2(i)
      pazs1(i,3)=pzaz(i)*sazs1(i)-pzcz(i)*sazs2(i)+ss2(i)

      paxs2(i,1)=pxax(i)*saxs2(i)-pxcx(i)*saxs3(i)+ss3(i)
      paxs2(i,2)=pyay(i)*saxs2(i)-pycy(i)*saxs3(i)
      paxs2(i,3)=pzaz(i)*saxs2(i)-pzcz(i)*saxs3(i)
      pays2(i,1)=pxax(i)*says2(i)-pxcx(i)*says3(i)
      pays2(i,2)=pyay(i)*says2(i)-pycy(i)*says3(i)+ss3(i)
      pays2(i,3)=pzaz(i)*says2(i)-pzcz(i)*says3(i)
      pazs2(i,1)=pxax(i)*sazs2(i)-pxcx(i)*sazs3(i)
      pazs2(i,2)=pyay(i)*sazs2(i)-pycy(i)*sazs3(i)
      pazs2(i,3)=pzaz(i)*sazs2(i)-pzcz(i)*sazs3(i)+ss3(i)

      paxs3(i,1)=pxax(i)*saxs3(i)-pxcx(i)*saxs4(i)+ss4(i)
      paxs3(i,2)=pyay(i)*saxs3(i)-pycy(i)*saxs4(i)
      paxs3(i,3)=pzaz(i)*saxs3(i)-pzcz(i)*saxs4(i)
      pays3(i,1)=pxax(i)*says3(i)-pxcx(i)*says4(i)
      pays3(i,2)=pyay(i)*says3(i)-pycy(i)*says4(i)+ss4(i)
      pays3(i,3)=pzaz(i)*says3(i)-pzcz(i)*says4(i)
      pazs3(i,1)=pxax(i)*sazs3(i)-pxcx(i)*sazs4(i)
      pazs3(i,2)=pyay(i)*sazs3(i)-pycy(i)*sazs4(i)
      pazs3(i,3)=pzaz(i)*sazs3(i)-pzcz(i)*sazs4(i)+ss4(i)

 1018 continue

      do 1019 i=1,n
      cx(i)=(saxs0(i)-saxs1(i))/twozeta(i)
      cy(i)=(says0(i)-says1(i))/twozeta(i)
 1019 cz(i)=(sazs0(i)-sazs1(i))/twozeta(i)

      do 1020 i=1,n
      daxs0(i,1)=pxax(i)*paxs0(i,1)-pxcx(i)*paxs1(i,1)+cx(i)+ps1(i,1)
      daxs0(i,2)=pyay(i)*paxs0(i,1)-pycy(i)*paxs1(i,1)
      daxs0(i,3)=pzaz(i)*paxs0(i,1)-pzcz(i)*paxs1(i,1)
      daxs0(i,4)=pyay(i)*paxs0(i,2)-pycy(i)*paxs1(i,2)+cx(i)
      daxs0(i,5)=pzaz(i)*paxs0(i,2)-pzcz(i)*paxs1(i,2)
      daxs0(i,6)=pzaz(i)*paxs0(i,3)-pzcz(i)*paxs1(i,3)+cx(i)
      days0(i,1)=pxax(i)*pays0(i,1)-pxcx(i)*pays1(i,1)+cy(i)
      days0(i,2)=pyay(i)*pays0(i,1)-pycy(i)*pays1(i,1)      +ps1(i,1)
      days0(i,3)=pzaz(i)*pays0(i,1)-pzcz(i)*pays1(i,1)
      days0(i,4)=pyay(i)*pays0(i,2)-pycy(i)*pays1(i,2)+cy(i)+ps1(i,2)
      days0(i,5)=pzaz(i)*pays0(i,2)-pzcz(i)*pays1(i,2)
      days0(i,6)=pzaz(i)*pays0(i,3)-pzcz(i)*pays1(i,3)+cy(i)
      dazs0(i,1)=pxax(i)*pazs0(i,1)-pxcx(i)*pazs1(i,1)+cz(i)
      dazs0(i,2)=pyay(i)*pazs0(i,1)-pycy(i)*pazs1(i,1)
      dazs0(i,3)=pzaz(i)*pazs0(i,1)-pzcz(i)*pazs1(i,1)      +ps1(i,1)
      dazs0(i,4)=pyay(i)*pazs0(i,2)-pycy(i)*pazs1(i,2)+cz(i)
      dazs0(i,5)=pzaz(i)*pazs0(i,2)-pzcz(i)*pazs1(i,2)      +ps1(i,2)
 1020 dazs0(i,6)=pzaz(i)*pazs0(i,3)-pzcz(i)*pazs1(i,3)+cz(i)+ps1(i,3)

      do 1021 i=1,n
      cx(i)=(saxs1(i)-saxs2(i))/twozeta(i)
      cy(i)=(says1(i)-says2(i))/twozeta(i)
 1021 cz(i)=(sazs1(i)-sazs2(i))/twozeta(i)

      do 1022 i=1,n
      daxs1(i,1)=pxax(i)*paxs1(i,1)-pxcx(i)*paxs2(i,1)+cx(i)+ps2(i,1)
      daxs1(i,2)=pyay(i)*paxs1(i,1)-pycy(i)*paxs2(i,1)
      daxs1(i,3)=pzaz(i)*paxs1(i,1)-pzcz(i)*paxs2(i,1)
      daxs1(i,4)=pyay(i)*paxs1(i,2)-pycy(i)*paxs2(i,2)+cx(i)
      daxs1(i,5)=pzaz(i)*paxs1(i,2)-pzcz(i)*paxs2(i,2)
      daxs1(i,6)=pzaz(i)*paxs1(i,3)-pzcz(i)*paxs2(i,3)+cx(i)
      days1(i,1)=pxax(i)*pays1(i,1)-pxcx(i)*pays2(i,1)+cy(i)
      days1(i,2)=pyay(i)*pays1(i,1)-pycy(i)*pays2(i,1)      +ps2(i,1)
      days1(i,3)=pzaz(i)*pays1(i,1)-pzcz(i)*pays2(i,1)
      days1(i,4)=pyay(i)*pays1(i,2)-pycy(i)*pays2(i,2)+cy(i)+ps2(i,2)
      days1(i,5)=pzaz(i)*pays1(i,2)-pzcz(i)*pays2(i,2)
      days1(i,6)=pzaz(i)*pays1(i,3)-pzcz(i)*pays2(i,3)+cy(i)
      dazs1(i,1)=pxax(i)*pazs1(i,1)-pxcx(i)*pazs2(i,1)+cz(i)
      dazs1(i,2)=pyay(i)*pazs1(i,1)-pycy(i)*pazs2(i,1)
      dazs1(i,3)=pzaz(i)*pazs1(i,1)-pzcz(i)*pazs2(i,1)      +ps2(i,1)
      dazs1(i,4)=pyay(i)*pazs1(i,2)-pycy(i)*pazs2(i,2)+cz(i)
      dazs1(i,5)=pzaz(i)*pazs1(i,2)-pzcz(i)*pazs2(i,2)      +ps2(i,2)
 1022 dazs1(i,6)=pzaz(i)*pazs1(i,3)-pzcz(i)*pazs2(i,3)+cz(i)+ps2(i,3)

      do 1023 i=1,n
      cx(i)=(saxs2(i)-saxs3(i))/twozeta(i)
      cy(i)=(says2(i)-says3(i))/twozeta(i)
 1023 cz(i)=(sazs2(i)-sazs3(i))/twozeta(i)

      do 1024 i=1,n
      daxs2(i,1)=pxax(i)*paxs2(i,1)-pxcx(i)*paxs3(i,1)+cx(i)+ps3(i,1)
      daxs2(i,2)=pyay(i)*paxs2(i,1)-pycy(i)*paxs3(i,1)
      daxs2(i,3)=pzaz(i)*paxs2(i,1)-pzcz(i)*paxs3(i,1)
      daxs2(i,4)=pyay(i)*paxs2(i,2)-pycy(i)*paxs3(i,2)+cx(i)
      daxs2(i,5)=pzaz(i)*paxs2(i,2)-pzcz(i)*paxs3(i,2)
      daxs2(i,6)=pzaz(i)*paxs2(i,3)-pzcz(i)*paxs3(i,3)+cx(i)
      days2(i,1)=pxax(i)*pays2(i,1)-pxcx(i)*pays3(i,1)+cy(i)
      days2(i,2)=pyay(i)*pays2(i,1)-pycy(i)*pays3(i,1)      +ps3(i,1)
      days2(i,3)=pzaz(i)*pays2(i,1)-pzcz(i)*pays3(i,1)
      days2(i,4)=pyay(i)*pays2(i,2)-pycy(i)*pays3(i,2)+cy(i)+ps3(i,2)
      days2(i,5)=pzaz(i)*pays2(i,2)-pzcz(i)*pays3(i,2)
      days2(i,6)=pzaz(i)*pays2(i,3)-pzcz(i)*pays3(i,3)+cy(i)
      dazs2(i,1)=pxax(i)*pazs2(i,1)-pxcx(i)*pazs3(i,1)+cz(i)
      dazs2(i,2)=pyay(i)*pazs2(i,1)-pycy(i)*pazs3(i,1)
      dazs2(i,3)=pzaz(i)*pazs2(i,1)-pzcz(i)*pazs3(i,1)      +ps3(i,1)
      dazs2(i,4)=pyay(i)*pazs2(i,2)-pycy(i)*pazs3(i,2)+cz(i)
      dazs2(i,5)=pzaz(i)*pazs2(i,2)-pzcz(i)*pazs3(i,2)      +ps3(i,2)
 1024 dazs2(i,6)=pzaz(i)*pazs2(i,3)-pzcz(i)*pazs3(i,3)+cz(i)+ps3(i,3)

      do 1025 j=1,3
      do 1025 i=1,n
      cx1(i,j)=(paxs0(i,j)-paxs1(i,j))/twozeta(i)
      cy1(i,j)=(pays0(i,j)-pays1(i,j))/twozeta(i)
 1025 cz1(i,j)=(pazs0(i,j)-pazs1(i,j))/twozeta(i)

      do 1026 i=1,n
      faxs0(i,01)=pxax(i)*daxs0(i,1)-pxcx(i)*daxs1(i,1)+cx1(i,1)*two
     &                                                 +ds1(i,1)
      faxs0(i,02)=pyay(i)*daxs0(i,1)-pycy(i)*daxs1(i,1)
      faxs0(i,03)=pzaz(i)*daxs0(i,1)-pzcz(i)*daxs1(i,1)
      faxs0(i,04)=pyay(i)*daxs0(i,2)-pycy(i)*daxs1(i,2)+cx1(i,1)
      faxs0(i,05)=pzaz(i)*daxs0(i,2)-pzcz(i)*daxs1(i,2)
      faxs0(i,06)=pzaz(i)*daxs0(i,3)-pzcz(i)*daxs1(i,3)+cx1(i,1)
      faxs0(i,07)=pyay(i)*daxs0(i,4)-pycy(i)*daxs1(i,4)+cx1(i,2)*two
      faxs0(i,08)=pzaz(i)*daxs0(i,4)-pzcz(i)*daxs1(i,4)
      faxs0(i,09)=pzaz(i)*daxs0(i,5)-pzcz(i)*daxs1(i,5)+cx1(i,2)
      faxs0(i,10)=pzaz(i)*daxs0(i,6)-pzcz(i)*daxs1(i,6)+cx1(i,3)*two
      fays0(i,01)=pxax(i)*days0(i,1)-pxcx(i)*days1(i,1)+cy1(i,1)*two
      fays0(i,02)=pyay(i)*days0(i,1)-pycy(i)*days1(i,1)
     &                                                 +ds1(i,1)
      fays0(i,03)=pzaz(i)*days0(i,1)-pzcz(i)*days1(i,1)
      fays0(i,04)=pyay(i)*days0(i,2)-pycy(i)*days1(i,2)+cy1(i,1)
     &                                                 +ds1(i,2)
      fays0(i,05)=pzaz(i)*days0(i,2)-pzcz(i)*days1(i,2)
      fays0(i,06)=pzaz(i)*days0(i,3)-pzcz(i)*days1(i,3)+cy1(i,1)
      fays0(i,07)=pyay(i)*days0(i,4)-pycy(i)*days1(i,4)+cy1(i,2)*two
     &                                                 +ds1(i,4)
      fays0(i,08)=pzaz(i)*days0(i,4)-pzcz(i)*days1(i,4)
      fays0(i,09)=pzaz(i)*days0(i,5)-pzcz(i)*days1(i,5)+cy1(i,2)
      fays0(i,10)=pzaz(i)*days0(i,6)-pzcz(i)*days1(i,6)+cy1(i,3)*two
      fazs0(i,01)=pxax(i)*dazs0(i,1)-pxcx(i)*dazs1(i,1)+cz1(i,1)*two
      fazs0(i,02)=pyay(i)*dazs0(i,1)-pycy(i)*dazs1(i,1)
      fazs0(i,03)=pzaz(i)*dazs0(i,1)-pzcz(i)*dazs1(i,1)
     &                                                 +ds1(i,1)
      fazs0(i,04)=pyay(i)*dazs0(i,2)-pycy(i)*dazs1(i,2)+cz1(i,1)
      fazs0(i,05)=pzaz(i)*dazs0(i,2)-pzcz(i)*dazs1(i,2)
     &                                                 +ds1(i,2)
      fazs0(i,06)=pzaz(i)*dazs0(i,3)-pzcz(i)*dazs1(i,3)+cz1(i,1)
     &                                                 +ds1(i,3)
      fazs0(i,07)=pyay(i)*dazs0(i,4)-pycy(i)*dazs1(i,4)+cz1(i,2)*two
      fazs0(i,08)=pzaz(i)*dazs0(i,4)-pzcz(i)*dazs1(i,4)
     &                                                 +ds1(i,4)
      fazs0(i,09)=pzaz(i)*dazs0(i,5)-pzcz(i)*dazs1(i,5)+cz1(i,2)
     &                                                 +ds1(i,5)
 1026 fazs0(i,10)=pzaz(i)*dazs0(i,6)-pzcz(i)*dazs1(i,6)+cz1(i,3)*two
     &                                                 +ds1(i,6)

      do 1027 j=1,3
      do 1027 i=1,n
      cx1(i,j)=(paxs1(i,j)-paxs2(i,j))/twozeta(i)
      cy1(i,j)=(pays1(i,j)-pays2(i,j))/twozeta(i)
 1027 cz1(i,j)=(pazs1(i,j)-pazs2(i,j))/twozeta(i)

      do 1028 i=1,n
      faxs1(i,01)=pxax(i)*daxs1(i,1)-pxcx(i)*daxs2(i,1)+cx1(i,1)*two
     &                                                 +ds2(i,1)
      faxs1(i,02)=pyay(i)*daxs1(i,1)-pycy(i)*daxs2(i,1)
      faxs1(i,03)=pzaz(i)*daxs1(i,1)-pzcz(i)*daxs2(i,1)
      faxs1(i,04)=pyay(i)*daxs1(i,2)-pycy(i)*daxs2(i,2)+cx1(i,1)
      faxs1(i,05)=pzaz(i)*daxs1(i,2)-pzcz(i)*daxs2(i,2)
      faxs1(i,06)=pzaz(i)*daxs1(i,3)-pzcz(i)*daxs2(i,3)+cx1(i,1)
      faxs1(i,07)=pyay(i)*daxs1(i,4)-pycy(i)*daxs2(i,4)+cx1(i,2)*two
      faxs1(i,08)=pzaz(i)*daxs1(i,4)-pzcz(i)*daxs2(i,4)
      faxs1(i,09)=pzaz(i)*daxs1(i,5)-pzcz(i)*daxs2(i,5)+cx1(i,2)
      faxs1(i,10)=pzaz(i)*daxs1(i,6)-pzcz(i)*daxs2(i,6)+cx1(i,3)*two
      fays1(i,01)=pxax(i)*days1(i,1)-pxcx(i)*days2(i,1)+cy1(i,1)*two
      fays1(i,02)=pyay(i)*days1(i,1)-pycy(i)*days2(i,1)
     &                                                 +ds2(i,1)
      fays1(i,03)=pzaz(i)*days1(i,1)-pzcz(i)*days2(i,1)
      fays1(i,04)=pyay(i)*days1(i,2)-pycy(i)*days2(i,2)+cy1(i,1)
     &                                                 +ds2(i,2)
      fays1(i,05)=pzaz(i)*days1(i,2)-pzcz(i)*days2(i,2)
      fays1(i,06)=pzaz(i)*days1(i,3)-pzcz(i)*days2(i,3)+cy1(i,1)
      fays1(i,07)=pyay(i)*days1(i,4)-pycy(i)*days2(i,4)+cy1(i,2)*two
     &                                                 +ds2(i,4)
      fays1(i,08)=pzaz(i)*days1(i,4)-pzcz(i)*days2(i,4)
      fays1(i,09)=pzaz(i)*days1(i,5)-pzcz(i)*days2(i,5)+cy1(i,2)
      fays1(i,10)=pzaz(i)*days1(i,6)-pzcz(i)*days2(i,6)+cy1(i,3)*two
      fazs1(i,01)=pxax(i)*dazs1(i,1)-pxcx(i)*dazs2(i,1)+cz1(i,1)*two
      fazs1(i,02)=pyay(i)*dazs1(i,1)-pycy(i)*dazs2(i,1)
      fazs1(i,03)=pzaz(i)*dazs1(i,1)-pzcz(i)*dazs2(i,1)
     &                                                 +ds2(i,1)
      fazs1(i,04)=pyay(i)*dazs1(i,2)-pycy(i)*dazs2(i,2)+cz1(i,1)
      fazs1(i,05)=pzaz(i)*dazs1(i,2)-pzcz(i)*dazs2(i,2)
     &                                                 +ds2(i,2)
      fazs1(i,06)=pzaz(i)*dazs1(i,3)-pzcz(i)*dazs2(i,3)+cz1(i,1)
     &                                                 +ds2(i,3)
      fazs1(i,07)=pyay(i)*dazs1(i,4)-pycy(i)*dazs2(i,4)+cz1(i,2)*two
      fazs1(i,08)=pzaz(i)*dazs1(i,4)-pzcz(i)*dazs2(i,4)
     &                                                 +ds2(i,4)
      fazs1(i,09)=pzaz(i)*dazs1(i,5)-pzcz(i)*dazs2(i,5)+cz1(i,2)
     &                                                 +ds2(i,5)
 1028 fazs1(i,10)=pzaz(i)*dazs1(i,6)-pzcz(i)*dazs2(i,6)+cz1(i,3)*two
     &                                                 +ds2(i,6)

      do 1029 j=1,6
      do 1029 i=1,n
      cx2(i,j)=(daxs0(i,j)-daxs1(i,j))/twozeta(i)
      cy2(i,j)=(days0(i,j)-days1(i,j))/twozeta(i)
 1029 cz2(i,j)=(dazs0(i,j)-dazs1(i,j))/twozeta(i)

      do 1030 i=1,n
      gaxs0(i,01)=pxax(i)*faxs0(i,01)-pxcx(i)*faxs1(i,01)+cx2(i,1)*three
     &                                                   +fs1(i,1)
      gaxs0(i,02)=pyay(i)*faxs0(i,01)-pycy(i)*faxs1(i,01)
      gaxs0(i,03)=pzaz(i)*faxs0(i,01)-pzcz(i)*faxs1(i,01)
      gaxs0(i,04)=pyay(i)*faxs0(i,02)-pycy(i)*faxs1(i,02)+cx2(i,1)
      gaxs0(i,05)=pzaz(i)*faxs0(i,02)-pzcz(i)*faxs1(i,02)
      gaxs0(i,06)=pzaz(i)*faxs0(i,03)-pzcz(i)*faxs1(i,03)+cx2(i,1)
      gaxs0(i,07)=pyay(i)*faxs0(i,04)-pycy(i)*faxs1(i,04)+cx2(i,2)*two
      gaxs0(i,08)=pzaz(i)*faxs0(i,04)-pzcz(i)*faxs1(i,04)
      gaxs0(i,09)=pzaz(i)*faxs0(i,05)-pzcz(i)*faxs1(i,05)+cx2(i,2)
      gaxs0(i,10)=pzaz(i)*faxs0(i,06)-pzcz(i)*faxs1(i,06)+cx2(i,3)*two
      gaxs0(i,11)=pyay(i)*faxs0(i,07)-pycy(i)*faxs1(i,07)+cx2(i,4)*three
      gaxs0(i,12)=pzaz(i)*faxs0(i,07)-pzcz(i)*faxs1(i,07)
      gaxs0(i,13)=pzaz(i)*faxs0(i,08)-pzcz(i)*faxs1(i,08)+cx2(i,4)
      gaxs0(i,14)=pzaz(i)*faxs0(i,09)-pzcz(i)*faxs1(i,09)+cx2(i,5)*two
      gaxs0(i,15)=pzaz(i)*faxs0(i,10)-pzcz(i)*faxs1(i,10)+cx2(i,6)*three
      gays0(i,01)=pxax(i)*fays0(i,01)-pxcx(i)*fays1(i,01)+cy2(i,1)*three
      gays0(i,02)=pyay(i)*fays0(i,01)-pycy(i)*fays1(i,01)
     &                                                   +fs1(i,1)
      gays0(i,03)=pzaz(i)*fays0(i,01)-pzcz(i)*fays1(i,01)
      gays0(i,04)=pyay(i)*fays0(i,02)-pycy(i)*fays1(i,02)+cy2(i,1)
     &                                                   +fs1(i,2)
      gays0(i,05)=pzaz(i)*fays0(i,02)-pzcz(i)*fays1(i,02)
      gays0(i,06)=pzaz(i)*fays0(i,03)-pzcz(i)*fays1(i,03)+cy2(i,1)
      gays0(i,07)=pyay(i)*fays0(i,04)-pycy(i)*fays1(i,04)+cy2(i,2)*two
     &                                                   +fs1(i,4)
      gays0(i,08)=pzaz(i)*fays0(i,04)-pzcz(i)*fays1(i,04)
      gays0(i,09)=pzaz(i)*fays0(i,05)-pzcz(i)*fays1(i,05)+cy2(i,2)
      gays0(i,10)=pzaz(i)*fays0(i,06)-pzcz(i)*fays1(i,06)+cy2(i,3)*two
      gays0(i,11)=pyay(i)*fays0(i,07)-pycy(i)*fays1(i,07)+cy2(i,4)*three
     &                                                   +fs1(i,7)
      gays0(i,12)=pzaz(i)*fays0(i,07)-pzcz(i)*fays1(i,07)
      gays0(i,13)=pzaz(i)*fays0(i,08)-pzcz(i)*fays1(i,08)+cy2(i,4)
      gays0(i,14)=pzaz(i)*fays0(i,09)-pzcz(i)*fays1(i,09)+cy2(i,5)*two
      gays0(i,15)=pzaz(i)*fays0(i,10)-pzcz(i)*fays1(i,10)+cy2(i,6)*three
      gazs0(i,01)=pxax(i)*fazs0(i,01)-pxcx(i)*fazs1(i,01)+cz2(i,1)*three
      gazs0(i,02)=pyay(i)*fazs0(i,01)-pycy(i)*fazs1(i,01)
      gazs0(i,03)=pzaz(i)*fazs0(i,01)-pzcz(i)*fazs1(i,01)
     &                                                   +fs1(i,1)
      gazs0(i,04)=pyay(i)*fazs0(i,02)-pycy(i)*fazs1(i,02)+cz2(i,1)
      gazs0(i,05)=pzaz(i)*fazs0(i,02)-pzcz(i)*fazs1(i,02)
     &                                                   +fs1(i,2)
      gazs0(i,06)=pzaz(i)*fazs0(i,03)-pzcz(i)*fazs1(i,03)+cz2(i,1)
     &                                                   +fs1(i,3)
      gazs0(i,07)=pyay(i)*fazs0(i,04)-pycy(i)*fazs1(i,04)+cz2(i,2)*two
      gazs0(i,08)=pzaz(i)*fazs0(i,04)-pzcz(i)*fazs1(i,04)
     &                                                   +fs1(i,4)
      gazs0(i,09)=pzaz(i)*fazs0(i,05)-pzcz(i)*fazs1(i,05)+cz2(i,2)
     &                                                   +fs1(i,5)
      gazs0(i,10)=pzaz(i)*fazs0(i,06)-pzcz(i)*fazs1(i,06)+cz2(i,3)*two
     &                                                   +fs1(i,6)
      gazs0(i,11)=pyay(i)*fazs0(i,07)-pycy(i)*fazs1(i,07)+cz2(i,4)*three
      gazs0(i,12)=pzaz(i)*fazs0(i,07)-pzcz(i)*fazs1(i,07)
     &                                                   +fs1(i,7)
      gazs0(i,13)=pzaz(i)*fazs0(i,08)-pzcz(i)*fazs1(i,08)+cz2(i,4)
     &                                                   +fs1(i,8)
      gazs0(i,14)=pzaz(i)*fazs0(i,09)-pzcz(i)*fazs1(i,09)+cz2(i,5)*two
     &                                                   +fs1(i,9)
 1030 gazs0(i,15)=pzaz(i)*fazs0(i,10)-pzcz(i)*fazs1(i,10)+cz2(i,6)*three
     &                                                   +fs1(i,10)

      do 1031 j=1,6
      do 1031 i=1,m
 1031 dscond(i,j)=zero

      do 1032 j=1,10
      do 1032 i=1,m
 1032 fscond(i,j)=zero

      do 1033 j=1,15
      do 1033 i=1,m
 1033 gscond(i,j)=zero

      do 1034 j=1,6
      do 1034 i=1,n
 1034 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)

      do 1035 j=1,10
      do 1035 i=1,n
 1035 fscond(icontr(i),j)=fscond(icontr(i),j)+fs0(i,j)

      do 1036 j=1,15
      do 1036 i=1,n
 1036 gscond(icontr(i),j)=gscond(icontr(i),j)+gs0(i,j)

      do 1037 i=1,m
      dpcond(i,01)=axbx(i)*dscond(i,1)+fscond(i,01)
      dpcond(i,02)=ayby(i)*dscond(i,1)+fscond(i,02)
      dpcond(i,03)=azbz(i)*dscond(i,1)+fscond(i,03)
      dpcond(i,04)=axbx(i)*dscond(i,2)+fscond(i,02)
      dpcond(i,05)=ayby(i)*dscond(i,2)+fscond(i,04)
      dpcond(i,06)=azbz(i)*dscond(i,2)+fscond(i,05)
      dpcond(i,07)=axbx(i)*dscond(i,3)+fscond(i,03)
      dpcond(i,08)=ayby(i)*dscond(i,3)+fscond(i,05)
      dpcond(i,09)=azbz(i)*dscond(i,3)+fscond(i,06)
      dpcond(i,10)=axbx(i)*dscond(i,4)+fscond(i,04)
      dpcond(i,11)=ayby(i)*dscond(i,4)+fscond(i,07)
      dpcond(i,12)=azbz(i)*dscond(i,4)+fscond(i,08)
      dpcond(i,13)=axbx(i)*dscond(i,5)+fscond(i,05)
      dpcond(i,14)=ayby(i)*dscond(i,5)+fscond(i,08)
      dpcond(i,15)=azbz(i)*dscond(i,5)+fscond(i,09)
      dpcond(i,16)=axbx(i)*dscond(i,6)+fscond(i,06)
      dpcond(i,17)=ayby(i)*dscond(i,6)+fscond(i,09)
 1037 dpcond(i,18)=azbz(i)*dscond(i,6)+fscond(i,10)

      do 1038 i=1,m
      fpcond(i,01)=axbx(i)*fscond(i,01)+gscond(i,01)
      fpcond(i,02)=ayby(i)*fscond(i,01)+gscond(i,02)
      fpcond(i,03)=azbz(i)*fscond(i,01)+gscond(i,03)
      fpcond(i,04)=axbx(i)*fscond(i,02)+gscond(i,02)
      fpcond(i,05)=ayby(i)*fscond(i,02)+gscond(i,04)
      fpcond(i,06)=azbz(i)*fscond(i,02)+gscond(i,05)
      fpcond(i,07)=axbx(i)*fscond(i,03)+gscond(i,03)
      fpcond(i,08)=ayby(i)*fscond(i,03)+gscond(i,05)
      fpcond(i,09)=azbz(i)*fscond(i,03)+gscond(i,06)
      fpcond(i,10)=axbx(i)*fscond(i,04)+gscond(i,04)
      fpcond(i,11)=ayby(i)*fscond(i,04)+gscond(i,07)
      fpcond(i,12)=azbz(i)*fscond(i,04)+gscond(i,08)
      fpcond(i,13)=axbx(i)*fscond(i,05)+gscond(i,05)
      fpcond(i,14)=ayby(i)*fscond(i,05)+gscond(i,08)
      fpcond(i,15)=azbz(i)*fscond(i,05)+gscond(i,09)
      fpcond(i,16)=axbx(i)*fscond(i,06)+gscond(i,06)
      fpcond(i,17)=ayby(i)*fscond(i,06)+gscond(i,09)
      fpcond(i,18)=azbz(i)*fscond(i,06)+gscond(i,10)
      fpcond(i,19)=axbx(i)*fscond(i,07)+gscond(i,07)
      fpcond(i,20)=ayby(i)*fscond(i,07)+gscond(i,11)
      fpcond(i,21)=azbz(i)*fscond(i,07)+gscond(i,12)
      fpcond(i,22)=axbx(i)*fscond(i,08)+gscond(i,08)
      fpcond(i,23)=ayby(i)*fscond(i,08)+gscond(i,12)
      fpcond(i,24)=azbz(i)*fscond(i,08)+gscond(i,13)
      fpcond(i,25)=axbx(i)*fscond(i,09)+gscond(i,09)
      fpcond(i,26)=ayby(i)*fscond(i,09)+gscond(i,13)
      fpcond(i,27)=azbz(i)*fscond(i,09)+gscond(i,14)
      fpcond(i,28)=axbx(i)*fscond(i,10)+gscond(i,10)
      fpcond(i,29)=ayby(i)*fscond(i,10)+gscond(i,14)
 1038 fpcond(i,30)=azbz(i)*fscond(i,10)+gscond(i,15)

      do 1039 i=1,m
      ddcond(i,01)=axbx(i)*dpcond(i,01)+fpcond(i,01)
      ddcond(i,02)=ayby(i)*dpcond(i,01)+fpcond(i,04)
      ddcond(i,03)=azbz(i)*dpcond(i,01)+fpcond(i,07)
      ddcond(i,04)=ayby(i)*dpcond(i,02)+fpcond(i,05)
      ddcond(i,05)=azbz(i)*dpcond(i,02)+fpcond(i,08)
      ddcond(i,06)=azbz(i)*dpcond(i,03)+fpcond(i,09)
      ddcond(i,07)=axbx(i)*dpcond(i,04)+fpcond(i,04)
      ddcond(i,08)=ayby(i)*dpcond(i,04)+fpcond(i,10)
      ddcond(i,09)=azbz(i)*dpcond(i,04)+fpcond(i,13)
      ddcond(i,10)=ayby(i)*dpcond(i,05)+fpcond(i,11)
      ddcond(i,11)=azbz(i)*dpcond(i,05)+fpcond(i,14)
      ddcond(i,12)=azbz(i)*dpcond(i,06)+fpcond(i,15)
      ddcond(i,13)=axbx(i)*dpcond(i,07)+fpcond(i,07)
      ddcond(i,14)=ayby(i)*dpcond(i,07)+fpcond(i,13)
      ddcond(i,15)=azbz(i)*dpcond(i,07)+fpcond(i,16)
      ddcond(i,16)=ayby(i)*dpcond(i,08)+fpcond(i,14)
      ddcond(i,17)=azbz(i)*dpcond(i,08)+fpcond(i,17)
      ddcond(i,18)=azbz(i)*dpcond(i,09)+fpcond(i,18)
      ddcond(i,19)=axbx(i)*dpcond(i,10)+fpcond(i,10)
      ddcond(i,20)=ayby(i)*dpcond(i,10)+fpcond(i,19)
      ddcond(i,21)=azbz(i)*dpcond(i,10)+fpcond(i,22)
      ddcond(i,22)=ayby(i)*dpcond(i,11)+fpcond(i,20)
      ddcond(i,23)=azbz(i)*dpcond(i,11)+fpcond(i,23)
      ddcond(i,24)=azbz(i)*dpcond(i,12)+fpcond(i,24)
      ddcond(i,25)=axbx(i)*dpcond(i,13)+fpcond(i,13)
      ddcond(i,26)=ayby(i)*dpcond(i,13)+fpcond(i,22)
      ddcond(i,27)=azbz(i)*dpcond(i,13)+fpcond(i,25)
      ddcond(i,28)=ayby(i)*dpcond(i,14)+fpcond(i,23)
      ddcond(i,29)=azbz(i)*dpcond(i,14)+fpcond(i,26)
      ddcond(i,30)=azbz(i)*dpcond(i,15)+fpcond(i,27)
      ddcond(i,31)=axbx(i)*dpcond(i,16)+fpcond(i,16)
      ddcond(i,32)=ayby(i)*dpcond(i,16)+fpcond(i,25)
      ddcond(i,33)=azbz(i)*dpcond(i,16)+fpcond(i,28)
      ddcond(i,34)=ayby(i)*dpcond(i,17)+fpcond(i,26)
      ddcond(i,35)=azbz(i)*dpcond(i,17)+fpcond(i,29)
 1039 ddcond(i,36)=azbz(i)*dpcond(i,18)+fpcond(i,30)

      do 1040 j=1,6
      do 1040 i=1,m
      daxscond(i,j)=zero
      dayscond(i,j)=zero
 1040 dazscond(i,j)=zero

      do 1041 j=1,10
      do 1041 i=1,m
      faxscond(i,j)=zero
      fayscond(i,j)=zero
 1041 fazscond(i,j)=zero

      do 1042 j=1,15
      do 1042 i=1,m
      gaxscond(i,j)=zero
      gayscond(i,j)=zero
 1042 gazscond(i,j)=zero

      do 1043 j=1,6
      do 1043 i=1,n
      daxscond(icontr(i),j)=daxscond(icontr(i),j)+daxs0(i,j)
      dayscond(icontr(i),j)=dayscond(icontr(i),j)+days0(i,j)
 1043 dazscond(icontr(i),j)=dazscond(icontr(i),j)+dazs0(i,j)

      do 1044 j=1,10
      do 1044 i=1,n
      faxscond(icontr(i),j)=faxscond(icontr(i),j)+faxs0(i,j)
      fayscond(icontr(i),j)=fayscond(icontr(i),j)+fays0(i,j)
 1044 fazscond(icontr(i),j)=fazscond(icontr(i),j)+fazs0(i,j)

      do 1045 j=1,15
      do 1045 i=1,n
      gaxscond(icontr(i),j)=gaxscond(icontr(i),j)+gaxs0(i,j)
      gayscond(icontr(i),j)=gayscond(icontr(i),j)+gays0(i,j)
 1045 gazscond(icontr(i),j)=gazscond(icontr(i),j)+gazs0(i,j)

      do 1046 i=1,m
      daxpcond(i,01)=axbx(i)*daxscond(i,1)+faxscond(i,01)
      daxpcond(i,02)=ayby(i)*daxscond(i,1)+faxscond(i,02)
      daxpcond(i,03)=azbz(i)*daxscond(i,1)+faxscond(i,03)
      daxpcond(i,04)=axbx(i)*daxscond(i,2)+faxscond(i,02)
      daxpcond(i,05)=ayby(i)*daxscond(i,2)+faxscond(i,04)
      daxpcond(i,06)=azbz(i)*daxscond(i,2)+faxscond(i,05)
      daxpcond(i,07)=axbx(i)*daxscond(i,3)+faxscond(i,03)
      daxpcond(i,08)=ayby(i)*daxscond(i,3)+faxscond(i,05)
      daxpcond(i,09)=azbz(i)*daxscond(i,3)+faxscond(i,06)
      daxpcond(i,10)=axbx(i)*daxscond(i,4)+faxscond(i,04)
      daxpcond(i,11)=ayby(i)*daxscond(i,4)+faxscond(i,07)
      daxpcond(i,12)=azbz(i)*daxscond(i,4)+faxscond(i,08)
      daxpcond(i,13)=axbx(i)*daxscond(i,5)+faxscond(i,05)
      daxpcond(i,14)=ayby(i)*daxscond(i,5)+faxscond(i,08)
      daxpcond(i,15)=azbz(i)*daxscond(i,5)+faxscond(i,09)
      daxpcond(i,16)=axbx(i)*daxscond(i,6)+faxscond(i,06)
      daxpcond(i,17)=ayby(i)*daxscond(i,6)+faxscond(i,09)
      daxpcond(i,18)=azbz(i)*daxscond(i,6)+faxscond(i,10)
      daypcond(i,01)=axbx(i)*dayscond(i,1)+fayscond(i,01)
      daypcond(i,02)=ayby(i)*dayscond(i,1)+fayscond(i,02)
      daypcond(i,03)=azbz(i)*dayscond(i,1)+fayscond(i,03)
      daypcond(i,04)=axbx(i)*dayscond(i,2)+fayscond(i,02)
      daypcond(i,05)=ayby(i)*dayscond(i,2)+fayscond(i,04)
      daypcond(i,06)=azbz(i)*dayscond(i,2)+fayscond(i,05)
      daypcond(i,07)=axbx(i)*dayscond(i,3)+fayscond(i,03)
      daypcond(i,08)=ayby(i)*dayscond(i,3)+fayscond(i,05)
      daypcond(i,09)=azbz(i)*dayscond(i,3)+fayscond(i,06)
      daypcond(i,10)=axbx(i)*dayscond(i,4)+fayscond(i,04)
      daypcond(i,11)=ayby(i)*dayscond(i,4)+fayscond(i,07)
      daypcond(i,12)=azbz(i)*dayscond(i,4)+fayscond(i,08)
      daypcond(i,13)=axbx(i)*dayscond(i,5)+fayscond(i,05)
      daypcond(i,14)=ayby(i)*dayscond(i,5)+fayscond(i,08)
      daypcond(i,15)=azbz(i)*dayscond(i,5)+fayscond(i,09)
      daypcond(i,16)=axbx(i)*dayscond(i,6)+fayscond(i,06)
      daypcond(i,17)=ayby(i)*dayscond(i,6)+fayscond(i,09)
      daypcond(i,18)=azbz(i)*dayscond(i,6)+fayscond(i,10)
      dazpcond(i,01)=axbx(i)*dazscond(i,1)+fazscond(i,01)
      dazpcond(i,02)=ayby(i)*dazscond(i,1)+fazscond(i,02)
      dazpcond(i,03)=azbz(i)*dazscond(i,1)+fazscond(i,03)
      dazpcond(i,04)=axbx(i)*dazscond(i,2)+fazscond(i,02)
      dazpcond(i,05)=ayby(i)*dazscond(i,2)+fazscond(i,04)
      dazpcond(i,06)=azbz(i)*dazscond(i,2)+fazscond(i,05)
      dazpcond(i,07)=axbx(i)*dazscond(i,3)+fazscond(i,03)
      dazpcond(i,08)=ayby(i)*dazscond(i,3)+fazscond(i,05)
      dazpcond(i,09)=azbz(i)*dazscond(i,3)+fazscond(i,06)
      dazpcond(i,10)=axbx(i)*dazscond(i,4)+fazscond(i,04)
      dazpcond(i,11)=ayby(i)*dazscond(i,4)+fazscond(i,07)
      dazpcond(i,12)=azbz(i)*dazscond(i,4)+fazscond(i,08)
      dazpcond(i,13)=axbx(i)*dazscond(i,5)+fazscond(i,05)
      dazpcond(i,14)=ayby(i)*dazscond(i,5)+fazscond(i,08)
      dazpcond(i,15)=azbz(i)*dazscond(i,5)+fazscond(i,09)
      dazpcond(i,16)=axbx(i)*dazscond(i,6)+fazscond(i,06)
      dazpcond(i,17)=ayby(i)*dazscond(i,6)+fazscond(i,09)
 1046 dazpcond(i,18)=azbz(i)*dazscond(i,6)+fazscond(i,10)

      do 1047 i=1,m
      faxpcond(i,01)=axbx(i)*faxscond(i,01)+gaxscond(i,01)
      faxpcond(i,02)=ayby(i)*faxscond(i,01)+gaxscond(i,02)
      faxpcond(i,03)=azbz(i)*faxscond(i,01)+gaxscond(i,03)
      faxpcond(i,04)=axbx(i)*faxscond(i,02)+gaxscond(i,02)
      faxpcond(i,05)=ayby(i)*faxscond(i,02)+gaxscond(i,04)
      faxpcond(i,06)=azbz(i)*faxscond(i,02)+gaxscond(i,05)
      faxpcond(i,07)=axbx(i)*faxscond(i,03)+gaxscond(i,03)
      faxpcond(i,08)=ayby(i)*faxscond(i,03)+gaxscond(i,05)
      faxpcond(i,09)=azbz(i)*faxscond(i,03)+gaxscond(i,06)
      faxpcond(i,10)=axbx(i)*faxscond(i,04)+gaxscond(i,04)
      faxpcond(i,11)=ayby(i)*faxscond(i,04)+gaxscond(i,07)
      faxpcond(i,12)=azbz(i)*faxscond(i,04)+gaxscond(i,08)
      faxpcond(i,13)=axbx(i)*faxscond(i,05)+gaxscond(i,05)
      faxpcond(i,14)=ayby(i)*faxscond(i,05)+gaxscond(i,08)
      faxpcond(i,15)=azbz(i)*faxscond(i,05)+gaxscond(i,09)
      faxpcond(i,16)=axbx(i)*faxscond(i,06)+gaxscond(i,06)
      faxpcond(i,17)=ayby(i)*faxscond(i,06)+gaxscond(i,09)
      faxpcond(i,18)=azbz(i)*faxscond(i,06)+gaxscond(i,10)
      faxpcond(i,19)=axbx(i)*faxscond(i,07)+gaxscond(i,07)
      faxpcond(i,20)=ayby(i)*faxscond(i,07)+gaxscond(i,11)
      faxpcond(i,21)=azbz(i)*faxscond(i,07)+gaxscond(i,12)
      faxpcond(i,22)=axbx(i)*faxscond(i,08)+gaxscond(i,08)
      faxpcond(i,23)=ayby(i)*faxscond(i,08)+gaxscond(i,12)
      faxpcond(i,24)=azbz(i)*faxscond(i,08)+gaxscond(i,13)
      faxpcond(i,25)=axbx(i)*faxscond(i,09)+gaxscond(i,09)
      faxpcond(i,26)=ayby(i)*faxscond(i,09)+gaxscond(i,13)
      faxpcond(i,27)=azbz(i)*faxscond(i,09)+gaxscond(i,14)
      faxpcond(i,28)=axbx(i)*faxscond(i,10)+gaxscond(i,10)
      faxpcond(i,29)=ayby(i)*faxscond(i,10)+gaxscond(i,14)
      faxpcond(i,30)=azbz(i)*faxscond(i,10)+gaxscond(i,15)
      faypcond(i,01)=axbx(i)*fayscond(i,01)+gayscond(i,01)
      faypcond(i,02)=ayby(i)*fayscond(i,01)+gayscond(i,02)
      faypcond(i,03)=azbz(i)*fayscond(i,01)+gayscond(i,03)
      faypcond(i,04)=axbx(i)*fayscond(i,02)+gayscond(i,02)
      faypcond(i,05)=ayby(i)*fayscond(i,02)+gayscond(i,04)
      faypcond(i,06)=azbz(i)*fayscond(i,02)+gayscond(i,05)
      faypcond(i,07)=axbx(i)*fayscond(i,03)+gayscond(i,03)
      faypcond(i,08)=ayby(i)*fayscond(i,03)+gayscond(i,05)
      faypcond(i,09)=azbz(i)*fayscond(i,03)+gayscond(i,06)
      faypcond(i,10)=axbx(i)*fayscond(i,04)+gayscond(i,04)
      faypcond(i,11)=ayby(i)*fayscond(i,04)+gayscond(i,07)
      faypcond(i,12)=azbz(i)*fayscond(i,04)+gayscond(i,08)
      faypcond(i,13)=axbx(i)*fayscond(i,05)+gayscond(i,05)
      faypcond(i,14)=ayby(i)*fayscond(i,05)+gayscond(i,08)
      faypcond(i,15)=azbz(i)*fayscond(i,05)+gayscond(i,09)
      faypcond(i,16)=axbx(i)*fayscond(i,06)+gayscond(i,06)
      faypcond(i,17)=ayby(i)*fayscond(i,06)+gayscond(i,09)
      faypcond(i,18)=azbz(i)*fayscond(i,06)+gayscond(i,10)
      faypcond(i,19)=axbx(i)*fayscond(i,07)+gayscond(i,07)
      faypcond(i,20)=ayby(i)*fayscond(i,07)+gayscond(i,11)
      faypcond(i,21)=azbz(i)*fayscond(i,07)+gayscond(i,12)
      faypcond(i,22)=axbx(i)*fayscond(i,08)+gayscond(i,08)
      faypcond(i,23)=ayby(i)*fayscond(i,08)+gayscond(i,12)
      faypcond(i,24)=azbz(i)*fayscond(i,08)+gayscond(i,13)
      faypcond(i,25)=axbx(i)*fayscond(i,09)+gayscond(i,09)
      faypcond(i,26)=ayby(i)*fayscond(i,09)+gayscond(i,13)
      faypcond(i,27)=azbz(i)*fayscond(i,09)+gayscond(i,14)
      faypcond(i,28)=axbx(i)*fayscond(i,10)+gayscond(i,10)
      faypcond(i,29)=ayby(i)*fayscond(i,10)+gayscond(i,14)
      faypcond(i,30)=azbz(i)*fayscond(i,10)+gayscond(i,15)
      fazpcond(i,01)=axbx(i)*fazscond(i,01)+gazscond(i,01)
      fazpcond(i,02)=ayby(i)*fazscond(i,01)+gazscond(i,02)
      fazpcond(i,03)=azbz(i)*fazscond(i,01)+gazscond(i,03)
      fazpcond(i,04)=axbx(i)*fazscond(i,02)+gazscond(i,02)
      fazpcond(i,05)=ayby(i)*fazscond(i,02)+gazscond(i,04)
      fazpcond(i,06)=azbz(i)*fazscond(i,02)+gazscond(i,05)
      fazpcond(i,07)=axbx(i)*fazscond(i,03)+gazscond(i,03)
      fazpcond(i,08)=ayby(i)*fazscond(i,03)+gazscond(i,05)
      fazpcond(i,09)=azbz(i)*fazscond(i,03)+gazscond(i,06)
      fazpcond(i,10)=axbx(i)*fazscond(i,04)+gazscond(i,04)
      fazpcond(i,11)=ayby(i)*fazscond(i,04)+gazscond(i,07)
      fazpcond(i,12)=azbz(i)*fazscond(i,04)+gazscond(i,08)
      fazpcond(i,13)=axbx(i)*fazscond(i,05)+gazscond(i,05)
      fazpcond(i,14)=ayby(i)*fazscond(i,05)+gazscond(i,08)
      fazpcond(i,15)=azbz(i)*fazscond(i,05)+gazscond(i,09)
      fazpcond(i,16)=axbx(i)*fazscond(i,06)+gazscond(i,06)
      fazpcond(i,17)=ayby(i)*fazscond(i,06)+gazscond(i,09)
      fazpcond(i,18)=azbz(i)*fazscond(i,06)+gazscond(i,10)
      fazpcond(i,19)=axbx(i)*fazscond(i,07)+gazscond(i,07)
      fazpcond(i,20)=ayby(i)*fazscond(i,07)+gazscond(i,11)
      fazpcond(i,21)=azbz(i)*fazscond(i,07)+gazscond(i,12)
      fazpcond(i,22)=axbx(i)*fazscond(i,08)+gazscond(i,08)
      fazpcond(i,23)=ayby(i)*fazscond(i,08)+gazscond(i,12)
      fazpcond(i,24)=azbz(i)*fazscond(i,08)+gazscond(i,13)
      fazpcond(i,25)=axbx(i)*fazscond(i,09)+gazscond(i,09)
      fazpcond(i,26)=ayby(i)*fazscond(i,09)+gazscond(i,13)
      fazpcond(i,27)=azbz(i)*fazscond(i,09)+gazscond(i,14)
      fazpcond(i,28)=axbx(i)*fazscond(i,10)+gazscond(i,10)
      fazpcond(i,29)=ayby(i)*fazscond(i,10)+gazscond(i,14)
 1047 fazpcond(i,30)=azbz(i)*fazscond(i,10)+gazscond(i,15)

      do 1048 i=1,m
      daxdcond(i,01)=axbx(i)*daxpcond(i,01)+faxpcond(i,01)
      daxdcond(i,02)=ayby(i)*daxpcond(i,01)+faxpcond(i,04)
      daxdcond(i,03)=azbz(i)*daxpcond(i,01)+faxpcond(i,07)
      daxdcond(i,04)=ayby(i)*daxpcond(i,02)+faxpcond(i,05)
      daxdcond(i,05)=azbz(i)*daxpcond(i,02)+faxpcond(i,08)
      daxdcond(i,06)=azbz(i)*daxpcond(i,03)+faxpcond(i,09)
      daxdcond(i,07)=axbx(i)*daxpcond(i,04)+faxpcond(i,04)
      daxdcond(i,08)=ayby(i)*daxpcond(i,04)+faxpcond(i,10)
      daxdcond(i,09)=azbz(i)*daxpcond(i,04)+faxpcond(i,13)
      daxdcond(i,10)=ayby(i)*daxpcond(i,05)+faxpcond(i,11)
      daxdcond(i,11)=azbz(i)*daxpcond(i,05)+faxpcond(i,14)
      daxdcond(i,12)=azbz(i)*daxpcond(i,06)+faxpcond(i,15)
      daxdcond(i,13)=axbx(i)*daxpcond(i,07)+faxpcond(i,07)
      daxdcond(i,14)=ayby(i)*daxpcond(i,07)+faxpcond(i,13)
      daxdcond(i,15)=azbz(i)*daxpcond(i,07)+faxpcond(i,16)
      daxdcond(i,16)=ayby(i)*daxpcond(i,08)+faxpcond(i,14)
      daxdcond(i,17)=azbz(i)*daxpcond(i,08)+faxpcond(i,17)
      daxdcond(i,18)=azbz(i)*daxpcond(i,09)+faxpcond(i,18)
      daxdcond(i,19)=axbx(i)*daxpcond(i,10)+faxpcond(i,10)
      daxdcond(i,20)=ayby(i)*daxpcond(i,10)+faxpcond(i,19)
      daxdcond(i,21)=azbz(i)*daxpcond(i,10)+faxpcond(i,22)
      daxdcond(i,22)=ayby(i)*daxpcond(i,11)+faxpcond(i,20)
      daxdcond(i,23)=azbz(i)*daxpcond(i,11)+faxpcond(i,23)
      daxdcond(i,24)=azbz(i)*daxpcond(i,12)+faxpcond(i,24)
      daxdcond(i,25)=axbx(i)*daxpcond(i,13)+faxpcond(i,13)
      daxdcond(i,26)=ayby(i)*daxpcond(i,13)+faxpcond(i,22)
      daxdcond(i,27)=azbz(i)*daxpcond(i,13)+faxpcond(i,25)
      daxdcond(i,28)=ayby(i)*daxpcond(i,14)+faxpcond(i,23)
      daxdcond(i,29)=azbz(i)*daxpcond(i,14)+faxpcond(i,26)
      daxdcond(i,30)=azbz(i)*daxpcond(i,15)+faxpcond(i,27)
      daxdcond(i,31)=axbx(i)*daxpcond(i,16)+faxpcond(i,16)
      daxdcond(i,32)=ayby(i)*daxpcond(i,16)+faxpcond(i,25)
      daxdcond(i,33)=azbz(i)*daxpcond(i,16)+faxpcond(i,28)
      daxdcond(i,34)=ayby(i)*daxpcond(i,17)+faxpcond(i,26)
      daxdcond(i,35)=azbz(i)*daxpcond(i,17)+faxpcond(i,29)
      daxdcond(i,36)=azbz(i)*daxpcond(i,18)+faxpcond(i,30)
      daydcond(i,01)=axbx(i)*daypcond(i,01)+faypcond(i,01)
      daydcond(i,02)=ayby(i)*daypcond(i,01)+faypcond(i,04)
      daydcond(i,03)=azbz(i)*daypcond(i,01)+faypcond(i,07)
      daydcond(i,04)=ayby(i)*daypcond(i,02)+faypcond(i,05)
      daydcond(i,05)=azbz(i)*daypcond(i,02)+faypcond(i,08)
      daydcond(i,06)=azbz(i)*daypcond(i,03)+faypcond(i,09)
      daydcond(i,07)=axbx(i)*daypcond(i,04)+faypcond(i,04)
      daydcond(i,08)=ayby(i)*daypcond(i,04)+faypcond(i,10)
      daydcond(i,09)=azbz(i)*daypcond(i,04)+faypcond(i,13)
      daydcond(i,10)=ayby(i)*daypcond(i,05)+faypcond(i,11)
      daydcond(i,11)=azbz(i)*daypcond(i,05)+faypcond(i,14)
      daydcond(i,12)=azbz(i)*daypcond(i,06)+faypcond(i,15)
      daydcond(i,13)=axbx(i)*daypcond(i,07)+faypcond(i,07)
      daydcond(i,14)=ayby(i)*daypcond(i,07)+faypcond(i,13)
      daydcond(i,15)=azbz(i)*daypcond(i,07)+faypcond(i,16)
      daydcond(i,16)=ayby(i)*daypcond(i,08)+faypcond(i,14)
      daydcond(i,17)=azbz(i)*daypcond(i,08)+faypcond(i,17)
      daydcond(i,18)=azbz(i)*daypcond(i,09)+faypcond(i,18)
      daydcond(i,19)=axbx(i)*daypcond(i,10)+faypcond(i,10)
      daydcond(i,20)=ayby(i)*daypcond(i,10)+faypcond(i,19)
      daydcond(i,21)=azbz(i)*daypcond(i,10)+faypcond(i,22)
      daydcond(i,22)=ayby(i)*daypcond(i,11)+faypcond(i,20)
      daydcond(i,23)=azbz(i)*daypcond(i,11)+faypcond(i,23)
      daydcond(i,24)=azbz(i)*daypcond(i,12)+faypcond(i,24)
      daydcond(i,25)=axbx(i)*daypcond(i,13)+faypcond(i,13)
      daydcond(i,26)=ayby(i)*daypcond(i,13)+faypcond(i,22)
      daydcond(i,27)=azbz(i)*daypcond(i,13)+faypcond(i,25)
      daydcond(i,28)=ayby(i)*daypcond(i,14)+faypcond(i,23)
      daydcond(i,29)=azbz(i)*daypcond(i,14)+faypcond(i,26)
      daydcond(i,30)=azbz(i)*daypcond(i,15)+faypcond(i,27)
      daydcond(i,31)=axbx(i)*daypcond(i,16)+faypcond(i,16)
      daydcond(i,32)=ayby(i)*daypcond(i,16)+faypcond(i,25)
      daydcond(i,33)=azbz(i)*daypcond(i,16)+faypcond(i,28)
      daydcond(i,34)=ayby(i)*daypcond(i,17)+faypcond(i,26)
      daydcond(i,35)=azbz(i)*daypcond(i,17)+faypcond(i,29)
      daydcond(i,36)=azbz(i)*daypcond(i,18)+faypcond(i,30)
      dazdcond(i,01)=axbx(i)*dazpcond(i,01)+fazpcond(i,01)
      dazdcond(i,02)=ayby(i)*dazpcond(i,01)+fazpcond(i,04)
      dazdcond(i,03)=azbz(i)*dazpcond(i,01)+fazpcond(i,07)
      dazdcond(i,04)=ayby(i)*dazpcond(i,02)+fazpcond(i,05)
      dazdcond(i,05)=azbz(i)*dazpcond(i,02)+fazpcond(i,08)
      dazdcond(i,06)=azbz(i)*dazpcond(i,03)+fazpcond(i,09)
      dazdcond(i,07)=axbx(i)*dazpcond(i,04)+fazpcond(i,04)
      dazdcond(i,08)=ayby(i)*dazpcond(i,04)+fazpcond(i,10)
      dazdcond(i,09)=azbz(i)*dazpcond(i,04)+fazpcond(i,13)
      dazdcond(i,10)=ayby(i)*dazpcond(i,05)+fazpcond(i,11)
      dazdcond(i,11)=azbz(i)*dazpcond(i,05)+fazpcond(i,14)
      dazdcond(i,12)=azbz(i)*dazpcond(i,06)+fazpcond(i,15)
      dazdcond(i,13)=axbx(i)*dazpcond(i,07)+fazpcond(i,07)
      dazdcond(i,14)=ayby(i)*dazpcond(i,07)+fazpcond(i,13)
      dazdcond(i,15)=azbz(i)*dazpcond(i,07)+fazpcond(i,16)
      dazdcond(i,16)=ayby(i)*dazpcond(i,08)+fazpcond(i,14)
      dazdcond(i,17)=azbz(i)*dazpcond(i,08)+fazpcond(i,17)
      dazdcond(i,18)=azbz(i)*dazpcond(i,09)+fazpcond(i,18)
      dazdcond(i,19)=axbx(i)*dazpcond(i,10)+fazpcond(i,10)
      dazdcond(i,20)=ayby(i)*dazpcond(i,10)+fazpcond(i,19)
      dazdcond(i,21)=azbz(i)*dazpcond(i,10)+fazpcond(i,22)
      dazdcond(i,22)=ayby(i)*dazpcond(i,11)+fazpcond(i,20)
      dazdcond(i,23)=azbz(i)*dazpcond(i,11)+fazpcond(i,23)
      dazdcond(i,24)=azbz(i)*dazpcond(i,12)+fazpcond(i,24)
      dazdcond(i,25)=axbx(i)*dazpcond(i,13)+fazpcond(i,13)
      dazdcond(i,26)=ayby(i)*dazpcond(i,13)+fazpcond(i,22)
      dazdcond(i,27)=azbz(i)*dazpcond(i,13)+fazpcond(i,25)
      dazdcond(i,28)=ayby(i)*dazpcond(i,14)+fazpcond(i,23)
      dazdcond(i,29)=azbz(i)*dazpcond(i,14)+fazpcond(i,26)
      dazdcond(i,30)=azbz(i)*dazpcond(i,15)+fazpcond(i,27)
      dazdcond(i,31)=axbx(i)*dazpcond(i,16)+fazpcond(i,16)
      dazdcond(i,32)=ayby(i)*dazpcond(i,16)+fazpcond(i,25)
      dazdcond(i,33)=azbz(i)*dazpcond(i,16)+fazpcond(i,28)
      dazdcond(i,34)=ayby(i)*dazpcond(i,17)+fazpcond(i,26)
      dazdcond(i,35)=azbz(i)*dazpcond(i,17)+fazpcond(i,29)
 1048 dazdcond(i,36)=azbz(i)*dazpcond(i,18)+fazpcond(i,30)

      do 1049 i=1,m
 1049 esp=esp-density(inddyy(i,01))*ddcond(i,01)
     &       -density(inddyy(i,07))*ddcond(i,07)
     &       -density(inddyy(i,08))*ddcond(i,08)
     &       -density(inddyy(i,13))*ddcond(i,13)
     &       -density(inddyy(i,14))*ddcond(i,14)
     &       -density(inddyy(i,15))*ddcond(i,15)
     &       -density(inddyy(i,19))*ddcond(i,19)
     &       -density(inddyy(i,20))*ddcond(i,20)
     &       -density(inddyy(i,21))*ddcond(i,21)
     &       -density(inddyy(i,22))*ddcond(i,22)
     &       -density(inddyy(i,25))*ddcond(i,25)
     &       -density(inddyy(i,26))*ddcond(i,26)
     &       -density(inddyy(i,27))*ddcond(i,27)
     &       -density(inddyy(i,28))*ddcond(i,28)
     &       -density(inddyy(i,29))*ddcond(i,29)
     &       -density(inddyy(i,31))*ddcond(i,31)
     &       -density(inddyy(i,32))*ddcond(i,32)
     &       -density(inddyy(i,33))*ddcond(i,33)
     &       -density(inddyy(i,34))*ddcond(i,34)
     &       -density(inddyy(i,35))*ddcond(i,35)
     &       -density(inddyy(i,36))*ddcond(i,36)

      do 1050 i=1,m
      if(iminj(i).ne.0) then

                esp=esp-density(inddyy(i,02))*ddcond(i,02)
     &                 -density(inddyy(i,03))*ddcond(i,03)
     &                 -density(inddyy(i,04))*ddcond(i,04)
     &                 -density(inddyy(i,05))*ddcond(i,05)
     &                 -density(inddyy(i,06))*ddcond(i,06)
     &                 -density(inddyy(i,09))*ddcond(i,09)
     &                 -density(inddyy(i,10))*ddcond(i,10)
     &                 -density(inddyy(i,11))*ddcond(i,11)
     &                 -density(inddyy(i,12))*ddcond(i,12)
     &                 -density(inddyy(i,16))*ddcond(i,16)
     &                 -density(inddyy(i,17))*ddcond(i,17)
     &                 -density(inddyy(i,18))*ddcond(i,18)
     &                 -density(inddyy(i,23))*ddcond(i,23)
     &                 -density(inddyy(i,24))*ddcond(i,24)
     &                 -density(inddyy(i,30))*ddcond(i,30)

                        endif
 1050 continue

      do 1051 i=1,m
      efix=efix-density(inddyy(i,01))*daxdcond(i,01)
     &         -density(inddyy(i,07))*daxdcond(i,07)
     &         -density(inddyy(i,08))*daxdcond(i,08)
     &         -density(inddyy(i,13))*daxdcond(i,13)
     &         -density(inddyy(i,14))*daxdcond(i,14)
     &         -density(inddyy(i,15))*daxdcond(i,15)
     &         -density(inddyy(i,19))*daxdcond(i,19)
     &         -density(inddyy(i,20))*daxdcond(i,20)
     &         -density(inddyy(i,21))*daxdcond(i,21)
     &         -density(inddyy(i,22))*daxdcond(i,22)
     &         -density(inddyy(i,25))*daxdcond(i,25)
     &         -density(inddyy(i,26))*daxdcond(i,26)
     &         -density(inddyy(i,27))*daxdcond(i,27)
     &         -density(inddyy(i,28))*daxdcond(i,28)
     &         -density(inddyy(i,29))*daxdcond(i,29)
     &         -density(inddyy(i,31))*daxdcond(i,31)
     &         -density(inddyy(i,32))*daxdcond(i,32)
     &         -density(inddyy(i,33))*daxdcond(i,33)
     &         -density(inddyy(i,34))*daxdcond(i,34)
     &         -density(inddyy(i,35))*daxdcond(i,35)
     &         -density(inddyy(i,36))*daxdcond(i,36)
      efiy=efiy-density(inddyy(i,01))*daydcond(i,01)
     &         -density(inddyy(i,07))*daydcond(i,07)
     &         -density(inddyy(i,08))*daydcond(i,08)
     &         -density(inddyy(i,13))*daydcond(i,13)
     &         -density(inddyy(i,14))*daydcond(i,14)
     &         -density(inddyy(i,15))*daydcond(i,15)
     &         -density(inddyy(i,19))*daydcond(i,19)
     &         -density(inddyy(i,20))*daydcond(i,20)
     &         -density(inddyy(i,21))*daydcond(i,21)
     &         -density(inddyy(i,22))*daydcond(i,22)
     &         -density(inddyy(i,25))*daydcond(i,25)
     &         -density(inddyy(i,26))*daydcond(i,26)
     &         -density(inddyy(i,27))*daydcond(i,27)
     &         -density(inddyy(i,28))*daydcond(i,28)
     &         -density(inddyy(i,29))*daydcond(i,29)
     &         -density(inddyy(i,31))*daydcond(i,31)
     &         -density(inddyy(i,32))*daydcond(i,32)
     &         -density(inddyy(i,33))*daydcond(i,33)
     &         -density(inddyy(i,34))*daydcond(i,34)
     &         -density(inddyy(i,35))*daydcond(i,35)
     &         -density(inddyy(i,36))*daydcond(i,36)
 1051 efiz=efiz-density(inddyy(i,01))*dazdcond(i,01)
     &         -density(inddyy(i,07))*dazdcond(i,07)
     &         -density(inddyy(i,08))*dazdcond(i,08)
     &         -density(inddyy(i,13))*dazdcond(i,13)
     &         -density(inddyy(i,14))*dazdcond(i,14)
     &         -density(inddyy(i,15))*dazdcond(i,15)
     &         -density(inddyy(i,19))*dazdcond(i,19)
     &         -density(inddyy(i,20))*dazdcond(i,20)
     &         -density(inddyy(i,21))*dazdcond(i,21)
     &         -density(inddyy(i,22))*dazdcond(i,22)
     &         -density(inddyy(i,25))*dazdcond(i,25)
     &         -density(inddyy(i,26))*dazdcond(i,26)
     &         -density(inddyy(i,27))*dazdcond(i,27)
     &         -density(inddyy(i,28))*dazdcond(i,28)
     &         -density(inddyy(i,29))*dazdcond(i,29)
     &         -density(inddyy(i,31))*dazdcond(i,31)
     &         -density(inddyy(i,32))*dazdcond(i,32)
     &         -density(inddyy(i,33))*dazdcond(i,33)
     &         -density(inddyy(i,34))*dazdcond(i,34)
     &         -density(inddyy(i,35))*dazdcond(i,35)
     &         -density(inddyy(i,36))*dazdcond(i,36)

      do 1052 i=1,m
      if(iminj(i).ne.0) then

              efix=efix-density(inddyy(i,02))*daxdcond(i,02)
     &                 -density(inddyy(i,03))*daxdcond(i,03)
     &                 -density(inddyy(i,04))*daxdcond(i,04)
     &                 -density(inddyy(i,05))*daxdcond(i,05)
     &                 -density(inddyy(i,06))*daxdcond(i,06)
     &                 -density(inddyy(i,09))*daxdcond(i,09)
     &                 -density(inddyy(i,10))*daxdcond(i,10)
     &                 -density(inddyy(i,11))*daxdcond(i,11)
     &                 -density(inddyy(i,12))*daxdcond(i,12)
     &                 -density(inddyy(i,16))*daxdcond(i,16)
     &                 -density(inddyy(i,17))*daxdcond(i,17)
     &                 -density(inddyy(i,18))*daxdcond(i,18)
     &                 -density(inddyy(i,23))*daxdcond(i,23)
     &                 -density(inddyy(i,24))*daxdcond(i,24)
     &                 -density(inddyy(i,30))*daxdcond(i,30)

              efiy=efiy-density(inddyy(i,02))*daydcond(i,02)
     &                 -density(inddyy(i,03))*daydcond(i,03)
     &                 -density(inddyy(i,04))*daydcond(i,04)
     &                 -density(inddyy(i,05))*daydcond(i,05)
     &                 -density(inddyy(i,06))*daydcond(i,06)
     &                 -density(inddyy(i,09))*daydcond(i,09)
     &                 -density(inddyy(i,10))*daydcond(i,10)
     &                 -density(inddyy(i,11))*daydcond(i,11)
     &                 -density(inddyy(i,12))*daydcond(i,12)
     &                 -density(inddyy(i,16))*daydcond(i,16)
     &                 -density(inddyy(i,17))*daydcond(i,17)
     &                 -density(inddyy(i,18))*daydcond(i,18)
     &                 -density(inddyy(i,23))*daydcond(i,23)
     &                 -density(inddyy(i,24))*daydcond(i,24)
     &                 -density(inddyy(i,30))*daydcond(i,30)

              efiz=efiz-density(inddyy(i,02))*dazdcond(i,02)
     &                 -density(inddyy(i,03))*dazdcond(i,03)
     &                 -density(inddyy(i,04))*dazdcond(i,04)
     &                 -density(inddyy(i,05))*dazdcond(i,05)
     &                 -density(inddyy(i,06))*dazdcond(i,06)
     &                 -density(inddyy(i,09))*dazdcond(i,09)
     &                 -density(inddyy(i,10))*dazdcond(i,10)
     &                 -density(inddyy(i,11))*dazdcond(i,11)
     &                 -density(inddyy(i,12))*dazdcond(i,12)
     &                 -density(inddyy(i,16))*dazdcond(i,16)
     &                 -density(inddyy(i,17))*dazdcond(i,17)
     &                 -density(inddyy(i,18))*dazdcond(i,18)
     &                 -density(inddyy(i,23))*dazdcond(i,23)
     &                 -density(inddyy(i,24))*dazdcond(i,24)
     &                 -density(inddyy(i,30))*dazdcond(i,30)

                        endif
 1052 continue
  
      return 
      end 

      subroutine checkpt(alpha,coeff,cent,cpt,dlarge,weight,tolerance,
     &                   ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,nconts,
     &                   ncontp,ncontd)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cpt(*),alpha(*),coeff(*),cent(3,*)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)

      data zero,expcut/0.0d0,80.0d0/

      dlarge=zero

      if(nconts.eq.0) return

c  loop over s functions

      do 1001 i=1,nconts

      s=zero

      ilabel=nptrs(i)

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      nc=icfunc(ilabel)

      xx=cpt(1)-cent(1,nc)
      yy=cpt(2)-cent(2,nc)
      zz=cpt(3)-cent(3,nc)

      rr=xx*xx+yy*yy+zz*zz

      do 1002 j=iptr1,iptr2

      rralpha=rr*alpha(j)
      if(rralpha.gt.expcut) goto 1002

      s=s+coeff(j)*exp(-rralpha)

 1002 continue

      dlrgsub=abs(s)
      if(dlrgsub.gt.dlarge) dlarge=dlrgsub

      if(dlarge*weight.gt.tolerance) return

 1001 continue

      if(ncontp.eq.0) return

c  loop over p functions

      do 1003 i=1,ncontp

      px=zero
      py=zero
      pz=zero

      ilabel=nptrp(i)

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      nc=icfunc(ilabel)

      xx=cpt(1)-cent(1,nc)
      yy=cpt(2)-cent(2,nc)
      zz=cpt(3)-cent(3,nc)

      rr=xx*xx+yy*yy+zz*zz

      do 2003 j=iptr1,iptr2

      rralpha=rr*alpha(j)
      if(rralpha.gt.expcut) goto 2003

      s=coeff(j)*exp(-rralpha)

      px=px+xx*s
      py=py+yy*s
      pz=pz+zz*s

 2003 continue

      dlrgsub=max(abs(px),abs(py),abs(pz))
      if(dlrgsub.gt.dlarge) dlarge=dlrgsub

      if(dlarge*weight.gt.tolerance) return

 1003 continue

      if(ncontd.eq.0) return

c  loop over s functions

      do 3002 i=1,ncontd

      dxx=zero
      dxy=zero
      dxz=zero
      dyy=zero
      dyz=zero
      dzz=zero

      ilabel=nptrd(i)

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      nc=icfunc(ilabel)

      xx=cpt(1)-cent(1,nc)
      yy=cpt(2)-cent(2,nc)
      zz=cpt(3)-cent(3,nc)

      rr=xx*xx+yy*yy+zz*zz

      do 3003 j=iptr1,iptr2

      rralpha=rr*alpha(j)
      if(rralpha.gt.expcut) goto 3003

      s=coeff(j)*exp(-rralpha)

      dxx=dxx+xx*xx*s
      dxy=dxy+xx*yy*s
      dxz=dxz+xx*zz*s
      dyy=dyy+yy*yy*s
      dyz=dyz+yy*zz*s
      dzz=dzz+zz*zz*s

 3003 continue

      dlrgsub=max(abs(dxx),abs(dxy),abs(dxz),abs(dyy),abs(dyz),abs(dzz))
      if(dlrgsub.gt.dlarge) dlarge=dlrgsub

      if(dlarge*weight.gt.tolerance) return

 3002 continue

      return
      end

      subroutine boys_print(n,natoms,nconts,ncontp,ncontd,nshels,nshelp,
     &                      nsheld,icfunc,nfuncatom,natomtype,overlap,
     &                      coeffmo,pmat,smat,pstmat)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),nfuncatom(*),icfunc(*),
     &          natomtype(*)

      dimension overlap(*),coeffmo(*)

      dimension pmat(n,*),smat(n,*),pstmat(n,*)

      data zero,two,cutoff/0.0d0,2.0d0,0.05d0/

      do 1001 j=1,n
      do 1001 i=1,n
 1001 pmat(i,j)=coeffmo(i)*coeffmo(j)

      ij=0

      do 1002 i=1,n
      do 1002 j=1,i
      ij=ij+1
      smat(i,j)=overlap(ij)
 1002 smat(j,i)=overlap(ij)

      do 1003 j=1,n
      do 1004 i=1,n
 1004 pstmat(i,j)=zero
      do 1003 k=1,n
      do 1003 i=1,n
 1003 pstmat(i,j)=pstmat(i,j)+pmat(i,k)*smat(k,j)

      ii=0

      do 1005 i=1,nconts
      nfuncatom(ii+1)=icfunc(nshels(i))
 1005 ii=ii+1

      do 1006 i=1,ncontp
      do 1007 k=1,3
 1007 nfuncatom(ii+k)=icfunc(nshelp(i))
 1006 ii=ii+3

      do 1008 i=1,ncontd
      do 1009 k=1,6
 1009 nfuncatom(ii+k)=icfunc(nsheld(i))
 1008 ii=ii+6

      write(6,1010)
 1010 format(/,'         mulliken population analysis :',/)

      do 1011 i=1,natoms

      pop=zero

      do 1012 j=1,n
 1012 if(nfuncatom(j).eq.i) pop=pop+pstmat(j,j)

      if(abs(pop).gt.cutoff) write(6,1013) i,pop
 1013 format(15x,' atom # ',i4,'       population = ',f8.4)

 1011 continue

      write(6,1014)
 1014 format(/,'         mayer bond order analysis :',/)

      do 1015 i=1,natoms
      do 1015 j=i,natoms

      if(i.eq.j) goto 1015

      bond=zero

      do 1016 k=1,n
      do 1016 l=1,n
 1016 if((nfuncatom(k).eq.i).and.
     &   (nfuncatom(l).eq.j)) bond=bond+pstmat(k,l)*pstmat(l,k)

      if(abs(two*bond).gt.cutoff) write(6,1017) i,j,two*bond
 1017 format(15x,' atoms # ',i4,' and ',i4,'       bond order = ',f8.4)

 1015 continue

      write(6,1018)
 1018 format()

      ii=0

      do 1019 j=1,nconts
      if(abs(coeffmo(ii+1)).gt.cutoff)
     &       write(6,1020) ii+1,nfuncatom(ii+1),coeffmo(ii+1)
 1020 format('         a.o. #',i5,',     center',i4,',    s  ',f15.8)
 1019 ii=ii+1

      do 1021 j=1,ncontp
      if(abs(coeffmo(ii+1)).gt.cutoff)
     &       write(6,1022) ii+1,nfuncatom(ii+1),coeffmo(ii+1)
 1022 format('         a.o. #',i5,',     center',i4,',    px ',f15.8)
      if(abs(coeffmo(ii+2)).gt.cutoff)
     &       write(6,1023) ii+2,nfuncatom(ii+2),coeffmo(ii+2)
 1023 format('         a.o. #',i5,',     center',i4,',    py ',f15.8)
      if(abs(coeffmo(ii+3)).gt.cutoff)
     &       write(6,1024) ii+3,nfuncatom(ii+3),coeffmo(ii+3)
 1024 format('         a.o. #',i5,',     center',i4,',    pz ',f15.8)
 1021 ii=ii+3

      do 1025 j=1,ncontd
      if(abs(coeffmo(ii+1)).gt.cutoff)
     &       write(6,1026) ii+1,nfuncatom(ii+1),coeffmo(ii+1)
 1026 format('         a.o. #',i5,',     center',i4,',    dxx',f15.8)
      if(abs(coeffmo(ii+2)).gt.cutoff)
     &       write(6,1027) ii+2,nfuncatom(ii+2),coeffmo(ii+2)
 1027 format('         a.o. #',i5,',     center',i4,',    dxy',f15.8)
      if(abs(coeffmo(ii+3)).gt.cutoff)
     &       write(6,1028) ii+3,nfuncatom(ii+3),coeffmo(ii+3)
 1028 format('         a.o. #',i5,',     center',i4,',    dxz',f15.8)
      if(abs(coeffmo(ii+4)).gt.cutoff)
     &       write(6,1029) ii+4,nfuncatom(ii+4),coeffmo(ii+4)
 1029 format('         a.o. #',i5,',     center',i4,',    dyy',f15.8)
      if(abs(coeffmo(ii+5)).gt.cutoff)
     &       write(6,1030) ii+5,nfuncatom(ii+5),coeffmo(ii+5)
 1030 format('         a.o. #',i5,',     center',i4,',    dyz',f15.8)
      if(abs(coeffmo(ii+6)).gt.cutoff)
     &       write(6,1031) ii+6,nfuncatom(ii+6),coeffmo(ii+6)
 1031 format('         a.o. #',i5,',     center',i4,',    dzz',f15.8)
 1025 ii=ii+6

      write(6,1032)
 1032 format(//)

      return
      end

      subroutine gradxxdd4(m,n,nn,nc,iminj,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,ttwozetab,
     &                     dss0,dsp0,dsd0,fss0,fsp0,fsd0,gss0,gsp0,gsd0,
     &                     hss0,hsp0,hsd0,axbx,ayby,azbz,dsscond,
     &                     dspcond,dsdcond,fsscond,fspcond,fsdcond,
     &                     gsscond,gspcond,gsdcond,hsscond,hspcond,
     &                     hsdcond,dpscond,dppcond,dpdcond,fpscond,
     &                     fppcond,fpdcond,gpscond,gppcond,gpdcond,
     &                     ddscond,ddpcond,dddcond,fdscond,fdpcond,
     &                     fddcond,dfscond,dfpcond,dfdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),
     &          ttwozetab(*),dss0(n,*),dsp0(n,*),dsd0(n,*),fss0(n,*),
     &          fsp0(n,*),fsd0(n,*),gss0(n,*),gsp0(n,*),gsd0(n,*),
     &          hss0(n,*),hsp0(n,*),hsd0(n,*),axbx(*),ayby(*),azbz(*),
     &          dsscond(m,*),dspcond(m,*),dsdcond(m,*),fsscond(m,*),
     &          fspcond(m,*),fsdcond(m,*),gsscond(m,*),gspcond(m,*),
     &          gsdcond(m,*),hsscond(m,*),hspcond(m,*),hsdcond(m,*),
     &          dpscond(m,*),dppcond(m,*),dpdcond(m,*),fpscond(m,*),
     &          fppcond(m,*),fpdcond(m,*),gpscond(m,*),gppcond(m,*),
     &          gpdcond(m,*),ddscond(m,*),ddpcond(m,*),dddcond(m,*),
     &          fdscond(m,*),fdpcond(m,*),fddcond(m,*),dfscond(m,*),
     &          dfpcond(m,*),dfdcond(m,*),grad(m,*)

      data zero/0.0d0/

      do 1001 j=1,6
      do 1001 i=1,m
 1001 dsscond(i,j)=zero

      do 1002 j=1,10
      do 1002 i=1,m
 1002 fsscond(i,j)=zero

      do 1003 j=1,15
      do 1003 i=1,m
 1003 gsscond(i,j)=zero

      do 1004 j=1,21
      do 1004 i=1,m
 1004 hsscond(i,j)=zero

      do 1005 j=1,6
      do 1005 i=1,nn
 1005 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dss0(i,j)*ttwozetab(i)*cdfits

      do 1006 k=1,3
      do 1006 j=1,6
      do 1006 i=1,nn
 1006 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1007 k=1,6
      do 1007 j=1,6
      do 1007 i=1,nn
 1007 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)
     &                     +dsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1008 j=1,10
      do 1008 i=1,nn
 1008 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fss0(i,j)*ttwozetab(i)*cdfits

      do 1009 k=1,3
      do 1009 j=1,10
      do 1009 i=1,nn
 1009 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1010 k=1,6
      do 1010 j=1,10
      do 1010 i=1,nn
 1010 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)
     &                     +fsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1011 j=1,15
      do 1011 i=1,nn
 1011 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gss0(i,j)*ttwozetab(i)*cdfits

      do 1012 k=1,3
      do 1012 j=1,15
      do 1012 i=1,nn
 1012 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1013 k=1,6
      do 1013 j=1,15
      do 1013 i=1,nn
 1013 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)
     &                     +gsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1014 j=1,21
      do 1014 i=1,nn
 1014 hsscond(iicontr(i),j)=hsscond(iicontr(i),j)
     &                     +hss0(i,j)*ttwozetab(i)*cdfits

      do 1015 k=1,3
      do 1015 j=1,21
      do 1015 i=1,nn
 1015 hsscond(iicontr(i),j)=hsscond(iicontr(i),j)
     &                     +hsp0(i,3*(j-1)+k)*ttwozetab(i)*cdfitp(k)

      do 1016 k=1,6
      do 1016 j=1,21
      do 1016 i=1,nn
 1016 hsscond(iicontr(i),j)=hsscond(iicontr(i),j)
     &                     +hsd0(i,6*(j-1)+k)*ttwozetab(i)*cdfitd(k)

      do 1017 i=1,m
      dpscond(i,01)=axbx(i)*dsscond(i,1)+fsscond(i,01)
      dpscond(i,02)=ayby(i)*dsscond(i,1)+fsscond(i,02)
      dpscond(i,03)=azbz(i)*dsscond(i,1)+fsscond(i,03)
      dpscond(i,04)=axbx(i)*dsscond(i,2)+fsscond(i,02)
      dpscond(i,05)=ayby(i)*dsscond(i,2)+fsscond(i,04)
      dpscond(i,06)=azbz(i)*dsscond(i,2)+fsscond(i,05)
      dpscond(i,07)=axbx(i)*dsscond(i,3)+fsscond(i,03)
      dpscond(i,08)=ayby(i)*dsscond(i,3)+fsscond(i,05)
      dpscond(i,09)=azbz(i)*dsscond(i,3)+fsscond(i,06)
      dpscond(i,10)=axbx(i)*dsscond(i,4)+fsscond(i,04)
      dpscond(i,11)=ayby(i)*dsscond(i,4)+fsscond(i,07)
      dpscond(i,12)=azbz(i)*dsscond(i,4)+fsscond(i,08)
      dpscond(i,13)=axbx(i)*dsscond(i,5)+fsscond(i,05)
      dpscond(i,14)=ayby(i)*dsscond(i,5)+fsscond(i,08)
      dpscond(i,15)=azbz(i)*dsscond(i,5)+fsscond(i,09)
      dpscond(i,16)=axbx(i)*dsscond(i,6)+fsscond(i,06)
      dpscond(i,17)=ayby(i)*dsscond(i,6)+fsscond(i,09)
 1017 dpscond(i,18)=azbz(i)*dsscond(i,6)+fsscond(i,10)

      do 1018 i=1,m
      fpscond(i,01)=axbx(i)*fsscond(i,01)+gsscond(i,01)
      fpscond(i,02)=ayby(i)*fsscond(i,01)+gsscond(i,02)
      fpscond(i,03)=azbz(i)*fsscond(i,01)+gsscond(i,03)
      fpscond(i,04)=axbx(i)*fsscond(i,02)+gsscond(i,02)
      fpscond(i,05)=ayby(i)*fsscond(i,02)+gsscond(i,04)
      fpscond(i,06)=azbz(i)*fsscond(i,02)+gsscond(i,05)
      fpscond(i,07)=axbx(i)*fsscond(i,03)+gsscond(i,03)
      fpscond(i,08)=ayby(i)*fsscond(i,03)+gsscond(i,05)
      fpscond(i,09)=azbz(i)*fsscond(i,03)+gsscond(i,06)
      fpscond(i,10)=axbx(i)*fsscond(i,04)+gsscond(i,04)
      fpscond(i,11)=ayby(i)*fsscond(i,04)+gsscond(i,07)
      fpscond(i,12)=azbz(i)*fsscond(i,04)+gsscond(i,08)
      fpscond(i,13)=axbx(i)*fsscond(i,05)+gsscond(i,05)
      fpscond(i,14)=ayby(i)*fsscond(i,05)+gsscond(i,08)
      fpscond(i,15)=azbz(i)*fsscond(i,05)+gsscond(i,09)
      fpscond(i,16)=axbx(i)*fsscond(i,06)+gsscond(i,06)
      fpscond(i,17)=ayby(i)*fsscond(i,06)+gsscond(i,09)
      fpscond(i,18)=azbz(i)*fsscond(i,06)+gsscond(i,10)
      fpscond(i,19)=axbx(i)*fsscond(i,07)+gsscond(i,07)
      fpscond(i,20)=ayby(i)*fsscond(i,07)+gsscond(i,11)
      fpscond(i,21)=azbz(i)*fsscond(i,07)+gsscond(i,12)
      fpscond(i,22)=axbx(i)*fsscond(i,08)+gsscond(i,08)
      fpscond(i,23)=ayby(i)*fsscond(i,08)+gsscond(i,12)
      fpscond(i,24)=azbz(i)*fsscond(i,08)+gsscond(i,13)
      fpscond(i,25)=axbx(i)*fsscond(i,09)+gsscond(i,09)
      fpscond(i,26)=ayby(i)*fsscond(i,09)+gsscond(i,13)
      fpscond(i,27)=azbz(i)*fsscond(i,09)+gsscond(i,14)
      fpscond(i,28)=axbx(i)*fsscond(i,10)+gsscond(i,10)
      fpscond(i,29)=ayby(i)*fsscond(i,10)+gsscond(i,14)
 1018 fpscond(i,30)=azbz(i)*fsscond(i,10)+gsscond(i,15)

      do 1019 i=1,m
      gpscond(i,01)=axbx(i)*gsscond(i,01)+hsscond(i,01)
      gpscond(i,02)=ayby(i)*gsscond(i,01)+hsscond(i,02)
      gpscond(i,03)=azbz(i)*gsscond(i,01)+hsscond(i,03)
      gpscond(i,04)=axbx(i)*gsscond(i,02)+hsscond(i,02)
      gpscond(i,05)=ayby(i)*gsscond(i,02)+hsscond(i,04)
      gpscond(i,06)=azbz(i)*gsscond(i,02)+hsscond(i,05)
      gpscond(i,07)=axbx(i)*gsscond(i,03)+hsscond(i,03)
      gpscond(i,08)=ayby(i)*gsscond(i,03)+hsscond(i,05)
      gpscond(i,09)=azbz(i)*gsscond(i,03)+hsscond(i,06)
      gpscond(i,10)=axbx(i)*gsscond(i,04)+hsscond(i,04)
      gpscond(i,11)=ayby(i)*gsscond(i,04)+hsscond(i,07)
      gpscond(i,12)=azbz(i)*gsscond(i,04)+hsscond(i,08)
      gpscond(i,13)=axbx(i)*gsscond(i,05)+hsscond(i,05)
      gpscond(i,14)=ayby(i)*gsscond(i,05)+hsscond(i,08)
      gpscond(i,15)=azbz(i)*gsscond(i,05)+hsscond(i,09)
      gpscond(i,16)=axbx(i)*gsscond(i,06)+hsscond(i,06)
      gpscond(i,17)=ayby(i)*gsscond(i,06)+hsscond(i,09)
      gpscond(i,18)=azbz(i)*gsscond(i,06)+hsscond(i,10)
      gpscond(i,19)=axbx(i)*gsscond(i,07)+hsscond(i,07)
      gpscond(i,20)=ayby(i)*gsscond(i,07)+hsscond(i,11)
      gpscond(i,21)=azbz(i)*gsscond(i,07)+hsscond(i,12)
      gpscond(i,22)=axbx(i)*gsscond(i,08)+hsscond(i,08)
      gpscond(i,23)=ayby(i)*gsscond(i,08)+hsscond(i,12)
      gpscond(i,24)=azbz(i)*gsscond(i,08)+hsscond(i,13)
      gpscond(i,25)=axbx(i)*gsscond(i,09)+hsscond(i,09)
      gpscond(i,26)=ayby(i)*gsscond(i,09)+hsscond(i,13)
      gpscond(i,27)=azbz(i)*gsscond(i,09)+hsscond(i,14)
      gpscond(i,28)=axbx(i)*gsscond(i,10)+hsscond(i,10)
      gpscond(i,29)=ayby(i)*gsscond(i,10)+hsscond(i,14)
      gpscond(i,30)=azbz(i)*gsscond(i,10)+hsscond(i,15)
      gpscond(i,31)=axbx(i)*gsscond(i,11)+hsscond(i,11)
      gpscond(i,32)=ayby(i)*gsscond(i,11)+hsscond(i,16)
      gpscond(i,33)=azbz(i)*gsscond(i,11)+hsscond(i,17)
      gpscond(i,34)=axbx(i)*gsscond(i,12)+hsscond(i,12)
      gpscond(i,35)=ayby(i)*gsscond(i,12)+hsscond(i,17)
      gpscond(i,36)=azbz(i)*gsscond(i,12)+hsscond(i,18)
      gpscond(i,37)=axbx(i)*gsscond(i,13)+hsscond(i,13)
      gpscond(i,38)=ayby(i)*gsscond(i,13)+hsscond(i,18)
      gpscond(i,39)=azbz(i)*gsscond(i,13)+hsscond(i,19)
      gpscond(i,40)=axbx(i)*gsscond(i,14)+hsscond(i,14)
      gpscond(i,41)=ayby(i)*gsscond(i,14)+hsscond(i,19)
      gpscond(i,42)=azbz(i)*gsscond(i,14)+hsscond(i,20)
      gpscond(i,43)=axbx(i)*gsscond(i,15)+hsscond(i,15)
      gpscond(i,44)=ayby(i)*gsscond(i,15)+hsscond(i,20)
 1019 gpscond(i,45)=azbz(i)*gsscond(i,15)+hsscond(i,21)

      do 1020 i=1,m
      ddscond(i,01)=axbx(i)*dpscond(i,01)+fpscond(i,01)
      ddscond(i,02)=ayby(i)*dpscond(i,01)+fpscond(i,04)
      ddscond(i,03)=azbz(i)*dpscond(i,01)+fpscond(i,07)
      ddscond(i,04)=ayby(i)*dpscond(i,02)+fpscond(i,05)
      ddscond(i,05)=azbz(i)*dpscond(i,02)+fpscond(i,08)
      ddscond(i,06)=azbz(i)*dpscond(i,03)+fpscond(i,09)
      ddscond(i,07)=axbx(i)*dpscond(i,04)+fpscond(i,04)
      ddscond(i,08)=ayby(i)*dpscond(i,04)+fpscond(i,10)
      ddscond(i,09)=azbz(i)*dpscond(i,04)+fpscond(i,13)
      ddscond(i,10)=ayby(i)*dpscond(i,05)+fpscond(i,11)
      ddscond(i,11)=azbz(i)*dpscond(i,05)+fpscond(i,14)
      ddscond(i,12)=azbz(i)*dpscond(i,06)+fpscond(i,15)
      ddscond(i,13)=axbx(i)*dpscond(i,07)+fpscond(i,07)
      ddscond(i,14)=ayby(i)*dpscond(i,07)+fpscond(i,13)
      ddscond(i,15)=azbz(i)*dpscond(i,07)+fpscond(i,16)
      ddscond(i,16)=ayby(i)*dpscond(i,08)+fpscond(i,14)
      ddscond(i,17)=azbz(i)*dpscond(i,08)+fpscond(i,17)
      ddscond(i,18)=azbz(i)*dpscond(i,09)+fpscond(i,18)
      ddscond(i,19)=axbx(i)*dpscond(i,10)+fpscond(i,10)
      ddscond(i,20)=ayby(i)*dpscond(i,10)+fpscond(i,19)
      ddscond(i,21)=azbz(i)*dpscond(i,10)+fpscond(i,22)
      ddscond(i,22)=ayby(i)*dpscond(i,11)+fpscond(i,20)
      ddscond(i,23)=azbz(i)*dpscond(i,11)+fpscond(i,23)
      ddscond(i,24)=azbz(i)*dpscond(i,12)+fpscond(i,24)
      ddscond(i,25)=axbx(i)*dpscond(i,13)+fpscond(i,13)
      ddscond(i,26)=ayby(i)*dpscond(i,13)+fpscond(i,22)
      ddscond(i,27)=azbz(i)*dpscond(i,13)+fpscond(i,25)
      ddscond(i,28)=ayby(i)*dpscond(i,14)+fpscond(i,23)
      ddscond(i,29)=azbz(i)*dpscond(i,14)+fpscond(i,26)
      ddscond(i,30)=azbz(i)*dpscond(i,15)+fpscond(i,27)
      ddscond(i,31)=axbx(i)*dpscond(i,16)+fpscond(i,16)
      ddscond(i,32)=ayby(i)*dpscond(i,16)+fpscond(i,25)
      ddscond(i,33)=azbz(i)*dpscond(i,16)+fpscond(i,28)
      ddscond(i,34)=ayby(i)*dpscond(i,17)+fpscond(i,26)
      ddscond(i,35)=azbz(i)*dpscond(i,17)+fpscond(i,29)
 1020 ddscond(i,36)=azbz(i)*dpscond(i,18)+fpscond(i,30)

      do 1021 i=1,m
      fdscond(i,01)=axbx(i)*fpscond(i,01)+gpscond(i,01)
      fdscond(i,02)=ayby(i)*fpscond(i,01)+gpscond(i,04)
      fdscond(i,03)=azbz(i)*fpscond(i,01)+gpscond(i,07)
      fdscond(i,04)=ayby(i)*fpscond(i,02)+gpscond(i,05)
      fdscond(i,05)=azbz(i)*fpscond(i,02)+gpscond(i,08)
      fdscond(i,06)=azbz(i)*fpscond(i,03)+gpscond(i,09)
      fdscond(i,07)=axbx(i)*fpscond(i,04)+gpscond(i,04)
      fdscond(i,08)=ayby(i)*fpscond(i,04)+gpscond(i,10)
      fdscond(i,09)=azbz(i)*fpscond(i,04)+gpscond(i,13)
      fdscond(i,10)=ayby(i)*fpscond(i,05)+gpscond(i,11)
      fdscond(i,11)=azbz(i)*fpscond(i,05)+gpscond(i,14)
      fdscond(i,12)=azbz(i)*fpscond(i,06)+gpscond(i,15)
      fdscond(i,13)=axbx(i)*fpscond(i,07)+gpscond(i,07)
      fdscond(i,14)=ayby(i)*fpscond(i,07)+gpscond(i,13)
      fdscond(i,15)=azbz(i)*fpscond(i,07)+gpscond(i,16)
      fdscond(i,16)=ayby(i)*fpscond(i,08)+gpscond(i,14)
      fdscond(i,17)=azbz(i)*fpscond(i,08)+gpscond(i,17)
      fdscond(i,18)=azbz(i)*fpscond(i,09)+gpscond(i,18)
      fdscond(i,19)=axbx(i)*fpscond(i,10)+gpscond(i,10)
      fdscond(i,20)=ayby(i)*fpscond(i,10)+gpscond(i,19)
      fdscond(i,21)=azbz(i)*fpscond(i,10)+gpscond(i,22)
      fdscond(i,22)=ayby(i)*fpscond(i,11)+gpscond(i,20)
      fdscond(i,23)=azbz(i)*fpscond(i,11)+gpscond(i,23)
      fdscond(i,24)=azbz(i)*fpscond(i,12)+gpscond(i,24)
      fdscond(i,25)=axbx(i)*fpscond(i,13)+gpscond(i,13)
      fdscond(i,26)=ayby(i)*fpscond(i,13)+gpscond(i,22)
      fdscond(i,27)=azbz(i)*fpscond(i,13)+gpscond(i,25)
      fdscond(i,28)=ayby(i)*fpscond(i,14)+gpscond(i,23)
      fdscond(i,29)=azbz(i)*fpscond(i,14)+gpscond(i,26)
      fdscond(i,30)=azbz(i)*fpscond(i,15)+gpscond(i,27)
      fdscond(i,31)=axbx(i)*fpscond(i,16)+gpscond(i,16)
      fdscond(i,32)=ayby(i)*fpscond(i,16)+gpscond(i,25)
      fdscond(i,33)=azbz(i)*fpscond(i,16)+gpscond(i,28)
      fdscond(i,34)=ayby(i)*fpscond(i,17)+gpscond(i,26)
      fdscond(i,35)=azbz(i)*fpscond(i,17)+gpscond(i,29)
      fdscond(i,36)=azbz(i)*fpscond(i,18)+gpscond(i,30)
      fdscond(i,37)=axbx(i)*fpscond(i,19)+gpscond(i,19)
      fdscond(i,38)=ayby(i)*fpscond(i,19)+gpscond(i,31)
      fdscond(i,39)=azbz(i)*fpscond(i,19)+gpscond(i,34)
      fdscond(i,40)=ayby(i)*fpscond(i,20)+gpscond(i,32)
      fdscond(i,41)=azbz(i)*fpscond(i,20)+gpscond(i,35)
      fdscond(i,42)=azbz(i)*fpscond(i,21)+gpscond(i,36)
      fdscond(i,43)=axbx(i)*fpscond(i,22)+gpscond(i,22)
      fdscond(i,44)=ayby(i)*fpscond(i,22)+gpscond(i,34)
      fdscond(i,45)=azbz(i)*fpscond(i,22)+gpscond(i,37)
      fdscond(i,46)=ayby(i)*fpscond(i,23)+gpscond(i,35)
      fdscond(i,47)=azbz(i)*fpscond(i,23)+gpscond(i,38)
      fdscond(i,48)=azbz(i)*fpscond(i,24)+gpscond(i,39)
      fdscond(i,49)=axbx(i)*fpscond(i,25)+gpscond(i,25)
      fdscond(i,50)=ayby(i)*fpscond(i,25)+gpscond(i,37)
      fdscond(i,51)=azbz(i)*fpscond(i,25)+gpscond(i,40)
      fdscond(i,52)=ayby(i)*fpscond(i,26)+gpscond(i,38)
      fdscond(i,53)=azbz(i)*fpscond(i,26)+gpscond(i,41)
      fdscond(i,54)=azbz(i)*fpscond(i,27)+gpscond(i,42)
      fdscond(i,55)=axbx(i)*fpscond(i,28)+gpscond(i,28)
      fdscond(i,56)=ayby(i)*fpscond(i,28)+gpscond(i,40)
      fdscond(i,57)=azbz(i)*fpscond(i,28)+gpscond(i,43)
      fdscond(i,58)=ayby(i)*fpscond(i,29)+gpscond(i,41)
      fdscond(i,59)=azbz(i)*fpscond(i,29)+gpscond(i,44)
 1021 fdscond(i,60)=azbz(i)*fpscond(i,30)+gpscond(i,45)

      do 1022 i=1,m
      dfscond(i,01)=axbx(i)*ddscond(i,01)+fdscond(i,01)
      dfscond(i,02)=ayby(i)*ddscond(i,01)+fdscond(i,07)
      dfscond(i,03)=azbz(i)*ddscond(i,01)+fdscond(i,13)
      dfscond(i,04)=ayby(i)*ddscond(i,02)+fdscond(i,08)
      dfscond(i,05)=azbz(i)*ddscond(i,02)+fdscond(i,14)
      dfscond(i,06)=azbz(i)*ddscond(i,03)+fdscond(i,15)
      dfscond(i,07)=ayby(i)*ddscond(i,04)+fdscond(i,10)
      dfscond(i,08)=azbz(i)*ddscond(i,04)+fdscond(i,16)
      dfscond(i,09)=azbz(i)*ddscond(i,05)+fdscond(i,17)
      dfscond(i,10)=azbz(i)*ddscond(i,06)+fdscond(i,18)
      dfscond(i,11)=axbx(i)*ddscond(i,07)+fdscond(i,07)
      dfscond(i,12)=ayby(i)*ddscond(i,07)+fdscond(i,19)
      dfscond(i,13)=azbz(i)*ddscond(i,07)+fdscond(i,25)
      dfscond(i,14)=ayby(i)*ddscond(i,08)+fdscond(i,20)
      dfscond(i,15)=azbz(i)*ddscond(i,08)+fdscond(i,26)
      dfscond(i,16)=azbz(i)*ddscond(i,09)+fdscond(i,27)
      dfscond(i,17)=ayby(i)*ddscond(i,10)+fdscond(i,22)
      dfscond(i,18)=azbz(i)*ddscond(i,10)+fdscond(i,28)
      dfscond(i,19)=azbz(i)*ddscond(i,11)+fdscond(i,29)
      dfscond(i,20)=azbz(i)*ddscond(i,12)+fdscond(i,30)
      dfscond(i,21)=axbx(i)*ddscond(i,13)+fdscond(i,13)
      dfscond(i,22)=ayby(i)*ddscond(i,13)+fdscond(i,25)
      dfscond(i,23)=azbz(i)*ddscond(i,13)+fdscond(i,31)
      dfscond(i,24)=ayby(i)*ddscond(i,14)+fdscond(i,26)
      dfscond(i,25)=azbz(i)*ddscond(i,14)+fdscond(i,32)
      dfscond(i,26)=azbz(i)*ddscond(i,15)+fdscond(i,33)
      dfscond(i,27)=ayby(i)*ddscond(i,16)+fdscond(i,28)
      dfscond(i,28)=azbz(i)*ddscond(i,16)+fdscond(i,34)
      dfscond(i,29)=azbz(i)*ddscond(i,17)+fdscond(i,35)
      dfscond(i,30)=azbz(i)*ddscond(i,18)+fdscond(i,36)
      dfscond(i,31)=axbx(i)*ddscond(i,19)+fdscond(i,19)
      dfscond(i,32)=ayby(i)*ddscond(i,19)+fdscond(i,37)
      dfscond(i,33)=azbz(i)*ddscond(i,19)+fdscond(i,43)
      dfscond(i,34)=ayby(i)*ddscond(i,20)+fdscond(i,38)
      dfscond(i,35)=azbz(i)*ddscond(i,20)+fdscond(i,44)
      dfscond(i,36)=azbz(i)*ddscond(i,21)+fdscond(i,45)
      dfscond(i,37)=ayby(i)*ddscond(i,22)+fdscond(i,40)
      dfscond(i,38)=azbz(i)*ddscond(i,22)+fdscond(i,46)
      dfscond(i,39)=azbz(i)*ddscond(i,23)+fdscond(i,47)
      dfscond(i,40)=azbz(i)*ddscond(i,24)+fdscond(i,48)
      dfscond(i,41)=axbx(i)*ddscond(i,25)+fdscond(i,25)
      dfscond(i,42)=ayby(i)*ddscond(i,25)+fdscond(i,43)
      dfscond(i,43)=azbz(i)*ddscond(i,25)+fdscond(i,49)
      dfscond(i,44)=ayby(i)*ddscond(i,26)+fdscond(i,44)
      dfscond(i,45)=azbz(i)*ddscond(i,26)+fdscond(i,50)
      dfscond(i,46)=azbz(i)*ddscond(i,27)+fdscond(i,51)
      dfscond(i,47)=ayby(i)*ddscond(i,28)+fdscond(i,46)
      dfscond(i,48)=azbz(i)*ddscond(i,28)+fdscond(i,52)
      dfscond(i,49)=azbz(i)*ddscond(i,29)+fdscond(i,53)
      dfscond(i,50)=azbz(i)*ddscond(i,30)+fdscond(i,54)
      dfscond(i,51)=axbx(i)*ddscond(i,31)+fdscond(i,31)
      dfscond(i,52)=ayby(i)*ddscond(i,31)+fdscond(i,49)
      dfscond(i,53)=azbz(i)*ddscond(i,31)+fdscond(i,55)
      dfscond(i,54)=ayby(i)*ddscond(i,32)+fdscond(i,50)
      dfscond(i,55)=azbz(i)*ddscond(i,32)+fdscond(i,56)
      dfscond(i,56)=azbz(i)*ddscond(i,33)+fdscond(i,57)
      dfscond(i,57)=ayby(i)*ddscond(i,34)+fdscond(i,52)
      dfscond(i,58)=azbz(i)*ddscond(i,34)+fdscond(i,58)
      dfscond(i,59)=azbz(i)*ddscond(i,35)+fdscond(i,59)
 1022 dfscond(i,60)=azbz(i)*ddscond(i,36)+fdscond(i,60)

      do 1023 i=1,m
      grad(i,001)=dfscond(i,01)*density(inddyy(i,01))
      grad(i,002)=dfscond(i,02)*density(inddyy(i,02))
      grad(i,003)=dfscond(i,03)*density(inddyy(i,03))
      grad(i,004)=dfscond(i,04)*density(inddyy(i,04))
      grad(i,005)=dfscond(i,05)*density(inddyy(i,05))
      grad(i,006)=dfscond(i,06)*density(inddyy(i,06))
      grad(i,007)=dfscond(i,11)*density(inddyy(i,07))
      grad(i,008)=dfscond(i,12)*density(inddyy(i,08))
      grad(i,009)=dfscond(i,13)*density(inddyy(i,09))
      grad(i,010)=dfscond(i,14)*density(inddyy(i,10))
      grad(i,011)=dfscond(i,15)*density(inddyy(i,11))
      grad(i,012)=dfscond(i,16)*density(inddyy(i,12))
      grad(i,013)=dfscond(i,21)*density(inddyy(i,13))
      grad(i,014)=dfscond(i,22)*density(inddyy(i,14))
      grad(i,015)=dfscond(i,23)*density(inddyy(i,15))
      grad(i,016)=dfscond(i,24)*density(inddyy(i,16))
      grad(i,017)=dfscond(i,25)*density(inddyy(i,17))
      grad(i,018)=dfscond(i,26)*density(inddyy(i,18))
      grad(i,019)=dfscond(i,31)*density(inddyy(i,19))
      grad(i,020)=dfscond(i,32)*density(inddyy(i,20))
      grad(i,021)=dfscond(i,33)*density(inddyy(i,21))
      grad(i,022)=dfscond(i,34)*density(inddyy(i,22))
      grad(i,023)=dfscond(i,35)*density(inddyy(i,23))
      grad(i,024)=dfscond(i,36)*density(inddyy(i,24))
      grad(i,025)=dfscond(i,41)*density(inddyy(i,25))
      grad(i,026)=dfscond(i,42)*density(inddyy(i,26))
      grad(i,027)=dfscond(i,43)*density(inddyy(i,27))
      grad(i,028)=dfscond(i,44)*density(inddyy(i,28))
      grad(i,029)=dfscond(i,45)*density(inddyy(i,29))
      grad(i,030)=dfscond(i,46)*density(inddyy(i,30))
      grad(i,031)=dfscond(i,51)*density(inddyy(i,31))
      grad(i,032)=dfscond(i,52)*density(inddyy(i,32))
      grad(i,033)=dfscond(i,53)*density(inddyy(i,33))
      grad(i,034)=dfscond(i,54)*density(inddyy(i,34))
      grad(i,035)=dfscond(i,55)*density(inddyy(i,35))
      grad(i,036)=dfscond(i,56)*density(inddyy(i,36))
      grad(i,037)=dfscond(i,02)*density(inddyy(i,01))
      grad(i,038)=dfscond(i,04)*density(inddyy(i,02))
      grad(i,039)=dfscond(i,05)*density(inddyy(i,03))
      grad(i,040)=dfscond(i,07)*density(inddyy(i,04))
      grad(i,041)=dfscond(i,08)*density(inddyy(i,05))
      grad(i,042)=dfscond(i,09)*density(inddyy(i,06))
      grad(i,043)=dfscond(i,12)*density(inddyy(i,07))
      grad(i,044)=dfscond(i,14)*density(inddyy(i,08))
      grad(i,045)=dfscond(i,15)*density(inddyy(i,09))
      grad(i,046)=dfscond(i,17)*density(inddyy(i,10))
      grad(i,047)=dfscond(i,18)*density(inddyy(i,11))
      grad(i,048)=dfscond(i,19)*density(inddyy(i,12))
      grad(i,049)=dfscond(i,22)*density(inddyy(i,13))
      grad(i,050)=dfscond(i,24)*density(inddyy(i,14))
      grad(i,051)=dfscond(i,25)*density(inddyy(i,15))
      grad(i,052)=dfscond(i,27)*density(inddyy(i,16))
      grad(i,053)=dfscond(i,28)*density(inddyy(i,17))
      grad(i,054)=dfscond(i,29)*density(inddyy(i,18))
      grad(i,055)=dfscond(i,32)*density(inddyy(i,19))
      grad(i,056)=dfscond(i,34)*density(inddyy(i,20))
      grad(i,057)=dfscond(i,35)*density(inddyy(i,21))
      grad(i,058)=dfscond(i,37)*density(inddyy(i,22))
      grad(i,059)=dfscond(i,38)*density(inddyy(i,23))
      grad(i,060)=dfscond(i,39)*density(inddyy(i,24))
      grad(i,061)=dfscond(i,42)*density(inddyy(i,25))
      grad(i,062)=dfscond(i,44)*density(inddyy(i,26))
      grad(i,063)=dfscond(i,45)*density(inddyy(i,27))
      grad(i,064)=dfscond(i,47)*density(inddyy(i,28))
      grad(i,065)=dfscond(i,48)*density(inddyy(i,29))
      grad(i,066)=dfscond(i,49)*density(inddyy(i,30))
      grad(i,067)=dfscond(i,52)*density(inddyy(i,31))
      grad(i,068)=dfscond(i,54)*density(inddyy(i,32))
      grad(i,069)=dfscond(i,55)*density(inddyy(i,33))
      grad(i,070)=dfscond(i,57)*density(inddyy(i,34))
      grad(i,071)=dfscond(i,58)*density(inddyy(i,35))
      grad(i,072)=dfscond(i,59)*density(inddyy(i,36))
      grad(i,073)=dfscond(i,03)*density(inddyy(i,01))
      grad(i,074)=dfscond(i,05)*density(inddyy(i,02))
      grad(i,075)=dfscond(i,06)*density(inddyy(i,03))
      grad(i,076)=dfscond(i,08)*density(inddyy(i,04))
      grad(i,077)=dfscond(i,09)*density(inddyy(i,05))
      grad(i,078)=dfscond(i,10)*density(inddyy(i,06))
      grad(i,079)=dfscond(i,13)*density(inddyy(i,07))
      grad(i,080)=dfscond(i,15)*density(inddyy(i,08))
      grad(i,081)=dfscond(i,16)*density(inddyy(i,09))
      grad(i,082)=dfscond(i,18)*density(inddyy(i,10))
      grad(i,083)=dfscond(i,19)*density(inddyy(i,11))
      grad(i,084)=dfscond(i,20)*density(inddyy(i,12))
      grad(i,085)=dfscond(i,23)*density(inddyy(i,13))
      grad(i,086)=dfscond(i,25)*density(inddyy(i,14))
      grad(i,087)=dfscond(i,26)*density(inddyy(i,15))
      grad(i,088)=dfscond(i,28)*density(inddyy(i,16))
      grad(i,089)=dfscond(i,29)*density(inddyy(i,17))
      grad(i,090)=dfscond(i,30)*density(inddyy(i,18))
      grad(i,091)=dfscond(i,33)*density(inddyy(i,19))
      grad(i,092)=dfscond(i,35)*density(inddyy(i,20))
      grad(i,093)=dfscond(i,36)*density(inddyy(i,21))
      grad(i,094)=dfscond(i,38)*density(inddyy(i,22))
      grad(i,095)=dfscond(i,39)*density(inddyy(i,23))
      grad(i,096)=dfscond(i,40)*density(inddyy(i,24))
      grad(i,097)=dfscond(i,43)*density(inddyy(i,25))
      grad(i,098)=dfscond(i,45)*density(inddyy(i,26))
      grad(i,099)=dfscond(i,46)*density(inddyy(i,27))
      grad(i,100)=dfscond(i,48)*density(inddyy(i,28))
      grad(i,101)=dfscond(i,49)*density(inddyy(i,29))
      grad(i,102)=dfscond(i,50)*density(inddyy(i,30))
      grad(i,103)=dfscond(i,53)*density(inddyy(i,31))
      grad(i,104)=dfscond(i,55)*density(inddyy(i,32))
      grad(i,105)=dfscond(i,56)*density(inddyy(i,33))
      grad(i,106)=dfscond(i,58)*density(inddyy(i,34))
      grad(i,107)=dfscond(i,59)*density(inddyy(i,35))
 1023 grad(i,108)=dfscond(i,60)*density(inddyy(i,36))

      do 1024 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1024 continue

      do 1025 k=1,3
      do 1025 j=1,36
      do 1025 i=1,m
 1025 gradient(k,nc)=gradient(k,nc)-grad(i,36*(k-1)+j)

      do 1026 k=1,3
      do 1026 j=1,36
      do 1026 i=1,m
 1026 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,36*(k-1)+j)

      return
      end

      subroutine gradovdp(ndim,m,n,icontr,inddyy,icentr,density,overlap,
     &                    gradient,zeta,twozetaa,eta,eta2,base,etarr,
     &                    pxax,pyay,pzaz,pxbx,pyby,pzbz,twozeta,ss0,ss,
     &                    ps0,ps,ds,pp,fs,fp,c,c1,c2,ppcond,fpcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),icentr(m,*)

      dimension density(*),overlap(ndim,*),gradient(3,*),zeta(*),
     &          twozetaa(*),eta(*),eta2(*),base(*),etarr(*),pxax(*),
     &          pyay(*),pzaz(*),pxbx(*),pyby(*),pzbz(*),twozeta(*),
     &          ss0(*),ss(*),ps0(n,*),ps(n,*),ds(n,*),pp(n,*),fs(n,*),
     &          fp(n,*),c(*),c1(n,*),c2(n,*),ppcond(m,*),fpcond(m,*),
     &          grad(m,*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)
      ps0(i,2)=pyay(i)*ss0(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
 1004 c(i)=ss0(i)/twozeta(i)

      do 1005 i=1,n
      ds(i,1)=pxax(i)*ps0(i,1)+c(i)
      ds(i,2)=pyay(i)*ps0(i,1)
      ds(i,3)=pzaz(i)*ps0(i,1)
      ds(i,4)=pyay(i)*ps0(i,2)+c(i)
      ds(i,5)=pzaz(i)*ps0(i,2)
 1005 ds(i,6)=pzaz(i)*ps0(i,3)+c(i)

      do 1006 i=1,n
      pp(i,1)=pxbx(i)*ps0(i,1)+c(i)
      pp(i,2)=pyby(i)*ps0(i,1)
      pp(i,3)=pzbz(i)*ps0(i,1)
      pp(i,4)=pxbx(i)*ps0(i,2)
      pp(i,5)=pyby(i)*ps0(i,2)+c(i)
      pp(i,6)=pzbz(i)*ps0(i,2)
      pp(i,7)=pxbx(i)*ps0(i,3)
      pp(i,8)=pyby(i)*ps0(i,3)
 1006 pp(i,9)=pzbz(i)*ps0(i,3)+c(i)

      do 1007 j=1,3
      do 1007 i=1,n
 1007 c1(i,j)=ps0(i,j)/twozeta(i)

      do 1008 i=1,n
      fs(i,01)=pxax(i)*ds(i,1)+c1(i,1)+c1(i,1)
      fs(i,02)=pyay(i)*ds(i,1)
      fs(i,03)=pzaz(i)*ds(i,1)
      fs(i,04)=pyay(i)*ds(i,2)+c1(i,1)
      fs(i,05)=pzaz(i)*ds(i,2)
      fs(i,06)=pzaz(i)*ds(i,3)+c1(i,1)
      fs(i,07)=pyay(i)*ds(i,4)+c1(i,2)+c1(i,2)
      fs(i,08)=pzaz(i)*ds(i,4)
      fs(i,09)=pzaz(i)*ds(i,5)+c1(i,2)
 1008 fs(i,10)=pzaz(i)*ds(i,6)+c1(i,3)+c1(i,3)

      do 1009 j=1,6
      do 1009 i=1,n
 1009 c2(i,j)=ds(i,j)/twozeta(i)

      do 1010 i=1,n
      fp(i,01)=pxbx(i)*fs(i,01)+c2(i,1)*three
      fp(i,02)=pyby(i)*fs(i,01)
      fp(i,03)=pzbz(i)*fs(i,01)
      fp(i,04)=pxbx(i)*fs(i,02)+c2(i,2)*two
      fp(i,05)=pyby(i)*fs(i,02)+c2(i,1)
      fp(i,06)=pzbz(i)*fs(i,02)
      fp(i,07)=pxbx(i)*fs(i,03)+c2(i,3)*two
      fp(i,08)=pyby(i)*fs(i,03)
      fp(i,09)=pzbz(i)*fs(i,03)+c2(i,1)
      fp(i,10)=pxbx(i)*fs(i,04)+c2(i,4)
      fp(i,11)=pyby(i)*fs(i,04)+c2(i,2)*two
      fp(i,12)=pzbz(i)*fs(i,04)
      fp(i,13)=pxbx(i)*fs(i,05)+c2(i,5)
      fp(i,14)=pyby(i)*fs(i,05)+c2(i,3)
      fp(i,15)=pzbz(i)*fs(i,05)+c2(i,2)
      fp(i,16)=pxbx(i)*fs(i,06)+c2(i,6)
      fp(i,17)=pyby(i)*fs(i,06)
      fp(i,18)=pzbz(i)*fs(i,06)+c2(i,3)*two
      fp(i,19)=pxbx(i)*fs(i,07)
      fp(i,20)=pyby(i)*fs(i,07)+c2(i,4)*three
      fp(i,21)=pzbz(i)*fs(i,07)
      fp(i,22)=pxbx(i)*fs(i,08)
      fp(i,23)=pyby(i)*fs(i,08)+c2(i,5)*two
      fp(i,24)=pzbz(i)*fs(i,08)+c2(i,4)
      fp(i,25)=pxbx(i)*fs(i,09)
      fp(i,26)=pyby(i)*fs(i,09)+c2(i,6)
      fp(i,27)=pzbz(i)*fs(i,09)+c2(i,5)*two
      fp(i,28)=pxbx(i)*fs(i,10)
      fp(i,29)=pyby(i)*fs(i,10)
 1010 fp(i,30)=pzbz(i)*fs(i,10)+c2(i,6)*three

      do 1011 j=1,9
      do 1011 i=1,m
 1011 ppcond(i,j)=zero

      do 1012 j=1,30
      do 1012 i=1,m
 1012 fpcond(i,j)=zero

      do 1013 j=1,9
      do 1013 i=1,n
 1013 ppcond(icontr(i),j)=ppcond(icontr(i),j)+pp(i,j)

      do 1014 j=1,30
      do 1014 i=1,n
 1014 fpcond(icontr(i),j)=fpcond(icontr(i),j)+fp(i,j)*twozetaa(i)

      do 1015 i=1,m
      overlap(inddyy(i,01),1)=overlap(inddyy(i,01),1)-ppcond(i,1)*two
      overlap(inddyy(i,02),1)=overlap(inddyy(i,02),1)-ppcond(i,2)*two
      overlap(inddyy(i,03),1)=overlap(inddyy(i,03),1)-ppcond(i,3)*two
      overlap(inddyy(i,04),1)=overlap(inddyy(i,04),1)-ppcond(i,4)
      overlap(inddyy(i,05),1)=overlap(inddyy(i,05),1)-ppcond(i,5)
      overlap(inddyy(i,06),1)=overlap(inddyy(i,06),1)-ppcond(i,6)
      overlap(inddyy(i,07),1)=overlap(inddyy(i,07),1)-ppcond(i,7)
      overlap(inddyy(i,08),1)=overlap(inddyy(i,08),1)-ppcond(i,8)
      overlap(inddyy(i,09),1)=overlap(inddyy(i,09),1)-ppcond(i,9)
      overlap(inddyy(i,04),2)=overlap(inddyy(i,04),2)-ppcond(i,1)
      overlap(inddyy(i,05),2)=overlap(inddyy(i,05),2)-ppcond(i,2)
      overlap(inddyy(i,06),2)=overlap(inddyy(i,06),2)-ppcond(i,3)
      overlap(inddyy(i,10),2)=overlap(inddyy(i,10),2)-ppcond(i,4)*two
      overlap(inddyy(i,11),2)=overlap(inddyy(i,11),2)-ppcond(i,5)*two
      overlap(inddyy(i,12),2)=overlap(inddyy(i,12),2)-ppcond(i,6)*two
      overlap(inddyy(i,13),2)=overlap(inddyy(i,13),2)-ppcond(i,7)
      overlap(inddyy(i,14),2)=overlap(inddyy(i,14),2)-ppcond(i,8)
      overlap(inddyy(i,15),2)=overlap(inddyy(i,15),2)-ppcond(i,9)
      overlap(inddyy(i,07),3)=overlap(inddyy(i,07),3)-ppcond(i,1)
      overlap(inddyy(i,08),3)=overlap(inddyy(i,08),3)-ppcond(i,2)
      overlap(inddyy(i,09),3)=overlap(inddyy(i,09),3)-ppcond(i,3)
      overlap(inddyy(i,13),3)=overlap(inddyy(i,13),3)-ppcond(i,4)
      overlap(inddyy(i,14),3)=overlap(inddyy(i,14),3)-ppcond(i,5)
      overlap(inddyy(i,15),3)=overlap(inddyy(i,15),3)-ppcond(i,6)
      overlap(inddyy(i,16),3)=overlap(inddyy(i,16),3)-ppcond(i,7)*two
      overlap(inddyy(i,17),3)=overlap(inddyy(i,17),3)-ppcond(i,8)*two
 1015 overlap(inddyy(i,18),3)=overlap(inddyy(i,18),3)-ppcond(i,9)*two

      do 1016 i=1,m
      overlap(inddyy(i,01),1)=overlap(inddyy(i,01),1)+fpcond(i,01)
      overlap(inddyy(i,02),1)=overlap(inddyy(i,02),1)+fpcond(i,02)
      overlap(inddyy(i,03),1)=overlap(inddyy(i,03),1)+fpcond(i,03)
      overlap(inddyy(i,04),1)=overlap(inddyy(i,04),1)+fpcond(i,04)
      overlap(inddyy(i,05),1)=overlap(inddyy(i,05),1)+fpcond(i,05)
      overlap(inddyy(i,06),1)=overlap(inddyy(i,06),1)+fpcond(i,06)
      overlap(inddyy(i,07),1)=overlap(inddyy(i,07),1)+fpcond(i,07)
      overlap(inddyy(i,08),1)=overlap(inddyy(i,08),1)+fpcond(i,08)
      overlap(inddyy(i,09),1)=overlap(inddyy(i,09),1)+fpcond(i,09)
      overlap(inddyy(i,10),1)=overlap(inddyy(i,10),1)+fpcond(i,10)
      overlap(inddyy(i,11),1)=overlap(inddyy(i,11),1)+fpcond(i,11)
      overlap(inddyy(i,12),1)=overlap(inddyy(i,12),1)+fpcond(i,12)
      overlap(inddyy(i,13),1)=overlap(inddyy(i,13),1)+fpcond(i,13)
      overlap(inddyy(i,14),1)=overlap(inddyy(i,14),1)+fpcond(i,14)
      overlap(inddyy(i,15),1)=overlap(inddyy(i,15),1)+fpcond(i,15)
      overlap(inddyy(i,16),1)=overlap(inddyy(i,16),1)+fpcond(i,16)
      overlap(inddyy(i,17),1)=overlap(inddyy(i,17),1)+fpcond(i,17)
      overlap(inddyy(i,18),1)=overlap(inddyy(i,18),1)+fpcond(i,18)
      overlap(inddyy(i,01),2)=overlap(inddyy(i,01),2)+fpcond(i,04)
      overlap(inddyy(i,02),2)=overlap(inddyy(i,02),2)+fpcond(i,05)
      overlap(inddyy(i,03),2)=overlap(inddyy(i,03),2)+fpcond(i,06)
      overlap(inddyy(i,04),2)=overlap(inddyy(i,04),2)+fpcond(i,10)
      overlap(inddyy(i,05),2)=overlap(inddyy(i,05),2)+fpcond(i,11)
      overlap(inddyy(i,06),2)=overlap(inddyy(i,06),2)+fpcond(i,12)
      overlap(inddyy(i,07),2)=overlap(inddyy(i,07),2)+fpcond(i,13)
      overlap(inddyy(i,08),2)=overlap(inddyy(i,08),2)+fpcond(i,14)
      overlap(inddyy(i,09),2)=overlap(inddyy(i,09),2)+fpcond(i,15)
      overlap(inddyy(i,10),2)=overlap(inddyy(i,10),2)+fpcond(i,19)
      overlap(inddyy(i,11),2)=overlap(inddyy(i,11),2)+fpcond(i,20)
      overlap(inddyy(i,12),2)=overlap(inddyy(i,12),2)+fpcond(i,21)
      overlap(inddyy(i,13),2)=overlap(inddyy(i,13),2)+fpcond(i,22)
      overlap(inddyy(i,14),2)=overlap(inddyy(i,14),2)+fpcond(i,23)
      overlap(inddyy(i,15),2)=overlap(inddyy(i,15),2)+fpcond(i,24)
      overlap(inddyy(i,16),2)=overlap(inddyy(i,16),2)+fpcond(i,25)
      overlap(inddyy(i,17),2)=overlap(inddyy(i,17),2)+fpcond(i,26)
      overlap(inddyy(i,18),2)=overlap(inddyy(i,18),2)+fpcond(i,27)
      overlap(inddyy(i,01),3)=overlap(inddyy(i,01),3)+fpcond(i,07)
      overlap(inddyy(i,02),3)=overlap(inddyy(i,02),3)+fpcond(i,08)
      overlap(inddyy(i,03),3)=overlap(inddyy(i,03),3)+fpcond(i,09)
      overlap(inddyy(i,04),3)=overlap(inddyy(i,04),3)+fpcond(i,13)
      overlap(inddyy(i,05),3)=overlap(inddyy(i,05),3)+fpcond(i,14)
      overlap(inddyy(i,06),3)=overlap(inddyy(i,06),3)+fpcond(i,15)
      overlap(inddyy(i,07),3)=overlap(inddyy(i,07),3)+fpcond(i,16)
      overlap(inddyy(i,08),3)=overlap(inddyy(i,08),3)+fpcond(i,17)
      overlap(inddyy(i,09),3)=overlap(inddyy(i,09),3)+fpcond(i,18)
      overlap(inddyy(i,10),3)=overlap(inddyy(i,10),3)+fpcond(i,22)
      overlap(inddyy(i,11),3)=overlap(inddyy(i,11),3)+fpcond(i,23)
      overlap(inddyy(i,12),3)=overlap(inddyy(i,12),3)+fpcond(i,24)
      overlap(inddyy(i,13),3)=overlap(inddyy(i,13),3)+fpcond(i,25)
      overlap(inddyy(i,14),3)=overlap(inddyy(i,14),3)+fpcond(i,26)
      overlap(inddyy(i,15),3)=overlap(inddyy(i,15),3)+fpcond(i,27)
      overlap(inddyy(i,16),3)=overlap(inddyy(i,16),3)+fpcond(i,28)
      overlap(inddyy(i,17),3)=overlap(inddyy(i,17),3)+fpcond(i,29)
 1016 overlap(inddyy(i,18),3)=overlap(inddyy(i,18),3)+fpcond(i,30)

      do 1017 i=1,n
 1017 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1018 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps0(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps0(i,2)
 1018 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps0(i,3)

      do 1019 i=1,n
 1019 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/twozetaa(i)

      do 1020 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds(i,2)
      ds(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds(i,3)
      ds(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds(i,4)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds(i,5)
 1020 ds(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds(i,6)+c(i)

      do 1021 i=1,n
 1021 c(i)=ss(i)/twozeta(i)

      do 1022 i=1,n
      pp(i,1)=pxbx(i)*ps(i,1)+eta2(i)*pp(i,1)+c(i)
      pp(i,2)=pyby(i)*ps(i,1)+eta2(i)*pp(i,2)
      pp(i,3)=pzbz(i)*ps(i,1)+eta2(i)*pp(i,3)
      pp(i,4)=pxbx(i)*ps(i,2)+eta2(i)*pp(i,4)
      pp(i,5)=pyby(i)*ps(i,2)+eta2(i)*pp(i,5)+c(i)
      pp(i,6)=pzbz(i)*ps(i,2)+eta2(i)*pp(i,6)
      pp(i,7)=pxbx(i)*ps(i,3)+eta2(i)*pp(i,7)
      pp(i,8)=pyby(i)*ps(i,3)+eta2(i)*pp(i,8)
 1022 pp(i,9)=pzbz(i)*ps(i,3)+eta2(i)*pp(i,9)+c(i)

      do 1023 j=1,3
      do 1023 i=1,n
 1023 c1(i,j)=ps(i,j)/twozeta(i)-eta2(i)*ps0(i,j)/twozetaa(i)

      do 1024 i=1,n
      fs(i,01)=pxax(i)*ds(i,1)+eta2(i)*fs(i,01)+c1(i,1)+c1(i,1)
      fs(i,02)=pyay(i)*ds(i,1)+eta2(i)*fs(i,02)
      fs(i,03)=pzaz(i)*ds(i,1)+eta2(i)*fs(i,03)
      fs(i,04)=pyay(i)*ds(i,2)+eta2(i)*fs(i,04)+c1(i,1)
      fs(i,05)=pzaz(i)*ds(i,2)+eta2(i)*fs(i,05)
      fs(i,06)=pzaz(i)*ds(i,3)+eta2(i)*fs(i,06)+c1(i,1)
      fs(i,07)=pyay(i)*ds(i,4)+eta2(i)*fs(i,07)+c1(i,2)+c1(i,2)
      fs(i,08)=pzaz(i)*ds(i,4)+eta2(i)*fs(i,08)
      fs(i,09)=pzaz(i)*ds(i,5)+eta2(i)*fs(i,09)+c1(i,2)
 1024 fs(i,10)=pzaz(i)*ds(i,6)+eta2(i)*fs(i,10)+c1(i,3)+c1(i,3)

      do 1025 j=1,6
      do 1025 i=1,n
 1025 c2(i,j)=ds(i,j)/twozeta(i)

      do 1026 i=1,n
      fp(i,01)=pxbx(i)*fs(i,01)+eta2(i)*fp(i,01)+c2(i,1)*three
      fp(i,02)=pyby(i)*fs(i,01)+eta2(i)*fp(i,02)
      fp(i,03)=pzbz(i)*fs(i,01)+eta2(i)*fp(i,03)
      fp(i,04)=pxbx(i)*fs(i,02)+eta2(i)*fp(i,04)+c2(i,2)*two
      fp(i,05)=pyby(i)*fs(i,02)+eta2(i)*fp(i,05)+c2(i,1)
      fp(i,06)=pzbz(i)*fs(i,02)+eta2(i)*fp(i,06)
      fp(i,07)=pxbx(i)*fs(i,03)+eta2(i)*fp(i,07)+c2(i,3)*two
      fp(i,08)=pyby(i)*fs(i,03)+eta2(i)*fp(i,08)
      fp(i,09)=pzbz(i)*fs(i,03)+eta2(i)*fp(i,09)+c2(i,1)
      fp(i,10)=pxbx(i)*fs(i,04)+eta2(i)*fp(i,10)+c2(i,4)
      fp(i,11)=pyby(i)*fs(i,04)+eta2(i)*fp(i,11)+c2(i,2)*two
      fp(i,12)=pzbz(i)*fs(i,04)+eta2(i)*fp(i,12)
      fp(i,13)=pxbx(i)*fs(i,05)+eta2(i)*fp(i,13)+c2(i,5)
      fp(i,14)=pyby(i)*fs(i,05)+eta2(i)*fp(i,14)+c2(i,3)
      fp(i,15)=pzbz(i)*fs(i,05)+eta2(i)*fp(i,15)+c2(i,2)
      fp(i,16)=pxbx(i)*fs(i,06)+eta2(i)*fp(i,16)+c2(i,6)
      fp(i,17)=pyby(i)*fs(i,06)+eta2(i)*fp(i,17)
      fp(i,18)=pzbz(i)*fs(i,06)+eta2(i)*fp(i,18)+c2(i,3)*two
      fp(i,19)=pxbx(i)*fs(i,07)+eta2(i)*fp(i,19)
      fp(i,20)=pyby(i)*fs(i,07)+eta2(i)*fp(i,20)+c2(i,4)*three
      fp(i,21)=pzbz(i)*fs(i,07)+eta2(i)*fp(i,21)
      fp(i,22)=pxbx(i)*fs(i,08)+eta2(i)*fp(i,22)
      fp(i,23)=pyby(i)*fs(i,08)+eta2(i)*fp(i,23)+c2(i,5)*two
      fp(i,24)=pzbz(i)*fs(i,08)+eta2(i)*fp(i,24)+c2(i,4)
      fp(i,25)=pxbx(i)*fs(i,09)+eta2(i)*fp(i,25)
      fp(i,26)=pyby(i)*fs(i,09)+eta2(i)*fp(i,26)+c2(i,6)
      fp(i,27)=pzbz(i)*fs(i,09)+eta2(i)*fp(i,27)+c2(i,5)*two
      fp(i,28)=pxbx(i)*fs(i,10)+eta2(i)*fp(i,28)
      fp(i,29)=pyby(i)*fs(i,10)+eta2(i)*fp(i,29)
 1026 fp(i,30)=pzbz(i)*fs(i,10)+eta2(i)*fp(i,30)+c2(i,6)*three

      do 1027 j=1,9
      do 1027 i=1,m
 1027 ppcond(i,j)=zero

      do 1028 j=1,30
      do 1028 i=1,m
 1028 fpcond(i,j)=zero

      do 1029 j=1,9
      do 1029 i=1,n
 1029 ppcond(icontr(i),j)=ppcond(icontr(i),j)+pp(i,j)

      do 1030 j=1,30
      do 1030 i=1,n
 1030 fpcond(icontr(i),j)=fpcond(icontr(i),j)+fp(i,j)*twozetaa(i)

      do 1031 i=1,m
      grad(i,01)=ppcond(i,1)*density(inddyy(i,01))*two
      grad(i,02)=ppcond(i,2)*density(inddyy(i,02))*two
      grad(i,03)=ppcond(i,3)*density(inddyy(i,03))*two
      grad(i,04)=ppcond(i,4)*density(inddyy(i,04))
      grad(i,05)=ppcond(i,5)*density(inddyy(i,05))
      grad(i,06)=ppcond(i,6)*density(inddyy(i,06))
      grad(i,07)=ppcond(i,7)*density(inddyy(i,07))
      grad(i,08)=ppcond(i,8)*density(inddyy(i,08))
      grad(i,09)=ppcond(i,9)*density(inddyy(i,09))
      grad(i,10)=ppcond(i,1)*density(inddyy(i,04))
      grad(i,11)=ppcond(i,2)*density(inddyy(i,05))
      grad(i,12)=ppcond(i,3)*density(inddyy(i,06))
      grad(i,13)=ppcond(i,4)*density(inddyy(i,10))*two
      grad(i,14)=ppcond(i,5)*density(inddyy(i,11))*two
      grad(i,15)=ppcond(i,6)*density(inddyy(i,12))*two
      grad(i,16)=ppcond(i,7)*density(inddyy(i,13))
      grad(i,17)=ppcond(i,8)*density(inddyy(i,14))
      grad(i,18)=ppcond(i,9)*density(inddyy(i,15))
      grad(i,19)=ppcond(i,1)*density(inddyy(i,07))
      grad(i,20)=ppcond(i,2)*density(inddyy(i,08))
      grad(i,21)=ppcond(i,3)*density(inddyy(i,09))
      grad(i,22)=ppcond(i,4)*density(inddyy(i,13))
      grad(i,23)=ppcond(i,5)*density(inddyy(i,14))
      grad(i,24)=ppcond(i,6)*density(inddyy(i,15))
      grad(i,25)=ppcond(i,7)*density(inddyy(i,16))*two
      grad(i,26)=ppcond(i,8)*density(inddyy(i,17))*two
 1031 grad(i,27)=ppcond(i,9)*density(inddyy(i,18))*two

      do 1032 k=1,3
      do 1032 j=1,9
      do 1032 i=1,m
 1032 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,9*(k-1)+j)

      do 1033 k=1,3
      do 1033 j=1,9
      do 1033 i=1,m
 1033 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,9*(k-1)+j)

      do 1034 i=1,m
      grad(i,01)=fpcond(i,01)*density(inddyy(i,01))
      grad(i,02)=fpcond(i,02)*density(inddyy(i,02))
      grad(i,03)=fpcond(i,03)*density(inddyy(i,03))
      grad(i,04)=fpcond(i,04)*density(inddyy(i,04))
      grad(i,05)=fpcond(i,05)*density(inddyy(i,05))
      grad(i,06)=fpcond(i,06)*density(inddyy(i,06))
      grad(i,07)=fpcond(i,07)*density(inddyy(i,07))
      grad(i,08)=fpcond(i,08)*density(inddyy(i,08))
      grad(i,09)=fpcond(i,09)*density(inddyy(i,09))
      grad(i,10)=fpcond(i,10)*density(inddyy(i,10))
      grad(i,11)=fpcond(i,11)*density(inddyy(i,11))
      grad(i,12)=fpcond(i,12)*density(inddyy(i,12))
      grad(i,13)=fpcond(i,13)*density(inddyy(i,13))
      grad(i,14)=fpcond(i,14)*density(inddyy(i,14))
      grad(i,15)=fpcond(i,15)*density(inddyy(i,15))
      grad(i,16)=fpcond(i,16)*density(inddyy(i,16))
      grad(i,17)=fpcond(i,17)*density(inddyy(i,17))
      grad(i,18)=fpcond(i,18)*density(inddyy(i,18))
      grad(i,19)=fpcond(i,04)*density(inddyy(i,01))
      grad(i,20)=fpcond(i,05)*density(inddyy(i,02))
      grad(i,21)=fpcond(i,06)*density(inddyy(i,03))
      grad(i,22)=fpcond(i,10)*density(inddyy(i,04))
      grad(i,23)=fpcond(i,11)*density(inddyy(i,05))
      grad(i,24)=fpcond(i,12)*density(inddyy(i,06))
      grad(i,25)=fpcond(i,13)*density(inddyy(i,07))
      grad(i,26)=fpcond(i,14)*density(inddyy(i,08))
      grad(i,27)=fpcond(i,15)*density(inddyy(i,09))
      grad(i,28)=fpcond(i,19)*density(inddyy(i,10))
      grad(i,29)=fpcond(i,20)*density(inddyy(i,11))
      grad(i,30)=fpcond(i,21)*density(inddyy(i,12))
      grad(i,31)=fpcond(i,22)*density(inddyy(i,13))
      grad(i,32)=fpcond(i,23)*density(inddyy(i,14))
      grad(i,33)=fpcond(i,24)*density(inddyy(i,15))
      grad(i,34)=fpcond(i,25)*density(inddyy(i,16))
      grad(i,35)=fpcond(i,26)*density(inddyy(i,17))
      grad(i,36)=fpcond(i,27)*density(inddyy(i,18))
      grad(i,37)=fpcond(i,07)*density(inddyy(i,01))
      grad(i,38)=fpcond(i,08)*density(inddyy(i,02))
      grad(i,39)=fpcond(i,09)*density(inddyy(i,03))
      grad(i,40)=fpcond(i,13)*density(inddyy(i,04))
      grad(i,41)=fpcond(i,14)*density(inddyy(i,05))
      grad(i,42)=fpcond(i,15)*density(inddyy(i,06))
      grad(i,43)=fpcond(i,16)*density(inddyy(i,07))
      grad(i,44)=fpcond(i,17)*density(inddyy(i,08))
      grad(i,45)=fpcond(i,18)*density(inddyy(i,09))
      grad(i,46)=fpcond(i,22)*density(inddyy(i,10))
      grad(i,47)=fpcond(i,23)*density(inddyy(i,11))
      grad(i,48)=fpcond(i,24)*density(inddyy(i,12))
      grad(i,49)=fpcond(i,25)*density(inddyy(i,13))
      grad(i,50)=fpcond(i,26)*density(inddyy(i,14))
      grad(i,51)=fpcond(i,27)*density(inddyy(i,15))
      grad(i,52)=fpcond(i,28)*density(inddyy(i,16))
      grad(i,53)=fpcond(i,29)*density(inddyy(i,17))
 1034 grad(i,54)=fpcond(i,30)*density(inddyy(i,18))

      do 1035 k=1,3
      do 1035 j=1,18
      do 1035 i=1,m
 1035 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

      do 1036 k=1,3
      do 1036 j=1,18
      do 1036 i=1,m
 1036 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,18*(k-1)+j)

      return
      end

      subroutine gradovpp(ndim,m,n,iminj,icontr,inddyy,icentr,density,
     &                    overlap,gradient,zeta,twozetaa,eta,eta2,base,
     &                    etarr,pxax,pyay,pzaz,pxbx,pyby,pzbz,twozeta,
     &                    ss0,ss,ps,sp,ds,dp,c,c1,spcond,dpcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*),icentr(m,*)

      dimension density(*),overlap(ndim,*),gradient(3,*),zeta(*),
     &          twozetaa(*),eta(*),eta2(*),base(*),etarr(*),pxax(*),
     &          pyay(*),pzaz(*),pxbx(*),pyby(*),pzbz(*),twozeta(*),
     &          ss0(*),ss(*),ps(n,*),sp(n,*),ds(n,*),dp(n,*),c(*),
     &          c1(n,*),spcond(m,*),dpcond(m,*),grad(m,*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps(i,1)=pxax(i)*ss0(i)
      ps(i,2)=pyay(i)*ss0(i)
 1003 ps(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
      sp(i,1)=pxbx(i)*ss0(i)
      sp(i,2)=pyby(i)*ss0(i)
 1004 sp(i,3)=pzbz(i)*ss0(i)

      do 1005 i=1,n
 1005 c(i)=ss0(i)/twozeta(i)

      do 1006 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)
      ds(i,3)=pzaz(i)*ps(i,1)
      ds(i,4)=pyay(i)*ps(i,2)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)
 1006 ds(i,6)=pzaz(i)*ps(i,3)+c(i)

      do 1007 j=1,3
      do 1007 i=1,n
 1007 c1(i,j)=ps(i,j)/twozeta(i)

      do 1008 i=1,n
      dp(i,01)=pxbx(i)*ds(i,1)+c1(i,1)*two
      dp(i,02)=pyby(i)*ds(i,1)
      dp(i,03)=pzbz(i)*ds(i,1)
      dp(i,04)=pxbx(i)*ds(i,2)+c1(i,2)
      dp(i,05)=pyby(i)*ds(i,2)+c1(i,1)
      dp(i,06)=pzbz(i)*ds(i,2)
      dp(i,07)=pxbx(i)*ds(i,3)+c1(i,3)
      dp(i,08)=pyby(i)*ds(i,3)
      dp(i,09)=pzbz(i)*ds(i,3)+c1(i,1)
      dp(i,10)=pxbx(i)*ds(i,4)
      dp(i,11)=pyby(i)*ds(i,4)+c1(i,2)*two
      dp(i,12)=pzbz(i)*ds(i,4)
      dp(i,13)=pxbx(i)*ds(i,5)
      dp(i,14)=pyby(i)*ds(i,5)+c1(i,3)
      dp(i,15)=pzbz(i)*ds(i,5)+c1(i,2)
      dp(i,16)=pxbx(i)*ds(i,6)
      dp(i,17)=pyby(i)*ds(i,6)
 1008 dp(i,18)=pzbz(i)*ds(i,6)+c1(i,3)*two

      do 1009 j=1,3
      do 1009 i=1,m
 1009 spcond(i,j)=zero

      do 1010 j=1,18
      do 1010 i=1,m
 1010 dpcond(i,j)=zero

      do 1011 j=1,3
      do 1011 i=1,n
 1011 spcond(icontr(i),j)=spcond(icontr(i),j)+sp(i,j)

      do 1012 j=1,18
      do 1012 i=1,n
 1012 dpcond(icontr(i),j)=dpcond(icontr(i),j)+dp(i,j)*twozetaa(i)

      do 1013 i=1,m
      overlap(inddyy(i,1),1)=overlap(inddyy(i,1),1)-spcond(i,1)
      overlap(inddyy(i,4),2)=overlap(inddyy(i,4),2)-spcond(i,1)
      overlap(inddyy(i,5),2)=overlap(inddyy(i,5),2)-spcond(i,2)
      overlap(inddyy(i,7),3)=overlap(inddyy(i,7),3)-spcond(i,1)
      overlap(inddyy(i,8),3)=overlap(inddyy(i,8),3)-spcond(i,2)
 1013 overlap(inddyy(i,9),3)=overlap(inddyy(i,9),3)-spcond(i,3)

      do 1014 i=1,m
      if(iminj(i).ne.0) then

              overlap(inddyy(i,2),1)=overlap(inddyy(i,2),1)-spcond(i,2)
              overlap(inddyy(i,3),1)=overlap(inddyy(i,3),1)-spcond(i,3)
              overlap(inddyy(i,6),2)=overlap(inddyy(i,6),2)-spcond(i,3)

                        endif
 1014 continue

      do 1015 i=1,m
      overlap(inddyy(i,1),1)=overlap(inddyy(i,1),1)+dpcond(i,01)
      overlap(inddyy(i,4),1)=overlap(inddyy(i,4),1)+dpcond(i,04)
      overlap(inddyy(i,5),1)=overlap(inddyy(i,5),1)+dpcond(i,05)
      overlap(inddyy(i,7),1)=overlap(inddyy(i,7),1)+dpcond(i,07)
      overlap(inddyy(i,8),1)=overlap(inddyy(i,8),1)+dpcond(i,08)
      overlap(inddyy(i,9),1)=overlap(inddyy(i,9),1)+dpcond(i,09)
      overlap(inddyy(i,1),2)=overlap(inddyy(i,1),2)+dpcond(i,04)
      overlap(inddyy(i,4),2)=overlap(inddyy(i,4),2)+dpcond(i,10)
      overlap(inddyy(i,5),2)=overlap(inddyy(i,5),2)+dpcond(i,11)
      overlap(inddyy(i,7),2)=overlap(inddyy(i,7),2)+dpcond(i,13)
      overlap(inddyy(i,8),2)=overlap(inddyy(i,8),2)+dpcond(i,14)
      overlap(inddyy(i,9),2)=overlap(inddyy(i,9),2)+dpcond(i,15)
      overlap(inddyy(i,1),3)=overlap(inddyy(i,1),3)+dpcond(i,07)
      overlap(inddyy(i,4),3)=overlap(inddyy(i,4),3)+dpcond(i,13)
      overlap(inddyy(i,5),3)=overlap(inddyy(i,5),3)+dpcond(i,14)
      overlap(inddyy(i,7),3)=overlap(inddyy(i,7),3)+dpcond(i,16)
      overlap(inddyy(i,8),3)=overlap(inddyy(i,8),3)+dpcond(i,17)
 1015 overlap(inddyy(i,9),3)=overlap(inddyy(i,9),3)+dpcond(i,18)

      do 1016 i=1,m
      if(iminj(i).ne.0) then

             overlap(inddyy(i,2),1)=overlap(inddyy(i,2),1)+dpcond(i,02)
             overlap(inddyy(i,3),1)=overlap(inddyy(i,3),1)+dpcond(i,03)
             overlap(inddyy(i,6),1)=overlap(inddyy(i,6),1)+dpcond(i,06)
             overlap(inddyy(i,2),2)=overlap(inddyy(i,2),2)+dpcond(i,05)
             overlap(inddyy(i,3),2)=overlap(inddyy(i,3),2)+dpcond(i,06)
             overlap(inddyy(i,6),2)=overlap(inddyy(i,6),2)+dpcond(i,12)
             overlap(inddyy(i,2),3)=overlap(inddyy(i,2),3)+dpcond(i,08)
             overlap(inddyy(i,3),3)=overlap(inddyy(i,3),3)+dpcond(i,09)
             overlap(inddyy(i,6),3)=overlap(inddyy(i,6),3)+dpcond(i,15)

                        endif
 1016 continue

      do 1017 i=1,n
 1017 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1018 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps(i,2)
 1018 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps(i,3)

      do 1019 i=1,n
      sp(i,1)=pxbx(i)*ss(i)+eta2(i)*sp(i,1)
      sp(i,2)=pyby(i)*ss(i)+eta2(i)*sp(i,2)
 1019 sp(i,3)=pzbz(i)*ss(i)+eta2(i)*sp(i,3)

      do 1020 i=1,n
 1020 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/twozetaa(i)

      do 1021 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds(i,2)
      ds(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds(i,3)
      ds(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds(i,4)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds(i,5)
 1021 ds(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds(i,6)+c(i)

      do 1022 j=1,3
      do 1022 i=1,n
 1022 c1(i,j)=ps(i,j)/twozeta(i)

      do 1023 i=1,n
      dp(i,01)=pxbx(i)*ds(i,1)+eta2(i)*dp(i,01)+c1(i,1)*two
      dp(i,02)=pyby(i)*ds(i,1)+eta2(i)*dp(i,02)
      dp(i,03)=pzbz(i)*ds(i,1)+eta2(i)*dp(i,03)
      dp(i,04)=pxbx(i)*ds(i,2)+eta2(i)*dp(i,04)+c1(i,2)
      dp(i,05)=pyby(i)*ds(i,2)+eta2(i)*dp(i,05)+c1(i,1)
      dp(i,06)=pzbz(i)*ds(i,2)+eta2(i)*dp(i,06)
      dp(i,07)=pxbx(i)*ds(i,3)+eta2(i)*dp(i,07)+c1(i,3)
      dp(i,08)=pyby(i)*ds(i,3)+eta2(i)*dp(i,08)
      dp(i,09)=pzbz(i)*ds(i,3)+eta2(i)*dp(i,09)+c1(i,1)
      dp(i,10)=pxbx(i)*ds(i,4)+eta2(i)*dp(i,10)
      dp(i,11)=pyby(i)*ds(i,4)+eta2(i)*dp(i,11)+c1(i,2)*two
      dp(i,12)=pzbz(i)*ds(i,4)+eta2(i)*dp(i,12)
      dp(i,13)=pxbx(i)*ds(i,5)+eta2(i)*dp(i,13)
      dp(i,14)=pyby(i)*ds(i,5)+eta2(i)*dp(i,14)+c1(i,3)
      dp(i,15)=pzbz(i)*ds(i,5)+eta2(i)*dp(i,15)+c1(i,2)
      dp(i,16)=pxbx(i)*ds(i,6)+eta2(i)*dp(i,16)
      dp(i,17)=pyby(i)*ds(i,6)+eta2(i)*dp(i,17)
 1023 dp(i,18)=pzbz(i)*ds(i,6)+eta2(i)*dp(i,18)+c1(i,3)*two

      do 1024 j=1,3
      do 1024 i=1,m
 1024 spcond(i,j)=zero

      do 1025 j=1,18
      do 1025 i=1,m
 1025 dpcond(i,j)=zero

      do 1026 j=1,3
      do 1026 i=1,n
 1026 spcond(icontr(i),j)=spcond(icontr(i),j)+sp(i,j)

      do 1027 j=1,18
      do 1027 i=1,n
 1027 dpcond(icontr(i),j)=dpcond(icontr(i),j)+dp(i,j)*twozetaa(i)

      do 1028 i=1,m
      grad(i,1)=spcond(i,1)*density(inddyy(i,1))
      grad(i,2)=spcond(i,2)*density(inddyy(i,2))
      grad(i,3)=spcond(i,3)*density(inddyy(i,3))
      grad(i,4)=spcond(i,1)*density(inddyy(i,4))
      grad(i,5)=spcond(i,2)*density(inddyy(i,5))
      grad(i,6)=spcond(i,3)*density(inddyy(i,6))
      grad(i,7)=spcond(i,1)*density(inddyy(i,7))
      grad(i,8)=spcond(i,2)*density(inddyy(i,8))
 1028 grad(i,9)=spcond(i,3)*density(inddyy(i,9))

      do 1029 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,2)=zero
                              grad(i,3)=zero
                              grad(i,6)=zero
                        endif
 1029 continue

      do 1030 k=1,3
      do 1030 j=1,3
      do 1030 i=1,m
 1030 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))-grad(i,3*(k-1)+j)

      do 1031 k=1,3
      do 1031 j=1,3
      do 1031 i=1,m
 1031 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,3*(k-1)+j)

      do 1032 i=1,m
      grad(i,01)=dpcond(i,01)*density(inddyy(i,1))
      grad(i,02)=dpcond(i,02)*density(inddyy(i,2))
      grad(i,03)=dpcond(i,03)*density(inddyy(i,3))
      grad(i,04)=dpcond(i,04)*density(inddyy(i,4))
      grad(i,05)=dpcond(i,05)*density(inddyy(i,5))
      grad(i,06)=dpcond(i,06)*density(inddyy(i,6))
      grad(i,07)=dpcond(i,07)*density(inddyy(i,7))
      grad(i,08)=dpcond(i,08)*density(inddyy(i,8))
      grad(i,09)=dpcond(i,09)*density(inddyy(i,9))
      grad(i,10)=dpcond(i,04)*density(inddyy(i,1))
      grad(i,11)=dpcond(i,05)*density(inddyy(i,2))
      grad(i,12)=dpcond(i,06)*density(inddyy(i,3))
      grad(i,13)=dpcond(i,10)*density(inddyy(i,4))
      grad(i,14)=dpcond(i,11)*density(inddyy(i,5))
      grad(i,15)=dpcond(i,12)*density(inddyy(i,6))
      grad(i,16)=dpcond(i,13)*density(inddyy(i,7))
      grad(i,17)=dpcond(i,14)*density(inddyy(i,8))
      grad(i,18)=dpcond(i,15)*density(inddyy(i,9))
      grad(i,19)=dpcond(i,07)*density(inddyy(i,1))
      grad(i,20)=dpcond(i,08)*density(inddyy(i,2))
      grad(i,21)=dpcond(i,09)*density(inddyy(i,3))
      grad(i,22)=dpcond(i,13)*density(inddyy(i,4))
      grad(i,23)=dpcond(i,14)*density(inddyy(i,5))
      grad(i,24)=dpcond(i,15)*density(inddyy(i,6))
      grad(i,25)=dpcond(i,16)*density(inddyy(i,7))
      grad(i,26)=dpcond(i,17)*density(inddyy(i,8))
 1032 grad(i,27)=dpcond(i,18)*density(inddyy(i,9))

      do 1033 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,15)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,24)=zero
                        endif
 1033 continue

      do 1034 k=1,3
      do 1034 j=1,9
      do 1034 i=1,m
 1034 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

      do 1035 k=1,3
      do 1035 j=1,9
      do 1035 i=1,m
 1035 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))-grad(i,9*(k-1)+j)

      return
      end

      subroutine genun(u,n,m)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
c
c  this is based on a subroutine taken out of connolly's ms program.

      implicit real*8(a-h,o-z)

      dimension u(3,*)

      data two,pi/2.0d0,3.1415926535898d0/

      nequator=sqrt(n*pi)

      nvertical=nequator/2

      m=0

      do 1001 i=1,nvertical+1

      theta=(pi*real64((i-1)))/real64(nvertical)

      z=cos(theta)
      xy=sin(theta)

      nhorizontal=max(1,int(real64(nequator)*xy))

      do 1001 j=1,nhorizontal

      phi=(two*pi*real64((j-1)))/real64(nhorizontal)

      x=cos(phi)*xy
      y=sin(phi)*xy

      m=m+1

      u(1,m)=x
      u(2,m)=y
      u(3,m)=z

 1001 continue

      return
      end

      subroutine delphidr(nreal,ninteger,natoms,nmaxorbs,nmaxaux,
     &                    nmaxpts,nmaxesp,mesp,nmaxiterations,idiis,
     &                    ngridtype,nfunctional,iptsflag,ncenters,
     &                    nptcharges,nbsystems,level,nalpha,nbeta,
     &                    nconts,ncontp,ncontd,ncds,ncdspd,nxcs,nxcspd,
     &                    ixcfit,natomtype,nptsatom,nshels,nshelp,
     &                    nsheld,ilfunc,icfunc,ngaussians,mtloca,
     &                    nfuncatom,icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &                    isys,iwkvec,cutoff,epsilon,dconvergence,
     &                    dmixing,elevelshift,coord,charge,
     &                    coordptcharge,ptcharge,core,focka,fockb,focke,
     &                    dmta,dmtb,coeffa,coeffb,overlap,alpha,coeffs,
     &                    alphacd,coefscd,coefpcd,coefdcd,alphaxc,
     &                    coefsxc,coefpxc,coefdxc,cdfitc,xcfita,xcfitb,
     &                    xcfite,tvector,tveca,tvecb,tvece,xcfitsave,
     &                    wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),ngaussians(*),mtloca(*),
     &          nfuncatom(*),icdlfunc(*),icdcfunc(*),ixclfunc(*),
     &          ixccfunc(*),isys(natoms,*),iwkvec(*)

      dimension cutoff(*),coord(3,*),charge(*),coordptcharge(3,*),
     &          ptcharge(*),core(*),focka(*),fockb(*),focke(*),dmta(*),
     &          dmtb(*),coeffa(nmaxorbs,*),coeffb(nmaxorbs,*),
     &          overlap(nmaxorbs,*),alpha(*),coeffs(*),alphacd(*),
     &          coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),coefsxc(*),
     &          coefpxc(*),coefdxc(*),cdfitc(*),xcfita(*),xcfitb(*),
     &          xcfite(*),tvector(*),tveca(*),tvecb(*),tvece(*),
     &          xcfitsave(*),wkvec(*)

      data zero,dlarge/0.0d0,1.0d+25/

      ncontractions=nconts+3*ncontp+6*ncontd

      ncdtotal=ncds+10*ncdspd
      nxctotal=nxcs+10*nxcspd

      savedmixing=dmixing

      ii=0
      ndelphi=0

      do 1001 i=1,nmaxiterations

      ii=ii+1

      if(ndelphi.eq.5) goto 1001

      ja=1
      jb=ja+nmaxaux*3
      jc=jb+nmaxaux*3

      call scfcycle(ii,nreal-jc,ninteger-nmaxaux,natoms,nmaxorbs,
     &              nmaxaux,nmaxpts,idiis,nfunctional,ngridtype,
     &              ncenters,nptcharges,nbsystems,level,nalpha,nbeta,
     &              ncontractions,nconts,ncontp,ncontd,ncds,ncdspd,nxcs,
     &              nxcspd,ixcfit,natomtype,nptsatom,nshels,nshelp,
     &              nsheld,mtloca,ilfunc,icfunc,ngaussians,nfuncatom,
     &              icdlfunc,icdcfunc,ixclfunc,ixccfunc,isys,iwkvec(1),
     &              iwkvec(nmaxaux+1),energy,elevelshift,dmixing,
     &              diiserror,dmaxpc,cutoff,coord,coordptcharge,charge,
     &              ptcharge,core,focka,fockb,focke,dmta,dmtb,coeffa,
     &              coeffb,overlap,alpha,coeffs,alphacd,coefscd,coefpcd,
     &              coefdcd,alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,
     &              xcfita,xcfitb,xcfite,tvector,tveca,tvecb,tvece,
     &              wkvec(ja),wkvec(jb),wkvec(jc))

      factor=max(dconvergence,dconvergence*(10**(3-ndelphi)))

      if((ii.le.2).or.(dmaxpc.gt.factor)) goto 1001

      ii=0

      write(6,1002)
 1002 format(//)

      ja=1
      jb=ja+3*mesp
      jc=jb+4*natoms*natoms
      jd=jc+2*natoms
      je=jd+natoms
      jf=je+3*natoms
      jg=jf+3*natoms
      jh=jg+3*nmaxesp

      ka=1
      kb=ka+mesp
      kc=kb+mesp
      kd=kb+natoms*2
      ke=kb+natoms*natoms

      call mespgen(nreal-jh,ninteger-ke,iptsflag,natoms,mesp,nmaxesp,
     &             nmaxaux,level,ncenters,nbsystems,0,0,nalpha,nbeta,
     &             nconts,ncontp,ncontd,ncds,ncdspd,nshels,nshelp,
     &             nsheld,ilfunc,ngaussians,icfunc,mtloca,icdlfunc,
     &             icdcfunc,natomtype,iwkvec(kc),iwkvec(kd),isys,
     &             iwkvec(ka),iwkvec(kb),iwkvec(ke),coord,charge,dmta,
     &             dmtb,alpha,coeffs,alphacd,coefscd,coefpcd,coefdcd,
     &             cdfitc,wkvec(ja),wkvec(jb),wkvec(jc),wkvec(jd),
     &             wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh))

      ndelphi=ndelphi+1

      ngrid=65
      ngridby2=33

      do 1003 j=1,ncenters
 1003 wkvec(j)=wkvec(jc+j-1)

      ja=1
      jb=ja+ncenters
      jc=jb+ngrid*ngrid*ngrid
      jd=jc+ngrid*ngrid*ngrid
      je=jd+ngrid*ngrid*ngrid
      jf=je+ngrid*ngrid*ngrid*6
      jg=jf+ngrid*ngrid*ngrid
      jh=jg+ncenters*3

      ji=jh+ncenters

      if(ji.gt.nreal) stop 'delphi driver real overflow'

      if((ngrid**3).gt.ninteger) stop 'delphi driver integer overflow'

      if(ndelphi.eq.5) iswitch=1

      call delphi(iswitch,ndelphi,ncenters,nptcharges,ngrid,ngridby2,
     &            natomtype,iwkvec,epsilon,coord,wkvec(ja),
     &            coordptcharge,ptcharge,wkvec(jb),wkvec(jc),wkvec(jd),
     &            wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh))

      ja=1
      jb=ja+(ncenters+nptcharges)*3
      jc=jb+(ncenters+nptcharges)

      call coremm(nreal-jc,ninteger,ncenters,nptcharges,nconts,ncontp,
     &            ncontd,nshels,nshelp,nsheld,mtloca,ilfunc,ngaussians,
     &            icfunc,iwkvec,cutoff(3),wkvec(ja),coord,coordptcharge,
     &            wkvec(jb),charge,ptcharge,alpha,coeffs,overlap,core,
     &            wkvec(jc))

 1001 continue

      dmixing=savedmixing

      if(dmaxpc.le.dconvergence) then
                                       write(6,1004)
                                 else
                                       write(6,1005)
                                 endif

 1004 format(/,' scf converged!!! :-) :-) :-) ')
 1005 format(/,' scf terminated unsuccessfully??? :-( :-( :-( ')

      call gengrid(nreal,nmaxpts,ngridtype,0,ncenters,nconts,ncontp,
     &             ncontd,ilfunc,icfunc,ngaussians,nshels,nshelp,nsheld,
     &             natomtype,nptsatom,iwkvec,coord,alpha,coeffs,wkvec)

      ja=1
      jb=ja+3*nxctotal
      jc=jb+3*nxctotal
      jd=jc+nxctotal*nxctotal

      call gridcall(nreal-jd,nxctotal,0,-1,nfunctional,ncenters,natoms,
     &              nbsystems,nalpha,nbeta,nconts,ncontp,ncontd,nxcs,
     &              nxcs+nxcspd,nmaxpts,natomtype,nptsatom,nshels,
     &              nshelp,nsheld,ilfunc,icfunc,ngaussians,ixclfunc,
     &              ixccfunc,isys,iwkvec,iwkvec(nxctotal+1),dmixing,
     &              cutoff(2),coord,alpha,coeffs,alphaxc,coefsxc,
     &              coefpxc,coefdxc,xcfita,xcfitb,xcfite,dmta,dmtb,
     &              tveca,tvecb,tvece,wkvec(ja),wkvec(jb),wkvec(jc),
     &              focka,fockb,focke,wkvec(jd))

      do 1006 i=1,nxctotal
 1006 xcfitsave(i)=xcfite(i)

      do 1007 i=1,nxctotal
 1007 xcfite(i)=zero

      call numxcc(nreal,ninteger,natoms,nmaxpts,ncenters,nconts,ncontp,
     &            ncontd,ncds,ncdspd,nxcs,nxcspd,nbsystems,level,iwkvec,
     &            mtloca,ilfunc,ngaussians,icfunc,nshels,nshelp,nsheld,
     &            natomtype,nptsatom,icdlfunc,icdcfunc,ixclfunc,
     &            ixccfunc,isys,cutoff(3),wkvec,coord,core,focka,fockb,
     &            focke,alpha,coeffs,alphacd,coefscd,coefpcd,coefdcd,
     &            alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,xcfita,xcfitb,
     &            xcfite)

      do 1008 i=1,nxctotal
 1008 xcfite(i)=xcfitsave(i)

      call totale(1,ncontractions,ncdtotal,-1,nptcharges,ncenters,
     &            nalpha,nbeta,nmaxaux,energy,diiserror,dmta,dmtb,focke,
     &            coord,charge,coordptcharge,ptcharge,wkvec,cdfitc,
     &            dmaxpc)

      return
      end

      subroutine auggv(n,ndim,iloc,tvalue,gv,expfac,term,sum)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.
c
c  based on brett dunlap's incomplete gamma function subroutines

      implicit real*8(a-h,o-z)

      dimension iloc(*)

      dimension tvalue(*),gv(ndim,*),expfac(*),term(*),sum(*)

      common/igfdata/table(17,161),smallu(17),bigu(13)

      data small,eterm/0.00000001d0,0.018315638888734d0/

      data a1,a2,a3/0.2507213d0,0.0292732d0,0.0038278d0/

      data b1,b2,b3,b4,b5/1.333333333333d0,0.53333333333333d0,
     &                    0.152380952000d0,3.28125000000000d0,
     &                    0.937500000000d0/

      data c1,c2,c3,c4/1.772453850905500d0,0.88622692545276d0,
     &                 0.041666666666667d0,0.16666666666667d0/

      data zero,tenth,quarter,three8ths,half,
     &     one,two,ten,sixteen,plus16,thirty6/0.000d0, 0.100d0, 0.250d0,
     &                                        0.375d0, 0.500d0, 1.000d0,
     &                                        2.000d0,10.000d0,16.000d0,
     &                                       16.050d0,36.000d0/

      do 1001 i=1,n
      do 1001 j=1,ndim
 1001 gv(j,i)=smallu(i)

      nn=0

      do 1002 j=1,ndim
      if((tvalue(j).lt.plus16).and.(tvalue(j).gt.small)) then
                                                              nn=nn+1
                                                              iloc(nn)=j
                                                         endif
 1002 continue

      if(nn.eq.0) goto 1003

cfpp$ nodepchk
      do 1004 j=1,nn
      i=ten*tvalue(iloc(j))
      x1=tvalue(iloc(j))-tenth*real64(i)
      x2=2*n-1
 1004 gv(iloc(j),n)=(((c3*table(n+4,i+1)*x1
     &                -c4*table(n+3,i+1))*x1
     &              +half*table(n+2,i+1))*x1
     &                   -table(n+1,i+1))*x1
     &                   +table(n,i+1)

      do 1005 j=1,nn
 1005 expfac(j)=exp(-tvalue(iloc(j)))

      do 1006 i=1,n-1
      x2=x2-two
cfpp$ nodepchk
      do 1007 j=1,nn
 1007 gv(iloc(j),n-i)=(gv(iloc(j),n-i+1)
     &               *two*tvalue(iloc(j))+expfac(j))/x2
 1006 continue

 1003 nn=0

      do 1008 j=1,ndim
      if(tvalue(j).ge.plus16) then
                                    nn=nn+1
                                    iloc(nn)=j
                              endif
 1008 continue

      if(nn.eq.0) return

cfpp$ nodepchk
      do 1009 j=1,nn
 1009 gv(iloc(j),n)=c2*bigu(n)/sqrt(tvalue(iloc(j)))

      do 1010 i=1,n-1
cfpp$ nodepchk
      do 1011 j=1,nn
 1011 gv(iloc(j),n)=gv(iloc(j),n)*half/tvalue(iloc(j))
 1010 continue

      x1=2*n-1
      x2=2*n-1

      do 1012 j=1,nn
      term(j)=one
 1012 sum(j)=one

      do 1013 i=1,n
      x1=x1-two
      do 1014 j=1,nn
 1014 term(j)=term(j)*x1/(two*tvalue(iloc(j)))
      do 1015 j=1,nn
 1015 sum(j)=sum(j)+term(j)
 1013 continue

      do 1016 j=1,nn
 1016 expfac(j)=zero

      do 1017 j=1,nn
 1017 if(tvalue(iloc(j)).lt.thirty6) expfac(j)=exp(-tvalue(iloc(j)))

cfpp$ nodepchk
      do 1018 j=1,nn
 1018 gv(iloc(j),n)=gv(iloc(j),n)-sum(j)*expfac(j)/(two*tvalue(iloc(j)))

      do 1019 i=1,n-1
      x2=x2-two
cfpp$ nodepchk
      do 1020 j=1,nn
 1020 gv(iloc(j),n-i)=(gv(iloc(j),n-i+1)
     &               *two*tvalue(iloc(j))+expfac(j))/x2
 1019 continue

      return
      end

      subroutine bfgs_r(icycle,n,hessian,grad_1,coord_1,grad_0,coord_0,
     &                  delta_g,delta_x,wkmat1,wkmat2)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)  

      dimension hessian(n,*),grad_1(*),coord_1(*),grad_0(*),coord_0(*),
     &          delta_g(*),delta_x(*),wkmat1(n,*),wkmat2(n,*)

      data zero,one,two,pi/0.0d0,1.0d0,2.0d0,3.1415926535898d0/

      rewind 21

      call fastrd(21,hessian,n*n)
      call fastrd(21,grad_0,n)
      call fastrd(21,coord_0,n)

      do 1001 i=1,n
 1001 delta_x(i)=coord_1(i)-coord_0(i)

      do 1002 i=1,n
 1002 delta_g(i)=grad_1(i)-grad_0(i)

      do 1003 i=1,n
      if(delta_x(i).lt.(-pi)) delta_x(i)=delta_x(i)+two*pi
 1003 if(delta_x(i).gt.(+pi)) delta_x(i)=delta_x(i)-two*pi

      den=zero

      do 1004 i=1,n
 1004 den=den+delta_x(i)*delta_g(i)

      do 1005 j=1,n
      do 1006 i=1,n
 1006 wkmat1(i,j)=   -(delta_x(i)*delta_g(j))/den
 1005 wkmat1(j,j)=one-(delta_x(j)*delta_g(j))/den

      do 1007 j=1,n
      do 1008 i=1,n
 1008 wkmat2(i,j)=zero
      do 1007 k=1,n
      do 1007 i=1,n
 1007 wkmat2(i,j)=wkmat2(i,j)+hessian(i,k)*wkmat1(j,k)

      do 1009 j=1,n
      do 1010 i=1,n
 1010 hessian(i,j)=zero
      do 1009 k=1,n
      do 1009 i=1,n
 1009 hessian(i,j)=hessian(i,j)+wkmat1(i,k)*wkmat2(k,j)

      do 1011 j=1,n
      do 1011 i=1,n
 1011 hessian(i,j)=hessian(i,j)+(delta_x(i)*delta_x(j))/den

      return
      end

      subroutine cdftmm(nreal,ninteger,nconts,ncontp,ncontd,ncds,ncdspd,
     &                  nshels,nshelp,nsheld,mtloca,iprimvc,nprimvc,
     &                  icentvc,icdlfunc,icdcfunc,isys,iwkvec,coord,
     &                  alpha,coeff,alphacd,coefscd,coefpcd,coefdcd,
     &                  tvector,density,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension jsend(20)

      dimension istat(mpi_status_size)

      dimension g(7)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*),iprimvc(*),
     &          nprimvc(*),icentvc(*),icdlfunc(*),icdcfunc(*),isys(*),
     &          iwkvec(*)

      dimension coord(3,*),alpha(*),coeff(*),alphacd(*),coefscd(*),
     &          coefpcd(*),coefdcd(*),tvector(*),density(*),wkvec(*)

      data zero,half,three,cutoff/0.0d0,0.5d0,3.0d0,1.0d+35/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      nprocesses=numprocs-1

      call igftable

      sqrt3=sqrt(three)

      ndim=nconts+3*ncontp+6*ncontd
      ndim=ndim*(ndim+1)/2

      call mpi_bcast(density,ndim,mpi_real8,0,mpi_comm_world,ierr)

      ndim=ncds+10*ncdspd

      do 1001 i=1,ndim
 1001 tvector(i)=zero

      do 1002 i=1,ncontd
      do 1002 j=1,nconts

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3

 1002 continue

      do 1003 i=1,ncontd
      do 1003 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+1)=density(i4+1)/sqrt3
      density(i4+2)=density(i4+2)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3

 1003 continue

      do 1004 i=1,ncontd
      do 1004 j=1,i

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      density(i4)=density(i4)/three
      if(i.ne.j) density(i4+1)=density(i4+1)/sqrt3
      if(i.ne.j) density(i4+2)=density(i4+2)/sqrt3
      if(i.ne.j) density(i4+3)=density(i4+3)/three
      if(i.ne.j) density(i4+4)=density(i4+4)/sqrt3
      if(i.ne.j) density(i4+5)=density(i4+5)/three

      density(i4+i1)=density(i4+i1)/sqrt3
      if(i.ne.j) density(i4+i1+3)=density(i4+i1+3)/sqrt3
      if(i.ne.j) density(i4+i1+5)=density(i4+i1+5)/sqrt3

      density(i4+i1*2+1)=density(i4+i1*2+1)/sqrt3
      if(i.ne.j) density(i4+i1*2+4)=density(i4+i1*2+4)/sqrt3
      if(i.ne.j) density(i4+i1*2+6)=density(i4+i1*2+6)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/three
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3
      density(i4+i1*3+6)=density(i4+i1*3+6)/three
      if(i.ne.j) density(i4+i1*3+7)=density(i4+i1*3+7)/sqrt3
      if(i.ne.j) density(i4+i1*3+8)=density(i4+i1*3+8)/three

      density(i4+i1*4+6)=density(i4+i1*4+6)/sqrt3
      density(i4+i1*4+9)=density(i4+i1*4+9)/sqrt3
      if(i.ne.j) density(i4+i1*4+11)=density(i4+i1*4+11)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/three
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3
      density(i4+i1*5+13)=density(i4+i1*5+13)/three
      density(i4+i1*5+14)=density(i4+i1*5+14)/sqrt3
      density(i4+i1*5+15)=density(i4+i1*5+15)/three

 1004 continue

      do 1005 i=1,nconts
      do 1005 j=1,i

      icenta=icentvc(nshels(i))
      icentb=icentvc(nshels(j))

      factor=zero
      if(isys(icenta).eq.1) factor=factor+half
      if(isys(icentb).eq.1) factor=factor+half

      i1=mtloca(nshels(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)*factor

 1005 continue

      do 1006 i=1,ncontp
      do 1006 j=1,nconts

      icenta=icentvc(nshelp(i))
      icentb=icentvc(nshels(j))

      factor=zero
      if(isys(icenta).eq.1) factor=factor+half
      if(isys(icentb).eq.1) factor=factor+half

      i1=mtloca(nshelp(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)*factor
      density(i4+i1)=density(i4+i1)*factor
      density(i4+i1+i1+1)=density(i4+i1+i1+1)*factor

 1006 continue

      do 1007 i=1,ncontp
      do 1007 j=1,i

      icenta=icentvc(nshelp(i))
      icentb=icentvc(nshelp(j))

      factor=zero
      if(isys(icenta).eq.1) factor=factor+half
      if(isys(icentb).eq.1) factor=factor+half

      i1=mtloca(nshelp(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      density(i4)=density(i4)*factor

      density(i4+i1)=density(i4+i1)*factor
      density(i4+i1+1)=density(i4+i1+1)*factor

      density(i4+i1+i1+1)=density(i4+i1+i1+1)*factor
      density(i4+i1+i1+2)=density(i4+i1+i1+2)*factor
      density(i4+i1+i1+3)=density(i4+i1+i1+3)*factor

      if(i.ne.j) then
                       density(i4+1)=density(i4+1)*factor
                       density(i4+2)=density(i4+2)*factor

                       density(i4+i1+2)=density(i4+i1+2)*factor
                 endif

 1007 continue

      do 1008 i=1,ncontd
      do 1008 j=1,nconts

      icenta=icentvc(nsheld(i))
      icentb=icentvc(nshels(j))

      factor=zero
      if(isys(icenta).eq.1) factor=factor+half
      if(isys(icentb).eq.1) factor=factor+half

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)*factor
      density(i4+i1)=density(i4+i1)*factor
      density(i4+i1*2+1)=density(i4+i1*2+1)*factor
      density(i4+i1*3+3)=density(i4+i1*3+3)*factor
      density(i4+i1*4+6)=density(i4+i1*4+6)*factor
      density(i4+i1*5+10)=density(i4+i1*5+10)*factor

 1008 continue

      do 1009 i=1,ncontd
      do 1009 j=1,ncontp

      icenta=icentvc(nsheld(i))
      icentb=icentvc(nshelp(j))

      factor=zero
      if(isys(icenta).eq.1) factor=factor+half
      if(isys(icentb).eq.1) factor=factor+half

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      density(i4)=density(i4)*factor
      density(i4+1)=density(i4+1)*factor
      density(i4+2)=density(i4+2)*factor

      density(i4+i1)=density(i4+i1)*factor
      density(i4+i1+1)=density(i4+i1+1)*factor
      density(i4+i1+2)=density(i4+i1+2)*factor

      density(i4+i1*2+1)=density(i4+i1*2+1)*factor
      density(i4+i1*2+2)=density(i4+i1*2+2)*factor
      density(i4+i1*2+3)=density(i4+i1*2+3)*factor

      density(i4+i1*3+3)=density(i4+i1*3+3)*factor
      density(i4+i1*3+4)=density(i4+i1*3+4)*factor
      density(i4+i1*3+5)=density(i4+i1*3+5)*factor

      density(i4+i1*4+6)=density(i4+i1*4+6)*factor
      density(i4+i1*4+7)=density(i4+i1*4+7)*factor
      density(i4+i1*4+8)=density(i4+i1*4+8)*factor

      density(i4+i1*5+10)=density(i4+i1*5+10)*factor
      density(i4+i1*5+11)=density(i4+i1*5+11)*factor
      density(i4+i1*5+12)=density(i4+i1*5+12)*factor

 1009 continue

      do 1010 i=1,ncontd
      do 1010 j=1,i

      icenta=icentvc(nsheld(i))
      icentb=icentvc(nsheld(j))

      factor=zero
      if(isys(icenta).eq.1) factor=factor+half
      if(isys(icentb).eq.1) factor=factor+half

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      density(i4)=density(i4)*factor

      density(i4+i1)=density(i4+i1)*factor
      density(i4+i1+1)=density(i4+i1+1)*factor

      density(i4+i1*2+1)=density(i4+i1*2+1)*factor
      density(i4+i1*2+2)=density(i4+i1*2+2)*factor
      density(i4+i1*2+3)=density(i4+i1*2+3)*factor

      density(i4+i1*3+3)=density(i4+i1*3+3)*factor
      density(i4+i1*3+4)=density(i4+i1*3+4)*factor
      density(i4+i1*3+5)=density(i4+i1*3+5)*factor
      density(i4+i1*3+6)=density(i4+i1*3+6)*factor

      density(i4+i1*4+6)=density(i4+i1*4+6)*factor
      density(i4+i1*4+7)=density(i4+i1*4+7)*factor
      density(i4+i1*4+8)=density(i4+i1*4+8)*factor
      density(i4+i1*4+9)=density(i4+i1*4+9)*factor
      density(i4+i1*4+10)=density(i4+i1*4+10)*factor

      density(i4+i1*5+10)=density(i4+i1*5+10)*factor
      density(i4+i1*5+11)=density(i4+i1*5+11)*factor
      density(i4+i1*5+12)=density(i4+i1*5+12)*factor
      density(i4+i1*5+13)=density(i4+i1*5+13)*factor
      density(i4+i1*5+14)=density(i4+i1*5+14)*factor
      density(i4+i1*5+15)=density(i4+i1*5+15)*factor

      if(i.ne.j) then
                       density(i4+1)=density(i4+1)*factor
                       density(i4+2)=density(i4+2)*factor
                       density(i4+3)=density(i4+3)*factor
                       density(i4+4)=density(i4+4)*factor
                       density(i4+5)=density(i4+5)*factor

                       density(i4+i1+2)=density(i4+i1+2)*factor
                       density(i4+i1+3)=density(i4+i1+3)*factor
                       density(i4+i1+4)=density(i4+i1+4)*factor
                       density(i4+i1+5)=density(i4+i1+5)*factor

                       density(i4+i1*2+4)=density(i4+i1*2+4)*factor
                       density(i4+i1*2+5)=density(i4+i1*2+5)*factor
                       density(i4+i1*2+6)=density(i4+i1*2+6)*factor

                       density(i4+i1*3+7)=density(i4+i1*3+7)*factor
                       density(i4+i1*3+8)=density(i4+i1*3+8)*factor

                       density(i4+i1*4+11)=density(i4+i1*4+11)*factor
                 endif

 1010 continue

      ncposs=nconts*(nconts+1)/2
      ncpopp=ncontp*(ncontp+1)/2
      ncpodd=ncontd*(ncontd+1)/2

      ncpops=ncontp*nconts
      ncpods=ncontd*nconts
      ncpodp=ncontd*ncontp

      npposs=0
      nppops=0
      nppopp=0
      nppods=0
      nppodp=0
      nppodd=0

      do 1011 i=1,nconts
      do 1011 j=1,i
 1011 npposs=npposs+nprimvc(nshels(i))*nprimvc(nshels(j))

      do 1012 i=1,ncontp
      do 1012 j=1,nconts
 1012 nppops=nppops+nprimvc(nshelp(i))*nprimvc(nshels(j))

      do 1013 i=1,ncontp
      do 1013 j=1,i
 1013 nppopp=nppopp+nprimvc(nshelp(i))*nprimvc(nshelp(j))

      do 1014 i=1,ncontd
      do 1014 j=1,nconts
 1014 nppods=nppods+nprimvc(nsheld(i))*nprimvc(nshels(j))

      do 1015 i=1,ncontd
      do 1015 j=1,ncontp
 1015 nppodp=nppodp+nprimvc(nsheld(i))*nprimvc(nshelp(j))

      do 1017 i=1,ncontd
      do 1017 j=1,i
 1017 nppodd=nppodd+nprimvc(nsheld(i))*nprimvc(nsheld(j))

      ja=1
      jb=ja+npposs
      jc=jb+ncposs

      if(jc.gt.ninteger) stop 'cdftmm ss integer overflow'

      je=1
      jf=je+npposs
      jg=jf+npposs
      jh=jg+npposs
      ji=jh+npposs
      jj=ji+npposs
      jk=jj+npposs
      jl=jk+npposs
      jm=jl+npposs
      jn=jm+npposs
      jo=jn+npposs
      jp=jo+npposs
      jq=jp+npposs
      jr=jq+npposs*8

      if(jr.gt.nreal) stop 'cdftmm ss real overflow'

      call setupcdss(ncposs,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &               icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,alpha,
     &               coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &               wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &               wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),density)

      jd=jc+n
      j0=jd+n

      if(j0.gt.ninteger) stop 'cdftmm ss integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                    endif

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n

      if(myid.eq.0) then
                          isent=0

                          do 1018 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp

                          call mpi_bsend(jsend,13,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop

 1018                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,13,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jq+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+ncposs
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+ncposs*3
      kl=kk+nloop*3
      km=kl+nloop*3
      kn=km+ncposs*6
      ko=kn+nloop*6
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop*10

      if(kv.gt.nreal) stop 'cdftmm ss real'

      call cdftss(ncposs,nloop,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),iwkvec(jd),g,coord,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,density,wkvec(je),
     &            wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jm),wkvec(ka),
     &            wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &            wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &            wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),
     &            wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku))

      if(ncontp.eq.0) goto 2001

      ja=1
      jb=ja+nppops
      jc=jb+ncpops*3

      if(jc.gt.ninteger) stop 'cdftmm ps integer overflow'

      je=1
      jf=je+nppops
      jg=jf+nppops
      jh=jg+nppops
      ji=jh+nppops
      jj=ji+nppops
      jk=jj+nppops
      jl=jk+nppops
      jm=jl+nppops
      jn=jm+nppops
      jo=jn+nppops
      jp=jo+nppops
      jq=jp+nppops
      jr=jq+nppops
      js=jr+nppops
      jt=js+nppops
      ju=jt+nppops*11

      if(ju.gt.nreal) stop 'cdftmm ps real overflow'

      call setupcdps(ncpops,n,ncontp,nconts,nshelp,nshels,mtloca,
     &               iprimvc,nprimvc,icentvc,iwkvec(ja),iwkvec(jb),
     &               cutoff,coord,alpha,coeff,wkvec(je),wkvec(jf),
     &               wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &               wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &               wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt),density)

      jd=jc+n
      j0=jd+n

      if(j0.gt.ninteger) stop 'cdftmm ps integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                    endif

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      if(myid.eq.0) then
                          isent=0

                          do 1019 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js

                          call mpi_bsend(jsend,16,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop

 1019                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,16,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jt+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+ncpops*3
      ko=kn+nloop*3
      kp=ko+nloop*3
      kq=kp+nloop*3
      kr=kq+nloop*3
      ks=kr+ncpops*9
      kt=ks+nloop*9
      ku=kt+nloop*9
      kv=ku+ncpops*18
      kw=kv+nloop*18
      kx=kw+nloop
      ky=kx+nloop
      kz=ky+nloop
      la=kz+nloop*3
      lb=la+nloop*3
      lc=lb+nloop
      ld=lc+nloop
      le=ld+nloop
      lf=le+nloop
      lg=lf+nloop
      lh=lg+nloop
      li=lh+nloop
      lj=li+nloop*10

      if(lj.gt.nreal) stop 'cdftmm ps real'

      call cdftps(ncpops,nloop,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),iwkvec(jd),g,coord,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,density,wkvec(je),
     &            wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jm),wkvec(jq),
     &            wkvec(jr),wkvec(js),wkvec(ka),wkvec(kb),wkvec(kc),
     &            wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &            wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &            wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &            wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),
     &            wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),
     &            wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),
     &            wkvec(lh),wkvec(li))

      ja=1
      jb=ja+ncpopp
      jc=jb+nppopp
      jd=jc+ncpopp*9

      if(jd.gt.ninteger) stop 'cdftmm pp integer overflow'

      je=1
      jf=je+nppopp
      jg=jf+nppopp
      jh=jg+nppopp
      ji=jh+nppopp
      jj=ji+nppopp
      jk=jj+nppopp
      jl=jk+nppopp
      jm=jl+nppopp
      jn=jm+nppopp
      jo=jn+nppopp
      jp=jo+nppopp
      jq=jp+nppopp
      jr=jq+nppopp
      js=jr+nppopp
      jt=js+nppopp
      ju=jt+nppopp
      jv=ju+nppopp
      jw=jv+nppopp
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp
      j0=jz+ncpopp*11

      if(j0.gt.nreal) stop 'cdftmm pp real overflow'

      call setupcdpp(ncpopp,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &               icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &               coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &               wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &               wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &               wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &               wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz),density)

      j0=jd+n
      j1=j0+n

      if(j1.gt.ninteger) stop 'cdftmm pp integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpopp,wkvec(18*n+0*ncpopp+1),wkvec(jw))
      call stringcopy(ncpopp,wkvec(18*n+1*ncpopp+1),wkvec(jx))
      call stringcopy(ncpopp,wkvec(18*n+2*ncpopp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      if(myid.eq.0) then
                          isent=0

                          do 1020 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=jb
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(jb),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          jb=jb+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1020                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      jb=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(jb),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop*3
      kp=ko+nloop*3
      kq=kp+nloop*3
      kr=kq+nloop*3
      ks=kr+nloop*3
      kt=ks+nloop*6
      ku=kt+nloop*6
      kv=ku+nloop*6
      kw=kv+nloop*6
      kx=kw+nloop*3
      ky=kx+nloop*9
      kz=ky+nloop*9
      la=kz+nloop*9
      lb=la+nloop*18
      lc=lb+nloop*18
      ld=lc+nloop*18
      le=ld+nloop*18
      lf=le+nloop*18
      lg=lf+nloop*36
      lh=lg+nloop*36
      li=lh+nloop*9
      lj=li+nloop*27
      lk=lj+nloop*54
      ll=lk+nloop
      lm=ll+nloop
      ln=lm+nloop
      lo=ln+nloop*3
      lp=lo+nloop*6
      lq=lp+nloop*9
      lr=lq+nloop
      ls=lr+nloop
      lt=ls+nloop
      lu=lt+nloop
      lv=lu+nloop
      lw=lv+nloop
      lx=lw+nloop
      ly=lx+nloop
      lz=ly+nloop
      ma=lz+nloop
      mb=ma+nloop*10

      if(mb.gt.nreal) stop 'cdftmm pp real'

      call cdftpp(ncpopp,nloop,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jb),iwkvec(jd),iwkvec(jc),iwkvec(j0),g,coord,
     &            alphacd,coefscd,coefpcd,coefdcd,tvector,density,
     &            wkvec(je),wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),
     &            wkvec(jo),wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),
     &            wkvec(js),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &            wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &            wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &            wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &            wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &            wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),
     &            wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),
     &            wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),
     &            wkvec(ln),wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),
     &            wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),wkvec(lw),
     &            wkvec(lx),wkvec(ly),wkvec(lz),wkvec(ma))

      if(ncontd.eq.0) goto 2001

      ja=1
      jb=ja+nppods
      jc=jb+ncpods*6

      if(jc.gt.ninteger) stop 'cdftmm ds integer overflow'

      je=1
      jf=je+nppods
      jg=jf+nppods
      jh=jg+nppods
      ji=jh+nppods
      jj=ji+nppods
      jk=jj+nppods
      jl=jk+nppods
      jm=jl+nppods
      jn=jm+nppods
      jo=jn+nppods
      jp=jo+nppods
      jq=jp+nppods
      jr=jq+nppods
      js=jr+nppods
      jt=js+nppods
      ju=jt+nppods*11

      if(ju.gt.nreal) stop 'cdftmm ds real overflow'

      call setupcdds(ncpods,n,ncontd,nconts,nsheld,nshels,mtloca,
     &               iprimvc,nprimvc,icentvc,iwkvec(ja),iwkvec(jb),
     &               cutoff,coord,alpha,coeff,wkvec(je),wkvec(jf),
     &               wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &               wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &               wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt),density)

      jd=jc+n
      j0=jd+n

      if(j0.gt.ninteger) stop 'cdftmm ds integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                    endif

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      if(myid.eq.0) then
                          isent=0

                          do 1021 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js

                          call mpi_bsend(jsend,16,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop

 1021                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,16,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jt+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop*3
      kp=ko+nloop*3
      kq=kp+nloop*3
      kr=kq+nloop*3
      ks=kr+ncpods*6
      kt=ks+nloop*6
      ku=kt+nloop*6
      kv=ku+nloop*6
      kw=kv+nloop*9
      kx=kw+ncpods*18
      ky=kx+nloop*18
      kz=ky+nloop*18
      la=kz+ncpods*36
      lb=la+nloop*36
      lc=lb+nloop
      ld=lc+nloop
      le=ld+nloop
      lf=le+nloop*3
      lg=lf+nloop*6
      lh=lg+nloop*9
      li=lh+nloop
      lj=li+nloop
      lk=lj+nloop
      ll=lk+nloop
      lm=ll+nloop
      ln=lm+nloop
      lo=ln+nloop
      lp=lo+nloop*10

      if(lp.gt.nreal) stop 'cdftmm ds real'

      call cdftds(ncpods,nloop,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),iwkvec(jd),g,coord,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,density,wkvec(je),
     &            wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jm),wkvec(jq),
     &            wkvec(jr),wkvec(js),wkvec(ka),wkvec(kb),wkvec(kc),
     &            wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &            wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &            wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &            wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),
     &            wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),
     &            wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),
     &            wkvec(lh),wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),
     &            wkvec(lm),wkvec(ln),wkvec(lo))

      ja=1
      jb=ja+nppodp
      jc=jb+ncpodp*18

      if(jc.gt.ninteger) stop 'cdftmm dp integer overflow'

      je=1
      jf=je+nppodp
      jg=jf+nppodp
      jh=jg+nppodp
      ji=jh+nppodp
      jj=ji+nppodp
      jk=jj+nppodp
      jl=jk+nppodp
      jm=jl+nppodp
      jn=jm+nppodp
      jo=jn+nppodp
      jp=jo+nppodp
      jq=jp+nppodp
      jr=jq+nppodp
      js=jr+nppodp
      jt=js+nppodp
      ju=jt+nppodp
      jv=ju+nppodp
      jw=jv+nppodp
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp
      j0=jz+ncpodp*11

      if(j0.gt.nreal) stop 'cdftmm dp real overflow'

      call setupcddp(ncpodp,n,ncontd,ncontp,nsheld,nshelp,mtloca,
     &               iprimvc,nprimvc,icentvc,iwkvec(ja),iwkvec(jb),
     &               cutoff,coord,alpha,coeff,wkvec(je),wkvec(jf),
     &               wkvec(jg),wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),
     &               wkvec(jl),wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),
     &               wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),
     &               wkvec(jv),wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz),
     &               density)

      jd=jc+n
      j0=jd+n

      if(j0.gt.ninteger) stop 'cdftmm dp integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpodp,wkvec(18*n+0*ncpodp+1),wkvec(jw))
      call stringcopy(ncpodp,wkvec(18*n+1*ncpodp+1),wkvec(jx))
      call stringcopy(ncpodp,wkvec(18*n+2*ncpodp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      if(myid.eq.0) then
                          isent=0

                          do 1022 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1022                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop*3
      kq=kp+nloop*3
      kr=kq+nloop*3
      ks=kr+nloop*3
      kt=ks+nloop*3
      ku=kt+nloop*6
      kv=ku+nloop*6
      kw=kv+nloop*6
      kx=kw+nloop*6
      ky=kx+nloop*6
      kz=ky+nloop*10
      la=kz+nloop*10
      lb=la+nloop*10
      lc=lb+nloop*10
      ld=lc+nloop*9
      le=ld+nloop*18
      lf=le+nloop*18
      lg=lf+nloop*18
      lh=lg+nloop*30
      li=lh+nloop*30
      lj=li+nloop*30
      lk=lj+nloop*36
      ll=lk+nloop*36
      lm=ll+nloop*60
      ln=lm+nloop*60
      lo=ln+nloop*18
      lp=lo+nloop*54
      lq=lp+nloop*108
      lr=lq+nloop
      ls=lr+nloop
      lt=ls+nloop
      lu=lt+nloop*3
      lv=lu+nloop*6
      lw=lv+nloop*9
      lx=lw+nloop*10
      ly=lx+nloop*18
      lz=ly+nloop
      ma=lz+nloop
      mb=ma+nloop
      mc=mb+nloop
      md=mc+nloop
      me=md+nloop
      mf=me+nloop
      mg=mf+nloop
      mh=mg+nloop
      mi=mh+nloop
      mj=mi+nloop*10

      if(mj.gt.nreal) stop 'cdftmm dp real'

      call cdftdp(ncpodp,nloop,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),iwkvec(jd),g,coord,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,density,wkvec(je),
     &            wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),wkvec(js),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &            wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &            wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),
     &            wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),
     &            wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),
     &            wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),
     &            wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),
     &            wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls),
     &            wkvec(lt),wkvec(lu),wkvec(lv),wkvec(lw),wkvec(lx),
     &            wkvec(ly),wkvec(lz),wkvec(ma),wkvec(mb),wkvec(mc),
     &            wkvec(md),wkvec(me),wkvec(mf),wkvec(mg),wkvec(mh),
     &            wkvec(mi))

      ja=1
      jb=ja+ncpodd
      jc=jb+nppodd
      jd=jc+ncpodd*36

      if(jd.gt.ninteger) stop 'cdftmm dd integer overflow'

      je=1
      jf=je+nppodd
      jg=jf+nppodd
      jh=jg+nppodd
      ji=jh+nppodd
      jj=ji+nppodd
      jk=jj+nppodd
      jl=jk+nppodd
      jm=jl+nppodd
      jn=jm+nppodd
      jo=jn+nppodd
      jp=jo+nppodd
      jq=jp+nppodd
      jr=jq+nppodd
      js=jr+nppodd
      jt=js+nppodd
      ju=jt+nppodd
      jv=ju+nppodd
      jw=jv+nppodd
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd
      j0=jz+ncpodd*11

      if(j0.gt.nreal) stop 'cdftmm dd real overflow'

      call setupcddd(ncpodd,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &               icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &               coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &               wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &               wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &               wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &               wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz),density)

      j0=jd+n
      j1=j0+n

      if(j1.gt.ninteger) stop 'cdftmm dd integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpodd,wkvec(18*n+0*ncpodd+1),wkvec(jw))
      call stringcopy(ncpodd,wkvec(18*n+1*ncpodd+1),wkvec(jx))
      call stringcopy(ncpodd,wkvec(18*n+2*ncpodd+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      if(myid.eq.0) then
                          isent=0

                          do 1023 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=jb
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(jb),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          jb=jb+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1023                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      jb=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(jb),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop*3
      kr=kq+nloop*3
      ks=kr+nloop*3
      kt=ks+nloop*3
      ku=kt+nloop*3
      kv=ku+nloop*3
      kw=kv+nloop*6
      kx=kw+nloop*6
      ky=kx+nloop*6
      kz=ky+nloop*6
      la=kz+nloop*6
      lb=la+nloop*6
      lc=lb+nloop*10
      ld=lc+nloop*10
      le=ld+nloop*10
      lf=le+nloop*10
      lg=lf+nloop*10
      lh=lg+nloop*15
      li=lh+nloop*15
      lj=li+nloop*15
      lk=lj+nloop*15
      ll=lk+nloop*9
      lm=ll+nloop*9
      ln=lm+nloop*18
      lo=ln+nloop*18
      lp=lo+nloop*18
      lq=lp+nloop*30
      lr=lq+nloop*30
      ls=lr+nloop*30
      lt=ls+nloop*45
      lu=lt+nloop*45
      lv=lu+nloop*45
      lw=lv+nloop*36
      lx=lw+nloop*36
      ly=lx+nloop*60
      lz=ly+nloop*60
      ma=lz+nloop*90
      mb=ma+nloop*90
      mc=mb+nloop*18
      md=mc+nloop*30
      me=md+nloop*36
      mf=me+nloop*54
      mg=mf+nloop*90
      mh=mg+nloop*108
      mi=mh+nloop*108
      mj=mi+nloop*180
      mk=mj+nloop*216
      ml=mk+nloop
      mm=ml+nloop
      mn=mm+nloop
      mo=mn+nloop*3
      mp=mo+nloop*6
      mq=mp+nloop*10
      mr=mq+nloop*15
      ms=mr+nloop*30
      mt=ms+nloop
      mu=mt+nloop
      mv=mu+nloop
      mw=mv+nloop
      mx=mw+nloop
      my=mx+nloop
      mz=my+nloop
      na=mz+nloop
      nb=na+nloop
      nc=nb+nloop
      nd=nc+nloop*10
                    
      if(mz.gt.nreal) stop 'cdftmm dd real'

      call cdftdd(ncpodd,nloop,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jb),iwkvec(jd),iwkvec(jc),iwkvec(j0),g,coord,
     &            alphacd,coefscd,coefpcd,coefdcd,tvector,density,
     &            wkvec(je),wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),
     &            wkvec(jo),wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),
     &            wkvec(js),wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),
     &            wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),
     &            wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),
     &            wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),
     &            wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &            wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),
     &            wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),
     &            wkvec(li),wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),
     &            wkvec(ln),wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),
     &            wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),wkvec(lw),
     &            wkvec(lx),wkvec(ly),wkvec(lz),wkvec(ma),wkvec(mb),
     &            wkvec(mc),wkvec(md),wkvec(me),wkvec(mf),wkvec(mg),
     &            wkvec(mh),wkvec(mi),wkvec(mj),wkvec(mk),wkvec(ml),
     &            wkvec(mm),wkvec(mn),wkvec(mo),wkvec(mp),wkvec(mq),
     &            wkvec(mr),wkvec(ms),wkvec(mt),wkvec(mu),wkvec(mv),
     &            wkvec(mw),wkvec(mx),wkvec(my),wkvec(mz),wkvec(na),
     &            wkvec(nb),wkvec(nc))

 2001 continue

      call mpi_reduce(tvector,wkvec,ndim,mpi_real8,
     &                mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) call stringcopy(ndim,tvector,wkvec)

      return
      end

      subroutine getdibydc(nint,ncentr,izmat1,izmat2,izmat3,dibydc,
     &                     coord)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)  

      dimension izmat1(*),izmat2(*),izmat3(*)

      dimension dibydc(nint,*),coord(3,*)

      dimension vec1(3),vec2(3),vec3(3),vec4(3),vec5(3)

      data zero,one/0.0d0,1.0d0/

      do 1001 i=1,3*ncentr
      do 1001 j=1,nint
 1001 dibydc(j,i)=zero

      iint=0

      do 1002 natom1=1,ncentr

      if(natom1.eq.1) ndegfreedom=0
      if(natom1.eq.2) ndegfreedom=1
      if(natom1.eq.3) ndegfreedom=2
      if(natom1.ge.4) ndegfreedom=3

      if(ndegfreedom.eq.0) goto 1002

      do 1003 n=1,ndegfreedom

      iint=iint+1

      natom2=izmat1(natom1)
      natom3=izmat2(natom1)
      natom4=izmat3(natom1)

      iloc1=3*(natom1-1)
      iloc2=3*(natom2-1)
      iloc3=3*(natom3-1)
      iloc4=3*(natom4-1)

      goto (2001,3001,4001) n

 2001 continue

      call unitvec(vec1,coord(1,natom1),coord(1,natom2))

      do 2002 k=1,3
      dibydc(iint,iloc1+k)=-vec1(k)
 2002 dibydc(iint,iloc2+k)=+vec1(k)

      goto 1003

 3001 continue

      call unitvec(vec1,coord(1,natom2),coord(1,natom1))
      call unitvec(vec2,coord(1,natom2),coord(1,natom3))

      dist12=dist(coord(1,natom1),coord(1,natom2))
      dist23=dist(coord(1,natom3),coord(1,natom2))

      factor1=dot(3,vec1,vec2)
      factor2=sqrt(one-factor1*factor1)

      do 3002 k=1,3
      dibydc(iint,iloc1+k)= (factor1*vec1(k)-vec2(k))/(dist12*factor2)
      dibydc(iint,iloc2+k)=-(factor1*vec1(k)-vec2(k))/(dist12*factor2)
     &                     -(factor1*vec2(k)-vec1(k))/(dist23*factor2)
 3002 dibydc(iint,iloc3+k)= (factor1*vec2(k)-vec1(k))/(dist23*factor2)

      goto 1003

 4001 continue

      call unitvec(vec1,coord(1,natom1),coord(1,natom2))
      call unitvec(vec2,coord(1,natom2),coord(1,natom3))
      call unitvec(vec3,coord(1,natom3),coord(1,natom4))

      factor1=-dot(3,vec1,vec2)
      factor2=-dot(3,vec2,vec3)

      factor3=sqrt(one-factor1*factor1)
      factor4=sqrt(one-factor2*factor2)

      call crossprod(vec4,vec1,vec2)
      call crossprod(vec5,vec2,vec3)

      dist12=dist(coord(1,natom1),coord(1,natom2))
      dist23=dist(coord(1,natom2),coord(1,natom3))
      dist34=dist(coord(1,natom3),coord(1,natom4))

      factor5=(dist23-dist12*factor1)/(dist23*dist12*factor3*factor3)
      factor6=(dist23-dist34*factor2)/(dist23*dist34*factor4*factor4)

      do 4002 k=1,3
      dibydc(iint,iloc1+k)=-vec4(k)/(dist12*factor3*factor3)
      dibydc(iint,iloc2+k)=+vec4(k)*factor5-vec5(k)*factor2/
     &                                      (dist23*factor4*factor4)
      dibydc(iint,iloc3+k)=-vec5(k)*factor6+vec4(k)*factor1/
     &                                      (dist23*factor3*factor3)
 4002 dibydc(iint,iloc4+k)=+vec5(k)/(dist34*factor4*factor4)

 1003 continue

 1002 continue

      return
      end

      subroutine xc_partial(nfunctional,xcnrg,xcpota,xcpotb,dnstya,
     &                      dnstyb,dnstyt,gradxa,gradya,gradza,gradxb,
     &                      gradyb,gradzb,gradxt,gradyt,gradzt,dbdgama,
     &                      dbdgamb,dbdgamc)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      data small,expcut/1.0d-15,80.0d0/

      data zero,one,two,three,four,five,six,seven,dnine,eleven/
     &    0.0d0,1.0d0,2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,9.0d0,11.0d0/

      data third,threequarters,fourthirds,fivethirds/
     &    0.33333333333333d0,0.75d0,1.3333333333333d0,1.6666666666667d0/

      data pi,dnom,zetadnom,pialpha/
     &    3.1415926535898d0,5.1297633d0,0.519842099d0,1.636963801d0/

      data fperdew,cp1,cp2,cp3,cp4/
     &    0.11d0,0.023266d0,7.389d-06,8.723d0,0.472d0/

      data tenthousand,thirtythousand,cpa,cpb,cpc,cpd/
     &    10000.0d0,30000.0d0,0.001667d0,0.002568d0,1.745d0,0.004235d0/

      gmoda=sqrt(gradxa*gradxa+gradya*gradya+gradza*gradza)
      gmodb=sqrt(gradxb*gradxb+gradyb*gradyb+gradzb*gradzb)
      gmodt=sqrt(gradxt*gradxt+gradyt*gradyt+gradzt*gradzt)

      bvalue=zero
      dbdrhoa=zero
      dbdrhob=zero
      dbdgama=zero
      dbdgamb=zero
      dbdgamc=zero

      if(dnstyt.lt.small) goto 1001

      call becke_partial(dnstya,dnstyb,gmoda,gmodb,bvalue,
     &                   dbdrhoa,dbdrhob,dbdgama,dbdgamb)

      if(gmodt.lt.small) goto 1001

      call perdew_partial(dnstya,dnstyb,dnstyt,gmodt,bvalue,
     &                    dbdrhoa,dbdrhob,dbdgama,dbdgamb,dbdgamc)

 1001 continue

      xcnrg=xcnrg+bvalue

      xcpota=xcpota+dbdrhoa
      xcpotb=xcpotb+dbdrhob

      return
      end

      subroutine gridwork(isubsystem,iswitch,iteration,nfunctional,
     &                    nauxfunctions,npoints,naos,nmos,ncontractions,
     &                    ncenters,nmaxatoms,nbsystems,nalpha,nbeta,
     &                    nconts,ncontp,ncontd,nxcfunctions,nxcs,nxcspd,
     &                    natomtype,nptsatom,nshels,nshelp,nsheld,
     &                    ilfunc,icfunc,ngaussians,ixclfunc,ixccfunc,
     &                    isys,iwkvec,coord,alpha,coeff,alphaxc,coefsxc,
     &                    coefpxc,coefdxc,extent,tvecb,tvece,auxoverlap,
     &                    amat,bmat,fv,fa,fb,dnsty,xcpot,xcnrg,weight,
     &                    gradx,grady,gradz,hssxx,hssxy,hssxz,hssyy,
     &                    hssyz,hsszz,xpoint,ypoint,zpoint,wpoint,wkvec,
     &                    fvx,fvy,fvz,fvxx,fvxy,fvxz,fvyy,fvyz,fvzz,wf,
     &                    wfx,wfy,wfz,extent1,extent2,extent3,extent4,
     &                    dcc,focka,fockb,focke)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),ngaussians(*),ixclfunc(*),
     &          ixccfunc(*),isys(*),iwkvec(*)

      dimension coord(3,*),alpha(*),coeff(*),alphaxc(*),coefsxc(*),
     &          coefpxc(*),coefdxc(*),extent(*),tvecb(*),tvece(*),
     &          auxoverlap(nauxfunctions,*),amat(*),bmat(*),
     &          fv(npoints,*),fa(nmos,*),fb(nmos,*),dnsty(npoints,*),
     &          xcpot(npoints,*),xcnrg(*),weight(*),gradx(npoints,*),
     &          grady(npoints,*),gradz(npoints,*),hssxx(npoints,*),
     &          hssxy(npoints,*),hssxz(npoints,*),hssyy(npoints,*),
     &          hssyz(npoints,*),hsszz(npoints,*),xpoint(*),ypoint(*),
     &          zpoint(*),wpoint(*),wkvec(*),fvx(npoints,*),
     &          fvy(npoints,*),fvz(npoints,*),fvxx(npoints,*),
     &          fvxy(npoints,*),fvxz(npoints,*),fvyy(npoints,*),
     &          fvyz(npoints,*),fvzz(npoints,*),wf(npoints,*),
     &          wfx(npoints,*),wfy(npoints,*),wfz(npoints,*),extent1(*),
     &          extent2(*),extent3(*),extent4(*),dcc(ncenters,*),
     &          focka(*),fockb(*),focke(*)

      data zero,half,one,two,three/0.0d0,0.5d0,1.0d0,2.0d0,3.0d0/
      data small,cutoff/1.0d-14,1.0d-16/
      data tolerance,cutrho2/1.0d-18,1.0d-20/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ixcfit=0
      if(nxcfunctions.gt.0) ixcfit=1

      igrad=0
      if(iswitch.eq.0) igrad=1

      ipert=0
      if(nfunctional.eq.2) ipert=1

      ipart=0
      if((ixcfit.eq.0).and.(igrad.eq.0)) ipart=1

      do 1001 i=1,ncenters
      do 1001 j=1,ncenters
 1001 dcc(j,i)=dist(coord(1,j),coord(1,i))

      call diffuse2(nconts,ncontp,ncontd,ilfunc,icfunc,ngaussians,
     &              nshels,nshelp,nsheld,cutoff,alpha,coeff,coord,
     &              extent1)

      call diffuse3(nxcs,nxcspd,ixclfunc,ixccfunc,cutoff,alphaxc,
     &              coefsxc,coefpxc,coefdxc,coord,extent2)

      call diffuse4(ncenters,natomtype,cutrho2,extent4)

      nsavefunctional=nfunctional

      if((ipert.eq.1).and.(igrad.eq.1)) nfunctional=1
      if((ipert.eq.1).and.(igrad.eq.0)) nfunctional=0

      if(myid.eq.0) then
                          rewind 11
                          rewind 12
                    endif

casa
c     if(iteration.eq.1) then
c                              do 1002 i=1,nxcfunctions
c                              do 1002 j=1,nxcfunctions
c1002                          auxoverlap(j,i)=zero
c                        endif

c     do 1003 i=1,nxcfunctions
c1003 tvece(i)=zero
casa

      do 1004 iatom=1,ncenters

      if(natomtype(iatom).eq.0) goto 1004

      if(myid.eq.0) then
                          call fastrd(11,xpoint,nptsatom(iatom))
                          call fastrd(11,ypoint,nptsatom(iatom))
                          call fastrd(11,zpoint,nptsatom(iatom))
                          call fastrd(11,wpoint,nptsatom(iatom))
                    endif

      do 1005 ia=1,nptsatom(iatom),npoints

      ib=min(ia+npoints-1,nptsatom(iatom))

      ilast=0
      if((iatom.eq.ncenters).and.(ib.eq.nptsatom(iatom))) ilast=1

      radius=sqrt((coord(1,iatom)-xpoint(ib))**2
     &           +(coord(2,iatom)-ypoint(ib))**2
     &           +(coord(3,iatom)-zpoint(ib))**2)

      call mpi_bcast(radius,1,mpi_real8,0,mpi_comm_world,ierr)

      npts=ib-ia+1

      nmaxloop=(npts/numprocs)+1
      if((nmaxloop*numprocs).lt.npts) nmaxloop=nmaxloop+1

      if(myid.eq.0) then
                          ja=ia

                          islave=0

                          do 1006 i=1,npts,nmaxloop

                          nloop=min(nmaxloop,npts-i+1)

                          call mpi_bsend(nloop,1,mpi_integer,
     &                                   islave,77,mpi_comm_world,ierr)
                          call mpi_bsend(ja,1,mpi_integer,
     &                                   islave,77,mpi_comm_world,ierr)

                          call mpi_bsend(xpoint(ja),nloop,mpi_real8,
     &                                   islave,77,mpi_comm_world,ierr)
                          call mpi_bsend(ypoint(ja),nloop,mpi_real8,
     &                                   islave,77,mpi_comm_world,ierr)
                          call mpi_bsend(zpoint(ja),nloop,mpi_real8,
     &                                   islave,77,mpi_comm_world,ierr)
                          call mpi_bsend(wpoint(ja),nloop,mpi_real8,
     &                                   islave,77,mpi_comm_world,ierr)

                          if(isubsystem.gt.1) then

                                   call fastrd(12,xcpot(1,1),nloop)
                                   call fastrd(12,xcpot(1,2),nloop)
                                   call fastrd(12,xcnrg(1),nloop)

                                   call mpi_bsend(xcpot(1,1),nloop,
     &                                            mpi_real8,islave,77,
     &                                            mpi_comm_world,ierr)
                                   call mpi_bsend(xcpot(1,2),nloop,
     &                                            mpi_real8,islave,77,
     &                                            mpi_comm_world,ierr)
                                   call mpi_bsend(xcnrg(1),nloop,
     &                                            mpi_real8,islave,77,
     &                                            mpi_comm_world,ierr)

                                              endif

                          ja=ja+nloop

                          last_slave=islave
                           
 1006                     islave=islave+1

                          do 1007 i=islave,numprocs-1
                          nloop=0
 1007                     call mpi_bsend(nloop,1,mpi_integer,
     &                                   i,77,mpi_comm_world,ierr)
                    endif

      call mpi_recv(npts,1,mpi_integer,0,77,mpi_comm_world,istat,ierr)

      if(npts.eq.0) goto 1005

      call mpi_recv(ja,1,mpi_integer,0,77,mpi_comm_world,istat,ierr)

      call mpi_recv(xpoint(ja),npts,mpi_real8,
     &              0,77,mpi_comm_world,istat,ierr)
      call mpi_recv(ypoint(ja),npts,mpi_real8,
     &              0,77,mpi_comm_world,istat,ierr)
      call mpi_recv(zpoint(ja),npts,mpi_real8,
     &              0,77,mpi_comm_world,istat,ierr)
      call mpi_recv(wpoint(ja),npts,mpi_real8,
     &              0,77,mpi_comm_world,istat,ierr)

casa
c     if(isubsystem.gt.1) then
c                               call mpi_recv(xcpot(1,1),npts,
c    &                                        mpi_real8,0,77,
c    &                                        mpi_comm_world,istat,ierr)
c                               call mpi_recv(xcpot(1,2),npts,
c    &                                        mpi_real8,0,77,
c    &                                        mpi_comm_world,istat,ierr)
c                               call mpi_recv(xcnrg(1),npts,
c    &                                        mpi_real8,0,77,
c    &                                        mpi_comm_world,istat,ierr)
c                               goto 1038
c                         endif
casa

      if(nfunctional.eq.0) then

                    call compg0(iatom,ncontractions,npts,npoints,
     &                          ncenters,nconts,ncontp,ncontd,ilfunc,
     &                          icfunc,ngaussians,nshels,nshelp,nsheld,
     &                          radius,coord,alpha,coeff,xpoint(ja),
     &                          ypoint(ja),zpoint(ja),fv,extent1,
     &                          extent3,dcc,wkvec(00*npoints+1),
     &                          wkvec(01*npoints+1),wkvec(02*npoints+1),
     &                          wkvec(03*npoints+1),wkvec(04*npoints+1),
     &                          wkvec(05*npoints+1),wkvec(06*npoints+1),
     &                          wkvec(07*npoints+1),wkvec(08*npoints+1),
     &                          wkvec(09*npoints+1),wkvec(10*npoints+1),
     &                          wkvec(11*npoints+1))

                           endif

      if((nfunctional.eq.1).and.(ipart.eq.1)) then

                    call compg1(iatom,ncontractions,npts,npoints,
     &                          ncenters,nconts,ncontp,ncontd,ilfunc,
     &                          icfunc,ngaussians,nshels,nshelp,nsheld,
     &                          radius,coord,alpha,coeff,xpoint(ja),
     &                          ypoint(ja),zpoint(ja),fv,fvx,fvy,fvz,
     &                          extent1,extent3,dcc,wkvec(00*npoints+1),
     &                          wkvec(01*npoints+1),wkvec(02*npoints+1),
     &                          wkvec(03*npoints+1),wkvec(04*npoints+1),
     &                          wkvec(05*npoints+1),wkvec(06*npoints+1),
     &                          wkvec(07*npoints+1),wkvec(08*npoints+1),
     &                          wkvec(09*npoints+1),wkvec(10*npoints+1),
     &                          wkvec(11*npoints+1),wkvec(12*npoints+1),
     &                          wkvec(13*npoints+1),wkvec(14*npoints+1),
     &                          wkvec(15*npoints+1),wkvec(16*npoints+1),
     &                          wkvec(17*npoints+1),wkvec(18*npoints+1),
     &                          wkvec(19*npoints+1),wkvec(20*npoints+1),
     &                          wkvec(21*npoints+1),wkvec(22*npoints+1),
     &                          wkvec(23*npoints+1),wkvec(24*npoints+1))

                                              endif

      if((nfunctional.eq.1).and.(ipart.eq.0)) then

                    call compg2(iatom,ncontractions,npts,npoints,
     &                          ncenters,nconts,ncontp,ncontd,ilfunc,
     &                          icfunc,ngaussians,nshels,nshelp,nsheld,
     &                          radius,coord,alpha,coeff,xpoint(ja),
     &                          ypoint(ja),zpoint(ja),fv,fvx,fvy,fvz,
     &                          fvxx,fvxy,fvxz,fvyy,fvyz,fvzz,extent1,
     &                          extent3,dcc,wkvec(00*npoints+1),
     &                          wkvec(01*npoints+1),wkvec(02*npoints+1),
     &                          wkvec(03*npoints+1),wkvec(04*npoints+1),
     &                          wkvec(05*npoints+1),wkvec(06*npoints+1),
     &                          wkvec(07*npoints+1),wkvec(08*npoints+1),
     &                          wkvec(09*npoints+1),wkvec(10*npoints+1),
     &                          wkvec(11*npoints+1),wkvec(12*npoints+1),
     &                          wkvec(13*npoints+1),wkvec(14*npoints+1),
     &                          wkvec(15*npoints+1),wkvec(16*npoints+1),
     &                          wkvec(17*npoints+1),wkvec(18*npoints+1),
     &                          wkvec(19*npoints+1),wkvec(20*npoints+1),
     &                          wkvec(21*npoints+1),wkvec(22*npoints+1),
     &                          wkvec(23*npoints+1),wkvec(24*npoints+1),
     &                          wkvec(25*npoints+1),wkvec(26*npoints+1),
     &                          wkvec(27*npoints+1),wkvec(28*npoints+1),
     &                          wkvec(29*npoints+1),wkvec(30*npoints+1),
     &                          wkvec(31*npoints+1),wkvec(32*npoints+1),
     &                          wkvec(33*npoints+1),wkvec(34*npoints+1),
     &                          wkvec(35*npoints+1),wkvec(36*npoints+1),
     &                          wkvec(37*npoints+1),wkvec(38*npoints+1),
     &                          wkvec(39*npoints+1))

                                              endif

      do 1008 j=1,2
      do 1008 k=1,npts
 1008 dnsty(k,j)=zero

      if(nfunctional.gt.0) then
                                 do 1009 j=1,2
                                 do 1009 k=1,npts
                                 gradx(k,j)=zero
                                 grady(k,j)=zero
 1009                            gradz(k,j)=zero

                                 if(ipart.eq.0) then
                                                      do 1010 j=1,2
                                                      do 1010 k=1,npts
                                                      hssxx(k,j)=zero
                                                      hssxy(k,j)=zero
                                                      hssxz(k,j)=zero
                                                      hssyy(k,j)=zero
                                                      hssyz(k,j)=zero
 1010                                                 hsszz(k,j)=zero
                                                endif
                           endif

      ihits=0

      do 1011 i=1,ncontractions
      if(extent3(i).gt.tolerance) then
                                        ihits=ihits+1
                                        iwkvec(ihits)=i
                                  endif
 1011 continue

      do 1012 i=1,ihits
      ii=iwkvec(i)

      do 1013 k=1,npts
 1013 wf(k,ii)=zero

      if((nfunctional.gt.0).and.(ipart.eq.0)) then
                                                    do 1014 k=1,npts
                                                    wfx(k,ii)=zero
                                                    wfy(k,ii)=zero
 1014                                               wfz(k,ii)=zero
                                              endif

      do 1012 j=1,ihits
      jj=iwkvec(j)

      ijmax=max(ii,jj)
      ijmin=min(ii,jj)
      ij=(ijmax*(ijmax-1)/2)+ijmin

      if(ii.eq.jj) then
                         factor=amat(ij)*two
                   else
                         factor=amat(ij)
                   endif

      do 1015 k=1,npts
 1015 wf(k,ii)=wf(k,ii)+factor*fv(k,jj)

      if((nfunctional.gt.0).and.(ipart.eq.0)) then

                            do 1016 k=1,npts
                            wfx(k,ii)=wfx(k,ii)+factor*fvx(k,jj)
                            wfy(k,ii)=wfy(k,ii)+factor*fvy(k,jj)
 1016                       wfz(k,ii)=wfz(k,ii)+factor*fvz(k,jj)

                                              endif

 1012 continue
 
      do 1017 i=1,ihits
      ii=iwkvec(i)
      do 1017 k=1,npts
 1017 dnsty(k,1)=dnsty(k,1)+fv(k,ii)*wf(k,ii)

      do 1018 k=1,npts
 1018 dnsty(k,1)=dnsty(k,1)*half

      if(nfunctional.gt.0) then

           do 1019 i=1,ihits
           ii=iwkvec(i)
           do 1019 k=1,npts
           gradx(k,1)=gradx(k,1)+fvx(k,ii)*wf(k,ii)
           grady(k,1)=grady(k,1)+fvy(k,ii)*wf(k,ii)
 1019      gradz(k,1)=gradz(k,1)+fvz(k,ii)*wf(k,ii)

                           endif

      if((nfunctional.gt.0).and.(ipart.eq.0)) then

           do 1020 i=1,ihits
           ii=iwkvec(i)
           do 1020 k=1,npts
           hssxx(k,1)=hssxx(k,1)+fvxx(k,ii)*wf(k,ii)+fvx(k,ii)*wfx(k,ii)
           hssxy(k,1)=hssxy(k,1)+fvxy(k,ii)*wf(k,ii)+fvx(k,ii)*wfy(k,ii)
           hssxz(k,1)=hssxz(k,1)+fvxz(k,ii)*wf(k,ii)+fvx(k,ii)*wfz(k,ii)
           hssyy(k,1)=hssyy(k,1)+fvyy(k,ii)*wf(k,ii)+fvy(k,ii)*wfy(k,ii)
           hssyz(k,1)=hssyz(k,1)+fvyz(k,ii)*wf(k,ii)+fvy(k,ii)*wfz(k,ii)
 1020      hsszz(k,1)=hsszz(k,1)+fvzz(k,ii)*wf(k,ii)+fvz(k,ii)*wfz(k,ii)

                                              endif

      if(nalpha.eq.nbeta) then

         do 1021 k=1,npts
 1021    dnsty(k,2)=dnsty(k,1)

         if(nfunctional.gt.0) then
                                    do 1022 k=1,npts
                                    gradx(k,2)=gradx(k,1)
                                    grady(k,2)=grady(k,1)
 1022                               gradz(k,2)=gradz(k,1)

                                    if(ipart.eq.0) then

                                                  do 1023 k=1,npts
                                                  hssxx(k,2)=hssxx(k,1)
                                                  hssxy(k,2)=hssxy(k,1)
                                                  hssxz(k,2)=hssxz(k,1)
                                                  hssyy(k,2)=hssyy(k,1)
                                                  hssyz(k,2)=hssyz(k,1)
 1023                                             hsszz(k,2)=hsszz(k,1)

                                                   endif
                              endif

         goto 1033

                          endif

      do 1024 i=1,ihits
      ii=iwkvec(i)

      do 1025 k=1,npts
 1025 wf(k,ii)=zero

      if((nfunctional.gt.0).and.(ipart.eq.0)) then
                                                    do 1026 k=1,npts
                                                    wfx(k,ii)=zero
                                                    wfy(k,ii)=zero
 1026                                               wfz(k,ii)=zero
                                              endif

      do 1024 j=1,ihits
      jj=iwkvec(j)

      ijmax=max(ii,jj)
      ijmin=min(ii,jj)
      ij=(ijmax*(ijmax-1)/2)+ijmin

      if(ii.eq.jj) then
                         factor=bmat(ij)*two
                   else
                         factor=bmat(ij)
                   endif

      do 1027 k=1,npts
 1027 wf(k,ii)=wf(k,ii)+factor*fv(k,jj)

      if((nfunctional.gt.0).and.(ipart.eq.0)) then

                            do 1028 k=1,npts
                            wfx(k,ii)=wfx(k,ii)+factor*fvx(k,jj)
                            wfy(k,ii)=wfy(k,ii)+factor*fvy(k,jj)
 1028                       wfz(k,ii)=wfz(k,ii)+factor*fvz(k,jj)

                                              endif

 1024 continue

      do 1029 i=1,ihits
      ii=iwkvec(i)
      do 1029 k=1,npts
 1029 dnsty(k,2)=dnsty(k,2)+fv(k,ii)*wf(k,ii)

      do 1030 k=1,npts
 1030 dnsty(k,2)=dnsty(k,2)*half

      if(nfunctional.gt.0) then

           do 1031 i=1,ihits
           ii=iwkvec(i)
           do 1031 k=1,npts
           gradx(k,2)=gradx(k,2)+fvx(k,ii)*wf(k,ii)
           grady(k,2)=grady(k,2)+fvy(k,ii)*wf(k,ii)
 1031      gradz(k,2)=gradz(k,2)+fvz(k,ii)*wf(k,ii)

                           endif

      if((nfunctional.gt.0).and.(ipart.eq.0)) then

           do 1032 i=1,ihits
           ii=iwkvec(i)
           do 1032 k=1,npts
           hssxx(k,2)=hssxx(k,2)+fvxx(k,ii)*wf(k,ii)+fvx(k,ii)*wfx(k,ii)
           hssxy(k,2)=hssxy(k,2)+fvxy(k,ii)*wf(k,ii)+fvx(k,ii)*wfy(k,ii)
           hssxz(k,2)=hssxz(k,2)+fvxz(k,ii)*wf(k,ii)+fvx(k,ii)*wfz(k,ii)
           hssyy(k,2)=hssyy(k,2)+fvyy(k,ii)*wf(k,ii)+fvy(k,ii)*wfy(k,ii)
           hssyz(k,2)=hssyz(k,2)+fvyz(k,ii)*wf(k,ii)+fvy(k,ii)*wfz(k,ii)
 1032      hsszz(k,2)=hsszz(k,2)+fvzz(k,ii)*wf(k,ii)+fvz(k,ii)*wfz(k,ii)

                                              endif

 1033 continue

      call addvecs(npts,dnsty(1,3),dnsty(1,1),dnsty(1,2))

      if(nfunctional.gt.0) then

                     call addvecs(npts,gradx(1,3),gradx(1,1),gradx(1,2))
                     call addvecs(npts,grady(1,3),grady(1,1),grady(1,2))
                     call addvecs(npts,gradz(1,3),gradz(1,1),gradz(1,2))

                           endif

      if((nfunctional.gt.0).and.(ipart.eq.0)) then

                     call addvecs(npts,hssxx(1,3),hssxx(1,1),hssxx(1,2))
                     call addvecs(npts,hssxy(1,3),hssxy(1,1),hssxy(1,2))
                     call addvecs(npts,hssxz(1,3),hssxz(1,1),hssxz(1,2))
                     call addvecs(npts,hssyy(1,3),hssyy(1,1),hssyy(1,2))
                     call addvecs(npts,hssyz(1,3),hssyz(1,1),hssyz(1,2))
                     call addvecs(npts,hsszz(1,3),hsszz(1,1),hsszz(1,2))

                                              endif

      do 1034 i=1,npts

      call xcfunctional(nfunctional,ixcfit,igrad,
     &                  dnsty(i,1),dnsty(i,2),dnsty(i,3),
     &                  gradx(i,1),grady(i,1),gradz(i,1),
     &                  gradx(i,2),grady(i,2),gradz(i,2),
     &                  gradx(i,3),grady(i,3),gradz(i,3),
     &                  hssxx(i,1),hssxy(i,1),hssxz(i,1),
     &                  hssyy(i,1),hssyz(i,1),hsszz(i,1),
     &                  hssxx(i,2),hssxy(i,2),hssxz(i,2),
     &                  hssyy(i,2),hssyz(i,2),hsszz(i,2),
     &                  hssxx(i,3),hssxy(i,3),hssxz(i,3),
     &                  hssyy(i,3),hssyz(i,3),hsszz(i,3),
     &                  xcnrg(i),xcpot(i,1),xcpot(i,2))

      if((nfunctional.gt.0).and.(ipart.eq.1)) then

          call xc_partial(nfunctional,xcnrg(i),xcpot(i,1),xcpot(i,2),
     &                    dnsty(i,1),dnsty(i,2),dnsty(i,3),
     &                    gradx(i,1),grady(i,1),gradz(i,1),
     &                    gradx(i,2),grady(i,2),gradz(i,2),
     &                    gradx(i,3),grady(i,3),gradz(i,3),
     &                    hssyy(i,3),hssyz(i,3),hsszz(i,3))

                                              endif

 1034 continue

      if((ixcfit.eq.0).and.(igrad.eq.0)) goto 1041

casa
c     if(igrad.eq.0) then

c                 do 1035 i=1,ncenters
c                 wkvec(i)=zero
c1035             if((dcc(i,iatom)-radius).le.extent4(i)) wkvec(i)=two

c                 do 1036 i=1,npts
c                 call partition1(ncenters,natomtype,xpoint(ja+i-1),
c    &                            ypoint(ja+i-1),zpoint(ja+i-1),wkvec,
c    &                            wkvec(ncenters+1),coord,
c    &                            weight_adjustment)

c                 xcpot(i,1)=xcpot(i,1)*weight_adjustment
c                 xcpot(i,2)=xcpot(i,2)*weight_adjustment

c1036             xcnrg(i)=xcnrg(i)*weight_adjustment

c                 call mpi_bsend(npts,1,
c    &                           mpi_integer,0,66,mpi_comm_world,ierr)

c                 call mpi_bsend(xcpot(1,1),npts,
c    &                           mpi_real8,0,66,mpi_comm_world,ierr)
c                 call mpi_bsend(xcpot(1,2),npts,
c    &                           mpi_real8,0,66,mpi_comm_world,ierr)
c                 call mpi_bsend(xcnrg(1),npts,
c    &                           mpi_real8,0,66,mpi_comm_world,ierr)

c                    endif

c     if((igrad.eq.0).and.(myid.eq.0)) then

c             do 1037 i=0,last_slave

c             call mpi_recv(nloop,1,
c    &                      mpi_integer,i,66,mpi_comm_world,istat,ierr)

c             call mpi_recv(wkvec(0*nloop+1),nloop,
c    &                      mpi_real8,i,66,mpi_comm_world,istat,ierr)
c             call mpi_recv(wkvec(1*nloop+1),nloop,
c    &                      mpi_real8,i,66,mpi_comm_world,istat,ierr)
c             call mpi_recv(wkvec(2*nloop+1),nloop,
c    &                      mpi_real8,i,66,mpi_comm_world,istat,ierr)

c             call fastwr(12,wkvec(0*nloop+1),nloop)
c             call fastwr(12,wkvec(1*nloop+1),nloop)
c             call fastwr(12,wkvec(2*nloop+1),nloop)

c1037         continue

c                                      endif

c1038 continue
casa

      if(igrad.eq.1) then
                           iwkvec(1)=ja
                           iwkvec(2)=npts
                           iwkvec(3)=myid

                           call mpi_bsend(iwkvec,3,mpi_integer,
     &                                    0,88,mpi_comm_world,ierr)

                           call mpi_bsend(xcpot(1,1),npts,mpi_real8,
     &                                    0,88,mpi_comm_world,ierr)
                           call mpi_bsend(xcpot(1,2),npts,mpi_real8,
     &                                    0,88,mpi_comm_world,ierr)
                           call mpi_bsend(xcnrg(1),npts,mpi_real8,
     &                                    0,88,mpi_comm_world,ierr)

                           goto 1074
casa
c                    else
c                          jhits=0

c                          do 1039 i=1,ncenters
c                          if(isys(i).eq.1) then

c                                 jhits=jhits+1
c                                 iwkvec(jhits)=i
c                                 distance=dcc(i,iatom)-radius
c                                 if(distance.le.extent4(i)) then

c                                                      wkvec(jhits)=two

c                                                            else

c                                                      wkvec(jhits)=zero

c                                                            endif

c                                             endif
c1039                      continue

c                          do 1040 i=1,npts
c                          call partition2(jhits,iwkvec,natomtype,
c    &                                     xpoint(ja+i-1),
c    &                                     ypoint(ja+i-1),
c    &                                     zpoint(ja+i-1),wkvec,
c    &                                     wkvec(ncenters+1),coord,
c    &                                     weight_adjustment)

c                          xcpot(i,1)=xcpot(i,1)*weight_adjustment
c                          xcpot(i,2)=xcpot(i,2)*weight_adjustment

c1040                      xcnrg(i)=xcnrg(i)*weight_adjustment
casaa
                     endif

 1041 continue

      jstart=ja-1

casa
c     if(ixcfit.eq.1) then
c                           do 1042 k=1,npts
c                           call weights(natomtype(iatom),
c    &                                   xpoint(jstart+k),
c    &                                   ypoint(jstart+k),
c    &                                   zpoint(jstart+k),
c    &                                   coord(1,iatom),adjust)
c1042                       wpoint(jstart+k)=wpoint(jstart+k)*adjust
c                     endif
casa

      do 1043 k=1,npts
      xcpot(k,1)=xcpot(k,1)*wpoint(jstart+k)
      xcpot(k,2)=xcpot(k,2)*wpoint(jstart+k)
 1043 xcnrg(k)=xcnrg(k)*wpoint(jstart+k)

      if(ixcfit.eq.0) then

             if(ipart.eq.1) then

                        do 1044 k=1,npts
                        hssyy(k,3)=hssyy(k,3)*wpoint(jstart+k)*two
                        hssyz(k,3)=hssyz(k,3)*wpoint(jstart+k)*two
 1044                   hsszz(k,3)=hsszz(k,3)*wpoint(jstart+k)

                        do 1045 k=1,npts
                        hssyy(k,1)=hssyy(k,3)*gradx(k,1)
                        hssyy(k,2)=hssyy(k,3)*grady(k,1)
 1045                   hssyy(k,3)=hssyy(k,3)*gradz(k,1)

                        do 1046 k=1,npts
                        hssyz(k,1)=hssyz(k,3)*gradx(k,2)
                        hssyz(k,2)=hssyz(k,3)*grady(k,2)
 1046                   hssyz(k,3)=hssyz(k,3)*gradz(k,2)

                        do 1047 k=1,npts
                        gradx(k,1)=hsszz(k,3)*gradx(k,1)
                        grady(k,1)=hsszz(k,3)*grady(k,1)
                        gradz(k,1)=hsszz(k,3)*gradz(k,1)
                        gradx(k,2)=hsszz(k,3)*gradx(k,2)
                        grady(k,2)=hsszz(k,3)*grady(k,2)
 1047                   gradz(k,2)=hsszz(k,3)*gradz(k,2)

                            endif

             ka=00*npts
             kb=01*npts
             kc=02*npts
             kd=03*npts
             ke=04*npts
             kf=05*npts
             kg=06*npts
             kh=07*npts
             ki=08*npts
             kj=09*npts
             kk=10*npts
             kl=11*npts
             km=12*npts
             kn=13*npts
             ko=14*npts
             kp=15*npts
             kq=16*npts
             kr=17*npts
             la=18*npts
             lb=19*npts
             lc=20*npts
             ld=21*npts
             le=22*npts
             lf=23*npts
             lg=24*npts
             lh=25*npts
             li=26*npts
             lj=27*npts
             lk=28*npts
             ll=29*npts

             ihits=0

             do 1048 i=1,ncontractions
             if(extent3(i).gt.tolerance) then

                        ihits=ihits+1
                        iwkvec(ihits)=i

                        ii=i*(i-1)/2

                        do 1049 k=1,npts
                        wkvec(ka+k)=fv(k,i)*xcpot(k,1)
                        wkvec(kb+k)=fv(k,i)*xcpot(k,2)
 1049                   wkvec(kc+k)=fv(k,i)*xcnrg(k)

                        if(nfunctional.eq.1) then

                                       do 1050 k=1,npts
                                       wkvec(kg+k)=fv(k,i)*hssyy(k,1)
                                       wkvec(kh+k)=fv(k,i)*hssyy(k,2)
                                       wkvec(ki+k)=fv(k,i)*hssyy(k,3)
                                       wkvec(kj+k)=fv(k,i)*hssyz(k,1)
                                       wkvec(kk+k)=fv(k,i)*hssyz(k,2)
                                       wkvec(kl+k)=fv(k,i)*hssyz(k,3)
                                       wkvec(km+k)=fvx(k,i)*hssyy(k,1)
                                       wkvec(kn+k)=fvy(k,i)*hssyy(k,2)
                                       wkvec(ko+k)=fvz(k,i)*hssyy(k,3)
                                       wkvec(kp+k)=fvx(k,i)*hssyz(k,1)
                                       wkvec(kq+k)=fvy(k,i)*hssyz(k,2)
                                       wkvec(kr+k)=fvz(k,i)*hssyz(k,3)
                                       wkvec(la+k)=fv(k,i)*gradx(k,2)
                                       wkvec(lb+k)=fv(k,i)*grady(k,2)
                                       wkvec(lc+k)=fv(k,i)*gradz(k,2)
                                       wkvec(ld+k)=fv(k,i)*gradx(k,1)
                                       wkvec(le+k)=fv(k,i)*grady(k,1)
                                       wkvec(lf+k)=fv(k,i)*gradz(k,1)
                                       wkvec(lg+k)=fvx(k,i)*gradx(k,2)
                                       wkvec(lh+k)=fvy(k,i)*grady(k,2)
                                       wkvec(li+k)=fvz(k,i)*gradz(k,2)
                                       wkvec(lj+k)=fvx(k,i)*gradx(k,1)
                                       wkvec(lk+k)=fvy(k,i)*grady(k,1)
 1050                                  wkvec(ll+k)=fvz(k,i)*gradz(k,1)

                                       do 1051 k=1,npts
                                       wkvec(km+k)=wkvec(km+k)
     &                                            +wkvec(kn+k)
     &                                            +wkvec(ko+k)
     &                                            +wkvec(lg+k)
     &                                            +wkvec(lh+k)
     &                                            +wkvec(li+k)
 1051                                  wkvec(kp+k)=wkvec(kp+k)
     &                                            +wkvec(kq+k)
     &                                            +wkvec(kr+k)
     &                                            +wkvec(lj+k)
     &                                            +wkvec(lk+k)
     &                                            +wkvec(ll+k)

                                       do 1052 k=1,npts
                                       wkvec(ke+k)=wkvec(km+k)
                                       wkvec(kf+k)=wkvec(kp+k)
                                       wkvec(kg+k)=wkvec(kg+k)
     &                                            +wkvec(la+k)
                                       wkvec(kh+k)=wkvec(kh+k)
     &                                            +wkvec(lb+k)
                                       wkvec(ki+k)=wkvec(ki+k)
     &                                            +wkvec(lc+k)
                                       wkvec(kj+k)=wkvec(kj+k)
     &                                            +wkvec(ld+k)
                                       wkvec(kk+k)=wkvec(kk+k)
     &                                            +wkvec(le+k)
 1052                                  wkvec(kl+k)=wkvec(kl+k)
     &                                            +wkvec(lf+k)

                                       do 1053 k=1,npts
                                       wkvec(ka+k)=wkvec(ka+k)
     &                                            +wkvec(ke+k)
 1053                                  wkvec(kb+k)=wkvec(kb+k)
     &                                            +wkvec(kf+k)

                                             endif

                       do 1054 j=1,ihits
                       jj=iwkvec(j)

                       if(extent3(i)*extent3(jj).lt.tolerance) goto 1054

                       ij=ii+jj

                       do 1055 k=1,npts
 1055                  focke(ij)=focke(ij)+fv(k,jj)*wkvec(kc+k)
                       do 1056 k=1,npts
 1056                  focka(ij)=focka(ij)+fv(k,jj)*wkvec(ka+k)
                       do 1057 k=1,npts
 1057                  fockb(ij)=fockb(ij)+fv(k,jj)*wkvec(kb+k)

                       if(nfunctional.eq.1) then

                               do 1058 k=1,npts
 1058                          focka(ij)=focka(ij)+fvx(k,jj)*wkvec(kg+k)
     &                                            +fvy(k,jj)*wkvec(kh+k)
     &                                            +fvz(k,jj)*wkvec(ki+k)
                               do 1059 k=1,npts
 1059                          fockb(ij)=fockb(ij)+fvx(k,jj)*wkvec(kj+k)
     &                                            +fvy(k,jj)*wkvec(kk+k)
     &                                            +fvz(k,jj)*wkvec(kl+k)

                                            endif

 1054                  continue

                                         endif
 1048        continue

                      endif

casa
c     if(ixcfit.eq.1) then

c             call gridxc(iatom,ncenters,npts,npoints,nxcfunctions,nxcs,
c    &                    nxcspd,ixclfunc,ixccfunc,radius,coord,alphaxc,
c    &                    coefsxc,coefpxc,coefdxc,xpoint(ja),ypoint(ja),
c    &                    zpoint(ja),fvx,extent2,extent,dcc,
c    &                    wkvec(0*npoints+1),wkvec(1*npoints+1),
c    &                    wkvec(2*npoints+1),wkvec(3*npoints+1),
c    &                    wkvec(4*npoints+1))

c             dlargest=dmaxvec(wpoint(ja),npts)

c             if(iteration.eq.1) then

c                         call sxcbld(ilast,nauxfunctions,npoints,
c    &                                nxcfunctions,npts,iwkvec,dlargest,
c    &                                tolerance,auxoverlap,extent,fvx,
c    &                                fvy,wpoint(ja),wkvec)

c                                endif

c             kstart=(nxcfunctions*(nxcfunctions+1))/2

c             do 1060 k=1,npts
c             if(dnsty(k,3).gt.small) then

c                      xcpot(k,1)=(xcpot(k,1)-xcnrg(k))/dnsty(k,3)
c                      xcpot(k,2)=(xcpot(k,2)-xcnrg(k))/dnsty(k,3)

c                                     else

c                      xcpot(k,1)=zero
c                      xcpot(k,2)=zero

c                                     endif
c1060         continue

c             do 1061 k=1,npts
c1061         wkvec(kstart+k)=zero

c             do 1062 i=1,nxcfunctions
c             if(extent(i).gt.tolerance) then

c                      do 1063 k=1,npts
c1063                  wkvec(kstart+k)=wkvec(kstart+k)+tvecb(i)*fvx(k,i)

c                                        endif
c1062         continue

c             ka=1*npts+kstart
c             kb=2*npts+kstart

c             do 1064 k=1,npts
c1064         wkvec(ka+k)=wkvec(kstart+k)*xcpot(k,1)
c             do 1065 k=1,npts
c1065         wkvec(kb+k)=wkvec(kstart+k)*xcpot(k,2)

c             ihits=0

c             do 1066 i=1,ncontractions
c             if(extent3(i).gt.tolerance) then

c                      ihits=ihits+1
c                      iwkvec(ihits)=i

c                      ii=i*(i-1)/2

c                      kc=3*npts+kstart
c                      kd=4*npts+kstart

c                      do 1067 k=1,npts
c1067                  wkvec(kc+k)=fv(k,i)*wkvec(ka+k)
c                      do 1068 k=1,npts
c1068                  wkvec(kd+k)=fv(k,i)*wkvec(kb+k)

c                      do 1069 j=1,ihits
c                      jj=iwkvec(j)
c                      if(extent3(i)*extent3(jj).lt.tolerance) goto 1069
c                      ij=ii+jj
c                      do 1070 k=1,npts
c1070                  focka(ij)=focka(ij)+fv(k,jj)*wkvec(kc+k)
c                      do 1071 k=1,npts
c1071                  fockb(ij)=fockb(ij)+fv(k,jj)*wkvec(kd+k)
c1069                  continue

c                                         endif
c1066 continue
c             
c                     endif

c     do 1072 i=1,nxcfunctions
c     if(extent(i)*dlargest.gt.tolerance) then

c                            do 1073 k=1,npts
c1073                        tvece(i)=tvece(i)+fvx(k,i)*xcnrg(k)

c                                         endif
c1072 continue
casa

 1074 continue

      if((myid.eq.0).and.(igrad.eq.1)) then

              do 1075 i=1,last_slave+1

              call mpi_recv(iwkvec,3,mpi_integer,
     &                      mpi_any_source,88,mpi_comm_world,istat,ierr)

              ja=iwkvec(1)
              npts=iwkvec(2)
              islave=iwkvec(3)

              call mpi_recv(xpoint(ja),npts,mpi_real8,
     &                      islave,88,mpi_comm_world,istat,ierr)
              call mpi_recv(ypoint(ja),npts,mpi_real8,
     &                      islave,88,mpi_comm_world,istat,ierr)
              call mpi_recv(zpoint(ja),npts,mpi_real8,
     &                      islave,88,mpi_comm_world,istat,ierr)

 1075         continue

                                       endif

 1005 continue

      if((myid.eq.0).and.(igrad.eq.1)) then

                                call fastwr(12,xpoint,nptsatom(iatom))
                                call fastwr(12,ypoint,nptsatom(iatom))
                                call fastwr(12,zpoint,nptsatom(iatom))

                                       endif

 1004 continue

casa
c     if(ixcfit.eq.1) then

c             if(iteration.eq.1) then

c                     na=nxcfunctions*(nxcfunctions+1)/2
c
c                     call mpi_reduce(wkvec(1),wkvec(1+na),na,mpi_real8,
c    &                                mpi_sum,0,mpi_comm_world,ierr)
c             
c                     if(myid.eq.0) call overlpcopy(nauxfunctions,
c    &                                              nxcfunctions,
c    &                                              wkvec(na+1),
c    &                                              auxoverlap)

c                                endif

c             call mpi_reduce(tvece,wkvec,nxcfunctions,
c    &                        mpi_real8,mpi_sum,0,mpi_comm_world,ierr)
c
c             if(myid.eq.0) call stringcopy(nxcfunctions,tvece,wkvec)
c
c             call mpi_bcast(tvece,nxcfunctions,
c    &                       mpi_real8,0,mpi_comm_world,ierr)

c                     endif
casa

      nfunctional=nsavefunctional

      return
      end

      subroutine gtxccf(bve,tve,s,n,ndim)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension bve(*),tve(*),s(ndim,*)

      data zero/0.0d0/

      do 1001 i=1,n
 1001 call fastrd(19,s(1,i),n)

      do 1002 i=1,n
 1002 bve(i)=zero

      do 1003 j=1,n
      do 1003 i=1,n
 1003 bve(i)=bve(i)+s(i,j)*tve(j)

      return
      end

      subroutine becke_partial(dnstya,dnstyb,gmoda,gmodb,bval,
     &                         dbdrhoa,dbdrhob,dbdgama,dbdgamb)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      data tol,beta/1.0d-15,0.0042d0/
      data zero,one,two/0.0d0,1.0d0,2.0d0/
      data three,four,six/3.0d0,4.0d0,6.0d0/
      data third,fourthirds/0.33333333333333d0,1.33333333333333d0/
      data pi/3.1415926535898d0/

      if(dnstya.gt.tol) then
                              xa=gmoda/(dnstya**fourthirds)
                        else
                              xa=zero
                        endif

      if(dnstyb.gt.tol) then
                              xb=gmodb/(dnstyb**fourthirds)
                        else
                              xb=zero
                        endif

      sinhxa=log(xa+sqrt(xa*xa+one))
      sinhxb=log(xb+sqrt(xb*xb+one))

      gxa=(-three/two)*((three/(four*pi))**third)
      gxb=(-three/two)*((three/(four*pi))**third)

      factora=one+six*beta*xa*sinhxa
      factorb=one+six*beta*xb*sinhxb

      gxa=gxa-beta*xa*xa/factora
      gxb=gxb-beta*xb*xb/factorb

      temp=((dnstya**fourthirds)*gxa)+((dnstyb**fourthirds)*gxb)

      if((dnstya+dnstyb).gt.tol) then
                                       temp=temp/(dnstya+dnstyb)
                                 else
                                       temp=zero
                                 endif

      bval=bval+temp

      topa=six*beta*beta*xa*xa*((xa/sqrt(xa*xa+one))-sinhxa)-two*beta*xa
      topb=six*beta*beta*xb*xb*((xb/sqrt(xb*xb+one))-sinhxb)-two*beta*xb

      dgdxa=topa/(factora*factora)
      dgdxb=topb/(factorb*factorb)

      dbdrhoa=dbdrhoa+(four/three)*(dnstya**third)*(gxa-xa*dgdxa)
      dbdrhob=dbdrhob+(four/three)*(dnstyb**third)*(gxb-xb*dgdxb)

      if(abs(gmoda).gt.tol) dbdgama=dbdgama+(one/two)*(one/gmoda)*dgdxa
      if(abs(gmodb).gt.tol) dbdgamb=dbdgamb+(one/two)*(one/gmodb)*dgdxb

      return
      end

      function dimp(coord1,coord2,coord3,coord4)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension vec42(3),vec43(3),vec41(3),vec(3)

      dimension coord1(*),coord2(*),coord3(*),coord4(*)

      data one/1.0d0/

      phi_1=dang(coord2,coord4,coord3)

      call unitvec(vec42,coord4,coord2)
      call unitvec(vec43,coord4,coord3)
      call unitvec(vec41,coord4,coord1)

      call crossprod(vec,vec42,vec43)

      sin_dimp=(dot(3,vec,vec41))/(sin(phi_1))

      if(sin_dimp.ge.+one) sin_dimp=+one
      if(sin_dimp.le.-one) sin_dimp=-one

      dimp=asin(sin_dimp)

      return
      end

      subroutine gridgrad(iatom,npoints,nmaxpts,ncenters,nconts,ncontp,
     &                    ncontd,ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,
     &                    natomtype,istore,iwkvec,cent,alpha,coeff,
     &                    wtbecke,extent,dcp,dcc,tmat,drvtv,x,y,z,
     &                    weight)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension natomtype(*),istore(*),iwkvec(*)

      dimension cent(3,*),alpha(*),coeff(*)

      dimension wtbecke(*),extent(*),dcp(*),dcc(ncenters,*)
      dimension tmat(ncenters,*),drvtv(nmaxpts,*)
      dimension x(*),y(*),z(*),weight(*)

      data zero,half,one,two,four,five/0.0d0,0.5d0,1.0d0,
     &                                 2.0d0,4.0d0,5.0d0/
      data sixteen,twentyone,thirtyfive,one_o_5/16.0d0,21.0d0,
     &                                          35.0d0,105.0d0/
      data tolerance,tol,bohr/0.0000000001d0,0.000001d0,0.529177d0/
      data afactor,pi/0.64d0,3.1415926535898d0/
      data alpha1,alpha2,alpha3/0.40d0,1.20d0,2.00d0/

      do 1001 i=1,ncenters
 1001 iwkvec(i)=0

      do 1002 j=1,3*ncenters
      do 1002 i=1,npoints
 1002 drvtv(i,j)=zero

      call diffuse1(ncenters,nconts,ncontp,ncontd,ilfunc,icfunc,ngauss,
     &              nptrs,nptrp,nptrd,tolerance,alpha,coeff,cent,extent)

      do 1003 katom=1,ncenters
      do 1003 jatom=1,ncenters
 1003 dcc(jatom,katom)=dist(cent(1,jatom),cent(1,katom))

      smallest=one/tolerance

      do 1004 jatom=1,ncenters
      if((jatom.eq.iatom).or.(natomtype(jatom).eq.0)) goto 1004
      if(dcc(iatom,jatom).le.smallest) smallest=dcc(iatom,jatom)
 1004 continue

      smallest=smallest*(one-afactor)*half

      do 1005 ipoint=1,npoints

      do 1006 icenter=1,ncenters
 1006 wtbecke(icenter)=zero

      dcp(iatom)=sqrt((cent(1,iatom)-x(ipoint))**2
     &                 +(cent(2,iatom)-y(ipoint))**2
     &                 +(cent(3,iatom)-z(ipoint))**2)

      if(dcp(iatom).lt.smallest) goto 1005

      ihits=0

      do 1007 icenter=1,ncenters
      rr=(cent(1,icenter)-x(ipoint))**2
     &  +(cent(2,icenter)-y(ipoint))**2
     &  +(cent(3,icenter)-z(ipoint))**2
      if((rr.le.extent(icenter)).and.(natomtype(icenter).ne.0)) then

                                 ihits=ihits+1
                                 istore(ihits+1)=icenter
                                 dcp(icenter)=sqrt(rr)

                                                                endif
 1007 continue

      if(ihits.eq.1) goto 1005

      istore(1)=ihits

      do 1008 icenter=1,ihits
      jcenter=istore(icenter+1)

      iwkvec(jcenter)=1
      iwkvec(iatom)=1

      partition=one

      do 1009 kcenter=1,ihits
      lcenter=istore(kcenter+1)
      if(lcenter.eq.jcenter) goto 1009

      u=(dcp(jcenter)-dcp(lcenter))/dcc(jcenter,lcenter)

      if(abs(u).lt.afactor) then
                                  zz=(thirtyfive*(u/afactor)
     &                               -thirtyfive*(u/afactor)**3
     &                               +twentyone*(u/afactor)**5
     &                               -five*(u/afactor)**7)/sixteen
                            else
                                  if(u.le.(-afactor)) zz=-one
                                  if(u.ge.(+afactor)) zz=+one
                            endif

      s=half*(one-zz)

      if(abs(u).gt.afactor) then

         tmat(jcenter,lcenter)=zero

                            else

         if(s.gt.tol) then

              tmat(jcenter,lcenter)=(half/s)
     &                             *(-one/sixteen)
     &                             *((thirtyfive/afactor)
     &                              -((one_o_5*(u**2))/(afactor**3))
     &                              +((one_o_5*(u**4))/(afactor**5))
     &                              -((thirtyfive*(u**6))/(afactor**7)))

                      else

              tmat(jcenter,lcenter)=zero

                      endif

                            endif

      partition=partition*s

 1009 continue

      wtbecke(jcenter)=partition

 1008 continue

      totalwtbecke=zero

      do 1010 icenter=1,ihits
      jcenter=istore(icenter+1)
 1010 totalwtbecke=totalwtbecke+wtbecke(jcenter)

      do 1011 icenter=1,ihits
      jcenter=istore(icenter+1)
      if(jcenter.eq.iatom) goto 1011

      jj=3*(jcenter-1)

      factor1=-(one/dcc(iatom,jcenter))/dcp(jcenter)
      factor2=(dcp(iatom)-dcp(jcenter))/(dcc(iatom,jcenter)**3)

      duabx=factor1*(cent(1,jcenter)-x(ipoint))
     &     +factor2*(cent(1,iatom)-cent(1,jcenter))
      duaby=factor1*(cent(2,jcenter)-y(ipoint))
     &     +factor2*(cent(2,iatom)-cent(2,jcenter))
      duabz=factor1*(cent(3,jcenter)-z(ipoint))
     &     +factor2*(cent(3,iatom)-cent(3,jcenter))

      factor=wtbecke(iatom)*tmat(iatom,jcenter)/totalwtbecke

      drvtv(ipoint,jj+1)=drvtv(ipoint,jj+1)+factor*duabx
      drvtv(ipoint,jj+2)=drvtv(ipoint,jj+2)+factor*duaby
      drvtv(ipoint,jj+3)=drvtv(ipoint,jj+3)+factor*duabz

      do 1012 kcenter=1,ihits
      lcenter=istore(kcenter+1)
      if(lcenter.eq.jcenter) goto 1012

      jj=3*(jcenter-1)

      factor1=-(one/dcc(lcenter,jcenter))/dcp(jcenter)
      factor2=(dcp(lcenter)-dcp(jcenter))/(dcc(lcenter,jcenter)**3)

      ducbx=factor1*(cent(1,jcenter)-x(ipoint))
     &     +factor2*(cent(1,lcenter)-cent(1,jcenter))
      ducby=factor1*(cent(2,jcenter)-y(ipoint))
     &     +factor2*(cent(2,lcenter)-cent(2,jcenter))
      ducbz=factor1*(cent(3,jcenter)-z(ipoint))
     &     +factor2*(cent(3,lcenter)-cent(3,jcenter))

      factor=wtbecke(iatom)*wtbecke(lcenter)
     &      *tmat(lcenter,jcenter)/(totalwtbecke**2)

      drvtv(ipoint,jj+1)=drvtv(ipoint,jj+1)-factor*ducbx
      drvtv(ipoint,jj+2)=drvtv(ipoint,jj+2)-factor*ducby
      drvtv(ipoint,jj+3)=drvtv(ipoint,jj+3)-factor*ducbz

 1012 continue

      do 1013 kcenter=1,ihits
      lcenter=istore(kcenter+1)
      if(lcenter.eq.jcenter) goto 1013

      jj=3*(jcenter-1)

      factor1=-(one/dcc(jcenter,lcenter))/dcp(lcenter)
      factor2=(dcp(jcenter)-dcp(lcenter))/(dcc(jcenter,lcenter)**3)

      dubcx=factor1*(cent(1,lcenter)-x(ipoint))
     &     +factor2*(cent(1,jcenter)-cent(1,lcenter))
      dubcy=factor1*(cent(2,lcenter)-y(ipoint))
     &     +factor2*(cent(2,jcenter)-cent(2,lcenter))
      dubcz=factor1*(cent(3,lcenter)-z(ipoint))
     &     +factor2*(cent(3,jcenter)-cent(3,lcenter))

      factor=wtbecke(iatom)*wtbecke(jcenter)
     &      *tmat(jcenter,lcenter)/(totalwtbecke**2)

      drvtv(ipoint,jj+1)=drvtv(ipoint,jj+1)+factor*dubcx
      drvtv(ipoint,jj+2)=drvtv(ipoint,jj+2)+factor*dubcy
      drvtv(ipoint,jj+3)=drvtv(ipoint,jj+3)+factor*dubcz

 1013 continue

 1011 continue

      do 1014 j=1,3
      jj=3*(iatom-1)+j
      do 1014 icenter=1,ihits
      jcenter=istore(icenter+1)
      if(jcenter.eq.iatom) goto 1014
      kk=3*(jcenter-1)+j
      drvtv(ipoint,jj)=drvtv(ipoint,jj)-drvtv(ipoint,kk)
 1014 continue

      wght_adjust=zero

      if(wtbecke(iatom).gt.tol) wght_adjust=weight(ipoint)*totalwtbecke
     &                                     /wtbecke(iatom)

      do 1015 icenter=1,ihits
      jcenter=istore(icenter+1)
      do 1015 j=1,3
      jj=3*(jcenter-1)+j
 1015 drvtv(ipoint,jj)=drvtv(ipoint,jj)*wght_adjust

 1005 continue

      return
      end

      subroutine normd(nconts,ncontp,ncontd,nshels,nshelp,nsheld,mtloca,
     &                 wkvec)

c  this subroutine written by alain st-amant and sor koon goh of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*)

      dimension wkvec(*)

      data three/3.0d0/

      sqrt3=sqrt(three)

      do 1001 i=1,ncontd
      do 1001 j=1,nconts

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      wkvec(i4)=wkvec(i4)/sqrt3
      wkvec(i4+i1*3+3)=wkvec(i4+i1*3+3)/sqrt3
      wkvec(i4+i1*5+10)=wkvec(i4+i1*5+10)/sqrt3

 1001 continue

      do 1002 i=1,ncontd
      do 1002 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      wkvec(i4)=wkvec(i4)/sqrt3
      wkvec(i4+1)=wkvec(i4+1)/sqrt3
      wkvec(i4+2)=wkvec(i4+2)/sqrt3

      wkvec(i4+i1*3+3)=wkvec(i4+i1*3+3)/sqrt3
      wkvec(i4+i1*3+4)=wkvec(i4+i1*3+4)/sqrt3
      wkvec(i4+i1*3+5)=wkvec(i4+i1*3+5)/sqrt3

      wkvec(i4+i1*5+10)=wkvec(i4+i1*5+10)/sqrt3
      wkvec(i4+i1*5+11)=wkvec(i4+i1*5+11)/sqrt3
      wkvec(i4+i1*5+12)=wkvec(i4+i1*5+12)/sqrt3

 1002 continue

      do 1003 i=1,ncontd
      do 1003 j=1,i

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      wkvec(i4)=wkvec(i4)/three
      if(i.ne.j) wkvec(i4+1)=wkvec(i4+1)/sqrt3
      if(i.ne.j) wkvec(i4+2)=wkvec(i4+2)/sqrt3
      if(i.ne.j) wkvec(i4+3)=wkvec(i4+3)/three
      if(i.ne.j) wkvec(i4+4)=wkvec(i4+4)/sqrt3
      if(i.ne.j) wkvec(i4+5)=wkvec(i4+5)/three

      wkvec(i4+i1)=wkvec(i4+i1)/sqrt3
      if(i.ne.j) wkvec(i4+i1+3)=wkvec(i4+i1+3)/sqrt3
      if(i.ne.j) wkvec(i4+i1+5)=wkvec(i4+i1+5)/sqrt3

      wkvec(i4+i1*2+1)=wkvec(i4+i1*2+1)/sqrt3
      if(i.ne.j) wkvec(i4+i1*2+4)=wkvec(i4+i1*2+4)/sqrt3
      if(i.ne.j) wkvec(i4+i1*2+6)=wkvec(i4+i1*2+6)/sqrt3

      wkvec(i4+i1*3+3)=wkvec(i4+i1*3+3)/three
      wkvec(i4+i1*3+4)=wkvec(i4+i1*3+4)/sqrt3
      wkvec(i4+i1*3+5)=wkvec(i4+i1*3+5)/sqrt3
      wkvec(i4+i1*3+6)=wkvec(i4+i1*3+6)/three
      if(i.ne.j) wkvec(i4+i1*3+7)=wkvec(i4+i1*3+7)/sqrt3
      if(i.ne.j) wkvec(i4+i1*3+8)=wkvec(i4+i1*3+8)/three

      wkvec(i4+i1*4+6)=wkvec(i4+i1*4+6)/sqrt3
      wkvec(i4+i1*4+9)=wkvec(i4+i1*4+9)/sqrt3
      if(i.ne.j) wkvec(i4+i1*4+11)=wkvec(i4+i1*4+11)/sqrt3

      wkvec(i4+i1*5+10)=wkvec(i4+i1*5+10)/three
      wkvec(i4+i1*5+11)=wkvec(i4+i1*5+11)/sqrt3
      wkvec(i4+i1*5+12)=wkvec(i4+i1*5+12)/sqrt3
      wkvec(i4+i1*5+13)=wkvec(i4+i1*5+13)/three
      wkvec(i4+i1*5+14)=wkvec(i4+i1*5+14)/sqrt3
      wkvec(i4+i1*5+15)=wkvec(i4+i1*5+15)/three

 1003 continue

      return
      end

      subroutine scfcontrol(nfdpbcalc,nreal,ninteger,natoms,nmaxorbs,
     &                      nmaxaux,nmaxpts,nmaxesp,mesp,nmaxiterations,
     &                      nfunctional,idiis,ngridtype,iptsflag,
     &                      ncenters,nptcharges,nbsystems,level,nalpha,
     &                      nbeta,nconts,ncontp,ncontd,ncds,ncdspd,nxcs,
     &                      nxcspd,ixcfit,natomtype,nptsatom,nshels,
     &                      nshelp,nsheld,ilfunc,icfunc,ngaussians,
     &                      mtloca,nfuncatom,icdlfunc,icdcfunc,ixclfunc,
     &                      ixccfunc,isys,iwkvec,epsilon,econvergence,
     &                      dmixing,elevelshift,cutoff,coord,charge,
     &                      coordpc,ptcharge,core,focka,fockb,focke,
     &                      dmta,dmtb,coeffa,coeffb,overlapinv,alpha,
     &                      coeffs,alphacd,coefscd,coefpcd,coefdcd,
     &                      alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,
     &                      xcfita,xcfitb,xcfite,xcfitesave,tvector,
     &                      tveca,tvecb,tvece,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),ngaussians(*),mtloca(*),
     &          nfuncatom(*),icdlfunc(*),icdcfunc(*),ixclfunc(*),
     &          ixccfunc(*),isys(natoms,*),iwkvec(*)

      dimension cutoff(*),coord(3,*),charge(*),coordpc(3,*),ptcharge(*),
     &          core(*),focka(*),fockb(*),focke(*),dmta(*),dmtb(*),
     &          coeffa(nmaxorbs,*),coeffb(nmaxorbs,*),
     &          overlapinv(nmaxorbs,*),alpha(*),coeffs(*),alphacd(*),
     &          coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),coefsxc(*),
     &          coefpxc(*),coefdxc(*),cdfitc(*),xcfita(*),xcfitb(*),
     &          xcfite(*),xcfitesave(*),tvector(*),tveca(*),tvecb(*),
     &          tvece(*),wkvec(*)

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      call mpi_bcast(nfdpbcalc,1,mpi_integer,0,mpi_comm_world,ierr)

      if(nfdpbcalc.eq.1) then

         call delphidr(nreal,ninteger,natoms,nmaxorbs,nmaxaux,nmaxpts,
     &                 nmaxesp,mesp,nmaxiterations,idiis,ngridtype,
     &                 nfunctional,iptsflag,ncenters,nptcharges,
     &                 nbsystems,level,nalpha,nbeta,nconts,ncontp,
     &                 ncontd,ncds,ncdspd,nxcs,nxcspd,ixcfit,natomtype,
     &                 nptsatom,nshels,nshelp,nsheld,ilfunc,icfunc,
     &                 ngaussians,mtloca,nfuncatom,icdlfunc,icdcfunc,
     &                 ixclfunc,ixccfunc,isys,iwkvec,cutoff,epsilon,
     &                 econvergence,dmixing,elevelshift,coord,charge,
     &                 coordpc,ptcharge,core,focka,fockb,focke,dmta,
     &                 dmtb,coeffa,coeffb,overlapinv,alpha,coeffs,
     &                 alphacd,coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &                 coefpxc,coefdxc,cdfitc,xcfita,xcfitb,xcfite,
     &                 tvector,tveca,tvecb,tvece,xcfitesave,wkvec)

                         else

         call scfrun(nreal,ninteger,natoms,nmaxorbs,nmaxaux,nmaxpts,
     &               nfunctional,nmaxiterations,idiis,ngridtype,
     &               ncenters,nptcharges,nbsystems,level,nalpha,nbeta,
     &               nconts,ncontp,ncontd,ncds,ncdspd,nxcs,nxcspd,
     &               ixcfit,natomtype,nptsatom,nshels,nshelp,nsheld,
     &               ilfunc,icfunc,mtloca,ngaussians,nfuncatom,icdlfunc,
     &               icdcfunc,ixclfunc,ixccfunc,isys,iwkvec,
     &               econvergence,dmixing,elevelshift,diiserror,cutoff,
     &               coord,charge,coordpc,ptcharge,core,focka,fockb,
     &               focke,dmta,dmtb,coeffa,coeffb,alpha,coeffs,alphacd,
     &               coefscd,coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,
     &               coefdxc,cdfitc,xcfita,xcfitb,xcfite,xcfitesave,
     &               tvector,tveca,tvecb,tvece,overlapinv,wkvec)

                         endif

      return
      end

      subroutine crossprod(a,b,c)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension a(*),b(*),c(*)

      a(1)=b(2)*c(3)-b(3)*c(2)
      a(2)=b(3)*c(1)-b(1)*c(3)
      a(3)=b(1)*c(2)-b(2)*c(1)

      return
      end

      function dihed(coori,coorj,coork,coorl)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension rij(3),rjk(3),rkj(3),rlk(3),vec1(3),vec2(3),vec3(3)

      dimension coori(*),coorj(*),coork(*),coorl(*)

      data one,two,pi,one80/1.0d0,2.0d0,3.1415926535898d0,180.0d0/

      rad2deg=one80/pi

      deg90=pi/two

      do 1001 i=1,3
 1001 rij(i)=coori(i)-coorj(i)

      do 1002 i=1,3
 1002 rjk(i)=coorj(i)-coork(i)

      do 1003 i=1,3
 1003 rkj(i)=coork(i)-coorj(i)

      do 1004 i=1,3
 1004 rlk(i)=coorl(i)-coork(i)

      call crossprod(vec1,rkj,rij)
      call crossprod(vec2,rlk,rjk)

      call crossprod(vec3,vec1,vec2)

      dihed=dmagvec(3,vec3)/dmagvec(3,vec2)/dmagvec(3,vec1)

      if(dihed.ge.+one) dihed=+one
      if(dihed.le.-one) dihed=-one

      dihed=asin(dihed)

      fac1=dot(3,vec1,vec2)/dmagvec(3,vec1)/dmagvec(3,vec2)

      if(fac1.ge.+one) fac1=+one
      if(fac1.le.-one) fac1=-one

      fac1=acos(fac1)

      fac2=dot(3,vec1,rlk)/dmagvec(3,vec1)/dmagvec(3,rlk)

      if(fac2.ge.+one) fac2=+one
      if(fac2.le.-one) fac2=-one

      fac2=acos(fac2)

      if((fac1.le.deg90).and.(fac2.le.deg90)) dihed=rad2deg*(+dihed)
      if((fac1.le.deg90).and.(fac2.gt.deg90)) dihed=rad2deg*(-dihed)
      if((fac1.gt.deg90).and.(fac2.le.deg90)) dihed=rad2deg*(pi-dihed)
      if((fac1.gt.deg90).and.(fac2.gt.deg90)) dihed=rad2deg*(dihed-pi)

      return
      end

      subroutine coremm(nreal,ninteger,natoms,nptcharges,nconts,ncontp,
     &                  ncontd,nshels,nshelp,nsheld,mtloca,iprimvc,
     &                  nprimvc,icentvc,iwkvec,cutoff,coord,coordatom,
     &                  coordptcharge,charge,chargatom,chargptcharge,
     &                  alpha,coeff,overlp,core,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension g(7)

      dimension jsend(20)

      dimension istat(mpi_status_size)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*),iprimvc(*),
     &          nprimvc(*),icentvc(*),iwkvec(*)

      dimension coord(3,*),coordatom(3,*),coordptcharge(3,*),charge(*),
     &          chargatom(*),chargptcharge(*),alpha(*),coeff(*),
     &          overlp(*),core(*),wkvec(*)

      data zero/0.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ndim=nconts+3*ncontp+6*ncontd
      ndim=ndim*(ndim+1)/2

      do 1001 i=1,ndim
      core(i)=zero
 1001 overlp(i)=zero

      ncentr=natoms+nptcharges

      do 1002 i=1,natoms
      do 1003 j=1,3
 1003 coord(j,i)=coordatom(j,i)
 1002 charge(i)=chargatom(i)

      if(nptcharges.eq.0) goto 1004

      do 1005 i=1,nptcharges
      do 1006 j=1,3
 1006 coord(j,natoms+i)=coordptcharge(j,i)
 1005 charge(natoms+i)=chargptcharge(i)

 1004 continue

      ncposs=nconts*(nconts+1)/2
      ncpopp=ncontp*(ncontp+1)/2
      ncpodd=ncontd*(ncontd+1)/2

      ncpops=ncontp*nconts
      ncpods=ncontd*nconts
      ncpodp=ncontd*ncontp

      npposs=0
      nppops=0
      nppopp=0
      nppods=0
      nppodp=0
      nppodd=0

      do 1007 i=1,nconts
      do 1007 j=1,i
 1007 npposs=npposs+nprimvc(nshels(i))*nprimvc(nshels(j))

      do 1008 i=1,ncontp
      do 1008 j=1,nconts
 1008 nppops=nppops+nprimvc(nshelp(i))*nprimvc(nshels(j))

      do 1009 i=1,ncontp
      do 1009 j=1,i
 1009 nppopp=nppopp+nprimvc(nshelp(i))*nprimvc(nshelp(j))

      do 1010 i=1,ncontd
      do 1010 j=1,nconts
 1010 nppods=nppods+nprimvc(nsheld(i))*nprimvc(nshels(j))

      do 1011 i=1,ncontd
      do 1011 j=1,ncontp
 1011 nppodp=nppodp+nprimvc(nsheld(i))*nprimvc(nshelp(j))

      do 1012 i=1,ncontd
      do 1012 j=1,i
 1012 nppodd=nppodd+nprimvc(nsheld(i))*nprimvc(nsheld(j))

      ja=1
      jb=ja+npposs
      jc=jb+ncposs

      if(jc.gt.ninteger) stop 'coremm ss integer overflow'

      je=1
      jf=je+npposs
      jg=jf+npposs
      jh=jg+npposs
      ji=jh+npposs
      jj=ji+npposs
      jk=jj+npposs
      jl=jk+npposs
      jm=jl+npposs
      jn=jm+npposs
      jo=jn+npposs
      jp=jo+npposs
      jq=jp+npposs
      jr=jq+npposs*7

      if(jr.gt.nreal) stop 'coremm ss real overflow'

      call setuppss(ncposs,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &              icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,alpha,
     &              coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &              wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &              wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq))

      jd=jc+n

      if(jd.gt.ninteger) stop 'coremm ss integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                    endif

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n

      if(myid.eq.0) then
                          isent=0

                          do 1013 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp

                          call mpi_bsend(jsend,13,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jk),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jl),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop

 1013                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,13,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jk),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jl),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jq+1
      kb=ka+nloop
      kc=kb+nloop 
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop

      if(kg.gt.nreal) stop 'coremm ss real overflow'

      call coress(ncposs,nloop,ncentr,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &            coord,charge,overlp,core,wkvec(je),wkvec(jn),
     &            wkvec(jo),wkvec(jp),wkvec(jk),wkvec(jm),wkvec(jl),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf))

      if(ncontp.eq.0) goto 1019

      ja=1
      jb=ja+nppops
      jc=jb+ncpops*3

      if(jc.gt.ninteger) stop 'coremm ps integer overflow'

      je=1
      jf=je+nppops
      jg=jf+nppops
      jh=jg+nppops
      ji=jh+nppops
      jj=ji+nppops
      jk=jj+nppops
      jl=jk+nppops
      jm=jl+nppops
      jn=jm+nppops
      jo=jn+nppops
      jp=jo+nppops
      jq=jp+nppops
      jr=jq+nppops
      js=jr+nppops
      jt=js+nppops
      ju=jt+nppops*10

      if(ju.gt.nreal) stop 'coremm ps real overflow'

      call setuppps(ncpops,n,ncontp,nconts,nshelp,nshels,mtloca,iprimvc,
     &              nprimvc,icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,
     &              alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &              wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &              wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jt))

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                    endif

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      if(myid.eq.0) then
                          isent=0

                          do 1014 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js

                          call mpi_bsend(jsend,16,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jk),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jl),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop

 1014                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,16,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jk),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jl),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jt+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop*3
      kf=ke+nloop*3
      kg=kf+nloop
      kh=kg+nloop
      ki=kh+nloop
      kj=ki+nloop
      kk=kj+nloop
      kl=kk+nloop*3

      if(kl.gt.nreal) stop 'coremm ps real overflow'

      call coreps(ncpops,nloop,ncentr,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &            coord,charge,overlp,core,wkvec(je),wkvec(jn),
     &            wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),
     &            wkvec(jk),wkvec(jm),wkvec(jl),wkvec(ka),wkvec(kb),
     &            wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &            wkvec(kh),wkvec(ki),wkvec(kj))

      ja=1
      jb=ja+ncpopp
      jc=jb+nppopp
      jd=jc+ncpopp*9

      if(jd.gt.ninteger) stop 'coremm pp integer overflow'

      je=1
      jf=je+nppopp
      jg=jf+nppopp
      jh=jg+nppopp
      ji=jh+nppopp
      jj=ji+nppopp
      jk=jj+nppopp
      jl=jk+nppopp
      jm=jl+nppopp
      jn=jm+nppopp
      jo=jn+nppopp
      jp=jo+nppopp
      jq=jp+nppopp
      jr=jq+nppopp
      js=jr+nppopp
      jt=js+nppopp
      ju=jt+nppopp
      jv=ju+nppopp
      jw=jv+nppopp
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp
      j0=jz+ncpopp*13

      if(j0.gt.nreal) stop 'coremm pp real overflow'

      call setupppp(ncpopp,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &              icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz))

      j1=jd+n

      if(j1.gt.ninteger) stop 'coremm pp integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpopp,wkvec(18*n+0*ncpopp+1),wkvec(jw))
      call stringcopy(ncpopp,wkvec(18*n+1*ncpopp+1),wkvec(jx))
      call stringcopy(ncpopp,wkvec(18*n+2*ncpopp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      if(myid.eq.0) then
                          isent=0

                          do 1015 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=jb
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(jb),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jk),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jl),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          jb=jb+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1015                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer, mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      jb=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(jb),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jk),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jl),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop*3
      kg=kf+nloop*3
      kh=kg+nloop*3
      ki=kh+nloop*6
      kj=ki+nloop*9
      kk=kj+nloop*9
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop
      kr=kq+nloop

      if(kr.gt.nreal) stop 'coremm pp real overflow'

      call corepp(ncpopp,nloop,ncentr,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &            iwkvec(jd),coord,charge,overlp,core,wkvec(je),
     &            wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt),
     &            wkvec(ju),wkvec(jv),wkvec(jk),wkvec(jm),wkvec(jl),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &            wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &            wkvec(kp),wkvec(kq))

      if(ncontd.eq.0) goto 1019

      ja=1
      jb=ja+nppods
      jc=jb+ncpods*6

      if(jc.gt.ninteger) stop 'coremm ds integer overflow'

      je=1
      jf=je+nppods
      jg=jf+nppods
      jh=jg+nppods
      ji=jh+nppods
      jj=ji+nppods
      jk=jj+nppods
      jl=jk+nppods
      jm=jl+nppods
      jn=jm+nppods
      jo=jn+nppods
      jp=jo+nppods
      jq=jp+nppods
      jr=jq+nppods
      js=jr+nppods
      jt=js+nppods
      ju=jt+nppods*11

      if(jt.gt.nreal) stop 'coremm ds real overflow'

      call setuppds(ncpods,n,ncontd,nconts,nsheld,nshels,mtloca,iprimvc,
     &              nprimvc,icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,
     &              alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &              wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &              wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jt))

      jd=jc+n

      if(jd.gt.ninteger) stop 'coremm ds integer overflow'


      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                    endif

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n

      if(myid.eq.0) then
                          isent=0

                          do 1016 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js

                          call mpi_bsend(jsend,16,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jf),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jk),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jl),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop

 1016                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,16,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jf),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jk),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jl),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jt+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop*3
      kg=kf+nloop*3
      kh=kg+nloop*3
      ki=kh+nloop*6
      kj=ki+nloop*6
      kk=kj+nloop
      kl=kk+nloop
      km=kl+nloop
      kn=km+nloop
      ko=kn+nloop
      kp=ko+nloop
      kq=kp+nloop

      if(kq.gt.nreal) stop 'coremm ds real overflow'

      call coreds(ncpods,nloop,ncentr,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &            coord,charge,overlp,core,wkvec(je),wkvec(jf),
     &            wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &            wkvec(js),wkvec(jk),wkvec(jm),wkvec(jl),wkvec(ka),
     &            wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &            wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),
     &            wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp))

      ja=1
      jb=ja+nppodp
      jc=jb+ncpodp*18

      if(jc.gt.ninteger) stop 'coremm dp integer overflow'

      je=1
      jf=je+nppodp
      jg=jf+nppodp
      jh=jg+nppodp
      ji=jh+nppodp
      jj=ji+nppodp
      jk=jj+nppodp
      jl=jk+nppodp
      jm=jl+nppodp
      jn=jm+nppodp
      jo=jn+nppodp
      jp=jo+nppodp
      jq=jp+nppodp
      jr=jq+nppodp
      js=jr+nppodp
      jt=js+nppodp
      ju=jt+nppodp
      jv=ju+nppodp
      jw=jv+nppodp
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp
      j0=jz+ncpodp*14

      if(j0.gt.nreal) stop 'coremm dp real overflow'

      call setuppdp(ncpodp,n,ncontd,ncontp,nsheld,nshelp,mtloca,iprimvc,
     &              nprimvc,icentvc,iwkvec(ja),iwkvec(jb),cutoff,coord,
     &              alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &              wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &              wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &              wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &              wkvec(jx),wkvec(jy),wkvec(jz))

      jd=jc+n

      if(jc.gt.ninteger) stop 'coremm dp integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpodp,wkvec(18*n+0*ncpodp+1),wkvec(jw))
      call stringcopy(ncpodp,wkvec(18*n+1*ncpodp+1),wkvec(jx))
      call stringcopy(ncpodp,wkvec(18*n+2*ncpodp+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      if(myid.eq.0) then
                          isent=0

                          do 1017 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=ja
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(ja),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jf),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jk),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jl),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          ja=ja+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1017                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ja=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(ja),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jf),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jk),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jl),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop*3
      kh=kg+nloop*3
      ki=kh+nloop*3
      kj=ki+nloop*3
      kk=kj+nloop*6
      kl=kk+nloop*6
      km=kl+nloop*10
      kn=km+nloop*18
      ko=kn+nloop*18
      kp=ko+nloop
      kq=kp+nloop*3
      kr=kq+nloop
      ks=kr+nloop
      kt=ks+nloop
      ku=kt+nloop
      kv=ku+nloop
      kw=kv+nloop

      if(kw.gt.nreal) stop 'coremm dp real overflow'

      call coredp(ncpodp,nloop,ncentr,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &            coord,charge,overlp,core,wkvec(je),wkvec(jf),
     &            wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jq),wkvec(jr),wkvec(js),wkvec(jt),
     &            wkvec(ju),wkvec(jv),wkvec(jk),wkvec(jm),wkvec(jl),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &            wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &            wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),
     &            wkvec(ku),wkvec(kv))

      ja=1
      jb=ja+ncpodd
      jc=jb+nppodd
      jd=jc+ncpodd*36

      if(jd.gt.ninteger) stop 'coremm dd integer overflow'

      je=1
      jf=je+nppodd
      jg=jf+nppodd
      jh=jg+nppodd
      ji=jh+nppodd
      jj=ji+nppodd
      jk=jj+nppodd
      jl=jk+nppodd
      jm=jl+nppodd
      jn=jm+nppodd
      jo=jn+nppodd
      jp=jo+nppodd
      jq=jp+nppodd
      jr=jq+nppodd
      js=jr+nppodd
      jt=js+nppodd
      ju=jt+nppodd
      jv=ju+nppodd
      jw=jv+nppodd
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd
      j0=jz+ncpodd*15

      if(j0.gt.nreal) stop 'coremm dd real overflow'

      call setuppdd(ncpodd,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &              icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),cutoff,
     &              coord,alpha,coeff,wkvec(je),wkvec(jf),wkvec(jg),
     &              wkvec(jh),wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),
     &              wkvec(jm),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),
     &              wkvec(jr),wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),
     &              wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jz))

      j1=jd+n

      if(j1.gt.ninteger) stop 'coremm dd integer overflow'

      if(myid.eq.0) then
                          call stringcopy(n,wkvec(00*n+1),wkvec(je))
                          call stringcopy(n,wkvec(01*n+1),wkvec(jf))
                          call stringcopy(n,wkvec(02*n+1),wkvec(jg))
                          call stringcopy(n,wkvec(03*n+1),wkvec(jh))
                          call stringcopy(n,wkvec(04*n+1),wkvec(ji))
                          call stringcopy(n,wkvec(05*n+1),wkvec(jj))
                          call stringcopy(n,wkvec(06*n+1),wkvec(jk))
                          call stringcopy(n,wkvec(07*n+1),wkvec(jl))
                          call stringcopy(n,wkvec(08*n+1),wkvec(jm))
                          call stringcopy(n,wkvec(09*n+1),wkvec(jn))
                          call stringcopy(n,wkvec(10*n+1),wkvec(jo))
                          call stringcopy(n,wkvec(11*n+1),wkvec(jp))
                          call stringcopy(n,wkvec(12*n+1),wkvec(jq))
                          call stringcopy(n,wkvec(13*n+1),wkvec(jr))
                          call stringcopy(n,wkvec(14*n+1),wkvec(js))
                          call stringcopy(n,wkvec(15*n+1),wkvec(jt))
                          call stringcopy(n,wkvec(16*n+1),wkvec(ju))
                          call stringcopy(n,wkvec(17*n+1),wkvec(jv))
                    endif

      call stringcopy(ncpodd,wkvec(18*n+0*ncpodd+1),wkvec(jw))
      call stringcopy(ncpodd,wkvec(18*n+1*ncpodd+1),wkvec(jx))
      call stringcopy(ncpodd,wkvec(18*n+2*ncpodd+1),wkvec(jy))

      je=1
      jf=je+n
      jg=jf+n
      jh=jg+n
      ji=jh+n
      jj=ji+n
      jk=jj+n
      jl=jk+n
      jm=jl+n
      jn=jm+n
      jo=jn+n
      jp=jo+n
      jq=jp+n
      jr=jq+n
      js=jr+n
      jt=js+n
      ju=jt+n
      jv=ju+n
      jw=jv+n
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      if(myid.eq.0) then
                          isent=0

                          do 1018 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          jsend(01)=jb
                          jsend(02)=je
                          jsend(03)=jf
                          jsend(04)=jg
                          jsend(05)=jh
                          jsend(06)=ji
                          jsend(07)=jj
                          jsend(08)=jk
                          jsend(09)=jl
                          jsend(10)=jm
                          jsend(11)=jn
                          jsend(12)=jo
                          jsend(13)=jp
                          jsend(14)=jq
                          jsend(15)=jr
                          jsend(16)=js
                          jsend(17)=jt
                          jsend(18)=ju
                          jsend(19)=jv

                          call mpi_bsend(jsend,19,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          call mpi_bsend(iwkvec(jb),nloop,
     &                                   mpi_integer,islave,islave,
     &                                   mpi_comm_world,ierr)

                          call mpi_bsend(wkvec(je),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jf),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jg),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jk),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jl),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jm),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jn),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jo),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jp),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jq),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jr),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(js),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jt),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(ju),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)
                          call mpi_bsend(wkvec(jv),nloop,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

                          jb=jb+nloop

                          je=je+nloop
                          jf=jf+nloop
                          jg=jg+nloop
                          jh=jh+nloop
                          ji=ji+nloop
                          jj=jj+nloop
                          jk=jk+nloop
                          jl=jl+nloop
                          jm=jm+nloop
                          jn=jn+nloop
                          jo=jo+nloop
                          jp=jp+nloop
                          jq=jq+nloop
                          jr=jr+nloop
                          js=js+nloop
                          jt=jt+nloop
                          ju=ju+nloop
                          jv=jv+nloop

 1018                     isent=isent+nloop
                    endif


      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(jsend,19,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      jb=jsend(01)
      je=jsend(02)
      jf=jsend(03)
      jg=jsend(04)
      jh=jsend(05)
      ji=jsend(06)
      jj=jsend(07)
      jk=jsend(08)
      jl=jsend(09)
      jm=jsend(10)
      jn=jsend(11)
      jo=jsend(12)
      jp=jsend(13)
      jq=jsend(14)
      jr=jsend(15)
      js=jsend(16)
      jt=jsend(17)
      ju=jsend(18)
      jv=jsend(19)

      call mpi_recv(iwkvec(jb),nloop,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      call mpi_recv(wkvec(je),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jf),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jg),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jk),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jl),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jm),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jn),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jo),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jp),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jq),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jr),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(js),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jt),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(ju),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)
      call mpi_recv(wkvec(jv),nloop,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierror)

      ka=jz+1
      kb=ka+nloop
      kc=kb+nloop
      kd=kc+nloop
      ke=kd+nloop
      kf=ke+nloop
      kg=kf+nloop
      kh=kg+nloop*3
      ki=kh+nloop*3
      kj=ki+nloop*3
      kk=kj+nloop*3
      kl=kk+nloop*3
      km=kl+nloop*6
      kn=km+nloop*6
      ko=kn+nloop*6
      kp=ko+nloop*10
      kq=kp+nloop*10
      kr=kq+nloop*15
      ks=kr+nloop*9
      kt=ks+nloop*18
      ku=kt+nloop*18
      kv=ku+nloop*30
      kw=kv+nloop*36
      kx=kw+nloop*36
      ky=kx+nloop
      kz=ky+nloop*3
      la=kz+nloop*6
      lb=la+nloop*9
      lc=lb+nloop
      ld=lc+nloop
      le=ld+nloop
      lf=le+nloop
      lg=lf+nloop
      lh=lg+nloop

      if(lh.gt.nreal) stop 'coremm dd real overflow'

      call coredd(ncpodd,nloop,ncentr,iwkvec(ja),iwkvec(jb),iwkvec(jc),
     &            iwkvec(jd),coord,charge,overlp,core,wkvec(je),
     &            wkvec(jf),wkvec(jg),wkvec(jw),wkvec(jx),wkvec(jy),
     &            wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &            wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jk),
     &            wkvec(jm),wkvec(jl),wkvec(ka),wkvec(kb),wkvec(kc),
     &            wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &            wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &            wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &            wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),
     &            wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),
     &            wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),wkvec(lg))

 1019 continue

      call mpi_reduce(overlp,wkvec,ndim,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) call stringcopy(ndim,overlp,wkvec)

      call mpi_reduce(core,wkvec,ndim,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) call stringcopy(ndim,core,wkvec)

      if(myid.eq.0) then
                          call normd(nconts,ncontp,ncontd,
     &                               nshels,nshelp,nsheld,mtloca,core)
                          call normd(nconts,ncontp,ncontd,
     &                               nshels,nshelp,nsheld,mtloca,overlp)
                    endif

      call mpi_bcast(overlp,ndim,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(core,ndim,mpi_real8,0,mpi_comm_world,ierr)

      return
      end

      subroutine xvecdd(m,n,nxcs,nxcspd,ilfunc,icfunc,iminj,icontr,
     &                  iicontr,inddyy,iloc,coord,dmat,vvector,
     &                  alphaaux,coeffs,coeffp,coeffd,zeta,ax,ay,az,
     &                  axbx,ayby,azbz,px,py,pz,base,zetarec,zetafac,
     &                  efac,gxax,gyay,gzaz,sss,pss,dss,dsscond,fss,
     &                  fsscond,gss,gsscond,hss,hsscond,qss,qsscond,dps,
     &                  dds,ddp,ddd,fps,fds,fdp,gps,gds,hps,c,c1,c2,c3,
     &                  c4,zzeta,aax,aay,aaz,ppx,ppy,ppz,axcx,aycy,azcz,
     &                  gather)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension index(36)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),iicontr(*),
     &          inddyy(m,*),iloc(*)

      dimension coord(3,*),dmat(*),vvector(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),zeta(*),ax(*),ay(*),az(*),axbx(*),
     &          ayby(*),azbz(*),px(*),py(*),pz(*),base(*),zetarec(*),
     &          zetafac(*),efac(*),gxax(*),gyay(*),gzaz(*),sss(*),
     &          pss(n,*),dss(n,*),dsscond(n,*),fss(n,*),fsscond(n,*),
     &          gss(n,*),gsscond(n,*),hss(n,*),hsscond(n,*),qss(n,*),
     &          qsscond(n,*),dps(n,*),dds(n,*),ddp(n,*),ddd(n,*),
     &          fps(n,*),fds(n,*),fdp(n,*),gps(n,*),gds(n,*),hps(n,*),
     &          c(*),c1(n,*),c2(n,*),c3(n,*),c4(n,*),zzeta(*),aax(*),
     &          aay(*),aaz(*),ppx(*),ppy(*),ppz(*),axcx(*),aycy(*),
     &          azcz(*),gather(n,*)

      data zero,one,two,three,four,five/0.0d0,1.0d0,2.0d0,
     &                                  3.0d0,4.0d0,5.0d0/
      data expcut,calcut,pi/45.0d0,1.0d-16,3.1415926535898d0/

      thrhlf=three/two

      sqrt3=sqrt(three)

      do 1000 i=1,n
 1000 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1001 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      do 1002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      sss(i)=zero
 1004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 1005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 1005 continue

      do 1006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 1006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 1007 i=1,nn
 1007 zetarec(i)=zetarec(i)/two

      do 1008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 1008 pss(i,3)=gzaz(i)*sss(i)

      do 1009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 1009 continue

      do 1010 j=1,3
      do 1010 i=1,nn
 1010 c1(i,j)=zetarec(i)*pss(i,j)

      do 1011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 1011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 1012 j=1,6
      do 1012 i=1,nn
 1012 c2(i,j)=zetarec(i)*dss(i,j)

      do 1013 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 1013 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 1014 i=1,nn
      dps(i,01)=axbx(iicontr(i))*dss(i,1)+fss(i,01)
      dps(i,02)=ayby(iicontr(i))*dss(i,1)+fss(i,02)
      dps(i,03)=azbz(iicontr(i))*dss(i,1)+fss(i,03)
      dps(i,04)=axbx(iicontr(i))*dss(i,2)+fss(i,02)
      dps(i,05)=ayby(iicontr(i))*dss(i,2)+fss(i,04)
      dps(i,06)=azbz(iicontr(i))*dss(i,2)+fss(i,05)
      dps(i,07)=axbx(iicontr(i))*dss(i,3)+fss(i,03)
      dps(i,08)=ayby(iicontr(i))*dss(i,3)+fss(i,05)
      dps(i,09)=azbz(iicontr(i))*dss(i,3)+fss(i,06)
      dps(i,10)=axbx(iicontr(i))*dss(i,4)+fss(i,04)
      dps(i,11)=ayby(iicontr(i))*dss(i,4)+fss(i,07)
      dps(i,12)=azbz(iicontr(i))*dss(i,4)+fss(i,08)
      dps(i,13)=axbx(iicontr(i))*dss(i,5)+fss(i,05)
      dps(i,14)=ayby(iicontr(i))*dss(i,5)+fss(i,08)
      dps(i,15)=azbz(iicontr(i))*dss(i,5)+fss(i,09)
      dps(i,16)=axbx(iicontr(i))*dss(i,6)+fss(i,06)
      dps(i,17)=ayby(iicontr(i))*dss(i,6)+fss(i,09)
 1014 dps(i,18)=azbz(iicontr(i))*dss(i,6)+fss(i,10)

      do 1015 i=1,nn
      fps(i,01)=axbx(iicontr(i))*fss(i,01)+gss(i,01)
      fps(i,02)=ayby(iicontr(i))*fss(i,01)+gss(i,02)
      fps(i,03)=azbz(iicontr(i))*fss(i,01)+gss(i,03)
      fps(i,04)=axbx(iicontr(i))*fss(i,02)+gss(i,02)
      fps(i,05)=ayby(iicontr(i))*fss(i,02)+gss(i,04)
      fps(i,06)=azbz(iicontr(i))*fss(i,02)+gss(i,05)
      fps(i,07)=axbx(iicontr(i))*fss(i,03)+gss(i,03)
      fps(i,08)=ayby(iicontr(i))*fss(i,03)+gss(i,05)
      fps(i,09)=azbz(iicontr(i))*fss(i,03)+gss(i,06)
      fps(i,10)=axbx(iicontr(i))*fss(i,04)+gss(i,04)
      fps(i,11)=ayby(iicontr(i))*fss(i,04)+gss(i,07)
      fps(i,12)=azbz(iicontr(i))*fss(i,04)+gss(i,08)
      fps(i,13)=axbx(iicontr(i))*fss(i,05)+gss(i,05)
      fps(i,14)=ayby(iicontr(i))*fss(i,05)+gss(i,08)
      fps(i,15)=azbz(iicontr(i))*fss(i,05)+gss(i,09)
      fps(i,16)=axbx(iicontr(i))*fss(i,06)+gss(i,06)
      fps(i,17)=ayby(iicontr(i))*fss(i,06)+gss(i,09)
      fps(i,18)=azbz(iicontr(i))*fss(i,06)+gss(i,10)
      fps(i,19)=axbx(iicontr(i))*fss(i,07)+gss(i,07)
      fps(i,20)=ayby(iicontr(i))*fss(i,07)+gss(i,11)
      fps(i,21)=azbz(iicontr(i))*fss(i,07)+gss(i,12)
      fps(i,22)=axbx(iicontr(i))*fss(i,08)+gss(i,08)
      fps(i,23)=ayby(iicontr(i))*fss(i,08)+gss(i,12)
      fps(i,24)=azbz(iicontr(i))*fss(i,08)+gss(i,13)
      fps(i,25)=axbx(iicontr(i))*fss(i,09)+gss(i,09)
      fps(i,26)=ayby(iicontr(i))*fss(i,09)+gss(i,13)
      fps(i,27)=azbz(iicontr(i))*fss(i,09)+gss(i,14)
      fps(i,28)=axbx(iicontr(i))*fss(i,10)+gss(i,10)
      fps(i,29)=ayby(iicontr(i))*fss(i,10)+gss(i,14)
 1015 fps(i,30)=azbz(iicontr(i))*fss(i,10)+gss(i,15)

      do 1016 i=1,nn
      dds(i,01)=axbx(iicontr(i))*dps(i,01)+fps(i,01)
      dds(i,02)=ayby(iicontr(i))*dps(i,01)+fps(i,04)
      dds(i,03)=azbz(iicontr(i))*dps(i,01)+fps(i,07)
      dds(i,04)=ayby(iicontr(i))*dps(i,02)+fps(i,05)
      dds(i,05)=azbz(iicontr(i))*dps(i,02)+fps(i,08)
      dds(i,06)=azbz(iicontr(i))*dps(i,03)+fps(i,09)
      dds(i,07)=axbx(iicontr(i))*dps(i,04)+fps(i,04)
      dds(i,08)=ayby(iicontr(i))*dps(i,04)+fps(i,10)
      dds(i,09)=azbz(iicontr(i))*dps(i,04)+fps(i,13)
      dds(i,10)=ayby(iicontr(i))*dps(i,05)+fps(i,11)
      dds(i,11)=azbz(iicontr(i))*dps(i,05)+fps(i,14)
      dds(i,12)=azbz(iicontr(i))*dps(i,06)+fps(i,15)
      dds(i,13)=axbx(iicontr(i))*dps(i,07)+fps(i,07)
      dds(i,14)=ayby(iicontr(i))*dps(i,07)+fps(i,13)
      dds(i,15)=azbz(iicontr(i))*dps(i,07)+fps(i,16)
      dds(i,16)=ayby(iicontr(i))*dps(i,08)+fps(i,14)
      dds(i,17)=azbz(iicontr(i))*dps(i,08)+fps(i,17)
      dds(i,18)=azbz(iicontr(i))*dps(i,09)+fps(i,18)
      dds(i,19)=axbx(iicontr(i))*dps(i,10)+fps(i,10)
      dds(i,20)=ayby(iicontr(i))*dps(i,10)+fps(i,19)
      dds(i,21)=azbz(iicontr(i))*dps(i,10)+fps(i,22)
      dds(i,22)=ayby(iicontr(i))*dps(i,11)+fps(i,20)
      dds(i,23)=azbz(iicontr(i))*dps(i,11)+fps(i,23)
      dds(i,24)=azbz(iicontr(i))*dps(i,12)+fps(i,24)
      dds(i,25)=axbx(iicontr(i))*dps(i,13)+fps(i,13)
      dds(i,26)=ayby(iicontr(i))*dps(i,13)+fps(i,22)
      dds(i,27)=azbz(iicontr(i))*dps(i,13)+fps(i,25)
      dds(i,28)=ayby(iicontr(i))*dps(i,14)+fps(i,23)
      dds(i,29)=azbz(iicontr(i))*dps(i,14)+fps(i,26)
      dds(i,30)=azbz(iicontr(i))*dps(i,15)+fps(i,27)
      dds(i,31)=axbx(iicontr(i))*dps(i,16)+fps(i,16)
      dds(i,32)=ayby(iicontr(i))*dps(i,16)+fps(i,25)
      dds(i,33)=azbz(iicontr(i))*dps(i,16)+fps(i,28)
      dds(i,34)=ayby(iicontr(i))*dps(i,17)+fps(i,26)
      dds(i,35)=azbz(iicontr(i))*dps(i,17)+fps(i,29)
 1016 dds(i,36)=azbz(iicontr(i))*dps(i,18)+fps(i,30)

      do 1017 i=1,nn
 1017 gather(i,1)=zero

      do 1018 j=1,36
      do 1018 i=1,nn
 1018 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dds(i,j)

      nnn=0

      do 1019 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 1019 continue

      index(01)=02
      index(02)=03
      index(03)=04
      index(04)=05
      index(05)=06
      index(06)=09
      index(07)=10
      index(08)=11
      index(09)=12
      index(10)=16
      index(11)=17
      index(12)=18
      index(13)=23
      index(14)=24
      index(15)=30

      do 1020 j=1,15
cfpp$ nodepchk
      do 1020 i=1,nnn
 1020 gather(iloc(i),1)=gather(iloc(i),1)
     &                 -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                 *dds(iloc(i),index(j))

      do 1021 i=1,nn
 1021 gather(i,1)=gather(i,1)*xcfits

      do 1022 i=1,nn
 1022 vvector(naux)=vvector(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      xcfitp(1)=coeffp(ilaux)
      xcfitp(2)=coeffp(ilaux)
      xcfitp(3)=coeffp(ilaux)

      xcfitd(1)=coeffd(ilaux)/sqrt3
      xcfitd(2)=coeffd(ilaux)
      xcfitd(3)=coeffd(ilaux)
      xcfitd(4)=coeffd(ilaux)/sqrt3
      xcfitd(5)=coeffd(ilaux)
      xcfitd(6)=coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,nn
 2010 c1(i,j)=zetarec(i)*pss(i,j)

      do 2011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 2011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 2012 j=1,6
      do 2012 i=1,nn
 2012 c2(i,j)=zetarec(i)*dss(i,j)

      do 2013 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 2013 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 2014 j=1,10
      do 2014 i=1,nn
 2014 c3(i,j)=zetarec(i)*fss(i,j)

      do 2015 i=1,nn
      hss(i,01)=gxax(i)*gss(i,01)+c3(i,01)*four
      hss(i,02)=gyay(i)*gss(i,01)
      hss(i,03)=gzaz(i)*gss(i,01)
      hss(i,04)=gyay(i)*gss(i,02)+c3(i,01)
      hss(i,05)=gzaz(i)*gss(i,02)
      hss(i,06)=gzaz(i)*gss(i,03)+c3(i,01)
      hss(i,07)=gyay(i)*gss(i,04)+c3(i,02)*two
      hss(i,08)=gzaz(i)*gss(i,04)
      hss(i,09)=gzaz(i)*gss(i,05)+c3(i,02)
      hss(i,10)=gzaz(i)*gss(i,06)+c3(i,03)*two
      hss(i,11)=gyay(i)*gss(i,07)+c3(i,04)*three
      hss(i,12)=gzaz(i)*gss(i,07)
      hss(i,13)=gzaz(i)*gss(i,08)+c3(i,04)
      hss(i,14)=gzaz(i)*gss(i,09)+c3(i,05)*two
      hss(i,15)=gzaz(i)*gss(i,10)+c3(i,06)*three
      hss(i,16)=gyay(i)*gss(i,11)+c3(i,07)*four
      hss(i,17)=gzaz(i)*gss(i,11)
      hss(i,18)=gzaz(i)*gss(i,12)+c3(i,07)
      hss(i,19)=gzaz(i)*gss(i,13)+c3(i,08)*two
      hss(i,20)=gzaz(i)*gss(i,14)+c3(i,09)*three
 2015 hss(i,21)=gzaz(i)*gss(i,15)+c3(i,10)*four

      do 2016 j=1,15
      do 2016 i=1,nn
 2016 c4(i,j)=zetarec(i)*gss(i,j)

      do 2017 i=1,nn
      qss(i,01)=gxax(i)*hss(i,01)+c4(i,01)*five
      qss(i,02)=gyay(i)*hss(i,01)
      qss(i,03)=gzaz(i)*hss(i,01)
      qss(i,04)=gyay(i)*hss(i,02)+c4(i,01)
      qss(i,05)=gzaz(i)*hss(i,02)
      qss(i,06)=gzaz(i)*hss(i,03)+c4(i,01)
      qss(i,07)=gyay(i)*hss(i,04)+c4(i,02)*two
      qss(i,08)=gzaz(i)*hss(i,04)
      qss(i,09)=gzaz(i)*hss(i,05)+c4(i,02)
      qss(i,10)=gzaz(i)*hss(i,06)+c4(i,03)*two
      qss(i,11)=gyay(i)*hss(i,07)+c4(i,04)*three
      qss(i,12)=gzaz(i)*hss(i,07)
      qss(i,13)=gzaz(i)*hss(i,08)+c4(i,04)
      qss(i,14)=gzaz(i)*hss(i,09)+c4(i,05)*two
      qss(i,15)=gzaz(i)*hss(i,10)+c4(i,06)*three
      qss(i,16)=gyay(i)*hss(i,11)+c4(i,07)*four
      qss(i,17)=gzaz(i)*hss(i,11)
      qss(i,18)=gzaz(i)*hss(i,12)+c4(i,07)
      qss(i,19)=gzaz(i)*hss(i,13)+c4(i,08)*two
      qss(i,20)=gzaz(i)*hss(i,14)+c4(i,09)*three
      qss(i,21)=gzaz(i)*hss(i,15)+c4(i,10)*four
      qss(i,22)=gyay(i)*hss(i,16)+c4(i,11)*five
      qss(i,23)=gzaz(i)*hss(i,16)
      qss(i,24)=gzaz(i)*hss(i,17)+c4(i,11)
      qss(i,25)=gzaz(i)*hss(i,18)+c4(i,12)*two
      qss(i,26)=gzaz(i)*hss(i,19)+c4(i,13)*three
      qss(i,27)=gzaz(i)*hss(i,20)+c4(i,14)*four
 2017 qss(i,28)=gzaz(i)*hss(i,21)+c4(i,15)*five

      call xcordd1(m,n,nn,iicontr,axbx,ayby,azbz,axcx,aycy,azcz,dss,
     &             fss,gss,hss,qss,dps,dds,ddp,ddd,fps,fds,fdp,gps,gds,
     &             hps)

      do 2018 j=1,10
      do 2018 i=1,nn
 2018 gather(i,j)=zero

      do 2019 j=1,36
      do 2019 i=1,nn
 2019 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dds(i,j)

      do 2020 k=1,3
      do 2020 j=1,36
      do 2020 i=1,nn
 2020 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*ddp(i,3*(j-1)+k)

      do 2021 k=1,6
      do 2021 j=1,36
      do 2021 i=1,nn
 2021 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*ddd(i,6*(j-1)+k)

      nnn=0

      do 2022 i=1,nn
      if(iminj(iicontr(i)).eq.0) then
                                       nnn=nnn+1
                                       iloc(nnn)=i
                                 endif
 2022 continue

      index(01)=02
      index(02)=03
      index(03)=04
      index(04)=05
      index(05)=06
      index(06)=09
      index(07)=10
      index(08)=11
      index(09)=12
      index(10)=16
      index(11)=17
      index(12)=18
      index(13)=23
      index(14)=24
      index(15)=30

      do 2023 j=1,15
cfpp$ nodepchk
      do 2023 i=1,nnn
 2023 gather(iloc(i),1)=gather(iloc(i),1)
     &                 -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                 *dds(iloc(i),index(j))

      do 2024 k=1,3
      do 2024 j=1,15
cfpp$ nodepchk
      do 2024 i=1,nnn
 2024 gather(iloc(i),k+1)=gather(iloc(i),k+1)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ddp(iloc(i),3*(index(j)-1)+k)

      do 2025 k=1,6
      do 2025 j=1,15
cfpp$ nodepchk
      do 2025 i=1,nnn
 2025 gather(iloc(i),k+4)=gather(iloc(i),k+4)
     &                   -dmat(inddyy(iicontr(iloc(i)),index(j)))
     &                   *ddd(iloc(i),6*(index(j)-1)+k)

      do 2026 i=1,nn
      gather(i,01)=gather(i,01)*xcfits
      gather(i,02)=gather(i,02)*xcfitp(1)
      gather(i,03)=gather(i,03)*xcfitp(2)
      gather(i,04)=gather(i,04)*xcfitp(3)
      gather(i,05)=gather(i,05)*xcfitd(1)
      gather(i,06)=gather(i,06)*xcfitd(2)
      gather(i,07)=gather(i,07)*xcfitd(3)
      gather(i,08)=gather(i,08)*xcfitd(4)
      gather(i,09)=gather(i,09)*xcfitd(5)
 2026 gather(i,10)=gather(i,10)*xcfitd(6)

      nc=nxcs+(naux-1)*10

      do 2027 i=1,nn
      do 2027 j=1,10
 2027 vvector(nc+j)=vvector(nc+j)+gather(i,j)

 2001 continue

      return
      end

      subroutine coreds(m,n,ncentr,icontr,inddyy,iloc,coord,charge,
     &                  overlap,core,zeta,zetaa,px,py,pz,pxax,pyay,pzaz,
     &                  eta,base,etarr,ss,ss0,ss1,ss2,ps,ps0,ps1,ds,
     &                  dscond,c,pxcx,pycy,pzcz,u,twozeta,eta2)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*),iloc(*)

      dimension coord(3,*),charge(*),overlap(*),core(*),zeta(*),
     &          zetaa(*),px(*),py(*),pz(*),pxax(*),pyay(*),pzaz(*),
     &          eta(*),base(*),etarr(*),ss(*),ss0(*),ss1(*),ss2(*),
     &          ps(n,*),ps0(n,*),ps1(n,*),ds(n,*),dscond(n,*),c(*),
     &          pxcx(*),pycy(*),pzcz(*),u(*),twozeta(*),eta2(*)

      data zero,thrhlf,two,three,pi/0.0d0,1.5d0,
     &                              2.0d0,3.0d0,3.1415926535898d0/

      sqrt3=sqrt(three)

      do 1001 i=1,n
      eta2(i)=two*eta(i)
 1001 twozeta(i)=two*zeta(i)

      do 1002 i=1,n
 1002 ss0(i)=((pi/zeta(i))**thrhlf)*base(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)
      ps0(i,2)=pyay(i)*ss0(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)

      do 1004 i=1,n
 1004 c(i)=ss0(i)/twozeta(i)

      do 1005 i=1,n
      ds(i,1)=pxax(i)*ps0(i,1)+c(i)
      ds(i,2)=pyay(i)*ps0(i,1)
      ds(i,3)=pzaz(i)*ps0(i,1)
      ds(i,4)=pyay(i)*ps0(i,2)+c(i)
      ds(i,5)=pzaz(i)*ps0(i,2)
 1005 ds(i,6)=pzaz(i)*ps0(i,3)+c(i)

      do 1006 j=1,6
      do 1006 i=1,n
 1006 overlap(inddyy(icontr(i),j))=overlap(inddyy(icontr(i),j))+ds(i,j)

      do 1007 i=1,n
 1007 ss(i)=eta(i)*(three-two*etarr(i))*ss0(i)

      do 1008 i=1,n
      ps(i,1)=pxax(i)*ss(i)+eta2(i)*ps0(i,1)
      ps(i,2)=pyay(i)*ss(i)+eta2(i)*ps0(i,2)
 1008 ps(i,3)=pzaz(i)*ss(i)+eta2(i)*ps0(i,3)

      do 1009 i=1,n
 1009 c(i)=ss(i)/twozeta(i)-eta2(i)*ss0(i)/(two*zetaa(i))

      do 1010 i=1,n
      ds(i,1)=pxax(i)*ps(i,1)+eta2(i)*ds(i,1)+c(i)
      ds(i,2)=pyay(i)*ps(i,1)+eta2(i)*ds(i,2)
      ds(i,3)=pzaz(i)*ps(i,1)+eta2(i)*ds(i,3)
      ds(i,4)=pyay(i)*ps(i,2)+eta2(i)*ds(i,4)+c(i)
      ds(i,5)=pzaz(i)*ps(i,2)+eta2(i)*ds(i,5)
 1010 ds(i,6)=pzaz(i)*ps(i,3)+eta2(i)*ds(i,6)+c(i)

      do 1011 j=1,6
      do 1011 i=1,n
 1011 core(inddyy(icontr(i),j))=core(inddyy(icontr(i),j))+ds(i,j)

      do 1012 j=1,6
      do 1012 i=1,n
 1012 dscond(i,j)=zero

      do 2001 nn=1,ncentr

      ccx=coord(1,nn)
      ccy=coord(2,nn)
      ccz=coord(3,nn)

      twopichrg=two*pi*charge(nn)

      do 2002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 2002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      call auggv(3,n,iloc,u,ps0,ss0,ss1,ss2)

      do 2003 i=1,n
      ss0(i)=base(i)*ps0(i,1)*twopichrg/zeta(i)
      ss1(i)=base(i)*ps0(i,2)*twopichrg/zeta(i)
 2003 ss2(i)=base(i)*ps0(i,3)*twopichrg/zeta(i)

      do 2004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

 2004 continue

      do 2005 i=1,n
 2005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 2006 i=1,n
      ds(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 2006 ds(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 2007 j=1,6
      do 2007 i=1,n
 2007 dscond(i,j)=dscond(i,j)+ds(i,j)

 2001 continue

      do 2008 j=1,6
      do 2008 i=1,n
 2008 core(inddyy(icontr(i),j))=core(inddyy(icontr(i),j))-dscond(i,j)

      return
      end

      subroutine makelowercase(str,n)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      character str(*)

      character ua,uz,la

      data ua,uz,la/'A','Z','a'/

      do 1001 i=1,n
 1001 if((ichar(str(i)).ge.ichar(ua)).and.
     &   (ichar(str(i)).le.ichar(uz)))      str(i)=char(ichar(str(i))
     &                                                 +ichar(la)
     &                                                 -ichar(ua))

      return
      end

      subroutine cdgrmm(natoms,ncds,ncdspd,ilfunc,icfunc,cdfitc,alpha,
     &                  coeffs,coeffp,coeffd,coord,gradient,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)
 
      dimension ilfunc(*),icfunc(*)

      dimension cdfitc(*),alpha(*),coeffs(*),coeffp(*),coeffd(*)
      dimension coord(3,*),gradient(3,*),wkvec(*)

      data zero/0.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      do 1001 i=1,3*natoms
 1001 wkvec(i)=zero

      call cdgrss(ncds,ilfunc,icfunc,cdfitc,alpha,coeffs,coord,wkvec)

      call cdgrxs(ncds,ncdspd,ilfunc,icfunc,cdfitc,alpha,coeffs,coeffp,
     &            coeffd,coord,wkvec)

      call cdgrxx(ncds,ncdspd,ilfunc,icfunc,cdfitc,alpha,coeffs,coeffp,
     &            coeffd,coord,wkvec)

      call mpi_reduce(wkvec(1),wkvec(3*natoms+1),3*natoms,
     &                mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then

              do 1002 i=1,natoms
              do 1002 j=1,3
 1002         gradient(j,i)=gradient(j,i)+wkvec(3*natoms+3*(i-1)+j)

                    endif

      return
      end

      subroutine boys_ss(n,icontr,inddyy,zeta,px,py,pz,base,ss,x_moment,
     &                   y_moment,z_moment)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(*)

      dimension zeta(*),px(*),py(*),pz(*),base(*),ss(n,*),x_moment(*),
     &          y_moment(*),z_moment(*)

      data zero,thrhlf,pi/0.0d0,1.5d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1002 ss(i,3)=pz(i)*base(i)

      do 1003 i=1,n
      ii=inddyy(icontr(i))
      x_moment(ii)=x_moment(ii)+ss(i,1)
      y_moment(ii)=y_moment(ii)+ss(i,2)
 1003 z_moment(ii)=z_moment(ii)+ss(i,3)

      return
      end

      subroutine boys_ps(m,n,icontr,inddyy,zeta,px,py,pz,pxax,pyay,pzaz,
     &                   base,ss,ps,c,x_moment,y_moment,z_moment)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension zeta(*),px(*),py(*),pz(*),pxax(*),pyay(*),pzaz(*),
     &          base(*),ss(n,*),ps(n,*),c(*),x_moment(*),y_moment(*),
     &          z_moment(*)

      data zero,thrhlf,two,pi/0.0d0,1.5d0,2.0d0,3.1415926535898d0/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1002 ss(i,3)=pz(i)*base(i)

      do 1003 i=1,n
 1003 c(i)=base(i)/(two*zeta(i))

      do 1004 i=1,n
      ps(i,1)=pxax(i)*ss(i,1)+c(i)
      ps(i,2)=pxax(i)*ss(i,2)
      ps(i,3)=pxax(i)*ss(i,3)
      ps(i,4)=pyay(i)*ss(i,1)
      ps(i,5)=pyay(i)*ss(i,2)+c(i)
      ps(i,6)=pyay(i)*ss(i,3)
      ps(i,7)=pzaz(i)*ss(i,1)
      ps(i,8)=pzaz(i)*ss(i,2)
 1004 ps(i,9)=pzaz(i)*ss(i,3)+c(i)

      do 1005 j=1,3
      do 1005 i=1,n
      ii=inddyy(icontr(i),j)
      x_moment(ii)=x_moment(ii)+ps(i,3*(j-1)+1)
      y_moment(ii)=y_moment(ii)+ps(i,3*(j-1)+2)
 1005 z_moment(ii)=z_moment(ii)+ps(i,3*(j-1)+3)

      return
      end

      subroutine xcorss(m,n,nxcs,nxcspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,coord,xcfit1,xcfit2,xcfit3,alphaaux,
     &                  coeffs,coeffp,coeffd,fock1,fock2,fock3,zeta,ax,
     &                  ay,az,px,py,pz,base,zetarec,zetafac,efac,gxax,
     &                  gyay,gzaz,sss,ssscond,pss,psscond,dss,dsscond,
     &                  ssp,psp,ssd,c,zzeta,aax,aay,aaz,ppx,ppy,ppz,
     &                  axcx,aycy,azcz,gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(*),
     &          iloc(*)

      dimension coord(3,*),xcfit1(*),xcfit2(*),xcfit3(*),alphaaux(*),
     &          coeffs(*),coeffp(*),coeffd(*),fock1(*),fock2(*),
     &          fock3(*),zeta(*),ax(*),ay(*),az(*),px(*),py(*),pz(*),
     &          base(*),zetarec(*),zetafac(*),efac(*),gxax(*),gyay(*),
     &          gzaz(*),sss(*),ssscond(*),pss(n,*),psscond(n,*),
     &          dss(n,*),dsscond(n,*),ssp(n,*),psp(n,*),ssd(n,*),c(*),
     &          zzeta(*),aax(*),aay(*),aaz(*),ppx(*),ppy(*),ppz(*),
     &          axcx(*),aycy(*),azcz(*),gather(n,*)

      data zero,one,two,three,four,five/0.0d0,1.0d0,2.0d0,
     &                                  3.0d0,4.0d0,5.0d0/
      data expcut,calcut/45.0d0,1.0d-16/

      sqrt3=sqrt(three)

      do 1001 j=1,1
      do 1001 i=1,n
 1001 gather(i,j)=zero

      do 1002 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=xcfit3(naux)*coeffs(ilaux)

      do 1003 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1003 zetarec(i)=one/(zeta(i)+zetaux)

      do 1004 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1004 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1005 i=1,n
      if(efac(i).lt.expcut) then

                            sss(i)=zetafac(i)*base(i)*exp(-efac(i))
                            gather(i,1)=gather(i,1)+sss(i)*xcfits

                            endif
 1005 continue

 1002 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=xcfit3(nxcs+(naux-1)*10+1)*coeffs(ilaux)

      xcfitp(1)=xcfit3(nxcs+(naux-1)*10+2)*coeffp(ilaux)
      xcfitp(2)=xcfit3(nxcs+(naux-1)*10+3)*coeffp(ilaux)
      xcfitp(3)=xcfit3(nxcs+(naux-1)*10+4)*coeffp(ilaux)

      xcfitd(1)=xcfit3(nxcs+(naux-1)*10+05)*coeffd(ilaux)/sqrt3
      xcfitd(2)=xcfit3(nxcs+(naux-1)*10+06)*coeffd(ilaux)
      xcfitd(3)=xcfit3(nxcs+(naux-1)*10+07)*coeffd(ilaux)
      xcfitd(4)=xcfit3(nxcs+(naux-1)*10+08)*coeffd(ilaux)/sqrt3
      xcfitd(5)=xcfit3(nxcs+(naux-1)*10+09)*coeffd(ilaux)
      xcfitd(6)=xcfit3(nxcs+(naux-1)*10+10)*coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 i=1,nn
      ssp(i,1)=axcx(i)*sss(i)+pss(i,1)
      ssp(i,2)=aycy(i)*sss(i)+pss(i,2)
 2010 ssp(i,3)=azcz(i)*sss(i)+pss(i,3)

      do 2011 i=1,nn
      psp(i,1)=axcx(i)*pss(i,1)+dss(i,1)
      psp(i,2)=aycy(i)*pss(i,1)+dss(i,2)
      psp(i,3)=azcz(i)*pss(i,1)+dss(i,3)
      psp(i,4)=axcx(i)*pss(i,2)+dss(i,2)
      psp(i,5)=aycy(i)*pss(i,2)+dss(i,4)
      psp(i,6)=azcz(i)*pss(i,2)+dss(i,5)
      psp(i,7)=axcx(i)*pss(i,3)+dss(i,3)
      psp(i,8)=aycy(i)*pss(i,3)+dss(i,5)
 2011 psp(i,9)=azcz(i)*pss(i,3)+dss(i,6)

      do 2012 i=1,nn
      ssd(i,1)=axcx(i)*ssp(i,1)+psp(i,1)
      ssd(i,2)=aycy(i)*ssp(i,1)+psp(i,4)
      ssd(i,3)=azcz(i)*ssp(i,1)+psp(i,7)
      ssd(i,4)=aycy(i)*ssp(i,2)+psp(i,5)
      ssd(i,5)=azcz(i)*ssp(i,2)+psp(i,8)
 2012 ssd(i,6)=azcz(i)*ssp(i,3)+psp(i,9)

cfpp$ nodepchk
      do 2013 i=1,nn
      index=iloc(i)
 2013 gather(index,1)=gather(index,1)+sss(i)*xcfits
     &                               +ssp(i,1)*xcfitp(1)
     &                               +ssp(i,2)*xcfitp(2)
     &                               +ssp(i,3)*xcfitp(3)
     &                               +ssd(i,1)*xcfitd(1)
     &                               +ssd(i,2)*xcfitd(2)
     &                               +ssd(i,3)*xcfitd(3)
     &                               +ssd(i,4)*xcfitd(4)
     &                               +ssd(i,5)*xcfitd(5)
     &                               +ssd(i,6)*xcfitd(6)

 2001 continue

      do 1006 i=1,n
 1006 fock3(inddyy(icontr(i)))=fock3(inddyy(icontr(i)))+gather(i,1)

      return
      end

      subroutine gradxc(ndim,ngridmax,ngridtype,iptsweight,ncntrt,
     &                  ncentr,nconts,ncontp,ncontd,natnumber,nptsatom,
     &                  nfuncatom,ilfunc,icfunc,ngauss,nptrs,nptrp,
     &                  nptrd,iwv,wkvec,wv,dmta,dmtb,cent,grad,alpha,
     &                  coeff)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension natnumber(*),nptsatom(*),nfuncatom(*)
      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension iwv(*)

      dimension wkvec(*),wv(*),dmta(*),dmtb(*),cent(3,*),grad(3,*)
      dimension alpha(*),coeff(*)

      data zero/0.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      ii=0

      do 1001 i=1,nconts
      nc=icfunc(nptrs(i))
      nfuncatom(ii+1)=nc
 1001 ii=ii+1

      do 1002 i=1,ncontp
      nc=icfunc(nptrp(i))
      do 1003 k=1,3
 1003 nfuncatom(ii+k)=nc
 1002 ii=ii+3

      do 1004 i=1,ncontd
      nc=icfunc(nptrd(i))
      do 1005 k=1,6
 1005 nfuncatom(ii+k)=nc
 1004 ii=ii+6

      do 1006 i=1,3*ncentr
 1006 wkvec(i)=zero

      nstart=min(512,32*numprocs)

      ngridbatch=nstart+16

 1007 ngridbatch=ngridbatch-16

      if(ngridbatch.le.0) stop 'gradxc going into xcgrad'

      ja=1
      jb=ja+ngridmax
      jc=jb+ngridmax
      jd=jc+ngridmax
      je=jd+ngridmax
      jf=je+ngridmax
      jg=jf+ngridmax
      jh=jg+ngridmax
      ji=jh+ngridbatch*ncntrt
      jj=ji+ngridbatch*ncntrt
      jk=jj+ngridbatch*ncntrt
      jl=jk+ngridbatch*ncntrt
      jm=jl+ncentr*ncentr
      jn=jm+ncntrt
      jo=jn+ncntrt
      jp=jo+ngridbatch*ncentr*3
      jq=jp+2*ncentr+2*ncentr*ncentr+ncentr*ngridmax

      ka=1
      kb=ka+ncentr+1

      if(jq.gt.ndim) goto 1007

      call xcgrad(ngridbatch,ngridmax,ngridtype,iptsweight,ncntrt,
     &            nconts,ncontp,ncontd,ncentr,ilfunc,icfunc,ngauss,
     &            nptrs,nptrp,nptrd,nptsatom,natnumber,nfuncatom,
     &            iwv(ka),iwv(kb),alpha,coeff,dmta,dmtb,cent,wkvec,
     &            wv(ja),wv(jb),wv(jc),wv(jd),wv(je),wv(jf),wv(jg),
     &            wv(jh),wv(ji),wv(jj),wv(jk),wv(jl),wv(jm),wv(jn),
     &            wv(jo),wv(jp))

      call mpi_reduce(wkvec,wkvec(3*ncentr+1),
     &                3*ncentr,mpi_real8,mpi_sum,0,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          do 1008 i=1,ncentr
                          do 1008 j=1,3
 1008                     grad(j,i)=grad(j,i)+wkvec(3*ncentr+3*(i-1)+j)
                    endif

      return
      end

       subroutine efips(m,n,icontr,inddyy,esp,efix,efiy,efiz,ccx,ccy,
     &                  ccz,g,density,zeta,px,py,pz,pxax,pyay,pzaz,
     &                  base,ss0,ss1,ps0,pscond,pxcx,pycy,pzcz,u,ss2,
     &                  saxs0,says0,sazs0,saxs1,says1,sazs1,paxs0,pays0,
     &                  pazs0,paxscond,payscond,pazscond)

c  this subroutine written by roger gallant and alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.
 
      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension g(*),density(*),zeta(*),px(*),py(*),pz(*),pxax(*),
     &          pyay(*),pzaz(*),base(*),ss0(*),ss1(*),ps0(n,*),
     &          pscond(m,*),pxcx(*),pycy(*),pzcz(*),u(*),ss2(*),
     &          saxs0(*),says0(*),sazs0(*),saxs1(*),says1(*),sazs1(*),
     &          paxs0(n,*),pays0(n,*),pazs0(n,*),paxscond(m,*),
     &          payscond(m,*),pazscond(m,*)

      data zero,half,one,two,pi/0.0d0,0.5d0,
     &                          1.0d0,2.0d0,3.1415926535898d0/

      twopi=two*pi

      do 1001 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1001 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1002 i=1,n
      call augg(3,u(i),g)
      ss0(i)=base(i)*g(1)*twopi/zeta(i)
      ss1(i)=base(i)*g(2)*twopi/zeta(i)
 1002 ss2(i)=base(i)*g(3)*twopi/zeta(i)

      do 1003 i=1,n
      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
 1003 ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)
 
      do 1004 i=1,n
      saxs0(i)=two*zeta(i)*pxcx(i)*ss1(i)
      says0(i)=two*zeta(i)*pycy(i)*ss1(i)
 1004 sazs0(i)=two*zeta(i)*pzcz(i)*ss1(i)

      do 1005 i=1,n
      saxs1(i)=two*zeta(i)*pxcx(i)*ss2(i)
      says1(i)=two*zeta(i)*pycy(i)*ss2(i)
 1005 sazs1(i)=two*zeta(i)*pzcz(i)*ss2(i)

      do 1006 i=1,n
      paxs0(i,1)=pxax(i)*saxs0(i)-pxcx(i)*saxs1(i)+ss1(i)
      paxs0(i,2)=pyay(i)*saxs0(i)-pycy(i)*saxs1(i)
      paxs0(i,3)=pzaz(i)*saxs0(i)-pzcz(i)*saxs1(i)
      pays0(i,1)=pxax(i)*says0(i)-pxcx(i)*says1(i)
      pays0(i,2)=pyay(i)*says0(i)-pycy(i)*says1(i)+ss1(i)
      pays0(i,3)=pzaz(i)*says0(i)-pzcz(i)*says1(i)
      pazs0(i,1)=pxax(i)*sazs0(i)-pxcx(i)*sazs1(i)
      pazs0(i,2)=pyay(i)*sazs0(i)-pycy(i)*sazs1(i)
 1006 pazs0(i,3)=pzaz(i)*sazs0(i)-pzcz(i)*sazs1(i)+ss1(i)

      do 1007 j=1,3
      do 1007 i=1,m
 1007 pscond(i,j)=zero

      do 1008 j=1,3
      do 1008 i=1,n
 1008 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)

      do 1009 j=1,3
      do 1009 i=1,m
      paxscond(i,j)=zero
      payscond(i,j)=zero
 1009 pazscond(i,j)=zero

      do 1010 j=1,3
      do 1010 i=1,n
      paxscond(icontr(i),j)=paxscond(icontr(i),j)+paxs0(i,j)
      payscond(icontr(i),j)=payscond(icontr(i),j)+pays0(i,j)
 1010 pazscond(icontr(i),j)=pazscond(icontr(i),j)+pazs0(i,j)

      do 1011 j=1,3
      do 1011 i=1,m
 1011 esp=esp-density(inddyy(i,j))*pscond(i,j)

      do 1012 j=1,3
      do 1012 i=1,m
      efix=efix-density(inddyy(i,j))*paxscond(i,j)
      efiy=efiy-density(inddyy(i,j))*payscond(i,j)
 1012 efiz=efiz-density(inddyy(i,j))*pazscond(i,j)

      return 
      end 

      subroutine mxmy_mpi(n,a,b,c)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      include "mpif.h"

      dimension istat(mpi_status_size)

      dimension a(n,*),b(n,*),c(n,*)

      data zero/0.0d0/

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      nprocesses=numprocs-1

      if(myid.eq.0) then
                          isent=0

                          do 1001 islave=0,numprocs-1

                          ia=n-isent
                          ib=numprocs-islave

                          nloop=ia/ib
                          if(mod(ia,ib).ne.0) nloop=nloop+1

                          call mpi_bsend(nloop,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)
                          call mpi_bsend(isent,1,mpi_integer,islave,
     &                                   islave,mpi_comm_world,ierr)

                          do 1002 i=1,nloop
 1002                     call mpi_bsend(b(1,isent+i),n,
     &                                   mpi_real8,islave,islave,
     &                                   mpi_comm_world,ierr)

 1001                     isent=isent+nloop
                    endif

      call mpi_recv(nloop,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)
      call mpi_recv(isent,1,mpi_integer,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1003 i=1,nloop
 1003 call mpi_recv(b(1,isent+i),n,mpi_real8,mpi_any_source,
     &              mpi_any_tag,mpi_comm_world,istat,ierr)

      do 1004 j=isent+1,isent+nloop
      do 1005 i=1,n
 1005 c(i,j)=zero
      do 1004 k=1,n
      do 1004 i=1,n
 1004 c(i,j)=c(i,j)+a(i,k)*b(k,j)

      call mpi_bsend(nloop,1,mpi_integer,0,01,mpi_comm_world,ierr)

      do 1006 i=1,nloop
 1006 call mpi_bsend(c(1,isent+i),n,mpi_real8,0,02,mpi_comm_world,ierr)

      if(myid.eq.0) then
                          ireceived=0

                          do 1007 islave=0,numprocs-1

                          call mpi_recv(nloop,1,mpi_integer,islave,
     &                                  01,mpi_comm_world,istat,ierr)

                          do 1008 i=1,nloop
 1008                     call mpi_recv(c(1,ireceived+i),n,
     &                                  mpi_real8,islave,02,
     &                                  mpi_comm_world,istat,ierr)

 1007                     ireceived=ireceived+nloop
                    endif

      call mpi_bcast(c,n*n,mpi_real8,0,mpi_comm_world,ierr)

      return
      end

      subroutine startup

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      include "mpif.h"

      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      call mpi_comm_size(mpi_comm_world,numprocs,ierr)

      if(myid.eq.0) call openfl
      if(myid.eq.0) call header
      call igftable

      return
      end

#!/bin/sh

STARTRE='^;;; Commentary:$'
STOPRE='^;;; Code:$'
DATE=$(date +"%B %e, %Y %H:%M %Z")

# Produce README.md for GitHub
echo "# Deft for Emacs [![MELPA badge][melpa-badge]][melpa-link] [![MELPA stable badge][melpa-stable-badge]][melpa-stable-link] [![Travis CI Build Status][travis-badge]][travis-link]

  [melpa-link]: https://melpa.org/#/deft
  [melpa-stable-link]: https://stable.melpa.org/#/deft
  [melpa-badge]: https://melpa.org/packages/deft-badge.svg
  [melpa-stable-badge]: https://stable.melpa.org/packages/deft-badge.svg
  [travis-link]: https://travis-ci.org/jrblevin/deft
  [travis-badge]: https://travis-ci.org/jrblevin/deft.svg?branch=master

<!-- Automatically generated from comments in deft.el. -->" > README.md

# Produce index.text for the Deft homepage
echo "title:       Deft for Emacs
description: Emacs mode for quickly browsing, filtering, and editing directories of plain text notes.
markup:      markdown
city:        Columbus
guid:        tag:jblevins.org,2011:/projects/deft/
feed:        true
created:     August 6, 2011 00:30 EDT
modified:    $DATE" > index.text

cat deft.el |\
    # Keep only the Commentary section
    awk "/$STARTRE/,/$STOPRE/" |\
    # Remove the start and step regexps
    grep -v "$STARTRE" | grep -v "$STOPRE" |\
    # Convert headers
    sed -e 's/^;;; \(.*\):$/## \1/' |\
    # Remove leading spaces (but don't disturb pre blocks)
    sed -e 's/^;;[ ]\{0,1\}//' |\
    # Escape wiki links
    #sed -e 's/\(\[\[[^]\n]*\]\]\)/\\\1/g' |\
    # Use Markdown-style backticks for single-quoted lisp code
    sed -e 's/`\([^'\'']*\)'\''/`\1`/g' |\
    # Use <kbd> tags for single character, unprefixed keybindings
    sed -e 's/`\([^`]\)`/<kbd>\1<\/kbd>/g' |\
    # Use <kbd> tags for TAB and RET keys
    sed -e 's/`TAB`/<kbd>TAB<\/kbd>/g' |\
    sed -e 's/`RET`/<kbd>RET<\/kbd>/g' |\
    # Use <kbd> tags for keybindings prefixed by C, M, or S
    sed -e 's/`\([CMS]-[^`]*\)`/<kbd>\1<\/kbd>/g' |\
    # Remove email addresses
    sed -e 's/ <[^>]*@[^<]*> / /g' \
    | tee -a README.md >> index.text

#!/bin/sh

STARTRE='^;;; Commentary:$'
STOPRE='^;;; Code:$'
DATE=$(date +"%B %e, %Y %H:%M %Z")

# Produce README.md for GitHub
echo "Deft for Emacs
==============

<!-- Automatically generated from comments in deft.el. -->" > README.md

# Produce index.text for the Deft homepage
echo "title:       Deft for Emacs
description: Emacs mode for quickly browsing, filtering, and editing directories of plain text notes.
markup:      markdown
city:        Columbus
guid:        tag:jblevins.org,2011:/projects/deft/
feed:        true
created:     August 6, 2011 00:30 EDT
modified:    $DATE" > index.text

cat deft.el |\
    # Keep only the Commentary section
    awk "/$STARTRE/,/$STOPRE/" |\
    # Remove the start and step regexps
    grep -v "$STARTRE" | grep -v "$STOPRE" |\
    # Convert headers
    sed -e 's/^;;; \(.*\):$/## \1/' |\
    # Remove leading spaces (but don't disturb pre blocks)
    sed -e 's/^;;[ ]\{0,1\}//' |\
    # Escape wiki links
    #sed -e 's/\(\[\[[^]\n]*\]\]\)/\\\1/g' |\
    # Use Markdown-style backticks for single-quoted lisp code
    sed -e 's/`\([^'\'']*\)'\''/`\1`/g' |\
    # Use <kbd> tags for single character, unprefixed keybindings
    sed -e 's/`\([^`]\)`/<kbd>\1<\/kbd>/g' |\
    # Use <kbd> tags for TAB and RET keys
    sed -e 's/`TAB`/<kbd>TAB<\/kbd>/g' |\
    sed -e 's/`RET`/<kbd>RET<\/kbd>/g' |\
    # Use <kbd> tags for keybindings prefixed by C, M, or S
    sed -e 's/`\([CMS]-[^`]*\)`/<kbd>\1<\/kbd>/g' |\
    # Remove email addresses
    sed -e 's/ <[^>]*@[^<]*> / /g' \
    | tee -a README.md >> index.text
